/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 97;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 68,
  Feature_HasRCPC_IMMOBit = 88,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 67,
  Feature_HasSHA3Bit = 66,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 29,
  Feature_HasLSEBit = 30,
  Feature_HasNoLSEBit = 96,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 85,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 79,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 45,
  Feature_HasSVEAESBit = 37,
  Feature_HasSVE2SM4Bit = 42,
  Feature_HasSVE2SHA3Bit = 95,
  Feature_HasSVEBitPermBit = 39,
  Feature_HasSMEandIsNonStreamingSafeBit = 58,
  Feature_HasSMEBit = 51,
  Feature_HasSMEF64F64Bit = 53,
  Feature_HasSMEF16F16Bit = 61,
  Feature_HasSMEI16I64Bit = 56,
  Feature_HasSME2andIsNonStreamingSafeBit = 63,
  Feature_HasSME2Bit = 60,
  Feature_HasSME2p1Bit = 65,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 48,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 43,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 49,
  Feature_HasLUTBit = 50,
  Feature_HasSME_LUTv2Bit = 64,
  Feature_HasSMEF8F16Bit = 54,
  Feature_HasSMEF8F32Bit = 52,
  Feature_HasSME_MOP4Bit = 57,
  Feature_HasSME_TMOPBit = 62,
  Feature_HasCMPBRBit = 86,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 31,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 40,
  Feature_HasSVE2_or_SMEBit = 33,
  Feature_HasSVE2_or_SME2Bit = 47,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 36,
  Feature_HasSVE2p1_or_SMEBit = 59,
  Feature_HasSVE2p1_or_SME2Bit = 28,
  Feature_HasSVE2p1_or_SME2p1Bit = 46,
  Feature_HasSVE2p2_or_SME2p2Bit = 32,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 55,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 38,
  Feature_HasNonStreamingSVE_or_SSVE_FEXPABit = 41,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 76,
  Feature_HasRCPCBit = 87,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 94,
  Feature_HasMatMulFP64Bit = 44,
  Feature_HasLS64Bit = 83,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 84,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 80,
  Feature_UseExperimentalZeroingPseudosBit = 35,
  Feature_UseAlternateSExtLoadCVTF32Bit = 78,
  Feature_UseScalarIncVLBit = 34,
  Feature_NoUseScalarIncVLBit = 91,
  Feature_HasFastIncVLBit = 92,
  Feature_UseSVEFPLD1RBit = 90,
  Feature_UseLDAPURBit = 89,
  Feature_AllowMisalignedMemAccessesBit = 93,
  Feature_NotForCodeSizeBit = 77,
  Feature_UseSTRQroBit = 75,
  Feature_TailCallX16X17Bit = 70,
  Feature_TailCallX17Bit = 81,
  Feature_TailCallNotX16Bit = 82,
  Feature_TailCallAnyBit = 69,
  Feature_SLSBLRMitigationBit = 73,
  Feature_NoSLSBLRMitigationBit = 72,
  Feature_OptimizedGISelOrOtherSelectorBit = 71,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF16F16())
    Features.set(Feature_HasSMEF16F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_MOP4()))
    Features.set(Feature_HasSME_MOP4Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_TMOP()))
    Features.set(Feature_HasSME_TMOPBit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_FEXPA()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_FEXPABit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->hasDisableFastIncVL())
    Features.set(Feature_HasFastIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasProperty(MachineFunctionProperties::Property::FailedISel) || !MF->getProperties().hasProperty(MachineFunctionProperties::Property::Legalized))
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSME_MOP4,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSMEF16F16_HasSME_MOP4,
  GIFBS_HasSMEF64F64_HasSME_MOP4,
  GIFBS_HasSMEF8F16_HasSME_MOP4,
  GIFBS_HasSMEF8F32_HasSME_MOP4,
  GIFBS_HasSMEI16I64_HasSME_MOP4,
  GIFBS_HasSVE_or_SME_IsLE,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasNonStreamingSVE_or_SSVE_FEXPABit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSMEF16F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF64F64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F32Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEI16I64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(903), /*)*//*default:*//*Label 154*/ GIMT_Encode4(439622),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3410),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(36405),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(50633),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(53154),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(53236), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(53318),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(61064),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(86179), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(97147), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(104671), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(114647),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(115138),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(115629),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(115897),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(116047),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(116538), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(116571),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(125509),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(126559), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(129608), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(143134),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(144485),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(145477),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(146469),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(147961), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(149453),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(150445),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(151437),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(152429),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(153421),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(154413),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(155405), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(156110),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(156815),
     /*    270 */ /*TargetOpcode::G_ATOMICRMW_FMAXIMUM*//*Label 34*/ GIMT_Encode4(157520),
     /*    274 */ /*TargetOpcode::G_ATOMICRMW_FMINIMUM*//*Label 35*/ GIMT_Encode4(158225), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(158930), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(158981),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(268045), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(279561),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 40*/ GIMT_Encode4(279851),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 41*/ GIMT_Encode4(281288),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 42*/ GIMT_Encode4(281408), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 43*/ GIMT_Encode4(281649),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 44*/ GIMT_Encode4(283547),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 45*/ GIMT_Encode4(285201),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 46*/ GIMT_Encode4(287980),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 47*/ GIMT_Encode4(288805),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 48*/ GIMT_Encode4(289243), GIMT_Encode4(0),
     /*    382 */ /*TargetOpcode::G_FSHR*//*Label 49*/ GIMT_Encode4(290068),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 50*/ GIMT_Encode4(290198), GIMT_Encode4(0),
     /*    394 */ /*TargetOpcode::G_ICMP*//*Label 51*/ GIMT_Encode4(290740), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    410 */ /*TargetOpcode::G_SELECT*//*Label 52*/ GIMT_Encode4(298517), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 53*/ GIMT_Encode4(299562),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 54*/ GIMT_Encode4(300046),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 55*/ GIMT_Encode4(300530),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 56*/ GIMT_Encode4(300960),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 57*/ GIMT_Encode4(301390),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 58*/ GIMT_Encode4(301820), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(302250),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(304048),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(304786),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(308882), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(325155), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(325771),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(329278),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(329526),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(329714),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(330691),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(331668),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(336296),
     /*    614 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 71*/ GIMT_Encode4(340302),
     /*    618 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 72*/ GIMT_Encode4(340622),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 73*/ GIMT_Encode4(340942), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    634 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 74*/ GIMT_Encode4(341799),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 75*/ GIMT_Encode4(342081),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 76*/ GIMT_Encode4(342459),
     /*    646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 77*/ GIMT_Encode4(342837),
     /*    650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 78*/ GIMT_Encode4(343187),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 79*/ GIMT_Encode4(343537),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 80*/ GIMT_Encode4(344240), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 81*/ GIMT_Encode4(344943),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 82*/ GIMT_Encode4(345347),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 83*/ GIMT_Encode4(345751),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 84*/ GIMT_Encode4(346155),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 85*/ GIMT_Encode4(346559),
     /*    722 */ /*TargetOpcode::G_LROUND*//*Label 86*/ GIMT_Encode4(347374),
     /*    726 */ /*TargetOpcode::G_LLROUND*//*Label 87*/ GIMT_Encode4(347540),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 88*/ GIMT_Encode4(347639), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 89*/ GIMT_Encode4(347655),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 90*/ GIMT_Encode4(353027),
     /*    754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(385949), GIMT_Encode4(0),
     /*    762 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 92*/ GIMT_Encode4(388867), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTTZ*//*Label 93*/ GIMT_Encode4(391187), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 94*/ GIMT_Encode4(391339), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 95*/ GIMT_Encode4(392013),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 96*/ GIMT_Encode4(392173),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 97*/ GIMT_Encode4(392487),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 98*/ GIMT_Encode4(392641), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 99*/ GIMT_Encode4(393132),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 100*/ GIMT_Encode4(393432),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 101*/ GIMT_Encode4(393923),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 102*/ GIMT_Encode4(394414), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 103*/ GIMT_Encode4(394905),
     /*    894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 104*/ GIMT_Encode4(396031),
     /*    898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 105*/ GIMT_Encode4(396647),
     /*    902 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 106*/ GIMT_Encode4(400369), GIMT_Encode4(0),
     /*    910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 107*/ GIMT_Encode4(400985),
     /*    914 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 108*/ GIMT_Encode4(416592), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 109*/ GIMT_Encode4(416892),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 110*/ GIMT_Encode4(416906),
     /*    958 */ /*TargetOpcode::G_UBSANTRAP*//*Label 111*/ GIMT_Encode4(416927), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 112*/ GIMT_Encode4(416952), GIMT_Encode4(0),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 113*/ GIMT_Encode4(417262),
     /*    982 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 114*/ GIMT_Encode4(417433),
     /*    986 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 115*/ GIMT_Encode4(417604),
     /*    990 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 116*/ GIMT_Encode4(417775),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 117*/ GIMT_Encode4(417946), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 118*/ GIMT_Encode4(419075),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 119*/ GIMT_Encode4(419278),
     /*   1022 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 120*/ GIMT_Encode4(419481),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 121*/ GIMT_Encode4(419684), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3278 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 122*/ GIMT_Encode4(419887), GIMT_Encode4(0),
     /*   3286 */ /*AArch64::G_BSP*//*Label 123*/ GIMT_Encode4(420027),
     /*   3290 */ /*AArch64::G_DUP*//*Label 124*/ GIMT_Encode4(421015),
     /*   3294 */ /*AArch64::G_DUPLANE16*//*Label 125*/ GIMT_Encode4(422838),
     /*   3298 */ /*AArch64::G_DUPLANE32*//*Label 126*/ GIMT_Encode4(423093),
     /*   3302 */ /*AArch64::G_DUPLANE64*//*Label 127*/ GIMT_Encode4(423348),
     /*   3306 */ /*AArch64::G_DUPLANE8*//*Label 128*/ GIMT_Encode4(423494),
     /*   3310 */ /*AArch64::G_EXT*//*Label 129*/ GIMT_Encode4(423673),
     /*   3314 */ /*AArch64::G_FCMEQ*//*Label 130*/ GIMT_Encode4(425323),
     /*   3318 */ /*AArch64::G_FCMGE*//*Label 131*/ GIMT_Encode4(425882),
     /*   3322 */ /*AArch64::G_FCMGT*//*Label 132*/ GIMT_Encode4(426974),
     /*   3326 */ /*AArch64::G_REV16*//*Label 133*/ GIMT_Encode4(428066),
     /*   3330 */ /*AArch64::G_REV32*//*Label 134*/ GIMT_Encode4(428220),
     /*   3334 */ /*AArch64::G_REV64*//*Label 135*/ GIMT_Encode4(428396),
     /*   3338 */ /*AArch64::G_SADDLP*//*Label 136*/ GIMT_Encode4(428670),
     /*   3342 */ /*AArch64::G_SADDLV*//*Label 137*/ GIMT_Encode4(428876),
     /*   3346 */ /*AArch64::G_SDOT*//*Label 138*/ GIMT_Encode4(429275),
     /*   3350 */ /*AArch64::G_SITOF*//*Label 139*/ GIMT_Encode4(429645),
     /*   3354 */ /*AArch64::G_SMULL*//*Label 140*/ GIMT_Encode4(429762),
     /*   3358 */ /*AArch64::G_TRN1*//*Label 141*/ GIMT_Encode4(430995),
     /*   3362 */ /*AArch64::G_TRN2*//*Label 142*/ GIMT_Encode4(431775),
     /*   3366 */ /*AArch64::G_UADDLP*//*Label 143*/ GIMT_Encode4(432555),
     /*   3370 */ /*AArch64::G_UADDLV*//*Label 144*/ GIMT_Encode4(432761),
     /*   3374 */ /*AArch64::G_UDOT*//*Label 145*/ GIMT_Encode4(433628),
     /*   3378 */ /*AArch64::G_UITOF*//*Label 146*/ GIMT_Encode4(433998),
     /*   3382 */ /*AArch64::G_UMULL*//*Label 147*/ GIMT_Encode4(434115),
     /*   3386 */ /*AArch64::G_UZP1*//*Label 148*/ GIMT_Encode4(435348),
     /*   3390 */ /*AArch64::G_UZP2*//*Label 149*/ GIMT_Encode4(436128),
     /*   3394 */ /*AArch64::G_VASHR*//*Label 150*/ GIMT_Encode4(436908),
     /*   3398 */ /*AArch64::G_VLSHR*//*Label 151*/ GIMT_Encode4(437606),
     /*   3402 */ /*AArch64::G_ZIP1*//*Label 152*/ GIMT_Encode4(438062),
     /*   3406 */ /*AArch64::G_ZIP2*//*Label 153*/ GIMT_Encode4(438842),
     /*   3410 */ // Label 0: @3410
     /*   3410 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 168*/ GIMT_Encode4(36404),
     /*   3421 */ /*GILLT_s32*//*Label 155*/ GIMT_Encode4(3509),
     /*   3425 */ /*GILLT_s64*//*Label 156*/ GIMT_Encode4(6288), GIMT_Encode4(0),
     /*   3433 */ /*GILLT_v2s32*//*Label 157*/ GIMT_Encode4(11616),
     /*   3437 */ /*GILLT_v2s64*//*Label 158*/ GIMT_Encode4(15224),
     /*   3441 */ /*GILLT_v4s16*//*Label 159*/ GIMT_Encode4(21126),
     /*   3445 */ /*GILLT_v4s32*//*Label 160*/ GIMT_Encode4(24624),
     /*   3449 */ /*GILLT_v8s8*//*Label 161*/ GIMT_Encode4(30802),
     /*   3453 */ /*GILLT_v8s16*//*Label 162*/ GIMT_Encode4(31652),
     /*   3457 */ /*GILLT_v16s8*//*Label 163*/ GIMT_Encode4(35230), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3477 */ /*GILLT_nxv2s64*//*Label 164*/ GIMT_Encode4(35954), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3489 */ /*GILLT_nxv4s32*//*Label 165*/ GIMT_Encode4(36326), GIMT_Encode4(0),
     /*   3497 */ /*GILLT_nxv8s16*//*Label 166*/ GIMT_Encode4(36352), GIMT_Encode4(0),
     /*   3505 */ /*GILLT_nxv16s8*//*Label 167*/ GIMT_Encode4(36378),
     /*   3509 */ // Label 155: @3509
     /*   3509 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(6287),
     /*   3514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3520 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3553), // Rule ID 13285 //
     /*   3525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3540 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3551 */     GIR_RootConstrainSelectedInstOperands,
     /*   3552 */     // GIR_Coverage, 13285,
     /*   3552 */     GIR_EraseRootFromParent_Done,
     /*   3553 */   // Label 170: @3553
     /*   3553 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3705), // Rule ID 13712 //
     /*   3558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3585 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3588 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3593 */     // MIs[2] pattern
     /*   3593 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3596 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3607 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3607 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3610 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3614 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3621 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3624 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3628 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3633 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3636 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3640 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3670 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3677 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3687 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3704 */     // GIR_Coverage, 13712,
     /*   3704 */     GIR_EraseRootFromParent_Done,
     /*   3705 */   // Label 171: @3705
     /*   3705 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3857), // Rule ID 15566 //
     /*   3710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3737 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3740 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3745 */     // MIs[2] pattern
     /*   3745 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3748 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3759 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3759 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3762 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3766 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3785 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3792 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3795 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3829 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3839 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3856 */     // GIR_Coverage, 15566,
     /*   3856 */     GIR_EraseRootFromParent_Done,
     /*   3857 */   // Label 172: @3857
     /*   3857 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4009), // Rule ID 15578 //
     /*   3862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3889 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3892 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3897 */     // MIs[2] pattern
     /*   3897 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3900 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3911 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3911 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3914 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3918 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3937 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3940 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3944 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3947 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3952 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3957 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3974 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3981 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4008 */     // GIR_Coverage, 15578,
     /*   4008 */     GIR_EraseRootFromParent_Done,
     /*   4009 */   // Label 173: @4009
     /*   4009 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4161), // Rule ID 15590 //
     /*   4014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4041 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4044 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4049 */     // MIs[2] pattern
     /*   4049 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4052 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4063 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4063 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4066 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4070 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4089 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4092 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   4096 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4099 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4126 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4133 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4143 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4160 */     // GIR_Coverage, 15590,
     /*   4160 */     GIR_EraseRootFromParent_Done,
     /*   4161 */   // Label 174: @4161
     /*   4161 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4194), // Rule ID 91 //
     /*   4166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   4181 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   4184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4192 */     GIR_RootConstrainSelectedInstOperands,
     /*   4193 */     // GIR_Coverage, 91,
     /*   4193 */     GIR_EraseRootFromParent_Done,
     /*   4194 */   // Label 175: @4194
     /*   4194 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4346), // Rule ID 2656 //
     /*   4199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4230 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4233 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   4238 */     // MIs[2] pattern
     /*   4238 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4241 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4248 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4248 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4251 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4255 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4262 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4265 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4269 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4274 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4277 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4281 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4284 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4289 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4294 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4318 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4328 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4345 */     // GIR_Coverage, 2656,
     /*   4345 */     GIR_EraseRootFromParent_Done,
     /*   4346 */   // Label 176: @4346
     /*   4346 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4498), // Rule ID 10011 //
     /*   4351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4382 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4385 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4390 */     // MIs[2] pattern
     /*   4390 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4393 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4400 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4400 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4403 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4407 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4414 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4417 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4421 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4426 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4429 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4433 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4441 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4446 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4470 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4480 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4497 */     // GIR_Coverage, 10011,
     /*   4497 */     GIR_EraseRootFromParent_Done,
     /*   4498 */   // Label 177: @4498
     /*   4498 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4650), // Rule ID 10023 //
     /*   4503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4534 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4537 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4542 */     // MIs[2] pattern
     /*   4542 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4545 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4552 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4552 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4555 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4559 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4578 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4581 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4585 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4593 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4598 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4615 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4622 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4632 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4649 */     // GIR_Coverage, 10023,
     /*   4649 */     GIR_EraseRootFromParent_Done,
     /*   4650 */   // Label 178: @4650
     /*   4650 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4802), // Rule ID 10035 //
     /*   4655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4686 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4689 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4694 */     // MIs[2] pattern
     /*   4694 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4697 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4704 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4704 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4707 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4711 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4730 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4733 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4737 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4750 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4774 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4784 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4801 */     // GIR_Coverage, 10035,
     /*   4801 */     GIR_EraseRootFromParent_Done,
     /*   4802 */   // Label 179: @4802
     /*   4802 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4959), // Rule ID 15609 //
     /*   4807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4834 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4837 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   4846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4853 */     // MIs[2] pred
     /*   4853 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4864 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4864 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4867 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4871 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4878 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4881 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4885 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4890 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4893 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4897 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4910 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   4922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4927 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   4931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4941 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4958 */     // GIR_Coverage, 15609,
     /*   4958 */     GIR_EraseRootFromParent_Done,
     /*   4959 */   // Label 180: @4959
     /*   4959 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(5116), // Rule ID 15610 //
     /*   4964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4991 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4994 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5003 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5010 */     // MIs[2] pred
     /*   5010 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5021 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5021 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5024 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5028 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5035 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5038 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5042 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5047 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5050 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5054 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5067 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5098 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5115 */     // GIR_Coverage, 15610,
     /*   5115 */     GIR_EraseRootFromParent_Done,
     /*   5116 */   // Label 181: @5116
     /*   5116 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(5273), // Rule ID 15611 //
     /*   5121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5148 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5151 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5160 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5167 */     // MIs[2] pred
     /*   5167 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5178 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5178 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5181 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5185 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5192 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5195 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5199 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5204 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5207 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5211 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5245 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5255 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5272 */     // GIR_Coverage, 15611,
     /*   5272 */     GIR_EraseRootFromParent_Done,
     /*   5273 */   // Label 182: @5273
     /*   5273 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(5430), // Rule ID 15612 //
     /*   5278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5305 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5308 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5317 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5324 */     // MIs[2] pred
     /*   5324 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5335 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5335 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5338 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5342 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5349 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5352 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5356 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5361 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5364 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5368 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5402 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5412 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5429 */     // GIR_Coverage, 15612,
     /*   5429 */     GIR_EraseRootFromParent_Done,
     /*   5430 */   // Label 183: @5430
     /*   5430 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5587), // Rule ID 10127 //
     /*   5435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5466 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5469 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   5478 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5485 */     // MIs[2] pred
     /*   5485 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5492 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5492 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5495 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5499 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5506 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5518 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5521 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5525 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5528 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5533 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5538 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   5550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5569 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5586 */     // GIR_Coverage, 10127,
     /*   5586 */     GIR_EraseRootFromParent_Done,
     /*   5587 */   // Label 184: @5587
     /*   5587 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5744), // Rule ID 10128 //
     /*   5592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5623 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5626 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5635 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5642 */     // MIs[2] pred
     /*   5642 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5649 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5649 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5652 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5656 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5675 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5678 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5682 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5690 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5726 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5743 */     // GIR_Coverage, 10128,
     /*   5743 */     GIR_EraseRootFromParent_Done,
     /*   5744 */   // Label 185: @5744
     /*   5744 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5901), // Rule ID 10129 //
     /*   5749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5780 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5783 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5792 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5799 */     // MIs[2] pred
     /*   5799 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5806 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5806 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5809 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5813 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5820 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5823 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5827 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5832 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5835 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5839 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5847 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5852 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5869 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5883 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5900 */     // GIR_Coverage, 10129,
     /*   5900 */     GIR_EraseRootFromParent_Done,
     /*   5901 */   // Label 186: @5901
     /*   5901 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(6058), // Rule ID 10130 //
     /*   5906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5937 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5940 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5949 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5956 */     // MIs[2] pred
     /*   5956 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5963 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5963 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5966 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5970 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5977 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5980 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5984 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5989 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5992 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5996 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5999 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   6017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   6021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   6030 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   6033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6040 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   6047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6057 */     // GIR_Coverage, 10130,
     /*   6057 */     GIR_EraseRootFromParent_Done,
     /*   6058 */   // Label 187: @6058
     /*   6058 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(6091), // Rule ID 13289 //
     /*   6063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6078 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6089 */     GIR_RootConstrainSelectedInstOperands,
     /*   6090 */     // GIR_Coverage, 13289,
     /*   6090 */     GIR_EraseRootFromParent_Done,
     /*   6091 */   // Label 188: @6091
     /*   6091 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(6127), // Rule ID 13852 //
     /*   6096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6111 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6125 */     GIR_RootConstrainSelectedInstOperands,
     /*   6126 */     // GIR_Coverage, 13852,
     /*   6126 */     GIR_EraseRootFromParent_Done,
     /*   6127 */   // Label 189: @6127
     /*   6127 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(6160), // Rule ID 97 //
     /*   6132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6147 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6158 */     GIR_RootConstrainSelectedInstOperands,
     /*   6159 */     // GIR_Coverage, 97,
     /*   6159 */     GIR_EraseRootFromParent_Done,
     /*   6160 */   // Label 190: @6160
     /*   6160 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(6196), // Rule ID 3921 //
     /*   6165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6180 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6194 */     GIR_RootConstrainSelectedInstOperands,
     /*   6195 */     // GIR_Coverage, 3921,
     /*   6195 */     GIR_EraseRootFromParent_Done,
     /*   6196 */   // Label 191: @6196
     /*   6196 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(6229), // Rule ID 13287 //
     /*   6201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6216 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6227 */     GIR_RootConstrainSelectedInstOperands,
     /*   6228 */     // GIR_Coverage, 13287,
     /*   6228 */     GIR_EraseRootFromParent_Done,
     /*   6229 */   // Label 192: @6229
     /*   6229 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(6262), // Rule ID 95 //
     /*   6234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6249 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6260 */     GIR_RootConstrainSelectedInstOperands,
     /*   6261 */     // GIR_Coverage, 95,
     /*   6261 */     GIR_EraseRootFromParent_Done,
     /*   6262 */   // Label 193: @6262
     /*   6262 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(6286), // Rule ID 93 //
     /*   6267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6279 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   6279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   6284 */     GIR_RootConstrainSelectedInstOperands,
     /*   6285 */     // GIR_Coverage, 93,
     /*   6285 */     GIR_Done,
     /*   6286 */   // Label 194: @6286
     /*   6286 */   GIM_Reject,
     /*   6287 */ // Label 169: @6287
     /*   6287 */ GIM_Reject,
     /*   6288 */ // Label 156: @6288
     /*   6288 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(11615),
     /*   6293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6299 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(6435), // Rule ID 5413 //
     /*   6304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6337 */     // MIs[1] Operand 2
     /*   6337 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6360 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6364 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6368 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6372 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6377 */     // MIs[3] Operand 2
     /*   6377 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6390 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6406 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6417 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6434 */     // GIR_Coverage, 5413,
     /*   6434 */     GIR_EraseRootFromParent_Done,
     /*   6435 */   // Label 196: @6435
     /*   6435 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(6571), // Rule ID 5412 //
     /*   6440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6473 */     // MIs[1] Operand 2
     /*   6473 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6492 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6500 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6504 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6508 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6513 */     // MIs[3] Operand 2
     /*   6513 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6524 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6526 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6553 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6570 */     // GIR_Coverage, 5412,
     /*   6570 */     GIR_EraseRootFromParent_Done,
     /*   6571 */   // Label 197: @6571
     /*   6571 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(6707), // Rule ID 5422 //
     /*   6576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6609 */     // MIs[1] Operand 2
     /*   6609 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6632 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6636 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6640 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6644 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6649 */     // MIs[3] Operand 2
     /*   6649 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6660 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6662 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   6669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6689 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6706 */     // GIR_Coverage, 5422,
     /*   6706 */     GIR_EraseRootFromParent_Done,
     /*   6707 */   // Label 198: @6707
     /*   6707 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(6843), // Rule ID 5411 //
     /*   6712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6745 */     // MIs[1] Operand 2
     /*   6745 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6772 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6776 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6780 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6785 */     // MIs[3] Operand 2
     /*   6785 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6796 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6798 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6825 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6842 */     // GIR_Coverage, 5411,
     /*   6842 */     GIR_EraseRootFromParent_Done,
     /*   6843 */   // Label 199: @6843
     /*   6843 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6979), // Rule ID 5410 //
     /*   6848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6881 */     // MIs[1] Operand 2
     /*   6881 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6908 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6912 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6916 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6921 */     // MIs[3] Operand 2
     /*   6921 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6932 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6934 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6961 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6978 */     // GIR_Coverage, 5410,
     /*   6978 */     GIR_EraseRootFromParent_Done,
     /*   6979 */   // Label 200: @6979
     /*   6979 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(7047), // Rule ID 6963 //
     /*   6984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7009 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   7013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7025 */     // MIs[2] Rn
     /*   7025 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7030 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   7034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7036 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7045 */     GIR_RootConstrainSelectedInstOperands,
     /*   7046 */     // GIR_Coverage, 6963,
     /*   7046 */     GIR_EraseRootFromParent_Done,
     /*   7047 */   // Label 201: @7047
     /*   7047 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(7115), // Rule ID 14010 //
     /*   7052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7077 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   7081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7093 */     // MIs[2] Rn
     /*   7093 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7098 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   7102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7104 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7113 */     GIR_RootConstrainSelectedInstOperands,
     /*   7114 */     // GIR_Coverage, 14010,
     /*   7114 */     GIR_EraseRootFromParent_Done,
     /*   7115 */   // Label 202: @7115
     /*   7115 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(7148), // Rule ID 13286 //
     /*   7120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7135 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   7142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7146 */     GIR_RootConstrainSelectedInstOperands,
     /*   7147 */     // GIR_Coverage, 13286,
     /*   7147 */     GIR_EraseRootFromParent_Done,
     /*   7148 */   // Label 203: @7148
     /*   7148 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(7281), // Rule ID 3973 //
     /*   7153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7190 */     // MIs[2] Operand 2
     /*   7190 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7209 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7213 */     // MIs[3] Operand 1
     /*   7213 */     // No operand predicates
     /*   7213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7219 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7231 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7250 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7279 */     GIR_RootConstrainSelectedInstOperands,
     /*   7280 */     // GIR_Coverage, 3973,
     /*   7280 */     GIR_EraseRootFromParent_Done,
     /*   7281 */   // Label 204: @7281
     /*   7281 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(7376), // Rule ID 3971 //
     /*   7286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7331 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7335 */     // MIs[3] Operand 1
     /*   7335 */     // No operand predicates
     /*   7335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7341 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7353 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7374 */     GIR_RootConstrainSelectedInstOperands,
     /*   7375 */     // GIR_Coverage, 3971,
     /*   7375 */     GIR_EraseRootFromParent_Done,
     /*   7376 */   // Label 205: @7376
     /*   7376 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(7471), // Rule ID 3972 //
     /*   7381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7426 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7430 */     // MIs[3] Operand 1
     /*   7430 */     // No operand predicates
     /*   7430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7436 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7448 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7469 */     GIR_RootConstrainSelectedInstOperands,
     /*   7470 */     // GIR_Coverage, 3972,
     /*   7470 */     GIR_EraseRootFromParent_Done,
     /*   7471 */   // Label 206: @7471
     /*   7471 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(7504), // Rule ID 92 //
     /*   7476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7491 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   7498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7502 */     GIR_RootConstrainSelectedInstOperands,
     /*   7503 */     // GIR_Coverage, 92,
     /*   7503 */     GIR_EraseRootFromParent_Done,
     /*   7504 */   // Label 207: @7504
     /*   7504 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(7637), // Rule ID 13862 //
     /*   7509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7550 */     // MIs[2] Operand 2
     /*   7550 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7573 */     // MIs[3] Operand 1
     /*   7573 */     // No operand predicates
     /*   7573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7575 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7587 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7606 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7635 */     GIR_RootConstrainSelectedInstOperands,
     /*   7636 */     // GIR_Coverage, 13862,
     /*   7636 */     GIR_EraseRootFromParent_Done,
     /*   7637 */   // Label 208: @7637
     /*   7637 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(7732), // Rule ID 13860 //
     /*   7642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7691 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7695 */     // MIs[3] Operand 1
     /*   7695 */     // No operand predicates
     /*   7695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7697 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7709 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7730 */     GIR_RootConstrainSelectedInstOperands,
     /*   7731 */     // GIR_Coverage, 13860,
     /*   7731 */     GIR_EraseRootFromParent_Done,
     /*   7732 */   // Label 209: @7732
     /*   7732 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(7827), // Rule ID 13861 //
     /*   7737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7786 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7790 */     // MIs[3] Operand 1
     /*   7790 */     // No operand predicates
     /*   7790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7792 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7804 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7825 */     GIR_RootConstrainSelectedInstOperands,
     /*   7826 */     // GIR_Coverage, 13861,
     /*   7826 */     GIR_EraseRootFromParent_Done,
     /*   7827 */   // Label 210: @7827
     /*   7827 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(7909), // Rule ID 13297 //
     /*   7832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7881 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7892 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7907 */     GIR_RootConstrainSelectedInstOperands,
     /*   7908 */     // GIR_Coverage, 13297,
     /*   7908 */     GIR_EraseRootFromParent_Done,
     /*   7909 */   // Label 211: @7909
     /*   7909 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(7991), // Rule ID 13298 //
     /*   7914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7959 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7974 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7989 */     GIR_RootConstrainSelectedInstOperands,
     /*   7990 */     // GIR_Coverage, 13298,
     /*   7990 */     GIR_EraseRootFromParent_Done,
     /*   7991 */   // Label 212: @7991
     /*   7991 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(8073), // Rule ID 123 //
     /*   7996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8045 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8049 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8056 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   8059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8071 */     GIR_RootConstrainSelectedInstOperands,
     /*   8072 */     // GIR_Coverage, 123,
     /*   8072 */     GIR_EraseRootFromParent_Done,
     /*   8073 */   // Label 213: @8073
     /*   8073 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(8155), // Rule ID 125 //
     /*   8078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8127 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8131 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8138 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8153 */     GIR_RootConstrainSelectedInstOperands,
     /*   8154 */     // GIR_Coverage, 125,
     /*   8154 */     GIR_EraseRootFromParent_Done,
     /*   8155 */   // Label 214: @8155
     /*   8155 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(8213), // Rule ID 13707 //
     /*   8160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8175 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8178 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8183 */     // MIs[1] pattern
     /*   8183 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8186 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8197 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8211 */     GIR_RootConstrainSelectedInstOperands,
     /*   8212 */     // GIR_Coverage, 13707,
     /*   8212 */     GIR_EraseRootFromParent_Done,
     /*   8213 */   // Label 215: @8213
     /*   8213 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(8271), // Rule ID 15561 //
     /*   8218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8233 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8236 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8241 */     // MIs[1] pattern
     /*   8241 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8244 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8255 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8269 */     GIR_RootConstrainSelectedInstOperands,
     /*   8270 */     // GIR_Coverage, 15561,
     /*   8270 */     GIR_EraseRootFromParent_Done,
     /*   8271 */   // Label 216: @8271
     /*   8271 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(8329), // Rule ID 15573 //
     /*   8276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8291 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8294 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8299 */     // MIs[1] pattern
     /*   8299 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8302 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8313 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8327 */     GIR_RootConstrainSelectedInstOperands,
     /*   8328 */     // GIR_Coverage, 15573,
     /*   8328 */     GIR_EraseRootFromParent_Done,
     /*   8329 */   // Label 217: @8329
     /*   8329 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(8387), // Rule ID 15585 //
     /*   8334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8349 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8352 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8357 */     // MIs[1] pattern
     /*   8357 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8360 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8371 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8385 */     GIR_RootConstrainSelectedInstOperands,
     /*   8386 */     // GIR_Coverage, 15585,
     /*   8386 */     GIR_EraseRootFromParent_Done,
     /*   8387 */   // Label 218: @8387
     /*   8387 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(8445), // Rule ID 2653 //
     /*   8392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8411 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8414 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8419 */     // MIs[1] pattern
     /*   8419 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8422 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8429 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8443 */     GIR_RootConstrainSelectedInstOperands,
     /*   8444 */     // GIR_Coverage, 2653,
     /*   8444 */     GIR_EraseRootFromParent_Done,
     /*   8445 */   // Label 219: @8445
     /*   8445 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8503), // Rule ID 10008 //
     /*   8450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8469 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8472 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8477 */     // MIs[1] pattern
     /*   8477 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8480 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8487 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8501 */     GIR_RootConstrainSelectedInstOperands,
     /*   8502 */     // GIR_Coverage, 10008,
     /*   8502 */     GIR_EraseRootFromParent_Done,
     /*   8503 */   // Label 220: @8503
     /*   8503 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8561), // Rule ID 10020 //
     /*   8508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8527 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8530 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8535 */     // MIs[1] pattern
     /*   8535 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8538 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8545 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8559 */     GIR_RootConstrainSelectedInstOperands,
     /*   8560 */     // GIR_Coverage, 10020,
     /*   8560 */     GIR_EraseRootFromParent_Done,
     /*   8561 */   // Label 221: @8561
     /*   8561 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8619), // Rule ID 10032 //
     /*   8566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8585 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8588 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8593 */     // MIs[1] pattern
     /*   8593 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8596 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8603 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8617 */     GIR_RootConstrainSelectedInstOperands,
     /*   8618 */     // GIR_Coverage, 10032,
     /*   8618 */     GIR_EraseRootFromParent_Done,
     /*   8619 */   // Label 222: @8619
     /*   8619 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8782), // Rule ID 13982 //
     /*   8624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   8648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8652 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8666 */     // MIs[1] Operand 2
     /*   8666 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8683 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8683 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8686 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8690 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8697 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8700 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8704 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8709 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8712 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8716 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8719 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8724 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8729 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   8741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8746 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8749 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8753 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8764 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8781 */     // GIR_Coverage, 13982,
     /*   8781 */     GIR_EraseRootFromParent_Done,
     /*   8782 */   // Label 223: @8782
     /*   8782 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8945), // Rule ID 13979 //
     /*   8787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   8811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8829 */     // MIs[1] Operand 2
     /*   8829 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8846 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8846 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8849 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8853 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8860 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8863 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8867 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8872 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8875 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8879 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8882 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8887 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8892 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   8904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8909 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8912 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8927 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8944 */     // GIR_Coverage, 13979,
     /*   8944 */     GIR_EraseRootFromParent_Done,
     /*   8945 */   // Label 224: @8945
     /*   8945 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(9095), // Rule ID 13988 //
     /*   8950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8983 */     // MIs[1] Operand 2
     /*   8983 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9000 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9000 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9003 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9007 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9026 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9029 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9033 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9063 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9077 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9094 */     // GIR_Coverage, 13988,
     /*   9094 */     GIR_EraseRootFromParent_Done,
     /*   9095 */   // Label 225: @9095
     /*   9095 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(9245), // Rule ID 13991 //
     /*   9100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9133 */     // MIs[1] Operand 2
     /*   9133 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9150 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9150 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9153 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9157 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9164 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9167 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9171 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9176 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9179 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9183 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9191 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9196 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9213 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9216 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9227 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9244 */     // GIR_Coverage, 13991,
     /*   9244 */     GIR_EraseRootFromParent_Done,
     /*   9245 */   // Label 226: @9245
     /*   9245 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(9395), // Rule ID 13987 //
     /*   9250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9283 */     // MIs[1] Operand 2
     /*   9283 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9300 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9300 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9303 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9307 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9314 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9317 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9321 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9326 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9329 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9333 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9336 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9341 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9363 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9377 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9394 */     // GIR_Coverage, 13987,
     /*   9394 */     GIR_EraseRootFromParent_Done,
     /*   9395 */   // Label 227: @9395
     /*   9395 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(9558), // Rule ID 5395 //
     /*   9400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9446 */     // MIs[1] Operand 2
     /*   9446 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9459 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9459 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9462 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9466 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9473 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9476 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9480 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9485 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9488 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9492 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9495 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9522 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9540 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9557 */     // GIR_Coverage, 5395,
     /*   9557 */     GIR_EraseRootFromParent_Done,
     /*   9558 */   // Label 228: @9558
     /*   9558 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(9721), // Rule ID 5392 //
     /*   9563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9609 */     // MIs[1] Operand 2
     /*   9609 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9622 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9622 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9625 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9629 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9636 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9639 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9643 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9648 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9651 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9655 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9658 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9663 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   9680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9685 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9692 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9703 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9720 */     // GIR_Coverage, 5392,
     /*   9720 */     GIR_EraseRootFromParent_Done,
     /*   9721 */   // Label 229: @9721
     /*   9721 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(9871), // Rule ID 5419 //
     /*   9726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9763 */     // MIs[1] Operand 2
     /*   9763 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9776 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9776 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9779 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9783 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9790 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9797 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9802 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9805 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9809 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9812 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9817 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9822 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9839 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9853 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9870 */     // GIR_Coverage, 5419,
     /*   9870 */     GIR_EraseRootFromParent_Done,
     /*   9871 */   // Label 230: @9871
     /*   9871 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(10021), // Rule ID 5425 //
     /*   9876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9913 */     // MIs[1] Operand 2
     /*   9913 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9926 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9926 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9929 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9933 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9940 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9943 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9947 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9952 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9955 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9959 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9962 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9967 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9972 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9989 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10003 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10020 */     // GIR_Coverage, 5425,
     /*  10020 */     GIR_EraseRootFromParent_Done,
     /*  10021 */   // Label 231: @10021
     /*  10021 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(10171), // Rule ID 5418 //
     /*  10026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10063 */     // MIs[1] Operand 2
     /*  10063 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10076 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10076 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10079 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10083 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10090 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10093 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10097 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10102 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10105 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10109 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10112 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10153 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10170 */     // GIR_Coverage, 5418,
     /*  10170 */     GIR_EraseRootFromParent_Done,
     /*  10171 */   // Label 232: @10171
     /*  10171 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(10204), // Rule ID 13290 //
     /*  10176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10191 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10198 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10202 */     GIR_RootConstrainSelectedInstOperands,
     /*  10203 */     // GIR_Coverage, 13290,
     /*  10203 */     GIR_EraseRootFromParent_Done,
     /*  10204 */   // Label 233: @10204
     /*  10204 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10240), // Rule ID 13853 //
     /*  10209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10224 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10238 */     GIR_RootConstrainSelectedInstOperands,
     /*  10239 */     // GIR_Coverage, 13853,
     /*  10239 */     GIR_EraseRootFromParent_Done,
     /*  10240 */   // Label 234: @10240
     /*  10240 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10273), // Rule ID 98 //
     /*  10245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10260 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10267 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10271 */     GIR_RootConstrainSelectedInstOperands,
     /*  10272 */     // GIR_Coverage, 98,
     /*  10272 */     GIR_EraseRootFromParent_Done,
     /*  10273 */   // Label 235: @10273
     /*  10273 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10309), // Rule ID 3922 //
     /*  10278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10293 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10300 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10307 */     GIR_RootConstrainSelectedInstOperands,
     /*  10308 */     // GIR_Coverage, 3922,
     /*  10308 */     GIR_EraseRootFromParent_Done,
     /*  10309 */   // Label 236: @10309
     /*  10309 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10342), // Rule ID 13288 //
     /*  10314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10329 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10336 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10340 */     GIR_RootConstrainSelectedInstOperands,
     /*  10341 */     // GIR_Coverage, 13288,
     /*  10341 */     GIR_EraseRootFromParent_Done,
     /*  10342 */   // Label 237: @10342
     /*  10342 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10405), // Rule ID 15601 //
     /*  10347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10362 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10365 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10374 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10381 */     // MIs[1] pred
     /*  10381 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10392 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10403 */     GIR_RootConstrainSelectedInstOperands,
     /*  10404 */     // GIR_Coverage, 15601,
     /*  10404 */     GIR_EraseRootFromParent_Done,
     /*  10405 */   // Label 238: @10405
     /*  10405 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10468), // Rule ID 15602 //
     /*  10410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10425 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10428 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10437 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10444 */     // MIs[1] pred
     /*  10444 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10455 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10466 */     GIR_RootConstrainSelectedInstOperands,
     /*  10467 */     // GIR_Coverage, 15602,
     /*  10467 */     GIR_EraseRootFromParent_Done,
     /*  10468 */   // Label 239: @10468
     /*  10468 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10531), // Rule ID 15603 //
     /*  10473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10488 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10491 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10500 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10507 */     // MIs[1] pred
     /*  10507 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10518 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10529 */     GIR_RootConstrainSelectedInstOperands,
     /*  10530 */     // GIR_Coverage, 15603,
     /*  10530 */     GIR_EraseRootFromParent_Done,
     /*  10531 */   // Label 240: @10531
     /*  10531 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10594), // Rule ID 15604 //
     /*  10536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10551 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10554 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10563 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10570 */     // MIs[1] pred
     /*  10570 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10581 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10592 */     GIR_RootConstrainSelectedInstOperands,
     /*  10593 */     // GIR_Coverage, 15604,
     /*  10593 */     GIR_EraseRootFromParent_Done,
     /*  10594 */   // Label 241: @10594
     /*  10594 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10627), // Rule ID 96 //
     /*  10599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10614 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10621 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10625 */     GIR_RootConstrainSelectedInstOperands,
     /*  10626 */     // GIR_Coverage, 96,
     /*  10626 */     GIR_EraseRootFromParent_Done,
     /*  10627 */   // Label 242: @10627
     /*  10627 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10690), // Rule ID 10119 //
     /*  10632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10651 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10654 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10663 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10670 */     // MIs[1] pred
     /*  10670 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10677 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10688 */     GIR_RootConstrainSelectedInstOperands,
     /*  10689 */     // GIR_Coverage, 10119,
     /*  10689 */     GIR_EraseRootFromParent_Done,
     /*  10690 */   // Label 243: @10690
     /*  10690 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(10753), // Rule ID 10120 //
     /*  10695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10714 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10717 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10733 */     // MIs[1] pred
     /*  10733 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10740 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10751 */     GIR_RootConstrainSelectedInstOperands,
     /*  10752 */     // GIR_Coverage, 10120,
     /*  10752 */     GIR_EraseRootFromParent_Done,
     /*  10753 */   // Label 244: @10753
     /*  10753 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(10816), // Rule ID 10121 //
     /*  10758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10777 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10780 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10789 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10796 */     // MIs[1] pred
     /*  10796 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10803 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10814 */     GIR_RootConstrainSelectedInstOperands,
     /*  10815 */     // GIR_Coverage, 10121,
     /*  10815 */     GIR_EraseRootFromParent_Done,
     /*  10816 */   // Label 245: @10816
     /*  10816 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(10879), // Rule ID 10122 //
     /*  10821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10840 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10843 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10852 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10859 */     // MIs[1] pred
     /*  10859 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10866 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10877 */     GIR_RootConstrainSelectedInstOperands,
     /*  10878 */     // GIR_Coverage, 10122,
     /*  10878 */     GIR_EraseRootFromParent_Done,
     /*  10879 */   // Label 246: @10879
     /*  10879 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(10935), // Rule ID 13396 //
     /*  10884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10899 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10902 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  10907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10922 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10933 */     GIR_RootConstrainSelectedInstOperands,
     /*  10934 */     // GIR_Coverage, 13396,
     /*  10934 */     GIR_EraseRootFromParent_Done,
     /*  10935 */   // Label 247: @10935
     /*  10935 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(10991), // Rule ID 13408 //
     /*  10940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10955 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10958 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  10963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10978 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  10981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10989 */     GIR_RootConstrainSelectedInstOperands,
     /*  10990 */     // GIR_Coverage, 13408,
     /*  10990 */     GIR_EraseRootFromParent_Done,
     /*  10991 */   // Label 248: @10991
     /*  10991 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11058), // Rule ID 13614 //
     /*  10996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11020 */     // MIs[1] imm
     /*  11020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11028 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11032 */     // MIs[2] Operand 1
     /*  11032 */     // No operand predicates
     /*  11032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11042 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11056 */     GIR_RootConstrainSelectedInstOperands,
     /*  11057 */     // GIR_Coverage, 13614,
     /*  11057 */     GIR_EraseRootFromParent_Done,
     /*  11058 */   // Label 249: @11058
     /*  11058 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11125), // Rule ID 13617 //
     /*  11063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11087 */     // MIs[1] imm
     /*  11087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11099 */     // MIs[2] Operand 1
     /*  11099 */     // No operand predicates
     /*  11099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11109 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11123 */     GIR_RootConstrainSelectedInstOperands,
     /*  11124 */     // GIR_Coverage, 13617,
     /*  11124 */     GIR_EraseRootFromParent_Done,
     /*  11125 */   // Label 250: @11125
     /*  11125 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11181), // Rule ID 997 //
     /*  11130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11149 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11152 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11168 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11179 */     GIR_RootConstrainSelectedInstOperands,
     /*  11180 */     // GIR_Coverage, 997,
     /*  11180 */     GIR_EraseRootFromParent_Done,
     /*  11181 */   // Label 251: @11181
     /*  11181 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11237), // Rule ID 1058 //
     /*  11186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11205 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11208 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11224 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11235 */     GIR_RootConstrainSelectedInstOperands,
     /*  11236 */     // GIR_Coverage, 1058,
     /*  11236 */     GIR_EraseRootFromParent_Done,
     /*  11237 */   // Label 252: @11237
     /*  11237 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11304), // Rule ID 2121 //
     /*  11242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11270 */     // MIs[1] imm
     /*  11270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11278 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11282 */     // MIs[2] Operand 1
     /*  11282 */     // No operand predicates
     /*  11282 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11288 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11302 */     GIR_RootConstrainSelectedInstOperands,
     /*  11303 */     // GIR_Coverage, 2121,
     /*  11303 */     GIR_EraseRootFromParent_Done,
     /*  11304 */   // Label 253: @11304
     /*  11304 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11371), // Rule ID 2130 //
     /*  11309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11337 */     // MIs[1] imm
     /*  11337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11345 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11349 */     // MIs[2] Operand 1
     /*  11349 */     // No operand predicates
     /*  11349 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11355 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11369 */     GIR_RootConstrainSelectedInstOperands,
     /*  11370 */     // GIR_Coverage, 2130,
     /*  11370 */     GIR_EraseRootFromParent_Done,
     /*  11371 */   // Label 254: @11371
     /*  11371 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11419), // Rule ID 13395 //
     /*  11376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11406 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11417 */     GIR_RootConstrainSelectedInstOperands,
     /*  11418 */     // GIR_Coverage, 13395,
     /*  11418 */     GIR_EraseRootFromParent_Done,
     /*  11419 */   // Label 255: @11419
     /*  11419 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11467), // Rule ID 13407 //
     /*  11424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11454 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11465 */     GIR_RootConstrainSelectedInstOperands,
     /*  11466 */     // GIR_Coverage, 13407,
     /*  11466 */     GIR_EraseRootFromParent_Done,
     /*  11467 */   // Label 256: @11467
     /*  11467 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11515), // Rule ID 996 //
     /*  11472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11502 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11507 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11513 */     GIR_RootConstrainSelectedInstOperands,
     /*  11514 */     // GIR_Coverage, 996,
     /*  11514 */     GIR_EraseRootFromParent_Done,
     /*  11515 */   // Label 257: @11515
     /*  11515 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11563), // Rule ID 1057 //
     /*  11520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11550 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11561 */     GIR_RootConstrainSelectedInstOperands,
     /*  11562 */     // GIR_Coverage, 1057,
     /*  11562 */     GIR_EraseRootFromParent_Done,
     /*  11563 */   // Label 258: @11563
     /*  11563 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11587), // Rule ID 94 //
     /*  11568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11580 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  11580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*  11585 */     GIR_RootConstrainSelectedInstOperands,
     /*  11586 */     // GIR_Coverage, 94,
     /*  11586 */     GIR_Done,
     /*  11587 */   // Label 259: @11587
     /*  11587 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11614), // Rule ID 1607 //
     /*  11592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11607 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  11607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*  11612 */     GIR_RootConstrainSelectedInstOperands,
     /*  11613 */     // GIR_Coverage, 1607,
     /*  11613 */     GIR_Done,
     /*  11614 */   // Label 260: @11614
     /*  11614 */   GIM_Reject,
     /*  11615 */ // Label 195: @11615
     /*  11615 */ GIM_Reject,
     /*  11616 */ // Label 157: @11616
     /*  11616 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(15223),
     /*  11621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11627 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11815), // Rule ID 6984 //
     /*  11632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11669 */     // MIs[2] Operand 2
     /*  11669 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11688 */     // MIs[3] Rn
     /*  11688 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11693 */     // MIs[3] Operand 2
     /*  11693 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11704 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11708 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11712 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11716 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11720 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11724 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11728 */     // MIs[5] Rn
     /*  11728 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11733 */     // MIs[5] Operand 2
     /*  11733 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11744 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11748 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11752 */     // MIs[6] Rn
     /*  11752 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11757 */     // MIs[6] Operand 2
     /*  11757 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11768 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11770 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11797 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11814 */     // GIR_Coverage, 6984,
     /*  11814 */     GIR_EraseRootFromParent_Done,
     /*  11815 */   // Label 262: @11815
     /*  11815 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12003), // Rule ID 14021 //
     /*  11820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11857 */     // MIs[2] Operand 2
     /*  11857 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11868 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11872 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11876 */     // MIs[3] Rn
     /*  11876 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11881 */     // MIs[3] Operand 2
     /*  11881 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11892 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11896 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11900 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11904 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11908 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11912 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11916 */     // MIs[5] Rn
     /*  11916 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11921 */     // MIs[5] Operand 2
     /*  11921 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11932 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11936 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11940 */     // MIs[6] Rn
     /*  11940 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11945 */     // MIs[6] Operand 2
     /*  11945 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11956 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11958 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  11980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  11983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11985 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  11992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11997 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12002 */     // GIR_Coverage, 14021,
     /*  12002 */     GIR_EraseRootFromParent_Done,
     /*  12003 */   // Label 263: @12003
     /*  12003 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12139), // Rule ID 5409 //
     /*  12008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12041 */     // MIs[1] Operand 2
     /*  12041 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12060 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12064 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12068 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12072 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12076 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12081 */     // MIs[3] Operand 2
     /*  12081 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12092 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12094 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12121 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12138 */     // GIR_Coverage, 5409,
     /*  12138 */     GIR_EraseRootFromParent_Done,
     /*  12139 */   // Label 264: @12139
     /*  12139 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12275), // Rule ID 5408 //
     /*  12144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12177 */     // MIs[1] Operand 2
     /*  12177 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12196 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12200 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12204 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12208 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12212 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12217 */     // MIs[3] Operand 2
     /*  12217 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12228 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12230 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12242 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12257 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12274 */     // GIR_Coverage, 5408,
     /*  12274 */     GIR_EraseRootFromParent_Done,
     /*  12275 */   // Label 265: @12275
     /*  12275 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12411), // Rule ID 5421 //
     /*  12280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12313 */     // MIs[1] Operand 2
     /*  12313 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12332 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12336 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12340 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12344 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12348 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12353 */     // MIs[3] Operand 2
     /*  12353 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12364 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12366 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  12373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12393 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12400 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12405 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12410 */     // GIR_Coverage, 5421,
     /*  12410 */     GIR_EraseRootFromParent_Done,
     /*  12411 */   // Label 266: @12411
     /*  12411 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12547), // Rule ID 5407 //
     /*  12416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12449 */     // MIs[1] Operand 2
     /*  12449 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12484 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12489 */     // MIs[3] Operand 2
     /*  12489 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12500 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12502 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12546 */     // GIR_Coverage, 5407,
     /*  12546 */     GIR_EraseRootFromParent_Done,
     /*  12547 */   // Label 267: @12547
     /*  12547 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12683), // Rule ID 5406 //
     /*  12552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12585 */     // MIs[1] Operand 2
     /*  12585 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12616 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12620 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12625 */     // MIs[3] Operand 2
     /*  12625 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12638 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12665 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12682 */     // GIR_Coverage, 5406,
     /*  12682 */     GIR_EraseRootFromParent_Done,
     /*  12683 */   // Label 268: @12683
     /*  12683 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12846), // Rule ID 13981 //
     /*  12688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  12712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12730 */     // MIs[1] Operand 2
     /*  12730 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12747 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12747 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12750 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12754 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12761 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12764 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12768 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12773 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12776 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12780 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12783 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12788 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12793 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  12805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12810 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12828 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12845 */     // GIR_Coverage, 13981,
     /*  12845 */     GIR_EraseRootFromParent_Done,
     /*  12846 */   // Label 269: @12846
     /*  12846 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(13009), // Rule ID 13978 //
     /*  12851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  12875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12893 */     // MIs[1] Operand 2
     /*  12893 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12910 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12910 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12913 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12917 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12924 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12927 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12931 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12936 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12939 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12943 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12946 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12951 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12956 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  12968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12973 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12976 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12980 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  12984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13008 */     // GIR_Coverage, 13978,
     /*  13008 */     GIR_EraseRootFromParent_Done,
     /*  13009 */   // Label 270: @13009
     /*  13009 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(13159), // Rule ID 13986 //
     /*  13014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13047 */     // MIs[1] Operand 2
     /*  13047 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13064 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13064 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13067 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13071 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13078 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13081 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13085 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13090 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13093 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13097 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13100 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13105 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13110 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13127 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13141 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13158 */     // GIR_Coverage, 13986,
     /*  13158 */     GIR_EraseRootFromParent_Done,
     /*  13159 */   // Label 271: @13159
     /*  13159 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(13309), // Rule ID 13990 //
     /*  13164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13197 */     // MIs[1] Operand 2
     /*  13197 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13214 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13214 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13217 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13221 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13228 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13231 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13235 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13240 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13243 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13247 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13250 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13255 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13260 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13277 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13291 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13308 */     // GIR_Coverage, 13990,
     /*  13308 */     GIR_EraseRootFromParent_Done,
     /*  13309 */   // Label 272: @13309
     /*  13309 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(13459), // Rule ID 13985 //
     /*  13314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13347 */     // MIs[1] Operand 2
     /*  13347 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13364 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13364 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13367 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13371 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13378 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13381 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13385 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13390 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13393 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13397 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13410 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13427 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13441 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13458 */     // GIR_Coverage, 13985,
     /*  13458 */     GIR_EraseRootFromParent_Done,
     /*  13459 */   // Label 273: @13459
     /*  13459 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13622), // Rule ID 5394 //
     /*  13464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  13492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13510 */     // MIs[1] Operand 2
     /*  13510 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13523 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13523 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13526 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13530 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13537 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13540 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13544 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13549 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13552 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13556 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13559 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13564 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13569 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13586 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13604 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13621 */     // GIR_Coverage, 5394,
     /*  13621 */     GIR_EraseRootFromParent_Done,
     /*  13622 */   // Label 274: @13622
     /*  13622 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(13785), // Rule ID 5391 //
     /*  13627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13659 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13673 */     // MIs[1] Operand 2
     /*  13673 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13686 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13686 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13689 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13693 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13700 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13703 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13707 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13712 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13715 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13719 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13722 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13727 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13732 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13749 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13752 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13767 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13784 */     // GIR_Coverage, 5391,
     /*  13784 */     GIR_EraseRootFromParent_Done,
     /*  13785 */   // Label 275: @13785
     /*  13785 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13935), // Rule ID 5417 //
     /*  13790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13827 */     // MIs[1] Operand 2
     /*  13827 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13840 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13840 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13843 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13847 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13854 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13857 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13861 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13866 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13869 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  13873 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13876 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13886 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13903 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13917 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13934 */     // GIR_Coverage, 5417,
     /*  13934 */     GIR_EraseRootFromParent_Done,
     /*  13935 */   // Label 276: @13935
     /*  13935 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(14085), // Rule ID 5424 //
     /*  13940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13977 */     // MIs[1] Operand 2
     /*  13977 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13990 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13990 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13993 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13997 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14004 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14007 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14011 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14016 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14019 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14023 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14026 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14031 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  14048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14053 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14067 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14084 */     // GIR_Coverage, 5424,
     /*  14084 */     GIR_EraseRootFromParent_Done,
     /*  14085 */   // Label 277: @14085
     /*  14085 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(14235), // Rule ID 5416 //
     /*  14090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14127 */     // MIs[1] Operand 2
     /*  14127 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14140 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14140 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14143 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14147 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14154 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14157 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14161 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14166 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14169 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14173 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14176 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14203 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14217 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14234 */     // GIR_Coverage, 5416,
     /*  14234 */     GIR_EraseRootFromParent_Done,
     /*  14235 */   // Label 278: @14235
     /*  14235 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(14304), // Rule ID 13430 //
     /*  14240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14255 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14258 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14287 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14302 */     GIR_RootConstrainSelectedInstOperands,
     /*  14303 */     // GIR_Coverage, 13430,
     /*  14303 */     GIR_EraseRootFromParent_Done,
     /*  14304 */   // Label 279: @14304
     /*  14304 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(14373), // Rule ID 13442 //
     /*  14309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14324 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14327 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14356 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14371 */     GIR_RootConstrainSelectedInstOperands,
     /*  14372 */     // GIR_Coverage, 13442,
     /*  14372 */     GIR_EraseRootFromParent_Done,
     /*  14373 */   // Label 280: @14373
     /*  14373 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(14429), // Rule ID 13392 //
     /*  14378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14393 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14396 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14416 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14427 */     GIR_RootConstrainSelectedInstOperands,
     /*  14428 */     // GIR_Coverage, 13392,
     /*  14428 */     GIR_EraseRootFromParent_Done,
     /*  14429 */   // Label 281: @14429
     /*  14429 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(14485), // Rule ID 13404 //
     /*  14434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14449 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14452 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14472 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14483 */     GIR_RootConstrainSelectedInstOperands,
     /*  14484 */     // GIR_Coverage, 13404,
     /*  14484 */     GIR_EraseRootFromParent_Done,
     /*  14485 */   // Label 282: @14485
     /*  14485 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(14552), // Rule ID 13634 //
     /*  14490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14514 */     // MIs[1] imm
     /*  14514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14526 */     // MIs[2] Operand 1
     /*  14526 */     // No operand predicates
     /*  14526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14530 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14536 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14550 */     GIR_RootConstrainSelectedInstOperands,
     /*  14551 */     // GIR_Coverage, 13634,
     /*  14551 */     GIR_EraseRootFromParent_Done,
     /*  14552 */   // Label 283: @14552
     /*  14552 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(14619), // Rule ID 13655 //
     /*  14557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14581 */     // MIs[1] imm
     /*  14581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14593 */     // MIs[2] Operand 1
     /*  14593 */     // No operand predicates
     /*  14593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14603 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14617 */     GIR_RootConstrainSelectedInstOperands,
     /*  14618 */     // GIR_Coverage, 13655,
     /*  14618 */     GIR_EraseRootFromParent_Done,
     /*  14619 */   // Label 284: @14619
     /*  14619 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(14688), // Rule ID 1365 //
     /*  14624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14643 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14646 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14655 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14671 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14686 */     GIR_RootConstrainSelectedInstOperands,
     /*  14687 */     // GIR_Coverage, 1365,
     /*  14687 */     GIR_EraseRootFromParent_Done,
     /*  14688 */   // Label 285: @14688
     /*  14688 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(14757), // Rule ID 1488 //
     /*  14693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14712 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14715 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14724 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14740 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14755 */     GIR_RootConstrainSelectedInstOperands,
     /*  14756 */     // GIR_Coverage, 1488,
     /*  14756 */     GIR_EraseRootFromParent_Done,
     /*  14757 */   // Label 286: @14757
     /*  14757 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(14813), // Rule ID 993 //
     /*  14762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14781 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14784 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14800 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14811 */     GIR_RootConstrainSelectedInstOperands,
     /*  14812 */     // GIR_Coverage, 993,
     /*  14812 */     GIR_EraseRootFromParent_Done,
     /*  14813 */   // Label 287: @14813
     /*  14813 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(14869), // Rule ID 1054 //
     /*  14818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14837 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14840 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14856 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14867 */     GIR_RootConstrainSelectedInstOperands,
     /*  14868 */     // GIR_Coverage, 1054,
     /*  14868 */     GIR_EraseRootFromParent_Done,
     /*  14869 */   // Label 288: @14869
     /*  14869 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(14936), // Rule ID 2238 //
     /*  14874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14902 */     // MIs[1] imm
     /*  14902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14910 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14914 */     // MIs[2] Operand 1
     /*  14914 */     // No operand predicates
     /*  14914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14920 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14934 */     GIR_RootConstrainSelectedInstOperands,
     /*  14935 */     // GIR_Coverage, 2238,
     /*  14935 */     GIR_EraseRootFromParent_Done,
     /*  14936 */   // Label 289: @14936
     /*  14936 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(15003), // Rule ID 2297 //
     /*  14941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14969 */     // MIs[1] imm
     /*  14969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14977 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14981 */     // MIs[2] Operand 1
     /*  14981 */     // No operand predicates
     /*  14981 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14987 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15001 */     GIR_RootConstrainSelectedInstOperands,
     /*  15002 */     // GIR_Coverage, 2297,
     /*  15002 */     GIR_EraseRootFromParent_Done,
     /*  15003 */   // Label 290: @15003
     /*  15003 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(15051), // Rule ID 13391 //
     /*  15008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15038 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15049 */     GIR_RootConstrainSelectedInstOperands,
     /*  15050 */     // GIR_Coverage, 13391,
     /*  15050 */     GIR_EraseRootFromParent_Done,
     /*  15051 */   // Label 291: @15051
     /*  15051 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(15099), // Rule ID 13403 //
     /*  15056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15086 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15097 */     GIR_RootConstrainSelectedInstOperands,
     /*  15098 */     // GIR_Coverage, 13403,
     /*  15098 */     GIR_EraseRootFromParent_Done,
     /*  15099 */   // Label 292: @15099
     /*  15099 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(15147), // Rule ID 992 //
     /*  15104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15134 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15145 */     GIR_RootConstrainSelectedInstOperands,
     /*  15146 */     // GIR_Coverage, 992,
     /*  15146 */     GIR_EraseRootFromParent_Done,
     /*  15147 */   // Label 293: @15147
     /*  15147 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(15195), // Rule ID 1053 //
     /*  15152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15182 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15193 */     GIR_RootConstrainSelectedInstOperands,
     /*  15194 */     // GIR_Coverage, 1053,
     /*  15194 */     GIR_EraseRootFromParent_Done,
     /*  15195 */   // Label 294: @15195
     /*  15195 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(15222), // Rule ID 1104 //
     /*  15200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15215 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  15220 */     GIR_RootConstrainSelectedInstOperands,
     /*  15221 */     // GIR_Coverage, 1104,
     /*  15221 */     GIR_Done,
     /*  15222 */   // Label 295: @15222
     /*  15222 */   GIM_Reject,
     /*  15223 */ // Label 261: @15223
     /*  15223 */ GIM_Reject,
     /*  15224 */ // Label 158: @15224
     /*  15224 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(21125),
     /*  15229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  15232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  15235 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(15353), // Rule ID 13569 //
     /*  15240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15283 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15287 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15291 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15296 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15300 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15304 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15308 */     // MIs[4] Operand 1
     /*  15308 */     // No operand predicates
     /*  15308 */     // MIs[2] Operand 2
     /*  15308 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15323 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15332 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15351 */     GIR_RootConstrainSelectedInstOperands,
     /*  15352 */     // GIR_Coverage, 13569,
     /*  15352 */     GIR_EraseRootFromParent_Done,
     /*  15353 */   // Label 297: @15353
     /*  15353 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15471), // Rule ID 13570 //
     /*  15358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15401 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15405 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15409 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15414 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15418 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15422 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15426 */     // MIs[4] Operand 1
     /*  15426 */     // No operand predicates
     /*  15426 */     // MIs[2] Operand 2
     /*  15426 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15441 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15443 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15450 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15469 */     GIR_RootConstrainSelectedInstOperands,
     /*  15470 */     // GIR_Coverage, 13570,
     /*  15470 */     GIR_EraseRootFromParent_Done,
     /*  15471 */   // Label 298: @15471
     /*  15471 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15589), // Rule ID 13599 //
     /*  15476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15519 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15523 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15527 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15536 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15540 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15544 */     // MIs[4] Operand 1
     /*  15544 */     // No operand predicates
     /*  15544 */     // MIs[2] Operand 2
     /*  15544 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15559 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15568 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15587 */     GIR_RootConstrainSelectedInstOperands,
     /*  15588 */     // GIR_Coverage, 13599,
     /*  15588 */     GIR_EraseRootFromParent_Done,
     /*  15589 */   // Label 299: @15589
     /*  15589 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15707), // Rule ID 13600 //
     /*  15594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15637 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15641 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15645 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15650 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15654 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15658 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15662 */     // MIs[4] Operand 1
     /*  15662 */     // No operand predicates
     /*  15662 */     // MIs[2] Operand 2
     /*  15662 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15677 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15686 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15705 */     GIR_RootConstrainSelectedInstOperands,
     /*  15706 */     // GIR_Coverage, 13600,
     /*  15706 */     GIR_EraseRootFromParent_Done,
     /*  15707 */   // Label 300: @15707
     /*  15707 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15825), // Rule ID 2042 //
     /*  15712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15759 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15763 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15767 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15772 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15776 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15780 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15784 */     // MIs[4] Operand 1
     /*  15784 */     // No operand predicates
     /*  15784 */     // MIs[2] Operand 2
     /*  15784 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15795 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15804 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15823 */     GIR_RootConstrainSelectedInstOperands,
     /*  15824 */     // GIR_Coverage, 2042,
     /*  15824 */     GIR_EraseRootFromParent_Done,
     /*  15825 */   // Label 301: @15825
     /*  15825 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15943), // Rule ID 13568 //
     /*  15830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15881 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15885 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15890 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15894 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15898 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15902 */     // MIs[4] Operand 1
     /*  15902 */     // No operand predicates
     /*  15902 */     // MIs[2] Operand 2
     /*  15902 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15913 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15922 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15941 */     GIR_RootConstrainSelectedInstOperands,
     /*  15942 */     // GIR_Coverage, 13568,
     /*  15942 */     GIR_EraseRootFromParent_Done,
     /*  15943 */   // Label 302: @15943
     /*  15943 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(16061), // Rule ID 2094 //
     /*  15948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15995 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15999 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16003 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16008 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16012 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16016 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16020 */     // MIs[4] Operand 1
     /*  16020 */     // No operand predicates
     /*  16020 */     // MIs[2] Operand 2
     /*  16020 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16031 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16040 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16045 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16059 */     GIR_RootConstrainSelectedInstOperands,
     /*  16060 */     // GIR_Coverage, 2094,
     /*  16060 */     GIR_EraseRootFromParent_Done,
     /*  16061 */   // Label 303: @16061
     /*  16061 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(16179), // Rule ID 13598 //
     /*  16066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16113 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16117 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16121 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16126 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16130 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16134 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16138 */     // MIs[4] Operand 1
     /*  16138 */     // No operand predicates
     /*  16138 */     // MIs[2] Operand 2
     /*  16138 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16149 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16158 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16177 */     GIR_RootConstrainSelectedInstOperands,
     /*  16178 */     // GIR_Coverage, 13598,
     /*  16178 */     GIR_EraseRootFromParent_Done,
     /*  16179 */   // Label 304: @16179
     /*  16179 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(16266), // Rule ID 13474 //
     /*  16184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16211 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16214 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16223 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16233 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16247 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16264 */     GIR_RootConstrainSelectedInstOperands,
     /*  16265 */     // GIR_Coverage, 13474,
     /*  16265 */     GIR_EraseRootFromParent_Done,
     /*  16266 */   // Label 305: @16266
     /*  16266 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(16353), // Rule ID 13498 //
     /*  16271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16298 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16301 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16310 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16327 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16334 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16351 */     GIR_RootConstrainSelectedInstOperands,
     /*  16352 */     // GIR_Coverage, 13498,
     /*  16352 */     GIR_EraseRootFromParent_Done,
     /*  16353 */   // Label 306: @16353
     /*  16353 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(16440), // Rule ID 1699 //
     /*  16358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16389 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16392 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16401 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16414 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16421 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16438 */     GIR_RootConstrainSelectedInstOperands,
     /*  16439 */     // GIR_Coverage, 1699,
     /*  16439 */     GIR_EraseRootFromParent_Done,
     /*  16440 */   // Label 307: @16440
     /*  16440 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(16527), // Rule ID 1777 //
     /*  16445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16476 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16479 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16488 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16508 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16525 */     GIR_RootConstrainSelectedInstOperands,
     /*  16526 */     // GIR_Coverage, 1777,
     /*  16526 */     GIR_EraseRootFromParent_Done,
     /*  16527 */   // Label 308: @16527
     /*  16527 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16642), // Rule ID 13564 //
     /*  16532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16575 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16579 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16583 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16592 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16596 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16600 */     // MIs[4] Operand 1
     /*  16600 */     // No operand predicates
     /*  16600 */     // MIs[2] Operand 2
     /*  16600 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16620 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16622 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16640 */     GIR_RootConstrainSelectedInstOperands,
     /*  16641 */     // GIR_Coverage, 13564,
     /*  16641 */     GIR_EraseRootFromParent_Done,
     /*  16642 */   // Label 309: @16642
     /*  16642 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16757), // Rule ID 13563 //
     /*  16647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16691 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16695 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16699 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16703 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16708 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16712 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16716 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16720 */     // MIs[4] Operand 1
     /*  16720 */     // No operand predicates
     /*  16720 */     // MIs[2] Operand 2
     /*  16720 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16735 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16737 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16755 */     GIR_RootConstrainSelectedInstOperands,
     /*  16756 */     // GIR_Coverage, 13563,
     /*  16756 */     GIR_EraseRootFromParent_Done,
     /*  16757 */   // Label 310: @16757
     /*  16757 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16872), // Rule ID 13594 //
     /*  16762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16805 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16809 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16813 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16818 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16822 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16826 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16830 */     // MIs[4] Operand 1
     /*  16830 */     // No operand predicates
     /*  16830 */     // MIs[2] Operand 2
     /*  16830 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16850 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16852 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16870 */     GIR_RootConstrainSelectedInstOperands,
     /*  16871 */     // GIR_Coverage, 13594,
     /*  16871 */     GIR_EraseRootFromParent_Done,
     /*  16872 */   // Label 311: @16872
     /*  16872 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16987), // Rule ID 13593 //
     /*  16877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16925 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16929 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16933 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16938 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16942 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16946 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16950 */     // MIs[4] Operand 1
     /*  16950 */     // No operand predicates
     /*  16950 */     // MIs[2] Operand 2
     /*  16950 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16965 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16967 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  16970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16985 */     GIR_RootConstrainSelectedInstOperands,
     /*  16986 */     // GIR_Coverage, 13593,
     /*  16986 */     GIR_EraseRootFromParent_Done,
     /*  16987 */   // Label 312: @16987
     /*  16987 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(17056), // Rule ID 1801 //
     /*  16992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17032 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17039 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17054 */     GIR_RootConstrainSelectedInstOperands,
     /*  17055 */     // GIR_Coverage, 1801,
     /*  17055 */     GIR_EraseRootFromParent_Done,
     /*  17056 */   // Label 313: @17056
     /*  17056 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(17125), // Rule ID 1800 //
     /*  17061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17108 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17123 */     GIR_RootConstrainSelectedInstOperands,
     /*  17124 */     // GIR_Coverage, 1800,
     /*  17124 */     GIR_EraseRootFromParent_Done,
     /*  17125 */   // Label 314: @17125
     /*  17125 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(17194), // Rule ID 1717 //
     /*  17130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17170 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17177 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  17180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17192 */     GIR_RootConstrainSelectedInstOperands,
     /*  17193 */     // GIR_Coverage, 1717,
     /*  17193 */     GIR_EraseRootFromParent_Done,
     /*  17194 */   // Label 315: @17194
     /*  17194 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(17263), // Rule ID 1799 //
     /*  17199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17246 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17261 */     GIR_RootConstrainSelectedInstOperands,
     /*  17262 */     // GIR_Coverage, 1799,
     /*  17262 */     GIR_EraseRootFromParent_Done,
     /*  17263 */   // Label 316: @17263
     /*  17263 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(17332), // Rule ID 1798 //
     /*  17268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17308 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17315 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17330 */     GIR_RootConstrainSelectedInstOperands,
     /*  17331 */     // GIR_Coverage, 1798,
     /*  17331 */     GIR_EraseRootFromParent_Done,
     /*  17332 */   // Label 317: @17332
     /*  17332 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(17447), // Rule ID 13562 //
     /*  17337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17384 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17388 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17392 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17397 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17401 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17405 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17409 */     // MIs[4] Operand 1
     /*  17409 */     // No operand predicates
     /*  17409 */     // MIs[2] Operand 2
     /*  17409 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17425 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17427 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17445 */     GIR_RootConstrainSelectedInstOperands,
     /*  17446 */     // GIR_Coverage, 13562,
     /*  17446 */     GIR_EraseRootFromParent_Done,
     /*  17447 */   // Label 318: @17447
     /*  17447 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(17562), // Rule ID 2040 //
     /*  17452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17504 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17508 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17512 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17517 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17521 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17525 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17529 */     // MIs[4] Operand 1
     /*  17529 */     // No operand predicates
     /*  17529 */     // MIs[2] Operand 2
     /*  17529 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17540 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17542 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17560 */     GIR_RootConstrainSelectedInstOperands,
     /*  17561 */     // GIR_Coverage, 2040,
     /*  17561 */     GIR_EraseRootFromParent_Done,
     /*  17562 */   // Label 319: @17562
     /*  17562 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(17677), // Rule ID 13592 //
     /*  17567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17614 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17618 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17622 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17627 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17631 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17635 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17639 */     // MIs[4] Operand 1
     /*  17639 */     // No operand predicates
     /*  17639 */     // MIs[2] Operand 2
     /*  17639 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17655 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17657 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17675 */     GIR_RootConstrainSelectedInstOperands,
     /*  17676 */     // GIR_Coverage, 13592,
     /*  17676 */     GIR_EraseRootFromParent_Done,
     /*  17677 */   // Label 320: @17677
     /*  17677 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17792), // Rule ID 2092 //
     /*  17682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17734 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17738 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17742 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17747 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17751 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17755 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17759 */     // MIs[4] Operand 1
     /*  17759 */     // No operand predicates
     /*  17759 */     // MIs[2] Operand 2
     /*  17759 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17772 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17790 */     GIR_RootConstrainSelectedInstOperands,
     /*  17791 */     // GIR_Coverage, 2092,
     /*  17791 */     GIR_EraseRootFromParent_Done,
     /*  17792 */   // Label 321: @17792
     /*  17792 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17859), // Rule ID 13486 //
     /*  17797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17840 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17857 */     GIR_RootConstrainSelectedInstOperands,
     /*  17858 */     // GIR_Coverage, 13486,
     /*  17858 */     GIR_EraseRootFromParent_Done,
     /*  17859 */   // Label 322: @17859
     /*  17859 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17926), // Rule ID 13516 //
     /*  17864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17900 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17907 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  17910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17924 */     GIR_RootConstrainSelectedInstOperands,
     /*  17925 */     // GIR_Coverage, 13516,
     /*  17925 */     GIR_EraseRootFromParent_Done,
     /*  17926 */   // Label 323: @17926
     /*  17926 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17993), // Rule ID 1729 //
     /*  17931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17960 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17974 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  17977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17991 */     GIR_RootConstrainSelectedInstOperands,
     /*  17992 */     // GIR_Coverage, 1729,
     /*  17992 */     GIR_EraseRootFromParent_Done,
     /*  17993 */   // Label 324: @17993
     /*  17993 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(18060), // Rule ID 1819 //
     /*  17998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18034 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18041 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18058 */     GIR_RootConstrainSelectedInstOperands,
     /*  18059 */     // GIR_Coverage, 1819,
     /*  18059 */     GIR_EraseRootFromParent_Done,
     /*  18060 */   // Label 325: @18060
     /*  18060 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(18141), // Rule ID 13472 //
     /*  18065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18092 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18095 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18104 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18124 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18139 */     GIR_RootConstrainSelectedInstOperands,
     /*  18140 */     // GIR_Coverage, 13472,
     /*  18140 */     GIR_EraseRootFromParent_Done,
     /*  18141 */   // Label 326: @18141
     /*  18141 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(18222), // Rule ID 13496 //
     /*  18146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18173 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18176 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18185 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18205 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18220 */     GIR_RootConstrainSelectedInstOperands,
     /*  18221 */     // GIR_Coverage, 13496,
     /*  18221 */     GIR_EraseRootFromParent_Done,
     /*  18222 */   // Label 327: @18222
     /*  18222 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18303), // Rule ID 1697 //
     /*  18227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18258 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18261 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18270 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18286 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18301 */     GIR_RootConstrainSelectedInstOperands,
     /*  18302 */     // GIR_Coverage, 1697,
     /*  18302 */     GIR_EraseRootFromParent_Done,
     /*  18303 */   // Label 328: @18303
     /*  18303 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18384), // Rule ID 1775 //
     /*  18308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18339 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18342 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18351 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18355 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18367 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18372 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18382 */     GIR_RootConstrainSelectedInstOperands,
     /*  18383 */     // GIR_Coverage, 1775,
     /*  18383 */     GIR_EraseRootFromParent_Done,
     /*  18384 */   // Label 329: @18384
     /*  18384 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18476), // Rule ID 13567 //
     /*  18389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18441 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18445 */     // MIs[3] Operand 1
     /*  18445 */     // No operand predicates
     /*  18445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18456 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18474 */     GIR_RootConstrainSelectedInstOperands,
     /*  18475 */     // GIR_Coverage, 13567,
     /*  18475 */     GIR_EraseRootFromParent_Done,
     /*  18476 */   // Label 330: @18476
     /*  18476 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18568), // Rule ID 13566 //
     /*  18481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18538 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18542 */     // MIs[3] Operand 1
     /*  18542 */     // No operand predicates
     /*  18542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18548 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18566 */     GIR_RootConstrainSelectedInstOperands,
     /*  18567 */     // GIR_Coverage, 13566,
     /*  18567 */     GIR_EraseRootFromParent_Done,
     /*  18568 */   // Label 331: @18568
     /*  18568 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18660), // Rule ID 13597 //
     /*  18573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18625 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18629 */     // MIs[3] Operand 1
     /*  18629 */     // No operand predicates
     /*  18629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18640 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18658 */     GIR_RootConstrainSelectedInstOperands,
     /*  18659 */     // GIR_Coverage, 13597,
     /*  18659 */     GIR_EraseRootFromParent_Done,
     /*  18660 */   // Label 332: @18660
     /*  18660 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18752), // Rule ID 13596 //
     /*  18665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18722 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18726 */     // MIs[3] Operand 1
     /*  18726 */     // No operand predicates
     /*  18726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18730 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18732 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18750 */     GIR_RootConstrainSelectedInstOperands,
     /*  18751 */     // GIR_Coverage, 13596,
     /*  18751 */     GIR_EraseRootFromParent_Done,
     /*  18752 */   // Label 333: @18752
     /*  18752 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(18844), // Rule ID 13565 //
     /*  18757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18796 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18813 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18817 */     // MIs[3] Operand 1
     /*  18817 */     // No operand predicates
     /*  18817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18824 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18842 */     GIR_RootConstrainSelectedInstOperands,
     /*  18843 */     // GIR_Coverage, 13565,
     /*  18843 */     GIR_EraseRootFromParent_Done,
     /*  18844 */   // Label 334: @18844
     /*  18844 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(18936), // Rule ID 2041 //
     /*  18849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18910 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18914 */     // MIs[3] Operand 1
     /*  18914 */     // No operand predicates
     /*  18914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18916 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18934 */     GIR_RootConstrainSelectedInstOperands,
     /*  18935 */     // GIR_Coverage, 2041,
     /*  18935 */     GIR_EraseRootFromParent_Done,
     /*  18936 */   // Label 335: @18936
     /*  18936 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(19028), // Rule ID 13595 //
     /*  18941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18997 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19001 */     // MIs[3] Operand 1
     /*  19001 */     // No operand predicates
     /*  19001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19008 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19026 */     GIR_RootConstrainSelectedInstOperands,
     /*  19027 */     // GIR_Coverage, 13595,
     /*  19027 */     GIR_EraseRootFromParent_Done,
     /*  19028 */   // Label 336: @19028
     /*  19028 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(19120), // Rule ID 2093 //
     /*  19033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19094 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19098 */     // MIs[3] Operand 1
     /*  19098 */     // No operand predicates
     /*  19098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19100 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19118 */     GIR_RootConstrainSelectedInstOperands,
     /*  19119 */     // GIR_Coverage, 2093,
     /*  19119 */     GIR_EraseRootFromParent_Done,
     /*  19120 */   // Label 337: @19120
     /*  19120 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(19171), // Rule ID 13510 //
     /*  19125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19157 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19169 */     GIR_RootConstrainSelectedInstOperands,
     /*  19170 */     // GIR_Coverage, 13510,
     /*  19170 */     GIR_EraseRootFromParent_Done,
     /*  19171 */   // Label 338: @19171
     /*  19171 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(19222), // Rule ID 13480 //
     /*  19176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19208 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19220 */     GIR_RootConstrainSelectedInstOperands,
     /*  19221 */     // GIR_Coverage, 13480,
     /*  19221 */     GIR_EraseRootFromParent_Done,
     /*  19222 */   // Label 339: @19222
     /*  19222 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(19273), // Rule ID 13509 //
     /*  19227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19252 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19259 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19271 */     GIR_RootConstrainSelectedInstOperands,
     /*  19272 */     // GIR_Coverage, 13509,
     /*  19272 */     GIR_EraseRootFromParent_Done,
     /*  19273 */   // Label 340: @19273
     /*  19273 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19324), // Rule ID 1813 //
     /*  19278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19303 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19310 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19322 */     GIR_RootConstrainSelectedInstOperands,
     /*  19323 */     // GIR_Coverage, 1813,
     /*  19323 */     GIR_EraseRootFromParent_Done,
     /*  19324 */   // Label 341: @19324
     /*  19324 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19375), // Rule ID 1723 //
     /*  19329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19361 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19373 */     GIR_RootConstrainSelectedInstOperands,
     /*  19374 */     // GIR_Coverage, 1723,
     /*  19374 */     GIR_EraseRootFromParent_Done,
     /*  19375 */   // Label 342: @19375
     /*  19375 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19426), // Rule ID 1812 //
     /*  19380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19412 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19424 */     GIR_RootConstrainSelectedInstOperands,
     /*  19425 */     // GIR_Coverage, 1812,
     /*  19425 */     GIR_EraseRootFromParent_Done,
     /*  19426 */   // Label 343: @19426
     /*  19426 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19482), // Rule ID 13398 //
     /*  19431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19446 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19449 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19469 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19480 */     GIR_RootConstrainSelectedInstOperands,
     /*  19481 */     // GIR_Coverage, 13398,
     /*  19481 */     GIR_EraseRootFromParent_Done,
     /*  19482 */   // Label 344: @19482
     /*  19482 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19538), // Rule ID 13410 //
     /*  19487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19502 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19505 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19525 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19536 */     GIR_RootConstrainSelectedInstOperands,
     /*  19537 */     // GIR_Coverage, 13410,
     /*  19537 */     GIR_EraseRootFromParent_Done,
     /*  19538 */   // Label 345: @19538
     /*  19538 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19605), // Rule ID 13638 //
     /*  19543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19567 */     // MIs[1] imm
     /*  19567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19575 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19579 */     // MIs[2] Operand 1
     /*  19579 */     // No operand predicates
     /*  19579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19583 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19589 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19603 */     GIR_RootConstrainSelectedInstOperands,
     /*  19604 */     // GIR_Coverage, 13638,
     /*  19604 */     GIR_EraseRootFromParent_Done,
     /*  19605 */   // Label 346: @19605
     /*  19605 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19672), // Rule ID 13659 //
     /*  19610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19634 */     // MIs[1] imm
     /*  19634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19642 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19646 */     // MIs[2] Operand 1
     /*  19646 */     // No operand predicates
     /*  19646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19650 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19656 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19670 */     GIR_RootConstrainSelectedInstOperands,
     /*  19671 */     // GIR_Coverage, 13659,
     /*  19671 */     GIR_EraseRootFromParent_Done,
     /*  19672 */   // Label 347: @19672
     /*  19672 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19728), // Rule ID 999 //
     /*  19677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19696 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19699 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19715 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19726 */     GIR_RootConstrainSelectedInstOperands,
     /*  19727 */     // GIR_Coverage, 999,
     /*  19727 */     GIR_EraseRootFromParent_Done,
     /*  19728 */   // Label 348: @19728
     /*  19728 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(19784), // Rule ID 1060 //
     /*  19733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19752 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19755 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19771 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19782 */     GIR_RootConstrainSelectedInstOperands,
     /*  19783 */     // GIR_Coverage, 1060,
     /*  19783 */     GIR_EraseRootFromParent_Done,
     /*  19784 */   // Label 349: @19784
     /*  19784 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(19851), // Rule ID 2242 //
     /*  19789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19817 */     // MIs[1] imm
     /*  19817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19825 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19829 */     // MIs[2] Operand 1
     /*  19829 */     // No operand predicates
     /*  19829 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19835 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19849 */     GIR_RootConstrainSelectedInstOperands,
     /*  19850 */     // GIR_Coverage, 2242,
     /*  19850 */     GIR_EraseRootFromParent_Done,
     /*  19851 */   // Label 350: @19851
     /*  19851 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(19918), // Rule ID 2301 //
     /*  19856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19884 */     // MIs[1] imm
     /*  19884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19892 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19896 */     // MIs[2] Operand 1
     /*  19896 */     // No operand predicates
     /*  19896 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19902 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19916 */     GIR_RootConstrainSelectedInstOperands,
     /*  19917 */     // GIR_Coverage, 2301,
     /*  19917 */     GIR_EraseRootFromParent_Done,
     /*  19918 */   // Label 351: @19918
     /*  19918 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(19988), // Rule ID 6980 //
     /*  19923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  19935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  19943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  19957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  19961 */     // MIs[2] Rn
     /*  19961 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19966 */     // MIs[2] Rm
     /*  19966 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  19971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19973 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  19973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  19976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  19986 */     GIR_RootConstrainSelectedInstOperands,
     /*  19987 */     // GIR_Coverage, 6980,
     /*  19987 */     GIR_EraseRootFromParent_Done,
     /*  19988 */   // Label 352: @19988
     /*  19988 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(20058), // Rule ID 14017 //
     /*  19993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20031 */     // MIs[2] Rn
     /*  20031 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20036 */     // MIs[2] Rm
     /*  20036 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20043 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20056 */     GIR_RootConstrainSelectedInstOperands,
     /*  20057 */     // GIR_Coverage, 14017,
     /*  20057 */     GIR_EraseRootFromParent_Done,
     /*  20058 */   // Label 353: @20058
     /*  20058 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(20121), // Rule ID 1797 //
     /*  20063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20106 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20119 */     GIR_RootConstrainSelectedInstOperands,
     /*  20120 */     // GIR_Coverage, 1797,
     /*  20120 */     GIR_EraseRootFromParent_Done,
     /*  20121 */   // Label 354: @20121
     /*  20121 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(20184), // Rule ID 1796 //
     /*  20126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20169 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20182 */     GIR_RootConstrainSelectedInstOperands,
     /*  20183 */     // GIR_Coverage, 1796,
     /*  20183 */     GIR_EraseRootFromParent_Done,
     /*  20184 */   // Label 355: @20184
     /*  20184 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(20247), // Rule ID 1716 //
     /*  20189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20232 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  20235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20245 */     GIR_RootConstrainSelectedInstOperands,
     /*  20246 */     // GIR_Coverage, 1716,
     /*  20246 */     GIR_EraseRootFromParent_Done,
     /*  20247 */   // Label 356: @20247
     /*  20247 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(20310), // Rule ID 1795 //
     /*  20252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20295 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20308 */     GIR_RootConstrainSelectedInstOperands,
     /*  20309 */     // GIR_Coverage, 1795,
     /*  20309 */     GIR_EraseRootFromParent_Done,
     /*  20310 */   // Label 357: @20310
     /*  20310 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(20373), // Rule ID 1794 //
     /*  20315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20358 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20371 */     GIR_RootConstrainSelectedInstOperands,
     /*  20372 */     // GIR_Coverage, 1794,
     /*  20372 */     GIR_EraseRootFromParent_Done,
     /*  20373 */   // Label 358: @20373
     /*  20373 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(20434), // Rule ID 13485 //
     /*  20378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20417 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20432 */     GIR_RootConstrainSelectedInstOperands,
     /*  20433 */     // GIR_Coverage, 13485,
     /*  20433 */     GIR_EraseRootFromParent_Done,
     /*  20434 */   // Label 359: @20434
     /*  20434 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(20495), // Rule ID 13515 //
     /*  20439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20478 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20493 */     GIR_RootConstrainSelectedInstOperands,
     /*  20494 */     // GIR_Coverage, 13515,
     /*  20494 */     GIR_EraseRootFromParent_Done,
     /*  20495 */   // Label 360: @20495
     /*  20495 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(20543), // Rule ID 13508 //
     /*  20500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20530 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20541 */     GIR_RootConstrainSelectedInstOperands,
     /*  20542 */     // GIR_Coverage, 13508,
     /*  20542 */     GIR_EraseRootFromParent_Done,
     /*  20543 */   // Label 361: @20543
     /*  20543 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(20591), // Rule ID 13397 //
     /*  20548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20578 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20589 */     GIR_RootConstrainSelectedInstOperands,
     /*  20590 */     // GIR_Coverage, 13397,
     /*  20590 */     GIR_EraseRootFromParent_Done,
     /*  20591 */   // Label 362: @20591
     /*  20591 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(20639), // Rule ID 13479 //
     /*  20596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20626 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20637 */     GIR_RootConstrainSelectedInstOperands,
     /*  20638 */     // GIR_Coverage, 13479,
     /*  20638 */     GIR_EraseRootFromParent_Done,
     /*  20639 */   // Label 363: @20639
     /*  20639 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(20687), // Rule ID 13409 //
     /*  20644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  20659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20674 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20685 */     GIR_RootConstrainSelectedInstOperands,
     /*  20686 */     // GIR_Coverage, 13409,
     /*  20686 */     GIR_EraseRootFromParent_Done,
     /*  20687 */   // Label 364: @20687
     /*  20687 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(20735), // Rule ID 13507 //
     /*  20692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20722 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20733 */     GIR_RootConstrainSelectedInstOperands,
     /*  20734 */     // GIR_Coverage, 13507,
     /*  20734 */     GIR_EraseRootFromParent_Done,
     /*  20735 */   // Label 365: @20735
     /*  20735 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(20796), // Rule ID 1728 //
     /*  20740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20779 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20794 */     GIR_RootConstrainSelectedInstOperands,
     /*  20795 */     // GIR_Coverage, 1728,
     /*  20795 */     GIR_EraseRootFromParent_Done,
     /*  20796 */   // Label 366: @20796
     /*  20796 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20857), // Rule ID 1818 //
     /*  20801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20840 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20855 */     GIR_RootConstrainSelectedInstOperands,
     /*  20856 */     // GIR_Coverage, 1818,
     /*  20856 */     GIR_EraseRootFromParent_Done,
     /*  20857 */   // Label 367: @20857
     /*  20857 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20905), // Rule ID 1811 //
     /*  20862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20892 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20903 */     GIR_RootConstrainSelectedInstOperands,
     /*  20904 */     // GIR_Coverage, 1811,
     /*  20904 */     GIR_EraseRootFromParent_Done,
     /*  20905 */   // Label 368: @20905
     /*  20905 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20953), // Rule ID 998 //
     /*  20910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20940 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20951 */     GIR_RootConstrainSelectedInstOperands,
     /*  20952 */     // GIR_Coverage, 998,
     /*  20952 */     GIR_EraseRootFromParent_Done,
     /*  20953 */   // Label 369: @20953
     /*  20953 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(21001), // Rule ID 1722 //
     /*  20958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20988 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20999 */     GIR_RootConstrainSelectedInstOperands,
     /*  21000 */     // GIR_Coverage, 1722,
     /*  21000 */     GIR_EraseRootFromParent_Done,
     /*  21001 */   // Label 370: @21001
     /*  21001 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(21049), // Rule ID 1059 //
     /*  21006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21036 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21047 */     GIR_RootConstrainSelectedInstOperands,
     /*  21048 */     // GIR_Coverage, 1059,
     /*  21048 */     GIR_EraseRootFromParent_Done,
     /*  21049 */   // Label 371: @21049
     /*  21049 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(21097), // Rule ID 1810 //
     /*  21054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21084 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21095 */     GIR_RootConstrainSelectedInstOperands,
     /*  21096 */     // GIR_Coverage, 1810,
     /*  21096 */     GIR_EraseRootFromParent_Done,
     /*  21097 */   // Label 372: @21097
     /*  21097 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(21124), // Rule ID 1106 //
     /*  21102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21117 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  21117 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  21122 */     GIR_RootConstrainSelectedInstOperands,
     /*  21123 */     // GIR_Coverage, 1106,
     /*  21123 */     GIR_Done,
     /*  21124 */   // Label 373: @21124
     /*  21124 */   GIM_Reject,
     /*  21125 */ // Label 296: @21125
     /*  21125 */ GIM_Reject,
     /*  21126 */ // Label 159: @21126
     /*  21126 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(24623),
     /*  21131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  21134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21137 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21273), // Rule ID 5405 //
     /*  21142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21175 */     // MIs[1] Operand 2
     /*  21175 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21198 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21202 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21206 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21210 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21215 */     // MIs[3] Operand 2
     /*  21215 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21226 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21228 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21244 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21255 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21272 */     // GIR_Coverage, 5405,
     /*  21272 */     GIR_EraseRootFromParent_Done,
     /*  21273 */   // Label 375: @21273
     /*  21273 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21409), // Rule ID 5404 //
     /*  21278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21311 */     // MIs[1] Operand 2
     /*  21311 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21330 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21334 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21338 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21342 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21346 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21351 */     // MIs[3] Operand 2
     /*  21351 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21362 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21364 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21391 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21408 */     // GIR_Coverage, 5404,
     /*  21408 */     GIR_EraseRootFromParent_Done,
     /*  21409 */   // Label 376: @21409
     /*  21409 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21545), // Rule ID 5420 //
     /*  21414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21447 */     // MIs[1] Operand 2
     /*  21447 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21466 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21470 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21474 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21478 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21482 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21487 */     // MIs[3] Operand 2
     /*  21487 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21498 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21500 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  21507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21516 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21527 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21544 */     // GIR_Coverage, 5420,
     /*  21544 */     GIR_EraseRootFromParent_Done,
     /*  21545 */   // Label 377: @21545
     /*  21545 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21681), // Rule ID 5403 //
     /*  21550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21583 */     // MIs[1] Operand 2
     /*  21583 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21602 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21606 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21610 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21614 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21618 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21623 */     // MIs[3] Operand 2
     /*  21623 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21634 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21636 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21663 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21670 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21675 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21680 */     // GIR_Coverage, 5403,
     /*  21680 */     GIR_EraseRootFromParent_Done,
     /*  21681 */   // Label 378: @21681
     /*  21681 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21817), // Rule ID 5402 //
     /*  21686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21719 */     // MIs[1] Operand 2
     /*  21719 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21738 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21742 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21746 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21750 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21754 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21759 */     // MIs[3] Operand 2
     /*  21759 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21772 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21784 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21788 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21799 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21806 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21816 */     // GIR_Coverage, 5402,
     /*  21816 */     GIR_EraseRootFromParent_Done,
     /*  21817 */   // Label 379: @21817
     /*  21817 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21950), // Rule ID 14022 //
     /*  21822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  21846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  21854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  21867 */     // MIs[1] Operand 2
     /*  21867 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21878 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  21882 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21886 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21890 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  21894 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21898 */     // MIs[5] Rn
     /*  21898 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21903 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  21905 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  21905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  21908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  21912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21921 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21932 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21949 */     // GIR_Coverage, 14022,
     /*  21949 */     GIR_EraseRootFromParent_Done,
     /*  21950 */   // Label 380: @21950
     /*  21950 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(22083), // Rule ID 6985 //
     /*  21955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  21967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  21979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22000 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22004 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  22008 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22012 */     // MIs[4] Rn
     /*  22012 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22017 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22021 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22025 */     // MIs[3] Operand 2
     /*  22025 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22036 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22038 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22065 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22082 */     // GIR_Coverage, 6985,
     /*  22082 */     GIR_EraseRootFromParent_Done,
     /*  22083 */   // Label 381: @22083
     /*  22083 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(22246), // Rule ID 13980 //
     /*  22088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22130 */     // MIs[1] Operand 2
     /*  22130 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22147 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22147 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22150 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22154 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22161 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22164 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22168 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22173 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22176 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22180 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22183 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22188 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22193 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22210 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22217 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22228 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22245 */     // GIR_Coverage, 13980,
     /*  22245 */     GIR_EraseRootFromParent_Done,
     /*  22246 */   // Label 382: @22246
     /*  22246 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22409), // Rule ID 13977 //
     /*  22251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22293 */     // MIs[1] Operand 2
     /*  22293 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22310 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22310 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22313 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22317 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22324 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22327 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22331 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22336 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22339 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22343 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  22368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22391 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22408 */     // GIR_Coverage, 13977,
     /*  22408 */     GIR_EraseRootFromParent_Done,
     /*  22409 */   // Label 383: @22409
     /*  22409 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22559), // Rule ID 13984 //
     /*  22414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  22438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22447 */     // MIs[1] Operand 2
     /*  22447 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22464 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22464 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22467 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22471 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22478 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22481 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22485 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22490 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22493 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22497 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22510 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22527 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22541 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22558 */     // GIR_Coverage, 13984,
     /*  22558 */     GIR_EraseRootFromParent_Done,
     /*  22559 */   // Label 384: @22559
     /*  22559 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22709), // Rule ID 13989 //
     /*  22564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22597 */     // MIs[1] Operand 2
     /*  22597 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22614 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22614 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22617 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22621 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22628 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22631 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22635 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22640 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22643 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22647 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22650 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22655 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22660 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  22672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22677 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22691 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22698 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22708 */     // GIR_Coverage, 13989,
     /*  22708 */     GIR_EraseRootFromParent_Done,
     /*  22709 */   // Label 385: @22709
     /*  22709 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22859), // Rule ID 13983 //
     /*  22714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22747 */     // MIs[1] Operand 2
     /*  22747 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22764 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22764 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22767 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22771 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22778 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22781 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22785 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22790 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22793 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22797 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22810 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22827 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22841 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22858 */     // GIR_Coverage, 13983,
     /*  22858 */     GIR_EraseRootFromParent_Done,
     /*  22859 */   // Label 386: @22859
     /*  22859 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(23022), // Rule ID 5393 //
     /*  22864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22910 */     // MIs[1] Operand 2
     /*  22910 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22923 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22923 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22926 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22930 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22937 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22940 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22944 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22949 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22952 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  22956 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22959 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22964 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22969 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22986 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23004 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23021 */     // GIR_Coverage, 5393,
     /*  23021 */     GIR_EraseRootFromParent_Done,
     /*  23022 */   // Label 387: @23022
     /*  23022 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(23185), // Rule ID 5390 //
     /*  23027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  23055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23059 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23073 */     // MIs[1] Operand 2
     /*  23073 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23086 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23086 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23089 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23093 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23100 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23103 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23107 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23112 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23115 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23119 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23127 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23132 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  23144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23149 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23152 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23167 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23184 */     // GIR_Coverage, 5390,
     /*  23184 */     GIR_EraseRootFromParent_Done,
     /*  23185 */   // Label 388: @23185
     /*  23185 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(23335), // Rule ID 5415 //
     /*  23190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23227 */     // MIs[1] Operand 2
     /*  23227 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23240 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23240 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23243 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23247 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23254 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23257 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23261 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23266 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23269 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23273 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23276 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23281 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23303 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23317 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23334 */     // GIR_Coverage, 5415,
     /*  23334 */     GIR_EraseRootFromParent_Done,
     /*  23335 */   // Label 389: @23335
     /*  23335 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23485), // Rule ID 5423 //
     /*  23340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23377 */     // MIs[1] Operand 2
     /*  23377 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23390 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23390 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23393 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23397 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23404 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23407 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23411 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23416 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23419 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23423 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23426 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23431 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  23448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23453 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23467 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23484 */     // GIR_Coverage, 5423,
     /*  23484 */     GIR_EraseRootFromParent_Done,
     /*  23485 */   // Label 390: @23485
     /*  23485 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23635), // Rule ID 5414 //
     /*  23490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23527 */     // MIs[1] Operand 2
     /*  23527 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23540 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23540 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23543 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23547 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23566 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23569 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23573 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23576 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23586 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23603 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23606 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23617 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23634 */     // GIR_Coverage, 5414,
     /*  23634 */     GIR_EraseRootFromParent_Done,
     /*  23635 */   // Label 391: @23635
     /*  23635 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23704), // Rule ID 13426 //
     /*  23640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23655 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23658 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23687 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  23690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23702 */     GIR_RootConstrainSelectedInstOperands,
     /*  23703 */     // GIR_Coverage, 13426,
     /*  23703 */     GIR_EraseRootFromParent_Done,
     /*  23704 */   // Label 392: @23704
     /*  23704 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23773), // Rule ID 13438 //
     /*  23709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23724 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23727 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  23732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23736 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23756 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  23759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23771 */     GIR_RootConstrainSelectedInstOperands,
     /*  23772 */     // GIR_Coverage, 13438,
     /*  23772 */     GIR_EraseRootFromParent_Done,
     /*  23773 */   // Label 393: @23773
     /*  23773 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23829), // Rule ID 13388 //
     /*  23778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23793 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23796 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  23801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23816 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  23819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23827 */     GIR_RootConstrainSelectedInstOperands,
     /*  23828 */     // GIR_Coverage, 13388,
     /*  23828 */     GIR_EraseRootFromParent_Done,
     /*  23829 */   // Label 394: @23829
     /*  23829 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23885), // Rule ID 13400 //
     /*  23834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23849 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  23852 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  23857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23872 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  23872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  23875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23883 */     GIR_RootConstrainSelectedInstOperands,
     /*  23884 */     // GIR_Coverage, 13400,
     /*  23884 */     GIR_EraseRootFromParent_Done,
     /*  23885 */   // Label 395: @23885
     /*  23885 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23952), // Rule ID 13630 //
     /*  23890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  23905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23914 */     // MIs[1] imm
     /*  23914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23922 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23926 */     // MIs[2] Operand 1
     /*  23926 */     // No operand predicates
     /*  23926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23930 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  23934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23936 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  23939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  23947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  23950 */     GIR_RootConstrainSelectedInstOperands,
     /*  23951 */     // GIR_Coverage, 13630,
     /*  23951 */     GIR_EraseRootFromParent_Done,
     /*  23952 */   // Label 396: @23952
     /*  23952 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(24019), // Rule ID 13651 //
     /*  23957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  23972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23981 */     // MIs[1] imm
     /*  23981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  23993 */     // MIs[2] Operand 1
     /*  23993 */     // No operand predicates
     /*  23993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24003 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24017 */     GIR_RootConstrainSelectedInstOperands,
     /*  24018 */     // GIR_Coverage, 13651,
     /*  24018 */     GIR_EraseRootFromParent_Done,
     /*  24019 */   // Label 397: @24019
     /*  24019 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24088), // Rule ID 1361 //
     /*  24024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24043 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24046 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24055 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24071 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24086 */     GIR_RootConstrainSelectedInstOperands,
     /*  24087 */     // GIR_Coverage, 1361,
     /*  24087 */     GIR_EraseRootFromParent_Done,
     /*  24088 */   // Label 398: @24088
     /*  24088 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24157), // Rule ID 1484 //
     /*  24093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24112 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24115 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24124 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24140 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24155 */     GIR_RootConstrainSelectedInstOperands,
     /*  24156 */     // GIR_Coverage, 1484,
     /*  24156 */     GIR_EraseRootFromParent_Done,
     /*  24157 */   // Label 399: @24157
     /*  24157 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24213), // Rule ID 989 //
     /*  24162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24181 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24184 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24200 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24211 */     GIR_RootConstrainSelectedInstOperands,
     /*  24212 */     // GIR_Coverage, 989,
     /*  24212 */     GIR_EraseRootFromParent_Done,
     /*  24213 */   // Label 400: @24213
     /*  24213 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24269), // Rule ID 1050 //
     /*  24218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24237 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24240 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24256 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24267 */     GIR_RootConstrainSelectedInstOperands,
     /*  24268 */     // GIR_Coverage, 1050,
     /*  24268 */     GIR_EraseRootFromParent_Done,
     /*  24269 */   // Label 401: @24269
     /*  24269 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24336), // Rule ID 2234 //
     /*  24274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24302 */     // MIs[1] imm
     /*  24302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24310 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24314 */     // MIs[2] Operand 1
     /*  24314 */     // No operand predicates
     /*  24314 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24320 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24334 */     GIR_RootConstrainSelectedInstOperands,
     /*  24335 */     // GIR_Coverage, 2234,
     /*  24335 */     GIR_EraseRootFromParent_Done,
     /*  24336 */   // Label 402: @24336
     /*  24336 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24403), // Rule ID 2293 //
     /*  24341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24369 */     // MIs[1] imm
     /*  24369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24377 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24381 */     // MIs[2] Operand 1
     /*  24381 */     // No operand predicates
     /*  24381 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24387 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24401 */     GIR_RootConstrainSelectedInstOperands,
     /*  24402 */     // GIR_Coverage, 2293,
     /*  24402 */     GIR_EraseRootFromParent_Done,
     /*  24403 */   // Label 403: @24403
     /*  24403 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24451), // Rule ID 13387 //
     /*  24408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24438 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24449 */     GIR_RootConstrainSelectedInstOperands,
     /*  24450 */     // GIR_Coverage, 13387,
     /*  24450 */     GIR_EraseRootFromParent_Done,
     /*  24451 */   // Label 404: @24451
     /*  24451 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(24499), // Rule ID 13399 //
     /*  24456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24486 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24497 */     GIR_RootConstrainSelectedInstOperands,
     /*  24498 */     // GIR_Coverage, 13399,
     /*  24498 */     GIR_EraseRootFromParent_Done,
     /*  24499 */   // Label 405: @24499
     /*  24499 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(24547), // Rule ID 988 //
     /*  24504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24534 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24545 */     GIR_RootConstrainSelectedInstOperands,
     /*  24546 */     // GIR_Coverage, 988,
     /*  24546 */     GIR_EraseRootFromParent_Done,
     /*  24547 */   // Label 406: @24547
     /*  24547 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(24595), // Rule ID 1049 //
     /*  24552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24582 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24593 */     GIR_RootConstrainSelectedInstOperands,
     /*  24594 */     // GIR_Coverage, 1049,
     /*  24594 */     GIR_EraseRootFromParent_Done,
     /*  24595 */   // Label 407: @24595
     /*  24595 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24622), // Rule ID 1102 //
     /*  24600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24615 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  24620 */     GIR_RootConstrainSelectedInstOperands,
     /*  24621 */     // GIR_Coverage, 1102,
     /*  24621 */     GIR_Done,
     /*  24622 */   // Label 408: @24622
     /*  24622 */   GIM_Reject,
     /*  24623 */ // Label 374: @24623
     /*  24623 */ GIM_Reject,
     /*  24624 */ // Label 160: @24624
     /*  24624 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(30801),
     /*  24629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24635 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24753), // Rule ID 13560 //
     /*  24640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24687 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24691 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24696 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24700 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24704 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24708 */     // MIs[4] Operand 1
     /*  24708 */     // No operand predicates
     /*  24708 */     // MIs[2] Operand 2
     /*  24708 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24723 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24732 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24751 */     GIR_RootConstrainSelectedInstOperands,
     /*  24752 */     // GIR_Coverage, 13560,
     /*  24752 */     GIR_EraseRootFromParent_Done,
     /*  24753 */   // Label 410: @24753
     /*  24753 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(24871), // Rule ID 13561 //
     /*  24758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24801 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24805 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24809 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24814 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24818 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24822 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24826 */     // MIs[4] Operand 1
     /*  24826 */     // No operand predicates
     /*  24826 */     // MIs[2] Operand 2
     /*  24826 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24841 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24843 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24850 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24869 */     GIR_RootConstrainSelectedInstOperands,
     /*  24870 */     // GIR_Coverage, 13561,
     /*  24870 */     GIR_EraseRootFromParent_Done,
     /*  24871 */   // Label 411: @24871
     /*  24871 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(24989), // Rule ID 13590 //
     /*  24876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  24891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24919 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24923 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24927 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24932 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24936 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24940 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24944 */     // MIs[4] Operand 1
     /*  24944 */     // No operand predicates
     /*  24944 */     // MIs[2] Operand 2
     /*  24944 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24959 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24968 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  24971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24987 */     GIR_RootConstrainSelectedInstOperands,
     /*  24988 */     // GIR_Coverage, 13590,
     /*  24988 */     GIR_EraseRootFromParent_Done,
     /*  24989 */   // Label 412: @24989
     /*  24989 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(25107), // Rule ID 13591 //
     /*  24994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25033 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25037 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25041 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25045 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25050 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25054 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25058 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25062 */     // MIs[4] Operand 1
     /*  25062 */     // No operand predicates
     /*  25062 */     // MIs[2] Operand 2
     /*  25062 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25077 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25086 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25105 */     GIR_RootConstrainSelectedInstOperands,
     /*  25106 */     // GIR_Coverage, 13591,
     /*  25106 */     GIR_EraseRootFromParent_Done,
     /*  25107 */   // Label 413: @25107
     /*  25107 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(25225), // Rule ID 2039 //
     /*  25112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25159 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25163 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25167 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25176 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25180 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25184 */     // MIs[4] Operand 1
     /*  25184 */     // No operand predicates
     /*  25184 */     // MIs[2] Operand 2
     /*  25184 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25195 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25204 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25223 */     GIR_RootConstrainSelectedInstOperands,
     /*  25224 */     // GIR_Coverage, 2039,
     /*  25224 */     GIR_EraseRootFromParent_Done,
     /*  25225 */   // Label 414: @25225
     /*  25225 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(25343), // Rule ID 13559 //
     /*  25230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25277 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25281 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25285 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25290 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25294 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25298 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25302 */     // MIs[4] Operand 1
     /*  25302 */     // No operand predicates
     /*  25302 */     // MIs[2] Operand 2
     /*  25302 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25313 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25322 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25341 */     GIR_RootConstrainSelectedInstOperands,
     /*  25342 */     // GIR_Coverage, 13559,
     /*  25342 */     GIR_EraseRootFromParent_Done,
     /*  25343 */   // Label 415: @25343
     /*  25343 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(25461), // Rule ID 2091 //
     /*  25348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25403 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25408 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25412 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25416 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25420 */     // MIs[4] Operand 1
     /*  25420 */     // No operand predicates
     /*  25420 */     // MIs[2] Operand 2
     /*  25420 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25431 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25440 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25459 */     GIR_RootConstrainSelectedInstOperands,
     /*  25460 */     // GIR_Coverage, 2091,
     /*  25460 */     GIR_EraseRootFromParent_Done,
     /*  25461 */   // Label 416: @25461
     /*  25461 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(25579), // Rule ID 13589 //
     /*  25466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25513 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25517 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25521 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25526 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25530 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25534 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25538 */     // MIs[4] Operand 1
     /*  25538 */     // No operand predicates
     /*  25538 */     // MIs[2] Operand 2
     /*  25538 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25549 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25558 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25563 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25577 */     GIR_RootConstrainSelectedInstOperands,
     /*  25578 */     // GIR_Coverage, 13589,
     /*  25578 */     GIR_EraseRootFromParent_Done,
     /*  25579 */   // Label 417: @25579
     /*  25579 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(25666), // Rule ID 13470 //
     /*  25584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25611 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25614 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25623 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25633 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25647 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25664 */     GIR_RootConstrainSelectedInstOperands,
     /*  25665 */     // GIR_Coverage, 13470,
     /*  25665 */     GIR_EraseRootFromParent_Done,
     /*  25666 */   // Label 418: @25666
     /*  25666 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25753), // Rule ID 13494 //
     /*  25671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25698 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25701 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25710 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25734 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25751 */     GIR_RootConstrainSelectedInstOperands,
     /*  25752 */     // GIR_Coverage, 13494,
     /*  25752 */     GIR_EraseRootFromParent_Done,
     /*  25753 */   // Label 419: @25753
     /*  25753 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25840), // Rule ID 1695 //
     /*  25758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25789 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25792 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25801 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25821 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25838 */     GIR_RootConstrainSelectedInstOperands,
     /*  25839 */     // GIR_Coverage, 1695,
     /*  25839 */     GIR_EraseRootFromParent_Done,
     /*  25840 */   // Label 420: @25840
     /*  25840 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25927), // Rule ID 1773 //
     /*  25845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25876 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25879 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25888 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25901 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25908 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25925 */     GIR_RootConstrainSelectedInstOperands,
     /*  25926 */     // GIR_Coverage, 1773,
     /*  25926 */     GIR_EraseRootFromParent_Done,
     /*  25927 */   // Label 421: @25927
     /*  25927 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(26042), // Rule ID 13555 //
     /*  25932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25979 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25983 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25988 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25992 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25996 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26000 */     // MIs[4] Operand 1
     /*  26000 */     // No operand predicates
     /*  26000 */     // MIs[2] Operand 2
     /*  26000 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26020 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26022 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26040 */     GIR_RootConstrainSelectedInstOperands,
     /*  26041 */     // GIR_Coverage, 13555,
     /*  26041 */     GIR_EraseRootFromParent_Done,
     /*  26042 */   // Label 422: @26042
     /*  26042 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(26157), // Rule ID 13554 //
     /*  26047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26095 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26099 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26103 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26108 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26112 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26116 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26120 */     // MIs[4] Operand 1
     /*  26120 */     // No operand predicates
     /*  26120 */     // MIs[2] Operand 2
     /*  26120 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26135 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26137 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26155 */     GIR_RootConstrainSelectedInstOperands,
     /*  26156 */     // GIR_Coverage, 13554,
     /*  26156 */     GIR_EraseRootFromParent_Done,
     /*  26157 */   // Label 423: @26157
     /*  26157 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(26272), // Rule ID 13585 //
     /*  26162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26213 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26226 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26230 */     // MIs[4] Operand 1
     /*  26230 */     // No operand predicates
     /*  26230 */     // MIs[2] Operand 2
     /*  26230 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26250 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26252 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26270 */     GIR_RootConstrainSelectedInstOperands,
     /*  26271 */     // GIR_Coverage, 13585,
     /*  26271 */     GIR_EraseRootFromParent_Done,
     /*  26272 */   // Label 424: @26272
     /*  26272 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(26387), // Rule ID 13584 //
     /*  26277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26325 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26329 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26333 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26338 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26342 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26346 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26350 */     // MIs[4] Operand 1
     /*  26350 */     // No operand predicates
     /*  26350 */     // MIs[2] Operand 2
     /*  26350 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26365 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26367 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26385 */     GIR_RootConstrainSelectedInstOperands,
     /*  26386 */     // GIR_Coverage, 13584,
     /*  26386 */     GIR_EraseRootFromParent_Done,
     /*  26387 */   // Label 425: @26387
     /*  26387 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(26456), // Rule ID 1793 //
     /*  26392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26425 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26432 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26439 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26454 */     GIR_RootConstrainSelectedInstOperands,
     /*  26455 */     // GIR_Coverage, 1793,
     /*  26455 */     GIR_EraseRootFromParent_Done,
     /*  26456 */   // Label 426: @26456
     /*  26456 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(26525), // Rule ID 1792 //
     /*  26461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26501 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26508 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26523 */     GIR_RootConstrainSelectedInstOperands,
     /*  26524 */     // GIR_Coverage, 1792,
     /*  26524 */     GIR_EraseRootFromParent_Done,
     /*  26525 */   // Label 427: @26525
     /*  26525 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(26594), // Rule ID 1715 //
     /*  26530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26570 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26577 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  26580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26592 */     GIR_RootConstrainSelectedInstOperands,
     /*  26593 */     // GIR_Coverage, 1715,
     /*  26593 */     GIR_EraseRootFromParent_Done,
     /*  26594 */   // Label 428: @26594
     /*  26594 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(26663), // Rule ID 1791 //
     /*  26599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26646 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26661 */     GIR_RootConstrainSelectedInstOperands,
     /*  26662 */     // GIR_Coverage, 1791,
     /*  26662 */     GIR_EraseRootFromParent_Done,
     /*  26663 */   // Label 429: @26663
     /*  26663 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26732), // Rule ID 1790 //
     /*  26668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26715 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26730 */     GIR_RootConstrainSelectedInstOperands,
     /*  26731 */     // GIR_Coverage, 1790,
     /*  26731 */     GIR_EraseRootFromParent_Done,
     /*  26732 */   // Label 430: @26732
     /*  26732 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26847), // Rule ID 13553 //
     /*  26737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26788 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26792 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26797 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26801 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26805 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26809 */     // MIs[4] Operand 1
     /*  26809 */     // No operand predicates
     /*  26809 */     // MIs[2] Operand 2
     /*  26809 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26825 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26827 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26845 */     GIR_RootConstrainSelectedInstOperands,
     /*  26846 */     // GIR_Coverage, 13553,
     /*  26846 */     GIR_EraseRootFromParent_Done,
     /*  26847 */   // Label 431: @26847
     /*  26847 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(26962), // Rule ID 2037 //
     /*  26852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26904 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26908 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26912 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26917 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26921 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26925 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26929 */     // MIs[4] Operand 1
     /*  26929 */     // No operand predicates
     /*  26929 */     // MIs[2] Operand 2
     /*  26929 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26940 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26942 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26960 */     GIR_RootConstrainSelectedInstOperands,
     /*  26961 */     // GIR_Coverage, 2037,
     /*  26961 */     GIR_EraseRootFromParent_Done,
     /*  26962 */   // Label 432: @26962
     /*  26962 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(27077), // Rule ID 13583 //
     /*  26967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27006 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27010 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27014 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27018 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27022 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27027 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27031 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27035 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27039 */     // MIs[4] Operand 1
     /*  27039 */     // No operand predicates
     /*  27039 */     // MIs[2] Operand 2
     /*  27039 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27055 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27057 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27075 */     GIR_RootConstrainSelectedInstOperands,
     /*  27076 */     // GIR_Coverage, 13583,
     /*  27076 */     GIR_EraseRootFromParent_Done,
     /*  27077 */   // Label 433: @27077
     /*  27077 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(27192), // Rule ID 2089 //
     /*  27082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27134 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27138 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27142 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27147 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27151 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27155 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27159 */     // MIs[4] Operand 1
     /*  27159 */     // No operand predicates
     /*  27159 */     // MIs[2] Operand 2
     /*  27159 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27170 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27172 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27190 */     GIR_RootConstrainSelectedInstOperands,
     /*  27191 */     // GIR_Coverage, 2089,
     /*  27191 */     GIR_EraseRootFromParent_Done,
     /*  27192 */   // Label 434: @27192
     /*  27192 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(27259), // Rule ID 13484 //
     /*  27197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27240 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27257 */     GIR_RootConstrainSelectedInstOperands,
     /*  27258 */     // GIR_Coverage, 13484,
     /*  27258 */     GIR_EraseRootFromParent_Done,
     /*  27259 */   // Label 435: @27259
     /*  27259 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(27326), // Rule ID 13514 //
     /*  27264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27307 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27324 */     GIR_RootConstrainSelectedInstOperands,
     /*  27325 */     // GIR_Coverage, 13514,
     /*  27325 */     GIR_EraseRootFromParent_Done,
     /*  27326 */   // Label 436: @27326
     /*  27326 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(27393), // Rule ID 1727 //
     /*  27331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27360 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27367 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27374 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27391 */     GIR_RootConstrainSelectedInstOperands,
     /*  27392 */     // GIR_Coverage, 1727,
     /*  27392 */     GIR_EraseRootFromParent_Done,
     /*  27393 */   // Label 437: @27393
     /*  27393 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(27460), // Rule ID 1817 //
     /*  27398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27441 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27446 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27458 */     GIR_RootConstrainSelectedInstOperands,
     /*  27459 */     // GIR_Coverage, 1817,
     /*  27459 */     GIR_EraseRootFromParent_Done,
     /*  27460 */   // Label 438: @27460
     /*  27460 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(27541), // Rule ID 13468 //
     /*  27465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27492 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27495 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27504 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27524 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27539 */     GIR_RootConstrainSelectedInstOperands,
     /*  27540 */     // GIR_Coverage, 13468,
     /*  27540 */     GIR_EraseRootFromParent_Done,
     /*  27541 */   // Label 439: @27541
     /*  27541 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(27622), // Rule ID 13492 //
     /*  27546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27573 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27576 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27585 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27594 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27605 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27620 */     GIR_RootConstrainSelectedInstOperands,
     /*  27621 */     // GIR_Coverage, 13492,
     /*  27621 */     GIR_EraseRootFromParent_Done,
     /*  27622 */   // Label 440: @27622
     /*  27622 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(27703), // Rule ID 1693 //
     /*  27627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27658 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27661 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27670 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27686 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27701 */     GIR_RootConstrainSelectedInstOperands,
     /*  27702 */     // GIR_Coverage, 1693,
     /*  27702 */     GIR_EraseRootFromParent_Done,
     /*  27703 */   // Label 441: @27703
     /*  27703 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(27784), // Rule ID 1771 //
     /*  27708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27739 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27742 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27751 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27767 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27782 */     GIR_RootConstrainSelectedInstOperands,
     /*  27783 */     // GIR_Coverage, 1771,
     /*  27783 */     GIR_EraseRootFromParent_Done,
     /*  27784 */   // Label 442: @27784
     /*  27784 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(27876), // Rule ID 13558 //
     /*  27789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27841 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27845 */     // MIs[3] Operand 1
     /*  27845 */     // No operand predicates
     /*  27845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27856 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27874 */     GIR_RootConstrainSelectedInstOperands,
     /*  27875 */     // GIR_Coverage, 13558,
     /*  27875 */     GIR_EraseRootFromParent_Done,
     /*  27876 */   // Label 443: @27876
     /*  27876 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(27968), // Rule ID 13557 //
     /*  27881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27921 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  27925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  27934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27938 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27942 */     // MIs[3] Operand 1
     /*  27942 */     // No operand predicates
     /*  27942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  27948 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  27963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  27966 */     GIR_RootConstrainSelectedInstOperands,
     /*  27967 */     // GIR_Coverage, 13557,
     /*  27967 */     GIR_EraseRootFromParent_Done,
     /*  27968 */   // Label 444: @27968
     /*  27968 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(28060), // Rule ID 13588 //
     /*  27973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28025 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28029 */     // MIs[3] Operand 1
     /*  28029 */     // No operand predicates
     /*  28029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28038 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28040 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28058 */     GIR_RootConstrainSelectedInstOperands,
     /*  28059 */     // GIR_Coverage, 13588,
     /*  28059 */     GIR_EraseRootFromParent_Done,
     /*  28060 */   // Label 445: @28060
     /*  28060 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(28152), // Rule ID 13587 //
     /*  28065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28122 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28126 */     // MIs[3] Operand 1
     /*  28126 */     // No operand predicates
     /*  28126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28130 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28132 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28150 */     GIR_RootConstrainSelectedInstOperands,
     /*  28151 */     // GIR_Coverage, 13587,
     /*  28151 */     GIR_EraseRootFromParent_Done,
     /*  28152 */   // Label 446: @28152
     /*  28152 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(28244), // Rule ID 13556 //
     /*  28157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28213 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28217 */     // MIs[3] Operand 1
     /*  28217 */     // No operand predicates
     /*  28217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28224 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28242 */     GIR_RootConstrainSelectedInstOperands,
     /*  28243 */     // GIR_Coverage, 13556,
     /*  28243 */     GIR_EraseRootFromParent_Done,
     /*  28244 */   // Label 447: @28244
     /*  28244 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(28336), // Rule ID 2038 //
     /*  28249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28310 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28314 */     // MIs[3] Operand 1
     /*  28314 */     // No operand predicates
     /*  28314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28316 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28334 */     GIR_RootConstrainSelectedInstOperands,
     /*  28335 */     // GIR_Coverage, 2038,
     /*  28335 */     GIR_EraseRootFromParent_Done,
     /*  28336 */   // Label 448: @28336
     /*  28336 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(28428), // Rule ID 13586 //
     /*  28341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28397 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28401 */     // MIs[3] Operand 1
     /*  28401 */     // No operand predicates
     /*  28401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28408 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28426 */     GIR_RootConstrainSelectedInstOperands,
     /*  28427 */     // GIR_Coverage, 13586,
     /*  28427 */     GIR_EraseRootFromParent_Done,
     /*  28428 */   // Label 449: @28428
     /*  28428 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(28520), // Rule ID 2090 //
     /*  28433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28494 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28498 */     // MIs[3] Operand 1
     /*  28498 */     // No operand predicates
     /*  28498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28500 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28518 */     GIR_RootConstrainSelectedInstOperands,
     /*  28519 */     // GIR_Coverage, 2090,
     /*  28519 */     GIR_EraseRootFromParent_Done,
     /*  28520 */   // Label 450: @28520
     /*  28520 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(28571), // Rule ID 13506 //
     /*  28525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28557 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28569 */     GIR_RootConstrainSelectedInstOperands,
     /*  28570 */     // GIR_Coverage, 13506,
     /*  28570 */     GIR_EraseRootFromParent_Done,
     /*  28571 */   // Label 451: @28571
     /*  28571 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(28622), // Rule ID 13478 //
     /*  28576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28608 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28620 */     GIR_RootConstrainSelectedInstOperands,
     /*  28621 */     // GIR_Coverage, 13478,
     /*  28621 */     GIR_EraseRootFromParent_Done,
     /*  28622 */   // Label 452: @28622
     /*  28622 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(28673), // Rule ID 13505 //
     /*  28627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28652 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28659 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28671 */     GIR_RootConstrainSelectedInstOperands,
     /*  28672 */     // GIR_Coverage, 13505,
     /*  28672 */     GIR_EraseRootFromParent_Done,
     /*  28673 */   // Label 453: @28673
     /*  28673 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(28724), // Rule ID 1809 //
     /*  28678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28710 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28715 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28722 */     GIR_RootConstrainSelectedInstOperands,
     /*  28723 */     // GIR_Coverage, 1809,
     /*  28723 */     GIR_EraseRootFromParent_Done,
     /*  28724 */   // Label 454: @28724
     /*  28724 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(28775), // Rule ID 1721 //
     /*  28729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28761 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28773 */     GIR_RootConstrainSelectedInstOperands,
     /*  28774 */     // GIR_Coverage, 1721,
     /*  28774 */     GIR_EraseRootFromParent_Done,
     /*  28775 */   // Label 455: @28775
     /*  28775 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(28826), // Rule ID 1808 //
     /*  28780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28812 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28824 */     GIR_RootConstrainSelectedInstOperands,
     /*  28825 */     // GIR_Coverage, 1808,
     /*  28825 */     GIR_EraseRootFromParent_Done,
     /*  28826 */   // Label 456: @28826
     /*  28826 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(28895), // Rule ID 13432 //
     /*  28831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28846 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28849 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28858 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28878 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  28881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28893 */     GIR_RootConstrainSelectedInstOperands,
     /*  28894 */     // GIR_Coverage, 13432,
     /*  28894 */     GIR_EraseRootFromParent_Done,
     /*  28895 */   // Label 457: @28895
     /*  28895 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(28964), // Rule ID 13444 //
     /*  28900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28915 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  28918 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28927 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  28931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28947 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  28947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  28950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  28962 */     GIR_RootConstrainSelectedInstOperands,
     /*  28963 */     // GIR_Coverage, 13444,
     /*  28963 */     GIR_EraseRootFromParent_Done,
     /*  28964 */   // Label 458: @28964
     /*  28964 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(29020), // Rule ID 13394 //
     /*  28969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28984 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  28987 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  28992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  28996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29007 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29018 */     GIR_RootConstrainSelectedInstOperands,
     /*  29019 */     // GIR_Coverage, 13394,
     /*  29019 */     GIR_EraseRootFromParent_Done,
     /*  29020 */   // Label 459: @29020
     /*  29020 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(29076), // Rule ID 13406 //
     /*  29025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29040 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29043 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29063 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29074 */     GIR_RootConstrainSelectedInstOperands,
     /*  29075 */     // GIR_Coverage, 13406,
     /*  29075 */     GIR_EraseRootFromParent_Done,
     /*  29076 */   // Label 460: @29076
     /*  29076 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(29143), // Rule ID 13636 //
     /*  29081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29105 */     // MIs[1] imm
     /*  29105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29113 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29117 */     // MIs[2] Operand 1
     /*  29117 */     // No operand predicates
     /*  29117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29121 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29127 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29141 */     GIR_RootConstrainSelectedInstOperands,
     /*  29142 */     // GIR_Coverage, 13636,
     /*  29142 */     GIR_EraseRootFromParent_Done,
     /*  29143 */   // Label 461: @29143
     /*  29143 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(29210), // Rule ID 13657 //
     /*  29148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29172 */     // MIs[1] imm
     /*  29172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29180 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29184 */     // MIs[2] Operand 1
     /*  29184 */     // No operand predicates
     /*  29184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29194 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29208 */     GIR_RootConstrainSelectedInstOperands,
     /*  29209 */     // GIR_Coverage, 13657,
     /*  29209 */     GIR_EraseRootFromParent_Done,
     /*  29210 */   // Label 462: @29210
     /*  29210 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(29279), // Rule ID 1367 //
     /*  29215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29234 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29237 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29246 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29262 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29277 */     GIR_RootConstrainSelectedInstOperands,
     /*  29278 */     // GIR_Coverage, 1367,
     /*  29278 */     GIR_EraseRootFromParent_Done,
     /*  29279 */   // Label 463: @29279
     /*  29279 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(29348), // Rule ID 1490 //
     /*  29284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29303 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29306 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29315 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29331 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29346 */     GIR_RootConstrainSelectedInstOperands,
     /*  29347 */     // GIR_Coverage, 1490,
     /*  29347 */     GIR_EraseRootFromParent_Done,
     /*  29348 */   // Label 464: @29348
     /*  29348 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(29404), // Rule ID 995 //
     /*  29353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29372 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29375 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29391 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29402 */     GIR_RootConstrainSelectedInstOperands,
     /*  29403 */     // GIR_Coverage, 995,
     /*  29403 */     GIR_EraseRootFromParent_Done,
     /*  29404 */   // Label 465: @29404
     /*  29404 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(29460), // Rule ID 1056 //
     /*  29409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29428 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29431 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29447 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29458 */     GIR_RootConstrainSelectedInstOperands,
     /*  29459 */     // GIR_Coverage, 1056,
     /*  29459 */     GIR_EraseRootFromParent_Done,
     /*  29460 */   // Label 466: @29460
     /*  29460 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(29527), // Rule ID 2240 //
     /*  29465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29493 */     // MIs[1] imm
     /*  29493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29501 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29505 */     // MIs[2] Operand 1
     /*  29505 */     // No operand predicates
     /*  29505 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29511 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29525 */     GIR_RootConstrainSelectedInstOperands,
     /*  29526 */     // GIR_Coverage, 2240,
     /*  29526 */     GIR_EraseRootFromParent_Done,
     /*  29527 */   // Label 467: @29527
     /*  29527 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(29594), // Rule ID 2299 //
     /*  29532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29560 */     // MIs[1] imm
     /*  29560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29568 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29572 */     // MIs[2] Operand 1
     /*  29572 */     // No operand predicates
     /*  29572 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29578 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29592 */     GIR_RootConstrainSelectedInstOperands,
     /*  29593 */     // GIR_Coverage, 2299,
     /*  29593 */     GIR_EraseRootFromParent_Done,
     /*  29594 */   // Label 468: @29594
     /*  29594 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(29664), // Rule ID 6981 //
     /*  29599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  29611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  29637 */     // MIs[2] Rn
     /*  29637 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29642 */     // MIs[2] Rm
     /*  29642 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29649 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29662 */     GIR_RootConstrainSelectedInstOperands,
     /*  29663 */     // GIR_Coverage, 6981,
     /*  29663 */     GIR_EraseRootFromParent_Done,
     /*  29664 */   // Label 469: @29664
     /*  29664 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(29734), // Rule ID 14018 //
     /*  29669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  29681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  29707 */     // MIs[2] Rn
     /*  29707 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29712 */     // MIs[2] Rm
     /*  29712 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29719 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29732 */     GIR_RootConstrainSelectedInstOperands,
     /*  29733 */     // GIR_Coverage, 14018,
     /*  29733 */     GIR_EraseRootFromParent_Done,
     /*  29734 */   // Label 470: @29734
     /*  29734 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(29797), // Rule ID 1789 //
     /*  29739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29782 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29795 */     GIR_RootConstrainSelectedInstOperands,
     /*  29796 */     // GIR_Coverage, 1789,
     /*  29796 */     GIR_EraseRootFromParent_Done,
     /*  29797 */   // Label 471: @29797
     /*  29797 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(29860), // Rule ID 1788 //
     /*  29802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29845 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29858 */     GIR_RootConstrainSelectedInstOperands,
     /*  29859 */     // GIR_Coverage, 1788,
     /*  29859 */     GIR_EraseRootFromParent_Done,
     /*  29860 */   // Label 472: @29860
     /*  29860 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(29923), // Rule ID 1714 //
     /*  29865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29908 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  29911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29921 */     GIR_RootConstrainSelectedInstOperands,
     /*  29922 */     // GIR_Coverage, 1714,
     /*  29922 */     GIR_EraseRootFromParent_Done,
     /*  29923 */   // Label 473: @29923
     /*  29923 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(29986), // Rule ID 1787 //
     /*  29928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29971 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29984 */     GIR_RootConstrainSelectedInstOperands,
     /*  29985 */     // GIR_Coverage, 1787,
     /*  29985 */     GIR_EraseRootFromParent_Done,
     /*  29986 */   // Label 474: @29986
     /*  29986 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(30049), // Rule ID 1786 //
     /*  29991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30027 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30034 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30047 */     GIR_RootConstrainSelectedInstOperands,
     /*  30048 */     // GIR_Coverage, 1786,
     /*  30048 */     GIR_EraseRootFromParent_Done,
     /*  30049 */   // Label 475: @30049
     /*  30049 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(30110), // Rule ID 13483 //
     /*  30054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30093 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30108 */     GIR_RootConstrainSelectedInstOperands,
     /*  30109 */     // GIR_Coverage, 13483,
     /*  30109 */     GIR_EraseRootFromParent_Done,
     /*  30110 */   // Label 476: @30110
     /*  30110 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(30171), // Rule ID 13513 //
     /*  30115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30154 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30169 */     GIR_RootConstrainSelectedInstOperands,
     /*  30170 */     // GIR_Coverage, 13513,
     /*  30170 */     GIR_EraseRootFromParent_Done,
     /*  30171 */   // Label 477: @30171
     /*  30171 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(30219), // Rule ID 13504 //
     /*  30176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30206 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30217 */     GIR_RootConstrainSelectedInstOperands,
     /*  30218 */     // GIR_Coverage, 13504,
     /*  30218 */     GIR_EraseRootFromParent_Done,
     /*  30219 */   // Label 478: @30219
     /*  30219 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(30267), // Rule ID 13393 //
     /*  30224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30254 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30265 */     GIR_RootConstrainSelectedInstOperands,
     /*  30266 */     // GIR_Coverage, 13393,
     /*  30266 */     GIR_EraseRootFromParent_Done,
     /*  30267 */   // Label 479: @30267
     /*  30267 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(30315), // Rule ID 13477 //
     /*  30272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30302 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30313 */     GIR_RootConstrainSelectedInstOperands,
     /*  30314 */     // GIR_Coverage, 13477,
     /*  30314 */     GIR_EraseRootFromParent_Done,
     /*  30315 */   // Label 480: @30315
     /*  30315 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(30363), // Rule ID 13405 //
     /*  30320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30350 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30361 */     GIR_RootConstrainSelectedInstOperands,
     /*  30362 */     // GIR_Coverage, 13405,
     /*  30362 */     GIR_EraseRootFromParent_Done,
     /*  30363 */   // Label 481: @30363
     /*  30363 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(30411), // Rule ID 13503 //
     /*  30368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30398 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30409 */     GIR_RootConstrainSelectedInstOperands,
     /*  30410 */     // GIR_Coverage, 13503,
     /*  30410 */     GIR_EraseRootFromParent_Done,
     /*  30411 */   // Label 482: @30411
     /*  30411 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(30472), // Rule ID 1726 //
     /*  30416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30455 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30460 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30470 */     GIR_RootConstrainSelectedInstOperands,
     /*  30471 */     // GIR_Coverage, 1726,
     /*  30471 */     GIR_EraseRootFromParent_Done,
     /*  30472 */   // Label 483: @30472
     /*  30472 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(30533), // Rule ID 1816 //
     /*  30477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30516 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30531 */     GIR_RootConstrainSelectedInstOperands,
     /*  30532 */     // GIR_Coverage, 1816,
     /*  30532 */     GIR_EraseRootFromParent_Done,
     /*  30533 */   // Label 484: @30533
     /*  30533 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(30581), // Rule ID 1807 //
     /*  30538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30568 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30579 */     GIR_RootConstrainSelectedInstOperands,
     /*  30580 */     // GIR_Coverage, 1807,
     /*  30580 */     GIR_EraseRootFromParent_Done,
     /*  30581 */   // Label 485: @30581
     /*  30581 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(30629), // Rule ID 994 //
     /*  30586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30616 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30627 */     GIR_RootConstrainSelectedInstOperands,
     /*  30628 */     // GIR_Coverage, 994,
     /*  30628 */     GIR_EraseRootFromParent_Done,
     /*  30629 */   // Label 486: @30629
     /*  30629 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(30677), // Rule ID 1720 //
     /*  30634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30664 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30675 */     GIR_RootConstrainSelectedInstOperands,
     /*  30676 */     // GIR_Coverage, 1720,
     /*  30676 */     GIR_EraseRootFromParent_Done,
     /*  30677 */   // Label 487: @30677
     /*  30677 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(30725), // Rule ID 1055 //
     /*  30682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30712 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30723 */     GIR_RootConstrainSelectedInstOperands,
     /*  30724 */     // GIR_Coverage, 1055,
     /*  30724 */     GIR_EraseRootFromParent_Done,
     /*  30725 */   // Label 488: @30725
     /*  30725 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(30773), // Rule ID 1806 //
     /*  30730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30760 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30771 */     GIR_RootConstrainSelectedInstOperands,
     /*  30772 */     // GIR_Coverage, 1806,
     /*  30772 */     GIR_EraseRootFromParent_Done,
     /*  30773 */   // Label 489: @30773
     /*  30773 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(30800), // Rule ID 1105 //
     /*  30778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30793 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  30793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  30798 */     GIR_RootConstrainSelectedInstOperands,
     /*  30799 */     // GIR_Coverage, 1105,
     /*  30799 */     GIR_Done,
     /*  30800 */   // Label 490: @30800
     /*  30800 */   GIM_Reject,
     /*  30801 */ // Label 409: @30801
     /*  30801 */ GIM_Reject,
     /*  30802 */ // Label 161: @30802
     /*  30802 */ GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(31651),
     /*  30807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  30813 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(30946), // Rule ID 14023 //
     /*  30818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  30842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  30850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  30859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  30863 */     // MIs[1] Operand 2
     /*  30863 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  30874 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  30878 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30882 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30886 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  30890 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30894 */     // MIs[5] Rn
     /*  30894 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  30899 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  30901 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  30901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  30904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  30908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  30921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  30923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30928 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  30935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30945 */     // GIR_Coverage, 14023,
     /*  30945 */     GIR_EraseRootFromParent_Done,
     /*  30946 */   // Label 492: @30946
     /*  30946 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(31079), // Rule ID 6986 //
     /*  30951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  30963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  30975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  30988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  30992 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30996 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  31000 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  31004 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31008 */     // MIs[4] Rn
     /*  31008 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31013 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31017 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31021 */     // MIs[3] Operand 2
     /*  31021 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  31032 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31034 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31046 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31078 */     // GIR_Coverage, 6986,
     /*  31078 */     GIR_EraseRootFromParent_Done,
     /*  31079 */   // Label 493: @31079
     /*  31079 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(31148), // Rule ID 13422 //
     /*  31084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31099 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31102 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31111 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31131 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31146 */     GIR_RootConstrainSelectedInstOperands,
     /*  31147 */     // GIR_Coverage, 13422,
     /*  31147 */     GIR_EraseRootFromParent_Done,
     /*  31148 */   // Label 494: @31148
     /*  31148 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(31217), // Rule ID 13434 //
     /*  31153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31168 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31171 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31180 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31200 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31215 */     GIR_RootConstrainSelectedInstOperands,
     /*  31216 */     // GIR_Coverage, 13434,
     /*  31216 */     GIR_EraseRootFromParent_Done,
     /*  31217 */   // Label 495: @31217
     /*  31217 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(31284), // Rule ID 13626 //
     /*  31222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31246 */     // MIs[1] imm
     /*  31246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31254 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31258 */     // MIs[2] Operand 1
     /*  31258 */     // No operand predicates
     /*  31258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31268 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31282 */     GIR_RootConstrainSelectedInstOperands,
     /*  31283 */     // GIR_Coverage, 13626,
     /*  31283 */     GIR_EraseRootFromParent_Done,
     /*  31284 */   // Label 496: @31284
     /*  31284 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(31351), // Rule ID 13647 //
     /*  31289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31313 */     // MIs[1] imm
     /*  31313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31321 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31325 */     // MIs[2] Operand 1
     /*  31325 */     // No operand predicates
     /*  31325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31329 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31335 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31349 */     GIR_RootConstrainSelectedInstOperands,
     /*  31350 */     // GIR_Coverage, 13647,
     /*  31350 */     GIR_EraseRootFromParent_Done,
     /*  31351 */   // Label 497: @31351
     /*  31351 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(31420), // Rule ID 1357 //
     /*  31356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31375 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31378 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31387 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31403 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31418 */     GIR_RootConstrainSelectedInstOperands,
     /*  31419 */     // GIR_Coverage, 1357,
     /*  31419 */     GIR_EraseRootFromParent_Done,
     /*  31420 */   // Label 498: @31420
     /*  31420 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(31489), // Rule ID 1480 //
     /*  31425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31444 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31447 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31456 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31472 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31487 */     GIR_RootConstrainSelectedInstOperands,
     /*  31488 */     // GIR_Coverage, 1480,
     /*  31488 */     GIR_EraseRootFromParent_Done,
     /*  31489 */   // Label 499: @31489
     /*  31489 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(31556), // Rule ID 2230 //
     /*  31494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31522 */     // MIs[1] imm
     /*  31522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31530 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31534 */     // MIs[2] Operand 1
     /*  31534 */     // No operand predicates
     /*  31534 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31540 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31554 */     GIR_RootConstrainSelectedInstOperands,
     /*  31555 */     // GIR_Coverage, 2230,
     /*  31555 */     GIR_EraseRootFromParent_Done,
     /*  31556 */   // Label 500: @31556
     /*  31556 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(31623), // Rule ID 2289 //
     /*  31561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31589 */     // MIs[1] imm
     /*  31589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31601 */     // MIs[2] Operand 1
     /*  31601 */     // No operand predicates
     /*  31601 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31607 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31621 */     GIR_RootConstrainSelectedInstOperands,
     /*  31622 */     // GIR_Coverage, 2289,
     /*  31622 */     GIR_EraseRootFromParent_Done,
     /*  31623 */   // Label 501: @31623
     /*  31623 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(31650), // Rule ID 1100 //
     /*  31628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31643 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  31648 */     GIR_RootConstrainSelectedInstOperands,
     /*  31649 */     // GIR_Coverage, 1100,
     /*  31649 */     GIR_Done,
     /*  31650 */   // Label 502: @31650
     /*  31650 */   GIM_Reject,
     /*  31651 */ // Label 491: @31651
     /*  31651 */ GIM_Reject,
     /*  31652 */ // Label 162: @31652
     /*  31652 */ GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(35229),
     /*  31657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31663 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(31750), // Rule ID 13466 //
     /*  31668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31695 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31698 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31707 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31717 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31731 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31748 */     GIR_RootConstrainSelectedInstOperands,
     /*  31749 */     // GIR_Coverage, 13466,
     /*  31749 */     GIR_EraseRootFromParent_Done,
     /*  31750 */   // Label 504: @31750
     /*  31750 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(31837), // Rule ID 13490 //
     /*  31755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31782 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31785 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31794 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31811 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31818 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31835 */     GIR_RootConstrainSelectedInstOperands,
     /*  31836 */     // GIR_Coverage, 13490,
     /*  31836 */     GIR_EraseRootFromParent_Done,
     /*  31837 */   // Label 505: @31837
     /*  31837 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(31924), // Rule ID 1691 //
     /*  31842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31873 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31876 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31885 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31898 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31905 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31922 */     GIR_RootConstrainSelectedInstOperands,
     /*  31923 */     // GIR_Coverage, 1691,
     /*  31923 */     GIR_EraseRootFromParent_Done,
     /*  31924 */   // Label 506: @31924
     /*  31924 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(32011), // Rule ID 1769 //
     /*  31929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31960 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31963 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31972 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31978 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31985 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31992 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  31995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32009 */     GIR_RootConstrainSelectedInstOperands,
     /*  32010 */     // GIR_Coverage, 1769,
     /*  32010 */     GIR_EraseRootFromParent_Done,
     /*  32011 */   // Label 507: @32011
     /*  32011 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(32080), // Rule ID 1785 //
     /*  32016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32047 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32063 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32078 */     GIR_RootConstrainSelectedInstOperands,
     /*  32079 */     // GIR_Coverage, 1785,
     /*  32079 */     GIR_EraseRootFromParent_Done,
     /*  32080 */   // Label 508: @32080
     /*  32080 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(32149), // Rule ID 1784 //
     /*  32085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32132 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32147 */     GIR_RootConstrainSelectedInstOperands,
     /*  32148 */     // GIR_Coverage, 1784,
     /*  32148 */     GIR_EraseRootFromParent_Done,
     /*  32149 */   // Label 509: @32149
     /*  32149 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(32218), // Rule ID 1713 //
     /*  32154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32194 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32201 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  32204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32216 */     GIR_RootConstrainSelectedInstOperands,
     /*  32217 */     // GIR_Coverage, 1713,
     /*  32217 */     GIR_EraseRootFromParent_Done,
     /*  32218 */   // Label 510: @32218
     /*  32218 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(32287), // Rule ID 1783 //
     /*  32223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32263 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32270 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32285 */     GIR_RootConstrainSelectedInstOperands,
     /*  32286 */     // GIR_Coverage, 1783,
     /*  32286 */     GIR_EraseRootFromParent_Done,
     /*  32287 */   // Label 511: @32287
     /*  32287 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(32356), // Rule ID 1782 //
     /*  32292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32339 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32354 */     GIR_RootConstrainSelectedInstOperands,
     /*  32355 */     // GIR_Coverage, 1782,
     /*  32355 */     GIR_EraseRootFromParent_Done,
     /*  32356 */   // Label 512: @32356
     /*  32356 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(32423), // Rule ID 13482 //
     /*  32361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32404 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32421 */     GIR_RootConstrainSelectedInstOperands,
     /*  32422 */     // GIR_Coverage, 13482,
     /*  32422 */     GIR_EraseRootFromParent_Done,
     /*  32423 */   // Label 513: @32423
     /*  32423 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(32490), // Rule ID 13512 //
     /*  32428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32457 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32471 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32488 */     GIR_RootConstrainSelectedInstOperands,
     /*  32489 */     // GIR_Coverage, 13512,
     /*  32489 */     GIR_EraseRootFromParent_Done,
     /*  32490 */   // Label 514: @32490
     /*  32490 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(32557), // Rule ID 1725 //
     /*  32495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32538 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32555 */     GIR_RootConstrainSelectedInstOperands,
     /*  32556 */     // GIR_Coverage, 1725,
     /*  32556 */     GIR_EraseRootFromParent_Done,
     /*  32557 */   // Label 515: @32557
     /*  32557 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(32624), // Rule ID 1815 //
     /*  32562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32605 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32622 */     GIR_RootConstrainSelectedInstOperands,
     /*  32623 */     // GIR_Coverage, 1815,
     /*  32623 */     GIR_EraseRootFromParent_Done,
     /*  32624 */   // Label 516: @32624
     /*  32624 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(32705), // Rule ID 13464 //
     /*  32629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32656 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32659 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32668 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32688 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32703 */     GIR_RootConstrainSelectedInstOperands,
     /*  32704 */     // GIR_Coverage, 13464,
     /*  32704 */     GIR_EraseRootFromParent_Done,
     /*  32705 */   // Label 517: @32705
     /*  32705 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(32786), // Rule ID 13488 //
     /*  32710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32737 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32740 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32749 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32769 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32784 */     GIR_RootConstrainSelectedInstOperands,
     /*  32785 */     // GIR_Coverage, 13488,
     /*  32785 */     GIR_EraseRootFromParent_Done,
     /*  32786 */   // Label 518: @32786
     /*  32786 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(32867), // Rule ID 1689 //
     /*  32791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32822 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32825 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32834 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32850 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32865 */     GIR_RootConstrainSelectedInstOperands,
     /*  32866 */     // GIR_Coverage, 1689,
     /*  32866 */     GIR_EraseRootFromParent_Done,
     /*  32867 */   // Label 519: @32867
     /*  32867 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(32948), // Rule ID 1767 //
     /*  32872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32903 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32906 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32915 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32919 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32931 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32946 */     GIR_RootConstrainSelectedInstOperands,
     /*  32947 */     // GIR_Coverage, 1767,
     /*  32947 */     GIR_EraseRootFromParent_Done,
     /*  32948 */   // Label 520: @32948
     /*  32948 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(32999), // Rule ID 13502 //
     /*  32953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32985 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  32988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  32992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  32997 */     GIR_RootConstrainSelectedInstOperands,
     /*  32998 */     // GIR_Coverage, 13502,
     /*  32998 */     GIR_EraseRootFromParent_Done,
     /*  32999 */   // Label 521: @32999
     /*  32999 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(33050), // Rule ID 13476 //
     /*  33004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33036 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33048 */     GIR_RootConstrainSelectedInstOperands,
     /*  33049 */     // GIR_Coverage, 13476,
     /*  33049 */     GIR_EraseRootFromParent_Done,
     /*  33050 */   // Label 522: @33050
     /*  33050 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(33101), // Rule ID 13501 //
     /*  33055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33087 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33099 */     GIR_RootConstrainSelectedInstOperands,
     /*  33100 */     // GIR_Coverage, 13501,
     /*  33100 */     GIR_EraseRootFromParent_Done,
     /*  33101 */   // Label 523: @33101
     /*  33101 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(33152), // Rule ID 1805 //
     /*  33106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33138 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33150 */     GIR_RootConstrainSelectedInstOperands,
     /*  33151 */     // GIR_Coverage, 1805,
     /*  33151 */     GIR_EraseRootFromParent_Done,
     /*  33152 */   // Label 524: @33152
     /*  33152 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(33203), // Rule ID 1719 //
     /*  33157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33182 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33189 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33201 */     GIR_RootConstrainSelectedInstOperands,
     /*  33202 */     // GIR_Coverage, 1719,
     /*  33202 */     GIR_EraseRootFromParent_Done,
     /*  33203 */   // Label 525: @33203
     /*  33203 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(33254), // Rule ID 1804 //
     /*  33208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33233 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33240 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33252 */     GIR_RootConstrainSelectedInstOperands,
     /*  33253 */     // GIR_Coverage, 1804,
     /*  33253 */     GIR_EraseRootFromParent_Done,
     /*  33254 */   // Label 526: @33254
     /*  33254 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(33323), // Rule ID 13428 //
     /*  33259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33274 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33277 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33286 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33306 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33321 */     GIR_RootConstrainSelectedInstOperands,
     /*  33322 */     // GIR_Coverage, 13428,
     /*  33322 */     GIR_EraseRootFromParent_Done,
     /*  33323 */   // Label 527: @33323
     /*  33323 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(33392), // Rule ID 13440 //
     /*  33328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33343 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33346 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33355 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33375 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33390 */     GIR_RootConstrainSelectedInstOperands,
     /*  33391 */     // GIR_Coverage, 13440,
     /*  33391 */     GIR_EraseRootFromParent_Done,
     /*  33392 */   // Label 528: @33392
     /*  33392 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(33448), // Rule ID 13390 //
     /*  33397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33412 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33415 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33435 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33446 */     GIR_RootConstrainSelectedInstOperands,
     /*  33447 */     // GIR_Coverage, 13390,
     /*  33447 */     GIR_EraseRootFromParent_Done,
     /*  33448 */   // Label 529: @33448
     /*  33448 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(33504), // Rule ID 13402 //
     /*  33453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33468 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33471 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33491 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33502 */     GIR_RootConstrainSelectedInstOperands,
     /*  33503 */     // GIR_Coverage, 13402,
     /*  33503 */     GIR_EraseRootFromParent_Done,
     /*  33504 */   // Label 530: @33504
     /*  33504 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(33571), // Rule ID 13632 //
     /*  33509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33533 */     // MIs[1] imm
     /*  33533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33541 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33545 */     // MIs[2] Operand 1
     /*  33545 */     // No operand predicates
     /*  33545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33549 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33555 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33569 */     GIR_RootConstrainSelectedInstOperands,
     /*  33570 */     // GIR_Coverage, 13632,
     /*  33570 */     GIR_EraseRootFromParent_Done,
     /*  33571 */   // Label 531: @33571
     /*  33571 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(33638), // Rule ID 13653 //
     /*  33576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33600 */     // MIs[1] imm
     /*  33600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33608 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33612 */     // MIs[2] Operand 1
     /*  33612 */     // No operand predicates
     /*  33612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33616 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33622 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  33625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33636 */     GIR_RootConstrainSelectedInstOperands,
     /*  33637 */     // GIR_Coverage, 13653,
     /*  33637 */     GIR_EraseRootFromParent_Done,
     /*  33638 */   // Label 532: @33638
     /*  33638 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(33707), // Rule ID 1363 //
     /*  33643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33662 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33665 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33674 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33690 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33705 */     GIR_RootConstrainSelectedInstOperands,
     /*  33706 */     // GIR_Coverage, 1363,
     /*  33706 */     GIR_EraseRootFromParent_Done,
     /*  33707 */   // Label 533: @33707
     /*  33707 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(33776), // Rule ID 1486 //
     /*  33712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33731 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33734 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33743 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33759 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33774 */     GIR_RootConstrainSelectedInstOperands,
     /*  33775 */     // GIR_Coverage, 1486,
     /*  33775 */     GIR_EraseRootFromParent_Done,
     /*  33776 */   // Label 534: @33776
     /*  33776 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(33832), // Rule ID 991 //
     /*  33781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33800 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33803 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33819 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33830 */     GIR_RootConstrainSelectedInstOperands,
     /*  33831 */     // GIR_Coverage, 991,
     /*  33831 */     GIR_EraseRootFromParent_Done,
     /*  33832 */   // Label 535: @33832
     /*  33832 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(33888), // Rule ID 1052 //
     /*  33837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33856 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33859 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33875 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33886 */     GIR_RootConstrainSelectedInstOperands,
     /*  33887 */     // GIR_Coverage, 1052,
     /*  33887 */     GIR_EraseRootFromParent_Done,
     /*  33888 */   // Label 536: @33888
     /*  33888 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(33955), // Rule ID 2236 //
     /*  33893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33921 */     // MIs[1] imm
     /*  33921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33929 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33933 */     // MIs[2] Operand 1
     /*  33933 */     // No operand predicates
     /*  33933 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33939 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33953 */     GIR_RootConstrainSelectedInstOperands,
     /*  33954 */     // GIR_Coverage, 2236,
     /*  33954 */     GIR_EraseRootFromParent_Done,
     /*  33955 */   // Label 537: @33955
     /*  33955 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(34022), // Rule ID 2295 //
     /*  33960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33988 */     // MIs[1] imm
     /*  33988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33996 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34000 */     // MIs[2] Operand 1
     /*  34000 */     // No operand predicates
     /*  34000 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34006 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  34009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34020 */     GIR_RootConstrainSelectedInstOperands,
     /*  34021 */     // GIR_Coverage, 2295,
     /*  34021 */     GIR_EraseRootFromParent_Done,
     /*  34022 */   // Label 538: @34022
     /*  34022 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(34092), // Rule ID 6982 //
     /*  34027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34065 */     // MIs[2] Rn
     /*  34065 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34070 */     // MIs[2] Rm
     /*  34070 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34077 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34090 */     GIR_RootConstrainSelectedInstOperands,
     /*  34091 */     // GIR_Coverage, 6982,
     /*  34091 */     GIR_EraseRootFromParent_Done,
     /*  34092 */   // Label 539: @34092
     /*  34092 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(34162), // Rule ID 14019 //
     /*  34097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34135 */     // MIs[2] Rn
     /*  34135 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34140 */     // MIs[2] Rm
     /*  34140 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34147 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34160 */     GIR_RootConstrainSelectedInstOperands,
     /*  34161 */     // GIR_Coverage, 14019,
     /*  34161 */     GIR_EraseRootFromParent_Done,
     /*  34162 */   // Label 540: @34162
     /*  34162 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(34225), // Rule ID 1781 //
     /*  34167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34210 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34223 */     GIR_RootConstrainSelectedInstOperands,
     /*  34224 */     // GIR_Coverage, 1781,
     /*  34224 */     GIR_EraseRootFromParent_Done,
     /*  34225 */   // Label 541: @34225
     /*  34225 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(34288), // Rule ID 1780 //
     /*  34230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34273 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34286 */     GIR_RootConstrainSelectedInstOperands,
     /*  34287 */     // GIR_Coverage, 1780,
     /*  34287 */     GIR_EraseRootFromParent_Done,
     /*  34288 */   // Label 542: @34288
     /*  34288 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(34351), // Rule ID 1712 //
     /*  34293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34336 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  34339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34349 */     GIR_RootConstrainSelectedInstOperands,
     /*  34350 */     // GIR_Coverage, 1712,
     /*  34350 */     GIR_EraseRootFromParent_Done,
     /*  34351 */   // Label 543: @34351
     /*  34351 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(34414), // Rule ID 1779 //
     /*  34356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34399 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34412 */     GIR_RootConstrainSelectedInstOperands,
     /*  34413 */     // GIR_Coverage, 1779,
     /*  34413 */     GIR_EraseRootFromParent_Done,
     /*  34414 */   // Label 544: @34414
     /*  34414 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(34477), // Rule ID 1778 //
     /*  34419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34462 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34475 */     GIR_RootConstrainSelectedInstOperands,
     /*  34476 */     // GIR_Coverage, 1778,
     /*  34476 */     GIR_EraseRootFromParent_Done,
     /*  34477 */   // Label 545: @34477
     /*  34477 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(34538), // Rule ID 13481 //
     /*  34482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34521 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34536 */     GIR_RootConstrainSelectedInstOperands,
     /*  34537 */     // GIR_Coverage, 13481,
     /*  34537 */     GIR_EraseRootFromParent_Done,
     /*  34538 */   // Label 546: @34538
     /*  34538 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(34599), // Rule ID 13511 //
     /*  34543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34582 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34597 */     GIR_RootConstrainSelectedInstOperands,
     /*  34598 */     // GIR_Coverage, 13511,
     /*  34598 */     GIR_EraseRootFromParent_Done,
     /*  34599 */   // Label 547: @34599
     /*  34599 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(34647), // Rule ID 13500 //
     /*  34604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34634 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34645 */     GIR_RootConstrainSelectedInstOperands,
     /*  34646 */     // GIR_Coverage, 13500,
     /*  34646 */     GIR_EraseRootFromParent_Done,
     /*  34647 */   // Label 548: @34647
     /*  34647 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34695), // Rule ID 13389 //
     /*  34652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  34667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34682 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34693 */     GIR_RootConstrainSelectedInstOperands,
     /*  34694 */     // GIR_Coverage, 13389,
     /*  34694 */     GIR_EraseRootFromParent_Done,
     /*  34695 */   // Label 549: @34695
     /*  34695 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(34743), // Rule ID 13475 //
     /*  34700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34730 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  34733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34741 */     GIR_RootConstrainSelectedInstOperands,
     /*  34742 */     // GIR_Coverage, 13475,
     /*  34742 */     GIR_EraseRootFromParent_Done,
     /*  34743 */   // Label 550: @34743
     /*  34743 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(34791), // Rule ID 13401 //
     /*  34748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  34763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34778 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34789 */     GIR_RootConstrainSelectedInstOperands,
     /*  34790 */     // GIR_Coverage, 13401,
     /*  34790 */     GIR_EraseRootFromParent_Done,
     /*  34791 */   // Label 551: @34791
     /*  34791 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(34839), // Rule ID 13499 //
     /*  34796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34826 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34837 */     GIR_RootConstrainSelectedInstOperands,
     /*  34838 */     // GIR_Coverage, 13499,
     /*  34838 */     GIR_EraseRootFromParent_Done,
     /*  34839 */   // Label 552: @34839
     /*  34839 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(34900), // Rule ID 1724 //
     /*  34844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34883 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34898 */     GIR_RootConstrainSelectedInstOperands,
     /*  34899 */     // GIR_Coverage, 1724,
     /*  34899 */     GIR_EraseRootFromParent_Done,
     /*  34900 */   // Label 553: @34900
     /*  34900 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(34961), // Rule ID 1814 //
     /*  34905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34944 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34959 */     GIR_RootConstrainSelectedInstOperands,
     /*  34960 */     // GIR_Coverage, 1814,
     /*  34960 */     GIR_EraseRootFromParent_Done,
     /*  34961 */   // Label 554: @34961
     /*  34961 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(35009), // Rule ID 1803 //
     /*  34966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34996 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35007 */     GIR_RootConstrainSelectedInstOperands,
     /*  35008 */     // GIR_Coverage, 1803,
     /*  35008 */     GIR_EraseRootFromParent_Done,
     /*  35009 */   // Label 555: @35009
     /*  35009 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(35057), // Rule ID 990 //
     /*  35014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35044 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35055 */     GIR_RootConstrainSelectedInstOperands,
     /*  35056 */     // GIR_Coverage, 990,
     /*  35056 */     GIR_EraseRootFromParent_Done,
     /*  35057 */   // Label 556: @35057
     /*  35057 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(35105), // Rule ID 1718 //
     /*  35062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35092 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35103 */     GIR_RootConstrainSelectedInstOperands,
     /*  35104 */     // GIR_Coverage, 1718,
     /*  35104 */     GIR_EraseRootFromParent_Done,
     /*  35105 */   // Label 557: @35105
     /*  35105 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(35153), // Rule ID 1051 //
     /*  35110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35140 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35151 */     GIR_RootConstrainSelectedInstOperands,
     /*  35152 */     // GIR_Coverage, 1051,
     /*  35152 */     GIR_EraseRootFromParent_Done,
     /*  35153 */   // Label 558: @35153
     /*  35153 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(35201), // Rule ID 1802 //
     /*  35158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35188 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35199 */     GIR_RootConstrainSelectedInstOperands,
     /*  35200 */     // GIR_Coverage, 1802,
     /*  35200 */     GIR_EraseRootFromParent_Done,
     /*  35201 */   // Label 559: @35201
     /*  35201 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(35228), // Rule ID 1103 //
     /*  35206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35221 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  35221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  35226 */     GIR_RootConstrainSelectedInstOperands,
     /*  35227 */     // GIR_Coverage, 1103,
     /*  35227 */     GIR_Done,
     /*  35228 */   // Label 560: @35228
     /*  35228 */   GIM_Reject,
     /*  35229 */ // Label 503: @35229
     /*  35229 */ GIM_Reject,
     /*  35230 */ // Label 163: @35230
     /*  35230 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(35953),
     /*  35235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35241 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(35310), // Rule ID 13424 //
     /*  35246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35261 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35264 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35273 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35293 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35308 */     GIR_RootConstrainSelectedInstOperands,
     /*  35309 */     // GIR_Coverage, 13424,
     /*  35309 */     GIR_EraseRootFromParent_Done,
     /*  35310 */   // Label 562: @35310
     /*  35310 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(35379), // Rule ID 13436 //
     /*  35315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35330 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35333 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35342 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35362 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35377 */     GIR_RootConstrainSelectedInstOperands,
     /*  35378 */     // GIR_Coverage, 13436,
     /*  35378 */     GIR_EraseRootFromParent_Done,
     /*  35379 */   // Label 563: @35379
     /*  35379 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(35446), // Rule ID 13628 //
     /*  35384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35408 */     // MIs[1] imm
     /*  35408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35416 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35420 */     // MIs[2] Operand 1
     /*  35420 */     // No operand predicates
     /*  35420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35430 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35444 */     GIR_RootConstrainSelectedInstOperands,
     /*  35445 */     // GIR_Coverage, 13628,
     /*  35445 */     GIR_EraseRootFromParent_Done,
     /*  35446 */   // Label 564: @35446
     /*  35446 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(35513), // Rule ID 13649 //
     /*  35451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35475 */     // MIs[1] imm
     /*  35475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35483 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35487 */     // MIs[2] Operand 1
     /*  35487 */     // No operand predicates
     /*  35487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35497 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35511 */     GIR_RootConstrainSelectedInstOperands,
     /*  35512 */     // GIR_Coverage, 13649,
     /*  35512 */     GIR_EraseRootFromParent_Done,
     /*  35513 */   // Label 565: @35513
     /*  35513 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(35582), // Rule ID 1359 //
     /*  35518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35537 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35540 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35549 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35565 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35580 */     GIR_RootConstrainSelectedInstOperands,
     /*  35581 */     // GIR_Coverage, 1359,
     /*  35581 */     GIR_EraseRootFromParent_Done,
     /*  35582 */   // Label 566: @35582
     /*  35582 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(35651), // Rule ID 1482 //
     /*  35587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35606 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35609 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35618 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35634 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35649 */     GIR_RootConstrainSelectedInstOperands,
     /*  35650 */     // GIR_Coverage, 1482,
     /*  35650 */     GIR_EraseRootFromParent_Done,
     /*  35651 */   // Label 567: @35651
     /*  35651 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(35718), // Rule ID 2232 //
     /*  35656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35684 */     // MIs[1] imm
     /*  35684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35692 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35696 */     // MIs[2] Operand 1
     /*  35696 */     // No operand predicates
     /*  35696 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35702 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35707 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35716 */     GIR_RootConstrainSelectedInstOperands,
     /*  35717 */     // GIR_Coverage, 2232,
     /*  35717 */     GIR_EraseRootFromParent_Done,
     /*  35718 */   // Label 568: @35718
     /*  35718 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(35785), // Rule ID 2291 //
     /*  35723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35751 */     // MIs[1] imm
     /*  35751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35759 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35763 */     // MIs[2] Operand 1
     /*  35763 */     // No operand predicates
     /*  35763 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35769 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35783 */     GIR_RootConstrainSelectedInstOperands,
     /*  35784 */     // GIR_Coverage, 2291,
     /*  35784 */     GIR_EraseRootFromParent_Done,
     /*  35785 */   // Label 569: @35785
     /*  35785 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(35855), // Rule ID 6983 //
     /*  35790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  35802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  35828 */     // MIs[2] Rn
     /*  35828 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35833 */     // MIs[2] Rm
     /*  35833 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35840 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35853 */     GIR_RootConstrainSelectedInstOperands,
     /*  35854 */     // GIR_Coverage, 6983,
     /*  35854 */     GIR_EraseRootFromParent_Done,
     /*  35855 */   // Label 570: @35855
     /*  35855 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(35925), // Rule ID 14020 //
     /*  35860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  35872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  35898 */     // MIs[2] Rn
     /*  35898 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  35903 */     // MIs[2] Rm
     /*  35903 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  35908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35910 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  35910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  35913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35923 */     GIR_RootConstrainSelectedInstOperands,
     /*  35924 */     // GIR_Coverage, 14020,
     /*  35924 */     GIR_EraseRootFromParent_Done,
     /*  35925 */   // Label 571: @35925
     /*  35925 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(35952), // Rule ID 1101 //
     /*  35930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35945 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  35950 */     GIR_RootConstrainSelectedInstOperands,
     /*  35951 */     // GIR_Coverage, 1101,
     /*  35951 */     GIR_Done,
     /*  35952 */   // Label 572: @35952
     /*  35952 */   GIM_Reject,
     /*  35953 */ // Label 561: @35953
     /*  35953 */ GIM_Reject,
     /*  35954 */ // Label 164: @35954
     /*  35954 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(36325),
     /*  35959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  35969 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(36031), // Rule ID 15204 //
     /*  35974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  35977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  35989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  35993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36005 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36018 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36029 */     GIR_RootConstrainSelectedInstOperands,
     /*  36030 */     // GIR_Coverage, 15204,
     /*  36030 */     GIR_EraseRootFromParent_Done,
     /*  36031 */   // Label 574: @36031
     /*  36031 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(36093), // Rule ID 15203 //
     /*  36036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36067 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36080 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36091 */     GIR_RootConstrainSelectedInstOperands,
     /*  36092 */     // GIR_Coverage, 15203,
     /*  36092 */     GIR_EraseRootFromParent_Done,
     /*  36093 */   // Label 575: @36093
     /*  36093 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(36155), // Rule ID 15202 //
     /*  36098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36129 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36142 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36153 */     GIR_RootConstrainSelectedInstOperands,
     /*  36154 */     // GIR_Coverage, 15202,
     /*  36154 */     GIR_EraseRootFromParent_Done,
     /*  36155 */   // Label 576: @36155
     /*  36155 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(36217), // Rule ID 8958 //
     /*  36160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36191 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36204 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36215 */     GIR_RootConstrainSelectedInstOperands,
     /*  36216 */     // GIR_Coverage, 8958,
     /*  36216 */     GIR_EraseRootFromParent_Done,
     /*  36217 */   // Label 577: @36217
     /*  36217 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(36263), // Rule ID 15205 //
     /*  36222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36237 */     // MIs[1] Operand 2
     /*  36237 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36250 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36261 */     GIR_RootConstrainSelectedInstOperands,
     /*  36262 */     // GIR_Coverage, 15205,
     /*  36262 */     GIR_EraseRootFromParent_Done,
     /*  36263 */   // Label 578: @36263
     /*  36263 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(36309), // Rule ID 8959 //
     /*  36268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36283 */     // MIs[1] Operand 2
     /*  36283 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36296 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36307 */     GIR_RootConstrainSelectedInstOperands,
     /*  36308 */     // GIR_Coverage, 8959,
     /*  36308 */     GIR_EraseRootFromParent_Done,
     /*  36309 */   // Label 579: @36309
     /*  36309 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(36324), // Rule ID 2780 //
     /*  36314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36317 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  36322 */     GIR_RootConstrainSelectedInstOperands,
     /*  36323 */     // GIR_Coverage, 2780,
     /*  36323 */     GIR_Done,
     /*  36324 */   // Label 580: @36324
     /*  36324 */   GIM_Reject,
     /*  36325 */ // Label 573: @36325
     /*  36325 */ GIM_Reject,
     /*  36326 */ // Label 165: @36326
     /*  36326 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(36351), // Rule ID 2779 //
     /*  36331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  36337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  36340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36344 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  36344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  36349 */   GIR_RootConstrainSelectedInstOperands,
     /*  36350 */   // GIR_Coverage, 2779,
     /*  36350 */   GIR_Done,
     /*  36351 */ // Label 581: @36351
     /*  36351 */ GIM_Reject,
     /*  36352 */ // Label 166: @36352
     /*  36352 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(36377), // Rule ID 2778 //
     /*  36357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  36363 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  36366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36370 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  36370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  36375 */   GIR_RootConstrainSelectedInstOperands,
     /*  36376 */   // GIR_Coverage, 2778,
     /*  36376 */   GIR_Done,
     /*  36377 */ // Label 582: @36377
     /*  36377 */ GIM_Reject,
     /*  36378 */ // Label 167: @36378
     /*  36378 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(36403), // Rule ID 2777 //
     /*  36383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  36389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  36392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36396 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  36396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  36401 */   GIR_RootConstrainSelectedInstOperands,
     /*  36402 */   // GIR_Coverage, 2777,
     /*  36402 */   GIR_Done,
     /*  36403 */ // Label 583: @36403
     /*  36403 */ GIM_Reject,
     /*  36404 */ // Label 168: @36404
     /*  36404 */ GIM_Reject,
     /*  36405 */ // Label 1: @36405
     /*  36405 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 597*/ GIMT_Encode4(50632),
     /*  36416 */ /*GILLT_s32*//*Label 584*/ GIMT_Encode4(36504),
     /*  36420 */ /*GILLT_s64*//*Label 585*/ GIMT_Encode4(37986), GIMT_Encode4(0),
     /*  36428 */ /*GILLT_v2s32*//*Label 586*/ GIMT_Encode4(41268),
     /*  36432 */ /*GILLT_v2s64*//*Label 587*/ GIMT_Encode4(42759),
     /*  36436 */ /*GILLT_v4s16*//*Label 588*/ GIMT_Encode4(45219),
     /*  36440 */ /*GILLT_v4s32*//*Label 589*/ GIMT_Encode4(46710),
     /*  36444 */ /*GILLT_v8s8*//*Label 590*/ GIMT_Encode4(49170),
     /*  36448 */ /*GILLT_v8s16*//*Label 591*/ GIMT_Encode4(49245),
     /*  36452 */ /*GILLT_v16s8*//*Label 592*/ GIMT_Encode4(50453), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36472 */ /*GILLT_nxv2s64*//*Label 593*/ GIMT_Encode4(50528), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36484 */ /*GILLT_nxv4s32*//*Label 594*/ GIMT_Encode4(50554), GIMT_Encode4(0),
     /*  36492 */ /*GILLT_nxv8s16*//*Label 595*/ GIMT_Encode4(50580), GIMT_Encode4(0),
     /*  36500 */ /*GILLT_nxv16s8*//*Label 596*/ GIMT_Encode4(50606),
     /*  36504 */ // Label 584: @36504
     /*  36504 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(37985),
     /*  36509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36515 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(36667), // Rule ID 10005 //
     /*  36520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36551 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36554 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  36559 */     // MIs[2] pattern
     /*  36559 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36562 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36569 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36569 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36572 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36576 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36583 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36586 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36590 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36595 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36598 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36602 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36605 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36610 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36615 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  36627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36632 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36639 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36649 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36666 */     // GIR_Coverage, 10005,
     /*  36666 */     GIR_EraseRootFromParent_Done,
     /*  36667 */   // Label 599: @36667
     /*  36667 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(36819), // Rule ID 10017 //
     /*  36672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36703 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36706 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  36711 */     // MIs[2] pattern
     /*  36711 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36714 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36721 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36721 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36724 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36728 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36735 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36738 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36742 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36747 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36750 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36754 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36757 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36762 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36767 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  36779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36784 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36791 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36801 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36813 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36818 */     // GIR_Coverage, 10017,
     /*  36818 */     GIR_EraseRootFromParent_Done,
     /*  36819 */   // Label 600: @36819
     /*  36819 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(36971), // Rule ID 10029 //
     /*  36824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36855 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36858 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  36863 */     // MIs[2] pattern
     /*  36863 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36866 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36873 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36873 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36876 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36880 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36899 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36902 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36906 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36909 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36914 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36919 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  36931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36936 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36939 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36953 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36965 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36970 */     // GIR_Coverage, 10029,
     /*  36970 */     GIR_EraseRootFromParent_Done,
     /*  36971 */   // Label 601: @36971
     /*  36971 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(37123), // Rule ID 10041 //
     /*  36976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37007 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37010 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  37015 */     // MIs[2] pattern
     /*  37015 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37018 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37025 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37025 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37028 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37032 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37039 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37042 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37046 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37051 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37054 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37058 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37066 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37071 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37091 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37095 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37105 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37122 */     // GIR_Coverage, 10041,
     /*  37122 */     GIR_EraseRootFromParent_Done,
     /*  37123 */   // Label 602: @37123
     /*  37123 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(37185), // Rule ID 3953 //
     /*  37128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37164 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  37164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  37167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37183 */     GIR_RootConstrainSelectedInstOperands,
     /*  37184 */     // GIR_Coverage, 3953,
     /*  37184 */     GIR_EraseRootFromParent_Done,
     /*  37185 */   // Label 603: @37185
     /*  37185 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(37342), // Rule ID 10143 //
     /*  37190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37221 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37224 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  37233 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37240 */     // MIs[2] pred
     /*  37240 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37247 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37247 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37250 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37254 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37273 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37276 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37280 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37288 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37293 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  37305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37314 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37324 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37341 */     // GIR_Coverage, 10143,
     /*  37341 */     GIR_EraseRootFromParent_Done,
     /*  37342 */   // Label 604: @37342
     /*  37342 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(37499), // Rule ID 10144 //
     /*  37347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37378 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37381 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  37390 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37397 */     // MIs[2] pred
     /*  37397 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37404 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37404 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37407 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37411 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37418 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37421 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37425 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37430 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37433 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37437 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37440 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  37462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37471 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37481 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37498 */     // GIR_Coverage, 10144,
     /*  37498 */     GIR_EraseRootFromParent_Done,
     /*  37499 */   // Label 605: @37499
     /*  37499 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(37656), // Rule ID 10145 //
     /*  37504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37535 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37538 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  37547 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37554 */     // MIs[2] pred
     /*  37554 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37561 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37561 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37564 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37568 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37587 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37590 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37594 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  37619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37628 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37638 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37655 */     // GIR_Coverage, 10145,
     /*  37655 */     GIR_EraseRootFromParent_Done,
     /*  37656 */   // Label 606: @37656
     /*  37656 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(37813), // Rule ID 10146 //
     /*  37661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37692 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37695 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  37704 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37711 */     // MIs[2] pred
     /*  37711 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37718 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37718 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37721 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37725 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37732 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37735 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37739 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37744 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37747 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37751 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37759 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37764 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  37776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37781 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37785 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37795 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37812 */     // GIR_Coverage, 10146,
     /*  37812 */     GIR_EraseRootFromParent_Done,
     /*  37813 */   // Label 607: @37813
     /*  37813 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37849), // Rule ID 3918 //
     /*  37818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  37833 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  37833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  37836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37838 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  37840 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  37844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37847 */     GIR_RootConstrainSelectedInstOperands,
     /*  37848 */     // GIR_Coverage, 3918,
     /*  37848 */     GIR_EraseRootFromParent_Done,
     /*  37849 */   // Label 608: @37849
     /*  37849 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37882), // Rule ID 3923 //
     /*  37854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  37869 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  37872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37880 */     GIR_RootConstrainSelectedInstOperands,
     /*  37881 */     // GIR_Coverage, 3923,
     /*  37881 */     GIR_EraseRootFromParent_Done,
     /*  37882 */   // Label 609: @37882
     /*  37882 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37918), // Rule ID 3912 //
     /*  37887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  37895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  37902 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  37902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  37905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37909 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  37913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37916 */     GIR_RootConstrainSelectedInstOperands,
     /*  37917 */     // GIR_Coverage, 3912,
     /*  37917 */     GIR_EraseRootFromParent_Done,
     /*  37918 */   // Label 610: @37918
     /*  37918 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(37954), // Rule ID 3916 //
     /*  37923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  37938 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  37938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  37941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  37945 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  37949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  37952 */     GIR_RootConstrainSelectedInstOperands,
     /*  37953 */     // GIR_Coverage, 3916,
     /*  37953 */     GIR_EraseRootFromParent_Done,
     /*  37954 */   // Label 611: @37954
     /*  37954 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(37984), // Rule ID 3914 //
     /*  37959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37971 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  37971 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  37976 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  37982 */     GIR_RootConstrainSelectedInstOperands,
     /*  37983 */     // GIR_Coverage, 3914,
     /*  37983 */     GIR_Done,
     /*  37984 */   // Label 612: @37984
     /*  37984 */   GIM_Reject,
     /*  37985 */ // Label 598: @37985
     /*  37985 */ GIM_Reject,
     /*  37986 */ // Label 585: @37986
     /*  37986 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(41267),
     /*  37991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  37994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37997 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(38133), // Rule ID 5437 //
     /*  38002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38035 */     // MIs[1] Operand 2
     /*  38035 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38054 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38058 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38062 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38066 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38070 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38075 */     // MIs[3] Operand 2
     /*  38075 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38088 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38104 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38115 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38132 */     // GIR_Coverage, 5437,
     /*  38132 */     GIR_EraseRootFromParent_Done,
     /*  38133 */   // Label 614: @38133
     /*  38133 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(38269), // Rule ID 5436 //
     /*  38138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38171 */     // MIs[1] Operand 2
     /*  38171 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38190 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38194 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38198 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38202 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38206 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38211 */     // MIs[3] Operand 2
     /*  38211 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38222 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38224 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38251 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38268 */     // GIR_Coverage, 5436,
     /*  38268 */     GIR_EraseRootFromParent_Done,
     /*  38269 */   // Label 615: @38269
     /*  38269 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(38405), // Rule ID 5446 //
     /*  38274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38307 */     // MIs[1] Operand 2
     /*  38307 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38318 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38322 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38326 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38330 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38334 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38338 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38342 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38347 */     // MIs[3] Operand 2
     /*  38347 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38358 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38360 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  38367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38387 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38404 */     // GIR_Coverage, 5446,
     /*  38404 */     GIR_EraseRootFromParent_Done,
     /*  38405 */   // Label 616: @38405
     /*  38405 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(38541), // Rule ID 5435 //
     /*  38410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38443 */     // MIs[1] Operand 2
     /*  38443 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38462 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38466 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38470 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38474 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38478 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38483 */     // MIs[3] Operand 2
     /*  38483 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38494 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38496 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38523 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38530 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38540 */     // GIR_Coverage, 5435,
     /*  38540 */     GIR_EraseRootFromParent_Done,
     /*  38541 */   // Label 617: @38541
     /*  38541 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(38677), // Rule ID 5434 //
     /*  38546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38579 */     // MIs[1] Operand 2
     /*  38579 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38598 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38602 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38606 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38610 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38614 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38619 */     // MIs[3] Operand 2
     /*  38619 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38632 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38644 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38659 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38676 */     // GIR_Coverage, 5434,
     /*  38676 */     GIR_EraseRootFromParent_Done,
     /*  38677 */   // Label 618: @38677
     /*  38677 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(38814), // Rule ID 3970 //
     /*  38682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  38714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  38718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38723 */     // MIs[2] Operand 2
     /*  38723 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  38734 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38738 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38742 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38746 */     // MIs[3] Operand 1
     /*  38746 */     // No operand predicates
     /*  38746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38748 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38748 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  38751 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38755 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38760 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  38767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38779 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  38785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  38806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38812 */     GIR_RootConstrainSelectedInstOperands,
     /*  38813 */     // GIR_Coverage, 3970,
     /*  38813 */     GIR_EraseRootFromParent_Done,
     /*  38814 */   // Label 619: @38814
     /*  38814 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(38913), // Rule ID 3968 //
     /*  38819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38860 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38864 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38868 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38872 */     // MIs[3] Operand 1
     /*  38872 */     // No operand predicates
     /*  38872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38874 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38886 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  38896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38911 */     GIR_RootConstrainSelectedInstOperands,
     /*  38912 */     // GIR_Coverage, 3968,
     /*  38912 */     GIR_EraseRootFromParent_Done,
     /*  38913 */   // Label 620: @38913
     /*  38913 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(39012), // Rule ID 3969 //
     /*  38918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  38954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38967 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  38971 */     // MIs[3] Operand 1
     /*  38971 */     // No operand predicates
     /*  38971 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38973 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38985 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  38995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39010 */     GIR_RootConstrainSelectedInstOperands,
     /*  39011 */     // GIR_Coverage, 3969,
     /*  39011 */     GIR_EraseRootFromParent_Done,
     /*  39012 */   // Label 621: @39012
     /*  39012 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(39098), // Rule ID 3963 //
     /*  39017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39021 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39066 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39070 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39077 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39096 */     GIR_RootConstrainSelectedInstOperands,
     /*  39097 */     // GIR_Coverage, 3963,
     /*  39097 */     GIR_EraseRootFromParent_Done,
     /*  39098 */   // Label 622: @39098
     /*  39098 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(39184), // Rule ID 3964 //
     /*  39103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39152 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39163 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39182 */     GIR_RootConstrainSelectedInstOperands,
     /*  39183 */     // GIR_Coverage, 3964,
     /*  39183 */     GIR_EraseRootFromParent_Done,
     /*  39184 */   // Label 623: @39184
     /*  39184 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(39317), // Rule ID 3976 //
     /*  39189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  39221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  39225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39230 */     // MIs[2] Operand 2
     /*  39230 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  39241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39249 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39253 */     // MIs[3] Operand 1
     /*  39253 */     // No operand predicates
     /*  39253 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39255 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  39258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39267 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  39274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39286 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39313 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39315 */     GIR_RootConstrainSelectedInstOperands,
     /*  39316 */     // GIR_Coverage, 3976,
     /*  39316 */     GIR_EraseRootFromParent_Done,
     /*  39317 */   // Label 624: @39317
     /*  39317 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(39412), // Rule ID 3974 //
     /*  39322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39371 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39375 */     // MIs[3] Operand 1
     /*  39375 */     // No operand predicates
     /*  39375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39377 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39389 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39410 */     GIR_RootConstrainSelectedInstOperands,
     /*  39411 */     // GIR_Coverage, 3974,
     /*  39411 */     GIR_EraseRootFromParent_Done,
     /*  39412 */   // Label 625: @39412
     /*  39412 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(39507), // Rule ID 3975 //
     /*  39417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39458 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39462 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39466 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39470 */     // MIs[3] Operand 1
     /*  39470 */     // No operand predicates
     /*  39470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39472 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39484 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39505 */     GIR_RootConstrainSelectedInstOperands,
     /*  39506 */     // GIR_Coverage, 3975,
     /*  39506 */     GIR_EraseRootFromParent_Done,
     /*  39507 */   // Label 626: @39507
     /*  39507 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(39589), // Rule ID 124 //
     /*  39512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39561 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39565 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39570 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39572 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39587 */     GIR_RootConstrainSelectedInstOperands,
     /*  39588 */     // GIR_Coverage, 124,
     /*  39588 */     GIR_EraseRootFromParent_Done,
     /*  39589 */   // Label 627: @39589
     /*  39589 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(39671), // Rule ID 126 //
     /*  39594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39643 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39647 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39652 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39654 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39669 */     GIR_RootConstrainSelectedInstOperands,
     /*  39670 */     // GIR_Coverage, 126,
     /*  39670 */     GIR_EraseRootFromParent_Done,
     /*  39671 */   // Label 628: @39671
     /*  39671 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(39733), // Rule ID 3954 //
     /*  39676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39712 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  39712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  39715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  39721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  39725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39731 */     GIR_RootConstrainSelectedInstOperands,
     /*  39732 */     // GIR_Coverage, 3954,
     /*  39732 */     GIR_EraseRootFromParent_Done,
     /*  39733 */   // Label 629: @39733
     /*  39733 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(39791), // Rule ID 10002 //
     /*  39738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39757 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39760 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  39765 */     // MIs[1] pattern
     /*  39765 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39768 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39775 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  39778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39780 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39789 */     GIR_RootConstrainSelectedInstOperands,
     /*  39790 */     // GIR_Coverage, 10002,
     /*  39790 */     GIR_EraseRootFromParent_Done,
     /*  39791 */   // Label 630: @39791
     /*  39791 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39849), // Rule ID 10014 //
     /*  39796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39815 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39818 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  39823 */     // MIs[1] pattern
     /*  39823 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39826 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39833 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  39836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39847 */     GIR_RootConstrainSelectedInstOperands,
     /*  39848 */     // GIR_Coverage, 10014,
     /*  39848 */     GIR_EraseRootFromParent_Done,
     /*  39849 */   // Label 631: @39849
     /*  39849 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(39907), // Rule ID 10026 //
     /*  39854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39873 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39876 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  39881 */     // MIs[1] pattern
     /*  39881 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39884 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39891 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  39894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39905 */     GIR_RootConstrainSelectedInstOperands,
     /*  39906 */     // GIR_Coverage, 10026,
     /*  39906 */     GIR_EraseRootFromParent_Done,
     /*  39907 */   // Label 632: @39907
     /*  39907 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(39965), // Rule ID 10038 //
     /*  39912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39931 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39934 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  39939 */     // MIs[1] pattern
     /*  39939 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39942 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39949 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  39952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  39963 */     GIR_RootConstrainSelectedInstOperands,
     /*  39964 */     // GIR_Coverage, 10038,
     /*  39964 */     GIR_EraseRootFromParent_Done,
     /*  39965 */   // Label 633: @39965
     /*  39965 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(40128), // Rule ID 5401 //
     /*  39970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  39998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40016 */     // MIs[1] Operand 2
     /*  40016 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40029 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40029 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40032 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40036 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40043 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40046 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40050 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40055 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40058 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40062 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40065 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40070 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40075 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  40087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40092 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40095 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40099 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40110 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40127 */     // GIR_Coverage, 5401,
     /*  40127 */     GIR_EraseRootFromParent_Done,
     /*  40128 */   // Label 634: @40128
     /*  40128 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(40291), // Rule ID 5398 //
     /*  40133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  40161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40179 */     // MIs[1] Operand 2
     /*  40179 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40192 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40192 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40195 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40199 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40218 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40221 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40225 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40228 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  40250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40255 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40273 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40290 */     // GIR_Coverage, 5398,
     /*  40290 */     GIR_EraseRootFromParent_Done,
     /*  40291 */   // Label 635: @40291
     /*  40291 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(40441), // Rule ID 5443 //
     /*  40296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40333 */     // MIs[1] Operand 2
     /*  40333 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40346 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40346 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40349 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40353 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40372 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40375 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40379 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40382 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40387 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40392 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40409 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40423 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40440 */     // GIR_Coverage, 5443,
     /*  40440 */     GIR_EraseRootFromParent_Done,
     /*  40441 */   // Label 636: @40441
     /*  40441 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(40591), // Rule ID 5449 //
     /*  40446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40483 */     // MIs[1] Operand 2
     /*  40483 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40496 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40496 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40503 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40522 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40525 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40529 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40532 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40537 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40542 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  40554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40573 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40590 */     // GIR_Coverage, 5449,
     /*  40590 */     GIR_EraseRootFromParent_Done,
     /*  40591 */   // Label 637: @40591
     /*  40591 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(40741), // Rule ID 5442 //
     /*  40596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40633 */     // MIs[1] Operand 2
     /*  40633 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40646 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40646 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40649 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40653 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40660 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40663 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40667 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40672 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40679 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40682 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40709 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40723 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40740 */     // GIR_Coverage, 5442,
     /*  40740 */     GIR_EraseRootFromParent_Done,
     /*  40741 */   // Label 638: @40741
     /*  40741 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(40777), // Rule ID 3919 //
     /*  40746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  40761 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  40761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  40764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40766 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  40768 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  40772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40775 */     GIR_RootConstrainSelectedInstOperands,
     /*  40776 */     // GIR_Coverage, 3919,
     /*  40776 */     GIR_EraseRootFromParent_Done,
     /*  40777 */   // Label 639: @40777
     /*  40777 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(40810), // Rule ID 3924 //
     /*  40782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  40797 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  40800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40808 */     GIR_RootConstrainSelectedInstOperands,
     /*  40809 */     // GIR_Coverage, 3924,
     /*  40809 */     GIR_EraseRootFromParent_Done,
     /*  40810 */   // Label 640: @40810
     /*  40810 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40846), // Rule ID 3913 //
     /*  40815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  40830 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  40830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  40833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40835 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  40841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40844 */     GIR_RootConstrainSelectedInstOperands,
     /*  40845 */     // GIR_Coverage, 3913,
     /*  40845 */     GIR_EraseRootFromParent_Done,
     /*  40846 */   // Label 641: @40846
     /*  40846 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40882), // Rule ID 3917 //
     /*  40851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  40866 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  40866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  40869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  40877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40880 */     GIR_RootConstrainSelectedInstOperands,
     /*  40881 */     // GIR_Coverage, 3917,
     /*  40881 */     GIR_EraseRootFromParent_Done,
     /*  40882 */   // Label 642: @40882
     /*  40882 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40945), // Rule ID 10135 //
     /*  40887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40906 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40909 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  40918 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40925 */     // MIs[1] pred
     /*  40925 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40932 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  40935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  40941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  40943 */     GIR_RootConstrainSelectedInstOperands,
     /*  40944 */     // GIR_Coverage, 10135,
     /*  40944 */     GIR_EraseRootFromParent_Done,
     /*  40945 */   // Label 643: @40945
     /*  40945 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(41008), // Rule ID 10136 //
     /*  40950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  40953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40969 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  40972 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  40977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  40981 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  40983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  40988 */     // MIs[1] pred
     /*  40988 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  40993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40995 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  40995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  40998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41006 */     GIR_RootConstrainSelectedInstOperands,
     /*  41007 */     // GIR_Coverage, 10136,
     /*  41007 */     GIR_EraseRootFromParent_Done,
     /*  41008 */   // Label 644: @41008
     /*  41008 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(41071), // Rule ID 10137 //
     /*  41013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41032 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41035 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  41044 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41051 */     // MIs[1] pred
     /*  41051 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41058 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  41061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41069 */     GIR_RootConstrainSelectedInstOperands,
     /*  41070 */     // GIR_Coverage, 10137,
     /*  41070 */     GIR_EraseRootFromParent_Done,
     /*  41071 */   // Label 645: @41071
     /*  41071 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(41134), // Rule ID 10138 //
     /*  41076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41095 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41098 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  41107 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41114 */     // MIs[1] pred
     /*  41114 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41121 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  41124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41132 */     GIR_RootConstrainSelectedInstOperands,
     /*  41133 */     // GIR_Coverage, 10138,
     /*  41133 */     GIR_EraseRootFromParent_Done,
     /*  41134 */   // Label 646: @41134
     /*  41134 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(41173), // Rule ID 1655 //
     /*  41139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41150 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41156 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41164 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  41164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41171 */     GIR_RootConstrainSelectedInstOperands,
     /*  41172 */     // GIR_Coverage, 1655,
     /*  41172 */     GIR_EraseRootFromParent_Done,
     /*  41173 */   // Label 647: @41173
     /*  41173 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(41209), // Rule ID 5284 //
     /*  41178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41186 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41192 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41200 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  41200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41207 */     GIR_RootConstrainSelectedInstOperands,
     /*  41208 */     // GIR_Coverage, 5284,
     /*  41208 */     GIR_EraseRootFromParent_Done,
     /*  41209 */   // Label 648: @41209
     /*  41209 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(41236), // Rule ID 1644 //
     /*  41214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41229 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  41229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  41234 */     GIR_RootConstrainSelectedInstOperands,
     /*  41235 */     // GIR_Coverage, 1644,
     /*  41235 */     GIR_Done,
     /*  41236 */   // Label 649: @41236
     /*  41236 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(41266), // Rule ID 3915 //
     /*  41241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41253 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  41253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  41258 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  41264 */     GIR_RootConstrainSelectedInstOperands,
     /*  41265 */     // GIR_Coverage, 3915,
     /*  41265 */     GIR_Done,
     /*  41266 */   // Label 650: @41266
     /*  41266 */   GIM_Reject,
     /*  41267 */ // Label 613: @41267
     /*  41267 */ GIM_Reject,
     /*  41268 */ // Label 586: @41268
     /*  41268 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(42758),
     /*  41273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41283 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(41415), // Rule ID 5433 //
     /*  41288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41317 */     // MIs[1] Operand 2
     /*  41317 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41336 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41340 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41344 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41348 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41352 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41357 */     // MIs[3] Operand 2
     /*  41357 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41368 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41370 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41397 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41414 */     // GIR_Coverage, 5433,
     /*  41414 */     GIR_EraseRootFromParent_Done,
     /*  41415 */   // Label 652: @41415
     /*  41415 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(41547), // Rule ID 5432 //
     /*  41420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41449 */     // MIs[1] Operand 2
     /*  41449 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41484 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41489 */     // MIs[3] Operand 2
     /*  41489 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41500 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41502 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41546 */     // GIR_Coverage, 5432,
     /*  41546 */     GIR_EraseRootFromParent_Done,
     /*  41547 */   // Label 653: @41547
     /*  41547 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(41679), // Rule ID 5445 //
     /*  41552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41581 */     // MIs[1] Operand 2
     /*  41581 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41600 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41604 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41608 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41612 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41616 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41621 */     // MIs[3] Operand 2
     /*  41621 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41632 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41634 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  41641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41661 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41673 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41678 */     // GIR_Coverage, 5445,
     /*  41678 */     GIR_EraseRootFromParent_Done,
     /*  41679 */   // Label 654: @41679
     /*  41679 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(41811), // Rule ID 5431 //
     /*  41684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41713 */     // MIs[1] Operand 2
     /*  41713 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41732 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41736 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41740 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41744 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41748 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41753 */     // MIs[3] Operand 2
     /*  41753 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41764 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41766 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41782 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41793 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41800 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41810 */     // GIR_Coverage, 5431,
     /*  41810 */     GIR_EraseRootFromParent_Done,
     /*  41811 */   // Label 655: @41811
     /*  41811 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(41943), // Rule ID 5430 //
     /*  41816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41845 */     // MIs[1] Operand 2
     /*  41845 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41868 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41872 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41876 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41880 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41885 */     // MIs[3] Operand 2
     /*  41885 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41896 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41898 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41925 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41942 */     // GIR_Coverage, 5430,
     /*  41942 */     GIR_EraseRootFromParent_Done,
     /*  41943 */   // Label 656: @41943
     /*  41943 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(42102), // Rule ID 5400 //
     /*  41948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  41972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41990 */     // MIs[1] Operand 2
     /*  41990 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42003 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42003 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42006 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42010 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42017 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42020 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42024 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42029 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42032 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42036 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42039 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42044 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42049 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  42061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42066 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42069 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42084 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42101 */     // GIR_Coverage, 5400,
     /*  42101 */     GIR_EraseRootFromParent_Done,
     /*  42102 */   // Label 657: @42102
     /*  42102 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(42261), // Rule ID 5397 //
     /*  42107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  42131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42149 */     // MIs[1] Operand 2
     /*  42149 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42162 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42162 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42165 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42169 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42176 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42179 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42183 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42188 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42191 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42195 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42208 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  42220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42225 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42243 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42255 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42260 */     // GIR_Coverage, 5397,
     /*  42260 */     GIR_EraseRootFromParent_Done,
     /*  42261 */   // Label 658: @42261
     /*  42261 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(42407), // Rule ID 5441 //
     /*  42266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42294 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42299 */     // MIs[1] Operand 2
     /*  42299 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42312 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42312 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42315 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42319 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42326 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42329 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42333 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42338 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42341 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42345 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42348 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42353 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42358 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42375 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42389 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42406 */     // GIR_Coverage, 5441,
     /*  42406 */     GIR_EraseRootFromParent_Done,
     /*  42407 */   // Label 659: @42407
     /*  42407 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(42553), // Rule ID 5448 //
     /*  42412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42445 */     // MIs[1] Operand 2
     /*  42445 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42458 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42458 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42461 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42465 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42472 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42475 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42479 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42484 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42487 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42491 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42494 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42499 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42504 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  42516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42521 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42524 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42535 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42542 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42552 */     // GIR_Coverage, 5448,
     /*  42552 */     GIR_EraseRootFromParent_Done,
     /*  42553 */   // Label 660: @42553
     /*  42553 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(42699), // Rule ID 5440 //
     /*  42558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42591 */     // MIs[1] Operand 2
     /*  42591 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42604 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42604 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42607 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42611 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42618 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42621 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42625 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42630 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42633 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42637 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42640 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42645 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42650 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42667 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42670 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42681 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42693 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42698 */     // GIR_Coverage, 5440,
     /*  42698 */     GIR_EraseRootFromParent_Done,
     /*  42699 */   // Label 661: @42699
     /*  42699 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(42734), // Rule ID 969 //
     /*  42704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42711 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42717 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42725 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  42725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  42728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42732 */     GIR_RootConstrainSelectedInstOperands,
     /*  42733 */     // GIR_Coverage, 969,
     /*  42733 */     GIR_EraseRootFromParent_Done,
     /*  42734 */   // Label 662: @42734
     /*  42734 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(42757), // Rule ID 1476 //
     /*  42739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42750 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  42755 */     GIR_RootConstrainSelectedInstOperands,
     /*  42756 */     // GIR_Coverage, 1476,
     /*  42756 */     GIR_Done,
     /*  42757 */   // Label 663: @42757
     /*  42757 */   GIM_Reject,
     /*  42758 */ // Label 651: @42758
     /*  42758 */ GIM_Reject,
     /*  42759 */ // Label 587: @42759
     /*  42759 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(45218),
     /*  42764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  42767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  42770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42774 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(42888), // Rule ID 2048 //
     /*  42779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42826 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42830 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42835 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42839 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42843 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42847 */     // MIs[4] Operand 1
     /*  42847 */     // No operand predicates
     /*  42847 */     // MIs[2] Operand 2
     /*  42847 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42858 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42860 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42867 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  42886 */     GIR_RootConstrainSelectedInstOperands,
     /*  42887 */     // GIR_Coverage, 2048,
     /*  42887 */     GIR_EraseRootFromParent_Done,
     /*  42888 */   // Label 665: @42888
     /*  42888 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(43002), // Rule ID 13576 //
     /*  42893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  42908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  42932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  42936 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42940 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  42944 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42949 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  42953 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42957 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  42961 */     // MIs[4] Operand 1
     /*  42961 */     // No operand predicates
     /*  42961 */     // MIs[2] Operand 2
     /*  42961 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  42972 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  42981 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  42981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  42984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  42988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  42993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  42997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43000 */     GIR_RootConstrainSelectedInstOperands,
     /*  43001 */     // GIR_Coverage, 13576,
     /*  43001 */     GIR_EraseRootFromParent_Done,
     /*  43002 */   // Label 666: @43002
     /*  43002 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(43116), // Rule ID 2100 //
     /*  43007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43054 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43058 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43071 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43075 */     // MIs[4] Operand 1
     /*  43075 */     // No operand predicates
     /*  43075 */     // MIs[2] Operand 2
     /*  43075 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43088 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43095 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43114 */     GIR_RootConstrainSelectedInstOperands,
     /*  43115 */     // GIR_Coverage, 2100,
     /*  43115 */     GIR_EraseRootFromParent_Done,
     /*  43116 */   // Label 667: @43116
     /*  43116 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(43230), // Rule ID 13606 //
     /*  43121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43164 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43168 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43172 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43177 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43181 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43185 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43189 */     // MIs[4] Operand 1
     /*  43189 */     // No operand predicates
     /*  43189 */     // MIs[2] Operand 2
     /*  43189 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43200 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43209 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43228 */     GIR_RootConstrainSelectedInstOperands,
     /*  43229 */     // GIR_Coverage, 13606,
     /*  43229 */     GIR_EraseRootFromParent_Done,
     /*  43230 */   // Label 668: @43230
     /*  43230 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(43295), // Rule ID 1855 //
     /*  43235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43271 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43278 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43293 */     GIR_RootConstrainSelectedInstOperands,
     /*  43294 */     // GIR_Coverage, 1855,
     /*  43294 */     GIR_EraseRootFromParent_Done,
     /*  43295 */   // Label 669: @43295
     /*  43295 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(43360), // Rule ID 1854 //
     /*  43300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43329 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43343 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43358 */     GIR_RootConstrainSelectedInstOperands,
     /*  43359 */     // GIR_Coverage, 1854,
     /*  43359 */     GIR_EraseRootFromParent_Done,
     /*  43360 */   // Label 670: @43360
     /*  43360 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(43425), // Rule ID 1759 //
     /*  43365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43408 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  43411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43423 */     GIR_RootConstrainSelectedInstOperands,
     /*  43424 */     // GIR_Coverage, 1759,
     /*  43424 */     GIR_EraseRootFromParent_Done,
     /*  43425 */   // Label 671: @43425
     /*  43425 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(43490), // Rule ID 1853 //
     /*  43430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43473 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43488 */     GIR_RootConstrainSelectedInstOperands,
     /*  43489 */     // GIR_Coverage, 1853,
     /*  43489 */     GIR_EraseRootFromParent_Done,
     /*  43490 */   // Label 672: @43490
     /*  43490 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(43555), // Rule ID 1852 //
     /*  43495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43538 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43553 */     GIR_RootConstrainSelectedInstOperands,
     /*  43554 */     // GIR_Coverage, 1852,
     /*  43554 */     GIR_EraseRootFromParent_Done,
     /*  43555 */   // Label 673: @43555
     /*  43555 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(43666), // Rule ID 13574 //
     /*  43560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43603 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43607 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43611 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43616 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43620 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43624 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43628 */     // MIs[4] Operand 1
     /*  43628 */     // No operand predicates
     /*  43628 */     // MIs[2] Operand 2
     /*  43628 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43644 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43646 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43664 */     GIR_RootConstrainSelectedInstOperands,
     /*  43665 */     // GIR_Coverage, 13574,
     /*  43665 */     GIR_EraseRootFromParent_Done,
     /*  43666 */   // Label 674: @43666
     /*  43666 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(43777), // Rule ID 2046 //
     /*  43671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43719 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43723 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43727 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43732 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43736 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43740 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43744 */     // MIs[4] Operand 1
     /*  43744 */     // No operand predicates
     /*  43744 */     // MIs[2] Operand 2
     /*  43744 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43755 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43757 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43775 */     GIR_RootConstrainSelectedInstOperands,
     /*  43776 */     // GIR_Coverage, 2046,
     /*  43776 */     GIR_EraseRootFromParent_Done,
     /*  43777 */   // Label 675: @43777
     /*  43777 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(43888), // Rule ID 13604 //
     /*  43782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43825 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43829 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43833 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43838 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43842 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43846 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43850 */     // MIs[4] Operand 1
     /*  43850 */     // No operand predicates
     /*  43850 */     // MIs[2] Operand 2
     /*  43850 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43866 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43868 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43886 */     GIR_RootConstrainSelectedInstOperands,
     /*  43887 */     // GIR_Coverage, 13604,
     /*  43887 */     GIR_EraseRootFromParent_Done,
     /*  43888 */   // Label 676: @43888
     /*  43888 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(43999), // Rule ID 2098 //
     /*  43893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43937 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43941 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43945 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43949 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43958 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43962 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43966 */     // MIs[4] Operand 1
     /*  43966 */     // No operand predicates
     /*  43966 */     // MIs[2] Operand 2
     /*  43966 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43977 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43979 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  43982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43997 */     GIR_RootConstrainSelectedInstOperands,
     /*  43998 */     // GIR_Coverage, 2098,
     /*  43998 */     GIR_EraseRootFromParent_Done,
     /*  43999 */   // Label 677: @43999
     /*  43999 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(44062), // Rule ID 1735 //
     /*  44004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44036 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44043 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  44046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44060 */     GIR_RootConstrainSelectedInstOperands,
     /*  44061 */     // GIR_Coverage, 1735,
     /*  44061 */     GIR_EraseRootFromParent_Done,
     /*  44062 */   // Label 678: @44062
     /*  44062 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(44125), // Rule ID 1825 //
     /*  44067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44106 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  44109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44123 */     GIR_RootConstrainSelectedInstOperands,
     /*  44124 */     // GIR_Coverage, 1825,
     /*  44124 */     GIR_EraseRootFromParent_Done,
     /*  44125 */   // Label 679: @44125
     /*  44125 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(44213), // Rule ID 13575 //
     /*  44130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44182 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44186 */     // MIs[3] Operand 1
     /*  44186 */     // No operand predicates
     /*  44186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44191 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44193 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44211 */     GIR_RootConstrainSelectedInstOperands,
     /*  44212 */     // GIR_Coverage, 13575,
     /*  44212 */     GIR_EraseRootFromParent_Done,
     /*  44213 */   // Label 680: @44213
     /*  44213 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(44301), // Rule ID 2047 //
     /*  44218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44275 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44279 */     // MIs[3] Operand 1
     /*  44279 */     // No operand predicates
     /*  44279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44281 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44299 */     GIR_RootConstrainSelectedInstOperands,
     /*  44300 */     // GIR_Coverage, 2047,
     /*  44300 */     GIR_EraseRootFromParent_Done,
     /*  44301 */   // Label 681: @44301
     /*  44301 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(44389), // Rule ID 13605 //
     /*  44306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44350 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44354 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44358 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44362 */     // MIs[3] Operand 1
     /*  44362 */     // No operand predicates
     /*  44362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44367 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44369 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44387 */     GIR_RootConstrainSelectedInstOperands,
     /*  44388 */     // GIR_Coverage, 13605,
     /*  44388 */     GIR_EraseRootFromParent_Done,
     /*  44389 */   // Label 682: @44389
     /*  44389 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(44477), // Rule ID 2099 //
     /*  44394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44451 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44455 */     // MIs[3] Operand 1
     /*  44455 */     // No operand predicates
     /*  44455 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44457 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44475 */     GIR_RootConstrainSelectedInstOperands,
     /*  44476 */     // GIR_Coverage, 2099,
     /*  44476 */     GIR_EraseRootFromParent_Done,
     /*  44477 */   // Label 683: @44477
     /*  44477 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(44524), // Rule ID 1867 //
     /*  44482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44510 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44522 */     GIR_RootConstrainSelectedInstOperands,
     /*  44523 */     // GIR_Coverage, 1867,
     /*  44523 */     GIR_EraseRootFromParent_Done,
     /*  44524 */   // Label 684: @44524
     /*  44524 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(44571), // Rule ID 1765 //
     /*  44529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44557 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  44560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44569 */     GIR_RootConstrainSelectedInstOperands,
     /*  44570 */     // GIR_Coverage, 1765,
     /*  44570 */     GIR_EraseRootFromParent_Done,
     /*  44571 */   // Label 685: @44571
     /*  44571 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(44618), // Rule ID 1866 //
     /*  44576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44604 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44616 */     GIR_RootConstrainSelectedInstOperands,
     /*  44617 */     // GIR_Coverage, 1866,
     /*  44617 */     GIR_EraseRootFromParent_Done,
     /*  44618 */   // Label 686: @44618
     /*  44618 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(44677), // Rule ID 1851 //
     /*  44623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44662 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44675 */     GIR_RootConstrainSelectedInstOperands,
     /*  44676 */     // GIR_Coverage, 1851,
     /*  44676 */     GIR_EraseRootFromParent_Done,
     /*  44677 */   // Label 687: @44677
     /*  44677 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(44736), // Rule ID 1850 //
     /*  44682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44721 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44734 */     GIR_RootConstrainSelectedInstOperands,
     /*  44735 */     // GIR_Coverage, 1850,
     /*  44735 */     GIR_EraseRootFromParent_Done,
     /*  44736 */   // Label 688: @44736
     /*  44736 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(44795), // Rule ID 1758 //
     /*  44741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44780 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  44783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44793 */     GIR_RootConstrainSelectedInstOperands,
     /*  44794 */     // GIR_Coverage, 1758,
     /*  44794 */     GIR_EraseRootFromParent_Done,
     /*  44795 */   // Label 689: @44795
     /*  44795 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(44854), // Rule ID 1849 //
     /*  44800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44839 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44852 */     GIR_RootConstrainSelectedInstOperands,
     /*  44853 */     // GIR_Coverage, 1849,
     /*  44853 */     GIR_EraseRootFromParent_Done,
     /*  44854 */   // Label 690: @44854
     /*  44854 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44913), // Rule ID 1848 //
     /*  44859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44898 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44911 */     GIR_RootConstrainSelectedInstOperands,
     /*  44912 */     // GIR_Coverage, 1848,
     /*  44912 */     GIR_EraseRootFromParent_Done,
     /*  44913 */   // Label 691: @44913
     /*  44913 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(44948), // Rule ID 971 //
     /*  44918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44925 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44931 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  44933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44939 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  44939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  44942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  44946 */     GIR_RootConstrainSelectedInstOperands,
     /*  44947 */     // GIR_Coverage, 971,
     /*  44947 */     GIR_EraseRootFromParent_Done,
     /*  44948 */   // Label 692: @44948
     /*  44948 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(45005), // Rule ID 1734 //
     /*  44953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44988 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  44991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45003 */     GIR_RootConstrainSelectedInstOperands,
     /*  45004 */     // GIR_Coverage, 1734,
     /*  45004 */     GIR_EraseRootFromParent_Done,
     /*  45005 */   // Label 693: @45005
     /*  45005 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(45062), // Rule ID 1824 //
     /*  45010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45045 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  45048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45060 */     GIR_RootConstrainSelectedInstOperands,
     /*  45061 */     // GIR_Coverage, 1824,
     /*  45061 */     GIR_EraseRootFromParent_Done,
     /*  45062 */   // Label 694: @45062
     /*  45062 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(45106), // Rule ID 1865 //
     /*  45067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45093 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45098 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45104 */     GIR_RootConstrainSelectedInstOperands,
     /*  45105 */     // GIR_Coverage, 1865,
     /*  45105 */     GIR_EraseRootFromParent_Done,
     /*  45106 */   // Label 695: @45106
     /*  45106 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(45150), // Rule ID 1764 //
     /*  45111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45137 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  45140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45148 */     GIR_RootConstrainSelectedInstOperands,
     /*  45149 */     // GIR_Coverage, 1764,
     /*  45149 */     GIR_EraseRootFromParent_Done,
     /*  45150 */   // Label 696: @45150
     /*  45150 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(45194), // Rule ID 1864 //
     /*  45155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45181 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45192 */     GIR_RootConstrainSelectedInstOperands,
     /*  45193 */     // GIR_Coverage, 1864,
     /*  45193 */     GIR_EraseRootFromParent_Done,
     /*  45194 */   // Label 697: @45194
     /*  45194 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(45217), // Rule ID 1478 //
     /*  45199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45210 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  45210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  45215 */     GIR_RootConstrainSelectedInstOperands,
     /*  45216 */     // GIR_Coverage, 1478,
     /*  45216 */     GIR_Done,
     /*  45217 */   // Label 698: @45217
     /*  45217 */   GIM_Reject,
     /*  45218 */ // Label 664: @45218
     /*  45218 */ GIM_Reject,
     /*  45219 */ // Label 588: @45219
     /*  45219 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(46709),
     /*  45224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45234 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(45366), // Rule ID 5429 //
     /*  45239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45268 */     // MIs[1] Operand 2
     /*  45268 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45287 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45291 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45295 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45299 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45303 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45308 */     // MIs[3] Operand 2
     /*  45308 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45319 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45321 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45337 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45348 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45365 */     // GIR_Coverage, 5429,
     /*  45365 */     GIR_EraseRootFromParent_Done,
     /*  45366 */   // Label 700: @45366
     /*  45366 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(45498), // Rule ID 5428 //
     /*  45371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45400 */     // MIs[1] Operand 2
     /*  45400 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45419 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45431 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45435 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45440 */     // MIs[3] Operand 2
     /*  45440 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45451 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45453 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45465 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45469 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45480 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45497 */     // GIR_Coverage, 5428,
     /*  45497 */     GIR_EraseRootFromParent_Done,
     /*  45498 */   // Label 701: @45498
     /*  45498 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(45630), // Rule ID 5444 //
     /*  45503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45532 */     // MIs[1] Operand 2
     /*  45532 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45551 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45555 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45559 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45563 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45567 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45572 */     // MIs[3] Operand 2
     /*  45572 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45583 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45585 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  45592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45597 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45612 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45629 */     // GIR_Coverage, 5444,
     /*  45629 */     GIR_EraseRootFromParent_Done,
     /*  45630 */   // Label 702: @45630
     /*  45630 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(45762), // Rule ID 5427 //
     /*  45635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45659 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45664 */     // MIs[1] Operand 2
     /*  45664 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45691 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45695 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45699 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45704 */     // MIs[3] Operand 2
     /*  45704 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45715 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45717 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45733 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45744 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45761 */     // GIR_Coverage, 5427,
     /*  45761 */     GIR_EraseRootFromParent_Done,
     /*  45762 */   // Label 703: @45762
     /*  45762 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(45894), // Rule ID 5426 //
     /*  45767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45796 */     // MIs[1] Operand 2
     /*  45796 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45815 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45819 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45823 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45827 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45831 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45836 */     // MIs[3] Operand 2
     /*  45836 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45847 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45849 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45876 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45893 */     // GIR_Coverage, 5426,
     /*  45893 */     GIR_EraseRootFromParent_Done,
     /*  45894 */   // Label 704: @45894
     /*  45894 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(46053), // Rule ID 5399 //
     /*  45899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  45923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  45931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45941 */     // MIs[1] Operand 2
     /*  45941 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45954 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45954 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  45957 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45961 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  45968 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  45971 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45975 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45980 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  45983 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  45987 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  45990 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45995 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46000 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  46012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46017 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46020 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46024 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46035 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46052 */     // GIR_Coverage, 5399,
     /*  46052 */     GIR_EraseRootFromParent_Done,
     /*  46053 */   // Label 705: @46053
     /*  46053 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(46212), // Rule ID 5396 //
     /*  46058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  46082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46090 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46100 */     // MIs[1] Operand 2
     /*  46100 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46113 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46113 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46116 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46120 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46127 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46130 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46134 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46139 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46142 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  46146 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46149 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46154 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  46171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46176 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46179 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46183 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46194 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46211 */     // GIR_Coverage, 5396,
     /*  46211 */     GIR_EraseRootFromParent_Done,
     /*  46212 */   // Label 706: @46212
     /*  46212 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(46358), // Rule ID 5439 //
     /*  46217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46250 */     // MIs[1] Operand 2
     /*  46250 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46263 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46263 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46266 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46270 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46277 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46280 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46284 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46289 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46292 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46296 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46299 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46304 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46309 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46326 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46340 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46357 */     // GIR_Coverage, 5439,
     /*  46357 */     GIR_EraseRootFromParent_Done,
     /*  46358 */   // Label 707: @46358
     /*  46358 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(46504), // Rule ID 5447 //
     /*  46363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46396 */     // MIs[1] Operand 2
     /*  46396 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46409 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46409 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46412 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46416 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46423 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46426 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46430 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46435 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46438 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46442 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46455 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  46467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46472 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46475 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46486 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46503 */     // GIR_Coverage, 5447,
     /*  46503 */     GIR_EraseRootFromParent_Done,
     /*  46504 */   // Label 708: @46504
     /*  46504 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(46650), // Rule ID 5438 //
     /*  46509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46542 */     // MIs[1] Operand 2
     /*  46542 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46555 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46555 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46558 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46562 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46569 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46572 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46576 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46581 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46584 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46588 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46591 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46596 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46601 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46618 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46621 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46632 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46649 */     // GIR_Coverage, 5438,
     /*  46649 */     GIR_EraseRootFromParent_Done,
     /*  46650 */   // Label 709: @46650
     /*  46650 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(46685), // Rule ID 967 //
     /*  46655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46662 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46668 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46676 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  46676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  46679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46683 */     GIR_RootConstrainSelectedInstOperands,
     /*  46684 */     // GIR_Coverage, 967,
     /*  46684 */     GIR_EraseRootFromParent_Done,
     /*  46685 */   // Label 710: @46685
     /*  46685 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(46708), // Rule ID 1474 //
     /*  46690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46701 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  46706 */     GIR_RootConstrainSelectedInstOperands,
     /*  46707 */     // GIR_Coverage, 1474,
     /*  46707 */     GIR_Done,
     /*  46708 */   // Label 711: @46708
     /*  46708 */   GIM_Reject,
     /*  46709 */ // Label 699: @46709
     /*  46709 */ GIM_Reject,
     /*  46710 */ // Label 589: @46710
     /*  46710 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(49169),
     /*  46715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46725 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(46839), // Rule ID 2045 //
     /*  46730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46777 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46781 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46790 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46794 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46798 */     // MIs[4] Operand 1
     /*  46798 */     // No operand predicates
     /*  46798 */     // MIs[2] Operand 2
     /*  46798 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46809 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46818 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46837 */     GIR_RootConstrainSelectedInstOperands,
     /*  46838 */     // GIR_Coverage, 2045,
     /*  46838 */     GIR_EraseRootFromParent_Done,
     /*  46839 */   // Label 713: @46839
     /*  46839 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(46953), // Rule ID 13573 //
     /*  46844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46879 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46883 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46887 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46891 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46895 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46900 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46904 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  46908 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  46912 */     // MIs[4] Operand 1
     /*  46912 */     // No operand predicates
     /*  46912 */     // MIs[2] Operand 2
     /*  46912 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  46923 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  46932 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  46932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  46935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  46944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  46948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  46951 */     GIR_RootConstrainSelectedInstOperands,
     /*  46952 */     // GIR_Coverage, 13573,
     /*  46952 */     GIR_EraseRootFromParent_Done,
     /*  46953 */   // Label 714: @46953
     /*  46953 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(47067), // Rule ID 2097 //
     /*  46958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47001 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47005 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47009 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47018 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47022 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47026 */     // MIs[4] Operand 1
     /*  47026 */     // No operand predicates
     /*  47026 */     // MIs[2] Operand 2
     /*  47026 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47037 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47046 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47065 */     GIR_RootConstrainSelectedInstOperands,
     /*  47066 */     // GIR_Coverage, 2097,
     /*  47066 */     GIR_EraseRootFromParent_Done,
     /*  47067 */   // Label 715: @47067
     /*  47067 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(47181), // Rule ID 13603 //
     /*  47072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47115 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47119 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47123 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47128 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47132 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47136 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47140 */     // MIs[4] Operand 1
     /*  47140 */     // No operand predicates
     /*  47140 */     // MIs[2] Operand 2
     /*  47140 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47151 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47160 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47179 */     GIR_RootConstrainSelectedInstOperands,
     /*  47180 */     // GIR_Coverage, 13603,
     /*  47180 */     GIR_EraseRootFromParent_Done,
     /*  47181 */   // Label 716: @47181
     /*  47181 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(47246), // Rule ID 1847 //
     /*  47186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47229 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47244 */     GIR_RootConstrainSelectedInstOperands,
     /*  47245 */     // GIR_Coverage, 1847,
     /*  47245 */     GIR_EraseRootFromParent_Done,
     /*  47246 */   // Label 717: @47246
     /*  47246 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(47311), // Rule ID 1846 //
     /*  47251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47287 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47294 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47309 */     GIR_RootConstrainSelectedInstOperands,
     /*  47310 */     // GIR_Coverage, 1846,
     /*  47310 */     GIR_EraseRootFromParent_Done,
     /*  47311 */   // Label 718: @47311
     /*  47311 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(47376), // Rule ID 1757 //
     /*  47316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47359 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  47362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47374 */     GIR_RootConstrainSelectedInstOperands,
     /*  47375 */     // GIR_Coverage, 1757,
     /*  47375 */     GIR_EraseRootFromParent_Done,
     /*  47376 */   // Label 719: @47376
     /*  47376 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(47441), // Rule ID 1845 //
     /*  47381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47417 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47424 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47439 */     GIR_RootConstrainSelectedInstOperands,
     /*  47440 */     // GIR_Coverage, 1845,
     /*  47440 */     GIR_EraseRootFromParent_Done,
     /*  47441 */   // Label 720: @47441
     /*  47441 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(47506), // Rule ID 1844 //
     /*  47446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47489 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47504 */     GIR_RootConstrainSelectedInstOperands,
     /*  47505 */     // GIR_Coverage, 1844,
     /*  47505 */     GIR_EraseRootFromParent_Done,
     /*  47506 */   // Label 721: @47506
     /*  47506 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(47617), // Rule ID 13571 //
     /*  47511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47554 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47558 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47562 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47567 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47571 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47575 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47579 */     // MIs[4] Operand 1
     /*  47579 */     // No operand predicates
     /*  47579 */     // MIs[2] Operand 2
     /*  47579 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47595 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47597 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47615 */     GIR_RootConstrainSelectedInstOperands,
     /*  47616 */     // GIR_Coverage, 13571,
     /*  47616 */     GIR_EraseRootFromParent_Done,
     /*  47617 */   // Label 722: @47617
     /*  47617 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(47728), // Rule ID 2043 //
     /*  47622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47670 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47674 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47678 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47683 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47687 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47691 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47695 */     // MIs[4] Operand 1
     /*  47695 */     // No operand predicates
     /*  47695 */     // MIs[2] Operand 2
     /*  47695 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47706 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47708 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47726 */     GIR_RootConstrainSelectedInstOperands,
     /*  47727 */     // GIR_Coverage, 2043,
     /*  47727 */     GIR_EraseRootFromParent_Done,
     /*  47728 */   // Label 723: @47728
     /*  47728 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(47839), // Rule ID 13601 //
     /*  47733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47776 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47780 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47784 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47789 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47793 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47797 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47801 */     // MIs[4] Operand 1
     /*  47801 */     // No operand predicates
     /*  47801 */     // MIs[2] Operand 2
     /*  47801 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47817 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47819 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47837 */     GIR_RootConstrainSelectedInstOperands,
     /*  47838 */     // GIR_Coverage, 13601,
     /*  47838 */     GIR_EraseRootFromParent_Done,
     /*  47839 */   // Label 724: @47839
     /*  47839 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(47950), // Rule ID 2095 //
     /*  47844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47892 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47896 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47900 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47905 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47909 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47913 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47917 */     // MIs[4] Operand 1
     /*  47917 */     // No operand predicates
     /*  47917 */     // MIs[2] Operand 2
     /*  47917 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47928 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47930 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  47933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47948 */     GIR_RootConstrainSelectedInstOperands,
     /*  47949 */     // GIR_Coverage, 2095,
     /*  47949 */     GIR_EraseRootFromParent_Done,
     /*  47950 */   // Label 725: @47950
     /*  47950 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(48013), // Rule ID 1733 //
     /*  47955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47980 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47987 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47994 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  47997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48011 */     GIR_RootConstrainSelectedInstOperands,
     /*  48012 */     // GIR_Coverage, 1733,
     /*  48012 */     GIR_EraseRootFromParent_Done,
     /*  48013 */   // Label 726: @48013
     /*  48013 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(48076), // Rule ID 1823 //
     /*  48018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48057 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  48060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48074 */     GIR_RootConstrainSelectedInstOperands,
     /*  48075 */     // GIR_Coverage, 1823,
     /*  48075 */     GIR_EraseRootFromParent_Done,
     /*  48076 */   // Label 727: @48076
     /*  48076 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(48164), // Rule ID 13572 //
     /*  48081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48133 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48137 */     // MIs[3] Operand 1
     /*  48137 */     // No operand predicates
     /*  48137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48144 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48162 */     GIR_RootConstrainSelectedInstOperands,
     /*  48163 */     // GIR_Coverage, 13572,
     /*  48163 */     GIR_EraseRootFromParent_Done,
     /*  48164 */   // Label 728: @48164
     /*  48164 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(48252), // Rule ID 2044 //
     /*  48169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48226 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48230 */     // MIs[3] Operand 1
     /*  48230 */     // No operand predicates
     /*  48230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48232 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48250 */     GIR_RootConstrainSelectedInstOperands,
     /*  48251 */     // GIR_Coverage, 2044,
     /*  48251 */     GIR_EraseRootFromParent_Done,
     /*  48252 */   // Label 729: @48252
     /*  48252 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(48340), // Rule ID 13602 //
     /*  48257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48309 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48313 */     // MIs[3] Operand 1
     /*  48313 */     // No operand predicates
     /*  48313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48320 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48338 */     GIR_RootConstrainSelectedInstOperands,
     /*  48339 */     // GIR_Coverage, 13602,
     /*  48339 */     GIR_EraseRootFromParent_Done,
     /*  48340 */   // Label 730: @48340
     /*  48340 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(48428), // Rule ID 2096 //
     /*  48345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48402 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48406 */     // MIs[3] Operand 1
     /*  48406 */     // No operand predicates
     /*  48406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48408 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48426 */     GIR_RootConstrainSelectedInstOperands,
     /*  48427 */     // GIR_Coverage, 2096,
     /*  48427 */     GIR_EraseRootFromParent_Done,
     /*  48428 */   // Label 731: @48428
     /*  48428 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(48475), // Rule ID 1863 //
     /*  48433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48461 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48473 */     GIR_RootConstrainSelectedInstOperands,
     /*  48474 */     // GIR_Coverage, 1863,
     /*  48474 */     GIR_EraseRootFromParent_Done,
     /*  48475 */   // Label 732: @48475
     /*  48475 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(48522), // Rule ID 1763 //
     /*  48480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48508 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  48511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48520 */     GIR_RootConstrainSelectedInstOperands,
     /*  48521 */     // GIR_Coverage, 1763,
     /*  48521 */     GIR_EraseRootFromParent_Done,
     /*  48522 */   // Label 733: @48522
     /*  48522 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(48569), // Rule ID 1862 //
     /*  48527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48555 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48567 */     GIR_RootConstrainSelectedInstOperands,
     /*  48568 */     // GIR_Coverage, 1862,
     /*  48568 */     GIR_EraseRootFromParent_Done,
     /*  48569 */   // Label 734: @48569
     /*  48569 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(48628), // Rule ID 1843 //
     /*  48574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48613 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48626 */     GIR_RootConstrainSelectedInstOperands,
     /*  48627 */     // GIR_Coverage, 1843,
     /*  48627 */     GIR_EraseRootFromParent_Done,
     /*  48628 */   // Label 735: @48628
     /*  48628 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(48687), // Rule ID 1842 //
     /*  48633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48672 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48685 */     GIR_RootConstrainSelectedInstOperands,
     /*  48686 */     // GIR_Coverage, 1842,
     /*  48686 */     GIR_EraseRootFromParent_Done,
     /*  48687 */   // Label 736: @48687
     /*  48687 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(48746), // Rule ID 1756 //
     /*  48692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48731 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  48734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48744 */     GIR_RootConstrainSelectedInstOperands,
     /*  48745 */     // GIR_Coverage, 1756,
     /*  48745 */     GIR_EraseRootFromParent_Done,
     /*  48746 */   // Label 737: @48746
     /*  48746 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(48805), // Rule ID 1841 //
     /*  48751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48790 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48803 */     GIR_RootConstrainSelectedInstOperands,
     /*  48804 */     // GIR_Coverage, 1841,
     /*  48804 */     GIR_EraseRootFromParent_Done,
     /*  48805 */   // Label 738: @48805
     /*  48805 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(48864), // Rule ID 1840 //
     /*  48810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48849 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48862 */     GIR_RootConstrainSelectedInstOperands,
     /*  48863 */     // GIR_Coverage, 1840,
     /*  48863 */     GIR_EraseRootFromParent_Done,
     /*  48864 */   // Label 739: @48864
     /*  48864 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(48899), // Rule ID 970 //
     /*  48869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48876 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48882 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  48884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48890 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  48890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  48893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48897 */     GIR_RootConstrainSelectedInstOperands,
     /*  48898 */     // GIR_Coverage, 970,
     /*  48898 */     GIR_EraseRootFromParent_Done,
     /*  48899 */   // Label 740: @48899
     /*  48899 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(48956), // Rule ID 1732 //
     /*  48904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48939 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  48942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  48954 */     GIR_RootConstrainSelectedInstOperands,
     /*  48955 */     // GIR_Coverage, 1732,
     /*  48955 */     GIR_EraseRootFromParent_Done,
     /*  48956 */   // Label 741: @48956
     /*  48956 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(49013), // Rule ID 1822 //
     /*  48961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48996 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  48999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  49011 */     GIR_RootConstrainSelectedInstOperands,
     /*  49012 */     // GIR_Coverage, 1822,
     /*  49012 */     GIR_EraseRootFromParent_Done,
     /*  49013 */   // Label 742: @49013
     /*  49013 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(49057), // Rule ID 1861 //
     /*  49018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49044 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49055 */     GIR_RootConstrainSelectedInstOperands,
     /*  49056 */     // GIR_Coverage, 1861,
     /*  49056 */     GIR_EraseRootFromParent_Done,
     /*  49057 */   // Label 743: @49057
     /*  49057 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(49101), // Rule ID 1762 //
     /*  49062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49088 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  49091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49099 */     GIR_RootConstrainSelectedInstOperands,
     /*  49100 */     // GIR_Coverage, 1762,
     /*  49100 */     GIR_EraseRootFromParent_Done,
     /*  49101 */   // Label 744: @49101
     /*  49101 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(49145), // Rule ID 1860 //
     /*  49106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49132 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49143 */     GIR_RootConstrainSelectedInstOperands,
     /*  49144 */     // GIR_Coverage, 1860,
     /*  49144 */     GIR_EraseRootFromParent_Done,
     /*  49145 */   // Label 745: @49145
     /*  49145 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(49168), // Rule ID 1477 //
     /*  49150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49161 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  49161 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  49166 */     GIR_RootConstrainSelectedInstOperands,
     /*  49167 */     // GIR_Coverage, 1477,
     /*  49167 */     GIR_Done,
     /*  49168 */   // Label 746: @49168
     /*  49168 */   GIM_Reject,
     /*  49169 */ // Label 712: @49169
     /*  49169 */ GIM_Reject,
     /*  49170 */ // Label 590: @49170
     /*  49170 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(49244),
     /*  49175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49185 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(49220), // Rule ID 965 //
     /*  49190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49197 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  49203 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  49205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49211 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  49211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  49214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49218 */     GIR_RootConstrainSelectedInstOperands,
     /*  49219 */     // GIR_Coverage, 965,
     /*  49219 */     GIR_EraseRootFromParent_Done,
     /*  49220 */   // Label 748: @49220
     /*  49220 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(49243), // Rule ID 1472 //
     /*  49225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49236 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  49241 */     GIR_RootConstrainSelectedInstOperands,
     /*  49242 */     // GIR_Coverage, 1472,
     /*  49242 */     GIR_Done,
     /*  49243 */   // Label 749: @49243
     /*  49243 */   GIM_Reject,
     /*  49244 */ // Label 747: @49244
     /*  49244 */ GIM_Reject,
     /*  49245 */ // Label 591: @49245
     /*  49245 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(50452),
     /*  49250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49260 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(49325), // Rule ID 1839 //
     /*  49265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49294 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49301 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49308 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49323 */     GIR_RootConstrainSelectedInstOperands,
     /*  49324 */     // GIR_Coverage, 1839,
     /*  49324 */     GIR_EraseRootFromParent_Done,
     /*  49325 */   // Label 751: @49325
     /*  49325 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(49390), // Rule ID 1838 //
     /*  49330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49359 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49373 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49388 */     GIR_RootConstrainSelectedInstOperands,
     /*  49389 */     // GIR_Coverage, 1838,
     /*  49389 */     GIR_EraseRootFromParent_Done,
     /*  49390 */   // Label 752: @49390
     /*  49390 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(49455), // Rule ID 1755 //
     /*  49395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49431 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49438 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  49441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49453 */     GIR_RootConstrainSelectedInstOperands,
     /*  49454 */     // GIR_Coverage, 1755,
     /*  49454 */     GIR_EraseRootFromParent_Done,
     /*  49455 */   // Label 753: @49455
     /*  49455 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(49520), // Rule ID 1837 //
     /*  49460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49503 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49518 */     GIR_RootConstrainSelectedInstOperands,
     /*  49519 */     // GIR_Coverage, 1837,
     /*  49519 */     GIR_EraseRootFromParent_Done,
     /*  49520 */   // Label 754: @49520
     /*  49520 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(49585), // Rule ID 1836 //
     /*  49525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49561 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49568 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49583 */     GIR_RootConstrainSelectedInstOperands,
     /*  49584 */     // GIR_Coverage, 1836,
     /*  49584 */     GIR_EraseRootFromParent_Done,
     /*  49585 */   // Label 755: @49585
     /*  49585 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(49648), // Rule ID 1731 //
     /*  49590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49615 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49629 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  49632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49646 */     GIR_RootConstrainSelectedInstOperands,
     /*  49647 */     // GIR_Coverage, 1731,
     /*  49647 */     GIR_EraseRootFromParent_Done,
     /*  49648 */   // Label 756: @49648
     /*  49648 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(49711), // Rule ID 1821 //
     /*  49653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49692 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  49695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49709 */     GIR_RootConstrainSelectedInstOperands,
     /*  49710 */     // GIR_Coverage, 1821,
     /*  49710 */     GIR_EraseRootFromParent_Done,
     /*  49711 */   // Label 757: @49711
     /*  49711 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(49758), // Rule ID 1859 //
     /*  49716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49744 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49756 */     GIR_RootConstrainSelectedInstOperands,
     /*  49757 */     // GIR_Coverage, 1859,
     /*  49757 */     GIR_EraseRootFromParent_Done,
     /*  49758 */   // Label 758: @49758
     /*  49758 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(49805), // Rule ID 1761 //
     /*  49763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49791 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  49794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49803 */     GIR_RootConstrainSelectedInstOperands,
     /*  49804 */     // GIR_Coverage, 1761,
     /*  49804 */     GIR_EraseRootFromParent_Done,
     /*  49805 */   // Label 759: @49805
     /*  49805 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(49852), // Rule ID 1858 //
     /*  49810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49838 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49843 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49850 */     GIR_RootConstrainSelectedInstOperands,
     /*  49851 */     // GIR_Coverage, 1858,
     /*  49851 */     GIR_EraseRootFromParent_Done,
     /*  49852 */   // Label 760: @49852
     /*  49852 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(49911), // Rule ID 1835 //
     /*  49857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49896 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49909 */     GIR_RootConstrainSelectedInstOperands,
     /*  49910 */     // GIR_Coverage, 1835,
     /*  49910 */     GIR_EraseRootFromParent_Done,
     /*  49911 */   // Label 761: @49911
     /*  49911 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(49970), // Rule ID 1834 //
     /*  49916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49955 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  49958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49968 */     GIR_RootConstrainSelectedInstOperands,
     /*  49969 */     // GIR_Coverage, 1834,
     /*  49969 */     GIR_EraseRootFromParent_Done,
     /*  49970 */   // Label 762: @49970
     /*  49970 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(50029), // Rule ID 1754 //
     /*  49975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50007 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50014 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  50017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50027 */     GIR_RootConstrainSelectedInstOperands,
     /*  50028 */     // GIR_Coverage, 1754,
     /*  50028 */     GIR_EraseRootFromParent_Done,
     /*  50029 */   // Label 763: @50029
     /*  50029 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(50088), // Rule ID 1833 //
     /*  50034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50073 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50086 */     GIR_RootConstrainSelectedInstOperands,
     /*  50087 */     // GIR_Coverage, 1833,
     /*  50087 */     GIR_EraseRootFromParent_Done,
     /*  50088 */   // Label 764: @50088
     /*  50088 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(50147), // Rule ID 1832 //
     /*  50093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50132 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50145 */     GIR_RootConstrainSelectedInstOperands,
     /*  50146 */     // GIR_Coverage, 1832,
     /*  50146 */     GIR_EraseRootFromParent_Done,
     /*  50147 */   // Label 765: @50147
     /*  50147 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(50182), // Rule ID 968 //
     /*  50152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50159 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50165 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50173 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  50173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  50176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50180 */     GIR_RootConstrainSelectedInstOperands,
     /*  50181 */     // GIR_Coverage, 968,
     /*  50181 */     GIR_EraseRootFromParent_Done,
     /*  50182 */   // Label 766: @50182
     /*  50182 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(50239), // Rule ID 1730 //
     /*  50187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50222 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  50225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50237 */     GIR_RootConstrainSelectedInstOperands,
     /*  50238 */     // GIR_Coverage, 1730,
     /*  50238 */     GIR_EraseRootFromParent_Done,
     /*  50239 */   // Label 767: @50239
     /*  50239 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(50296), // Rule ID 1820 //
     /*  50244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50279 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  50282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50294 */     GIR_RootConstrainSelectedInstOperands,
     /*  50295 */     // GIR_Coverage, 1820,
     /*  50295 */     GIR_EraseRootFromParent_Done,
     /*  50296 */   // Label 768: @50296
     /*  50296 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(50340), // Rule ID 1857 //
     /*  50301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50327 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50338 */     GIR_RootConstrainSelectedInstOperands,
     /*  50339 */     // GIR_Coverage, 1857,
     /*  50339 */     GIR_EraseRootFromParent_Done,
     /*  50340 */   // Label 769: @50340
     /*  50340 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(50384), // Rule ID 1760 //
     /*  50345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50371 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  50374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50382 */     GIR_RootConstrainSelectedInstOperands,
     /*  50383 */     // GIR_Coverage, 1760,
     /*  50383 */     GIR_EraseRootFromParent_Done,
     /*  50384 */   // Label 770: @50384
     /*  50384 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(50428), // Rule ID 1856 //
     /*  50389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50415 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50426 */     GIR_RootConstrainSelectedInstOperands,
     /*  50427 */     // GIR_Coverage, 1856,
     /*  50427 */     GIR_EraseRootFromParent_Done,
     /*  50428 */   // Label 771: @50428
     /*  50428 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(50451), // Rule ID 1475 //
     /*  50433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50444 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  50444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  50449 */     GIR_RootConstrainSelectedInstOperands,
     /*  50450 */     // GIR_Coverage, 1475,
     /*  50450 */     GIR_Done,
     /*  50451 */   // Label 772: @50451
     /*  50451 */   GIM_Reject,
     /*  50452 */ // Label 750: @50452
     /*  50452 */ GIM_Reject,
     /*  50453 */ // Label 592: @50453
     /*  50453 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(50527),
     /*  50458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50468 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(50503), // Rule ID 966 //
     /*  50473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50480 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50486 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50494 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  50494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  50497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50501 */     GIR_RootConstrainSelectedInstOperands,
     /*  50502 */     // GIR_Coverage, 966,
     /*  50502 */     GIR_EraseRootFromParent_Done,
     /*  50503 */   // Label 774: @50503
     /*  50503 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(50526), // Rule ID 1473 //
     /*  50508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50519 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  50524 */     GIR_RootConstrainSelectedInstOperands,
     /*  50525 */     // GIR_Coverage, 1473,
     /*  50525 */     GIR_Done,
     /*  50526 */   // Label 775: @50526
     /*  50526 */   GIM_Reject,
     /*  50527 */ // Label 773: @50527
     /*  50527 */ GIM_Reject,
     /*  50528 */ // Label 593: @50528
     /*  50528 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(50553), // Rule ID 7505 //
     /*  50533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  50539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  50542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50546 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  50546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  50551 */   GIR_RootConstrainSelectedInstOperands,
     /*  50552 */   // GIR_Coverage, 7505,
     /*  50552 */   GIR_Done,
     /*  50553 */ // Label 776: @50553
     /*  50553 */ GIM_Reject,
     /*  50554 */ // Label 594: @50554
     /*  50554 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(50579), // Rule ID 7504 //
     /*  50559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  50565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  50568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50572 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  50572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  50577 */   GIR_RootConstrainSelectedInstOperands,
     /*  50578 */   // GIR_Coverage, 7504,
     /*  50578 */   GIR_Done,
     /*  50579 */ // Label 777: @50579
     /*  50579 */ GIM_Reject,
     /*  50580 */ // Label 595: @50580
     /*  50580 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(50605), // Rule ID 7503 //
     /*  50585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  50591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  50594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50598 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  50598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  50603 */   GIR_RootConstrainSelectedInstOperands,
     /*  50604 */   // GIR_Coverage, 7503,
     /*  50604 */   GIR_Done,
     /*  50605 */ // Label 778: @50605
     /*  50605 */ GIM_Reject,
     /*  50606 */ // Label 596: @50606
     /*  50606 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(50631), // Rule ID 7502 //
     /*  50611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  50617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  50620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50624 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  50624 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  50629 */   GIR_RootConstrainSelectedInstOperands,
     /*  50630 */   // GIR_Coverage, 7502,
     /*  50630 */   GIR_Done,
     /*  50631 */ // Label 779: @50631
     /*  50631 */ GIM_Reject,
     /*  50632 */ // Label 597: @50632
     /*  50632 */ GIM_Reject,
     /*  50633 */ // Label 2: @50633
     /*  50633 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 788*/ GIMT_Encode4(53153),
     /*  50644 */ /*GILLT_s32*//*Label 780*/ GIMT_Encode4(50684),
     /*  50648 */ /*GILLT_s64*//*Label 781*/ GIMT_Encode4(50841), GIMT_Encode4(0),
     /*  50656 */ /*GILLT_v2s32*//*Label 782*/ GIMT_Encode4(52077), GIMT_Encode4(0),
     /*  50664 */ /*GILLT_v4s16*//*Label 783*/ GIMT_Encode4(52415),
     /*  50668 */ /*GILLT_v4s32*//*Label 784*/ GIMT_Encode4(52753),
     /*  50672 */ /*GILLT_v8s8*//*Label 785*/ GIMT_Encode4(52919),
     /*  50676 */ /*GILLT_v8s16*//*Label 786*/ GIMT_Encode4(52953),
     /*  50680 */ /*GILLT_v16s8*//*Label 787*/ GIMT_Encode4(53119),
     /*  50684 */ // Label 780: @50684
     /*  50684 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(50840),
     /*  50689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  50695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50699 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(50754), // Rule ID 3955 //
     /*  50704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50720 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50735 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50752 */     GIR_RootConstrainSelectedInstOperands,
     /*  50753 */     // GIR_Coverage, 3955,
     /*  50753 */     GIR_EraseRootFromParent_Done,
     /*  50754 */   // Label 790: @50754
     /*  50754 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(50809), // Rule ID 13856 //
     /*  50759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50779 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50790 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  50801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50807 */     GIR_RootConstrainSelectedInstOperands,
     /*  50808 */     // GIR_Coverage, 13856,
     /*  50808 */     GIR_EraseRootFromParent_Done,
     /*  50809 */   // Label 791: @50809
     /*  50809 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(50839), // Rule ID 3951 //
     /*  50814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50822 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  50825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50837 */     GIR_RootConstrainSelectedInstOperands,
     /*  50838 */     // GIR_Coverage, 3951,
     /*  50838 */     GIR_EraseRootFromParent_Done,
     /*  50839 */   // Label 792: @50839
     /*  50839 */   GIM_Reject,
     /*  50840 */ // Label 789: @50840
     /*  50840 */ GIM_Reject,
     /*  50841 */ // Label 781: @50841
     /*  50841 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(52076),
     /*  50846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  50852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50856 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(51002), // Rule ID 3960 //
     /*  50861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  50873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50882 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  50893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  50901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  50905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  50909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50914 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  50925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50927 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  50927 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  50930 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50934 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50939 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  50945 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50950 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50967 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  50973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  50983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  50986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  50991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  50994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51000 */     GIR_RootConstrainSelectedInstOperands,
     /*  51001 */     // GIR_Coverage, 3960,
     /*  51001 */     GIR_EraseRootFromParent_Done,
     /*  51002 */   // Label 794: @51002
     /*  51002 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(51106), // Rule ID 3961 //
     /*  51007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51028 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51058 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51070 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51104 */     GIR_RootConstrainSelectedInstOperands,
     /*  51105 */     // GIR_Coverage, 3961,
     /*  51105 */     GIR_EraseRootFromParent_Done,
     /*  51106 */   // Label 795: @51106
     /*  51106 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(51210), // Rule ID 13859 //
     /*  51111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  51136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51149 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  51160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51162 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51174 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51208 */     GIR_RootConstrainSelectedInstOperands,
     /*  51209 */     // GIR_Coverage, 13859,
     /*  51209 */     GIR_EraseRootFromParent_Done,
     /*  51210 */   // Label 796: @51210
     /*  51210 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(51265), // Rule ID 3956 //
     /*  51215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51231 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51246 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51263 */     GIR_RootConstrainSelectedInstOperands,
     /*  51264 */     // GIR_Coverage, 3956,
     /*  51264 */     GIR_EraseRootFromParent_Done,
     /*  51265 */   // Label 797: @51265
     /*  51265 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(51320), // Rule ID 13857 //
     /*  51270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51290 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51301 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  51312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51318 */     GIR_RootConstrainSelectedInstOperands,
     /*  51319 */     // GIR_Coverage, 13857,
     /*  51319 */     GIR_EraseRootFromParent_Done,
     /*  51320 */   // Label 798: @51320
     /*  51320 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(51433), // Rule ID 3967 //
     /*  51325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51342 */     // MIs[1] Operand 2
     /*  51342 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51361 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51365 */     // MIs[2] Operand 1
     /*  51365 */     // No operand predicates
     /*  51365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51367 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51379 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51398 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51431 */     GIR_RootConstrainSelectedInstOperands,
     /*  51432 */     // GIR_Coverage, 3967,
     /*  51432 */     GIR_EraseRootFromParent_Done,
     /*  51433 */   // Label 799: @51433
     /*  51433 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(51508), // Rule ID 3965 //
     /*  51438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51463 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51467 */     // MIs[2] Operand 1
     /*  51467 */     // No operand predicates
     /*  51467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51469 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51481 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51506 */     GIR_RootConstrainSelectedInstOperands,
     /*  51507 */     // GIR_Coverage, 3965,
     /*  51507 */     GIR_EraseRootFromParent_Done,
     /*  51508 */   // Label 800: @51508
     /*  51508 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(51583), // Rule ID 3966 //
     /*  51513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51538 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  51542 */     // MIs[2] Operand 1
     /*  51542 */     // No operand predicates
     /*  51542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51544 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51556 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51581 */     GIR_RootConstrainSelectedInstOperands,
     /*  51582 */     // GIR_Coverage, 3966,
     /*  51582 */     GIR_EraseRootFromParent_Done,
     /*  51583 */   // Label 801: @51583
     /*  51583 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(51721), // Rule ID 3957 //
     /*  51588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51605 */     // MIs[1] Operand 2
     /*  51605 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51633 */     // MIs[2] Operand 2
     /*  51633 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  51644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51646 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  51646 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51649 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51653 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51658 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  51664 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51669 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51686 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51719 */     GIR_RootConstrainSelectedInstOperands,
     /*  51720 */     // GIR_Coverage, 3957,
     /*  51720 */     GIR_EraseRootFromParent_Done,
     /*  51721 */   // Label 802: @51721
     /*  51721 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(51821), // Rule ID 3958 //
     /*  51726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51743 */     // MIs[1] Operand 2
     /*  51743 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51773 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51785 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51819 */     GIR_RootConstrainSelectedInstOperands,
     /*  51820 */     // GIR_Coverage, 3958,
     /*  51820 */     GIR_EraseRootFromParent_Done,
     /*  51821 */   // Label 803: @51821
     /*  51821 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(51921), // Rule ID 13858 //
     /*  51826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  51855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51860 */     // MIs[2] Operand 2
     /*  51860 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  51871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51873 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51885 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51919 */     GIR_RootConstrainSelectedInstOperands,
     /*  51920 */     // GIR_Coverage, 13858,
     /*  51920 */     GIR_EraseRootFromParent_Done,
     /*  51921 */   // Label 804: @51921
     /*  51921 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(51983), // Rule ID 3959 //
     /*  51926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51962 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51981 */     GIR_RootConstrainSelectedInstOperands,
     /*  51982 */     // GIR_Coverage, 3959,
     /*  51982 */     GIR_EraseRootFromParent_Done,
     /*  51983 */   // Label 805: @51983
     /*  51983 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(52045), // Rule ID 3962 //
     /*  51988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  52017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52024 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  52024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52043 */     GIR_RootConstrainSelectedInstOperands,
     /*  52044 */     // GIR_Coverage, 3962,
     /*  52044 */     GIR_EraseRootFromParent_Done,
     /*  52045 */   // Label 806: @52045
     /*  52045 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(52075), // Rule ID 3952 //
     /*  52050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52058 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  52058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  52061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  52067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52073 */     GIR_RootConstrainSelectedInstOperands,
     /*  52074 */     // GIR_Coverage, 3952,
     /*  52074 */     GIR_EraseRootFromParent_Done,
     /*  52075 */   // Label 807: @52075
     /*  52075 */   GIM_Reject,
     /*  52076 */ // Label 793: @52076
     /*  52076 */ GIM_Reject,
     /*  52077 */ // Label 782: @52077
     /*  52077 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(52414),
     /*  52082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  52085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52092 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(52178), // Rule ID 13550 //
     /*  52097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52128 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52141 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52145 */     // MIs[3] Operand 1
     /*  52145 */     // No operand predicates
     /*  52145 */     // MIs[1] Operand 2
     /*  52145 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52160 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52162 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52176 */     GIR_RootConstrainSelectedInstOperands,
     /*  52177 */     // GIR_Coverage, 13550,
     /*  52177 */     GIR_EraseRootFromParent_Done,
     /*  52178 */   // Label 809: @52178
     /*  52178 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(52264), // Rule ID 2034 //
     /*  52183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52223 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52227 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52231 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52235 */     // MIs[3] Operand 1
     /*  52235 */     // No operand predicates
     /*  52235 */     // MIs[1] Operand 2
     /*  52235 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52246 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52248 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52262 */     GIR_RootConstrainSelectedInstOperands,
     /*  52263 */     // GIR_Coverage, 2034,
     /*  52263 */     GIR_EraseRootFromParent_Done,
     /*  52264 */   // Label 810: @52264
     /*  52264 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(52327), // Rule ID 13551 //
     /*  52269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52301 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52305 */     // MIs[2] Operand 1
     /*  52305 */     // No operand predicates
     /*  52305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52311 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52325 */     GIR_RootConstrainSelectedInstOperands,
     /*  52326 */     // GIR_Coverage, 13551,
     /*  52326 */     GIR_EraseRootFromParent_Done,
     /*  52327 */   // Label 811: @52327
     /*  52327 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(52390), // Rule ID 2035 //
     /*  52332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52368 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52372 */     // MIs[2] Operand 1
     /*  52372 */     // No operand predicates
     /*  52372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52374 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  52377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52388 */     GIR_RootConstrainSelectedInstOperands,
     /*  52389 */     // GIR_Coverage, 2035,
     /*  52389 */     GIR_EraseRootFromParent_Done,
     /*  52390 */   // Label 812: @52390
     /*  52390 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(52413), // Rule ID 1352 //
     /*  52395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52406 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  52406 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  52411 */     GIR_RootConstrainSelectedInstOperands,
     /*  52412 */     // GIR_Coverage, 1352,
     /*  52412 */     GIR_Done,
     /*  52413 */   // Label 813: @52413
     /*  52413 */   GIM_Reject,
     /*  52414 */ // Label 808: @52414
     /*  52414 */ GIM_Reject,
     /*  52415 */ // Label 783: @52415
     /*  52415 */ GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(52752),
     /*  52420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  52423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52430 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(52516), // Rule ID 13547 //
     /*  52435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52479 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52483 */     // MIs[3] Operand 1
     /*  52483 */     // No operand predicates
     /*  52483 */     // MIs[1] Operand 2
     /*  52483 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52500 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52514 */     GIR_RootConstrainSelectedInstOperands,
     /*  52515 */     // GIR_Coverage, 13547,
     /*  52515 */     GIR_EraseRootFromParent_Done,
     /*  52516 */   // Label 815: @52516
     /*  52516 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(52602), // Rule ID 2031 //
     /*  52521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52573 */     // MIs[3] Operand 1
     /*  52573 */     // No operand predicates
     /*  52573 */     // MIs[1] Operand 2
     /*  52573 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52584 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52586 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52600 */     GIR_RootConstrainSelectedInstOperands,
     /*  52601 */     // GIR_Coverage, 2031,
     /*  52601 */     GIR_EraseRootFromParent_Done,
     /*  52602 */   // Label 816: @52602
     /*  52602 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(52665), // Rule ID 13548 //
     /*  52607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52639 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52643 */     // MIs[2] Operand 1
     /*  52643 */     // No operand predicates
     /*  52643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52649 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52663 */     GIR_RootConstrainSelectedInstOperands,
     /*  52664 */     // GIR_Coverage, 13548,
     /*  52664 */     GIR_EraseRootFromParent_Done,
     /*  52665 */   // Label 817: @52665
     /*  52665 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(52728), // Rule ID 2032 //
     /*  52670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52706 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52710 */     // MIs[2] Operand 1
     /*  52710 */     // No operand predicates
     /*  52710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52712 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52726 */     GIR_RootConstrainSelectedInstOperands,
     /*  52727 */     // GIR_Coverage, 2032,
     /*  52727 */     GIR_EraseRootFromParent_Done,
     /*  52728 */   // Label 818: @52728
     /*  52728 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(52751), // Rule ID 1350 //
     /*  52733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52744 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  52744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  52749 */     GIR_RootConstrainSelectedInstOperands,
     /*  52750 */     // GIR_Coverage, 1350,
     /*  52750 */     GIR_Done,
     /*  52751 */   // Label 819: @52751
     /*  52751 */   GIM_Reject,
     /*  52752 */ // Label 814: @52752
     /*  52752 */ GIM_Reject,
     /*  52753 */ // Label 784: @52753
     /*  52753 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(52918),
     /*  52758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52768 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(52831), // Rule ID 13552 //
     /*  52773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52805 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52809 */     // MIs[2] Operand 1
     /*  52809 */     // No operand predicates
     /*  52809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52815 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52829 */     GIR_RootConstrainSelectedInstOperands,
     /*  52830 */     // GIR_Coverage, 13552,
     /*  52830 */     GIR_EraseRootFromParent_Done,
     /*  52831 */   // Label 821: @52831
     /*  52831 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(52894), // Rule ID 2036 //
     /*  52836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52872 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52876 */     // MIs[2] Operand 1
     /*  52876 */     // No operand predicates
     /*  52876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52878 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52892 */     GIR_RootConstrainSelectedInstOperands,
     /*  52893 */     // GIR_Coverage, 2036,
     /*  52893 */     GIR_EraseRootFromParent_Done,
     /*  52894 */   // Label 822: @52894
     /*  52894 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(52917), // Rule ID 1353 //
     /*  52899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52910 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  52910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  52915 */     GIR_RootConstrainSelectedInstOperands,
     /*  52916 */     // GIR_Coverage, 1353,
     /*  52916 */     GIR_Done,
     /*  52917 */   // Label 823: @52917
     /*  52917 */   GIM_Reject,
     /*  52918 */ // Label 820: @52918
     /*  52918 */ GIM_Reject,
     /*  52919 */ // Label 785: @52919
     /*  52919 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(52952), // Rule ID 1348 //
     /*  52924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52945 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  52950 */   GIR_RootConstrainSelectedInstOperands,
     /*  52951 */   // GIR_Coverage, 1348,
     /*  52951 */   GIR_Done,
     /*  52952 */ // Label 824: @52952
     /*  52952 */ GIM_Reject,
     /*  52953 */ // Label 786: @52953
     /*  52953 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(53118),
     /*  52958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52968 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(53031), // Rule ID 13549 //
     /*  52973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53005 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53009 */     // MIs[2] Operand 1
     /*  53009 */     // No operand predicates
     /*  53009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53015 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  53018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53029 */     GIR_RootConstrainSelectedInstOperands,
     /*  53030 */     // GIR_Coverage, 13549,
     /*  53030 */     GIR_EraseRootFromParent_Done,
     /*  53031 */   // Label 826: @53031
     /*  53031 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(53094), // Rule ID 2033 //
     /*  53036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  53051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  53064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53072 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53076 */     // MIs[2] Operand 1
     /*  53076 */     // No operand predicates
     /*  53076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53078 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  53081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53092 */     GIR_RootConstrainSelectedInstOperands,
     /*  53093 */     // GIR_Coverage, 2033,
     /*  53093 */     GIR_EraseRootFromParent_Done,
     /*  53094 */   // Label 827: @53094
     /*  53094 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(53117), // Rule ID 1351 //
     /*  53099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53110 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  53110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  53115 */     GIR_RootConstrainSelectedInstOperands,
     /*  53116 */     // GIR_Coverage, 1351,
     /*  53116 */     GIR_Done,
     /*  53117 */   // Label 828: @53117
     /*  53117 */   GIM_Reject,
     /*  53118 */ // Label 825: @53118
     /*  53118 */ GIM_Reject,
     /*  53119 */ // Label 787: @53119
     /*  53119 */ GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(53152), // Rule ID 1349 //
     /*  53124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  53133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53145 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  53145 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  53150 */   GIR_RootConstrainSelectedInstOperands,
     /*  53151 */   // GIR_Coverage, 1349,
     /*  53151 */   GIR_Done,
     /*  53152 */ // Label 829: @53152
     /*  53152 */ GIM_Reject,
     /*  53153 */ // Label 788: @53153
     /*  53153 */ GIM_Reject,
     /*  53154 */ // Label 3: @53154
     /*  53154 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 832*/ GIMT_Encode4(53235),
     /*  53165 */ /*GILLT_s32*//*Label 830*/ GIMT_Encode4(53173),
     /*  53169 */ /*GILLT_s64*//*Label 831*/ GIMT_Encode4(53204),
     /*  53173 */ // Label 830: @53173
     /*  53173 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(53203), // Rule ID 117 //
     /*  53178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53196 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  53201 */   GIR_RootConstrainSelectedInstOperands,
     /*  53202 */   // GIR_Coverage, 117,
     /*  53202 */   GIR_Done,
     /*  53203 */ // Label 833: @53203
     /*  53203 */ GIM_Reject,
     /*  53204 */ // Label 831: @53204
     /*  53204 */ GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(53234), // Rule ID 118 //
     /*  53209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53227 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  53227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  53232 */   GIR_RootConstrainSelectedInstOperands,
     /*  53233 */   // GIR_Coverage, 118,
     /*  53233 */   GIR_Done,
     /*  53234 */ // Label 834: @53234
     /*  53234 */ GIM_Reject,
     /*  53235 */ // Label 832: @53235
     /*  53235 */ GIM_Reject,
     /*  53236 */ // Label 4: @53236
     /*  53236 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 837*/ GIMT_Encode4(53317),
     /*  53247 */ /*GILLT_s32*//*Label 835*/ GIMT_Encode4(53255),
     /*  53251 */ /*GILLT_s64*//*Label 836*/ GIMT_Encode4(53286),
     /*  53255 */ // Label 835: @53255
     /*  53255 */ GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(53285), // Rule ID 115 //
     /*  53260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53278 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  53283 */   GIR_RootConstrainSelectedInstOperands,
     /*  53284 */   // GIR_Coverage, 115,
     /*  53284 */   GIR_Done,
     /*  53285 */ // Label 838: @53285
     /*  53285 */ GIM_Reject,
     /*  53286 */ // Label 836: @53286
     /*  53286 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(53316), // Rule ID 116 //
     /*  53291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53309 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  53309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  53314 */   GIR_RootConstrainSelectedInstOperands,
     /*  53315 */   // GIR_Coverage, 116,
     /*  53315 */   GIR_Done,
     /*  53316 */ // Label 839: @53316
     /*  53316 */ GIM_Reject,
     /*  53317 */ // Label 837: @53317
     /*  53317 */ GIM_Reject,
     /*  53318 */ // Label 5: @53318
     /*  53318 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 858*/ GIMT_Encode4(61063),
     /*  53329 */ /*GILLT_s32*//*Label 840*/ GIMT_Encode4(53417),
     /*  53333 */ /*GILLT_s64*//*Label 841*/ GIMT_Encode4(53915), GIMT_Encode4(0),
     /*  53341 */ /*GILLT_v2s32*//*Label 842*/ GIMT_Encode4(55350),
     /*  53345 */ /*GILLT_v2s64*//*Label 843*/ GIMT_Encode4(55510),
     /*  53349 */ /*GILLT_v4s16*//*Label 844*/ GIMT_Encode4(55670),
     /*  53353 */ /*GILLT_v4s32*//*Label 845*/ GIMT_Encode4(55830),
     /*  53357 */ /*GILLT_v8s8*//*Label 846*/ GIMT_Encode4(55990),
     /*  53361 */ /*GILLT_v8s16*//*Label 847*/ GIMT_Encode4(56150),
     /*  53365 */ /*GILLT_v16s8*//*Label 848*/ GIMT_Encode4(56310),
     /*  53369 */ /*GILLT_nxv1s1*//*Label 849*/ GIMT_Encode4(56470),
     /*  53373 */ /*GILLT_nxv2s1*//*Label 850*/ GIMT_Encode4(57011), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  53385 */ /*GILLT_nxv2s64*//*Label 851*/ GIMT_Encode4(57552),
     /*  53389 */ /*GILLT_nxv4s1*//*Label 852*/ GIMT_Encode4(58024), GIMT_Encode4(0),
     /*  53397 */ /*GILLT_nxv4s32*//*Label 853*/ GIMT_Encode4(58565),
     /*  53401 */ /*GILLT_nxv8s1*//*Label 854*/ GIMT_Encode4(59037),
     /*  53405 */ /*GILLT_nxv8s16*//*Label 855*/ GIMT_Encode4(59578),
     /*  53409 */ /*GILLT_nxv16s1*//*Label 856*/ GIMT_Encode4(60050),
     /*  53413 */ /*GILLT_nxv16s8*//*Label 857*/ GIMT_Encode4(60591),
     /*  53417 */ // Label 840: @53417
     /*  53417 */ GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(53914),
     /*  53422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53428 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(53483), // Rule ID 13309 //
     /*  53433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53453 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53463 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53470 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  53473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53477 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53481 */     GIR_RootConstrainSelectedInstOperands,
     /*  53482 */     // GIR_Coverage, 13309,
     /*  53482 */     GIR_EraseRootFromParent_Done,
     /*  53483 */   // Label 860: @53483
     /*  53483 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53538), // Rule ID 162 //
     /*  53488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53512 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53518 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53525 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  53528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53532 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53536 */     GIR_RootConstrainSelectedInstOperands,
     /*  53537 */     // GIR_Coverage, 162,
     /*  53537 */     GIR_EraseRootFromParent_Done,
     /*  53538 */   // Label 861: @53538
     /*  53538 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53607), // Rule ID 5696 //
     /*  53543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  53580 */     // MIs[2] Operand 1
     /*  53580 */     // No operand predicates
     /*  53580 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53593 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  53593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  53596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53605 */     GIR_RootConstrainSelectedInstOperands,
     /*  53606 */     // GIR_Coverage, 5696,
     /*  53606 */     GIR_EraseRootFromParent_Done,
     /*  53607 */   // Label 862: @53607
     /*  53607 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53676), // Rule ID 5697 //
     /*  53612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53645 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53649 */     // MIs[2] Operand 1
     /*  53649 */     // No operand predicates
     /*  53649 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53662 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  53662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  53665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53674 */     GIR_RootConstrainSelectedInstOperands,
     /*  53675 */     // GIR_Coverage, 5697,
     /*  53675 */     GIR_EraseRootFromParent_Done,
     /*  53676 */   // Label 863: @53676
     /*  53676 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53729), // Rule ID 13307 //
     /*  53681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53706 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53716 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53727 */     GIR_RootConstrainSelectedInstOperands,
     /*  53728 */     // GIR_Coverage, 13307,
     /*  53728 */     GIR_EraseRootFromParent_Done,
     /*  53729 */   // Label 864: @53729
     /*  53729 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53782), // Rule ID 160 //
     /*  53734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53763 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53769 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53780 */     GIR_RootConstrainSelectedInstOperands,
     /*  53781 */     // GIR_Coverage, 160,
     /*  53781 */     GIR_EraseRootFromParent_Done,
     /*  53782 */   // Label 865: @53782
     /*  53782 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(53823), // Rule ID 142 //
     /*  53787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  53791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53803 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  53807 */     // MIs[1] Operand 1
     /*  53807 */     // No operand predicates
     /*  53807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53809 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  53809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  53812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53816 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  53821 */     GIR_RootConstrainSelectedInstOperands,
     /*  53822 */     // GIR_Coverage, 142,
     /*  53822 */     GIR_EraseRootFromParent_Done,
     /*  53823 */   // Label 866: @53823
     /*  53823 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(53856), // Rule ID 13305 //
     /*  53828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53843 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53850 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53854 */     GIR_RootConstrainSelectedInstOperands,
     /*  53855 */     // GIR_Coverage, 13305,
     /*  53855 */     GIR_EraseRootFromParent_Done,
     /*  53856 */   // Label 867: @53856
     /*  53856 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(53889), // Rule ID 158 //
     /*  53861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53876 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53883 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53887 */     GIR_RootConstrainSelectedInstOperands,
     /*  53888 */     // GIR_Coverage, 158,
     /*  53888 */     GIR_EraseRootFromParent_Done,
     /*  53889 */   // Label 868: @53889
     /*  53889 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(53913), // Rule ID 156 //
     /*  53894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53906 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  53911 */     GIR_RootConstrainSelectedInstOperands,
     /*  53912 */     // GIR_Coverage, 156,
     /*  53912 */     GIR_Done,
     /*  53913 */   // Label 869: @53913
     /*  53913 */   GIM_Reject,
     /*  53914 */ // Label 859: @53914
     /*  53914 */ GIM_Reject,
     /*  53915 */ // Label 841: @53915
     /*  53915 */ GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(55349),
     /*  53920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53926 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(53981), // Rule ID 13310 //
     /*  53931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53951 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53968 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53979 */     GIR_RootConstrainSelectedInstOperands,
     /*  53980 */     // GIR_Coverage, 13310,
     /*  53980 */     GIR_EraseRootFromParent_Done,
     /*  53981 */   // Label 871: @53981
     /*  53981 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(54036), // Rule ID 163 //
     /*  53986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54010 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54023 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  54026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54034 */     GIR_RootConstrainSelectedInstOperands,
     /*  54035 */     // GIR_Coverage, 163,
     /*  54035 */     GIR_EraseRootFromParent_Done,
     /*  54036 */   // Label 872: @54036
     /*  54036 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(54149), // Rule ID 5698 //
     /*  54041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  54053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  54065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  54069 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54086 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  54090 */     // MIs[3] Operand 1
     /*  54090 */     // No operand predicates
     /*  54090 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54101 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54103 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  54103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  54110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  54119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  54122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54148 */     // GIR_Coverage, 5698,
     /*  54148 */     GIR_EraseRootFromParent_Done,
     /*  54149 */   // Label 873: @54149
     /*  54149 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(54262), // Rule ID 5699 //
     /*  54154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  54166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  54178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54199 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54203 */     // MIs[3] Operand 1
     /*  54203 */     // No operand predicates
     /*  54203 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54216 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  54216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  54223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54228 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  54232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  54235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54261 */     // GIR_Coverage, 5699,
     /*  54261 */     GIR_EraseRootFromParent_Done,
     /*  54262 */   // Label 874: @54262
     /*  54262 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54361), // Rule ID 7154 //
     /*  54267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54279 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54282 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54287 */     // MIs[1] addr
     /*  54287 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54296 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  54300 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54313 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  54320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54325 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54329 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54360 */     // GIR_Coverage, 7154,
     /*  54360 */     GIR_EraseRootFromParent_Done,
     /*  54361 */   // Label 875: @54361
     /*  54361 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54460), // Rule ID 7155 //
     /*  54366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54378 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54381 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54386 */     // MIs[1] addr
     /*  54386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54395 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  54399 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54412 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  54419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54424 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54428 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54459 */     // GIR_Coverage, 7155,
     /*  54459 */     GIR_EraseRootFromParent_Done,
     /*  54460 */   // Label 876: @54460
     /*  54460 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(54559), // Rule ID 7156 //
     /*  54465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54477 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54480 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54485 */     // MIs[1] addr
     /*  54485 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54494 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  54498 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54511 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  54518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54527 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54558 */     // GIR_Coverage, 7156,
     /*  54558 */     GIR_EraseRootFromParent_Done,
     /*  54559 */   // Label 877: @54559
     /*  54559 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(54658), // Rule ID 7161 //
     /*  54564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54576 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54579 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54584 */     // MIs[1] addr
     /*  54584 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54593 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  54597 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54610 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  54617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54626 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54657 */     // GIR_Coverage, 7161,
     /*  54657 */     GIR_EraseRootFromParent_Done,
     /*  54658 */   // Label 878: @54658
     /*  54658 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(54757), // Rule ID 7162 //
     /*  54663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54675 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54678 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54683 */     // MIs[1] addr
     /*  54683 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54692 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  54696 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54709 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  54716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54725 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54756 */     // GIR_Coverage, 7162,
     /*  54756 */     GIR_EraseRootFromParent_Done,
     /*  54757 */   // Label 879: @54757
     /*  54757 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(54856), // Rule ID 7163 //
     /*  54762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54774 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54777 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54782 */     // MIs[1] addr
     /*  54782 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54791 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  54795 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54808 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  54815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54820 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54824 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54855 */     // GIR_Coverage, 7163,
     /*  54855 */     GIR_EraseRootFromParent_Done,
     /*  54856 */   // Label 880: @54856
     /*  54856 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(54909), // Rule ID 13308 //
     /*  54861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54886 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54896 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54907 */     GIR_RootConstrainSelectedInstOperands,
     /*  54908 */     // GIR_Coverage, 13308,
     /*  54908 */     GIR_EraseRootFromParent_Done,
     /*  54909 */   // Label 881: @54909
     /*  54909 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(54962), // Rule ID 161 //
     /*  54914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54943 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54949 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54960 */     GIR_RootConstrainSelectedInstOperands,
     /*  54961 */     // GIR_Coverage, 161,
     /*  54961 */     GIR_EraseRootFromParent_Done,
     /*  54962 */   // Label 882: @54962
     /*  54962 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55062), // Rule ID 4004 //
     /*  54967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54975 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54986 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  54986 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  54989 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54993 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54998 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  55004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  55021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55026 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  55035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55061 */     // GIR_Coverage, 4004,
     /*  55061 */     GIR_EraseRootFromParent_Done,
     /*  55062 */   // Label 883: @55062
     /*  55062 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55103), // Rule ID 143 //
     /*  55067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55083 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  55087 */     // MIs[1] Operand 1
     /*  55087 */     // No operand predicates
     /*  55087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55089 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  55089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  55092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55094 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55096 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  55101 */     GIR_RootConstrainSelectedInstOperands,
     /*  55102 */     // GIR_Coverage, 143,
     /*  55102 */     GIR_EraseRootFromParent_Done,
     /*  55103 */   // Label 884: @55103
     /*  55103 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(55136), // Rule ID 13306 //
     /*  55108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55123 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  55126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55130 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55134 */     GIR_RootConstrainSelectedInstOperands,
     /*  55135 */     // GIR_Coverage, 13306,
     /*  55135 */     GIR_EraseRootFromParent_Done,
     /*  55136 */   // Label 885: @55136
     /*  55136 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(55169), // Rule ID 159 //
     /*  55141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55156 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  55159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55167 */     GIR_RootConstrainSelectedInstOperands,
     /*  55168 */     // GIR_Coverage, 159,
     /*  55168 */     GIR_EraseRootFromParent_Done,
     /*  55169 */   // Label 886: @55169
     /*  55169 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55233), // Rule ID 13964 //
     /*  55174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55206 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55212 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55220 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55225 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55231 */     GIR_RootConstrainSelectedInstOperands,
     /*  55232 */     // GIR_Coverage, 13964,
     /*  55232 */     GIR_EraseRootFromParent_Done,
     /*  55233 */   // Label 887: @55233
     /*  55233 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55297), // Rule ID 5080 //
     /*  55238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55274 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55280 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55284 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55289 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55295 */     GIR_RootConstrainSelectedInstOperands,
     /*  55296 */     // GIR_Coverage, 5080,
     /*  55296 */     GIR_EraseRootFromParent_Done,
     /*  55297 */   // Label 888: @55297
     /*  55297 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(55321), // Rule ID 157 //
     /*  55302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55314 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  55314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  55319 */     GIR_RootConstrainSelectedInstOperands,
     /*  55320 */     // GIR_Coverage, 157,
     /*  55320 */     GIR_Done,
     /*  55321 */   // Label 889: @55321
     /*  55321 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(55348), // Rule ID 2484 //
     /*  55326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55341 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  55341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55346 */     GIR_RootConstrainSelectedInstOperands,
     /*  55347 */     // GIR_Coverage, 2484,
     /*  55347 */     GIR_Done,
     /*  55348 */   // Label 890: @55348
     /*  55348 */   GIM_Reject,
     /*  55349 */ // Label 870: @55349
     /*  55349 */ GIM_Reject,
     /*  55350 */ // Label 842: @55350
     /*  55350 */ GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(55509),
     /*  55355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55365 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(55425), // Rule ID 13963 //
     /*  55370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55398 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55412 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55417 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55423 */     GIR_RootConstrainSelectedInstOperands,
     /*  55424 */     // GIR_Coverage, 13963,
     /*  55424 */     GIR_EraseRootFromParent_Done,
     /*  55425 */   // Label 892: @55425
     /*  55425 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(55485), // Rule ID 5079 //
     /*  55430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  55449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55462 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55468 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55472 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55477 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55483 */     GIR_RootConstrainSelectedInstOperands,
     /*  55484 */     // GIR_Coverage, 5079,
     /*  55484 */     GIR_EraseRootFromParent_Done,
     /*  55485 */   // Label 893: @55485
     /*  55485 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(55508), // Rule ID 2483 //
     /*  55490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55501 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55506 */     GIR_RootConstrainSelectedInstOperands,
     /*  55507 */     // GIR_Coverage, 2483,
     /*  55507 */     GIR_Done,
     /*  55508 */   // Label 894: @55508
     /*  55508 */   GIM_Reject,
     /*  55509 */ // Label 891: @55509
     /*  55509 */ GIM_Reject,
     /*  55510 */ // Label 843: @55510
     /*  55510 */ GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(55669),
     /*  55515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55525 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(55585), // Rule ID 13967 //
     /*  55530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55558 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55564 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55572 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55577 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55583 */     GIR_RootConstrainSelectedInstOperands,
     /*  55584 */     // GIR_Coverage, 13967,
     /*  55584 */     GIR_EraseRootFromParent_Done,
     /*  55585 */   // Label 896: @55585
     /*  55585 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(55645), // Rule ID 5083 //
     /*  55590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55622 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55632 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55637 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55643 */     GIR_RootConstrainSelectedInstOperands,
     /*  55644 */     // GIR_Coverage, 5083,
     /*  55644 */     GIR_EraseRootFromParent_Done,
     /*  55645 */   // Label 897: @55645
     /*  55645 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(55668), // Rule ID 2487 //
     /*  55650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55661 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55666 */     GIR_RootConstrainSelectedInstOperands,
     /*  55667 */     // GIR_Coverage, 2487,
     /*  55667 */     GIR_Done,
     /*  55668 */   // Label 898: @55668
     /*  55668 */   GIM_Reject,
     /*  55669 */ // Label 895: @55669
     /*  55669 */ GIM_Reject,
     /*  55670 */ // Label 844: @55670
     /*  55670 */ GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(55829),
     /*  55675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55685 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(55745), // Rule ID 13962 //
     /*  55690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55718 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55732 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55737 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55743 */     GIR_RootConstrainSelectedInstOperands,
     /*  55744 */     // GIR_Coverage, 13962,
     /*  55744 */     GIR_EraseRootFromParent_Done,
     /*  55745 */   // Label 900: @55745
     /*  55745 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(55805), // Rule ID 5078 //
     /*  55750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55782 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55788 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55792 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55797 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55803 */     GIR_RootConstrainSelectedInstOperands,
     /*  55804 */     // GIR_Coverage, 5078,
     /*  55804 */     GIR_EraseRootFromParent_Done,
     /*  55805 */   // Label 901: @55805
     /*  55805 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(55828), // Rule ID 2482 //
     /*  55810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55821 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55826 */     GIR_RootConstrainSelectedInstOperands,
     /*  55827 */     // GIR_Coverage, 2482,
     /*  55827 */     GIR_Done,
     /*  55828 */   // Label 902: @55828
     /*  55828 */   GIM_Reject,
     /*  55829 */ // Label 899: @55829
     /*  55829 */ GIM_Reject,
     /*  55830 */ // Label 845: @55830
     /*  55830 */ GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(55989),
     /*  55835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55845 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(55905), // Rule ID 13966 //
     /*  55850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55878 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55892 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55897 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55903 */     GIR_RootConstrainSelectedInstOperands,
     /*  55904 */     // GIR_Coverage, 13966,
     /*  55904 */     GIR_EraseRootFromParent_Done,
     /*  55905 */   // Label 904: @55905
     /*  55905 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(55965), // Rule ID 5082 //
     /*  55910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55952 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55957 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55963 */     GIR_RootConstrainSelectedInstOperands,
     /*  55964 */     // GIR_Coverage, 5082,
     /*  55964 */     GIR_EraseRootFromParent_Done,
     /*  55965 */   // Label 905: @55965
     /*  55965 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(55988), // Rule ID 2486 //
     /*  55970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55981 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55986 */     GIR_RootConstrainSelectedInstOperands,
     /*  55987 */     // GIR_Coverage, 2486,
     /*  55987 */     GIR_Done,
     /*  55988 */   // Label 906: @55988
     /*  55988 */   GIM_Reject,
     /*  55989 */ // Label 903: @55989
     /*  55989 */ GIM_Reject,
     /*  55990 */ // Label 846: @55990
     /*  55990 */ GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(56149),
     /*  55995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56005 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(56065), // Rule ID 13445 //
     /*  56010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  56025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56038 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56044 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56052 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56063 */     GIR_RootConstrainSelectedInstOperands,
     /*  56064 */     // GIR_Coverage, 13445,
     /*  56064 */     GIR_EraseRootFromParent_Done,
     /*  56065 */   // Label 908: @56065
     /*  56065 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(56125), // Rule ID 1597 //
     /*  56070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  56089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56102 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56112 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56123 */     GIR_RootConstrainSelectedInstOperands,
     /*  56124 */     // GIR_Coverage, 1597,
     /*  56124 */     GIR_EraseRootFromParent_Done,
     /*  56125 */   // Label 909: @56125
     /*  56125 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(56148), // Rule ID 1595 //
     /*  56130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56141 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  56141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  56146 */     GIR_RootConstrainSelectedInstOperands,
     /*  56147 */     // GIR_Coverage, 1595,
     /*  56147 */     GIR_Done,
     /*  56148 */   // Label 910: @56148
     /*  56148 */   GIM_Reject,
     /*  56149 */ // Label 907: @56149
     /*  56149 */ GIM_Reject,
     /*  56150 */ // Label 847: @56150
     /*  56150 */ GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(56309),
     /*  56155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56165 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(56225), // Rule ID 13965 //
     /*  56170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56198 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56212 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56217 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  56219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56223 */     GIR_RootConstrainSelectedInstOperands,
     /*  56224 */     // GIR_Coverage, 13965,
     /*  56224 */     GIR_EraseRootFromParent_Done,
     /*  56225 */   // Label 912: @56225
     /*  56225 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(56285), // Rule ID 5081 //
     /*  56230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  56249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56262 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56268 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56272 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56277 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  56279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56283 */     GIR_RootConstrainSelectedInstOperands,
     /*  56284 */     // GIR_Coverage, 5081,
     /*  56284 */     GIR_EraseRootFromParent_Done,
     /*  56285 */   // Label 913: @56285
     /*  56285 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(56308), // Rule ID 2485 //
     /*  56290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56301 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  56301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  56306 */     GIR_RootConstrainSelectedInstOperands,
     /*  56307 */     // GIR_Coverage, 2485,
     /*  56307 */     GIR_Done,
     /*  56308 */   // Label 914: @56308
     /*  56308 */   GIM_Reject,
     /*  56309 */ // Label 911: @56309
     /*  56309 */ GIM_Reject,
     /*  56310 */ // Label 848: @56310
     /*  56310 */ GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(56469),
     /*  56315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56325 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(56385), // Rule ID 13446 //
     /*  56330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56358 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56372 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56383 */     GIR_RootConstrainSelectedInstOperands,
     /*  56384 */     // GIR_Coverage, 13446,
     /*  56384 */     GIR_EraseRootFromParent_Done,
     /*  56385 */   // Label 916: @56385
     /*  56385 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(56445), // Rule ID 1598 //
     /*  56390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  56409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56422 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56428 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56432 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  56435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56443 */     GIR_RootConstrainSelectedInstOperands,
     /*  56444 */     // GIR_Coverage, 1598,
     /*  56444 */     GIR_EraseRootFromParent_Done,
     /*  56445 */   // Label 917: @56445
     /*  56445 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(56468), // Rule ID 1596 //
     /*  56450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  56461 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  56461 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  56466 */     GIR_RootConstrainSelectedInstOperands,
     /*  56467 */     // GIR_Coverage, 1596,
     /*  56467 */     GIR_Done,
     /*  56468 */   // Label 918: @56468
     /*  56468 */   GIM_Reject,
     /*  56469 */ // Label 915: @56469
     /*  56469 */ GIM_Reject,
     /*  56470 */ // Label 849: @56470
     /*  56470 */ GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(57010),
     /*  56475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56485 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(56542), // Rule ID 15159 //
     /*  56490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56521 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56527 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56540 */     GIR_RootConstrainSelectedInstOperands,
     /*  56541 */     // GIR_Coverage, 15159,
     /*  56541 */     GIR_EraseRootFromParent_Done,
     /*  56542 */   // Label 920: @56542
     /*  56542 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(56599), // Rule ID 15162 //
     /*  56547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56578 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56584 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56597 */     GIR_RootConstrainSelectedInstOperands,
     /*  56598 */     // GIR_Coverage, 15162,
     /*  56598 */     GIR_EraseRootFromParent_Done,
     /*  56599 */   // Label 921: @56599
     /*  56599 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(56656), // Rule ID 15158 //
     /*  56604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56635 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56641 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56654 */     GIR_RootConstrainSelectedInstOperands,
     /*  56655 */     // GIR_Coverage, 15158,
     /*  56655 */     GIR_EraseRootFromParent_Done,
     /*  56656 */   // Label 922: @56656
     /*  56656 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(56713), // Rule ID 15161 //
     /*  56661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56692 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56698 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56711 */     GIR_RootConstrainSelectedInstOperands,
     /*  56712 */     // GIR_Coverage, 15161,
     /*  56712 */     GIR_EraseRootFromParent_Done,
     /*  56713 */   // Label 923: @56713
     /*  56713 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(56770), // Rule ID 15157 //
     /*  56718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56749 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56755 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56768 */     GIR_RootConstrainSelectedInstOperands,
     /*  56769 */     // GIR_Coverage, 15157,
     /*  56769 */     GIR_EraseRootFromParent_Done,
     /*  56770 */   // Label 924: @56770
     /*  56770 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(56827), // Rule ID 15160 //
     /*  56775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56806 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56812 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56825 */     GIR_RootConstrainSelectedInstOperands,
     /*  56826 */     // GIR_Coverage, 15160,
     /*  56826 */     GIR_EraseRootFromParent_Done,
     /*  56827 */   // Label 925: @56827
     /*  56827 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(56884), // Rule ID 8497 //
     /*  56832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56863 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56869 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56876 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56882 */     GIR_RootConstrainSelectedInstOperands,
     /*  56883 */     // GIR_Coverage, 8497,
     /*  56883 */     GIR_EraseRootFromParent_Done,
     /*  56884 */   // Label 926: @56884
     /*  56884 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(56941), // Rule ID 8498 //
     /*  56889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56920 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56926 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56939 */     GIR_RootConstrainSelectedInstOperands,
     /*  56940 */     // GIR_Coverage, 8498,
     /*  56940 */     GIR_EraseRootFromParent_Done,
     /*  56941 */   // Label 927: @56941
     /*  56941 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(56988), // Rule ID 10761 //
     /*  56946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56957 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  56957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  56964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56969 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56986 */     GIR_RootConstrainSelectedInstOperands,
     /*  56987 */     // GIR_Coverage, 10761,
     /*  56987 */     GIR_EraseRootFromParent_Done,
     /*  56988 */   // Label 928: @56988
     /*  56988 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(57009), // Rule ID 2753 //
     /*  56993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56996 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57007 */     GIR_RootConstrainSelectedInstOperands,
     /*  57008 */     // GIR_Coverage, 2753,
     /*  57008 */     GIR_EraseRootFromParent_Done,
     /*  57009 */   // Label 929: @57009
     /*  57009 */   GIM_Reject,
     /*  57010 */ // Label 919: @57010
     /*  57010 */ GIM_Reject,
     /*  57011 */ // Label 850: @57011
     /*  57011 */ GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(57551),
     /*  57016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  57026 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(57083), // Rule ID 15150 //
     /*  57031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57062 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57068 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57081 */     GIR_RootConstrainSelectedInstOperands,
     /*  57082 */     // GIR_Coverage, 15150,
     /*  57082 */     GIR_EraseRootFromParent_Done,
     /*  57083 */   // Label 931: @57083
     /*  57083 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(57140), // Rule ID 15153 //
     /*  57088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57119 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57125 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57138 */     GIR_RootConstrainSelectedInstOperands,
     /*  57139 */     // GIR_Coverage, 15153,
     /*  57139 */     GIR_EraseRootFromParent_Done,
     /*  57140 */   // Label 932: @57140
     /*  57140 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(57197), // Rule ID 15149 //
     /*  57145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57176 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57182 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57195 */     GIR_RootConstrainSelectedInstOperands,
     /*  57196 */     // GIR_Coverage, 15149,
     /*  57196 */     GIR_EraseRootFromParent_Done,
     /*  57197 */   // Label 933: @57197
     /*  57197 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(57254), // Rule ID 15152 //
     /*  57202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57233 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57239 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57252 */     GIR_RootConstrainSelectedInstOperands,
     /*  57253 */     // GIR_Coverage, 15152,
     /*  57253 */     GIR_EraseRootFromParent_Done,
     /*  57254 */   // Label 934: @57254
     /*  57254 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(57311), // Rule ID 15148 //
     /*  57259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57290 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57296 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57309 */     GIR_RootConstrainSelectedInstOperands,
     /*  57310 */     // GIR_Coverage, 15148,
     /*  57310 */     GIR_EraseRootFromParent_Done,
     /*  57311 */   // Label 935: @57311
     /*  57311 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(57368), // Rule ID 15151 //
     /*  57316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57347 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57353 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57366 */     GIR_RootConstrainSelectedInstOperands,
     /*  57367 */     // GIR_Coverage, 15151,
     /*  57367 */     GIR_EraseRootFromParent_Done,
     /*  57368 */   // Label 936: @57368
     /*  57368 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(57425), // Rule ID 8493 //
     /*  57373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57404 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57410 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57415 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57423 */     GIR_RootConstrainSelectedInstOperands,
     /*  57424 */     // GIR_Coverage, 8493,
     /*  57424 */     GIR_EraseRootFromParent_Done,
     /*  57425 */   // Label 937: @57425
     /*  57425 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(57482), // Rule ID 8494 //
     /*  57430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  57445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  57449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57461 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57467 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57480 */     GIR_RootConstrainSelectedInstOperands,
     /*  57481 */     // GIR_Coverage, 8494,
     /*  57481 */     GIR_EraseRootFromParent_Done,
     /*  57482 */   // Label 938: @57482
     /*  57482 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(57529), // Rule ID 10760 //
     /*  57487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57498 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  57498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  57501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  57505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  57513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  57515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  57525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  57527 */     GIR_RootConstrainSelectedInstOperands,
     /*  57528 */     // GIR_Coverage, 10760,
     /*  57528 */     GIR_EraseRootFromParent_Done,
     /*  57529 */   // Label 939: @57529
     /*  57529 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(57550), // Rule ID 2752 //
     /*  57534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57537 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57544 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57548 */     GIR_RootConstrainSelectedInstOperands,
     /*  57549 */     // GIR_Coverage, 2752,
     /*  57549 */     GIR_EraseRootFromParent_Done,
     /*  57550 */   // Label 940: @57550
     /*  57550 */   GIM_Reject,
     /*  57551 */ // Label 930: @57551
     /*  57551 */ GIM_Reject,
     /*  57552 */ // Label 851: @57552
     /*  57552 */ GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(58023),
     /*  57557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  57567 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(57622), // Rule ID 15090 //
     /*  57572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57603 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57609 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57620 */     GIR_RootConstrainSelectedInstOperands,
     /*  57621 */     // GIR_Coverage, 15090,
     /*  57621 */     GIR_EraseRootFromParent_Done,
     /*  57622 */   // Label 942: @57622
     /*  57622 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(57677), // Rule ID 15093 //
     /*  57627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57658 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57664 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57675 */     GIR_RootConstrainSelectedInstOperands,
     /*  57676 */     // GIR_Coverage, 15093,
     /*  57676 */     GIR_EraseRootFromParent_Done,
     /*  57677 */   // Label 943: @57677
     /*  57677 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(57732), // Rule ID 15089 //
     /*  57682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57719 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57730 */     GIR_RootConstrainSelectedInstOperands,
     /*  57731 */     // GIR_Coverage, 15089,
     /*  57731 */     GIR_EraseRootFromParent_Done,
     /*  57732 */   // Label 944: @57732
     /*  57732 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(57787), // Rule ID 15092 //
     /*  57737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57768 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57774 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57785 */     GIR_RootConstrainSelectedInstOperands,
     /*  57786 */     // GIR_Coverage, 15092,
     /*  57786 */     GIR_EraseRootFromParent_Done,
     /*  57787 */   // Label 945: @57787
     /*  57787 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(57842), // Rule ID 15088 //
     /*  57792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57823 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57829 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57840 */     GIR_RootConstrainSelectedInstOperands,
     /*  57841 */     // GIR_Coverage, 15088,
     /*  57841 */     GIR_EraseRootFromParent_Done,
     /*  57842 */   // Label 946: @57842
     /*  57842 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(57897), // Rule ID 15091 //
     /*  57847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57878 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57884 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57895 */     GIR_RootConstrainSelectedInstOperands,
     /*  57896 */     // GIR_Coverage, 15091,
     /*  57896 */     GIR_EraseRootFromParent_Done,
     /*  57897 */   // Label 947: @57897
     /*  57897 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(57952), // Rule ID 7542 //
     /*  57902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57933 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57939 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57944 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57950 */     GIR_RootConstrainSelectedInstOperands,
     /*  57951 */     // GIR_Coverage, 7542,
     /*  57951 */     GIR_EraseRootFromParent_Done,
     /*  57952 */   // Label 948: @57952
     /*  57952 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(58007), // Rule ID 7543 //
     /*  57957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57988 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57994 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58005 */     GIR_RootConstrainSelectedInstOperands,
     /*  58006 */     // GIR_Coverage, 7543,
     /*  58006 */     GIR_EraseRootFromParent_Done,
     /*  58007 */   // Label 949: @58007
     /*  58007 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(58022), // Rule ID 3146 //
     /*  58012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58015 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  58015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  58020 */     GIR_RootConstrainSelectedInstOperands,
     /*  58021 */     // GIR_Coverage, 3146,
     /*  58021 */     GIR_Done,
     /*  58022 */   // Label 950: @58022
     /*  58022 */   GIM_Reject,
     /*  58023 */ // Label 941: @58023
     /*  58023 */ GIM_Reject,
     /*  58024 */ // Label 852: @58024
     /*  58024 */ GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(58564),
     /*  58029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  58039 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(58096), // Rule ID 15141 //
     /*  58044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58075 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58081 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58094 */     GIR_RootConstrainSelectedInstOperands,
     /*  58095 */     // GIR_Coverage, 15141,
     /*  58095 */     GIR_EraseRootFromParent_Done,
     /*  58096 */   // Label 952: @58096
     /*  58096 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(58153), // Rule ID 15144 //
     /*  58101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58132 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58138 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58151 */     GIR_RootConstrainSelectedInstOperands,
     /*  58152 */     // GIR_Coverage, 15144,
     /*  58152 */     GIR_EraseRootFromParent_Done,
     /*  58153 */   // Label 953: @58153
     /*  58153 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(58210), // Rule ID 15140 //
     /*  58158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58189 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58195 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58208 */     GIR_RootConstrainSelectedInstOperands,
     /*  58209 */     // GIR_Coverage, 15140,
     /*  58209 */     GIR_EraseRootFromParent_Done,
     /*  58210 */   // Label 954: @58210
     /*  58210 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(58267), // Rule ID 15143 //
     /*  58215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58246 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58252 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58265 */     GIR_RootConstrainSelectedInstOperands,
     /*  58266 */     // GIR_Coverage, 15143,
     /*  58266 */     GIR_EraseRootFromParent_Done,
     /*  58267 */   // Label 955: @58267
     /*  58267 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(58324), // Rule ID 15139 //
     /*  58272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58303 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58309 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58322 */     GIR_RootConstrainSelectedInstOperands,
     /*  58323 */     // GIR_Coverage, 15139,
     /*  58323 */     GIR_EraseRootFromParent_Done,
     /*  58324 */   // Label 956: @58324
     /*  58324 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(58381), // Rule ID 15142 //
     /*  58329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58360 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58366 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58379 */     GIR_RootConstrainSelectedInstOperands,
     /*  58380 */     // GIR_Coverage, 15142,
     /*  58380 */     GIR_EraseRootFromParent_Done,
     /*  58381 */   // Label 957: @58381
     /*  58381 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(58438), // Rule ID 8489 //
     /*  58386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58417 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58423 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58436 */     GIR_RootConstrainSelectedInstOperands,
     /*  58437 */     // GIR_Coverage, 8489,
     /*  58437 */     GIR_EraseRootFromParent_Done,
     /*  58438 */   // Label 958: @58438
     /*  58438 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(58495), // Rule ID 8490 //
     /*  58443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  58458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  58462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58474 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58480 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58485 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58493 */     GIR_RootConstrainSelectedInstOperands,
     /*  58494 */     // GIR_Coverage, 8490,
     /*  58494 */     GIR_EraseRootFromParent_Done,
     /*  58495 */   // Label 959: @58495
     /*  58495 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(58542), // Rule ID 10759 //
     /*  58500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58511 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  58511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  58518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58523 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  58538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  58540 */     GIR_RootConstrainSelectedInstOperands,
     /*  58541 */     // GIR_Coverage, 10759,
     /*  58541 */     GIR_EraseRootFromParent_Done,
     /*  58542 */   // Label 960: @58542
     /*  58542 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(58563), // Rule ID 2751 //
     /*  58547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58550 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  58561 */     GIR_RootConstrainSelectedInstOperands,
     /*  58562 */     // GIR_Coverage, 2751,
     /*  58562 */     GIR_EraseRootFromParent_Done,
     /*  58563 */   // Label 961: @58563
     /*  58563 */   GIM_Reject,
     /*  58564 */ // Label 951: @58564
     /*  58564 */ GIM_Reject,
     /*  58565 */ // Label 853: @58565
     /*  58565 */ GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(59036),
     /*  58570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  58580 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(58635), // Rule ID 15081 //
     /*  58585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58616 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58622 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58633 */     GIR_RootConstrainSelectedInstOperands,
     /*  58634 */     // GIR_Coverage, 15081,
     /*  58634 */     GIR_EraseRootFromParent_Done,
     /*  58635 */   // Label 963: @58635
     /*  58635 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(58690), // Rule ID 15084 //
     /*  58640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58671 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58677 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58688 */     GIR_RootConstrainSelectedInstOperands,
     /*  58689 */     // GIR_Coverage, 15084,
     /*  58689 */     GIR_EraseRootFromParent_Done,
     /*  58690 */   // Label 964: @58690
     /*  58690 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(58745), // Rule ID 15080 //
     /*  58695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58726 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58732 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58743 */     GIR_RootConstrainSelectedInstOperands,
     /*  58744 */     // GIR_Coverage, 15080,
     /*  58744 */     GIR_EraseRootFromParent_Done,
     /*  58745 */   // Label 965: @58745
     /*  58745 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(58800), // Rule ID 15083 //
     /*  58750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58781 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58787 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58798 */     GIR_RootConstrainSelectedInstOperands,
     /*  58799 */     // GIR_Coverage, 15083,
     /*  58799 */     GIR_EraseRootFromParent_Done,
     /*  58800 */   // Label 966: @58800
     /*  58800 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(58855), // Rule ID 15079 //
     /*  58805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58836 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58842 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58853 */     GIR_RootConstrainSelectedInstOperands,
     /*  58854 */     // GIR_Coverage, 15079,
     /*  58854 */     GIR_EraseRootFromParent_Done,
     /*  58855 */   // Label 967: @58855
     /*  58855 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(58910), // Rule ID 15082 //
     /*  58860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58891 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58897 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58908 */     GIR_RootConstrainSelectedInstOperands,
     /*  58909 */     // GIR_Coverage, 15082,
     /*  58909 */     GIR_EraseRootFromParent_Done,
     /*  58910 */   // Label 968: @58910
     /*  58910 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(58965), // Rule ID 7538 //
     /*  58915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58946 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58952 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58963 */     GIR_RootConstrainSelectedInstOperands,
     /*  58964 */     // GIR_Coverage, 7538,
     /*  58964 */     GIR_EraseRootFromParent_Done,
     /*  58965 */   // Label 969: @58965
     /*  58965 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(59020), // Rule ID 7539 //
     /*  58970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59001 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59007 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  59007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59012 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59018 */     GIR_RootConstrainSelectedInstOperands,
     /*  59019 */     // GIR_Coverage, 7539,
     /*  59019 */     GIR_EraseRootFromParent_Done,
     /*  59020 */   // Label 970: @59020
     /*  59020 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(59035), // Rule ID 3145 //
     /*  59025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59028 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  59028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  59033 */     GIR_RootConstrainSelectedInstOperands,
     /*  59034 */     // GIR_Coverage, 3145,
     /*  59034 */     GIR_Done,
     /*  59035 */   // Label 971: @59035
     /*  59035 */   GIM_Reject,
     /*  59036 */ // Label 962: @59036
     /*  59036 */ GIM_Reject,
     /*  59037 */ // Label 854: @59037
     /*  59037 */ GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(59577),
     /*  59042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  59052 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(59109), // Rule ID 15132 //
     /*  59057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59088 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59094 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59107 */     GIR_RootConstrainSelectedInstOperands,
     /*  59108 */     // GIR_Coverage, 15132,
     /*  59108 */     GIR_EraseRootFromParent_Done,
     /*  59109 */   // Label 973: @59109
     /*  59109 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(59166), // Rule ID 15135 //
     /*  59114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59145 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59151 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59164 */     GIR_RootConstrainSelectedInstOperands,
     /*  59165 */     // GIR_Coverage, 15135,
     /*  59165 */     GIR_EraseRootFromParent_Done,
     /*  59166 */   // Label 974: @59166
     /*  59166 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(59223), // Rule ID 15131 //
     /*  59171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59202 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59208 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59221 */     GIR_RootConstrainSelectedInstOperands,
     /*  59222 */     // GIR_Coverage, 15131,
     /*  59222 */     GIR_EraseRootFromParent_Done,
     /*  59223 */   // Label 975: @59223
     /*  59223 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(59280), // Rule ID 15134 //
     /*  59228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59259 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59265 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59278 */     GIR_RootConstrainSelectedInstOperands,
     /*  59279 */     // GIR_Coverage, 15134,
     /*  59279 */     GIR_EraseRootFromParent_Done,
     /*  59280 */   // Label 976: @59280
     /*  59280 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(59337), // Rule ID 15130 //
     /*  59285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59316 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59322 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59335 */     GIR_RootConstrainSelectedInstOperands,
     /*  59336 */     // GIR_Coverage, 15130,
     /*  59336 */     GIR_EraseRootFromParent_Done,
     /*  59337 */   // Label 977: @59337
     /*  59337 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(59394), // Rule ID 15133 //
     /*  59342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59373 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59379 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59392 */     GIR_RootConstrainSelectedInstOperands,
     /*  59393 */     // GIR_Coverage, 15133,
     /*  59393 */     GIR_EraseRootFromParent_Done,
     /*  59394 */   // Label 978: @59394
     /*  59394 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(59451), // Rule ID 8485 //
     /*  59399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59430 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59436 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59449 */     GIR_RootConstrainSelectedInstOperands,
     /*  59450 */     // GIR_Coverage, 8485,
     /*  59450 */     GIR_EraseRootFromParent_Done,
     /*  59451 */   // Label 979: @59451
     /*  59451 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(59508), // Rule ID 8486 //
     /*  59456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  59471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  59475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59487 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59493 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59506 */     GIR_RootConstrainSelectedInstOperands,
     /*  59507 */     // GIR_Coverage, 8486,
     /*  59507 */     GIR_EraseRootFromParent_Done,
     /*  59508 */   // Label 980: @59508
     /*  59508 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(59555), // Rule ID 10758 //
     /*  59513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59524 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  59524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  59527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  59531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59536 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  59539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  59551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  59553 */     GIR_RootConstrainSelectedInstOperands,
     /*  59554 */     // GIR_Coverage, 10758,
     /*  59554 */     GIR_EraseRootFromParent_Done,
     /*  59555 */   // Label 981: @59555
     /*  59555 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(59576), // Rule ID 2750 //
     /*  59560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59563 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  59574 */     GIR_RootConstrainSelectedInstOperands,
     /*  59575 */     // GIR_Coverage, 2750,
     /*  59575 */     GIR_EraseRootFromParent_Done,
     /*  59576 */   // Label 982: @59576
     /*  59576 */   GIM_Reject,
     /*  59577 */ // Label 972: @59577
     /*  59577 */ GIM_Reject,
     /*  59578 */ // Label 855: @59578
     /*  59578 */ GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(60049),
     /*  59583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  59593 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(59648), // Rule ID 15072 //
     /*  59598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59629 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59635 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59646 */     GIR_RootConstrainSelectedInstOperands,
     /*  59647 */     // GIR_Coverage, 15072,
     /*  59647 */     GIR_EraseRootFromParent_Done,
     /*  59648 */   // Label 984: @59648
     /*  59648 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(59703), // Rule ID 15075 //
     /*  59653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59684 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59690 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59701 */     GIR_RootConstrainSelectedInstOperands,
     /*  59702 */     // GIR_Coverage, 15075,
     /*  59702 */     GIR_EraseRootFromParent_Done,
     /*  59703 */   // Label 985: @59703
     /*  59703 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(59758), // Rule ID 15071 //
     /*  59708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59739 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59745 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59756 */     GIR_RootConstrainSelectedInstOperands,
     /*  59757 */     // GIR_Coverage, 15071,
     /*  59757 */     GIR_EraseRootFromParent_Done,
     /*  59758 */   // Label 986: @59758
     /*  59758 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(59813), // Rule ID 15074 //
     /*  59763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59794 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59800 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59811 */     GIR_RootConstrainSelectedInstOperands,
     /*  59812 */     // GIR_Coverage, 15074,
     /*  59812 */     GIR_EraseRootFromParent_Done,
     /*  59813 */   // Label 987: @59813
     /*  59813 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(59868), // Rule ID 15070 //
     /*  59818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59849 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59855 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59866 */     GIR_RootConstrainSelectedInstOperands,
     /*  59867 */     // GIR_Coverage, 15070,
     /*  59867 */     GIR_EraseRootFromParent_Done,
     /*  59868 */   // Label 988: @59868
     /*  59868 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(59923), // Rule ID 15073 //
     /*  59873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59904 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59908 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59910 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59921 */     GIR_RootConstrainSelectedInstOperands,
     /*  59922 */     // GIR_Coverage, 15073,
     /*  59922 */     GIR_EraseRootFromParent_Done,
     /*  59923 */   // Label 989: @59923
     /*  59923 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(59978), // Rule ID 7534 //
     /*  59928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59959 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59965 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59976 */     GIR_RootConstrainSelectedInstOperands,
     /*  59977 */     // GIR_Coverage, 7534,
     /*  59977 */     GIR_EraseRootFromParent_Done,
     /*  59978 */   // Label 990: @59978
     /*  59978 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(60033), // Rule ID 7535 //
     /*  59983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  60002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60014 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60020 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  60020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60031 */     GIR_RootConstrainSelectedInstOperands,
     /*  60032 */     // GIR_Coverage, 7535,
     /*  60032 */     GIR_EraseRootFromParent_Done,
     /*  60033 */   // Label 991: @60033
     /*  60033 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(60048), // Rule ID 3144 //
     /*  60038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60041 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  60041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  60046 */     GIR_RootConstrainSelectedInstOperands,
     /*  60047 */     // GIR_Coverage, 3144,
     /*  60047 */     GIR_Done,
     /*  60048 */   // Label 992: @60048
     /*  60048 */   GIM_Reject,
     /*  60049 */ // Label 983: @60049
     /*  60049 */ GIM_Reject,
     /*  60050 */ // Label 856: @60050
     /*  60050 */ GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(60590),
     /*  60055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  60065 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(60122), // Rule ID 15123 //
     /*  60070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60101 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60107 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60120 */     GIR_RootConstrainSelectedInstOperands,
     /*  60121 */     // GIR_Coverage, 15123,
     /*  60121 */     GIR_EraseRootFromParent_Done,
     /*  60122 */   // Label 994: @60122
     /*  60122 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(60179), // Rule ID 15126 //
     /*  60127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60158 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60164 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60177 */     GIR_RootConstrainSelectedInstOperands,
     /*  60178 */     // GIR_Coverage, 15126,
     /*  60178 */     GIR_EraseRootFromParent_Done,
     /*  60179 */   // Label 995: @60179
     /*  60179 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(60236), // Rule ID 15122 //
     /*  60184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60215 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60221 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60234 */     GIR_RootConstrainSelectedInstOperands,
     /*  60235 */     // GIR_Coverage, 15122,
     /*  60235 */     GIR_EraseRootFromParent_Done,
     /*  60236 */   // Label 996: @60236
     /*  60236 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(60293), // Rule ID 15125 //
     /*  60241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60272 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60278 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60291 */     GIR_RootConstrainSelectedInstOperands,
     /*  60292 */     // GIR_Coverage, 15125,
     /*  60292 */     GIR_EraseRootFromParent_Done,
     /*  60293 */   // Label 997: @60293
     /*  60293 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(60350), // Rule ID 15121 //
     /*  60298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60329 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60335 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60348 */     GIR_RootConstrainSelectedInstOperands,
     /*  60349 */     // GIR_Coverage, 15121,
     /*  60349 */     GIR_EraseRootFromParent_Done,
     /*  60350 */   // Label 998: @60350
     /*  60350 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(60407), // Rule ID 15124 //
     /*  60355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60386 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60392 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60405 */     GIR_RootConstrainSelectedInstOperands,
     /*  60406 */     // GIR_Coverage, 15124,
     /*  60406 */     GIR_EraseRootFromParent_Done,
     /*  60407 */   // Label 999: @60407
     /*  60407 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(60464), // Rule ID 8481 //
     /*  60412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60443 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60449 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60462 */     GIR_RootConstrainSelectedInstOperands,
     /*  60463 */     // GIR_Coverage, 8481,
     /*  60463 */     GIR_EraseRootFromParent_Done,
     /*  60464 */   // Label 1000: @60464
     /*  60464 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(60521), // Rule ID 8482 //
     /*  60469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60500 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60506 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60511 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60519 */     GIR_RootConstrainSelectedInstOperands,
     /*  60520 */     // GIR_Coverage, 8482,
     /*  60520 */     GIR_EraseRootFromParent_Done,
     /*  60521 */   // Label 1001: @60521
     /*  60521 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(60568), // Rule ID 10757 //
     /*  60526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60537 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  60537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  60540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  60544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60549 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  60552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  60564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  60566 */     GIR_RootConstrainSelectedInstOperands,
     /*  60567 */     // GIR_Coverage, 10757,
     /*  60567 */     GIR_EraseRootFromParent_Done,
     /*  60568 */   // Label 1002: @60568
     /*  60568 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(60589), // Rule ID 2749 //
     /*  60573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60576 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  60587 */     GIR_RootConstrainSelectedInstOperands,
     /*  60588 */     // GIR_Coverage, 2749,
     /*  60588 */     GIR_EraseRootFromParent_Done,
     /*  60589 */   // Label 1003: @60589
     /*  60589 */   GIM_Reject,
     /*  60590 */ // Label 993: @60590
     /*  60590 */ GIM_Reject,
     /*  60591 */ // Label 857: @60591
     /*  60591 */ GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(61062),
     /*  60596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  60606 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(60661), // Rule ID 15063 //
     /*  60611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60642 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60648 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60659 */     GIR_RootConstrainSelectedInstOperands,
     /*  60660 */     // GIR_Coverage, 15063,
     /*  60660 */     GIR_EraseRootFromParent_Done,
     /*  60661 */   // Label 1005: @60661
     /*  60661 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(60716), // Rule ID 15066 //
     /*  60666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60697 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60703 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60714 */     GIR_RootConstrainSelectedInstOperands,
     /*  60715 */     // GIR_Coverage, 15066,
     /*  60715 */     GIR_EraseRootFromParent_Done,
     /*  60716 */   // Label 1006: @60716
     /*  60716 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(60771), // Rule ID 15062 //
     /*  60721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60752 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60758 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60769 */     GIR_RootConstrainSelectedInstOperands,
     /*  60770 */     // GIR_Coverage, 15062,
     /*  60770 */     GIR_EraseRootFromParent_Done,
     /*  60771 */   // Label 1007: @60771
     /*  60771 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(60826), // Rule ID 15065 //
     /*  60776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60807 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60813 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60824 */     GIR_RootConstrainSelectedInstOperands,
     /*  60825 */     // GIR_Coverage, 15065,
     /*  60825 */     GIR_EraseRootFromParent_Done,
     /*  60826 */   // Label 1008: @60826
     /*  60826 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(60881), // Rule ID 15061 //
     /*  60831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60862 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60868 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60879 */     GIR_RootConstrainSelectedInstOperands,
     /*  60880 */     // GIR_Coverage, 15061,
     /*  60880 */     GIR_EraseRootFromParent_Done,
     /*  60881 */   // Label 1009: @60881
     /*  60881 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(60936), // Rule ID 15064 //
     /*  60886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60917 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60923 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60934 */     GIR_RootConstrainSelectedInstOperands,
     /*  60935 */     // GIR_Coverage, 15064,
     /*  60935 */     GIR_EraseRootFromParent_Done,
     /*  60936 */   // Label 1010: @60936
     /*  60936 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(60991), // Rule ID 7530 //
     /*  60941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60972 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60978 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60989 */     GIR_RootConstrainSelectedInstOperands,
     /*  60990 */     // GIR_Coverage, 7530,
     /*  60990 */     GIR_EraseRootFromParent_Done,
     /*  60991 */   // Label 1011: @60991
     /*  60991 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(61046), // Rule ID 7531 //
     /*  60996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  61011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  61015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61027 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61033 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  61033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61044 */     GIR_RootConstrainSelectedInstOperands,
     /*  61045 */     // GIR_Coverage, 7531,
     /*  61045 */     GIR_EraseRootFromParent_Done,
     /*  61046 */   // Label 1012: @61046
     /*  61046 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(61061), // Rule ID 3143 //
     /*  61051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61054 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  61054 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  61059 */     GIR_RootConstrainSelectedInstOperands,
     /*  61060 */     // GIR_Coverage, 3143,
     /*  61060 */     GIR_Done,
     /*  61061 */   // Label 1013: @61061
     /*  61061 */   GIM_Reject,
     /*  61062 */ // Label 1004: @61062
     /*  61062 */ GIM_Reject,
     /*  61063 */ // Label 858: @61063
     /*  61063 */ GIM_Reject,
     /*  61064 */ // Label 6: @61064
     /*  61064 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1032*/ GIMT_Encode4(86178),
     /*  61075 */ /*GILLT_s32*//*Label 1014*/ GIMT_Encode4(61163),
     /*  61079 */ /*GILLT_s64*//*Label 1015*/ GIMT_Encode4(61523), GIMT_Encode4(0),
     /*  61087 */ /*GILLT_v2s32*//*Label 1016*/ GIMT_Encode4(63422),
     /*  61091 */ /*GILLT_v2s64*//*Label 1017*/ GIMT_Encode4(64730),
     /*  61095 */ /*GILLT_v4s16*//*Label 1018*/ GIMT_Encode4(66038),
     /*  61099 */ /*GILLT_v4s32*//*Label 1019*/ GIMT_Encode4(67346),
     /*  61103 */ /*GILLT_v8s8*//*Label 1020*/ GIMT_Encode4(68654),
     /*  61107 */ /*GILLT_v8s16*//*Label 1021*/ GIMT_Encode4(69962),
     /*  61111 */ /*GILLT_v16s8*//*Label 1022*/ GIMT_Encode4(71270),
     /*  61115 */ /*GILLT_nxv1s1*//*Label 1023*/ GIMT_Encode4(72578),
     /*  61119 */ /*GILLT_nxv2s1*//*Label 1024*/ GIMT_Encode4(72610), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  61131 */ /*GILLT_nxv2s64*//*Label 1025*/ GIMT_Encode4(72642),
     /*  61135 */ /*GILLT_nxv4s1*//*Label 1026*/ GIMT_Encode4(76002), GIMT_Encode4(0),
     /*  61143 */ /*GILLT_nxv4s32*//*Label 1027*/ GIMT_Encode4(76034),
     /*  61147 */ /*GILLT_nxv8s1*//*Label 1028*/ GIMT_Encode4(79394),
     /*  61151 */ /*GILLT_nxv8s16*//*Label 1029*/ GIMT_Encode4(79426),
     /*  61155 */ /*GILLT_nxv16s1*//*Label 1030*/ GIMT_Encode4(82786),
     /*  61159 */ /*GILLT_nxv16s8*//*Label 1031*/ GIMT_Encode4(82818),
     /*  61163 */ // Label 1014: @61163
     /*  61163 */ GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(61522),
     /*  61168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  61171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61174 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(61229), // Rule ID 13329 //
     /*  61179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61199 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61216 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  61219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61227 */     GIR_RootConstrainSelectedInstOperands,
     /*  61228 */     // GIR_Coverage, 13329,
     /*  61228 */     GIR_EraseRootFromParent_Done,
     /*  61229 */   // Label 1034: @61229
     /*  61229 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(61284), // Rule ID 174 //
     /*  61234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61258 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61271 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  61274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61278 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61282 */     GIR_RootConstrainSelectedInstOperands,
     /*  61283 */     // GIR_Coverage, 174,
     /*  61283 */     GIR_EraseRootFromParent_Done,
     /*  61284 */   // Label 1035: @61284
     /*  61284 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(61325), // Rule ID 146 //
     /*  61289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  61293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61305 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  61309 */     // MIs[1] Operand 1
     /*  61309 */     // No operand predicates
     /*  61309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61311 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  61311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  61314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61318 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  61323 */     GIR_RootConstrainSelectedInstOperands,
     /*  61324 */     // GIR_Coverage, 146,
     /*  61324 */     GIR_EraseRootFromParent_Done,
     /*  61325 */   // Label 1036: @61325
     /*  61325 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(61358), // Rule ID 13331 //
     /*  61330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61345 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  61348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61356 */     GIR_RootConstrainSelectedInstOperands,
     /*  61357 */     // GIR_Coverage, 13331,
     /*  61357 */     GIR_EraseRootFromParent_Done,
     /*  61358 */   // Label 1037: @61358
     /*  61358 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(61391), // Rule ID 178 //
     /*  61363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  61378 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  61378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  61381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61389 */     GIR_RootConstrainSelectedInstOperands,
     /*  61390 */     // GIR_Coverage, 178,
     /*  61390 */     GIR_EraseRootFromParent_Done,
     /*  61391 */   // Label 1038: @61391
     /*  61391 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(61444), // Rule ID 13327 //
     /*  61396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61421 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61431 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  61434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  61442 */     GIR_RootConstrainSelectedInstOperands,
     /*  61443 */     // GIR_Coverage, 13327,
     /*  61443 */     GIR_EraseRootFromParent_Done,
     /*  61444 */   // Label 1039: @61444
     /*  61444 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(61497), // Rule ID 172 //
     /*  61449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  61469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  61473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61478 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61484 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  61487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  61495 */     GIR_RootConstrainSelectedInstOperands,
     /*  61496 */     // GIR_Coverage, 172,
     /*  61496 */     GIR_EraseRootFromParent_Done,
     /*  61497 */   // Label 1040: @61497
     /*  61497 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(61521), // Rule ID 176 //
     /*  61502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61514 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  61519 */     GIR_RootConstrainSelectedInstOperands,
     /*  61520 */     // GIR_Coverage, 176,
     /*  61520 */     GIR_Done,
     /*  61521 */   // Label 1041: @61521
     /*  61521 */   GIM_Reject,
     /*  61522 */ // Label 1033: @61522
     /*  61522 */ GIM_Reject,
     /*  61523 */ // Label 1015: @61523
     /*  61523 */ GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(63421),
     /*  61528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  61531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  61534 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(61656), // Rule ID 4017 //
     /*  61539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61575 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61580 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61584 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61595 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61599 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61603 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61607 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61611 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61615 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61619 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61623 */     // MIs[4] Rn
     /*  61623 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61628 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61632 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61643 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61645 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61654 */     GIR_RootConstrainSelectedInstOperands,
     /*  61655 */     // GIR_Coverage, 4017,
     /*  61655 */     GIR_EraseRootFromParent_Done,
     /*  61656 */   // Label 1043: @61656
     /*  61656 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(61778), // Rule ID 13879 //
     /*  61661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61702 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61706 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61729 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61733 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61737 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61741 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61745 */     // MIs[4] Rn
     /*  61745 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61750 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61754 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61765 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61767 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61776 */     GIR_RootConstrainSelectedInstOperands,
     /*  61777 */     // GIR_Coverage, 13879,
     /*  61777 */     GIR_EraseRootFromParent_Done,
     /*  61778 */   // Label 1044: @61778
     /*  61778 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(61833), // Rule ID 13330 //
     /*  61783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61803 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61820 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61831 */     GIR_RootConstrainSelectedInstOperands,
     /*  61832 */     // GIR_Coverage, 13330,
     /*  61832 */     GIR_EraseRootFromParent_Done,
     /*  61833 */   // Label 1045: @61833
     /*  61833 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(61888), // Rule ID 175 //
     /*  61838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61862 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61875 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61882 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61886 */     GIR_RootConstrainSelectedInstOperands,
     /*  61887 */     // GIR_Coverage, 175,
     /*  61887 */     GIR_EraseRootFromParent_Done,
     /*  61888 */   // Label 1046: @61888
     /*  61888 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(61997), // Rule ID 13679 //
     /*  61893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61941 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61947 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61958 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61962 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61966 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61971 */     // MIs[4] LHS
     /*  61971 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61976 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61978 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61995 */     GIR_RootConstrainSelectedInstOperands,
     /*  61996 */     // GIR_Coverage, 13679,
     /*  61996 */     GIR_EraseRootFromParent_Done,
     /*  61997 */   // Label 1047: @61997
     /*  61997 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(62106), // Rule ID 13678 //
     /*  62002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62050 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62071 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  62075 */     // MIs[4] LHS
     /*  62075 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62080 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62085 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62087 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  62104 */     GIR_RootConstrainSelectedInstOperands,
     /*  62105 */     // GIR_Coverage, 13678,
     /*  62105 */     GIR_EraseRootFromParent_Done,
     /*  62106 */   // Label 1048: @62106
     /*  62106 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(62215), // Rule ID 13681 //
     /*  62111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62164 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62170 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62176 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62180 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  62184 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62189 */     // MIs[4] LHS
     /*  62189 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62194 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62196 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  62209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62213 */     GIR_RootConstrainSelectedInstOperands,
     /*  62214 */     // GIR_Coverage, 13681,
     /*  62214 */     GIR_EraseRootFromParent_Done,
     /*  62215 */   // Label 1049: @62215
     /*  62215 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(62324), // Rule ID 13680 //
     /*  62220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62273 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62279 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  62281 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  62285 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62289 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  62293 */     // MIs[4] LHS
     /*  62293 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62298 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62303 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62305 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  62314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  62318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  62322 */     GIR_RootConstrainSelectedInstOperands,
     /*  62323 */     // GIR_Coverage, 13680,
     /*  62323 */     GIR_EraseRootFromParent_Done,
     /*  62324 */   // Label 1050: @62324
     /*  62324 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(62433), // Rule ID 2471 //
     /*  62329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62386 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62390 */     // MIs[3] LHS
     /*  62390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62395 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62399 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62412 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62414 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62431 */     GIR_RootConstrainSelectedInstOperands,
     /*  62432 */     // GIR_Coverage, 2471,
     /*  62432 */     GIR_EraseRootFromParent_Done,
     /*  62433 */   // Label 1051: @62433
     /*  62433 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(62542), // Rule ID 13676 //
     /*  62438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62495 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62499 */     // MIs[3] LHS
     /*  62499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62508 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62514 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62521 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62523 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62540 */     GIR_RootConstrainSelectedInstOperands,
     /*  62541 */     // GIR_Coverage, 13676,
     /*  62541 */     GIR_EraseRootFromParent_Done,
     /*  62542 */   // Label 1052: @62542
     /*  62542 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(62651), // Rule ID 13675 //
     /*  62547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62609 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62613 */     // MIs[3] LHS
     /*  62613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62618 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62622 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62632 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62649 */     GIR_RootConstrainSelectedInstOperands,
     /*  62650 */     // GIR_Coverage, 13675,
     /*  62650 */     GIR_EraseRootFromParent_Done,
     /*  62651 */   // Label 1053: @62651
     /*  62651 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(62760), // Rule ID 13677 //
     /*  62656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62697 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62701 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62722 */     // MIs[3] LHS
     /*  62722 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62727 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62731 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62737 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62739 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62741 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62758 */     GIR_RootConstrainSelectedInstOperands,
     /*  62759 */     // GIR_Coverage, 13677,
     /*  62759 */     GIR_EraseRootFromParent_Done,
     /*  62760 */   // Label 1054: @62760
     /*  62760 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(62801), // Rule ID 147 //
     /*  62765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  62769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62781 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  62785 */     // MIs[1] Operand 1
     /*  62785 */     // No operand predicates
     /*  62785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62787 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  62787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  62790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62794 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  62799 */     GIR_RootConstrainSelectedInstOperands,
     /*  62800 */     // GIR_Coverage, 147,
     /*  62800 */     GIR_EraseRootFromParent_Done,
     /*  62801 */   // Label 1055: @62801
     /*  62801 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(62834), // Rule ID 13332 //
     /*  62806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62821 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62828 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62832 */     GIR_RootConstrainSelectedInstOperands,
     /*  62833 */     // GIR_Coverage, 13332,
     /*  62833 */     GIR_EraseRootFromParent_Done,
     /*  62834 */   // Label 1056: @62834
     /*  62834 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(62867), // Rule ID 179 //
     /*  62839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62854 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62861 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62865 */     GIR_RootConstrainSelectedInstOperands,
     /*  62866 */     // GIR_Coverage, 179,
     /*  62866 */     GIR_EraseRootFromParent_Done,
     /*  62867 */   // Label 1057: @62867
     /*  62867 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(62934), // Rule ID 13615 //
     /*  62872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62896 */     // MIs[1] imm
     /*  62896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62908 */     // MIs[2] Operand 1
     /*  62908 */     // No operand predicates
     /*  62908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62912 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62918 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62932 */     GIR_RootConstrainSelectedInstOperands,
     /*  62933 */     // GIR_Coverage, 13615,
     /*  62933 */     GIR_EraseRootFromParent_Done,
     /*  62934 */   // Label 1058: @62934
     /*  62934 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(63001), // Rule ID 13618 //
     /*  62939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62963 */     // MIs[1] imm
     /*  62963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62971 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62975 */     // MIs[2] Operand 1
     /*  62975 */     // No operand predicates
     /*  62975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62979 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62985 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62999 */     GIR_RootConstrainSelectedInstOperands,
     /*  63000 */     // GIR_Coverage, 13618,
     /*  63000 */     GIR_EraseRootFromParent_Done,
     /*  63001 */   // Label 1059: @63001
     /*  63001 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(63054), // Rule ID 13328 //
     /*  63006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63031 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63041 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  63044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  63048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  63052 */     GIR_RootConstrainSelectedInstOperands,
     /*  63053 */     // GIR_Coverage, 13328,
     /*  63053 */     GIR_EraseRootFromParent_Done,
     /*  63054 */   // Label 1060: @63054
     /*  63054 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(63121), // Rule ID 2122 //
     /*  63059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  63078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63087 */     // MIs[1] imm
     /*  63087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  63099 */     // MIs[2] Operand 1
     /*  63099 */     // No operand predicates
     /*  63099 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63105 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  63108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63119 */     GIR_RootConstrainSelectedInstOperands,
     /*  63120 */     // GIR_Coverage, 2122,
     /*  63120 */     GIR_EraseRootFromParent_Done,
     /*  63121 */   // Label 1061: @63121
     /*  63121 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(63188), // Rule ID 2131 //
     /*  63126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  63145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63154 */     // MIs[1] imm
     /*  63154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63162 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  63166 */     // MIs[2] Operand 1
     /*  63166 */     // No operand predicates
     /*  63166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  63170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63172 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  63172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  63175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  63179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  63183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  63186 */     GIR_RootConstrainSelectedInstOperands,
     /*  63187 */     // GIR_Coverage, 2131,
     /*  63187 */     GIR_EraseRootFromParent_Done,
     /*  63188 */   // Label 1062: @63188
     /*  63188 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(63241), // Rule ID 173 //
     /*  63193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63222 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63228 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  63231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  63235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  63239 */     GIR_RootConstrainSelectedInstOperands,
     /*  63240 */     // GIR_Coverage, 173,
     /*  63240 */     GIR_EraseRootFromParent_Done,
     /*  63241 */   // Label 1063: @63241
     /*  63241 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(63305), // Rule ID 13970 //
     /*  63246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63278 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63284 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63292 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63297 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  63299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63303 */     GIR_RootConstrainSelectedInstOperands,
     /*  63304 */     // GIR_Coverage, 13970,
     /*  63304 */     GIR_EraseRootFromParent_Done,
     /*  63305 */   // Label 1064: @63305
     /*  63305 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(63369), // Rule ID 5092 //
     /*  63310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63346 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63352 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63356 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63361 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  63363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63367 */     GIR_RootConstrainSelectedInstOperands,
     /*  63368 */     // GIR_Coverage, 5092,
     /*  63368 */     GIR_EraseRootFromParent_Done,
     /*  63369 */   // Label 1065: @63369
     /*  63369 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(63393), // Rule ID 177 //
     /*  63374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63386 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  63391 */     GIR_RootConstrainSelectedInstOperands,
     /*  63392 */     // GIR_Coverage, 177,
     /*  63392 */     GIR_Done,
     /*  63393 */   // Label 1066: @63393
     /*  63393 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(63420), // Rule ID 5098 //
     /*  63398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63413 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  63418 */     GIR_RootConstrainSelectedInstOperands,
     /*  63419 */     // GIR_Coverage, 5098,
     /*  63419 */     GIR_Done,
     /*  63420 */   // Label 1067: @63420
     /*  63420 */   GIM_Reject,
     /*  63421 */ // Label 1042: @63421
     /*  63421 */ GIM_Reject,
     /*  63422 */ // Label 1016: @63422
     /*  63422 */ GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(64729),
     /*  63427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63433 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(63542), // Rule ID 13672 //
     /*  63438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63486 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63492 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63499 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63503 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63507 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63511 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63516 */     // MIs[4] LHS
     /*  63516 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63521 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63523 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63540 */     GIR_RootConstrainSelectedInstOperands,
     /*  63541 */     // GIR_Coverage, 13672,
     /*  63541 */     GIR_EraseRootFromParent_Done,
     /*  63542 */   // Label 1069: @63542
     /*  63542 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(63651), // Rule ID 13671 //
     /*  63547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63582 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63595 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63601 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63616 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63620 */     // MIs[4] LHS
     /*  63620 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63625 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63632 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63649 */     GIR_RootConstrainSelectedInstOperands,
     /*  63650 */     // GIR_Coverage, 13671,
     /*  63650 */     GIR_EraseRootFromParent_Done,
     /*  63651 */   // Label 1070: @63651
     /*  63651 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(63760), // Rule ID 13674 //
     /*  63656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63700 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63705 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63709 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63715 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63717 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63721 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63725 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63729 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63734 */     // MIs[4] LHS
     /*  63734 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63739 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63741 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63758 */     GIR_RootConstrainSelectedInstOperands,
     /*  63759 */     // GIR_Coverage, 13674,
     /*  63759 */     GIR_EraseRootFromParent_Done,
     /*  63760 */   // Label 1071: @63760
     /*  63760 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(63869), // Rule ID 13673 //
     /*  63765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63818 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63826 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63830 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63834 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63838 */     // MIs[4] LHS
     /*  63838 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63843 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63848 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63850 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63867 */     GIR_RootConstrainSelectedInstOperands,
     /*  63868 */     // GIR_Coverage, 13673,
     /*  63868 */     GIR_EraseRootFromParent_Done,
     /*  63869 */   // Label 1072: @63869
     /*  63869 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(63978), // Rule ID 2470 //
     /*  63874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63931 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63935 */     // MIs[3] LHS
     /*  63935 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63940 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63944 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63950 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63957 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63959 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63976 */     GIR_RootConstrainSelectedInstOperands,
     /*  63977 */     // GIR_Coverage, 2470,
     /*  63977 */     GIR_EraseRootFromParent_Done,
     /*  63978 */   // Label 1073: @63978
     /*  63978 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(64087), // Rule ID 13669 //
     /*  63983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  64036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64040 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64044 */     // MIs[3] LHS
     /*  64044 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64049 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64053 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64059 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64066 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64068 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64085 */     GIR_RootConstrainSelectedInstOperands,
     /*  64086 */     // GIR_Coverage, 13669,
     /*  64086 */     GIR_EraseRootFromParent_Done,
     /*  64087 */   // Label 1074: @64087
     /*  64087 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(64196), // Rule ID 13668 //
     /*  64092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64154 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64158 */     // MIs[3] LHS
     /*  64158 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64163 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64167 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64175 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64177 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64194 */     GIR_RootConstrainSelectedInstOperands,
     /*  64195 */     // GIR_Coverage, 13668,
     /*  64195 */     GIR_EraseRootFromParent_Done,
     /*  64196 */   // Label 1075: @64196
     /*  64196 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(64305), // Rule ID 13670 //
     /*  64201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64263 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64267 */     // MIs[3] LHS
     /*  64267 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64272 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64276 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64282 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64284 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64286 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64303 */     GIR_RootConstrainSelectedInstOperands,
     /*  64304 */     // GIR_Coverage, 13670,
     /*  64304 */     GIR_EraseRootFromParent_Done,
     /*  64305 */   // Label 1076: @64305
     /*  64305 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(64372), // Rule ID 13635 //
     /*  64310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64334 */     // MIs[1] imm
     /*  64334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64342 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64346 */     // MIs[2] Operand 1
     /*  64346 */     // No operand predicates
     /*  64346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64350 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64356 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64370 */     GIR_RootConstrainSelectedInstOperands,
     /*  64371 */     // GIR_Coverage, 13635,
     /*  64371 */     GIR_EraseRootFromParent_Done,
     /*  64372 */   // Label 1077: @64372
     /*  64372 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(64439), // Rule ID 13656 //
     /*  64377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64401 */     // MIs[1] imm
     /*  64401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64409 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64413 */     // MIs[2] Operand 1
     /*  64413 */     // No operand predicates
     /*  64413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64417 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64423 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64437 */     GIR_RootConstrainSelectedInstOperands,
     /*  64438 */     // GIR_Coverage, 13656,
     /*  64438 */     GIR_EraseRootFromParent_Done,
     /*  64439 */   // Label 1078: @64439
     /*  64439 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(64506), // Rule ID 2239 //
     /*  64444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64472 */     // MIs[1] imm
     /*  64472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64480 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64484 */     // MIs[2] Operand 1
     /*  64484 */     // No operand predicates
     /*  64484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64490 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64495 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64504 */     GIR_RootConstrainSelectedInstOperands,
     /*  64505 */     // GIR_Coverage, 2239,
     /*  64505 */     GIR_EraseRootFromParent_Done,
     /*  64506 */   // Label 1079: @64506
     /*  64506 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(64573), // Rule ID 2298 //
     /*  64511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64539 */     // MIs[1] imm
     /*  64539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64547 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64551 */     // MIs[2] Operand 1
     /*  64551 */     // No operand predicates
     /*  64551 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64557 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64571 */     GIR_RootConstrainSelectedInstOperands,
     /*  64572 */     // GIR_Coverage, 2298,
     /*  64572 */     GIR_EraseRootFromParent_Done,
     /*  64573 */   // Label 1080: @64573
     /*  64573 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(64637), // Rule ID 13969 //
     /*  64578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64610 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64616 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64624 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64629 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64635 */     GIR_RootConstrainSelectedInstOperands,
     /*  64636 */     // GIR_Coverage, 13969,
     /*  64636 */     GIR_EraseRootFromParent_Done,
     /*  64637 */   // Label 1081: @64637
     /*  64637 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(64701), // Rule ID 5091 //
     /*  64642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64678 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64684 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64688 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64693 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64699 */     GIR_RootConstrainSelectedInstOperands,
     /*  64700 */     // GIR_Coverage, 5091,
     /*  64700 */     GIR_EraseRootFromParent_Done,
     /*  64701 */   // Label 1082: @64701
     /*  64701 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(64728), // Rule ID 5097 //
     /*  64706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64721 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64726 */     GIR_RootConstrainSelectedInstOperands,
     /*  64727 */     // GIR_Coverage, 5097,
     /*  64727 */     GIR_Done,
     /*  64728 */   // Label 1083: @64728
     /*  64728 */   GIM_Reject,
     /*  64729 */ // Label 1068: @64729
     /*  64729 */ GIM_Reject,
     /*  64730 */ // Label 1017: @64730
     /*  64730 */ GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(66037),
     /*  64735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64741 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(64850), // Rule ID 13700 //
     /*  64746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64794 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64800 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64807 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64811 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64815 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64819 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64824 */     // MIs[4] LHS
     /*  64824 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64829 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64831 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64848 */     GIR_RootConstrainSelectedInstOperands,
     /*  64849 */     // GIR_Coverage, 13700,
     /*  64849 */     GIR_EraseRootFromParent_Done,
     /*  64850 */   // Label 1085: @64850
     /*  64850 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(64959), // Rule ID 13699 //
     /*  64855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64903 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64909 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64916 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64920 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64924 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64928 */     // MIs[4] LHS
     /*  64928 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64933 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64938 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64940 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64957 */     GIR_RootConstrainSelectedInstOperands,
     /*  64958 */     // GIR_Coverage, 13699,
     /*  64958 */     GIR_EraseRootFromParent_Done,
     /*  64959 */   // Label 1086: @64959
     /*  64959 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(65068), // Rule ID 13702 //
     /*  64964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65017 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65023 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65025 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65029 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65033 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65037 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65042 */     // MIs[4] LHS
     /*  65042 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65047 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65049 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65066 */     GIR_RootConstrainSelectedInstOperands,
     /*  65067 */     // GIR_Coverage, 13702,
     /*  65067 */     GIR_EraseRootFromParent_Done,
     /*  65068 */   // Label 1087: @65068
     /*  65068 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(65177), // Rule ID 13701 //
     /*  65073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65126 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65132 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65134 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65138 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65142 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65146 */     // MIs[4] LHS
     /*  65146 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65151 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65156 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65158 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65175 */     GIR_RootConstrainSelectedInstOperands,
     /*  65176 */     // GIR_Coverage, 13701,
     /*  65176 */     GIR_EraseRootFromParent_Done,
     /*  65177 */   // Label 1088: @65177
     /*  65177 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(65286), // Rule ID 2474 //
     /*  65182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65239 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65243 */     // MIs[3] LHS
     /*  65243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65252 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65258 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65265 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65267 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65284 */     GIR_RootConstrainSelectedInstOperands,
     /*  65285 */     // GIR_Coverage, 2474,
     /*  65285 */     GIR_EraseRootFromParent_Done,
     /*  65286 */   // Label 1089: @65286
     /*  65286 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(65395), // Rule ID 13697 //
     /*  65291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65348 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65352 */     // MIs[3] LHS
     /*  65352 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65357 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65361 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65367 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65374 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65376 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65393 */     GIR_RootConstrainSelectedInstOperands,
     /*  65394 */     // GIR_Coverage, 13697,
     /*  65394 */     GIR_EraseRootFromParent_Done,
     /*  65395 */   // Label 1090: @65395
     /*  65395 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(65504), // Rule ID 13696 //
     /*  65400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65462 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65466 */     // MIs[3] LHS
     /*  65466 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65471 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65475 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65483 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65485 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65502 */     GIR_RootConstrainSelectedInstOperands,
     /*  65503 */     // GIR_Coverage, 13696,
     /*  65503 */     GIR_EraseRootFromParent_Done,
     /*  65504 */   // Label 1091: @65504
     /*  65504 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(65613), // Rule ID 13698 //
     /*  65509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65571 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65575 */     // MIs[3] LHS
     /*  65575 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65580 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65584 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65590 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65592 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65594 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65611 */     GIR_RootConstrainSelectedInstOperands,
     /*  65612 */     // GIR_Coverage, 13698,
     /*  65612 */     GIR_EraseRootFromParent_Done,
     /*  65613 */   // Label 1092: @65613
     /*  65613 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(65680), // Rule ID 13639 //
     /*  65618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65642 */     // MIs[1] imm
     /*  65642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65650 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65654 */     // MIs[2] Operand 1
     /*  65654 */     // No operand predicates
     /*  65654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65658 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65662 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65664 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65678 */     GIR_RootConstrainSelectedInstOperands,
     /*  65679 */     // GIR_Coverage, 13639,
     /*  65679 */     GIR_EraseRootFromParent_Done,
     /*  65680 */   // Label 1093: @65680
     /*  65680 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65747), // Rule ID 13660 //
     /*  65685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65709 */     // MIs[1] imm
     /*  65709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65717 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65721 */     // MIs[2] Operand 1
     /*  65721 */     // No operand predicates
     /*  65721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65725 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65731 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65745 */     GIR_RootConstrainSelectedInstOperands,
     /*  65746 */     // GIR_Coverage, 13660,
     /*  65746 */     GIR_EraseRootFromParent_Done,
     /*  65747 */   // Label 1094: @65747
     /*  65747 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(65814), // Rule ID 2243 //
     /*  65752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65780 */     // MIs[1] imm
     /*  65780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65788 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65792 */     // MIs[2] Operand 1
     /*  65792 */     // No operand predicates
     /*  65792 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65798 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65812 */     GIR_RootConstrainSelectedInstOperands,
     /*  65813 */     // GIR_Coverage, 2243,
     /*  65813 */     GIR_EraseRootFromParent_Done,
     /*  65814 */   // Label 1095: @65814
     /*  65814 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(65881), // Rule ID 2302 //
     /*  65819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65847 */     // MIs[1] imm
     /*  65847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65855 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65859 */     // MIs[2] Operand 1
     /*  65859 */     // No operand predicates
     /*  65859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65865 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65879 */     GIR_RootConstrainSelectedInstOperands,
     /*  65880 */     // GIR_Coverage, 2302,
     /*  65880 */     GIR_EraseRootFromParent_Done,
     /*  65881 */   // Label 1096: @65881
     /*  65881 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(65945), // Rule ID 13973 //
     /*  65886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65918 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65924 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65932 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65937 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  65939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65943 */     GIR_RootConstrainSelectedInstOperands,
     /*  65944 */     // GIR_Coverage, 13973,
     /*  65944 */     GIR_EraseRootFromParent_Done,
     /*  65945 */   // Label 1097: @65945
     /*  65945 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(66009), // Rule ID 5095 //
     /*  65950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65986 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65992 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65996 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66001 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  66003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66007 */     GIR_RootConstrainSelectedInstOperands,
     /*  66008 */     // GIR_Coverage, 5095,
     /*  66008 */     GIR_EraseRootFromParent_Done,
     /*  66009 */   // Label 1098: @66009
     /*  66009 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(66036), // Rule ID 5101 //
     /*  66014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66029 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  66029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  66034 */     GIR_RootConstrainSelectedInstOperands,
     /*  66035 */     // GIR_Coverage, 5101,
     /*  66035 */     GIR_Done,
     /*  66036 */   // Label 1099: @66036
     /*  66036 */   GIM_Reject,
     /*  66037 */ // Label 1084: @66037
     /*  66037 */ GIM_Reject,
     /*  66038 */ // Label 1018: @66038
     /*  66038 */ GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(67345),
     /*  66043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66049 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(66158), // Rule ID 13665 //
     /*  66054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66102 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66115 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66119 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66123 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66127 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66132 */     // MIs[4] LHS
     /*  66132 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66137 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66139 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66156 */     GIR_RootConstrainSelectedInstOperands,
     /*  66157 */     // GIR_Coverage, 13665,
     /*  66157 */     GIR_EraseRootFromParent_Done,
     /*  66158 */   // Label 1101: @66158
     /*  66158 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(66267), // Rule ID 13664 //
     /*  66163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66202 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66211 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66217 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66224 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66228 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66232 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66236 */     // MIs[4] LHS
     /*  66236 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66241 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66246 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66248 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66265 */     GIR_RootConstrainSelectedInstOperands,
     /*  66266 */     // GIR_Coverage, 13664,
     /*  66266 */     GIR_EraseRootFromParent_Done,
     /*  66267 */   // Label 1102: @66267
     /*  66267 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(66376), // Rule ID 13667 //
     /*  66272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66325 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66331 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66333 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66337 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66341 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66345 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66350 */     // MIs[4] LHS
     /*  66350 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66355 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66357 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66374 */     GIR_RootConstrainSelectedInstOperands,
     /*  66375 */     // GIR_Coverage, 13667,
     /*  66375 */     GIR_EraseRootFromParent_Done,
     /*  66376 */   // Label 1103: @66376
     /*  66376 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(66485), // Rule ID 13666 //
     /*  66381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66434 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66440 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66442 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66446 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66450 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66454 */     // MIs[4] LHS
     /*  66454 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66459 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66464 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66466 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66483 */     GIR_RootConstrainSelectedInstOperands,
     /*  66484 */     // GIR_Coverage, 13666,
     /*  66484 */     GIR_EraseRootFromParent_Done,
     /*  66485 */   // Label 1104: @66485
     /*  66485 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(66594), // Rule ID 2469 //
     /*  66490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66547 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66551 */     // MIs[3] LHS
     /*  66551 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66556 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66560 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66566 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66568 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66573 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66575 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66592 */     GIR_RootConstrainSelectedInstOperands,
     /*  66593 */     // GIR_Coverage, 2469,
     /*  66593 */     GIR_EraseRootFromParent_Done,
     /*  66594 */   // Label 1105: @66594
     /*  66594 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(66703), // Rule ID 13662 //
     /*  66599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66656 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66660 */     // MIs[3] LHS
     /*  66660 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66665 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66669 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66682 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66684 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66701 */     GIR_RootConstrainSelectedInstOperands,
     /*  66702 */     // GIR_Coverage, 13662,
     /*  66702 */     GIR_EraseRootFromParent_Done,
     /*  66703 */   // Label 1106: @66703
     /*  66703 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(66812), // Rule ID 13661 //
     /*  66708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66753 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66770 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66774 */     // MIs[3] LHS
     /*  66774 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66779 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66783 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66791 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66793 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66810 */     GIR_RootConstrainSelectedInstOperands,
     /*  66811 */     // GIR_Coverage, 13661,
     /*  66811 */     GIR_EraseRootFromParent_Done,
     /*  66812 */   // Label 1107: @66812
     /*  66812 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(66921), // Rule ID 13663 //
     /*  66817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66862 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66879 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66883 */     // MIs[3] LHS
     /*  66883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66888 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66892 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66898 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66900 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66902 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66919 */     GIR_RootConstrainSelectedInstOperands,
     /*  66920 */     // GIR_Coverage, 13663,
     /*  66920 */     GIR_EraseRootFromParent_Done,
     /*  66921 */   // Label 1108: @66921
     /*  66921 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(66988), // Rule ID 13631 //
     /*  66926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66950 */     // MIs[1] imm
     /*  66950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66958 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66962 */     // MIs[2] Operand 1
     /*  66962 */     // No operand predicates
     /*  66962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66972 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66986 */     GIR_RootConstrainSelectedInstOperands,
     /*  66987 */     // GIR_Coverage, 13631,
     /*  66987 */     GIR_EraseRootFromParent_Done,
     /*  66988 */   // Label 1109: @66988
     /*  66988 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(67055), // Rule ID 13652 //
     /*  66993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67017 */     // MIs[1] imm
     /*  67017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67025 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67029 */     // MIs[2] Operand 1
     /*  67029 */     // No operand predicates
     /*  67029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67033 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67039 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  67042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67053 */     GIR_RootConstrainSelectedInstOperands,
     /*  67054 */     // GIR_Coverage, 13652,
     /*  67054 */     GIR_EraseRootFromParent_Done,
     /*  67055 */   // Label 1110: @67055
     /*  67055 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(67122), // Rule ID 2235 //
     /*  67060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67088 */     // MIs[1] imm
     /*  67088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67096 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67100 */     // MIs[2] Operand 1
     /*  67100 */     // No operand predicates
     /*  67100 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67106 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  67109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67120 */     GIR_RootConstrainSelectedInstOperands,
     /*  67121 */     // GIR_Coverage, 2235,
     /*  67121 */     GIR_EraseRootFromParent_Done,
     /*  67122 */   // Label 1111: @67122
     /*  67122 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(67189), // Rule ID 2294 //
     /*  67127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67155 */     // MIs[1] imm
     /*  67155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67163 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  67167 */     // MIs[2] Operand 1
     /*  67167 */     // No operand predicates
     /*  67167 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67173 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  67176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67187 */     GIR_RootConstrainSelectedInstOperands,
     /*  67188 */     // GIR_Coverage, 2294,
     /*  67188 */     GIR_EraseRootFromParent_Done,
     /*  67189 */   // Label 1112: @67189
     /*  67189 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(67253), // Rule ID 13968 //
     /*  67194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67226 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67232 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67240 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67245 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  67247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67251 */     GIR_RootConstrainSelectedInstOperands,
     /*  67252 */     // GIR_Coverage, 13968,
     /*  67252 */     GIR_EraseRootFromParent_Done,
     /*  67253 */   // Label 1113: @67253
     /*  67253 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(67317), // Rule ID 5090 //
     /*  67258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67294 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67300 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67304 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67309 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  67311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67315 */     GIR_RootConstrainSelectedInstOperands,
     /*  67316 */     // GIR_Coverage, 5090,
     /*  67316 */     GIR_EraseRootFromParent_Done,
     /*  67317 */   // Label 1114: @67317
     /*  67317 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(67344), // Rule ID 5096 //
     /*  67322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67337 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  67342 */     GIR_RootConstrainSelectedInstOperands,
     /*  67343 */     // GIR_Coverage, 5096,
     /*  67343 */     GIR_Done,
     /*  67344 */   // Label 1115: @67344
     /*  67344 */   GIM_Reject,
     /*  67345 */ // Label 1100: @67345
     /*  67345 */ GIM_Reject,
     /*  67346 */ // Label 1019: @67346
     /*  67346 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(68653),
     /*  67351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67357 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(67466), // Rule ID 13693 //
     /*  67362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67397 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67410 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67416 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67431 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67435 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67440 */     // MIs[4] LHS
     /*  67440 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67445 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67447 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67464 */     GIR_RootConstrainSelectedInstOperands,
     /*  67465 */     // GIR_Coverage, 13693,
     /*  67465 */     GIR_EraseRootFromParent_Done,
     /*  67466 */   // Label 1117: @67466
     /*  67466 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(67575), // Rule ID 13692 //
     /*  67471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67519 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67525 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67536 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67540 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67544 */     // MIs[4] LHS
     /*  67544 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67549 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67554 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67556 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67573 */     GIR_RootConstrainSelectedInstOperands,
     /*  67574 */     // GIR_Coverage, 13692,
     /*  67574 */     GIR_EraseRootFromParent_Done,
     /*  67575 */   // Label 1118: @67575
     /*  67575 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(67684), // Rule ID 13695 //
     /*  67580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67633 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67639 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67641 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67645 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67649 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67653 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67658 */     // MIs[4] LHS
     /*  67658 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67663 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67665 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67682 */     GIR_RootConstrainSelectedInstOperands,
     /*  67683 */     // GIR_Coverage, 13695,
     /*  67683 */     GIR_EraseRootFromParent_Done,
     /*  67684 */   // Label 1119: @67684
     /*  67684 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(67793), // Rule ID 13694 //
     /*  67689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67742 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67750 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67754 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67758 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67762 */     // MIs[4] LHS
     /*  67762 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67767 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67772 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67774 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67791 */     GIR_RootConstrainSelectedInstOperands,
     /*  67792 */     // GIR_Coverage, 13694,
     /*  67792 */     GIR_EraseRootFromParent_Done,
     /*  67793 */   // Label 1120: @67793
     /*  67793 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(67902), // Rule ID 2473 //
     /*  67798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67855 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67859 */     // MIs[3] LHS
     /*  67859 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67864 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67868 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67874 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67881 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67883 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67900 */     GIR_RootConstrainSelectedInstOperands,
     /*  67901 */     // GIR_Coverage, 2473,
     /*  67901 */     GIR_EraseRootFromParent_Done,
     /*  67902 */   // Label 1121: @67902
     /*  67902 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(68011), // Rule ID 13690 //
     /*  67907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67964 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67968 */     // MIs[3] LHS
     /*  67968 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67973 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67977 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67983 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67990 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67992 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  68009 */     GIR_RootConstrainSelectedInstOperands,
     /*  68010 */     // GIR_Coverage, 13690,
     /*  68010 */     GIR_EraseRootFromParent_Done,
     /*  68011 */   // Label 1122: @68011
     /*  68011 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(68120), // Rule ID 13689 //
     /*  68016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68078 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68082 */     // MIs[3] LHS
     /*  68082 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68087 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68091 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68097 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68099 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68101 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  68110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  68114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68118 */     GIR_RootConstrainSelectedInstOperands,
     /*  68119 */     // GIR_Coverage, 13689,
     /*  68119 */     GIR_EraseRootFromParent_Done,
     /*  68120 */   // Label 1123: @68120
     /*  68120 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(68229), // Rule ID 13691 //
     /*  68125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68187 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68191 */     // MIs[3] LHS
     /*  68191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68196 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68200 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68208 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68210 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68227 */     GIR_RootConstrainSelectedInstOperands,
     /*  68228 */     // GIR_Coverage, 13691,
     /*  68228 */     GIR_EraseRootFromParent_Done,
     /*  68229 */   // Label 1124: @68229
     /*  68229 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(68296), // Rule ID 13637 //
     /*  68234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68258 */     // MIs[1] imm
     /*  68258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68266 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68270 */     // MIs[2] Operand 1
     /*  68270 */     // No operand predicates
     /*  68270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68274 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68280 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68294 */     GIR_RootConstrainSelectedInstOperands,
     /*  68295 */     // GIR_Coverage, 13637,
     /*  68295 */     GIR_EraseRootFromParent_Done,
     /*  68296 */   // Label 1125: @68296
     /*  68296 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(68363), // Rule ID 13658 //
     /*  68301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68325 */     // MIs[1] imm
     /*  68325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68333 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68337 */     // MIs[2] Operand 1
     /*  68337 */     // No operand predicates
     /*  68337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68341 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68347 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68361 */     GIR_RootConstrainSelectedInstOperands,
     /*  68362 */     // GIR_Coverage, 13658,
     /*  68362 */     GIR_EraseRootFromParent_Done,
     /*  68363 */   // Label 1126: @68363
     /*  68363 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(68430), // Rule ID 2241 //
     /*  68368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68396 */     // MIs[1] imm
     /*  68396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68404 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68408 */     // MIs[2] Operand 1
     /*  68408 */     // No operand predicates
     /*  68408 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68414 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68428 */     GIR_RootConstrainSelectedInstOperands,
     /*  68429 */     // GIR_Coverage, 2241,
     /*  68429 */     GIR_EraseRootFromParent_Done,
     /*  68430 */   // Label 1127: @68430
     /*  68430 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(68497), // Rule ID 2300 //
     /*  68435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68463 */     // MIs[1] imm
     /*  68463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68471 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68475 */     // MIs[2] Operand 1
     /*  68475 */     // No operand predicates
     /*  68475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68481 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68495 */     GIR_RootConstrainSelectedInstOperands,
     /*  68496 */     // GIR_Coverage, 2300,
     /*  68496 */     GIR_EraseRootFromParent_Done,
     /*  68497 */   // Label 1128: @68497
     /*  68497 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(68561), // Rule ID 13972 //
     /*  68502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68534 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68540 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68548 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68553 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68559 */     GIR_RootConstrainSelectedInstOperands,
     /*  68560 */     // GIR_Coverage, 13972,
     /*  68560 */     GIR_EraseRootFromParent_Done,
     /*  68561 */   // Label 1129: @68561
     /*  68561 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(68625), // Rule ID 5094 //
     /*  68566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68602 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68608 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68612 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68617 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68623 */     GIR_RootConstrainSelectedInstOperands,
     /*  68624 */     // GIR_Coverage, 5094,
     /*  68624 */     GIR_EraseRootFromParent_Done,
     /*  68625 */   // Label 1130: @68625
     /*  68625 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(68652), // Rule ID 5100 //
     /*  68630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68645 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  68650 */     GIR_RootConstrainSelectedInstOperands,
     /*  68651 */     // GIR_Coverage, 5100,
     /*  68651 */     GIR_Done,
     /*  68652 */   // Label 1131: @68652
     /*  68652 */   GIM_Reject,
     /*  68653 */ // Label 1116: @68653
     /*  68653 */ GIM_Reject,
     /*  68654 */ // Label 1020: @68654
     /*  68654 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(69961),
     /*  68659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68665 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(68774), // Rule ID 13453 //
     /*  68670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68718 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68735 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68739 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68743 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68748 */     // MIs[4] Rd
     /*  68748 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68753 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68755 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68772 */     GIR_RootConstrainSelectedInstOperands,
     /*  68773 */     // GIR_Coverage, 13453,
     /*  68773 */     GIR_EraseRootFromParent_Done,
     /*  68774 */   // Label 1133: @68774
     /*  68774 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(68883), // Rule ID 13452 //
     /*  68779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68827 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68833 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68840 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68844 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68848 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68852 */     // MIs[4] Rd
     /*  68852 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68857 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68862 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68864 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68881 */     GIR_RootConstrainSelectedInstOperands,
     /*  68882 */     // GIR_Coverage, 13452,
     /*  68882 */     GIR_EraseRootFromParent_Done,
     /*  68883 */   // Label 1134: @68883
     /*  68883 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(68992), // Rule ID 13455 //
     /*  68888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68941 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68947 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68949 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68953 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68957 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68961 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68966 */     // MIs[4] Rd
     /*  68966 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68971 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68973 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68990 */     GIR_RootConstrainSelectedInstOperands,
     /*  68991 */     // GIR_Coverage, 13455,
     /*  68991 */     GIR_EraseRootFromParent_Done,
     /*  68992 */   // Label 1135: @68992
     /*  68992 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(69101), // Rule ID 13454 //
     /*  68997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69050 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69058 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69062 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69066 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69070 */     // MIs[4] Rd
     /*  69070 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69075 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69080 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69082 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  69091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  69095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69099 */     GIR_RootConstrainSelectedInstOperands,
     /*  69100 */     // GIR_Coverage, 13454,
     /*  69100 */     GIR_EraseRootFromParent_Done,
     /*  69101 */   // Label 1136: @69101
     /*  69101 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(69210), // Rule ID 1605 //
     /*  69106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69163 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69167 */     // MIs[3] Rd
     /*  69167 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69176 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69182 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69189 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69191 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  69200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  69204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  69208 */     GIR_RootConstrainSelectedInstOperands,
     /*  69209 */     // GIR_Coverage, 1605,
     /*  69209 */     GIR_EraseRootFromParent_Done,
     /*  69210 */   // Label 1137: @69210
     /*  69210 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(69319), // Rule ID 13450 //
     /*  69215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69272 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69276 */     // MIs[3] Rd
     /*  69276 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69281 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69285 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69291 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69298 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69300 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  69317 */     GIR_RootConstrainSelectedInstOperands,
     /*  69318 */     // GIR_Coverage, 13450,
     /*  69318 */     GIR_EraseRootFromParent_Done,
     /*  69319 */   // Label 1138: @69319
     /*  69319 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(69428), // Rule ID 13449 //
     /*  69324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69386 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69390 */     // MIs[3] Rd
     /*  69390 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69395 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69399 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69407 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69409 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  69418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  69422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69426 */     GIR_RootConstrainSelectedInstOperands,
     /*  69427 */     // GIR_Coverage, 13449,
     /*  69427 */     GIR_EraseRootFromParent_Done,
     /*  69428 */   // Label 1139: @69428
     /*  69428 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(69537), // Rule ID 13451 //
     /*  69433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69495 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69499 */     // MIs[3] Rd
     /*  69499 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69508 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69514 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69516 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69518 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69535 */     GIR_RootConstrainSelectedInstOperands,
     /*  69536 */     // GIR_Coverage, 13451,
     /*  69536 */     GIR_EraseRootFromParent_Done,
     /*  69537 */   // Label 1140: @69537
     /*  69537 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(69604), // Rule ID 13627 //
     /*  69542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69566 */     // MIs[1] imm
     /*  69566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69574 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69578 */     // MIs[2] Operand 1
     /*  69578 */     // No operand predicates
     /*  69578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69588 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69602 */     GIR_RootConstrainSelectedInstOperands,
     /*  69603 */     // GIR_Coverage, 13627,
     /*  69603 */     GIR_EraseRootFromParent_Done,
     /*  69604 */   // Label 1141: @69604
     /*  69604 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69671), // Rule ID 13648 //
     /*  69609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69633 */     // MIs[1] imm
     /*  69633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69641 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69645 */     // MIs[2] Operand 1
     /*  69645 */     // No operand predicates
     /*  69645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69649 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69655 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69669 */     GIR_RootConstrainSelectedInstOperands,
     /*  69670 */     // GIR_Coverage, 13648,
     /*  69670 */     GIR_EraseRootFromParent_Done,
     /*  69671 */   // Label 1142: @69671
     /*  69671 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(69738), // Rule ID 2231 //
     /*  69676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69704 */     // MIs[1] imm
     /*  69704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69712 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69716 */     // MIs[2] Operand 1
     /*  69716 */     // No operand predicates
     /*  69716 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69720 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69722 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69736 */     GIR_RootConstrainSelectedInstOperands,
     /*  69737 */     // GIR_Coverage, 2231,
     /*  69737 */     GIR_EraseRootFromParent_Done,
     /*  69738 */   // Label 1143: @69738
     /*  69738 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(69805), // Rule ID 2290 //
     /*  69743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69771 */     // MIs[1] imm
     /*  69771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69779 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69783 */     // MIs[2] Operand 1
     /*  69783 */     // No operand predicates
     /*  69783 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69789 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69803 */     GIR_RootConstrainSelectedInstOperands,
     /*  69804 */     // GIR_Coverage, 2290,
     /*  69804 */     GIR_EraseRootFromParent_Done,
     /*  69805 */   // Label 1144: @69805
     /*  69805 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(69869), // Rule ID 13447 //
     /*  69810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69842 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69848 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69856 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69867 */     GIR_RootConstrainSelectedInstOperands,
     /*  69868 */     // GIR_Coverage, 13447,
     /*  69868 */     GIR_EraseRootFromParent_Done,
     /*  69869 */   // Label 1145: @69869
     /*  69869 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(69933), // Rule ID 1601 //
     /*  69874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69910 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69916 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69920 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  69927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69931 */     GIR_RootConstrainSelectedInstOperands,
     /*  69932 */     // GIR_Coverage, 1601,
     /*  69932 */     GIR_EraseRootFromParent_Done,
     /*  69933 */   // Label 1146: @69933
     /*  69933 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(69960), // Rule ID 1603 //
     /*  69938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69953 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  69958 */     GIR_RootConstrainSelectedInstOperands,
     /*  69959 */     // GIR_Coverage, 1603,
     /*  69959 */     GIR_Done,
     /*  69960 */   // Label 1147: @69960
     /*  69960 */   GIM_Reject,
     /*  69961 */ // Label 1132: @69961
     /*  69961 */ GIM_Reject,
     /*  69962 */ // Label 1021: @69962
     /*  69962 */ GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71269),
     /*  69967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69973 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(70082), // Rule ID 13686 //
     /*  69978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70026 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70032 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70039 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70043 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70047 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70051 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70056 */     // MIs[4] LHS
     /*  70056 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70061 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70063 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  70076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  70080 */     GIR_RootConstrainSelectedInstOperands,
     /*  70081 */     // GIR_Coverage, 13686,
     /*  70081 */     GIR_EraseRootFromParent_Done,
     /*  70082 */   // Label 1149: @70082
     /*  70082 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(70191), // Rule ID 13685 //
     /*  70087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70122 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70135 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70141 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70148 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70152 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70156 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70160 */     // MIs[4] LHS
     /*  70160 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70165 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70170 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70172 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  70185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  70189 */     GIR_RootConstrainSelectedInstOperands,
     /*  70190 */     // GIR_Coverage, 13685,
     /*  70190 */     GIR_EraseRootFromParent_Done,
     /*  70191 */   // Label 1150: @70191
     /*  70191 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(70300), // Rule ID 13688 //
     /*  70196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70249 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70255 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70257 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70261 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70265 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70269 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70274 */     // MIs[4] LHS
     /*  70274 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70279 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70281 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  70294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70298 */     GIR_RootConstrainSelectedInstOperands,
     /*  70299 */     // GIR_Coverage, 13688,
     /*  70299 */     GIR_EraseRootFromParent_Done,
     /*  70300 */   // Label 1151: @70300
     /*  70300 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(70409), // Rule ID 13687 //
     /*  70305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70358 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70366 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70370 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70374 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70378 */     // MIs[4] LHS
     /*  70378 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70383 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70390 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  70403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70407 */     GIR_RootConstrainSelectedInstOperands,
     /*  70408 */     // GIR_Coverage, 13687,
     /*  70408 */     GIR_EraseRootFromParent_Done,
     /*  70409 */   // Label 1152: @70409
     /*  70409 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(70518), // Rule ID 2472 //
     /*  70414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70471 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70475 */     // MIs[3] LHS
     /*  70475 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70480 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70484 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70490 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70497 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70499 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70516 */     GIR_RootConstrainSelectedInstOperands,
     /*  70517 */     // GIR_Coverage, 2472,
     /*  70517 */     GIR_EraseRootFromParent_Done,
     /*  70518 */   // Label 1153: @70518
     /*  70518 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(70627), // Rule ID 13683 //
     /*  70523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70580 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70584 */     // MIs[3] LHS
     /*  70584 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70589 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70593 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70606 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70608 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70625 */     GIR_RootConstrainSelectedInstOperands,
     /*  70626 */     // GIR_Coverage, 13683,
     /*  70626 */     GIR_EraseRootFromParent_Done,
     /*  70627 */   // Label 1154: @70627
     /*  70627 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(70736), // Rule ID 13682 //
     /*  70632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70694 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70698 */     // MIs[3] LHS
     /*  70698 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70703 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70707 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70713 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70715 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70717 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70734 */     GIR_RootConstrainSelectedInstOperands,
     /*  70735 */     // GIR_Coverage, 13682,
     /*  70735 */     GIR_EraseRootFromParent_Done,
     /*  70736 */   // Label 1155: @70736
     /*  70736 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(70845), // Rule ID 13684 //
     /*  70741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70803 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70807 */     // MIs[3] LHS
     /*  70807 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70812 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70816 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70822 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70824 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70826 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70843 */     GIR_RootConstrainSelectedInstOperands,
     /*  70844 */     // GIR_Coverage, 13684,
     /*  70844 */     GIR_EraseRootFromParent_Done,
     /*  70845 */   // Label 1156: @70845
     /*  70845 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(70912), // Rule ID 13633 //
     /*  70850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70874 */     // MIs[1] imm
     /*  70874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70882 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70886 */     // MIs[2] Operand 1
     /*  70886 */     // No operand predicates
     /*  70886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70890 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70896 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70910 */     GIR_RootConstrainSelectedInstOperands,
     /*  70911 */     // GIR_Coverage, 13633,
     /*  70911 */     GIR_EraseRootFromParent_Done,
     /*  70912 */   // Label 1157: @70912
     /*  70912 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(70979), // Rule ID 13654 //
     /*  70917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70941 */     // MIs[1] imm
     /*  70941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70949 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70953 */     // MIs[2] Operand 1
     /*  70953 */     // No operand predicates
     /*  70953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70957 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70963 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70977 */     GIR_RootConstrainSelectedInstOperands,
     /*  70978 */     // GIR_Coverage, 13654,
     /*  70978 */     GIR_EraseRootFromParent_Done,
     /*  70979 */   // Label 1158: @70979
     /*  70979 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(71046), // Rule ID 2237 //
     /*  70984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71012 */     // MIs[1] imm
     /*  71012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71020 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  71024 */     // MIs[2] Operand 1
     /*  71024 */     // No operand predicates
     /*  71024 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71030 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  71033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71044 */     GIR_RootConstrainSelectedInstOperands,
     /*  71045 */     // GIR_Coverage, 2237,
     /*  71045 */     GIR_EraseRootFromParent_Done,
     /*  71046 */   // Label 1159: @71046
     /*  71046 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(71113), // Rule ID 2296 //
     /*  71051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71079 */     // MIs[1] imm
     /*  71079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71087 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  71091 */     // MIs[2] Operand 1
     /*  71091 */     // No operand predicates
     /*  71091 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71097 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  71100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71111 */     GIR_RootConstrainSelectedInstOperands,
     /*  71112 */     // GIR_Coverage, 2296,
     /*  71112 */     GIR_EraseRootFromParent_Done,
     /*  71113 */   // Label 1160: @71113
     /*  71113 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(71177), // Rule ID 13971 //
     /*  71118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71150 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71156 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71164 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71169 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  71171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71175 */     GIR_RootConstrainSelectedInstOperands,
     /*  71176 */     // GIR_Coverage, 13971,
     /*  71176 */     GIR_EraseRootFromParent_Done,
     /*  71177 */   // Label 1161: @71177
     /*  71177 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(71241), // Rule ID 5093 //
     /*  71182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71218 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71224 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71228 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71233 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  71235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71239 */     GIR_RootConstrainSelectedInstOperands,
     /*  71240 */     // GIR_Coverage, 5093,
     /*  71240 */     GIR_EraseRootFromParent_Done,
     /*  71241 */   // Label 1162: @71241
     /*  71241 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(71268), // Rule ID 5099 //
     /*  71246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71261 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  71266 */     GIR_RootConstrainSelectedInstOperands,
     /*  71267 */     // GIR_Coverage, 5099,
     /*  71267 */     GIR_Done,
     /*  71268 */   // Label 1163: @71268
     /*  71268 */   GIM_Reject,
     /*  71269 */ // Label 1148: @71269
     /*  71269 */ GIM_Reject,
     /*  71270 */ // Label 1022: @71270
     /*  71270 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72577),
     /*  71275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71281 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(71390), // Rule ID 13460 //
     /*  71286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71334 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71340 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71347 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71351 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71355 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71359 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71364 */     // MIs[4] Rd
     /*  71364 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71369 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71371 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71388 */     GIR_RootConstrainSelectedInstOperands,
     /*  71389 */     // GIR_Coverage, 13460,
     /*  71389 */     GIR_EraseRootFromParent_Done,
     /*  71390 */   // Label 1165: @71390
     /*  71390 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(71499), // Rule ID 13459 //
     /*  71395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71443 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71449 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71460 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71464 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71468 */     // MIs[4] Rd
     /*  71468 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71473 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71478 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71480 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71497 */     GIR_RootConstrainSelectedInstOperands,
     /*  71498 */     // GIR_Coverage, 13459,
     /*  71498 */     GIR_EraseRootFromParent_Done,
     /*  71499 */   // Label 1166: @71499
     /*  71499 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(71608), // Rule ID 13462 //
     /*  71504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71557 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71563 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71565 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71569 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71573 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71577 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71582 */     // MIs[4] Rd
     /*  71582 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71587 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71589 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71606 */     GIR_RootConstrainSelectedInstOperands,
     /*  71607 */     // GIR_Coverage, 13462,
     /*  71607 */     GIR_EraseRootFromParent_Done,
     /*  71608 */   // Label 1167: @71608
     /*  71608 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(71717), // Rule ID 13461 //
     /*  71613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71666 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71672 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71674 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71678 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71682 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71686 */     // MIs[4] Rd
     /*  71686 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71691 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71696 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71698 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71715 */     GIR_RootConstrainSelectedInstOperands,
     /*  71716 */     // GIR_Coverage, 13461,
     /*  71716 */     GIR_EraseRootFromParent_Done,
     /*  71717 */   // Label 1168: @71717
     /*  71717 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(71826), // Rule ID 1606 //
     /*  71722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71767 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71779 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71783 */     // MIs[3] Rd
     /*  71783 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71788 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71792 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71798 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71805 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71807 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71824 */     GIR_RootConstrainSelectedInstOperands,
     /*  71825 */     // GIR_Coverage, 1606,
     /*  71825 */     GIR_EraseRootFromParent_Done,
     /*  71826 */   // Label 1169: @71826
     /*  71826 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(71935), // Rule ID 13457 //
     /*  71831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71888 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71892 */     // MIs[3] Rd
     /*  71892 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71897 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71901 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71907 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71914 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71916 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71933 */     GIR_RootConstrainSelectedInstOperands,
     /*  71934 */     // GIR_Coverage, 13457,
     /*  71934 */     GIR_EraseRootFromParent_Done,
     /*  71935 */   // Label 1170: @71935
     /*  71935 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72044), // Rule ID 13456 //
     /*  71940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72002 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72006 */     // MIs[3] Rd
     /*  72006 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  72011 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72015 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72021 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72023 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72025 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  72034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  72038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  72042 */     GIR_RootConstrainSelectedInstOperands,
     /*  72043 */     // GIR_Coverage, 13456,
     /*  72043 */     GIR_EraseRootFromParent_Done,
     /*  72044 */   // Label 1171: @72044
     /*  72044 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72153), // Rule ID 13458 //
     /*  72049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72111 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72115 */     // MIs[3] Rd
     /*  72115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  72120 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72124 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72130 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72132 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72134 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  72143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  72151 */     GIR_RootConstrainSelectedInstOperands,
     /*  72152 */     // GIR_Coverage, 13458,
     /*  72152 */     GIR_EraseRootFromParent_Done,
     /*  72153 */   // Label 1172: @72153
     /*  72153 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(72220), // Rule ID 13629 //
     /*  72158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72182 */     // MIs[1] imm
     /*  72182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72190 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72194 */     // MIs[2] Operand 1
     /*  72194 */     // No operand predicates
     /*  72194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72198 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72204 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  72207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72218 */     GIR_RootConstrainSelectedInstOperands,
     /*  72219 */     // GIR_Coverage, 13629,
     /*  72219 */     GIR_EraseRootFromParent_Done,
     /*  72220 */   // Label 1173: @72220
     /*  72220 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72287), // Rule ID 13650 //
     /*  72225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72249 */     // MIs[1] imm
     /*  72249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72257 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72261 */     // MIs[2] Operand 1
     /*  72261 */     // No operand predicates
     /*  72261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72265 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72271 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72285 */     GIR_RootConstrainSelectedInstOperands,
     /*  72286 */     // GIR_Coverage, 13650,
     /*  72286 */     GIR_EraseRootFromParent_Done,
     /*  72287 */   // Label 1174: @72287
     /*  72287 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72354), // Rule ID 2233 //
     /*  72292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72320 */     // MIs[1] imm
     /*  72320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72328 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72332 */     // MIs[2] Operand 1
     /*  72332 */     // No operand predicates
     /*  72332 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72338 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  72341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72352 */     GIR_RootConstrainSelectedInstOperands,
     /*  72353 */     // GIR_Coverage, 2233,
     /*  72353 */     GIR_EraseRootFromParent_Done,
     /*  72354 */   // Label 1175: @72354
     /*  72354 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72421), // Rule ID 2292 //
     /*  72359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72387 */     // MIs[1] imm
     /*  72387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72395 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72399 */     // MIs[2] Operand 1
     /*  72399 */     // No operand predicates
     /*  72399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72405 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72419 */     GIR_RootConstrainSelectedInstOperands,
     /*  72420 */     // GIR_Coverage, 2292,
     /*  72420 */     GIR_EraseRootFromParent_Done,
     /*  72421 */   // Label 1176: @72421
     /*  72421 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72485), // Rule ID 13448 //
     /*  72426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72458 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72464 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72472 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72483 */     GIR_RootConstrainSelectedInstOperands,
     /*  72484 */     // GIR_Coverage, 13448,
     /*  72484 */     GIR_EraseRootFromParent_Done,
     /*  72485 */   // Label 1177: @72485
     /*  72485 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72549), // Rule ID 1602 //
     /*  72490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72526 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72536 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72547 */     GIR_RootConstrainSelectedInstOperands,
     /*  72548 */     // GIR_Coverage, 1602,
     /*  72548 */     GIR_EraseRootFromParent_Done,
     /*  72549 */   // Label 1178: @72549
     /*  72549 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(72576), // Rule ID 1604 //
     /*  72554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72569 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  72574 */     GIR_RootConstrainSelectedInstOperands,
     /*  72575 */     // GIR_Coverage, 1604,
     /*  72575 */     GIR_Done,
     /*  72576 */   // Label 1179: @72576
     /*  72576 */   GIM_Reject,
     /*  72577 */ // Label 1164: @72577
     /*  72577 */ GIM_Reject,
     /*  72578 */ // Label 1023: @72578
     /*  72578 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(72609), // Rule ID 8520 //
     /*  72583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  72589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  72592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72596 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  72596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72601 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72603 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72605 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72607 */   GIR_RootConstrainSelectedInstOperands,
     /*  72608 */   // GIR_Coverage, 8520,
     /*  72608 */   GIR_EraseRootFromParent_Done,
     /*  72609 */ // Label 1180: @72609
     /*  72609 */ GIM_Reject,
     /*  72610 */ // Label 1024: @72610
     /*  72610 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(72641), // Rule ID 8519 //
     /*  72615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  72621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  72624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72628 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  72628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72633 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72635 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72637 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72639 */   GIR_RootConstrainSelectedInstOperands,
     /*  72640 */   // GIR_Coverage, 8519,
     /*  72640 */   GIR_EraseRootFromParent_Done,
     /*  72641 */ // Label 1181: @72641
     /*  72641 */ GIM_Reject,
     /*  72642 */ // Label 1025: @72642
     /*  72642 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(76001),
     /*  72647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72657 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(72775), // Rule ID 15803 //
     /*  72662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  72665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72701 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72707 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72709 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  72713 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72717 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72721 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72725 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  72729 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  72737 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  72741 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72745 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72749 */     // MIs[6] Op3
     /*  72749 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  72754 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  72756 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  72756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  72759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  72761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  72765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  72769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  72773 */     GIR_RootConstrainSelectedInstOperands,
     /*  72774 */     // GIR_Coverage, 15803,
     /*  72774 */     GIR_EraseRootFromParent_Done,
     /*  72775 */   // Label 1183: @72775
     /*  72775 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(72893), // Rule ID 15805 //
     /*  72780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  72783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72819 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72825 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72827 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  72831 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72835 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72839 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72843 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  72847 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72853 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  72855 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  72859 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72863 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72867 */     // MIs[6] Op3
     /*  72867 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72872 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  72874 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  72874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  72877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  72879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  72883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  72887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  72891 */     GIR_RootConstrainSelectedInstOperands,
     /*  72892 */     // GIR_Coverage, 15805,
     /*  72892 */     GIR_EraseRootFromParent_Done,
     /*  72893 */   // Label 1184: @72893
     /*  72893 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73011), // Rule ID 15802 //
     /*  72898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  72901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72933 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72937 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72943 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72945 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  72949 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72953 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72957 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72961 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  72965 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72971 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  72973 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  72977 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72981 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72985 */     // MIs[6] Op3
     /*  72985 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  72990 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  72992 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  72992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  72995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  72997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  73001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  73005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  73009 */     GIR_RootConstrainSelectedInstOperands,
     /*  73010 */     // GIR_Coverage, 15802,
     /*  73010 */     GIR_EraseRootFromParent_Done,
     /*  73011 */   // Label 1185: @73011
     /*  73011 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73129), // Rule ID 15804 //
     /*  73016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73055 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73061 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73063 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  73067 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73071 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73075 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73079 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  73083 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73089 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  73091 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  73095 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73099 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73103 */     // MIs[6] Op3
     /*  73103 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73108 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73110 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  73113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  73119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  73123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73127 */     GIR_RootConstrainSelectedInstOperands,
     /*  73128 */     // GIR_Coverage, 15804,
     /*  73128 */     GIR_EraseRootFromParent_Done,
     /*  73129 */   // Label 1186: @73129
     /*  73129 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73247), // Rule ID 15750 //
     /*  73134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73165 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73173 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73179 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73181 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73185 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73189 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73193 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73197 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  73201 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73205 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73209 */     // MIs[5] Op3
     /*  73209 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  73214 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73218 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73224 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73226 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73228 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  73237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  73241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  73245 */     GIR_RootConstrainSelectedInstOperands,
     /*  73246 */     // GIR_Coverage, 15750,
     /*  73246 */     GIR_EraseRootFromParent_Done,
     /*  73247 */   // Label 1187: @73247
     /*  73247 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73365), // Rule ID 15755 //
     /*  73252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73291 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73297 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73299 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73303 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73307 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73311 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  73315 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73319 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73323 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73327 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73331 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73337 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73339 */     // MIs[4] Op3
     /*  73339 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73344 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73346 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  73355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  73359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73363 */     GIR_RootConstrainSelectedInstOperands,
     /*  73364 */     // GIR_Coverage, 15755,
     /*  73364 */     GIR_EraseRootFromParent_Done,
     /*  73365 */   // Label 1188: @73365
     /*  73365 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73483), // Rule ID 15756 //
     /*  73370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73409 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73415 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73417 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73421 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73425 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73429 */     // MIs[4] Op3
     /*  73429 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73434 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  73438 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73442 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73446 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73450 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73454 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73460 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73462 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73464 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  73473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  73477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73481 */     GIR_RootConstrainSelectedInstOperands,
     /*  73482 */     // GIR_Coverage, 15756,
     /*  73482 */     GIR_EraseRootFromParent_Done,
     /*  73483 */   // Label 1189: @73483
     /*  73483 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(73601), // Rule ID 11956 //
     /*  73488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73527 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73533 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73535 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73539 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73543 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73547 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73551 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  73555 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73559 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73563 */     // MIs[5] Op3
     /*  73563 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  73568 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73572 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73578 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73580 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73582 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  73591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  73595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  73599 */     GIR_RootConstrainSelectedInstOperands,
     /*  73600 */     // GIR_Coverage, 11956,
     /*  73600 */     GIR_EraseRootFromParent_Done,
     /*  73601 */   // Label 1190: @73601
     /*  73601 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(73719), // Rule ID 15752 //
     /*  73606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73637 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73645 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73651 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73653 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73657 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73661 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73665 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73669 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  73673 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73677 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73681 */     // MIs[5] Op3
     /*  73681 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  73686 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73690 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73696 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73698 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73700 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  73709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  73713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  73717 */     GIR_RootConstrainSelectedInstOperands,
     /*  73718 */     // GIR_Coverage, 15752,
     /*  73718 */     GIR_EraseRootFromParent_Done,
     /*  73719 */   // Label 1191: @73719
     /*  73719 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(73837), // Rule ID 15753 //
     /*  73724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73763 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73769 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73771 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73775 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73779 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73783 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  73787 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73791 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73795 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73799 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73803 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73809 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73811 */     // MIs[4] Op3
     /*  73811 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73816 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73818 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  73827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  73831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73835 */     GIR_RootConstrainSelectedInstOperands,
     /*  73836 */     // GIR_Coverage, 15753,
     /*  73836 */     GIR_EraseRootFromParent_Done,
     /*  73837 */   // Label 1192: @73837
     /*  73837 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(73955), // Rule ID 15754 //
     /*  73842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73881 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73887 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73889 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73893 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73897 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73901 */     // MIs[4] Op3
     /*  73901 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73906 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  73910 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73914 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73918 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73922 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  73926 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73932 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  73934 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  73936 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  73936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  73939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  73941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  73945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  73949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  73953 */     GIR_RootConstrainSelectedInstOperands,
     /*  73954 */     // GIR_Coverage, 15754,
     /*  73954 */     GIR_EraseRootFromParent_Done,
     /*  73955 */   // Label 1193: @73955
     /*  73955 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74073), // Rule ID 15751 //
     /*  73960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  73963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  73991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  73995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73999 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74007 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74011 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74015 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74019 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74023 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74027 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74031 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74035 */     // MIs[5] Op3
     /*  74035 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  74040 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74044 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74050 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74052 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74054 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  74057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  74063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  74067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74071 */     GIR_RootConstrainSelectedInstOperands,
     /*  74072 */     // GIR_Coverage, 15751,
     /*  74072 */     GIR_EraseRootFromParent_Done,
     /*  74073 */   // Label 1194: @74073
     /*  74073 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74191), // Rule ID 15799 //
     /*  74078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74113 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74117 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74121 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74125 */     // MIs[3] Op3
     /*  74125 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  74130 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74134 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74140 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74142 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  74146 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74150 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74154 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74158 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74162 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74168 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74170 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74172 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  74185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74189 */     GIR_RootConstrainSelectedInstOperands,
     /*  74190 */     // GIR_Coverage, 15799,
     /*  74190 */     GIR_EraseRootFromParent_Done,
     /*  74191 */   // Label 1195: @74191
     /*  74191 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74309), // Rule ID 15801 //
     /*  74196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74239 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74243 */     // MIs[3] Op3
     /*  74243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  74248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74252 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74258 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74260 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  74264 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74268 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74272 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74276 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74280 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74286 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74288 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74290 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  74299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  74303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74307 */     GIR_RootConstrainSelectedInstOperands,
     /*  74308 */     // GIR_Coverage, 15801,
     /*  74308 */     GIR_EraseRootFromParent_Done,
     /*  74309 */   // Label 1196: @74309
     /*  74309 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74427), // Rule ID 11967 //
     /*  74314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74357 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74361 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74365 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74369 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74375 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74377 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  74381 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74385 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74389 */     // MIs[5] Op3
     /*  74389 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  74394 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74398 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74406 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74408 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  74421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74425 */     GIR_RootConstrainSelectedInstOperands,
     /*  74426 */     // GIR_Coverage, 11967,
     /*  74426 */     GIR_EraseRootFromParent_Done,
     /*  74427 */   // Label 1197: @74427
     /*  74427 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74545), // Rule ID 15800 //
     /*  74432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74475 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74479 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74483 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74487 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74493 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74495 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  74499 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74503 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74507 */     // MIs[5] Op3
     /*  74507 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  74512 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74516 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74522 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74524 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74526 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  74535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  74539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  74543 */     GIR_RootConstrainSelectedInstOperands,
     /*  74544 */     // GIR_Coverage, 15800,
     /*  74544 */     GIR_EraseRootFromParent_Done,
     /*  74545 */   // Label 1198: @74545
     /*  74545 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74635), // Rule ID 15728 //
     /*  74550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74589 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74595 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74597 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74601 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74605 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74609 */     // MIs[4] Op3
     /*  74609 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74614 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74616 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  74625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74633 */     GIR_RootConstrainSelectedInstOperands,
     /*  74634 */     // GIR_Coverage, 15728,
     /*  74634 */     GIR_EraseRootFromParent_Done,
     /*  74635 */   // Label 1199: @74635
     /*  74635 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74725), // Rule ID 15727 //
     /*  74640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74679 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74685 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74691 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74695 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74699 */     // MIs[4] Op3
     /*  74699 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74704 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74706 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  74715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74723 */     GIR_RootConstrainSelectedInstOperands,
     /*  74724 */     // GIR_Coverage, 15727,
     /*  74724 */     GIR_EraseRootFromParent_Done,
     /*  74725 */   // Label 1200: @74725
     /*  74725 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74815), // Rule ID 15726 //
     /*  74730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74769 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74775 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74785 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74789 */     // MIs[4] Op3
     /*  74789 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74794 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74796 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  74805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74813 */     GIR_RootConstrainSelectedInstOperands,
     /*  74814 */     // GIR_Coverage, 15726,
     /*  74814 */     GIR_EraseRootFromParent_Done,
     /*  74815 */   // Label 1201: @74815
     /*  74815 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74905), // Rule ID 15725 //
     /*  74820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74859 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74865 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74867 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74871 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74875 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74879 */     // MIs[4] Op3
     /*  74879 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74884 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74886 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  74895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  74899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74903 */     GIR_RootConstrainSelectedInstOperands,
     /*  74904 */     // GIR_Coverage, 15725,
     /*  74904 */     GIR_EraseRootFromParent_Done,
     /*  74905 */   // Label 1202: @74905
     /*  74905 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74995), // Rule ID 15722 //
     /*  74910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  74933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  74949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74953 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74957 */     // MIs[3] Op3
     /*  74957 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  74962 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  74966 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74972 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74974 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74976 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  74979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  74985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  74989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74993 */     GIR_RootConstrainSelectedInstOperands,
     /*  74994 */     // GIR_Coverage, 15722,
     /*  74994 */     GIR_EraseRootFromParent_Done,
     /*  74995 */   // Label 1203: @74995
     /*  74995 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(75085), // Rule ID 15724 //
     /*  75000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75039 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75043 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75047 */     // MIs[3] Op3
     /*  75047 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75052 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75056 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75062 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75064 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75066 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  75069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  75079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75083 */     GIR_RootConstrainSelectedInstOperands,
     /*  75084 */     // GIR_Coverage, 15724,
     /*  75084 */     GIR_EraseRootFromParent_Done,
     /*  75085 */   // Label 1204: @75085
     /*  75085 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(75175), // Rule ID 11948 //
     /*  75090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75133 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75137 */     // MIs[3] Op3
     /*  75137 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75142 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75146 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75152 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75154 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75156 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  75159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  75169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75173 */     GIR_RootConstrainSelectedInstOperands,
     /*  75174 */     // GIR_Coverage, 11948,
     /*  75174 */     GIR_EraseRootFromParent_Done,
     /*  75175 */   // Label 1205: @75175
     /*  75175 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(75265), // Rule ID 15723 //
     /*  75180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75223 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75227 */     // MIs[3] Op3
     /*  75227 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75232 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75236 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75242 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75244 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75246 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  75249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  75259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75263 */     GIR_RootConstrainSelectedInstOperands,
     /*  75264 */     // GIR_Coverage, 15723,
     /*  75264 */     GIR_EraseRootFromParent_Done,
     /*  75265 */   // Label 1206: @75265
     /*  75265 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(75355), // Rule ID 15806 //
     /*  75270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75301 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75305 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75309 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75313 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75317 */     // MIs[3] Op3
     /*  75317 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  75326 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75332 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75334 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75336 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  75349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75353 */     GIR_RootConstrainSelectedInstOperands,
     /*  75354 */     // GIR_Coverage, 15806,
     /*  75354 */     GIR_EraseRootFromParent_Done,
     /*  75355 */   // Label 1207: @75355
     /*  75355 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(75445), // Rule ID 15808 //
     /*  75360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75403 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75407 */     // MIs[3] Op3
     /*  75407 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  75416 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75422 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75424 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75426 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  75439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75443 */     GIR_RootConstrainSelectedInstOperands,
     /*  75444 */     // GIR_Coverage, 15808,
     /*  75444 */     GIR_EraseRootFromParent_Done,
     /*  75445 */   // Label 1208: @75445
     /*  75445 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(75535), // Rule ID 11968 //
     /*  75450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75493 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75497 */     // MIs[3] Op3
     /*  75497 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75502 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  75506 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75512 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75514 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75516 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  75529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75533 */     GIR_RootConstrainSelectedInstOperands,
     /*  75534 */     // GIR_Coverage, 11968,
     /*  75534 */     GIR_EraseRootFromParent_Done,
     /*  75535 */   // Label 1209: @75535
     /*  75535 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(75625), // Rule ID 15807 //
     /*  75540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75575 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75579 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75583 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75587 */     // MIs[3] Op3
     /*  75587 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75592 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  75596 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75602 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75604 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75606 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  75619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75623 */     GIR_RootConstrainSelectedInstOperands,
     /*  75624 */     // GIR_Coverage, 15807,
     /*  75624 */     GIR_EraseRootFromParent_Done,
     /*  75625 */   // Label 1210: @75625
     /*  75625 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(75715), // Rule ID 15810 //
     /*  75630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75661 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  75669 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75677 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75681 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75685 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75689 */     // MIs[4] Op3
     /*  75689 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  75694 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75696 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  75705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  75709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  75713 */     GIR_RootConstrainSelectedInstOperands,
     /*  75714 */     // GIR_Coverage, 15810,
     /*  75714 */     GIR_EraseRootFromParent_Done,
     /*  75715 */   // Label 1211: @75715
     /*  75715 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75805), // Rule ID 15812 //
     /*  75720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  75759 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75765 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75767 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75771 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75775 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75779 */     // MIs[4] Op3
     /*  75779 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75784 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75786 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  75795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  75799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75803 */     GIR_RootConstrainSelectedInstOperands,
     /*  75804 */     // GIR_Coverage, 15812,
     /*  75804 */     GIR_EraseRootFromParent_Done,
     /*  75805 */   // Label 1212: @75805
     /*  75805 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(75895), // Rule ID 15809 //
     /*  75810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  75849 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75855 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75857 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75861 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75865 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75869 */     // MIs[4] Op3
     /*  75869 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  75874 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75876 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  75885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  75889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  75893 */     GIR_RootConstrainSelectedInstOperands,
     /*  75894 */     // GIR_Coverage, 15809,
     /*  75894 */     GIR_EraseRootFromParent_Done,
     /*  75895 */   // Label 1213: @75895
     /*  75895 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(75985), // Rule ID 15811 //
     /*  75900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  75927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  75939 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75945 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75947 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75951 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75955 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75959 */     // MIs[4] Op3
     /*  75959 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75964 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75966 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  75975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  75979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75983 */     GIR_RootConstrainSelectedInstOperands,
     /*  75984 */     // GIR_Coverage, 15811,
     /*  75984 */     GIR_EraseRootFromParent_Done,
     /*  75985 */   // Label 1214: @75985
     /*  75985 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(76000), // Rule ID 7525 //
     /*  75990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  75993 */     // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  75993 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  75998 */     GIR_RootConstrainSelectedInstOperands,
     /*  75999 */     // GIR_Coverage, 7525,
     /*  75999 */     GIR_Done,
     /*  76000 */   // Label 1215: @76000
     /*  76000 */   GIM_Reject,
     /*  76001 */ // Label 1182: @76001
     /*  76001 */ GIM_Reject,
     /*  76002 */ // Label 1026: @76002
     /*  76002 */ GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(76033), // Rule ID 8518 //
     /*  76007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  76010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  76013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  76016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  76020 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  76020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  76023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  76025 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  76027 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  76029 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  76031 */   GIR_RootConstrainSelectedInstOperands,
     /*  76032 */   // GIR_Coverage, 8518,
     /*  76032 */   GIR_EraseRootFromParent_Done,
     /*  76033 */ // Label 1216: @76033
     /*  76033 */ GIM_Reject,
     /*  76034 */ // Label 1027: @76034
     /*  76034 */ GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(79393),
     /*  76039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  76049 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(76167), // Rule ID 15789 //
     /*  76054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76093 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76099 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76101 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  76105 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76109 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76113 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76117 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76121 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76127 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  76129 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  76133 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76137 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76141 */     // MIs[6] Op3
     /*  76141 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  76146 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76148 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  76157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  76161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  76165 */     GIR_RootConstrainSelectedInstOperands,
     /*  76166 */     // GIR_Coverage, 15789,
     /*  76166 */     GIR_EraseRootFromParent_Done,
     /*  76167 */   // Label 1218: @76167
     /*  76167 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(76285), // Rule ID 15791 //
     /*  76172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76211 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76217 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76219 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  76223 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76227 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76231 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76235 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76239 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76245 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  76247 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  76251 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76255 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76259 */     // MIs[6] Op3
     /*  76259 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76264 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76266 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  76275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  76279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76283 */     GIR_RootConstrainSelectedInstOperands,
     /*  76284 */     // GIR_Coverage, 15791,
     /*  76284 */     GIR_EraseRootFromParent_Done,
     /*  76285 */   // Label 1219: @76285
     /*  76285 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(76403), // Rule ID 15788 //
     /*  76290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76329 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76335 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76337 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  76341 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76345 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76349 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76353 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76357 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76363 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  76365 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  76369 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76373 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76377 */     // MIs[6] Op3
     /*  76377 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  76382 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76384 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  76393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  76397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  76401 */     GIR_RootConstrainSelectedInstOperands,
     /*  76402 */     // GIR_Coverage, 15788,
     /*  76402 */     GIR_EraseRootFromParent_Done,
     /*  76403 */   // Label 1220: @76403
     /*  76403 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(76521), // Rule ID 15790 //
     /*  76408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76447 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76453 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76455 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  76459 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76463 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76467 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76471 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76475 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  76483 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  76487 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76491 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76495 */     // MIs[6] Op3
     /*  76495 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76500 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76502 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  76511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  76515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76519 */     GIR_RootConstrainSelectedInstOperands,
     /*  76520 */     // GIR_Coverage, 15790,
     /*  76520 */     GIR_EraseRootFromParent_Done,
     /*  76521 */   // Label 1221: @76521
     /*  76521 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(76639), // Rule ID 15743 //
     /*  76526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76565 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76571 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76573 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76577 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76581 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76585 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76589 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  76593 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76597 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76601 */     // MIs[5] Op3
     /*  76601 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76606 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76610 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76616 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76618 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76620 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  76623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  76629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  76633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76637 */     GIR_RootConstrainSelectedInstOperands,
     /*  76638 */     // GIR_Coverage, 15743,
     /*  76638 */     GIR_EraseRootFromParent_Done,
     /*  76639 */   // Label 1222: @76639
     /*  76639 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(76757), // Rule ID 15748 //
     /*  76644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76683 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76689 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76691 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76695 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76699 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76703 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  76707 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76711 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76715 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76719 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76723 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76731 */     // MIs[4] Op3
     /*  76731 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76736 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76738 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  76741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  76747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76755 */     GIR_RootConstrainSelectedInstOperands,
     /*  76756 */     // GIR_Coverage, 15748,
     /*  76756 */     GIR_EraseRootFromParent_Done,
     /*  76757 */   // Label 1223: @76757
     /*  76757 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(76875), // Rule ID 15749 //
     /*  76762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76801 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76807 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76809 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76813 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76817 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76821 */     // MIs[4] Op3
     /*  76821 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76826 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76830 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76834 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76838 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76842 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76846 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76852 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76854 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76856 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  76859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  76865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76873 */     GIR_RootConstrainSelectedInstOperands,
     /*  76874 */     // GIR_Coverage, 15749,
     /*  76874 */     GIR_EraseRootFromParent_Done,
     /*  76875 */   // Label 1224: @76875
     /*  76875 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(76993), // Rule ID 11954 //
     /*  76880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76919 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76925 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76927 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76931 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76935 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  76939 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76943 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  76947 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76951 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  76955 */     // MIs[5] Op3
     /*  76955 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76960 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  76964 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76970 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76972 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76974 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  76974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  76977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  76983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  76987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76991 */     GIR_RootConstrainSelectedInstOperands,
     /*  76992 */     // GIR_Coverage, 11954,
     /*  76992 */     GIR_EraseRootFromParent_Done,
     /*  76993 */   // Label 1225: @76993
     /*  76993 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(77111), // Rule ID 15745 //
     /*  76998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77037 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77043 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77045 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77049 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77053 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77057 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77061 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  77065 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77069 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77073 */     // MIs[5] Op3
     /*  77073 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77078 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77082 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77090 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77092 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  77095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  77101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  77105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77109 */     GIR_RootConstrainSelectedInstOperands,
     /*  77110 */     // GIR_Coverage, 15745,
     /*  77110 */     GIR_EraseRootFromParent_Done,
     /*  77111 */   // Label 1226: @77111
     /*  77111 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(77229), // Rule ID 15746 //
     /*  77116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77147 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77155 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77161 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77163 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77167 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77171 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77175 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  77179 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77183 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77187 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77191 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77195 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77201 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77203 */     // MIs[4] Op3
     /*  77203 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77208 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77210 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  77213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  77219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77227 */     GIR_RootConstrainSelectedInstOperands,
     /*  77228 */     // GIR_Coverage, 15746,
     /*  77228 */     GIR_EraseRootFromParent_Done,
     /*  77229 */   // Label 1227: @77229
     /*  77229 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(77347), // Rule ID 15747 //
     /*  77234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77273 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77279 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77281 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77285 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77289 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77293 */     // MIs[4] Op3
     /*  77293 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77298 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77302 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77306 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77310 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77314 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77318 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77324 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77326 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77328 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  77331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  77337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77345 */     GIR_RootConstrainSelectedInstOperands,
     /*  77346 */     // GIR_Coverage, 15747,
     /*  77346 */     GIR_EraseRootFromParent_Done,
     /*  77347 */   // Label 1228: @77347
     /*  77347 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(77465), // Rule ID 15744 //
     /*  77352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77391 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77397 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77399 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77403 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77407 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77411 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77415 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77419 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77423 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77427 */     // MIs[5] Op3
     /*  77427 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77432 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77436 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77442 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77444 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77446 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  77449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  77455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  77459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77463 */     GIR_RootConstrainSelectedInstOperands,
     /*  77464 */     // GIR_Coverage, 15744,
     /*  77464 */     GIR_EraseRootFromParent_Done,
     /*  77465 */   // Label 1229: @77465
     /*  77465 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(77583), // Rule ID 15785 //
     /*  77470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77513 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77517 */     // MIs[3] Op3
     /*  77517 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  77522 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  77526 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77534 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  77538 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77542 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77546 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77550 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77554 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77560 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77562 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77564 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  77577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77581 */     GIR_RootConstrainSelectedInstOperands,
     /*  77582 */     // GIR_Coverage, 15785,
     /*  77582 */     GIR_EraseRootFromParent_Done,
     /*  77583 */   // Label 1230: @77583
     /*  77583 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(77701), // Rule ID 15787 //
     /*  77588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77631 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77635 */     // MIs[3] Op3
     /*  77635 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77640 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  77644 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77650 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77652 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  77656 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77660 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77664 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77668 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77672 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77678 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77680 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77682 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  77695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77699 */     GIR_RootConstrainSelectedInstOperands,
     /*  77700 */     // GIR_Coverage, 15787,
     /*  77700 */     GIR_EraseRootFromParent_Done,
     /*  77701 */   // Label 1231: @77701
     /*  77701 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(77819), // Rule ID 11964 //
     /*  77706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77741 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77745 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77749 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77753 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77757 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  77761 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77767 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77769 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  77773 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77777 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77781 */     // MIs[5] Op3
     /*  77781 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  77786 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77790 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77796 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77798 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77800 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  77813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77817 */     GIR_RootConstrainSelectedInstOperands,
     /*  77818 */     // GIR_Coverage, 11964,
     /*  77818 */     GIR_EraseRootFromParent_Done,
     /*  77819 */   // Label 1232: @77819
     /*  77819 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(77937), // Rule ID 15786 //
     /*  77824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77859 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77863 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77867 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77871 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77875 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  77879 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77887 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  77891 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77895 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77899 */     // MIs[5] Op3
     /*  77899 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77904 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  77908 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77914 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  77916 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77918 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  77931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77935 */     GIR_RootConstrainSelectedInstOperands,
     /*  77936 */     // GIR_Coverage, 15786,
     /*  77936 */     GIR_EraseRootFromParent_Done,
     /*  77937 */   // Label 1233: @77937
     /*  77937 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(78027), // Rule ID 15721 //
     /*  77942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77981 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77987 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77989 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77993 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77997 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78001 */     // MIs[4] Op3
     /*  78001 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78006 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78008 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  78017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78025 */     GIR_RootConstrainSelectedInstOperands,
     /*  78026 */     // GIR_Coverage, 15721,
     /*  78026 */     GIR_EraseRootFromParent_Done,
     /*  78027 */   // Label 1234: @78027
     /*  78027 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(78117), // Rule ID 15720 //
     /*  78032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78071 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78077 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78079 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78083 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78087 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78091 */     // MIs[4] Op3
     /*  78091 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78096 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78098 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  78107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78115 */     GIR_RootConstrainSelectedInstOperands,
     /*  78116 */     // GIR_Coverage, 15720,
     /*  78116 */     GIR_EraseRootFromParent_Done,
     /*  78117 */   // Label 1235: @78117
     /*  78117 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(78207), // Rule ID 15719 //
     /*  78122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78161 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78167 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78169 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78173 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78177 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78181 */     // MIs[4] Op3
     /*  78181 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78186 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78188 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  78197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78205 */     GIR_RootConstrainSelectedInstOperands,
     /*  78206 */     // GIR_Coverage, 15719,
     /*  78206 */     GIR_EraseRootFromParent_Done,
     /*  78207 */   // Label 1236: @78207
     /*  78207 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(78297), // Rule ID 15718 //
     /*  78212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78243 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78251 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78257 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78259 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78263 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78267 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78271 */     // MIs[4] Op3
     /*  78271 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78276 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78278 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  78287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78295 */     GIR_RootConstrainSelectedInstOperands,
     /*  78296 */     // GIR_Coverage, 15718,
     /*  78296 */     GIR_EraseRootFromParent_Done,
     /*  78297 */   // Label 1237: @78297
     /*  78297 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(78387), // Rule ID 15715 //
     /*  78302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78345 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78349 */     // MIs[3] Op3
     /*  78349 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78354 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78358 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78366 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78368 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  78381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78385 */     GIR_RootConstrainSelectedInstOperands,
     /*  78386 */     // GIR_Coverage, 15715,
     /*  78386 */     GIR_EraseRootFromParent_Done,
     /*  78387 */   // Label 1238: @78387
     /*  78387 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(78477), // Rule ID 15717 //
     /*  78392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78435 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78439 */     // MIs[3] Op3
     /*  78439 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78444 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78448 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78454 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78456 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78458 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  78471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78475 */     GIR_RootConstrainSelectedInstOperands,
     /*  78476 */     // GIR_Coverage, 15717,
     /*  78476 */     GIR_EraseRootFromParent_Done,
     /*  78477 */   // Label 1239: @78477
     /*  78477 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(78567), // Rule ID 11946 //
     /*  78482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78525 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78529 */     // MIs[3] Op3
     /*  78529 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78534 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78538 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78544 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78546 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78548 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  78561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78565 */     GIR_RootConstrainSelectedInstOperands,
     /*  78566 */     // GIR_Coverage, 11946,
     /*  78566 */     GIR_EraseRootFromParent_Done,
     /*  78567 */   // Label 1240: @78567
     /*  78567 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(78657), // Rule ID 15716 //
     /*  78572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78615 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78619 */     // MIs[3] Op3
     /*  78619 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78624 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  78628 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78634 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78638 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  78641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  78651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78655 */     GIR_RootConstrainSelectedInstOperands,
     /*  78656 */     // GIR_Coverage, 15716,
     /*  78656 */     GIR_EraseRootFromParent_Done,
     /*  78657 */   // Label 1241: @78657
     /*  78657 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(78747), // Rule ID 15792 //
     /*  78662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78705 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78709 */     // MIs[3] Op3
     /*  78709 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78714 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  78718 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78726 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78728 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  78731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  78741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78745 */     GIR_RootConstrainSelectedInstOperands,
     /*  78746 */     // GIR_Coverage, 15792,
     /*  78746 */     GIR_EraseRootFromParent_Done,
     /*  78747 */   // Label 1242: @78747
     /*  78747 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(78837), // Rule ID 15794 //
     /*  78752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78795 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78799 */     // MIs[3] Op3
     /*  78799 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78804 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  78808 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78814 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78816 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78818 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  78821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  78831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78835 */     GIR_RootConstrainSelectedInstOperands,
     /*  78836 */     // GIR_Coverage, 15794,
     /*  78836 */     GIR_EraseRootFromParent_Done,
     /*  78837 */   // Label 1243: @78837
     /*  78837 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(78927), // Rule ID 11965 //
     /*  78842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78885 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78889 */     // MIs[3] Op3
     /*  78889 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78894 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  78898 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78904 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78906 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78908 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  78911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  78921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78925 */     GIR_RootConstrainSelectedInstOperands,
     /*  78926 */     // GIR_Coverage, 11965,
     /*  78926 */     GIR_EraseRootFromParent_Done,
     /*  78927 */   // Label 1244: @78927
     /*  78927 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(79017), // Rule ID 15793 //
     /*  78932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78979 */     // MIs[3] Op3
     /*  78979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  78988 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78994 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  78996 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  78998 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  79011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79015 */     GIR_RootConstrainSelectedInstOperands,
     /*  79016 */     // GIR_Coverage, 15793,
     /*  79016 */     GIR_EraseRootFromParent_Done,
     /*  79017 */   // Label 1245: @79017
     /*  79017 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(79107), // Rule ID 15796 //
     /*  79022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  79061 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79067 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79069 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79073 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79077 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79081 */     // MIs[4] Op3
     /*  79081 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  79086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79088 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  79097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  79101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  79105 */     GIR_RootConstrainSelectedInstOperands,
     /*  79106 */     // GIR_Coverage, 15796,
     /*  79106 */     GIR_EraseRootFromParent_Done,
     /*  79107 */   // Label 1246: @79107
     /*  79107 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(79197), // Rule ID 15798 //
     /*  79112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79143 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79147 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  79151 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79157 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79159 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79163 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79167 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79171 */     // MIs[4] Op3
     /*  79171 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79176 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79178 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  79187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  79191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79195 */     GIR_RootConstrainSelectedInstOperands,
     /*  79196 */     // GIR_Coverage, 15798,
     /*  79196 */     GIR_EraseRootFromParent_Done,
     /*  79197 */   // Label 1247: @79197
     /*  79197 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(79287), // Rule ID 15795 //
     /*  79202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  79241 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79247 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79249 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79253 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79257 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79261 */     // MIs[4] Op3
     /*  79261 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  79266 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79268 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  79277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  79281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  79285 */     GIR_RootConstrainSelectedInstOperands,
     /*  79286 */     // GIR_Coverage, 15795,
     /*  79286 */     GIR_EraseRootFromParent_Done,
     /*  79287 */   // Label 1248: @79287
     /*  79287 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(79377), // Rule ID 15797 //
     /*  79292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  79331 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79337 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79339 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79343 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79347 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79351 */     // MIs[4] Op3
     /*  79351 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79356 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79358 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  79367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  79371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79375 */     GIR_RootConstrainSelectedInstOperands,
     /*  79376 */     // GIR_Coverage, 15797,
     /*  79376 */     GIR_EraseRootFromParent_Done,
     /*  79377 */   // Label 1249: @79377
     /*  79377 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(79392), // Rule ID 7524 //
     /*  79382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79385 */     // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  79385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  79390 */     GIR_RootConstrainSelectedInstOperands,
     /*  79391 */     // GIR_Coverage, 7524,
     /*  79391 */     GIR_Done,
     /*  79392 */   // Label 1250: @79392
     /*  79392 */   GIM_Reject,
     /*  79393 */ // Label 1217: @79393
     /*  79393 */ GIM_Reject,
     /*  79394 */ // Label 1028: @79394
     /*  79394 */ GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(79425), // Rule ID 8517 //
     /*  79399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  79405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  79408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  79412 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  79412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  79415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  79417 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79419 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79421 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  79423 */   GIR_RootConstrainSelectedInstOperands,
     /*  79424 */   // GIR_Coverage, 8517,
     /*  79424 */   GIR_EraseRootFromParent_Done,
     /*  79425 */ // Label 1251: @79425
     /*  79425 */ GIM_Reject,
     /*  79426 */ // Label 1029: @79426
     /*  79426 */ GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(82785),
     /*  79431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  79441 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(79559), // Rule ID 15775 //
     /*  79446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79485 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79491 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79493 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  79497 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79501 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79505 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79509 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  79513 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  79521 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  79525 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79529 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79533 */     // MIs[6] Op3
     /*  79533 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  79538 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79540 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  79549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  79553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  79557 */     GIR_RootConstrainSelectedInstOperands,
     /*  79558 */     // GIR_Coverage, 15775,
     /*  79558 */     GIR_EraseRootFromParent_Done,
     /*  79559 */   // Label 1253: @79559
     /*  79559 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(79677), // Rule ID 15777 //
     /*  79564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79603 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79609 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79611 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  79615 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79619 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79623 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79627 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  79631 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79637 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  79639 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  79643 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79647 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79651 */     // MIs[6] Op3
     /*  79651 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79656 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79658 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  79667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  79671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79675 */     GIR_RootConstrainSelectedInstOperands,
     /*  79676 */     // GIR_Coverage, 15777,
     /*  79676 */     GIR_EraseRootFromParent_Done,
     /*  79677 */   // Label 1254: @79677
     /*  79677 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(79795), // Rule ID 15774 //
     /*  79682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79721 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79727 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79729 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  79733 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79737 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79741 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79745 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  79749 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79755 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  79757 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  79761 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79765 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79769 */     // MIs[6] Op3
     /*  79769 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  79774 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79776 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  79785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  79789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  79793 */     GIR_RootConstrainSelectedInstOperands,
     /*  79794 */     // GIR_Coverage, 15774,
     /*  79794 */     GIR_EraseRootFromParent_Done,
     /*  79795 */   // Label 1255: @79795
     /*  79795 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(79913), // Rule ID 15776 //
     /*  79800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79839 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79845 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79847 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  79851 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79855 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79859 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79863 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  79867 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79873 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  79875 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  79879 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79883 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79887 */     // MIs[6] Op3
     /*  79887 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79892 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79894 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  79903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  79907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79911 */     GIR_RootConstrainSelectedInstOperands,
     /*  79912 */     // GIR_Coverage, 15776,
     /*  79912 */     GIR_EraseRootFromParent_Done,
     /*  79913 */   // Label 1256: @79913
     /*  79913 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(80031), // Rule ID 15736 //
     /*  79918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79957 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79963 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79965 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79969 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79973 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79977 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79981 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  79985 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79989 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79993 */     // MIs[5] Op3
     /*  79993 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  79998 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80002 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80008 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80010 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80012 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  80021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  80025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80029 */     GIR_RootConstrainSelectedInstOperands,
     /*  80030 */     // GIR_Coverage, 15736,
     /*  80030 */     GIR_EraseRootFromParent_Done,
     /*  80031 */   // Label 1257: @80031
     /*  80031 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(80149), // Rule ID 15741 //
     /*  80036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80075 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80081 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80083 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80087 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80091 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80095 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  80099 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80103 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80107 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80111 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80115 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80121 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80123 */     // MIs[4] Op3
     /*  80123 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80128 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80130 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  80139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  80143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80147 */     GIR_RootConstrainSelectedInstOperands,
     /*  80148 */     // GIR_Coverage, 15741,
     /*  80148 */     GIR_EraseRootFromParent_Done,
     /*  80149 */   // Label 1258: @80149
     /*  80149 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(80267), // Rule ID 15742 //
     /*  80154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80193 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80199 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80201 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80205 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80209 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80213 */     // MIs[4] Op3
     /*  80213 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80218 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80222 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80226 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80230 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80234 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80238 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80244 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80246 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80248 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  80257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  80261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80265 */     GIR_RootConstrainSelectedInstOperands,
     /*  80266 */     // GIR_Coverage, 15742,
     /*  80266 */     GIR_EraseRootFromParent_Done,
     /*  80267 */   // Label 1259: @80267
     /*  80267 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(80385), // Rule ID 11952 //
     /*  80272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80311 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80317 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80319 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80323 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80327 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80331 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80335 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80339 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80343 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80347 */     // MIs[5] Op3
     /*  80347 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80352 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80356 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80362 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80364 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80366 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  80375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  80379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80383 */     GIR_RootConstrainSelectedInstOperands,
     /*  80384 */     // GIR_Coverage, 11952,
     /*  80384 */     GIR_EraseRootFromParent_Done,
     /*  80385 */   // Label 1260: @80385
     /*  80385 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(80503), // Rule ID 15738 //
     /*  80390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80429 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80435 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80437 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80441 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80445 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80449 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80453 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  80457 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80461 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80465 */     // MIs[5] Op3
     /*  80465 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80470 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80474 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80480 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80482 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80484 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  80493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  80497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80501 */     GIR_RootConstrainSelectedInstOperands,
     /*  80502 */     // GIR_Coverage, 15738,
     /*  80502 */     GIR_EraseRootFromParent_Done,
     /*  80503 */   // Label 1261: @80503
     /*  80503 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(80621), // Rule ID 15739 //
     /*  80508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80547 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80553 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80555 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80559 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80563 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80567 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  80571 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80575 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80579 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80583 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80587 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80593 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80595 */     // MIs[4] Op3
     /*  80595 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80600 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80602 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  80611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  80615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80619 */     GIR_RootConstrainSelectedInstOperands,
     /*  80620 */     // GIR_Coverage, 15739,
     /*  80620 */     GIR_EraseRootFromParent_Done,
     /*  80621 */   // Label 1262: @80621
     /*  80621 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(80739), // Rule ID 15740 //
     /*  80626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80665 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80671 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80673 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80677 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80681 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80685 */     // MIs[4] Op3
     /*  80685 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80690 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80694 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80698 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80702 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80706 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80710 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80716 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80718 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80720 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  80729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  80733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80737 */     GIR_RootConstrainSelectedInstOperands,
     /*  80738 */     // GIR_Coverage, 15740,
     /*  80738 */     GIR_EraseRootFromParent_Done,
     /*  80739 */   // Label 1263: @80739
     /*  80739 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(80857), // Rule ID 15737 //
     /*  80744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80783 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80791 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80795 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80799 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80803 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80807 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80811 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80815 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80819 */     // MIs[5] Op3
     /*  80819 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80824 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80828 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80834 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80836 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80838 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  80841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  80847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  80851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80855 */     GIR_RootConstrainSelectedInstOperands,
     /*  80856 */     // GIR_Coverage, 15737,
     /*  80856 */     GIR_EraseRootFromParent_Done,
     /*  80857 */   // Label 1264: @80857
     /*  80857 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(80975), // Rule ID 15771 //
     /*  80862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80905 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80909 */     // MIs[3] Op3
     /*  80909 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80914 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80918 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80924 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80926 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  80930 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80934 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80938 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80942 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  80946 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80952 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  80954 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  80956 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  80956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  80965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  80969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80973 */     GIR_RootConstrainSelectedInstOperands,
     /*  80974 */     // GIR_Coverage, 15771,
     /*  80974 */     GIR_EraseRootFromParent_Done,
     /*  80975 */   // Label 1265: @80975
     /*  80975 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(81093), // Rule ID 15773 //
     /*  80980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81011 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81023 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81027 */     // MIs[3] Op3
     /*  81027 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  81032 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81036 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81042 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81044 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  81048 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81052 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81056 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81060 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81064 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81072 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81074 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  81083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  81087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  81091 */     GIR_RootConstrainSelectedInstOperands,
     /*  81092 */     // GIR_Coverage, 15773,
     /*  81092 */     GIR_EraseRootFromParent_Done,
     /*  81093 */   // Label 1266: @81093
     /*  81093 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(81211), // Rule ID 11961 //
     /*  81098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81141 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81145 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81149 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81153 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81159 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81161 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  81165 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81169 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81173 */     // MIs[5] Op3
     /*  81173 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81178 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81182 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81188 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81190 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81192 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  81201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  81205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81209 */     GIR_RootConstrainSelectedInstOperands,
     /*  81210 */     // GIR_Coverage, 11961,
     /*  81210 */     GIR_EraseRootFromParent_Done,
     /*  81211 */   // Label 1267: @81211
     /*  81211 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(81329), // Rule ID 15772 //
     /*  81216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81259 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81263 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81267 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81271 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81277 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81279 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  81283 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81287 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81291 */     // MIs[5] Op3
     /*  81291 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  81296 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81300 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81306 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81308 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81310 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  81319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  81323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  81327 */     GIR_RootConstrainSelectedInstOperands,
     /*  81328 */     // GIR_Coverage, 15772,
     /*  81328 */     GIR_EraseRootFromParent_Done,
     /*  81329 */   // Label 1268: @81329
     /*  81329 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(81419), // Rule ID 15714 //
     /*  81334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81373 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81379 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81381 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81385 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81389 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81393 */     // MIs[4] Op3
     /*  81393 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81398 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81400 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  81409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  81413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81417 */     GIR_RootConstrainSelectedInstOperands,
     /*  81418 */     // GIR_Coverage, 15714,
     /*  81418 */     GIR_EraseRootFromParent_Done,
     /*  81419 */   // Label 1269: @81419
     /*  81419 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(81509), // Rule ID 15713 //
     /*  81424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81463 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81469 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81471 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81475 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81479 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81483 */     // MIs[4] Op3
     /*  81483 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81488 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81490 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  81499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  81503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81507 */     GIR_RootConstrainSelectedInstOperands,
     /*  81508 */     // GIR_Coverage, 15713,
     /*  81508 */     GIR_EraseRootFromParent_Done,
     /*  81509 */   // Label 1270: @81509
     /*  81509 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(81599), // Rule ID 15712 //
     /*  81514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  81537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81553 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81559 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81561 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81565 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81569 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81573 */     // MIs[4] Op3
     /*  81573 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81578 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81580 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  81589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  81593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81597 */     GIR_RootConstrainSelectedInstOperands,
     /*  81598 */     // GIR_Coverage, 15712,
     /*  81598 */     GIR_EraseRootFromParent_Done,
     /*  81599 */   // Label 1271: @81599
     /*  81599 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(81689), // Rule ID 15711 //
     /*  81604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  81627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81643 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81649 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81651 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81655 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81659 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81663 */     // MIs[4] Op3
     /*  81663 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81668 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81670 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  81679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  81683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81687 */     GIR_RootConstrainSelectedInstOperands,
     /*  81688 */     // GIR_Coverage, 15711,
     /*  81688 */     GIR_EraseRootFromParent_Done,
     /*  81689 */   // Label 1272: @81689
     /*  81689 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(81779), // Rule ID 15708 //
     /*  81694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81737 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81741 */     // MIs[3] Op3
     /*  81741 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81746 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81750 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81756 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81758 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81760 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  81769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  81773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81777 */     GIR_RootConstrainSelectedInstOperands,
     /*  81778 */     // GIR_Coverage, 15708,
     /*  81778 */     GIR_EraseRootFromParent_Done,
     /*  81779 */   // Label 1273: @81779
     /*  81779 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(81869), // Rule ID 15710 //
     /*  81784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81815 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  81823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81827 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81831 */     // MIs[3] Op3
     /*  81831 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  81836 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81840 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81846 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81848 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81850 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  81859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  81863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  81867 */     GIR_RootConstrainSelectedInstOperands,
     /*  81868 */     // GIR_Coverage, 15710,
     /*  81868 */     GIR_EraseRootFromParent_Done,
     /*  81869 */   // Label 1274: @81869
     /*  81869 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(81959), // Rule ID 11944 //
     /*  81874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81909 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81913 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81917 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81921 */     // MIs[3] Op3
     /*  81921 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81926 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  81930 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81936 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  81938 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  81940 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  81943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  81949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  81953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81957 */     GIR_RootConstrainSelectedInstOperands,
     /*  81958 */     // GIR_Coverage, 11944,
     /*  81958 */     GIR_EraseRootFromParent_Done,
     /*  81959 */   // Label 1275: @81959
     /*  81959 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(82049), // Rule ID 15709 //
     /*  81964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  81987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81995 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81999 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82003 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82007 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82011 */     // MIs[3] Op3
     /*  82011 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82016 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82020 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82026 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82028 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82030 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  82033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  82043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82047 */     GIR_RootConstrainSelectedInstOperands,
     /*  82048 */     // GIR_Coverage, 15709,
     /*  82048 */     GIR_EraseRootFromParent_Done,
     /*  82049 */   // Label 1276: @82049
     /*  82049 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(82139), // Rule ID 15778 //
     /*  82054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82089 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82093 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82097 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82101 */     // MIs[3] Op3
     /*  82101 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  82106 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  82110 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82118 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82120 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  82129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  82133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  82137 */     GIR_RootConstrainSelectedInstOperands,
     /*  82138 */     // GIR_Coverage, 15778,
     /*  82138 */     GIR_EraseRootFromParent_Done,
     /*  82139 */   // Label 1277: @82139
     /*  82139 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(82229), // Rule ID 15780 //
     /*  82144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82187 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82191 */     // MIs[3] Op3
     /*  82191 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82196 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  82200 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82208 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82210 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  82223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82227 */     GIR_RootConstrainSelectedInstOperands,
     /*  82228 */     // GIR_Coverage, 15780,
     /*  82228 */     GIR_EraseRootFromParent_Done,
     /*  82229 */   // Label 1278: @82229
     /*  82229 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(82319), // Rule ID 11962 //
     /*  82234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82277 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82281 */     // MIs[3] Op3
     /*  82281 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  82286 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  82290 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82296 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82298 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82300 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  82309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  82313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  82317 */     GIR_RootConstrainSelectedInstOperands,
     /*  82318 */     // GIR_Coverage, 11962,
     /*  82318 */     GIR_EraseRootFromParent_Done,
     /*  82319 */   // Label 1279: @82319
     /*  82319 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(82409), // Rule ID 15779 //
     /*  82324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82351 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82355 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82367 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82371 */     // MIs[3] Op3
     /*  82371 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82376 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  82380 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82386 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82390 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  82403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82407 */     GIR_RootConstrainSelectedInstOperands,
     /*  82408 */     // GIR_Coverage, 15779,
     /*  82408 */     GIR_EraseRootFromParent_Done,
     /*  82409 */   // Label 1280: @82409
     /*  82409 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(82499), // Rule ID 15782 //
     /*  82414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  82453 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82459 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82461 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82465 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82469 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82473 */     // MIs[4] Op3
     /*  82473 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  82478 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82480 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  82489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  82493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  82497 */     GIR_RootConstrainSelectedInstOperands,
     /*  82498 */     // GIR_Coverage, 15782,
     /*  82498 */     GIR_EraseRootFromParent_Done,
     /*  82499 */   // Label 1281: @82499
     /*  82499 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(82589), // Rule ID 15784 //
     /*  82504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  82543 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82549 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82551 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82555 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82559 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82563 */     // MIs[4] Op3
     /*  82563 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82568 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82570 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  82579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  82583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82587 */     GIR_RootConstrainSelectedInstOperands,
     /*  82588 */     // GIR_Coverage, 15784,
     /*  82588 */     GIR_EraseRootFromParent_Done,
     /*  82589 */   // Label 1282: @82589
     /*  82589 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(82679), // Rule ID 15781 //
     /*  82594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  82633 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82639 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82641 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82645 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82649 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82653 */     // MIs[4] Op3
     /*  82653 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  82658 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82660 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  82669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  82673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  82677 */     GIR_RootConstrainSelectedInstOperands,
     /*  82678 */     // GIR_Coverage, 15781,
     /*  82678 */     GIR_EraseRootFromParent_Done,
     /*  82679 */   // Label 1283: @82679
     /*  82679 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(82769), // Rule ID 15783 //
     /*  82684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  82711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  82723 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82735 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82739 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82743 */     // MIs[4] Op3
     /*  82743 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82748 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82750 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  82759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  82763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82767 */     GIR_RootConstrainSelectedInstOperands,
     /*  82768 */     // GIR_Coverage, 15783,
     /*  82768 */     GIR_EraseRootFromParent_Done,
     /*  82769 */   // Label 1284: @82769
     /*  82769 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(82784), // Rule ID 7523 //
     /*  82774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  82777 */     // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  82777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  82782 */     GIR_RootConstrainSelectedInstOperands,
     /*  82783 */     // GIR_Coverage, 7523,
     /*  82783 */     GIR_Done,
     /*  82784 */   // Label 1285: @82784
     /*  82784 */   GIM_Reject,
     /*  82785 */ // Label 1252: @82785
     /*  82785 */ GIM_Reject,
     /*  82786 */ // Label 1030: @82786
     /*  82786 */ GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(82817), // Rule ID 8516 //
     /*  82791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  82794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  82797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  82800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  82804 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  82804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  82807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  82809 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  82811 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  82813 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  82815 */   GIR_RootConstrainSelectedInstOperands,
     /*  82816 */   // GIR_Coverage, 8516,
     /*  82816 */   GIR_EraseRootFromParent_Done,
     /*  82817 */ // Label 1286: @82817
     /*  82817 */ GIM_Reject,
     /*  82818 */ // Label 1031: @82818
     /*  82818 */ GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(86177),
     /*  82823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  82833 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(82951), // Rule ID 15761 //
     /*  82838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82877 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82883 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82885 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  82889 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82893 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82897 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82901 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  82905 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82911 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  82913 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  82917 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82921 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82925 */     // MIs[6] Op3
     /*  82925 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  82930 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82932 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  82932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  82941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  82945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  82949 */     GIR_RootConstrainSelectedInstOperands,
     /*  82950 */     // GIR_Coverage, 15761,
     /*  82950 */     GIR_EraseRootFromParent_Done,
     /*  82951 */   // Label 1288: @82951
     /*  82951 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(83069), // Rule ID 15763 //
     /*  82956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  82987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  82991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82995 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83001 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83003 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  83007 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83011 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83015 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83019 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83023 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83029 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  83031 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  83035 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83039 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83043 */     // MIs[6] Op3
     /*  83043 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83048 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83050 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  83059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  83063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83067 */     GIR_RootConstrainSelectedInstOperands,
     /*  83068 */     // GIR_Coverage, 15763,
     /*  83068 */     GIR_EraseRootFromParent_Done,
     /*  83069 */   // Label 1289: @83069
     /*  83069 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(83187), // Rule ID 15760 //
     /*  83074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83113 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83121 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  83125 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83129 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83133 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83137 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83141 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83147 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  83149 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  83153 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83157 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83161 */     // MIs[6] Op3
     /*  83161 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  83166 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83168 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  83177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  83181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  83185 */     GIR_RootConstrainSelectedInstOperands,
     /*  83186 */     // GIR_Coverage, 15760,
     /*  83186 */     GIR_EraseRootFromParent_Done,
     /*  83187 */   // Label 1290: @83187
     /*  83187 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(83305), // Rule ID 15762 //
     /*  83192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83223 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83231 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83237 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83239 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  83243 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83247 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83251 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83255 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83259 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83265 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  83267 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  83271 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83275 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83279 */     // MIs[6] Op3
     /*  83279 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83284 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83286 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  83295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  83299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83303 */     GIR_RootConstrainSelectedInstOperands,
     /*  83304 */     // GIR_Coverage, 15762,
     /*  83304 */     GIR_EraseRootFromParent_Done,
     /*  83305 */   // Label 1291: @83305
     /*  83305 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(83423), // Rule ID 15729 //
     /*  83310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83341 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83349 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83355 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83357 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83361 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83365 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83369 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83373 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  83377 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83381 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83385 */     // MIs[5] Op3
     /*  83385 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83390 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83394 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83400 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83402 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83404 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  83413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  83417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83421 */     GIR_RootConstrainSelectedInstOperands,
     /*  83422 */     // GIR_Coverage, 15729,
     /*  83422 */     GIR_EraseRootFromParent_Done,
     /*  83423 */   // Label 1292: @83423
     /*  83423 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(83541), // Rule ID 15734 //
     /*  83428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83467 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83473 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83475 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83479 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83483 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83487 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  83491 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83495 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83499 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83503 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83507 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83513 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83515 */     // MIs[4] Op3
     /*  83515 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83520 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83522 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  83531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  83535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83539 */     GIR_RootConstrainSelectedInstOperands,
     /*  83540 */     // GIR_Coverage, 15734,
     /*  83540 */     GIR_EraseRootFromParent_Done,
     /*  83541 */   // Label 1293: @83541
     /*  83541 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(83659), // Rule ID 15735 //
     /*  83546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83585 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83591 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83593 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83597 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83601 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83605 */     // MIs[4] Op3
     /*  83605 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83610 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83614 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83618 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83622 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83626 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83630 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83638 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83640 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  83649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  83653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83657 */     GIR_RootConstrainSelectedInstOperands,
     /*  83658 */     // GIR_Coverage, 15735,
     /*  83658 */     GIR_EraseRootFromParent_Done,
     /*  83659 */   // Label 1294: @83659
     /*  83659 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(83777), // Rule ID 11950 //
     /*  83664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83695 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83703 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83709 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83711 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83715 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83719 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83723 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83727 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  83731 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83735 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83739 */     // MIs[5] Op3
     /*  83739 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83744 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83748 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83754 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83756 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83758 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  83767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  83771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83775 */     GIR_RootConstrainSelectedInstOperands,
     /*  83776 */     // GIR_Coverage, 11950,
     /*  83776 */     GIR_EraseRootFromParent_Done,
     /*  83777 */   // Label 1295: @83777
     /*  83777 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(83895), // Rule ID 15731 //
     /*  83782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  83805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83821 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83827 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83829 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83833 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83837 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83841 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83845 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  83849 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83853 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83857 */     // MIs[5] Op3
     /*  83857 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83862 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83866 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83874 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83876 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  83885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  83889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83893 */     GIR_RootConstrainSelectedInstOperands,
     /*  83894 */     // GIR_Coverage, 15731,
     /*  83894 */     GIR_EraseRootFromParent_Done,
     /*  83895 */   // Label 1296: @83895
     /*  83895 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(84013), // Rule ID 15732 //
     /*  83900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  83923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83939 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83945 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83947 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83951 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83955 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83959 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  83963 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83967 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  83971 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  83975 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  83979 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83985 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  83987 */     // MIs[4] Op3
     /*  83987 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83992 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  83994 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  83994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  83997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  84003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  84007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84011 */     GIR_RootConstrainSelectedInstOperands,
     /*  84012 */     // GIR_Coverage, 15732,
     /*  84012 */     GIR_EraseRootFromParent_Done,
     /*  84013 */   // Label 1297: @84013
     /*  84013 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(84131), // Rule ID 15733 //
     /*  84018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  84041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84057 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84063 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84065 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84069 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84073 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84077 */     // MIs[4] Op3
     /*  84077 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84082 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84086 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84090 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84094 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84098 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84102 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84110 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84112 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  84115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  84121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  84125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84129 */     GIR_RootConstrainSelectedInstOperands,
     /*  84130 */     // GIR_Coverage, 15733,
     /*  84130 */     GIR_EraseRootFromParent_Done,
     /*  84131 */   // Label 1298: @84131
     /*  84131 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(84249), // Rule ID 15730 //
     /*  84136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  84159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84175 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84181 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84183 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84187 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84191 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84195 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84199 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84203 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84207 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84211 */     // MIs[5] Op3
     /*  84211 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  84216 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84220 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84226 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84228 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84230 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  84233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  84239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  84243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  84247 */     GIR_RootConstrainSelectedInstOperands,
     /*  84248 */     // GIR_Coverage, 15730,
     /*  84248 */     GIR_EraseRootFromParent_Done,
     /*  84249 */   // Label 1299: @84249
     /*  84249 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(84367), // Rule ID 15757 //
     /*  84254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84297 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84301 */     // MIs[3] Op3
     /*  84301 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  84306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84310 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84316 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84318 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  84322 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84326 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84330 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84334 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84338 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84344 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84346 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84348 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  84357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  84361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  84365 */     GIR_RootConstrainSelectedInstOperands,
     /*  84366 */     // GIR_Coverage, 15757,
     /*  84366 */     GIR_EraseRootFromParent_Done,
     /*  84367 */   // Label 1300: @84367
     /*  84367 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(84485), // Rule ID 15759 //
     /*  84372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84415 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84419 */     // MIs[3] Op3
     /*  84419 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  84424 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84428 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84434 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84436 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  84440 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84444 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84448 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84452 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84456 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84462 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84464 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84466 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  84475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  84479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  84483 */     GIR_RootConstrainSelectedInstOperands,
     /*  84484 */     // GIR_Coverage, 15759,
     /*  84484 */     GIR_EraseRootFromParent_Done,
     /*  84485 */   // Label 1301: @84485
     /*  84485 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(84603), // Rule ID 11958 //
     /*  84490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84533 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84537 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84541 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84545 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84551 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84553 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  84557 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84561 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84565 */     // MIs[5] Op3
     /*  84565 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  84570 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84574 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84580 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84582 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84584 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  84593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  84597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  84601 */     GIR_RootConstrainSelectedInstOperands,
     /*  84602 */     // GIR_Coverage, 11958,
     /*  84602 */     GIR_EraseRootFromParent_Done,
     /*  84603 */   // Label 1302: @84603
     /*  84603 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(84721), // Rule ID 15758 //
     /*  84608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  84647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84651 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84655 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84659 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  84663 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84669 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  84671 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  84675 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84679 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84683 */     // MIs[5] Op3
     /*  84683 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  84688 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84692 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84698 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84700 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84702 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  84711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  84715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  84719 */     GIR_RootConstrainSelectedInstOperands,
     /*  84720 */     // GIR_Coverage, 15758,
     /*  84720 */     GIR_EraseRootFromParent_Done,
     /*  84721 */   // Label 1303: @84721
     /*  84721 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(84811), // Rule ID 15707 //
     /*  84726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84765 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84771 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84773 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84777 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84781 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84785 */     // MIs[4] Op3
     /*  84785 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84790 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84792 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  84795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  84801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  84805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84809 */     GIR_RootConstrainSelectedInstOperands,
     /*  84810 */     // GIR_Coverage, 15707,
     /*  84810 */     GIR_EraseRootFromParent_Done,
     /*  84811 */   // Label 1304: @84811
     /*  84811 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(84901), // Rule ID 15706 //
     /*  84816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84855 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84861 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84863 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84867 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84871 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84875 */     // MIs[4] Op3
     /*  84875 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84880 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84882 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  84885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  84891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  84895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84899 */     GIR_RootConstrainSelectedInstOperands,
     /*  84900 */     // GIR_Coverage, 15706,
     /*  84900 */     GIR_EraseRootFromParent_Done,
     /*  84901 */   // Label 1305: @84901
     /*  84901 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(84991), // Rule ID 15705 //
     /*  84906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  84929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84945 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84951 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84953 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84957 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84961 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84965 */     // MIs[4] Op3
     /*  84965 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84970 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84972 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  84975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  84981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  84985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84989 */     GIR_RootConstrainSelectedInstOperands,
     /*  84990 */     // GIR_Coverage, 15705,
     /*  84990 */     GIR_EraseRootFromParent_Done,
     /*  84991 */   // Label 1306: @84991
     /*  84991 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(85081), // Rule ID 15704 //
     /*  84996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85031 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85035 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85041 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85043 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85047 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85051 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85055 */     // MIs[4] Op3
     /*  85055 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85060 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85062 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  85071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  85075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85079 */     GIR_RootConstrainSelectedInstOperands,
     /*  85080 */     // GIR_Coverage, 15704,
     /*  85080 */     GIR_EraseRootFromParent_Done,
     /*  85081 */   // Label 1307: @85081
     /*  85081 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(85171), // Rule ID 15701 //
     /*  85086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85129 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85133 */     // MIs[3] Op3
     /*  85133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85142 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85148 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85150 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85152 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  85165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85169 */     GIR_RootConstrainSelectedInstOperands,
     /*  85170 */     // GIR_Coverage, 15701,
     /*  85170 */     GIR_EraseRootFromParent_Done,
     /*  85171 */   // Label 1308: @85171
     /*  85171 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(85261), // Rule ID 15703 //
     /*  85176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85207 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85219 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85223 */     // MIs[3] Op3
     /*  85223 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85228 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85232 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85238 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85240 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85242 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  85255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85259 */     GIR_RootConstrainSelectedInstOperands,
     /*  85260 */     // GIR_Coverage, 15703,
     /*  85260 */     GIR_EraseRootFromParent_Done,
     /*  85261 */   // Label 1309: @85261
     /*  85261 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(85351), // Rule ID 11942 //
     /*  85266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85309 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85313 */     // MIs[3] Op3
     /*  85313 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85318 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85322 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85328 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85330 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85332 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  85345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85349 */     GIR_RootConstrainSelectedInstOperands,
     /*  85350 */     // GIR_Coverage, 11942,
     /*  85350 */     GIR_EraseRootFromParent_Done,
     /*  85351 */   // Label 1310: @85351
     /*  85351 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(85441), // Rule ID 15702 //
     /*  85356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85403 */     // MIs[3] Op3
     /*  85403 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85408 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85412 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85418 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85420 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85422 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  85425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  85435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85439 */     GIR_RootConstrainSelectedInstOperands,
     /*  85440 */     // GIR_Coverage, 15702,
     /*  85440 */     GIR_EraseRootFromParent_Done,
     /*  85441 */   // Label 1311: @85441
     /*  85441 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(85531), // Rule ID 15764 //
     /*  85446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85489 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85493 */     // MIs[3] Op3
     /*  85493 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85498 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  85502 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85508 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85510 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85512 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  85525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85529 */     GIR_RootConstrainSelectedInstOperands,
     /*  85530 */     // GIR_Coverage, 15764,
     /*  85530 */     GIR_EraseRootFromParent_Done,
     /*  85531 */   // Label 1312: @85531
     /*  85531 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(85621), // Rule ID 15766 //
     /*  85536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85579 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85583 */     // MIs[3] Op3
     /*  85583 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  85592 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85598 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85600 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85602 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  85615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85619 */     GIR_RootConstrainSelectedInstOperands,
     /*  85620 */     // GIR_Coverage, 15766,
     /*  85620 */     GIR_EraseRootFromParent_Done,
     /*  85621 */   // Label 1313: @85621
     /*  85621 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(85711), // Rule ID 11959 //
     /*  85626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85669 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85673 */     // MIs[3] Op3
     /*  85673 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  85682 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85688 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85690 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85692 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  85705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85709 */     GIR_RootConstrainSelectedInstOperands,
     /*  85710 */     // GIR_Coverage, 11959,
     /*  85710 */     GIR_EraseRootFromParent_Done,
     /*  85711 */   // Label 1314: @85711
     /*  85711 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(85801), // Rule ID 15765 //
     /*  85716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85759 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85763 */     // MIs[3] Op3
     /*  85763 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  85772 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85778 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85780 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85782 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  85795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85799 */     GIR_RootConstrainSelectedInstOperands,
     /*  85800 */     // GIR_Coverage, 15765,
     /*  85800 */     GIR_EraseRootFromParent_Done,
     /*  85801 */   // Label 1315: @85801
     /*  85801 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(85891), // Rule ID 15768 //
     /*  85806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85837 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  85845 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85851 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85853 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85857 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85861 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85865 */     // MIs[4] Op3
     /*  85865 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  85870 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85872 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  85881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  85885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  85889 */     GIR_RootConstrainSelectedInstOperands,
     /*  85890 */     // GIR_Coverage, 15768,
     /*  85890 */     GIR_EraseRootFromParent_Done,
     /*  85891 */   // Label 1316: @85891
     /*  85891 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(85981), // Rule ID 15770 //
     /*  85896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  85923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85927 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  85935 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85941 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85943 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85947 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85951 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85955 */     // MIs[4] Op3
     /*  85955 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85960 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85962 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  85971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  85975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85979 */     GIR_RootConstrainSelectedInstOperands,
     /*  85980 */     // GIR_Coverage, 15770,
     /*  85980 */     GIR_EraseRootFromParent_Done,
     /*  85981 */   // Label 1317: @85981
     /*  85981 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(86071), // Rule ID 15767 //
     /*  85986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  86013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  86025 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86031 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86033 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86037 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86041 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86045 */     // MIs[4] Op3
     /*  86045 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  86050 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86052 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  86061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  86065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  86069 */     GIR_RootConstrainSelectedInstOperands,
     /*  86070 */     // GIR_Coverage, 15767,
     /*  86070 */     GIR_EraseRootFromParent_Done,
     /*  86071 */   // Label 1318: @86071
     /*  86071 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(86161), // Rule ID 15769 //
     /*  86076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  86103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  86115 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86121 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86123 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86127 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86131 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86135 */     // MIs[4] Op3
     /*  86135 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86140 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86142 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  86151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  86155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86159 */     GIR_RootConstrainSelectedInstOperands,
     /*  86160 */     // GIR_Coverage, 15769,
     /*  86160 */     GIR_EraseRootFromParent_Done,
     /*  86161 */   // Label 1319: @86161
     /*  86161 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(86176), // Rule ID 7522 //
     /*  86166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  86169 */     // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  86169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  86174 */     GIR_RootConstrainSelectedInstOperands,
     /*  86175 */     // GIR_Coverage, 7522,
     /*  86175 */     GIR_Done,
     /*  86176 */   // Label 1320: @86176
     /*  86176 */   GIM_Reject,
     /*  86177 */ // Label 1287: @86177
     /*  86177 */ GIM_Reject,
     /*  86178 */ // Label 1032: @86178
     /*  86178 */ GIM_Reject,
     /*  86179 */ // Label 7: @86179
     /*  86179 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1339*/ GIMT_Encode4(97146),
     /*  86190 */ /*GILLT_s32*//*Label 1321*/ GIMT_Encode4(86278),
     /*  86194 */ /*GILLT_s64*//*Label 1322*/ GIMT_Encode4(86958), GIMT_Encode4(0),
     /*  86202 */ /*GILLT_v2s32*//*Label 1323*/ GIMT_Encode4(87801),
     /*  86206 */ /*GILLT_v2s64*//*Label 1324*/ GIMT_Encode4(88036),
     /*  86210 */ /*GILLT_v4s16*//*Label 1325*/ GIMT_Encode4(88725),
     /*  86214 */ /*GILLT_v4s32*//*Label 1326*/ GIMT_Encode4(88960),
     /*  86218 */ /*GILLT_v8s8*//*Label 1327*/ GIMT_Encode4(89649),
     /*  86222 */ /*GILLT_v8s16*//*Label 1328*/ GIMT_Encode4(89887),
     /*  86226 */ /*GILLT_v16s8*//*Label 1329*/ GIMT_Encode4(90576),
     /*  86230 */ /*GILLT_nxv1s1*//*Label 1330*/ GIMT_Encode4(91268),
     /*  86234 */ /*GILLT_nxv2s1*//*Label 1331*/ GIMT_Encode4(91318), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  86246 */ /*GILLT_nxv2s64*//*Label 1332*/ GIMT_Encode4(91368),
     /*  86250 */ /*GILLT_nxv4s1*//*Label 1333*/ GIMT_Encode4(92775), GIMT_Encode4(0),
     /*  86258 */ /*GILLT_nxv4s32*//*Label 1334*/ GIMT_Encode4(92825),
     /*  86262 */ /*GILLT_nxv8s1*//*Label 1335*/ GIMT_Encode4(94232),
     /*  86266 */ /*GILLT_nxv8s16*//*Label 1336*/ GIMT_Encode4(94282),
     /*  86270 */ /*GILLT_nxv16s1*//*Label 1337*/ GIMT_Encode4(95689),
     /*  86274 */ /*GILLT_nxv16s8*//*Label 1338*/ GIMT_Encode4(95739),
     /*  86278 */ // Label 1321: @86278
     /*  86278 */ GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(86957),
     /*  86283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  86286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86289 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(86347), // Rule ID 13318 //
     /*  86294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86319 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86332 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86341 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86345 */     GIR_RootConstrainSelectedInstOperands,
     /*  86346 */     // GIR_Coverage, 13318,
     /*  86346 */     GIR_EraseRootFromParent_Done,
     /*  86347 */   // Label 1341: @86347
     /*  86347 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(86402), // Rule ID 13317 //
     /*  86352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86372 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86389 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  86396 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86400 */     GIR_RootConstrainSelectedInstOperands,
     /*  86401 */     // GIR_Coverage, 13317,
     /*  86401 */     GIR_EraseRootFromParent_Done,
     /*  86402 */   // Label 1342: @86402
     /*  86402 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(86460), // Rule ID 13315 //
     /*  86407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  86436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86445 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86454 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86458 */     GIR_RootConstrainSelectedInstOperands,
     /*  86459 */     // GIR_Coverage, 13315,
     /*  86459 */     GIR_EraseRootFromParent_Done,
     /*  86460 */   // Label 1343: @86460
     /*  86460 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(86518), // Rule ID 166 //
     /*  86465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  86494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86503 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86512 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86516 */     GIR_RootConstrainSelectedInstOperands,
     /*  86517 */     // GIR_Coverage, 166,
     /*  86517 */     GIR_EraseRootFromParent_Done,
     /*  86518 */   // Label 1344: @86518
     /*  86518 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(86576), // Rule ID 13316 //
     /*  86523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86548 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86561 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86570 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86574 */     GIR_RootConstrainSelectedInstOperands,
     /*  86575 */     // GIR_Coverage, 13316,
     /*  86575 */     GIR_EraseRootFromParent_Done,
     /*  86576 */   // Label 1345: @86576
     /*  86576 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(86631), // Rule ID 13319 //
     /*  86581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86605 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86611 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86618 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  86621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  86625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86629 */     GIR_RootConstrainSelectedInstOperands,
     /*  86630 */     // GIR_Coverage, 13319,
     /*  86630 */     GIR_EraseRootFromParent_Done,
     /*  86631 */   // Label 1346: @86631
     /*  86631 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(86672), // Rule ID 144 //
     /*  86636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  86640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86652 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  86656 */     // MIs[1] Operand 1
     /*  86656 */     // No operand predicates
     /*  86656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86658 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  86658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  86661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  86665 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  86670 */     GIR_RootConstrainSelectedInstOperands,
     /*  86671 */     // GIR_Coverage, 144,
     /*  86671 */     GIR_EraseRootFromParent_Done,
     /*  86672 */   // Label 1347: @86672
     /*  86672 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(86705), // Rule ID 13325 //
     /*  86677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86692 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  86695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  86699 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86703 */     GIR_RootConstrainSelectedInstOperands,
     /*  86704 */     // GIR_Coverage, 13325,
     /*  86704 */     GIR_EraseRootFromParent_Done,
     /*  86705 */   // Label 1348: @86705
     /*  86705 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(86738), // Rule ID 170 //
     /*  86710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  86725 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  86725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  86728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  86732 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  86736 */     GIR_RootConstrainSelectedInstOperands,
     /*  86737 */     // GIR_Coverage, 170,
     /*  86737 */     GIR_EraseRootFromParent_Done,
     /*  86738 */   // Label 1349: @86738
     /*  86738 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(86791), // Rule ID 13311 //
     /*  86743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86768 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86778 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  86778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  86781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  86789 */     GIR_RootConstrainSelectedInstOperands,
     /*  86790 */     // GIR_Coverage, 13311,
     /*  86790 */     GIR_EraseRootFromParent_Done,
     /*  86791 */   // Label 1350: @86791
     /*  86791 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(86847), // Rule ID 164 //
     /*  86796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  86830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86832 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  86832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  86835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  86845 */     GIR_RootConstrainSelectedInstOperands,
     /*  86846 */     // GIR_Coverage, 164,
     /*  86846 */     GIR_EraseRootFromParent_Done,
     /*  86847 */   // Label 1351: @86847
     /*  86847 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(86900), // Rule ID 13312 //
     /*  86852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  86872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  86876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86881 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  86885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86887 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  86887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  86890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  86898 */     GIR_RootConstrainSelectedInstOperands,
     /*  86899 */     // GIR_Coverage, 13312,
     /*  86899 */     GIR_EraseRootFromParent_Done,
     /*  86900 */   // Label 1352: @86900
     /*  86900 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(86932), // Rule ID 4002 //
     /*  86905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  86917 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  86917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  86920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  86930 */     GIR_RootConstrainSelectedInstOperands,
     /*  86931 */     // GIR_Coverage, 4002,
     /*  86931 */     GIR_EraseRootFromParent_Done,
     /*  86932 */   // Label 1353: @86932
     /*  86932 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(86956), // Rule ID 168 //
     /*  86937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  86949 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  86949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  86954 */     GIR_RootConstrainSelectedInstOperands,
     /*  86955 */     // GIR_Coverage, 168,
     /*  86955 */     GIR_Done,
     /*  86956 */   // Label 1354: @86956
     /*  86956 */   GIM_Reject,
     /*  86957 */ // Label 1340: @86957
     /*  86957 */ GIM_Reject,
     /*  86958 */ // Label 1322: @86958
     /*  86958 */ GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(87800),
     /*  86963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  86966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  86969 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(87027), // Rule ID 13323 //
     /*  86974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  86990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  86994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  86999 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87012 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87025 */     GIR_RootConstrainSelectedInstOperands,
     /*  87026 */     // GIR_Coverage, 13323,
     /*  87026 */     GIR_EraseRootFromParent_Done,
     /*  87027 */   // Label 1356: @87027
     /*  87027 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(87082), // Rule ID 13322 //
     /*  87032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87052 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87062 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87069 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  87076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87080 */     GIR_RootConstrainSelectedInstOperands,
     /*  87081 */     // GIR_Coverage, 13322,
     /*  87081 */     GIR_EraseRootFromParent_Done,
     /*  87082 */   // Label 1357: @87082
     /*  87082 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(87140), // Rule ID 13320 //
     /*  87087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87125 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  87134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87138 */     GIR_RootConstrainSelectedInstOperands,
     /*  87139 */     // GIR_Coverage, 13320,
     /*  87139 */     GIR_EraseRootFromParent_Done,
     /*  87140 */   // Label 1358: @87140
     /*  87140 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(87198), // Rule ID 167 //
     /*  87145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87183 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87192 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87196 */     GIR_RootConstrainSelectedInstOperands,
     /*  87197 */     // GIR_Coverage, 167,
     /*  87197 */     GIR_EraseRootFromParent_Done,
     /*  87198 */   // Label 1359: @87198
     /*  87198 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(87256), // Rule ID 13321 //
     /*  87203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87228 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87241 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87250 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87254 */     GIR_RootConstrainSelectedInstOperands,
     /*  87255 */     // GIR_Coverage, 13321,
     /*  87255 */     GIR_EraseRootFromParent_Done,
     /*  87256 */   // Label 1360: @87256
     /*  87256 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(87311), // Rule ID 13324 //
     /*  87261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87285 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87298 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  87301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87305 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87309 */     GIR_RootConstrainSelectedInstOperands,
     /*  87310 */     // GIR_Coverage, 13324,
     /*  87310 */     GIR_EraseRootFromParent_Done,
     /*  87311 */   // Label 1361: @87311
     /*  87311 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(87411), // Rule ID 1613 //
     /*  87316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  87331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87335 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  87339 */     // MIs[1] Operand 1
     /*  87339 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  87344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  87348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  87356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  87360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  87374 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87380 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  87382 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87386 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87392 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87394 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87396 */     // (xor:{ *:[v1i64] } (setcc:{ *:[v1i64] } (and:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm), immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v1i64] })  =>  (CMTSTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  87396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv1i64),
     /*  87399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  87405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  87409 */     GIR_RootConstrainSelectedInstOperands,
     /*  87410 */     // GIR_Coverage, 1613,
     /*  87410 */     GIR_EraseRootFromParent_Done,
     /*  87411 */   // Label 1362: @87411
     /*  87411 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(87452), // Rule ID 145 //
     /*  87416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  87420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87432 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  87436 */     // MIs[1] Operand 1
     /*  87436 */     // No operand predicates
     /*  87436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87438 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  87438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  87441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87445 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  87450 */     GIR_RootConstrainSelectedInstOperands,
     /*  87451 */     // GIR_Coverage, 145,
     /*  87451 */     GIR_EraseRootFromParent_Done,
     /*  87452 */   // Label 1363: @87452
     /*  87452 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(87485), // Rule ID 13326 //
     /*  87457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87472 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  87475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  87479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87483 */     GIR_RootConstrainSelectedInstOperands,
     /*  87484 */     // GIR_Coverage, 13326,
     /*  87484 */     GIR_EraseRootFromParent_Done,
     /*  87485 */   // Label 1364: @87485
     /*  87485 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(87518), // Rule ID 171 //
     /*  87490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  87505 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  87505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  87508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87512 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87516 */     GIR_RootConstrainSelectedInstOperands,
     /*  87517 */     // GIR_Coverage, 171,
     /*  87517 */     GIR_EraseRootFromParent_Done,
     /*  87518 */   // Label 1365: @87518
     /*  87518 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(87571), // Rule ID 13313 //
     /*  87523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87548 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87558 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  87558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  87561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  87569 */     GIR_RootConstrainSelectedInstOperands,
     /*  87570 */     // GIR_Coverage, 13313,
     /*  87570 */     GIR_EraseRootFromParent_Done,
     /*  87571 */   // Label 1366: @87571
     /*  87571 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(87627), // Rule ID 165 //
     /*  87576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87612 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  87612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  87615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  87625 */     GIR_RootConstrainSelectedInstOperands,
     /*  87626 */     // GIR_Coverage, 165,
     /*  87626 */     GIR_EraseRootFromParent_Done,
     /*  87627 */   // Label 1367: @87627
     /*  87627 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(87680), // Rule ID 13314 //
     /*  87632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  87652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87661 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87667 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  87667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  87670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  87678 */     GIR_RootConstrainSelectedInstOperands,
     /*  87679 */     // GIR_Coverage, 13314,
     /*  87679 */     GIR_EraseRootFromParent_Done,
     /*  87680 */   // Label 1368: @87680
     /*  87680 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(87712), // Rule ID 4003 //
     /*  87685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87697 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  87697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  87700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  87710 */     GIR_RootConstrainSelectedInstOperands,
     /*  87711 */     // GIR_Coverage, 4003,
     /*  87711 */     GIR_EraseRootFromParent_Done,
     /*  87712 */   // Label 1369: @87712
     /*  87712 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(87748), // Rule ID 4987 //
     /*  87717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87729 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  87737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87739 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  87739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  87742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87746 */     GIR_RootConstrainSelectedInstOperands,
     /*  87747 */     // GIR_Coverage, 4987,
     /*  87747 */     GIR_EraseRootFromParent_Done,
     /*  87748 */   // Label 1370: @87748
     /*  87748 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(87772), // Rule ID 169 //
     /*  87753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  87765 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  87765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  87770 */     GIR_RootConstrainSelectedInstOperands,
     /*  87771 */     // GIR_Coverage, 169,
     /*  87771 */     GIR_Done,
     /*  87772 */   // Label 1371: @87772
     /*  87772 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(87799), // Rule ID 5086 //
     /*  87777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87792 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  87792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  87797 */     GIR_RootConstrainSelectedInstOperands,
     /*  87798 */     // GIR_Coverage, 5086,
     /*  87798 */     GIR_Done,
     /*  87799 */   // Label 1372: @87799
     /*  87799 */   GIM_Reject,
     /*  87800 */ // Label 1355: @87800
     /*  87800 */ GIM_Reject,
     /*  87801 */ // Label 1323: @87801
     /*  87801 */ GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(88035),
     /*  87806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  87812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87816 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(87912), // Rule ID 1160 //
     /*  87821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  87832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  87836 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  87840 */     // MIs[1] Operand 1
     /*  87840 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  87845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  87849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  87857 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  87861 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  87875 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87881 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  87883 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87887 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87893 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87895 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87897 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  87897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  87900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  87906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  87910 */     GIR_RootConstrainSelectedInstOperands,
     /*  87911 */     // GIR_Coverage, 1160,
     /*  87911 */     GIR_EraseRootFromParent_Done,
     /*  87912 */   // Label 1374: @87912
     /*  87912 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(87979), // Rule ID 5034 //
     /*  87917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  87925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  87929 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  87933 */     // MIs[1] Operand 1
     /*  87933 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  87938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  87942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87948 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  87950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  87954 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87960 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87964 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, v2i32:{ *:[v2i32] }:$Rn)
     /*  87964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  87967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  87973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  87977 */     GIR_RootConstrainSelectedInstOperands,
     /*  87978 */     // GIR_Coverage, 5034,
     /*  87978 */     GIR_EraseRootFromParent_Done,
     /*  87979 */   // Label 1375: @87979
     /*  87979 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(88011), // Rule ID 4985 //
     /*  87984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87992 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87998 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  88000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88002 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  88002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  88005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88009 */     GIR_RootConstrainSelectedInstOperands,
     /*  88010 */     // GIR_Coverage, 4985,
     /*  88010 */     GIR_EraseRootFromParent_Done,
     /*  88011 */   // Label 1376: @88011
     /*  88011 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(88034), // Rule ID 5085 //
     /*  88016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88027 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  88027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  88032 */     GIR_RootConstrainSelectedInstOperands,
     /*  88033 */     // GIR_Coverage, 5085,
     /*  88033 */     GIR_Done,
     /*  88034 */   // Label 1377: @88034
     /*  88034 */   GIM_Reject,
     /*  88035 */ // Label 1373: @88035
     /*  88035 */ GIM_Reject,
     /*  88036 */ // Label 1324: @88036
     /*  88036 */ GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(88724),
     /*  88041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88051 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(88147), // Rule ID 1162 //
     /*  88056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88071 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  88075 */     // MIs[1] Operand 1
     /*  88075 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  88110 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88116 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  88118 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  88122 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88128 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  88130 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  88132 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  88132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  88135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  88141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  88145 */     GIR_RootConstrainSelectedInstOperands,
     /*  88146 */     // GIR_Coverage, 1162,
     /*  88146 */     GIR_EraseRootFromParent_Done,
     /*  88147 */   // Label 1379: @88147
     /*  88147 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(88214), // Rule ID 5036 //
     /*  88152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88164 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  88168 */     // MIs[1] Operand 1
     /*  88168 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  88177 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88183 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  88185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  88189 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88195 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88197 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88199 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, v2i64:{ *:[v2i64] }:$Rn)
     /*  88199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  88202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88212 */     GIR_RootConstrainSelectedInstOperands,
     /*  88213 */     // GIR_Coverage, 5036,
     /*  88213 */     GIR_EraseRootFromParent_Done,
     /*  88214 */   // Label 1380: @88214
     /*  88214 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(88299), // Rule ID 13848 //
     /*  88219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  88242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  88263 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88269 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88282 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  88285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  88289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  88293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  88297 */     GIR_RootConstrainSelectedInstOperands,
     /*  88298 */     // GIR_Coverage, 13848,
     /*  88298 */     GIR_EraseRootFromParent_Done,
     /*  88299 */   // Label 1381: @88299
     /*  88299 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(88384), // Rule ID 13847 //
     /*  88304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88340 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  88353 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88359 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88367 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  88370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  88374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  88378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  88382 */     GIR_RootConstrainSelectedInstOperands,
     /*  88383 */     // GIR_Coverage, 13847,
     /*  88383 */     GIR_EraseRootFromParent_Done,
     /*  88384 */   // Label 1382: @88384
     /*  88384 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(88469), // Rule ID 13846 //
     /*  88389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  88416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  88437 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88443 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88452 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  88455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  88459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  88463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  88467 */     GIR_RootConstrainSelectedInstOperands,
     /*  88468 */     // GIR_Coverage, 13846,
     /*  88468 */     GIR_EraseRootFromParent_Done,
     /*  88469 */   // Label 1383: @88469
     /*  88469 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(88554), // Rule ID 3830 //
     /*  88474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  88527 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88533 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88537 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  88540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  88544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  88548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  88552 */     GIR_RootConstrainSelectedInstOperands,
     /*  88553 */     // GIR_Coverage, 3830,
     /*  88553 */     GIR_EraseRootFromParent_Done,
     /*  88554 */   // Label 1384: @88554
     /*  88554 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(88586), // Rule ID 4988 //
     /*  88559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88567 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88573 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  88575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88577 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  88577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  88580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88584 */     GIR_RootConstrainSelectedInstOperands,
     /*  88585 */     // GIR_Coverage, 4988,
     /*  88585 */     GIR_EraseRootFromParent_Done,
     /*  88586 */   // Label 1385: @88586
     /*  88586 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(88643), // Rule ID 3826 //
     /*  88591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88626 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  88629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  88635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  88639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  88641 */     GIR_RootConstrainSelectedInstOperands,
     /*  88642 */     // GIR_Coverage, 3826,
     /*  88642 */     GIR_EraseRootFromParent_Done,
     /*  88643 */   // Label 1386: @88643
     /*  88643 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(88700), // Rule ID 13836 //
     /*  88648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  88651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88683 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  88683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  88686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  88688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  88692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  88696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  88698 */     GIR_RootConstrainSelectedInstOperands,
     /*  88699 */     // GIR_Coverage, 13836,
     /*  88699 */     GIR_EraseRootFromParent_Done,
     /*  88700 */   // Label 1387: @88700
     /*  88700 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(88723), // Rule ID 5089 //
     /*  88705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88716 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  88716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  88721 */     GIR_RootConstrainSelectedInstOperands,
     /*  88722 */     // GIR_Coverage, 5089,
     /*  88722 */     GIR_Done,
     /*  88723 */   // Label 1388: @88723
     /*  88723 */   GIM_Reject,
     /*  88724 */ // Label 1378: @88724
     /*  88724 */ GIM_Reject,
     /*  88725 */ // Label 1325: @88725
     /*  88725 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(88959),
     /*  88730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  88736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88740 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(88836), // Rule ID 1158 //
     /*  88745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  88760 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  88764 */     // MIs[1] Operand 1
     /*  88764 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  88785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  88799 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88805 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  88807 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  88811 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88817 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  88819 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  88821 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  88821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  88824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  88830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  88834 */     GIR_RootConstrainSelectedInstOperands,
     /*  88835 */     // GIR_Coverage, 1158,
     /*  88835 */     GIR_EraseRootFromParent_Done,
     /*  88836 */   // Label 1390: @88836
     /*  88836 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(88903), // Rule ID 5032 //
     /*  88841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  88853 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  88857 */     // MIs[1] Operand 1
     /*  88857 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  88866 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88872 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  88874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  88878 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  88886 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88888 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, v4i16:{ *:[v4i16] }:$Rn)
     /*  88888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  88891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88901 */     GIR_RootConstrainSelectedInstOperands,
     /*  88902 */     // GIR_Coverage, 5032,
     /*  88902 */     GIR_EraseRootFromParent_Done,
     /*  88903 */   // Label 1391: @88903
     /*  88903 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(88935), // Rule ID 4983 //
     /*  88908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88916 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88922 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  88924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88926 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  88926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  88929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88933 */     GIR_RootConstrainSelectedInstOperands,
     /*  88934 */     // GIR_Coverage, 4983,
     /*  88934 */     GIR_EraseRootFromParent_Done,
     /*  88935 */   // Label 1392: @88935
     /*  88935 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(88958), // Rule ID 5084 //
     /*  88940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88951 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  88951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  88956 */     GIR_RootConstrainSelectedInstOperands,
     /*  88957 */     // GIR_Coverage, 5084,
     /*  88957 */     GIR_Done,
     /*  88958 */   // Label 1393: @88958
     /*  88958 */   GIM_Reject,
     /*  88959 */ // Label 1389: @88959
     /*  88959 */ GIM_Reject,
     /*  88960 */ // Label 1326: @88960
     /*  88960 */ GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(89648),
     /*  88965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  88968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88975 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(89071), // Rule ID 1161 //
     /*  88980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88995 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88999 */     // MIs[1] Operand 1
     /*  88999 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89034 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89040 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89042 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89046 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89052 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89054 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89056 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  89056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  89059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89069 */     GIR_RootConstrainSelectedInstOperands,
     /*  89070 */     // GIR_Coverage, 1161,
     /*  89070 */     GIR_EraseRootFromParent_Done,
     /*  89071 */   // Label 1395: @89071
     /*  89071 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(89138), // Rule ID 5035 //
     /*  89076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89088 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89092 */     // MIs[1] Operand 1
     /*  89092 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  89101 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89107 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  89109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  89113 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89121 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89123 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, v4i32:{ *:[v4i32] }:$Rn)
     /*  89123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  89126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89136 */     GIR_RootConstrainSelectedInstOperands,
     /*  89137 */     // GIR_Coverage, 5035,
     /*  89137 */     GIR_EraseRootFromParent_Done,
     /*  89138 */   // Label 1396: @89138
     /*  89138 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(89223), // Rule ID 13845 //
     /*  89143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  89166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89187 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89193 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89206 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  89213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89221 */     GIR_RootConstrainSelectedInstOperands,
     /*  89222 */     // GIR_Coverage, 13845,
     /*  89222 */     GIR_EraseRootFromParent_Done,
     /*  89223 */   // Label 1397: @89223
     /*  89223 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(89308), // Rule ID 13844 //
     /*  89228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89277 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89283 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89291 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  89298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  89302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89306 */     GIR_RootConstrainSelectedInstOperands,
     /*  89307 */     // GIR_Coverage, 13844,
     /*  89307 */     GIR_EraseRootFromParent_Done,
     /*  89308 */   // Label 1398: @89308
     /*  89308 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(89393), // Rule ID 13843 //
     /*  89313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  89340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89352 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89361 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89367 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89374 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89376 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  89383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89391 */     GIR_RootConstrainSelectedInstOperands,
     /*  89392 */     // GIR_Coverage, 13843,
     /*  89392 */     GIR_EraseRootFromParent_Done,
     /*  89393 */   // Label 1399: @89393
     /*  89393 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(89478), // Rule ID 3829 //
     /*  89398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89438 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89451 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89457 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89461 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  89468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  89472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89476 */     GIR_RootConstrainSelectedInstOperands,
     /*  89477 */     // GIR_Coverage, 3829,
     /*  89477 */     GIR_EraseRootFromParent_Done,
     /*  89478 */   // Label 1400: @89478
     /*  89478 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(89510), // Rule ID 4986 //
     /*  89483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89491 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89497 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  89499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89501 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  89501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  89504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89508 */     GIR_RootConstrainSelectedInstOperands,
     /*  89509 */     // GIR_Coverage, 4986,
     /*  89509 */     GIR_EraseRootFromParent_Done,
     /*  89510 */   // Label 1401: @89510
     /*  89510 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(89567), // Rule ID 3825 //
     /*  89515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89550 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  89553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  89559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  89565 */     GIR_RootConstrainSelectedInstOperands,
     /*  89566 */     // GIR_Coverage, 3825,
     /*  89566 */     GIR_EraseRootFromParent_Done,
     /*  89567 */   // Label 1402: @89567
     /*  89567 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(89624), // Rule ID 13835 //
     /*  89572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89607 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  89607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  89610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  89616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  89622 */     GIR_RootConstrainSelectedInstOperands,
     /*  89623 */     // GIR_Coverage, 13835,
     /*  89623 */     GIR_EraseRootFromParent_Done,
     /*  89624 */   // Label 1403: @89624
     /*  89624 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(89647), // Rule ID 5088 //
     /*  89629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89640 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  89640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  89645 */     GIR_RootConstrainSelectedInstOperands,
     /*  89646 */     // GIR_Coverage, 5088,
     /*  89646 */     GIR_Done,
     /*  89647 */   // Label 1404: @89647
     /*  89647 */   GIM_Reject,
     /*  89648 */ // Label 1394: @89648
     /*  89648 */ GIM_Reject,
     /*  89649 */ // Label 1327: @89649
     /*  89649 */ GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(89886),
     /*  89654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  89660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89664 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(89760), // Rule ID 1156 //
     /*  89669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  89684 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  89688 */     // MIs[1] Operand 1
     /*  89688 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89705 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  89709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89723 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89729 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89735 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89741 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89743 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89745 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  89745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  89748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89758 */     GIR_RootConstrainSelectedInstOperands,
     /*  89759 */     // GIR_Coverage, 1156,
     /*  89759 */     GIR_EraseRootFromParent_Done,
     /*  89760 */   // Label 1406: @89760
     /*  89760 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(89827), // Rule ID 5030 //
     /*  89765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  89777 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  89781 */     // MIs[1] Operand 1
     /*  89781 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  89790 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89796 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  89798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  89802 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89810 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89812 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rn)
     /*  89812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  89815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89825 */     GIR_RootConstrainSelectedInstOperands,
     /*  89826 */     // GIR_Coverage, 5030,
     /*  89826 */     GIR_EraseRootFromParent_Done,
     /*  89827 */   // Label 1407: @89827
     /*  89827 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(89862), // Rule ID 972 //
     /*  89832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89843 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89849 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  89851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89853 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  89853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  89856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89858 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89860 */     GIR_RootConstrainSelectedInstOperands,
     /*  89861 */     // GIR_Coverage, 972,
     /*  89861 */     GIR_EraseRootFromParent_Done,
     /*  89862 */   // Label 1408: @89862
     /*  89862 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(89885), // Rule ID 1599 //
     /*  89867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89878 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  89878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  89883 */     GIR_RootConstrainSelectedInstOperands,
     /*  89884 */     // GIR_Coverage, 1599,
     /*  89884 */     GIR_Done,
     /*  89885 */   // Label 1409: @89885
     /*  89885 */   GIM_Reject,
     /*  89886 */ // Label 1405: @89886
     /*  89886 */ GIM_Reject,
     /*  89887 */ // Label 1328: @89887
     /*  89887 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(90575),
     /*  89892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89902 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(89998), // Rule ID 1159 //
     /*  89907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89922 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89926 */     // MIs[1] Operand 1
     /*  89926 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89947 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89961 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89967 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89969 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89973 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89979 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89981 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89983 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  89983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  89986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89996 */     GIR_RootConstrainSelectedInstOperands,
     /*  89997 */     // GIR_Coverage, 1159,
     /*  89997 */     GIR_EraseRootFromParent_Done,
     /*  89998 */   // Label 1411: @89998
     /*  89998 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(90065), // Rule ID 5033 //
     /*  90003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90015 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90019 */     // MIs[1] Operand 1
     /*  90019 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90028 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90034 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90040 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90046 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90050 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, v8i16:{ *:[v8i16] }:$Rn)
     /*  90050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  90053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90063 */     GIR_RootConstrainSelectedInstOperands,
     /*  90064 */     // GIR_Coverage, 5033,
     /*  90064 */     GIR_EraseRootFromParent_Done,
     /*  90065 */   // Label 1412: @90065
     /*  90065 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(90150), // Rule ID 13842 //
     /*  90070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90114 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90120 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90133 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90148 */     GIR_RootConstrainSelectedInstOperands,
     /*  90149 */     // GIR_Coverage, 13842,
     /*  90149 */     GIR_EraseRootFromParent_Done,
     /*  90150 */   // Label 1413: @90150
     /*  90150 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(90235), // Rule ID 13841 //
     /*  90155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90191 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90204 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90210 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90218 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90233 */     GIR_RootConstrainSelectedInstOperands,
     /*  90234 */     // GIR_Coverage, 13841,
     /*  90234 */     GIR_EraseRootFromParent_Done,
     /*  90235 */   // Label 1414: @90235
     /*  90235 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(90320), // Rule ID 13840 //
     /*  90240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90288 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90294 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90303 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90318 */     GIR_RootConstrainSelectedInstOperands,
     /*  90319 */     // GIR_Coverage, 13840,
     /*  90319 */     GIR_EraseRootFromParent_Done,
     /*  90320 */   // Label 1415: @90320
     /*  90320 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(90405), // Rule ID 3828 //
     /*  90325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90365 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90378 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90384 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90388 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90403 */     GIR_RootConstrainSelectedInstOperands,
     /*  90404 */     // GIR_Coverage, 3828,
     /*  90404 */     GIR_EraseRootFromParent_Done,
     /*  90405 */   // Label 1416: @90405
     /*  90405 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(90437), // Rule ID 4984 //
     /*  90410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90418 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90424 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  90426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90428 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  90428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  90431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  90435 */     GIR_RootConstrainSelectedInstOperands,
     /*  90436 */     // GIR_Coverage, 4984,
     /*  90436 */     GIR_EraseRootFromParent_Done,
     /*  90437 */   // Label 1417: @90437
     /*  90437 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(90494), // Rule ID 3824 //
     /*  90442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90477 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  90480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  90486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  90492 */     GIR_RootConstrainSelectedInstOperands,
     /*  90493 */     // GIR_Coverage, 3824,
     /*  90493 */     GIR_EraseRootFromParent_Done,
     /*  90494 */   // Label 1418: @90494
     /*  90494 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(90551), // Rule ID 13834 //
     /*  90499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90534 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  90534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  90537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  90543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  90549 */     GIR_RootConstrainSelectedInstOperands,
     /*  90550 */     // GIR_Coverage, 13834,
     /*  90550 */     GIR_EraseRootFromParent_Done,
     /*  90551 */   // Label 1419: @90551
     /*  90551 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(90574), // Rule ID 5087 //
     /*  90556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90567 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  90567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  90572 */     GIR_RootConstrainSelectedInstOperands,
     /*  90573 */     // GIR_Coverage, 5087,
     /*  90573 */     GIR_Done,
     /*  90574 */   // Label 1420: @90574
     /*  90574 */   GIM_Reject,
     /*  90575 */ // Label 1410: @90575
     /*  90575 */ GIM_Reject,
     /*  90576 */ // Label 1329: @90576
     /*  90576 */ GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(91267),
     /*  90581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90591 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(90687), // Rule ID 1157 //
     /*  90596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90611 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90615 */     // MIs[1] Operand 1
     /*  90615 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  90650 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90656 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  90658 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  90662 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90668 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  90670 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  90672 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  90672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  90675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  90681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  90685 */     GIR_RootConstrainSelectedInstOperands,
     /*  90686 */     // GIR_Coverage, 1157,
     /*  90686 */     GIR_EraseRootFromParent_Done,
     /*  90687 */   // Label 1422: @90687
     /*  90687 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(90754), // Rule ID 5031 //
     /*  90692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90704 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90708 */     // MIs[1] Operand 1
     /*  90708 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90717 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90723 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90729 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90737 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90739 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rn)
     /*  90739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  90742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90752 */     GIR_RootConstrainSelectedInstOperands,
     /*  90753 */     // GIR_Coverage, 5031,
     /*  90753 */     GIR_EraseRootFromParent_Done,
     /*  90754 */   // Label 1423: @90754
     /*  90754 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(90839), // Rule ID 13839 //
     /*  90759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90803 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90809 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90820 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90822 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  90822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90837 */     GIR_RootConstrainSelectedInstOperands,
     /*  90838 */     // GIR_Coverage, 13839,
     /*  90838 */     GIR_EraseRootFromParent_Done,
     /*  90839 */   // Label 1424: @90839
     /*  90839 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(90924), // Rule ID 13838 //
     /*  90844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90893 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90899 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90907 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  90907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90922 */     GIR_RootConstrainSelectedInstOperands,
     /*  90923 */     // GIR_Coverage, 13838,
     /*  90923 */     GIR_EraseRootFromParent_Done,
     /*  90924 */   // Label 1425: @90924
     /*  90924 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(91009), // Rule ID 13837 //
     /*  90929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90977 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90983 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90992 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  90992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91007 */     GIR_RootConstrainSelectedInstOperands,
     /*  91008 */     // GIR_Coverage, 13837,
     /*  91008 */     GIR_EraseRootFromParent_Done,
     /*  91009 */   // Label 1426: @91009
     /*  91009 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(91094), // Rule ID 3827 //
     /*  91014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91067 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91073 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91077 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  91077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  91084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  91088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91092 */     GIR_RootConstrainSelectedInstOperands,
     /*  91093 */     // GIR_Coverage, 3827,
     /*  91093 */     GIR_EraseRootFromParent_Done,
     /*  91094 */   // Label 1427: @91094
     /*  91094 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(91129), // Rule ID 973 //
     /*  91099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91110 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  91118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91120 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  91120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  91123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  91127 */     GIR_RootConstrainSelectedInstOperands,
     /*  91128 */     // GIR_Coverage, 973,
     /*  91128 */     GIR_EraseRootFromParent_Done,
     /*  91129 */   // Label 1428: @91129
     /*  91129 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(91186), // Rule ID 3823 //
     /*  91134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91169 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  91169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  91184 */     GIR_RootConstrainSelectedInstOperands,
     /*  91185 */     // GIR_Coverage, 3823,
     /*  91185 */     GIR_EraseRootFromParent_Done,
     /*  91186 */   // Label 1429: @91186
     /*  91186 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(91243), // Rule ID 13833 //
     /*  91191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91226 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  91226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  91241 */     GIR_RootConstrainSelectedInstOperands,
     /*  91242 */     // GIR_Coverage, 13833,
     /*  91242 */     GIR_EraseRootFromParent_Done,
     /*  91243 */   // Label 1430: @91243
     /*  91243 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(91266), // Rule ID 1600 //
     /*  91248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91259 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  91259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  91264 */     GIR_RootConstrainSelectedInstOperands,
     /*  91265 */     // GIR_Coverage, 1600,
     /*  91265 */     GIR_Done,
     /*  91266 */   // Label 1431: @91266
     /*  91266 */   GIM_Reject,
     /*  91267 */ // Label 1421: @91267
     /*  91267 */ GIM_Reject,
     /*  91268 */ // Label 1330: @91268
     /*  91268 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(91317), // Rule ID 8510 //
     /*  91273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  91276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  91279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  91282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  91286 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  91286 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  91289 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  91293 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91298 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  91301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  91306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  91308 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91311 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  91313 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  91315 */   GIR_RootConstrainSelectedInstOperands,
     /*  91316 */   // GIR_Coverage, 8510,
     /*  91316 */   GIR_EraseRootFromParent_Done,
     /*  91317 */ // Label 1432: @91317
     /*  91317 */ GIM_Reject,
     /*  91318 */ // Label 1331: @91318
     /*  91318 */ GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(91367), // Rule ID 8509 //
     /*  91323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  91326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  91329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  91332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  91336 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  91336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  91339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  91343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91348 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  91351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  91356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  91358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91361 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  91363 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  91365 */   GIR_RootConstrainSelectedInstOperands,
     /*  91366 */   // GIR_Coverage, 8509,
     /*  91366 */   GIR_EraseRootFromParent_Done,
     /*  91367 */ // Label 1433: @91367
     /*  91367 */ GIM_Reject,
     /*  91368 */ // Label 1332: @91368
     /*  91368 */ GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(92774),
     /*  91373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  91383 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(91501), // Rule ID 15840 //
     /*  91388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  91427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91431 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91435 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91439 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  91443 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91449 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91451 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  91455 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91459 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91463 */     // MIs[5] Op3
     /*  91463 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  91468 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91472 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91478 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91480 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91482 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  91491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  91495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  91499 */     GIR_RootConstrainSelectedInstOperands,
     /*  91500 */     // GIR_Coverage, 15840,
     /*  91500 */     GIR_EraseRootFromParent_Done,
     /*  91501 */   // Label 1435: @91501
     /*  91501 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(91619), // Rule ID 15839 //
     /*  91506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91537 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  91545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91549 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91553 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91557 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  91561 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91567 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91569 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  91573 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91577 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91581 */     // MIs[5] Op3
     /*  91581 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  91586 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91590 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91596 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91598 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91600 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  91609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  91613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  91617 */     GIR_RootConstrainSelectedInstOperands,
     /*  91618 */     // GIR_Coverage, 15839,
     /*  91618 */     GIR_EraseRootFromParent_Done,
     /*  91619 */   // Label 1436: @91619
     /*  91619 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(91737), // Rule ID 15838 //
     /*  91624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91667 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91671 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91675 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  91679 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91685 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91687 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  91691 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91695 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91699 */     // MIs[5] Op3
     /*  91699 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  91704 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91708 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91714 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91716 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91718 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  91727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  91731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  91735 */     GIR_RootConstrainSelectedInstOperands,
     /*  91736 */     // GIR_Coverage, 15838,
     /*  91736 */     GIR_EraseRootFromParent_Done,
     /*  91737 */   // Label 1437: @91737
     /*  91737 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(91855), // Rule ID 15837 //
     /*  91742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91777 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91781 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91785 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91789 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91793 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  91797 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91803 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91805 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  91809 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91813 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91817 */     // MIs[5] Op3
     /*  91817 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  91822 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91826 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91832 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91834 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91836 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  91845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  91849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  91853 */     GIR_RootConstrainSelectedInstOperands,
     /*  91854 */     // GIR_Coverage, 15837,
     /*  91854 */     GIR_EraseRootFromParent_Done,
     /*  91855 */   // Label 1438: @91855
     /*  91855 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(91973), // Rule ID 15834 //
     /*  91860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  91899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91903 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91907 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91911 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  91915 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91919 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91923 */     // MIs[4] Op3
     /*  91923 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  91928 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  91932 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91938 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  91940 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  91944 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91950 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  91952 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  91954 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  91954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  91957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  91959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  91963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  91967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  91971 */     GIR_RootConstrainSelectedInstOperands,
     /*  91972 */     // GIR_Coverage, 15834,
     /*  91972 */     GIR_EraseRootFromParent_Done,
     /*  91973 */   // Label 1439: @91973
     /*  91973 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(92091), // Rule ID 15836 //
     /*  91978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  91981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  91989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  91993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  91997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  92017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92021 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92025 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92029 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  92033 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92037 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92041 */     // MIs[4] Op3
     /*  92041 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  92046 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  92050 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  92058 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92062 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92068 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92070 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92072 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  92081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  92085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92089 */     GIR_RootConstrainSelectedInstOperands,
     /*  92090 */     // GIR_Coverage, 15836,
     /*  92090 */     GIR_EraseRootFromParent_Done,
     /*  92091 */   // Label 1440: @92091
     /*  92091 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(92209), // Rule ID 11976 //
     /*  92096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92131 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  92135 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92139 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92143 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92147 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  92151 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92155 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92159 */     // MIs[4] Op3
     /*  92159 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  92164 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  92168 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92174 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  92176 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92180 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92186 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92188 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92190 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }))), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  92199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  92203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  92207 */     GIR_RootConstrainSelectedInstOperands,
     /*  92208 */     // GIR_Coverage, 11976,
     /*  92208 */     GIR_EraseRootFromParent_Done,
     /*  92209 */   // Label 1441: @92209
     /*  92209 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(92327), // Rule ID 15835 //
     /*  92214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92245 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  92253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92257 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92261 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92265 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  92269 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92273 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92277 */     // MIs[4] Op3
     /*  92277 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  92282 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  92286 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92292 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  92294 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92298 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92304 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92306 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92308 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }))), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  92317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  92321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92325 */     GIR_RootConstrainSelectedInstOperands,
     /*  92326 */     // GIR_Coverage, 15835,
     /*  92326 */     GIR_EraseRootFromParent_Done,
     /*  92327 */   // Label 1442: @92327
     /*  92327 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(92398), // Rule ID 15700 //
     /*  92332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92371 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92377 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92381 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  92384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  92388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  92392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92396 */     GIR_RootConstrainSelectedInstOperands,
     /*  92397 */     // GIR_Coverage, 15700,
     /*  92397 */     GIR_EraseRootFromParent_Done,
     /*  92398 */   // Label 1443: @92398
     /*  92398 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(92469), // Rule ID 15699 //
     /*  92403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92442 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92448 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92450 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92452 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  92455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  92459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  92463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92467 */     GIR_RootConstrainSelectedInstOperands,
     /*  92468 */     // GIR_Coverage, 15699,
     /*  92468 */     GIR_EraseRootFromParent_Done,
     /*  92469 */   // Label 1444: @92469
     /*  92469 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(92540), // Rule ID 15698 //
     /*  92474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92513 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92523 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  92526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  92534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92538 */     GIR_RootConstrainSelectedInstOperands,
     /*  92539 */     // GIR_Coverage, 15698,
     /*  92539 */     GIR_EraseRootFromParent_Done,
     /*  92540 */   // Label 1445: @92540
     /*  92540 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(92611), // Rule ID 11940 //
     /*  92545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92584 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92590 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92594 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  92597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  92605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  92609 */     GIR_RootConstrainSelectedInstOperands,
     /*  92610 */     // GIR_Coverage, 11940,
     /*  92610 */     GIR_EraseRootFromParent_Done,
     /*  92611 */   // Label 1446: @92611
     /*  92611 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(92672), // Rule ID 11975 //
     /*  92616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  92627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92635 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  92639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  92643 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92649 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  92651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  92653 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  92662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  92666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  92670 */     GIR_RootConstrainSelectedInstOperands,
     /*  92671 */     // GIR_Coverage, 11975,
     /*  92671 */     GIR_EraseRootFromParent_Done,
     /*  92672 */   // Label 1447: @92672
     /*  92672 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(92715), // Rule ID 13800 //
     /*  92677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92698 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  92701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  92707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  92711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  92713 */     GIR_RootConstrainSelectedInstOperands,
     /*  92714 */     // GIR_Coverage, 13800,
     /*  92714 */     GIR_EraseRootFromParent_Done,
     /*  92715 */   // Label 1448: @92715
     /*  92715 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(92758), // Rule ID 3154 //
     /*  92720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92741 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  92744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  92752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  92756 */     GIR_RootConstrainSelectedInstOperands,
     /*  92757 */     // GIR_Coverage, 3154,
     /*  92757 */     GIR_EraseRootFromParent_Done,
     /*  92758 */   // Label 1449: @92758
     /*  92758 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(92773), // Rule ID 7529 //
     /*  92763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92766 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  92766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  92771 */     GIR_RootConstrainSelectedInstOperands,
     /*  92772 */     // GIR_Coverage, 7529,
     /*  92772 */     GIR_Done,
     /*  92773 */   // Label 1450: @92773
     /*  92773 */   GIM_Reject,
     /*  92774 */ // Label 1434: @92774
     /*  92774 */ GIM_Reject,
     /*  92775 */ // Label 1333: @92775
     /*  92775 */ GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(92824), // Rule ID 8508 //
     /*  92780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  92786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  92789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  92793 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  92793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  92796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  92800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92805 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  92808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  92813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  92815 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92818 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92820 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  92822 */   GIR_RootConstrainSelectedInstOperands,
     /*  92823 */   // GIR_Coverage, 8508,
     /*  92823 */   GIR_EraseRootFromParent_Done,
     /*  92824 */ // Label 1451: @92824
     /*  92824 */ GIM_Reject,
     /*  92825 */ // Label 1334: @92825
     /*  92825 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(94231),
     /*  92830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92840 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(92958), // Rule ID 15833 //
     /*  92845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  92884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92896 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  92900 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92906 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  92908 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  92912 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92916 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92920 */     // MIs[5] Op3
     /*  92920 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  92925 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92929 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92935 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92937 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92939 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  92939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  92948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  92952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  92956 */     GIR_RootConstrainSelectedInstOperands,
     /*  92957 */     // GIR_Coverage, 15833,
     /*  92957 */     GIR_EraseRootFromParent_Done,
     /*  92958 */   // Label 1453: @92958
     /*  92958 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(93076), // Rule ID 15832 //
     /*  92963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  92994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  92998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  93002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93006 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93010 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93018 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93024 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93026 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93030 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93034 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93038 */     // MIs[5] Op3
     /*  93038 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93043 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93047 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93055 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93057 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  93066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  93070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93074 */     GIR_RootConstrainSelectedInstOperands,
     /*  93075 */     // GIR_Coverage, 15832,
     /*  93075 */     GIR_EraseRootFromParent_Done,
     /*  93076 */   // Label 1454: @93076
     /*  93076 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(93194), // Rule ID 15831 //
     /*  93081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93124 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93128 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93132 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93136 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93142 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93144 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93148 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93152 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93156 */     // MIs[5] Op3
     /*  93156 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93161 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93165 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93171 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93173 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93175 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  93184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  93188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93192 */     GIR_RootConstrainSelectedInstOperands,
     /*  93193 */     // GIR_Coverage, 15831,
     /*  93193 */     GIR_EraseRootFromParent_Done,
     /*  93194 */   // Label 1455: @93194
     /*  93194 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(93312), // Rule ID 15830 //
     /*  93199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93242 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93246 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93250 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93254 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93260 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93262 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93266 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93270 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93274 */     // MIs[5] Op3
     /*  93274 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93279 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93283 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93289 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93291 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93293 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  93302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  93306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93310 */     GIR_RootConstrainSelectedInstOperands,
     /*  93311 */     // GIR_Coverage, 15830,
     /*  93311 */     GIR_EraseRootFromParent_Done,
     /*  93312 */   // Label 1456: @93312
     /*  93312 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(93430), // Rule ID 15827 //
     /*  93317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93360 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93364 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93368 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  93372 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93376 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93380 */     // MIs[4] Op3
     /*  93380 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  93385 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93389 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93395 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93397 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93401 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93407 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93409 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93411 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  93420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  93424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  93428 */     GIR_RootConstrainSelectedInstOperands,
     /*  93429 */     // GIR_Coverage, 15827,
     /*  93429 */     GIR_EraseRootFromParent_Done,
     /*  93430 */   // Label 1457: @93430
     /*  93430 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(93548), // Rule ID 15829 //
     /*  93435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93478 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93482 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93486 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  93490 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93494 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93498 */     // MIs[4] Op3
     /*  93498 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  93503 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93507 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93513 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93515 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93519 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93525 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93527 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93529 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  93538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  93542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93546 */     GIR_RootConstrainSelectedInstOperands,
     /*  93547 */     // GIR_Coverage, 15829,
     /*  93547 */     GIR_EraseRootFromParent_Done,
     /*  93548 */   // Label 1458: @93548
     /*  93548 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(93666), // Rule ID 11974 //
     /*  93553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93584 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93596 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93600 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93604 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93608 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93612 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93616 */     // MIs[4] Op3
     /*  93616 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  93621 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93625 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93631 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93633 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93637 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93643 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93645 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93647 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }))), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  93656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  93660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  93664 */     GIR_RootConstrainSelectedInstOperands,
     /*  93665 */     // GIR_Coverage, 11974,
     /*  93665 */     GIR_EraseRootFromParent_Done,
     /*  93666 */   // Label 1459: @93666
     /*  93666 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(93784), // Rule ID 15828 //
     /*  93671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93722 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93726 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93730 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93734 */     // MIs[4] Op3
     /*  93734 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  93739 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93743 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93749 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93751 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93755 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93761 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93763 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93765 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }))), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  93774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  93778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93782 */     GIR_RootConstrainSelectedInstOperands,
     /*  93783 */     // GIR_Coverage, 15828,
     /*  93783 */     GIR_EraseRootFromParent_Done,
     /*  93784 */   // Label 1460: @93784
     /*  93784 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(93855), // Rule ID 15697 //
     /*  93789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93828 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93834 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93838 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  93845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  93849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93853 */     GIR_RootConstrainSelectedInstOperands,
     /*  93854 */     // GIR_Coverage, 15697,
     /*  93854 */     GIR_EraseRootFromParent_Done,
     /*  93855 */   // Label 1461: @93855
     /*  93855 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(93926), // Rule ID 15696 //
     /*  93860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  93883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93899 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93905 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93909 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  93916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  93920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93924 */     GIR_RootConstrainSelectedInstOperands,
     /*  93925 */     // GIR_Coverage, 15696,
     /*  93925 */     GIR_EraseRootFromParent_Done,
     /*  93926 */   // Label 1462: @93926
     /*  93926 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(93997), // Rule ID 15695 //
     /*  93931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  93938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  93962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  93966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93970 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93976 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93980 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  93980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  93987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  93991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93995 */     GIR_RootConstrainSelectedInstOperands,
     /*  93996 */     // GIR_Coverage, 15695,
     /*  93996 */     GIR_EraseRootFromParent_Done,
     /*  93997 */   // Label 1463: @93997
     /*  93997 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(94068), // Rule ID 11938 //
     /*  94002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94033 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94041 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94047 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  94049 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94051 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  94054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  94066 */     GIR_RootConstrainSelectedInstOperands,
     /*  94067 */     // GIR_Coverage, 11938,
     /*  94067 */     GIR_EraseRootFromParent_Done,
     /*  94068 */   // Label 1464: @94068
     /*  94068 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(94129), // Rule ID 11973 //
     /*  94073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  94084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94092 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  94096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  94100 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94106 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  94108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  94110 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  94119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  94123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  94127 */     GIR_RootConstrainSelectedInstOperands,
     /*  94128 */     // GIR_Coverage, 11973,
     /*  94128 */     GIR_EraseRootFromParent_Done,
     /*  94129 */   // Label 1465: @94129
     /*  94129 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(94172), // Rule ID 13799 //
     /*  94134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94155 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  94158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  94164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  94168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  94170 */     GIR_RootConstrainSelectedInstOperands,
     /*  94171 */     // GIR_Coverage, 13799,
     /*  94171 */     GIR_EraseRootFromParent_Done,
     /*  94172 */   // Label 1466: @94172
     /*  94172 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(94215), // Rule ID 3152 //
     /*  94177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94198 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  94201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94203 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  94213 */     GIR_RootConstrainSelectedInstOperands,
     /*  94214 */     // GIR_Coverage, 3152,
     /*  94214 */     GIR_EraseRootFromParent_Done,
     /*  94215 */   // Label 1467: @94215
     /*  94215 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(94230), // Rule ID 7528 //
     /*  94220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94223 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  94223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  94228 */     GIR_RootConstrainSelectedInstOperands,
     /*  94229 */     // GIR_Coverage, 7528,
     /*  94229 */     GIR_Done,
     /*  94230 */   // Label 1468: @94230
     /*  94230 */   GIM_Reject,
     /*  94231 */ // Label 1452: @94231
     /*  94231 */ GIM_Reject,
     /*  94232 */ // Label 1335: @94232
     /*  94232 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(94281), // Rule ID 8507 //
     /*  94237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  94243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  94246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  94250 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  94250 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  94253 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  94257 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94262 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  94265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  94270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  94272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94275 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94277 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  94279 */   GIR_RootConstrainSelectedInstOperands,
     /*  94280 */   // GIR_Coverage, 8507,
     /*  94280 */   GIR_EraseRootFromParent_Done,
     /*  94281 */ // Label 1469: @94281
     /*  94281 */ GIM_Reject,
     /*  94282 */ // Label 1336: @94282
     /*  94282 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(95688),
     /*  94287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94297 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(94415), // Rule ID 15826 //
     /*  94302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94345 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94349 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94353 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94357 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94363 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94365 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94369 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94373 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94377 */     // MIs[5] Op3
     /*  94377 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94382 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94386 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94392 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94394 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94396 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  94405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  94409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94413 */     GIR_RootConstrainSelectedInstOperands,
     /*  94414 */     // GIR_Coverage, 15826,
     /*  94414 */     GIR_EraseRootFromParent_Done,
     /*  94415 */   // Label 1471: @94415
     /*  94415 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(94533), // Rule ID 15825 //
     /*  94420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94451 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94463 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94467 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94471 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94475 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94483 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94487 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94491 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94495 */     // MIs[5] Op3
     /*  94495 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94500 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94504 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94510 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94512 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94514 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  94523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  94527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94531 */     GIR_RootConstrainSelectedInstOperands,
     /*  94532 */     // GIR_Coverage, 15825,
     /*  94532 */     GIR_EraseRootFromParent_Done,
     /*  94533 */   // Label 1472: @94533
     /*  94533 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(94651), // Rule ID 15824 //
     /*  94538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94573 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94577 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94581 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94585 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94589 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94593 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94601 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94605 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94609 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94613 */     // MIs[5] Op3
     /*  94613 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94618 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94622 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94630 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94632 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  94641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  94645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94649 */     GIR_RootConstrainSelectedInstOperands,
     /*  94650 */     // GIR_Coverage, 15824,
     /*  94650 */     GIR_EraseRootFromParent_Done,
     /*  94651 */   // Label 1473: @94651
     /*  94651 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(94769), // Rule ID 15823 //
     /*  94656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94699 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94703 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94707 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94711 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94717 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94719 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94723 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94727 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94731 */     // MIs[5] Op3
     /*  94731 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94736 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94740 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94746 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94748 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94750 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  94759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  94763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94767 */     GIR_RootConstrainSelectedInstOperands,
     /*  94768 */     // GIR_Coverage, 15823,
     /*  94768 */     GIR_EraseRootFromParent_Done,
     /*  94769 */   // Label 1474: @94769
     /*  94769 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(94887), // Rule ID 15820 //
     /*  94774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  94813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94817 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94821 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94825 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  94829 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94833 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94837 */     // MIs[4] Op3
     /*  94837 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  94842 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  94846 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94852 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  94854 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94858 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94864 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94866 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94868 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  94877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  94881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  94885 */     GIR_RootConstrainSelectedInstOperands,
     /*  94886 */     // GIR_Coverage, 15820,
     /*  94886 */     GIR_EraseRootFromParent_Done,
     /*  94887 */   // Label 1475: @94887
     /*  94887 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(95005), // Rule ID 15822 //
     /*  94892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  94931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94935 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  94939 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94943 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  94947 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94951 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  94955 */     // MIs[4] Op3
     /*  94955 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  94960 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  94964 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94970 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  94972 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94976 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94982 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94984 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94986 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  94986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  94995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  94999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95003 */     GIR_RootConstrainSelectedInstOperands,
     /*  95004 */     // GIR_Coverage, 15822,
     /*  95004 */     GIR_EraseRootFromParent_Done,
     /*  95005 */   // Label 1476: @95005
     /*  95005 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(95123), // Rule ID 11972 //
     /*  95010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95041 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95053 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95057 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95061 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95065 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95069 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95073 */     // MIs[4] Op3
     /*  95073 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  95078 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95082 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95090 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95094 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95100 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95102 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95104 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }))), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  95113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  95117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  95121 */     GIR_RootConstrainSelectedInstOperands,
     /*  95122 */     // GIR_Coverage, 11972,
     /*  95122 */     GIR_EraseRootFromParent_Done,
     /*  95123 */   // Label 1477: @95123
     /*  95123 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(95241), // Rule ID 15821 //
     /*  95128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95159 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95171 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95175 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95179 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95183 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95187 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95191 */     // MIs[4] Op3
     /*  95191 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  95196 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95200 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95208 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95212 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95218 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95220 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95222 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }))), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  95231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  95235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95239 */     GIR_RootConstrainSelectedInstOperands,
     /*  95240 */     // GIR_Coverage, 15821,
     /*  95240 */     GIR_EraseRootFromParent_Done,
     /*  95241 */   // Label 1478: @95241
     /*  95241 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(95312), // Rule ID 15694 //
     /*  95246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95285 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95291 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95293 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95295 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  95302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95310 */     GIR_RootConstrainSelectedInstOperands,
     /*  95311 */     // GIR_Coverage, 15694,
     /*  95311 */     GIR_EraseRootFromParent_Done,
     /*  95312 */   // Label 1479: @95312
     /*  95312 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(95383), // Rule ID 15693 //
     /*  95317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95356 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95362 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95366 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  95373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95381 */     GIR_RootConstrainSelectedInstOperands,
     /*  95382 */     // GIR_Coverage, 15693,
     /*  95382 */     GIR_EraseRootFromParent_Done,
     /*  95383 */   // Label 1480: @95383
     /*  95383 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(95454), // Rule ID 15692 //
     /*  95388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95427 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95433 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95437 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95452 */     GIR_RootConstrainSelectedInstOperands,
     /*  95453 */     // GIR_Coverage, 15692,
     /*  95453 */     GIR_EraseRootFromParent_Done,
     /*  95454 */   // Label 1481: @95454
     /*  95454 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(95525), // Rule ID 11936 //
     /*  95459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95498 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95504 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95508 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95523 */     GIR_RootConstrainSelectedInstOperands,
     /*  95524 */     // GIR_Coverage, 11936,
     /*  95524 */     GIR_EraseRootFromParent_Done,
     /*  95525 */   // Label 1482: @95525
     /*  95525 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(95586), // Rule ID 11971 //
     /*  95530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  95541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95549 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  95553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  95557 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95563 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  95565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  95567 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  95576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  95580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  95584 */     GIR_RootConstrainSelectedInstOperands,
     /*  95585 */     // GIR_Coverage, 11971,
     /*  95585 */     GIR_EraseRootFromParent_Done,
     /*  95586 */   // Label 1483: @95586
     /*  95586 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(95629), // Rule ID 13798 //
     /*  95591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95612 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  95615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  95621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  95627 */     GIR_RootConstrainSelectedInstOperands,
     /*  95628 */     // GIR_Coverage, 13798,
     /*  95628 */     GIR_EraseRootFromParent_Done,
     /*  95629 */   // Label 1484: @95629
     /*  95629 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(95672), // Rule ID 3150 //
     /*  95634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95655 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  95658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  95670 */     GIR_RootConstrainSelectedInstOperands,
     /*  95671 */     // GIR_Coverage, 3150,
     /*  95671 */     GIR_EraseRootFromParent_Done,
     /*  95672 */   // Label 1485: @95672
     /*  95672 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(95687), // Rule ID 7527 //
     /*  95677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95680 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  95680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  95685 */     GIR_RootConstrainSelectedInstOperands,
     /*  95686 */     // GIR_Coverage, 7527,
     /*  95686 */     GIR_Done,
     /*  95687 */   // Label 1486: @95687
     /*  95687 */   GIM_Reject,
     /*  95688 */ // Label 1470: @95688
     /*  95688 */ GIM_Reject,
     /*  95689 */ // Label 1337: @95689
     /*  95689 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(95738), // Rule ID 8506 //
     /*  95694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  95700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  95703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  95707 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  95707 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  95710 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  95714 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95719 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  95722 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  95727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  95729 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95732 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95734 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  95736 */   GIR_RootConstrainSelectedInstOperands,
     /*  95737 */   // GIR_Coverage, 8506,
     /*  95737 */   GIR_EraseRootFromParent_Done,
     /*  95738 */ // Label 1487: @95738
     /*  95738 */ GIM_Reject,
     /*  95739 */ // Label 1338: @95739
     /*  95739 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(97145),
     /*  95744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95754 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(95872), // Rule ID 15819 //
     /*  95759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  95798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95802 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95806 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95810 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95814 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95820 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  95822 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  95826 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95830 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95834 */     // MIs[5] Op3
     /*  95834 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  95839 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95843 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95849 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95851 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95853 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  95853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  95862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  95866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  95870 */     GIR_RootConstrainSelectedInstOperands,
     /*  95871 */     // GIR_Coverage, 15819,
     /*  95871 */     GIR_EraseRootFromParent_Done,
     /*  95872 */   // Label 1489: @95872
     /*  95872 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(95990), // Rule ID 15818 //
     /*  95877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  95916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95920 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95924 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  95928 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95932 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95938 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  95940 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  95944 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95948 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95952 */     // MIs[5] Op3
     /*  95952 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  95957 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95961 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95967 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95969 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95971 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  95971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  95980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  95984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  95988 */     GIR_RootConstrainSelectedInstOperands,
     /*  95989 */     // GIR_Coverage, 15818,
     /*  95989 */     GIR_EraseRootFromParent_Done,
     /*  95990 */   // Label 1490: @95990
     /*  95990 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(96108), // Rule ID 15817 //
     /*  95995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96042 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96046 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96050 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96058 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96062 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96066 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96070 */     // MIs[5] Op3
     /*  96070 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96075 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96079 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96085 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96087 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96089 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  96098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  96102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96106 */     GIR_RootConstrainSelectedInstOperands,
     /*  96107 */     // GIR_Coverage, 15817,
     /*  96107 */     GIR_EraseRootFromParent_Done,
     /*  96108 */   // Label 1491: @96108
     /*  96108 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(96226), // Rule ID 15816 //
     /*  96113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96156 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96160 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96164 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96168 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96174 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96176 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96180 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96184 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96188 */     // MIs[5] Op3
     /*  96188 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96193 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96197 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96203 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96205 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96207 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  96216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  96220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96224 */     GIR_RootConstrainSelectedInstOperands,
     /*  96225 */     // GIR_Coverage, 15816,
     /*  96225 */     GIR_EraseRootFromParent_Done,
     /*  96226 */   // Label 1492: @96226
     /*  96226 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(96344), // Rule ID 15813 //
     /*  96231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96274 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96278 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96282 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  96286 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96290 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96294 */     // MIs[4] Op3
     /*  96294 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  96299 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96303 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96309 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96311 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96315 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96321 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96323 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96325 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  96334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  96338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  96342 */     GIR_RootConstrainSelectedInstOperands,
     /*  96343 */     // GIR_Coverage, 15813,
     /*  96343 */     GIR_EraseRootFromParent_Done,
     /*  96344 */   // Label 1493: @96344
     /*  96344 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(96462), // Rule ID 15815 //
     /*  96349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96380 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96384 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96388 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96392 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96396 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96400 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  96404 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96408 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96412 */     // MIs[4] Op3
     /*  96412 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  96417 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96421 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96427 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96429 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96433 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96439 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96441 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96443 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  96452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  96456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96460 */     GIR_RootConstrainSelectedInstOperands,
     /*  96461 */     // GIR_Coverage, 15815,
     /*  96461 */     GIR_EraseRootFromParent_Done,
     /*  96462 */   // Label 1494: @96462
     /*  96462 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(96580), // Rule ID 11970 //
     /*  96467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96510 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96514 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96518 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96522 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96526 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96530 */     // MIs[4] Op3
     /*  96530 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  96535 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96539 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96545 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96547 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96551 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96559 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96561 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }))), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  96570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  96574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  96578 */     GIR_RootConstrainSelectedInstOperands,
     /*  96579 */     // GIR_Coverage, 11970,
     /*  96579 */     GIR_EraseRootFromParent_Done,
     /*  96580 */   // Label 1495: @96580
     /*  96580 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(96698), // Rule ID 15814 //
     /*  96585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96616 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96632 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96636 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96640 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96644 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96648 */     // MIs[4] Op3
     /*  96648 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  96653 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96657 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96663 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96665 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96669 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96677 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96679 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }))), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  96688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  96692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96696 */     GIR_RootConstrainSelectedInstOperands,
     /*  96697 */     // GIR_Coverage, 15814,
     /*  96697 */     GIR_EraseRootFromParent_Done,
     /*  96698 */   // Label 1496: @96698
     /*  96698 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(96769), // Rule ID 15691 //
     /*  96703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96742 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96752 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  96759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  96763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96767 */     GIR_RootConstrainSelectedInstOperands,
     /*  96768 */     // GIR_Coverage, 15691,
     /*  96768 */     GIR_EraseRootFromParent_Done,
     /*  96769 */   // Label 1497: @96769
     /*  96769 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(96840), // Rule ID 15690 //
     /*  96774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  96797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96805 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96813 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96819 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96823 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  96830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  96834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96838 */     GIR_RootConstrainSelectedInstOperands,
     /*  96839 */     // GIR_Coverage, 15690,
     /*  96839 */     GIR_EraseRootFromParent_Done,
     /*  96840 */   // Label 1498: @96840
     /*  96840 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(96911), // Rule ID 15689 //
     /*  96845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96884 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96890 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96892 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96894 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  96901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  96905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96909 */     GIR_RootConstrainSelectedInstOperands,
     /*  96910 */     // GIR_Coverage, 15689,
     /*  96910 */     GIR_EraseRootFromParent_Done,
     /*  96911 */   // Label 1499: @96911
     /*  96911 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(96982), // Rule ID 11934 //
     /*  96916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  96939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  96951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96955 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96965 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  96965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  96972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  96976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96980 */     GIR_RootConstrainSelectedInstOperands,
     /*  96981 */     // GIR_Coverage, 11934,
     /*  96981 */     GIR_EraseRootFromParent_Done,
     /*  96982 */   // Label 1500: @96982
     /*  96982 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(97043), // Rule ID 11969 //
     /*  96987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  96998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97006 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  97010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  97014 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97020 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  97022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97024 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  97033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  97037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  97041 */     GIR_RootConstrainSelectedInstOperands,
     /*  97042 */     // GIR_Coverage, 11969,
     /*  97042 */     GIR_EraseRootFromParent_Done,
     /*  97043 */   // Label 1501: @97043
     /*  97043 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(97086), // Rule ID 13797 //
     /*  97048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97069 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  97072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  97078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  97082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  97084 */     GIR_RootConstrainSelectedInstOperands,
     /*  97085 */     // GIR_Coverage, 13797,
     /*  97085 */     GIR_EraseRootFromParent_Done,
     /*  97086 */   // Label 1502: @97086
     /*  97086 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(97129), // Rule ID 3148 //
     /*  97091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97112 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  97115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  97119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  97123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  97127 */     GIR_RootConstrainSelectedInstOperands,
     /*  97128 */     // GIR_Coverage, 3148,
     /*  97128 */     GIR_EraseRootFromParent_Done,
     /*  97129 */   // Label 1503: @97129
     /*  97129 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(97144), // Rule ID 7526 //
     /*  97134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97137 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  97137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  97142 */     GIR_RootConstrainSelectedInstOperands,
     /*  97143 */     // GIR_Coverage, 7526,
     /*  97143 */     GIR_Done,
     /*  97144 */   // Label 1504: @97144
     /*  97144 */   GIM_Reject,
     /*  97145 */ // Label 1488: @97145
     /*  97145 */ GIM_Reject,
     /*  97146 */ // Label 1339: @97146
     /*  97146 */ GIM_Reject,
     /*  97147 */ // Label 8: @97147
     /*  97147 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(104670),
     /*  97152 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  97155 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1517*/ GIMT_Encode4(104669),
     /*  97166 */   /*GILLT_v2s64*//*Label 1506*/ GIMT_Encode4(97234), GIMT_Encode4(0),
     /*  97174 */   /*GILLT_v4s32*//*Label 1507*/ GIMT_Encode4(97755), GIMT_Encode4(0),
     /*  97182 */   /*GILLT_v8s16*//*Label 1508*/ GIMT_Encode4(100167),
     /*  97186 */   /*GILLT_v16s8*//*Label 1509*/ GIMT_Encode4(102576), GIMT_Encode4(0),
     /*  97194 */   /*GILLT_nxv2s1*//*Label 1510*/ GIMT_Encode4(104487), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  97210 */   /*GILLT_nxv4s1*//*Label 1511*/ GIMT_Encode4(104513),
     /*  97214 */   /*GILLT_nxv4s16*//*Label 1512*/ GIMT_Encode4(104539),
     /*  97218 */   /*GILLT_nxv4s32*//*Label 1513*/ GIMT_Encode4(104565),
     /*  97222 */   /*GILLT_nxv8s1*//*Label 1514*/ GIMT_Encode4(104591),
     /*  97226 */   /*GILLT_nxv8s16*//*Label 1515*/ GIMT_Encode4(104617),
     /*  97230 */   /*GILLT_nxv16s1*//*Label 1516*/ GIMT_Encode4(104643),
     /*  97234 */   // Label 1506: @97234
     /*  97234 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(97754),
     /*  97239 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  97245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97253 */     GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(97315), // Rule ID 5838 //
     /*  97258 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97262 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97268 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  97270 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97272 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  97272 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97275 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  97279 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97284 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97288 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97290 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  97293 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97295 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97301 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  97304 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97309 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97314 */       // GIR_Coverage, 5838,
     /*  97314 */       GIR_EraseRootFromParent_Done,
     /*  97315 */     // Label 1519: @97315
     /*  97315 */     GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(97377), // Rule ID 5842 //
     /*  97320 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97324 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97330 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  97332 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97334 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  97334 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97337 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  97341 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97346 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97350 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97352 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  97355 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97357 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97360 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97363 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  97366 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97371 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97376 */       // GIR_Coverage, 5842,
     /*  97376 */       GIR_EraseRootFromParent_Done,
     /*  97377 */     // Label 1520: @97377
     /*  97377 */     GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(97435), // Rule ID 5839 //
     /*  97382 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97386 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  97390 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97392 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  97392 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  97395 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97399 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97404 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97406 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97409 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97411 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97414 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  97416 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  97419 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97424 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97429 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97434 */       // GIR_Coverage, 5839,
     /*  97434 */       GIR_EraseRootFromParent_Done,
     /*  97435 */     // Label 1521: @97435
     /*  97435 */     GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(97493), // Rule ID 5843 //
     /*  97440 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97444 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  97448 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97450 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  97450 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  97453 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97457 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97462 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97464 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97467 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97469 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97472 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  97474 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  97477 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97482 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97487 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97492 */       // GIR_Coverage, 5843,
     /*  97492 */       GIR_EraseRootFromParent_Done,
     /*  97493 */     // Label 1522: @97493
     /*  97493 */     GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(97623), // Rule ID 5837 //
     /*  97498 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97502 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  97502 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  97505 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97509 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97514 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97516 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  97519 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97523 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97528 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97531 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  97535 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  97538 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97543 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97548 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97553 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97556 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97560 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97565 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97567 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97570 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97574 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97579 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97582 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  97586 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97589 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97594 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97599 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97604 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  97607 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97609 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97612 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  97615 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97618 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97621 */       GIR_RootConstrainSelectedInstOperands,
     /*  97622 */       // GIR_Coverage, 5837,
     /*  97622 */       GIR_EraseRootFromParent_Done,
     /*  97623 */     // Label 1523: @97623
     /*  97623 */     GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(97753), // Rule ID 5841 //
     /*  97628 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97632 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  97632 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  97635 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97639 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97644 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97646 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  97649 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97653 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97658 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97661 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  97665 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  97668 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97673 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97678 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97683 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97686 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97690 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97695 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97697 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97700 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97704 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97709 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97712 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  97716 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97719 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97724 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97729 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97734 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  97737 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97739 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97742 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  97745 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97748 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  97751 */       GIR_RootConstrainSelectedInstOperands,
     /*  97752 */       // GIR_Coverage, 5841,
     /*  97752 */       GIR_EraseRootFromParent_Done,
     /*  97753 */     // Label 1524: @97753
     /*  97753 */     GIM_Reject,
     /*  97754 */   // Label 1518: @97754
     /*  97754 */   GIM_Reject,
     /*  97755 */   // Label 1507: @97755
     /*  97755 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(100166),
     /*  97760 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  97763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  97766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97770 */     GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(97899), // Rule ID 5467 //
     /*  97775 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97779 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97783 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  97787 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97791 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97795 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  97799 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97803 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  97807 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97811 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97815 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  97819 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97824 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97828 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97834 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97836 */       // MIs[2] Operand 2
     /*  97836 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  97847 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  97849 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  97849 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97852 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  97856 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97861 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  97864 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  97868 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97871 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97876 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97881 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  97884 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97886 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97889 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  97893 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  97897 */       GIR_RootConstrainSelectedInstOperands,
     /*  97898 */       // GIR_Coverage, 5467,
     /*  97898 */       GIR_EraseRootFromParent_Done,
     /*  97899 */     // Label 1526: @97899
     /*  97899 */     GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(98021), // Rule ID 5463 //
     /*  97904 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97908 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97912 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  97916 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97920 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97924 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  97928 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97932 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  97936 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  97940 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97944 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  97948 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97953 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97958 */       // MIs[2] Operand 2
     /*  97958 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  97969 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  97971 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  97971 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97974 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  97978 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97983 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  97986 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  97990 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97993 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97998 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98003 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  98006 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98008 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98011 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  98015 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  98019 */       GIR_RootConstrainSelectedInstOperands,
     /*  98020 */       // GIR_Coverage, 5463,
     /*  98020 */       GIR_EraseRootFromParent_Done,
     /*  98021 */     // Label 1527: @98021
     /*  98021 */     GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(98143), // Rule ID 5465 //
     /*  98026 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98030 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98034 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98038 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98042 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98046 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  98050 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98054 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  98058 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  98062 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98066 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98070 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98075 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98080 */       // MIs[2] Operand 2
     /*  98080 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  98091 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98093 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  98093 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98096 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98100 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98105 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  98108 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98112 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98115 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98120 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98125 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  98128 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98130 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98133 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  98137 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  98141 */       GIR_RootConstrainSelectedInstOperands,
     /*  98142 */       // GIR_Coverage, 5465,
     /*  98142 */       GIR_EraseRootFromParent_Done,
     /*  98143 */     // Label 1528: @98143
     /*  98143 */     GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(98245), // Rule ID 5613 //
     /*  98148 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98152 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98156 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98160 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98164 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  98168 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98172 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98177 */       // MIs[2] Operand 2
     /*  98177 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  98188 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  98192 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98196 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98200 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  98204 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  98208 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98212 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98217 */       // MIs[4] Operand 2
     /*  98217 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  98228 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  98230 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  98230 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  98233 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98235 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  98239 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  98243 */       GIR_RootConstrainSelectedInstOperands,
     /*  98244 */       // GIR_Coverage, 5613,
     /*  98244 */       GIR_EraseRootFromParent_Done,
     /*  98245 */     // Label 1529: @98245
     /*  98245 */     GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(98374), // Rule ID 6393 //
     /*  98250 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98254 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98258 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  98262 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  98265 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  98270 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98274 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98278 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98283 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  98287 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98289 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  98289 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  98292 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  98296 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98301 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98304 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98306 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98309 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98313 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98318 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98320 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98323 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98327 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98332 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98335 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  98339 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98342 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98347 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98352 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98357 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  98360 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98362 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98365 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  98369 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98372 */       GIR_RootConstrainSelectedInstOperands,
     /*  98373 */       // GIR_Coverage, 6393,
     /*  98373 */       GIR_EraseRootFromParent_Done,
     /*  98374 */     // Label 1530: @98374
     /*  98374 */     GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(98416), // Rule ID 5848 //
     /*  98379 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  98386 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  98393 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  98393 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  98396 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98398 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  98403 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98406 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98411 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  98414 */       GIR_RootConstrainSelectedInstOperands,
     /*  98415 */       // GIR_Coverage, 5848,
     /*  98415 */       GIR_EraseRootFromParent_Done,
     /*  98416 */     // Label 1531: @98416
     /*  98416 */     GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(98458), // Rule ID 5852 //
     /*  98421 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  98428 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  98435 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  98435 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  98438 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98440 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  98445 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98448 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  98453 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  98456 */       GIR_RootConstrainSelectedInstOperands,
     /*  98457 */       // GIR_Coverage, 5852,
     /*  98457 */       GIR_EraseRootFromParent_Done,
     /*  98458 */     // Label 1532: @98458
     /*  98458 */     GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(98581), // Rule ID 2578 //
     /*  98463 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98466 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98470 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98474 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  98478 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  98481 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  98486 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98490 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98494 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98499 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  98503 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98507 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  98511 */       // MIs[2] Operand 1
     /*  98511 */       // No operand predicates
     /*  98511 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98513 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  98513 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98516 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98520 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98525 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98527 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98530 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98534 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98539 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98542 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98546 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98549 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98554 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98559 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98564 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /*  98567 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98569 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98572 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  98576 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  98579 */       GIR_RootConstrainSelectedInstOperands,
     /*  98580 */       // GIR_Coverage, 2578,
     /*  98580 */       GIR_EraseRootFromParent_Done,
     /*  98581 */     // Label 1533: @98581
     /*  98581 */     GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(98704), // Rule ID 6363 //
     /*  98586 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98589 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98593 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98597 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98601 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98605 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98609 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  98613 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98617 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98622 */       // MIs[2] imm
     /*  98622 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98626 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98630 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  98634 */       // MIs[3] Operand 1
     /*  98634 */       // No operand predicates
     /*  98634 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98636 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  98636 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98639 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98643 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98648 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98650 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98653 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98657 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98662 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98665 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98669 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98672 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98677 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98682 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98687 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  98690 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98692 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98695 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  98699 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  98702 */       GIR_RootConstrainSelectedInstOperands,
     /*  98703 */       // GIR_Coverage, 6363,
     /*  98703 */       GIR_EraseRootFromParent_Done,
     /*  98704 */     // Label 1534: @98704
     /*  98704 */     GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(98824), // Rule ID 6399 //
     /*  98709 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98713 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98717 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  98721 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98725 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98729 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  98733 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98737 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98742 */       // MIs[2] imm
     /*  98742 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98746 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98750 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  98754 */       // MIs[3] Operand 1
     /*  98754 */       // No operand predicates
     /*  98754 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98756 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  98756 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98759 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98763 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98768 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98770 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98773 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98777 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98782 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98785 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98789 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98792 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98797 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98802 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98807 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  98810 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98812 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98815 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  98819 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  98822 */       GIR_RootConstrainSelectedInstOperands,
     /*  98823 */       // GIR_Coverage, 6399,
     /*  98823 */       GIR_EraseRootFromParent_Done,
     /*  98824 */     // Label 1535: @98824
     /*  98824 */     GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(98941), // Rule ID 2501 //
     /*  98829 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98832 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98836 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98840 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  98844 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  98847 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  98852 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98856 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98860 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98865 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98870 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98872 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  98872 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98875 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98879 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98884 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98886 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98889 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98893 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98898 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98901 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  98905 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98908 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98913 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98918 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98923 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  98926 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98928 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98931 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  98935 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  98939 */       GIR_RootConstrainSelectedInstOperands,
     /*  98940 */       // GIR_Coverage, 2501,
     /*  98940 */       GIR_EraseRootFromParent_Done,
     /*  98941 */     // Label 1536: @98941
     /*  98941 */     GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(99058), // Rule ID 5383 //
     /*  98946 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98949 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98953 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98957 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  98961 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  98964 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  98969 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  98973 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98977 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98982 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98987 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98989 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  98989 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98992 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98996 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99001 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99003 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99006 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99010 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99015 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99018 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99022 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99025 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99030 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99035 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99040 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  99043 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99045 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99048 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  99052 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  99056 */       GIR_RootConstrainSelectedInstOperands,
     /*  99057 */       // GIR_Coverage, 5383,
     /*  99057 */       GIR_EraseRootFromParent_Done,
     /*  99058 */     // Label 1537: @99058
     /*  99058 */     GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(99175), // Rule ID 5386 //
     /*  99063 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99066 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99070 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99074 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99078 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  99081 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  99086 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99090 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99094 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99099 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99104 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99106 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  99106 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99109 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99113 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99118 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99120 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99123 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99127 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99132 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99135 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99139 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99142 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99147 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99152 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99157 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  99160 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99162 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99165 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  99169 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  99173 */       GIR_RootConstrainSelectedInstOperands,
     /*  99174 */       // GIR_Coverage, 5386,
     /*  99174 */       GIR_EraseRootFromParent_Done,
     /*  99175 */     // Label 1538: @99175
     /*  99175 */     GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(99292), // Rule ID 5389 //
     /*  99180 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99183 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99187 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99191 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99195 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  99198 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  99203 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99207 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99211 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99216 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99221 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99223 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  99223 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99226 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99230 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99235 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99237 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99240 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99244 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99249 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99252 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99256 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99259 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99264 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99269 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99274 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /*  99277 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99279 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99282 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  99286 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  99290 */       GIR_RootConstrainSelectedInstOperands,
     /*  99291 */       // GIR_Coverage, 5389,
     /*  99291 */       GIR_EraseRootFromParent_Done,
     /*  99292 */     // Label 1539: @99292
     /*  99292 */     GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(99396), // Rule ID 2497 //
     /*  99297 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99300 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99304 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99308 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99312 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  99315 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /*  99320 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99324 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99329 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99331 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  99331 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99334 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99338 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99343 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99345 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99348 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99352 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99357 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99360 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99364 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99367 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99372 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99377 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99382 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /*  99385 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99387 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99390 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  99394 */       GIR_RootConstrainSelectedInstOperands,
     /*  99395 */       // GIR_Coverage, 2497,
     /*  99395 */       GIR_EraseRootFromParent_Done,
     /*  99396 */     // Label 1540: @99396
     /*  99396 */     GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(99452), // Rule ID 5546 //
     /*  99401 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99405 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99409 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99413 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99418 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  99422 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99426 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99430 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99435 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  99437 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  99437 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /*  99440 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99442 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  99446 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  99450 */       GIR_RootConstrainSelectedInstOperands,
     /*  99451 */       // GIR_Coverage, 5546,
     /*  99451 */       GIR_EraseRootFromParent_Done,
     /*  99452 */     // Label 1541: @99452
     /*  99452 */     GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(99518), // Rule ID 5846 //
     /*  99457 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99461 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99465 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  99471 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  99473 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99475 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /*  99475 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  99478 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  99482 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99487 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  99491 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99493 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99496 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99498 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99501 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99504 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99507 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99512 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99517 */       // GIR_Coverage, 5846,
     /*  99517 */       GIR_EraseRootFromParent_Done,
     /*  99518 */     // Label 1542: @99518
     /*  99518 */     GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(99584), // Rule ID 5850 //
     /*  99523 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99527 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99531 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  99537 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  99539 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99541 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /*  99541 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  99544 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  99548 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99553 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  99557 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99559 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99562 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99564 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99567 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99570 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99573 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99578 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99583 */       // GIR_Coverage, 5850,
     /*  99583 */       GIR_EraseRootFromParent_Done,
     /*  99584 */     // Label 1543: @99584
     /*  99584 */     GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(99677), // Rule ID 4950 //
     /*  99589 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99593 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99597 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  99601 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99605 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99610 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99612 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  99612 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99615 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99619 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99624 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99626 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99629 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99633 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99638 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99641 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99645 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99648 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99653 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99658 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99663 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /*  99666 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99668 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99671 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  99675 */       GIR_RootConstrainSelectedInstOperands,
     /*  99676 */       // GIR_Coverage, 4950,
     /*  99676 */       GIR_EraseRootFromParent_Done,
     /*  99677 */     // Label 1544: @99677
     /*  99677 */     GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(99773), // Rule ID 4997 //
     /*  99682 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99685 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99689 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99693 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99697 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99701 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99706 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99708 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /*  99708 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99711 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99715 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99720 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99722 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99725 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99729 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99734 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99737 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99741 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99744 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99749 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99754 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99759 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /*  99762 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99764 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99767 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  99771 */       GIR_RootConstrainSelectedInstOperands,
     /*  99772 */       // GIR_Coverage, 4997,
     /*  99772 */       GIR_EraseRootFromParent_Done,
     /*  99773 */     // Label 1545: @99773
     /*  99773 */     GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(99835), // Rule ID 5847 //
     /*  99778 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99782 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99786 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  99790 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99792 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /*  99792 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  99795 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99799 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99804 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99806 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99809 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99811 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99814 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  99816 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99819 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99824 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99829 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99834 */       // GIR_Coverage, 5847,
     /*  99834 */       GIR_EraseRootFromParent_Done,
     /*  99835 */     // Label 1546: @99835
     /*  99835 */     GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(99897), // Rule ID 5851 //
     /*  99840 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99844 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99848 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  99852 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99854 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /*  99854 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  99857 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99861 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99866 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  99868 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99871 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99873 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99876 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  99878 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  99881 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99886 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99891 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99896 */       // GIR_Coverage, 5851,
     /*  99896 */       GIR_EraseRootFromParent_Done,
     /*  99897 */     // Label 1547: @99897
     /*  99897 */     GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(100031), // Rule ID 5845 //
     /*  99902 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99906 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99910 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  99910 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  99913 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99917 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99922 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99924 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  99927 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99931 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99936 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  99939 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  99943 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  99946 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99951 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99956 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99961 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99964 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99968 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99973 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99975 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99978 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99982 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99987 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99990 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99994 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99997 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100002 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100007 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100012 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100015 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100017 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100020 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100023 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100026 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100029 */       GIR_RootConstrainSelectedInstOperands,
     /* 100030 */       // GIR_Coverage, 5845,
     /* 100030 */       GIR_EraseRootFromParent_Done,
     /* 100031 */     // Label 1548: @100031
     /* 100031 */     GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(100165), // Rule ID 5849 //
     /* 100036 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100040 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100044 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 100044 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 100047 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100051 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100056 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100058 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 100061 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100065 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100070 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 100073 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 100077 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 100080 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100085 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100090 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100095 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100098 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100102 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100107 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100109 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100112 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100116 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100121 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100124 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100128 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100131 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100136 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100141 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100146 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100149 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100151 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100154 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100157 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100160 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100163 */       GIR_RootConstrainSelectedInstOperands,
     /* 100164 */       // GIR_Coverage, 5849,
     /* 100164 */       GIR_EraseRootFromParent_Done,
     /* 100165 */     // Label 1549: @100165
     /* 100165 */     GIM_Reject,
     /* 100166 */   // Label 1525: @100166
     /* 100166 */   GIM_Reject,
     /* 100167 */   // Label 1508: @100167
     /* 100167 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(102575),
     /* 100172 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 100178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100182 */     GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(100311), // Rule ID 5461 //
     /* 100187 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100191 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100195 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100199 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100203 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100207 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100211 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100215 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 100219 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 100223 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100227 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100231 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100236 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 100240 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 100246 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /* 100248 */       // MIs[2] Operand 2
     /* 100248 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 100259 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 100261 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 100261 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100264 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100268 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100273 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100276 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100280 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100283 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100288 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100293 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 100296 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100298 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100301 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 100305 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 100309 */       GIR_RootConstrainSelectedInstOperands,
     /* 100310 */       // GIR_Coverage, 5461,
     /* 100310 */       GIR_EraseRootFromParent_Done,
     /* 100311 */     // Label 1551: @100311
     /* 100311 */     GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(100433), // Rule ID 5457 //
     /* 100316 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100320 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100324 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100328 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100332 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100336 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100340 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100344 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 100348 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 100352 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100356 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100360 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100365 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100370 */       // MIs[2] Operand 2
     /* 100370 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 100381 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 100383 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 100383 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100386 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100390 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100395 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100398 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100402 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100405 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100410 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100415 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /* 100418 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100420 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100423 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 100427 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 100431 */       GIR_RootConstrainSelectedInstOperands,
     /* 100432 */       // GIR_Coverage, 5457,
     /* 100432 */       GIR_EraseRootFromParent_Done,
     /* 100433 */     // Label 1552: @100433
     /* 100433 */     GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(100555), // Rule ID 5459 //
     /* 100438 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100442 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100446 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100450 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100454 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100458 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100462 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100466 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 100470 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 100474 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100478 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100482 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100487 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100492 */       // MIs[2] Operand 2
     /* 100492 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 100503 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 100505 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 100505 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100508 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100512 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100517 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100520 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100524 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100527 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100532 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100537 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 100540 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100542 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100545 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 100549 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 100553 */       GIR_RootConstrainSelectedInstOperands,
     /* 100554 */       // GIR_Coverage, 5459,
     /* 100554 */       GIR_EraseRootFromParent_Done,
     /* 100555 */     // Label 1553: @100555
     /* 100555 */     GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(100657), // Rule ID 5612 //
     /* 100560 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100564 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100568 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100572 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100576 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100580 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100584 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100589 */       // MIs[2] Operand 2
     /* 100589 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 100600 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 100604 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100608 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100612 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 100616 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100620 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100624 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100629 */       // MIs[4] Operand 2
     /* 100629 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /* 100640 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 100642 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 100642 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 100645 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100647 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 100651 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 100655 */       GIR_RootConstrainSelectedInstOperands,
     /* 100656 */       // GIR_Coverage, 5612,
     /* 100656 */       GIR_EraseRootFromParent_Done,
     /* 100657 */     // Label 1554: @100657
     /* 100657 */     GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(100786), // Rule ID 6392 //
     /* 100662 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100666 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100670 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100674 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100677 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 100682 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100686 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100690 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100695 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /* 100699 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100701 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 100701 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 100704 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 100708 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100713 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100716 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100718 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100721 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100725 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100730 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100732 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100735 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100739 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100744 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100747 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 100751 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100754 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100759 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100764 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100769 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /* 100772 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100774 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100777 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 100781 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100784 */       GIR_RootConstrainSelectedInstOperands,
     /* 100785 */       // GIR_Coverage, 6392,
     /* 100785 */       GIR_EraseRootFromParent_Done,
     /* 100786 */     // Label 1555: @100786
     /* 100786 */     GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(100828), // Rule ID 5856 //
     /* 100791 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 100798 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 100805 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /* 100805 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100808 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100810 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 100815 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100818 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100823 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100826 */       GIR_RootConstrainSelectedInstOperands,
     /* 100827 */       // GIR_Coverage, 5856,
     /* 100827 */       GIR_EraseRootFromParent_Done,
     /* 100828 */     // Label 1556: @100828
     /* 100828 */     GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(100870), // Rule ID 5860 //
     /* 100833 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 100840 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 100847 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /* 100847 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 100850 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100852 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 100857 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100860 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100865 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 100868 */       GIR_RootConstrainSelectedInstOperands,
     /* 100869 */       // GIR_Coverage, 5860,
     /* 100869 */       GIR_EraseRootFromParent_Done,
     /* 100870 */     // Label 1557: @100870
     /* 100870 */     GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(100993), // Rule ID 2576 //
     /* 100875 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100878 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100882 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100886 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100890 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100893 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 100898 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100902 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100906 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100911 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 100915 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100919 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 100923 */       // MIs[2] Operand 1
     /* 100923 */       // No operand predicates
     /* 100923 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 100925 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 100925 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100928 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100932 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100937 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100939 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100942 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100946 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100951 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100954 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100958 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100961 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100966 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100971 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100976 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /* 100979 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100981 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100984 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100988 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 100991 */       GIR_RootConstrainSelectedInstOperands,
     /* 100992 */       // GIR_Coverage, 2576,
     /* 100992 */       GIR_EraseRootFromParent_Done,
     /* 100993 */     // Label 1558: @100993
     /* 100993 */     GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(101116), // Rule ID 6362 //
     /* 100998 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101001 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101005 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101009 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101013 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101017 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101021 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 101025 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101029 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101034 */       // MIs[2] imm
     /* 101034 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 101038 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101042 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 101046 */       // MIs[3] Operand 1
     /* 101046 */       // No operand predicates
     /* 101046 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101048 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 101048 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101051 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101055 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101060 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101062 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101065 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101069 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101074 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101077 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101081 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101084 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101089 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101094 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101099 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /* 101102 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101104 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101107 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 101111 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 101114 */       GIR_RootConstrainSelectedInstOperands,
     /* 101115 */       // GIR_Coverage, 6362,
     /* 101115 */       GIR_EraseRootFromParent_Done,
     /* 101116 */     // Label 1559: @101116
     /* 101116 */     GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(101236), // Rule ID 6398 //
     /* 101121 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101125 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101129 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101133 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101137 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101141 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 101145 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101149 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101154 */       // MIs[2] imm
     /* 101154 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 101158 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101162 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 101166 */       // MIs[3] Operand 1
     /* 101166 */       // No operand predicates
     /* 101166 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101168 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 101168 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101171 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101175 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101180 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101182 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101185 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101189 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101194 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101197 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101201 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101204 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101209 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101214 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101219 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /* 101222 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101224 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101227 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 101231 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 101234 */       GIR_RootConstrainSelectedInstOperands,
     /* 101235 */       // GIR_Coverage, 6398,
     /* 101235 */       GIR_EraseRootFromParent_Done,
     /* 101236 */     // Label 1560: @101236
     /* 101236 */     GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(101353), // Rule ID 2500 //
     /* 101241 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101244 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101248 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101252 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101256 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101259 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 101264 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101268 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 101272 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101277 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101282 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101284 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101284 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101287 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101291 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101296 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101298 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101301 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101305 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101310 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101313 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101317 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101320 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101325 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101330 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101335 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /* 101338 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101340 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101343 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101347 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101351 */       GIR_RootConstrainSelectedInstOperands,
     /* 101352 */       // GIR_Coverage, 2500,
     /* 101352 */       GIR_EraseRootFromParent_Done,
     /* 101353 */     // Label 1561: @101353
     /* 101353 */     GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(101470), // Rule ID 5382 //
     /* 101358 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101361 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101365 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101369 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101373 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101376 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 101381 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101385 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 101389 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101394 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101399 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101401 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101401 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101404 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101408 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101413 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101415 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101418 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101422 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101427 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101430 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101434 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101437 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101442 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101447 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101452 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 101455 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101457 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101460 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101464 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101468 */       GIR_RootConstrainSelectedInstOperands,
     /* 101469 */       // GIR_Coverage, 5382,
     /* 101469 */       GIR_EraseRootFromParent_Done,
     /* 101470 */     // Label 1562: @101470
     /* 101470 */     GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(101587), // Rule ID 5385 //
     /* 101475 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101478 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101482 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101486 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101490 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101493 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 101498 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101502 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 101506 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101511 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101516 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101518 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101518 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101521 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101525 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101530 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101532 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101535 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101539 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101544 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101547 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101551 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101554 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101559 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101564 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101569 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /* 101572 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101574 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101577 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101581 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101585 */       GIR_RootConstrainSelectedInstOperands,
     /* 101586 */       // GIR_Coverage, 5385,
     /* 101586 */       GIR_EraseRootFromParent_Done,
     /* 101587 */     // Label 1563: @101587
     /* 101587 */     GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(101704), // Rule ID 5388 //
     /* 101592 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101595 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101599 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101603 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101607 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 101610 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 101615 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101619 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 101623 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101628 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101633 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101635 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101635 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101638 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101642 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101647 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101649 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101652 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101656 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101661 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101664 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101668 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101671 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101676 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101681 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101686 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /* 101689 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101691 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101694 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101698 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 101702 */       GIR_RootConstrainSelectedInstOperands,
     /* 101703 */       // GIR_Coverage, 5388,
     /* 101703 */       GIR_EraseRootFromParent_Done,
     /* 101704 */     // Label 1564: @101704
     /* 101704 */     GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(101805), // Rule ID 4944 //
     /* 101709 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101713 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101717 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 101721 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 101724 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 101729 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101733 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101738 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101740 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /* 101740 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101743 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101747 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101752 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101754 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101757 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101761 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101766 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101769 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101773 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101776 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101781 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101786 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101791 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 101794 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101796 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101799 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 101803 */       GIR_RootConstrainSelectedInstOperands,
     /* 101804 */       // GIR_Coverage, 4944,
     /* 101804 */       GIR_EraseRootFromParent_Done,
     /* 101805 */     // Label 1565: @101805
     /* 101805 */     GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(101861), // Rule ID 5537 //
     /* 101810 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101814 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101818 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101822 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101827 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 101831 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101835 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101839 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101844 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 101846 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 101846 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 101849 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101851 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 101855 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 101859 */       GIR_RootConstrainSelectedInstOperands,
     /* 101860 */       // GIR_Coverage, 5537,
     /* 101860 */       GIR_EraseRootFromParent_Done,
     /* 101861 */     // Label 1566: @101861
     /* 101861 */     GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(101927), // Rule ID 5854 //
     /* 101866 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101870 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101874 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 101880 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 101882 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101884 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /* 101884 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 101887 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 101891 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101896 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 101900 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101902 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101905 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101907 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101910 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101913 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101916 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101921 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101926 */       // GIR_Coverage, 5854,
     /* 101926 */       GIR_EraseRootFromParent_Done,
     /* 101927 */     // Label 1567: @101927
     /* 101927 */     GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(101993), // Rule ID 5858 //
     /* 101932 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101936 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101940 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 101946 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 101948 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101950 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /* 101950 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 101953 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 101957 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101962 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 101966 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101968 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101971 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101973 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101976 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101979 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101982 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101987 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101992 */       // GIR_Coverage, 5858,
     /* 101992 */       GIR_EraseRootFromParent_Done,
     /* 101993 */     // Label 1568: @101993
     /* 101993 */     GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(102086), // Rule ID 4952 //
     /* 101998 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102002 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102006 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 102010 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102014 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102019 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102021 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /* 102021 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102024 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102028 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102033 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102035 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102038 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102042 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102047 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102050 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102054 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102057 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102062 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102067 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102072 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 102075 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102077 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102080 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102084 */       GIR_RootConstrainSelectedInstOperands,
     /* 102085 */       // GIR_Coverage, 4952,
     /* 102085 */       GIR_EraseRootFromParent_Done,
     /* 102086 */     // Label 1569: @102086
     /* 102086 */     GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(102182), // Rule ID 4996 //
     /* 102091 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102094 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102098 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102102 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102106 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102110 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102115 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102117 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /* 102117 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102120 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102124 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102129 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102131 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102134 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102138 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102143 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102146 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102150 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102153 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102158 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102163 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102168 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /* 102171 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102173 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102176 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 102180 */       GIR_RootConstrainSelectedInstOperands,
     /* 102181 */       // GIR_Coverage, 4996,
     /* 102181 */       GIR_EraseRootFromParent_Done,
     /* 102182 */     // Label 1570: @102182
     /* 102182 */     GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(102244), // Rule ID 5855 //
     /* 102187 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102191 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102195 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 102199 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102201 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /* 102201 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 102204 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102208 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102213 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102215 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102218 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102220 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102223 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102225 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 102228 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102233 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102238 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102243 */       // GIR_Coverage, 5855,
     /* 102243 */       GIR_EraseRootFromParent_Done,
     /* 102244 */     // Label 1571: @102244
     /* 102244 */     GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(102306), // Rule ID 5859 //
     /* 102249 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102253 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102257 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 102261 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102263 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /* 102263 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 102266 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102270 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102275 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102277 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102280 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102282 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102285 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102287 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 102290 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102295 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102300 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102305 */       // GIR_Coverage, 5859,
     /* 102305 */       GIR_EraseRootFromParent_Done,
     /* 102306 */     // Label 1572: @102306
     /* 102306 */     GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(102440), // Rule ID 5853 //
     /* 102311 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102315 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102319 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 102319 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 102322 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102326 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102331 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 102333 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 102336 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102340 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102345 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 102348 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 102352 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 102355 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102360 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102365 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102370 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102373 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102377 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102382 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102384 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102387 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102391 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102396 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102399 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102403 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102406 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102411 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102416 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102421 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102424 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102426 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102429 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102432 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102435 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102438 */       GIR_RootConstrainSelectedInstOperands,
     /* 102439 */       // GIR_Coverage, 5853,
     /* 102439 */       GIR_EraseRootFromParent_Done,
     /* 102440 */     // Label 1573: @102440
     /* 102440 */     GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(102574), // Rule ID 5857 //
     /* 102445 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102449 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102453 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 102453 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 102456 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102460 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102465 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 102467 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 102470 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102474 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102479 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 102482 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 102486 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 102489 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102494 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102499 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102504 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102507 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102511 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102516 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102518 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102521 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102525 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102530 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102533 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102537 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102540 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102545 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102550 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102555 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102558 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102560 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102563 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102566 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102569 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102572 */       GIR_RootConstrainSelectedInstOperands,
     /* 102573 */       // GIR_Coverage, 5857,
     /* 102573 */       GIR_EraseRootFromParent_Done,
     /* 102574 */     // Label 1574: @102574
     /* 102574 */     GIM_Reject,
     /* 102575 */   // Label 1550: @102575
     /* 102575 */   GIM_Reject,
     /* 102576 */   // Label 1509: @102576
     /* 102576 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(104486),
     /* 102581 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 102584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 102587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102591 */     GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(102720), // Rule ID 5455 //
     /* 102596 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102600 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102604 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102608 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102612 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102616 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102620 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102624 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 102628 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 102632 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102636 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102640 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102645 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 102649 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 102655 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /* 102657 */       // MIs[2] Operand 2
     /* 102657 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 102668 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 102670 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 102670 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102673 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102677 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102682 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102685 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102689 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102692 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102697 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102702 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 102705 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102707 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102710 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102714 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102718 */       GIR_RootConstrainSelectedInstOperands,
     /* 102719 */       // GIR_Coverage, 5455,
     /* 102719 */       GIR_EraseRootFromParent_Done,
     /* 102720 */     // Label 1576: @102720
     /* 102720 */     GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(102842), // Rule ID 5451 //
     /* 102725 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102729 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102733 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102737 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102741 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102745 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102749 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102753 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 102757 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 102761 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102765 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102769 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102774 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102779 */       // MIs[2] Operand 2
     /* 102779 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 102790 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102792 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 102792 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102795 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102799 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102804 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102807 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102811 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102814 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102819 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102824 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /* 102827 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102829 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102832 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102836 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102840 */       GIR_RootConstrainSelectedInstOperands,
     /* 102841 */       // GIR_Coverage, 5451,
     /* 102841 */       GIR_EraseRootFromParent_Done,
     /* 102842 */     // Label 1577: @102842
     /* 102842 */     GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(102964), // Rule ID 5453 //
     /* 102847 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102851 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102855 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102859 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102863 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102867 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102871 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102875 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 102879 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 102883 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102887 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102891 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102896 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102901 */       // MIs[2] Operand 2
     /* 102901 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 102912 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102914 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 102914 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102917 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102921 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102926 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102929 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102933 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102936 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102941 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102946 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 102949 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102951 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102954 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102958 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102962 */       GIR_RootConstrainSelectedInstOperands,
     /* 102963 */       // GIR_Coverage, 5453,
     /* 102963 */       GIR_EraseRootFromParent_Done,
     /* 102964 */     // Label 1578: @102964
     /* 102964 */     GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(103066), // Rule ID 5611 //
     /* 102969 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102973 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102977 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102981 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102985 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102989 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102993 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102998 */       // MIs[2] Operand 2
     /* 102998 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 103009 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 103013 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103017 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103021 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 103025 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 103029 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103033 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103038 */       // MIs[4] Operand 2
     /* 103038 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /* 103049 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 103051 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 103051 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 103054 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103056 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 103060 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 103064 */       GIR_RootConstrainSelectedInstOperands,
     /* 103065 */       // GIR_Coverage, 5611,
     /* 103065 */       GIR_EraseRootFromParent_Done,
     /* 103066 */     // Label 1579: @103066
     /* 103066 */     GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(103195), // Rule ID 6391 //
     /* 103071 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103075 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103079 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103083 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103086 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 103091 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103095 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103099 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103104 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /* 103108 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103110 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 103110 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 103113 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 103117 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103122 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103125 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103127 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103130 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103134 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103139 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103141 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103144 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103148 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103153 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103156 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 103160 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103163 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103168 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103173 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103178 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /* 103181 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103183 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103186 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103190 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103193 */       GIR_RootConstrainSelectedInstOperands,
     /* 103194 */       // GIR_Coverage, 6391,
     /* 103194 */       GIR_EraseRootFromParent_Done,
     /* 103195 */     // Label 1580: @103195
     /* 103195 */     GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(103237), // Rule ID 5864 //
     /* 103200 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 103207 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 103214 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /* 103214 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 103217 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103219 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 103224 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103227 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103232 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 103235 */       GIR_RootConstrainSelectedInstOperands,
     /* 103236 */       // GIR_Coverage, 5864,
     /* 103236 */       GIR_EraseRootFromParent_Done,
     /* 103237 */     // Label 1581: @103237
     /* 103237 */     GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(103360), // Rule ID 2574 //
     /* 103242 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103245 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103249 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103253 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103257 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103260 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 103265 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103269 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103273 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103278 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 103282 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 103286 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 103290 */       // MIs[2] Operand 1
     /* 103290 */       // No operand predicates
     /* 103290 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 103292 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 103292 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103295 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103299 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103304 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103306 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103309 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103313 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103318 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103321 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103325 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103328 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103333 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103338 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103343 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /* 103346 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103348 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103351 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103355 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 103358 */       GIR_RootConstrainSelectedInstOperands,
     /* 103359 */       // GIR_Coverage, 2574,
     /* 103359 */       GIR_EraseRootFromParent_Done,
     /* 103360 */     // Label 1582: @103360
     /* 103360 */     GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(103483), // Rule ID 6361 //
     /* 103365 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103368 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103372 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103376 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103380 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103384 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 103388 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 103392 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103396 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103401 */       // MIs[2] imm
     /* 103401 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 103405 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 103409 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 103413 */       // MIs[3] Operand 1
     /* 103413 */       // No operand predicates
     /* 103413 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 103415 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 103415 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103418 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103422 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103427 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103429 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103432 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103436 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103441 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103444 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103448 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103451 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103456 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103461 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103466 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /* 103469 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103471 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103474 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 103478 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 103481 */       GIR_RootConstrainSelectedInstOperands,
     /* 103482 */       // GIR_Coverage, 6361,
     /* 103482 */       GIR_EraseRootFromParent_Done,
     /* 103483 */     // Label 1583: @103483
     /* 103483 */     GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(103603), // Rule ID 6397 //
     /* 103488 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103492 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103496 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103500 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103504 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 103508 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 103512 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 103516 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103521 */       // MIs[2] imm
     /* 103521 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 103525 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 103529 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 103533 */       // MIs[3] Operand 1
     /* 103533 */       // No operand predicates
     /* 103533 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 103535 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 103535 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103538 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103542 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103547 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103549 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103552 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103556 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103561 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103564 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103568 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103571 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103576 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103581 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103586 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /* 103589 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103591 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103594 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 103598 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 103601 */       GIR_RootConstrainSelectedInstOperands,
     /* 103602 */       // GIR_Coverage, 6397,
     /* 103602 */       GIR_EraseRootFromParent_Done,
     /* 103603 */     // Label 1584: @103603
     /* 103603 */     GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(103720), // Rule ID 2499 //
     /* 103608 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103611 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103615 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103619 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103623 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103626 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 103631 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103635 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 103639 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103644 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103649 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103651 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 103651 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103654 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103658 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103663 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103665 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103668 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103672 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103677 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103680 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103684 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103687 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103692 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103697 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103702 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /* 103705 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103707 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103710 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103714 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103718 */       GIR_RootConstrainSelectedInstOperands,
     /* 103719 */       // GIR_Coverage, 2499,
     /* 103719 */       GIR_EraseRootFromParent_Done,
     /* 103720 */     // Label 1585: @103720
     /* 103720 */     GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(103837), // Rule ID 5381 //
     /* 103725 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103728 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103732 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103736 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103740 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103743 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 103748 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103752 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 103756 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103761 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103766 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103768 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 103768 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103771 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103775 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103780 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103782 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103785 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103789 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103794 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103797 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103801 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103804 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103809 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103814 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103819 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 103822 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103824 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103827 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103831 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103835 */       GIR_RootConstrainSelectedInstOperands,
     /* 103836 */       // GIR_Coverage, 5381,
     /* 103836 */       GIR_EraseRootFromParent_Done,
     /* 103837 */     // Label 1586: @103837
     /* 103837 */     GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(103954), // Rule ID 5384 //
     /* 103842 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103845 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103849 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103853 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103857 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103860 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 103865 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103869 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 103873 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103878 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103883 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103885 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 103885 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103888 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103892 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103897 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103899 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103902 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103906 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103911 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103914 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103918 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103921 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103926 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103931 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103936 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /* 103939 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103941 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103944 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103948 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103952 */       GIR_RootConstrainSelectedInstOperands,
     /* 103953 */       // GIR_Coverage, 5384,
     /* 103953 */       GIR_EraseRootFromParent_Done,
     /* 103954 */     // Label 1587: @103954
     /* 103954 */     GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(104071), // Rule ID 5387 //
     /* 103959 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103962 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103966 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103970 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103974 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103977 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 103982 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 103986 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 103990 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103995 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104000 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104002 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 104002 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104005 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104009 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104014 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104016 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104019 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104023 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104028 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104031 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104035 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104038 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104043 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104048 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104053 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /* 104056 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104058 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104061 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 104065 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 104069 */       GIR_RootConstrainSelectedInstOperands,
     /* 104070 */       // GIR_Coverage, 5387,
     /* 104070 */       GIR_EraseRootFromParent_Done,
     /* 104071 */     // Label 1588: @104071
     /* 104071 */     GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(104127), // Rule ID 5528 //
     /* 104076 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104080 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104084 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104088 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104093 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 104097 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104101 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104105 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104110 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 104112 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 104112 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 104115 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104117 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 104121 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 104125 */       GIR_RootConstrainSelectedInstOperands,
     /* 104126 */       // GIR_Coverage, 5528,
     /* 104126 */       GIR_EraseRootFromParent_Done,
     /* 104127 */     // Label 1589: @104127
     /* 104127 */     GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(104193), // Rule ID 5862 //
     /* 104132 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104136 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104140 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 104146 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 104148 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104150 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /* 104150 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104153 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 104157 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104162 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 104166 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104168 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104171 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104173 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104176 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104179 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 104182 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104187 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104192 */       // GIR_Coverage, 5862,
     /* 104192 */       GIR_EraseRootFromParent_Done,
     /* 104193 */     // Label 1590: @104193
     /* 104193 */     GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(104289), // Rule ID 4995 //
     /* 104198 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104201 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104205 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104209 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104213 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104217 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104222 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104224 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /* 104224 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104227 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104231 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104236 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104238 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104241 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104245 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104250 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104253 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104257 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104260 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104265 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104270 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104275 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /* 104278 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104280 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104283 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 104287 */       GIR_RootConstrainSelectedInstOperands,
     /* 104288 */       // GIR_Coverage, 4995,
     /* 104288 */       GIR_EraseRootFromParent_Done,
     /* 104289 */     // Label 1591: @104289
     /* 104289 */     GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(104351), // Rule ID 5863 //
     /* 104294 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104298 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104302 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 104306 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104308 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /* 104308 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 104311 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104315 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104320 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104322 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104325 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104327 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104330 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 104332 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 104335 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104340 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104345 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104350 */       // GIR_Coverage, 5863,
     /* 104350 */       GIR_EraseRootFromParent_Done,
     /* 104351 */     // Label 1592: @104351
     /* 104351 */     GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(104485), // Rule ID 5861 //
     /* 104356 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104360 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104364 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 104364 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 104367 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104371 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104376 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 104378 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 104381 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104385 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104390 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 104393 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 104397 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 104400 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104405 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104410 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104415 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104418 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104422 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104427 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104429 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104432 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104436 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104441 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104444 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104448 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104451 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104456 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104461 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104466 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 104469 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104471 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104474 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104477 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104480 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104483 */       GIR_RootConstrainSelectedInstOperands,
     /* 104484 */       // GIR_Coverage, 5861,
     /* 104484 */       GIR_EraseRootFromParent_Done,
     /* 104485 */     // Label 1593: @104485
     /* 104485 */     GIM_Reject,
     /* 104486 */   // Label 1575: @104486
     /* 104486 */   GIM_Reject,
     /* 104487 */   // Label 1510: @104487
     /* 104487 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(104512), // Rule ID 9137 //
     /* 104492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104495 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 104498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 104501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 104505 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /* 104505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 104510 */     GIR_RootConstrainSelectedInstOperands,
     /* 104511 */     // GIR_Coverage, 9137,
     /* 104511 */     GIR_Done,
     /* 104512 */   // Label 1594: @104512
     /* 104512 */   GIM_Reject,
     /* 104513 */   // Label 1511: @104513
     /* 104513 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(104538), // Rule ID 9138 //
     /* 104518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104521 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 104524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 104527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 104531 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /* 104531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 104536 */     GIR_RootConstrainSelectedInstOperands,
     /* 104537 */     // GIR_Coverage, 9138,
     /* 104537 */     GIR_Done,
     /* 104538 */   // Label 1595: @104538
     /* 104538 */   GIM_Reject,
     /* 104539 */   // Label 1512: @104539
     /* 104539 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(104564), // Rule ID 9141 //
     /* 104544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104547 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 104550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 104553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 104557 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /* 104557 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 104562 */     GIR_RootConstrainSelectedInstOperands,
     /* 104563 */     // GIR_Coverage, 9141,
     /* 104563 */     GIR_Done,
     /* 104564 */   // Label 1596: @104564
     /* 104564 */   GIM_Reject,
     /* 104565 */   // Label 1513: @104565
     /* 104565 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(104590), // Rule ID 9143 //
     /* 104570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104573 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 104576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 104579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 104583 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /* 104583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 104588 */     GIR_RootConstrainSelectedInstOperands,
     /* 104589 */     // GIR_Coverage, 9143,
     /* 104589 */     GIR_Done,
     /* 104590 */   // Label 1597: @104590
     /* 104590 */   GIM_Reject,
     /* 104591 */   // Label 1514: @104591
     /* 104591 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(104616), // Rule ID 9139 //
     /* 104596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104599 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 104602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 104605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 104609 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /* 104609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 104614 */     GIR_RootConstrainSelectedInstOperands,
     /* 104615 */     // GIR_Coverage, 9139,
     /* 104615 */     GIR_Done,
     /* 104616 */   // Label 1598: @104616
     /* 104616 */   GIM_Reject,
     /* 104617 */   // Label 1515: @104617
     /* 104617 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(104642), // Rule ID 9142 //
     /* 104622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104625 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 104628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 104631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 104635 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /* 104635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 104640 */     GIR_RootConstrainSelectedInstOperands,
     /* 104641 */     // GIR_Coverage, 9142,
     /* 104641 */     GIR_Done,
     /* 104642 */   // Label 1599: @104642
     /* 104642 */   GIM_Reject,
     /* 104643 */   // Label 1516: @104643
     /* 104643 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(104668), // Rule ID 9140 //
     /* 104648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 104651 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 104654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 104657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 104661 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /* 104661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 104666 */     GIR_RootConstrainSelectedInstOperands,
     /* 104667 */     // GIR_Coverage, 9140,
     /* 104667 */     GIR_Done,
     /* 104668 */   // Label 1600: @104668
     /* 104668 */   GIM_Reject,
     /* 104669 */   // Label 1517: @104669
     /* 104669 */   GIM_Reject,
     /* 104670 */ // Label 1505: @104670
     /* 104670 */ GIM_Reject,
     /* 104671 */ // Label 9: @104671
     /* 104671 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1615*/ GIMT_Encode4(114646),
     /* 104682 */ /*GILLT_s32*//*Label 1601*/ GIMT_Encode4(104770),
     /* 104686 */ /*GILLT_s64*//*Label 1602*/ GIMT_Encode4(105167),
     /* 104690 */ /*GILLT_s128*//*Label 1603*/ GIMT_Encode4(107158),
     /* 104694 */ /*GILLT_v2s32*//*Label 1604*/ GIMT_Encode4(107804),
     /* 104698 */ /*GILLT_v2s64*//*Label 1605*/ GIMT_Encode4(108719),
     /* 104702 */ /*GILLT_v4s16*//*Label 1606*/ GIMT_Encode4(109488),
     /* 104706 */ /*GILLT_v4s32*//*Label 1607*/ GIMT_Encode4(110403),
     /* 104710 */ /*GILLT_v8s8*//*Label 1608*/ GIMT_Encode4(111248),
     /* 104714 */ /*GILLT_v8s16*//*Label 1609*/ GIMT_Encode4(111809),
     /* 104718 */ /*GILLT_v16s8*//*Label 1610*/ GIMT_Encode4(112654), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104738 */ /*GILLT_nxv2s64*//*Label 1611*/ GIMT_Encode4(113106), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104750 */ /*GILLT_nxv4s32*//*Label 1612*/ GIMT_Encode4(113555), GIMT_Encode4(0),
     /* 104758 */ /*GILLT_nxv8s16*//*Label 1613*/ GIMT_Encode4(114004), GIMT_Encode4(0),
     /* 104766 */ /*GILLT_nxv16s8*//*Label 1614*/ GIMT_Encode4(114453),
     /* 104770 */ // Label 1601: @104770
     /* 104770 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(105166),
     /* 104775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104778 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(104852), // Rule ID 7114 //
     /* 104783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 104787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 104795 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104798 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 104802 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104809 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104812 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 104816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 104825 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15928>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 104825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 104828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 104850 */     GIR_RootConstrainSelectedInstOperands,
     /* 104851 */     // GIR_Coverage, 7114,
     /* 104851 */     GIR_EraseRootFromParent_Done,
     /* 104852 */   // Label 1617: @104852
     /* 104852 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(104926), // Rule ID 7115 //
     /* 104857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 104861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 104869 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 104876 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104883 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104886 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 104890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 104899 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15928>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 104899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 104902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 104924 */     GIR_RootConstrainSelectedInstOperands,
     /* 104925 */     // GIR_Coverage, 7115,
     /* 104925 */     GIR_EraseRootFromParent_Done,
     /* 104926 */   // Label 1618: @104926
     /* 104926 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(104995), // Rule ID 7116 //
     /* 104931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 104935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 104943 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104946 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 104950 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104957 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104960 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 104964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 104973 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15928>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 104973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 104976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 104993 */     GIR_RootConstrainSelectedInstOperands,
     /* 104994 */     // GIR_Coverage, 7116,
     /* 104994 */     GIR_EraseRootFromParent_Done,
     /* 104995 */   // Label 1619: @104995
     /* 104995 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(105064), // Rule ID 7117 //
     /* 105000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105012 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105015 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105019 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 105026 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105029 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 105042 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15928>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 105045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105062 */     GIR_RootConstrainSelectedInstOperands,
     /* 105063 */     // GIR_Coverage, 7117,
     /* 105063 */     GIR_EraseRootFromParent_Done,
     /* 105064 */   // Label 1620: @105064
     /* 105064 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(105117), // Rule ID 5828 //
     /* 105069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 105081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 105085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105089 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 105093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105095 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /* 105095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105100 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /* 105106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105116 */     // GIR_Coverage, 5828,
     /* 105116 */     GIR_EraseRootFromParent_Done,
     /* 105117 */   // Label 1621: @105117
     /* 105117 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(105141), // Rule ID 6725 //
     /* 105122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105130 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /* 105130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105140 */     // GIR_Coverage, 6725,
     /* 105140 */     GIR_Done,
     /* 105141 */   // Label 1622: @105141
     /* 105141 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(105165), // Rule ID 6726 //
     /* 105146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 105154 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /* 105154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 105164 */     // GIR_Coverage, 6726,
     /* 105164 */     GIR_Done,
     /* 105165 */   // Label 1623: @105165
     /* 105165 */   GIM_Reject,
     /* 105166 */ // Label 1616: @105166
     /* 105166 */ GIM_Reject,
     /* 105167 */ // Label 1602: @105167
     /* 105167 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(105244), // Rule ID 7118 //
     /* 105172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105179 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105183 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105187 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105190 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105194 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105201 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105204 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105208 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105210 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105217 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15936>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105237 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105242 */   GIR_RootConstrainSelectedInstOperands,
     /* 105243 */   // GIR_Coverage, 7118,
     /* 105243 */   GIR_EraseRootFromParent_Done,
     /* 105244 */ // Label 1624: @105244
     /* 105244 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(105321), // Rule ID 7119 //
     /* 105249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105256 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105260 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105264 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105267 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105271 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105278 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105281 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105285 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105287 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105294 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15936>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105309 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105314 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105319 */   GIR_RootConstrainSelectedInstOperands,
     /* 105320 */   // GIR_Coverage, 7119,
     /* 105320 */   GIR_EraseRootFromParent_Done,
     /* 105321 */ // Label 1625: @105321
     /* 105321 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(105393), // Rule ID 7120 //
     /* 105326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105333 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105337 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105341 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105344 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105348 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105355 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105358 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105362 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105364 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105371 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15936>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105386 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105391 */   GIR_RootConstrainSelectedInstOperands,
     /* 105392 */   // GIR_Coverage, 7120,
     /* 105392 */   GIR_EraseRootFromParent_Done,
     /* 105393 */ // Label 1626: @105393
     /* 105393 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(105465), // Rule ID 7121 //
     /* 105398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105405 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105409 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 105413 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 105416 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 105420 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 105427 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 105430 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 105434 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105436 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105443 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15936>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105458 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 105463 */   GIR_RootConstrainSelectedInstOperands,
     /* 105464 */   // GIR_Coverage, 7121,
     /* 105464 */   GIR_EraseRootFromParent_Done,
     /* 105465 */ // Label 1627: @105465
     /* 105465 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(105521), // Rule ID 5830 //
     /* 105470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105477 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105481 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 105485 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 105489 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105493 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 105497 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105499 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /* 105499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105504 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 105510 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105520 */   // GIR_Coverage, 5830,
     /* 105520 */   GIR_EraseRootFromParent_Done,
     /* 105521 */ // Label 1628: @105521
     /* 105521 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(105551), // Rule ID 6700 //
     /* 105526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105540 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /* 105540 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105545 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105550 */   // GIR_Coverage, 6700,
     /* 105550 */   GIR_Done,
     /* 105551 */ // Label 1629: @105551
     /* 105551 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(105581), // Rule ID 6701 //
     /* 105556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105570 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /* 105570 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105575 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105580 */   // GIR_Coverage, 6701,
     /* 105580 */   GIR_Done,
     /* 105581 */ // Label 1630: @105581
     /* 105581 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(105611), // Rule ID 6702 //
     /* 105586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105600 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /* 105600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105605 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105610 */   // GIR_Coverage, 6702,
     /* 105610 */   GIR_Done,
     /* 105611 */ // Label 1631: @105611
     /* 105611 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(105641), // Rule ID 6703 //
     /* 105616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105630 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /* 105630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105635 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105640 */   // GIR_Coverage, 6703,
     /* 105640 */   GIR_Done,
     /* 105641 */ // Label 1632: @105641
     /* 105641 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(105671), // Rule ID 6704 //
     /* 105646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105660 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /* 105660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105665 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105670 */   // GIR_Coverage, 6704,
     /* 105670 */   GIR_Done,
     /* 105671 */ // Label 1633: @105671
     /* 105671 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(105701), // Rule ID 6705 //
     /* 105676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105690 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /* 105690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105695 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105700 */   // GIR_Coverage, 6705,
     /* 105700 */   GIR_Done,
     /* 105701 */ // Label 1634: @105701
     /* 105701 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(105751), // Rule ID 6711 //
     /* 105706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105720 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /* 105720 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105723 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105727 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105732 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105736 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105741 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 105744 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105749 */   GIR_RootConstrainSelectedInstOperands,
     /* 105750 */   // GIR_Coverage, 6711,
     /* 105750 */   GIR_EraseRootFromParent_Done,
     /* 105751 */ // Label 1635: @105751
     /* 105751 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(105801), // Rule ID 6712 //
     /* 105756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105770 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /* 105770 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105773 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105777 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105782 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105786 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 105794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105796 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105799 */   GIR_RootConstrainSelectedInstOperands,
     /* 105800 */   // GIR_Coverage, 6712,
     /* 105800 */   GIR_EraseRootFromParent_Done,
     /* 105801 */ // Label 1636: @105801
     /* 105801 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(105851), // Rule ID 6713 //
     /* 105806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105820 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /* 105820 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105823 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105827 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105832 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105836 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 105844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105846 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105849 */   GIR_RootConstrainSelectedInstOperands,
     /* 105850 */   // GIR_Coverage, 6713,
     /* 105850 */   GIR_EraseRootFromParent_Done,
     /* 105851 */ // Label 1637: @105851
     /* 105851 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(105901), // Rule ID 6714 //
     /* 105856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105870 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /* 105870 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105873 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105877 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105882 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105886 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 105894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105896 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105899 */   GIR_RootConstrainSelectedInstOperands,
     /* 105900 */   // GIR_Coverage, 6714,
     /* 105900 */   GIR_EraseRootFromParent_Done,
     /* 105901 */ // Label 1638: @105901
     /* 105901 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(105951), // Rule ID 6715 //
     /* 105906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 105909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105920 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /* 105920 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105923 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105927 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105932 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 105936 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 105944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105946 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105949 */   GIR_RootConstrainSelectedInstOperands,
     /* 105950 */   // GIR_Coverage, 6715,
     /* 105950 */   GIR_EraseRootFromParent_Done,
     /* 105951 */ // Label 1639: @105951
     /* 105951 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(105978), // Rule ID 6716 //
     /* 105956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105967 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 105967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105972 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105977 */   // GIR_Coverage, 6716,
     /* 105977 */   GIR_Done,
     /* 105978 */ // Label 1640: @105978
     /* 105978 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(106005), // Rule ID 6717 //
     /* 105983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 105994 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 105994 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105999 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106004 */   // GIR_Coverage, 6717,
     /* 106004 */   GIR_Done,
     /* 106005 */ // Label 1641: @106005
     /* 106005 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(106032), // Rule ID 6718 //
     /* 106010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106021 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /* 106021 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106026 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106031 */   // GIR_Coverage, 6718,
     /* 106031 */   GIR_Done,
     /* 106032 */ // Label 1642: @106032
     /* 106032 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(106059), // Rule ID 6727 //
     /* 106037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106048 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 106048 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106058 */   // GIR_Coverage, 6727,
     /* 106058 */   GIR_Done,
     /* 106059 */ // Label 1643: @106059
     /* 106059 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(106086), // Rule ID 6728 //
     /* 106064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106075 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /* 106075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106080 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106085 */   // GIR_Coverage, 6728,
     /* 106085 */   GIR_Done,
     /* 106086 */ // Label 1644: @106086
     /* 106086 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(106113), // Rule ID 6729 //
     /* 106091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106102 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /* 106102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106107 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 106112 */   // GIR_Coverage, 6729,
     /* 106112 */   GIR_Done,
     /* 106113 */ // Label 1645: @106113
     /* 106113 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(106145), // Rule ID 6730 //
     /* 106118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106132 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106135 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106137 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106139 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106144 */   // GIR_Coverage, 6730,
     /* 106144 */   GIR_EraseRootFromParent_Done,
     /* 106145 */ // Label 1646: @106145
     /* 106145 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(106177), // Rule ID 6731 //
     /* 106150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106164 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106167 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106169 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106171 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106176 */   // GIR_Coverage, 6731,
     /* 106176 */   GIR_EraseRootFromParent_Done,
     /* 106177 */ // Label 1647: @106177
     /* 106177 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(106209), // Rule ID 6732 //
     /* 106182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106196 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106199 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106201 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106203 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106208 */   // GIR_Coverage, 6732,
     /* 106208 */   GIR_EraseRootFromParent_Done,
     /* 106209 */ // Label 1648: @106209
     /* 106209 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(106241), // Rule ID 6733 //
     /* 106214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106228 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106231 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106233 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106235 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106240 */   // GIR_Coverage, 6733,
     /* 106240 */   GIR_EraseRootFromParent_Done,
     /* 106241 */ // Label 1649: @106241
     /* 106241 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(106273), // Rule ID 6734 //
     /* 106246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106260 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106263 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106265 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106267 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106272 */   // GIR_Coverage, 6734,
     /* 106272 */   GIR_EraseRootFromParent_Done,
     /* 106273 */ // Label 1650: @106273
     /* 106273 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(106299), // Rule ID 6735 //
     /* 106278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106292 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /* 106292 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106297 */   GIR_RootConstrainSelectedInstOperands,
     /* 106298 */   // GIR_Coverage, 6735,
     /* 106298 */   GIR_Done,
     /* 106299 */ // Label 1651: @106299
     /* 106299 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(106325), // Rule ID 6736 //
     /* 106304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106318 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /* 106318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106323 */   GIR_RootConstrainSelectedInstOperands,
     /* 106324 */   // GIR_Coverage, 6736,
     /* 106324 */   GIR_Done,
     /* 106325 */ // Label 1652: @106325
     /* 106325 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(106351), // Rule ID 6737 //
     /* 106330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106344 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /* 106344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 106349 */   GIR_RootConstrainSelectedInstOperands,
     /* 106350 */   // GIR_Coverage, 6737,
     /* 106350 */   GIR_Done,
     /* 106351 */ // Label 1653: @106351
     /* 106351 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(106377), // Rule ID 6738 //
     /* 106356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106370 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /* 106370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106375 */   GIR_RootConstrainSelectedInstOperands,
     /* 106376 */   // GIR_Coverage, 6738,
     /* 106376 */   GIR_Done,
     /* 106377 */ // Label 1654: @106377
     /* 106377 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(106403), // Rule ID 6739 //
     /* 106382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106396 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /* 106396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106401 */   GIR_RootConstrainSelectedInstOperands,
     /* 106402 */   // GIR_Coverage, 6739,
     /* 106402 */   GIR_Done,
     /* 106403 */ // Label 1655: @106403
     /* 106403 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(106432), // Rule ID 6740 //
     /* 106408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106419 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106422 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106431 */   // GIR_Coverage, 6740,
     /* 106431 */   GIR_EraseRootFromParent_Done,
     /* 106432 */ // Label 1656: @106432
     /* 106432 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(106461), // Rule ID 6741 //
     /* 106437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106448 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 106448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106451 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106453 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106455 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106460 */   // GIR_Coverage, 6741,
     /* 106460 */   GIR_EraseRootFromParent_Done,
     /* 106461 */ // Label 1657: @106461
     /* 106461 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(106493), // Rule ID 6795 //
     /* 106466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106480 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106483 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106487 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106492 */   // GIR_Coverage, 6795,
     /* 106492 */   GIR_EraseRootFromParent_Done,
     /* 106493 */ // Label 1658: @106493
     /* 106493 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(106525), // Rule ID 6796 //
     /* 106498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106512 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106515 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106517 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106519 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106524 */   // GIR_Coverage, 6796,
     /* 106524 */   GIR_EraseRootFromParent_Done,
     /* 106525 */ // Label 1659: @106525
     /* 106525 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(106557), // Rule ID 6797 //
     /* 106530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106544 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106547 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106549 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106556 */   // GIR_Coverage, 6797,
     /* 106556 */   GIR_EraseRootFromParent_Done,
     /* 106557 */ // Label 1660: @106557
     /* 106557 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(106589), // Rule ID 6798 //
     /* 106562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106576 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106579 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106588 */   // GIR_Coverage, 6798,
     /* 106588 */   GIR_EraseRootFromParent_Done,
     /* 106589 */ // Label 1661: @106589
     /* 106589 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(106621), // Rule ID 6799 //
     /* 106594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106608 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106611 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106613 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106615 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106620 */   // GIR_Coverage, 6799,
     /* 106620 */   GIR_EraseRootFromParent_Done,
     /* 106621 */ // Label 1662: @106621
     /* 106621 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(106647), // Rule ID 6800 //
     /* 106626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106640 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /* 106640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106645 */   GIR_RootConstrainSelectedInstOperands,
     /* 106646 */   // GIR_Coverage, 6800,
     /* 106646 */   GIR_Done,
     /* 106647 */ // Label 1663: @106647
     /* 106647 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(106673), // Rule ID 6801 //
     /* 106652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106666 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /* 106666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106671 */   GIR_RootConstrainSelectedInstOperands,
     /* 106672 */   // GIR_Coverage, 6801,
     /* 106672 */   GIR_Done,
     /* 106673 */ // Label 1664: @106673
     /* 106673 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(106699), // Rule ID 6802 //
     /* 106678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106692 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /* 106692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106697 */   GIR_RootConstrainSelectedInstOperands,
     /* 106698 */   // GIR_Coverage, 6802,
     /* 106698 */   GIR_Done,
     /* 106699 */ // Label 1665: @106699
     /* 106699 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(106725), // Rule ID 6803 //
     /* 106704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106718 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /* 106718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 106723 */   GIR_RootConstrainSelectedInstOperands,
     /* 106724 */   // GIR_Coverage, 6803,
     /* 106724 */   GIR_Done,
     /* 106725 */ // Label 1666: @106725
     /* 106725 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(106751), // Rule ID 6804 //
     /* 106730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106744 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /* 106744 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 106749 */   GIR_RootConstrainSelectedInstOperands,
     /* 106750 */   // GIR_Coverage, 6804,
     /* 106750 */   GIR_Done,
     /* 106751 */ // Label 1667: @106751
     /* 106751 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(106780), // Rule ID 6805 //
     /* 106756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106767 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106770 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106772 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106774 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106779 */   // GIR_Coverage, 6805,
     /* 106779 */   GIR_EraseRootFromParent_Done,
     /* 106780 */ // Label 1668: @106780
     /* 106780 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(106809), // Rule ID 6806 //
     /* 106785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106796 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 106796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106799 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106801 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106803 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106808 */   // GIR_Coverage, 6806,
     /* 106808 */   GIR_EraseRootFromParent_Done,
     /* 106809 */ // Label 1669: @106809
     /* 106809 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(106841), // Rule ID 6807 //
     /* 106814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106828 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 106828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106831 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106833 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106840 */   // GIR_Coverage, 6807,
     /* 106840 */   GIR_EraseRootFromParent_Done,
     /* 106841 */ // Label 1670: @106841
     /* 106841 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(106873), // Rule ID 6808 //
     /* 106846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106860 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 106860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106863 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106865 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106867 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106872 */   // GIR_Coverage, 6808,
     /* 106872 */   GIR_EraseRootFromParent_Done,
     /* 106873 */ // Label 1671: @106873
     /* 106873 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(106905), // Rule ID 6809 //
     /* 106878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 106884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106892 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 106892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106895 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106897 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106899 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106904 */   // GIR_Coverage, 6809,
     /* 106904 */   GIR_EraseRootFromParent_Done,
     /* 106905 */ // Label 1672: @106905
     /* 106905 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(106937), // Rule ID 6810 //
     /* 106910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106924 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 106924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106927 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106929 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106931 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106936 */   // GIR_Coverage, 6810,
     /* 106936 */   GIR_EraseRootFromParent_Done,
     /* 106937 */ // Label 1673: @106937
     /* 106937 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(106969), // Rule ID 6811 //
     /* 106942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 106948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106956 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 106956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106959 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 106961 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 106963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106968 */   // GIR_Coverage, 6811,
     /* 106968 */   GIR_EraseRootFromParent_Done,
     /* 106969 */ // Label 1674: @106969
     /* 106969 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(106995), // Rule ID 6812 //
     /* 106974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 106977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 106980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106988 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /* 106988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 106993 */   GIR_RootConstrainSelectedInstOperands,
     /* 106994 */   // GIR_Coverage, 6812,
     /* 106994 */   GIR_Done,
     /* 106995 */ // Label 1675: @106995
     /* 106995 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(107021), // Rule ID 6813 //
     /* 107000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107014 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /* 107014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107019 */   GIR_RootConstrainSelectedInstOperands,
     /* 107020 */   // GIR_Coverage, 6813,
     /* 107020 */   GIR_Done,
     /* 107021 */ // Label 1676: @107021
     /* 107021 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(107047), // Rule ID 6814 //
     /* 107026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107040 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /* 107040 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 107045 */   GIR_RootConstrainSelectedInstOperands,
     /* 107046 */   // GIR_Coverage, 6814,
     /* 107046 */   GIR_Done,
     /* 107047 */ // Label 1677: @107047
     /* 107047 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(107073), // Rule ID 6815 //
     /* 107052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107066 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /* 107066 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107071 */   GIR_RootConstrainSelectedInstOperands,
     /* 107072 */   // GIR_Coverage, 6815,
     /* 107072 */   GIR_Done,
     /* 107073 */ // Label 1678: @107073
     /* 107073 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(107099), // Rule ID 6816 //
     /* 107078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107092 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /* 107092 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107097 */   GIR_RootConstrainSelectedInstOperands,
     /* 107098 */   // GIR_Coverage, 6816,
     /* 107098 */   GIR_Done,
     /* 107099 */ // Label 1679: @107099
     /* 107099 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(107128), // Rule ID 6817 //
     /* 107104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107115 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 107115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107118 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107120 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107122 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107127 */   // GIR_Coverage, 6817,
     /* 107127 */   GIR_EraseRootFromParent_Done,
     /* 107128 */ // Label 1680: @107128
     /* 107128 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(107157), // Rule ID 6818 //
     /* 107133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107144 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 107144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107147 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107149 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107151 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107156 */   // GIR_Coverage, 6818,
     /* 107156 */   GIR_EraseRootFromParent_Done,
     /* 107157 */ // Label 1681: @107157
     /* 107157 */ GIM_Reject,
     /* 107158 */ // Label 1603: @107158
     /* 107158 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(107190), // Rule ID 6832 //
     /* 107163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107177 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107180 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107182 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107184 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107189 */   // GIR_Coverage, 6832,
     /* 107189 */   GIR_EraseRootFromParent_Done,
     /* 107190 */ // Label 1682: @107190
     /* 107190 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(107222), // Rule ID 6833 //
     /* 107195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107209 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107212 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107214 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107216 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107221 */   // GIR_Coverage, 6833,
     /* 107221 */   GIR_EraseRootFromParent_Done,
     /* 107222 */ // Label 1683: @107222
     /* 107222 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(107254), // Rule ID 6834 //
     /* 107227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107241 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107244 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107246 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107248 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107253 */   // GIR_Coverage, 6834,
     /* 107253 */   GIR_EraseRootFromParent_Done,
     /* 107254 */ // Label 1684: @107254
     /* 107254 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(107286), // Rule ID 6835 //
     /* 107259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107273 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107276 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107278 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107280 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107285 */   // GIR_Coverage, 6835,
     /* 107285 */   GIR_EraseRootFromParent_Done,
     /* 107286 */ // Label 1685: @107286
     /* 107286 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(107318), // Rule ID 6836 //
     /* 107291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107305 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107308 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107310 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107312 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107317 */   // GIR_Coverage, 6836,
     /* 107317 */   GIR_EraseRootFromParent_Done,
     /* 107318 */ // Label 1686: @107318
     /* 107318 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(107350), // Rule ID 6837 //
     /* 107323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107337 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107340 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107342 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107344 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107349 */   // GIR_Coverage, 6837,
     /* 107349 */   GIR_EraseRootFromParent_Done,
     /* 107350 */ // Label 1687: @107350
     /* 107350 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(107382), // Rule ID 6838 //
     /* 107355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 107361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107369 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 107369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107372 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107374 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107376 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107381 */   // GIR_Coverage, 6838,
     /* 107381 */   GIR_EraseRootFromParent_Done,
     /* 107382 */ // Label 1688: @107382
     /* 107382 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(107415), // Rule ID 6839 //
     /* 107387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107401 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /* 107401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107406 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107408 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107413 */   GIR_RootConstrainSelectedInstOperands,
     /* 107414 */   // GIR_Coverage, 6839,
     /* 107414 */   GIR_EraseRootFromParent_Done,
     /* 107415 */ // Label 1689: @107415
     /* 107415 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(107486), // Rule ID 6840 //
     /* 107420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107434 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /* 107434 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107437 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 107441 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107446 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 107459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107464 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107468 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107475 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107478 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107484 */   GIR_RootConstrainSelectedInstOperands,
     /* 107485 */   // GIR_Coverage, 6840,
     /* 107485 */   GIR_EraseRootFromParent_Done,
     /* 107486 */ // Label 1690: @107486
     /* 107486 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(107557), // Rule ID 6841 //
     /* 107491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107505 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /* 107505 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107508 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 107512 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107517 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107523 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107526 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 107530 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107535 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107539 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107549 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107555 */   GIR_RootConstrainSelectedInstOperands,
     /* 107556 */   // GIR_Coverage, 6841,
     /* 107556 */   GIR_EraseRootFromParent_Done,
     /* 107557 */ // Label 1691: @107557
     /* 107557 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(107628), // Rule ID 6842 //
     /* 107562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 107568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107576 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /* 107576 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107579 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 107583 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107588 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107592 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107594 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107597 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 107601 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107606 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107620 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107626 */   GIR_RootConstrainSelectedInstOperands,
     /* 107627 */   // GIR_Coverage, 6842,
     /* 107627 */   GIR_EraseRootFromParent_Done,
     /* 107628 */ // Label 1692: @107628
     /* 107628 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(107661), // Rule ID 6843 //
     /* 107633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107647 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /* 107647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107652 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107654 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107659 */   GIR_RootConstrainSelectedInstOperands,
     /* 107660 */   // GIR_Coverage, 6843,
     /* 107660 */   GIR_EraseRootFromParent_Done,
     /* 107661 */ // Label 1693: @107661
     /* 107661 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(107732), // Rule ID 6844 //
     /* 107666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107680 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /* 107680 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107683 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 107687 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107692 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107698 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107701 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 107705 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107710 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107721 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107730 */   GIR_RootConstrainSelectedInstOperands,
     /* 107731 */   // GIR_Coverage, 6844,
     /* 107731 */   GIR_EraseRootFromParent_Done,
     /* 107732 */ // Label 1694: @107732
     /* 107732 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(107803), // Rule ID 6845 //
     /* 107737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 107743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107751 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /* 107751 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 107754 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 107758 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107763 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107769 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 107772 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 107776 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107781 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 107785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 107790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107792 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107795 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 107801 */   GIR_RootConstrainSelectedInstOperands,
     /* 107802 */   // GIR_Coverage, 6845,
     /* 107802 */   GIR_EraseRootFromParent_Done,
     /* 107803 */ // Label 1695: @107803
     /* 107803 */ GIM_Reject,
     /* 107804 */ // Label 1604: @107804
     /* 107804 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(107834), // Rule ID 6697 //
     /* 107809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107823 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107828 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107833 */   // GIR_Coverage, 6697,
     /* 107833 */   GIR_Done,
     /* 107834 */ // Label 1696: @107834
     /* 107834 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(107864), // Rule ID 6699 //
     /* 107839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107853 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107858 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107863 */   // GIR_Coverage, 6699,
     /* 107863 */   GIR_Done,
     /* 107864 */ // Label 1697: @107864
     /* 107864 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(107914), // Rule ID 6708 //
     /* 107869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107883 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 107883 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107886 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107890 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107895 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 107899 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107912 */   GIR_RootConstrainSelectedInstOperands,
     /* 107913 */   // GIR_Coverage, 6708,
     /* 107913 */   GIR_EraseRootFromParent_Done,
     /* 107914 */ // Label 1698: @107914
     /* 107914 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(107964), // Rule ID 6710 //
     /* 107919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107933 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 107933 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107936 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107940 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107945 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 107949 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107962 */   GIR_RootConstrainSelectedInstOperands,
     /* 107963 */   // GIR_Coverage, 6710,
     /* 107963 */   GIR_EraseRootFromParent_Done,
     /* 107964 */ // Label 1699: @107964
     /* 107964 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(107996), // Rule ID 6742 //
     /* 107969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107983 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 107983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107986 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107988 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107990 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107995 */   // GIR_Coverage, 6742,
     /* 107995 */   GIR_EraseRootFromParent_Done,
     /* 107996 */ // Label 1700: @107996
     /* 107996 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(108028), // Rule ID 6743 //
     /* 108001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108015 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108018 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108020 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108022 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108027 */   // GIR_Coverage, 6743,
     /* 108027 */   GIR_EraseRootFromParent_Done,
     /* 108028 */ // Label 1701: @108028
     /* 108028 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(108060), // Rule ID 6744 //
     /* 108033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108047 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108050 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108052 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108054 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108059 */   // GIR_Coverage, 6744,
     /* 108059 */   GIR_EraseRootFromParent_Done,
     /* 108060 */ // Label 1702: @108060
     /* 108060 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(108092), // Rule ID 6745 //
     /* 108065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108079 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108082 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108084 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108086 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108091 */   // GIR_Coverage, 6745,
     /* 108091 */   GIR_EraseRootFromParent_Done,
     /* 108092 */ // Label 1703: @108092
     /* 108092 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(108124), // Rule ID 6746 //
     /* 108097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108111 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108114 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108116 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108118 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108123 */   // GIR_Coverage, 6746,
     /* 108123 */   GIR_EraseRootFromParent_Done,
     /* 108124 */ // Label 1704: @108124
     /* 108124 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(108156), // Rule ID 6747 //
     /* 108129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108143 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108146 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108148 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108150 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108155 */   // GIR_Coverage, 6747,
     /* 108155 */   GIR_EraseRootFromParent_Done,
     /* 108156 */ // Label 1705: @108156
     /* 108156 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(108182), // Rule ID 6748 //
     /* 108161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108175 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /* 108175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108180 */   GIR_RootConstrainSelectedInstOperands,
     /* 108181 */   // GIR_Coverage, 6748,
     /* 108181 */   GIR_Done,
     /* 108182 */ // Label 1706: @108182
     /* 108182 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(108208), // Rule ID 6749 //
     /* 108187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108201 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /* 108201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 108206 */   GIR_RootConstrainSelectedInstOperands,
     /* 108207 */   // GIR_Coverage, 6749,
     /* 108207 */   GIR_Done,
     /* 108208 */ // Label 1707: @108208
     /* 108208 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(108234), // Rule ID 6750 //
     /* 108213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108227 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /* 108227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 108232 */   GIR_RootConstrainSelectedInstOperands,
     /* 108233 */   // GIR_Coverage, 6750,
     /* 108233 */   GIR_Done,
     /* 108234 */ // Label 1708: @108234
     /* 108234 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(108260), // Rule ID 6751 //
     /* 108239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108253 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /* 108253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108258 */   GIR_RootConstrainSelectedInstOperands,
     /* 108259 */   // GIR_Coverage, 6751,
     /* 108259 */   GIR_Done,
     /* 108260 */ // Label 1709: @108260
     /* 108260 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(108286), // Rule ID 6752 //
     /* 108265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108279 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /* 108279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108284 */   GIR_RootConstrainSelectedInstOperands,
     /* 108285 */   // GIR_Coverage, 6752,
     /* 108285 */   GIR_Done,
     /* 108286 */ // Label 1710: @108286
     /* 108286 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(108312), // Rule ID 6753 //
     /* 108291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108305 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /* 108305 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 108310 */   GIR_RootConstrainSelectedInstOperands,
     /* 108311 */   // GIR_Coverage, 6753,
     /* 108311 */   GIR_Done,
     /* 108312 */ // Label 1711: @108312
     /* 108312 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(108341), // Rule ID 6754 //
     /* 108317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108328 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 108328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108331 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108333 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108335 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108340 */   // GIR_Coverage, 6754,
     /* 108340 */   GIR_EraseRootFromParent_Done,
     /* 108341 */ // Label 1712: @108341
     /* 108341 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(108373), // Rule ID 6819 //
     /* 108346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108360 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108363 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108365 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108367 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108372 */   // GIR_Coverage, 6819,
     /* 108372 */   GIR_EraseRootFromParent_Done,
     /* 108373 */ // Label 1713: @108373
     /* 108373 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(108405), // Rule ID 6820 //
     /* 108378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108392 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108395 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108397 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108399 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108404 */   // GIR_Coverage, 6820,
     /* 108404 */   GIR_EraseRootFromParent_Done,
     /* 108405 */ // Label 1714: @108405
     /* 108405 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(108437), // Rule ID 6821 //
     /* 108410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108424 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108427 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108429 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108436 */   // GIR_Coverage, 6821,
     /* 108436 */   GIR_EraseRootFromParent_Done,
     /* 108437 */ // Label 1715: @108437
     /* 108437 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(108469), // Rule ID 6822 //
     /* 108442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108456 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108459 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108463 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108468 */   // GIR_Coverage, 6822,
     /* 108468 */   GIR_EraseRootFromParent_Done,
     /* 108469 */ // Label 1716: @108469
     /* 108469 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(108501), // Rule ID 6823 //
     /* 108474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108488 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108491 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108493 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108495 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108500 */   // GIR_Coverage, 6823,
     /* 108500 */   GIR_EraseRootFromParent_Done,
     /* 108501 */ // Label 1717: @108501
     /* 108501 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(108533), // Rule ID 6824 //
     /* 108506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108520 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108523 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108525 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108532 */   // GIR_Coverage, 6824,
     /* 108532 */   GIR_EraseRootFromParent_Done,
     /* 108533 */ // Label 1718: @108533
     /* 108533 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(108559), // Rule ID 6825 //
     /* 108538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108552 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /* 108552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108557 */   GIR_RootConstrainSelectedInstOperands,
     /* 108558 */   // GIR_Coverage, 6825,
     /* 108558 */   GIR_Done,
     /* 108559 */ // Label 1719: @108559
     /* 108559 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(108585), // Rule ID 6826 //
     /* 108564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108578 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /* 108578 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 108583 */   GIR_RootConstrainSelectedInstOperands,
     /* 108584 */   // GIR_Coverage, 6826,
     /* 108584 */   GIR_Done,
     /* 108585 */ // Label 1720: @108585
     /* 108585 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(108611), // Rule ID 6827 //
     /* 108590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108604 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /* 108604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 108609 */   GIR_RootConstrainSelectedInstOperands,
     /* 108610 */   // GIR_Coverage, 6827,
     /* 108610 */   GIR_Done,
     /* 108611 */ // Label 1721: @108611
     /* 108611 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(108637), // Rule ID 6828 //
     /* 108616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108630 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /* 108630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108635 */   GIR_RootConstrainSelectedInstOperands,
     /* 108636 */   // GIR_Coverage, 6828,
     /* 108636 */   GIR_Done,
     /* 108637 */ // Label 1722: @108637
     /* 108637 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(108663), // Rule ID 6829 //
     /* 108642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108656 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /* 108656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108661 */   GIR_RootConstrainSelectedInstOperands,
     /* 108662 */   // GIR_Coverage, 6829,
     /* 108662 */   GIR_Done,
     /* 108663 */ // Label 1723: @108663
     /* 108663 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(108689), // Rule ID 6830 //
     /* 108668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108682 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /* 108682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 108687 */   GIR_RootConstrainSelectedInstOperands,
     /* 108688 */   // GIR_Coverage, 6830,
     /* 108688 */   GIR_Done,
     /* 108689 */ // Label 1724: @108689
     /* 108689 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(108718), // Rule ID 6831 //
     /* 108694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108705 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 108705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108708 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108710 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108712 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108717 */   // GIR_Coverage, 6831,
     /* 108717 */   GIR_EraseRootFromParent_Done,
     /* 108718 */ // Label 1725: @108718
     /* 108718 */ GIM_Reject,
     /* 108719 */ // Label 1605: @108719
     /* 108719 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(108751), // Rule ID 6846 //
     /* 108724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 108730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108738 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108741 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108743 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108745 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108750 */   // GIR_Coverage, 6846,
     /* 108750 */   GIR_EraseRootFromParent_Done,
     /* 108751 */ // Label 1726: @108751
     /* 108751 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(108783), // Rule ID 6847 //
     /* 108756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108770 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108773 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108775 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108777 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108782 */   // GIR_Coverage, 6847,
     /* 108782 */   GIR_EraseRootFromParent_Done,
     /* 108783 */ // Label 1727: @108783
     /* 108783 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(108815), // Rule ID 6848 //
     /* 108788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108802 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108805 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108807 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108809 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108814 */   // GIR_Coverage, 6848,
     /* 108814 */   GIR_EraseRootFromParent_Done,
     /* 108815 */ // Label 1728: @108815
     /* 108815 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(108847), // Rule ID 6849 //
     /* 108820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108834 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108837 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108839 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108841 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108846 */   // GIR_Coverage, 6849,
     /* 108846 */   GIR_EraseRootFromParent_Done,
     /* 108847 */ // Label 1729: @108847
     /* 108847 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(108879), // Rule ID 6850 //
     /* 108852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 108858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108866 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108869 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108871 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108873 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108878 */   // GIR_Coverage, 6850,
     /* 108878 */   GIR_EraseRootFromParent_Done,
     /* 108879 */ // Label 1730: @108879
     /* 108879 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(108911), // Rule ID 6851 //
     /* 108884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108898 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 108898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108901 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108903 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108905 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108910 */   // GIR_Coverage, 6851,
     /* 108910 */   GIR_EraseRootFromParent_Done,
     /* 108911 */ // Label 1731: @108911
     /* 108911 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(108944), // Rule ID 6852 //
     /* 108916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 108922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108930 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /* 108930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 108933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 108935 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108937 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 108942 */   GIR_RootConstrainSelectedInstOperands,
     /* 108943 */   // GIR_Coverage, 6852,
     /* 108943 */   GIR_EraseRootFromParent_Done,
     /* 108944 */ // Label 1732: @108944
     /* 108944 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(108970), // Rule ID 6853 //
     /* 108949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108963 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /* 108963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 108968 */   GIR_RootConstrainSelectedInstOperands,
     /* 108969 */   // GIR_Coverage, 6853,
     /* 108969 */   GIR_Done,
     /* 108970 */ // Label 1733: @108970
     /* 108970 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(108996), // Rule ID 6854 //
     /* 108975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108989 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /* 108989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 108994 */   GIR_RootConstrainSelectedInstOperands,
     /* 108995 */   // GIR_Coverage, 6854,
     /* 108995 */   GIR_Done,
     /* 108996 */ // Label 1734: @108996
     /* 108996 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(109022), // Rule ID 6855 //
     /* 109001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109015 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /* 109015 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109020 */   GIR_RootConstrainSelectedInstOperands,
     /* 109021 */   // GIR_Coverage, 6855,
     /* 109021 */   GIR_Done,
     /* 109022 */ // Label 1735: @109022
     /* 109022 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(109048), // Rule ID 6856 //
     /* 109027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109041 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /* 109041 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 109046 */   GIR_RootConstrainSelectedInstOperands,
     /* 109047 */   // GIR_Coverage, 6856,
     /* 109047 */   GIR_Done,
     /* 109048 */ // Label 1736: @109048
     /* 109048 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(109074), // Rule ID 6857 //
     /* 109053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109067 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /* 109067 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109072 */   GIR_RootConstrainSelectedInstOperands,
     /* 109073 */   // GIR_Coverage, 6857,
     /* 109073 */   GIR_Done,
     /* 109074 */ // Label 1737: @109074
     /* 109074 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(109103), // Rule ID 6858 //
     /* 109079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109090 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 109090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109093 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109095 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109097 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109102 */   // GIR_Coverage, 6858,
     /* 109102 */   GIR_EraseRootFromParent_Done,
     /* 109103 */ // Label 1738: @109103
     /* 109103 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(109135), // Rule ID 6872 //
     /* 109108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 109114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109122 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109125 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109134 */   // GIR_Coverage, 6872,
     /* 109134 */   GIR_EraseRootFromParent_Done,
     /* 109135 */ // Label 1739: @109135
     /* 109135 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(109167), // Rule ID 6873 //
     /* 109140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109154 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109157 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109159 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109166 */   // GIR_Coverage, 6873,
     /* 109166 */   GIR_EraseRootFromParent_Done,
     /* 109167 */ // Label 1740: @109167
     /* 109167 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(109199), // Rule ID 6874 //
     /* 109172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109186 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109189 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109191 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109193 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109198 */   // GIR_Coverage, 6874,
     /* 109198 */   GIR_EraseRootFromParent_Done,
     /* 109199 */ // Label 1741: @109199
     /* 109199 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(109231), // Rule ID 6875 //
     /* 109204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109218 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109221 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109223 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109230 */   // GIR_Coverage, 6875,
     /* 109230 */   GIR_EraseRootFromParent_Done,
     /* 109231 */ // Label 1742: @109231
     /* 109231 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(109263), // Rule ID 6876 //
     /* 109236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109250 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109253 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109255 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109257 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109262 */   // GIR_Coverage, 6876,
     /* 109262 */   GIR_EraseRootFromParent_Done,
     /* 109263 */ // Label 1743: @109263
     /* 109263 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(109295), // Rule ID 6877 //
     /* 109268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109282 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109285 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109287 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109289 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109294 */   // GIR_Coverage, 6877,
     /* 109294 */   GIR_EraseRootFromParent_Done,
     /* 109295 */ // Label 1744: @109295
     /* 109295 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(109328), // Rule ID 6878 //
     /* 109300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 109306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109314 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /* 109314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109319 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109321 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109326 */   GIR_RootConstrainSelectedInstOperands,
     /* 109327 */   // GIR_Coverage, 6878,
     /* 109327 */   GIR_EraseRootFromParent_Done,
     /* 109328 */ // Label 1745: @109328
     /* 109328 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(109354), // Rule ID 6879 //
     /* 109333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109347 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /* 109347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109352 */   GIR_RootConstrainSelectedInstOperands,
     /* 109353 */   // GIR_Coverage, 6879,
     /* 109353 */   GIR_Done,
     /* 109354 */ // Label 1746: @109354
     /* 109354 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(109380), // Rule ID 6880 //
     /* 109359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109373 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /* 109373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109378 */   GIR_RootConstrainSelectedInstOperands,
     /* 109379 */   // GIR_Coverage, 6880,
     /* 109379 */   GIR_Done,
     /* 109380 */ // Label 1747: @109380
     /* 109380 */ GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(109406), // Rule ID 6881 //
     /* 109385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109399 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /* 109399 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 109404 */   GIR_RootConstrainSelectedInstOperands,
     /* 109405 */   // GIR_Coverage, 6881,
     /* 109405 */   GIR_Done,
     /* 109406 */ // Label 1748: @109406
     /* 109406 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(109432), // Rule ID 6882 //
     /* 109411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109425 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /* 109425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109430 */   GIR_RootConstrainSelectedInstOperands,
     /* 109431 */   // GIR_Coverage, 6882,
     /* 109431 */   GIR_Done,
     /* 109432 */ // Label 1749: @109432
     /* 109432 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(109458), // Rule ID 6883 //
     /* 109437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109451 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /* 109451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109456 */   GIR_RootConstrainSelectedInstOperands,
     /* 109457 */   // GIR_Coverage, 6883,
     /* 109457 */   GIR_Done,
     /* 109458 */ // Label 1750: @109458
     /* 109458 */ GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(109487), // Rule ID 6884 //
     /* 109463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109474 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 109474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109477 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109479 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109481 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109486 */   // GIR_Coverage, 6884,
     /* 109486 */   GIR_EraseRootFromParent_Done,
     /* 109487 */ // Label 1751: @109487
     /* 109487 */ GIM_Reject,
     /* 109488 */ // Label 1606: @109488
     /* 109488 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(109518), // Rule ID 6696 //
     /* 109493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109507 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 109507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109512 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109517 */   // GIR_Coverage, 6696,
     /* 109517 */   GIR_Done,
     /* 109518 */ // Label 1752: @109518
     /* 109518 */ GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(109548), // Rule ID 6698 //
     /* 109523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109537 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 109537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109542 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109547 */   // GIR_Coverage, 6698,
     /* 109547 */   GIR_Done,
     /* 109548 */ // Label 1753: @109548
     /* 109548 */ GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(109598), // Rule ID 6707 //
     /* 109553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109567 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 109567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109579 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 109583 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 109591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109593 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109596 */   GIR_RootConstrainSelectedInstOperands,
     /* 109597 */   // GIR_Coverage, 6707,
     /* 109597 */   GIR_EraseRootFromParent_Done,
     /* 109598 */ // Label 1754: @109598
     /* 109598 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(109648), // Rule ID 6709 //
     /* 109603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109617 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 109617 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109620 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109624 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109629 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 109633 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 109641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109643 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109646 */   GIR_RootConstrainSelectedInstOperands,
     /* 109647 */   // GIR_Coverage, 6709,
     /* 109647 */   GIR_EraseRootFromParent_Done,
     /* 109648 */ // Label 1755: @109648
     /* 109648 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(109680), // Rule ID 6755 //
     /* 109653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109667 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109670 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109672 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109674 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109679 */   // GIR_Coverage, 6755,
     /* 109679 */   GIR_EraseRootFromParent_Done,
     /* 109680 */ // Label 1756: @109680
     /* 109680 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(109712), // Rule ID 6756 //
     /* 109685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109699 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109702 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109704 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109706 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109711 */   // GIR_Coverage, 6756,
     /* 109711 */   GIR_EraseRootFromParent_Done,
     /* 109712 */ // Label 1757: @109712
     /* 109712 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(109744), // Rule ID 6757 //
     /* 109717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 109723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109731 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109734 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109736 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109738 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109743 */   // GIR_Coverage, 6757,
     /* 109743 */   GIR_EraseRootFromParent_Done,
     /* 109744 */ // Label 1758: @109744
     /* 109744 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(109776), // Rule ID 6758 //
     /* 109749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109763 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109766 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109768 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109770 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109775 */   // GIR_Coverage, 6758,
     /* 109775 */   GIR_EraseRootFromParent_Done,
     /* 109776 */ // Label 1759: @109776
     /* 109776 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(109808), // Rule ID 6759 //
     /* 109781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109795 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109798 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109800 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109802 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109807 */   // GIR_Coverage, 6759,
     /* 109807 */   GIR_EraseRootFromParent_Done,
     /* 109808 */ // Label 1760: @109808
     /* 109808 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(109840), // Rule ID 6760 //
     /* 109813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109827 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 109827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109830 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109832 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109834 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109839 */   // GIR_Coverage, 6760,
     /* 109839 */   GIR_EraseRootFromParent_Done,
     /* 109840 */ // Label 1761: @109840
     /* 109840 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(109866), // Rule ID 6761 //
     /* 109845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109859 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /* 109859 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 109864 */   GIR_RootConstrainSelectedInstOperands,
     /* 109865 */   // GIR_Coverage, 6761,
     /* 109865 */   GIR_Done,
     /* 109866 */ // Label 1762: @109866
     /* 109866 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(109892), // Rule ID 6762 //
     /* 109871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109885 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /* 109885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 109890 */   GIR_RootConstrainSelectedInstOperands,
     /* 109891 */   // GIR_Coverage, 6762,
     /* 109891 */   GIR_Done,
     /* 109892 */ // Label 1763: @109892
     /* 109892 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(109918), // Rule ID 6763 //
     /* 109897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 109903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109911 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /* 109911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 109916 */   GIR_RootConstrainSelectedInstOperands,
     /* 109917 */   // GIR_Coverage, 6763,
     /* 109917 */   GIR_Done,
     /* 109918 */ // Label 1764: @109918
     /* 109918 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(109944), // Rule ID 6764 //
     /* 109923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109937 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /* 109937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 109942 */   GIR_RootConstrainSelectedInstOperands,
     /* 109943 */   // GIR_Coverage, 6764,
     /* 109943 */   GIR_Done,
     /* 109944 */ // Label 1765: @109944
     /* 109944 */ GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(109970), // Rule ID 6765 //
     /* 109949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109963 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /* 109963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 109968 */   GIR_RootConstrainSelectedInstOperands,
     /* 109969 */   // GIR_Coverage, 6765,
     /* 109969 */   GIR_Done,
     /* 109970 */ // Label 1766: @109970
     /* 109970 */ GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(109996), // Rule ID 6766 //
     /* 109975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109989 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /* 109989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 109994 */   GIR_RootConstrainSelectedInstOperands,
     /* 109995 */   // GIR_Coverage, 6766,
     /* 109995 */   GIR_Done,
     /* 109996 */ // Label 1767: @109996
     /* 109996 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(110025), // Rule ID 6767 //
     /* 110001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110012 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 110012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110015 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110017 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110019 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110024 */   // GIR_Coverage, 6767,
     /* 110024 */   GIR_EraseRootFromParent_Done,
     /* 110025 */ // Label 1768: @110025
     /* 110025 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(110057), // Rule ID 6768 //
     /* 110030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110044 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110047 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110049 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110056 */   // GIR_Coverage, 6768,
     /* 110056 */   GIR_EraseRootFromParent_Done,
     /* 110057 */ // Label 1769: @110057
     /* 110057 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(110089), // Rule ID 6769 //
     /* 110062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110076 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110079 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110081 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110083 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110088 */   // GIR_Coverage, 6769,
     /* 110088 */   GIR_EraseRootFromParent_Done,
     /* 110089 */ // Label 1770: @110089
     /* 110089 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(110121), // Rule ID 6770 //
     /* 110094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110108 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110111 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110113 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110115 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110120 */   // GIR_Coverage, 6770,
     /* 110120 */   GIR_EraseRootFromParent_Done,
     /* 110121 */ // Label 1771: @110121
     /* 110121 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(110153), // Rule ID 6771 //
     /* 110126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110140 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110143 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110145 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110147 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110152 */   // GIR_Coverage, 6771,
     /* 110152 */   GIR_EraseRootFromParent_Done,
     /* 110153 */ // Label 1772: @110153
     /* 110153 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(110185), // Rule ID 6772 //
     /* 110158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110172 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110175 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110177 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110179 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110184 */   // GIR_Coverage, 6772,
     /* 110184 */   GIR_EraseRootFromParent_Done,
     /* 110185 */ // Label 1773: @110185
     /* 110185 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(110217), // Rule ID 6773 //
     /* 110190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110204 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110207 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110209 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110211 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110216 */   // GIR_Coverage, 6773,
     /* 110216 */   GIR_EraseRootFromParent_Done,
     /* 110217 */ // Label 1774: @110217
     /* 110217 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(110243), // Rule ID 6774 //
     /* 110222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110236 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /* 110236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110241 */   GIR_RootConstrainSelectedInstOperands,
     /* 110242 */   // GIR_Coverage, 6774,
     /* 110242 */   GIR_Done,
     /* 110243 */ // Label 1775: @110243
     /* 110243 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(110269), // Rule ID 6775 //
     /* 110248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110262 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /* 110262 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110267 */   GIR_RootConstrainSelectedInstOperands,
     /* 110268 */   // GIR_Coverage, 6775,
     /* 110268 */   GIR_Done,
     /* 110269 */ // Label 1776: @110269
     /* 110269 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(110295), // Rule ID 6776 //
     /* 110274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110288 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /* 110288 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 110293 */   GIR_RootConstrainSelectedInstOperands,
     /* 110294 */   // GIR_Coverage, 6776,
     /* 110294 */   GIR_Done,
     /* 110295 */ // Label 1777: @110295
     /* 110295 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(110321), // Rule ID 6777 //
     /* 110300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110314 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /* 110314 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110319 */   GIR_RootConstrainSelectedInstOperands,
     /* 110320 */   // GIR_Coverage, 6777,
     /* 110320 */   GIR_Done,
     /* 110321 */ // Label 1778: @110321
     /* 110321 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(110347), // Rule ID 6778 //
     /* 110326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110340 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /* 110340 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110345 */   GIR_RootConstrainSelectedInstOperands,
     /* 110346 */   // GIR_Coverage, 6778,
     /* 110346 */   GIR_Done,
     /* 110347 */ // Label 1779: @110347
     /* 110347 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(110373), // Rule ID 6779 //
     /* 110352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110366 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /* 110366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 110371 */   GIR_RootConstrainSelectedInstOperands,
     /* 110372 */   // GIR_Coverage, 6779,
     /* 110372 */   GIR_Done,
     /* 110373 */ // Label 1780: @110373
     /* 110373 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(110402), // Rule ID 6780 //
     /* 110378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110389 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 110389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110392 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110394 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110401 */   // GIR_Coverage, 6780,
     /* 110401 */   GIR_EraseRootFromParent_Done,
     /* 110402 */ // Label 1781: @110402
     /* 110402 */ GIM_Reject,
     /* 110403 */ // Label 1607: @110403
     /* 110403 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(110435), // Rule ID 6859 //
     /* 110408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110422 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110425 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110434 */   // GIR_Coverage, 6859,
     /* 110434 */   GIR_EraseRootFromParent_Done,
     /* 110435 */ // Label 1782: @110435
     /* 110435 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(110467), // Rule ID 6860 //
     /* 110440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110454 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110457 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110459 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110461 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110466 */   // GIR_Coverage, 6860,
     /* 110466 */   GIR_EraseRootFromParent_Done,
     /* 110467 */ // Label 1783: @110467
     /* 110467 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(110499), // Rule ID 6861 //
     /* 110472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110486 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110489 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110491 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110493 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110498 */   // GIR_Coverage, 6861,
     /* 110498 */   GIR_EraseRootFromParent_Done,
     /* 110499 */ // Label 1784: @110499
     /* 110499 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(110531), // Rule ID 6862 //
     /* 110504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110518 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110521 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110523 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110525 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110530 */   // GIR_Coverage, 6862,
     /* 110530 */   GIR_EraseRootFromParent_Done,
     /* 110531 */ // Label 1785: @110531
     /* 110531 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(110563), // Rule ID 6863 //
     /* 110536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110550 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110553 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110555 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110557 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110562 */   // GIR_Coverage, 6863,
     /* 110562 */   GIR_EraseRootFromParent_Done,
     /* 110563 */ // Label 1786: @110563
     /* 110563 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(110595), // Rule ID 6864 //
     /* 110568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110582 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110585 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110587 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110589 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110594 */   // GIR_Coverage, 6864,
     /* 110594 */   GIR_EraseRootFromParent_Done,
     /* 110595 */ // Label 1787: @110595
     /* 110595 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(110666), // Rule ID 6865 //
     /* 110600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110614 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 110614 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 110617 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110621 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110626 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 110635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110644 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110648 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 110653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 110655 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110658 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 110661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 110664 */   GIR_RootConstrainSelectedInstOperands,
     /* 110665 */   // GIR_Coverage, 6865,
     /* 110665 */   GIR_EraseRootFromParent_Done,
     /* 110666 */ // Label 1788: @110666
     /* 110666 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(110692), // Rule ID 6866 //
     /* 110671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110685 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /* 110685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 110690 */   GIR_RootConstrainSelectedInstOperands,
     /* 110691 */   // GIR_Coverage, 6866,
     /* 110691 */   GIR_Done,
     /* 110692 */ // Label 1789: @110692
     /* 110692 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(110718), // Rule ID 6867 //
     /* 110697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110711 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /* 110711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 110716 */   GIR_RootConstrainSelectedInstOperands,
     /* 110717 */   // GIR_Coverage, 6867,
     /* 110717 */   GIR_Done,
     /* 110718 */ // Label 1790: @110718
     /* 110718 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(110744), // Rule ID 6868 //
     /* 110723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110737 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /* 110737 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 110742 */   GIR_RootConstrainSelectedInstOperands,
     /* 110743 */   // GIR_Coverage, 6868,
     /* 110743 */   GIR_Done,
     /* 110744 */ // Label 1791: @110744
     /* 110744 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(110770), // Rule ID 6869 //
     /* 110749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110763 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /* 110763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110768 */   GIR_RootConstrainSelectedInstOperands,
     /* 110769 */   // GIR_Coverage, 6869,
     /* 110769 */   GIR_Done,
     /* 110770 */ // Label 1792: @110770
     /* 110770 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(110796), // Rule ID 6870 //
     /* 110775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110789 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /* 110789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110794 */   GIR_RootConstrainSelectedInstOperands,
     /* 110795 */   // GIR_Coverage, 6870,
     /* 110795 */   GIR_Done,
     /* 110796 */ // Label 1793: @110796
     /* 110796 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(110825), // Rule ID 6871 //
     /* 110801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110812 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 110812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110815 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110819 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110824 */   // GIR_Coverage, 6871,
     /* 110824 */   GIR_EraseRootFromParent_Done,
     /* 110825 */ // Label 1794: @110825
     /* 110825 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(110857), // Rule ID 6885 //
     /* 110830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110844 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 110844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110847 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110849 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110856 */   // GIR_Coverage, 6885,
     /* 110856 */   GIR_EraseRootFromParent_Done,
     /* 110857 */ // Label 1795: @110857
     /* 110857 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(110889), // Rule ID 6886 //
     /* 110862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110876 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 110876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110879 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110881 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110883 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110888 */   // GIR_Coverage, 6886,
     /* 110888 */   GIR_EraseRootFromParent_Done,
     /* 110889 */ // Label 1796: @110889
     /* 110889 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(110921), // Rule ID 6887 //
     /* 110894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110908 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 110908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110911 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110913 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110915 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110920 */   // GIR_Coverage, 6887,
     /* 110920 */   GIR_EraseRootFromParent_Done,
     /* 110921 */ // Label 1797: @110921
     /* 110921 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(110953), // Rule ID 6888 //
     /* 110926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110940 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 110940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110943 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110952 */   // GIR_Coverage, 6888,
     /* 110952 */   GIR_EraseRootFromParent_Done,
     /* 110953 */ // Label 1798: @110953
     /* 110953 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(110985), // Rule ID 6889 //
     /* 110958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110972 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 110972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110975 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110977 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110979 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110984 */   // GIR_Coverage, 6889,
     /* 110984 */   GIR_EraseRootFromParent_Done,
     /* 110985 */ // Label 1799: @110985
     /* 110985 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(111017), // Rule ID 6890 //
     /* 110990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111004 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111007 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111009 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111016 */   // GIR_Coverage, 6890,
     /* 111016 */   GIR_EraseRootFromParent_Done,
     /* 111017 */ // Label 1800: @111017
     /* 111017 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(111088), // Rule ID 6891 //
     /* 111022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 111028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111036 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 111036 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 111039 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111043 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111048 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 111052 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111054 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 111057 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111061 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111066 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 111070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 111075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111080 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 111083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 111086 */   GIR_RootConstrainSelectedInstOperands,
     /* 111087 */   // GIR_Coverage, 6891,
     /* 111087 */   GIR_EraseRootFromParent_Done,
     /* 111088 */ // Label 1801: @111088
     /* 111088 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(111114), // Rule ID 6892 //
     /* 111093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111107 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /* 111107 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111112 */   GIR_RootConstrainSelectedInstOperands,
     /* 111113 */   // GIR_Coverage, 6892,
     /* 111113 */   GIR_Done,
     /* 111114 */ // Label 1802: @111114
     /* 111114 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(111140), // Rule ID 6893 //
     /* 111119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111133 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /* 111133 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 111138 */   GIR_RootConstrainSelectedInstOperands,
     /* 111139 */   // GIR_Coverage, 6893,
     /* 111139 */   GIR_Done,
     /* 111140 */ // Label 1803: @111140
     /* 111140 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(111166), // Rule ID 6894 //
     /* 111145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111159 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /* 111159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 111164 */   GIR_RootConstrainSelectedInstOperands,
     /* 111165 */   // GIR_Coverage, 6894,
     /* 111165 */   GIR_Done,
     /* 111166 */ // Label 1804: @111166
     /* 111166 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(111192), // Rule ID 6895 //
     /* 111171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111185 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /* 111185 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111190 */   GIR_RootConstrainSelectedInstOperands,
     /* 111191 */   // GIR_Coverage, 6895,
     /* 111191 */   GIR_Done,
     /* 111192 */ // Label 1805: @111192
     /* 111192 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(111218), // Rule ID 6896 //
     /* 111197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111211 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /* 111211 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 111216 */   GIR_RootConstrainSelectedInstOperands,
     /* 111217 */   // GIR_Coverage, 6896,
     /* 111217 */   GIR_Done,
     /* 111218 */ // Label 1806: @111218
     /* 111218 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(111247), // Rule ID 6897 //
     /* 111223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111234 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 111234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111237 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111239 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111241 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111246 */   // GIR_Coverage, 6897,
     /* 111246 */   GIR_EraseRootFromParent_Done,
     /* 111247 */ // Label 1807: @111247
     /* 111247 */ GIM_Reject,
     /* 111248 */ // Label 1608: @111248
     /* 111248 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(111322), // Rule ID 5704 //
     /* 111253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111260 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111264 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 111268 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111272 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111277 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111279 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /* 111279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /* 111286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111291 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 111295 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111305 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 111311 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111316 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 111321 */   // GIR_Coverage, 5704,
     /* 111321 */   GIR_EraseRootFromParent_Done,
     /* 111322 */ // Label 1808: @111322
     /* 111322 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(111352), // Rule ID 6695 //
     /* 111327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111341 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 111341 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111346 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111351 */   // GIR_Coverage, 6695,
     /* 111351 */   GIR_Done,
     /* 111352 */ // Label 1809: @111352
     /* 111352 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(111402), // Rule ID 6706 //
     /* 111357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111371 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 111371 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111374 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111378 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111383 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 111387 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 111395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111397 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111400 */   GIR_RootConstrainSelectedInstOperands,
     /* 111401 */   // GIR_Coverage, 6706,
     /* 111401 */   GIR_EraseRootFromParent_Done,
     /* 111402 */ // Label 1810: @111402
     /* 111402 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(111434), // Rule ID 6781 //
     /* 111407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111421 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111424 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111426 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111433 */   // GIR_Coverage, 6781,
     /* 111433 */   GIR_EraseRootFromParent_Done,
     /* 111434 */ // Label 1811: @111434
     /* 111434 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(111466), // Rule ID 6782 //
     /* 111439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111453 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111456 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111458 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111460 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111465 */   // GIR_Coverage, 6782,
     /* 111465 */   GIR_EraseRootFromParent_Done,
     /* 111466 */ // Label 1812: @111466
     /* 111466 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(111498), // Rule ID 6783 //
     /* 111471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111485 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111488 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111490 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111492 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111497 */   // GIR_Coverage, 6783,
     /* 111497 */   GIR_EraseRootFromParent_Done,
     /* 111498 */ // Label 1813: @111498
     /* 111498 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(111530), // Rule ID 6784 //
     /* 111503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111517 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111520 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111522 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111524 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111529 */   // GIR_Coverage, 6784,
     /* 111529 */   GIR_EraseRootFromParent_Done,
     /* 111530 */ // Label 1814: @111530
     /* 111530 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(111562), // Rule ID 6785 //
     /* 111535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111549 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111552 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111554 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111556 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111561 */   // GIR_Coverage, 6785,
     /* 111561 */   GIR_EraseRootFromParent_Done,
     /* 111562 */ // Label 1815: @111562
     /* 111562 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(111594), // Rule ID 6786 //
     /* 111567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111581 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111584 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111586 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111588 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111593 */   // GIR_Coverage, 6786,
     /* 111593 */   GIR_EraseRootFromParent_Done,
     /* 111594 */ // Label 1816: @111594
     /* 111594 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(111626), // Rule ID 6787 //
     /* 111599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111613 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 111613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111616 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111618 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111620 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111625 */   // GIR_Coverage, 6787,
     /* 111625 */   GIR_EraseRootFromParent_Done,
     /* 111626 */ // Label 1817: @111626
     /* 111626 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(111652), // Rule ID 6788 //
     /* 111631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111645 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /* 111645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 111650 */   GIR_RootConstrainSelectedInstOperands,
     /* 111651 */   // GIR_Coverage, 6788,
     /* 111651 */   GIR_Done,
     /* 111652 */ // Label 1818: @111652
     /* 111652 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(111678), // Rule ID 6789 //
     /* 111657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111671 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /* 111671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 111676 */   GIR_RootConstrainSelectedInstOperands,
     /* 111677 */   // GIR_Coverage, 6789,
     /* 111677 */   GIR_Done,
     /* 111678 */ // Label 1819: @111678
     /* 111678 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(111704), // Rule ID 6790 //
     /* 111683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111697 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /* 111697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 111702 */   GIR_RootConstrainSelectedInstOperands,
     /* 111703 */   // GIR_Coverage, 6790,
     /* 111703 */   GIR_Done,
     /* 111704 */ // Label 1820: @111704
     /* 111704 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(111730), // Rule ID 6791 //
     /* 111709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111723 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /* 111723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 111728 */   GIR_RootConstrainSelectedInstOperands,
     /* 111729 */   // GIR_Coverage, 6791,
     /* 111729 */   GIR_Done,
     /* 111730 */ // Label 1821: @111730
     /* 111730 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(111756), // Rule ID 6792 //
     /* 111735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111749 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /* 111749 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 111754 */   GIR_RootConstrainSelectedInstOperands,
     /* 111755 */   // GIR_Coverage, 6792,
     /* 111755 */   GIR_Done,
     /* 111756 */ // Label 1822: @111756
     /* 111756 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(111782), // Rule ID 6793 //
     /* 111761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111775 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /* 111775 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 111780 */   GIR_RootConstrainSelectedInstOperands,
     /* 111781 */   // GIR_Coverage, 6793,
     /* 111781 */   GIR_Done,
     /* 111782 */ // Label 1823: @111782
     /* 111782 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(111808), // Rule ID 6794 //
     /* 111787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111801 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /* 111801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 111806 */   GIR_RootConstrainSelectedInstOperands,
     /* 111807 */   // GIR_Coverage, 6794,
     /* 111807 */   GIR_Done,
     /* 111808 */ // Label 1824: @111808
     /* 111808 */ GIM_Reject,
     /* 111809 */ // Label 1609: @111809
     /* 111809 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(111841), // Rule ID 6898 //
     /* 111814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 111820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111828 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 111828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111831 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111833 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111840 */   // GIR_Coverage, 6898,
     /* 111840 */   GIR_EraseRootFromParent_Done,
     /* 111841 */ // Label 1825: @111841
     /* 111841 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(111873), // Rule ID 6899 //
     /* 111846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111860 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 111860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111863 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111865 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111867 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111872 */   // GIR_Coverage, 6899,
     /* 111872 */   GIR_EraseRootFromParent_Done,
     /* 111873 */ // Label 1826: @111873
     /* 111873 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(111905), // Rule ID 6900 //
     /* 111878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111892 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 111892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111895 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111897 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111899 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111904 */   // GIR_Coverage, 6900,
     /* 111904 */   GIR_EraseRootFromParent_Done,
     /* 111905 */ // Label 1827: @111905
     /* 111905 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(111937), // Rule ID 6901 //
     /* 111910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 111916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111924 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 111924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111927 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111929 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111931 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111936 */   // GIR_Coverage, 6901,
     /* 111936 */   GIR_EraseRootFromParent_Done,
     /* 111937 */ // Label 1828: @111937
     /* 111937 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(111969), // Rule ID 6902 //
     /* 111942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111956 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 111956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111959 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111961 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111968 */   // GIR_Coverage, 6902,
     /* 111968 */   GIR_EraseRootFromParent_Done,
     /* 111969 */ // Label 1829: @111969
     /* 111969 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(112001), // Rule ID 6903 //
     /* 111974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111988 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 111988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111991 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112000 */   // GIR_Coverage, 6903,
     /* 112000 */   GIR_EraseRootFromParent_Done,
     /* 112001 */ // Label 1830: @112001
     /* 112001 */ GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(112072), // Rule ID 6904 //
     /* 112006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112020 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 112020 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 112023 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112027 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112032 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112038 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112041 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112045 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112050 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 112059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112061 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112064 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 112070 */   GIR_RootConstrainSelectedInstOperands,
     /* 112071 */   // GIR_Coverage, 6904,
     /* 112071 */   GIR_EraseRootFromParent_Done,
     /* 112072 */ // Label 1831: @112072
     /* 112072 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(112098), // Rule ID 6905 //
     /* 112077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112091 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /* 112091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112096 */   GIR_RootConstrainSelectedInstOperands,
     /* 112097 */   // GIR_Coverage, 6905,
     /* 112097 */   GIR_Done,
     /* 112098 */ // Label 1832: @112098
     /* 112098 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(112124), // Rule ID 6906 //
     /* 112103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112117 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /* 112117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112122 */   GIR_RootConstrainSelectedInstOperands,
     /* 112123 */   // GIR_Coverage, 6906,
     /* 112123 */   GIR_Done,
     /* 112124 */ // Label 1833: @112124
     /* 112124 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(112150), // Rule ID 6907 //
     /* 112129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112143 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /* 112143 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 112148 */   GIR_RootConstrainSelectedInstOperands,
     /* 112149 */   // GIR_Coverage, 6907,
     /* 112149 */   GIR_Done,
     /* 112150 */ // Label 1834: @112150
     /* 112150 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(112176), // Rule ID 6908 //
     /* 112155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112169 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /* 112169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112174 */   GIR_RootConstrainSelectedInstOperands,
     /* 112175 */   // GIR_Coverage, 6908,
     /* 112175 */   GIR_Done,
     /* 112176 */ // Label 1835: @112176
     /* 112176 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(112202), // Rule ID 6909 //
     /* 112181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112195 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /* 112195 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112200 */   GIR_RootConstrainSelectedInstOperands,
     /* 112201 */   // GIR_Coverage, 6909,
     /* 112201 */   GIR_Done,
     /* 112202 */ // Label 1836: @112202
     /* 112202 */ GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(112231), // Rule ID 6910 //
     /* 112207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112218 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 112218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112221 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112223 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112230 */   // GIR_Coverage, 6910,
     /* 112230 */   GIR_EraseRootFromParent_Done,
     /* 112231 */ // Label 1837: @112231
     /* 112231 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(112263), // Rule ID 6911 //
     /* 112236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112250 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112253 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112255 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112257 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112262 */   // GIR_Coverage, 6911,
     /* 112262 */   GIR_EraseRootFromParent_Done,
     /* 112263 */ // Label 1838: @112263
     /* 112263 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(112295), // Rule ID 6912 //
     /* 112268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112282 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112285 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112287 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112289 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112294 */   // GIR_Coverage, 6912,
     /* 112294 */   GIR_EraseRootFromParent_Done,
     /* 112295 */ // Label 1839: @112295
     /* 112295 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(112327), // Rule ID 6913 //
     /* 112300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112314 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112317 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112319 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112321 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112326 */   // GIR_Coverage, 6913,
     /* 112326 */   GIR_EraseRootFromParent_Done,
     /* 112327 */ // Label 1840: @112327
     /* 112327 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(112359), // Rule ID 6914 //
     /* 112332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112346 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112349 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112351 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112353 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112358 */   // GIR_Coverage, 6914,
     /* 112358 */   GIR_EraseRootFromParent_Done,
     /* 112359 */ // Label 1841: @112359
     /* 112359 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(112391), // Rule ID 6915 //
     /* 112364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112378 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112381 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112383 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112385 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112390 */   // GIR_Coverage, 6915,
     /* 112390 */   GIR_EraseRootFromParent_Done,
     /* 112391 */ // Label 1842: @112391
     /* 112391 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(112423), // Rule ID 6916 //
     /* 112396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112410 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112413 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112415 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112417 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112422 */   // GIR_Coverage, 6916,
     /* 112422 */   GIR_EraseRootFromParent_Done,
     /* 112423 */ // Label 1843: @112423
     /* 112423 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(112494), // Rule ID 6917 //
     /* 112428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112442 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 112442 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 112445 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112449 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112454 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112460 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112463 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112467 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112472 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 112481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112486 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 112492 */   GIR_RootConstrainSelectedInstOperands,
     /* 112493 */   // GIR_Coverage, 6917,
     /* 112493 */   GIR_EraseRootFromParent_Done,
     /* 112494 */ // Label 1844: @112494
     /* 112494 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(112520), // Rule ID 6918 //
     /* 112499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112513 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /* 112513 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112518 */   GIR_RootConstrainSelectedInstOperands,
     /* 112519 */   // GIR_Coverage, 6918,
     /* 112519 */   GIR_Done,
     /* 112520 */ // Label 1845: @112520
     /* 112520 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(112546), // Rule ID 6919 //
     /* 112525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112539 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /* 112539 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112544 */   GIR_RootConstrainSelectedInstOperands,
     /* 112545 */   // GIR_Coverage, 6919,
     /* 112545 */   GIR_Done,
     /* 112546 */ // Label 1846: @112546
     /* 112546 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(112572), // Rule ID 6920 //
     /* 112551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112565 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /* 112565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 112570 */   GIR_RootConstrainSelectedInstOperands,
     /* 112571 */   // GIR_Coverage, 6920,
     /* 112571 */   GIR_Done,
     /* 112572 */ // Label 1847: @112572
     /* 112572 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(112598), // Rule ID 6921 //
     /* 112577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112591 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /* 112591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 112596 */   GIR_RootConstrainSelectedInstOperands,
     /* 112597 */   // GIR_Coverage, 6921,
     /* 112597 */   GIR_Done,
     /* 112598 */ // Label 1848: @112598
     /* 112598 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(112624), // Rule ID 6922 //
     /* 112603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112617 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /* 112617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112622 */   GIR_RootConstrainSelectedInstOperands,
     /* 112623 */   // GIR_Coverage, 6922,
     /* 112623 */   GIR_Done,
     /* 112624 */ // Label 1849: @112624
     /* 112624 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(112653), // Rule ID 6923 //
     /* 112629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112640 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 112640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112643 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112652 */   // GIR_Coverage, 6923,
     /* 112652 */   GIR_EraseRootFromParent_Done,
     /* 112653 */ // Label 1850: @112653
     /* 112653 */ GIM_Reject,
     /* 112654 */ // Label 1610: @112654
     /* 112654 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(112686), // Rule ID 6924 //
     /* 112659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112673 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112676 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112678 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112680 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112685 */   // GIR_Coverage, 6924,
     /* 112685 */   GIR_EraseRootFromParent_Done,
     /* 112686 */ // Label 1851: @112686
     /* 112686 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(112718), // Rule ID 6925 //
     /* 112691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112705 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112708 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112710 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112712 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112717 */   // GIR_Coverage, 6925,
     /* 112717 */   GIR_EraseRootFromParent_Done,
     /* 112718 */ // Label 1852: @112718
     /* 112718 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(112750), // Rule ID 6926 //
     /* 112723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112737 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112740 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112742 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112744 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112749 */   // GIR_Coverage, 6926,
     /* 112749 */   GIR_EraseRootFromParent_Done,
     /* 112750 */ // Label 1853: @112750
     /* 112750 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(112782), // Rule ID 6927 //
     /* 112755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112769 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112772 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112774 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112776 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112781 */   // GIR_Coverage, 6927,
     /* 112781 */   GIR_EraseRootFromParent_Done,
     /* 112782 */ // Label 1854: @112782
     /* 112782 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(112814), // Rule ID 6928 //
     /* 112787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112801 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112804 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112806 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112808 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112813 */   // GIR_Coverage, 6928,
     /* 112813 */   GIR_EraseRootFromParent_Done,
     /* 112814 */ // Label 1855: @112814
     /* 112814 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(112846), // Rule ID 6929 //
     /* 112819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112833 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112836 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112838 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112840 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112845 */   // GIR_Coverage, 6929,
     /* 112845 */   GIR_EraseRootFromParent_Done,
     /* 112846 */ // Label 1856: @112846
     /* 112846 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(112878), // Rule ID 6930 //
     /* 112851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112865 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 112865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112868 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112870 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112872 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112877 */   // GIR_Coverage, 6930,
     /* 112877 */   GIR_EraseRootFromParent_Done,
     /* 112878 */ // Label 1857: @112878
     /* 112878 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(112949), // Rule ID 6931 //
     /* 112883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112897 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 112897 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 112900 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 112904 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112909 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 112922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112927 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 112936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 112947 */   GIR_RootConstrainSelectedInstOperands,
     /* 112948 */   // GIR_Coverage, 6931,
     /* 112948 */   GIR_EraseRootFromParent_Done,
     /* 112949 */ // Label 1858: @112949
     /* 112949 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(112975), // Rule ID 6932 //
     /* 112954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112968 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /* 112968 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 112973 */   GIR_RootConstrainSelectedInstOperands,
     /* 112974 */   // GIR_Coverage, 6932,
     /* 112974 */   GIR_Done,
     /* 112975 */ // Label 1859: @112975
     /* 112975 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(113001), // Rule ID 6933 //
     /* 112980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112994 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /* 112994 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 112999 */   GIR_RootConstrainSelectedInstOperands,
     /* 113000 */   // GIR_Coverage, 6933,
     /* 113000 */   GIR_Done,
     /* 113001 */ // Label 1860: @113001
     /* 113001 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(113027), // Rule ID 6934 //
     /* 113006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113020 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /* 113020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 113025 */   GIR_RootConstrainSelectedInstOperands,
     /* 113026 */   // GIR_Coverage, 6934,
     /* 113026 */   GIR_Done,
     /* 113027 */ // Label 1861: @113027
     /* 113027 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(113053), // Rule ID 6935 //
     /* 113032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113046 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /* 113046 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 113051 */   GIR_RootConstrainSelectedInstOperands,
     /* 113052 */   // GIR_Coverage, 6935,
     /* 113052 */   GIR_Done,
     /* 113053 */ // Label 1862: @113053
     /* 113053 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(113079), // Rule ID 6936 //
     /* 113058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113072 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /* 113072 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 113077 */   GIR_RootConstrainSelectedInstOperands,
     /* 113078 */   // GIR_Coverage, 6936,
     /* 113078 */   GIR_Done,
     /* 113079 */ // Label 1863: @113079
     /* 113079 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(113105), // Rule ID 6937 //
     /* 113084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113098 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /* 113098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 113103 */   GIR_RootConstrainSelectedInstOperands,
     /* 113104 */   // GIR_Coverage, 6937,
     /* 113104 */   GIR_Done,
     /* 113105 */ // Label 1864: @113105
     /* 113105 */ GIM_Reject,
     /* 113106 */ // Label 1611: @113106
     /* 113106 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(113138), // Rule ID 10638 //
     /* 113111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 113117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113125 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113128 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113130 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113132 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113137 */   // GIR_Coverage, 10638,
     /* 113137 */   GIR_EraseRootFromParent_Done,
     /* 113138 */ // Label 1865: @113138
     /* 113138 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(113170), // Rule ID 10639 //
     /* 113143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113157 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113160 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113162 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113164 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113169 */   // GIR_Coverage, 10639,
     /* 113169 */   GIR_EraseRootFromParent_Done,
     /* 113170 */ // Label 1866: @113170
     /* 113170 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(113202), // Rule ID 10640 //
     /* 113175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113189 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113192 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113194 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113196 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113201 */   // GIR_Coverage, 10640,
     /* 113201 */   GIR_EraseRootFromParent_Done,
     /* 113202 */ // Label 1867: @113202
     /* 113202 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(113234), // Rule ID 10641 //
     /* 113207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113221 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113224 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113226 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113228 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113233 */   // GIR_Coverage, 10641,
     /* 113233 */   GIR_EraseRootFromParent_Done,
     /* 113234 */ // Label 1868: @113234
     /* 113234 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(113266), // Rule ID 10642 //
     /* 113239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113253 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113256 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113258 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113260 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113265 */   // GIR_Coverage, 10642,
     /* 113265 */   GIR_EraseRootFromParent_Done,
     /* 113266 */ // Label 1869: @113266
     /* 113266 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(113298), // Rule ID 10643 //
     /* 113271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113285 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113288 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113292 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113297 */   // GIR_Coverage, 10643,
     /* 113297 */   GIR_EraseRootFromParent_Done,
     /* 113298 */ // Label 1870: @113298
     /* 113298 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(113330), // Rule ID 10656 //
     /* 113303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 113309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113317 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113320 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113322 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113324 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113329 */   // GIR_Coverage, 10656,
     /* 113329 */   GIR_EraseRootFromParent_Done,
     /* 113330 */ // Label 1871: @113330
     /* 113330 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(113362), // Rule ID 10657 //
     /* 113335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113349 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113352 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113354 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113356 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113361 */   // GIR_Coverage, 10657,
     /* 113361 */   GIR_EraseRootFromParent_Done,
     /* 113362 */ // Label 1872: @113362
     /* 113362 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(113394), // Rule ID 10658 //
     /* 113367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113381 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113384 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113386 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113388 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113393 */   // GIR_Coverage, 10658,
     /* 113393 */   GIR_EraseRootFromParent_Done,
     /* 113394 */ // Label 1873: @113394
     /* 113394 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(113426), // Rule ID 10659 //
     /* 113399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113413 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113416 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113418 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113420 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113425 */   // GIR_Coverage, 10659,
     /* 113425 */   GIR_EraseRootFromParent_Done,
     /* 113426 */ // Label 1874: @113426
     /* 113426 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(113458), // Rule ID 10660 //
     /* 113431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113445 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113448 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113450 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113452 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113457 */   // GIR_Coverage, 10660,
     /* 113457 */   GIR_EraseRootFromParent_Done,
     /* 113458 */ // Label 1875: @113458
     /* 113458 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(113490), // Rule ID 10661 //
     /* 113463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113477 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113480 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113482 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113484 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113489 */   // GIR_Coverage, 10661,
     /* 113489 */   GIR_EraseRootFromParent_Done,
     /* 113490 */ // Label 1876: @113490
     /* 113490 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(113522), // Rule ID 10666 //
     /* 113495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 113498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113509 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 113509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113512 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113521 */   // GIR_Coverage, 10666,
     /* 113521 */   GIR_EraseRootFromParent_Done,
     /* 113522 */ // Label 1877: @113522
     /* 113522 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(113554), // Rule ID 10667 //
     /* 113527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 113530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113541 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 113541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113544 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113546 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113548 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113553 */   // GIR_Coverage, 10667,
     /* 113553 */   GIR_EraseRootFromParent_Done,
     /* 113554 */ // Label 1878: @113554
     /* 113554 */ GIM_Reject,
     /* 113555 */ // Label 1612: @113555
     /* 113555 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(113587), // Rule ID 10632 //
     /* 113560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 113566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113574 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113577 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113579 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113581 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113586 */   // GIR_Coverage, 10632,
     /* 113586 */   GIR_EraseRootFromParent_Done,
     /* 113587 */ // Label 1879: @113587
     /* 113587 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(113619), // Rule ID 10633 //
     /* 113592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113606 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113609 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113611 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113613 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113618 */   // GIR_Coverage, 10633,
     /* 113618 */   GIR_EraseRootFromParent_Done,
     /* 113619 */ // Label 1880: @113619
     /* 113619 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(113651), // Rule ID 10634 //
     /* 113624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113638 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113641 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113643 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113645 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113650 */   // GIR_Coverage, 10634,
     /* 113650 */   GIR_EraseRootFromParent_Done,
     /* 113651 */ // Label 1881: @113651
     /* 113651 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(113683), // Rule ID 10635 //
     /* 113656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113670 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113673 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113675 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113682 */   // GIR_Coverage, 10635,
     /* 113682 */   GIR_EraseRootFromParent_Done,
     /* 113683 */ // Label 1882: @113683
     /* 113683 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(113715), // Rule ID 10636 //
     /* 113688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113702 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113705 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113707 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113714 */   // GIR_Coverage, 10636,
     /* 113714 */   GIR_EraseRootFromParent_Done,
     /* 113715 */ // Label 1883: @113715
     /* 113715 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(113747), // Rule ID 10637 //
     /* 113720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113734 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113737 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113739 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113741 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113746 */   // GIR_Coverage, 10637,
     /* 113746 */   GIR_EraseRootFromParent_Done,
     /* 113747 */ // Label 1884: @113747
     /* 113747 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(113779), // Rule ID 10650 //
     /* 113752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 113758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113766 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113769 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113771 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113773 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113778 */   // GIR_Coverage, 10650,
     /* 113778 */   GIR_EraseRootFromParent_Done,
     /* 113779 */ // Label 1885: @113779
     /* 113779 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(113811), // Rule ID 10651 //
     /* 113784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113798 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113801 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113803 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113805 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113810 */   // GIR_Coverage, 10651,
     /* 113810 */   GIR_EraseRootFromParent_Done,
     /* 113811 */ // Label 1886: @113811
     /* 113811 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(113843), // Rule ID 10652 //
     /* 113816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113830 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113833 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113835 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113837 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113842 */   // GIR_Coverage, 10652,
     /* 113842 */   GIR_EraseRootFromParent_Done,
     /* 113843 */ // Label 1887: @113843
     /* 113843 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(113875), // Rule ID 10653 //
     /* 113848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113862 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113865 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113867 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113869 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113874 */   // GIR_Coverage, 10653,
     /* 113874 */   GIR_EraseRootFromParent_Done,
     /* 113875 */ // Label 1888: @113875
     /* 113875 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(113907), // Rule ID 10654 //
     /* 113880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 113886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113894 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113897 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113899 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113901 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113906 */   // GIR_Coverage, 10654,
     /* 113906 */   GIR_EraseRootFromParent_Done,
     /* 113907 */ // Label 1889: @113907
     /* 113907 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(113939), // Rule ID 10655 //
     /* 113912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 113915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 113918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113926 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113929 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113931 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113933 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113938 */   // GIR_Coverage, 10655,
     /* 113938 */   GIR_EraseRootFromParent_Done,
     /* 113939 */ // Label 1890: @113939
     /* 113939 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(113971), // Rule ID 10664 //
     /* 113944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 113947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113958 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 113958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113961 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113963 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113965 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113970 */   // GIR_Coverage, 10664,
     /* 113970 */   GIR_EraseRootFromParent_Done,
     /* 113971 */ // Label 1891: @113971
     /* 113971 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(114003), // Rule ID 10665 //
     /* 113976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 113979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 113982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 113990 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 113990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113993 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113995 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114002 */   // GIR_Coverage, 10665,
     /* 114002 */   GIR_EraseRootFromParent_Done,
     /* 114003 */ // Label 1892: @114003
     /* 114003 */ GIM_Reject,
     /* 114004 */ // Label 1613: @114004
     /* 114004 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(114036), // Rule ID 10626 //
     /* 114009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 114015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114023 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114026 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114028 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114030 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114035 */   // GIR_Coverage, 10626,
     /* 114035 */   GIR_EraseRootFromParent_Done,
     /* 114036 */ // Label 1893: @114036
     /* 114036 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(114068), // Rule ID 10627 //
     /* 114041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114055 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114058 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114060 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114062 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114067 */   // GIR_Coverage, 10627,
     /* 114067 */   GIR_EraseRootFromParent_Done,
     /* 114068 */ // Label 1894: @114068
     /* 114068 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(114100), // Rule ID 10628 //
     /* 114073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114087 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114090 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114092 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114094 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114099 */   // GIR_Coverage, 10628,
     /* 114099 */   GIR_EraseRootFromParent_Done,
     /* 114100 */ // Label 1895: @114100
     /* 114100 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(114132), // Rule ID 10629 //
     /* 114105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114119 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114122 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114124 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114126 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114131 */   // GIR_Coverage, 10629,
     /* 114131 */   GIR_EraseRootFromParent_Done,
     /* 114132 */ // Label 1896: @114132
     /* 114132 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(114164), // Rule ID 10630 //
     /* 114137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114151 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114154 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114156 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114158 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114163 */   // GIR_Coverage, 10630,
     /* 114163 */   GIR_EraseRootFromParent_Done,
     /* 114164 */ // Label 1897: @114164
     /* 114164 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(114196), // Rule ID 10631 //
     /* 114169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114183 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114186 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114188 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114190 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114195 */   // GIR_Coverage, 10631,
     /* 114195 */   GIR_EraseRootFromParent_Done,
     /* 114196 */ // Label 1898: @114196
     /* 114196 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(114228), // Rule ID 10644 //
     /* 114201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 114207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114215 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114218 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114220 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114222 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114227 */   // GIR_Coverage, 10644,
     /* 114227 */   GIR_EraseRootFromParent_Done,
     /* 114228 */ // Label 1899: @114228
     /* 114228 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(114260), // Rule ID 10645 //
     /* 114233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114247 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114250 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114252 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114254 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114259 */   // GIR_Coverage, 10645,
     /* 114259 */   GIR_EraseRootFromParent_Done,
     /* 114260 */ // Label 1900: @114260
     /* 114260 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(114292), // Rule ID 10646 //
     /* 114265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114279 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114282 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114284 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114286 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114291 */   // GIR_Coverage, 10646,
     /* 114291 */   GIR_EraseRootFromParent_Done,
     /* 114292 */ // Label 1901: @114292
     /* 114292 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(114324), // Rule ID 10647 //
     /* 114297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114311 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114314 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114316 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114318 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114323 */   // GIR_Coverage, 10647,
     /* 114323 */   GIR_EraseRootFromParent_Done,
     /* 114324 */ // Label 1902: @114324
     /* 114324 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(114356), // Rule ID 10648 //
     /* 114329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114343 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114346 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114348 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114350 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114355 */   // GIR_Coverage, 10648,
     /* 114355 */   GIR_EraseRootFromParent_Done,
     /* 114356 */ // Label 1903: @114356
     /* 114356 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(114388), // Rule ID 10649 //
     /* 114361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114375 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114378 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114380 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114382 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114387 */   // GIR_Coverage, 10649,
     /* 114387 */   GIR_EraseRootFromParent_Done,
     /* 114388 */ // Label 1904: @114388
     /* 114388 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(114420), // Rule ID 10662 //
     /* 114393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 114396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114407 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 114407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114410 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114412 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114414 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114419 */   // GIR_Coverage, 10662,
     /* 114419 */   GIR_EraseRootFromParent_Done,
     /* 114420 */ // Label 1905: @114420
     /* 114420 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(114452), // Rule ID 10663 //
     /* 114425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 114428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114439 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 114439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114442 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114444 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114446 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114451 */   // GIR_Coverage, 10663,
     /* 114451 */   GIR_EraseRootFromParent_Done,
     /* 114452 */ // Label 1906: @114452
     /* 114452 */ GIM_Reject,
     /* 114453 */ // Label 1614: @114453
     /* 114453 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(114485), // Rule ID 10620 //
     /* 114458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114472 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114475 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114477 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114479 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114484 */   // GIR_Coverage, 10620,
     /* 114484 */   GIR_EraseRootFromParent_Done,
     /* 114485 */ // Label 1907: @114485
     /* 114485 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(114517), // Rule ID 10621 //
     /* 114490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114504 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114507 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114509 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114511 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114516 */   // GIR_Coverage, 10621,
     /* 114516 */   GIR_EraseRootFromParent_Done,
     /* 114517 */ // Label 1908: @114517
     /* 114517 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(114549), // Rule ID 10622 //
     /* 114522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114536 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114539 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114541 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114543 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114548 */   // GIR_Coverage, 10622,
     /* 114548 */   GIR_EraseRootFromParent_Done,
     /* 114549 */ // Label 1909: @114549
     /* 114549 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(114581), // Rule ID 10623 //
     /* 114554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114568 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114571 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114573 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114575 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114580 */   // GIR_Coverage, 10623,
     /* 114580 */   GIR_EraseRootFromParent_Done,
     /* 114581 */ // Label 1910: @114581
     /* 114581 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(114613), // Rule ID 10624 //
     /* 114586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114600 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114603 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114605 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114607 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114612 */   // GIR_Coverage, 10624,
     /* 114612 */   GIR_EraseRootFromParent_Done,
     /* 114613 */ // Label 1911: @114613
     /* 114613 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(114645), // Rule ID 10625 //
     /* 114618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114632 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 114632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114635 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114637 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114639 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114644 */   // GIR_Coverage, 10625,
     /* 114644 */   GIR_EraseRootFromParent_Done,
     /* 114645 */ // Label 1912: @114645
     /* 114645 */ GIM_Reject,
     /* 114646 */ // Label 1615: @114646
     /* 114646 */ GIM_Reject,
     /* 114647 */ // Label 10: @114647
     /* 114647 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1921*/ GIMT_Encode4(115137),
     /* 114658 */ /*GILLT_s16*//*Label 1913*/ GIMT_Encode4(114698),
     /* 114662 */ /*GILLT_s32*//*Label 1914*/ GIMT_Encode4(114729),
     /* 114666 */ /*GILLT_s64*//*Label 1915*/ GIMT_Encode4(114760), GIMT_Encode4(0),
     /* 114674 */ /*GILLT_v2s32*//*Label 1916*/ GIMT_Encode4(114791),
     /* 114678 */ /*GILLT_v2s64*//*Label 1917*/ GIMT_Encode4(114822),
     /* 114682 */ /*GILLT_v4s16*//*Label 1918*/ GIMT_Encode4(114853),
     /* 114686 */ /*GILLT_v4s32*//*Label 1919*/ GIMT_Encode4(114884), GIMT_Encode4(0),
     /* 114694 */ /*GILLT_v8s16*//*Label 1920*/ GIMT_Encode4(114915),
     /* 114698 */ // Label 1913: @114698
     /* 114698 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(114728), // Rule ID 564 //
     /* 114703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 114706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114717 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 114717 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /* 114722 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114726 */   GIR_RootConstrainSelectedInstOperands,
     /* 114727 */   // GIR_Coverage, 564,
     /* 114727 */   GIR_Done,
     /* 114728 */ // Label 1922: @114728
     /* 114728 */ GIM_Reject,
     /* 114729 */ // Label 1914: @114729
     /* 114729 */ GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(114759), // Rule ID 566 //
     /* 114734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 114737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114748 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 114748 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /* 114753 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114757 */   GIR_RootConstrainSelectedInstOperands,
     /* 114758 */   // GIR_Coverage, 566,
     /* 114758 */   GIR_Done,
     /* 114759 */ // Label 1923: @114759
     /* 114759 */ GIM_Reject,
     /* 114760 */ // Label 1915: @114760
     /* 114760 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(114790), // Rule ID 568 //
     /* 114765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 114768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114779 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 114779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /* 114784 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114788 */   GIR_RootConstrainSelectedInstOperands,
     /* 114789 */   // GIR_Coverage, 568,
     /* 114789 */   GIR_Done,
     /* 114790 */ // Label 1924: @114790
     /* 114790 */ GIM_Reject,
     /* 114791 */ // Label 1916: @114791
     /* 114791 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(114821), // Rule ID 933 //
     /* 114796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114810 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 114810 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /* 114815 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114819 */   GIR_RootConstrainSelectedInstOperands,
     /* 114820 */   // GIR_Coverage, 933,
     /* 114820 */   GIR_Done,
     /* 114821 */ // Label 1925: @114821
     /* 114821 */ GIM_Reject,
     /* 114822 */ // Label 1917: @114822
     /* 114822 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(114852), // Rule ID 937 //
     /* 114827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114841 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 114841 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /* 114846 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114850 */   GIR_RootConstrainSelectedInstOperands,
     /* 114851 */   // GIR_Coverage, 937,
     /* 114851 */   GIR_Done,
     /* 114852 */ // Label 1926: @114852
     /* 114852 */ GIM_Reject,
     /* 114853 */ // Label 1918: @114853
     /* 114853 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(114883), // Rule ID 929 //
     /* 114858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114872 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 114872 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /* 114877 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114881 */   GIR_RootConstrainSelectedInstOperands,
     /* 114882 */   // GIR_Coverage, 929,
     /* 114882 */   GIR_Done,
     /* 114883 */ // Label 1927: @114883
     /* 114883 */ GIM_Reject,
     /* 114884 */ // Label 1919: @114884
     /* 114884 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(114914), // Rule ID 935 //
     /* 114889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114903 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 114903 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 114908 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114912 */   GIR_RootConstrainSelectedInstOperands,
     /* 114913 */   // GIR_Coverage, 935,
     /* 114913 */   GIR_Done,
     /* 114914 */ // Label 1928: @114914
     /* 114914 */ GIM_Reject,
     /* 114915 */ // Label 1920: @114915
     /* 114915 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(115136),
     /* 114920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114931 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(114950), // Rule ID 931 //
     /* 114936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114939 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 114939 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /* 114944 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 114948 */     GIR_RootConstrainSelectedInstOperands,
     /* 114949 */     // GIR_Coverage, 931,
     /* 114949 */     GIR_Done,
     /* 114950 */   // Label 1930: @114950
     /* 114950 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(115135), // Rule ID 7056 //
     /* 114955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 114958 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 114958 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 114961 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 114965 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114970 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 114974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 114976 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 114979 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 114983 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114988 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 114991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 114993 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 114996 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115000 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115005 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 115011 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115016 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115021 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 115024 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 115028 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115033 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 115036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 115038 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 115041 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 115045 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115050 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 115053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115055 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 115058 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 115062 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115067 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 115070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115072 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 115075 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115079 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 115093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115098 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115101 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 115104 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 115125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 115133 */     GIR_RootConstrainSelectedInstOperands,
     /* 115134 */     // GIR_Coverage, 7056,
     /* 115134 */     GIR_EraseRootFromParent_Done,
     /* 115135 */   // Label 1931: @115135
     /* 115135 */   GIM_Reject,
     /* 115136 */ // Label 1929: @115136
     /* 115136 */ GIM_Reject,
     /* 115137 */ // Label 1921: @115137
     /* 115137 */ GIM_Reject,
     /* 115138 */ // Label 11: @115138
     /* 115138 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1940*/ GIMT_Encode4(115628),
     /* 115149 */ /*GILLT_s16*//*Label 1932*/ GIMT_Encode4(115189),
     /* 115153 */ /*GILLT_s32*//*Label 1933*/ GIMT_Encode4(115220),
     /* 115157 */ /*GILLT_s64*//*Label 1934*/ GIMT_Encode4(115251), GIMT_Encode4(0),
     /* 115165 */ /*GILLT_v2s32*//*Label 1935*/ GIMT_Encode4(115282),
     /* 115169 */ /*GILLT_v2s64*//*Label 1936*/ GIMT_Encode4(115313),
     /* 115173 */ /*GILLT_v4s16*//*Label 1937*/ GIMT_Encode4(115344),
     /* 115177 */ /*GILLT_v4s32*//*Label 1938*/ GIMT_Encode4(115375), GIMT_Encode4(0),
     /* 115185 */ /*GILLT_v8s16*//*Label 1939*/ GIMT_Encode4(115406),
     /* 115189 */ // Label 1932: @115189
     /* 115189 */ GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(115219), // Rule ID 528 //
     /* 115194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 115204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 115208 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 115208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /* 115213 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115217 */   GIR_RootConstrainSelectedInstOperands,
     /* 115218 */   // GIR_Coverage, 528,
     /* 115218 */   GIR_Done,
     /* 115219 */ // Label 1941: @115219
     /* 115219 */ GIM_Reject,
     /* 115220 */ // Label 1933: @115220
     /* 115220 */ GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(115250), // Rule ID 530 //
     /* 115225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115239 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 115239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /* 115244 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115248 */   GIR_RootConstrainSelectedInstOperands,
     /* 115249 */   // GIR_Coverage, 530,
     /* 115249 */   GIR_Done,
     /* 115250 */ // Label 1942: @115250
     /* 115250 */ GIM_Reject,
     /* 115251 */ // Label 1934: @115251
     /* 115251 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(115281), // Rule ID 532 //
     /* 115256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115270 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 115270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /* 115275 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115279 */   GIR_RootConstrainSelectedInstOperands,
     /* 115280 */   // GIR_Coverage, 532,
     /* 115280 */   GIR_Done,
     /* 115281 */ // Label 1943: @115281
     /* 115281 */ GIM_Reject,
     /* 115282 */ // Label 1935: @115282
     /* 115282 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(115312), // Rule ID 873 //
     /* 115287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 115290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115301 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 115301 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /* 115306 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115310 */   GIR_RootConstrainSelectedInstOperands,
     /* 115311 */   // GIR_Coverage, 873,
     /* 115311 */   GIR_Done,
     /* 115312 */ // Label 1944: @115312
     /* 115312 */ GIM_Reject,
     /* 115313 */ // Label 1936: @115313
     /* 115313 */ GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(115343), // Rule ID 877 //
     /* 115318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 115321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 115324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115332 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 115332 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /* 115337 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115341 */   GIR_RootConstrainSelectedInstOperands,
     /* 115342 */   // GIR_Coverage, 877,
     /* 115342 */   GIR_Done,
     /* 115343 */ // Label 1945: @115343
     /* 115343 */ GIM_Reject,
     /* 115344 */ // Label 1937: @115344
     /* 115344 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(115374), // Rule ID 869 //
     /* 115349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 115352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 115355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115363 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 115363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /* 115368 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115372 */   GIR_RootConstrainSelectedInstOperands,
     /* 115373 */   // GIR_Coverage, 869,
     /* 115373 */   GIR_Done,
     /* 115374 */ // Label 1946: @115374
     /* 115374 */ GIM_Reject,
     /* 115375 */ // Label 1938: @115375
     /* 115375 */ GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(115405), // Rule ID 875 //
     /* 115380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 115383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115394 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 115394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 115399 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115403 */   GIR_RootConstrainSelectedInstOperands,
     /* 115404 */   // GIR_Coverage, 875,
     /* 115404 */   GIR_Done,
     /* 115405 */ // Label 1947: @115405
     /* 115405 */ GIM_Reject,
     /* 115406 */ // Label 1939: @115406
     /* 115406 */ GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(115627),
     /* 115411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115422 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(115441), // Rule ID 871 //
     /* 115427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 115430 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 115430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /* 115435 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 115439 */     GIR_RootConstrainSelectedInstOperands,
     /* 115440 */     // GIR_Coverage, 871,
     /* 115440 */     GIR_Done,
     /* 115441 */   // Label 1949: @115441
     /* 115441 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(115626), // Rule ID 7050 //
     /* 115446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 115449 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 115449 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 115452 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 115456 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115461 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 115467 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 115470 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 115474 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115479 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 115482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 115484 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 115487 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115491 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115496 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 115502 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115507 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115512 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 115515 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 115519 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115524 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 115527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 115529 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 115532 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 115536 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115541 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 115544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115546 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 115549 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 115553 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115558 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 115561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 115566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 115584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115589 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115592 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 115595 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 115616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 115624 */     GIR_RootConstrainSelectedInstOperands,
     /* 115625 */     // GIR_Coverage, 7050,
     /* 115625 */     GIR_EraseRootFromParent_Done,
     /* 115626 */   // Label 1950: @115626
     /* 115626 */   GIM_Reject,
     /* 115627 */ // Label 1948: @115627
     /* 115627 */ GIM_Reject,
     /* 115628 */ // Label 1940: @115628
     /* 115628 */ GIM_Reject,
     /* 115629 */ // Label 12: @115629
     /* 115629 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1953*/ GIMT_Encode4(115896),
     /* 115640 */ /*GILLT_s32*//*Label 1951*/ GIMT_Encode4(115648),
     /* 115644 */ /*GILLT_s64*//*Label 1952*/ GIMT_Encode4(115772),
     /* 115648 */ // Label 1951: @115648
     /* 115648 */ GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(115691), // Rule ID 4821 //
     /* 115653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115663 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 115663 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 115666 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 115670 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115675 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 115684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115686 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115689 */   GIR_RootConstrainSelectedInstOperands,
     /* 115690 */   // GIR_Coverage, 4821,
     /* 115690 */   GIR_EraseRootFromParent_Done,
     /* 115691 */ // Label 1954: @115691
     /* 115691 */ GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(115731), // Rule ID 4827 //
     /* 115696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115703 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 115703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 115710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115715 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 115724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115726 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115729 */   GIR_RootConstrainSelectedInstOperands,
     /* 115730 */   // GIR_Coverage, 4827,
     /* 115730 */   GIR_EraseRootFromParent_Done,
     /* 115731 */ // Label 1955: @115731
     /* 115731 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(115771), // Rule ID 4829 //
     /* 115736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 115743 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 115743 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 115746 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 115750 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115755 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 115764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115766 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115769 */   GIR_RootConstrainSelectedInstOperands,
     /* 115770 */   // GIR_Coverage, 4829,
     /* 115770 */   GIR_EraseRootFromParent_Done,
     /* 115771 */ // Label 1956: @115771
     /* 115771 */ GIM_Reject,
     /* 115772 */ // Label 1952: @115772
     /* 115772 */ GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(115815), // Rule ID 4823 //
     /* 115777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115787 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 115787 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 115790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 115794 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115799 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 115808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115813 */   GIR_RootConstrainSelectedInstOperands,
     /* 115814 */   // GIR_Coverage, 4823,
     /* 115814 */   GIR_EraseRootFromParent_Done,
     /* 115815 */ // Label 1957: @115815
     /* 115815 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(115855), // Rule ID 4831 //
     /* 115820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115827 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 115827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 115834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115839 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 115848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115853 */   GIR_RootConstrainSelectedInstOperands,
     /* 115854 */   // GIR_Coverage, 4831,
     /* 115854 */   GIR_EraseRootFromParent_Done,
     /* 115855 */ // Label 1958: @115855
     /* 115855 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(115895), // Rule ID 4833 //
     /* 115860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115867 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 115867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 115870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 115874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115879 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115883 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 115888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115890 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115893 */   GIR_RootConstrainSelectedInstOperands,
     /* 115894 */   // GIR_Coverage, 4833,
     /* 115894 */   GIR_EraseRootFromParent_Done,
     /* 115895 */ // Label 1959: @115895
     /* 115895 */ GIM_Reject,
     /* 115896 */ // Label 1953: @115896
     /* 115896 */ GIM_Reject,
     /* 115897 */ // Label 13: @115897
     /* 115897 */ GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(116046),
     /* 115902 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 115905 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1964*/ GIMT_Encode4(116045),
     /* 115916 */   /*GILLT_s16*//*Label 1961*/ GIMT_Encode4(115928),
     /* 115920 */   /*GILLT_s32*//*Label 1962*/ GIMT_Encode4(115969),
     /* 115924 */   /*GILLT_s64*//*Label 1963*/ GIMT_Encode4(116007),
     /* 115928 */   // Label 1961: @115928
     /* 115928 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(115968), // Rule ID 4825 //
     /* 115933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115940 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 115940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 115943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 115947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115952 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 115961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 115963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115966 */     GIR_RootConstrainSelectedInstOperands,
     /* 115967 */     // GIR_Coverage, 4825,
     /* 115967 */     GIR_EraseRootFromParent_Done,
     /* 115968 */   // Label 1965: @115968
     /* 115968 */   GIM_Reject,
     /* 115969 */   // Label 1962: @115969
     /* 115969 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(116006), // Rule ID 4835 //
     /* 115974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 115978 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 115978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 115985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 115994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 115999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 116001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116004 */     GIR_RootConstrainSelectedInstOperands,
     /* 116005 */     // GIR_Coverage, 4835,
     /* 116005 */     GIR_EraseRootFromParent_Done,
     /* 116006 */   // Label 1966: @116006
     /* 116006 */   GIM_Reject,
     /* 116007 */   // Label 1963: @116007
     /* 116007 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(116044), // Rule ID 4837 //
     /* 116012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116016 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 116016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 116019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 116023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116028 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 116037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 116039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116042 */     GIR_RootConstrainSelectedInstOperands,
     /* 116043 */     // GIR_Coverage, 4837,
     /* 116043 */     GIR_EraseRootFromParent_Done,
     /* 116044 */   // Label 1967: @116044
     /* 116044 */   GIM_Reject,
     /* 116045 */   // Label 1964: @116045
     /* 116045 */   GIM_Reject,
     /* 116046 */ // Label 1960: @116046
     /* 116046 */ GIM_Reject,
     /* 116047 */ // Label 14: @116047
     /* 116047 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1976*/ GIMT_Encode4(116537),
     /* 116058 */ /*GILLT_s16*//*Label 1968*/ GIMT_Encode4(116098),
     /* 116062 */ /*GILLT_s32*//*Label 1969*/ GIMT_Encode4(116129),
     /* 116066 */ /*GILLT_s64*//*Label 1970*/ GIMT_Encode4(116160), GIMT_Encode4(0),
     /* 116074 */ /*GILLT_v2s32*//*Label 1971*/ GIMT_Encode4(116191),
     /* 116078 */ /*GILLT_v2s64*//*Label 1972*/ GIMT_Encode4(116222),
     /* 116082 */ /*GILLT_v4s16*//*Label 1973*/ GIMT_Encode4(116253),
     /* 116086 */ /*GILLT_v4s32*//*Label 1974*/ GIMT_Encode4(116284), GIMT_Encode4(0),
     /* 116094 */ /*GILLT_v8s16*//*Label 1975*/ GIMT_Encode4(116315),
     /* 116098 */ // Label 1968: @116098
     /* 116098 */ GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(116128), // Rule ID 546 //
     /* 116103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116117 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 116117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /* 116122 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116126 */   GIR_RootConstrainSelectedInstOperands,
     /* 116127 */   // GIR_Coverage, 546,
     /* 116127 */   GIR_Done,
     /* 116128 */ // Label 1977: @116128
     /* 116128 */ GIM_Reject,
     /* 116129 */ // Label 1969: @116129
     /* 116129 */ GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(116159), // Rule ID 548 //
     /* 116134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116148 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 116148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /* 116153 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116157 */   GIR_RootConstrainSelectedInstOperands,
     /* 116158 */   // GIR_Coverage, 548,
     /* 116158 */   GIR_Done,
     /* 116159 */ // Label 1978: @116159
     /* 116159 */ GIM_Reject,
     /* 116160 */ // Label 1970: @116160
     /* 116160 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(116190), // Rule ID 550 //
     /* 116165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116179 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 116179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /* 116184 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116188 */   GIR_RootConstrainSelectedInstOperands,
     /* 116189 */   // GIR_Coverage, 550,
     /* 116189 */   GIR_Done,
     /* 116190 */ // Label 1979: @116190
     /* 116190 */ GIM_Reject,
     /* 116191 */ // Label 1971: @116191
     /* 116191 */ GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(116221), // Rule ID 903 //
     /* 116196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116210 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 116210 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /* 116215 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116219 */   GIR_RootConstrainSelectedInstOperands,
     /* 116220 */   // GIR_Coverage, 903,
     /* 116220 */   GIR_Done,
     /* 116221 */ // Label 1980: @116221
     /* 116221 */ GIM_Reject,
     /* 116222 */ // Label 1972: @116222
     /* 116222 */ GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(116252), // Rule ID 907 //
     /* 116227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 116233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116241 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 116241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /* 116246 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116250 */   GIR_RootConstrainSelectedInstOperands,
     /* 116251 */   // GIR_Coverage, 907,
     /* 116251 */   GIR_Done,
     /* 116252 */ // Label 1981: @116252
     /* 116252 */ GIM_Reject,
     /* 116253 */ // Label 1973: @116253
     /* 116253 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(116283), // Rule ID 899 //
     /* 116258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116272 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 116272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /* 116277 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116281 */   GIR_RootConstrainSelectedInstOperands,
     /* 116282 */   // GIR_Coverage, 899,
     /* 116282 */   GIR_Done,
     /* 116283 */ // Label 1982: @116283
     /* 116283 */ GIM_Reject,
     /* 116284 */ // Label 1974: @116284
     /* 116284 */ GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(116314), // Rule ID 905 //
     /* 116289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116303 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 116303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 116308 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116312 */   GIR_RootConstrainSelectedInstOperands,
     /* 116313 */   // GIR_Coverage, 905,
     /* 116313 */   GIR_Done,
     /* 116314 */ // Label 1983: @116314
     /* 116314 */ GIM_Reject,
     /* 116315 */ // Label 1975: @116315
     /* 116315 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(116536),
     /* 116320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116331 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(116350), // Rule ID 901 //
     /* 116336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116339 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 116339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /* 116344 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116348 */     GIR_RootConstrainSelectedInstOperands,
     /* 116349 */     // GIR_Coverage, 901,
     /* 116349 */     GIR_Done,
     /* 116350 */   // Label 1985: @116350
     /* 116350 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(116535), // Rule ID 7052 //
     /* 116355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 116358 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 116358 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 116361 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 116365 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116370 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 116376 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 116379 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 116383 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116388 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 116391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 116393 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 116396 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116400 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116405 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 116411 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116416 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116421 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 116424 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 116428 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116433 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 116436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 116438 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 116441 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 116445 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116450 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 116453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116455 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 116458 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 116462 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116467 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 116470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116472 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 116475 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116479 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116498 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116501 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 116504 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 116525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 116533 */     GIR_RootConstrainSelectedInstOperands,
     /* 116534 */     // GIR_Coverage, 7052,
     /* 116534 */     GIR_EraseRootFromParent_Done,
     /* 116535 */   // Label 1986: @116535
     /* 116535 */   GIM_Reject,
     /* 116536 */ // Label 1984: @116536
     /* 116536 */ GIM_Reject,
     /* 116537 */ // Label 1976: @116537
     /* 116537 */ GIM_Reject,
     /* 116538 */ // Label 15: @116538
     /* 116538 */ GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(116570), // Rule ID 3904 //
     /* 116543 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 116546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 116550 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /* 116550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 116553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116555 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /* 116565 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 116568 */   GIR_RootConstrainSelectedInstOperands,
     /* 116569 */   // GIR_Coverage, 3904,
     /* 116569 */   GIR_EraseRootFromParent_Done,
     /* 116570 */ // Label 1987: @116570
     /* 116570 */ GIM_Reject,
     /* 116571 */ // Label 16: @116571
     /* 116571 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2008*/ GIMT_Encode4(125508),
     /* 116582 */ /*GILLT_s8*//*Label 1988*/ GIMT_Encode4(116678),
     /* 116586 */ /*GILLT_s16*//*Label 1989*/ GIMT_Encode4(116854),
     /* 116590 */ /*GILLT_s32*//*Label 1990*/ GIMT_Encode4(117030),
     /* 116594 */ /*GILLT_s64*//*Label 1991*/ GIMT_Encode4(119424),
     /* 116598 */ /*GILLT_s128*//*Label 1992*/ GIMT_Encode4(122137),
     /* 116602 */ /*GILLT_v2s32*//*Label 1993*/ GIMT_Encode4(122346),
     /* 116606 */ /*GILLT_v2s64*//*Label 1994*/ GIMT_Encode4(122724),
     /* 116610 */ /*GILLT_v4s16*//*Label 1995*/ GIMT_Encode4(123102),
     /* 116614 */ /*GILLT_v4s32*//*Label 1996*/ GIMT_Encode4(123480),
     /* 116618 */ /*GILLT_v8s8*//*Label 1997*/ GIMT_Encode4(123858),
     /* 116622 */ /*GILLT_v8s16*//*Label 1998*/ GIMT_Encode4(124066),
     /* 116626 */ /*GILLT_v16s8*//*Label 1999*/ GIMT_Encode4(124444), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 116638 */ /*GILLT_nxv2s16*//*Label 2000*/ GIMT_Encode4(124652),
     /* 116642 */ /*GILLT_nxv2s32*//*Label 2001*/ GIMT_Encode4(124716),
     /* 116646 */ /*GILLT_nxv2s64*//*Label 2002*/ GIMT_Encode4(124780), GIMT_Encode4(0),
     /* 116654 */ /*GILLT_nxv4s16*//*Label 2003*/ GIMT_Encode4(124954),
     /* 116658 */ /*GILLT_nxv4s32*//*Label 2004*/ GIMT_Encode4(125018), GIMT_Encode4(0),
     /* 116666 */ /*GILLT_nxv8s16*//*Label 2005*/ GIMT_Encode4(125192),
     /* 116670 */ /*GILLT_nxv16s1*//*Label 2006*/ GIMT_Encode4(125366),
     /* 116674 */ /*GILLT_nxv16s8*//*Label 2007*/ GIMT_Encode4(125410),
     /* 116678 */ // Label 1988: @116678
     /* 116678 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(116853),
     /* 116683 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116686 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 116694 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116698 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(116739), // Rule ID 237 //
     /* 116703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 116713 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 116713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 116716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116737 */     GIR_RootConstrainSelectedInstOperands,
     /* 116738 */     // GIR_Coverage, 237,
     /* 116738 */     GIR_EraseRootFromParent_Done,
     /* 116739 */   // Label 2010: @116739
     /* 116739 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(116780), // Rule ID 238 //
     /* 116744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 116754 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 116754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 116757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116778 */     GIR_RootConstrainSelectedInstOperands,
     /* 116779 */     // GIR_Coverage, 238,
     /* 116779 */     GIR_EraseRootFromParent_Done,
     /* 116780 */   // Label 2011: @116780
     /* 116780 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(116816), // Rule ID 261 //
     /* 116785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 116795 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 116795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 116798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116814 */     GIR_RootConstrainSelectedInstOperands,
     /* 116815 */     // GIR_Coverage, 261,
     /* 116815 */     GIR_EraseRootFromParent_Done,
     /* 116816 */   // Label 2012: @116816
     /* 116816 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(116852), // Rule ID 282 //
     /* 116821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 116831 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 116831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 116834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116850 */     GIR_RootConstrainSelectedInstOperands,
     /* 116851 */     // GIR_Coverage, 282,
     /* 116851 */     GIR_EraseRootFromParent_Done,
     /* 116852 */   // Label 2013: @116852
     /* 116852 */   GIM_Reject,
     /* 116853 */ // Label 2009: @116853
     /* 116853 */ GIM_Reject,
     /* 116854 */ // Label 1989: @116854
     /* 116854 */ GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(117029),
     /* 116859 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116862 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116870 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116874 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(116915), // Rule ID 239 //
     /* 116879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 116889 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 116889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 116892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116913 */     GIR_RootConstrainSelectedInstOperands,
     /* 116914 */     // GIR_Coverage, 239,
     /* 116914 */     GIR_EraseRootFromParent_Done,
     /* 116915 */   // Label 2015: @116915
     /* 116915 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(116956), // Rule ID 240 //
     /* 116920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 116930 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 116930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 116933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116954 */     GIR_RootConstrainSelectedInstOperands,
     /* 116955 */     // GIR_Coverage, 240,
     /* 116955 */     GIR_EraseRootFromParent_Done,
     /* 116956 */   // Label 2016: @116956
     /* 116956 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(116992), // Rule ID 262 //
     /* 116961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 116971 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 116971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 116974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 116976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116990 */     GIR_RootConstrainSelectedInstOperands,
     /* 116991 */     // GIR_Coverage, 262,
     /* 116991 */     GIR_EraseRootFromParent_Done,
     /* 116992 */   // Label 2017: @116992
     /* 116992 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(117028), // Rule ID 283 //
     /* 116997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117007 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 117010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117026 */     GIR_RootConstrainSelectedInstOperands,
     /* 117027 */     // GIR_Coverage, 283,
     /* 117027 */     GIR_EraseRootFromParent_Done,
     /* 117028 */   // Label 2018: @117028
     /* 117028 */   GIM_Reject,
     /* 117029 */ // Label 2014: @117029
     /* 117029 */ GIM_Reject,
     /* 117030 */ // Label 1990: @117030
     /* 117030 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(117083), // Rule ID 233 //
     /* 117035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117038 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117046 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117050 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117057 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 117060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117062 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117077 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117081 */   GIR_RootConstrainSelectedInstOperands,
     /* 117082 */   // GIR_Coverage, 233,
     /* 117082 */   GIR_EraseRootFromParent_Done,
     /* 117083 */ // Label 2019: @117083
     /* 117083 */ GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(117136), // Rule ID 234 //
     /* 117088 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117091 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117099 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117103 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117110 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 117113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117125 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117130 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117134 */   GIR_RootConstrainSelectedInstOperands,
     /* 117135 */   // GIR_Coverage, 234,
     /* 117135 */   GIR_EraseRootFromParent_Done,
     /* 117136 */ // Label 2020: @117136
     /* 117136 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(117192), // Rule ID 241 //
     /* 117141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117144 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117147 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117155 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117159 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117166 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 117169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117186 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117190 */   GIR_RootConstrainSelectedInstOperands,
     /* 117191 */   // GIR_Coverage, 241,
     /* 117191 */   GIR_EraseRootFromParent_Done,
     /* 117192 */ // Label 2021: @117192
     /* 117192 */ GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(117248), // Rule ID 242 //
     /* 117197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117200 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117203 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117211 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117215 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117222 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 117225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117242 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117246 */   GIR_RootConstrainSelectedInstOperands,
     /* 117247 */   // GIR_Coverage, 242,
     /* 117247 */   GIR_EraseRootFromParent_Done,
     /* 117248 */ // Label 2022: @117248
     /* 117248 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(117308), // Rule ID 4120 //
     /* 117253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117256 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117260 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117271 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117275 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 117282 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 117282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 117285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117302 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117306 */   GIR_RootConstrainSelectedInstOperands,
     /* 117307 */   // GIR_Coverage, 4120,
     /* 117307 */   GIR_EraseRootFromParent_Done,
     /* 117308 */ // Label 2023: @117308
     /* 117308 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(117368), // Rule ID 4121 //
     /* 117313 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117316 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117320 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117331 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117335 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 117342 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 117342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 117345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117362 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117366 */   GIR_RootConstrainSelectedInstOperands,
     /* 117367 */   // GIR_Coverage, 4121,
     /* 117367 */   GIR_EraseRootFromParent_Done,
     /* 117368 */ // Label 2024: @117368
     /* 117368 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(117428), // Rule ID 4122 //
     /* 117373 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117376 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117380 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117395 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 117402 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 117402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 117405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117422 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117426 */   GIR_RootConstrainSelectedInstOperands,
     /* 117427 */   // GIR_Coverage, 4122,
     /* 117427 */   GIR_EraseRootFromParent_Done,
     /* 117428 */ // Label 2025: @117428
     /* 117428 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(117488), // Rule ID 4123 //
     /* 117433 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117436 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117440 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117451 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117455 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 117462 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 117462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 117465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117472 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117477 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117482 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117486 */   GIR_RootConstrainSelectedInstOperands,
     /* 117487 */   // GIR_Coverage, 4123,
     /* 117487 */   GIR_EraseRootFromParent_Done,
     /* 117488 */ // Label 2026: @117488
     /* 117488 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(117548), // Rule ID 4124 //
     /* 117493 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117496 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117500 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117511 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117515 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117522 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 117525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117542 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117546 */   GIR_RootConstrainSelectedInstOperands,
     /* 117547 */   // GIR_Coverage, 4124,
     /* 117547 */   GIR_EraseRootFromParent_Done,
     /* 117548 */ // Label 2027: @117548
     /* 117548 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(117608), // Rule ID 4125 //
     /* 117553 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117556 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117560 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117571 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117575 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117582 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 117585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117602 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117606 */   GIR_RootConstrainSelectedInstOperands,
     /* 117607 */   // GIR_Coverage, 4125,
     /* 117607 */   GIR_EraseRootFromParent_Done,
     /* 117608 */ // Label 2028: @117608
     /* 117608 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(117656), // Rule ID 260 //
     /* 117613 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117616 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117624 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117628 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117635 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 117638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117650 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117654 */   GIR_RootConstrainSelectedInstOperands,
     /* 117655 */   // GIR_Coverage, 260,
     /* 117655 */   GIR_EraseRootFromParent_Done,
     /* 117656 */ // Label 2029: @117656
     /* 117656 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(117707), // Rule ID 263 //
     /* 117661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117664 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117667 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117675 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117679 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117686 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 117689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117691 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117701 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117705 */   GIR_RootConstrainSelectedInstOperands,
     /* 117706 */   // GIR_Coverage, 263,
     /* 117706 */   GIR_EraseRootFromParent_Done,
     /* 117707 */ // Label 2030: @117707
     /* 117707 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(117770), // Rule ID 7082 //
     /* 117712 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117715 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117719 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117726 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 117729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117733 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117737 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 117744 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15912>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 117744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 117747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117764 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117768 */   GIR_RootConstrainSelectedInstOperands,
     /* 117769 */   // GIR_Coverage, 7082,
     /* 117769 */   GIR_EraseRootFromParent_Done,
     /* 117770 */ // Label 2031: @117770
     /* 117770 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(117833), // Rule ID 7084 //
     /* 117775 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117778 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117782 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117789 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 117792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117796 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117800 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 117807 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15912>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 117807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 117810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 117827 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117831 */   GIR_RootConstrainSelectedInstOperands,
     /* 117832 */   // GIR_Coverage, 7084,
     /* 117832 */   GIR_EraseRootFromParent_Done,
     /* 117833 */ // Label 2032: @117833
     /* 117833 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(117896), // Rule ID 7094 //
     /* 117838 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117841 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117845 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117852 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 117855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117859 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117863 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 117870 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15920>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 117870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 117873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117875 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117880 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117890 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117894 */   GIR_RootConstrainSelectedInstOperands,
     /* 117895 */   // GIR_Coverage, 7094,
     /* 117895 */   GIR_EraseRootFromParent_Done,
     /* 117896 */ // Label 2033: @117896
     /* 117896 */ GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(117959), // Rule ID 7096 //
     /* 117901 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117904 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117908 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117915 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 117918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117922 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117926 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 117933 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15920>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 117933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 117936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 117938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117948 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117953 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117957 */   GIR_RootConstrainSelectedInstOperands,
     /* 117958 */   // GIR_Coverage, 7096,
     /* 117958 */   GIR_EraseRootFromParent_Done,
     /* 117959 */ // Label 2034: @117959
     /* 117959 */ GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(118022), // Rule ID 7104 //
     /* 117964 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117967 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117971 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117978 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 117981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117985 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117989 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117996 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15928>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 117999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118001 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118016 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118020 */   GIR_RootConstrainSelectedInstOperands,
     /* 118021 */   // GIR_Coverage, 7104,
     /* 118021 */   GIR_EraseRootFromParent_Done,
     /* 118022 */ // Label 2035: @118022
     /* 118022 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(118085), // Rule ID 7105 //
     /* 118027 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118030 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118034 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118041 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118048 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118052 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 118059 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15928>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 118059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 118062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118069 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118083 */   GIR_RootConstrainSelectedInstOperands,
     /* 118084 */   // GIR_Coverage, 7105,
     /* 118084 */   GIR_EraseRootFromParent_Done,
     /* 118085 */ // Label 2036: @118085
     /* 118085 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(118133), // Rule ID 281 //
     /* 118090 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118093 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118105 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118112 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 118115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118127 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118131 */   GIR_RootConstrainSelectedInstOperands,
     /* 118132 */   // GIR_Coverage, 281,
     /* 118132 */   GIR_EraseRootFromParent_Done,
     /* 118133 */ // Label 2037: @118133
     /* 118133 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(118184), // Rule ID 284 //
     /* 118138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118141 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118144 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 118152 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118156 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118163 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 118166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118168 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118178 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118182 */   GIR_RootConstrainSelectedInstOperands,
     /* 118183 */   // GIR_Coverage, 284,
     /* 118183 */   GIR_EraseRootFromParent_Done,
     /* 118184 */ // Label 2038: @118184
     /* 118184 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(118239), // Rule ID 4147 //
     /* 118189 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118192 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118196 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118207 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118211 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 118218 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 118218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 118221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118233 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118237 */   GIR_RootConstrainSelectedInstOperands,
     /* 118238 */   // GIR_Coverage, 4147,
     /* 118238 */   GIR_EraseRootFromParent_Done,
     /* 118239 */ // Label 2039: @118239
     /* 118239 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(118294), // Rule ID 4148 //
     /* 118244 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118247 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118251 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118262 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118266 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118273 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 118276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118288 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118292 */   GIR_RootConstrainSelectedInstOperands,
     /* 118293 */   // GIR_Coverage, 4148,
     /* 118293 */   GIR_EraseRootFromParent_Done,
     /* 118294 */ // Label 2040: @118294
     /* 118294 */ GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(118349), // Rule ID 4149 //
     /* 118299 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118302 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118306 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118317 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118321 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118328 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 118331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118343 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118347 */   GIR_RootConstrainSelectedInstOperands,
     /* 118348 */   // GIR_Coverage, 4149,
     /* 118348 */   GIR_EraseRootFromParent_Done,
     /* 118349 */ // Label 2041: @118349
     /* 118349 */ GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(118404), // Rule ID 4170 //
     /* 118354 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118357 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118361 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118372 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118376 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118383 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 118386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118388 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118398 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118402 */   GIR_RootConstrainSelectedInstOperands,
     /* 118403 */   // GIR_Coverage, 4170,
     /* 118403 */   GIR_EraseRootFromParent_Done,
     /* 118404 */ // Label 2042: @118404
     /* 118404 */ GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(118459), // Rule ID 4171 //
     /* 118409 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118412 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118416 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118427 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118431 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118438 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 118441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118443 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118453 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118457 */   GIR_RootConstrainSelectedInstOperands,
     /* 118458 */   // GIR_Coverage, 4171,
     /* 118458 */   GIR_EraseRootFromParent_Done,
     /* 118459 */ // Label 2043: @118459
     /* 118459 */ GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(118514), // Rule ID 4172 //
     /* 118464 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118467 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118471 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118482 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118486 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118493 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 118496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118503 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118508 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118512 */   GIR_RootConstrainSelectedInstOperands,
     /* 118513 */   // GIR_Coverage, 4172,
     /* 118513 */   GIR_EraseRootFromParent_Done,
     /* 118514 */ // Label 2044: @118514
     /* 118514 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(118572), // Rule ID 7086 //
     /* 118519 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118522 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118526 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118533 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118540 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118544 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118551 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15912>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 118554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118556 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118566 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118570 */   GIR_RootConstrainSelectedInstOperands,
     /* 118571 */   // GIR_Coverage, 7086,
     /* 118571 */   GIR_EraseRootFromParent_Done,
     /* 118572 */ // Label 2045: @118572
     /* 118572 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(118630), // Rule ID 7088 //
     /* 118577 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118580 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118584 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118591 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118598 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118602 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118609 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15912>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 118612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118614 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118619 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118624 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118628 */   GIR_RootConstrainSelectedInstOperands,
     /* 118629 */   // GIR_Coverage, 7088,
     /* 118629 */   GIR_EraseRootFromParent_Done,
     /* 118630 */ // Label 2046: @118630
     /* 118630 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(118688), // Rule ID 7098 //
     /* 118635 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118638 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118642 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118649 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118656 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118660 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 118667 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15920>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 118667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 118670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118677 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118682 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118686 */   GIR_RootConstrainSelectedInstOperands,
     /* 118687 */   // GIR_Coverage, 7098,
     /* 118687 */   GIR_EraseRootFromParent_Done,
     /* 118688 */ // Label 2047: @118688
     /* 118688 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(118746), // Rule ID 7100 //
     /* 118693 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118696 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118700 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118707 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118714 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118718 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118725 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15920>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 118728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118730 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118735 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118740 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118744 */   GIR_RootConstrainSelectedInstOperands,
     /* 118745 */   // GIR_Coverage, 7100,
     /* 118745 */   GIR_EraseRootFromParent_Done,
     /* 118746 */ // Label 2048: @118746
     /* 118746 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(118804), // Rule ID 7106 //
     /* 118751 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118754 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118758 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118765 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118772 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118776 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 118783 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15928>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 118783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 118786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118798 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118802 */   GIR_RootConstrainSelectedInstOperands,
     /* 118803 */   // GIR_Coverage, 7106,
     /* 118803 */   GIR_EraseRootFromParent_Done,
     /* 118804 */ // Label 2049: @118804
     /* 118804 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(118862), // Rule ID 7107 //
     /* 118809 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118812 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118816 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118823 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118834 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118841 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15928>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 118844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118856 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118860 */   GIR_RootConstrainSelectedInstOperands,
     /* 118861 */   // GIR_Coverage, 7107,
     /* 118861 */   GIR_EraseRootFromParent_Done,
     /* 118862 */ // Label 2050: @118862
     /* 118862 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(118923), // Rule ID 7492 //
     /* 118867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 118870 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118873 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118877 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118884 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118891 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118895 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118902 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15901>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 118905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118917 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118921 */   GIR_RootConstrainSelectedInstOperands,
     /* 118922 */   // GIR_Coverage, 7492,
     /* 118922 */   GIR_EraseRootFromParent_Done,
     /* 118923 */ // Label 2051: @118923
     /* 118923 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(118984), // Rule ID 7494 //
     /* 118928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 118931 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118934 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118938 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118945 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 118948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118952 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118956 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118963 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15903>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 118966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118973 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118978 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118982 */   GIR_RootConstrainSelectedInstOperands,
     /* 118983 */   // GIR_Coverage, 7494,
     /* 118983 */   GIR_EraseRootFromParent_Done,
     /* 118984 */ // Label 2052: @118984
     /* 118984 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(119045), // Rule ID 7496 //
     /* 118989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 118992 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118995 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118999 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119006 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119013 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119017 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 119024 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15905>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /* 119027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119039 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119043 */   GIR_RootConstrainSelectedInstOperands,
     /* 119044 */   // GIR_Coverage, 7496,
     /* 119044 */   GIR_EraseRootFromParent_Done,
     /* 119045 */ // Label 2053: @119045
     /* 119045 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(119089), // Rule ID 7072 //
     /* 119050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 119053 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119056 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119060 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119067 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119074 */   // MIs[0] ptr
     /* 119074 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119082 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15901>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119082 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 119087 */   GIR_RootConstrainSelectedInstOperands,
     /* 119088 */   // GIR_Coverage, 7072,
     /* 119088 */   GIR_Done,
     /* 119089 */ // Label 2054: @119089
     /* 119089 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(119133), // Rule ID 7074 //
     /* 119094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 119097 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119100 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119104 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119111 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119118 */   // MIs[0] ptr
     /* 119118 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119126 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15903>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 119131 */   GIR_RootConstrainSelectedInstOperands,
     /* 119132 */   // GIR_Coverage, 7074,
     /* 119132 */   GIR_Done,
     /* 119133 */ // Label 2055: @119133
     /* 119133 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(119177), // Rule ID 7076 //
     /* 119138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 119141 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119144 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119148 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119155 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119162 */   // MIs[0] ptr
     /* 119162 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119170 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15905>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /* 119175 */   GIR_RootConstrainSelectedInstOperands,
     /* 119176 */   // GIR_Coverage, 7076,
     /* 119176 */   GIR_Done,
     /* 119177 */ // Label 2056: @119177
     /* 119177 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(119218), // Rule ID 7078 //
     /* 119182 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119185 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119189 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119196 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 119199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119203 */   // MIs[0] ptr
     /* 119203 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119211 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15909>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119211 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 119216 */   GIR_RootConstrainSelectedInstOperands,
     /* 119217 */   // GIR_Coverage, 7078,
     /* 119217 */   GIR_Done,
     /* 119218 */ // Label 2057: @119218
     /* 119218 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(119259), // Rule ID 7080 //
     /* 119223 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119226 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119230 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119237 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119244 */   // MIs[0] ptr
     /* 119244 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119252 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15901>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 119257 */   GIR_RootConstrainSelectedInstOperands,
     /* 119258 */   // GIR_Coverage, 7080,
     /* 119258 */   GIR_Done,
     /* 119259 */ // Label 2058: @119259
     /* 119259 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(119300), // Rule ID 7090 //
     /* 119264 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119267 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119271 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119278 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 119281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119285 */   // MIs[0] ptr
     /* 119285 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119293 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15917>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119293 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 119298 */   GIR_RootConstrainSelectedInstOperands,
     /* 119299 */   // GIR_Coverage, 7090,
     /* 119299 */   GIR_Done,
     /* 119300 */ // Label 2059: @119300
     /* 119300 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(119341), // Rule ID 7092 //
     /* 119305 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119308 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119312 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119319 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119326 */   // MIs[0] ptr
     /* 119326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119334 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15903>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 119339 */   GIR_RootConstrainSelectedInstOperands,
     /* 119340 */   // GIR_Coverage, 7092,
     /* 119340 */   GIR_Done,
     /* 119341 */ // Label 2060: @119341
     /* 119341 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(119382), // Rule ID 7102 //
     /* 119346 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119349 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119353 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119360 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 119363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119367 */   // MIs[0] ptr
     /* 119367 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119375 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15925>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 119380 */   GIR_RootConstrainSelectedInstOperands,
     /* 119381 */   // GIR_Coverage, 7102,
     /* 119381 */   GIR_Done,
     /* 119382 */ // Label 2061: @119382
     /* 119382 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(119423), // Rule ID 7103 //
     /* 119387 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119390 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119394 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119401 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119408 */   // MIs[0] ptr
     /* 119408 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119416 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15905>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 119416 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 119421 */   GIR_RootConstrainSelectedInstOperands,
     /* 119422 */   // GIR_Coverage, 7103,
     /* 119422 */   GIR_Done,
     /* 119423 */ // Label 2062: @119423
     /* 119423 */ GIM_Reject,
     /* 119424 */ // Label 1991: @119424
     /* 119424 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(119477), // Rule ID 235 //
     /* 119429 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119432 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119440 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119444 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119451 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 119454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119456 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119471 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119475 */   GIR_RootConstrainSelectedInstOperands,
     /* 119476 */   // GIR_Coverage, 235,
     /* 119476 */   GIR_EraseRootFromParent_Done,
     /* 119477 */ // Label 2063: @119477
     /* 119477 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(119530), // Rule ID 236 //
     /* 119482 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119485 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119493 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119497 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119504 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 119507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119524 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119528 */   GIR_RootConstrainSelectedInstOperands,
     /* 119529 */   // GIR_Coverage, 236,
     /* 119529 */   GIR_EraseRootFromParent_Done,
     /* 119530 */ // Label 2064: @119530
     /* 119530 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(119586), // Rule ID 243 //
     /* 119535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119538 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119541 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119549 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119553 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119560 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 119563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119580 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119584 */   GIR_RootConstrainSelectedInstOperands,
     /* 119585 */   // GIR_Coverage, 243,
     /* 119585 */   GIR_EraseRootFromParent_Done,
     /* 119586 */ // Label 2065: @119586
     /* 119586 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(119642), // Rule ID 244 //
     /* 119591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119594 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119597 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119605 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119609 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119616 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 119619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119621 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119636 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119640 */   GIR_RootConstrainSelectedInstOperands,
     /* 119641 */   // GIR_Coverage, 244,
     /* 119641 */   GIR_EraseRootFromParent_Done,
     /* 119642 */ // Label 2066: @119642
     /* 119642 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(119695), // Rule ID 4086 //
     /* 119647 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119650 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119658 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119662 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119669 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 119672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119689 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119693 */   GIR_RootConstrainSelectedInstOperands,
     /* 119694 */   // GIR_Coverage, 4086,
     /* 119694 */   GIR_EraseRootFromParent_Done,
     /* 119695 */ // Label 2067: @119695
     /* 119695 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(119748), // Rule ID 4087 //
     /* 119700 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119703 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119711 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119715 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119722 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 119725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119732 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119742 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119746 */   GIR_RootConstrainSelectedInstOperands,
     /* 119747 */   // GIR_Coverage, 4087,
     /* 119747 */   GIR_EraseRootFromParent_Done,
     /* 119748 */ // Label 2068: @119748
     /* 119748 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(119801), // Rule ID 4088 //
     /* 119753 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119756 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119764 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119768 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119775 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 119778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119780 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119785 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119790 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119795 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119799 */   GIR_RootConstrainSelectedInstOperands,
     /* 119800 */   // GIR_Coverage, 4088,
     /* 119800 */   GIR_EraseRootFromParent_Done,
     /* 119801 */ // Label 2069: @119801
     /* 119801 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(119854), // Rule ID 4089 //
     /* 119806 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119809 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119817 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119821 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119828 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 119831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119843 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119848 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119852 */   GIR_RootConstrainSelectedInstOperands,
     /* 119853 */   // GIR_Coverage, 4089,
     /* 119853 */   GIR_EraseRootFromParent_Done,
     /* 119854 */ // Label 2070: @119854
     /* 119854 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(119946), // Rule ID 4112 //
     /* 119859 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119862 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119866 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 119877 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119881 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 119888 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 119888 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119891 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 119895 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119915 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 119921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 119924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119929 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 119935 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 119940 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119945 */   // GIR_Coverage, 4112,
     /* 119945 */   GIR_EraseRootFromParent_Done,
     /* 119946 */ // Label 2071: @119946
     /* 119946 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(120038), // Rule ID 4113 //
     /* 119951 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119954 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119958 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 119969 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119973 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 119980 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 119980 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119983 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 119987 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120002 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120007 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120021 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120032 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120037 */   // GIR_Coverage, 4113,
     /* 120037 */   GIR_EraseRootFromParent_Done,
     /* 120038 */ // Label 2072: @120038
     /* 120038 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(120130), // Rule ID 4114 //
     /* 120043 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120046 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120050 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120061 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 120072 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120072 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120075 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 120079 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120099 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120103 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120113 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120119 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120124 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120129 */   // GIR_Coverage, 4114,
     /* 120129 */   GIR_EraseRootFromParent_Done,
     /* 120130 */ // Label 2073: @120130
     /* 120130 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(120222), // Rule ID 4115 //
     /* 120135 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120138 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120142 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120153 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120157 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 120164 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 120171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120191 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120195 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120205 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120211 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120216 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120221 */   // GIR_Coverage, 4115,
     /* 120221 */   GIR_EraseRootFromParent_Done,
     /* 120222 */ // Label 2074: @120222
     /* 120222 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(120314), // Rule ID 4116 //
     /* 120227 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120230 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120234 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120245 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120249 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 120256 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120256 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120259 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 120263 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120268 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120273 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120278 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120283 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120297 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120303 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120308 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120313 */   // GIR_Coverage, 4116,
     /* 120313 */   GIR_EraseRootFromParent_Done,
     /* 120314 */ // Label 2075: @120314
     /* 120314 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(120406), // Rule ID 4117 //
     /* 120319 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120322 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120326 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120337 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120341 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 120348 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 120355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120375 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120395 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120400 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120405 */   // GIR_Coverage, 4117,
     /* 120405 */   GIR_EraseRootFromParent_Done,
     /* 120406 */ // Label 2076: @120406
     /* 120406 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(120498), // Rule ID 4118 //
     /* 120411 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120414 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120418 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 120440 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 120447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120457 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120467 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120471 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120487 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120492 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120497 */   // GIR_Coverage, 4118,
     /* 120497 */   GIR_EraseRootFromParent_Done,
     /* 120498 */ // Label 2077: @120498
     /* 120498 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(120590), // Rule ID 4119 //
     /* 120503 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120506 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120510 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120521 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120525 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 120532 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 120532 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120535 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 120539 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120559 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 120565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 120568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120573 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 120579 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 120584 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120589 */   // GIR_Coverage, 4119,
     /* 120589 */   GIR_EraseRootFromParent_Done,
     /* 120590 */ // Label 2078: @120590
     /* 120590 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(120638), // Rule ID 259 //
     /* 120595 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120598 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120606 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120610 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120617 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 120620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120622 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120627 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120632 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120636 */   GIR_RootConstrainSelectedInstOperands,
     /* 120637 */   // GIR_Coverage, 259,
     /* 120637 */   GIR_EraseRootFromParent_Done,
     /* 120638 */ // Label 2079: @120638
     /* 120638 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(120689), // Rule ID 264 //
     /* 120643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120646 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120649 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120657 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120661 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120668 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 120671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120678 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120683 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120687 */   GIR_RootConstrainSelectedInstOperands,
     /* 120688 */   // GIR_Coverage, 264,
     /* 120688 */   GIR_EraseRootFromParent_Done,
     /* 120689 */ // Label 2080: @120689
     /* 120689 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(120752), // Rule ID 7110 //
     /* 120694 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120697 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120701 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120708 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120715 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120719 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120726 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15936>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 120729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120731 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120736 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120741 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120746 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120750 */   GIR_RootConstrainSelectedInstOperands,
     /* 120751 */   // GIR_Coverage, 7110,
     /* 120751 */   GIR_EraseRootFromParent_Done,
     /* 120752 */ // Label 2081: @120752
     /* 120752 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(120815), // Rule ID 7111 //
     /* 120757 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120760 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120764 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120771 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120778 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120782 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120789 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15936>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 120792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120804 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120809 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120813 */   GIR_RootConstrainSelectedInstOperands,
     /* 120814 */   // GIR_Coverage, 7111,
     /* 120814 */   GIR_EraseRootFromParent_Done,
     /* 120815 */ // Label 2082: @120815
     /* 120815 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(120863), // Rule ID 280 //
     /* 120820 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120823 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120831 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120835 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120842 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 120845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120852 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120857 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120861 */   GIR_RootConstrainSelectedInstOperands,
     /* 120862 */   // GIR_Coverage, 280,
     /* 120862 */   GIR_EraseRootFromParent_Done,
     /* 120863 */ // Label 2083: @120863
     /* 120863 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(120914), // Rule ID 285 //
     /* 120868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120871 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120874 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120882 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120886 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 120893 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 120893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 120896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120908 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120912 */   GIR_RootConstrainSelectedInstOperands,
     /* 120913 */   // GIR_Coverage, 285,
     /* 120913 */   GIR_EraseRootFromParent_Done,
     /* 120914 */ // Label 2084: @120914
     /* 120914 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(120962), // Rule ID 4133 //
     /* 120919 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120922 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120930 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120934 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120941 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 120944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120956 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120960 */   GIR_RootConstrainSelectedInstOperands,
     /* 120961 */   // GIR_Coverage, 4133,
     /* 120961 */   GIR_EraseRootFromParent_Done,
     /* 120962 */ // Label 2085: @120962
     /* 120962 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(121010), // Rule ID 4134 //
     /* 120967 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120970 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120978 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120982 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120989 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 120992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120994 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121008 */   GIR_RootConstrainSelectedInstOperands,
     /* 121009 */   // GIR_Coverage, 4134,
     /* 121009 */   GIR_EraseRootFromParent_Done,
     /* 121010 */ // Label 2086: @121010
     /* 121010 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(121097), // Rule ID 4150 //
     /* 121015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121018 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121022 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121033 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121037 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 121044 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 121044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 121051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121066 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121080 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121086 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121096 */   // GIR_Coverage, 4150,
     /* 121096 */   GIR_EraseRootFromParent_Done,
     /* 121097 */ // Label 2087: @121097
     /* 121097 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(121184), // Rule ID 4151 //
     /* 121102 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121105 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121109 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121120 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121124 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 121131 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 121131 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121134 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 121138 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121153 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121157 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121167 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121178 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121183 */   // GIR_Coverage, 4151,
     /* 121183 */   GIR_EraseRootFromParent_Done,
     /* 121184 */ // Label 2088: @121184
     /* 121184 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(121271), // Rule ID 4152 //
     /* 121189 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121192 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121196 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121207 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121211 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 121218 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 121218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 121225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121230 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121240 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121254 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121260 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121265 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121270 */   // GIR_Coverage, 4152,
     /* 121270 */   GIR_EraseRootFromParent_Done,
     /* 121271 */ // Label 2089: @121271
     /* 121271 */ GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(121358), // Rule ID 4153 //
     /* 121276 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121279 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121283 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121294 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121298 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 121305 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 121305 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121308 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 121312 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121327 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121331 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121347 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121352 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121357 */   // GIR_Coverage, 4153,
     /* 121357 */   GIR_EraseRootFromParent_Done,
     /* 121358 */ // Label 2090: @121358
     /* 121358 */ GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(121406), // Rule ID 4161 //
     /* 121363 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121366 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121374 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121378 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121385 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 121388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121400 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121404 */   GIR_RootConstrainSelectedInstOperands,
     /* 121405 */   // GIR_Coverage, 4161,
     /* 121405 */   GIR_EraseRootFromParent_Done,
     /* 121406 */ // Label 2091: @121406
     /* 121406 */ GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(121454), // Rule ID 4162 //
     /* 121411 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121414 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121422 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121426 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121433 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 121436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121443 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121448 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121452 */   GIR_RootConstrainSelectedInstOperands,
     /* 121453 */   // GIR_Coverage, 4162,
     /* 121453 */   GIR_EraseRootFromParent_Done,
     /* 121454 */ // Label 2092: @121454
     /* 121454 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(121541), // Rule ID 4173 //
     /* 121459 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121462 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121466 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121477 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121481 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 121488 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 121488 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121491 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 121495 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121500 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121505 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121510 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121514 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121530 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121535 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121540 */   // GIR_Coverage, 4173,
     /* 121540 */   GIR_EraseRootFromParent_Done,
     /* 121541 */ // Label 2093: @121541
     /* 121541 */ GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(121628), // Rule ID 4174 //
     /* 121546 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121549 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121553 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121564 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121568 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 121575 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 121575 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121578 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 121582 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121597 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121611 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121617 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121622 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121627 */   // GIR_Coverage, 4174,
     /* 121627 */   GIR_EraseRootFromParent_Done,
     /* 121628 */ // Label 2094: @121628
     /* 121628 */ GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(121715), // Rule ID 4175 //
     /* 121633 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121636 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121640 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121651 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121655 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 121662 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 121662 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121665 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 121669 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121684 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121698 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121704 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121714 */   // GIR_Coverage, 4175,
     /* 121714 */   GIR_EraseRootFromParent_Done,
     /* 121715 */ // Label 2095: @121715
     /* 121715 */ GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(121802), // Rule ID 4176 //
     /* 121720 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121723 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121727 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 121749 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 121749 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 121756 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121771 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121775 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121791 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121796 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121801 */   // GIR_Coverage, 4176,
     /* 121801 */   GIR_EraseRootFromParent_Done,
     /* 121802 */ // Label 2096: @121802
     /* 121802 */ GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(121860), // Rule ID 7112 //
     /* 121807 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121810 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121814 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121821 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121828 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121832 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121839 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15936>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 121842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121844 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121854 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121858 */   GIR_RootConstrainSelectedInstOperands,
     /* 121859 */   // GIR_Coverage, 7112,
     /* 121859 */   GIR_EraseRootFromParent_Done,
     /* 121860 */ // Label 2097: @121860
     /* 121860 */ GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(121918), // Rule ID 7113 //
     /* 121865 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121868 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121872 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121879 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121886 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121890 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121897 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15936>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 121900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121912 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121916 */   GIR_RootConstrainSelectedInstOperands,
     /* 121917 */   // GIR_Coverage, 7113,
     /* 121917 */   GIR_EraseRootFromParent_Done,
     /* 121918 */ // Label 2098: @121918
     /* 121918 */ GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(121979), // Rule ID 7497 //
     /* 121923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 121926 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121929 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121933 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121940 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 121943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121947 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121951 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121958 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15907>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /* 121961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121963 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121968 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121973 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121977 */   GIR_RootConstrainSelectedInstOperands,
     /* 121978 */   // GIR_Coverage, 7497,
     /* 121978 */   GIR_EraseRootFromParent_Done,
     /* 121979 */ // Label 2099: @121979
     /* 121979 */ GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(122010), // Rule ID 6453 //
     /* 121984 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121987 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121995 */   // MIs[0] Rn
     /* 121995 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122003 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 122003 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 122008 */   GIR_RootConstrainSelectedInstOperands,
     /* 122009 */   // GIR_Coverage, 6453,
     /* 122009 */   GIR_Done,
     /* 122010 */ // Label 2100: @122010
     /* 122010 */ GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(122054), // Rule ID 7077 //
     /* 122015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 122018 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122021 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122025 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122032 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122039 */   // MIs[0] ptr
     /* 122039 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122047 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15907>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 122047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 122052 */   GIR_RootConstrainSelectedInstOperands,
     /* 122053 */   // GIR_Coverage, 7077,
     /* 122053 */   GIR_Done,
     /* 122054 */ // Label 2101: @122054
     /* 122054 */ GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(122095), // Rule ID 7108 //
     /* 122059 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122062 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122066 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 122076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122080 */   // MIs[0] ptr
     /* 122080 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122088 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15933>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 122088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 122093 */   GIR_RootConstrainSelectedInstOperands,
     /* 122094 */   // GIR_Coverage, 7108,
     /* 122094 */   GIR_Done,
     /* 122095 */ // Label 2102: @122095
     /* 122095 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(122136), // Rule ID 7109 //
     /* 122100 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122103 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122107 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122114 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122121 */   // MIs[0] ptr
     /* 122121 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122129 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15907>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 122129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 122134 */   GIR_RootConstrainSelectedInstOperands,
     /* 122135 */   // GIR_Coverage, 7109,
     /* 122135 */   GIR_Done,
     /* 122136 */ // Label 2103: @122136
     /* 122136 */ GIM_Reject,
     /* 122137 */ // Label 1992: @122137
     /* 122137 */ GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(122345),
     /* 122142 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122145 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122153 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122157 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(122198), // Rule ID 245 //
     /* 122162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122172 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 122175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122196 */     GIR_RootConstrainSelectedInstOperands,
     /* 122197 */     // GIR_Coverage, 245,
     /* 122197 */     GIR_EraseRootFromParent_Done,
     /* 122198 */   // Label 2105: @122198
     /* 122198 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(122239), // Rule ID 246 //
     /* 122203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122213 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 122216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122237 */     GIR_RootConstrainSelectedInstOperands,
     /* 122238 */     // GIR_Coverage, 246,
     /* 122238 */     GIR_EraseRootFromParent_Done,
     /* 122239 */   // Label 2106: @122239
     /* 122239 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(122275), // Rule ID 265 //
     /* 122244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122254 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 122257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122273 */     GIR_RootConstrainSelectedInstOperands,
     /* 122274 */     // GIR_Coverage, 265,
     /* 122274 */     GIR_EraseRootFromParent_Done,
     /* 122275 */   // Label 2107: @122275
     /* 122275 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(122311), // Rule ID 286 //
     /* 122280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122290 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 122290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 122293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122309 */     GIR_RootConstrainSelectedInstOperands,
     /* 122310 */     // GIR_Coverage, 286,
     /* 122310 */     GIR_EraseRootFromParent_Done,
     /* 122311 */   // Label 2108: @122311
     /* 122311 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(122344), // Rule ID 4142 //
     /* 122316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122323 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 122326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122342 */     GIR_RootConstrainSelectedInstOperands,
     /* 122343 */     // GIR_Coverage, 4142,
     /* 122343 */     GIR_EraseRootFromParent_Done,
     /* 122344 */   // Label 2109: @122344
     /* 122344 */   GIM_Reject,
     /* 122345 */ // Label 2104: @122345
     /* 122345 */ GIM_Reject,
     /* 122346 */ // Label 1993: @122346
     /* 122346 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(122723),
     /* 122351 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122354 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122362 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(122407), // Rule ID 4076 //
     /* 122367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122381 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 122384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122405 */     GIR_RootConstrainSelectedInstOperands,
     /* 122406 */     // GIR_Coverage, 4076,
     /* 122406 */     GIR_EraseRootFromParent_Done,
     /* 122407 */   // Label 2111: @122407
     /* 122407 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(122452), // Rule ID 4077 //
     /* 122412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122426 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 122429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122450 */     GIR_RootConstrainSelectedInstOperands,
     /* 122451 */     // GIR_Coverage, 4077,
     /* 122451 */     GIR_EraseRootFromParent_Done,
     /* 122452 */   // Label 2112: @122452
     /* 122452 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(122497), // Rule ID 4078 //
     /* 122457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122471 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 122474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122495 */     GIR_RootConstrainSelectedInstOperands,
     /* 122496 */     // GIR_Coverage, 4078,
     /* 122496 */     GIR_EraseRootFromParent_Done,
     /* 122497 */   // Label 2113: @122497
     /* 122497 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(122542), // Rule ID 4079 //
     /* 122502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122516 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 122519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122540 */     GIR_RootConstrainSelectedInstOperands,
     /* 122541 */     // GIR_Coverage, 4079,
     /* 122541 */     GIR_EraseRootFromParent_Done,
     /* 122542 */   // Label 2114: @122542
     /* 122542 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(122582), // Rule ID 4128 //
     /* 122547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122561 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122580 */     GIR_RootConstrainSelectedInstOperands,
     /* 122581 */     // GIR_Coverage, 4128,
     /* 122581 */     GIR_EraseRootFromParent_Done,
     /* 122582 */   // Label 2115: @122582
     /* 122582 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(122622), // Rule ID 4131 //
     /* 122587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122601 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122620 */     GIR_RootConstrainSelectedInstOperands,
     /* 122621 */     // GIR_Coverage, 4131,
     /* 122621 */     GIR_EraseRootFromParent_Done,
     /* 122622 */   // Label 2116: @122622
     /* 122622 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(122662), // Rule ID 4156 //
     /* 122627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122641 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 122644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122660 */     GIR_RootConstrainSelectedInstOperands,
     /* 122661 */     // GIR_Coverage, 4156,
     /* 122661 */     GIR_EraseRootFromParent_Done,
     /* 122662 */   // Label 2117: @122662
     /* 122662 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(122702), // Rule ID 4157 //
     /* 122667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122681 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 122684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122700 */     GIR_RootConstrainSelectedInstOperands,
     /* 122701 */     // GIR_Coverage, 4157,
     /* 122701 */     GIR_EraseRootFromParent_Done,
     /* 122702 */   // Label 2118: @122702
     /* 122702 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(122722), // Rule ID 6452 //
     /* 122707 */     // MIs[0] Rn
     /* 122707 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122715 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 122715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 122720 */     GIR_RootConstrainSelectedInstOperands,
     /* 122721 */     // GIR_Coverage, 6452,
     /* 122721 */     GIR_Done,
     /* 122722 */   // Label 2119: @122722
     /* 122722 */   GIM_Reject,
     /* 122723 */ // Label 2110: @122723
     /* 122723 */ GIM_Reject,
     /* 122724 */ // Label 1994: @122724
     /* 122724 */ GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(123101),
     /* 122729 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122732 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122740 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(122785), // Rule ID 4090 //
     /* 122745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122759 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 122762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122783 */     GIR_RootConstrainSelectedInstOperands,
     /* 122784 */     // GIR_Coverage, 4090,
     /* 122784 */     GIR_EraseRootFromParent_Done,
     /* 122785 */   // Label 2121: @122785
     /* 122785 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(122830), // Rule ID 4091 //
     /* 122790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122804 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 122807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122828 */     GIR_RootConstrainSelectedInstOperands,
     /* 122829 */     // GIR_Coverage, 4091,
     /* 122829 */     GIR_EraseRootFromParent_Done,
     /* 122830 */   // Label 2122: @122830
     /* 122830 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(122875), // Rule ID 4092 //
     /* 122835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122849 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 122852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122873 */     GIR_RootConstrainSelectedInstOperands,
     /* 122874 */     // GIR_Coverage, 4092,
     /* 122874 */     GIR_EraseRootFromParent_Done,
     /* 122875 */   // Label 2123: @122875
     /* 122875 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(122920), // Rule ID 4093 //
     /* 122880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122894 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 122897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122918 */     GIR_RootConstrainSelectedInstOperands,
     /* 122919 */     // GIR_Coverage, 4093,
     /* 122919 */     GIR_EraseRootFromParent_Done,
     /* 122920 */   // Label 2124: @122920
     /* 122920 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(122960), // Rule ID 4136 //
     /* 122925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122939 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 122942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122958 */     GIR_RootConstrainSelectedInstOperands,
     /* 122959 */     // GIR_Coverage, 4136,
     /* 122959 */     GIR_EraseRootFromParent_Done,
     /* 122960 */   // Label 2125: @122960
     /* 122960 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(123000), // Rule ID 4140 //
     /* 122965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122979 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 122982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122998 */     GIR_RootConstrainSelectedInstOperands,
     /* 122999 */     // GIR_Coverage, 4140,
     /* 122999 */     GIR_EraseRootFromParent_Done,
     /* 123000 */   // Label 2126: @123000
     /* 123000 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(123040), // Rule ID 4163 //
     /* 123005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123019 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123038 */     GIR_RootConstrainSelectedInstOperands,
     /* 123039 */     // GIR_Coverage, 4163,
     /* 123039 */     GIR_EraseRootFromParent_Done,
     /* 123040 */   // Label 2127: @123040
     /* 123040 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(123080), // Rule ID 4164 //
     /* 123045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123059 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123078 */     GIR_RootConstrainSelectedInstOperands,
     /* 123079 */     // GIR_Coverage, 4164,
     /* 123079 */     GIR_EraseRootFromParent_Done,
     /* 123080 */   // Label 2128: @123080
     /* 123080 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(123100), // Rule ID 6449 //
     /* 123085 */     // MIs[0] Rn
     /* 123085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123093 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 123093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 123098 */     GIR_RootConstrainSelectedInstOperands,
     /* 123099 */     // GIR_Coverage, 6449,
     /* 123099 */     GIR_Done,
     /* 123100 */   // Label 2129: @123100
     /* 123100 */   GIM_Reject,
     /* 123101 */ // Label 2120: @123101
     /* 123101 */ GIM_Reject,
     /* 123102 */ // Label 1995: @123102
     /* 123102 */ GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(123479),
     /* 123107 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123110 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123118 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(123163), // Rule ID 4082 //
     /* 123123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123137 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 123140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123161 */     GIR_RootConstrainSelectedInstOperands,
     /* 123162 */     // GIR_Coverage, 4082,
     /* 123162 */     GIR_EraseRootFromParent_Done,
     /* 123163 */   // Label 2131: @123163
     /* 123163 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(123208), // Rule ID 4083 //
     /* 123168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123182 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 123185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123206 */     GIR_RootConstrainSelectedInstOperands,
     /* 123207 */     // GIR_Coverage, 4083,
     /* 123207 */     GIR_EraseRootFromParent_Done,
     /* 123208 */   // Label 2132: @123208
     /* 123208 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(123253), // Rule ID 4084 //
     /* 123213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123227 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 123230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123251 */     GIR_RootConstrainSelectedInstOperands,
     /* 123252 */     // GIR_Coverage, 4084,
     /* 123252 */     GIR_EraseRootFromParent_Done,
     /* 123253 */   // Label 2133: @123253
     /* 123253 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(123298), // Rule ID 4085 //
     /* 123258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123272 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 123275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123296 */     GIR_RootConstrainSelectedInstOperands,
     /* 123297 */     // GIR_Coverage, 4085,
     /* 123297 */     GIR_EraseRootFromParent_Done,
     /* 123298 */   // Label 2134: @123298
     /* 123298 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(123338), // Rule ID 4130 //
     /* 123303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123317 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 123320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123336 */     GIR_RootConstrainSelectedInstOperands,
     /* 123337 */     // GIR_Coverage, 4130,
     /* 123337 */     GIR_EraseRootFromParent_Done,
     /* 123338 */   // Label 2135: @123338
     /* 123338 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(123378), // Rule ID 4132 //
     /* 123343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123357 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 123360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123376 */     GIR_RootConstrainSelectedInstOperands,
     /* 123377 */     // GIR_Coverage, 4132,
     /* 123377 */     GIR_EraseRootFromParent_Done,
     /* 123378 */   // Label 2136: @123378
     /* 123378 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(123418), // Rule ID 4158 //
     /* 123383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123397 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 123400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123416 */     GIR_RootConstrainSelectedInstOperands,
     /* 123417 */     // GIR_Coverage, 4158,
     /* 123417 */     GIR_EraseRootFromParent_Done,
     /* 123418 */   // Label 2137: @123418
     /* 123418 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(123458), // Rule ID 4160 //
     /* 123423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123437 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 123440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123456 */     GIR_RootConstrainSelectedInstOperands,
     /* 123457 */     // GIR_Coverage, 4160,
     /* 123457 */     GIR_EraseRootFromParent_Done,
     /* 123458 */   // Label 2138: @123458
     /* 123458 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(123478), // Rule ID 6451 //
     /* 123463 */     // MIs[0] Rn
     /* 123463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123471 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 123471 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 123476 */     GIR_RootConstrainSelectedInstOperands,
     /* 123477 */     // GIR_Coverage, 6451,
     /* 123477 */     GIR_Done,
     /* 123478 */   // Label 2139: @123478
     /* 123478 */   GIM_Reject,
     /* 123479 */ // Label 2130: @123479
     /* 123479 */ GIM_Reject,
     /* 123480 */ // Label 1996: @123480
     /* 123480 */ GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(123857),
     /* 123485 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123488 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123496 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(123541), // Rule ID 4094 //
     /* 123501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123515 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 123518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123539 */     GIR_RootConstrainSelectedInstOperands,
     /* 123540 */     // GIR_Coverage, 4094,
     /* 123540 */     GIR_EraseRootFromParent_Done,
     /* 123541 */   // Label 2141: @123541
     /* 123541 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(123586), // Rule ID 4095 //
     /* 123546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123560 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 123563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123584 */     GIR_RootConstrainSelectedInstOperands,
     /* 123585 */     // GIR_Coverage, 4095,
     /* 123585 */     GIR_EraseRootFromParent_Done,
     /* 123586 */   // Label 2142: @123586
     /* 123586 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(123631), // Rule ID 4096 //
     /* 123591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123605 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 123608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123629 */     GIR_RootConstrainSelectedInstOperands,
     /* 123630 */     // GIR_Coverage, 4096,
     /* 123630 */     GIR_EraseRootFromParent_Done,
     /* 123631 */   // Label 2143: @123631
     /* 123631 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(123676), // Rule ID 4097 //
     /* 123636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123650 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 123653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123674 */     GIR_RootConstrainSelectedInstOperands,
     /* 123675 */     // GIR_Coverage, 4097,
     /* 123675 */     GIR_EraseRootFromParent_Done,
     /* 123676 */   // Label 2144: @123676
     /* 123676 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(123716), // Rule ID 4135 //
     /* 123681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123684 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123695 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123714 */     GIR_RootConstrainSelectedInstOperands,
     /* 123715 */     // GIR_Coverage, 4135,
     /* 123715 */     GIR_EraseRootFromParent_Done,
     /* 123716 */   // Label 2145: @123716
     /* 123716 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(123756), // Rule ID 4139 //
     /* 123721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123735 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123754 */     GIR_RootConstrainSelectedInstOperands,
     /* 123755 */     // GIR_Coverage, 4139,
     /* 123755 */     GIR_EraseRootFromParent_Done,
     /* 123756 */   // Label 2146: @123756
     /* 123756 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(123796), // Rule ID 4165 //
     /* 123761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123775 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123794 */     GIR_RootConstrainSelectedInstOperands,
     /* 123795 */     // GIR_Coverage, 4165,
     /* 123795 */     GIR_EraseRootFromParent_Done,
     /* 123796 */   // Label 2147: @123796
     /* 123796 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(123836), // Rule ID 4166 //
     /* 123801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123815 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123834 */     GIR_RootConstrainSelectedInstOperands,
     /* 123835 */     // GIR_Coverage, 4166,
     /* 123835 */     GIR_EraseRootFromParent_Done,
     /* 123836 */   // Label 2148: @123836
     /* 123836 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(123856), // Rule ID 6448 //
     /* 123841 */     // MIs[0] Rn
     /* 123841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123849 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 123849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 123854 */     GIR_RootConstrainSelectedInstOperands,
     /* 123855 */     // GIR_Coverage, 6448,
     /* 123855 */     GIR_Done,
     /* 123856 */   // Label 2149: @123856
     /* 123856 */   GIM_Reject,
     /* 123857 */ // Label 2140: @123857
     /* 123857 */ GIM_Reject,
     /* 123858 */ // Label 1997: @123858
     /* 123858 */ GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(124065),
     /* 123863 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123866 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123874 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(123919), // Rule ID 4080 //
     /* 123879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123893 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 123896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123917 */     GIR_RootConstrainSelectedInstOperands,
     /* 123918 */     // GIR_Coverage, 4080,
     /* 123918 */     GIR_EraseRootFromParent_Done,
     /* 123919 */   // Label 2151: @123919
     /* 123919 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(123964), // Rule ID 4081 //
     /* 123924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123938 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 123941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123962 */     GIR_RootConstrainSelectedInstOperands,
     /* 123963 */     // GIR_Coverage, 4081,
     /* 123963 */     GIR_EraseRootFromParent_Done,
     /* 123964 */   // Label 2152: @123964
     /* 123964 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(124004), // Rule ID 4129 //
     /* 123969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123983 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 123986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124002 */     GIR_RootConstrainSelectedInstOperands,
     /* 124003 */     // GIR_Coverage, 4129,
     /* 124003 */     GIR_EraseRootFromParent_Done,
     /* 124004 */   // Label 2153: @124004
     /* 124004 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(124044), // Rule ID 4159 //
     /* 124009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124023 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 124026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124042 */     GIR_RootConstrainSelectedInstOperands,
     /* 124043 */     // GIR_Coverage, 4159,
     /* 124043 */     GIR_EraseRootFromParent_Done,
     /* 124044 */   // Label 2154: @124044
     /* 124044 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(124064), // Rule ID 6450 //
     /* 124049 */     // MIs[0] Rn
     /* 124049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124057 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 124062 */     GIR_RootConstrainSelectedInstOperands,
     /* 124063 */     // GIR_Coverage, 6450,
     /* 124063 */     GIR_Done,
     /* 124064 */   // Label 2155: @124064
     /* 124064 */   GIM_Reject,
     /* 124065 */ // Label 2150: @124065
     /* 124065 */ GIM_Reject,
     /* 124066 */ // Label 1998: @124066
     /* 124066 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(124443),
     /* 124071 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124074 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124082 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(124127), // Rule ID 4098 //
     /* 124087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124101 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124125 */     GIR_RootConstrainSelectedInstOperands,
     /* 124126 */     // GIR_Coverage, 4098,
     /* 124126 */     GIR_EraseRootFromParent_Done,
     /* 124127 */   // Label 2157: @124127
     /* 124127 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(124172), // Rule ID 4099 //
     /* 124132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124146 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124170 */     GIR_RootConstrainSelectedInstOperands,
     /* 124171 */     // GIR_Coverage, 4099,
     /* 124171 */     GIR_EraseRootFromParent_Done,
     /* 124172 */   // Label 2158: @124172
     /* 124172 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(124217), // Rule ID 4100 //
     /* 124177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124191 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124215 */     GIR_RootConstrainSelectedInstOperands,
     /* 124216 */     // GIR_Coverage, 4100,
     /* 124216 */     GIR_EraseRootFromParent_Done,
     /* 124217 */   // Label 2159: @124217
     /* 124217 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(124262), // Rule ID 4101 //
     /* 124222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124236 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124260 */     GIR_RootConstrainSelectedInstOperands,
     /* 124261 */     // GIR_Coverage, 4101,
     /* 124261 */     GIR_EraseRootFromParent_Done,
     /* 124262 */   // Label 2160: @124262
     /* 124262 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(124302), // Rule ID 4138 //
     /* 124267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124281 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124300 */     GIR_RootConstrainSelectedInstOperands,
     /* 124301 */     // GIR_Coverage, 4138,
     /* 124301 */     GIR_EraseRootFromParent_Done,
     /* 124302 */   // Label 2161: @124302
     /* 124302 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(124342), // Rule ID 4141 //
     /* 124307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124321 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124340 */     GIR_RootConstrainSelectedInstOperands,
     /* 124341 */     // GIR_Coverage, 4141,
     /* 124341 */     GIR_EraseRootFromParent_Done,
     /* 124342 */   // Label 2162: @124342
     /* 124342 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(124382), // Rule ID 4167 //
     /* 124347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124361 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124380 */     GIR_RootConstrainSelectedInstOperands,
     /* 124381 */     // GIR_Coverage, 4167,
     /* 124381 */     GIR_EraseRootFromParent_Done,
     /* 124382 */   // Label 2163: @124382
     /* 124382 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(124422), // Rule ID 4169 //
     /* 124387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124401 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124420 */     GIR_RootConstrainSelectedInstOperands,
     /* 124421 */     // GIR_Coverage, 4169,
     /* 124421 */     GIR_EraseRootFromParent_Done,
     /* 124422 */   // Label 2164: @124422
     /* 124422 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(124442), // Rule ID 6447 //
     /* 124427 */     // MIs[0] Rn
     /* 124427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124435 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 124440 */     GIR_RootConstrainSelectedInstOperands,
     /* 124441 */     // GIR_Coverage, 6447,
     /* 124441 */     GIR_Done,
     /* 124442 */   // Label 2165: @124442
     /* 124442 */   GIM_Reject,
     /* 124443 */ // Label 2156: @124443
     /* 124443 */ GIM_Reject,
     /* 124444 */ // Label 1999: @124444
     /* 124444 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(124651),
     /* 124449 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124452 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124460 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(124505), // Rule ID 4102 //
     /* 124465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124479 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124503 */     GIR_RootConstrainSelectedInstOperands,
     /* 124504 */     // GIR_Coverage, 4102,
     /* 124504 */     GIR_EraseRootFromParent_Done,
     /* 124505 */   // Label 2167: @124505
     /* 124505 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(124550), // Rule ID 4103 //
     /* 124510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124524 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124548 */     GIR_RootConstrainSelectedInstOperands,
     /* 124549 */     // GIR_Coverage, 4103,
     /* 124549 */     GIR_EraseRootFromParent_Done,
     /* 124550 */   // Label 2168: @124550
     /* 124550 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(124590), // Rule ID 4137 //
     /* 124555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124569 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124588 */     GIR_RootConstrainSelectedInstOperands,
     /* 124589 */     // GIR_Coverage, 4137,
     /* 124589 */     GIR_EraseRootFromParent_Done,
     /* 124590 */   // Label 2169: @124590
     /* 124590 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(124630), // Rule ID 4168 //
     /* 124595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124609 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124628 */     GIR_RootConstrainSelectedInstOperands,
     /* 124629 */     // GIR_Coverage, 4168,
     /* 124629 */     GIR_EraseRootFromParent_Done,
     /* 124630 */   // Label 2170: @124630
     /* 124630 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(124650), // Rule ID 6446 //
     /* 124635 */     // MIs[0] Rn
     /* 124635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124643 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 124648 */     GIR_RootConstrainSelectedInstOperands,
     /* 124649 */     // GIR_Coverage, 6446,
     /* 124649 */     GIR_Done,
     /* 124650 */   // Label 2171: @124650
     /* 124650 */   GIM_Reject,
     /* 124651 */ // Label 2166: @124651
     /* 124651 */ GIM_Reject,
     /* 124652 */ // Label 2000: @124652
     /* 124652 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(124715), // Rule ID 11022 //
     /* 124657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124660 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124663 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 124671 */   // MIs[0] base
     /* 124671 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124679 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124679 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124682 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124686 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124691 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 124699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124704 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124709 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124713 */   GIR_RootConstrainSelectedInstOperands,
     /* 124714 */   // GIR_Coverage, 11022,
     /* 124714 */   GIR_EraseRootFromParent_Done,
     /* 124715 */ // Label 2172: @124715
     /* 124715 */ GIM_Reject,
     /* 124716 */ // Label 2001: @124716
     /* 124716 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(124779), // Rule ID 11028 //
     /* 124721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124724 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124727 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 124735 */   // MIs[0] base
     /* 124735 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124743 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124743 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124746 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124750 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124755 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 124763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124765 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124768 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124773 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124777 */   GIR_RootConstrainSelectedInstOperands,
     /* 124778 */   // GIR_Coverage, 11028,
     /* 124778 */   GIR_EraseRootFromParent_Done,
     /* 124779 */ // Label 2173: @124779
     /* 124779 */ GIM_Reject,
     /* 124780 */ // Label 2002: @124780
     /* 124780 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(124953),
     /* 124785 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124788 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 124796 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124800 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(124848), // Rule ID 11013 //
     /* 124805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124812 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124824 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 124832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124837 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124846 */     GIR_RootConstrainSelectedInstOperands,
     /* 124847 */     // GIR_Coverage, 11013,
     /* 124847 */     GIR_EraseRootFromParent_Done,
     /* 124848 */   // Label 2175: @124848
     /* 124848 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(124896), // Rule ID 11031 //
     /* 124853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124860 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124872 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 124880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124885 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124894 */     GIR_RootConstrainSelectedInstOperands,
     /* 124895 */     // GIR_Coverage, 11031,
     /* 124895 */     GIR_EraseRootFromParent_Done,
     /* 124896 */   // Label 2176: @124896
     /* 124896 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(124924), // Rule ID 11058 //
     /* 124901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124908 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 124911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124913 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124922 */     GIR_RootConstrainSelectedInstOperands,
     /* 124923 */     // GIR_Coverage, 11058,
     /* 124923 */     GIR_EraseRootFromParent_Done,
     /* 124924 */   // Label 2177: @124924
     /* 124924 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(124952), // Rule ID 11070 //
     /* 124929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124936 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 124939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 124941 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124950 */     GIR_RootConstrainSelectedInstOperands,
     /* 124951 */     // GIR_Coverage, 11070,
     /* 124951 */     GIR_EraseRootFromParent_Done,
     /* 124952 */   // Label 2178: @124952
     /* 124952 */   GIM_Reject,
     /* 124953 */ // Label 2174: @124953
     /* 124953 */ GIM_Reject,
     /* 124954 */ // Label 2003: @124954
     /* 124954 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(125017), // Rule ID 11019 //
     /* 124959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124962 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124965 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 124973 */   // MIs[0] base
     /* 124973 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124981 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124981 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124984 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 124988 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124993 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 125001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125006 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125011 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125015 */   GIR_RootConstrainSelectedInstOperands,
     /* 125016 */   // GIR_Coverage, 11019,
     /* 125016 */   GIR_EraseRootFromParent_Done,
     /* 125017 */ // Label 2179: @125017
     /* 125017 */ GIM_Reject,
     /* 125018 */ // Label 2004: @125018
     /* 125018 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(125191),
     /* 125023 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125026 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 125034 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125038 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(125086), // Rule ID 11001 //
     /* 125043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125050 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125062 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 125070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125075 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125084 */     GIR_RootConstrainSelectedInstOperands,
     /* 125085 */     // GIR_Coverage, 11001,
     /* 125085 */     GIR_EraseRootFromParent_Done,
     /* 125086 */   // Label 2181: @125086
     /* 125086 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(125134), // Rule ID 11025 //
     /* 125091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125098 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125110 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 125118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125123 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125132 */     GIR_RootConstrainSelectedInstOperands,
     /* 125133 */     // GIR_Coverage, 11025,
     /* 125133 */     GIR_EraseRootFromParent_Done,
     /* 125134 */   // Label 2182: @125134
     /* 125134 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(125162), // Rule ID 11054 //
     /* 125139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125146 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125151 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125160 */     GIR_RootConstrainSelectedInstOperands,
     /* 125161 */     // GIR_Coverage, 11054,
     /* 125161 */     GIR_EraseRootFromParent_Done,
     /* 125162 */   // Label 2183: @125162
     /* 125162 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(125190), // Rule ID 11066 //
     /* 125167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125174 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125179 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125188 */     GIR_RootConstrainSelectedInstOperands,
     /* 125189 */     // GIR_Coverage, 11066,
     /* 125189 */     GIR_EraseRootFromParent_Done,
     /* 125190 */   // Label 2184: @125190
     /* 125190 */   GIM_Reject,
     /* 125191 */ // Label 2180: @125191
     /* 125191 */ GIM_Reject,
     /* 125192 */ // Label 2005: @125192
     /* 125192 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(125365),
     /* 125197 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125200 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 125208 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125212 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(125260), // Rule ID 10980 //
     /* 125217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125224 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 125231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125236 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 125244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125249 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125258 */     GIR_RootConstrainSelectedInstOperands,
     /* 125259 */     // GIR_Coverage, 10980,
     /* 125259 */     GIR_EraseRootFromParent_Done,
     /* 125260 */   // Label 2186: @125260
     /* 125260 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(125308), // Rule ID 11016 //
     /* 125265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125272 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 125279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125284 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 125292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125297 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125306 */     GIR_RootConstrainSelectedInstOperands,
     /* 125307 */     // GIR_Coverage, 11016,
     /* 125307 */     GIR_EraseRootFromParent_Done,
     /* 125308 */   // Label 2187: @125308
     /* 125308 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(125336), // Rule ID 11050 //
     /* 125313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125320 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125325 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125334 */     GIR_RootConstrainSelectedInstOperands,
     /* 125335 */     // GIR_Coverage, 11050,
     /* 125335 */     GIR_EraseRootFromParent_Done,
     /* 125336 */   // Label 2188: @125336
     /* 125336 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(125364), // Rule ID 11062 //
     /* 125341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125348 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125353 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125362 */     GIR_RootConstrainSelectedInstOperands,
     /* 125363 */     // GIR_Coverage, 11062,
     /* 125363 */     GIR_EraseRootFromParent_Done,
     /* 125364 */   // Label 2189: @125364
     /* 125364 */   GIM_Reject,
     /* 125365 */ // Label 2185: @125365
     /* 125365 */ GIM_Reject,
     /* 125366 */ // Label 2006: @125366
     /* 125366 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(125409), // Rule ID 2428 //
     /* 125371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125374 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125377 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 125385 */   // MIs[0] base
     /* 125385 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125393 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 125396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 125398 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125403 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125407 */   GIR_RootConstrainSelectedInstOperands,
     /* 125408 */   // GIR_Coverage, 2428,
     /* 125408 */   GIR_EraseRootFromParent_Done,
     /* 125409 */ // Label 2190: @125409
     /* 125409 */ GIM_Reject,
     /* 125410 */ // Label 2007: @125410
     /* 125410 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(125507),
     /* 125415 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125418 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 125426 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125430 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(125478), // Rule ID 10948 //
     /* 125435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125442 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 125449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125454 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 125462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125467 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125476 */     GIR_RootConstrainSelectedInstOperands,
     /* 125477 */     // GIR_Coverage, 10948,
     /* 125477 */     GIR_EraseRootFromParent_Done,
     /* 125478 */   // Label 2192: @125478
     /* 125478 */   GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(125506), // Rule ID 11046 //
     /* 125483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125490 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 125493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 125495 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125504 */     GIR_RootConstrainSelectedInstOperands,
     /* 125505 */     // GIR_Coverage, 11046,
     /* 125505 */     GIR_EraseRootFromParent_Done,
     /* 125506 */   // Label 2193: @125506
     /* 125506 */   GIM_Reject,
     /* 125507 */ // Label 2191: @125507
     /* 125507 */ GIM_Reject,
     /* 125508 */ // Label 2008: @125508
     /* 125508 */ GIM_Reject,
     /* 125509 */ // Label 17: @125509
     /* 125509 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2196*/ GIMT_Encode4(126558),
     /* 125520 */ /*GILLT_s32*//*Label 2194*/ GIMT_Encode4(125528),
     /* 125524 */ /*GILLT_s64*//*Label 2195*/ GIMT_Encode4(125942),
     /* 125528 */ // Label 2194: @125528
     /* 125528 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(125941),
     /* 125533 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125536 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(125589), // Rule ID 247 //
     /* 125541 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 125563 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 125563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 125566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125587 */     GIR_RootConstrainSelectedInstOperands,
     /* 125588 */     // GIR_Coverage, 247,
     /* 125588 */     GIR_EraseRootFromParent_Done,
     /* 125589 */   // Label 2198: @125589
     /* 125589 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(125642), // Rule ID 248 //
     /* 125594 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 125616 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 125616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 125619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125640 */     GIR_RootConstrainSelectedInstOperands,
     /* 125641 */     // GIR_Coverage, 248,
     /* 125641 */     GIR_EraseRootFromParent_Done,
     /* 125642 */   // Label 2199: @125642
     /* 125642 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(125695), // Rule ID 251 //
     /* 125647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 125669 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 125669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 125672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125693 */     GIR_RootConstrainSelectedInstOperands,
     /* 125694 */     // GIR_Coverage, 251,
     /* 125694 */     GIR_EraseRootFromParent_Done,
     /* 125695 */   // Label 2200: @125695
     /* 125695 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(125748), // Rule ID 252 //
     /* 125700 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 125722 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 125722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 125725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125746 */     GIR_RootConstrainSelectedInstOperands,
     /* 125747 */     // GIR_Coverage, 252,
     /* 125747 */     GIR_EraseRootFromParent_Done,
     /* 125748 */   // Label 2201: @125748
     /* 125748 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(125796), // Rule ID 268 //
     /* 125753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 125775 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 125775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 125778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125794 */     GIR_RootConstrainSelectedInstOperands,
     /* 125795 */     // GIR_Coverage, 268,
     /* 125795 */     GIR_EraseRootFromParent_Done,
     /* 125796 */   // Label 2202: @125796
     /* 125796 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(125844), // Rule ID 270 //
     /* 125801 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 125823 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 125823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 125826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125842 */     GIR_RootConstrainSelectedInstOperands,
     /* 125843 */     // GIR_Coverage, 270,
     /* 125843 */     GIR_EraseRootFromParent_Done,
     /* 125844 */   // Label 2203: @125844
     /* 125844 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(125892), // Rule ID 289 //
     /* 125849 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 125871 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 125871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 125874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125890 */     GIR_RootConstrainSelectedInstOperands,
     /* 125891 */     // GIR_Coverage, 289,
     /* 125891 */     GIR_EraseRootFromParent_Done,
     /* 125892 */   // Label 2204: @125892
     /* 125892 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(125940), // Rule ID 291 //
     /* 125897 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 125904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 125919 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 125919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 125922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125938 */     GIR_RootConstrainSelectedInstOperands,
     /* 125939 */     // GIR_Coverage, 291,
     /* 125939 */     GIR_EraseRootFromParent_Done,
     /* 125940 */   // Label 2205: @125940
     /* 125940 */   GIM_Reject,
     /* 125941 */ // Label 2197: @125941
     /* 125941 */ GIM_Reject,
     /* 125942 */ // Label 2195: @125942
     /* 125942 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(126557),
     /* 125947 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125950 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(126003), // Rule ID 249 //
     /* 125955 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 125977 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 125977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 125980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126001 */     GIR_RootConstrainSelectedInstOperands,
     /* 126002 */     // GIR_Coverage, 249,
     /* 126002 */     GIR_EraseRootFromParent_Done,
     /* 126003 */   // Label 2207: @126003
     /* 126003 */   GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(126056), // Rule ID 250 //
     /* 126008 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 126030 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 126030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 126033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126054 */     GIR_RootConstrainSelectedInstOperands,
     /* 126055 */     // GIR_Coverage, 250,
     /* 126055 */     GIR_EraseRootFromParent_Done,
     /* 126056 */   // Label 2208: @126056
     /* 126056 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(126109), // Rule ID 253 //
     /* 126061 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 126083 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 126083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 126086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126107 */     GIR_RootConstrainSelectedInstOperands,
     /* 126108 */     // GIR_Coverage, 253,
     /* 126108 */     GIR_EraseRootFromParent_Done,
     /* 126109 */   // Label 2209: @126109
     /* 126109 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(126162), // Rule ID 254 //
     /* 126114 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 126136 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 126136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 126139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126160 */     GIR_RootConstrainSelectedInstOperands,
     /* 126161 */     // GIR_Coverage, 254,
     /* 126161 */     GIR_EraseRootFromParent_Done,
     /* 126162 */   // Label 2210: @126162
     /* 126162 */   GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(126215), // Rule ID 255 //
     /* 126167 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 126189 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 126189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 126192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126213 */     GIR_RootConstrainSelectedInstOperands,
     /* 126214 */     // GIR_Coverage, 255,
     /* 126214 */     GIR_EraseRootFromParent_Done,
     /* 126215 */   // Label 2211: @126215
     /* 126215 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(126268), // Rule ID 256 //
     /* 126220 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 126242 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 126242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 126245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126266 */     GIR_RootConstrainSelectedInstOperands,
     /* 126267 */     // GIR_Coverage, 256,
     /* 126267 */     GIR_EraseRootFromParent_Done,
     /* 126268 */   // Label 2212: @126268
     /* 126268 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(126316), // Rule ID 269 //
     /* 126273 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 126295 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 126295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 126298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126314 */     GIR_RootConstrainSelectedInstOperands,
     /* 126315 */     // GIR_Coverage, 269,
     /* 126315 */     GIR_EraseRootFromParent_Done,
     /* 126316 */   // Label 2213: @126316
     /* 126316 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(126364), // Rule ID 271 //
     /* 126321 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 126343 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 126343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 126346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126362 */     GIR_RootConstrainSelectedInstOperands,
     /* 126363 */     // GIR_Coverage, 271,
     /* 126363 */     GIR_EraseRootFromParent_Done,
     /* 126364 */   // Label 2214: @126364
     /* 126364 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(126412), // Rule ID 272 //
     /* 126369 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 126391 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 126391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 126394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126410 */     GIR_RootConstrainSelectedInstOperands,
     /* 126411 */     // GIR_Coverage, 272,
     /* 126411 */     GIR_EraseRootFromParent_Done,
     /* 126412 */   // Label 2215: @126412
     /* 126412 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(126460), // Rule ID 290 //
     /* 126417 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 126439 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 126439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 126442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126458 */     GIR_RootConstrainSelectedInstOperands,
     /* 126459 */     // GIR_Coverage, 290,
     /* 126459 */     GIR_EraseRootFromParent_Done,
     /* 126460 */   // Label 2216: @126460
     /* 126460 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(126508), // Rule ID 292 //
     /* 126465 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 126487 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 126487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 126490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126506 */     GIR_RootConstrainSelectedInstOperands,
     /* 126507 */     // GIR_Coverage, 292,
     /* 126507 */     GIR_EraseRootFromParent_Done,
     /* 126508 */   // Label 2217: @126508
     /* 126508 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(126556), // Rule ID 293 //
     /* 126513 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 126535 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 126535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 126538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126554 */     GIR_RootConstrainSelectedInstOperands,
     /* 126555 */     // GIR_Coverage, 293,
     /* 126555 */     GIR_EraseRootFromParent_Done,
     /* 126556 */   // Label 2218: @126556
     /* 126556 */   GIM_Reject,
     /* 126557 */ // Label 2206: @126557
     /* 126557 */ GIM_Reject,
     /* 126558 */ // Label 2196: @126558
     /* 126558 */ GIM_Reject,
     /* 126559 */ // Label 18: @126559
     /* 126559 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2221*/ GIMT_Encode4(129607),
     /* 126570 */ /*GILLT_s32*//*Label 2219*/ GIMT_Encode4(126578),
     /* 126574 */ /*GILLT_s64*//*Label 2220*/ GIMT_Encode4(128117),
     /* 126578 */ // Label 2219: @126578
     /* 126578 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(126634), // Rule ID 229 //
     /* 126583 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126586 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126597 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126601 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 126608 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 126608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 126611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126628 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126632 */   GIR_RootConstrainSelectedInstOperands,
     /* 126633 */   // GIR_Coverage, 229,
     /* 126633 */   GIR_EraseRootFromParent_Done,
     /* 126634 */ // Label 2222: @126634
     /* 126634 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(126690), // Rule ID 230 //
     /* 126639 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126642 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126653 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126657 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 126664 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 126664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 126667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126669 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126684 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126688 */   GIR_RootConstrainSelectedInstOperands,
     /* 126689 */   // GIR_Coverage, 230,
     /* 126689 */   GIR_EraseRootFromParent_Done,
     /* 126690 */ // Label 2223: @126690
     /* 126690 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(126746), // Rule ID 231 //
     /* 126695 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126698 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126709 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126713 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 126720 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 126720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 126723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126730 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126735 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126740 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126744 */   GIR_RootConstrainSelectedInstOperands,
     /* 126745 */   // GIR_Coverage, 231,
     /* 126745 */   GIR_EraseRootFromParent_Done,
     /* 126746 */ // Label 2224: @126746
     /* 126746 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(126802), // Rule ID 232 //
     /* 126751 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126754 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126765 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126769 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 126776 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 126776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 126779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126786 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126796 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126800 */   GIR_RootConstrainSelectedInstOperands,
     /* 126801 */   // GIR_Coverage, 232,
     /* 126801 */   GIR_EraseRootFromParent_Done,
     /* 126802 */ // Label 2225: @126802
     /* 126802 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(126858), // Rule ID 4126 //
     /* 126807 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126810 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126821 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126825 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 126832 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 126832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 126835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126837 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126856 */   GIR_RootConstrainSelectedInstOperands,
     /* 126857 */   // GIR_Coverage, 4126,
     /* 126857 */   GIR_EraseRootFromParent_Done,
     /* 126858 */ // Label 2226: @126858
     /* 126858 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(126914), // Rule ID 4127 //
     /* 126863 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126866 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126877 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126881 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 126888 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 126888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 126891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126908 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126912 */   GIR_RootConstrainSelectedInstOperands,
     /* 126913 */   // GIR_Coverage, 4127,
     /* 126913 */   GIR_EraseRootFromParent_Done,
     /* 126914 */ // Label 2227: @126914
     /* 126914 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(126965), // Rule ID 266 //
     /* 126919 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126922 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126933 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126937 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 126944 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 126944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 126947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126954 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126959 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126963 */   GIR_RootConstrainSelectedInstOperands,
     /* 126964 */   // GIR_Coverage, 266,
     /* 126964 */   GIR_EraseRootFromParent_Done,
     /* 126965 */ // Label 2228: @126965
     /* 126965 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(127016), // Rule ID 267 //
     /* 126970 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126973 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126984 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126988 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 126995 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 126995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 126998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127010 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127014 */   GIR_RootConstrainSelectedInstOperands,
     /* 127015 */   // GIR_Coverage, 267,
     /* 127015 */   GIR_EraseRootFromParent_Done,
     /* 127016 */ // Label 2229: @127016
     /* 127016 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(127075), // Rule ID 7083 //
     /* 127021 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127024 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127031 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127038 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127042 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 127049 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15912>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 127049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 127052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 127069 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127073 */   GIR_RootConstrainSelectedInstOperands,
     /* 127074 */   // GIR_Coverage, 7083,
     /* 127074 */   GIR_EraseRootFromParent_Done,
     /* 127075 */ // Label 2230: @127075
     /* 127075 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(127134), // Rule ID 7085 //
     /* 127080 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127083 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127090 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127097 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127101 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 127108 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15912>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 127108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 127111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127118 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 127128 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127132 */   GIR_RootConstrainSelectedInstOperands,
     /* 127133 */   // GIR_Coverage, 7085,
     /* 127133 */   GIR_EraseRootFromParent_Done,
     /* 127134 */ // Label 2231: @127134
     /* 127134 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(127193), // Rule ID 7095 //
     /* 127139 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127142 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127149 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127156 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127160 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 127167 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15920>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 127167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 127170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127172 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127177 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127187 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127191 */   GIR_RootConstrainSelectedInstOperands,
     /* 127192 */   // GIR_Coverage, 7095,
     /* 127192 */   GIR_EraseRootFromParent_Done,
     /* 127193 */ // Label 2232: @127193
     /* 127193 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(127252), // Rule ID 7097 //
     /* 127198 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127201 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127208 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127215 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127219 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 127226 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15920>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 127226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 127229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127236 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127246 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127250 */   GIR_RootConstrainSelectedInstOperands,
     /* 127251 */   // GIR_Coverage, 7097,
     /* 127251 */   GIR_EraseRootFromParent_Done,
     /* 127252 */ // Label 2233: @127252
     /* 127252 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(127303), // Rule ID 287 //
     /* 127257 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127260 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127271 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127275 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127282 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 127282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 127285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127297 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127301 */   GIR_RootConstrainSelectedInstOperands,
     /* 127302 */   // GIR_Coverage, 287,
     /* 127302 */   GIR_EraseRootFromParent_Done,
     /* 127303 */ // Label 2234: @127303
     /* 127303 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(127354), // Rule ID 288 //
     /* 127308 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127311 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127322 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127326 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127333 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 127333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 127336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127348 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127352 */   GIR_RootConstrainSelectedInstOperands,
     /* 127353 */   // GIR_Coverage, 288,
     /* 127353 */   GIR_EraseRootFromParent_Done,
     /* 127354 */ // Label 2235: @127354
     /* 127354 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(127405), // Rule ID 4145 //
     /* 127359 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127362 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127373 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127377 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127384 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 127387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127399 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127403 */   GIR_RootConstrainSelectedInstOperands,
     /* 127404 */   // GIR_Coverage, 4145,
     /* 127404 */   GIR_EraseRootFromParent_Done,
     /* 127405 */ // Label 2236: @127405
     /* 127405 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(127456), // Rule ID 4177 //
     /* 127410 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127413 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127424 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127428 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127435 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 127438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127450 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127454 */   GIR_RootConstrainSelectedInstOperands,
     /* 127455 */   // GIR_Coverage, 4177,
     /* 127455 */   GIR_EraseRootFromParent_Done,
     /* 127456 */ // Label 2237: @127456
     /* 127456 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(127507), // Rule ID 4178 //
     /* 127461 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127464 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127475 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127479 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127486 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 127489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127501 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127505 */   GIR_RootConstrainSelectedInstOperands,
     /* 127506 */   // GIR_Coverage, 4178,
     /* 127506 */   GIR_EraseRootFromParent_Done,
     /* 127507 */ // Label 2238: @127507
     /* 127507 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(127558), // Rule ID 4179 //
     /* 127512 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127515 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127526 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127530 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127537 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 127540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127542 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127547 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127552 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127556 */   GIR_RootConstrainSelectedInstOperands,
     /* 127557 */   // GIR_Coverage, 4179,
     /* 127557 */   GIR_EraseRootFromParent_Done,
     /* 127558 */ // Label 2239: @127558
     /* 127558 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(127612), // Rule ID 7087 //
     /* 127563 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127566 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127573 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127580 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127584 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127591 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15912>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 127594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127601 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127606 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127610 */   GIR_RootConstrainSelectedInstOperands,
     /* 127611 */   // GIR_Coverage, 7087,
     /* 127611 */   GIR_EraseRootFromParent_Done,
     /* 127612 */ // Label 2240: @127612
     /* 127612 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(127666), // Rule ID 7089 //
     /* 127617 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127620 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127627 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127634 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127638 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127645 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15912>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 127648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127660 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127664 */   GIR_RootConstrainSelectedInstOperands,
     /* 127665 */   // GIR_Coverage, 7089,
     /* 127665 */   GIR_EraseRootFromParent_Done,
     /* 127666 */ // Label 2241: @127666
     /* 127666 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(127720), // Rule ID 7099 //
     /* 127671 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127674 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127681 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127688 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127692 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 127699 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15920>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 127699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 127702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127714 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127718 */   GIR_RootConstrainSelectedInstOperands,
     /* 127719 */   // GIR_Coverage, 7099,
     /* 127719 */   GIR_EraseRootFromParent_Done,
     /* 127720 */ // Label 2242: @127720
     /* 127720 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(127774), // Rule ID 7101 //
     /* 127725 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127728 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127735 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127742 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127746 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127753 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15920>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 127756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127758 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127768 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127772 */   GIR_RootConstrainSelectedInstOperands,
     /* 127773 */   // GIR_Coverage, 7101,
     /* 127773 */   GIR_EraseRootFromParent_Done,
     /* 127774 */ // Label 2243: @127774
     /* 127774 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(127831), // Rule ID 7493 //
     /* 127779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 127782 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127785 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127792 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127799 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127803 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127810 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15901>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 127813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127825 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127829 */   GIR_RootConstrainSelectedInstOperands,
     /* 127830 */   // GIR_Coverage, 7493,
     /* 127830 */   GIR_EraseRootFromParent_Done,
     /* 127831 */ // Label 2244: @127831
     /* 127831 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(127888), // Rule ID 7495 //
     /* 127836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 127839 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127842 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127849 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127856 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127860 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127867 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15903>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 127867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 127870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127882 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127886 */   GIR_RootConstrainSelectedInstOperands,
     /* 127887 */   // GIR_Coverage, 7495,
     /* 127887 */   GIR_EraseRootFromParent_Done,
     /* 127888 */ // Label 2245: @127888
     /* 127888 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(127928), // Rule ID 7073 //
     /* 127893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 127896 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127899 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127906 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127913 */   // MIs[0] ptr
     /* 127913 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127921 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15901>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 127921 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 127926 */   GIR_RootConstrainSelectedInstOperands,
     /* 127927 */   // GIR_Coverage, 7073,
     /* 127927 */   GIR_Done,
     /* 127928 */ // Label 2246: @127928
     /* 127928 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(127968), // Rule ID 7075 //
     /* 127933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 127936 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127946 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127953 */   // MIs[0] ptr
     /* 127953 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127961 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15903>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 127961 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 127966 */   GIR_RootConstrainSelectedInstOperands,
     /* 127967 */   // GIR_Coverage, 7075,
     /* 127967 */   GIR_Done,
     /* 127968 */ // Label 2247: @127968
     /* 127968 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(128005), // Rule ID 7079 //
     /* 127973 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 127976 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127983 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127990 */   // MIs[0] ptr
     /* 127990 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127998 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15909>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 127998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 128003 */   GIR_RootConstrainSelectedInstOperands,
     /* 128004 */   // GIR_Coverage, 7079,
     /* 128004 */   GIR_Done,
     /* 128005 */ // Label 2248: @128005
     /* 128005 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(128042), // Rule ID 7081 //
     /* 128010 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128013 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128020 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128027 */   // MIs[0] ptr
     /* 128027 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128035 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15901>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128035 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 128040 */   GIR_RootConstrainSelectedInstOperands,
     /* 128041 */   // GIR_Coverage, 7081,
     /* 128041 */   GIR_Done,
     /* 128042 */ // Label 2249: @128042
     /* 128042 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(128079), // Rule ID 7091 //
     /* 128047 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128050 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128057 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128064 */   // MIs[0] ptr
     /* 128064 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128072 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15917>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128072 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 128077 */   GIR_RootConstrainSelectedInstOperands,
     /* 128078 */   // GIR_Coverage, 7091,
     /* 128078 */   GIR_Done,
     /* 128079 */ // Label 2250: @128079
     /* 128079 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(128116), // Rule ID 7093 //
     /* 128084 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128087 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128094 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128101 */   // MIs[0] ptr
     /* 128101 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128109 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15903>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 128109 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 128114 */   GIR_RootConstrainSelectedInstOperands,
     /* 128115 */   // GIR_Coverage, 7093,
     /* 128115 */   GIR_Done,
     /* 128116 */ // Label 2251: @128116
     /* 128116 */ GIM_Reject,
     /* 128117 */ // Label 2220: @128117
     /* 128117 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(129606),
     /* 128122 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128125 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(128210), // Rule ID 4104 //
     /* 128130 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128152 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128179 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128209 */     // GIR_Coverage, 4104,
     /* 128209 */     GIR_EraseRootFromParent_Done,
     /* 128210 */   // Label 2253: @128210
     /* 128210 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(128295), // Rule ID 4105 //
     /* 128215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128237 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128264 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128294 */     // GIR_Coverage, 4105,
     /* 128294 */     GIR_EraseRootFromParent_Done,
     /* 128295 */   // Label 2254: @128295
     /* 128295 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(128380), // Rule ID 4106 //
     /* 128300 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 128322 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 128329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128349 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128374 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128379 */     // GIR_Coverage, 4106,
     /* 128379 */     GIR_EraseRootFromParent_Done,
     /* 128380 */   // Label 2255: @128380
     /* 128380 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(128465), // Rule ID 4107 //
     /* 128385 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 128407 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 128414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128434 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128464 */     // GIR_Coverage, 4107,
     /* 128464 */     GIR_EraseRootFromParent_Done,
     /* 128465 */   // Label 2256: @128465
     /* 128465 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(128550), // Rule ID 4108 //
     /* 128470 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 128492 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 128499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128519 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128549 */     // GIR_Coverage, 4108,
     /* 128549 */     GIR_EraseRootFromParent_Done,
     /* 128550 */   // Label 2257: @128550
     /* 128550 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(128635), // Rule ID 4109 //
     /* 128555 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 128577 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 128584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128604 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128634 */     // GIR_Coverage, 4109,
     /* 128634 */     GIR_EraseRootFromParent_Done,
     /* 128635 */   // Label 2258: @128635
     /* 128635 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(128720), // Rule ID 4110 //
     /* 128640 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128662 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128689 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128719 */     // GIR_Coverage, 4110,
     /* 128719 */     GIR_EraseRootFromParent_Done,
     /* 128720 */   // Label 2259: @128720
     /* 128720 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(128805), // Rule ID 4111 //
     /* 128725 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128747 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 128747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128774 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128804 */     // GIR_Coverage, 4111,
     /* 128804 */     GIR_EraseRootFromParent_Done,
     /* 128805 */   // Label 2260: @128805
     /* 128805 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(128885), // Rule ID 4143 //
     /* 128810 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 128832 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 128832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 128839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128854 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128874 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128884 */     // GIR_Coverage, 4143,
     /* 128884 */     GIR_EraseRootFromParent_Done,
     /* 128885 */   // Label 2261: @128885
     /* 128885 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(128965), // Rule ID 4144 //
     /* 128890 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 128912 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 128912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 128919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128934 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 128943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 128954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128959 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128964 */     // GIR_Coverage, 4144,
     /* 128964 */     GIR_EraseRootFromParent_Done,
     /* 128965 */   // Label 2262: @128965
     /* 128965 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(129045), // Rule ID 4146 //
     /* 128970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 128981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 128992 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 128992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 128999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129014 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129044 */     // GIR_Coverage, 4146,
     /* 129044 */     GIR_EraseRootFromParent_Done,
     /* 129045 */   // Label 2263: @129045
     /* 129045 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(129125), // Rule ID 4154 //
     /* 129050 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 129072 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 129072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 129079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129094 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129124 */     // GIR_Coverage, 4154,
     /* 129124 */     GIR_EraseRootFromParent_Done,
     /* 129125 */   // Label 2264: @129125
     /* 129125 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(129205), // Rule ID 4180 //
     /* 129130 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 129152 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 129159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129174 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129194 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129204 */     // GIR_Coverage, 4180,
     /* 129204 */     GIR_EraseRootFromParent_Done,
     /* 129205 */   // Label 2265: @129205
     /* 129205 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(129285), // Rule ID 4181 //
     /* 129210 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129232 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129254 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129274 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129284 */     // GIR_Coverage, 4181,
     /* 129284 */     GIR_EraseRootFromParent_Done,
     /* 129285 */   // Label 2266: @129285
     /* 129285 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(129365), // Rule ID 4182 //
     /* 129290 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129312 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129334 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129354 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129359 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129364 */     // GIR_Coverage, 4182,
     /* 129364 */     GIR_EraseRootFromParent_Done,
     /* 129365 */   // Label 2267: @129365
     /* 129365 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(129445), // Rule ID 4183 //
     /* 129370 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129392 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129414 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129444 */     // GIR_Coverage, 4183,
     /* 129444 */     GIR_EraseRootFromParent_Done,
     /* 129445 */   // Label 2268: @129445
     /* 129445 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(129525), // Rule ID 4184 //
     /* 129450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129472 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129494 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129524 */     // GIR_Coverage, 4184,
     /* 129524 */     GIR_EraseRootFromParent_Done,
     /* 129525 */   // Label 2269: @129525
     /* 129525 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(129605), // Rule ID 4185 //
     /* 129530 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129552 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 129552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129574 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129594 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129604 */     // GIR_Coverage, 4185,
     /* 129604 */     GIR_EraseRootFromParent_Done,
     /* 129605 */   // Label 2270: @129605
     /* 129605 */   GIM_Reject,
     /* 129606 */ // Label 2252: @129606
     /* 129606 */ GIM_Reject,
     /* 129607 */ // Label 2221: @129607
     /* 129607 */ GIM_Reject,
     /* 129608 */ // Label 19: @129608
     /* 129608 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2291*/ GIMT_Encode4(143133),
     /* 129619 */ /*GILLT_s8*//*Label 2271*/ GIMT_Encode4(129715),
     /* 129623 */ /*GILLT_s16*//*Label 2272*/ GIMT_Encode4(130082),
     /* 129627 */ /*GILLT_s32*//*Label 2273*/ GIMT_Encode4(131221),
     /* 129631 */ /*GILLT_s64*//*Label 2274*/ GIMT_Encode4(135816),
     /* 129635 */ /*GILLT_s128*//*Label 2275*/ GIMT_Encode4(139585),
     /* 129639 */ /*GILLT_v2s32*//*Label 2276*/ GIMT_Encode4(139791),
     /* 129643 */ /*GILLT_v2s64*//*Label 2277*/ GIMT_Encode4(140197),
     /* 129647 */ /*GILLT_v4s16*//*Label 2278*/ GIMT_Encode4(140647),
     /* 129651 */ /*GILLT_v4s32*//*Label 2279*/ GIMT_Encode4(141053),
     /* 129655 */ /*GILLT_v8s8*//*Label 2280*/ GIMT_Encode4(141459),
     /* 129659 */ /*GILLT_v8s16*//*Label 2281*/ GIMT_Encode4(141679),
     /* 129663 */ /*GILLT_v16s8*//*Label 2282*/ GIMT_Encode4(142085), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129675 */ /*GILLT_nxv2s16*//*Label 2283*/ GIMT_Encode4(142305),
     /* 129679 */ /*GILLT_nxv2s32*//*Label 2284*/ GIMT_Encode4(142365),
     /* 129683 */ /*GILLT_nxv2s64*//*Label 2285*/ GIMT_Encode4(142425), GIMT_Encode4(0),
     /* 129691 */ /*GILLT_nxv4s16*//*Label 2286*/ GIMT_Encode4(142595),
     /* 129695 */ /*GILLT_nxv4s32*//*Label 2287*/ GIMT_Encode4(142655), GIMT_Encode4(0),
     /* 129703 */ /*GILLT_nxv8s16*//*Label 2288*/ GIMT_Encode4(142825),
     /* 129707 */ /*GILLT_nxv16s1*//*Label 2289*/ GIMT_Encode4(142995),
     /* 129711 */ /*GILLT_nxv16s8*//*Label 2290*/ GIMT_Encode4(143039),
     /* 129715 */ // Label 2271: @129715
     /* 129715 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(130081),
     /* 129720 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129723 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 129727 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(129795), // Rule ID 13270 //
     /* 129732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 129736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 129740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 129744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 129753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 129757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129761 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 129765 */     // MIs[2] Operand 1
     /* 129765 */     // No operand predicates
     /* 129765 */     // MIs[0] Rn
     /* 129765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 129775 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 129775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 129778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 129782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 129785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 129793 */     GIR_RootConstrainSelectedInstOperands,
     /* 129794 */     // GIR_Coverage, 13270,
     /* 129794 */     GIR_EraseRootFromParent_Done,
     /* 129795 */   // Label 2293: @129795
     /* 129795 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(129894), // Rule ID 13271 //
     /* 129800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 129804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 129808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 129812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 129821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 129825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129829 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 129833 */     // MIs[2] Operand 1
     /* 129833 */     // No operand predicates
     /* 129833 */     // MIs[0] Rn
     /* 129833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 129843 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 129843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 129846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129855 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 129858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 129862 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 129865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 129870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 129875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 129878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 129884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 129892 */     GIR_RootConstrainSelectedInstOperands,
     /* 129893 */     // GIR_Coverage, 13271,
     /* 129893 */     GIR_EraseRootFromParent_Done,
     /* 129894 */   // Label 2294: @129894
     /* 129894 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(129943), // Rule ID 303 //
     /* 129899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 129902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 129906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 129917 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 129917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 129920 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 129922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 129932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 129937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129941 */     GIR_RootConstrainSelectedInstOperands,
     /* 129942 */     // GIR_Coverage, 303,
     /* 129942 */     GIR_EraseRootFromParent_Done,
     /* 129943 */   // Label 2295: @129943
     /* 129943 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(129992), // Rule ID 304 //
     /* 129948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 129951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 129955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 129966 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 129966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 129969 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 129971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 129981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 129986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129990 */     GIR_RootConstrainSelectedInstOperands,
     /* 129991 */     // GIR_Coverage, 304,
     /* 129991 */     GIR_EraseRootFromParent_Done,
     /* 129992 */   // Label 2296: @129992
     /* 129992 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(130036), // Rule ID 313 //
     /* 129997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 130000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 130004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 130015 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 130015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 130018 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 130020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130034 */     GIR_RootConstrainSelectedInstOperands,
     /* 130035 */     // GIR_Coverage, 313,
     /* 130035 */     GIR_EraseRootFromParent_Done,
     /* 130036 */   // Label 2297: @130036
     /* 130036 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(130080), // Rule ID 321 //
     /* 130041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 130044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 130048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 130059 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 130059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 130062 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 130064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130078 */     GIR_RootConstrainSelectedInstOperands,
     /* 130079 */     // GIR_Coverage, 321,
     /* 130079 */     GIR_EraseRootFromParent_Done,
     /* 130080 */   // Label 2298: @130080
     /* 130080 */   GIM_Reject,
     /* 130081 */ // Label 2292: @130081
     /* 130081 */ GIM_Reject,
     /* 130082 */ // Label 2272: @130082
     /* 130082 */ GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(131220),
     /* 130087 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130090 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 130094 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(130193), // Rule ID 4518 //
     /* 130099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130120 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 130137 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 130137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130149 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 130168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130191 */     GIR_RootConstrainSelectedInstOperands,
     /* 130192 */     // GIR_Coverage, 4518,
     /* 130192 */     GIR_EraseRootFromParent_Done,
     /* 130193 */   // Label 2300: @130193
     /* 130193 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(130292), // Rule ID 4519 //
     /* 130198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130219 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 130236 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 130236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130248 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 130267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130290 */     GIR_RootConstrainSelectedInstOperands,
     /* 130291 */     // GIR_Coverage, 4519,
     /* 130291 */     GIR_EraseRootFromParent_Done,
     /* 130292 */   // Label 2301: @130292
     /* 130292 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(130391), // Rule ID 13268 //
     /* 130297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130318 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 130335 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 130335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130347 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 130366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130389 */     GIR_RootConstrainSelectedInstOperands,
     /* 130390 */     // GIR_Coverage, 13268,
     /* 130390 */     GIR_EraseRootFromParent_Done,
     /* 130391 */   // Label 2302: @130391
     /* 130391 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(130490), // Rule ID 13269 //
     /* 130396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130417 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130421 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 130434 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 130434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130446 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 130465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130488 */     GIR_RootConstrainSelectedInstOperands,
     /* 130489 */     // GIR_Coverage, 13269,
     /* 130489 */     GIR_EraseRootFromParent_Done,
     /* 130490 */   // Label 2303: @130490
     /* 130490 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(130584), // Rule ID 4547 //
     /* 130495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130516 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 130533 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 130533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130545 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 130564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130582 */     GIR_RootConstrainSelectedInstOperands,
     /* 130583 */     // GIR_Coverage, 4547,
     /* 130583 */     GIR_EraseRootFromParent_Done,
     /* 130584 */   // Label 2304: @130584
     /* 130584 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(130678), // Rule ID 4574 //
     /* 130589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130610 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 130627 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 130627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130639 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 130658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130676 */     GIR_RootConstrainSelectedInstOperands,
     /* 130677 */     // GIR_Coverage, 4574,
     /* 130677 */     GIR_EraseRootFromParent_Done,
     /* 130678 */   // Label 2305: @130678
     /* 130678 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(130772), // Rule ID 13267 //
     /* 130683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130704 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 130721 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 130721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130733 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 130752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130770 */     GIR_RootConstrainSelectedInstOperands,
     /* 130771 */     // GIR_Coverage, 13267,
     /* 130771 */     GIR_EraseRootFromParent_Done,
     /* 130772 */   // Label 2306: @130772
     /* 130772 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(130866), // Rule ID 13273 //
     /* 130777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130798 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 130802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 130815 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 130815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 130818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130827 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 130833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 130838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 130846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130864 */     GIR_RootConstrainSelectedInstOperands,
     /* 130865 */     // GIR_Coverage, 13273,
     /* 130865 */     GIR_EraseRootFromParent_Done,
     /* 130866 */   // Label 2307: @130866
     /* 130866 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(130934), // Rule ID 6515 //
     /* 130871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 130892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 130900 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 130904 */     // MIs[2] Operand 1
     /* 130904 */     // No operand predicates
     /* 130904 */     // MIs[0] Rn
     /* 130904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 130914 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 130914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 130917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 130921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 130924 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 130932 */     GIR_RootConstrainSelectedInstOperands,
     /* 130933 */     // GIR_Coverage, 6515,
     /* 130933 */     GIR_EraseRootFromParent_Done,
     /* 130934 */   // Label 2308: @130934
     /* 130934 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(131033), // Rule ID 6520 //
     /* 130939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 130943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 130947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 130951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 130960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 130968 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 130972 */     // MIs[2] Operand 1
     /* 130972 */     // No operand predicates
     /* 130972 */     // MIs[0] Rn
     /* 130972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 130982 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 130982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 130985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130994 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130997 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 131001 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 131004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 131017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 131023 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 131031 */     GIR_RootConstrainSelectedInstOperands,
     /* 131032 */     // GIR_Coverage, 6520,
     /* 131032 */     GIR_EraseRootFromParent_Done,
     /* 131033 */   // Label 2309: @131033
     /* 131033 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(131082), // Rule ID 305 //
     /* 131038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131045 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 131056 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 131056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 131059 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131080 */     GIR_RootConstrainSelectedInstOperands,
     /* 131081 */     // GIR_Coverage, 305,
     /* 131081 */     GIR_EraseRootFromParent_Done,
     /* 131082 */   // Label 2310: @131082
     /* 131082 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(131131), // Rule ID 306 //
     /* 131087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 131105 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 131105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 131108 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131129 */     GIR_RootConstrainSelectedInstOperands,
     /* 131130 */     // GIR_Coverage, 306,
     /* 131130 */     GIR_EraseRootFromParent_Done,
     /* 131131 */   // Label 2311: @131131
     /* 131131 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(131175), // Rule ID 314 //
     /* 131136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 131154 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 131154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 131157 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131173 */     GIR_RootConstrainSelectedInstOperands,
     /* 131174 */     // GIR_Coverage, 314,
     /* 131174 */     GIR_EraseRootFromParent_Done,
     /* 131175 */   // Label 2312: @131175
     /* 131175 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(131219), // Rule ID 322 //
     /* 131180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 131198 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 131198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 131201 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131217 */     GIR_RootConstrainSelectedInstOperands,
     /* 131218 */     // GIR_Coverage, 322,
     /* 131218 */     GIR_EraseRootFromParent_Done,
     /* 131219 */   // Label 2313: @131219
     /* 131219 */   GIM_Reject,
     /* 131220 */ // Label 2299: @131220
     /* 131220 */ GIM_Reject,
     /* 131221 */ // Label 2273: @131221
     /* 131221 */ GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(131334), // Rule ID 4516 //
     /* 131226 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131229 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131233 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131240 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131244 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131248 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 131252 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131256 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131261 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131265 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131269 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131271 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 131278 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 131278 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131281 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131285 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131290 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131296 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131301 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 131309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131312 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131327 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131332 */   GIR_RootConstrainSelectedInstOperands,
     /* 131333 */   // GIR_Coverage, 4516,
     /* 131333 */   GIR_EraseRootFromParent_Done,
     /* 131334 */ // Label 2314: @131334
     /* 131334 */ GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(131447), // Rule ID 4517 //
     /* 131339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131342 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131346 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131353 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131357 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131361 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 131365 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131369 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131374 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131378 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131382 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131384 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 131391 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 131391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131403 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131409 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131414 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 131422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131445 */   GIR_RootConstrainSelectedInstOperands,
     /* 131446 */   // GIR_Coverage, 4517,
     /* 131446 */   GIR_EraseRootFromParent_Done,
     /* 131447 */ // Label 2315: @131447
     /* 131447 */ GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(131553), // Rule ID 4520 //
     /* 131452 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131455 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131467 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 131471 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131475 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131480 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131484 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131490 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 131497 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 131497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131509 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131515 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131520 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 131528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131546 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131551 */   GIR_RootConstrainSelectedInstOperands,
     /* 131552 */   // GIR_Coverage, 4520,
     /* 131552 */   GIR_EraseRootFromParent_Done,
     /* 131553 */ // Label 2316: @131553
     /* 131553 */ GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(131659), // Rule ID 4521 //
     /* 131558 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131561 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131573 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 131577 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131581 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131586 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131590 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131594 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131596 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 131603 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 131603 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131606 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131610 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131615 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131621 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131626 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 131634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131652 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131657 */   GIR_RootConstrainSelectedInstOperands,
     /* 131658 */   // GIR_Coverage, 4521,
     /* 131658 */   GIR_EraseRootFromParent_Done,
     /* 131659 */ // Label 2317: @131659
     /* 131659 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(131765), // Rule ID 4522 //
     /* 131664 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131667 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131671 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131675 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131679 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 131683 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131687 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131692 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131696 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131700 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131702 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 131709 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 131709 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131712 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131716 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131721 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131727 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131732 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 131740 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131743 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131748 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131758 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131763 */   GIR_RootConstrainSelectedInstOperands,
     /* 131764 */   // GIR_Coverage, 4522,
     /* 131764 */   GIR_EraseRootFromParent_Done,
     /* 131765 */ // Label 2318: @131765
     /* 131765 */ GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(131871), // Rule ID 4523 //
     /* 131770 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131773 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131777 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131781 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131785 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 131789 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131793 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131798 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131802 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131806 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131808 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 131815 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 131815 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131818 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131822 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131827 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131838 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 131846 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131864 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131869 */   GIR_RootConstrainSelectedInstOperands,
     /* 131870 */   // GIR_Coverage, 4523,
     /* 131870 */   GIR_EraseRootFromParent_Done,
     /* 131871 */ // Label 2319: @131871
     /* 131871 */ GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(131977), // Rule ID 13275 //
     /* 131876 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131879 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131883 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131887 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131891 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 131895 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131899 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131904 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131908 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131912 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131914 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 131921 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 131921 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131924 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131928 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131933 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 131939 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 131944 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 131952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131960 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131965 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131970 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131975 */   GIR_RootConstrainSelectedInstOperands,
     /* 131976 */   // GIR_Coverage, 13275,
     /* 131976 */   GIR_EraseRootFromParent_Done,
     /* 131977 */ // Label 2320: @131977
     /* 131977 */ GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(132083), // Rule ID 13276 //
     /* 131982 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131985 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131989 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131993 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131997 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 132001 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132005 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132010 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132014 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132018 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132020 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 132027 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 132027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132039 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132045 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132050 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 132058 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132066 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132071 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132076 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132081 */   GIR_RootConstrainSelectedInstOperands,
     /* 132082 */   // GIR_Coverage, 13276,
     /* 132082 */   GIR_EraseRootFromParent_Done,
     /* 132083 */ // Label 2321: @132083
     /* 132083 */ GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(132191), // Rule ID 4546 //
     /* 132088 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132091 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132095 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132102 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132106 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132110 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132114 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132118 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132123 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132127 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132131 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132133 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 132140 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 132140 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132143 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132147 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132152 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132158 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132163 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 132171 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132184 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132189 */   GIR_RootConstrainSelectedInstOperands,
     /* 132190 */   // GIR_Coverage, 4546,
     /* 132190 */   GIR_EraseRootFromParent_Done,
     /* 132191 */ // Label 2322: @132191
     /* 132191 */ GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(132292), // Rule ID 4548 //
     /* 132196 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132199 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132203 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132207 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132211 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 132215 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132219 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132224 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132228 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132232 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132234 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 132241 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 132241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132253 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132259 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132264 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 132272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132285 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132290 */   GIR_RootConstrainSelectedInstOperands,
     /* 132291 */   // GIR_Coverage, 4548,
     /* 132291 */   GIR_EraseRootFromParent_Done,
     /* 132292 */ // Label 2323: @132292
     /* 132292 */ GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(132393), // Rule ID 4549 //
     /* 132297 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132300 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132304 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132308 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132312 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 132316 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132320 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132325 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132329 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132333 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132335 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 132342 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 132342 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132345 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132349 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132354 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132360 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132365 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 132373 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132386 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132391 */   GIR_RootConstrainSelectedInstOperands,
     /* 132392 */   // GIR_Coverage, 4549,
     /* 132392 */   GIR_EraseRootFromParent_Done,
     /* 132393 */ // Label 2324: @132393
     /* 132393 */ GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(132501), // Rule ID 4573 //
     /* 132398 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132401 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132405 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132412 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132416 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132420 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132424 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132428 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132433 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132437 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132441 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132443 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 132450 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132462 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132468 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132473 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 132481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132499 */   GIR_RootConstrainSelectedInstOperands,
     /* 132500 */   // GIR_Coverage, 4573,
     /* 132500 */   GIR_EraseRootFromParent_Done,
     /* 132501 */ // Label 2325: @132501
     /* 132501 */ GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(132602), // Rule ID 4575 //
     /* 132506 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132509 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132513 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132517 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132521 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 132525 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132529 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132534 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132538 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132542 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132544 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 132551 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132551 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132554 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132558 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132563 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132569 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132574 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 132582 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132595 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132600 */   GIR_RootConstrainSelectedInstOperands,
     /* 132601 */   // GIR_Coverage, 4575,
     /* 132601 */   GIR_EraseRootFromParent_Done,
     /* 132602 */ // Label 2326: @132602
     /* 132602 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(132703), // Rule ID 4576 //
     /* 132607 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132610 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132614 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132618 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132622 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 132626 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132630 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132635 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132639 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132643 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132645 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 132652 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132652 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132655 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132659 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132664 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132670 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132675 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 132683 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132686 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132691 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132696 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132701 */   GIR_RootConstrainSelectedInstOperands,
     /* 132702 */   // GIR_Coverage, 4576,
     /* 132702 */   GIR_EraseRootFromParent_Done,
     /* 132703 */ // Label 2327: @132703
     /* 132703 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(132804), // Rule ID 13272 //
     /* 132708 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132711 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132715 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132719 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132723 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 132727 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132731 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132736 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132744 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132746 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 132753 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 132753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132765 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132771 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132776 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 132784 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132792 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132802 */   GIR_RootConstrainSelectedInstOperands,
     /* 132803 */   // GIR_Coverage, 13272,
     /* 132803 */   GIR_EraseRootFromParent_Done,
     /* 132804 */ // Label 2328: @132804
     /* 132804 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(132905), // Rule ID 13274 //
     /* 132809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132812 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132816 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132820 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132824 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 132828 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132832 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132837 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132841 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132845 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132847 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 132854 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132854 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132857 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132861 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132866 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 132872 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 132877 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 132885 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132898 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132903 */   GIR_RootConstrainSelectedInstOperands,
     /* 132904 */   // GIR_Coverage, 13274,
     /* 132904 */   GIR_EraseRootFromParent_Done,
     /* 132905 */ // Label 2329: @132905
     /* 132905 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(132987), // Rule ID 6509 //
     /* 132910 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132913 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132917 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132924 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132928 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132932 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 132936 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132940 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132945 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 132949 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 132953 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 132957 */   // MIs[2] Operand 1
     /* 132957 */   // No operand predicates
     /* 132957 */   // MIs[0] Rn
     /* 132957 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132965 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 132967 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 132967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 132970 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 132974 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 132977 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132979 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 132985 */   GIR_RootConstrainSelectedInstOperands,
     /* 132986 */   // GIR_Coverage, 6509,
     /* 132986 */   GIR_EraseRootFromParent_Done,
     /* 132987 */ // Label 2330: @132987
     /* 132987 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(133069), // Rule ID 6510 //
     /* 132992 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132995 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132999 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133006 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133010 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133014 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 133018 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133022 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133027 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133031 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133035 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 133039 */   // MIs[2] Operand 1
     /* 133039 */   // No operand predicates
     /* 133039 */   // MIs[0] Rn
     /* 133039 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133047 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133049 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 133052 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133056 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133059 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133061 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133067 */   GIR_RootConstrainSelectedInstOperands,
     /* 133068 */   // GIR_Coverage, 6510,
     /* 133068 */   GIR_EraseRootFromParent_Done,
     /* 133069 */ // Label 2331: @133069
     /* 133069 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(133144), // Rule ID 6511 //
     /* 133074 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133077 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133081 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133085 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133089 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133093 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133097 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133102 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133106 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133110 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 133114 */   // MIs[2] Operand 1
     /* 133114 */   // No operand predicates
     /* 133114 */   // MIs[0] Rn
     /* 133114 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133122 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133124 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 133127 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133131 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133134 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133136 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133142 */   GIR_RootConstrainSelectedInstOperands,
     /* 133143 */   // GIR_Coverage, 6511,
     /* 133143 */   GIR_EraseRootFromParent_Done,
     /* 133144 */ // Label 2332: @133144
     /* 133144 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(133219), // Rule ID 6512 //
     /* 133149 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133152 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133156 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133160 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133164 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133168 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133172 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133177 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133181 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133185 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 133189 */   // MIs[2] Operand 1
     /* 133189 */   // No operand predicates
     /* 133189 */   // MIs[0] Rn
     /* 133189 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133197 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133199 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 133202 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133206 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133209 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133217 */   GIR_RootConstrainSelectedInstOperands,
     /* 133218 */   // GIR_Coverage, 6512,
     /* 133218 */   GIR_EraseRootFromParent_Done,
     /* 133219 */ // Label 2333: @133219
     /* 133219 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(133332), // Rule ID 6516 //
     /* 133224 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133227 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133231 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133238 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133242 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133246 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 133250 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133254 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133259 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133263 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133267 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 133271 */   // MIs[2] Operand 1
     /* 133271 */   // No operand predicates
     /* 133271 */   // MIs[0] Rn
     /* 133271 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133279 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133281 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133281 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 133284 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 133288 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133293 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 133296 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133300 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 133303 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133308 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 133316 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133319 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133322 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133324 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133330 */   GIR_RootConstrainSelectedInstOperands,
     /* 133331 */   // GIR_Coverage, 6516,
     /* 133331 */   GIR_EraseRootFromParent_Done,
     /* 133332 */ // Label 2334: @133332
     /* 133332 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(133445), // Rule ID 6517 //
     /* 133337 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133340 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133344 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133351 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133355 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133359 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 133363 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133367 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133372 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133376 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133380 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 133384 */   // MIs[2] Operand 1
     /* 133384 */   // No operand predicates
     /* 133384 */   // MIs[0] Rn
     /* 133384 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133392 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133394 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133394 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 133397 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 133401 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133406 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 133409 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133413 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 133416 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133421 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 133429 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133432 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133435 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133437 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133443 */   GIR_RootConstrainSelectedInstOperands,
     /* 133444 */   // GIR_Coverage, 6517,
     /* 133444 */   GIR_EraseRootFromParent_Done,
     /* 133445 */ // Label 2335: @133445
     /* 133445 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(133551), // Rule ID 6518 //
     /* 133450 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133453 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133457 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133461 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133465 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 133469 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133473 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133478 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133482 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133486 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 133490 */   // MIs[2] Operand 1
     /* 133490 */   // No operand predicates
     /* 133490 */   // MIs[0] Rn
     /* 133490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133498 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133500 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 133503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 133507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133512 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 133515 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133519 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 133522 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133527 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 133535 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133538 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133541 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133543 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133549 */   GIR_RootConstrainSelectedInstOperands,
     /* 133550 */   // GIR_Coverage, 6518,
     /* 133550 */   GIR_EraseRootFromParent_Done,
     /* 133551 */ // Label 2336: @133551
     /* 133551 */ GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(133657), // Rule ID 6519 //
     /* 133556 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133559 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133563 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133567 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133571 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 133575 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133579 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133584 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 133588 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133592 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 133596 */   // MIs[2] Operand 1
     /* 133596 */   // No operand predicates
     /* 133596 */   // MIs[0] Rn
     /* 133596 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133604 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133606 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 133606 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 133609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 133613 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133618 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 133621 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 133625 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 133628 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133633 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 133641 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133644 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 133647 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133649 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 133655 */   GIR_RootConstrainSelectedInstOperands,
     /* 133656 */   // GIR_Coverage, 6519,
     /* 133656 */   GIR_EraseRootFromParent_Done,
     /* 133657 */ // Label 2337: @133657
     /* 133657 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(133717), // Rule ID 295 //
     /* 133662 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133665 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133669 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133680 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133684 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 133691 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 133691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 133694 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133696 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133701 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133711 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133715 */   GIR_RootConstrainSelectedInstOperands,
     /* 133716 */   // GIR_Coverage, 295,
     /* 133716 */   GIR_EraseRootFromParent_Done,
     /* 133717 */ // Label 2338: @133717
     /* 133717 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(133777), // Rule ID 296 //
     /* 133722 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133725 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133729 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 133751 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 133751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 133754 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133771 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133775 */   GIR_RootConstrainSelectedInstOperands,
     /* 133776 */   // GIR_Coverage, 296,
     /* 133776 */   GIR_EraseRootFromParent_Done,
     /* 133777 */ // Label 2339: @133777
     /* 133777 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(133837), // Rule ID 297 //
     /* 133782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133785 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133789 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133800 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133804 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 133811 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 133811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 133814 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133835 */   GIR_RootConstrainSelectedInstOperands,
     /* 133836 */   // GIR_Coverage, 297,
     /* 133836 */   GIR_EraseRootFromParent_Done,
     /* 133837 */ // Label 2340: @133837
     /* 133837 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(133897), // Rule ID 298 //
     /* 133842 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133845 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133849 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133860 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133864 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 133871 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 133871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 133874 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133881 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133886 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133891 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133895 */   GIR_RootConstrainSelectedInstOperands,
     /* 133896 */   // GIR_Coverage, 298,
     /* 133896 */   GIR_EraseRootFromParent_Done,
     /* 133897 */ // Label 2341: @133897
     /* 133897 */ GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(133950), // Rule ID 299 //
     /* 133902 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133905 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133913 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133917 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 133924 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 133924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 133927 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133948 */   GIR_RootConstrainSelectedInstOperands,
     /* 133949 */   // GIR_Coverage, 299,
     /* 133949 */   GIR_EraseRootFromParent_Done,
     /* 133950 */ // Label 2342: @133950
     /* 133950 */ GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(134003), // Rule ID 300 //
     /* 133955 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133958 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133966 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 133977 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 133977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 133980 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 133982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133997 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134001 */   GIR_RootConstrainSelectedInstOperands,
     /* 134002 */   // GIR_Coverage, 300,
     /* 134002 */   GIR_EraseRootFromParent_Done,
     /* 134003 */ // Label 2343: @134003
     /* 134003 */ GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(134059), // Rule ID 307 //
     /* 134008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134011 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134014 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134022 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134026 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 134033 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 134033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 134036 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134053 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134057 */   GIR_RootConstrainSelectedInstOperands,
     /* 134058 */   // GIR_Coverage, 307,
     /* 134058 */   GIR_EraseRootFromParent_Done,
     /* 134059 */ // Label 2344: @134059
     /* 134059 */ GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(134115), // Rule ID 308 //
     /* 134064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134067 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134070 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134078 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134082 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 134089 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 134089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 134092 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134109 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134113 */   GIR_RootConstrainSelectedInstOperands,
     /* 134114 */   // GIR_Coverage, 308,
     /* 134114 */   GIR_EraseRootFromParent_Done,
     /* 134115 */ // Label 2345: @134115
     /* 134115 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(134167), // Rule ID 312 //
     /* 134120 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134123 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134131 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134135 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134142 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 134145 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 134151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134161 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134165 */   GIR_RootConstrainSelectedInstOperands,
     /* 134166 */   // GIR_Coverage, 312,
     /* 134166 */   GIR_EraseRootFromParent_Done,
     /* 134167 */ // Label 2346: @134167
     /* 134167 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(134218), // Rule ID 315 //
     /* 134172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 134175 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134178 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134186 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134190 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134197 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 134200 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 134202 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134212 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134216 */   GIR_RootConstrainSelectedInstOperands,
     /* 134217 */   // GIR_Coverage, 315,
     /* 134217 */   GIR_EraseRootFromParent_Done,
     /* 134218 */ // Label 2347: @134218
     /* 134218 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(134277), // Rule ID 317 //
     /* 134223 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134226 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134230 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134241 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134245 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 134252 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 134252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 134255 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 134261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134266 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134271 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134275 */   GIR_RootConstrainSelectedInstOperands,
     /* 134276 */   // GIR_Coverage, 317,
     /* 134276 */   GIR_EraseRootFromParent_Done,
     /* 134277 */ // Label 2348: @134277
     /* 134277 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(134336), // Rule ID 318 //
     /* 134282 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134285 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134289 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134300 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134304 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 134311 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 134311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 134314 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 134320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134330 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134334 */   GIR_RootConstrainSelectedInstOperands,
     /* 134335 */   // GIR_Coverage, 318,
     /* 134335 */   GIR_EraseRootFromParent_Done,
     /* 134336 */ // Label 2349: @134336
     /* 134336 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(134413), // Rule ID 7142 //
     /* 134341 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134344 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134351 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134354 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 134362 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 134366 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134371 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134375 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134377 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 134384 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15965>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 134384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 134387 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 134391 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134396 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134406 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134411 */   GIR_RootConstrainSelectedInstOperands,
     /* 134412 */   // GIR_Coverage, 7142,
     /* 134412 */   GIR_EraseRootFromParent_Done,
     /* 134413 */ // Label 2350: @134413
     /* 134413 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(134490), // Rule ID 7143 //
     /* 134418 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134421 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134428 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134431 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134435 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 134439 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 134443 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134448 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134452 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134454 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 134461 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15965>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 134461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 134464 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 134468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134473 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134478 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134488 */   GIR_RootConstrainSelectedInstOperands,
     /* 134489 */   // GIR_Coverage, 7143,
     /* 134489 */   GIR_EraseRootFromParent_Done,
     /* 134490 */ // Label 2351: @134490
     /* 134490 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(134549), // Rule ID 7123 //
     /* 134495 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134498 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134505 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134512 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134516 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 134523 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15951>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 134523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 134526 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134528 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134533 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134538 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134543 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134547 */   GIR_RootConstrainSelectedInstOperands,
     /* 134548 */   // GIR_Coverage, 7123,
     /* 134548 */   GIR_EraseRootFromParent_Done,
     /* 134549 */ // Label 2352: @134549
     /* 134549 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(134608), // Rule ID 7124 //
     /* 134554 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134557 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134564 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134571 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134575 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 134582 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15951>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 134582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 134585 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134602 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134606 */   GIR_RootConstrainSelectedInstOperands,
     /* 134607 */   // GIR_Coverage, 7124,
     /* 134607 */   GIR_EraseRootFromParent_Done,
     /* 134608 */ // Label 2353: @134608
     /* 134608 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(134667), // Rule ID 7128 //
     /* 134613 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134616 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134623 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134630 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134634 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 134641 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15958>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 134641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 134644 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134651 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134661 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134665 */   GIR_RootConstrainSelectedInstOperands,
     /* 134666 */   // GIR_Coverage, 7128,
     /* 134666 */   GIR_EraseRootFromParent_Done,
     /* 134667 */ // Label 2354: @134667
     /* 134667 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(134726), // Rule ID 7129 //
     /* 134672 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134675 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134682 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134689 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134693 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 134700 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15958>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 134700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 134703 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134720 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134724 */   GIR_RootConstrainSelectedInstOperands,
     /* 134725 */   // GIR_Coverage, 7129,
     /* 134725 */   GIR_EraseRootFromParent_Done,
     /* 134726 */ // Label 2355: @134726
     /* 134726 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(134785), // Rule ID 7133 //
     /* 134731 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134734 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134741 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134748 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134752 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 134759 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15965>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 134759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 134762 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134764 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134774 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134779 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134783 */   GIR_RootConstrainSelectedInstOperands,
     /* 134784 */   // GIR_Coverage, 7133,
     /* 134784 */   GIR_EraseRootFromParent_Done,
     /* 134785 */ // Label 2356: @134785
     /* 134785 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(134844), // Rule ID 7134 //
     /* 134790 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134793 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134800 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134807 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134811 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 134818 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15965>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 134818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 134821 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 134823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134828 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 134833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 134838 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134842 */   GIR_RootConstrainSelectedInstOperands,
     /* 134843 */   // GIR_Coverage, 7134,
     /* 134843 */   GIR_EraseRootFromParent_Done,
     /* 134844 */ // Label 2357: @134844
     /* 134844 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(134916), // Rule ID 7144 //
     /* 134849 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134852 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134859 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134862 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134866 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 134870 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 134874 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134879 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134883 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134885 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134892 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15965>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 134895 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 134899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134904 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134909 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134914 */   GIR_RootConstrainSelectedInstOperands,
     /* 134915 */   // GIR_Coverage, 7144,
     /* 134915 */   GIR_EraseRootFromParent_Done,
     /* 134916 */ // Label 2358: @134916
     /* 134916 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(134988), // Rule ID 7145 //
     /* 134921 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 134924 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134931 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134934 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 134942 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 134946 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134951 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134955 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134957 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 134964 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15965>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 134967 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 134971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134981 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134986 */   GIR_RootConstrainSelectedInstOperands,
     /* 134987 */   // GIR_Coverage, 7145,
     /* 134987 */   GIR_EraseRootFromParent_Done,
     /* 134988 */ // Label 2359: @134988
     /* 134988 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(135040), // Rule ID 320 //
     /* 134993 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134996 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135004 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135008 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135015 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 135015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 135018 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135034 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135038 */   GIR_RootConstrainSelectedInstOperands,
     /* 135039 */   // GIR_Coverage, 320,
     /* 135039 */   GIR_EraseRootFromParent_Done,
     /* 135040 */ // Label 2360: @135040
     /* 135040 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(135091), // Rule ID 323 //
     /* 135045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135048 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135051 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135059 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135063 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135070 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 135070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 135073 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135080 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135085 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135089 */   GIR_RootConstrainSelectedInstOperands,
     /* 135090 */   // GIR_Coverage, 323,
     /* 135090 */   GIR_EraseRootFromParent_Done,
     /* 135091 */ // Label 2361: @135091
     /* 135091 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(135150), // Rule ID 326 //
     /* 135096 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135099 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135103 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135114 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135118 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 135125 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 135125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 135128 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135134 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135144 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135148 */   GIR_RootConstrainSelectedInstOperands,
     /* 135149 */   // GIR_Coverage, 326,
     /* 135149 */   GIR_EraseRootFromParent_Done,
     /* 135150 */ // Label 2362: @135150
     /* 135150 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(135209), // Rule ID 327 //
     /* 135155 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135158 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135162 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135173 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135177 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 135184 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 135184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 135187 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135193 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135203 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135207 */   GIR_RootConstrainSelectedInstOperands,
     /* 135208 */   // GIR_Coverage, 327,
     /* 135208 */   GIR_EraseRootFromParent_Done,
     /* 135209 */ // Label 2363: @135209
     /* 135209 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(135263), // Rule ID 7125 //
     /* 135214 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135217 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135224 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135231 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135235 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 135242 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15951>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 135242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 135245 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135247 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135257 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135261 */   GIR_RootConstrainSelectedInstOperands,
     /* 135262 */   // GIR_Coverage, 7125,
     /* 135262 */   GIR_EraseRootFromParent_Done,
     /* 135263 */ // Label 2364: @135263
     /* 135263 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(135317), // Rule ID 7126 //
     /* 135268 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135271 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135278 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135285 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135289 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 135296 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15951>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 135299 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135311 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135315 */   GIR_RootConstrainSelectedInstOperands,
     /* 135316 */   // GIR_Coverage, 7126,
     /* 135316 */   GIR_EraseRootFromParent_Done,
     /* 135317 */ // Label 2365: @135317
     /* 135317 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(135371), // Rule ID 7130 //
     /* 135322 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135325 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135332 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135339 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135343 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 135350 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15958>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 135350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 135353 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135365 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135369 */   GIR_RootConstrainSelectedInstOperands,
     /* 135370 */   // GIR_Coverage, 7130,
     /* 135370 */   GIR_EraseRootFromParent_Done,
     /* 135371 */ // Label 2366: @135371
     /* 135371 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(135425), // Rule ID 7131 //
     /* 135376 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135379 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135386 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135393 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135397 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 135404 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15958>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 135407 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135409 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135419 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135423 */   GIR_RootConstrainSelectedInstOperands,
     /* 135424 */   // GIR_Coverage, 7131,
     /* 135424 */   GIR_EraseRootFromParent_Done,
     /* 135425 */ // Label 2367: @135425
     /* 135425 */ GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(135479), // Rule ID 7135 //
     /* 135430 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135433 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135440 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135447 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135451 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 135458 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15965>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 135458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 135461 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135468 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135473 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135477 */   GIR_RootConstrainSelectedInstOperands,
     /* 135478 */   // GIR_Coverage, 7135,
     /* 135478 */   GIR_EraseRootFromParent_Done,
     /* 135479 */ // Label 2368: @135479
     /* 135479 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(135533), // Rule ID 7136 //
     /* 135484 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135487 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135494 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135501 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135505 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135512 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15965>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 135515 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135517 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135522 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135527 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135531 */   GIR_RootConstrainSelectedInstOperands,
     /* 135532 */   // GIR_Coverage, 7136,
     /* 135532 */   GIR_EraseRootFromParent_Done,
     /* 135533 */ // Label 2369: @135533
     /* 135533 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(135590), // Rule ID 7498 //
     /* 135538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 135541 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135544 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135551 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135558 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135562 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 135569 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15949>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 135572 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135574 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135584 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135588 */   GIR_RootConstrainSelectedInstOperands,
     /* 135589 */   // GIR_Coverage, 7498,
     /* 135589 */   GIR_EraseRootFromParent_Done,
     /* 135590 */ // Label 2370: @135590
     /* 135590 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(135647), // Rule ID 7499 //
     /* 135595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 135598 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135601 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135608 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135615 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135619 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 135626 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15956>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 135629 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135636 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135641 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135645 */   GIR_RootConstrainSelectedInstOperands,
     /* 135646 */   // GIR_Coverage, 7499,
     /* 135646 */   GIR_EraseRootFromParent_Done,
     /* 135647 */ // Label 2371: @135647
     /* 135647 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(135704), // Rule ID 7500 //
     /* 135652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 135655 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135658 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135665 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135672 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135676 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 135683 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15963>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 135683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 135686 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 135688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135698 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135702 */   GIR_RootConstrainSelectedInstOperands,
     /* 135703 */   // GIR_Coverage, 7500,
     /* 135703 */   GIR_EraseRootFromParent_Done,
     /* 135704 */ // Label 2372: @135704
     /* 135704 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(135741), // Rule ID 7122 //
     /* 135709 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135712 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135719 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135726 */   // MIs[0] ptr
     /* 135726 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135734 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15949>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 135734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 135739 */   GIR_RootConstrainSelectedInstOperands,
     /* 135740 */   // GIR_Coverage, 7122,
     /* 135740 */   GIR_Done,
     /* 135741 */ // Label 2373: @135741
     /* 135741 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(135778), // Rule ID 7127 //
     /* 135746 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135749 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135756 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135763 */   // MIs[0] ptr
     /* 135763 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135771 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15956>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 135771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 135776 */   GIR_RootConstrainSelectedInstOperands,
     /* 135777 */   // GIR_Coverage, 7127,
     /* 135777 */   GIR_Done,
     /* 135778 */ // Label 2374: @135778
     /* 135778 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(135815), // Rule ID 7132 //
     /* 135783 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135786 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135793 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135800 */   // MIs[0] ptr
     /* 135800 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135808 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15963>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 135808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 135813 */   GIR_RootConstrainSelectedInstOperands,
     /* 135814 */   // GIR_Coverage, 7132,
     /* 135814 */   GIR_Done,
     /* 135815 */ // Label 2375: @135815
     /* 135815 */ GIM_Reject,
     /* 135816 */ // Label 2274: @135816
     /* 135816 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(135922), // Rule ID 4524 //
     /* 135821 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135824 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135828 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135832 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135836 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 135840 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135844 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135849 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 135853 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135857 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135859 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 135866 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 135866 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 135869 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135873 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135878 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 135884 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135889 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 135897 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135915 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135920 */   GIR_RootConstrainSelectedInstOperands,
     /* 135921 */   // GIR_Coverage, 4524,
     /* 135921 */   GIR_EraseRootFromParent_Done,
     /* 135922 */ // Label 2376: @135922
     /* 135922 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(136028), // Rule ID 4525 //
     /* 135927 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135934 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135942 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 135946 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135950 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135955 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 135959 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135963 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135965 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 135972 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 135972 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 135975 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135979 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135984 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 135990 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135995 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 136003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136006 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136021 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136026 */   GIR_RootConstrainSelectedInstOperands,
     /* 136027 */   // GIR_Coverage, 4525,
     /* 136027 */   GIR_EraseRootFromParent_Done,
     /* 136028 */ // Label 2377: @136028
     /* 136028 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(136134), // Rule ID 4526 //
     /* 136033 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136036 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136048 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136052 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136056 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136061 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136065 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136069 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136071 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 136078 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 136078 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136081 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136085 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136090 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136096 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136101 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 136109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136127 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136132 */   GIR_RootConstrainSelectedInstOperands,
     /* 136133 */   // GIR_Coverage, 4526,
     /* 136133 */   GIR_EraseRootFromParent_Done,
     /* 136134 */ // Label 2378: @136134
     /* 136134 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(136240), // Rule ID 4527 //
     /* 136139 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136142 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136146 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136150 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136154 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136158 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136162 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136167 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136171 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136175 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136177 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 136184 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 136184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136196 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136202 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136207 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 136215 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136233 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136238 */   GIR_RootConstrainSelectedInstOperands,
     /* 136239 */   // GIR_Coverage, 4527,
     /* 136239 */   GIR_EraseRootFromParent_Done,
     /* 136240 */ // Label 2379: @136240
     /* 136240 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(136341), // Rule ID 4550 //
     /* 136245 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136248 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136252 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136256 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136260 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136264 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136268 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136273 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136281 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136283 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 136290 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 136290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136302 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136308 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136313 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 136321 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136334 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136339 */   GIR_RootConstrainSelectedInstOperands,
     /* 136340 */   // GIR_Coverage, 4550,
     /* 136340 */   GIR_EraseRootFromParent_Done,
     /* 136341 */ // Label 2380: @136341
     /* 136341 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(136442), // Rule ID 4551 //
     /* 136346 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136349 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136353 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136357 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136361 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136365 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136369 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136374 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136378 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136382 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136384 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 136391 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 136391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136403 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136409 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136414 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 136422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136435 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136440 */   GIR_RootConstrainSelectedInstOperands,
     /* 136441 */   // GIR_Coverage, 4551,
     /* 136441 */   GIR_EraseRootFromParent_Done,
     /* 136442 */ // Label 2381: @136442
     /* 136442 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(136543), // Rule ID 4577 //
     /* 136447 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136450 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136454 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136458 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136462 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136466 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136470 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136475 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136479 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136483 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136485 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 136492 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136492 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136495 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136499 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136504 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136510 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136515 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 136523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136526 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136536 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136541 */   GIR_RootConstrainSelectedInstOperands,
     /* 136542 */   // GIR_Coverage, 4577,
     /* 136542 */   GIR_EraseRootFromParent_Done,
     /* 136543 */ // Label 2382: @136543
     /* 136543 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(136644), // Rule ID 4578 //
     /* 136548 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136551 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136555 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136559 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136563 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136567 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136571 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136576 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 136580 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136584 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136586 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 136593 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136593 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 136596 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136600 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136605 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 136611 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136616 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 136624 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136627 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136632 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136637 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136642 */   GIR_RootConstrainSelectedInstOperands,
     /* 136643 */   // GIR_Coverage, 4578,
     /* 136643 */   GIR_EraseRootFromParent_Done,
     /* 136644 */ // Label 2383: @136644
     /* 136644 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(136719), // Rule ID 6513 //
     /* 136649 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136652 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136656 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136664 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136668 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136672 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136677 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 136681 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 136685 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 136689 */   // MIs[2] Operand 1
     /* 136689 */   // No operand predicates
     /* 136689 */   // MIs[0] Rn
     /* 136689 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136697 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 136699 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 136699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 136702 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 136706 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 136709 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136711 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 136717 */   GIR_RootConstrainSelectedInstOperands,
     /* 136718 */   // GIR_Coverage, 6513,
     /* 136718 */   GIR_EraseRootFromParent_Done,
     /* 136719 */ // Label 2384: @136719
     /* 136719 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(136794), // Rule ID 6514 //
     /* 136724 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136727 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136731 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136735 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 136739 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 136743 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136747 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 136752 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 136756 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 136760 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 136764 */   // MIs[2] Operand 1
     /* 136764 */   // No operand predicates
     /* 136764 */   // MIs[0] Rn
     /* 136764 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136772 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 136774 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 136774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 136777 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 136781 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 136784 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 136792 */   GIR_RootConstrainSelectedInstOperands,
     /* 136793 */   // GIR_Coverage, 6514,
     /* 136793 */   GIR_EraseRootFromParent_Done,
     /* 136794 */ // Label 2385: @136794
     /* 136794 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(136847), // Rule ID 301 //
     /* 136799 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136802 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136810 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136814 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 136821 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 136821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 136824 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 136826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136836 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136841 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136845 */   GIR_RootConstrainSelectedInstOperands,
     /* 136846 */   // GIR_Coverage, 301,
     /* 136846 */   GIR_EraseRootFromParent_Done,
     /* 136847 */ // Label 2386: @136847
     /* 136847 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(136900), // Rule ID 302 //
     /* 136852 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136855 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136863 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136867 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 136874 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 136874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 136877 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 136879 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136884 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136889 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136894 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136898 */   GIR_RootConstrainSelectedInstOperands,
     /* 136899 */   // GIR_Coverage, 302,
     /* 136899 */   GIR_EraseRootFromParent_Done,
     /* 136900 */ // Label 2387: @136900
     /* 136900 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(136956), // Rule ID 309 //
     /* 136905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136908 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136911 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136919 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136923 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 136930 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 136930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 136933 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 136935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136950 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136954 */   GIR_RootConstrainSelectedInstOperands,
     /* 136955 */   // GIR_Coverage, 309,
     /* 136955 */   GIR_EraseRootFromParent_Done,
     /* 136956 */ // Label 2388: @136956
     /* 136956 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(137012), // Rule ID 310 //
     /* 136961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136964 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136967 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 136975 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136979 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 136986 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 136986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 136989 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 136991 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136996 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137001 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137006 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137010 */   GIR_RootConstrainSelectedInstOperands,
     /* 137011 */   // GIR_Coverage, 310,
     /* 137011 */   GIR_EraseRootFromParent_Done,
     /* 137012 */ // Label 2389: @137012
     /* 137012 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(137101), // Rule ID 4482 //
     /* 137017 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137020 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137024 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137035 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137039 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 137046 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 137046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137058 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137064 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137069 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 137077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137080 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137095 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137099 */   GIR_RootConstrainSelectedInstOperands,
     /* 137100 */   // GIR_Coverage, 4482,
     /* 137100 */   GIR_EraseRootFromParent_Done,
     /* 137101 */ // Label 2390: @137101
     /* 137101 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(137190), // Rule ID 4483 //
     /* 137106 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137109 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137113 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137124 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137128 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 137135 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 137135 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137138 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137142 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137147 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137153 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137158 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 137166 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137169 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137184 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137188 */   GIR_RootConstrainSelectedInstOperands,
     /* 137189 */   // GIR_Coverage, 4483,
     /* 137189 */   GIR_EraseRootFromParent_Done,
     /* 137190 */ // Label 2391: @137190
     /* 137190 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(137279), // Rule ID 4484 //
     /* 137195 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137198 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137202 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137213 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137217 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 137224 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 137224 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137227 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137231 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137236 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137242 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137247 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 137255 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137263 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137268 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137273 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137277 */   GIR_RootConstrainSelectedInstOperands,
     /* 137278 */   // GIR_Coverage, 4484,
     /* 137278 */   GIR_EraseRootFromParent_Done,
     /* 137279 */ // Label 2392: @137279
     /* 137279 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(137368), // Rule ID 4485 //
     /* 137284 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137287 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137291 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137302 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137306 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 137313 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 137313 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137316 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137320 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137325 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137331 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137336 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 137344 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137362 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137366 */   GIR_RootConstrainSelectedInstOperands,
     /* 137367 */   // GIR_Coverage, 4485,
     /* 137367 */   GIR_EraseRootFromParent_Done,
     /* 137368 */ // Label 2393: @137368
     /* 137368 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(137457), // Rule ID 4486 //
     /* 137373 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137376 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137380 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137395 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 137402 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 137402 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137405 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137409 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137414 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137420 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137425 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 137433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137446 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137451 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137455 */   GIR_RootConstrainSelectedInstOperands,
     /* 137456 */   // GIR_Coverage, 4486,
     /* 137456 */   GIR_EraseRootFromParent_Done,
     /* 137457 */ // Label 2394: @137457
     /* 137457 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(137546), // Rule ID 4487 //
     /* 137462 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137465 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137469 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137480 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137484 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 137491 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 137491 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137494 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137498 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137503 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 137509 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137514 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 137522 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137540 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137544 */   GIR_RootConstrainSelectedInstOperands,
     /* 137545 */   // GIR_Coverage, 4487,
     /* 137545 */   GIR_EraseRootFromParent_Done,
     /* 137546 */ // Label 2395: @137546
     /* 137546 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(137599), // Rule ID 4498 //
     /* 137551 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137554 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137562 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137566 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137573 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137576 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137593 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137597 */   GIR_RootConstrainSelectedInstOperands,
     /* 137598 */   // GIR_Coverage, 4498,
     /* 137598 */   GIR_EraseRootFromParent_Done,
     /* 137599 */ // Label 2396: @137599
     /* 137599 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(137652), // Rule ID 4499 //
     /* 137604 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137607 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137615 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137619 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137626 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137629 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137636 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137641 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137646 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137650 */   GIR_RootConstrainSelectedInstOperands,
     /* 137651 */   // GIR_Coverage, 4499,
     /* 137651 */   GIR_EraseRootFromParent_Done,
     /* 137652 */ // Label 2397: @137652
     /* 137652 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(137705), // Rule ID 4500 //
     /* 137657 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137660 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137668 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137672 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137679 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137682 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137699 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137703 */   GIR_RootConstrainSelectedInstOperands,
     /* 137704 */   // GIR_Coverage, 4500,
     /* 137704 */   GIR_EraseRootFromParent_Done,
     /* 137705 */ // Label 2398: @137705
     /* 137705 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(137758), // Rule ID 4501 //
     /* 137710 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137713 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137721 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137725 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137732 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137735 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137752 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137756 */   GIR_RootConstrainSelectedInstOperands,
     /* 137757 */   // GIR_Coverage, 4501,
     /* 137757 */   GIR_EraseRootFromParent_Done,
     /* 137758 */ // Label 2399: @137758
     /* 137758 */ GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(137810), // Rule ID 311 //
     /* 137763 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137766 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137774 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137778 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137785 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 137788 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 137794 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137799 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137804 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137808 */   GIR_RootConstrainSelectedInstOperands,
     /* 137809 */   // GIR_Coverage, 311,
     /* 137809 */   GIR_EraseRootFromParent_Done,
     /* 137810 */ // Label 2400: @137810
     /* 137810 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(137861), // Rule ID 316 //
     /* 137815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 137818 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137821 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137829 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137833 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137840 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 137843 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137855 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137859 */   GIR_RootConstrainSelectedInstOperands,
     /* 137860 */   // GIR_Coverage, 316,
     /* 137860 */   GIR_EraseRootFromParent_Done,
     /* 137861 */ // Label 2401: @137861
     /* 137861 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(137909), // Rule ID 4528 //
     /* 137866 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137869 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137877 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137881 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137888 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 137891 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137903 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137907 */   GIR_RootConstrainSelectedInstOperands,
     /* 137908 */   // GIR_Coverage, 4528,
     /* 137908 */   GIR_EraseRootFromParent_Done,
     /* 137909 */ // Label 2402: @137909
     /* 137909 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(137957), // Rule ID 4529 //
     /* 137914 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137917 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137925 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137929 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137936 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 137939 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 137941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137951 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137955 */   GIR_RootConstrainSelectedInstOperands,
     /* 137956 */   // GIR_Coverage, 4529,
     /* 137956 */   GIR_EraseRootFromParent_Done,
     /* 137957 */ // Label 2403: @137957
     /* 137957 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(138041), // Rule ID 4543 //
     /* 137962 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137965 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137969 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137980 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137984 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 137991 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 137991 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 137994 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137998 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138003 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138009 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138014 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 138022 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138030 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138035 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138039 */   GIR_RootConstrainSelectedInstOperands,
     /* 138040 */   // GIR_Coverage, 4543,
     /* 138040 */   GIR_EraseRootFromParent_Done,
     /* 138041 */ // Label 2404: @138041
     /* 138041 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(138125), // Rule ID 4544 //
     /* 138046 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138049 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138053 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138064 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138068 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 138075 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 138075 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138078 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138082 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138087 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138093 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138098 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 138106 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138109 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138119 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138123 */   GIR_RootConstrainSelectedInstOperands,
     /* 138124 */   // GIR_Coverage, 4544,
     /* 138124 */   GIR_EraseRootFromParent_Done,
     /* 138125 */ // Label 2405: @138125
     /* 138125 */ GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(138209), // Rule ID 4545 //
     /* 138130 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138133 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138137 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 138144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138148 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138152 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 138159 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 138159 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138162 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138166 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138171 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138177 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138182 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 138190 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138193 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138203 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138207 */   GIR_RootConstrainSelectedInstOperands,
     /* 138208 */   // GIR_Coverage, 4545,
     /* 138208 */   GIR_EraseRootFromParent_Done,
     /* 138209 */ // Label 2406: @138209
     /* 138209 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(138286), // Rule ID 7146 //
     /* 138214 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138217 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138224 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138227 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138231 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138235 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138239 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138244 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138248 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138250 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138257 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15972>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 138260 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 138264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138269 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138279 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138284 */   GIR_RootConstrainSelectedInstOperands,
     /* 138285 */   // GIR_Coverage, 7146,
     /* 138285 */   GIR_EraseRootFromParent_Done,
     /* 138286 */ // Label 2407: @138286
     /* 138286 */ GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(138363), // Rule ID 7147 //
     /* 138291 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138294 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138301 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138304 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138308 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138312 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138316 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138321 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138325 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138327 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138334 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15972>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 138337 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 138341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138356 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138361 */   GIR_RootConstrainSelectedInstOperands,
     /* 138362 */   // GIR_Coverage, 7147,
     /* 138362 */   GIR_EraseRootFromParent_Done,
     /* 138363 */ // Label 2408: @138363
     /* 138363 */ GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(138422), // Rule ID 7138 //
     /* 138368 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138371 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138378 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138385 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138389 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138396 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15972>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 138399 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 138401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138411 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138416 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138420 */   GIR_RootConstrainSelectedInstOperands,
     /* 138421 */   // GIR_Coverage, 7138,
     /* 138421 */   GIR_EraseRootFromParent_Done,
     /* 138422 */ // Label 2409: @138422
     /* 138422 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(138481), // Rule ID 7139 //
     /* 138427 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138430 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138437 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138444 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138448 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138455 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15972>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 138458 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 138460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138475 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138479 */   GIR_RootConstrainSelectedInstOperands,
     /* 138480 */   // GIR_Coverage, 7139,
     /* 138480 */   GIR_EraseRootFromParent_Done,
     /* 138481 */ // Label 2410: @138481
     /* 138481 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(138553), // Rule ID 7148 //
     /* 138486 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138489 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138496 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138499 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138503 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138507 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138511 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138516 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138522 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 138529 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15972>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 138529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 138532 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 138536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138546 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138551 */   GIR_RootConstrainSelectedInstOperands,
     /* 138552 */   // GIR_Coverage, 7148,
     /* 138552 */   GIR_EraseRootFromParent_Done,
     /* 138553 */ // Label 2411: @138553
     /* 138553 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(138625), // Rule ID 7149 //
     /* 138558 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138561 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138568 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138571 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138575 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138579 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138583 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138588 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138592 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138594 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 138601 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15972>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 138601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 138604 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 138608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138623 */   GIR_RootConstrainSelectedInstOperands,
     /* 138624 */   // GIR_Coverage, 7149,
     /* 138624 */   GIR_EraseRootFromParent_Done,
     /* 138625 */ // Label 2412: @138625
     /* 138625 */ GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(138722), // Rule ID 7490 //
     /* 138630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 138633 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138636 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138643 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138646 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138650 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 138654 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 138658 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 138662 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138666 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138670 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 138674 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138679 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 138683 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 138687 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 138691 */   // MIs[3] Operand 1
     /* 138691 */   // No operand predicates
     /* 138691 */   // MIs[0] Rn
     /* 138691 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138699 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 138701 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15970>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 138701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 138704 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 138708 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 138711 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 138720 */   GIR_RootConstrainSelectedInstOperands,
     /* 138721 */   // GIR_Coverage, 7490,
     /* 138721 */   GIR_EraseRootFromParent_Done,
     /* 138722 */ // Label 2413: @138722
     /* 138722 */ GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(138774), // Rule ID 319 //
     /* 138727 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 138749 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 138749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 138752 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 138758 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138768 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138772 */   GIR_RootConstrainSelectedInstOperands,
     /* 138773 */   // GIR_Coverage, 319,
     /* 138773 */   GIR_EraseRootFromParent_Done,
     /* 138774 */ // Label 2414: @138774
     /* 138774 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(138825), // Rule ID 324 //
     /* 138779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 138782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138785 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138797 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 138804 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 138804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 138807 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138823 */   GIR_RootConstrainSelectedInstOperands,
     /* 138824 */   // GIR_Coverage, 324,
     /* 138824 */   GIR_EraseRootFromParent_Done,
     /* 138825 */ // Label 2415: @138825
     /* 138825 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(138879), // Rule ID 7140 //
     /* 138830 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138833 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138840 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138847 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138851 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 138858 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15972>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 138858 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 138861 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 138863 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138873 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138877 */   GIR_RootConstrainSelectedInstOperands,
     /* 138878 */   // GIR_Coverage, 7140,
     /* 138878 */   GIR_EraseRootFromParent_Done,
     /* 138879 */ // Label 2416: @138879
     /* 138879 */ GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(138933), // Rule ID 7141 //
     /* 138884 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138887 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138894 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138901 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138905 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 138912 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15972>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 138912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 138915 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 138917 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138927 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138931 */   GIR_RootConstrainSelectedInstOperands,
     /* 138932 */   // GIR_Coverage, 7141,
     /* 138932 */   GIR_EraseRootFromParent_Done,
     /* 138933 */ // Label 2417: @138933
     /* 138933 */ GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(138990), // Rule ID 7501 //
     /* 138938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 138941 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 138944 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138951 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138958 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138962 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 138969 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15970>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 138969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 138972 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 138974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138984 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138988 */   GIR_RootConstrainSelectedInstOperands,
     /* 138989 */   // GIR_Coverage, 7501,
     /* 138989 */   GIR_EraseRootFromParent_Done,
     /* 138990 */ // Label 2418: @138990
     /* 138990 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(139038), // Rule ID 4552 //
     /* 138995 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138998 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139006 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139010 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 139017 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 139020 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139032 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139036 */   GIR_RootConstrainSelectedInstOperands,
     /* 139037 */   // GIR_Coverage, 4552,
     /* 139037 */   GIR_EraseRootFromParent_Done,
     /* 139038 */ // Label 2419: @139038
     /* 139038 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(139086), // Rule ID 4553 //
     /* 139043 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139046 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139054 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139058 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 139065 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 139068 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139080 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139084 */   GIR_RootConstrainSelectedInstOperands,
     /* 139085 */   // GIR_Coverage, 4553,
     /* 139085 */   GIR_EraseRootFromParent_Done,
     /* 139086 */ // Label 2420: @139086
     /* 139086 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(139170), // Rule ID 4568 //
     /* 139091 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139094 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139098 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139109 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139113 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 139120 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139132 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139138 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139143 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 139151 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139154 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139159 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139164 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139168 */   GIR_RootConstrainSelectedInstOperands,
     /* 139169 */   // GIR_Coverage, 4568,
     /* 139169 */   GIR_EraseRootFromParent_Done,
     /* 139170 */ // Label 2421: @139170
     /* 139170 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(139254), // Rule ID 4569 //
     /* 139175 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139178 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139182 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 139189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139193 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139197 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 139204 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139204 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139207 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139211 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139216 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139222 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139227 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 139235 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139238 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139243 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139248 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139252 */   GIR_RootConstrainSelectedInstOperands,
     /* 139253 */   // GIR_Coverage, 4569,
     /* 139253 */   GIR_EraseRootFromParent_Done,
     /* 139254 */ // Label 2422: @139254
     /* 139254 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(139338), // Rule ID 4570 //
     /* 139259 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139262 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139266 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 139273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139281 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 139288 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139288 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139291 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139295 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139300 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139306 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139311 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 139319 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139336 */   GIR_RootConstrainSelectedInstOperands,
     /* 139337 */   // GIR_Coverage, 4570,
     /* 139337 */   GIR_EraseRootFromParent_Done,
     /* 139338 */ // Label 2423: @139338
     /* 139338 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(139422), // Rule ID 7489 //
     /* 139343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 139346 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139349 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139356 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139359 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 139363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 139367 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 139371 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139375 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139380 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 139384 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 139388 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 139392 */   // MIs[2] Operand 1
     /* 139392 */   // No operand predicates
     /* 139392 */   // MIs[0] Rn
     /* 139392 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 139400 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 139402 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15970>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 139402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 139405 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 139409 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 139412 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139414 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 139420 */   GIR_RootConstrainSelectedInstOperands,
     /* 139421 */   // GIR_Coverage, 7489,
     /* 139421 */   GIR_EraseRootFromParent_Done,
     /* 139422 */ // Label 2424: @139422
     /* 139422 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(139520), // Rule ID 7491 //
     /* 139427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 139430 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139433 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139440 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139443 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 139447 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 139451 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 139455 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139460 */   // MIs[0] Rn
     /* 139460 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 139468 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139470 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15970>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 139470 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 139473 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 139477 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139482 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 139485 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 139489 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 139492 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139497 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 139505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 139511 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139513 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139518 */   GIR_RootConstrainSelectedInstOperands,
     /* 139519 */   // GIR_Coverage, 7491,
     /* 139519 */   GIR_EraseRootFromParent_Done,
     /* 139520 */ // Label 2425: @139520
     /* 139520 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(139557), // Rule ID 7137 //
     /* 139525 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139528 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139535 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139542 */   // MIs[0] ptr
     /* 139542 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 139550 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15970>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 139550 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 139555 */   GIR_RootConstrainSelectedInstOperands,
     /* 139556 */   // GIR_Coverage, 7137,
     /* 139556 */   GIR_Done,
     /* 139557 */ // Label 2426: @139557
     /* 139557 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(139584), // Rule ID 6461 //
     /* 139562 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139565 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139569 */   // MIs[0] Rn
     /* 139569 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 139577 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 139577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 139582 */   GIR_RootConstrainSelectedInstOperands,
     /* 139583 */   // GIR_Coverage, 6461,
     /* 139583 */   GIR_Done,
     /* 139584 */ // Label 2427: @139584
     /* 139584 */ GIM_Reject,
     /* 139585 */ // Label 2275: @139585
     /* 139585 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(139790),
     /* 139590 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139593 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 139601 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139605 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(139646), // Rule ID 4480 //
     /* 139610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 139613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 139620 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 139620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 139623 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139644 */     GIR_RootConstrainSelectedInstOperands,
     /* 139645 */     // GIR_Coverage, 4480,
     /* 139645 */     GIR_EraseRootFromParent_Done,
     /* 139646 */   // Label 2429: @139646
     /* 139646 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(139687), // Rule ID 4481 //
     /* 139651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 139654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 139661 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 139661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 139664 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139685 */     GIR_RootConstrainSelectedInstOperands,
     /* 139686 */     // GIR_Coverage, 4481,
     /* 139686 */     GIR_EraseRootFromParent_Done,
     /* 139687 */   // Label 2430: @139687
     /* 139687 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(139720), // Rule ID 4535 //
     /* 139692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 139699 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 139699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 139702 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139718 */     GIR_RootConstrainSelectedInstOperands,
     /* 139719 */     // GIR_Coverage, 4535,
     /* 139719 */     GIR_EraseRootFromParent_Done,
     /* 139720 */   // Label 2431: @139720
     /* 139720 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(139753), // Rule ID 4559 //
     /* 139725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 139732 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 139732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 139735 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139751 */     GIR_RootConstrainSelectedInstOperands,
     /* 139752 */     // GIR_Coverage, 4559,
     /* 139752 */     GIR_EraseRootFromParent_Done,
     /* 139753 */   // Label 2432: @139753
     /* 139753 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(139789), // Rule ID 325 //
     /* 139758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 139768 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 139768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 139771 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139787 */     GIR_RootConstrainSelectedInstOperands,
     /* 139788 */     // GIR_Coverage, 325,
     /* 139788 */     GIR_EraseRootFromParent_Done,
     /* 139789 */   // Label 2433: @139789
     /* 139789 */   GIM_Reject,
     /* 139790 */ // Label 2428: @139790
     /* 139790 */ GIM_Reject,
     /* 139791 */ // Label 2276: @139791
     /* 139791 */ GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(140196),
     /* 139796 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139799 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139803 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(139852), // Rule ID 4488 //
     /* 139808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 139811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139826 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 139829 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139850 */     GIR_RootConstrainSelectedInstOperands,
     /* 139851 */     // GIR_Coverage, 4488,
     /* 139851 */     GIR_EraseRootFromParent_Done,
     /* 139852 */   // Label 2435: @139852
     /* 139852 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(139901), // Rule ID 4489 //
     /* 139857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 139860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 139875 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 139875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 139878 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139899 */     GIR_RootConstrainSelectedInstOperands,
     /* 139900 */     // GIR_Coverage, 4489,
     /* 139900 */     GIR_EraseRootFromParent_Done,
     /* 139901 */   // Label 2436: @139901
     /* 139901 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(139950), // Rule ID 4490 //
     /* 139906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 139909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139924 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 139927 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139948 */     GIR_RootConstrainSelectedInstOperands,
     /* 139949 */     // GIR_Coverage, 4490,
     /* 139949 */     GIR_EraseRootFromParent_Done,
     /* 139950 */   // Label 2437: @139950
     /* 139950 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(139999), // Rule ID 4491 //
     /* 139955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 139958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 139973 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 139973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 139976 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139997 */     GIR_RootConstrainSelectedInstOperands,
     /* 139998 */     // GIR_Coverage, 4491,
     /* 139998 */     GIR_EraseRootFromParent_Done,
     /* 139999 */   // Label 2438: @139999
     /* 139999 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(140043), // Rule ID 4530 //
     /* 140004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140022 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140025 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140041 */     GIR_RootConstrainSelectedInstOperands,
     /* 140042 */     // GIR_Coverage, 4530,
     /* 140042 */     GIR_EraseRootFromParent_Done,
     /* 140043 */   // Label 2439: @140043
     /* 140043 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(140087), // Rule ID 4533 //
     /* 140048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140066 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140069 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140085 */     GIR_RootConstrainSelectedInstOperands,
     /* 140086 */     // GIR_Coverage, 4533,
     /* 140086 */     GIR_EraseRootFromParent_Done,
     /* 140087 */   // Label 2440: @140087
     /* 140087 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(140131), // Rule ID 4554 //
     /* 140092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140110 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140113 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140129 */     GIR_RootConstrainSelectedInstOperands,
     /* 140130 */     // GIR_Coverage, 4554,
     /* 140130 */     GIR_EraseRootFromParent_Done,
     /* 140131 */   // Label 2441: @140131
     /* 140131 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(140175), // Rule ID 4557 //
     /* 140136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140154 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140157 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140173 */     GIR_RootConstrainSelectedInstOperands,
     /* 140174 */     // GIR_Coverage, 4557,
     /* 140174 */     GIR_EraseRootFromParent_Done,
     /* 140175 */   // Label 2442: @140175
     /* 140175 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(140195), // Rule ID 6460 //
     /* 140180 */     // MIs[0] Rn
     /* 140180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 140188 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 140188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 140193 */     GIR_RootConstrainSelectedInstOperands,
     /* 140194 */     // GIR_Coverage, 6460,
     /* 140194 */     GIR_Done,
     /* 140195 */   // Label 2443: @140195
     /* 140195 */   GIM_Reject,
     /* 140196 */ // Label 2434: @140196
     /* 140196 */ GIM_Reject,
     /* 140197 */ // Label 2277: @140197
     /* 140197 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(140646),
     /* 140202 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140205 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140209 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(140258), // Rule ID 4502 //
     /* 140214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 140217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 140232 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 140232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 140235 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140256 */     GIR_RootConstrainSelectedInstOperands,
     /* 140257 */     // GIR_Coverage, 4502,
     /* 140257 */     GIR_EraseRootFromParent_Done,
     /* 140258 */   // Label 2445: @140258
     /* 140258 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(140307), // Rule ID 4503 //
     /* 140263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 140266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 140281 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 140281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 140284 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140305 */     GIR_RootConstrainSelectedInstOperands,
     /* 140306 */     // GIR_Coverage, 4503,
     /* 140306 */     GIR_EraseRootFromParent_Done,
     /* 140307 */   // Label 2446: @140307
     /* 140307 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(140356), // Rule ID 4504 //
     /* 140312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 140315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 140330 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 140330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 140333 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140354 */     GIR_RootConstrainSelectedInstOperands,
     /* 140355 */     // GIR_Coverage, 4504,
     /* 140355 */     GIR_EraseRootFromParent_Done,
     /* 140356 */   // Label 2447: @140356
     /* 140356 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(140405), // Rule ID 4505 //
     /* 140361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 140364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 140379 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 140379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 140382 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140403 */     GIR_RootConstrainSelectedInstOperands,
     /* 140404 */     // GIR_Coverage, 4505,
     /* 140404 */     GIR_EraseRootFromParent_Done,
     /* 140405 */   // Label 2448: @140405
     /* 140405 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(140449), // Rule ID 4537 //
     /* 140410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 140428 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 140428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 140431 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140447 */     GIR_RootConstrainSelectedInstOperands,
     /* 140448 */     // GIR_Coverage, 4537,
     /* 140448 */     GIR_EraseRootFromParent_Done,
     /* 140449 */   // Label 2449: @140449
     /* 140449 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(140493), // Rule ID 4541 //
     /* 140454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 140472 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 140472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 140475 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140491 */     GIR_RootConstrainSelectedInstOperands,
     /* 140492 */     // GIR_Coverage, 4541,
     /* 140492 */     GIR_EraseRootFromParent_Done,
     /* 140493 */   // Label 2450: @140493
     /* 140493 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(140537), // Rule ID 4561 //
     /* 140498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 140516 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 140519 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140535 */     GIR_RootConstrainSelectedInstOperands,
     /* 140536 */     // GIR_Coverage, 4561,
     /* 140536 */     GIR_EraseRootFromParent_Done,
     /* 140537 */   // Label 2451: @140537
     /* 140537 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(140581), // Rule ID 4565 //
     /* 140542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 140560 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 140563 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140579 */     GIR_RootConstrainSelectedInstOperands,
     /* 140580 */     // GIR_Coverage, 4565,
     /* 140580 */     GIR_EraseRootFromParent_Done,
     /* 140581 */   // Label 2452: @140581
     /* 140581 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(140625), // Rule ID 4566 //
     /* 140586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 140604 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 140607 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140623 */     GIR_RootConstrainSelectedInstOperands,
     /* 140624 */     // GIR_Coverage, 4566,
     /* 140624 */     GIR_EraseRootFromParent_Done,
     /* 140625 */   // Label 2453: @140625
     /* 140625 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(140645), // Rule ID 6457 //
     /* 140630 */     // MIs[0] Rn
     /* 140630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 140638 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 140638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 140643 */     GIR_RootConstrainSelectedInstOperands,
     /* 140644 */     // GIR_Coverage, 6457,
     /* 140644 */     GIR_Done,
     /* 140645 */   // Label 2454: @140645
     /* 140645 */   GIM_Reject,
     /* 140646 */ // Label 2444: @140646
     /* 140646 */ GIM_Reject,
     /* 140647 */ // Label 2278: @140647
     /* 140647 */ GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(141052),
     /* 140652 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140655 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140659 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(140708), // Rule ID 4492 //
     /* 140664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 140682 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 140682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 140685 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140706 */     GIR_RootConstrainSelectedInstOperands,
     /* 140707 */     // GIR_Coverage, 4492,
     /* 140707 */     GIR_EraseRootFromParent_Done,
     /* 140708 */   // Label 2456: @140708
     /* 140708 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(140757), // Rule ID 4493 //
     /* 140713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 140731 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 140731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 140734 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140755 */     GIR_RootConstrainSelectedInstOperands,
     /* 140756 */     // GIR_Coverage, 4493,
     /* 140756 */     GIR_EraseRootFromParent_Done,
     /* 140757 */   // Label 2457: @140757
     /* 140757 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(140806), // Rule ID 4496 //
     /* 140762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 140780 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 140780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 140783 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140804 */     GIR_RootConstrainSelectedInstOperands,
     /* 140805 */     // GIR_Coverage, 4496,
     /* 140805 */     GIR_EraseRootFromParent_Done,
     /* 140806 */   // Label 2458: @140806
     /* 140806 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(140855), // Rule ID 4497 //
     /* 140811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 140829 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 140829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 140832 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140853 */     GIR_RootConstrainSelectedInstOperands,
     /* 140854 */     // GIR_Coverage, 4497,
     /* 140854 */     GIR_EraseRootFromParent_Done,
     /* 140855 */   // Label 2459: @140855
     /* 140855 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(140899), // Rule ID 4532 //
     /* 140860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140878 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140881 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140897 */     GIR_RootConstrainSelectedInstOperands,
     /* 140898 */     // GIR_Coverage, 4532,
     /* 140898 */     GIR_EraseRootFromParent_Done,
     /* 140899 */   // Label 2460: @140899
     /* 140899 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(140943), // Rule ID 4534 //
     /* 140904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140922 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140925 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140941 */     GIR_RootConstrainSelectedInstOperands,
     /* 140942 */     // GIR_Coverage, 4534,
     /* 140942 */     GIR_EraseRootFromParent_Done,
     /* 140943 */   // Label 2461: @140943
     /* 140943 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(140987), // Rule ID 4556 //
     /* 140948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140966 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140969 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140985 */     GIR_RootConstrainSelectedInstOperands,
     /* 140986 */     // GIR_Coverage, 4556,
     /* 140986 */     GIR_EraseRootFromParent_Done,
     /* 140987 */   // Label 2462: @140987
     /* 140987 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(141031), // Rule ID 4558 //
     /* 140992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 140995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141010 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141013 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141029 */     GIR_RootConstrainSelectedInstOperands,
     /* 141030 */     // GIR_Coverage, 4558,
     /* 141030 */     GIR_EraseRootFromParent_Done,
     /* 141031 */   // Label 2463: @141031
     /* 141031 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(141051), // Rule ID 6459 //
     /* 141036 */     // MIs[0] Rn
     /* 141036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141044 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 141049 */     GIR_RootConstrainSelectedInstOperands,
     /* 141050 */     // GIR_Coverage, 6459,
     /* 141050 */     GIR_Done,
     /* 141051 */   // Label 2464: @141051
     /* 141051 */   GIM_Reject,
     /* 141052 */ // Label 2455: @141052
     /* 141052 */ GIM_Reject,
     /* 141053 */ // Label 2279: @141053
     /* 141053 */ GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(141458),
     /* 141058 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141061 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141065 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(141114), // Rule ID 4506 //
     /* 141070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141088 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141091 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141112 */     GIR_RootConstrainSelectedInstOperands,
     /* 141113 */     // GIR_Coverage, 4506,
     /* 141113 */     GIR_EraseRootFromParent_Done,
     /* 141114 */   // Label 2466: @141114
     /* 141114 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(141163), // Rule ID 4507 //
     /* 141119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141137 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141140 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141161 */     GIR_RootConstrainSelectedInstOperands,
     /* 141162 */     // GIR_Coverage, 4507,
     /* 141162 */     GIR_EraseRootFromParent_Done,
     /* 141163 */   // Label 2467: @141163
     /* 141163 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(141212), // Rule ID 4508 //
     /* 141168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141186 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141189 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141210 */     GIR_RootConstrainSelectedInstOperands,
     /* 141211 */     // GIR_Coverage, 4508,
     /* 141211 */     GIR_EraseRootFromParent_Done,
     /* 141212 */   // Label 2468: @141212
     /* 141212 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(141261), // Rule ID 4509 //
     /* 141217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141235 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141238 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141259 */     GIR_RootConstrainSelectedInstOperands,
     /* 141260 */     // GIR_Coverage, 4509,
     /* 141260 */     GIR_EraseRootFromParent_Done,
     /* 141261 */   // Label 2469: @141261
     /* 141261 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(141305), // Rule ID 4536 //
     /* 141266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 141284 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 141284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 141287 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141303 */     GIR_RootConstrainSelectedInstOperands,
     /* 141304 */     // GIR_Coverage, 4536,
     /* 141304 */     GIR_EraseRootFromParent_Done,
     /* 141305 */   // Label 2470: @141305
     /* 141305 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(141349), // Rule ID 4540 //
     /* 141310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 141328 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 141328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 141331 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141347 */     GIR_RootConstrainSelectedInstOperands,
     /* 141348 */     // GIR_Coverage, 4540,
     /* 141348 */     GIR_EraseRootFromParent_Done,
     /* 141349 */   // Label 2471: @141349
     /* 141349 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(141393), // Rule ID 4560 //
     /* 141354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141372 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 141375 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141391 */     GIR_RootConstrainSelectedInstOperands,
     /* 141392 */     // GIR_Coverage, 4560,
     /* 141392 */     GIR_EraseRootFromParent_Done,
     /* 141393 */   // Label 2472: @141393
     /* 141393 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(141437), // Rule ID 4564 //
     /* 141398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141416 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 141419 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141435 */     GIR_RootConstrainSelectedInstOperands,
     /* 141436 */     // GIR_Coverage, 4564,
     /* 141436 */     GIR_EraseRootFromParent_Done,
     /* 141437 */   // Label 2473: @141437
     /* 141437 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(141457), // Rule ID 6456 //
     /* 141442 */     // MIs[0] Rn
     /* 141442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141450 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 141455 */     GIR_RootConstrainSelectedInstOperands,
     /* 141456 */     // GIR_Coverage, 6456,
     /* 141456 */     GIR_Done,
     /* 141457 */   // Label 2474: @141457
     /* 141457 */   GIM_Reject,
     /* 141458 */ // Label 2465: @141458
     /* 141458 */ GIM_Reject,
     /* 141459 */ // Label 2280: @141459
     /* 141459 */ GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(141678),
     /* 141464 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141467 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141471 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(141520), // Rule ID 4494 //
     /* 141476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 141494 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 141494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 141497 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141518 */     GIR_RootConstrainSelectedInstOperands,
     /* 141519 */     // GIR_Coverage, 4494,
     /* 141519 */     GIR_EraseRootFromParent_Done,
     /* 141520 */   // Label 2476: @141520
     /* 141520 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(141569), // Rule ID 4495 //
     /* 141525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 141543 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 141543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 141546 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141567 */     GIR_RootConstrainSelectedInstOperands,
     /* 141568 */     // GIR_Coverage, 4495,
     /* 141568 */     GIR_EraseRootFromParent_Done,
     /* 141569 */   // Label 2477: @141569
     /* 141569 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(141613), // Rule ID 4531 //
     /* 141574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 141592 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 141592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 141595 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141611 */     GIR_RootConstrainSelectedInstOperands,
     /* 141612 */     // GIR_Coverage, 4531,
     /* 141612 */     GIR_EraseRootFromParent_Done,
     /* 141613 */   // Label 2478: @141613
     /* 141613 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(141657), // Rule ID 4555 //
     /* 141618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141636 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141639 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141655 */     GIR_RootConstrainSelectedInstOperands,
     /* 141656 */     // GIR_Coverage, 4555,
     /* 141656 */     GIR_EraseRootFromParent_Done,
     /* 141657 */   // Label 2479: @141657
     /* 141657 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(141677), // Rule ID 6458 //
     /* 141662 */     // MIs[0] Rn
     /* 141662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141670 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141670 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 141675 */     GIR_RootConstrainSelectedInstOperands,
     /* 141676 */     // GIR_Coverage, 6458,
     /* 141676 */     GIR_Done,
     /* 141677 */   // Label 2480: @141677
     /* 141677 */   GIM_Reject,
     /* 141678 */ // Label 2475: @141678
     /* 141678 */ GIM_Reject,
     /* 141679 */ // Label 2281: @141679
     /* 141679 */ GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(142084),
     /* 141684 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141687 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141691 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(141740), // Rule ID 4510 //
     /* 141696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141714 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141717 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141738 */     GIR_RootConstrainSelectedInstOperands,
     /* 141739 */     // GIR_Coverage, 4510,
     /* 141739 */     GIR_EraseRootFromParent_Done,
     /* 141740 */   // Label 2482: @141740
     /* 141740 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(141789), // Rule ID 4511 //
     /* 141745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141763 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141766 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141787 */     GIR_RootConstrainSelectedInstOperands,
     /* 141788 */     // GIR_Coverage, 4511,
     /* 141788 */     GIR_EraseRootFromParent_Done,
     /* 141789 */   // Label 2483: @141789
     /* 141789 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(141838), // Rule ID 4514 //
     /* 141794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141812 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141815 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141836 */     GIR_RootConstrainSelectedInstOperands,
     /* 141837 */     // GIR_Coverage, 4514,
     /* 141837 */     GIR_EraseRootFromParent_Done,
     /* 141838 */   // Label 2484: @141838
     /* 141838 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(141887), // Rule ID 4515 //
     /* 141843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141861 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141864 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141885 */     GIR_RootConstrainSelectedInstOperands,
     /* 141886 */     // GIR_Coverage, 4515,
     /* 141886 */     GIR_EraseRootFromParent_Done,
     /* 141887 */   // Label 2485: @141887
     /* 141887 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(141931), // Rule ID 4539 //
     /* 141892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 141910 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 141910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 141913 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141929 */     GIR_RootConstrainSelectedInstOperands,
     /* 141930 */     // GIR_Coverage, 4539,
     /* 141930 */     GIR_EraseRootFromParent_Done,
     /* 141931 */   // Label 2486: @141931
     /* 141931 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(141975), // Rule ID 4542 //
     /* 141936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 141954 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 141954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 141957 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141973 */     GIR_RootConstrainSelectedInstOperands,
     /* 141974 */     // GIR_Coverage, 4542,
     /* 141974 */     GIR_EraseRootFromParent_Done,
     /* 141975 */   // Label 2487: @141975
     /* 141975 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(142019), // Rule ID 4563 //
     /* 141980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141998 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142001 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142017 */     GIR_RootConstrainSelectedInstOperands,
     /* 142018 */     // GIR_Coverage, 4563,
     /* 142018 */     GIR_EraseRootFromParent_Done,
     /* 142019 */   // Label 2488: @142019
     /* 142019 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(142063), // Rule ID 4567 //
     /* 142024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142042 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142045 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142061 */     GIR_RootConstrainSelectedInstOperands,
     /* 142062 */     // GIR_Coverage, 4567,
     /* 142062 */     GIR_EraseRootFromParent_Done,
     /* 142063 */   // Label 2489: @142063
     /* 142063 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(142083), // Rule ID 6455 //
     /* 142068 */     // MIs[0] Rn
     /* 142068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142076 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 142076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 142081 */     GIR_RootConstrainSelectedInstOperands,
     /* 142082 */     // GIR_Coverage, 6455,
     /* 142082 */     GIR_Done,
     /* 142083 */   // Label 2490: @142083
     /* 142083 */   GIM_Reject,
     /* 142084 */ // Label 2481: @142084
     /* 142084 */ GIM_Reject,
     /* 142085 */ // Label 2282: @142085
     /* 142085 */ GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(142304),
     /* 142090 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142093 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142097 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(142146), // Rule ID 4512 //
     /* 142102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 142120 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 142120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 142123 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142144 */     GIR_RootConstrainSelectedInstOperands,
     /* 142145 */     // GIR_Coverage, 4512,
     /* 142145 */     GIR_EraseRootFromParent_Done,
     /* 142146 */   // Label 2492: @142146
     /* 142146 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(142195), // Rule ID 4513 //
     /* 142151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 142169 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 142169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 142172 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142193 */     GIR_RootConstrainSelectedInstOperands,
     /* 142194 */     // GIR_Coverage, 4513,
     /* 142194 */     GIR_EraseRootFromParent_Done,
     /* 142195 */   // Label 2493: @142195
     /* 142195 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(142239), // Rule ID 4538 //
     /* 142200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142218 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142221 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142237 */     GIR_RootConstrainSelectedInstOperands,
     /* 142238 */     // GIR_Coverage, 4538,
     /* 142238 */     GIR_EraseRootFromParent_Done,
     /* 142239 */   // Label 2494: @142239
     /* 142239 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(142283), // Rule ID 4562 //
     /* 142244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142262 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142265 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142281 */     GIR_RootConstrainSelectedInstOperands,
     /* 142282 */     // GIR_Coverage, 4562,
     /* 142282 */     GIR_EraseRootFromParent_Done,
     /* 142283 */   // Label 2495: @142283
     /* 142283 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(142303), // Rule ID 6454 //
     /* 142288 */     // MIs[0] Rn
     /* 142288 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142296 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 142296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 142301 */     GIR_RootConstrainSelectedInstOperands,
     /* 142302 */     // GIR_Coverage, 6454,
     /* 142302 */     GIR_Done,
     /* 142303 */   // Label 2496: @142303
     /* 142303 */   GIM_Reject,
     /* 142304 */ // Label 2491: @142304
     /* 142304 */ GIM_Reject,
     /* 142305 */ // Label 2283: @142305
     /* 142305 */ GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(142364), // Rule ID 10938 //
     /* 142310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142313 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142316 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142320 */   // MIs[0] base
     /* 142320 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142328 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 142335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142340 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142343 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 142348 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142353 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142358 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142362 */   GIR_RootConstrainSelectedInstOperands,
     /* 142363 */   // GIR_Coverage, 10938,
     /* 142363 */   GIR_EraseRootFromParent_Done,
     /* 142364 */ // Label 2497: @142364
     /* 142364 */ GIM_Reject,
     /* 142365 */ // Label 2284: @142365
     /* 142365 */ GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(142424), // Rule ID 10944 //
     /* 142370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142373 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142376 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142380 */   // MIs[0] base
     /* 142380 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142388 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142388 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142391 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 142395 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142400 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142403 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 142408 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142410 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142413 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142418 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142422 */   GIR_RootConstrainSelectedInstOperands,
     /* 142423 */   // GIR_Coverage, 10944,
     /* 142423 */   GIR_EraseRootFromParent_Done,
     /* 142424 */ // Label 2498: @142424
     /* 142424 */ GIM_Reject,
     /* 142425 */ // Label 2285: @142425
     /* 142425 */ GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(142594),
     /* 142430 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142433 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142437 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142441 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(142489), // Rule ID 10929 //
     /* 142446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142453 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 142460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142465 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 142473 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142478 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142487 */     GIR_RootConstrainSelectedInstOperands,
     /* 142488 */     // GIR_Coverage, 10929,
     /* 142488 */     GIR_EraseRootFromParent_Done,
     /* 142489 */   // Label 2500: @142489
     /* 142489 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(142537), // Rule ID 10947 //
     /* 142494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142501 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 142508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142513 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 142521 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142526 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142535 */     GIR_RootConstrainSelectedInstOperands,
     /* 142536 */     // GIR_Coverage, 10947,
     /* 142536 */     GIR_EraseRootFromParent_Done,
     /* 142537 */   // Label 2501: @142537
     /* 142537 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(142565), // Rule ID 11059 //
     /* 142542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142549 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142552 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142554 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142563 */     GIR_RootConstrainSelectedInstOperands,
     /* 142564 */     // GIR_Coverage, 11059,
     /* 142564 */     GIR_EraseRootFromParent_Done,
     /* 142565 */   // Label 2502: @142565
     /* 142565 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(142593), // Rule ID 11071 //
     /* 142570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142577 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142580 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142582 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142591 */     GIR_RootConstrainSelectedInstOperands,
     /* 142592 */     // GIR_Coverage, 11071,
     /* 142592 */     GIR_EraseRootFromParent_Done,
     /* 142593 */   // Label 2503: @142593
     /* 142593 */   GIM_Reject,
     /* 142594 */ // Label 2499: @142594
     /* 142594 */ GIM_Reject,
     /* 142595 */ // Label 2286: @142595
     /* 142595 */ GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(142654), // Rule ID 10935 //
     /* 142600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142603 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142606 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142610 */   // MIs[0] base
     /* 142610 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142618 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142618 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142621 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 142625 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142630 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142633 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 142638 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142640 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142643 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142652 */   GIR_RootConstrainSelectedInstOperands,
     /* 142653 */   // GIR_Coverage, 10935,
     /* 142653 */   GIR_EraseRootFromParent_Done,
     /* 142654 */ // Label 2504: @142654
     /* 142654 */ GIM_Reject,
     /* 142655 */ // Label 2287: @142655
     /* 142655 */ GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(142824),
     /* 142660 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142663 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142667 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142671 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(142719), // Rule ID 10923 //
     /* 142676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142683 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 142690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142695 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 142703 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142708 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142717 */     GIR_RootConstrainSelectedInstOperands,
     /* 142718 */     // GIR_Coverage, 10923,
     /* 142718 */     GIR_EraseRootFromParent_Done,
     /* 142719 */   // Label 2506: @142719
     /* 142719 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(142767), // Rule ID 10941 //
     /* 142724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142731 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 142738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142743 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 142751 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142756 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142765 */     GIR_RootConstrainSelectedInstOperands,
     /* 142766 */     // GIR_Coverage, 10941,
     /* 142766 */     GIR_EraseRootFromParent_Done,
     /* 142767 */   // Label 2507: @142767
     /* 142767 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(142795), // Rule ID 11055 //
     /* 142772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142779 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142782 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142784 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142793 */     GIR_RootConstrainSelectedInstOperands,
     /* 142794 */     // GIR_Coverage, 11055,
     /* 142794 */     GIR_EraseRootFromParent_Done,
     /* 142795 */   // Label 2508: @142795
     /* 142795 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(142823), // Rule ID 11067 //
     /* 142800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142807 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142810 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142812 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142821 */     GIR_RootConstrainSelectedInstOperands,
     /* 142822 */     // GIR_Coverage, 11067,
     /* 142822 */     GIR_EraseRootFromParent_Done,
     /* 142823 */   // Label 2509: @142823
     /* 142823 */   GIM_Reject,
     /* 142824 */ // Label 2505: @142824
     /* 142824 */ GIM_Reject,
     /* 142825 */ // Label 2288: @142825
     /* 142825 */ GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(142994),
     /* 142830 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142833 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142837 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142841 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(142889), // Rule ID 10914 //
     /* 142846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142853 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 142860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142865 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 142873 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142878 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142887 */     GIR_RootConstrainSelectedInstOperands,
     /* 142888 */     // GIR_Coverage, 10914,
     /* 142888 */     GIR_EraseRootFromParent_Done,
     /* 142889 */   // Label 2511: @142889
     /* 142889 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(142937), // Rule ID 10932 //
     /* 142894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 142897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142901 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 142904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 142908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142913 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 142916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 142921 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142926 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142935 */     GIR_RootConstrainSelectedInstOperands,
     /* 142936 */     // GIR_Coverage, 10932,
     /* 142936 */     GIR_EraseRootFromParent_Done,
     /* 142937 */   // Label 2512: @142937
     /* 142937 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(142965), // Rule ID 11051 //
     /* 142942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142949 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142952 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142954 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142963 */     GIR_RootConstrainSelectedInstOperands,
     /* 142964 */     // GIR_Coverage, 11051,
     /* 142964 */     GIR_EraseRootFromParent_Done,
     /* 142965 */   // Label 2513: @142965
     /* 142965 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(142993), // Rule ID 11063 //
     /* 142970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 142973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142977 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 142977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 142980 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 142982 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 142984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142991 */     GIR_RootConstrainSelectedInstOperands,
     /* 142992 */     // GIR_Coverage, 11063,
     /* 142992 */     GIR_EraseRootFromParent_Done,
     /* 142993 */   // Label 2514: @142993
     /* 142993 */   GIM_Reject,
     /* 142994 */ // Label 2510: @142994
     /* 142994 */ GIM_Reject,
     /* 142995 */ // Label 2289: @142995
     /* 142995 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(143038), // Rule ID 2430 //
     /* 143000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143003 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143006 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 143014 */   // MIs[0] base
     /* 143014 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143022 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 143025 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 143027 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143032 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143036 */   GIR_RootConstrainSelectedInstOperands,
     /* 143037 */   // GIR_Coverage, 2430,
     /* 143037 */   GIR_EraseRootFromParent_Done,
     /* 143038 */ // Label 2515: @143038
     /* 143038 */ GIM_Reject,
     /* 143039 */ // Label 2290: @143039
     /* 143039 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(143132),
     /* 143044 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143047 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143051 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143055 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(143103), // Rule ID 10900 //
     /* 143060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143067 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 143070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 143074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143079 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 143082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 143087 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143092 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143101 */     GIR_RootConstrainSelectedInstOperands,
     /* 143102 */     // GIR_Coverage, 10900,
     /* 143102 */     GIR_EraseRootFromParent_Done,
     /* 143103 */   // Label 2517: @143103
     /* 143103 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(143131), // Rule ID 11047 //
     /* 143108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 143111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143115 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 143118 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143120 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143129 */     GIR_RootConstrainSelectedInstOperands,
     /* 143130 */     // GIR_Coverage, 11047,
     /* 143130 */     GIR_EraseRootFromParent_Done,
     /* 143131 */   // Label 2518: @143131
     /* 143131 */   GIM_Reject,
     /* 143132 */ // Label 2516: @143132
     /* 143132 */ GIM_Reject,
     /* 143133 */ // Label 2291: @143133
     /* 143133 */ GIM_Reject,
     /* 143134 */ // Label 20: @143134
     /* 143134 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2521*/ GIMT_Encode4(144484),
     /* 143145 */ /*GILLT_s32*//*Label 2519*/ GIMT_Encode4(143153),
     /* 143149 */ /*GILLT_s64*//*Label 2520*/ GIMT_Encode4(144171),
     /* 143153 */ // Label 2519: @143153
     /* 143153 */ GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(144170),
     /* 143158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 143161 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 143164 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(143219), // Rule ID 7360 //
     /* 143169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143172 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143179 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 143182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143186 */     // MIs[0] Rn
     /* 143186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143202 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 143205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143217 */     GIR_RootConstrainSelectedInstOperands,
     /* 143218 */     // GIR_Coverage, 7360,
     /* 143218 */     GIR_EraseRootFromParent_Done,
     /* 143219 */   // Label 2523: @143219
     /* 143219 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(143274), // Rule ID 7361 //
     /* 143224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143227 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143234 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 143237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143241 */     // MIs[0] Rn
     /* 143241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143257 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 143260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143266 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143272 */     GIR_RootConstrainSelectedInstOperands,
     /* 143273 */     // GIR_Coverage, 7361,
     /* 143273 */     GIR_EraseRootFromParent_Done,
     /* 143274 */   // Label 2524: @143274
     /* 143274 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(143329), // Rule ID 7362 //
     /* 143279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143282 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143289 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 143292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143296 */     // MIs[0] Rn
     /* 143296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143312 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 143315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143327 */     GIR_RootConstrainSelectedInstOperands,
     /* 143328 */     // GIR_Coverage, 7362,
     /* 143328 */     GIR_EraseRootFromParent_Done,
     /* 143329 */   // Label 2525: @143329
     /* 143329 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(143384), // Rule ID 7363 //
     /* 143334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143337 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143344 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 143347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143351 */     // MIs[0] Rn
     /* 143351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143367 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 143370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143382 */     GIR_RootConstrainSelectedInstOperands,
     /* 143383 */     // GIR_Coverage, 7363,
     /* 143383 */     GIR_EraseRootFromParent_Done,
     /* 143384 */   // Label 2526: @143384
     /* 143384 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(143439), // Rule ID 7364 //
     /* 143389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143392 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 143399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 143402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143406 */     // MIs[0] Rn
     /* 143406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143422 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 143425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143437 */     GIR_RootConstrainSelectedInstOperands,
     /* 143438 */     // GIR_Coverage, 7364,
     /* 143438 */     GIR_EraseRootFromParent_Done,
     /* 143439 */   // Label 2527: @143439
     /* 143439 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(143494), // Rule ID 7365 //
     /* 143444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143447 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143454 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 143457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143461 */     // MIs[0] Rn
     /* 143461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143477 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 143480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143492 */     GIR_RootConstrainSelectedInstOperands,
     /* 143493 */     // GIR_Coverage, 7365,
     /* 143493 */     GIR_EraseRootFromParent_Done,
     /* 143494 */   // Label 2528: @143494
     /* 143494 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(143549), // Rule ID 7366 //
     /* 143499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143502 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143509 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 143512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143516 */     // MIs[0] Rn
     /* 143516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143532 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 143535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143547 */     GIR_RootConstrainSelectedInstOperands,
     /* 143548 */     // GIR_Coverage, 7366,
     /* 143548 */     GIR_EraseRootFromParent_Done,
     /* 143549 */   // Label 2529: @143549
     /* 143549 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(143604), // Rule ID 7367 //
     /* 143554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143557 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143564 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 143567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143571 */     // MIs[0] Rn
     /* 143571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143587 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 143590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143602 */     GIR_RootConstrainSelectedInstOperands,
     /* 143603 */     // GIR_Coverage, 7367,
     /* 143603 */     GIR_EraseRootFromParent_Done,
     /* 143604 */   // Label 2530: @143604
     /* 143604 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(143659), // Rule ID 7368 //
     /* 143609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143612 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143619 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 143622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143626 */     // MIs[0] Rn
     /* 143626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143642 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 143645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143657 */     GIR_RootConstrainSelectedInstOperands,
     /* 143658 */     // GIR_Coverage, 7368,
     /* 143658 */     GIR_EraseRootFromParent_Done,
     /* 143659 */   // Label 2531: @143659
     /* 143659 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(143714), // Rule ID 7369 //
     /* 143664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143667 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 143674 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 143677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143681 */     // MIs[0] Rn
     /* 143681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143697 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 143700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143712 */     GIR_RootConstrainSelectedInstOperands,
     /* 143713 */     // GIR_Coverage, 7369,
     /* 143713 */     GIR_EraseRootFromParent_Done,
     /* 143714 */   // Label 2532: @143714
     /* 143714 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(143769), // Rule ID 7370 //
     /* 143719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143722 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143729 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 143732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143736 */     // MIs[0] Rn
     /* 143736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143752 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 143755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143767 */     GIR_RootConstrainSelectedInstOperands,
     /* 143768 */     // GIR_Coverage, 7370,
     /* 143768 */     GIR_EraseRootFromParent_Done,
     /* 143769 */   // Label 2533: @143769
     /* 143769 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(143824), // Rule ID 7371 //
     /* 143774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143777 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 143787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143791 */     // MIs[0] Rn
     /* 143791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143807 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 143810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143822 */     GIR_RootConstrainSelectedInstOperands,
     /* 143823 */     // GIR_Coverage, 7371,
     /* 143823 */     GIR_EraseRootFromParent_Done,
     /* 143824 */   // Label 2534: @143824
     /* 143824 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(143879), // Rule ID 7372 //
     /* 143829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143832 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143839 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 143842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143846 */     // MIs[0] Rn
     /* 143846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143862 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 143865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143871 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143877 */     GIR_RootConstrainSelectedInstOperands,
     /* 143878 */     // GIR_Coverage, 7372,
     /* 143878 */     GIR_EraseRootFromParent_Done,
     /* 143879 */   // Label 2535: @143879
     /* 143879 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(143934), // Rule ID 7373 //
     /* 143884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143887 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143894 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 143897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143901 */     // MIs[0] Rn
     /* 143901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143917 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 143920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143932 */     GIR_RootConstrainSelectedInstOperands,
     /* 143933 */     // GIR_Coverage, 7373,
     /* 143933 */     GIR_EraseRootFromParent_Done,
     /* 143934 */   // Label 2536: @143934
     /* 143934 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(143989), // Rule ID 7374 //
     /* 143939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 143942 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 143949 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 143952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143956 */     // MIs[0] Rn
     /* 143956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 143972 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 143972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 143975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 143977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 143979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 143981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 143983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143987 */     GIR_RootConstrainSelectedInstOperands,
     /* 143988 */     // GIR_Coverage, 7374,
     /* 143988 */     GIR_EraseRootFromParent_Done,
     /* 143989 */   // Label 2537: @143989
     /* 143989 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(144049), // Rule ID 13199 //
     /* 143994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 143997 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 144004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144008 */     // MIs[0] addr
     /* 144008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144024 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 144024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 144027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 144030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144032 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 144037 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 144039 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 144041 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 144043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144047 */     GIR_RootConstrainSelectedInstOperands,
     /* 144048 */     // GIR_Coverage, 13199,
     /* 144048 */     GIR_EraseRootFromParent_Done,
     /* 144049 */   // Label 2538: @144049
     /* 144049 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(144109), // Rule ID 13200 //
     /* 144054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 144057 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144068 */     // MIs[0] addr
     /* 144068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144084 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 144084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 144087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 144090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144092 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 144097 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 144099 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 144101 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 144103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144107 */     GIR_RootConstrainSelectedInstOperands,
     /* 144108 */     // GIR_Coverage, 13200,
     /* 144108 */     GIR_EraseRootFromParent_Done,
     /* 144109 */   // Label 2539: @144109
     /* 144109 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(144169), // Rule ID 13201 //
     /* 144114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 144117 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144128 */     // MIs[0] addr
     /* 144128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144144 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 144144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 144147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 144150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144152 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 144157 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 144159 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 144161 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 144163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144167 */     GIR_RootConstrainSelectedInstOperands,
     /* 144168 */     // GIR_Coverage, 13201,
     /* 144168 */     GIR_EraseRootFromParent_Done,
     /* 144169 */   // Label 2540: @144169
     /* 144169 */   GIM_Reject,
     /* 144170 */ // Label 2522: @144170
     /* 144170 */ GIM_Reject,
     /* 144171 */ // Label 2520: @144171
     /* 144171 */ GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(144483),
     /* 144176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 144179 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 144182 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 144189 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(144237), // Rule ID 2589 //
     /* 144194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144197 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 144200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144204 */     // MIs[0] Rn
     /* 144204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144220 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 144223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144235 */     GIR_RootConstrainSelectedInstOperands,
     /* 144236 */     // GIR_Coverage, 2589,
     /* 144236 */     GIR_EraseRootFromParent_Done,
     /* 144237 */   // Label 2542: @144237
     /* 144237 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(144285), // Rule ID 2590 //
     /* 144242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 144248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144252 */     // MIs[0] Rn
     /* 144252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144268 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 144271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144277 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144283 */     GIR_RootConstrainSelectedInstOperands,
     /* 144284 */     // GIR_Coverage, 2590,
     /* 144284 */     GIR_EraseRootFromParent_Done,
     /* 144285 */   // Label 2543: @144285
     /* 144285 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(144333), // Rule ID 2591 //
     /* 144290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144293 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 144296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144300 */     // MIs[0] Rn
     /* 144300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144316 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 144319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144331 */     GIR_RootConstrainSelectedInstOperands,
     /* 144332 */     // GIR_Coverage, 2591,
     /* 144332 */     GIR_EraseRootFromParent_Done,
     /* 144333 */   // Label 2544: @144333
     /* 144333 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(144381), // Rule ID 2592 //
     /* 144338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144341 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 144344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144348 */     // MIs[0] Rn
     /* 144348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144364 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 144367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144379 */     GIR_RootConstrainSelectedInstOperands,
     /* 144380 */     // GIR_Coverage, 2592,
     /* 144380 */     GIR_EraseRootFromParent_Done,
     /* 144381 */   // Label 2545: @144381
     /* 144381 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(144429), // Rule ID 2593 //
     /* 144386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144389 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 144392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144396 */     // MIs[0] Rn
     /* 144396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144412 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 144415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144427 */     GIR_RootConstrainSelectedInstOperands,
     /* 144428 */     // GIR_Coverage, 2593,
     /* 144428 */     GIR_EraseRootFromParent_Done,
     /* 144429 */   // Label 2546: @144429
     /* 144429 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(144482), // Rule ID 13202 //
     /* 144434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 144437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144441 */     // MIs[0] addr
     /* 144441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144457 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 144457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 144460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 144463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144465 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 144470 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 144472 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 144474 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 144476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144480 */     GIR_RootConstrainSelectedInstOperands,
     /* 144481 */     // GIR_Coverage, 13202,
     /* 144481 */     GIR_EraseRootFromParent_Done,
     /* 144482 */   // Label 2547: @144482
     /* 144482 */   GIM_Reject,
     /* 144483 */ // Label 2541: @144483
     /* 144483 */ GIM_Reject,
     /* 144484 */ // Label 2521: @144484
     /* 144484 */ GIM_Reject,
     /* 144485 */ // Label 21: @144485
     /* 144485 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2550*/ GIMT_Encode4(145476),
     /* 144496 */ /*GILLT_s32*//*Label 2548*/ GIMT_Encode4(144504),
     /* 144500 */ /*GILLT_s64*//*Label 2549*/ GIMT_Encode4(145249),
     /* 144504 */ // Label 2548: @144504
     /* 144504 */ GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(145248),
     /* 144509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144512 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(144561), // Rule ID 7345 //
     /* 144517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144520 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144527 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 144530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144534 */     // MIs[0] Rn
     /* 144534 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144546 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 144549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144553 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144559 */     GIR_RootConstrainSelectedInstOperands,
     /* 144560 */     // GIR_Coverage, 7345,
     /* 144560 */     GIR_EraseRootFromParent_Done,
     /* 144561 */   // Label 2552: @144561
     /* 144561 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(144610), // Rule ID 7346 //
     /* 144566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144569 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144576 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 144579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144583 */     // MIs[0] Rn
     /* 144583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144595 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 144598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144608 */     GIR_RootConstrainSelectedInstOperands,
     /* 144609 */     // GIR_Coverage, 7346,
     /* 144609 */     GIR_EraseRootFromParent_Done,
     /* 144610 */   // Label 2553: @144610
     /* 144610 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(144659), // Rule ID 7347 //
     /* 144615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144618 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144625 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 144628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144632 */     // MIs[0] Rn
     /* 144632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144644 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 144647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144657 */     GIR_RootConstrainSelectedInstOperands,
     /* 144658 */     // GIR_Coverage, 7347,
     /* 144658 */     GIR_EraseRootFromParent_Done,
     /* 144659 */   // Label 2554: @144659
     /* 144659 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(144708), // Rule ID 7348 //
     /* 144664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144667 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144674 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 144677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144681 */     // MIs[0] Rn
     /* 144681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144693 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 144696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144706 */     GIR_RootConstrainSelectedInstOperands,
     /* 144707 */     // GIR_Coverage, 7348,
     /* 144707 */     GIR_EraseRootFromParent_Done,
     /* 144708 */   // Label 2555: @144708
     /* 144708 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(144757), // Rule ID 7349 //
     /* 144713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144716 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144723 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 144726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144730 */     // MIs[0] Rn
     /* 144730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144742 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 144745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144755 */     GIR_RootConstrainSelectedInstOperands,
     /* 144756 */     // GIR_Coverage, 7349,
     /* 144756 */     GIR_EraseRootFromParent_Done,
     /* 144757 */   // Label 2556: @144757
     /* 144757 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(144806), // Rule ID 7350 //
     /* 144762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144765 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144772 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 144775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144779 */     // MIs[0] Rn
     /* 144779 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144791 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 144794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144804 */     GIR_RootConstrainSelectedInstOperands,
     /* 144805 */     // GIR_Coverage, 7350,
     /* 144805 */     GIR_EraseRootFromParent_Done,
     /* 144806 */   // Label 2557: @144806
     /* 144806 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(144855), // Rule ID 7351 //
     /* 144811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144814 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144821 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 144824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144828 */     // MIs[0] Rn
     /* 144828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144840 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 144843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144853 */     GIR_RootConstrainSelectedInstOperands,
     /* 144854 */     // GIR_Coverage, 7351,
     /* 144854 */     GIR_EraseRootFromParent_Done,
     /* 144855 */   // Label 2558: @144855
     /* 144855 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(144904), // Rule ID 7352 //
     /* 144860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144863 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144870 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 144873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144877 */     // MIs[0] Rn
     /* 144877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144889 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 144892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144902 */     GIR_RootConstrainSelectedInstOperands,
     /* 144903 */     // GIR_Coverage, 7352,
     /* 144903 */     GIR_EraseRootFromParent_Done,
     /* 144904 */   // Label 2559: @144904
     /* 144904 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(144953), // Rule ID 7353 //
     /* 144909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144912 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 144922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144926 */     // MIs[0] Rn
     /* 144926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144938 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 144941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144951 */     GIR_RootConstrainSelectedInstOperands,
     /* 144952 */     // GIR_Coverage, 7353,
     /* 144952 */     GIR_EraseRootFromParent_Done,
     /* 144953 */   // Label 2560: @144953
     /* 144953 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(145002), // Rule ID 7354 //
     /* 144958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144961 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 144968 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 144971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144975 */     // MIs[0] Rn
     /* 144975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144987 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 144987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 144990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 144992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 144994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145000 */     GIR_RootConstrainSelectedInstOperands,
     /* 145001 */     // GIR_Coverage, 7354,
     /* 145001 */     GIR_EraseRootFromParent_Done,
     /* 145002 */   // Label 2561: @145002
     /* 145002 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(145051), // Rule ID 7355 //
     /* 145007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145017 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145024 */     // MIs[0] Rn
     /* 145024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145036 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 145039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145049 */     GIR_RootConstrainSelectedInstOperands,
     /* 145050 */     // GIR_Coverage, 7355,
     /* 145050 */     GIR_EraseRootFromParent_Done,
     /* 145051 */   // Label 2562: @145051
     /* 145051 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(145100), // Rule ID 7356 //
     /* 145056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145059 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145066 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145073 */     // MIs[0] Rn
     /* 145073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145085 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 145088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145098 */     GIR_RootConstrainSelectedInstOperands,
     /* 145099 */     // GIR_Coverage, 7356,
     /* 145099 */     GIR_EraseRootFromParent_Done,
     /* 145100 */   // Label 2563: @145100
     /* 145100 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(145149), // Rule ID 7357 //
     /* 145105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145108 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145115 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145122 */     // MIs[0] Rn
     /* 145122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145134 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 145137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145147 */     GIR_RootConstrainSelectedInstOperands,
     /* 145148 */     // GIR_Coverage, 7357,
     /* 145148 */     GIR_EraseRootFromParent_Done,
     /* 145149 */   // Label 2564: @145149
     /* 145149 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(145198), // Rule ID 7358 //
     /* 145154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145157 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145171 */     // MIs[0] Rn
     /* 145171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145183 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 145186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145196 */     GIR_RootConstrainSelectedInstOperands,
     /* 145197 */     // GIR_Coverage, 7358,
     /* 145197 */     GIR_EraseRootFromParent_Done,
     /* 145198 */   // Label 2565: @145198
     /* 145198 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(145247), // Rule ID 7359 //
     /* 145203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145206 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145213 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145220 */     // MIs[0] Rn
     /* 145220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145232 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 145235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145245 */     GIR_RootConstrainSelectedInstOperands,
     /* 145246 */     // GIR_Coverage, 7359,
     /* 145246 */     GIR_EraseRootFromParent_Done,
     /* 145247 */   // Label 2566: @145247
     /* 145247 */   GIM_Reject,
     /* 145248 */ // Label 2551: @145248
     /* 145248 */ GIM_Reject,
     /* 145249 */ // Label 2549: @145249
     /* 145249 */ GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(145475),
     /* 145254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145257 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 145264 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(145306), // Rule ID 7340 //
     /* 145269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145272 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145279 */     // MIs[0] Rn
     /* 145279 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145291 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 145294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145304 */     GIR_RootConstrainSelectedInstOperands,
     /* 145305 */     // GIR_Coverage, 7340,
     /* 145305 */     GIR_EraseRootFromParent_Done,
     /* 145306 */   // Label 2568: @145306
     /* 145306 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(145348), // Rule ID 7341 //
     /* 145311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145314 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145321 */     // MIs[0] Rn
     /* 145321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145333 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 145336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145346 */     GIR_RootConstrainSelectedInstOperands,
     /* 145347 */     // GIR_Coverage, 7341,
     /* 145347 */     GIR_EraseRootFromParent_Done,
     /* 145348 */   // Label 2569: @145348
     /* 145348 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(145390), // Rule ID 7342 //
     /* 145353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145356 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145363 */     // MIs[0] Rn
     /* 145363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145375 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 145378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145388 */     GIR_RootConstrainSelectedInstOperands,
     /* 145389 */     // GIR_Coverage, 7342,
     /* 145389 */     GIR_EraseRootFromParent_Done,
     /* 145390 */   // Label 2570: @145390
     /* 145390 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(145432), // Rule ID 7343 //
     /* 145395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145398 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145405 */     // MIs[0] Rn
     /* 145405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145417 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 145420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145430 */     GIR_RootConstrainSelectedInstOperands,
     /* 145431 */     // GIR_Coverage, 7343,
     /* 145431 */     GIR_EraseRootFromParent_Done,
     /* 145432 */   // Label 2571: @145432
     /* 145432 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(145474), // Rule ID 7344 //
     /* 145437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145440 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145447 */     // MIs[0] Rn
     /* 145447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145459 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 145462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145472 */     GIR_RootConstrainSelectedInstOperands,
     /* 145473 */     // GIR_Coverage, 7344,
     /* 145473 */     GIR_EraseRootFromParent_Done,
     /* 145474 */   // Label 2572: @145474
     /* 145474 */   GIM_Reject,
     /* 145475 */ // Label 2567: @145475
     /* 145475 */ GIM_Reject,
     /* 145476 */ // Label 2550: @145476
     /* 145476 */ GIM_Reject,
     /* 145477 */ // Label 22: @145477
     /* 145477 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2575*/ GIMT_Encode4(146468),
     /* 145488 */ /*GILLT_s32*//*Label 2573*/ GIMT_Encode4(145496),
     /* 145492 */ /*GILLT_s64*//*Label 2574*/ GIMT_Encode4(146241),
     /* 145496 */ // Label 2573: @145496
     /* 145496 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(146240),
     /* 145501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 145504 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(145553), // Rule ID 7185 //
     /* 145509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145512 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145519 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145526 */     // MIs[0] Rn
     /* 145526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145538 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 145541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145551 */     GIR_RootConstrainSelectedInstOperands,
     /* 145552 */     // GIR_Coverage, 7185,
     /* 145552 */     GIR_EraseRootFromParent_Done,
     /* 145553 */   // Label 2577: @145553
     /* 145553 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(145602), // Rule ID 7186 //
     /* 145558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145561 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145568 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145575 */     // MIs[0] Rn
     /* 145575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145587 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 145590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145594 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145600 */     GIR_RootConstrainSelectedInstOperands,
     /* 145601 */     // GIR_Coverage, 7186,
     /* 145601 */     GIR_EraseRootFromParent_Done,
     /* 145602 */   // Label 2578: @145602
     /* 145602 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(145651), // Rule ID 7187 //
     /* 145607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145610 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145624 */     // MIs[0] Rn
     /* 145624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145636 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 145639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145649 */     GIR_RootConstrainSelectedInstOperands,
     /* 145650 */     // GIR_Coverage, 7187,
     /* 145650 */     GIR_EraseRootFromParent_Done,
     /* 145651 */   // Label 2579: @145651
     /* 145651 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(145700), // Rule ID 7188 //
     /* 145656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145659 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145666 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145673 */     // MIs[0] Rn
     /* 145673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145685 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 145688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145698 */     GIR_RootConstrainSelectedInstOperands,
     /* 145699 */     // GIR_Coverage, 7188,
     /* 145699 */     GIR_EraseRootFromParent_Done,
     /* 145700 */   // Label 2580: @145700
     /* 145700 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(145749), // Rule ID 7189 //
     /* 145705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145708 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145715 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145722 */     // MIs[0] Rn
     /* 145722 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145734 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 145737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145741 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145747 */     GIR_RootConstrainSelectedInstOperands,
     /* 145748 */     // GIR_Coverage, 7189,
     /* 145748 */     GIR_EraseRootFromParent_Done,
     /* 145749 */   // Label 2581: @145749
     /* 145749 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(145798), // Rule ID 7190 //
     /* 145754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145757 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145764 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145771 */     // MIs[0] Rn
     /* 145771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145783 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 145786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145790 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145796 */     GIR_RootConstrainSelectedInstOperands,
     /* 145797 */     // GIR_Coverage, 7190,
     /* 145797 */     GIR_EraseRootFromParent_Done,
     /* 145798 */   // Label 2582: @145798
     /* 145798 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(145847), // Rule ID 7191 //
     /* 145803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145806 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145813 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145820 */     // MIs[0] Rn
     /* 145820 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145832 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 145835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145839 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145845 */     GIR_RootConstrainSelectedInstOperands,
     /* 145846 */     // GIR_Coverage, 7191,
     /* 145846 */     GIR_EraseRootFromParent_Done,
     /* 145847 */   // Label 2583: @145847
     /* 145847 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(145896), // Rule ID 7192 //
     /* 145852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145855 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145862 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145869 */     // MIs[0] Rn
     /* 145869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145881 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 145884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145894 */     GIR_RootConstrainSelectedInstOperands,
     /* 145895 */     // GIR_Coverage, 7192,
     /* 145895 */     GIR_EraseRootFromParent_Done,
     /* 145896 */   // Label 2584: @145896
     /* 145896 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(145945), // Rule ID 7193 //
     /* 145901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145904 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145911 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145918 */     // MIs[0] Rn
     /* 145918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145930 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 145933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145943 */     GIR_RootConstrainSelectedInstOperands,
     /* 145944 */     // GIR_Coverage, 7193,
     /* 145944 */     GIR_EraseRootFromParent_Done,
     /* 145945 */   // Label 2585: @145945
     /* 145945 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(145994), // Rule ID 7194 //
     /* 145950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145953 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145960 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145967 */     // MIs[0] Rn
     /* 145967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145979 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 145979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 145982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 145984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 145986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145992 */     GIR_RootConstrainSelectedInstOperands,
     /* 145993 */     // GIR_Coverage, 7194,
     /* 145993 */     GIR_EraseRootFromParent_Done,
     /* 145994 */   // Label 2586: @145994
     /* 145994 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(146043), // Rule ID 7195 //
     /* 145999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146002 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146009 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146016 */     // MIs[0] Rn
     /* 146016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146028 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 146031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146041 */     GIR_RootConstrainSelectedInstOperands,
     /* 146042 */     // GIR_Coverage, 7195,
     /* 146042 */     GIR_EraseRootFromParent_Done,
     /* 146043 */   // Label 2587: @146043
     /* 146043 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(146092), // Rule ID 7196 //
     /* 146048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146051 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146058 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146065 */     // MIs[0] Rn
     /* 146065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146077 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 146080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146090 */     GIR_RootConstrainSelectedInstOperands,
     /* 146091 */     // GIR_Coverage, 7196,
     /* 146091 */     GIR_EraseRootFromParent_Done,
     /* 146092 */   // Label 2588: @146092
     /* 146092 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(146141), // Rule ID 7197 //
     /* 146097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146107 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146114 */     // MIs[0] Rn
     /* 146114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146126 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 146129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146139 */     GIR_RootConstrainSelectedInstOperands,
     /* 146140 */     // GIR_Coverage, 7197,
     /* 146140 */     GIR_EraseRootFromParent_Done,
     /* 146141 */   // Label 2589: @146141
     /* 146141 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(146190), // Rule ID 7198 //
     /* 146146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146149 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146156 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146163 */     // MIs[0] Rn
     /* 146163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146175 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 146178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146188 */     GIR_RootConstrainSelectedInstOperands,
     /* 146189 */     // GIR_Coverage, 7198,
     /* 146189 */     GIR_EraseRootFromParent_Done,
     /* 146190 */   // Label 2590: @146190
     /* 146190 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(146239), // Rule ID 7199 //
     /* 146195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146198 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146212 */     // MIs[0] Rn
     /* 146212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146224 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 146227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146231 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146237 */     GIR_RootConstrainSelectedInstOperands,
     /* 146238 */     // GIR_Coverage, 7199,
     /* 146238 */     GIR_EraseRootFromParent_Done,
     /* 146239 */   // Label 2591: @146239
     /* 146239 */   GIM_Reject,
     /* 146240 */ // Label 2576: @146240
     /* 146240 */ GIM_Reject,
     /* 146241 */ // Label 2574: @146241
     /* 146241 */ GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(146467),
     /* 146246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146249 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 146256 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(146298), // Rule ID 2579 //
     /* 146261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146264 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146271 */     // MIs[0] Rn
     /* 146271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146283 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 146286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146296 */     GIR_RootConstrainSelectedInstOperands,
     /* 146297 */     // GIR_Coverage, 2579,
     /* 146297 */     GIR_EraseRootFromParent_Done,
     /* 146298 */   // Label 2593: @146298
     /* 146298 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(146340), // Rule ID 2580 //
     /* 146303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146306 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146313 */     // MIs[0] Rn
     /* 146313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146325 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 146328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146338 */     GIR_RootConstrainSelectedInstOperands,
     /* 146339 */     // GIR_Coverage, 2580,
     /* 146339 */     GIR_EraseRootFromParent_Done,
     /* 146340 */   // Label 2594: @146340
     /* 146340 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(146382), // Rule ID 2581 //
     /* 146345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146348 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146355 */     // MIs[0] Rn
     /* 146355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146367 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 146370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146380 */     GIR_RootConstrainSelectedInstOperands,
     /* 146381 */     // GIR_Coverage, 2581,
     /* 146381 */     GIR_EraseRootFromParent_Done,
     /* 146382 */   // Label 2595: @146382
     /* 146382 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(146424), // Rule ID 2582 //
     /* 146387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146390 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146397 */     // MIs[0] Rn
     /* 146397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146409 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 146412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146416 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146422 */     GIR_RootConstrainSelectedInstOperands,
     /* 146423 */     // GIR_Coverage, 2582,
     /* 146423 */     GIR_EraseRootFromParent_Done,
     /* 146424 */   // Label 2596: @146424
     /* 146424 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(146466), // Rule ID 2583 //
     /* 146429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146439 */     // MIs[0] Rn
     /* 146439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146451 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 146454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146464 */     GIR_RootConstrainSelectedInstOperands,
     /* 146465 */     // GIR_Coverage, 2583,
     /* 146465 */     GIR_EraseRootFromParent_Done,
     /* 146466 */   // Label 2597: @146466
     /* 146466 */   GIM_Reject,
     /* 146467 */ // Label 2592: @146467
     /* 146467 */ GIM_Reject,
     /* 146468 */ // Label 2575: @146468
     /* 146468 */ GIM_Reject,
     /* 146469 */ // Label 23: @146469
     /* 146469 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2600*/ GIMT_Encode4(147960),
     /* 146480 */ /*GILLT_s32*//*Label 2598*/ GIMT_Encode4(146488),
     /* 146484 */ /*GILLT_s64*//*Label 2599*/ GIMT_Encode4(147608),
     /* 146488 */ // Label 2598: @146488
     /* 146488 */ GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(147607),
     /* 146493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146496 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(146570), // Rule ID 7380 //
     /* 146501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146504 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146511 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146518 */     // MIs[0] Rn
     /* 146518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146530 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146542 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146548 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 146557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146568 */     GIR_RootConstrainSelectedInstOperands,
     /* 146569 */     // GIR_Coverage, 7380,
     /* 146569 */     GIR_EraseRootFromParent_Done,
     /* 146570 */   // Label 2602: @146570
     /* 146570 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(146644), // Rule ID 7381 //
     /* 146575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146578 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146585 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146592 */     // MIs[0] Rn
     /* 146592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146604 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146616 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 146631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146636 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146642 */     GIR_RootConstrainSelectedInstOperands,
     /* 146643 */     // GIR_Coverage, 7381,
     /* 146643 */     GIR_EraseRootFromParent_Done,
     /* 146644 */   // Label 2603: @146644
     /* 146644 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(146718), // Rule ID 7382 //
     /* 146649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146652 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146659 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146666 */     // MIs[0] Rn
     /* 146666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146678 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146690 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146696 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 146705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146716 */     GIR_RootConstrainSelectedInstOperands,
     /* 146717 */     // GIR_Coverage, 7382,
     /* 146717 */     GIR_EraseRootFromParent_Done,
     /* 146718 */   // Label 2604: @146718
     /* 146718 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(146792), // Rule ID 7383 //
     /* 146723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146726 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146733 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146740 */     // MIs[0] Rn
     /* 146740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146752 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146764 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 146779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146790 */     GIR_RootConstrainSelectedInstOperands,
     /* 146791 */     // GIR_Coverage, 7383,
     /* 146791 */     GIR_EraseRootFromParent_Done,
     /* 146792 */   // Label 2605: @146792
     /* 146792 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(146866), // Rule ID 7384 //
     /* 146797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146800 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146807 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146814 */     // MIs[0] Rn
     /* 146814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146826 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146838 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146844 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 146853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146858 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146864 */     GIR_RootConstrainSelectedInstOperands,
     /* 146865 */     // GIR_Coverage, 7384,
     /* 146865 */     GIR_EraseRootFromParent_Done,
     /* 146866 */   // Label 2606: @146866
     /* 146866 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(146940), // Rule ID 7385 //
     /* 146871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146874 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146881 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146888 */     // MIs[0] Rn
     /* 146888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146900 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146912 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146918 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 146927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146938 */     GIR_RootConstrainSelectedInstOperands,
     /* 146939 */     // GIR_Coverage, 7385,
     /* 146939 */     GIR_EraseRootFromParent_Done,
     /* 146940 */   // Label 2607: @146940
     /* 146940 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(147014), // Rule ID 7386 //
     /* 146945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146948 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146955 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146962 */     // MIs[0] Rn
     /* 146962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146974 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 146974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 146981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146986 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 146992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 146996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 146998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 147001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147012 */     GIR_RootConstrainSelectedInstOperands,
     /* 147013 */     // GIR_Coverage, 7386,
     /* 147013 */     GIR_EraseRootFromParent_Done,
     /* 147014 */   // Label 2608: @147014
     /* 147014 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(147088), // Rule ID 7387 //
     /* 147019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147022 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147029 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147036 */     // MIs[0] Rn
     /* 147036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147048 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147060 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147066 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 147075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147080 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147086 */     GIR_RootConstrainSelectedInstOperands,
     /* 147087 */     // GIR_Coverage, 7387,
     /* 147087 */     GIR_EraseRootFromParent_Done,
     /* 147088 */   // Label 2609: @147088
     /* 147088 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(147162), // Rule ID 7388 //
     /* 147093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147096 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147103 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147110 */     // MIs[0] Rn
     /* 147110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147122 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147134 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147140 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 147149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147160 */     GIR_RootConstrainSelectedInstOperands,
     /* 147161 */     // GIR_Coverage, 7388,
     /* 147161 */     GIR_EraseRootFromParent_Done,
     /* 147162 */   // Label 2610: @147162
     /* 147162 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(147236), // Rule ID 7389 //
     /* 147167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147170 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147177 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147184 */     // MIs[0] Rn
     /* 147184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147196 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147208 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 147223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147228 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147234 */     GIR_RootConstrainSelectedInstOperands,
     /* 147235 */     // GIR_Coverage, 7389,
     /* 147235 */     GIR_EraseRootFromParent_Done,
     /* 147236 */   // Label 2611: @147236
     /* 147236 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(147310), // Rule ID 7390 //
     /* 147241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147244 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147251 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147258 */     // MIs[0] Rn
     /* 147258 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147270 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147282 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147288 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 147297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147302 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147308 */     GIR_RootConstrainSelectedInstOperands,
     /* 147309 */     // GIR_Coverage, 7390,
     /* 147309 */     GIR_EraseRootFromParent_Done,
     /* 147310 */   // Label 2612: @147310
     /* 147310 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(147384), // Rule ID 7391 //
     /* 147315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147318 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147325 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147332 */     // MIs[0] Rn
     /* 147332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147344 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147356 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 147371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147382 */     GIR_RootConstrainSelectedInstOperands,
     /* 147383 */     // GIR_Coverage, 7391,
     /* 147383 */     GIR_EraseRootFromParent_Done,
     /* 147384 */   // Label 2613: @147384
     /* 147384 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(147458), // Rule ID 7392 //
     /* 147389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147392 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147406 */     // MIs[0] Rn
     /* 147406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147418 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147430 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 147445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147456 */     GIR_RootConstrainSelectedInstOperands,
     /* 147457 */     // GIR_Coverage, 7392,
     /* 147457 */     GIR_EraseRootFromParent_Done,
     /* 147458 */   // Label 2614: @147458
     /* 147458 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(147532), // Rule ID 7393 //
     /* 147463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147466 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147473 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147480 */     // MIs[0] Rn
     /* 147480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147492 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147504 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 147519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147530 */     GIR_RootConstrainSelectedInstOperands,
     /* 147531 */     // GIR_Coverage, 7393,
     /* 147531 */     GIR_EraseRootFromParent_Done,
     /* 147532 */   // Label 2615: @147532
     /* 147532 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(147606), // Rule ID 7394 //
     /* 147537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147554 */     // MIs[0] Rn
     /* 147554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147566 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 147569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 147573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147578 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 147593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147598 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147604 */     GIR_RootConstrainSelectedInstOperands,
     /* 147605 */     // GIR_Coverage, 7394,
     /* 147605 */     GIR_EraseRootFromParent_Done,
     /* 147606 */   // Label 2616: @147606
     /* 147606 */   GIM_Reject,
     /* 147607 */ // Label 2601: @147607
     /* 147607 */ GIM_Reject,
     /* 147608 */ // Label 2599: @147608
     /* 147608 */ GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(147959),
     /* 147613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147616 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 147623 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(147690), // Rule ID 7375 //
     /* 147628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147631 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147638 */     // MIs[0] Rn
     /* 147638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147650 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147662 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147668 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 147677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147682 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147688 */     GIR_RootConstrainSelectedInstOperands,
     /* 147689 */     // GIR_Coverage, 7375,
     /* 147689 */     GIR_EraseRootFromParent_Done,
     /* 147690 */   // Label 2618: @147690
     /* 147690 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(147757), // Rule ID 7376 //
     /* 147695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147698 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147705 */     // MIs[0] Rn
     /* 147705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147717 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147729 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147735 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 147744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147755 */     GIR_RootConstrainSelectedInstOperands,
     /* 147756 */     // GIR_Coverage, 7376,
     /* 147756 */     GIR_EraseRootFromParent_Done,
     /* 147757 */   // Label 2619: @147757
     /* 147757 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(147824), // Rule ID 7377 //
     /* 147762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147765 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147772 */     // MIs[0] Rn
     /* 147772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147784 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147796 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147802 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 147811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147816 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147822 */     GIR_RootConstrainSelectedInstOperands,
     /* 147823 */     // GIR_Coverage, 7377,
     /* 147823 */     GIR_EraseRootFromParent_Done,
     /* 147824 */   // Label 2620: @147824
     /* 147824 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(147891), // Rule ID 7378 //
     /* 147829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147832 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147839 */     // MIs[0] Rn
     /* 147839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147851 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147863 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147869 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 147878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147889 */     GIR_RootConstrainSelectedInstOperands,
     /* 147890 */     // GIR_Coverage, 7378,
     /* 147890 */     GIR_EraseRootFromParent_Done,
     /* 147891 */   // Label 2621: @147891
     /* 147891 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(147958), // Rule ID 7379 //
     /* 147896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147906 */     // MIs[0] Rn
     /* 147906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147918 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 147918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 147925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147930 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 147936 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 147945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147956 */     GIR_RootConstrainSelectedInstOperands,
     /* 147957 */     // GIR_Coverage, 7379,
     /* 147957 */     GIR_EraseRootFromParent_Done,
     /* 147958 */   // Label 2622: @147958
     /* 147958 */   GIM_Reject,
     /* 147959 */ // Label 2617: @147959
     /* 147959 */ GIM_Reject,
     /* 147960 */ // Label 2600: @147960
     /* 147960 */ GIM_Reject,
     /* 147961 */ // Label 24: @147961
     /* 147961 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2625*/ GIMT_Encode4(149452),
     /* 147972 */ /*GILLT_s32*//*Label 2623*/ GIMT_Encode4(147980),
     /* 147976 */ /*GILLT_s64*//*Label 2624*/ GIMT_Encode4(149100),
     /* 147980 */ // Label 2623: @147980
     /* 147980 */ GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(149099),
     /* 147985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147988 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(148062), // Rule ID 7400 //
     /* 147993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147996 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148003 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148010 */     // MIs[0] Rn
     /* 148010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148022 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148034 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148040 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 148049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148054 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148060 */     GIR_RootConstrainSelectedInstOperands,
     /* 148061 */     // GIR_Coverage, 7400,
     /* 148061 */     GIR_EraseRootFromParent_Done,
     /* 148062 */   // Label 2627: @148062
     /* 148062 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(148136), // Rule ID 7401 //
     /* 148067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148070 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148077 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148084 */     // MIs[0] Rn
     /* 148084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148096 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148108 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148114 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 148123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148134 */     GIR_RootConstrainSelectedInstOperands,
     /* 148135 */     // GIR_Coverage, 7401,
     /* 148135 */     GIR_EraseRootFromParent_Done,
     /* 148136 */   // Label 2628: @148136
     /* 148136 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(148210), // Rule ID 7402 //
     /* 148141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148144 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148151 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148158 */     // MIs[0] Rn
     /* 148158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148170 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148182 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148188 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 148197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148208 */     GIR_RootConstrainSelectedInstOperands,
     /* 148209 */     // GIR_Coverage, 7402,
     /* 148209 */     GIR_EraseRootFromParent_Done,
     /* 148210 */   // Label 2629: @148210
     /* 148210 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(148284), // Rule ID 7403 //
     /* 148215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148218 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148225 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148232 */     // MIs[0] Rn
     /* 148232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148244 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148256 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 148271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148282 */     GIR_RootConstrainSelectedInstOperands,
     /* 148283 */     // GIR_Coverage, 7403,
     /* 148283 */     GIR_EraseRootFromParent_Done,
     /* 148284 */   // Label 2630: @148284
     /* 148284 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(148358), // Rule ID 7404 //
     /* 148289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148292 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148299 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148306 */     // MIs[0] Rn
     /* 148306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148318 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148330 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148336 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 148345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148356 */     GIR_RootConstrainSelectedInstOperands,
     /* 148357 */     // GIR_Coverage, 7404,
     /* 148357 */     GIR_EraseRootFromParent_Done,
     /* 148358 */   // Label 2631: @148358
     /* 148358 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(148432), // Rule ID 7405 //
     /* 148363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148366 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148373 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148380 */     // MIs[0] Rn
     /* 148380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148392 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148404 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148410 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 148419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148430 */     GIR_RootConstrainSelectedInstOperands,
     /* 148431 */     // GIR_Coverage, 7405,
     /* 148431 */     GIR_EraseRootFromParent_Done,
     /* 148432 */   // Label 2632: @148432
     /* 148432 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(148506), // Rule ID 7406 //
     /* 148437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148440 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148454 */     // MIs[0] Rn
     /* 148454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148466 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148478 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148484 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 148493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148504 */     GIR_RootConstrainSelectedInstOperands,
     /* 148505 */     // GIR_Coverage, 7406,
     /* 148505 */     GIR_EraseRootFromParent_Done,
     /* 148506 */   // Label 2633: @148506
     /* 148506 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(148580), // Rule ID 7407 //
     /* 148511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148514 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148521 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148528 */     // MIs[0] Rn
     /* 148528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148540 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148552 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148558 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 148567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148578 */     GIR_RootConstrainSelectedInstOperands,
     /* 148579 */     // GIR_Coverage, 7407,
     /* 148579 */     GIR_EraseRootFromParent_Done,
     /* 148580 */   // Label 2634: @148580
     /* 148580 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(148654), // Rule ID 7408 //
     /* 148585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148588 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148595 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148602 */     // MIs[0] Rn
     /* 148602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148614 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148626 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 148641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148652 */     GIR_RootConstrainSelectedInstOperands,
     /* 148653 */     // GIR_Coverage, 7408,
     /* 148653 */     GIR_EraseRootFromParent_Done,
     /* 148654 */   // Label 2635: @148654
     /* 148654 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(148728), // Rule ID 7409 //
     /* 148659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148662 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148669 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148676 */     // MIs[0] Rn
     /* 148676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148688 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148700 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148706 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 148715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148726 */     GIR_RootConstrainSelectedInstOperands,
     /* 148727 */     // GIR_Coverage, 7409,
     /* 148727 */     GIR_EraseRootFromParent_Done,
     /* 148728 */   // Label 2636: @148728
     /* 148728 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(148802), // Rule ID 7410 //
     /* 148733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148743 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148750 */     // MIs[0] Rn
     /* 148750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148762 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148774 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148780 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 148789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148796 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148800 */     GIR_RootConstrainSelectedInstOperands,
     /* 148801 */     // GIR_Coverage, 7410,
     /* 148801 */     GIR_EraseRootFromParent_Done,
     /* 148802 */   // Label 2637: @148802
     /* 148802 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(148876), // Rule ID 7411 //
     /* 148807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148810 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148817 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148824 */     // MIs[0] Rn
     /* 148824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148836 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148848 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 148863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148874 */     GIR_RootConstrainSelectedInstOperands,
     /* 148875 */     // GIR_Coverage, 7411,
     /* 148875 */     GIR_EraseRootFromParent_Done,
     /* 148876 */   // Label 2638: @148876
     /* 148876 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(148950), // Rule ID 7412 //
     /* 148881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148884 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148891 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148898 */     // MIs[0] Rn
     /* 148898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148910 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148922 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148928 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 148937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148948 */     GIR_RootConstrainSelectedInstOperands,
     /* 148949 */     // GIR_Coverage, 7412,
     /* 148949 */     GIR_EraseRootFromParent_Done,
     /* 148950 */   // Label 2639: @148950
     /* 148950 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(149024), // Rule ID 7413 //
     /* 148955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148958 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148965 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148972 */     // MIs[0] Rn
     /* 148972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148984 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 148991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148996 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149002 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 149011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149022 */     GIR_RootConstrainSelectedInstOperands,
     /* 149023 */     // GIR_Coverage, 7413,
     /* 149023 */     GIR_EraseRootFromParent_Done,
     /* 149024 */   // Label 2640: @149024
     /* 149024 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(149098), // Rule ID 7414 //
     /* 149029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149032 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149039 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149046 */     // MIs[0] Rn
     /* 149046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149058 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149070 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 149085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149096 */     GIR_RootConstrainSelectedInstOperands,
     /* 149097 */     // GIR_Coverage, 7414,
     /* 149097 */     GIR_EraseRootFromParent_Done,
     /* 149098 */   // Label 2641: @149098
     /* 149098 */   GIM_Reject,
     /* 149099 */ // Label 2626: @149099
     /* 149099 */ GIM_Reject,
     /* 149100 */ // Label 2624: @149100
     /* 149100 */ GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(149451),
     /* 149105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149108 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149115 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(149182), // Rule ID 7395 //
     /* 149120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149123 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149130 */     // MIs[0] Rn
     /* 149130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149142 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149154 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149160 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 149169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149174 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149180 */     GIR_RootConstrainSelectedInstOperands,
     /* 149181 */     // GIR_Coverage, 7395,
     /* 149181 */     GIR_EraseRootFromParent_Done,
     /* 149182 */   // Label 2643: @149182
     /* 149182 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(149249), // Rule ID 7396 //
     /* 149187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149190 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149197 */     // MIs[0] Rn
     /* 149197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149209 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149221 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149227 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 149236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149247 */     GIR_RootConstrainSelectedInstOperands,
     /* 149248 */     // GIR_Coverage, 7396,
     /* 149248 */     GIR_EraseRootFromParent_Done,
     /* 149249 */   // Label 2644: @149249
     /* 149249 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(149316), // Rule ID 7397 //
     /* 149254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149257 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149264 */     // MIs[0] Rn
     /* 149264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149276 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149288 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 149303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149314 */     GIR_RootConstrainSelectedInstOperands,
     /* 149315 */     // GIR_Coverage, 7397,
     /* 149315 */     GIR_EraseRootFromParent_Done,
     /* 149316 */   // Label 2645: @149316
     /* 149316 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(149383), // Rule ID 7398 //
     /* 149321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149324 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149331 */     // MIs[0] Rn
     /* 149331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149343 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149355 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149361 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 149370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149375 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149381 */     GIR_RootConstrainSelectedInstOperands,
     /* 149382 */     // GIR_Coverage, 7398,
     /* 149382 */     GIR_EraseRootFromParent_Done,
     /* 149383 */   // Label 2646: @149383
     /* 149383 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(149450), // Rule ID 7399 //
     /* 149388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149391 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149398 */     // MIs[0] Rn
     /* 149398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149410 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 149417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149422 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 149437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149448 */     GIR_RootConstrainSelectedInstOperands,
     /* 149449 */     // GIR_Coverage, 7399,
     /* 149449 */     GIR_EraseRootFromParent_Done,
     /* 149450 */   // Label 2647: @149450
     /* 149450 */   GIM_Reject,
     /* 149451 */ // Label 2642: @149451
     /* 149451 */ GIM_Reject,
     /* 149452 */ // Label 2625: @149452
     /* 149452 */ GIM_Reject,
     /* 149453 */ // Label 25: @149453
     /* 149453 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2650*/ GIMT_Encode4(150444),
     /* 149464 */ /*GILLT_s32*//*Label 2648*/ GIMT_Encode4(149472),
     /* 149468 */ /*GILLT_s64*//*Label 2649*/ GIMT_Encode4(150217),
     /* 149472 */ // Label 2648: @149472
     /* 149472 */ GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(150216),
     /* 149477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149480 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(149529), // Rule ID 7205 //
     /* 149485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149488 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149495 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149502 */     // MIs[0] Rn
     /* 149502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149514 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 149517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149527 */     GIR_RootConstrainSelectedInstOperands,
     /* 149528 */     // GIR_Coverage, 7205,
     /* 149528 */     GIR_EraseRootFromParent_Done,
     /* 149529 */   // Label 2652: @149529
     /* 149529 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(149578), // Rule ID 7206 //
     /* 149534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149537 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149544 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149551 */     // MIs[0] Rn
     /* 149551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149563 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 149566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149576 */     GIR_RootConstrainSelectedInstOperands,
     /* 149577 */     // GIR_Coverage, 7206,
     /* 149577 */     GIR_EraseRootFromParent_Done,
     /* 149578 */   // Label 2653: @149578
     /* 149578 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(149627), // Rule ID 7207 //
     /* 149583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149586 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149593 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149600 */     // MIs[0] Rn
     /* 149600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149612 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 149615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149625 */     GIR_RootConstrainSelectedInstOperands,
     /* 149626 */     // GIR_Coverage, 7207,
     /* 149626 */     GIR_EraseRootFromParent_Done,
     /* 149627 */   // Label 2654: @149627
     /* 149627 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(149676), // Rule ID 7208 //
     /* 149632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149635 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149642 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149649 */     // MIs[0] Rn
     /* 149649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149661 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 149664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149674 */     GIR_RootConstrainSelectedInstOperands,
     /* 149675 */     // GIR_Coverage, 7208,
     /* 149675 */     GIR_EraseRootFromParent_Done,
     /* 149676 */   // Label 2655: @149676
     /* 149676 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(149725), // Rule ID 7209 //
     /* 149681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149684 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149691 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149698 */     // MIs[0] Rn
     /* 149698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149710 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 149713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149719 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149723 */     GIR_RootConstrainSelectedInstOperands,
     /* 149724 */     // GIR_Coverage, 7209,
     /* 149724 */     GIR_EraseRootFromParent_Done,
     /* 149725 */   // Label 2656: @149725
     /* 149725 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(149774), // Rule ID 7210 //
     /* 149730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149733 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149740 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149747 */     // MIs[0] Rn
     /* 149747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149759 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 149762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149772 */     GIR_RootConstrainSelectedInstOperands,
     /* 149773 */     // GIR_Coverage, 7210,
     /* 149773 */     GIR_EraseRootFromParent_Done,
     /* 149774 */   // Label 2657: @149774
     /* 149774 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(149823), // Rule ID 7211 //
     /* 149779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149782 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149789 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149796 */     // MIs[0] Rn
     /* 149796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149808 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 149811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149821 */     GIR_RootConstrainSelectedInstOperands,
     /* 149822 */     // GIR_Coverage, 7211,
     /* 149822 */     GIR_EraseRootFromParent_Done,
     /* 149823 */   // Label 2658: @149823
     /* 149823 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(149872), // Rule ID 7212 //
     /* 149828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149831 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149838 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149845 */     // MIs[0] Rn
     /* 149845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149857 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 149860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149870 */     GIR_RootConstrainSelectedInstOperands,
     /* 149871 */     // GIR_Coverage, 7212,
     /* 149871 */     GIR_EraseRootFromParent_Done,
     /* 149872 */   // Label 2659: @149872
     /* 149872 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(149921), // Rule ID 7213 //
     /* 149877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149880 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149887 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149894 */     // MIs[0] Rn
     /* 149894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149906 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 149909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149919 */     GIR_RootConstrainSelectedInstOperands,
     /* 149920 */     // GIR_Coverage, 7213,
     /* 149920 */     GIR_EraseRootFromParent_Done,
     /* 149921 */   // Label 2660: @149921
     /* 149921 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(149970), // Rule ID 7214 //
     /* 149926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149929 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149943 */     // MIs[0] Rn
     /* 149943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149955 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 149955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 149958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 149962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149968 */     GIR_RootConstrainSelectedInstOperands,
     /* 149969 */     // GIR_Coverage, 7214,
     /* 149969 */     GIR_EraseRootFromParent_Done,
     /* 149970 */   // Label 2661: @149970
     /* 149970 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(150019), // Rule ID 7215 //
     /* 149975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149992 */     // MIs[0] Rn
     /* 149992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150004 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 150007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150017 */     GIR_RootConstrainSelectedInstOperands,
     /* 150018 */     // GIR_Coverage, 7215,
     /* 150018 */     GIR_EraseRootFromParent_Done,
     /* 150019 */   // Label 2662: @150019
     /* 150019 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(150068), // Rule ID 7216 //
     /* 150024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150027 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150034 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150041 */     // MIs[0] Rn
     /* 150041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150053 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 150056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150066 */     GIR_RootConstrainSelectedInstOperands,
     /* 150067 */     // GIR_Coverage, 7216,
     /* 150067 */     GIR_EraseRootFromParent_Done,
     /* 150068 */   // Label 2663: @150068
     /* 150068 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(150117), // Rule ID 7217 //
     /* 150073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150083 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150090 */     // MIs[0] Rn
     /* 150090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150102 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 150105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150115 */     GIR_RootConstrainSelectedInstOperands,
     /* 150116 */     // GIR_Coverage, 7217,
     /* 150116 */     GIR_EraseRootFromParent_Done,
     /* 150117 */   // Label 2664: @150117
     /* 150117 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(150166), // Rule ID 7218 //
     /* 150122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150125 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150139 */     // MIs[0] Rn
     /* 150139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150151 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 150154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150164 */     GIR_RootConstrainSelectedInstOperands,
     /* 150165 */     // GIR_Coverage, 7218,
     /* 150165 */     GIR_EraseRootFromParent_Done,
     /* 150166 */   // Label 2665: @150166
     /* 150166 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(150215), // Rule ID 7219 //
     /* 150171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150188 */     // MIs[0] Rn
     /* 150188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150200 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 150203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150213 */     GIR_RootConstrainSelectedInstOperands,
     /* 150214 */     // GIR_Coverage, 7219,
     /* 150214 */     GIR_EraseRootFromParent_Done,
     /* 150215 */   // Label 2666: @150215
     /* 150215 */   GIM_Reject,
     /* 150216 */ // Label 2651: @150216
     /* 150216 */ GIM_Reject,
     /* 150217 */ // Label 2649: @150217
     /* 150217 */ GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(150443),
     /* 150222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150225 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 150232 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(150274), // Rule ID 7200 //
     /* 150237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150240 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150247 */     // MIs[0] Rn
     /* 150247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150259 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 150262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150266 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150272 */     GIR_RootConstrainSelectedInstOperands,
     /* 150273 */     // GIR_Coverage, 7200,
     /* 150273 */     GIR_EraseRootFromParent_Done,
     /* 150274 */   // Label 2668: @150274
     /* 150274 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(150316), // Rule ID 7201 //
     /* 150279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150282 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150289 */     // MIs[0] Rn
     /* 150289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150301 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 150304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150314 */     GIR_RootConstrainSelectedInstOperands,
     /* 150315 */     // GIR_Coverage, 7201,
     /* 150315 */     GIR_EraseRootFromParent_Done,
     /* 150316 */   // Label 2669: @150316
     /* 150316 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(150358), // Rule ID 7202 //
     /* 150321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150324 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150331 */     // MIs[0] Rn
     /* 150331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150343 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 150346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150356 */     GIR_RootConstrainSelectedInstOperands,
     /* 150357 */     // GIR_Coverage, 7202,
     /* 150357 */     GIR_EraseRootFromParent_Done,
     /* 150358 */   // Label 2670: @150358
     /* 150358 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(150400), // Rule ID 7203 //
     /* 150363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150366 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150373 */     // MIs[0] Rn
     /* 150373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150385 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 150388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150392 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150398 */     GIR_RootConstrainSelectedInstOperands,
     /* 150399 */     // GIR_Coverage, 7203,
     /* 150399 */     GIR_EraseRootFromParent_Done,
     /* 150400 */   // Label 2671: @150400
     /* 150400 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(150442), // Rule ID 7204 //
     /* 150405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150408 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150415 */     // MIs[0] Rn
     /* 150415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150427 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 150430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150440 */     GIR_RootConstrainSelectedInstOperands,
     /* 150441 */     // GIR_Coverage, 7204,
     /* 150441 */     GIR_EraseRootFromParent_Done,
     /* 150442 */   // Label 2672: @150442
     /* 150442 */   GIM_Reject,
     /* 150443 */ // Label 2667: @150443
     /* 150443 */ GIM_Reject,
     /* 150444 */ // Label 2650: @150444
     /* 150444 */ GIM_Reject,
     /* 150445 */ // Label 26: @150445
     /* 150445 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2675*/ GIMT_Encode4(151436),
     /* 150456 */ /*GILLT_s32*//*Label 2673*/ GIMT_Encode4(150464),
     /* 150460 */ /*GILLT_s64*//*Label 2674*/ GIMT_Encode4(151209),
     /* 150464 */ // Label 2673: @150464
     /* 150464 */ GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(151208),
     /* 150469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 150472 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(150521), // Rule ID 7225 //
     /* 150477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150480 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150487 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150494 */     // MIs[0] Rn
     /* 150494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150506 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 150509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150519 */     GIR_RootConstrainSelectedInstOperands,
     /* 150520 */     // GIR_Coverage, 7225,
     /* 150520 */     GIR_EraseRootFromParent_Done,
     /* 150521 */   // Label 2677: @150521
     /* 150521 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(150570), // Rule ID 7226 //
     /* 150526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150529 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150536 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150543 */     // MIs[0] Rn
     /* 150543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150555 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 150558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150568 */     GIR_RootConstrainSelectedInstOperands,
     /* 150569 */     // GIR_Coverage, 7226,
     /* 150569 */     GIR_EraseRootFromParent_Done,
     /* 150570 */   // Label 2678: @150570
     /* 150570 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(150619), // Rule ID 7227 //
     /* 150575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150578 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150585 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150592 */     // MIs[0] Rn
     /* 150592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150604 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 150607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150617 */     GIR_RootConstrainSelectedInstOperands,
     /* 150618 */     // GIR_Coverage, 7227,
     /* 150618 */     GIR_EraseRootFromParent_Done,
     /* 150619 */   // Label 2679: @150619
     /* 150619 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(150668), // Rule ID 7228 //
     /* 150624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150627 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150634 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150641 */     // MIs[0] Rn
     /* 150641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150653 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 150656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150666 */     GIR_RootConstrainSelectedInstOperands,
     /* 150667 */     // GIR_Coverage, 7228,
     /* 150667 */     GIR_EraseRootFromParent_Done,
     /* 150668 */   // Label 2680: @150668
     /* 150668 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(150717), // Rule ID 7229 //
     /* 150673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150676 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150683 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150690 */     // MIs[0] Rn
     /* 150690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150702 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 150705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150715 */     GIR_RootConstrainSelectedInstOperands,
     /* 150716 */     // GIR_Coverage, 7229,
     /* 150716 */     GIR_EraseRootFromParent_Done,
     /* 150717 */   // Label 2681: @150717
     /* 150717 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(150766), // Rule ID 7230 //
     /* 150722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150725 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150732 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150739 */     // MIs[0] Rn
     /* 150739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150751 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 150754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150764 */     GIR_RootConstrainSelectedInstOperands,
     /* 150765 */     // GIR_Coverage, 7230,
     /* 150765 */     GIR_EraseRootFromParent_Done,
     /* 150766 */   // Label 2682: @150766
     /* 150766 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(150815), // Rule ID 7231 //
     /* 150771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150774 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150781 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150788 */     // MIs[0] Rn
     /* 150788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150800 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 150803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150813 */     GIR_RootConstrainSelectedInstOperands,
     /* 150814 */     // GIR_Coverage, 7231,
     /* 150814 */     GIR_EraseRootFromParent_Done,
     /* 150815 */   // Label 2683: @150815
     /* 150815 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(150864), // Rule ID 7232 //
     /* 150820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150823 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150830 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150837 */     // MIs[0] Rn
     /* 150837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150849 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 150852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150862 */     GIR_RootConstrainSelectedInstOperands,
     /* 150863 */     // GIR_Coverage, 7232,
     /* 150863 */     GIR_EraseRootFromParent_Done,
     /* 150864 */   // Label 2684: @150864
     /* 150864 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(150913), // Rule ID 7233 //
     /* 150869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150872 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150879 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150886 */     // MIs[0] Rn
     /* 150886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150898 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 150901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150911 */     GIR_RootConstrainSelectedInstOperands,
     /* 150912 */     // GIR_Coverage, 7233,
     /* 150912 */     GIR_EraseRootFromParent_Done,
     /* 150913 */   // Label 2685: @150913
     /* 150913 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(150962), // Rule ID 7234 //
     /* 150918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150921 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150928 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150935 */     // MIs[0] Rn
     /* 150935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150947 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 150950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 150954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150960 */     GIR_RootConstrainSelectedInstOperands,
     /* 150961 */     // GIR_Coverage, 7234,
     /* 150961 */     GIR_EraseRootFromParent_Done,
     /* 150962 */   // Label 2686: @150962
     /* 150962 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(151011), // Rule ID 7235 //
     /* 150967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150970 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150984 */     // MIs[0] Rn
     /* 150984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150996 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 150996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 150999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151009 */     GIR_RootConstrainSelectedInstOperands,
     /* 151010 */     // GIR_Coverage, 7235,
     /* 151010 */     GIR_EraseRootFromParent_Done,
     /* 151011 */   // Label 2687: @151011
     /* 151011 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(151060), // Rule ID 7236 //
     /* 151016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151019 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151026 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151033 */     // MIs[0] Rn
     /* 151033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151045 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 151048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151058 */     GIR_RootConstrainSelectedInstOperands,
     /* 151059 */     // GIR_Coverage, 7236,
     /* 151059 */     GIR_EraseRootFromParent_Done,
     /* 151060 */   // Label 2688: @151060
     /* 151060 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(151109), // Rule ID 7237 //
     /* 151065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151068 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151075 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151082 */     // MIs[0] Rn
     /* 151082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151094 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 151097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151107 */     GIR_RootConstrainSelectedInstOperands,
     /* 151108 */     // GIR_Coverage, 7237,
     /* 151108 */     GIR_EraseRootFromParent_Done,
     /* 151109 */   // Label 2689: @151109
     /* 151109 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(151158), // Rule ID 7238 //
     /* 151114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151117 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151124 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151131 */     // MIs[0] Rn
     /* 151131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151143 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 151146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151156 */     GIR_RootConstrainSelectedInstOperands,
     /* 151157 */     // GIR_Coverage, 7238,
     /* 151157 */     GIR_EraseRootFromParent_Done,
     /* 151158 */   // Label 2690: @151158
     /* 151158 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(151207), // Rule ID 7239 //
     /* 151163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151166 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151180 */     // MIs[0] Rn
     /* 151180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151192 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 151195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151205 */     GIR_RootConstrainSelectedInstOperands,
     /* 151206 */     // GIR_Coverage, 7239,
     /* 151206 */     GIR_EraseRootFromParent_Done,
     /* 151207 */   // Label 2691: @151207
     /* 151207 */   GIM_Reject,
     /* 151208 */ // Label 2676: @151208
     /* 151208 */ GIM_Reject,
     /* 151209 */ // Label 2674: @151209
     /* 151209 */ GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(151435),
     /* 151214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151217 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 151224 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(151266), // Rule ID 7220 //
     /* 151229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151232 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151239 */     // MIs[0] Rn
     /* 151239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151251 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 151254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151258 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151264 */     GIR_RootConstrainSelectedInstOperands,
     /* 151265 */     // GIR_Coverage, 7220,
     /* 151265 */     GIR_EraseRootFromParent_Done,
     /* 151266 */   // Label 2693: @151266
     /* 151266 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(151308), // Rule ID 7221 //
     /* 151271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151274 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151281 */     // MIs[0] Rn
     /* 151281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151293 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 151296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151306 */     GIR_RootConstrainSelectedInstOperands,
     /* 151307 */     // GIR_Coverage, 7221,
     /* 151307 */     GIR_EraseRootFromParent_Done,
     /* 151308 */   // Label 2694: @151308
     /* 151308 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(151350), // Rule ID 7222 //
     /* 151313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151316 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151323 */     // MIs[0] Rn
     /* 151323 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151335 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 151338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151348 */     GIR_RootConstrainSelectedInstOperands,
     /* 151349 */     // GIR_Coverage, 7222,
     /* 151349 */     GIR_EraseRootFromParent_Done,
     /* 151350 */   // Label 2695: @151350
     /* 151350 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(151392), // Rule ID 7223 //
     /* 151355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151358 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151365 */     // MIs[0] Rn
     /* 151365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151377 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 151380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151390 */     GIR_RootConstrainSelectedInstOperands,
     /* 151391 */     // GIR_Coverage, 7223,
     /* 151391 */     GIR_EraseRootFromParent_Done,
     /* 151392 */   // Label 2696: @151392
     /* 151392 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(151434), // Rule ID 7224 //
     /* 151397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151400 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151407 */     // MIs[0] Rn
     /* 151407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151419 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 151422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151432 */     GIR_RootConstrainSelectedInstOperands,
     /* 151433 */     // GIR_Coverage, 7224,
     /* 151433 */     GIR_EraseRootFromParent_Done,
     /* 151434 */   // Label 2697: @151434
     /* 151434 */   GIM_Reject,
     /* 151435 */ // Label 2692: @151435
     /* 151435 */ GIM_Reject,
     /* 151436 */ // Label 2675: @151436
     /* 151436 */ GIM_Reject,
     /* 151437 */ // Label 27: @151437
     /* 151437 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2700*/ GIMT_Encode4(152428),
     /* 151448 */ /*GILLT_s32*//*Label 2698*/ GIMT_Encode4(151456),
     /* 151452 */ /*GILLT_s64*//*Label 2699*/ GIMT_Encode4(152201),
     /* 151456 */ // Label 2698: @151456
     /* 151456 */ GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(152200),
     /* 151461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151464 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(151513), // Rule ID 7265 //
     /* 151469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151472 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151479 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151486 */     // MIs[0] Rn
     /* 151486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151498 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 151501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151511 */     GIR_RootConstrainSelectedInstOperands,
     /* 151512 */     // GIR_Coverage, 7265,
     /* 151512 */     GIR_EraseRootFromParent_Done,
     /* 151513 */   // Label 2702: @151513
     /* 151513 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(151562), // Rule ID 7266 //
     /* 151518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151521 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151528 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151535 */     // MIs[0] Rn
     /* 151535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151547 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 151550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151560 */     GIR_RootConstrainSelectedInstOperands,
     /* 151561 */     // GIR_Coverage, 7266,
     /* 151561 */     GIR_EraseRootFromParent_Done,
     /* 151562 */   // Label 2703: @151562
     /* 151562 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(151611), // Rule ID 7267 //
     /* 151567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151570 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151577 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151584 */     // MIs[0] Rn
     /* 151584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151596 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 151599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151609 */     GIR_RootConstrainSelectedInstOperands,
     /* 151610 */     // GIR_Coverage, 7267,
     /* 151610 */     GIR_EraseRootFromParent_Done,
     /* 151611 */   // Label 2704: @151611
     /* 151611 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(151660), // Rule ID 7268 //
     /* 151616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151619 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151626 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151633 */     // MIs[0] Rn
     /* 151633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151645 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 151648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151652 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151658 */     GIR_RootConstrainSelectedInstOperands,
     /* 151659 */     // GIR_Coverage, 7268,
     /* 151659 */     GIR_EraseRootFromParent_Done,
     /* 151660 */   // Label 2705: @151660
     /* 151660 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(151709), // Rule ID 7269 //
     /* 151665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151668 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151675 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151682 */     // MIs[0] Rn
     /* 151682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151694 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 151697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151707 */     GIR_RootConstrainSelectedInstOperands,
     /* 151708 */     // GIR_Coverage, 7269,
     /* 151708 */     GIR_EraseRootFromParent_Done,
     /* 151709 */   // Label 2706: @151709
     /* 151709 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(151758), // Rule ID 7270 //
     /* 151714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151717 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151724 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151731 */     // MIs[0] Rn
     /* 151731 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151743 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 151746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151756 */     GIR_RootConstrainSelectedInstOperands,
     /* 151757 */     // GIR_Coverage, 7270,
     /* 151757 */     GIR_EraseRootFromParent_Done,
     /* 151758 */   // Label 2707: @151758
     /* 151758 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(151807), // Rule ID 7271 //
     /* 151763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151766 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151773 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151780 */     // MIs[0] Rn
     /* 151780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151792 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 151795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151805 */     GIR_RootConstrainSelectedInstOperands,
     /* 151806 */     // GIR_Coverage, 7271,
     /* 151806 */     GIR_EraseRootFromParent_Done,
     /* 151807 */   // Label 2708: @151807
     /* 151807 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(151856), // Rule ID 7272 //
     /* 151812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151815 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151822 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151829 */     // MIs[0] Rn
     /* 151829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151841 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 151844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151854 */     GIR_RootConstrainSelectedInstOperands,
     /* 151855 */     // GIR_Coverage, 7272,
     /* 151855 */     GIR_EraseRootFromParent_Done,
     /* 151856 */   // Label 2709: @151856
     /* 151856 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(151905), // Rule ID 7273 //
     /* 151861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151864 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151871 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151878 */     // MIs[0] Rn
     /* 151878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151890 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 151893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151903 */     GIR_RootConstrainSelectedInstOperands,
     /* 151904 */     // GIR_Coverage, 7273,
     /* 151904 */     GIR_EraseRootFromParent_Done,
     /* 151905 */   // Label 2710: @151905
     /* 151905 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(151954), // Rule ID 7274 //
     /* 151910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151913 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151920 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151927 */     // MIs[0] Rn
     /* 151927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151939 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 151942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151952 */     GIR_RootConstrainSelectedInstOperands,
     /* 151953 */     // GIR_Coverage, 7274,
     /* 151953 */     GIR_EraseRootFromParent_Done,
     /* 151954 */   // Label 2711: @151954
     /* 151954 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(152003), // Rule ID 7275 //
     /* 151959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151962 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151976 */     // MIs[0] Rn
     /* 151976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151988 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 151991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152001 */     GIR_RootConstrainSelectedInstOperands,
     /* 152002 */     // GIR_Coverage, 7275,
     /* 152002 */     GIR_EraseRootFromParent_Done,
     /* 152003 */   // Label 2712: @152003
     /* 152003 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(152052), // Rule ID 7276 //
     /* 152008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152011 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152025 */     // MIs[0] Rn
     /* 152025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152037 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 152040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152050 */     GIR_RootConstrainSelectedInstOperands,
     /* 152051 */     // GIR_Coverage, 7276,
     /* 152051 */     GIR_EraseRootFromParent_Done,
     /* 152052 */   // Label 2713: @152052
     /* 152052 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(152101), // Rule ID 7277 //
     /* 152057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152060 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152067 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152074 */     // MIs[0] Rn
     /* 152074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152086 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 152089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152099 */     GIR_RootConstrainSelectedInstOperands,
     /* 152100 */     // GIR_Coverage, 7277,
     /* 152100 */     GIR_EraseRootFromParent_Done,
     /* 152101 */   // Label 2714: @152101
     /* 152101 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(152150), // Rule ID 7278 //
     /* 152106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152109 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152116 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152123 */     // MIs[0] Rn
     /* 152123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152135 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 152138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152148 */     GIR_RootConstrainSelectedInstOperands,
     /* 152149 */     // GIR_Coverage, 7278,
     /* 152149 */     GIR_EraseRootFromParent_Done,
     /* 152150 */   // Label 2715: @152150
     /* 152150 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(152199), // Rule ID 7279 //
     /* 152155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152158 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152172 */     // MIs[0] Rn
     /* 152172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152184 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 152187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152197 */     GIR_RootConstrainSelectedInstOperands,
     /* 152198 */     // GIR_Coverage, 7279,
     /* 152198 */     GIR_EraseRootFromParent_Done,
     /* 152199 */   // Label 2716: @152199
     /* 152199 */   GIM_Reject,
     /* 152200 */ // Label 2701: @152200
     /* 152200 */ GIM_Reject,
     /* 152201 */ // Label 2699: @152201
     /* 152201 */ GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(152427),
     /* 152206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152209 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 152216 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(152258), // Rule ID 7260 //
     /* 152221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152224 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152231 */     // MIs[0] Rn
     /* 152231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152243 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 152246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152250 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152256 */     GIR_RootConstrainSelectedInstOperands,
     /* 152257 */     // GIR_Coverage, 7260,
     /* 152257 */     GIR_EraseRootFromParent_Done,
     /* 152258 */   // Label 2718: @152258
     /* 152258 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(152300), // Rule ID 7261 //
     /* 152263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152266 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152273 */     // MIs[0] Rn
     /* 152273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152285 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 152288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152298 */     GIR_RootConstrainSelectedInstOperands,
     /* 152299 */     // GIR_Coverage, 7261,
     /* 152299 */     GIR_EraseRootFromParent_Done,
     /* 152300 */   // Label 2719: @152300
     /* 152300 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(152342), // Rule ID 7262 //
     /* 152305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152308 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152315 */     // MIs[0] Rn
     /* 152315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152327 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 152330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152340 */     GIR_RootConstrainSelectedInstOperands,
     /* 152341 */     // GIR_Coverage, 7262,
     /* 152341 */     GIR_EraseRootFromParent_Done,
     /* 152342 */   // Label 2720: @152342
     /* 152342 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(152384), // Rule ID 7263 //
     /* 152347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152350 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152357 */     // MIs[0] Rn
     /* 152357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152369 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 152372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152382 */     GIR_RootConstrainSelectedInstOperands,
     /* 152383 */     // GIR_Coverage, 7263,
     /* 152383 */     GIR_EraseRootFromParent_Done,
     /* 152384 */   // Label 2721: @152384
     /* 152384 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(152426), // Rule ID 7264 //
     /* 152389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152392 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152399 */     // MIs[0] Rn
     /* 152399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152411 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 152414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152424 */     GIR_RootConstrainSelectedInstOperands,
     /* 152425 */     // GIR_Coverage, 7264,
     /* 152425 */     GIR_EraseRootFromParent_Done,
     /* 152426 */   // Label 2722: @152426
     /* 152426 */   GIM_Reject,
     /* 152427 */ // Label 2717: @152427
     /* 152427 */ GIM_Reject,
     /* 152428 */ // Label 2700: @152428
     /* 152428 */ GIM_Reject,
     /* 152429 */ // Label 28: @152429
     /* 152429 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2725*/ GIMT_Encode4(153420),
     /* 152440 */ /*GILLT_s32*//*Label 2723*/ GIMT_Encode4(152448),
     /* 152444 */ /*GILLT_s64*//*Label 2724*/ GIMT_Encode4(153193),
     /* 152448 */ // Label 2723: @152448
     /* 152448 */ GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(153192),
     /* 152453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152456 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(152505), // Rule ID 7285 //
     /* 152461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152464 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152471 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152478 */     // MIs[0] Rn
     /* 152478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152490 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 152493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152503 */     GIR_RootConstrainSelectedInstOperands,
     /* 152504 */     // GIR_Coverage, 7285,
     /* 152504 */     GIR_EraseRootFromParent_Done,
     /* 152505 */   // Label 2727: @152505
     /* 152505 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(152554), // Rule ID 7286 //
     /* 152510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152513 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152520 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152527 */     // MIs[0] Rn
     /* 152527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152539 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 152542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152552 */     GIR_RootConstrainSelectedInstOperands,
     /* 152553 */     // GIR_Coverage, 7286,
     /* 152553 */     GIR_EraseRootFromParent_Done,
     /* 152554 */   // Label 2728: @152554
     /* 152554 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(152603), // Rule ID 7287 //
     /* 152559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152562 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152569 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152576 */     // MIs[0] Rn
     /* 152576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152588 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 152591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152601 */     GIR_RootConstrainSelectedInstOperands,
     /* 152602 */     // GIR_Coverage, 7287,
     /* 152602 */     GIR_EraseRootFromParent_Done,
     /* 152603 */   // Label 2729: @152603
     /* 152603 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(152652), // Rule ID 7288 //
     /* 152608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152611 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152618 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152625 */     // MIs[0] Rn
     /* 152625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152637 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 152640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152650 */     GIR_RootConstrainSelectedInstOperands,
     /* 152651 */     // GIR_Coverage, 7288,
     /* 152651 */     GIR_EraseRootFromParent_Done,
     /* 152652 */   // Label 2730: @152652
     /* 152652 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(152701), // Rule ID 7289 //
     /* 152657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152660 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152667 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152674 */     // MIs[0] Rn
     /* 152674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152686 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 152689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152699 */     GIR_RootConstrainSelectedInstOperands,
     /* 152700 */     // GIR_Coverage, 7289,
     /* 152700 */     GIR_EraseRootFromParent_Done,
     /* 152701 */   // Label 2731: @152701
     /* 152701 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(152750), // Rule ID 7290 //
     /* 152706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152709 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152716 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152723 */     // MIs[0] Rn
     /* 152723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152735 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 152738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152748 */     GIR_RootConstrainSelectedInstOperands,
     /* 152749 */     // GIR_Coverage, 7290,
     /* 152749 */     GIR_EraseRootFromParent_Done,
     /* 152750 */   // Label 2732: @152750
     /* 152750 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(152799), // Rule ID 7291 //
     /* 152755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152758 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152765 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152772 */     // MIs[0] Rn
     /* 152772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152784 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 152787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152791 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152797 */     GIR_RootConstrainSelectedInstOperands,
     /* 152798 */     // GIR_Coverage, 7291,
     /* 152798 */     GIR_EraseRootFromParent_Done,
     /* 152799 */   // Label 2733: @152799
     /* 152799 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(152848), // Rule ID 7292 //
     /* 152804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152807 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152814 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152821 */     // MIs[0] Rn
     /* 152821 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152833 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 152836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152846 */     GIR_RootConstrainSelectedInstOperands,
     /* 152847 */     // GIR_Coverage, 7292,
     /* 152847 */     GIR_EraseRootFromParent_Done,
     /* 152848 */   // Label 2734: @152848
     /* 152848 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(152897), // Rule ID 7293 //
     /* 152853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152856 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152863 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152870 */     // MIs[0] Rn
     /* 152870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152882 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 152885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152895 */     GIR_RootConstrainSelectedInstOperands,
     /* 152896 */     // GIR_Coverage, 7293,
     /* 152896 */     GIR_EraseRootFromParent_Done,
     /* 152897 */   // Label 2735: @152897
     /* 152897 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(152946), // Rule ID 7294 //
     /* 152902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152905 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152912 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152919 */     // MIs[0] Rn
     /* 152919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152931 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 152934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152944 */     GIR_RootConstrainSelectedInstOperands,
     /* 152945 */     // GIR_Coverage, 7294,
     /* 152945 */     GIR_EraseRootFromParent_Done,
     /* 152946 */   // Label 2736: @152946
     /* 152946 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(152995), // Rule ID 7295 //
     /* 152951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152954 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152961 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152968 */     // MIs[0] Rn
     /* 152968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152980 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 152983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152993 */     GIR_RootConstrainSelectedInstOperands,
     /* 152994 */     // GIR_Coverage, 7295,
     /* 152994 */     GIR_EraseRootFromParent_Done,
     /* 152995 */   // Label 2737: @152995
     /* 152995 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(153044), // Rule ID 7296 //
     /* 153000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153010 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153017 */     // MIs[0] Rn
     /* 153017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153029 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 153032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153042 */     GIR_RootConstrainSelectedInstOperands,
     /* 153043 */     // GIR_Coverage, 7296,
     /* 153043 */     GIR_EraseRootFromParent_Done,
     /* 153044 */   // Label 2738: @153044
     /* 153044 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(153093), // Rule ID 7297 //
     /* 153049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153052 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153059 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153066 */     // MIs[0] Rn
     /* 153066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153078 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 153081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153091 */     GIR_RootConstrainSelectedInstOperands,
     /* 153092 */     // GIR_Coverage, 7297,
     /* 153092 */     GIR_EraseRootFromParent_Done,
     /* 153093 */   // Label 2739: @153093
     /* 153093 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(153142), // Rule ID 7298 //
     /* 153098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153101 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153108 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153115 */     // MIs[0] Rn
     /* 153115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153127 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 153130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153140 */     GIR_RootConstrainSelectedInstOperands,
     /* 153141 */     // GIR_Coverage, 7298,
     /* 153141 */     GIR_EraseRootFromParent_Done,
     /* 153142 */   // Label 2740: @153142
     /* 153142 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(153191), // Rule ID 7299 //
     /* 153147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153150 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153157 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153164 */     // MIs[0] Rn
     /* 153164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153176 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 153179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153183 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153189 */     GIR_RootConstrainSelectedInstOperands,
     /* 153190 */     // GIR_Coverage, 7299,
     /* 153190 */     GIR_EraseRootFromParent_Done,
     /* 153191 */   // Label 2741: @153191
     /* 153191 */   GIM_Reject,
     /* 153192 */ // Label 2726: @153192
     /* 153192 */ GIM_Reject,
     /* 153193 */ // Label 2724: @153193
     /* 153193 */ GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(153419),
     /* 153198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153201 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153208 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(153250), // Rule ID 7280 //
     /* 153213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153216 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153223 */     // MIs[0] Rn
     /* 153223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153235 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 153238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153248 */     GIR_RootConstrainSelectedInstOperands,
     /* 153249 */     // GIR_Coverage, 7280,
     /* 153249 */     GIR_EraseRootFromParent_Done,
     /* 153250 */   // Label 2743: @153250
     /* 153250 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(153292), // Rule ID 7281 //
     /* 153255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153258 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153265 */     // MIs[0] Rn
     /* 153265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153277 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 153280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153290 */     GIR_RootConstrainSelectedInstOperands,
     /* 153291 */     // GIR_Coverage, 7281,
     /* 153291 */     GIR_EraseRootFromParent_Done,
     /* 153292 */   // Label 2744: @153292
     /* 153292 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(153334), // Rule ID 7282 //
     /* 153297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153300 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153307 */     // MIs[0] Rn
     /* 153307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153319 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 153322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153326 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153332 */     GIR_RootConstrainSelectedInstOperands,
     /* 153333 */     // GIR_Coverage, 7282,
     /* 153333 */     GIR_EraseRootFromParent_Done,
     /* 153334 */   // Label 2745: @153334
     /* 153334 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(153376), // Rule ID 7283 //
     /* 153339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153342 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153349 */     // MIs[0] Rn
     /* 153349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153361 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 153364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153374 */     GIR_RootConstrainSelectedInstOperands,
     /* 153375 */     // GIR_Coverage, 7283,
     /* 153375 */     GIR_EraseRootFromParent_Done,
     /* 153376 */   // Label 2746: @153376
     /* 153376 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(153418), // Rule ID 7284 //
     /* 153381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153384 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153391 */     // MIs[0] Rn
     /* 153391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153403 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 153406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153416 */     GIR_RootConstrainSelectedInstOperands,
     /* 153417 */     // GIR_Coverage, 7284,
     /* 153417 */     GIR_EraseRootFromParent_Done,
     /* 153418 */   // Label 2747: @153418
     /* 153418 */   GIM_Reject,
     /* 153419 */ // Label 2742: @153419
     /* 153419 */ GIM_Reject,
     /* 153420 */ // Label 2725: @153420
     /* 153420 */ GIM_Reject,
     /* 153421 */ // Label 29: @153421
     /* 153421 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2750*/ GIMT_Encode4(154412),
     /* 153432 */ /*GILLT_s32*//*Label 2748*/ GIMT_Encode4(153440),
     /* 153436 */ /*GILLT_s64*//*Label 2749*/ GIMT_Encode4(154185),
     /* 153440 */ // Label 2748: @153440
     /* 153440 */ GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(154184),
     /* 153445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153448 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(153497), // Rule ID 7305 //
     /* 153453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153456 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153463 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153470 */     // MIs[0] Rn
     /* 153470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153482 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 153485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153495 */     GIR_RootConstrainSelectedInstOperands,
     /* 153496 */     // GIR_Coverage, 7305,
     /* 153496 */     GIR_EraseRootFromParent_Done,
     /* 153497 */   // Label 2752: @153497
     /* 153497 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(153546), // Rule ID 7306 //
     /* 153502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153505 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153512 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153519 */     // MIs[0] Rn
     /* 153519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153531 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 153534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153538 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153544 */     GIR_RootConstrainSelectedInstOperands,
     /* 153545 */     // GIR_Coverage, 7306,
     /* 153545 */     GIR_EraseRootFromParent_Done,
     /* 153546 */   // Label 2753: @153546
     /* 153546 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(153595), // Rule ID 7307 //
     /* 153551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153554 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153561 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153568 */     // MIs[0] Rn
     /* 153568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153580 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 153583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153593 */     GIR_RootConstrainSelectedInstOperands,
     /* 153594 */     // GIR_Coverage, 7307,
     /* 153594 */     GIR_EraseRootFromParent_Done,
     /* 153595 */   // Label 2754: @153595
     /* 153595 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(153644), // Rule ID 7308 //
     /* 153600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153603 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153610 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153617 */     // MIs[0] Rn
     /* 153617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153629 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 153632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153636 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153642 */     GIR_RootConstrainSelectedInstOperands,
     /* 153643 */     // GIR_Coverage, 7308,
     /* 153643 */     GIR_EraseRootFromParent_Done,
     /* 153644 */   // Label 2755: @153644
     /* 153644 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(153693), // Rule ID 7309 //
     /* 153649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153652 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153659 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153666 */     // MIs[0] Rn
     /* 153666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153678 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 153681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153691 */     GIR_RootConstrainSelectedInstOperands,
     /* 153692 */     // GIR_Coverage, 7309,
     /* 153692 */     GIR_EraseRootFromParent_Done,
     /* 153693 */   // Label 2756: @153693
     /* 153693 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(153742), // Rule ID 7310 //
     /* 153698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153701 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153708 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153715 */     // MIs[0] Rn
     /* 153715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153727 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 153730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153740 */     GIR_RootConstrainSelectedInstOperands,
     /* 153741 */     // GIR_Coverage, 7310,
     /* 153741 */     GIR_EraseRootFromParent_Done,
     /* 153742 */   // Label 2757: @153742
     /* 153742 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(153791), // Rule ID 7311 //
     /* 153747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153750 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153757 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153764 */     // MIs[0] Rn
     /* 153764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153776 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 153779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153789 */     GIR_RootConstrainSelectedInstOperands,
     /* 153790 */     // GIR_Coverage, 7311,
     /* 153790 */     GIR_EraseRootFromParent_Done,
     /* 153791 */   // Label 2758: @153791
     /* 153791 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(153840), // Rule ID 7312 //
     /* 153796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153799 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153806 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153813 */     // MIs[0] Rn
     /* 153813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153825 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 153828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153838 */     GIR_RootConstrainSelectedInstOperands,
     /* 153839 */     // GIR_Coverage, 7312,
     /* 153839 */     GIR_EraseRootFromParent_Done,
     /* 153840 */   // Label 2759: @153840
     /* 153840 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(153889), // Rule ID 7313 //
     /* 153845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153848 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153855 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153862 */     // MIs[0] Rn
     /* 153862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153874 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 153877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153887 */     GIR_RootConstrainSelectedInstOperands,
     /* 153888 */     // GIR_Coverage, 7313,
     /* 153888 */     GIR_EraseRootFromParent_Done,
     /* 153889 */   // Label 2760: @153889
     /* 153889 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(153938), // Rule ID 7314 //
     /* 153894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153897 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153904 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153911 */     // MIs[0] Rn
     /* 153911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153923 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 153926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153936 */     GIR_RootConstrainSelectedInstOperands,
     /* 153937 */     // GIR_Coverage, 7314,
     /* 153937 */     GIR_EraseRootFromParent_Done,
     /* 153938 */   // Label 2761: @153938
     /* 153938 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(153987), // Rule ID 7315 //
     /* 153943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153946 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153953 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153960 */     // MIs[0] Rn
     /* 153960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153972 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 153975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153985 */     GIR_RootConstrainSelectedInstOperands,
     /* 153986 */     // GIR_Coverage, 7315,
     /* 153986 */     GIR_EraseRootFromParent_Done,
     /* 153987 */   // Label 2762: @153987
     /* 153987 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(154036), // Rule ID 7316 //
     /* 153992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153995 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154002 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154009 */     // MIs[0] Rn
     /* 154009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154021 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 154024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154034 */     GIR_RootConstrainSelectedInstOperands,
     /* 154035 */     // GIR_Coverage, 7316,
     /* 154035 */     GIR_EraseRootFromParent_Done,
     /* 154036 */   // Label 2763: @154036
     /* 154036 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(154085), // Rule ID 7317 //
     /* 154041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154044 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154051 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154058 */     // MIs[0] Rn
     /* 154058 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154070 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 154073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154083 */     GIR_RootConstrainSelectedInstOperands,
     /* 154084 */     // GIR_Coverage, 7317,
     /* 154084 */     GIR_EraseRootFromParent_Done,
     /* 154085 */   // Label 2764: @154085
     /* 154085 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(154134), // Rule ID 7318 //
     /* 154090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154093 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154100 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154107 */     // MIs[0] Rn
     /* 154107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154119 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 154122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154132 */     GIR_RootConstrainSelectedInstOperands,
     /* 154133 */     // GIR_Coverage, 7318,
     /* 154133 */     GIR_EraseRootFromParent_Done,
     /* 154134 */   // Label 2765: @154134
     /* 154134 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(154183), // Rule ID 7319 //
     /* 154139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154142 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154149 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154156 */     // MIs[0] Rn
     /* 154156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154168 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 154171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154181 */     GIR_RootConstrainSelectedInstOperands,
     /* 154182 */     // GIR_Coverage, 7319,
     /* 154182 */     GIR_EraseRootFromParent_Done,
     /* 154183 */   // Label 2766: @154183
     /* 154183 */   GIM_Reject,
     /* 154184 */ // Label 2751: @154184
     /* 154184 */ GIM_Reject,
     /* 154185 */ // Label 2749: @154185
     /* 154185 */ GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(154411),
     /* 154190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 154193 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154200 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(154242), // Rule ID 7300 //
     /* 154205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154208 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154215 */     // MIs[0] Rn
     /* 154215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154227 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 154230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154240 */     GIR_RootConstrainSelectedInstOperands,
     /* 154241 */     // GIR_Coverage, 7300,
     /* 154241 */     GIR_EraseRootFromParent_Done,
     /* 154242 */   // Label 2768: @154242
     /* 154242 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(154284), // Rule ID 7301 //
     /* 154247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154250 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154257 */     // MIs[0] Rn
     /* 154257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154269 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 154272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154282 */     GIR_RootConstrainSelectedInstOperands,
     /* 154283 */     // GIR_Coverage, 7301,
     /* 154283 */     GIR_EraseRootFromParent_Done,
     /* 154284 */   // Label 2769: @154284
     /* 154284 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(154326), // Rule ID 7302 //
     /* 154289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154292 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154299 */     // MIs[0] Rn
     /* 154299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154311 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 154314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154318 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154324 */     GIR_RootConstrainSelectedInstOperands,
     /* 154325 */     // GIR_Coverage, 7302,
     /* 154325 */     GIR_EraseRootFromParent_Done,
     /* 154326 */   // Label 2770: @154326
     /* 154326 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(154368), // Rule ID 7303 //
     /* 154331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154334 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154341 */     // MIs[0] Rn
     /* 154341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154353 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 154356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154366 */     GIR_RootConstrainSelectedInstOperands,
     /* 154367 */     // GIR_Coverage, 7303,
     /* 154367 */     GIR_EraseRootFromParent_Done,
     /* 154368 */   // Label 2771: @154368
     /* 154368 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(154410), // Rule ID 7304 //
     /* 154373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154376 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154383 */     // MIs[0] Rn
     /* 154383 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154395 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 154398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154408 */     GIR_RootConstrainSelectedInstOperands,
     /* 154409 */     // GIR_Coverage, 7304,
     /* 154409 */     GIR_EraseRootFromParent_Done,
     /* 154410 */   // Label 2772: @154410
     /* 154410 */   GIM_Reject,
     /* 154411 */ // Label 2767: @154411
     /* 154411 */ GIM_Reject,
     /* 154412 */ // Label 2750: @154412
     /* 154412 */ GIM_Reject,
     /* 154413 */ // Label 30: @154413
     /* 154413 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2775*/ GIMT_Encode4(155404),
     /* 154424 */ /*GILLT_s32*//*Label 2773*/ GIMT_Encode4(154432),
     /* 154428 */ /*GILLT_s64*//*Label 2774*/ GIMT_Encode4(155177),
     /* 154432 */ // Label 2773: @154432
     /* 154432 */ GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(155176),
     /* 154437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154440 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(154489), // Rule ID 7325 //
     /* 154445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154448 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154455 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154462 */     // MIs[0] Rn
     /* 154462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154474 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 154477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154487 */     GIR_RootConstrainSelectedInstOperands,
     /* 154488 */     // GIR_Coverage, 7325,
     /* 154488 */     GIR_EraseRootFromParent_Done,
     /* 154489 */   // Label 2777: @154489
     /* 154489 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(154538), // Rule ID 7326 //
     /* 154494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154497 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154504 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154511 */     // MIs[0] Rn
     /* 154511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154523 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 154526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154536 */     GIR_RootConstrainSelectedInstOperands,
     /* 154537 */     // GIR_Coverage, 7326,
     /* 154537 */     GIR_EraseRootFromParent_Done,
     /* 154538 */   // Label 2778: @154538
     /* 154538 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(154587), // Rule ID 7327 //
     /* 154543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154546 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154553 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154560 */     // MIs[0] Rn
     /* 154560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154572 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 154575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154585 */     GIR_RootConstrainSelectedInstOperands,
     /* 154586 */     // GIR_Coverage, 7327,
     /* 154586 */     GIR_EraseRootFromParent_Done,
     /* 154587 */   // Label 2779: @154587
     /* 154587 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(154636), // Rule ID 7328 //
     /* 154592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154595 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154602 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154609 */     // MIs[0] Rn
     /* 154609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154621 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 154624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154634 */     GIR_RootConstrainSelectedInstOperands,
     /* 154635 */     // GIR_Coverage, 7328,
     /* 154635 */     GIR_EraseRootFromParent_Done,
     /* 154636 */   // Label 2780: @154636
     /* 154636 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(154685), // Rule ID 7329 //
     /* 154641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154644 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154651 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154658 */     // MIs[0] Rn
     /* 154658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154670 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 154673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154683 */     GIR_RootConstrainSelectedInstOperands,
     /* 154684 */     // GIR_Coverage, 7329,
     /* 154684 */     GIR_EraseRootFromParent_Done,
     /* 154685 */   // Label 2781: @154685
     /* 154685 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(154734), // Rule ID 7330 //
     /* 154690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154693 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154700 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154707 */     // MIs[0] Rn
     /* 154707 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154719 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 154722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154732 */     GIR_RootConstrainSelectedInstOperands,
     /* 154733 */     // GIR_Coverage, 7330,
     /* 154733 */     GIR_EraseRootFromParent_Done,
     /* 154734 */   // Label 2782: @154734
     /* 154734 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(154783), // Rule ID 7331 //
     /* 154739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154742 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154749 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154756 */     // MIs[0] Rn
     /* 154756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154768 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 154771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154781 */     GIR_RootConstrainSelectedInstOperands,
     /* 154782 */     // GIR_Coverage, 7331,
     /* 154782 */     GIR_EraseRootFromParent_Done,
     /* 154783 */   // Label 2783: @154783
     /* 154783 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(154832), // Rule ID 7332 //
     /* 154788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154791 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154798 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154805 */     // MIs[0] Rn
     /* 154805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154817 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 154820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154830 */     GIR_RootConstrainSelectedInstOperands,
     /* 154831 */     // GIR_Coverage, 7332,
     /* 154831 */     GIR_EraseRootFromParent_Done,
     /* 154832 */   // Label 2784: @154832
     /* 154832 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(154881), // Rule ID 7333 //
     /* 154837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154840 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154847 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154854 */     // MIs[0] Rn
     /* 154854 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154866 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 154869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154879 */     GIR_RootConstrainSelectedInstOperands,
     /* 154880 */     // GIR_Coverage, 7333,
     /* 154880 */     GIR_EraseRootFromParent_Done,
     /* 154881 */   // Label 2785: @154881
     /* 154881 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(154930), // Rule ID 7334 //
     /* 154886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154889 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154896 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154903 */     // MIs[0] Rn
     /* 154903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154915 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 154918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154928 */     GIR_RootConstrainSelectedInstOperands,
     /* 154929 */     // GIR_Coverage, 7334,
     /* 154929 */     GIR_EraseRootFromParent_Done,
     /* 154930 */   // Label 2786: @154930
     /* 154930 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(154979), // Rule ID 7335 //
     /* 154935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154938 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154945 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154952 */     // MIs[0] Rn
     /* 154952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154964 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 154967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154977 */     GIR_RootConstrainSelectedInstOperands,
     /* 154978 */     // GIR_Coverage, 7335,
     /* 154978 */     GIR_EraseRootFromParent_Done,
     /* 154979 */   // Label 2787: @154979
     /* 154979 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(155028), // Rule ID 7336 //
     /* 154984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154987 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154994 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155001 */     // MIs[0] Rn
     /* 155001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155013 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 155016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155026 */     GIR_RootConstrainSelectedInstOperands,
     /* 155027 */     // GIR_Coverage, 7336,
     /* 155027 */     GIR_EraseRootFromParent_Done,
     /* 155028 */   // Label 2788: @155028
     /* 155028 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(155077), // Rule ID 7337 //
     /* 155033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155036 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155043 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155050 */     // MIs[0] Rn
     /* 155050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155062 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 155065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155075 */     GIR_RootConstrainSelectedInstOperands,
     /* 155076 */     // GIR_Coverage, 7337,
     /* 155076 */     GIR_EraseRootFromParent_Done,
     /* 155077 */   // Label 2789: @155077
     /* 155077 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(155126), // Rule ID 7338 //
     /* 155082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155085 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155092 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155099 */     // MIs[0] Rn
     /* 155099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155111 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 155114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155124 */     GIR_RootConstrainSelectedInstOperands,
     /* 155125 */     // GIR_Coverage, 7338,
     /* 155125 */     GIR_EraseRootFromParent_Done,
     /* 155126 */   // Label 2790: @155126
     /* 155126 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(155175), // Rule ID 7339 //
     /* 155131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155134 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155141 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155148 */     // MIs[0] Rn
     /* 155148 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155160 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 155163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155173 */     GIR_RootConstrainSelectedInstOperands,
     /* 155174 */     // GIR_Coverage, 7339,
     /* 155174 */     GIR_EraseRootFromParent_Done,
     /* 155175 */   // Label 2791: @155175
     /* 155175 */   GIM_Reject,
     /* 155176 */ // Label 2776: @155176
     /* 155176 */ GIM_Reject,
     /* 155177 */ // Label 2774: @155177
     /* 155177 */ GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(155403),
     /* 155182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155185 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 155192 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(155234), // Rule ID 7320 //
     /* 155197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155200 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155207 */     // MIs[0] Rn
     /* 155207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155219 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 155222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155232 */     GIR_RootConstrainSelectedInstOperands,
     /* 155233 */     // GIR_Coverage, 7320,
     /* 155233 */     GIR_EraseRootFromParent_Done,
     /* 155234 */   // Label 2793: @155234
     /* 155234 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(155276), // Rule ID 7321 //
     /* 155239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155242 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155249 */     // MIs[0] Rn
     /* 155249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155261 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 155264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155274 */     GIR_RootConstrainSelectedInstOperands,
     /* 155275 */     // GIR_Coverage, 7321,
     /* 155275 */     GIR_EraseRootFromParent_Done,
     /* 155276 */   // Label 2794: @155276
     /* 155276 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(155318), // Rule ID 7322 //
     /* 155281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155284 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155291 */     // MIs[0] Rn
     /* 155291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155303 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 155306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155316 */     GIR_RootConstrainSelectedInstOperands,
     /* 155317 */     // GIR_Coverage, 7322,
     /* 155317 */     GIR_EraseRootFromParent_Done,
     /* 155318 */   // Label 2795: @155318
     /* 155318 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(155360), // Rule ID 7323 //
     /* 155323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155326 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155333 */     // MIs[0] Rn
     /* 155333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155345 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 155348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155358 */     GIR_RootConstrainSelectedInstOperands,
     /* 155359 */     // GIR_Coverage, 7323,
     /* 155359 */     GIR_EraseRootFromParent_Done,
     /* 155360 */   // Label 2796: @155360
     /* 155360 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(155402), // Rule ID 7324 //
     /* 155365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155368 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155375 */     // MIs[0] Rn
     /* 155375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155387 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 155390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155400 */     GIR_RootConstrainSelectedInstOperands,
     /* 155401 */     // GIR_Coverage, 7324,
     /* 155401 */     GIR_EraseRootFromParent_Done,
     /* 155402 */   // Label 2797: @155402
     /* 155402 */   GIM_Reject,
     /* 155403 */ // Label 2792: @155403
     /* 155403 */ GIM_Reject,
     /* 155404 */ // Label 2775: @155404
     /* 155404 */ GIM_Reject,
     /* 155405 */ // Label 31: @155405
     /* 155405 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2801*/ GIMT_Encode4(156109),
     /* 155416 */ /*GILLT_s16*//*Label 2798*/ GIMT_Encode4(155428),
     /* 155420 */ /*GILLT_s32*//*Label 2799*/ GIMT_Encode4(155655),
     /* 155424 */ /*GILLT_s64*//*Label 2800*/ GIMT_Encode4(155882),
     /* 155428 */ // Label 2798: @155428
     /* 155428 */ GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(155654),
     /* 155433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 155436 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155443 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(155485), // Rule ID 2584 //
     /* 155448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155451 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155458 */     // MIs[0] Rn
     /* 155458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155470 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 155473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155483 */     GIR_RootConstrainSelectedInstOperands,
     /* 155484 */     // GIR_Coverage, 2584,
     /* 155484 */     GIR_EraseRootFromParent_Done,
     /* 155485 */   // Label 2803: @155485
     /* 155485 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(155527), // Rule ID 2585 //
     /* 155490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155493 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155500 */     // MIs[0] Rn
     /* 155500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155512 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 155515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155525 */     GIR_RootConstrainSelectedInstOperands,
     /* 155526 */     // GIR_Coverage, 2585,
     /* 155526 */     GIR_EraseRootFromParent_Done,
     /* 155527 */   // Label 2804: @155527
     /* 155527 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(155569), // Rule ID 2586 //
     /* 155532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155535 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155542 */     // MIs[0] Rn
     /* 155542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155554 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 155557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155567 */     GIR_RootConstrainSelectedInstOperands,
     /* 155568 */     // GIR_Coverage, 2586,
     /* 155568 */     GIR_EraseRootFromParent_Done,
     /* 155569 */   // Label 2805: @155569
     /* 155569 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(155611), // Rule ID 2587 //
     /* 155574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155577 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155584 */     // MIs[0] Rn
     /* 155584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155596 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 155599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155609 */     GIR_RootConstrainSelectedInstOperands,
     /* 155610 */     // GIR_Coverage, 2587,
     /* 155610 */     GIR_EraseRootFromParent_Done,
     /* 155611 */   // Label 2806: @155611
     /* 155611 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(155653), // Rule ID 2588 //
     /* 155616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155619 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155626 */     // MIs[0] Rn
     /* 155626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155638 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 155641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155645 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155651 */     GIR_RootConstrainSelectedInstOperands,
     /* 155652 */     // GIR_Coverage, 2588,
     /* 155652 */     GIR_EraseRootFromParent_Done,
     /* 155653 */   // Label 2807: @155653
     /* 155653 */   GIM_Reject,
     /* 155654 */ // Label 2802: @155654
     /* 155654 */ GIM_Reject,
     /* 155655 */ // Label 2799: @155655
     /* 155655 */ GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(155881),
     /* 155660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155663 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155670 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(155712), // Rule ID 7415 //
     /* 155675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155685 */     // MIs[0] Rn
     /* 155685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155697 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 155700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155710 */     GIR_RootConstrainSelectedInstOperands,
     /* 155711 */     // GIR_Coverage, 7415,
     /* 155711 */     GIR_EraseRootFromParent_Done,
     /* 155712 */   // Label 2809: @155712
     /* 155712 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(155754), // Rule ID 7416 //
     /* 155717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155720 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155727 */     // MIs[0] Rn
     /* 155727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155739 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 155742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155752 */     GIR_RootConstrainSelectedInstOperands,
     /* 155753 */     // GIR_Coverage, 7416,
     /* 155753 */     GIR_EraseRootFromParent_Done,
     /* 155754 */   // Label 2810: @155754
     /* 155754 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(155796), // Rule ID 7417 //
     /* 155759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155762 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155769 */     // MIs[0] Rn
     /* 155769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155781 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 155784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155794 */     GIR_RootConstrainSelectedInstOperands,
     /* 155795 */     // GIR_Coverage, 7417,
     /* 155795 */     GIR_EraseRootFromParent_Done,
     /* 155796 */   // Label 2811: @155796
     /* 155796 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(155838), // Rule ID 7418 //
     /* 155801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155804 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155811 */     // MIs[0] Rn
     /* 155811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155823 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 155826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155836 */     GIR_RootConstrainSelectedInstOperands,
     /* 155837 */     // GIR_Coverage, 7418,
     /* 155837 */     GIR_EraseRootFromParent_Done,
     /* 155838 */   // Label 2812: @155838
     /* 155838 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(155880), // Rule ID 7419 //
     /* 155843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155846 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155853 */     // MIs[0] Rn
     /* 155853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155865 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 155868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155872 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155878 */     GIR_RootConstrainSelectedInstOperands,
     /* 155879 */     // GIR_Coverage, 7419,
     /* 155879 */     GIR_EraseRootFromParent_Done,
     /* 155880 */   // Label 2813: @155880
     /* 155880 */   GIM_Reject,
     /* 155881 */ // Label 2808: @155881
     /* 155881 */ GIM_Reject,
     /* 155882 */ // Label 2800: @155882
     /* 155882 */ GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(156108),
     /* 155887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155890 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 155897 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(155939), // Rule ID 7420 //
     /* 155902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155905 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155912 */     // MIs[0] Rn
     /* 155912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155924 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 155927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155931 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155937 */     GIR_RootConstrainSelectedInstOperands,
     /* 155938 */     // GIR_Coverage, 7420,
     /* 155938 */     GIR_EraseRootFromParent_Done,
     /* 155939 */   // Label 2815: @155939
     /* 155939 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(155981), // Rule ID 7421 //
     /* 155944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155947 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155954 */     // MIs[0] Rn
     /* 155954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155966 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 155966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 155969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155979 */     GIR_RootConstrainSelectedInstOperands,
     /* 155980 */     // GIR_Coverage, 7421,
     /* 155980 */     GIR_EraseRootFromParent_Done,
     /* 155981 */   // Label 2816: @155981
     /* 155981 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(156023), // Rule ID 7422 //
     /* 155986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 155989 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155996 */     // MIs[0] Rn
     /* 155996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156008 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 156011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156015 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156021 */     GIR_RootConstrainSelectedInstOperands,
     /* 156022 */     // GIR_Coverage, 7422,
     /* 156022 */     GIR_EraseRootFromParent_Done,
     /* 156023 */   // Label 2817: @156023
     /* 156023 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(156065), // Rule ID 7423 //
     /* 156028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156031 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156038 */     // MIs[0] Rn
     /* 156038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156050 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 156053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156063 */     GIR_RootConstrainSelectedInstOperands,
     /* 156064 */     // GIR_Coverage, 7423,
     /* 156064 */     GIR_EraseRootFromParent_Done,
     /* 156065 */   // Label 2818: @156065
     /* 156065 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(156107), // Rule ID 7424 //
     /* 156070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156073 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156080 */     // MIs[0] Rn
     /* 156080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156092 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 156095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156105 */     GIR_RootConstrainSelectedInstOperands,
     /* 156106 */     // GIR_Coverage, 7424,
     /* 156106 */     GIR_EraseRootFromParent_Done,
     /* 156107 */   // Label 2819: @156107
     /* 156107 */   GIM_Reject,
     /* 156108 */ // Label 2814: @156108
     /* 156108 */ GIM_Reject,
     /* 156109 */ // Label 2801: @156109
     /* 156109 */ GIM_Reject,
     /* 156110 */ // Label 32: @156110
     /* 156110 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2823*/ GIMT_Encode4(156814),
     /* 156121 */ /*GILLT_s16*//*Label 2820*/ GIMT_Encode4(156133),
     /* 156125 */ /*GILLT_s32*//*Label 2821*/ GIMT_Encode4(156360),
     /* 156129 */ /*GILLT_s64*//*Label 2822*/ GIMT_Encode4(156587),
     /* 156133 */ // Label 2820: @156133
     /* 156133 */ GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(156359),
     /* 156138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156141 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156148 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(156190), // Rule ID 7425 //
     /* 156153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156156 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156163 */     // MIs[0] Rn
     /* 156163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156175 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 156178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156188 */     GIR_RootConstrainSelectedInstOperands,
     /* 156189 */     // GIR_Coverage, 7425,
     /* 156189 */     GIR_EraseRootFromParent_Done,
     /* 156190 */   // Label 2825: @156190
     /* 156190 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(156232), // Rule ID 7426 //
     /* 156195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156198 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156205 */     // MIs[0] Rn
     /* 156205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156217 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 156220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156230 */     GIR_RootConstrainSelectedInstOperands,
     /* 156231 */     // GIR_Coverage, 7426,
     /* 156231 */     GIR_EraseRootFromParent_Done,
     /* 156232 */   // Label 2826: @156232
     /* 156232 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(156274), // Rule ID 7427 //
     /* 156237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156240 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156247 */     // MIs[0] Rn
     /* 156247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156259 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 156262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156266 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156272 */     GIR_RootConstrainSelectedInstOperands,
     /* 156273 */     // GIR_Coverage, 7427,
     /* 156273 */     GIR_EraseRootFromParent_Done,
     /* 156274 */   // Label 2827: @156274
     /* 156274 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(156316), // Rule ID 7428 //
     /* 156279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156282 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156289 */     // MIs[0] Rn
     /* 156289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156301 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 156304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156314 */     GIR_RootConstrainSelectedInstOperands,
     /* 156315 */     // GIR_Coverage, 7428,
     /* 156315 */     GIR_EraseRootFromParent_Done,
     /* 156316 */   // Label 2828: @156316
     /* 156316 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(156358), // Rule ID 7429 //
     /* 156321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156324 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156331 */     // MIs[0] Rn
     /* 156331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156343 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 156346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156356 */     GIR_RootConstrainSelectedInstOperands,
     /* 156357 */     // GIR_Coverage, 7429,
     /* 156357 */     GIR_EraseRootFromParent_Done,
     /* 156358 */   // Label 2829: @156358
     /* 156358 */   GIM_Reject,
     /* 156359 */ // Label 2824: @156359
     /* 156359 */ GIM_Reject,
     /* 156360 */ // Label 2821: @156360
     /* 156360 */ GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(156586),
     /* 156365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156368 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156375 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(156417), // Rule ID 7430 //
     /* 156380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156383 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156390 */     // MIs[0] Rn
     /* 156390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156402 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 156405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156415 */     GIR_RootConstrainSelectedInstOperands,
     /* 156416 */     // GIR_Coverage, 7430,
     /* 156416 */     GIR_EraseRootFromParent_Done,
     /* 156417 */   // Label 2831: @156417
     /* 156417 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(156459), // Rule ID 7431 //
     /* 156422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156425 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156432 */     // MIs[0] Rn
     /* 156432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156444 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 156447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156457 */     GIR_RootConstrainSelectedInstOperands,
     /* 156458 */     // GIR_Coverage, 7431,
     /* 156458 */     GIR_EraseRootFromParent_Done,
     /* 156459 */   // Label 2832: @156459
     /* 156459 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(156501), // Rule ID 7432 //
     /* 156464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156467 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156474 */     // MIs[0] Rn
     /* 156474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156486 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 156489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156493 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156499 */     GIR_RootConstrainSelectedInstOperands,
     /* 156500 */     // GIR_Coverage, 7432,
     /* 156500 */     GIR_EraseRootFromParent_Done,
     /* 156501 */   // Label 2833: @156501
     /* 156501 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(156543), // Rule ID 7433 //
     /* 156506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156509 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156516 */     // MIs[0] Rn
     /* 156516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156528 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 156531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156541 */     GIR_RootConstrainSelectedInstOperands,
     /* 156542 */     // GIR_Coverage, 7433,
     /* 156542 */     GIR_EraseRootFromParent_Done,
     /* 156543 */   // Label 2834: @156543
     /* 156543 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(156585), // Rule ID 7434 //
     /* 156548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156551 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156558 */     // MIs[0] Rn
     /* 156558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156570 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 156573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156583 */     GIR_RootConstrainSelectedInstOperands,
     /* 156584 */     // GIR_Coverage, 7434,
     /* 156584 */     GIR_EraseRootFromParent_Done,
     /* 156585 */   // Label 2835: @156585
     /* 156585 */   GIM_Reject,
     /* 156586 */ // Label 2830: @156586
     /* 156586 */ GIM_Reject,
     /* 156587 */ // Label 2822: @156587
     /* 156587 */ GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(156813),
     /* 156592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156595 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156602 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(156644), // Rule ID 7435 //
     /* 156607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156610 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156617 */     // MIs[0] Rn
     /* 156617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156629 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 156632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156636 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156642 */     GIR_RootConstrainSelectedInstOperands,
     /* 156643 */     // GIR_Coverage, 7435,
     /* 156643 */     GIR_EraseRootFromParent_Done,
     /* 156644 */   // Label 2837: @156644
     /* 156644 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(156686), // Rule ID 7436 //
     /* 156649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156652 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156659 */     // MIs[0] Rn
     /* 156659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156671 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 156674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156684 */     GIR_RootConstrainSelectedInstOperands,
     /* 156685 */     // GIR_Coverage, 7436,
     /* 156685 */     GIR_EraseRootFromParent_Done,
     /* 156686 */   // Label 2838: @156686
     /* 156686 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(156728), // Rule ID 7437 //
     /* 156691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156694 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156701 */     // MIs[0] Rn
     /* 156701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156713 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 156716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156726 */     GIR_RootConstrainSelectedInstOperands,
     /* 156727 */     // GIR_Coverage, 7437,
     /* 156727 */     GIR_EraseRootFromParent_Done,
     /* 156728 */   // Label 2839: @156728
     /* 156728 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(156770), // Rule ID 7438 //
     /* 156733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156736 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156743 */     // MIs[0] Rn
     /* 156743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156755 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 156758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156768 */     GIR_RootConstrainSelectedInstOperands,
     /* 156769 */     // GIR_Coverage, 7438,
     /* 156769 */     GIR_EraseRootFromParent_Done,
     /* 156770 */   // Label 2840: @156770
     /* 156770 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(156812), // Rule ID 7439 //
     /* 156775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156778 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156785 */     // MIs[0] Rn
     /* 156785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156797 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 156800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156810 */     GIR_RootConstrainSelectedInstOperands,
     /* 156811 */     // GIR_Coverage, 7439,
     /* 156811 */     GIR_EraseRootFromParent_Done,
     /* 156812 */   // Label 2841: @156812
     /* 156812 */   GIM_Reject,
     /* 156813 */ // Label 2836: @156813
     /* 156813 */ GIM_Reject,
     /* 156814 */ // Label 2823: @156814
     /* 156814 */ GIM_Reject,
     /* 156815 */ // Label 33: @156815
     /* 156815 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2845*/ GIMT_Encode4(157519),
     /* 156826 */ /*GILLT_s16*//*Label 2842*/ GIMT_Encode4(156838),
     /* 156830 */ /*GILLT_s32*//*Label 2843*/ GIMT_Encode4(157065),
     /* 156834 */ /*GILLT_s64*//*Label 2844*/ GIMT_Encode4(157292),
     /* 156838 */ // Label 2842: @156838
     /* 156838 */ GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(157064),
     /* 156843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156846 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156853 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(156895), // Rule ID 7440 //
     /* 156858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156861 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156868 */     // MIs[0] Rn
     /* 156868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156880 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 156883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156893 */     GIR_RootConstrainSelectedInstOperands,
     /* 156894 */     // GIR_Coverage, 7440,
     /* 156894 */     GIR_EraseRootFromParent_Done,
     /* 156895 */   // Label 2847: @156895
     /* 156895 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(156937), // Rule ID 7441 //
     /* 156900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156903 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156910 */     // MIs[0] Rn
     /* 156910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156922 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 156925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156935 */     GIR_RootConstrainSelectedInstOperands,
     /* 156936 */     // GIR_Coverage, 7441,
     /* 156936 */     GIR_EraseRootFromParent_Done,
     /* 156937 */   // Label 2848: @156937
     /* 156937 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(156979), // Rule ID 7442 //
     /* 156942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156945 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156952 */     // MIs[0] Rn
     /* 156952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156964 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 156964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 156967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156977 */     GIR_RootConstrainSelectedInstOperands,
     /* 156978 */     // GIR_Coverage, 7442,
     /* 156978 */     GIR_EraseRootFromParent_Done,
     /* 156979 */   // Label 2849: @156979
     /* 156979 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(157021), // Rule ID 7443 //
     /* 156984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 156987 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156994 */     // MIs[0] Rn
     /* 156994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157006 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 157009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157019 */     GIR_RootConstrainSelectedInstOperands,
     /* 157020 */     // GIR_Coverage, 7443,
     /* 157020 */     GIR_EraseRootFromParent_Done,
     /* 157021 */   // Label 2850: @157021
     /* 157021 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(157063), // Rule ID 7444 //
     /* 157026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157029 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157036 */     // MIs[0] Rn
     /* 157036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157048 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 157051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157061 */     GIR_RootConstrainSelectedInstOperands,
     /* 157062 */     // GIR_Coverage, 7444,
     /* 157062 */     GIR_EraseRootFromParent_Done,
     /* 157063 */   // Label 2851: @157063
     /* 157063 */   GIM_Reject,
     /* 157064 */ // Label 2846: @157064
     /* 157064 */ GIM_Reject,
     /* 157065 */ // Label 2843: @157065
     /* 157065 */ GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(157291),
     /* 157070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157073 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157080 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(157122), // Rule ID 7445 //
     /* 157085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157095 */     // MIs[0] Rn
     /* 157095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157107 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 157110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157120 */     GIR_RootConstrainSelectedInstOperands,
     /* 157121 */     // GIR_Coverage, 7445,
     /* 157121 */     GIR_EraseRootFromParent_Done,
     /* 157122 */   // Label 2853: @157122
     /* 157122 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(157164), // Rule ID 7446 //
     /* 157127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157130 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157137 */     // MIs[0] Rn
     /* 157137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157149 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 157152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157162 */     GIR_RootConstrainSelectedInstOperands,
     /* 157163 */     // GIR_Coverage, 7446,
     /* 157163 */     GIR_EraseRootFromParent_Done,
     /* 157164 */   // Label 2854: @157164
     /* 157164 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(157206), // Rule ID 7447 //
     /* 157169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157172 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157179 */     // MIs[0] Rn
     /* 157179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157191 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 157194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157204 */     GIR_RootConstrainSelectedInstOperands,
     /* 157205 */     // GIR_Coverage, 7447,
     /* 157205 */     GIR_EraseRootFromParent_Done,
     /* 157206 */   // Label 2855: @157206
     /* 157206 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(157248), // Rule ID 7448 //
     /* 157211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157221 */     // MIs[0] Rn
     /* 157221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157233 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 157236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157246 */     GIR_RootConstrainSelectedInstOperands,
     /* 157247 */     // GIR_Coverage, 7448,
     /* 157247 */     GIR_EraseRootFromParent_Done,
     /* 157248 */   // Label 2856: @157248
     /* 157248 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(157290), // Rule ID 7449 //
     /* 157253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157256 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157263 */     // MIs[0] Rn
     /* 157263 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157275 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 157278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157288 */     GIR_RootConstrainSelectedInstOperands,
     /* 157289 */     // GIR_Coverage, 7449,
     /* 157289 */     GIR_EraseRootFromParent_Done,
     /* 157290 */   // Label 2857: @157290
     /* 157290 */   GIM_Reject,
     /* 157291 */ // Label 2852: @157291
     /* 157291 */ GIM_Reject,
     /* 157292 */ // Label 2844: @157292
     /* 157292 */ GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(157518),
     /* 157297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157300 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157307 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(157349), // Rule ID 7450 //
     /* 157312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157315 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157322 */     // MIs[0] Rn
     /* 157322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157334 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 157337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157341 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157347 */     GIR_RootConstrainSelectedInstOperands,
     /* 157348 */     // GIR_Coverage, 7450,
     /* 157348 */     GIR_EraseRootFromParent_Done,
     /* 157349 */   // Label 2859: @157349
     /* 157349 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(157391), // Rule ID 7451 //
     /* 157354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157357 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157364 */     // MIs[0] Rn
     /* 157364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157376 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 157379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157389 */     GIR_RootConstrainSelectedInstOperands,
     /* 157390 */     // GIR_Coverage, 7451,
     /* 157390 */     GIR_EraseRootFromParent_Done,
     /* 157391 */   // Label 2860: @157391
     /* 157391 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(157433), // Rule ID 7452 //
     /* 157396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157406 */     // MIs[0] Rn
     /* 157406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157418 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 157421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157425 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157431 */     GIR_RootConstrainSelectedInstOperands,
     /* 157432 */     // GIR_Coverage, 7452,
     /* 157432 */     GIR_EraseRootFromParent_Done,
     /* 157433 */   // Label 2861: @157433
     /* 157433 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(157475), // Rule ID 7453 //
     /* 157438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157448 */     // MIs[0] Rn
     /* 157448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157460 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 157463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157473 */     GIR_RootConstrainSelectedInstOperands,
     /* 157474 */     // GIR_Coverage, 7453,
     /* 157474 */     GIR_EraseRootFromParent_Done,
     /* 157475 */   // Label 2862: @157475
     /* 157475 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(157517), // Rule ID 7454 //
     /* 157480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157483 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157490 */     // MIs[0] Rn
     /* 157490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157502 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 157505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157515 */     GIR_RootConstrainSelectedInstOperands,
     /* 157516 */     // GIR_Coverage, 7454,
     /* 157516 */     GIR_EraseRootFromParent_Done,
     /* 157517 */   // Label 2863: @157517
     /* 157517 */   GIM_Reject,
     /* 157518 */ // Label 2858: @157518
     /* 157518 */ GIM_Reject,
     /* 157519 */ // Label 2845: @157519
     /* 157519 */ GIM_Reject,
     /* 157520 */ // Label 34: @157520
     /* 157520 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2867*/ GIMT_Encode4(158224),
     /* 157531 */ /*GILLT_s16*//*Label 2864*/ GIMT_Encode4(157543),
     /* 157535 */ /*GILLT_s32*//*Label 2865*/ GIMT_Encode4(157770),
     /* 157539 */ /*GILLT_s64*//*Label 2866*/ GIMT_Encode4(157997),
     /* 157543 */ // Label 2864: @157543
     /* 157543 */ GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(157769),
     /* 157548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157551 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157558 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(157600), // Rule ID 7455 //
     /* 157563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157573 */     // MIs[0] Rn
     /* 157573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157585 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_monotonic>>  =>  (LDFMAXH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXH),
     /* 157588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157598 */     GIR_RootConstrainSelectedInstOperands,
     /* 157599 */     // GIR_Coverage, 7455,
     /* 157599 */     GIR_EraseRootFromParent_Done,
     /* 157600 */   // Label 2869: @157600
     /* 157600 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(157642), // Rule ID 7456 //
     /* 157605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157608 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157615 */     // MIs[0] Rn
     /* 157615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157627 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acquire>>  =>  (LDFMAXAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAH),
     /* 157630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157640 */     GIR_RootConstrainSelectedInstOperands,
     /* 157641 */     // GIR_Coverage, 7456,
     /* 157641 */     GIR_EraseRootFromParent_Done,
     /* 157642 */   // Label 2870: @157642
     /* 157642 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(157684), // Rule ID 7457 //
     /* 157647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157650 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157657 */     // MIs[0] Rn
     /* 157657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157669 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_release>>  =>  (LDFMAXLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLH),
     /* 157672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157682 */     GIR_RootConstrainSelectedInstOperands,
     /* 157683 */     // GIR_Coverage, 7457,
     /* 157683 */     GIR_EraseRootFromParent_Done,
     /* 157684 */   // Label 2871: @157684
     /* 157684 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(157726), // Rule ID 7458 //
     /* 157689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157692 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157699 */     // MIs[0] Rn
     /* 157699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157711 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acq_rel>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 157714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157724 */     GIR_RootConstrainSelectedInstOperands,
     /* 157725 */     // GIR_Coverage, 7458,
     /* 157725 */     GIR_EraseRootFromParent_Done,
     /* 157726 */   // Label 2872: @157726
     /* 157726 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(157768), // Rule ID 7459 //
     /* 157731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157734 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157741 */     // MIs[0] Rn
     /* 157741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157753 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_seq_cst>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 157756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157766 */     GIR_RootConstrainSelectedInstOperands,
     /* 157767 */     // GIR_Coverage, 7459,
     /* 157767 */     GIR_EraseRootFromParent_Done,
     /* 157768 */   // Label 2873: @157768
     /* 157768 */   GIM_Reject,
     /* 157769 */ // Label 2868: @157769
     /* 157769 */ GIM_Reject,
     /* 157770 */ // Label 2865: @157770
     /* 157770 */ GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(157996),
     /* 157775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157778 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157785 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(157827), // Rule ID 7460 //
     /* 157790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157800 */     // MIs[0] Rn
     /* 157800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157812 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_monotonic>>  =>  (LDFMAXS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXS),
     /* 157815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157825 */     GIR_RootConstrainSelectedInstOperands,
     /* 157826 */     // GIR_Coverage, 7460,
     /* 157826 */     GIR_EraseRootFromParent_Done,
     /* 157827 */   // Label 2875: @157827
     /* 157827 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(157869), // Rule ID 7461 //
     /* 157832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157842 */     // MIs[0] Rn
     /* 157842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157854 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acquire>>  =>  (LDFMAXAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAS),
     /* 157857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157867 */     GIR_RootConstrainSelectedInstOperands,
     /* 157868 */     // GIR_Coverage, 7461,
     /* 157868 */     GIR_EraseRootFromParent_Done,
     /* 157869 */   // Label 2876: @157869
     /* 157869 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(157911), // Rule ID 7462 //
     /* 157874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157877 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157884 */     // MIs[0] Rn
     /* 157884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157896 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_release>>  =>  (LDFMAXLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLS),
     /* 157899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157909 */     GIR_RootConstrainSelectedInstOperands,
     /* 157910 */     // GIR_Coverage, 7462,
     /* 157910 */     GIR_EraseRootFromParent_Done,
     /* 157911 */   // Label 2877: @157911
     /* 157911 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(157953), // Rule ID 7463 //
     /* 157916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157926 */     // MIs[0] Rn
     /* 157926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157938 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acq_rel>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 157941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157951 */     GIR_RootConstrainSelectedInstOperands,
     /* 157952 */     // GIR_Coverage, 7463,
     /* 157952 */     GIR_EraseRootFromParent_Done,
     /* 157953 */   // Label 2878: @157953
     /* 157953 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(157995), // Rule ID 7464 //
     /* 157958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157961 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157968 */     // MIs[0] Rn
     /* 157968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157980 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_seq_cst>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 157983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157993 */     GIR_RootConstrainSelectedInstOperands,
     /* 157994 */     // GIR_Coverage, 7464,
     /* 157994 */     GIR_EraseRootFromParent_Done,
     /* 157995 */   // Label 2879: @157995
     /* 157995 */   GIM_Reject,
     /* 157996 */ // Label 2874: @157996
     /* 157996 */ GIM_Reject,
     /* 157997 */ // Label 2866: @157997
     /* 157997 */ GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(158223),
     /* 158002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158005 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158012 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(158054), // Rule ID 7465 //
     /* 158017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158020 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158027 */     // MIs[0] Rn
     /* 158027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158039 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_monotonic>>  =>  (LDFMAXD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXD),
     /* 158042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158046 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158052 */     GIR_RootConstrainSelectedInstOperands,
     /* 158053 */     // GIR_Coverage, 7465,
     /* 158053 */     GIR_EraseRootFromParent_Done,
     /* 158054 */   // Label 2881: @158054
     /* 158054 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(158096), // Rule ID 7466 //
     /* 158059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158062 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158069 */     // MIs[0] Rn
     /* 158069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158081 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acquire>>  =>  (LDFMAXAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAD),
     /* 158084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158094 */     GIR_RootConstrainSelectedInstOperands,
     /* 158095 */     // GIR_Coverage, 7466,
     /* 158095 */     GIR_EraseRootFromParent_Done,
     /* 158096 */   // Label 2882: @158096
     /* 158096 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(158138), // Rule ID 7467 //
     /* 158101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158111 */     // MIs[0] Rn
     /* 158111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158123 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_release>>  =>  (LDFMAXLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLD),
     /* 158126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158136 */     GIR_RootConstrainSelectedInstOperands,
     /* 158137 */     // GIR_Coverage, 7467,
     /* 158137 */     GIR_EraseRootFromParent_Done,
     /* 158138 */   // Label 2883: @158138
     /* 158138 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(158180), // Rule ID 7468 //
     /* 158143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158146 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158153 */     // MIs[0] Rn
     /* 158153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158165 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acq_rel>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 158168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158178 */     GIR_RootConstrainSelectedInstOperands,
     /* 158179 */     // GIR_Coverage, 7468,
     /* 158179 */     GIR_EraseRootFromParent_Done,
     /* 158180 */   // Label 2884: @158180
     /* 158180 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(158222), // Rule ID 7469 //
     /* 158185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158188 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158195 */     // MIs[0] Rn
     /* 158195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158207 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_seq_cst>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 158210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158220 */     GIR_RootConstrainSelectedInstOperands,
     /* 158221 */     // GIR_Coverage, 7469,
     /* 158221 */     GIR_EraseRootFromParent_Done,
     /* 158222 */   // Label 2885: @158222
     /* 158222 */   GIM_Reject,
     /* 158223 */ // Label 2880: @158223
     /* 158223 */ GIM_Reject,
     /* 158224 */ // Label 2867: @158224
     /* 158224 */ GIM_Reject,
     /* 158225 */ // Label 35: @158225
     /* 158225 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2889*/ GIMT_Encode4(158929),
     /* 158236 */ /*GILLT_s16*//*Label 2886*/ GIMT_Encode4(158248),
     /* 158240 */ /*GILLT_s32*//*Label 2887*/ GIMT_Encode4(158475),
     /* 158244 */ /*GILLT_s64*//*Label 2888*/ GIMT_Encode4(158702),
     /* 158248 */ // Label 2886: @158248
     /* 158248 */ GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(158474),
     /* 158253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158256 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 158263 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(158305), // Rule ID 7470 //
     /* 158268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158278 */     // MIs[0] Rn
     /* 158278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158290 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_monotonic>>  =>  (LDFMINH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINH),
     /* 158293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158303 */     GIR_RootConstrainSelectedInstOperands,
     /* 158304 */     // GIR_Coverage, 7470,
     /* 158304 */     GIR_EraseRootFromParent_Done,
     /* 158305 */   // Label 2891: @158305
     /* 158305 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(158347), // Rule ID 7471 //
     /* 158310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158313 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158320 */     // MIs[0] Rn
     /* 158320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158332 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acquire>>  =>  (LDFMINAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAH),
     /* 158335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158345 */     GIR_RootConstrainSelectedInstOperands,
     /* 158346 */     // GIR_Coverage, 7471,
     /* 158346 */     GIR_EraseRootFromParent_Done,
     /* 158347 */   // Label 2892: @158347
     /* 158347 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(158389), // Rule ID 7472 //
     /* 158352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158355 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158362 */     // MIs[0] Rn
     /* 158362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158374 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_release>>  =>  (LDFMINLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLH),
     /* 158377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158387 */     GIR_RootConstrainSelectedInstOperands,
     /* 158388 */     // GIR_Coverage, 7472,
     /* 158388 */     GIR_EraseRootFromParent_Done,
     /* 158389 */   // Label 2893: @158389
     /* 158389 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(158431), // Rule ID 7473 //
     /* 158394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158397 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158404 */     // MIs[0] Rn
     /* 158404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158416 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acq_rel>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 158419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158429 */     GIR_RootConstrainSelectedInstOperands,
     /* 158430 */     // GIR_Coverage, 7473,
     /* 158430 */     GIR_EraseRootFromParent_Done,
     /* 158431 */   // Label 2894: @158431
     /* 158431 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(158473), // Rule ID 7474 //
     /* 158436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158439 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158446 */     // MIs[0] Rn
     /* 158446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158458 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_seq_cst>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 158461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158471 */     GIR_RootConstrainSelectedInstOperands,
     /* 158472 */     // GIR_Coverage, 7474,
     /* 158472 */     GIR_EraseRootFromParent_Done,
     /* 158473 */   // Label 2895: @158473
     /* 158473 */   GIM_Reject,
     /* 158474 */ // Label 2890: @158474
     /* 158474 */ GIM_Reject,
     /* 158475 */ // Label 2887: @158475
     /* 158475 */ GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(158701),
     /* 158480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158483 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158490 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(158532), // Rule ID 7475 //
     /* 158495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158505 */     // MIs[0] Rn
     /* 158505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158517 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_monotonic>>  =>  (LDFMINS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINS),
     /* 158520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158530 */     GIR_RootConstrainSelectedInstOperands,
     /* 158531 */     // GIR_Coverage, 7475,
     /* 158531 */     GIR_EraseRootFromParent_Done,
     /* 158532 */   // Label 2897: @158532
     /* 158532 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(158574), // Rule ID 7476 //
     /* 158537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158540 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158547 */     // MIs[0] Rn
     /* 158547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158559 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acquire>>  =>  (LDFMINAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAS),
     /* 158562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158572 */     GIR_RootConstrainSelectedInstOperands,
     /* 158573 */     // GIR_Coverage, 7476,
     /* 158573 */     GIR_EraseRootFromParent_Done,
     /* 158574 */   // Label 2898: @158574
     /* 158574 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(158616), // Rule ID 7477 //
     /* 158579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158582 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158589 */     // MIs[0] Rn
     /* 158589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158601 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_release>>  =>  (LDFMINLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLS),
     /* 158604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158614 */     GIR_RootConstrainSelectedInstOperands,
     /* 158615 */     // GIR_Coverage, 7477,
     /* 158615 */     GIR_EraseRootFromParent_Done,
     /* 158616 */   // Label 2899: @158616
     /* 158616 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(158658), // Rule ID 7478 //
     /* 158621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158624 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158631 */     // MIs[0] Rn
     /* 158631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158643 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acq_rel>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 158646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158656 */     GIR_RootConstrainSelectedInstOperands,
     /* 158657 */     // GIR_Coverage, 7478,
     /* 158657 */     GIR_EraseRootFromParent_Done,
     /* 158658 */   // Label 2900: @158658
     /* 158658 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(158700), // Rule ID 7479 //
     /* 158663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158666 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158673 */     // MIs[0] Rn
     /* 158673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158685 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_seq_cst>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 158688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158698 */     GIR_RootConstrainSelectedInstOperands,
     /* 158699 */     // GIR_Coverage, 7479,
     /* 158699 */     GIR_EraseRootFromParent_Done,
     /* 158700 */   // Label 2901: @158700
     /* 158700 */   GIM_Reject,
     /* 158701 */ // Label 2896: @158701
     /* 158701 */ GIM_Reject,
     /* 158702 */ // Label 2888: @158702
     /* 158702 */ GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(158928),
     /* 158707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158710 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158717 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(158759), // Rule ID 7480 //
     /* 158722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158725 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158732 */     // MIs[0] Rn
     /* 158732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158744 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_monotonic>>  =>  (LDFMIND:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMIND),
     /* 158747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158757 */     GIR_RootConstrainSelectedInstOperands,
     /* 158758 */     // GIR_Coverage, 7480,
     /* 158758 */     GIR_EraseRootFromParent_Done,
     /* 158759 */   // Label 2903: @158759
     /* 158759 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(158801), // Rule ID 7481 //
     /* 158764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158767 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158774 */     // MIs[0] Rn
     /* 158774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158786 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acquire>>  =>  (LDFMINAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAD),
     /* 158789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158799 */     GIR_RootConstrainSelectedInstOperands,
     /* 158800 */     // GIR_Coverage, 7481,
     /* 158800 */     GIR_EraseRootFromParent_Done,
     /* 158801 */   // Label 2904: @158801
     /* 158801 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(158843), // Rule ID 7482 //
     /* 158806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158809 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158816 */     // MIs[0] Rn
     /* 158816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158828 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_release>>  =>  (LDFMINLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLD),
     /* 158831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158835 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158841 */     GIR_RootConstrainSelectedInstOperands,
     /* 158842 */     // GIR_Coverage, 7482,
     /* 158842 */     GIR_EraseRootFromParent_Done,
     /* 158843 */   // Label 2905: @158843
     /* 158843 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(158885), // Rule ID 7483 //
     /* 158848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158851 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158858 */     // MIs[0] Rn
     /* 158858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158870 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acq_rel>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 158873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158883 */     GIR_RootConstrainSelectedInstOperands,
     /* 158884 */     // GIR_Coverage, 7483,
     /* 158884 */     GIR_EraseRootFromParent_Done,
     /* 158885 */   // Label 2906: @158885
     /* 158885 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(158927), // Rule ID 7484 //
     /* 158890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158893 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158900 */     // MIs[0] Rn
     /* 158900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158912 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_seq_cst>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 158915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158925 */     GIR_RootConstrainSelectedInstOperands,
     /* 158926 */     // GIR_Coverage, 7484,
     /* 158926 */     GIR_EraseRootFromParent_Done,
     /* 158927 */   // Label 2907: @158927
     /* 158927 */   GIM_Reject,
     /* 158928 */ // Label 2902: @158928
     /* 158928 */ GIM_Reject,
     /* 158929 */ // Label 2889: @158929
     /* 158929 */ GIM_Reject,
     /* 158930 */ // Label 36: @158930
     /* 158930 */ GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(158957), // Rule ID 7070 //
     /* 158935 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158938 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 158942 */   // MIs[0] Operand 1
     /* 158942 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 158945 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 158945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 158948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 158951 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158955 */   GIR_RootConstrainSelectedInstOperands,
     /* 158956 */   // GIR_Coverage, 7070,
     /* 158956 */   GIR_EraseRootFromParent_Done,
     /* 158957 */ // Label 2908: @158957
     /* 158957 */ GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(158980), // Rule ID 7071 //
     /* 158962 */   // MIs[0] Operand 0
     /* 158962 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 158965 */   // MIs[0] Operand 1
     /* 158965 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 158968 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 158968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 158971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 158974 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158978 */   GIR_RootConstrainSelectedInstOperands,
     /* 158979 */   // GIR_Coverage, 7071,
     /* 158979 */   GIR_EraseRootFromParent_Done,
     /* 158980 */ // Label 2909: @158980
     /* 158980 */ GIM_Reject,
     /* 158981 */ // Label 37: @158981
     /* 158981 */ GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(171508),
     /* 158986 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 158989 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(159080), // Rule ID 6549 //
     /* 158994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 158997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 159002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 159005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159020 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159023 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 159028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159032 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 159036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159048 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 159048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 159051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 159055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159060 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 159064 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 159068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 159073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159078 */     GIR_RootConstrainSelectedInstOperands,
     /* 159079 */     // GIR_Coverage, 6549,
     /* 159079 */     GIR_EraseRootFromParent_Done,
     /* 159080 */   // Label 2911: @159080
     /* 159080 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(159171), // Rule ID 6550 //
     /* 159085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 159088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 159093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 159096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159111 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159114 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 159119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 159123 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 159127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159139 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 159139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 159142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 159146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159151 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 159155 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 159159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 159164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159169 */     GIR_RootConstrainSelectedInstOperands,
     /* 159170 */     // GIR_Coverage, 6550,
     /* 159170 */     GIR_EraseRootFromParent_Done,
     /* 159171 */   // Label 2912: @159171
     /* 159171 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(159232), // Rule ID 4934 //
     /* 159176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 159181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 159184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 159199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159208 */     // MIs[1] Operand 2
     /* 159208 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 159219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159221 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 159221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 159224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 159230 */     GIR_RootConstrainSelectedInstOperands,
     /* 159231 */     // GIR_Coverage, 4934,
     /* 159231 */     GIR_EraseRootFromParent_Done,
     /* 159232 */   // Label 2913: @159232
     /* 159232 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(159272), // Rule ID 2651 //
     /* 159237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 159240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 159245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159252 */     // MIs[0] pattern
     /* 159252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 159255 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 159260 */     // (intrinsic_wo_chain:{ *:[i64] } 1332:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 159260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 159263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159265 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 159267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 159270 */     GIR_RootConstrainSelectedInstOperands,
     /* 159271 */     // GIR_Coverage, 2651,
     /* 159271 */     GIR_EraseRootFromParent_Done,
     /* 159272 */   // Label 2914: @159272
     /* 159272 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(159312), // Rule ID 9991 //
     /* 159277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 159280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 159285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159292 */     // MIs[0] pattern
     /* 159292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 159295 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 159300 */     // (intrinsic_wo_chain:{ *:[i64] } 1334:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 159300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 159303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159305 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 159307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 159310 */     GIR_RootConstrainSelectedInstOperands,
     /* 159311 */     // GIR_Coverage, 9991,
     /* 159311 */     GIR_EraseRootFromParent_Done,
     /* 159312 */   // Label 2915: @159312
     /* 159312 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(159352), // Rule ID 9994 //
     /* 159317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 159320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 159325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159332 */     // MIs[0] pattern
     /* 159332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 159335 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 159340 */     // (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 159340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 159343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159345 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 159347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 159350 */     GIR_RootConstrainSelectedInstOperands,
     /* 159351 */     // GIR_Coverage, 9994,
     /* 159351 */     GIR_EraseRootFromParent_Done,
     /* 159352 */   // Label 2916: @159352
     /* 159352 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(159392), // Rule ID 9997 //
     /* 159357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 159360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 159365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159372 */     // MIs[0] pattern
     /* 159372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 159375 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 159380 */     // (intrinsic_wo_chain:{ *:[i64] } 1333:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 159380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 159383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159385 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 159387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 159390 */     GIR_RootConstrainSelectedInstOperands,
     /* 159391 */     // GIR_Coverage, 9997,
     /* 159391 */     GIR_EraseRootFromParent_Done,
     /* 159392 */   // Label 2917: @159392
     /* 159392 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(159431), // Rule ID 66 //
     /* 159397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 159400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 159405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159419 */     // (intrinsic_wo_chain:{ *:[i32] } 546:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 159419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 159422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 159429 */     GIR_RootConstrainSelectedInstOperands,
     /* 159430 */     // GIR_Coverage, 66,
     /* 159430 */     GIR_EraseRootFromParent_Done,
     /* 159431 */   // Label 2918: @159431
     /* 159431 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(159467), // Rule ID 346 //
     /* 159436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159458 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 159458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 159461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159465 */     GIR_RootConstrainSelectedInstOperands,
     /* 159466 */     // GIR_Coverage, 346,
     /* 159466 */     GIR_EraseRootFromParent_Done,
     /* 159467 */   // Label 2919: @159467
     /* 159467 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(159503), // Rule ID 347 //
     /* 159472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159494 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 159494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 159497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159501 */     GIR_RootConstrainSelectedInstOperands,
     /* 159502 */     // GIR_Coverage, 347,
     /* 159502 */     GIR_EraseRootFromParent_Done,
     /* 159503 */   // Label 2920: @159503
     /* 159503 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(159539), // Rule ID 348 //
     /* 159508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159530 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 159530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 159533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159537 */     GIR_RootConstrainSelectedInstOperands,
     /* 159538 */     // GIR_Coverage, 348,
     /* 159538 */     GIR_EraseRootFromParent_Done,
     /* 159539 */   // Label 2921: @159539
     /* 159539 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(159575), // Rule ID 349 //
     /* 159544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159566 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 159566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 159569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159573 */     GIR_RootConstrainSelectedInstOperands,
     /* 159574 */     // GIR_Coverage, 349,
     /* 159574 */     GIR_EraseRootFromParent_Done,
     /* 159575 */   // Label 2922: @159575
     /* 159575 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(159611), // Rule ID 350 //
     /* 159580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159602 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 159602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 159605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159609 */     GIR_RootConstrainSelectedInstOperands,
     /* 159610 */     // GIR_Coverage, 350,
     /* 159610 */     GIR_EraseRootFromParent_Done,
     /* 159611 */   // Label 2923: @159611
     /* 159611 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(159647), // Rule ID 351 //
     /* 159616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 159624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159638 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 159638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 159641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159645 */     GIR_RootConstrainSelectedInstOperands,
     /* 159646 */     // GIR_Coverage, 351,
     /* 159646 */     GIR_EraseRootFromParent_Done,
     /* 159647 */   // Label 2924: @159647
     /* 159647 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(159683), // Rule ID 352 //
     /* 159652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159674 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 159674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 159677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159681 */     GIR_RootConstrainSelectedInstOperands,
     /* 159682 */     // GIR_Coverage, 352,
     /* 159682 */     GIR_EraseRootFromParent_Done,
     /* 159683 */   // Label 2925: @159683
     /* 159683 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(159719), // Rule ID 353 //
     /* 159688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159710 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 159710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 159713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159717 */     GIR_RootConstrainSelectedInstOperands,
     /* 159718 */     // GIR_Coverage, 353,
     /* 159718 */     GIR_EraseRootFromParent_Done,
     /* 159719 */   // Label 2926: @159719
     /* 159719 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(159755), // Rule ID 354 //
     /* 159724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159746 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 159746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 159749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159753 */     GIR_RootConstrainSelectedInstOperands,
     /* 159754 */     // GIR_Coverage, 354,
     /* 159754 */     GIR_EraseRootFromParent_Done,
     /* 159755 */   // Label 2927: @159755
     /* 159755 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(159791), // Rule ID 355 //
     /* 159760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159782 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 159782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 159785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159789 */     GIR_RootConstrainSelectedInstOperands,
     /* 159790 */     // GIR_Coverage, 355,
     /* 159790 */     GIR_EraseRootFromParent_Done,
     /* 159791 */   // Label 2928: @159791
     /* 159791 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(159827), // Rule ID 356 //
     /* 159796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159818 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 159818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 159821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159825 */     GIR_RootConstrainSelectedInstOperands,
     /* 159826 */     // GIR_Coverage, 356,
     /* 159826 */     GIR_EraseRootFromParent_Done,
     /* 159827 */   // Label 2929: @159827
     /* 159827 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(159863), // Rule ID 357 //
     /* 159832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 159840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159854 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 159854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 159857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159861 */     GIR_RootConstrainSelectedInstOperands,
     /* 159862 */     // GIR_Coverage, 357,
     /* 159862 */     GIR_EraseRootFromParent_Done,
     /* 159863 */   // Label 2930: @159863
     /* 159863 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(159899), // Rule ID 358 //
     /* 159868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 159876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159890 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 159890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 159893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159897 */     GIR_RootConstrainSelectedInstOperands,
     /* 159898 */     // GIR_Coverage, 358,
     /* 159898 */     GIR_EraseRootFromParent_Done,
     /* 159899 */   // Label 2931: @159899
     /* 159899 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(159935), // Rule ID 359 //
     /* 159904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 159907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 159912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159926 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 159926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 159929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159933 */     GIR_RootConstrainSelectedInstOperands,
     /* 159934 */     // GIR_Coverage, 359,
     /* 159934 */     GIR_EraseRootFromParent_Done,
     /* 159935 */   // Label 2932: @159935
     /* 159935 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(159971), // Rule ID 360 //
     /* 159940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 159948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 159958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159962 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 159962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 159965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159969 */     GIR_RootConstrainSelectedInstOperands,
     /* 159970 */     // GIR_Coverage, 360,
     /* 159970 */     GIR_EraseRootFromParent_Done,
     /* 159971 */   // Label 2933: @159971
     /* 159971 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(160007), // Rule ID 361 //
     /* 159976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 159979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 159984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 159994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159998 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 159998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 160001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160005 */     GIR_RootConstrainSelectedInstOperands,
     /* 160006 */     // GIR_Coverage, 361,
     /* 160006 */     GIR_EraseRootFromParent_Done,
     /* 160007 */   // Label 2934: @160007
     /* 160007 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(160043), // Rule ID 362 //
     /* 160012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160034 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 160037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160041 */     GIR_RootConstrainSelectedInstOperands,
     /* 160042 */     // GIR_Coverage, 362,
     /* 160042 */     GIR_EraseRootFromParent_Done,
     /* 160043 */   // Label 2935: @160043
     /* 160043 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(160079), // Rule ID 363 //
     /* 160048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 160056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160070 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 160073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160077 */     GIR_RootConstrainSelectedInstOperands,
     /* 160078 */     // GIR_Coverage, 363,
     /* 160078 */     GIR_EraseRootFromParent_Done,
     /* 160079 */   // Label 2936: @160079
     /* 160079 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(160115), // Rule ID 364 //
     /* 160084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160106 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 160109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160113 */     GIR_RootConstrainSelectedInstOperands,
     /* 160114 */     // GIR_Coverage, 364,
     /* 160114 */     GIR_EraseRootFromParent_Done,
     /* 160115 */   // Label 2937: @160115
     /* 160115 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(160151), // Rule ID 365 //
     /* 160120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160142 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 160145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160149 */     GIR_RootConstrainSelectedInstOperands,
     /* 160150 */     // GIR_Coverage, 365,
     /* 160150 */     GIR_EraseRootFromParent_Done,
     /* 160151 */   // Label 2938: @160151
     /* 160151 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(160187), // Rule ID 366 //
     /* 160156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160178 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 160181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160185 */     GIR_RootConstrainSelectedInstOperands,
     /* 160186 */     // GIR_Coverage, 366,
     /* 160186 */     GIR_EraseRootFromParent_Done,
     /* 160187 */   // Label 2939: @160187
     /* 160187 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(160223), // Rule ID 367 //
     /* 160192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160214 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 160217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160221 */     GIR_RootConstrainSelectedInstOperands,
     /* 160222 */     // GIR_Coverage, 367,
     /* 160222 */     GIR_EraseRootFromParent_Done,
     /* 160223 */   // Label 2940: @160223
     /* 160223 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(160259), // Rule ID 368 //
     /* 160228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160250 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 160253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160257 */     GIR_RootConstrainSelectedInstOperands,
     /* 160258 */     // GIR_Coverage, 368,
     /* 160258 */     GIR_EraseRootFromParent_Done,
     /* 160259 */   // Label 2941: @160259
     /* 160259 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(160295), // Rule ID 369 //
     /* 160264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 160272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160286 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 160289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160293 */     GIR_RootConstrainSelectedInstOperands,
     /* 160294 */     // GIR_Coverage, 369,
     /* 160294 */     GIR_EraseRootFromParent_Done,
     /* 160295 */   // Label 2942: @160295
     /* 160295 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(160331), // Rule ID 370 //
     /* 160300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160322 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 160325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160329 */     GIR_RootConstrainSelectedInstOperands,
     /* 160330 */     // GIR_Coverage, 370,
     /* 160330 */     GIR_EraseRootFromParent_Done,
     /* 160331 */   // Label 2943: @160331
     /* 160331 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(160367), // Rule ID 371 //
     /* 160336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160358 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 160361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160365 */     GIR_RootConstrainSelectedInstOperands,
     /* 160366 */     // GIR_Coverage, 371,
     /* 160366 */     GIR_EraseRootFromParent_Done,
     /* 160367 */   // Label 2944: @160367
     /* 160367 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(160403), // Rule ID 372 //
     /* 160372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160394 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 160397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160401 */     GIR_RootConstrainSelectedInstOperands,
     /* 160402 */     // GIR_Coverage, 372,
     /* 160402 */     GIR_EraseRootFromParent_Done,
     /* 160403 */   // Label 2945: @160403
     /* 160403 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(160439), // Rule ID 373 //
     /* 160408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160430 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 160433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160437 */     GIR_RootConstrainSelectedInstOperands,
     /* 160438 */     // GIR_Coverage, 373,
     /* 160438 */     GIR_EraseRootFromParent_Done,
     /* 160439 */   // Label 2946: @160439
     /* 160439 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(160475), // Rule ID 374 //
     /* 160444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160466 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 160469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160473 */     GIR_RootConstrainSelectedInstOperands,
     /* 160474 */     // GIR_Coverage, 374,
     /* 160474 */     GIR_EraseRootFromParent_Done,
     /* 160475 */   // Label 2947: @160475
     /* 160475 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(160511), // Rule ID 375 //
     /* 160480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 160488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160502 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 160505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160509 */     GIR_RootConstrainSelectedInstOperands,
     /* 160510 */     // GIR_Coverage, 375,
     /* 160510 */     GIR_EraseRootFromParent_Done,
     /* 160511 */   // Label 2948: @160511
     /* 160511 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(160547), // Rule ID 376 //
     /* 160516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160538 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 160541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160545 */     GIR_RootConstrainSelectedInstOperands,
     /* 160546 */     // GIR_Coverage, 376,
     /* 160546 */     GIR_EraseRootFromParent_Done,
     /* 160547 */   // Label 2949: @160547
     /* 160547 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(160583), // Rule ID 377 //
     /* 160552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160574 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 160577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160581 */     GIR_RootConstrainSelectedInstOperands,
     /* 160582 */     // GIR_Coverage, 377,
     /* 160582 */     GIR_EraseRootFromParent_Done,
     /* 160583 */   // Label 2950: @160583
     /* 160583 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(160619), // Rule ID 378 //
     /* 160588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160610 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 160613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160617 */     GIR_RootConstrainSelectedInstOperands,
     /* 160618 */     // GIR_Coverage, 378,
     /* 160618 */     GIR_EraseRootFromParent_Done,
     /* 160619 */   // Label 2951: @160619
     /* 160619 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(160655), // Rule ID 379 //
     /* 160624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160646 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 160649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160653 */     GIR_RootConstrainSelectedInstOperands,
     /* 160654 */     // GIR_Coverage, 379,
     /* 160654 */     GIR_EraseRootFromParent_Done,
     /* 160655 */   // Label 2952: @160655
     /* 160655 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(160691), // Rule ID 380 //
     /* 160660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160682 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 160685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160689 */     GIR_RootConstrainSelectedInstOperands,
     /* 160690 */     // GIR_Coverage, 380,
     /* 160690 */     GIR_EraseRootFromParent_Done,
     /* 160691 */   // Label 2953: @160691
     /* 160691 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(160727), // Rule ID 381 //
     /* 160696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 160704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160718 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 160721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160725 */     GIR_RootConstrainSelectedInstOperands,
     /* 160726 */     // GIR_Coverage, 381,
     /* 160726 */     GIR_EraseRootFromParent_Done,
     /* 160727 */   // Label 2954: @160727
     /* 160727 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(160763), // Rule ID 382 //
     /* 160732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160754 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 160757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160761 */     GIR_RootConstrainSelectedInstOperands,
     /* 160762 */     // GIR_Coverage, 382,
     /* 160762 */     GIR_EraseRootFromParent_Done,
     /* 160763 */   // Label 2955: @160763
     /* 160763 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(160799), // Rule ID 383 //
     /* 160768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160790 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 160790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 160793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160797 */     GIR_RootConstrainSelectedInstOperands,
     /* 160798 */     // GIR_Coverage, 383,
     /* 160798 */     GIR_EraseRootFromParent_Done,
     /* 160799 */   // Label 2956: @160799
     /* 160799 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(160835), // Rule ID 384 //
     /* 160804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160826 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 160826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 160829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160833 */     GIR_RootConstrainSelectedInstOperands,
     /* 160834 */     // GIR_Coverage, 384,
     /* 160834 */     GIR_EraseRootFromParent_Done,
     /* 160835 */   // Label 2957: @160835
     /* 160835 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(160871), // Rule ID 385 //
     /* 160840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160862 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 160862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 160865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160869 */     GIR_RootConstrainSelectedInstOperands,
     /* 160870 */     // GIR_Coverage, 385,
     /* 160870 */     GIR_EraseRootFromParent_Done,
     /* 160871 */   // Label 2958: @160871
     /* 160871 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(160907), // Rule ID 386 //
     /* 160876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160898 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 160898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 160901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160905 */     GIR_RootConstrainSelectedInstOperands,
     /* 160906 */     // GIR_Coverage, 386,
     /* 160906 */     GIR_EraseRootFromParent_Done,
     /* 160907 */   // Label 2959: @160907
     /* 160907 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(160943), // Rule ID 387 //
     /* 160912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 160915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 160920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160934 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 160934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 160937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160941 */     GIR_RootConstrainSelectedInstOperands,
     /* 160942 */     // GIR_Coverage, 387,
     /* 160942 */     GIR_EraseRootFromParent_Done,
     /* 160943 */   // Label 2960: @160943
     /* 160943 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(160979), // Rule ID 388 //
     /* 160948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 160956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 160966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160970 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 160970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 160973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160977 */     GIR_RootConstrainSelectedInstOperands,
     /* 160978 */     // GIR_Coverage, 388,
     /* 160978 */     GIR_EraseRootFromParent_Done,
     /* 160979 */   // Label 2961: @160979
     /* 160979 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(161015), // Rule ID 389 //
     /* 160984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 160987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 160992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161006 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 161009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161013 */     GIR_RootConstrainSelectedInstOperands,
     /* 161014 */     // GIR_Coverage, 389,
     /* 161014 */     GIR_EraseRootFromParent_Done,
     /* 161015 */   // Label 2962: @161015
     /* 161015 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(161051), // Rule ID 390 //
     /* 161020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161042 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 161045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161049 */     GIR_RootConstrainSelectedInstOperands,
     /* 161050 */     // GIR_Coverage, 390,
     /* 161050 */     GIR_EraseRootFromParent_Done,
     /* 161051 */   // Label 2963: @161051
     /* 161051 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(161087), // Rule ID 391 //
     /* 161056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161078 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 161081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161085 */     GIR_RootConstrainSelectedInstOperands,
     /* 161086 */     // GIR_Coverage, 391,
     /* 161086 */     GIR_EraseRootFromParent_Done,
     /* 161087 */   // Label 2964: @161087
     /* 161087 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(161123), // Rule ID 392 //
     /* 161092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161114 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 161117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161121 */     GIR_RootConstrainSelectedInstOperands,
     /* 161122 */     // GIR_Coverage, 392,
     /* 161122 */     GIR_EraseRootFromParent_Done,
     /* 161123 */   // Label 2965: @161123
     /* 161123 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(161159), // Rule ID 393 //
     /* 161128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 161136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161150 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 161153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161157 */     GIR_RootConstrainSelectedInstOperands,
     /* 161158 */     // GIR_Coverage, 393,
     /* 161158 */     GIR_EraseRootFromParent_Done,
     /* 161159 */   // Label 2966: @161159
     /* 161159 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(161195), // Rule ID 575 //
     /* 161164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 161172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161186 */     // (intrinsic_wo_chain:{ *:[f32] } 548:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 161186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 161189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161193 */     GIR_RootConstrainSelectedInstOperands,
     /* 161194 */     // GIR_Coverage, 575,
     /* 161194 */     GIR_EraseRootFromParent_Done,
     /* 161195 */   // Label 2967: @161195
     /* 161195 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(161231), // Rule ID 576 //
     /* 161200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 161208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161222 */     // (intrinsic_wo_chain:{ *:[f64] } 548:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 161222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 161225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161229 */     GIR_RootConstrainSelectedInstOperands,
     /* 161230 */     // GIR_Coverage, 576,
     /* 161230 */     GIR_EraseRootFromParent_Done,
     /* 161231 */   // Label 2968: @161231
     /* 161231 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(161267), // Rule ID 577 //
     /* 161236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 161244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161258 */     // (intrinsic_wo_chain:{ *:[f32] } 550:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 161258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 161261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161265 */     GIR_RootConstrainSelectedInstOperands,
     /* 161266 */     // GIR_Coverage, 577,
     /* 161266 */     GIR_EraseRootFromParent_Done,
     /* 161267 */   // Label 2969: @161267
     /* 161267 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(161303), // Rule ID 578 //
     /* 161272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 161280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161294 */     // (intrinsic_wo_chain:{ *:[f64] } 550:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 161294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 161297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161301 */     GIR_RootConstrainSelectedInstOperands,
     /* 161302 */     // GIR_Coverage, 578,
     /* 161302 */     GIR_EraseRootFromParent_Done,
     /* 161303 */   // Label 2970: @161303
     /* 161303 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(161339), // Rule ID 579 //
     /* 161308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 161316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161330 */     // (intrinsic_wo_chain:{ *:[f32] } 547:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 161330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 161333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161337 */     GIR_RootConstrainSelectedInstOperands,
     /* 161338 */     // GIR_Coverage, 579,
     /* 161338 */     GIR_EraseRootFromParent_Done,
     /* 161339 */   // Label 2971: @161339
     /* 161339 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(161375), // Rule ID 580 //
     /* 161344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 161352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161366 */     // (intrinsic_wo_chain:{ *:[f64] } 547:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 161366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 161369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161373 */     GIR_RootConstrainSelectedInstOperands,
     /* 161374 */     // GIR_Coverage, 580,
     /* 161374 */     GIR_EraseRootFromParent_Done,
     /* 161375 */   // Label 2972: @161375
     /* 161375 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(161411), // Rule ID 581 //
     /* 161380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 161388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161402 */     // (intrinsic_wo_chain:{ *:[f32] } 549:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 161402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 161405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161409 */     GIR_RootConstrainSelectedInstOperands,
     /* 161410 */     // GIR_Coverage, 581,
     /* 161410 */     GIR_EraseRootFromParent_Done,
     /* 161411 */   // Label 2973: @161411
     /* 161411 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(161447), // Rule ID 582 //
     /* 161416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 161419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 161424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161438 */     // (intrinsic_wo_chain:{ *:[f64] } 549:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 161438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 161441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161445 */     GIR_RootConstrainSelectedInstOperands,
     /* 161446 */     // GIR_Coverage, 582,
     /* 161446 */     GIR_EraseRootFromParent_Done,
     /* 161447 */   // Label 2974: @161447
     /* 161447 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(161483), // Rule ID 710 //
     /* 161452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 161463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 161466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161474 */     // (intrinsic_wo_chain:{ *:[v8i8] } 575:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 161474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 161477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161481 */     GIR_RootConstrainSelectedInstOperands,
     /* 161482 */     // GIR_Coverage, 710,
     /* 161482 */     GIR_EraseRootFromParent_Done,
     /* 161483 */   // Label 2975: @161483
     /* 161483 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(161519), // Rule ID 711 //
     /* 161488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 161499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161510 */     // (intrinsic_wo_chain:{ *:[v16i8] } 575:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 161510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 161513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161517 */     GIR_RootConstrainSelectedInstOperands,
     /* 161518 */     // GIR_Coverage, 711,
     /* 161518 */     GIR_EraseRootFromParent_Done,
     /* 161519 */   // Label 2976: @161519
     /* 161519 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(161555), // Rule ID 712 //
     /* 161524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161546 */     // (intrinsic_wo_chain:{ *:[v4i16] } 575:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 161546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 161549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161553 */     GIR_RootConstrainSelectedInstOperands,
     /* 161554 */     // GIR_Coverage, 712,
     /* 161554 */     GIR_EraseRootFromParent_Done,
     /* 161555 */   // Label 2977: @161555
     /* 161555 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(161591), // Rule ID 713 //
     /* 161560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161582 */     // (intrinsic_wo_chain:{ *:[v8i16] } 575:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 161582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 161585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161589 */     GIR_RootConstrainSelectedInstOperands,
     /* 161590 */     // GIR_Coverage, 713,
     /* 161590 */     GIR_EraseRootFromParent_Done,
     /* 161591 */   // Label 2978: @161591
     /* 161591 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(161627), // Rule ID 714 //
     /* 161596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161618 */     // (intrinsic_wo_chain:{ *:[v2i32] } 575:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 161618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 161621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161625 */     GIR_RootConstrainSelectedInstOperands,
     /* 161626 */     // GIR_Coverage, 714,
     /* 161626 */     GIR_EraseRootFromParent_Done,
     /* 161627 */   // Label 2979: @161627
     /* 161627 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(161663), // Rule ID 715 //
     /* 161632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 161640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161654 */     // (intrinsic_wo_chain:{ *:[v4i32] } 575:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 161654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 161657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161661 */     GIR_RootConstrainSelectedInstOperands,
     /* 161662 */     // GIR_Coverage, 715,
     /* 161662 */     GIR_EraseRootFromParent_Done,
     /* 161663 */   // Label 2980: @161663
     /* 161663 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(161699), // Rule ID 796 //
     /* 161668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161690 */     // (intrinsic_wo_chain:{ *:[v4i16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 161690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 161693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161697 */     GIR_RootConstrainSelectedInstOperands,
     /* 161698 */     // GIR_Coverage, 796,
     /* 161698 */     GIR_EraseRootFromParent_Done,
     /* 161699 */   // Label 2981: @161699
     /* 161699 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(161735), // Rule ID 797 //
     /* 161704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161726 */     // (intrinsic_wo_chain:{ *:[v8i16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 161726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 161729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161733 */     GIR_RootConstrainSelectedInstOperands,
     /* 161734 */     // GIR_Coverage, 797,
     /* 161734 */     GIR_EraseRootFromParent_Done,
     /* 161735 */   // Label 2982: @161735
     /* 161735 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(161771), // Rule ID 798 //
     /* 161740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161762 */     // (intrinsic_wo_chain:{ *:[v2i32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 161762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 161765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161769 */     GIR_RootConstrainSelectedInstOperands,
     /* 161770 */     // GIR_Coverage, 798,
     /* 161770 */     GIR_EraseRootFromParent_Done,
     /* 161771 */   // Label 2983: @161771
     /* 161771 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(161807), // Rule ID 799 //
     /* 161776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161798 */     // (intrinsic_wo_chain:{ *:[v4i32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 161798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 161801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161805 */     GIR_RootConstrainSelectedInstOperands,
     /* 161806 */     // GIR_Coverage, 799,
     /* 161806 */     GIR_EraseRootFromParent_Done,
     /* 161807 */   // Label 2984: @161807
     /* 161807 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(161843), // Rule ID 800 //
     /* 161812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161834 */     // (intrinsic_wo_chain:{ *:[v2i64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 161834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 161837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161841 */     GIR_RootConstrainSelectedInstOperands,
     /* 161842 */     // GIR_Coverage, 800,
     /* 161842 */     GIR_EraseRootFromParent_Done,
     /* 161843 */   // Label 2985: @161843
     /* 161843 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(161879), // Rule ID 801 //
     /* 161848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 161859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 161862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161870 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 161870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 161873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161877 */     GIR_RootConstrainSelectedInstOperands,
     /* 161878 */     // GIR_Coverage, 801,
     /* 161878 */     GIR_EraseRootFromParent_Done,
     /* 161879 */   // Label 2986: @161879
     /* 161879 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(161915), // Rule ID 802 //
     /* 161884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 161895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161906 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 161906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 161909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161913 */     GIR_RootConstrainSelectedInstOperands,
     /* 161914 */     // GIR_Coverage, 802,
     /* 161914 */     GIR_EraseRootFromParent_Done,
     /* 161915 */   // Label 2987: @161915
     /* 161915 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(161951), // Rule ID 803 //
     /* 161920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161942 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 161942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 161945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161949 */     GIR_RootConstrainSelectedInstOperands,
     /* 161950 */     // GIR_Coverage, 803,
     /* 161950 */     GIR_EraseRootFromParent_Done,
     /* 161951 */   // Label 2988: @161951
     /* 161951 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(161987), // Rule ID 804 //
     /* 161956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161978 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 161978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 161981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161985 */     GIR_RootConstrainSelectedInstOperands,
     /* 161986 */     // GIR_Coverage, 804,
     /* 161986 */     GIR_EraseRootFromParent_Done,
     /* 161987 */   // Label 2989: @161987
     /* 161987 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(162023), // Rule ID 805 //
     /* 161992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 162000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162014 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 162017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162021 */     GIR_RootConstrainSelectedInstOperands,
     /* 162022 */     // GIR_Coverage, 805,
     /* 162022 */     GIR_EraseRootFromParent_Done,
     /* 162023 */   // Label 2990: @162023
     /* 162023 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(162059), // Rule ID 806 //
     /* 162028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162050 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 162053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162057 */     GIR_RootConstrainSelectedInstOperands,
     /* 162058 */     // GIR_Coverage, 806,
     /* 162058 */     GIR_EraseRootFromParent_Done,
     /* 162059 */   // Label 2991: @162059
     /* 162059 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(162095), // Rule ID 807 //
     /* 162064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162086 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 162089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162093 */     GIR_RootConstrainSelectedInstOperands,
     /* 162094 */     // GIR_Coverage, 807,
     /* 162094 */     GIR_EraseRootFromParent_Done,
     /* 162095 */   // Label 2992: @162095
     /* 162095 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(162131), // Rule ID 808 //
     /* 162100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162122 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 162125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162129 */     GIR_RootConstrainSelectedInstOperands,
     /* 162130 */     // GIR_Coverage, 808,
     /* 162130 */     GIR_EraseRootFromParent_Done,
     /* 162131 */   // Label 2993: @162131
     /* 162131 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(162167), // Rule ID 809 //
     /* 162136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162158 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 162161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162165 */     GIR_RootConstrainSelectedInstOperands,
     /* 162166 */     // GIR_Coverage, 809,
     /* 162166 */     GIR_EraseRootFromParent_Done,
     /* 162167 */   // Label 2994: @162167
     /* 162167 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(162203), // Rule ID 810 //
     /* 162172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 162180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162194 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 162197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162201 */     GIR_RootConstrainSelectedInstOperands,
     /* 162202 */     // GIR_Coverage, 810,
     /* 162202 */     GIR_EraseRootFromParent_Done,
     /* 162203 */   // Label 2995: @162203
     /* 162203 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(162239), // Rule ID 811 //
     /* 162208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162230 */     // (intrinsic_wo_chain:{ *:[v4i16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 162233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162237 */     GIR_RootConstrainSelectedInstOperands,
     /* 162238 */     // GIR_Coverage, 811,
     /* 162238 */     GIR_EraseRootFromParent_Done,
     /* 162239 */   // Label 2996: @162239
     /* 162239 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(162275), // Rule ID 812 //
     /* 162244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162266 */     // (intrinsic_wo_chain:{ *:[v8i16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 162269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162273 */     GIR_RootConstrainSelectedInstOperands,
     /* 162274 */     // GIR_Coverage, 812,
     /* 162274 */     GIR_EraseRootFromParent_Done,
     /* 162275 */   // Label 2997: @162275
     /* 162275 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(162311), // Rule ID 813 //
     /* 162280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162302 */     // (intrinsic_wo_chain:{ *:[v2i32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 162305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162309 */     GIR_RootConstrainSelectedInstOperands,
     /* 162310 */     // GIR_Coverage, 813,
     /* 162310 */     GIR_EraseRootFromParent_Done,
     /* 162311 */   // Label 2998: @162311
     /* 162311 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(162347), // Rule ID 814 //
     /* 162316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162338 */     // (intrinsic_wo_chain:{ *:[v4i32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 162341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162345 */     GIR_RootConstrainSelectedInstOperands,
     /* 162346 */     // GIR_Coverage, 814,
     /* 162346 */     GIR_EraseRootFromParent_Done,
     /* 162347 */   // Label 2999: @162347
     /* 162347 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(162383), // Rule ID 815 //
     /* 162352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 162360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162374 */     // (intrinsic_wo_chain:{ *:[v2i64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 162377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162381 */     GIR_RootConstrainSelectedInstOperands,
     /* 162382 */     // GIR_Coverage, 815,
     /* 162382 */     GIR_EraseRootFromParent_Done,
     /* 162383 */   // Label 3000: @162383
     /* 162383 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(162419), // Rule ID 816 //
     /* 162388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162410 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 162413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162417 */     GIR_RootConstrainSelectedInstOperands,
     /* 162418 */     // GIR_Coverage, 816,
     /* 162418 */     GIR_EraseRootFromParent_Done,
     /* 162419 */   // Label 3001: @162419
     /* 162419 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(162455), // Rule ID 817 //
     /* 162424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162446 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 162449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162453 */     GIR_RootConstrainSelectedInstOperands,
     /* 162454 */     // GIR_Coverage, 817,
     /* 162454 */     GIR_EraseRootFromParent_Done,
     /* 162455 */   // Label 3002: @162455
     /* 162455 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(162491), // Rule ID 818 //
     /* 162460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162482 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 162485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162489 */     GIR_RootConstrainSelectedInstOperands,
     /* 162490 */     // GIR_Coverage, 818,
     /* 162490 */     GIR_EraseRootFromParent_Done,
     /* 162491 */   // Label 3003: @162491
     /* 162491 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(162527), // Rule ID 819 //
     /* 162496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162518 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 162521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162525 */     GIR_RootConstrainSelectedInstOperands,
     /* 162526 */     // GIR_Coverage, 819,
     /* 162526 */     GIR_EraseRootFromParent_Done,
     /* 162527 */   // Label 3004: @162527
     /* 162527 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(162563), // Rule ID 820 //
     /* 162532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162554 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 162557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162561 */     GIR_RootConstrainSelectedInstOperands,
     /* 162562 */     // GIR_Coverage, 820,
     /* 162562 */     GIR_EraseRootFromParent_Done,
     /* 162563 */   // Label 3005: @162563
     /* 162563 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(162599), // Rule ID 821 //
     /* 162568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162590 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 162593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162597 */     GIR_RootConstrainSelectedInstOperands,
     /* 162598 */     // GIR_Coverage, 821,
     /* 162598 */     GIR_EraseRootFromParent_Done,
     /* 162599 */   // Label 3006: @162599
     /* 162599 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(162635), // Rule ID 822 //
     /* 162604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162626 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 162629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162633 */     GIR_RootConstrainSelectedInstOperands,
     /* 162634 */     // GIR_Coverage, 822,
     /* 162634 */     GIR_EraseRootFromParent_Done,
     /* 162635 */   // Label 3007: @162635
     /* 162635 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(162671), // Rule ID 823 //
     /* 162640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162662 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 162665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162669 */     GIR_RootConstrainSelectedInstOperands,
     /* 162670 */     // GIR_Coverage, 823,
     /* 162670 */     GIR_EraseRootFromParent_Done,
     /* 162671 */   // Label 3008: @162671
     /* 162671 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(162707), // Rule ID 824 //
     /* 162676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162698 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 162701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162705 */     GIR_RootConstrainSelectedInstOperands,
     /* 162706 */     // GIR_Coverage, 824,
     /* 162706 */     GIR_EraseRootFromParent_Done,
     /* 162707 */   // Label 3009: @162707
     /* 162707 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(162743), // Rule ID 825 //
     /* 162712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162734 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 162737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162741 */     GIR_RootConstrainSelectedInstOperands,
     /* 162742 */     // GIR_Coverage, 825,
     /* 162742 */     GIR_EraseRootFromParent_Done,
     /* 162743 */   // Label 3010: @162743
     /* 162743 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(162779), // Rule ID 826 //
     /* 162748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162770 */     // (intrinsic_wo_chain:{ *:[v4i16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 162773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162777 */     GIR_RootConstrainSelectedInstOperands,
     /* 162778 */     // GIR_Coverage, 826,
     /* 162778 */     GIR_EraseRootFromParent_Done,
     /* 162779 */   // Label 3011: @162779
     /* 162779 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(162815), // Rule ID 827 //
     /* 162784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162806 */     // (intrinsic_wo_chain:{ *:[v8i16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 162809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162813 */     GIR_RootConstrainSelectedInstOperands,
     /* 162814 */     // GIR_Coverage, 827,
     /* 162814 */     GIR_EraseRootFromParent_Done,
     /* 162815 */   // Label 3012: @162815
     /* 162815 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(162851), // Rule ID 828 //
     /* 162820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 162834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162842 */     // (intrinsic_wo_chain:{ *:[v2i32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 162842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 162845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162849 */     GIR_RootConstrainSelectedInstOperands,
     /* 162850 */     // GIR_Coverage, 828,
     /* 162850 */     GIR_EraseRootFromParent_Done,
     /* 162851 */   // Label 3013: @162851
     /* 162851 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(162887), // Rule ID 829 //
     /* 162856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 162867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162878 */     // (intrinsic_wo_chain:{ *:[v4i32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 162878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 162881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162885 */     GIR_RootConstrainSelectedInstOperands,
     /* 162886 */     // GIR_Coverage, 829,
     /* 162886 */     GIR_EraseRootFromParent_Done,
     /* 162887 */   // Label 3014: @162887
     /* 162887 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(162923), // Rule ID 830 //
     /* 162892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 162903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162914 */     // (intrinsic_wo_chain:{ *:[v2i64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 162914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 162917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162921 */     GIR_RootConstrainSelectedInstOperands,
     /* 162922 */     // GIR_Coverage, 830,
     /* 162922 */     GIR_EraseRootFromParent_Done,
     /* 162923 */   // Label 3015: @162923
     /* 162923 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(162959), // Rule ID 831 //
     /* 162928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 162942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162950 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 162950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 162953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162957 */     GIR_RootConstrainSelectedInstOperands,
     /* 162958 */     // GIR_Coverage, 831,
     /* 162958 */     GIR_EraseRootFromParent_Done,
     /* 162959 */   // Label 3016: @162959
     /* 162959 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(162995), // Rule ID 832 //
     /* 162964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 162967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 162975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162986 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 162986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 162989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162993 */     GIR_RootConstrainSelectedInstOperands,
     /* 162994 */     // GIR_Coverage, 832,
     /* 162994 */     GIR_EraseRootFromParent_Done,
     /* 162995 */   // Label 3017: @162995
     /* 162995 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(163031), // Rule ID 833 //
     /* 163000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163022 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 163025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163029 */     GIR_RootConstrainSelectedInstOperands,
     /* 163030 */     // GIR_Coverage, 833,
     /* 163030 */     GIR_EraseRootFromParent_Done,
     /* 163031 */   // Label 3018: @163031
     /* 163031 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(163067), // Rule ID 834 //
     /* 163036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163058 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 163061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163065 */     GIR_RootConstrainSelectedInstOperands,
     /* 163066 */     // GIR_Coverage, 834,
     /* 163066 */     GIR_EraseRootFromParent_Done,
     /* 163067 */   // Label 3019: @163067
     /* 163067 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(163103), // Rule ID 835 //
     /* 163072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 163080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163094 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 163097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163101 */     GIR_RootConstrainSelectedInstOperands,
     /* 163102 */     // GIR_Coverage, 835,
     /* 163102 */     GIR_EraseRootFromParent_Done,
     /* 163103 */   // Label 3020: @163103
     /* 163103 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(163139), // Rule ID 836 //
     /* 163108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 163116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163130 */     // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 163130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 163133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163137 */     GIR_RootConstrainSelectedInstOperands,
     /* 163138 */     // GIR_Coverage, 836,
     /* 163138 */     GIR_EraseRootFromParent_Done,
     /* 163139 */   // Label 3021: @163139
     /* 163139 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(163175), // Rule ID 863 //
     /* 163144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163166 */     // (intrinsic_wo_chain:{ *:[v4f16] } 632:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 163166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 163169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163173 */     GIR_RootConstrainSelectedInstOperands,
     /* 163174 */     // GIR_Coverage, 863,
     /* 163174 */     GIR_EraseRootFromParent_Done,
     /* 163175 */   // Label 3022: @163175
     /* 163175 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(163211), // Rule ID 864 //
     /* 163180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163202 */     // (intrinsic_wo_chain:{ *:[v8f16] } 632:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 163202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 163205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163209 */     GIR_RootConstrainSelectedInstOperands,
     /* 163210 */     // GIR_Coverage, 864,
     /* 163210 */     GIR_EraseRootFromParent_Done,
     /* 163211 */   // Label 3023: @163211
     /* 163211 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(163247), // Rule ID 865 //
     /* 163216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163238 */     // (intrinsic_wo_chain:{ *:[v2f32] } 632:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 163241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163245 */     GIR_RootConstrainSelectedInstOperands,
     /* 163246 */     // GIR_Coverage, 865,
     /* 163246 */     GIR_EraseRootFromParent_Done,
     /* 163247 */   // Label 3024: @163247
     /* 163247 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(163283), // Rule ID 866 //
     /* 163252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163274 */     // (intrinsic_wo_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 163277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163281 */     GIR_RootConstrainSelectedInstOperands,
     /* 163282 */     // GIR_Coverage, 866,
     /* 163282 */     GIR_EraseRootFromParent_Done,
     /* 163283 */   // Label 3025: @163283
     /* 163283 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(163319), // Rule ID 867 //
     /* 163288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 163296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163310 */     // (intrinsic_wo_chain:{ *:[v2f64] } 632:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 163313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163317 */     GIR_RootConstrainSelectedInstOperands,
     /* 163318 */     // GIR_Coverage, 867,
     /* 163318 */     GIR_EraseRootFromParent_Done,
     /* 163319 */   // Label 3026: @163319
     /* 163319 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(163355), // Rule ID 938 //
     /* 163324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 163332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163346 */     // (intrinsic_wo_chain:{ *:[v2f32] } 636:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 163349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163353 */     GIR_RootConstrainSelectedInstOperands,
     /* 163354 */     // GIR_Coverage, 938,
     /* 163354 */     GIR_EraseRootFromParent_Done,
     /* 163355 */   // Label 3027: @163355
     /* 163355 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(163391), // Rule ID 939 //
     /* 163360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 163368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163382 */     // (intrinsic_wo_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 163385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163389 */     GIR_RootConstrainSelectedInstOperands,
     /* 163390 */     // GIR_Coverage, 939,
     /* 163390 */     GIR_EraseRootFromParent_Done,
     /* 163391 */   // Label 3028: @163391
     /* 163391 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(163427), // Rule ID 940 //
     /* 163396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 163404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163418 */     // (intrinsic_wo_chain:{ *:[v2f64] } 636:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 163421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163425 */     GIR_RootConstrainSelectedInstOperands,
     /* 163426 */     // GIR_Coverage, 940,
     /* 163426 */     GIR_EraseRootFromParent_Done,
     /* 163427 */   // Label 3029: @163427
     /* 163427 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(163463), // Rule ID 941 //
     /* 163432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 163440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163454 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 163457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163461 */     GIR_RootConstrainSelectedInstOperands,
     /* 163462 */     // GIR_Coverage, 941,
     /* 163462 */     GIR_EraseRootFromParent_Done,
     /* 163463 */   // Label 3030: @163463
     /* 163463 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(163499), // Rule ID 942 //
     /* 163468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 163476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163490 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 163493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163497 */     GIR_RootConstrainSelectedInstOperands,
     /* 163498 */     // GIR_Coverage, 942,
     /* 163498 */     GIR_EraseRootFromParent_Done,
     /* 163499 */   // Label 3031: @163499
     /* 163499 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(163535), // Rule ID 943 //
     /* 163504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 163512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163526 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 163529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163533 */     GIR_RootConstrainSelectedInstOperands,
     /* 163534 */     // GIR_Coverage, 943,
     /* 163534 */     GIR_EraseRootFromParent_Done,
     /* 163535 */   // Label 3032: @163535
     /* 163535 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(163571), // Rule ID 944 //
     /* 163540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 163548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163562 */     // (intrinsic_wo_chain:{ *:[v2f32] } 635:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 163565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163569 */     GIR_RootConstrainSelectedInstOperands,
     /* 163570 */     // GIR_Coverage, 944,
     /* 163570 */     GIR_EraseRootFromParent_Done,
     /* 163571 */   // Label 3033: @163571
     /* 163571 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(163607), // Rule ID 945 //
     /* 163576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 163584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163598 */     // (intrinsic_wo_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 163601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163605 */     GIR_RootConstrainSelectedInstOperands,
     /* 163606 */     // GIR_Coverage, 945,
     /* 163606 */     GIR_EraseRootFromParent_Done,
     /* 163607 */   // Label 3034: @163607
     /* 163607 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(163643), // Rule ID 946 //
     /* 163612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 163620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163634 */     // (intrinsic_wo_chain:{ *:[v2f64] } 635:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 163637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163641 */     GIR_RootConstrainSelectedInstOperands,
     /* 163642 */     // GIR_Coverage, 946,
     /* 163642 */     GIR_EraseRootFromParent_Done,
     /* 163643 */   // Label 3035: @163643
     /* 163643 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(163679), // Rule ID 947 //
     /* 163648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 163656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163670 */     // (intrinsic_wo_chain:{ *:[v2f32] } 637:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 163673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163677 */     GIR_RootConstrainSelectedInstOperands,
     /* 163678 */     // GIR_Coverage, 947,
     /* 163678 */     GIR_EraseRootFromParent_Done,
     /* 163679 */   // Label 3036: @163679
     /* 163679 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(163715), // Rule ID 948 //
     /* 163684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 163692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163706 */     // (intrinsic_wo_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 163709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163713 */     GIR_RootConstrainSelectedInstOperands,
     /* 163714 */     // GIR_Coverage, 948,
     /* 163714 */     GIR_EraseRootFromParent_Done,
     /* 163715 */   // Label 3037: @163715
     /* 163715 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(163751), // Rule ID 949 //
     /* 163720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 163728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163742 */     // (intrinsic_wo_chain:{ *:[v2f64] } 637:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 163745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163749 */     GIR_RootConstrainSelectedInstOperands,
     /* 163750 */     // GIR_Coverage, 949,
     /* 163750 */     GIR_EraseRootFromParent_Done,
     /* 163751 */   // Label 3038: @163751
     /* 163751 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(163787), // Rule ID 950 //
     /* 163756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163778 */     // (intrinsic_wo_chain:{ *:[v4f16] } 639:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 163778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 163781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163785 */     GIR_RootConstrainSelectedInstOperands,
     /* 163786 */     // GIR_Coverage, 950,
     /* 163786 */     GIR_EraseRootFromParent_Done,
     /* 163787 */   // Label 3039: @163787
     /* 163787 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(163823), // Rule ID 951 //
     /* 163792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163814 */     // (intrinsic_wo_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 163814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 163817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163821 */     GIR_RootConstrainSelectedInstOperands,
     /* 163822 */     // GIR_Coverage, 951,
     /* 163822 */     GIR_EraseRootFromParent_Done,
     /* 163823 */   // Label 3040: @163823
     /* 163823 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(163859), // Rule ID 952 //
     /* 163828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163850 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 163850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 163853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163857 */     GIR_RootConstrainSelectedInstOperands,
     /* 163858 */     // GIR_Coverage, 952,
     /* 163858 */     GIR_EraseRootFromParent_Done,
     /* 163859 */   // Label 3041: @163859
     /* 163859 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(163895), // Rule ID 953 //
     /* 163864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163886 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 163886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 163889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163893 */     GIR_RootConstrainSelectedInstOperands,
     /* 163894 */     // GIR_Coverage, 953,
     /* 163894 */     GIR_EraseRootFromParent_Done,
     /* 163895 */   // Label 3042: @163895
     /* 163895 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(163931), // Rule ID 954 //
     /* 163900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 163908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163922 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 163922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 163925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163929 */     GIR_RootConstrainSelectedInstOperands,
     /* 163930 */     // GIR_Coverage, 954,
     /* 163930 */     GIR_EraseRootFromParent_Done,
     /* 163931 */   // Label 3043: @163931
     /* 163931 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(163967), // Rule ID 1001 //
     /* 163936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 163944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 163950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163958 */     // (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 163958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 163961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163965 */     GIR_RootConstrainSelectedInstOperands,
     /* 163966 */     // GIR_Coverage, 1001,
     /* 163966 */     GIR_EraseRootFromParent_Done,
     /* 163967 */   // Label 3044: @163967
     /* 163967 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(164003), // Rule ID 1003 //
     /* 163972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 163980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 163986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163994 */     // (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 163994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 163997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164001 */     GIR_RootConstrainSelectedInstOperands,
     /* 164002 */     // GIR_Coverage, 1003,
     /* 164002 */     GIR_EraseRootFromParent_Done,
     /* 164003 */   // Label 3045: @164003
     /* 164003 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(164039), // Rule ID 1005 //
     /* 164008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164030 */     // (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 164030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 164033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164037 */     GIR_RootConstrainSelectedInstOperands,
     /* 164038 */     // GIR_Coverage, 1005,
     /* 164038 */     GIR_EraseRootFromParent_Done,
     /* 164039 */   // Label 3046: @164039
     /* 164039 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(164075), // Rule ID 1007 //
     /* 164044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164066 */     // (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 164066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 164069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164073 */     GIR_RootConstrainSelectedInstOperands,
     /* 164074 */     // GIR_Coverage, 1007,
     /* 164074 */     GIR_EraseRootFromParent_Done,
     /* 164075 */   // Label 3047: @164075
     /* 164075 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(164111), // Rule ID 1009 //
     /* 164080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164102 */     // (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 164102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 164105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164109 */     GIR_RootConstrainSelectedInstOperands,
     /* 164110 */     // GIR_Coverage, 1009,
     /* 164110 */     GIR_EraseRootFromParent_Done,
     /* 164111 */   // Label 3048: @164111
     /* 164111 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(164147), // Rule ID 1011 //
     /* 164116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 164124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164138 */     // (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 164138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 164141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164145 */     GIR_RootConstrainSelectedInstOperands,
     /* 164146 */     // GIR_Coverage, 1011,
     /* 164146 */     GIR_EraseRootFromParent_Done,
     /* 164147 */   // Label 3049: @164147
     /* 164147 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(164183), // Rule ID 1022 //
     /* 164152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164174 */     // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 164174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 164177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164181 */     GIR_RootConstrainSelectedInstOperands,
     /* 164182 */     // GIR_Coverage, 1022,
     /* 164182 */     GIR_EraseRootFromParent_Done,
     /* 164183 */   // Label 3050: @164183
     /* 164183 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(164219), // Rule ID 1023 //
     /* 164188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 164199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164210 */     // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 164210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 164213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164217 */     GIR_RootConstrainSelectedInstOperands,
     /* 164218 */     // GIR_Coverage, 1023,
     /* 164218 */     GIR_EraseRootFromParent_Done,
     /* 164219 */   // Label 3051: @164219
     /* 164219 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(164255), // Rule ID 1024 //
     /* 164224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164246 */     // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 164246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 164249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164253 */     GIR_RootConstrainSelectedInstOperands,
     /* 164254 */     // GIR_Coverage, 1024,
     /* 164254 */     GIR_EraseRootFromParent_Done,
     /* 164255 */   // Label 3052: @164255
     /* 164255 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(164291), // Rule ID 1025 //
     /* 164260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164282 */     // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 164282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 164285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164289 */     GIR_RootConstrainSelectedInstOperands,
     /* 164290 */     // GIR_Coverage, 1025,
     /* 164290 */     GIR_EraseRootFromParent_Done,
     /* 164291 */   // Label 3053: @164291
     /* 164291 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(164327), // Rule ID 1026 //
     /* 164296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164318 */     // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 164318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 164321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164325 */     GIR_RootConstrainSelectedInstOperands,
     /* 164326 */     // GIR_Coverage, 1026,
     /* 164326 */     GIR_EraseRootFromParent_Done,
     /* 164327 */   // Label 3054: @164327
     /* 164327 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(164363), // Rule ID 1027 //
     /* 164332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164354 */     // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 164354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 164357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164361 */     GIR_RootConstrainSelectedInstOperands,
     /* 164362 */     // GIR_Coverage, 1027,
     /* 164362 */     GIR_EraseRootFromParent_Done,
     /* 164363 */   // Label 3055: @164363
     /* 164363 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(164399), // Rule ID 1028 //
     /* 164368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 164376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164390 */     // (intrinsic_wo_chain:{ *:[v2i64] } 678:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 164390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 164393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164397 */     GIR_RootConstrainSelectedInstOperands,
     /* 164398 */     // GIR_Coverage, 1028,
     /* 164398 */     GIR_EraseRootFromParent_Done,
     /* 164399 */   // Label 3056: @164399
     /* 164399 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(164435), // Rule ID 1029 //
     /* 164404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 164415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164426 */     // (intrinsic_wo_chain:{ *:[v8i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 164426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 164429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164433 */     GIR_RootConstrainSelectedInstOperands,
     /* 164434 */     // GIR_Coverage, 1029,
     /* 164434 */     GIR_EraseRootFromParent_Done,
     /* 164435 */   // Label 3057: @164435
     /* 164435 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(164471), // Rule ID 1030 //
     /* 164440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 164451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164462 */     // (intrinsic_wo_chain:{ *:[v16i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 164462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 164465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164469 */     GIR_RootConstrainSelectedInstOperands,
     /* 164470 */     // GIR_Coverage, 1030,
     /* 164470 */     GIR_EraseRootFromParent_Done,
     /* 164471 */   // Label 3058: @164471
     /* 164471 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(164507), // Rule ID 1031 //
     /* 164476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164498 */     // (intrinsic_wo_chain:{ *:[v4i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 164498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 164501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164505 */     GIR_RootConstrainSelectedInstOperands,
     /* 164506 */     // GIR_Coverage, 1031,
     /* 164506 */     GIR_EraseRootFromParent_Done,
     /* 164507 */   // Label 3059: @164507
     /* 164507 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(164543), // Rule ID 1032 //
     /* 164512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164534 */     // (intrinsic_wo_chain:{ *:[v8i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 164534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 164537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164541 */     GIR_RootConstrainSelectedInstOperands,
     /* 164542 */     // GIR_Coverage, 1032,
     /* 164542 */     GIR_EraseRootFromParent_Done,
     /* 164543 */   // Label 3060: @164543
     /* 164543 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(164579), // Rule ID 1033 //
     /* 164548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164570 */     // (intrinsic_wo_chain:{ *:[v2i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 164570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 164573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164577 */     GIR_RootConstrainSelectedInstOperands,
     /* 164578 */     // GIR_Coverage, 1033,
     /* 164578 */     GIR_EraseRootFromParent_Done,
     /* 164579 */   // Label 3061: @164579
     /* 164579 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(164615), // Rule ID 1034 //
     /* 164584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164606 */     // (intrinsic_wo_chain:{ *:[v4i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 164606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 164609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164613 */     GIR_RootConstrainSelectedInstOperands,
     /* 164614 */     // GIR_Coverage, 1034,
     /* 164614 */     GIR_EraseRootFromParent_Done,
     /* 164615 */   // Label 3062: @164615
     /* 164615 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(164651), // Rule ID 1035 //
     /* 164620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 164628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164642 */     // (intrinsic_wo_chain:{ *:[v2i64] } 685:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 164642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 164645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164649 */     GIR_RootConstrainSelectedInstOperands,
     /* 164650 */     // GIR_Coverage, 1035,
     /* 164650 */     GIR_EraseRootFromParent_Done,
     /* 164651 */   // Label 3063: @164651
     /* 164651 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(164687), // Rule ID 1062 //
     /* 164656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 164670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164678 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 164678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 164681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164685 */     GIR_RootConstrainSelectedInstOperands,
     /* 164686 */     // GIR_Coverage, 1062,
     /* 164686 */     GIR_EraseRootFromParent_Done,
     /* 164687 */   // Label 3064: @164687
     /* 164687 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(164723), // Rule ID 1064 //
     /* 164692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 164706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164714 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 164714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 164717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164721 */     GIR_RootConstrainSelectedInstOperands,
     /* 164722 */     // GIR_Coverage, 1064,
     /* 164722 */     GIR_EraseRootFromParent_Done,
     /* 164723 */   // Label 3065: @164723
     /* 164723 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(164759), // Rule ID 1066 //
     /* 164728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164750 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 164750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 164753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164757 */     GIR_RootConstrainSelectedInstOperands,
     /* 164758 */     // GIR_Coverage, 1066,
     /* 164758 */     GIR_EraseRootFromParent_Done,
     /* 164759 */   // Label 3066: @164759
     /* 164759 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(164795), // Rule ID 1068 //
     /* 164764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164786 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 164786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 164789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164793 */     GIR_RootConstrainSelectedInstOperands,
     /* 164794 */     // GIR_Coverage, 1068,
     /* 164794 */     GIR_EraseRootFromParent_Done,
     /* 164795 */   // Label 3067: @164795
     /* 164795 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(164831), // Rule ID 1070 //
     /* 164800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164822 */     // (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 164822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 164825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164829 */     GIR_RootConstrainSelectedInstOperands,
     /* 164830 */     // GIR_Coverage, 1070,
     /* 164830 */     GIR_EraseRootFromParent_Done,
     /* 164831 */   // Label 3068: @164831
     /* 164831 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(164867), // Rule ID 1072 //
     /* 164836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 164844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164858 */     // (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 164858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 164861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164865 */     GIR_RootConstrainSelectedInstOperands,
     /* 164866 */     // GIR_Coverage, 1072,
     /* 164866 */     GIR_EraseRootFromParent_Done,
     /* 164867 */   // Label 3069: @164867
     /* 164867 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(164903), // Rule ID 1086 //
     /* 164872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 164880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164894 */     // (intrinsic_wo_chain:{ *:[v2i32] } 746:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 164894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 164897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164901 */     GIR_RootConstrainSelectedInstOperands,
     /* 164902 */     // GIR_Coverage, 1086,
     /* 164902 */     GIR_EraseRootFromParent_Done,
     /* 164903 */   // Label 3070: @164903
     /* 164903 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(164939), // Rule ID 1087 //
     /* 164908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 164916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164930 */     // (intrinsic_wo_chain:{ *:[v4i32] } 746:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 164930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 164933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164937 */     GIR_RootConstrainSelectedInstOperands,
     /* 164938 */     // GIR_Coverage, 1087,
     /* 164938 */     GIR_EraseRootFromParent_Done,
     /* 164939 */   // Label 3071: @164939
     /* 164939 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(164975), // Rule ID 1088 //
     /* 164944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 164952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164966 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 164966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 164969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164973 */     GIR_RootConstrainSelectedInstOperands,
     /* 164974 */     // GIR_Coverage, 1088,
     /* 164974 */     GIR_EraseRootFromParent_Done,
     /* 164975 */   // Label 3072: @164975
     /* 164975 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(165011), // Rule ID 1089 //
     /* 164980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 164988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165002 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 165002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 165005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165009 */     GIR_RootConstrainSelectedInstOperands,
     /* 165010 */     // GIR_Coverage, 1089,
     /* 165010 */     GIR_EraseRootFromParent_Done,
     /* 165011 */   // Label 3073: @165011
     /* 165011 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(165047), // Rule ID 1653 //
     /* 165016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 165024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165038 */     // (intrinsic_wo_chain:{ *:[f32] } 786:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 165038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 165041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165045 */     GIR_RootConstrainSelectedInstOperands,
     /* 165046 */     // GIR_Coverage, 1653,
     /* 165046 */     GIR_EraseRootFromParent_Done,
     /* 165047 */   // Label 3074: @165047
     /* 165047 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(165083), // Rule ID 1659 //
     /* 165052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165074 */     // (intrinsic_wo_chain:{ *:[i64] } 678:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 165074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 165077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165081 */     GIR_RootConstrainSelectedInstOperands,
     /* 165082 */     // GIR_Coverage, 1659,
     /* 165082 */     GIR_EraseRootFromParent_Done,
     /* 165083 */   // Label 3075: @165083
     /* 165083 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(165119), // Rule ID 1660 //
     /* 165088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165110 */     // (intrinsic_wo_chain:{ *:[i32] } 678:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 165110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 165113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165117 */     GIR_RootConstrainSelectedInstOperands,
     /* 165118 */     // GIR_Coverage, 1660,
     /* 165118 */     GIR_EraseRootFromParent_Done,
     /* 165119 */   // Label 3076: @165119
     /* 165119 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(165155), // Rule ID 1661 //
     /* 165124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 165132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165146 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 165146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 165149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165153 */     GIR_RootConstrainSelectedInstOperands,
     /* 165154 */     // GIR_Coverage, 1661,
     /* 165154 */     GIR_EraseRootFromParent_Done,
     /* 165155 */   // Label 3077: @165155
     /* 165155 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(165191), // Rule ID 1662 //
     /* 165160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 165168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165182 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 165182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 165185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165189 */     GIR_RootConstrainSelectedInstOperands,
     /* 165190 */     // GIR_Coverage, 1662,
     /* 165190 */     GIR_EraseRootFromParent_Done,
     /* 165191 */   // Label 3078: @165191
     /* 165191 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(165227), // Rule ID 1663 //
     /* 165196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 165204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165218 */     // (intrinsic_wo_chain:{ *:[f32] } 663:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 165218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 165221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165225 */     GIR_RootConstrainSelectedInstOperands,
     /* 165226 */     // GIR_Coverage, 1663,
     /* 165226 */     GIR_EraseRootFromParent_Done,
     /* 165227 */   // Label 3079: @165227
     /* 165227 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(165263), // Rule ID 1664 //
     /* 165232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 165240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165254 */     // (intrinsic_wo_chain:{ *:[f32] } 664:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 165254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 165257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165261 */     GIR_RootConstrainSelectedInstOperands,
     /* 165262 */     // GIR_Coverage, 1664,
     /* 165262 */     GIR_EraseRootFromParent_Done,
     /* 165263 */   // Label 3080: @165263
     /* 165263 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(165299), // Rule ID 1670 //
     /* 165268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 165276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165290 */     // (intrinsic_wo_chain:{ *:[f32] } 665:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 165290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 165293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165297 */     GIR_RootConstrainSelectedInstOperands,
     /* 165298 */     // GIR_Coverage, 1670,
     /* 165298 */     GIR_EraseRootFromParent_Done,
     /* 165299 */   // Label 3081: @165299
     /* 165299 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(165335), // Rule ID 1943 //
     /* 165304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 165312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165326 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 165329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165333 */     GIR_RootConstrainSelectedInstOperands,
     /* 165334 */     // GIR_Coverage, 1943,
     /* 165334 */     GIR_EraseRootFromParent_Done,
     /* 165335 */   // Label 3082: @165335
     /* 165335 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(165371), // Rule ID 1945 //
     /* 165340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 165348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165362 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 165365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165369 */     GIR_RootConstrainSelectedInstOperands,
     /* 165370 */     // GIR_Coverage, 1945,
     /* 165370 */     GIR_EraseRootFromParent_Done,
     /* 165371 */   // Label 3083: @165371
     /* 165371 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(165407), // Rule ID 1947 //
     /* 165376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 165384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165398 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 165401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165405 */     GIR_RootConstrainSelectedInstOperands,
     /* 165406 */     // GIR_Coverage, 1947,
     /* 165406 */     GIR_EraseRootFromParent_Done,
     /* 165407 */   // Label 3084: @165407
     /* 165407 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(165443), // Rule ID 1949 //
     /* 165412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 165420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165434 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 165437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165441 */     GIR_RootConstrainSelectedInstOperands,
     /* 165442 */     // GIR_Coverage, 1949,
     /* 165442 */     GIR_EraseRootFromParent_Done,
     /* 165443 */   // Label 3085: @165443
     /* 165443 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(165479), // Rule ID 1951 //
     /* 165448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 165456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165470 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 165473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165477 */     GIR_RootConstrainSelectedInstOperands,
     /* 165478 */     // GIR_Coverage, 1951,
     /* 165478 */     GIR_EraseRootFromParent_Done,
     /* 165479 */   // Label 3086: @165479
     /* 165479 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(165515), // Rule ID 1953 //
     /* 165484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 165492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165506 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 165509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165513 */     GIR_RootConstrainSelectedInstOperands,
     /* 165514 */     // GIR_Coverage, 1953,
     /* 165514 */     GIR_EraseRootFromParent_Done,
     /* 165515 */   // Label 3087: @165515
     /* 165515 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(165551), // Rule ID 1955 //
     /* 165520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 165528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165542 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 165545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165549 */     GIR_RootConstrainSelectedInstOperands,
     /* 165550 */     // GIR_Coverage, 1955,
     /* 165550 */     GIR_EraseRootFromParent_Done,
     /* 165551 */   // Label 3088: @165551
     /* 165551 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(165587), // Rule ID 1957 //
     /* 165556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 165564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165578 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 165581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165585 */     GIR_RootConstrainSelectedInstOperands,
     /* 165586 */     // GIR_Coverage, 1957,
     /* 165586 */     GIR_EraseRootFromParent_Done,
     /* 165587 */   // Label 3089: @165587
     /* 165587 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(165623), // Rule ID 1959 //
     /* 165592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 165600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165614 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 165617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165621 */     GIR_RootConstrainSelectedInstOperands,
     /* 165622 */     // GIR_Coverage, 1959,
     /* 165622 */     GIR_EraseRootFromParent_Done,
     /* 165623 */   // Label 3090: @165623
     /* 165623 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(165659), // Rule ID 1961 //
     /* 165628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 165636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165650 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 165653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165657 */     GIR_RootConstrainSelectedInstOperands,
     /* 165658 */     // GIR_Coverage, 1961,
     /* 165658 */     GIR_EraseRootFromParent_Done,
     /* 165659 */   // Label 3091: @165659
     /* 165659 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(165695), // Rule ID 1963 //
     /* 165664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 165672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 165675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 165682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165686 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 165689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165693 */     GIR_RootConstrainSelectedInstOperands,
     /* 165694 */     // GIR_Coverage, 1963,
     /* 165694 */     GIR_EraseRootFromParent_Done,
     /* 165695 */   // Label 3092: @165695
     /* 165695 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(165731), // Rule ID 1965 //
     /* 165700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 165708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165722 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 165725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165729 */     GIR_RootConstrainSelectedInstOperands,
     /* 165730 */     // GIR_Coverage, 1965,
     /* 165730 */     GIR_EraseRootFromParent_Done,
     /* 165731 */   // Label 3093: @165731
     /* 165731 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(165767), // Rule ID 2305 //
     /* 165736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 165739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 165744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165758 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 165758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 165761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165765 */     GIR_RootConstrainSelectedInstOperands,
     /* 165766 */     // GIR_Coverage, 2305,
     /* 165766 */     GIR_EraseRootFromParent_Done,
     /* 165767 */   // Label 3094: @165767
     /* 165767 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(165803), // Rule ID 2306 //
     /* 165772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 165775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 165780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165794 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 165794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 165797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165801 */     GIR_RootConstrainSelectedInstOperands,
     /* 165802 */     // GIR_Coverage, 2306,
     /* 165802 */     GIR_EraseRootFromParent_Done,
     /* 165803 */   // Label 3095: @165803
     /* 165803 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(165839), // Rule ID 2314 //
     /* 165808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 165811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 165816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 165819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 165822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 165830 */     // (intrinsic_wo_chain:{ *:[i32] } 521:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 165830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 165833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165837 */     GIR_RootConstrainSelectedInstOperands,
     /* 165838 */     // GIR_Coverage, 2314,
     /* 165838 */     GIR_EraseRootFromParent_Done,
     /* 165839 */   // Label 3096: @165839
     /* 165839 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(165875), // Rule ID 2515 //
     /* 165844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 165858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165866 */     // (intrinsic_wo_chain:{ *:[v1i64] } 678:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 165866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 165869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165873 */     GIR_RootConstrainSelectedInstOperands,
     /* 165874 */     // GIR_Coverage, 2515,
     /* 165874 */     GIR_EraseRootFromParent_Done,
     /* 165875 */   // Label 3097: @165875
     /* 165875 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(165914), // Rule ID 3548 //
     /* 165880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 165888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 165891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 165894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 165898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165902 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 165902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 165905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 165907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 165909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165912 */     GIR_RootConstrainSelectedInstOperands,
     /* 165913 */     // GIR_Coverage, 3548,
     /* 165913 */     GIR_EraseRootFromParent_Done,
     /* 165914 */   // Label 3098: @165914
     /* 165914 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(165953), // Rule ID 3549 //
     /* 165919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 165927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 165930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 165937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165941 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 165941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 165944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 165946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 165948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165951 */     GIR_RootConstrainSelectedInstOperands,
     /* 165952 */     // GIR_Coverage, 3549,
     /* 165952 */     GIR_EraseRootFromParent_Done,
     /* 165953 */   // Label 3099: @165953
     /* 165953 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(165992), // Rule ID 3550 //
     /* 165958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 165966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 165969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 165976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165980 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 165980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 165983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 165985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 165987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 165990 */     GIR_RootConstrainSelectedInstOperands,
     /* 165991 */     // GIR_Coverage, 3550,
     /* 165991 */     GIR_EraseRootFromParent_Done,
     /* 165992 */   // Label 3100: @165992
     /* 165992 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(166031), // Rule ID 3551 //
     /* 165997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 166005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 166008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 166011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166019 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1627:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 166019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 166022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 166024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 166026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166029 */     GIR_RootConstrainSelectedInstOperands,
     /* 166030 */     // GIR_Coverage, 3551,
     /* 166030 */     GIR_EraseRootFromParent_Done,
     /* 166031 */   // Label 3101: @166031
     /* 166031 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(166087), // Rule ID 3555 //
     /* 166036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 166044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 166047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 166050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166058 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1629:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 166058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 166061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 166075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 166085 */     GIR_RootConstrainSelectedInstOperands,
     /* 166086 */     // GIR_Coverage, 3555,
     /* 166086 */     GIR_EraseRootFromParent_Done,
     /* 166087 */   // Label 3102: @166087
     /* 166087 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(166143), // Rule ID 3556 //
     /* 166092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 166100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 166106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166114 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1629:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 166114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 166117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 166131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 166141 */     GIR_RootConstrainSelectedInstOperands,
     /* 166142 */     // GIR_Coverage, 3556,
     /* 166142 */     GIR_EraseRootFromParent_Done,
     /* 166143 */   // Label 3103: @166143
     /* 166143 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(166199), // Rule ID 3557 //
     /* 166148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 166156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 166162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166170 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1629:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 166170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 166173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 166187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 166197 */     GIR_RootConstrainSelectedInstOperands,
     /* 166198 */     // GIR_Coverage, 3557,
     /* 166198 */     GIR_EraseRootFromParent_Done,
     /* 166199 */   // Label 3104: @166199
     /* 166199 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(166255), // Rule ID 3558 //
     /* 166204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 166207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 166212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 166215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 166218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 166226 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1629:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 166226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 166229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 166233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 166243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 166248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 166251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 166253 */     GIR_RootConstrainSelectedInstOperands,
     /* 166254 */     // GIR_Coverage, 3558,
     /* 166254 */     GIR_EraseRootFromParent_Done,
     /* 166255 */   // Label 3105: @166255
     /* 166255 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(166288), // Rule ID 4009 //
     /* 166260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 166265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166279 */     // (intrinsic_wo_chain:{ *:[i32] } 501:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 166279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 166282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166286 */     GIR_RootConstrainSelectedInstOperands,
     /* 166287 */     // GIR_Coverage, 4009,
     /* 166287 */     GIR_EraseRootFromParent_Done,
     /* 166288 */   // Label 3106: @166288
     /* 166288 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(166353), // Rule ID 4010 //
     /* 166293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 166298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166312 */     // (intrinsic_wo_chain:{ *:[i32] } 502:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 166312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 166315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 166319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 166324 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 166328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 166330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 166333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166335 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 166342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 166347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 166352 */     // GIR_Coverage, 4010,
     /* 166352 */     GIR_EraseRootFromParent_Done,
     /* 166353 */   // Label 3107: @166353
     /* 166353 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(166386), // Rule ID 4816 //
     /* 166358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 166363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166377 */     // (intrinsic_wo_chain:{ *:[v1f64] } 636:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 166380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166384 */     GIR_RootConstrainSelectedInstOperands,
     /* 166385 */     // GIR_Coverage, 4816,
     /* 166385 */     GIR_EraseRootFromParent_Done,
     /* 166386 */   // Label 3108: @166386
     /* 166386 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(166419), // Rule ID 4817 //
     /* 166391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 166396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166410 */     // (intrinsic_wo_chain:{ *:[v1f64] } 638:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 166413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166417 */     GIR_RootConstrainSelectedInstOperands,
     /* 166418 */     // GIR_Coverage, 4817,
     /* 166418 */     GIR_EraseRootFromParent_Done,
     /* 166419 */   // Label 3109: @166419
     /* 166419 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(166452), // Rule ID 4818 //
     /* 166424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 166429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166443 */     // (intrinsic_wo_chain:{ *:[v1f64] } 635:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 166446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166450 */     GIR_RootConstrainSelectedInstOperands,
     /* 166451 */     // GIR_Coverage, 4818,
     /* 166451 */     GIR_EraseRootFromParent_Done,
     /* 166452 */   // Label 3110: @166452
     /* 166452 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(166485), // Rule ID 4819 //
     /* 166457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 166462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166476 */     // (intrinsic_wo_chain:{ *:[v1f64] } 637:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 166479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166483 */     GIR_RootConstrainSelectedInstOperands,
     /* 166484 */     // GIR_Coverage, 4819,
     /* 166484 */     GIR_EraseRootFromParent_Done,
     /* 166485 */   // Label 3111: @166485
     /* 166485 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(166518), // Rule ID 4933 //
     /* 166490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 166495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166509 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 166509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 166512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166516 */     GIR_RootConstrainSelectedInstOperands,
     /* 166517 */     // GIR_Coverage, 4933,
     /* 166517 */     GIR_EraseRootFromParent_Done,
     /* 166518 */   // Label 3112: @166518
     /* 166518 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(166551), // Rule ID 4943 //
     /* 166523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 166528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166542 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 166542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 166545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166549 */     GIR_RootConstrainSelectedInstOperands,
     /* 166550 */     // GIR_Coverage, 4943,
     /* 166550 */     GIR_EraseRootFromParent_Done,
     /* 166551 */   // Label 3113: @166551
     /* 166551 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(166587), // Rule ID 5285 //
     /* 166556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166578 */     // (intrinsic_wo_chain:{ *:[v1i64] } 685:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 166578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 166581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166585 */     GIR_RootConstrainSelectedInstOperands,
     /* 166586 */     // GIR_Coverage, 5285,
     /* 166586 */     GIR_EraseRootFromParent_Done,
     /* 166587 */   // Label 3114: @166587
     /* 166587 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(166620), // Rule ID 5288 //
     /* 166592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 166597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166611 */     // (intrinsic_wo_chain:{ *:[v1i64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 166614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166618 */     GIR_RootConstrainSelectedInstOperands,
     /* 166619 */     // GIR_Coverage, 5288,
     /* 166619 */     GIR_EraseRootFromParent_Done,
     /* 166620 */   // Label 3115: @166620
     /* 166620 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(166653), // Rule ID 5289 //
     /* 166625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 166630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166644 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 166647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166651 */     GIR_RootConstrainSelectedInstOperands,
     /* 166652 */     // GIR_Coverage, 5289,
     /* 166652 */     GIR_EraseRootFromParent_Done,
     /* 166653 */   // Label 3116: @166653
     /* 166653 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(166686), // Rule ID 5290 //
     /* 166658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 166663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166677 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 166680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166684 */     GIR_RootConstrainSelectedInstOperands,
     /* 166685 */     // GIR_Coverage, 5290,
     /* 166685 */     GIR_EraseRootFromParent_Done,
     /* 166686 */   // Label 3117: @166686
     /* 166686 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(166719), // Rule ID 5291 //
     /* 166691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 166696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166710 */     // (intrinsic_wo_chain:{ *:[v1i64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 166713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166717 */     GIR_RootConstrainSelectedInstOperands,
     /* 166718 */     // GIR_Coverage, 5291,
     /* 166718 */     GIR_EraseRootFromParent_Done,
     /* 166719 */   // Label 3118: @166719
     /* 166719 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(166752), // Rule ID 5292 //
     /* 166724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 166729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166743 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 166746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166750 */     GIR_RootConstrainSelectedInstOperands,
     /* 166751 */     // GIR_Coverage, 5292,
     /* 166751 */     GIR_EraseRootFromParent_Done,
     /* 166752 */   // Label 3119: @166752
     /* 166752 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(166785), // Rule ID 5293 //
     /* 166757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 166762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166776 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 166779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166783 */     GIR_RootConstrainSelectedInstOperands,
     /* 166784 */     // GIR_Coverage, 5293,
     /* 166784 */     GIR_EraseRootFromParent_Done,
     /* 166785 */   // Label 3120: @166785
     /* 166785 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(166818), // Rule ID 5294 //
     /* 166790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 166795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166809 */     // (intrinsic_wo_chain:{ *:[v1i64] } 589:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 166812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166816 */     GIR_RootConstrainSelectedInstOperands,
     /* 166817 */     // GIR_Coverage, 5294,
     /* 166817 */     GIR_EraseRootFromParent_Done,
     /* 166818 */   // Label 3121: @166818
     /* 166818 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(166851), // Rule ID 5295 //
     /* 166823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 166828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166842 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 166845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166849 */     GIR_RootConstrainSelectedInstOperands,
     /* 166850 */     // GIR_Coverage, 5295,
     /* 166850 */     GIR_EraseRootFromParent_Done,
     /* 166851 */   // Label 3122: @166851
     /* 166851 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(166884), // Rule ID 5296 //
     /* 166856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 166861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166875 */     // (intrinsic_wo_chain:{ *:[v1i64] } 592:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 166878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166882 */     GIR_RootConstrainSelectedInstOperands,
     /* 166883 */     // GIR_Coverage, 5296,
     /* 166883 */     GIR_EraseRootFromParent_Done,
     /* 166884 */   // Label 3123: @166884
     /* 166884 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(166917), // Rule ID 5297 //
     /* 166889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 166894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166908 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 166908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 166911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166915 */     GIR_RootConstrainSelectedInstOperands,
     /* 166916 */     // GIR_Coverage, 5297,
     /* 166916 */     GIR_EraseRootFromParent_Done,
     /* 166917 */   // Label 3124: @166917
     /* 166917 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(166950), // Rule ID 5298 //
     /* 166922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 166927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 166930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 166933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166941 */     // (intrinsic_wo_chain:{ *:[f16] } 632:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 166941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 166944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166948 */     GIR_RootConstrainSelectedInstOperands,
     /* 166949 */     // GIR_Coverage, 5298,
     /* 166949 */     GIR_EraseRootFromParent_Done,
     /* 166950 */   // Label 3125: @166950
     /* 166950 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(166983), // Rule ID 5299 //
     /* 166955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 166960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166974 */     // (intrinsic_wo_chain:{ *:[f32] } 632:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 166974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 166977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166981 */     GIR_RootConstrainSelectedInstOperands,
     /* 166982 */     // GIR_Coverage, 5299,
     /* 166982 */     GIR_EraseRootFromParent_Done,
     /* 166983 */   // Label 3126: @166983
     /* 166983 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(167016), // Rule ID 5300 //
     /* 166988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 166993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167007 */     // (intrinsic_wo_chain:{ *:[f64] } 632:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 167007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 167010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167014 */     GIR_RootConstrainSelectedInstOperands,
     /* 167015 */     // GIR_Coverage, 5300,
     /* 167015 */     GIR_EraseRootFromParent_Done,
     /* 167016 */   // Label 3127: @167016
     /* 167016 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(167049), // Rule ID 5301 //
     /* 167021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 167026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167040 */     // (intrinsic_wo_chain:{ *:[v1f64] } 632:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 167043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167047 */     GIR_RootConstrainSelectedInstOperands,
     /* 167048 */     // GIR_Coverage, 5301,
     /* 167048 */     GIR_EraseRootFromParent_Done,
     /* 167049 */   // Label 3128: @167049
     /* 167049 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(167082), // Rule ID 5313 //
     /* 167054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 167059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 167065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167073 */     // (intrinsic_wo_chain:{ *:[f16] } 634:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 167073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 167076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167080 */     GIR_RootConstrainSelectedInstOperands,
     /* 167081 */     // GIR_Coverage, 5313,
     /* 167081 */     GIR_EraseRootFromParent_Done,
     /* 167082 */   // Label 3129: @167082
     /* 167082 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(167115), // Rule ID 5314 //
     /* 167087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 167092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167106 */     // (intrinsic_wo_chain:{ *:[f32] } 634:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 167106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 167109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167113 */     GIR_RootConstrainSelectedInstOperands,
     /* 167114 */     // GIR_Coverage, 5314,
     /* 167114 */     GIR_EraseRootFromParent_Done,
     /* 167115 */   // Label 3130: @167115
     /* 167115 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(167148), // Rule ID 5315 //
     /* 167120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 167125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167139 */     // (intrinsic_wo_chain:{ *:[f64] } 634:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 167139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 167142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167146 */     GIR_RootConstrainSelectedInstOperands,
     /* 167147 */     // GIR_Coverage, 5315,
     /* 167147 */     GIR_EraseRootFromParent_Done,
     /* 167148 */   // Label 3131: @167148
     /* 167148 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(167181), // Rule ID 5316 //
     /* 167153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 167158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 167164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167172 */     // (intrinsic_wo_chain:{ *:[f16] } 639:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 167172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 167175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167179 */     GIR_RootConstrainSelectedInstOperands,
     /* 167180 */     // GIR_Coverage, 5316,
     /* 167180 */     GIR_EraseRootFromParent_Done,
     /* 167181 */   // Label 3132: @167181
     /* 167181 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(167214), // Rule ID 5317 //
     /* 167186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 167191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167205 */     // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 167205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 167208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167212 */     GIR_RootConstrainSelectedInstOperands,
     /* 167213 */     // GIR_Coverage, 5317,
     /* 167213 */     GIR_EraseRootFromParent_Done,
     /* 167214 */   // Label 3133: @167214
     /* 167214 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(167247), // Rule ID 5318 //
     /* 167219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 167224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167238 */     // (intrinsic_wo_chain:{ *:[f64] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 167238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 167241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167245 */     GIR_RootConstrainSelectedInstOperands,
     /* 167246 */     // GIR_Coverage, 5318,
     /* 167246 */     GIR_EraseRootFromParent_Done,
     /* 167247 */   // Label 3134: @167247
     /* 167247 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(167280), // Rule ID 5319 //
     /* 167252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 167257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167271 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 167274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167278 */     GIR_RootConstrainSelectedInstOperands,
     /* 167279 */     // GIR_Coverage, 5319,
     /* 167279 */     GIR_EraseRootFromParent_Done,
     /* 167280 */   // Label 3135: @167280
     /* 167280 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(167313), // Rule ID 5649 //
     /* 167285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 167290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167304 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 167307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167311 */     GIR_RootConstrainSelectedInstOperands,
     /* 167312 */     // GIR_Coverage, 5649,
     /* 167312 */     GIR_EraseRootFromParent_Done,
     /* 167313 */   // Label 3136: @167313
     /* 167313 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(167398), // Rule ID 5650 //
     /* 167318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 167323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167337 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 167337 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 167340 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 167344 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167349 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 167353 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 167357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 167359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167371 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 167378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 167391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167396 */     GIR_RootConstrainSelectedInstOperands,
     /* 167397 */     // GIR_Coverage, 5650,
     /* 167397 */     GIR_EraseRootFromParent_Done,
     /* 167398 */   // Label 3137: @167398
     /* 167398 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(167431), // Rule ID 5651 //
     /* 167403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 167408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167422 */     // (intrinsic_wo_chain:{ *:[f64] } 580:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 167425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167429 */     GIR_RootConstrainSelectedInstOperands,
     /* 167430 */     // GIR_Coverage, 5651,
     /* 167430 */     GIR_EraseRootFromParent_Done,
     /* 167431 */   // Label 3138: @167431
     /* 167431 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(167464), // Rule ID 5653 //
     /* 167436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 167441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167455 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 167458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167462 */     GIR_RootConstrainSelectedInstOperands,
     /* 167463 */     // GIR_Coverage, 5653,
     /* 167463 */     GIR_EraseRootFromParent_Done,
     /* 167464 */   // Label 3139: @167464
     /* 167464 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(167497), // Rule ID 5655 //
     /* 167469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 167474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167488 */     // (intrinsic_wo_chain:{ *:[f64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 167491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167495 */     GIR_RootConstrainSelectedInstOperands,
     /* 167496 */     // GIR_Coverage, 5655,
     /* 167496 */     GIR_EraseRootFromParent_Done,
     /* 167497 */   // Label 3140: @167497
     /* 167497 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(167530), // Rule ID 5657 //
     /* 167502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167521 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 167524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167528 */     GIR_RootConstrainSelectedInstOperands,
     /* 167529 */     // GIR_Coverage, 5657,
     /* 167529 */     GIR_EraseRootFromParent_Done,
     /* 167530 */   // Label 3141: @167530
     /* 167530 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(167563), // Rule ID 5659 //
     /* 167535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167554 */     // (intrinsic_wo_chain:{ *:[f64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 167557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167561 */     GIR_RootConstrainSelectedInstOperands,
     /* 167562 */     // GIR_Coverage, 5659,
     /* 167562 */     GIR_EraseRootFromParent_Done,
     /* 167563 */   // Label 3142: @167563
     /* 167563 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(167596), // Rule ID 5661 //
     /* 167568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167587 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 167590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167594 */     GIR_RootConstrainSelectedInstOperands,
     /* 167595 */     // GIR_Coverage, 5661,
     /* 167595 */     GIR_EraseRootFromParent_Done,
     /* 167596 */   // Label 3143: @167596
     /* 167596 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(167629), // Rule ID 5663 //
     /* 167601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167620 */     // (intrinsic_wo_chain:{ *:[f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 167623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167627 */     GIR_RootConstrainSelectedInstOperands,
     /* 167628 */     // GIR_Coverage, 5663,
     /* 167628 */     GIR_EraseRootFromParent_Done,
     /* 167629 */   // Label 3144: @167629
     /* 167629 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(167662), // Rule ID 5665 //
     /* 167634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167653 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 167653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 167656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167660 */     GIR_RootConstrainSelectedInstOperands,
     /* 167661 */     // GIR_Coverage, 5665,
     /* 167661 */     GIR_EraseRootFromParent_Done,
     /* 167662 */   // Label 3145: @167662
     /* 167662 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(167695), // Rule ID 5667 //
     /* 167667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167686 */     // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 167686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 167689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167693 */     GIR_RootConstrainSelectedInstOperands,
     /* 167694 */     // GIR_Coverage, 5667,
     /* 167694 */     GIR_EraseRootFromParent_Done,
     /* 167695 */   // Label 3146: @167695
     /* 167695 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(167728), // Rule ID 13206 //
     /* 167700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 167708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 167715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167719 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 167719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 167722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167726 */     GIR_RootConstrainSelectedInstOperands,
     /* 167727 */     // GIR_Coverage, 13206,
     /* 167727 */     GIR_EraseRootFromParent_Done,
     /* 167728 */   // Label 3147: @167728
     /* 167728 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(167761), // Rule ID 13208 //
     /* 167733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 167741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 167748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167752 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 167752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 167755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167759 */     GIR_RootConstrainSelectedInstOperands,
     /* 167760 */     // GIR_Coverage, 13208,
     /* 167760 */     GIR_EraseRootFromParent_Done,
     /* 167761 */   // Label 3148: @167761
     /* 167761 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(167794), // Rule ID 13210 //
     /* 167766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167785 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 167785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 167788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167792 */     GIR_RootConstrainSelectedInstOperands,
     /* 167793 */     // GIR_Coverage, 13210,
     /* 167793 */     GIR_EraseRootFromParent_Done,
     /* 167794 */   // Label 3149: @167794
     /* 167794 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(167827), // Rule ID 13212 //
     /* 167799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167818 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 167818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 167821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167825 */     GIR_RootConstrainSelectedInstOperands,
     /* 167826 */     // GIR_Coverage, 13212,
     /* 167826 */     GIR_EraseRootFromParent_Done,
     /* 167827 */   // Label 3150: @167827
     /* 167827 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(167942), // Rule ID 13213 //
     /* 167832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 167837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167851 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 167851 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 167854 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 167858 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167863 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 167867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 167869 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 167872 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 167876 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 167883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 167886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 167890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167895 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 167898 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 167901 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 167904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167924 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 167931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167941 */     // GIR_Coverage, 13213,
     /* 167941 */     GIR_EraseRootFromParent_Done,
     /* 167942 */   // Label 3151: @167942
     /* 167942 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(167975), // Rule ID 13215 //
     /* 167947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 167952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 167955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 167962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167966 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 167966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 167969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167973 */     GIR_RootConstrainSelectedInstOperands,
     /* 167974 */     // GIR_Coverage, 13215,
     /* 167974 */     GIR_EraseRootFromParent_Done,
     /* 167975 */   // Label 3152: @167975
     /* 167975 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(168008), // Rule ID 13217 //
     /* 167980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 167985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 167988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 167995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167999 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 167999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 168002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168006 */     GIR_RootConstrainSelectedInstOperands,
     /* 168007 */     // GIR_Coverage, 13217,
     /* 168007 */     GIR_EraseRootFromParent_Done,
     /* 168008 */   // Label 3153: @168008
     /* 168008 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(168041), // Rule ID 13219 //
     /* 168013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168032 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 168032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 168035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168039 */     GIR_RootConstrainSelectedInstOperands,
     /* 168040 */     // GIR_Coverage, 13219,
     /* 168040 */     GIR_EraseRootFromParent_Done,
     /* 168041 */   // Label 3154: @168041
     /* 168041 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(168074), // Rule ID 13221 //
     /* 168046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168065 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 168065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 168068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168072 */     GIR_RootConstrainSelectedInstOperands,
     /* 168073 */     // GIR_Coverage, 13221,
     /* 168073 */     GIR_EraseRootFromParent_Done,
     /* 168074 */   // Label 3155: @168074
     /* 168074 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(168189), // Rule ID 13222 //
     /* 168079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168098 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168098 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 168101 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 168105 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168110 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168116 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168119 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168123 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168142 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168145 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168148 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 168151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168171 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168188 */     // GIR_Coverage, 13222,
     /* 168188 */     GIR_EraseRootFromParent_Done,
     /* 168189 */   // Label 3156: @168189
     /* 168189 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(168308), // Rule ID 13223 //
     /* 168194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 168199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168213 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168213 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168216 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 168220 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168225 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168229 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168235 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168238 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168242 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168261 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168264 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168267 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168290 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168302 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168307 */     // GIR_Coverage, 13223,
     /* 168307 */     GIR_EraseRootFromParent_Done,
     /* 168308 */   // Label 3157: @168308
     /* 168308 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(168423), // Rule ID 13224 //
     /* 168313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 168318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168332 */     // (intrinsic_wo_chain:{ *:[i64] } 662:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 168332 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168335 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 168339 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168344 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168350 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 168353 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168357 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 168367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168376 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168379 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168382 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168405 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 168412 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168417 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168422 */     // GIR_Coverage, 13224,
     /* 168422 */     GIR_EraseRootFromParent_Done,
     /* 168423 */   // Label 3158: @168423
     /* 168423 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(168542), // Rule ID 13225 //
     /* 168428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168447 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168447 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168450 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 168454 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168459 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168463 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168469 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168472 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168476 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168495 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168498 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168501 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168504 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168524 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168541 */     // GIR_Coverage, 13225,
     /* 168541 */     GIR_EraseRootFromParent_Done,
     /* 168542 */   // Label 3159: @168542
     /* 168542 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(168657), // Rule ID 13226 //
     /* 168547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 168552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168566 */     // (intrinsic_wo_chain:{ *:[i64] } 727:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 168566 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168569 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 168573 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168578 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168584 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 168587 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168591 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 168601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168610 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168613 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168616 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168639 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 168646 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168656 */     // GIR_Coverage, 13226,
     /* 168656 */     GIR_EraseRootFromParent_Done,
     /* 168657 */   // Label 3160: @168657
     /* 168657 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(168690), // Rule ID 13228 //
     /* 168662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 168670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 168677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168681 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 168681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 168684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168688 */     GIR_RootConstrainSelectedInstOperands,
     /* 168689 */     // GIR_Coverage, 13228,
     /* 168689 */     GIR_EraseRootFromParent_Done,
     /* 168690 */   // Label 3161: @168690
     /* 168690 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(168723), // Rule ID 13230 //
     /* 168695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 168703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 168710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168714 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 168714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 168717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168721 */     GIR_RootConstrainSelectedInstOperands,
     /* 168722 */     // GIR_Coverage, 13230,
     /* 168722 */     GIR_EraseRootFromParent_Done,
     /* 168723 */   // Label 3162: @168723
     /* 168723 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(168756), // Rule ID 13232 //
     /* 168728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168747 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 168747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 168750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168754 */     GIR_RootConstrainSelectedInstOperands,
     /* 168755 */     // GIR_Coverage, 13232,
     /* 168755 */     GIR_EraseRootFromParent_Done,
     /* 168756 */   // Label 3163: @168756
     /* 168756 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(168789), // Rule ID 13234 //
     /* 168761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168780 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 168780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 168783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168787 */     GIR_RootConstrainSelectedInstOperands,
     /* 168788 */     // GIR_Coverage, 13234,
     /* 168788 */     GIR_EraseRootFromParent_Done,
     /* 168789 */   // Label 3164: @168789
     /* 168789 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(168904), // Rule ID 13235 //
     /* 168794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168813 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168813 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 168816 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 168820 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168825 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168831 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168834 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168838 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168857 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168860 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168863 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 168866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168886 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 168893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168903 */     // GIR_Coverage, 13235,
     /* 168903 */     GIR_EraseRootFromParent_Done,
     /* 168904 */   // Label 3165: @168904
     /* 168904 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(169023), // Rule ID 13236 //
     /* 168909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 168914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168928 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 168928 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 168931 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 168935 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168940 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168944 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 168950 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 168953 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 168957 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 168967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 168971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168976 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168979 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 168982 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 168985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169005 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169022 */     // GIR_Coverage, 13236,
     /* 169022 */     GIR_EraseRootFromParent_Done,
     /* 169023 */   // Label 3166: @169023
     /* 169023 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(169056), // Rule ID 13238 //
     /* 169028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169047 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 169050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169054 */     GIR_RootConstrainSelectedInstOperands,
     /* 169055 */     // GIR_Coverage, 13238,
     /* 169055 */     GIR_EraseRootFromParent_Done,
     /* 169056 */   // Label 3167: @169056
     /* 169056 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(169089), // Rule ID 13240 //
     /* 169061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169080 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 169083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169087 */     GIR_RootConstrainSelectedInstOperands,
     /* 169088 */     // GIR_Coverage, 13240,
     /* 169088 */     GIR_EraseRootFromParent_Done,
     /* 169089 */   // Label 3168: @169089
     /* 169089 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(169122), // Rule ID 13242 //
     /* 169094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169113 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 169116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169120 */     GIR_RootConstrainSelectedInstOperands,
     /* 169121 */     // GIR_Coverage, 13242,
     /* 169121 */     GIR_EraseRootFromParent_Done,
     /* 169122 */   // Label 3169: @169122
     /* 169122 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(169155), // Rule ID 13244 //
     /* 169127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169146 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 169149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169153 */     GIR_RootConstrainSelectedInstOperands,
     /* 169154 */     // GIR_Coverage, 13244,
     /* 169154 */     GIR_EraseRootFromParent_Done,
     /* 169155 */   // Label 3170: @169155
     /* 169155 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(169270), // Rule ID 13245 //
     /* 169160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169179 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169179 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 169182 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 169186 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169191 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169197 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169200 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169204 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169223 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169226 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169229 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 169232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169252 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169269 */     // GIR_Coverage, 13245,
     /* 169269 */     GIR_EraseRootFromParent_Done,
     /* 169270 */   // Label 3171: @169270
     /* 169270 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(169389), // Rule ID 13246 //
     /* 169275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 169280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169294 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169294 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169297 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 169301 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169306 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169310 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169316 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169319 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169323 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169342 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169345 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169348 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169371 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169383 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169388 */     // GIR_Coverage, 13246,
     /* 169388 */     GIR_EraseRootFromParent_Done,
     /* 169389 */   // Label 3172: @169389
     /* 169389 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(169422), // Rule ID 13248 //
     /* 169394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169413 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 169416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169420 */     GIR_RootConstrainSelectedInstOperands,
     /* 169421 */     // GIR_Coverage, 13248,
     /* 169421 */     GIR_EraseRootFromParent_Done,
     /* 169422 */   // Label 3173: @169422
     /* 169422 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(169455), // Rule ID 13250 //
     /* 169427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169446 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 169449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169453 */     GIR_RootConstrainSelectedInstOperands,
     /* 169454 */     // GIR_Coverage, 13250,
     /* 169454 */     GIR_EraseRootFromParent_Done,
     /* 169455 */   // Label 3174: @169455
     /* 169455 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(169488), // Rule ID 13252 //
     /* 169460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169479 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 169482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169486 */     GIR_RootConstrainSelectedInstOperands,
     /* 169487 */     // GIR_Coverage, 13252,
     /* 169487 */     GIR_EraseRootFromParent_Done,
     /* 169488 */   // Label 3175: @169488
     /* 169488 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(169521), // Rule ID 13254 //
     /* 169493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169512 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 169515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169519 */     GIR_RootConstrainSelectedInstOperands,
     /* 169520 */     // GIR_Coverage, 13254,
     /* 169520 */     GIR_EraseRootFromParent_Done,
     /* 169521 */   // Label 3176: @169521
     /* 169521 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(169636), // Rule ID 13255 //
     /* 169526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169545 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169545 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 169548 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 169552 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169557 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169589 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169592 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169595 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 169598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169618 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169635 */     // GIR_Coverage, 13255,
     /* 169635 */     GIR_EraseRootFromParent_Done,
     /* 169636 */   // Label 3177: @169636
     /* 169636 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(169755), // Rule ID 13256 //
     /* 169641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 169646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169660 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169660 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169663 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 169667 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169672 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169676 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169682 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169685 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169689 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169708 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169711 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169714 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169737 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169744 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169754 */     // GIR_Coverage, 13256,
     /* 169754 */     GIR_EraseRootFromParent_Done,
     /* 169755 */   // Label 3178: @169755
     /* 169755 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(169788), // Rule ID 13258 //
     /* 169760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169779 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 169782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169786 */     GIR_RootConstrainSelectedInstOperands,
     /* 169787 */     // GIR_Coverage, 13258,
     /* 169787 */     GIR_EraseRootFromParent_Done,
     /* 169788 */   // Label 3179: @169788
     /* 169788 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(169821), // Rule ID 13260 //
     /* 169793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169812 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 169815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169819 */     GIR_RootConstrainSelectedInstOperands,
     /* 169820 */     // GIR_Coverage, 13260,
     /* 169820 */     GIR_EraseRootFromParent_Done,
     /* 169821 */   // Label 3180: @169821
     /* 169821 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(169854), // Rule ID 13262 //
     /* 169826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169845 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 169848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169852 */     GIR_RootConstrainSelectedInstOperands,
     /* 169853 */     // GIR_Coverage, 13262,
     /* 169853 */     GIR_EraseRootFromParent_Done,
     /* 169854 */   // Label 3181: @169854
     /* 169854 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(169887), // Rule ID 13264 //
     /* 169859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169878 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 169881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169885 */     GIR_RootConstrainSelectedInstOperands,
     /* 169886 */     // GIR_Coverage, 13264,
     /* 169886 */     GIR_EraseRootFromParent_Done,
     /* 169887 */   // Label 3182: @169887
     /* 169887 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(170002), // Rule ID 13265 //
     /* 169892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 169897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169911 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169911 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 169914 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 169918 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169923 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169929 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169932 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169936 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169955 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169958 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169961 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 169964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169984 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170001 */     // GIR_Coverage, 13265,
     /* 170001 */     GIR_EraseRootFromParent_Done,
     /* 170002 */   // Label 3183: @170002
     /* 170002 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(170121), // Rule ID 13266 //
     /* 170007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 170012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170026 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170026 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170029 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 170033 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170038 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170042 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170048 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170051 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170055 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170074 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170077 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170080 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170103 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170120 */     // GIR_Coverage, 13266,
     /* 170120 */     GIR_EraseRootFromParent_Done,
     /* 170121 */   // Label 3184: @170121
     /* 170121 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(170153), // Rule ID 2393 //
     /* 170126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 170134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 170137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 170140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170144 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1669:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 170144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 170147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 170151 */     GIR_RootConstrainSelectedInstOperands,
     /* 170152 */     // GIR_Coverage, 2393,
     /* 170152 */     GIR_EraseRootFromParent_Done,
     /* 170153 */   // Label 3185: @170153
     /* 170153 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(170185), // Rule ID 2394 //
     /* 170158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 170166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 170169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 170172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170176 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1670:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 170176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 170179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 170183 */     GIR_RootConstrainSelectedInstOperands,
     /* 170184 */     // GIR_Coverage, 2394,
     /* 170184 */     GIR_EraseRootFromParent_Done,
     /* 170185 */   // Label 3186: @170185
     /* 170185 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(170217), // Rule ID 2395 //
     /* 170190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 170198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 170201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 170204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170208 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1671:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 170208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 170211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 170215 */     GIR_RootConstrainSelectedInstOperands,
     /* 170216 */     // GIR_Coverage, 2395,
     /* 170216 */     GIR_EraseRootFromParent_Done,
     /* 170217 */   // Label 3187: @170217
     /* 170217 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(170249), // Rule ID 3093 //
     /* 170222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 170225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 170230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 170233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 170236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170240 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1851:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 170240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 170243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170247 */     GIR_RootConstrainSelectedInstOperands,
     /* 170248 */     // GIR_Coverage, 3093,
     /* 170248 */     GIR_EraseRootFromParent_Done,
     /* 170249 */   // Label 3188: @170249
     /* 170249 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(170281), // Rule ID 3094 //
     /* 170254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 170257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 170262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 170265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 170268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170272 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1851:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 170272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 170275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170279 */     GIR_RootConstrainSelectedInstOperands,
     /* 170280 */     // GIR_Coverage, 3094,
     /* 170280 */     GIR_EraseRootFromParent_Done,
     /* 170281 */   // Label 3189: @170281
     /* 170281 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(170313), // Rule ID 3095 //
     /* 170286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 170289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 170294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 170297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 170300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170304 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1851:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 170304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 170307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170311 */     GIR_RootConstrainSelectedInstOperands,
     /* 170312 */     // GIR_Coverage, 3095,
     /* 170312 */     GIR_EraseRootFromParent_Done,
     /* 170313 */   // Label 3190: @170313
     /* 170313 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(170345), // Rule ID 3349 //
     /* 170318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 170326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 170329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 170332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170336 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1661:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 170336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 170339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170343 */     GIR_RootConstrainSelectedInstOperands,
     /* 170344 */     // GIR_Coverage, 3349,
     /* 170344 */     GIR_EraseRootFromParent_Done,
     /* 170345 */   // Label 3191: @170345
     /* 170345 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(170377), // Rule ID 3350 //
     /* 170350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 170358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 170361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 170364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170368 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1661:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 170368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 170371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170375 */     GIR_RootConstrainSelectedInstOperands,
     /* 170376 */     // GIR_Coverage, 3350,
     /* 170376 */     GIR_EraseRootFromParent_Done,
     /* 170377 */   // Label 3192: @170377
     /* 170377 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(170409), // Rule ID 3351 //
     /* 170382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 170385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 170390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 170393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 170396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 170400 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1661:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 170400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 170403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 170405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170407 */     GIR_RootConstrainSelectedInstOperands,
     /* 170408 */     // GIR_Coverage, 3351,
     /* 170408 */     GIR_EraseRootFromParent_Done,
     /* 170409 */   // Label 3193: @170409
     /* 170409 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(170441), // Rule ID 3430 //
     /* 170414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 170417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 170422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 170425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 170428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170432 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1422:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 170432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 170435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170439 */     GIR_RootConstrainSelectedInstOperands,
     /* 170440 */     // GIR_Coverage, 3430,
     /* 170440 */     GIR_EraseRootFromParent_Done,
     /* 170441 */   // Label 3194: @170441
     /* 170441 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(170473), // Rule ID 3431 //
     /* 170446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 170449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 170454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 170457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 170460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170464 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1422:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 170464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 170467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170471 */     GIR_RootConstrainSelectedInstOperands,
     /* 170472 */     // GIR_Coverage, 3431,
     /* 170472 */     GIR_EraseRootFromParent_Done,
     /* 170473 */   // Label 3195: @170473
     /* 170473 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(170505), // Rule ID 3432 //
     /* 170478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 170481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 170486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 170489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 170492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170496 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1422:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 170496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 170499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 170501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170503 */     GIR_RootConstrainSelectedInstOperands,
     /* 170504 */     // GIR_Coverage, 3432,
     /* 170504 */     GIR_EraseRootFromParent_Done,
     /* 170505 */   // Label 3196: @170505
     /* 170505 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(170537), // Rule ID 3458 //
     /* 170510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 170513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 170518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 170521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 170524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 170528 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1261:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 170528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 170531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 170533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 170535 */     GIR_RootConstrainSelectedInstOperands,
     /* 170536 */     // GIR_Coverage, 3458,
     /* 170536 */     GIR_EraseRootFromParent_Done,
     /* 170537 */   // Label 3197: @170537
     /* 170537 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(170569), // Rule ID 4661 //
     /* 170542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 170545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 170556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170560 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 170560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 170563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170567 */     GIR_RootConstrainSelectedInstOperands,
     /* 170568 */     // GIR_Coverage, 4661,
     /* 170568 */     GIR_EraseRootFromParent_Done,
     /* 170569 */   // Label 3198: @170569
     /* 170569 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(170601), // Rule ID 4662 //
     /* 170574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 170577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 170588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170592 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 170592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 170595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170599 */     GIR_RootConstrainSelectedInstOperands,
     /* 170600 */     // GIR_Coverage, 4662,
     /* 170600 */     GIR_EraseRootFromParent_Done,
     /* 170601 */   // Label 3199: @170601
     /* 170601 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(170630), // Rule ID 4663 //
     /* 170606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 170617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170621 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 170621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 170624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170628 */     GIR_RootConstrainSelectedInstOperands,
     /* 170629 */     // GIR_Coverage, 4663,
     /* 170629 */     GIR_EraseRootFromParent_Done,
     /* 170630 */   // Label 3200: @170630
     /* 170630 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(170659), // Rule ID 4664 //
     /* 170635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 170646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170650 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 170650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 170653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170657 */     GIR_RootConstrainSelectedInstOperands,
     /* 170658 */     // GIR_Coverage, 4664,
     /* 170658 */     GIR_EraseRootFromParent_Done,
     /* 170659 */   // Label 3201: @170659
     /* 170659 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(170688), // Rule ID 4665 //
     /* 170664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170679 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 170679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 170682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170686 */     GIR_RootConstrainSelectedInstOperands,
     /* 170687 */     // GIR_Coverage, 4665,
     /* 170687 */     GIR_EraseRootFromParent_Done,
     /* 170688 */   // Label 3202: @170688
     /* 170688 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(170717), // Rule ID 4666 //
     /* 170693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170708 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 170708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 170711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170715 */     GIR_RootConstrainSelectedInstOperands,
     /* 170716 */     // GIR_Coverage, 4666,
     /* 170716 */     GIR_EraseRootFromParent_Done,
     /* 170717 */   // Label 3203: @170717
     /* 170717 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(170749), // Rule ID 4673 //
     /* 170722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 170725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 170736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170740 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 170740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 170743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170747 */     GIR_RootConstrainSelectedInstOperands,
     /* 170748 */     // GIR_Coverage, 4673,
     /* 170748 */     GIR_EraseRootFromParent_Done,
     /* 170749 */   // Label 3204: @170749
     /* 170749 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(170781), // Rule ID 4674 //
     /* 170754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 170757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 170768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170772 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 170772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 170775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170779 */     GIR_RootConstrainSelectedInstOperands,
     /* 170780 */     // GIR_Coverage, 4674,
     /* 170780 */     GIR_EraseRootFromParent_Done,
     /* 170781 */   // Label 3205: @170781
     /* 170781 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(170810), // Rule ID 4675 //
     /* 170786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 170797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170801 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 170801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 170804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170808 */     GIR_RootConstrainSelectedInstOperands,
     /* 170809 */     // GIR_Coverage, 4675,
     /* 170809 */     GIR_EraseRootFromParent_Done,
     /* 170810 */   // Label 3206: @170810
     /* 170810 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(170839), // Rule ID 4676 //
     /* 170815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 170826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170830 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 170830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 170833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170837 */     GIR_RootConstrainSelectedInstOperands,
     /* 170838 */     // GIR_Coverage, 4676,
     /* 170838 */     GIR_EraseRootFromParent_Done,
     /* 170839 */   // Label 3207: @170839
     /* 170839 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(170868), // Rule ID 4677 //
     /* 170844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 170859 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 170859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 170862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170866 */     GIR_RootConstrainSelectedInstOperands,
     /* 170867 */     // GIR_Coverage, 4677,
     /* 170867 */     GIR_EraseRootFromParent_Done,
     /* 170868 */   // Label 3208: @170868
     /* 170868 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(170897), // Rule ID 4678 //
     /* 170873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 170878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 170888 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 170888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 170891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170895 */     GIR_RootConstrainSelectedInstOperands,
     /* 170896 */     // GIR_Coverage, 4678,
     /* 170896 */     GIR_EraseRootFromParent_Done,
     /* 170897 */   // Label 3209: @170897
     /* 170897 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(170926), // Rule ID 4973 //
     /* 170902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170917 */     // (intrinsic_wo_chain:{ *:[v4i16] } 592:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 170917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 170920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170924 */     GIR_RootConstrainSelectedInstOperands,
     /* 170925 */     // GIR_Coverage, 4973,
     /* 170925 */     GIR_EraseRootFromParent_Done,
     /* 170926 */   // Label 3210: @170926
     /* 170926 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(170955), // Rule ID 4974 //
     /* 170931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170946 */     // (intrinsic_wo_chain:{ *:[v8i16] } 592:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 170946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 170949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170953 */     GIR_RootConstrainSelectedInstOperands,
     /* 170954 */     // GIR_Coverage, 4974,
     /* 170954 */     GIR_EraseRootFromParent_Done,
     /* 170955 */   // Label 3211: @170955
     /* 170955 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(170984), // Rule ID 4975 //
     /* 170960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170975 */     // (intrinsic_wo_chain:{ *:[v2i32] } 592:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 170975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 170978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170982 */     GIR_RootConstrainSelectedInstOperands,
     /* 170983 */     // GIR_Coverage, 4975,
     /* 170983 */     GIR_EraseRootFromParent_Done,
     /* 170984 */   // Label 3212: @170984
     /* 170984 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(171013), // Rule ID 4976 //
     /* 170989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 170994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171004 */     // (intrinsic_wo_chain:{ *:[v4i32] } 592:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 171004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 171007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171011 */     GIR_RootConstrainSelectedInstOperands,
     /* 171012 */     // GIR_Coverage, 4976,
     /* 171012 */     GIR_EraseRootFromParent_Done,
     /* 171013 */   // Label 3213: @171013
     /* 171013 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(171042), // Rule ID 4977 //
     /* 171018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 171023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171033 */     // (intrinsic_wo_chain:{ *:[v2i64] } 592:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 171033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 171036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171040 */     GIR_RootConstrainSelectedInstOperands,
     /* 171041 */     // GIR_Coverage, 4977,
     /* 171041 */     GIR_EraseRootFromParent_Done,
     /* 171042 */   // Label 3214: @171042
     /* 171042 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(171071), // Rule ID 4978 //
     /* 171047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171062 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 171062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 171065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171069 */     GIR_RootConstrainSelectedInstOperands,
     /* 171070 */     // GIR_Coverage, 4978,
     /* 171070 */     GIR_EraseRootFromParent_Done,
     /* 171071 */   // Label 3215: @171071
     /* 171071 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(171100), // Rule ID 4979 //
     /* 171076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171091 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 171091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 171094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171098 */     GIR_RootConstrainSelectedInstOperands,
     /* 171099 */     // GIR_Coverage, 4979,
     /* 171099 */     GIR_EraseRootFromParent_Done,
     /* 171100 */   // Label 3216: @171100
     /* 171100 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(171129), // Rule ID 4980 //
     /* 171105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171120 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 171120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 171123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171127 */     GIR_RootConstrainSelectedInstOperands,
     /* 171128 */     // GIR_Coverage, 4980,
     /* 171128 */     GIR_EraseRootFromParent_Done,
     /* 171129 */   // Label 3217: @171129
     /* 171129 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(171158), // Rule ID 4981 //
     /* 171134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171149 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 171149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 171152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171156 */     GIR_RootConstrainSelectedInstOperands,
     /* 171157 */     // GIR_Coverage, 4981,
     /* 171157 */     GIR_EraseRootFromParent_Done,
     /* 171158 */   // Label 3218: @171158
     /* 171158 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(171187), // Rule ID 4982 //
     /* 171163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 171168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171178 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 171178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 171181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171185 */     GIR_RootConstrainSelectedInstOperands,
     /* 171186 */     // GIR_Coverage, 4982,
     /* 171186 */     GIR_EraseRootFromParent_Done,
     /* 171187 */   // Label 3219: @171187
     /* 171187 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(171219), // Rule ID 8469 //
     /* 171192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 171200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 171203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 171206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171210 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1660:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 171210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 171213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171217 */     GIR_RootConstrainSelectedInstOperands,
     /* 171218 */     // GIR_Coverage, 8469,
     /* 171218 */     GIR_EraseRootFromParent_Done,
     /* 171219 */   // Label 3220: @171219
     /* 171219 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(171251), // Rule ID 8470 //
     /* 171224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 171232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 171235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 171238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171242 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1660:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 171242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 171245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171249 */     GIR_RootConstrainSelectedInstOperands,
     /* 171250 */     // GIR_Coverage, 8470,
     /* 171250 */     GIR_EraseRootFromParent_Done,
     /* 171251 */   // Label 3221: @171251
     /* 171251 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(171283), // Rule ID 8471 //
     /* 171256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 171264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 171267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 171270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171274 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1660:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 171274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 171277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171281 */     GIR_RootConstrainSelectedInstOperands,
     /* 171282 */     // GIR_Coverage, 8471,
     /* 171282 */     GIR_EraseRootFromParent_Done,
     /* 171283 */   // Label 3222: @171283
     /* 171283 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(171315), // Rule ID 11880 //
     /* 171288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 171296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 171299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 171302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171306 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2044:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 171306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 171309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171313 */     GIR_RootConstrainSelectedInstOperands,
     /* 171314 */     // GIR_Coverage, 11880,
     /* 171314 */     GIR_EraseRootFromParent_Done,
     /* 171315 */   // Label 3223: @171315
     /* 171315 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(171347), // Rule ID 11881 //
     /* 171320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 171328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 171331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 171334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171338 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2044:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 171338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 171341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171345 */     GIR_RootConstrainSelectedInstOperands,
     /* 171346 */     // GIR_Coverage, 11881,
     /* 171346 */     GIR_EraseRootFromParent_Done,
     /* 171347 */   // Label 3224: @171347
     /* 171347 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(171379), // Rule ID 11882 //
     /* 171352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 171360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 171363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 171366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171370 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2044:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 171370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 171373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171377 */     GIR_RootConstrainSelectedInstOperands,
     /* 171378 */     // GIR_Coverage, 11882,
     /* 171378 */     GIR_EraseRootFromParent_Done,
     /* 171379 */   // Label 3225: @171379
     /* 171379 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(171411), // Rule ID 11883 //
     /* 171384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 171392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 171395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 171398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171402 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1853:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 171402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 171405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171409 */     GIR_RootConstrainSelectedInstOperands,
     /* 171410 */     // GIR_Coverage, 11883,
     /* 171410 */     GIR_EraseRootFromParent_Done,
     /* 171411 */   // Label 3226: @171411
     /* 171411 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(171443), // Rule ID 11884 //
     /* 171416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 171424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 171427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 171430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171434 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1853:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 171434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 171437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171441 */     GIR_RootConstrainSelectedInstOperands,
     /* 171442 */     // GIR_Coverage, 11884,
     /* 171442 */     GIR_EraseRootFromParent_Done,
     /* 171443 */   // Label 3227: @171443
     /* 171443 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(171475), // Rule ID 11885 //
     /* 171448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 171456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 171459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 171462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171466 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1853:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 171466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 171469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171473 */     GIR_RootConstrainSelectedInstOperands,
     /* 171474 */     // GIR_Coverage, 11885,
     /* 171474 */     GIR_EraseRootFromParent_Done,
     /* 171475 */   // Label 3228: @171475
     /* 171475 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(171507), // Rule ID 12052 //
     /* 171480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 171483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 171488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 171491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 171494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171498 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1260:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 171498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 171501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 171503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171505 */     GIR_RootConstrainSelectedInstOperands,
     /* 171506 */     // GIR_Coverage, 12052,
     /* 171506 */     GIR_EraseRootFromParent_Done,
     /* 171507 */   // Label 3229: @171507
     /* 171507 */   GIM_Reject,
     /* 171508 */ // Label 2910: @171508
     /* 171508 */ GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(217822),
     /* 171513 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 171516 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(171700), // Rule ID 2568 //
     /* 171521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 171529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 171550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 171554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 171562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 171566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 171570 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 171573 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 171578 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171582 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 171595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 171599 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171603 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 171607 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 171611 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171615 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 171619 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 171624 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 171628 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 171632 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 171636 */     // MIs[5] Operand 1
     /* 171636 */     // No operand predicates
     /* 171636 */     // MIs[3] Operand 2
     /* 171636 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 171647 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 171651 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 171653 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 171653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 171656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171665 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 171671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 171684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 171688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 171695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 171698 */     GIR_RootConstrainSelectedInstOperands,
     /* 171699 */     // GIR_Coverage, 2568,
     /* 171699 */     GIR_EraseRootFromParent_Done,
     /* 171700 */   // Label 3231: @171700
     /* 171700 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(171884), // Rule ID 6317 //
     /* 171705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 171713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 171734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 171738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 171746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 171750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 171754 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 171757 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 171762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171766 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171775 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 171779 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 171783 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171787 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 171791 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 171795 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171799 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 171803 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 171808 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 171812 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 171816 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 171820 */     // MIs[5] Operand 1
     /* 171820 */     // No operand predicates
     /* 171820 */     // MIs[3] Operand 2
     /* 171820 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 171831 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 171835 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 171837 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 171837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 171840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171849 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 171855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 171868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 171872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 171879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 171882 */     GIR_RootConstrainSelectedInstOperands,
     /* 171883 */     // GIR_Coverage, 6317,
     /* 171883 */     GIR_EraseRootFromParent_Done,
     /* 171884 */   // Label 3232: @171884
     /* 171884 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(172024), // Rule ID 2057 //
     /* 171889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 171897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 171918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 171922 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 171925 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 171930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171934 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 171942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 171946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 171954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 171958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 171966 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 171971 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 171975 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 171979 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 171983 */     // MIs[4] Operand 1
     /* 171983 */     // No operand predicates
     /* 171983 */     // MIs[2] Operand 2
     /* 171983 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 171994 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 171996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 172003 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 172006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 172015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172022 */     GIR_RootConstrainSelectedInstOperands,
     /* 172023 */     // GIR_Coverage, 2057,
     /* 172023 */     GIR_EraseRootFromParent_Done,
     /* 172024 */   // Label 3233: @172024
     /* 172024 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(172164), // Rule ID 2064 //
     /* 172029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172062 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 172065 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172074 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 172082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 172094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 172098 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172102 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172106 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 172111 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172115 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172119 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 172123 */     // MIs[4] Operand 1
     /* 172123 */     // No operand predicates
     /* 172123 */     // MIs[2] Operand 2
     /* 172123 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 172134 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 172143 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 172146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 172155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172162 */     GIR_RootConstrainSelectedInstOperands,
     /* 172163 */     // GIR_Coverage, 2064,
     /* 172163 */     GIR_EraseRootFromParent_Done,
     /* 172164 */   // Label 3234: @172164
     /* 172164 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(172304), // Rule ID 2060 //
     /* 172169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172202 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 172205 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172214 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 172222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 172234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 172238 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172242 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172246 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172251 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172255 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172259 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 172263 */     // MIs[4] Operand 1
     /* 172263 */     // No operand predicates
     /* 172263 */     // MIs[2] Operand 2
     /* 172263 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 172274 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 172283 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 172286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 172295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172302 */     GIR_RootConstrainSelectedInstOperands,
     /* 172303 */     // GIR_Coverage, 2060,
     /* 172303 */     GIR_EraseRootFromParent_Done,
     /* 172304 */   // Label 3235: @172304
     /* 172304 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(172444), // Rule ID 2067 //
     /* 172309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172342 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 172345 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172354 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 172362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 172374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 172378 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172382 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172386 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172391 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172395 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172399 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 172403 */     // MIs[4] Operand 1
     /* 172403 */     // No operand predicates
     /* 172403 */     // MIs[2] Operand 2
     /* 172403 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 172414 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172416 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 172423 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 172426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 172435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172442 */     GIR_RootConstrainSelectedInstOperands,
     /* 172443 */     // GIR_Coverage, 2067,
     /* 172443 */     GIR_EraseRootFromParent_Done,
     /* 172444 */   // Label 3236: @172444
     /* 172444 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(172581), // Rule ID 2055 //
     /* 172449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172482 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 172485 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172494 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 172507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 172519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 172523 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172527 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172531 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 172536 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172540 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172544 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 172548 */     // MIs[4] Operand 1
     /* 172548 */     // No operand predicates
     /* 172548 */     // MIs[2] Operand 2
     /* 172548 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 172559 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172561 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 172564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 172572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172579 */     GIR_RootConstrainSelectedInstOperands,
     /* 172580 */     // GIR_Coverage, 2055,
     /* 172580 */     GIR_EraseRootFromParent_Done,
     /* 172581 */   // Label 3237: @172581
     /* 172581 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(172718), // Rule ID 2062 //
     /* 172586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172619 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 172622 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172631 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 172644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 172656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 172660 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172664 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172668 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 172673 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172677 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172681 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 172685 */     // MIs[4] Operand 1
     /* 172685 */     // No operand predicates
     /* 172685 */     // MIs[2] Operand 2
     /* 172685 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 172696 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172698 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 172701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 172709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172716 */     GIR_RootConstrainSelectedInstOperands,
     /* 172717 */     // GIR_Coverage, 2062,
     /* 172717 */     GIR_EraseRootFromParent_Done,
     /* 172718 */   // Label 3238: @172718
     /* 172718 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(172855), // Rule ID 2058 //
     /* 172723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172756 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 172759 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172768 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 172781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172789 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 172793 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 172797 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172801 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172805 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172810 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172814 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172818 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 172822 */     // MIs[4] Operand 1
     /* 172822 */     // No operand predicates
     /* 172822 */     // MIs[2] Operand 2
     /* 172822 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 172833 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172835 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 172838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 172846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172853 */     GIR_RootConstrainSelectedInstOperands,
     /* 172854 */     // GIR_Coverage, 2058,
     /* 172854 */     GIR_EraseRootFromParent_Done,
     /* 172855 */   // Label 3239: @172855
     /* 172855 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(172992), // Rule ID 2065 //
     /* 172860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 172868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 172889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 172893 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 172896 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 172901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172905 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 172918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 172922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 172930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 172934 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172938 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 172942 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172947 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 172951 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 172955 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 172959 */     // MIs[4] Operand 1
     /* 172959 */     // No operand predicates
     /* 172959 */     // MIs[2] Operand 2
     /* 172959 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 172970 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 172972 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 172972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 172975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 172979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 172983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 172987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 172990 */     GIR_RootConstrainSelectedInstOperands,
     /* 172991 */     // GIR_Coverage, 2065,
     /* 172991 */     GIR_EraseRootFromParent_Done,
     /* 172992 */   // Label 3240: @172992
     /* 172992 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(173153), // Rule ID 2569 //
     /* 172997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173046 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173049 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173058 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173062 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173071 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173075 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173079 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 173083 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173088 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 173092 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173096 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173100 */     // MIs[4] Operand 1
     /* 173100 */     // No operand predicates
     /* 173100 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173104 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 173106 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173118 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 173137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 173148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 173151 */     GIR_RootConstrainSelectedInstOperands,
     /* 173152 */     // GIR_Coverage, 2569,
     /* 173152 */     GIR_EraseRootFromParent_Done,
     /* 173153 */   // Label 3241: @173153
     /* 173153 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(173314), // Rule ID 6318 //
     /* 173158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173207 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173210 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173215 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173219 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173236 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173240 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 173244 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173249 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 173253 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173257 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173261 */     // MIs[4] Operand 1
     /* 173261 */     // No operand predicates
     /* 173261 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173265 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 173267 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173279 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 173298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 173309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 173312 */     GIR_RootConstrainSelectedInstOperands,
     /* 173313 */     // GIR_Coverage, 6318,
     /* 173313 */     GIR_EraseRootFromParent_Done,
     /* 173314 */   // Label 3242: @173314
     /* 173314 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(173424), // Rule ID 2085 //
     /* 173319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173381 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173385 */     // MIs[3] Operand 1
     /* 173385 */     // No operand predicates
     /* 173385 */     // MIs[1] Operand 2
     /* 173385 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 173396 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 173405 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 173405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 173408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 173415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 173419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 173422 */     GIR_RootConstrainSelectedInstOperands,
     /* 173423 */     // GIR_Coverage, 2085,
     /* 173423 */     GIR_EraseRootFromParent_Done,
     /* 173424 */   // Label 3243: @173424
     /* 173424 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(173534), // Rule ID 2088 //
     /* 173429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 173470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173491 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 173495 */     // MIs[3] Operand 1
     /* 173495 */     // No operand predicates
     /* 173495 */     // MIs[1] Operand 2
     /* 173495 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 173506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 173515 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 173515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 173518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 173525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 173529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 173532 */     GIR_RootConstrainSelectedInstOperands,
     /* 173533 */     // GIR_Coverage, 2088,
     /* 173533 */     GIR_EraseRootFromParent_Done,
     /* 173534 */   // Label 3244: @173534
     /* 173534 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(173623), // Rule ID 1743 //
     /* 173539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173572 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 173575 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173584 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 173597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 173604 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 173607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 173616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 173621 */     GIR_RootConstrainSelectedInstOperands,
     /* 173622 */     // GIR_Coverage, 1743,
     /* 173622 */     GIR_EraseRootFromParent_Done,
     /* 173623 */   // Label 3245: @173623
     /* 173623 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(173712), // Rule ID 1745 //
     /* 173628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173661 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 173664 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173673 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 173686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 173693 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 173696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 173705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 173710 */     GIR_RootConstrainSelectedInstOperands,
     /* 173711 */     // GIR_Coverage, 1745,
     /* 173711 */     GIR_EraseRootFromParent_Done,
     /* 173712 */   // Label 3246: @173712
     /* 173712 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(173801), // Rule ID 1747 //
     /* 173717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173750 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 173753 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173762 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173768 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 173775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 173782 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 173785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 173794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 173799 */     GIR_RootConstrainSelectedInstOperands,
     /* 173800 */     // GIR_Coverage, 1747,
     /* 173800 */     GIR_EraseRootFromParent_Done,
     /* 173801 */   // Label 3247: @173801
     /* 173801 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(173890), // Rule ID 1749 //
     /* 173806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173839 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 173842 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173851 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 173864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 173871 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 173874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 173883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 173888 */     GIR_RootConstrainSelectedInstOperands,
     /* 173889 */     // GIR_Coverage, 1749,
     /* 173889 */     GIR_EraseRootFromParent_Done,
     /* 173890 */   // Label 3248: @173890
     /* 173890 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(174012), // Rule ID 6971 //
     /* 173895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 173900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173930 */     // MIs[1] Operand 2
     /* 173930 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 173941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 173945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173949 */     // MIs[2] Rn
     /* 173949 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 173954 */     // MIs[2] Operand 2
     /* 173954 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 173965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 173967 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 173967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 173970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 173974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173979 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 173983 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 173987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 173989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173994 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174011 */     // GIR_Coverage, 6971,
     /* 174011 */     GIR_EraseRootFromParent_Done,
     /* 174012 */   // Label 3249: @174012
     /* 174012 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(174134), // Rule ID 6973 //
     /* 174017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174052 */     // MIs[1] Operand 2
     /* 174052 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174071 */     // MIs[2] Rn
     /* 174071 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174076 */     // MIs[2] Operand 2
     /* 174076 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 174087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174089 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 174089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 174096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174101 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174105 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174116 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174133 */     // GIR_Coverage, 6973,
     /* 174133 */     GIR_EraseRootFromParent_Done,
     /* 174134 */   // Label 3250: @174134
     /* 174134 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(174256), // Rule ID 6975 //
     /* 174139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 174169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174174 */     // MIs[1] Operand 2
     /* 174174 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174193 */     // MIs[2] Rn
     /* 174193 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174198 */     // MIs[2] Operand 2
     /* 174198 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 174209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174211 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 174211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 174218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174223 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174227 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174238 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174255 */     // GIR_Coverage, 6975,
     /* 174255 */     GIR_EraseRootFromParent_Done,
     /* 174256 */   // Label 3251: @174256
     /* 174256 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(174378), // Rule ID 6977 //
     /* 174261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 174266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174296 */     // MIs[1] Operand 2
     /* 174296 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174315 */     // MIs[2] Rn
     /* 174315 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174320 */     // MIs[2] Operand 2
     /* 174320 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 174331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174333 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 174333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 174340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174360 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174377 */     // GIR_Coverage, 6977,
     /* 174377 */     GIR_EraseRootFromParent_Done,
     /* 174378 */   // Label 3252: @174378
     /* 174378 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(174500), // Rule ID 6979 //
     /* 174383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 174388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174418 */     // MIs[1] Operand 2
     /* 174418 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174437 */     // MIs[2] Rn
     /* 174437 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174442 */     // MIs[2] Operand 2
     /* 174442 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 174453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174455 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 174455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 174462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174471 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174482 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174494 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174499 */     // GIR_Coverage, 6979,
     /* 174499 */     GIR_EraseRootFromParent_Done,
     /* 174500 */   // Label 3253: @174500
     /* 174500 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(174683), // Rule ID 2567 //
     /* 174505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 174554 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 174557 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 174562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174566 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174575 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174580 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 174584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174586 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 174586 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 174589 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174593 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 174600 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 174603 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 174607 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174612 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 174615 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 174619 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 174622 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174627 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174632 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174649 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 174655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 174668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 174678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174681 */     GIR_RootConstrainSelectedInstOperands,
     /* 174682 */     // GIR_Coverage, 2567,
     /* 174682 */     GIR_EraseRootFromParent_Done,
     /* 174683 */   // Label 3254: @174683
     /* 174683 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(174866), // Rule ID 6316 //
     /* 174688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 174737 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 174740 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 174745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174749 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174763 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 174767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174769 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 174769 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 174772 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174776 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 174783 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 174786 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 174790 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174795 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 174798 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 174802 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 174805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174810 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174815 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174832 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 174838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 174851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 174861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174864 */     GIR_RootConstrainSelectedInstOperands,
     /* 174865 */     // GIR_Coverage, 6316,
     /* 174865 */     GIR_EraseRootFromParent_Done,
     /* 174866 */   // Label 3255: @174866
     /* 174866 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(174970), // Rule ID 13517 //
     /* 174871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 174874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 174879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 174912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174916 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 174920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 174925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 174929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 174933 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 174937 */     // MIs[3] Operand 1
     /* 174937 */     // No operand predicates
     /* 174937 */     // MIs[1] Operand 2
     /* 174937 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174952 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 174954 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 174954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 174957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 174961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 174965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 174968 */     GIR_RootConstrainSelectedInstOperands,
     /* 174969 */     // GIR_Coverage, 13517,
     /* 174969 */     GIR_EraseRootFromParent_Done,
     /* 174970 */   // Label 3256: @174970
     /* 174970 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(175074), // Rule ID 13520 //
     /* 174975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 174983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 175016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175033 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175037 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175041 */     // MIs[3] Operand 1
     /* 175041 */     // No operand predicates
     /* 175041 */     // MIs[1] Operand 2
     /* 175041 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175056 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175058 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 175061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175072 */     GIR_RootConstrainSelectedInstOperands,
     /* 175073 */     // GIR_Coverage, 13520,
     /* 175073 */     GIR_EraseRootFromParent_Done,
     /* 175074 */   // Label 3257: @175074
     /* 175074 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(175205), // Rule ID 2524 //
     /* 175079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 175082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 175090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 175093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 175096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175121 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175154 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175158 */     // MIs[3] Operand 1
     /* 175158 */     // No operand predicates
     /* 175158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175160 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 175160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175172 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 175178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 175191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175203 */     GIR_RootConstrainSelectedInstOperands,
     /* 175204 */     // GIR_Coverage, 2524,
     /* 175204 */     GIR_EraseRootFromParent_Done,
     /* 175205 */   // Label 3258: @175205
     /* 175205 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(175336), // Rule ID 2525 //
     /* 175210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175252 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175285 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175289 */     // MIs[3] Operand 1
     /* 175289 */     // No operand predicates
     /* 175289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175291 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 175291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175303 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 175309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 175322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175334 */     GIR_RootConstrainSelectedInstOperands,
     /* 175335 */     // GIR_Coverage, 2525,
     /* 175335 */     GIR_EraseRootFromParent_Done,
     /* 175336 */   // Label 3259: @175336
     /* 175336 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(175467), // Rule ID 2526 //
     /* 175341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175383 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175416 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 175420 */     // MIs[3] Operand 1
     /* 175420 */     // No operand predicates
     /* 175420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175422 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 175422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175434 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 175440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 175453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175465 */     GIR_RootConstrainSelectedInstOperands,
     /* 175466 */     // GIR_Coverage, 2526,
     /* 175466 */     GIR_EraseRootFromParent_Done,
     /* 175467 */   // Label 3260: @175467
     /* 175467 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(175598), // Rule ID 13703 //
     /* 175472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 175475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 175483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 175486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 175489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 175518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175526 */     // MIs[2] Operand 1
     /* 175526 */     // No operand predicates
     /* 175526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 175530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175534 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175538 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 175542 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175547 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 175551 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175553 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 175553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175565 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 175571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 175584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 175593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 175596 */     GIR_RootConstrainSelectedInstOperands,
     /* 175597 */     // GIR_Coverage, 13703,
     /* 175597 */     GIR_EraseRootFromParent_Done,
     /* 175598 */   // Label 3261: @175598
     /* 175598 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(175729), // Rule ID 13704 //
     /* 175603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 175649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175653 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175657 */     // MIs[2] Operand 1
     /* 175657 */     // No operand predicates
     /* 175657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 175661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175669 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 175673 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175678 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 175682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175684 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 175684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175696 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 175702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 175715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 175724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 175727 */     GIR_RootConstrainSelectedInstOperands,
     /* 175728 */     // GIR_Coverage, 13704,
     /* 175728 */     GIR_EraseRootFromParent_Done,
     /* 175729 */   // Label 3262: @175729
     /* 175729 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(175860), // Rule ID 13705 //
     /* 175734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 175780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175784 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 175788 */     // MIs[2] Operand 1
     /* 175788 */     // No operand predicates
     /* 175788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 175792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175796 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175800 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 175804 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175809 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 175813 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175815 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 175815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175827 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 175833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 175846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 175855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 175858 */     GIR_RootConstrainSelectedInstOperands,
     /* 175859 */     // GIR_Coverage, 13705,
     /* 175859 */     GIR_EraseRootFromParent_Done,
     /* 175860 */   // Label 3263: @175860
     /* 175860 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(175974), // Rule ID 2056 //
     /* 175865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 175873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 175894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 175898 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 175901 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 175906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175910 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 175923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 175927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175935 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 175940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175948 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175952 */     // MIs[3] Operand 1
     /* 175952 */     // No operand predicates
     /* 175952 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175954 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 175957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 175961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 175965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175972 */     GIR_RootConstrainSelectedInstOperands,
     /* 175973 */     // GIR_Coverage, 2056,
     /* 175973 */     GIR_EraseRootFromParent_Done,
     /* 175974 */   // Label 3264: @175974
     /* 175974 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(176088), // Rule ID 2063 //
     /* 175979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 175987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176012 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176015 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 176020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176024 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176062 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176066 */     // MIs[3] Operand 1
     /* 176066 */     // No operand predicates
     /* 176066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176068 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 176071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176086 */     GIR_RootConstrainSelectedInstOperands,
     /* 176087 */     // GIR_Coverage, 2063,
     /* 176087 */     GIR_EraseRootFromParent_Done,
     /* 176088 */   // Label 3265: @176088
     /* 176088 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(176202), // Rule ID 2059 //
     /* 176093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 176101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176126 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176129 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 176134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176138 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176159 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176163 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176176 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176180 */     // MIs[3] Operand 1
     /* 176180 */     // No operand predicates
     /* 176180 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176182 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 176185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176200 */     GIR_RootConstrainSelectedInstOperands,
     /* 176201 */     // GIR_Coverage, 2059,
     /* 176201 */     GIR_EraseRootFromParent_Done,
     /* 176202 */   // Label 3266: @176202
     /* 176202 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(176316), // Rule ID 2066 //
     /* 176207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 176215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176240 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176243 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 176248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176252 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176290 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176294 */     // MIs[3] Operand 1
     /* 176294 */     // No operand predicates
     /* 176294 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176296 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 176299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176314 */     GIR_RootConstrainSelectedInstOperands,
     /* 176315 */     // GIR_Coverage, 2066,
     /* 176315 */     GIR_EraseRootFromParent_Done,
     /* 176316 */   // Label 3267: @176316
     /* 176316 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(176430), // Rule ID 2061 //
     /* 176321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 176329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176354 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176357 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 176362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 176366 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 176370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176404 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176408 */     // MIs[3] Operand 1
     /* 176408 */     // No operand predicates
     /* 176408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176410 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 176413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176428 */     GIR_RootConstrainSelectedInstOperands,
     /* 176429 */     // GIR_Coverage, 2061,
     /* 176429 */     GIR_EraseRootFromParent_Done,
     /* 176430 */   // Label 3268: @176430
     /* 176430 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(176544), // Rule ID 2068 //
     /* 176435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 176443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176468 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176471 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 176476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 176480 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 176484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176518 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176522 */     // MIs[3] Operand 1
     /* 176522 */     // No operand predicates
     /* 176522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176524 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 176527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176542 */     GIR_RootConstrainSelectedInstOperands,
     /* 176543 */     // GIR_Coverage, 2068,
     /* 176543 */     GIR_EraseRootFromParent_Done,
     /* 176544 */   // Label 3269: @176544
     /* 176544 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(176648), // Rule ID 1987 //
     /* 176549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 176552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176615 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176619 */     // MIs[3] Operand 1
     /* 176619 */     // No operand predicates
     /* 176619 */     // MIs[1] Operand 2
     /* 176619 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176630 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176632 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 176635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176646 */     GIR_RootConstrainSelectedInstOperands,
     /* 176647 */     // GIR_Coverage, 1987,
     /* 176647 */     GIR_EraseRootFromParent_Done,
     /* 176648 */   // Label 3270: @176648
     /* 176648 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(176752), // Rule ID 2017 //
     /* 176653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 176661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176719 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176723 */     // MIs[3] Operand 1
     /* 176723 */     // No operand predicates
     /* 176723 */     // MIs[1] Operand 2
     /* 176723 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176736 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 176739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176750 */     GIR_RootConstrainSelectedInstOperands,
     /* 176751 */     // GIR_Coverage, 2017,
     /* 176751 */     GIR_EraseRootFromParent_Done,
     /* 176752 */   // Label 3271: @176752
     /* 176752 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(176856), // Rule ID 2024 //
     /* 176757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 176765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176823 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176827 */     // MIs[3] Operand 1
     /* 176827 */     // No operand predicates
     /* 176827 */     // MIs[1] Operand 2
     /* 176827 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176840 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 176843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176854 */     GIR_RootConstrainSelectedInstOperands,
     /* 176855 */     // GIR_Coverage, 2024,
     /* 176855 */     GIR_EraseRootFromParent_Done,
     /* 176856 */   // Label 3272: @176856
     /* 176856 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(176960), // Rule ID 2083 //
     /* 176861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 176869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176923 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176927 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176931 */     // MIs[3] Operand 1
     /* 176931 */     // No operand predicates
     /* 176931 */     // MIs[1] Operand 2
     /* 176931 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176944 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 176947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176958 */     GIR_RootConstrainSelectedInstOperands,
     /* 176959 */     // GIR_Coverage, 2083,
     /* 176959 */     GIR_EraseRootFromParent_Done,
     /* 176960 */   // Label 3273: @176960
     /* 176960 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(177064), // Rule ID 1990 //
     /* 176965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 177006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 177010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 177018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 177027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177031 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177035 */     // MIs[3] Operand 1
     /* 177035 */     // No operand predicates
     /* 177035 */     // MIs[1] Operand 2
     /* 177035 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 177046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 177048 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 177051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177062 */     GIR_RootConstrainSelectedInstOperands,
     /* 177063 */     // GIR_Coverage, 1990,
     /* 177063 */     GIR_EraseRootFromParent_Done,
     /* 177064 */   // Label 3274: @177064
     /* 177064 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(177168), // Rule ID 2020 //
     /* 177069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 177077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 177102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 177110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 177114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 177122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177127 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 177131 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177135 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177139 */     // MIs[3] Operand 1
     /* 177139 */     // No operand predicates
     /* 177139 */     // MIs[1] Operand 2
     /* 177139 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 177150 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 177152 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 177155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177166 */     GIR_RootConstrainSelectedInstOperands,
     /* 177167 */     // GIR_Coverage, 2020,
     /* 177167 */     GIR_EraseRootFromParent_Done,
     /* 177168 */   // Label 3275: @177168
     /* 177168 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(177272), // Rule ID 2027 //
     /* 177173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 177181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 177206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 177214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 177218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 177226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 177235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177239 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177243 */     // MIs[3] Operand 1
     /* 177243 */     // No operand predicates
     /* 177243 */     // MIs[1] Operand 2
     /* 177243 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 177254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 177256 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 177259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177270 */     GIR_RootConstrainSelectedInstOperands,
     /* 177271 */     // GIR_Coverage, 2027,
     /* 177271 */     GIR_EraseRootFromParent_Done,
     /* 177272 */   // Label 3276: @177272
     /* 177272 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(177376), // Rule ID 2086 //
     /* 177277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 177310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 177318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 177322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 177330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 177339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177343 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177347 */     // MIs[3] Operand 1
     /* 177347 */     // No operand predicates
     /* 177347 */     // MIs[1] Operand 2
     /* 177347 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 177358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 177360 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 177363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177374 */     GIR_RootConstrainSelectedInstOperands,
     /* 177375 */     // GIR_Coverage, 2086,
     /* 177375 */     GIR_EraseRootFromParent_Done,
     /* 177376 */   // Label 3277: @177376
     /* 177376 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(177433), // Rule ID 1751 //
     /* 177381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 177409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 177416 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 177419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 177426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 177431 */     GIR_RootConstrainSelectedInstOperands,
     /* 177432 */     // GIR_Coverage, 1751,
     /* 177432 */     GIR_EraseRootFromParent_Done,
     /* 177433 */   // Label 3278: @177433
     /* 177433 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(177490), // Rule ID 1753 //
     /* 177438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 177466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 177473 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 177476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 177483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 177488 */     GIR_RootConstrainSelectedInstOperands,
     /* 177489 */     // GIR_Coverage, 1753,
     /* 177489 */     GIR_EraseRootFromParent_Done,
     /* 177490 */   // Label 3279: @177490
     /* 177490 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(177600), // Rule ID 6335 //
     /* 177495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 177500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 177521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 177525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 177529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177534 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 177545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 177549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177553 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 177557 */     // MIs[2] Operand 1
     /* 177557 */     // No operand predicates
     /* 177557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177559 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 177559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177571 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 177577 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177582 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 177590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 177598 */     GIR_RootConstrainSelectedInstOperands,
     /* 177599 */     // GIR_Coverage, 6335,
     /* 177599 */     GIR_EraseRootFromParent_Done,
     /* 177600 */   // Label 3280: @177600
     /* 177600 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(177697), // Rule ID 13974 //
     /* 177605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177647 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177657 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 177657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177669 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 177675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 177688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177695 */     GIR_RootConstrainSelectedInstOperands,
     /* 177696 */     // GIR_Coverage, 13974,
     /* 177696 */     GIR_EraseRootFromParent_Done,
     /* 177697 */   // Label 3281: @177697
     /* 177697 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(177794), // Rule ID 13975 //
     /* 177702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177744 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177754 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 177754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177766 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 177772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 177785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177792 */     GIR_RootConstrainSelectedInstOperands,
     /* 177793 */     // GIR_Coverage, 13975,
     /* 177793 */     GIR_EraseRootFromParent_Done,
     /* 177794 */   // Label 3282: @177794
     /* 177794 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(177891), // Rule ID 13976 //
     /* 177799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 177832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177841 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177851 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 177851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 177854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177863 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 177869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 177882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177889 */     GIR_RootConstrainSelectedInstOperands,
     /* 177890 */     // GIR_Coverage, 13976,
     /* 177890 */     GIR_EraseRootFromParent_Done,
     /* 177891 */   // Label 3283: @177891
     /* 177891 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(177974), // Rule ID 1742 //
     /* 177896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 177904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 177929 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 177932 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177941 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177957 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 177957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 177960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 177964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 177968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 177972 */     GIR_RootConstrainSelectedInstOperands,
     /* 177973 */     // GIR_Coverage, 1742,
     /* 177973 */     GIR_EraseRootFromParent_Done,
     /* 177974 */   // Label 3284: @177974
     /* 177974 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(178057), // Rule ID 1744 //
     /* 177979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 177987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 177993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 177996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 178012 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 178015 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 178020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178024 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178040 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 178040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 178043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 178051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 178055 */     GIR_RootConstrainSelectedInstOperands,
     /* 178056 */     // GIR_Coverage, 1744,
     /* 178056 */     GIR_EraseRootFromParent_Done,
     /* 178057 */   // Label 3285: @178057
     /* 178057 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(178140), // Rule ID 1746 //
     /* 178062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 178070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 178095 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 178098 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 178103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178107 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178123 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 178123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 178126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 178134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 178138 */     GIR_RootConstrainSelectedInstOperands,
     /* 178139 */     // GIR_Coverage, 1746,
     /* 178139 */     GIR_EraseRootFromParent_Done,
     /* 178140 */   // Label 3286: @178140
     /* 178140 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(178223), // Rule ID 1748 //
     /* 178145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 178153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 178178 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 178181 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 178186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178190 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178206 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 178206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 178209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 178217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 178221 */     GIR_RootConstrainSelectedInstOperands,
     /* 178222 */     // GIR_Coverage, 1748,
     /* 178222 */     GIR_EraseRootFromParent_Done,
     /* 178223 */   // Label 3287: @178223
     /* 178223 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(178303), // Rule ID 5273 //
     /* 178228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 178233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 178258 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 178261 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 178266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 178270 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 178274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178286 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 178289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 178297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 178301 */     GIR_RootConstrainSelectedInstOperands,
     /* 178302 */     // GIR_Coverage, 5273,
     /* 178302 */     GIR_EraseRootFromParent_Done,
     /* 178303 */   // Label 3288: @178303
     /* 178303 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(178383), // Rule ID 5274 //
     /* 178308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 178313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 178338 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 178341 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 178346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 178350 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 178354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178366 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 178369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 178373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 178377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 178381 */     GIR_RootConstrainSelectedInstOperands,
     /* 178382 */     // GIR_Coverage, 5274,
     /* 178382 */     GIR_EraseRootFromParent_Done,
     /* 178383 */   // Label 3289: @178383
     /* 178383 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(178480), // Rule ID 5270 //
     /* 178388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 178391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 178402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 178405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178434 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 178438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178440 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 178440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 178443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 178447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178452 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 178458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 178471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178478 */     GIR_RootConstrainSelectedInstOperands,
     /* 178479 */     // GIR_Coverage, 5270,
     /* 178479 */     GIR_EraseRootFromParent_Done,
     /* 178480 */   // Label 3290: @178480
     /* 178480 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(178577), // Rule ID 5271 //
     /* 178485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178531 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 178535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178537 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 178537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 178540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 178544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178549 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 178555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 178568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178575 */     GIR_RootConstrainSelectedInstOperands,
     /* 178576 */     // GIR_Coverage, 5271,
     /* 178576 */     GIR_EraseRootFromParent_Done,
     /* 178577 */   // Label 3291: @178577
     /* 178577 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(178674), // Rule ID 5272 //
     /* 178582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178628 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 178632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178634 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 178634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 178641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178646 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 178652 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 178665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178672 */     GIR_RootConstrainSelectedInstOperands,
     /* 178673 */     // GIR_Coverage, 5272,
     /* 178673 */     GIR_EraseRootFromParent_Done,
     /* 178674 */   // Label 3292: @178674
     /* 178674 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(178755), // Rule ID 13518 //
     /* 178679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178729 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178733 */     // MIs[2] Operand 1
     /* 178733 */     // No operand predicates
     /* 178733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178739 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 178742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178753 */     GIR_RootConstrainSelectedInstOperands,
     /* 178754 */     // GIR_Coverage, 13518,
     /* 178754 */     GIR_EraseRootFromParent_Done,
     /* 178755 */   // Label 3293: @178755
     /* 178755 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(178836), // Rule ID 13519 //
     /* 178760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 178771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178810 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178814 */     // MIs[2] Operand 1
     /* 178814 */     // No operand predicates
     /* 178814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178820 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 178823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178834 */     GIR_RootConstrainSelectedInstOperands,
     /* 178835 */     // GIR_Coverage, 13519,
     /* 178835 */     GIR_EraseRootFromParent_Done,
     /* 178836 */   // Label 3294: @178836
     /* 178836 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(178917), // Rule ID 13521 //
     /* 178841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178891 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178895 */     // MIs[2] Operand 1
     /* 178895 */     // No operand predicates
     /* 178895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178901 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 178904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178915 */     GIR_RootConstrainSelectedInstOperands,
     /* 178916 */     // GIR_Coverage, 13521,
     /* 178916 */     GIR_EraseRootFromParent_Done,
     /* 178917 */   // Label 3295: @178917
     /* 178917 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(178998), // Rule ID 13522 //
     /* 178922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178972 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178976 */     // MIs[2] Operand 1
     /* 178976 */     // No operand predicates
     /* 178976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178982 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 178985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178996 */     GIR_RootConstrainSelectedInstOperands,
     /* 178997 */     // GIR_Coverage, 13522,
     /* 178997 */     GIR_EraseRootFromParent_Done,
     /* 178998 */   // Label 3296: @178998
     /* 178998 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(179079), // Rule ID 13523 //
     /* 179003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 179032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 179036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179053 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 179057 */     // MIs[2] Operand 1
     /* 179057 */     // No operand predicates
     /* 179057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179063 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 179066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179077 */     GIR_RootConstrainSelectedInstOperands,
     /* 179078 */     // GIR_Coverage, 13523,
     /* 179078 */     GIR_EraseRootFromParent_Done,
     /* 179079 */   // Label 3297: @179079
     /* 179079 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(179160), // Rule ID 13524 //
     /* 179084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 179087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 179095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 179098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 179101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 179113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179134 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179138 */     // MIs[2] Operand 1
     /* 179138 */     // No operand predicates
     /* 179138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179144 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 179147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179158 */     GIR_RootConstrainSelectedInstOperands,
     /* 179159 */     // GIR_Coverage, 13524,
     /* 179159 */     GIR_EraseRootFromParent_Done,
     /* 179160 */   // Label 3298: @179160
     /* 179160 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(179241), // Rule ID 13525 //
     /* 179165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 179194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179215 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179219 */     // MIs[2] Operand 1
     /* 179219 */     // No operand predicates
     /* 179219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179225 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 179228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179239 */     GIR_RootConstrainSelectedInstOperands,
     /* 179240 */     // GIR_Coverage, 13525,
     /* 179240 */     GIR_EraseRootFromParent_Done,
     /* 179241 */   // Label 3299: @179241
     /* 179241 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(179322), // Rule ID 13526 //
     /* 179246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 179275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 179279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179296 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 179300 */     // MIs[2] Operand 1
     /* 179300 */     // No operand predicates
     /* 179300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179306 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 179309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179320 */     GIR_RootConstrainSelectedInstOperands,
     /* 179321 */     // GIR_Coverage, 13526,
     /* 179321 */     GIR_EraseRootFromParent_Done,
     /* 179322 */   // Label 3300: @179322
     /* 179322 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(179428), // Rule ID 6332 //
     /* 179327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 179332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 179335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 179349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 179353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 179357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179362 */     // MIs[1] Operand 2
     /* 179362 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 179373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 179377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179381 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 179385 */     // MIs[2] Operand 1
     /* 179385 */     // No operand predicates
     /* 179385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179387 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 179387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 179390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 179394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179399 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 179405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 179410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 179418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 179423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 179426 */     GIR_RootConstrainSelectedInstOperands,
     /* 179427 */     // GIR_Coverage, 6332,
     /* 179427 */     GIR_EraseRootFromParent_Done,
     /* 179428 */   // Label 3301: @179428
     /* 179428 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(179509), // Rule ID 1988 //
     /* 179433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 179436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179487 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179491 */     // MIs[2] Operand 1
     /* 179491 */     // No operand predicates
     /* 179491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179493 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 179496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179507 */     GIR_RootConstrainSelectedInstOperands,
     /* 179508 */     // GIR_Coverage, 1988,
     /* 179508 */     GIR_EraseRootFromParent_Done,
     /* 179509 */   // Label 3302: @179509
     /* 179509 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(179590), // Rule ID 1989 //
     /* 179514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 179517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179568 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179572 */     // MIs[2] Operand 1
     /* 179572 */     // No operand predicates
     /* 179572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179574 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 179577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179588 */     GIR_RootConstrainSelectedInstOperands,
     /* 179589 */     // GIR_Coverage, 1989,
     /* 179589 */     GIR_EraseRootFromParent_Done,
     /* 179590 */   // Label 3303: @179590
     /* 179590 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(179671), // Rule ID 2018 //
     /* 179595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179649 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179653 */     // MIs[2] Operand 1
     /* 179653 */     // No operand predicates
     /* 179653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179655 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 179658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179669 */     GIR_RootConstrainSelectedInstOperands,
     /* 179670 */     // GIR_Coverage, 2018,
     /* 179670 */     GIR_EraseRootFromParent_Done,
     /* 179671 */   // Label 3304: @179671
     /* 179671 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(179752), // Rule ID 2019 //
     /* 179676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179730 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179734 */     // MIs[2] Operand 1
     /* 179734 */     // No operand predicates
     /* 179734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179736 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 179739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179750 */     GIR_RootConstrainSelectedInstOperands,
     /* 179751 */     // GIR_Coverage, 2019,
     /* 179751 */     GIR_EraseRootFromParent_Done,
     /* 179752 */   // Label 3305: @179752
     /* 179752 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(179833), // Rule ID 2025 //
     /* 179757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179811 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179815 */     // MIs[2] Operand 1
     /* 179815 */     // No operand predicates
     /* 179815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179817 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 179820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179831 */     GIR_RootConstrainSelectedInstOperands,
     /* 179832 */     // GIR_Coverage, 2025,
     /* 179832 */     GIR_EraseRootFromParent_Done,
     /* 179833 */   // Label 3306: @179833
     /* 179833 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(179914), // Rule ID 2026 //
     /* 179838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179892 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179896 */     // MIs[2] Operand 1
     /* 179896 */     // No operand predicates
     /* 179896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179898 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 179901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179912 */     GIR_RootConstrainSelectedInstOperands,
     /* 179913 */     // GIR_Coverage, 2026,
     /* 179913 */     GIR_EraseRootFromParent_Done,
     /* 179914 */   // Label 3307: @179914
     /* 179914 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(179995), // Rule ID 2084 //
     /* 179919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 179927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179973 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179977 */     // MIs[2] Operand 1
     /* 179977 */     // No operand predicates
     /* 179977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179979 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 179982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179993 */     GIR_RootConstrainSelectedInstOperands,
     /* 179994 */     // GIR_Coverage, 2084,
     /* 179994 */     GIR_EraseRootFromParent_Done,
     /* 179995 */   // Label 3308: @179995
     /* 179995 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(180076), // Rule ID 1991 //
     /* 180000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180054 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180058 */     // MIs[2] Operand 1
     /* 180058 */     // No operand predicates
     /* 180058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180060 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 180063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180074 */     GIR_RootConstrainSelectedInstOperands,
     /* 180075 */     // GIR_Coverage, 1991,
     /* 180075 */     GIR_EraseRootFromParent_Done,
     /* 180076 */   // Label 3309: @180076
     /* 180076 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(180157), // Rule ID 1992 //
     /* 180081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180135 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180139 */     // MIs[2] Operand 1
     /* 180139 */     // No operand predicates
     /* 180139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180141 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 180144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180155 */     GIR_RootConstrainSelectedInstOperands,
     /* 180156 */     // GIR_Coverage, 1992,
     /* 180156 */     GIR_EraseRootFromParent_Done,
     /* 180157 */   // Label 3310: @180157
     /* 180157 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(180238), // Rule ID 2021 //
     /* 180162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 180170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180216 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180220 */     // MIs[2] Operand 1
     /* 180220 */     // No operand predicates
     /* 180220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180222 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 180225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180236 */     GIR_RootConstrainSelectedInstOperands,
     /* 180237 */     // GIR_Coverage, 2021,
     /* 180237 */     GIR_EraseRootFromParent_Done,
     /* 180238 */   // Label 3311: @180238
     /* 180238 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(180319), // Rule ID 2022 //
     /* 180243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 180251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180297 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180301 */     // MIs[2] Operand 1
     /* 180301 */     // No operand predicates
     /* 180301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180303 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 180306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180317 */     GIR_RootConstrainSelectedInstOperands,
     /* 180318 */     // GIR_Coverage, 2022,
     /* 180318 */     GIR_EraseRootFromParent_Done,
     /* 180319 */   // Label 3312: @180319
     /* 180319 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(180400), // Rule ID 2028 //
     /* 180324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 180332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180378 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180382 */     // MIs[2] Operand 1
     /* 180382 */     // No operand predicates
     /* 180382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180384 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 180387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180398 */     GIR_RootConstrainSelectedInstOperands,
     /* 180399 */     // GIR_Coverage, 2028,
     /* 180399 */     GIR_EraseRootFromParent_Done,
     /* 180400 */   // Label 3313: @180400
     /* 180400 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(180481), // Rule ID 2029 //
     /* 180405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 180413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180459 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180463 */     // MIs[2] Operand 1
     /* 180463 */     // No operand predicates
     /* 180463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180465 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 180468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180479 */     GIR_RootConstrainSelectedInstOperands,
     /* 180480 */     // GIR_Coverage, 2029,
     /* 180480 */     GIR_EraseRootFromParent_Done,
     /* 180481 */   // Label 3314: @180481
     /* 180481 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(180562), // Rule ID 2087 //
     /* 180486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 180494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 180519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180540 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180544 */     // MIs[2] Operand 1
     /* 180544 */     // No operand predicates
     /* 180544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180546 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 180549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180560 */     GIR_RootConstrainSelectedInstOperands,
     /* 180561 */     // GIR_Coverage, 2087,
     /* 180561 */     GIR_EraseRootFromParent_Done,
     /* 180562 */   // Label 3315: @180562
     /* 180562 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(180643), // Rule ID 1993 //
     /* 180567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 180600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 180604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180621 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 180625 */     // MIs[2] Operand 1
     /* 180625 */     // No operand predicates
     /* 180625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180627 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 180630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180641 */     GIR_RootConstrainSelectedInstOperands,
     /* 180642 */     // GIR_Coverage, 1993,
     /* 180642 */     GIR_EraseRootFromParent_Done,
     /* 180643 */   // Label 3316: @180643
     /* 180643 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(180724), // Rule ID 1994 //
     /* 180648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 180651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 180659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 180662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 180665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 180685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 180694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180702 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 180706 */     // MIs[2] Operand 1
     /* 180706 */     // No operand predicates
     /* 180706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180708 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 180711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180722 */     GIR_RootConstrainSelectedInstOperands,
     /* 180723 */     // GIR_Coverage, 1994,
     /* 180723 */     GIR_EraseRootFromParent_Done,
     /* 180724 */   // Label 3317: @180724
     /* 180724 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(180805), // Rule ID 1995 //
     /* 180729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180783 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180787 */     // MIs[2] Operand 1
     /* 180787 */     // No operand predicates
     /* 180787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180789 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 180792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180803 */     GIR_RootConstrainSelectedInstOperands,
     /* 180804 */     // GIR_Coverage, 1995,
     /* 180804 */     GIR_EraseRootFromParent_Done,
     /* 180805 */   // Label 3318: @180805
     /* 180805 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(180886), // Rule ID 1996 //
     /* 180810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 180847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180864 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 180868 */     // MIs[2] Operand 1
     /* 180868 */     // No operand predicates
     /* 180868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180870 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 180873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180884 */     GIR_RootConstrainSelectedInstOperands,
     /* 180885 */     // GIR_Coverage, 1996,
     /* 180885 */     GIR_EraseRootFromParent_Done,
     /* 180886 */   // Label 3319: @180886
     /* 180886 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(180967), // Rule ID 2023 //
     /* 180891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 180899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180945 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180949 */     // MIs[2] Operand 1
     /* 180949 */     // No operand predicates
     /* 180949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180951 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 180954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180965 */     GIR_RootConstrainSelectedInstOperands,
     /* 180966 */     // GIR_Coverage, 2023,
     /* 180966 */     GIR_EraseRootFromParent_Done,
     /* 180967 */   // Label 3320: @180967
     /* 180967 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(181048), // Rule ID 2030 //
     /* 180972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 180980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 181005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 181013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 181022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181026 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 181030 */     // MIs[2] Operand 1
     /* 181030 */     // No operand predicates
     /* 181030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 181032 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 181032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 181035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 181043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 181046 */     GIR_RootConstrainSelectedInstOperands,
     /* 181047 */     // GIR_Coverage, 2030,
     /* 181047 */     GIR_EraseRootFromParent_Done,
     /* 181048 */   // Label 3321: @181048
     /* 181048 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(181126), // Rule ID 6319 //
     /* 181053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 181058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 181083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 181091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 181100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181104 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 181108 */     // MIs[2] Operand 1
     /* 181108 */     // No operand predicates
     /* 181108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 181110 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 181110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 181113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 181121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 181124 */     GIR_RootConstrainSelectedInstOperands,
     /* 181125 */     // GIR_Coverage, 6319,
     /* 181125 */     GIR_EraseRootFromParent_Done,
     /* 181126 */   // Label 3322: @181126
     /* 181126 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(181186), // Rule ID 6385 //
     /* 181131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 181139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 181157 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 181157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 181160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 181164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181169 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 181172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 181177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181184 */     GIR_RootConstrainSelectedInstOperands,
     /* 181185 */     // GIR_Coverage, 6385,
     /* 181185 */     GIR_EraseRootFromParent_Done,
     /* 181186 */   // Label 3323: @181186
     /* 181186 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(181246), // Rule ID 6386 //
     /* 181191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 181217 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 181217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 181220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 181224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181229 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 181232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 181237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181244 */     GIR_RootConstrainSelectedInstOperands,
     /* 181245 */     // GIR_Coverage, 6386,
     /* 181245 */     GIR_EraseRootFromParent_Done,
     /* 181246 */   // Label 3324: @181246
     /* 181246 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(181306), // Rule ID 6387 //
     /* 181251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 181277 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 181277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 181280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 181284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181289 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 181292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 181297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181304 */     GIR_RootConstrainSelectedInstOperands,
     /* 181305 */     // GIR_Coverage, 6387,
     /* 181305 */     GIR_EraseRootFromParent_Done,
     /* 181306 */   // Label 3325: @181306
     /* 181306 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(181353), // Rule ID 3897 //
     /* 181311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 181314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 181319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181333 */     // MIs[0] Operand 3
     /* 181333 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 181344 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 181344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 181347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181351 */     GIR_RootConstrainSelectedInstOperands,
     /* 181352 */     // GIR_Coverage, 3897,
     /* 181352 */     GIR_EraseRootFromParent_Done,
     /* 181353 */   // Label 3326: @181353
     /* 181353 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(181400), // Rule ID 3898 //
     /* 181358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 181361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 181366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181380 */     // MIs[0] Operand 3
     /* 181380 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 181391 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 181391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 181394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181398 */     GIR_RootConstrainSelectedInstOperands,
     /* 181399 */     // GIR_Coverage, 3898,
     /* 181399 */     GIR_EraseRootFromParent_Done,
     /* 181400 */   // Label 3327: @181400
     /* 181400 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(181447), // Rule ID 3899 //
     /* 181405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 181408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 181413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181427 */     // MIs[0] Operand 3
     /* 181427 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 181438 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 181438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 181441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181445 */     GIR_RootConstrainSelectedInstOperands,
     /* 181446 */     // GIR_Coverage, 3899,
     /* 181446 */     GIR_EraseRootFromParent_Done,
     /* 181447 */   // Label 3328: @181447
     /* 181447 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(181494), // Rule ID 3900 //
     /* 181452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 181455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 181460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181474 */     // MIs[0] Operand 3
     /* 181474 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 181485 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 181485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 181488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 181492 */     GIR_RootConstrainSelectedInstOperands,
     /* 181493 */     // GIR_Coverage, 3900,
     /* 181493 */     GIR_EraseRootFromParent_Done,
     /* 181494 */   // Label 3329: @181494
     /* 181494 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(181540), // Rule ID 3544 //
     /* 181499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 181507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 181510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 181513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181521 */     // MIs[0] Idx
     /* 181521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 181529 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 181529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 181532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 181536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 181538 */     GIR_RootConstrainSelectedInstOperands,
     /* 181539 */     // GIR_Coverage, 3544,
     /* 181539 */     GIR_EraseRootFromParent_Done,
     /* 181540 */   // Label 3330: @181540
     /* 181540 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(181586), // Rule ID 3545 //
     /* 181545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 181553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 181556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 181559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181567 */     // MIs[0] Idx
     /* 181567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181570 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 181575 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 181575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 181578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 181582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 181584 */     GIR_RootConstrainSelectedInstOperands,
     /* 181585 */     // GIR_Coverage, 3545,
     /* 181585 */     GIR_EraseRootFromParent_Done,
     /* 181586 */   // Label 3331: @181586
     /* 181586 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(181632), // Rule ID 3546 //
     /* 181591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 181599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 181602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 181605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181613 */     // MIs[0] Idx
     /* 181613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181616 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 181621 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 181621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 181624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 181628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 181630 */     GIR_RootConstrainSelectedInstOperands,
     /* 181631 */     // GIR_Coverage, 3546,
     /* 181631 */     GIR_EraseRootFromParent_Done,
     /* 181632 */   // Label 3332: @181632
     /* 181632 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(181678), // Rule ID 3547 //
     /* 181637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 181640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 181645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 181648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 181651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 181659 */     // MIs[0] Idx
     /* 181659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 181662 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 181667 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1626:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 181667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 181670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 181674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 181676 */     GIR_RootConstrainSelectedInstOperands,
     /* 181677 */     // GIR_Coverage, 3547,
     /* 181677 */     GIR_EraseRootFromParent_Done,
     /* 181678 */   // Label 3333: @181678
     /* 181678 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(181734), // Rule ID 2109 //
     /* 181683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 181691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181720 */     // MIs[1] Operand 1
     /* 181720 */     // No operand predicates
     /* 181720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181722 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 181725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181732 */     GIR_RootConstrainSelectedInstOperands,
     /* 181733 */     // GIR_Coverage, 2109,
     /* 181733 */     GIR_EraseRootFromParent_Done,
     /* 181734 */   // Label 3334: @181734
     /* 181734 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(181790), // Rule ID 2110 //
     /* 181739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 181747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181776 */     // MIs[1] Operand 1
     /* 181776 */     // No operand predicates
     /* 181776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181778 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 181781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181788 */     GIR_RootConstrainSelectedInstOperands,
     /* 181789 */     // GIR_Coverage, 2110,
     /* 181789 */     GIR_EraseRootFromParent_Done,
     /* 181790 */   // Label 3335: @181790
     /* 181790 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(181846), // Rule ID 2115 //
     /* 181795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 181803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181832 */     // MIs[1] Operand 1
     /* 181832 */     // No operand predicates
     /* 181832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181834 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 181837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181844 */     GIR_RootConstrainSelectedInstOperands,
     /* 181845 */     // GIR_Coverage, 2115,
     /* 181845 */     GIR_EraseRootFromParent_Done,
     /* 181846 */   // Label 3336: @181846
     /* 181846 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(181902), // Rule ID 2116 //
     /* 181851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 181859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181888 */     // MIs[1] Operand 1
     /* 181888 */     // No operand predicates
     /* 181888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181890 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 181893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181900 */     GIR_RootConstrainSelectedInstOperands,
     /* 181901 */     // GIR_Coverage, 2116,
     /* 181901 */     GIR_EraseRootFromParent_Done,
     /* 181902 */   // Label 3337: @181902
     /* 181902 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(181958), // Rule ID 2123 //
     /* 181907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 181915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181944 */     // MIs[1] Operand 1
     /* 181944 */     // No operand predicates
     /* 181944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181946 */     // (intrinsic_wo_chain:{ *:[i32] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 181949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181956 */     GIR_RootConstrainSelectedInstOperands,
     /* 181957 */     // GIR_Coverage, 2123,
     /* 181957 */     GIR_EraseRootFromParent_Done,
     /* 181958 */   // Label 3338: @181958
     /* 181958 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(182014), // Rule ID 2126 //
     /* 181963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 181971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182000 */     // MIs[1] Operand 1
     /* 182000 */     // No operand predicates
     /* 182000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182002 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 182002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 182005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182012 */     GIR_RootConstrainSelectedInstOperands,
     /* 182013 */     // GIR_Coverage, 2126,
     /* 182013 */     GIR_EraseRootFromParent_Done,
     /* 182014 */   // Label 3339: @182014
     /* 182014 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(182070), // Rule ID 2148 //
     /* 182019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 182027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 182030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 182033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 182056 */     // MIs[1] Operand 1
     /* 182056 */     // No operand predicates
     /* 182056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182058 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 182058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 182061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182068 */     GIR_RootConstrainSelectedInstOperands,
     /* 182069 */     // GIR_Coverage, 2148,
     /* 182069 */     GIR_EraseRootFromParent_Done,
     /* 182070 */   // Label 3340: @182070
     /* 182070 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(182126), // Rule ID 2150 //
     /* 182075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 182083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 182086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 182089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 182112 */     // MIs[1] Operand 1
     /* 182112 */     // No operand predicates
     /* 182112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182114 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 182114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 182117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182124 */     GIR_RootConstrainSelectedInstOperands,
     /* 182125 */     // GIR_Coverage, 2150,
     /* 182125 */     GIR_EraseRootFromParent_Done,
     /* 182126 */   // Label 3341: @182126
     /* 182126 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(182182), // Rule ID 2152 //
     /* 182131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 182139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 182142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 182145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 182168 */     // MIs[1] Operand 1
     /* 182168 */     // No operand predicates
     /* 182168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182170 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 182170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 182173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182180 */     GIR_RootConstrainSelectedInstOperands,
     /* 182181 */     // GIR_Coverage, 2152,
     /* 182181 */     GIR_EraseRootFromParent_Done,
     /* 182182 */   // Label 3342: @182182
     /* 182182 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(182235), // Rule ID 6320 //
     /* 182187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 182192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182221 */     // MIs[1] Operand 1
     /* 182221 */     // No operand predicates
     /* 182221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182223 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 182223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 182226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182233 */     GIR_RootConstrainSelectedInstOperands,
     /* 182234 */     // GIR_Coverage, 6320,
     /* 182234 */     GIR_EraseRootFromParent_Done,
     /* 182235 */   // Label 3343: @182235
     /* 182235 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(182288), // Rule ID 6321 //
     /* 182240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 182245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182274 */     // MIs[1] Operand 1
     /* 182274 */     // No operand predicates
     /* 182274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182276 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 182276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 182279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182286 */     GIR_RootConstrainSelectedInstOperands,
     /* 182287 */     // GIR_Coverage, 6321,
     /* 182287 */     GIR_EraseRootFromParent_Done,
     /* 182288 */   // Label 3344: @182288
     /* 182288 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(182341), // Rule ID 6322 //
     /* 182293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 182298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182327 */     // MIs[1] Operand 1
     /* 182327 */     // No operand predicates
     /* 182327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182329 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 182332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182339 */     GIR_RootConstrainSelectedInstOperands,
     /* 182340 */     // GIR_Coverage, 6322,
     /* 182340 */     GIR_EraseRootFromParent_Done,
     /* 182341 */   // Label 3345: @182341
     /* 182341 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(182394), // Rule ID 6323 //
     /* 182346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 182351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182380 */     // MIs[1] Operand 1
     /* 182380 */     // No operand predicates
     /* 182380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182382 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 182385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182392 */     GIR_RootConstrainSelectedInstOperands,
     /* 182393 */     // GIR_Coverage, 6323,
     /* 182393 */     GIR_EraseRootFromParent_Done,
     /* 182394 */   // Label 3346: @182394
     /* 182394 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(182447), // Rule ID 6324 //
     /* 182399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 182404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182433 */     // MIs[1] Operand 1
     /* 182433 */     // No operand predicates
     /* 182433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182435 */     // (intrinsic_wo_chain:{ *:[v1i64] } 762:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 182438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182445 */     GIR_RootConstrainSelectedInstOperands,
     /* 182446 */     // GIR_Coverage, 6324,
     /* 182446 */     GIR_EraseRootFromParent_Done,
     /* 182447 */   // Label 3347: @182447
     /* 182447 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(182500), // Rule ID 6325 //
     /* 182452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 182457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182486 */     // MIs[1] Operand 1
     /* 182486 */     // No operand predicates
     /* 182486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182488 */     // (intrinsic_wo_chain:{ *:[v1i64] } 763:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 182491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182498 */     GIR_RootConstrainSelectedInstOperands,
     /* 182499 */     // GIR_Coverage, 6325,
     /* 182499 */     GIR_EraseRootFromParent_Done,
     /* 182500 */   // Label 3348: @182500
     /* 182500 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(182553), // Rule ID 6326 //
     /* 182505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182539 */     // MIs[1] Operand 1
     /* 182539 */     // No operand predicates
     /* 182539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182541 */     // (intrinsic_wo_chain:{ *:[f32] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 182541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 182544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182551 */     GIR_RootConstrainSelectedInstOperands,
     /* 182552 */     // GIR_Coverage, 6326,
     /* 182552 */     GIR_EraseRootFromParent_Done,
     /* 182553 */   // Label 3349: @182553
     /* 182553 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(182606), // Rule ID 6327 //
     /* 182558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182592 */     // MIs[1] Operand 1
     /* 182592 */     // No operand predicates
     /* 182592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182594 */     // (intrinsic_wo_chain:{ *:[f64] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 182597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182604 */     GIR_RootConstrainSelectedInstOperands,
     /* 182605 */     // GIR_Coverage, 6327,
     /* 182605 */     GIR_EraseRootFromParent_Done,
     /* 182606 */   // Label 3350: @182606
     /* 182606 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(182659), // Rule ID 6328 //
     /* 182611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182645 */     // MIs[1] Operand 1
     /* 182645 */     // No operand predicates
     /* 182645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182647 */     // (intrinsic_wo_chain:{ *:[v1f64] } 765:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 182650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182657 */     GIR_RootConstrainSelectedInstOperands,
     /* 182658 */     // GIR_Coverage, 6328,
     /* 182658 */     GIR_EraseRootFromParent_Done,
     /* 182659 */   // Label 3351: @182659
     /* 182659 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(182712), // Rule ID 6329 //
     /* 182664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182698 */     // MIs[1] Operand 1
     /* 182698 */     // No operand predicates
     /* 182698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182700 */     // (intrinsic_wo_chain:{ *:[f64] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 182703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182710 */     GIR_RootConstrainSelectedInstOperands,
     /* 182711 */     // GIR_Coverage, 6329,
     /* 182711 */     GIR_EraseRootFromParent_Done,
     /* 182712 */   // Label 3352: @182712
     /* 182712 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(182765), // Rule ID 6330 //
     /* 182717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182751 */     // MIs[1] Operand 1
     /* 182751 */     // No operand predicates
     /* 182751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182753 */     // (intrinsic_wo_chain:{ *:[v1f64] } 766:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 182756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182763 */     GIR_RootConstrainSelectedInstOperands,
     /* 182764 */     // GIR_Coverage, 6330,
     /* 182764 */     GIR_EraseRootFromParent_Done,
     /* 182765 */   // Label 3353: @182765
     /* 182765 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(182818), // Rule ID 6331 //
     /* 182770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182804 */     // MIs[1] Operand 1
     /* 182804 */     // No operand predicates
     /* 182804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182806 */     // (intrinsic_wo_chain:{ *:[f32] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 182806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 182809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182816 */     GIR_RootConstrainSelectedInstOperands,
     /* 182817 */     // GIR_Coverage, 6331,
     /* 182817 */     GIR_EraseRootFromParent_Done,
     /* 182818 */   // Label 3354: @182818
     /* 182818 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(182900), // Rule ID 6333 //
     /* 182823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182857 */     // MIs[1] Operand 1
     /* 182857 */     // No operand predicates
     /* 182857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182859 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182871 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 182890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182898 */     GIR_RootConstrainSelectedInstOperands,
     /* 182899 */     // GIR_Coverage, 6333,
     /* 182899 */     GIR_EraseRootFromParent_Done,
     /* 182900 */   // Label 3355: @182900
     /* 182900 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(182982), // Rule ID 6334 //
     /* 182905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182939 */     // MIs[1] Operand 1
     /* 182939 */     // No operand predicates
     /* 182939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182941 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182953 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 182972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182980 */     GIR_RootConstrainSelectedInstOperands,
     /* 182981 */     // GIR_Coverage, 6334,
     /* 182981 */     GIR_EraseRootFromParent_Done,
     /* 182982 */   // Label 3356: @182982
     /* 182982 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(183064), // Rule ID 6336 //
     /* 182987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 183021 */     // MIs[1] Operand 1
     /* 183021 */     // No operand predicates
     /* 183021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183023 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 183023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 183026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183035 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 183041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 183054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183062 */     GIR_RootConstrainSelectedInstOperands,
     /* 183063 */     // GIR_Coverage, 6336,
     /* 183063 */     GIR_EraseRootFromParent_Done,
     /* 183064 */   // Label 3357: @183064
     /* 183064 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(183146), // Rule ID 6337 //
     /* 183069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 183074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 183077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 183103 */     // MIs[1] Operand 1
     /* 183103 */     // No operand predicates
     /* 183103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183105 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 183105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 183108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183117 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 183123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 183136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 183144 */     GIR_RootConstrainSelectedInstOperands,
     /* 183145 */     // GIR_Coverage, 6337,
     /* 183145 */     GIR_EraseRootFromParent_Done,
     /* 183146 */   // Label 3358: @183146
     /* 183146 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(183252), // Rule ID 6338 //
     /* 183151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 183156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 183162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 183185 */     // MIs[1] Operand 1
     /* 183185 */     // No operand predicates
     /* 183185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183187 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 183187 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 183190 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 183194 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183199 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 183203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 183206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 183208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 183211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 183236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183251 */     // GIR_Coverage, 6338,
     /* 183251 */     GIR_EraseRootFromParent_Done,
     /* 183252 */   // Label 3359: @183252
     /* 183252 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(183358), // Rule ID 6339 //
     /* 183257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 183262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 183268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 183291 */     // MIs[1] Operand 1
     /* 183291 */     // No operand predicates
     /* 183291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183293 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 183293 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 183296 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 183300 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183305 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 183309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 183312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 183314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 183317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 183342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183357 */     // GIR_Coverage, 6339,
     /* 183357 */     GIR_EraseRootFromParent_Done,
     /* 183358 */   // Label 3360: @183358
     /* 183358 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(183464), // Rule ID 6340 //
     /* 183363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 183368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 183374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 183397 */     // MIs[1] Operand 1
     /* 183397 */     // No operand predicates
     /* 183397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183399 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 183399 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 183402 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 183406 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183411 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 183415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 183418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 183420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 183423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 183448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183458 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183463 */     // GIR_Coverage, 6340,
     /* 183463 */     GIR_EraseRootFromParent_Done,
     /* 183464 */   // Label 3361: @183464
     /* 183464 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(183570), // Rule ID 6341 //
     /* 183469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 183474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 183480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 183503 */     // MIs[1] Operand 1
     /* 183503 */     // No operand predicates
     /* 183503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183505 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 183505 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 183508 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 183512 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183517 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 183521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 183524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 183526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 183529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 183554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183569 */     // GIR_Coverage, 6341,
     /* 183569 */     GIR_EraseRootFromParent_Done,
     /* 183570 */   // Label 3362: @183570
     /* 183570 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(183628), // Rule ID 7032 //
     /* 183575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 183580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 183601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 183605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 183609 */     // MIs[1] Operand 1
     /* 183609 */     // No operand predicates
     /* 183609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183611 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (MOVKXi:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm), 48:{ *:[i32] })
     /* 183611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVKXi),
     /* 183614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 183618 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 183623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 183626 */     GIR_RootConstrainSelectedInstOperands,
     /* 183627 */     // GIR_Coverage, 7032,
     /* 183627 */     GIR_EraseRootFromParent_Done,
     /* 183628 */   // Label 3363: @183628
     /* 183628 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(183670), // Rule ID 3045 //
     /* 183633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 183641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183651 */     // MIs[0] Op2
     /* 183651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183654 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 183659 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1864:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 183659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 183662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183668 */     GIR_RootConstrainSelectedInstOperands,
     /* 183669 */     // GIR_Coverage, 3045,
     /* 183669 */     GIR_EraseRootFromParent_Done,
     /* 183670 */   // Label 3364: @183670
     /* 183670 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(183712), // Rule ID 3046 //
     /* 183675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 183683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183693 */     // MIs[0] Op2
     /* 183693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 183701 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 183701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 183704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183710 */     GIR_RootConstrainSelectedInstOperands,
     /* 183711 */     // GIR_Coverage, 3046,
     /* 183711 */     GIR_EraseRootFromParent_Done,
     /* 183712 */   // Label 3365: @183712
     /* 183712 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(183754), // Rule ID 3047 //
     /* 183717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 183725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183735 */     // MIs[0] Op2
     /* 183735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183738 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 183743 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1864:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 183743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 183746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183752 */     GIR_RootConstrainSelectedInstOperands,
     /* 183753 */     // GIR_Coverage, 3047,
     /* 183753 */     GIR_EraseRootFromParent_Done,
     /* 183754 */   // Label 3366: @183754
     /* 183754 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(183796), // Rule ID 3081 //
     /* 183759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183777 */     // MIs[0] Op2
     /* 183777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183780 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183785 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1845:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 183788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183794 */     GIR_RootConstrainSelectedInstOperands,
     /* 183795 */     // GIR_Coverage, 3081,
     /* 183795 */     GIR_EraseRootFromParent_Done,
     /* 183796 */   // Label 3367: @183796
     /* 183796 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(183838), // Rule ID 3082 //
     /* 183801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183819 */     // MIs[0] Op2
     /* 183819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183822 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183827 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1845:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 183830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183836 */     GIR_RootConstrainSelectedInstOperands,
     /* 183837 */     // GIR_Coverage, 3082,
     /* 183837 */     GIR_EraseRootFromParent_Done,
     /* 183838 */   // Label 3368: @183838
     /* 183838 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(183880), // Rule ID 3083 //
     /* 183843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183861 */     // MIs[0] Op2
     /* 183861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 183869 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1845:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 183869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 183872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183878 */     GIR_RootConstrainSelectedInstOperands,
     /* 183879 */     // GIR_Coverage, 3083,
     /* 183879 */     GIR_EraseRootFromParent_Done,
     /* 183880 */   // Label 3369: @183880
     /* 183880 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(183922), // Rule ID 3530 //
     /* 183885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183903 */     // MIs[0] Op2
     /* 183903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183906 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 183911 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1345:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 183911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 183914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183920 */     GIR_RootConstrainSelectedInstOperands,
     /* 183921 */     // GIR_Coverage, 3530,
     /* 183921 */     GIR_EraseRootFromParent_Done,
     /* 183922 */   // Label 3370: @183922
     /* 183922 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(183964), // Rule ID 3531 //
     /* 183927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183945 */     // MIs[0] Op2
     /* 183945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183948 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 183953 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1345:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 183953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 183956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183962 */     GIR_RootConstrainSelectedInstOperands,
     /* 183963 */     // GIR_Coverage, 3531,
     /* 183963 */     GIR_EraseRootFromParent_Done,
     /* 183964 */   // Label 3371: @183964
     /* 183964 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(184006), // Rule ID 3532 //
     /* 183969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183987 */     // MIs[0] Op2
     /* 183987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183990 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 183995 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1345:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 183995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 183998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184004 */     GIR_RootConstrainSelectedInstOperands,
     /* 184005 */     // GIR_Coverage, 3532,
     /* 184005 */     GIR_EraseRootFromParent_Done,
     /* 184006 */   // Label 3372: @184006
     /* 184006 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(184048), // Rule ID 3533 //
     /* 184011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 184014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 184019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184029 */     // MIs[0] Op2
     /* 184029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184032 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 184037 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1345:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 184037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 184040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184046 */     GIR_RootConstrainSelectedInstOperands,
     /* 184047 */     // GIR_Coverage, 3533,
     /* 184047 */     GIR_EraseRootFromParent_Done,
     /* 184048 */   // Label 3373: @184048
     /* 184048 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(184090), // Rule ID 3534 //
     /* 184053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 184056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 184061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184071 */     // MIs[0] Op2
     /* 184071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184074 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 184079 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1345:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 184079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 184082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184088 */     GIR_RootConstrainSelectedInstOperands,
     /* 184089 */     // GIR_Coverage, 3534,
     /* 184089 */     GIR_EraseRootFromParent_Done,
     /* 184090 */   // Label 3374: @184090
     /* 184090 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(184132), // Rule ID 3535 //
     /* 184095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 184098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 184103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184113 */     // MIs[0] Op2
     /* 184113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184116 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 184121 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1345:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 184121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 184124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184130 */     GIR_RootConstrainSelectedInstOperands,
     /* 184131 */     // GIR_Coverage, 3535,
     /* 184131 */     GIR_EraseRootFromParent_Done,
     /* 184132 */   // Label 3375: @184132
     /* 184132 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(184174), // Rule ID 3536 //
     /* 184137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 184140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 184145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184155 */     // MIs[0] Op2
     /* 184155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 184163 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1345:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 184163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 184166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184172 */     GIR_RootConstrainSelectedInstOperands,
     /* 184173 */     // GIR_Coverage, 3536,
     /* 184173 */     GIR_EraseRootFromParent_Done,
     /* 184174 */   // Label 3376: @184174
     /* 184174 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(184216), // Rule ID 11817 //
     /* 184179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 184187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184197 */     // MIs[0] Op2
     /* 184197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184200 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184205 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1839:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 184208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184214 */     GIR_RootConstrainSelectedInstOperands,
     /* 184215 */     // GIR_Coverage, 11817,
     /* 184215 */     GIR_EraseRootFromParent_Done,
     /* 184216 */   // Label 3377: @184216
     /* 184216 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(184258), // Rule ID 11818 //
     /* 184221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 184229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184239 */     // MIs[0] Op2
     /* 184239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184242 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184247 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1839:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 184250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184256 */     GIR_RootConstrainSelectedInstOperands,
     /* 184257 */     // GIR_Coverage, 11818,
     /* 184257 */     GIR_EraseRootFromParent_Done,
     /* 184258 */   // Label 3378: @184258
     /* 184258 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(184300), // Rule ID 11819 //
     /* 184263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 184271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184281 */     // MIs[0] Op2
     /* 184281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184284 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184289 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1839:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 184292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184298 */     GIR_RootConstrainSelectedInstOperands,
     /* 184299 */     // GIR_Coverage, 11819,
     /* 184299 */     GIR_EraseRootFromParent_Done,
     /* 184300 */   // Label 3379: @184300
     /* 184300 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(184342), // Rule ID 11820 //
     /* 184305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 184313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184323 */     // MIs[0] Op2
     /* 184323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184326 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184331 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1718:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 184334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184340 */     GIR_RootConstrainSelectedInstOperands,
     /* 184341 */     // GIR_Coverage, 11820,
     /* 184341 */     GIR_EraseRootFromParent_Done,
     /* 184342 */   // Label 3380: @184342
     /* 184342 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(184384), // Rule ID 11821 //
     /* 184347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 184355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184365 */     // MIs[0] Op2
     /* 184365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184373 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1718:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 184376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184382 */     GIR_RootConstrainSelectedInstOperands,
     /* 184383 */     // GIR_Coverage, 11821,
     /* 184383 */     GIR_EraseRootFromParent_Done,
     /* 184384 */   // Label 3381: @184384
     /* 184384 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(184426), // Rule ID 11822 //
     /* 184389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 184397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184407 */     // MIs[0] Op2
     /* 184407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184415 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1718:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 184418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184424 */     GIR_RootConstrainSelectedInstOperands,
     /* 184425 */     // GIR_Coverage, 11822,
     /* 184425 */     GIR_EraseRootFromParent_Done,
     /* 184426 */   // Label 3382: @184426
     /* 184426 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(184468), // Rule ID 11824 //
     /* 184431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 184439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184449 */     // MIs[0] Op2
     /* 184449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184452 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184457 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1676:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 184460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184466 */     GIR_RootConstrainSelectedInstOperands,
     /* 184467 */     // GIR_Coverage, 11824,
     /* 184467 */     GIR_EraseRootFromParent_Done,
     /* 184468 */   // Label 3383: @184468
     /* 184468 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(184510), // Rule ID 11826 //
     /* 184473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 184481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184491 */     // MIs[0] Op2
     /* 184491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184494 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184499 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1676:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 184502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184508 */     GIR_RootConstrainSelectedInstOperands,
     /* 184509 */     // GIR_Coverage, 11826,
     /* 184509 */     GIR_EraseRootFromParent_Done,
     /* 184510 */   // Label 3384: @184510
     /* 184510 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(184552), // Rule ID 11828 //
     /* 184515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 184523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184533 */     // MIs[0] Op2
     /* 184533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184541 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1676:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 184544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184550 */     GIR_RootConstrainSelectedInstOperands,
     /* 184551 */     // GIR_Coverage, 11828,
     /* 184551 */     GIR_EraseRootFromParent_Done,
     /* 184552 */   // Label 3385: @184552
     /* 184552 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(184594), // Rule ID 11829 //
     /* 184557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 184565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184575 */     // MIs[0] Op2
     /* 184575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184578 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184583 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1843:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 184586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184592 */     GIR_RootConstrainSelectedInstOperands,
     /* 184593 */     // GIR_Coverage, 11829,
     /* 184593 */     GIR_EraseRootFromParent_Done,
     /* 184594 */   // Label 3386: @184594
     /* 184594 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(184636), // Rule ID 11830 //
     /* 184599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 184607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184617 */     // MIs[0] Op2
     /* 184617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184620 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184625 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 184628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184634 */     GIR_RootConstrainSelectedInstOperands,
     /* 184635 */     // GIR_Coverage, 11830,
     /* 184635 */     GIR_EraseRootFromParent_Done,
     /* 184636 */   // Label 3387: @184636
     /* 184636 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(184678), // Rule ID 11831 //
     /* 184641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 184649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184659 */     // MIs[0] Op2
     /* 184659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184662 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184667 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 184670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184676 */     GIR_RootConstrainSelectedInstOperands,
     /* 184677 */     // GIR_Coverage, 11831,
     /* 184677 */     GIR_EraseRootFromParent_Done,
     /* 184678 */   // Label 3388: @184678
     /* 184678 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(184720), // Rule ID 11832 //
     /* 184683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184701 */     // MIs[0] Op2
     /* 184701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184704 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184709 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1833:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 184712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184718 */     GIR_RootConstrainSelectedInstOperands,
     /* 184719 */     // GIR_Coverage, 11832,
     /* 184719 */     GIR_EraseRootFromParent_Done,
     /* 184720 */   // Label 3389: @184720
     /* 184720 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(184762), // Rule ID 11833 //
     /* 184725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184743 */     // MIs[0] Op2
     /* 184743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184751 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1833:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 184754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184760 */     GIR_RootConstrainSelectedInstOperands,
     /* 184761 */     // GIR_Coverage, 11833,
     /* 184761 */     GIR_EraseRootFromParent_Done,
     /* 184762 */   // Label 3390: @184762
     /* 184762 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(184804), // Rule ID 11834 //
     /* 184767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184785 */     // MIs[0] Op2
     /* 184785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1833:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 184796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184802 */     GIR_RootConstrainSelectedInstOperands,
     /* 184803 */     // GIR_Coverage, 11834,
     /* 184803 */     GIR_EraseRootFromParent_Done,
     /* 184804 */   // Label 3391: @184804
     /* 184804 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(184846), // Rule ID 11835 //
     /* 184809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184827 */     // MIs[0] Op2
     /* 184827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184835 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2038:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 184838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184844 */     GIR_RootConstrainSelectedInstOperands,
     /* 184845 */     // GIR_Coverage, 11835,
     /* 184845 */     GIR_EraseRootFromParent_Done,
     /* 184846 */   // Label 3392: @184846
     /* 184846 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(184888), // Rule ID 11836 //
     /* 184851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184869 */     // MIs[0] Op2
     /* 184869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184872 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184877 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2038:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 184880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184886 */     GIR_RootConstrainSelectedInstOperands,
     /* 184887 */     // GIR_Coverage, 11836,
     /* 184887 */     GIR_EraseRootFromParent_Done,
     /* 184888 */   // Label 3393: @184888
     /* 184888 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(184930), // Rule ID 11837 //
     /* 184893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184911 */     // MIs[0] Op2
     /* 184911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184914 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184919 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2038:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 184922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184928 */     GIR_RootConstrainSelectedInstOperands,
     /* 184929 */     // GIR_Coverage, 11837,
     /* 184929 */     GIR_EraseRootFromParent_Done,
     /* 184930 */   // Label 3394: @184930
     /* 184930 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(184972), // Rule ID 11838 //
     /* 184935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 184943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184953 */     // MIs[0] Op2
     /* 184953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184956 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184961 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2035:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 184964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184970 */     GIR_RootConstrainSelectedInstOperands,
     /* 184971 */     // GIR_Coverage, 11838,
     /* 184971 */     GIR_EraseRootFromParent_Done,
     /* 184972 */   // Label 3395: @184972
     /* 184972 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(185014), // Rule ID 11839 //
     /* 184977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 184985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184995 */     // MIs[0] Op2
     /* 184995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184998 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 185003 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2035:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 185003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 185006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185012 */     GIR_RootConstrainSelectedInstOperands,
     /* 185013 */     // GIR_Coverage, 11839,
     /* 185013 */     GIR_EraseRootFromParent_Done,
     /* 185014 */   // Label 3396: @185014
     /* 185014 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(185056), // Rule ID 11840 //
     /* 185019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 185027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185037 */     // MIs[0] Op2
     /* 185037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185040 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 185045 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2035:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 185045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 185048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185054 */     GIR_RootConstrainSelectedInstOperands,
     /* 185055 */     // GIR_Coverage, 11840,
     /* 185055 */     GIR_EraseRootFromParent_Done,
     /* 185056 */   // Label 3397: @185056
     /* 185056 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(185098), // Rule ID 11898 //
     /* 185061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 185069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185079 */     // MIs[0] Op2
     /* 185079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185082 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 185087 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1865:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 185087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 185090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185096 */     GIR_RootConstrainSelectedInstOperands,
     /* 185097 */     // GIR_Coverage, 11898,
     /* 185097 */     GIR_EraseRootFromParent_Done,
     /* 185098 */   // Label 3398: @185098
     /* 185098 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(185140), // Rule ID 11899 //
     /* 185103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 185111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185121 */     // MIs[0] Op2
     /* 185121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185124 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 185129 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1865:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 185129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 185132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185138 */     GIR_RootConstrainSelectedInstOperands,
     /* 185139 */     // GIR_Coverage, 11899,
     /* 185139 */     GIR_EraseRootFromParent_Done,
     /* 185140 */   // Label 3399: @185140
     /* 185140 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(185182), // Rule ID 11900 //
     /* 185145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 185153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185163 */     // MIs[0] Op2
     /* 185163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185166 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 185171 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1865:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 185171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 185174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185180 */     GIR_RootConstrainSelectedInstOperands,
     /* 185181 */     // GIR_Coverage, 11900,
     /* 185181 */     GIR_EraseRootFromParent_Done,
     /* 185182 */   // Label 3400: @185182
     /* 185182 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(185224), // Rule ID 11901 //
     /* 185187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 185195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185205 */     // MIs[0] Op2
     /* 185205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185208 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 185213 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2058:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 185213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 185216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185222 */     GIR_RootConstrainSelectedInstOperands,
     /* 185223 */     // GIR_Coverage, 11901,
     /* 185223 */     GIR_EraseRootFromParent_Done,
     /* 185224 */   // Label 3401: @185224
     /* 185224 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(185266), // Rule ID 11902 //
     /* 185229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 185237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185247 */     // MIs[0] Op2
     /* 185247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185250 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 185255 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2058:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 185255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 185258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185264 */     GIR_RootConstrainSelectedInstOperands,
     /* 185265 */     // GIR_Coverage, 11902,
     /* 185265 */     GIR_EraseRootFromParent_Done,
     /* 185266 */   // Label 3402: @185266
     /* 185266 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(185308), // Rule ID 11903 //
     /* 185271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 185279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185289 */     // MIs[0] Op2
     /* 185289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 185297 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2058:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 185297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 185300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185306 */     GIR_RootConstrainSelectedInstOperands,
     /* 185307 */     // GIR_Coverage, 11903,
     /* 185307 */     GIR_EraseRootFromParent_Done,
     /* 185308 */   // Label 3403: @185308
     /* 185308 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(185350), // Rule ID 11904 //
     /* 185313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 185321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185331 */     // MIs[0] Op2
     /* 185331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 185339 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2059:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 185339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 185342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185348 */     GIR_RootConstrainSelectedInstOperands,
     /* 185349 */     // GIR_Coverage, 11904,
     /* 185349 */     GIR_EraseRootFromParent_Done,
     /* 185350 */   // Label 3404: @185350
     /* 185350 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(185392), // Rule ID 11905 //
     /* 185355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 185363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185373 */     // MIs[0] Op2
     /* 185373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185376 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 185381 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2059:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 185381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 185384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185390 */     GIR_RootConstrainSelectedInstOperands,
     /* 185391 */     // GIR_Coverage, 11905,
     /* 185391 */     GIR_EraseRootFromParent_Done,
     /* 185392 */   // Label 3405: @185392
     /* 185392 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(185434), // Rule ID 11906 //
     /* 185397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 185405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185415 */     // MIs[0] Op2
     /* 185415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 185418 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 185423 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2059:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 185423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 185426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185432 */     GIR_RootConstrainSelectedInstOperands,
     /* 185433 */     // GIR_Coverage, 11906,
     /* 185433 */     GIR_EraseRootFromParent_Done,
     /* 185434 */   // Label 3406: @185434
     /* 185434 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(185486), // Rule ID 2132 //
     /* 185439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 185447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185472 */     // MIs[1] Operand 1
     /* 185472 */     // No operand predicates
     /* 185472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185474 */     // (intrinsic_wo_chain:{ *:[v4i16] } 762:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 185477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185484 */     GIR_RootConstrainSelectedInstOperands,
     /* 185485 */     // GIR_Coverage, 2132,
     /* 185485 */     GIR_EraseRootFromParent_Done,
     /* 185486 */   // Label 3407: @185486
     /* 185486 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(185538), // Rule ID 2133 //
     /* 185491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 185499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185524 */     // MIs[1] Operand 1
     /* 185524 */     // No operand predicates
     /* 185524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185526 */     // (intrinsic_wo_chain:{ *:[v8i16] } 762:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 185529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185536 */     GIR_RootConstrainSelectedInstOperands,
     /* 185537 */     // GIR_Coverage, 2133,
     /* 185537 */     GIR_EraseRootFromParent_Done,
     /* 185538 */   // Label 3408: @185538
     /* 185538 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(185590), // Rule ID 2134 //
     /* 185543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 185551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185576 */     // MIs[1] Operand 1
     /* 185576 */     // No operand predicates
     /* 185576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185578 */     // (intrinsic_wo_chain:{ *:[v2i32] } 762:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 185581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185588 */     GIR_RootConstrainSelectedInstOperands,
     /* 185589 */     // GIR_Coverage, 2134,
     /* 185589 */     GIR_EraseRootFromParent_Done,
     /* 185590 */   // Label 3409: @185590
     /* 185590 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(185642), // Rule ID 2135 //
     /* 185595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 185603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185628 */     // MIs[1] Operand 1
     /* 185628 */     // No operand predicates
     /* 185628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185630 */     // (intrinsic_wo_chain:{ *:[v4i32] } 762:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 185633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185640 */     GIR_RootConstrainSelectedInstOperands,
     /* 185641 */     // GIR_Coverage, 2135,
     /* 185641 */     GIR_EraseRootFromParent_Done,
     /* 185642 */   // Label 3410: @185642
     /* 185642 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(185694), // Rule ID 2136 //
     /* 185647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 185655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185680 */     // MIs[1] Operand 1
     /* 185680 */     // No operand predicates
     /* 185680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185682 */     // (intrinsic_wo_chain:{ *:[v2i64] } 762:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 185685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185692 */     GIR_RootConstrainSelectedInstOperands,
     /* 185693 */     // GIR_Coverage, 2136,
     /* 185693 */     GIR_EraseRootFromParent_Done,
     /* 185694 */   // Label 3411: @185694
     /* 185694 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(185746), // Rule ID 2137 //
     /* 185699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185732 */     // MIs[1] Operand 1
     /* 185732 */     // No operand predicates
     /* 185732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185734 */     // (intrinsic_wo_chain:{ *:[v4i16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 185737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185744 */     GIR_RootConstrainSelectedInstOperands,
     /* 185745 */     // GIR_Coverage, 2137,
     /* 185745 */     GIR_EraseRootFromParent_Done,
     /* 185746 */   // Label 3412: @185746
     /* 185746 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(185798), // Rule ID 2138 //
     /* 185751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185784 */     // MIs[1] Operand 1
     /* 185784 */     // No operand predicates
     /* 185784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185786 */     // (intrinsic_wo_chain:{ *:[v8i16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 185789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185796 */     GIR_RootConstrainSelectedInstOperands,
     /* 185797 */     // GIR_Coverage, 2138,
     /* 185797 */     GIR_EraseRootFromParent_Done,
     /* 185798 */   // Label 3413: @185798
     /* 185798 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(185850), // Rule ID 2139 //
     /* 185803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185836 */     // MIs[1] Operand 1
     /* 185836 */     // No operand predicates
     /* 185836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185838 */     // (intrinsic_wo_chain:{ *:[v2i32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 185841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185848 */     GIR_RootConstrainSelectedInstOperands,
     /* 185849 */     // GIR_Coverage, 2139,
     /* 185849 */     GIR_EraseRootFromParent_Done,
     /* 185850 */   // Label 3414: @185850
     /* 185850 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(185902), // Rule ID 2140 //
     /* 185855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185888 */     // MIs[1] Operand 1
     /* 185888 */     // No operand predicates
     /* 185888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185890 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 185893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185900 */     GIR_RootConstrainSelectedInstOperands,
     /* 185901 */     // GIR_Coverage, 2140,
     /* 185901 */     GIR_EraseRootFromParent_Done,
     /* 185902 */   // Label 3415: @185902
     /* 185902 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(185954), // Rule ID 2141 //
     /* 185907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185940 */     // MIs[1] Operand 1
     /* 185940 */     // No operand predicates
     /* 185940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185942 */     // (intrinsic_wo_chain:{ *:[v2i64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 185945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185952 */     GIR_RootConstrainSelectedInstOperands,
     /* 185953 */     // GIR_Coverage, 2141,
     /* 185953 */     GIR_EraseRootFromParent_Done,
     /* 185954 */   // Label 3416: @185954
     /* 185954 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(186006), // Rule ID 2142 //
     /* 185959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185992 */     // MIs[1] Operand 1
     /* 185992 */     // No operand predicates
     /* 185992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185994 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 185997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186004 */     GIR_RootConstrainSelectedInstOperands,
     /* 186005 */     // GIR_Coverage, 2142,
     /* 186005 */     GIR_EraseRootFromParent_Done,
     /* 186006 */   // Label 3417: @186006
     /* 186006 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(186058), // Rule ID 2143 //
     /* 186011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 186019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186044 */     // MIs[1] Operand 1
     /* 186044 */     // No operand predicates
     /* 186044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186046 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 186049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186056 */     GIR_RootConstrainSelectedInstOperands,
     /* 186057 */     // GIR_Coverage, 2143,
     /* 186057 */     GIR_EraseRootFromParent_Done,
     /* 186058 */   // Label 3418: @186058
     /* 186058 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(186110), // Rule ID 2144 //
     /* 186063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 186071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186096 */     // MIs[1] Operand 1
     /* 186096 */     // No operand predicates
     /* 186096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186098 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 186101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186108 */     GIR_RootConstrainSelectedInstOperands,
     /* 186109 */     // GIR_Coverage, 2144,
     /* 186109 */     GIR_EraseRootFromParent_Done,
     /* 186110 */   // Label 3419: @186110
     /* 186110 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(186162), // Rule ID 2145 //
     /* 186115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 186123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186148 */     // MIs[1] Operand 1
     /* 186148 */     // No operand predicates
     /* 186148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186150 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 186153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186160 */     GIR_RootConstrainSelectedInstOperands,
     /* 186161 */     // GIR_Coverage, 2145,
     /* 186161 */     GIR_EraseRootFromParent_Done,
     /* 186162 */   // Label 3420: @186162
     /* 186162 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(186214), // Rule ID 2146 //
     /* 186167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 186175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186200 */     // MIs[1] Operand 1
     /* 186200 */     // No operand predicates
     /* 186200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186202 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 186205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186212 */     GIR_RootConstrainSelectedInstOperands,
     /* 186213 */     // GIR_Coverage, 2146,
     /* 186213 */     GIR_EraseRootFromParent_Done,
     /* 186214 */   // Label 3421: @186214
     /* 186214 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(186266), // Rule ID 2244 //
     /* 186219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 186227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186252 */     // MIs[1] Operand 1
     /* 186252 */     // No operand predicates
     /* 186252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186254 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 186257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186264 */     GIR_RootConstrainSelectedInstOperands,
     /* 186265 */     // GIR_Coverage, 2244,
     /* 186265 */     GIR_EraseRootFromParent_Done,
     /* 186266 */   // Label 3422: @186266
     /* 186266 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(186318), // Rule ID 2245 //
     /* 186271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 186274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 186279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186304 */     // MIs[1] Operand 1
     /* 186304 */     // No operand predicates
     /* 186304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186306 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 186309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186316 */     GIR_RootConstrainSelectedInstOperands,
     /* 186317 */     // GIR_Coverage, 2245,
     /* 186317 */     GIR_EraseRootFromParent_Done,
     /* 186318 */   // Label 3423: @186318
     /* 186318 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(186370), // Rule ID 2246 //
     /* 186323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 186331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186356 */     // MIs[1] Operand 1
     /* 186356 */     // No operand predicates
     /* 186356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186358 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 186361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186368 */     GIR_RootConstrainSelectedInstOperands,
     /* 186369 */     // GIR_Coverage, 2246,
     /* 186369 */     GIR_EraseRootFromParent_Done,
     /* 186370 */   // Label 3424: @186370
     /* 186370 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(186422), // Rule ID 2247 //
     /* 186375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 186383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186408 */     // MIs[1] Operand 1
     /* 186408 */     // No operand predicates
     /* 186408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186410 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 186413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186420 */     GIR_RootConstrainSelectedInstOperands,
     /* 186421 */     // GIR_Coverage, 2247,
     /* 186421 */     GIR_EraseRootFromParent_Done,
     /* 186422 */   // Label 3425: @186422
     /* 186422 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(186474), // Rule ID 2248 //
     /* 186427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 186435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 186456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 186460 */     // MIs[1] Operand 1
     /* 186460 */     // No operand predicates
     /* 186460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186462 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 186462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 186465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 186472 */     GIR_RootConstrainSelectedInstOperands,
     /* 186473 */     // GIR_Coverage, 2248,
     /* 186473 */     GIR_EraseRootFromParent_Done,
     /* 186474 */   // Label 3426: @186474
     /* 186474 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(186519), // Rule ID 63 //
     /* 186479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 186482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 186487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 186490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 186508 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 186508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 186511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186517 */     GIR_RootConstrainSelectedInstOperands,
     /* 186518 */     // GIR_Coverage, 63,
     /* 186518 */     GIR_EraseRootFromParent_Done,
     /* 186519 */   // Label 3427: @186519
     /* 186519 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(186564), // Rule ID 129 //
     /* 186524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 186532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186553 */     // (intrinsic_wo_chain:{ *:[i32] } 503:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 186556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186562 */     GIR_RootConstrainSelectedInstOperands,
     /* 186563 */     // GIR_Coverage, 129,
     /* 186563 */     GIR_EraseRootFromParent_Done,
     /* 186564 */   // Label 3428: @186564
     /* 186564 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(186609), // Rule ID 130 //
     /* 186569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 186577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186598 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 186601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186607 */     GIR_RootConstrainSelectedInstOperands,
     /* 186608 */     // GIR_Coverage, 130,
     /* 186608 */     GIR_EraseRootFromParent_Done,
     /* 186609 */   // Label 3429: @186609
     /* 186609 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(186654), // Rule ID 131 //
     /* 186614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 186622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186643 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 186646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186652 */     GIR_RootConstrainSelectedInstOperands,
     /* 186653 */     // GIR_Coverage, 131,
     /* 186653 */     GIR_EraseRootFromParent_Done,
     /* 186654 */   // Label 3430: @186654
     /* 186654 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(186699), // Rule ID 132 //
     /* 186659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 186667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186688 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 186688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 186691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186697 */     GIR_RootConstrainSelectedInstOperands,
     /* 186698 */     // GIR_Coverage, 132,
     /* 186698 */     GIR_EraseRootFromParent_Done,
     /* 186699 */   // Label 3431: @186699
     /* 186699 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(186744), // Rule ID 133 //
     /* 186704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 186712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186733 */     // (intrinsic_wo_chain:{ *:[i32] } 504:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 186736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186742 */     GIR_RootConstrainSelectedInstOperands,
     /* 186743 */     // GIR_Coverage, 133,
     /* 186743 */     GIR_EraseRootFromParent_Done,
     /* 186744 */   // Label 3432: @186744
     /* 186744 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(186789), // Rule ID 134 //
     /* 186749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 186757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186778 */     // (intrinsic_wo_chain:{ *:[i32] } 505:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 186781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186787 */     GIR_RootConstrainSelectedInstOperands,
     /* 186788 */     // GIR_Coverage, 134,
     /* 186788 */     GIR_EraseRootFromParent_Done,
     /* 186789 */   // Label 3433: @186789
     /* 186789 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(186834), // Rule ID 135 //
     /* 186794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 186802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186823 */     // (intrinsic_wo_chain:{ *:[i32] } 506:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 186826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186832 */     GIR_RootConstrainSelectedInstOperands,
     /* 186833 */     // GIR_Coverage, 135,
     /* 186833 */     GIR_EraseRootFromParent_Done,
     /* 186834 */   // Label 3434: @186834
     /* 186834 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(186879), // Rule ID 136 //
     /* 186839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 186847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186868 */     // (intrinsic_wo_chain:{ *:[i32] } 507:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 186868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 186871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186877 */     GIR_RootConstrainSelectedInstOperands,
     /* 186878 */     // GIR_Coverage, 136,
     /* 186878 */     GIR_EraseRootFromParent_Done,
     /* 186879 */   // Label 3435: @186879
     /* 186879 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(186924), // Rule ID 1042 //
     /* 186884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 186895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 186898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 186901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186913 */     // (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 186913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 186916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186922 */     GIR_RootConstrainSelectedInstOperands,
     /* 186923 */     // GIR_Coverage, 1042,
     /* 186923 */     GIR_EraseRootFromParent_Done,
     /* 186924 */   // Label 3436: @186924
     /* 186924 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(186969), // Rule ID 1043 //
     /* 186929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 186940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 186943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 186946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186958 */     // (intrinsic_wo_chain:{ *:[v16i8] } 715:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 186958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 186961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186967 */     GIR_RootConstrainSelectedInstOperands,
     /* 186968 */     // GIR_Coverage, 1043,
     /* 186968 */     GIR_EraseRootFromParent_Done,
     /* 186969 */   // Label 3437: @186969
     /* 186969 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(187014), // Rule ID 1044 //
     /* 186974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187003 */     // (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 187003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 187006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187012 */     GIR_RootConstrainSelectedInstOperands,
     /* 187013 */     // GIR_Coverage, 1044,
     /* 187013 */     GIR_EraseRootFromParent_Done,
     /* 187014 */   // Label 3438: @187014
     /* 187014 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(187059), // Rule ID 1045 //
     /* 187019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 187027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187048 */     // (intrinsic_wo_chain:{ *:[v8i16] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 187048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 187051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187057 */     GIR_RootConstrainSelectedInstOperands,
     /* 187058 */     // GIR_Coverage, 1045,
     /* 187058 */     GIR_EraseRootFromParent_Done,
     /* 187059 */   // Label 3439: @187059
     /* 187059 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(187104), // Rule ID 1046 //
     /* 187064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 187072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187093 */     // (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 187093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 187096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187102 */     GIR_RootConstrainSelectedInstOperands,
     /* 187103 */     // GIR_Coverage, 1046,
     /* 187103 */     GIR_EraseRootFromParent_Done,
     /* 187104 */   // Label 3440: @187104
     /* 187104 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(187149), // Rule ID 1047 //
     /* 187109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 187117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187138 */     // (intrinsic_wo_chain:{ *:[v4i32] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 187138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 187141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187147 */     GIR_RootConstrainSelectedInstOperands,
     /* 187148 */     // GIR_Coverage, 1047,
     /* 187148 */     GIR_EraseRootFromParent_Done,
     /* 187149 */   // Label 3441: @187149
     /* 187149 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(187194), // Rule ID 1048 //
     /* 187154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 187162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187183 */     // (intrinsic_wo_chain:{ *:[v2i64] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 187183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 187186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187192 */     GIR_RootConstrainSelectedInstOperands,
     /* 187193 */     // GIR_Coverage, 1048,
     /* 187193 */     GIR_EraseRootFromParent_Done,
     /* 187194 */   // Label 3442: @187194
     /* 187194 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(187239), // Rule ID 1090 //
     /* 187199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 187210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 187213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 187216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187228 */     // (intrinsic_wo_chain:{ *:[v8i8] } 754:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 187228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 187231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187237 */     GIR_RootConstrainSelectedInstOperands,
     /* 187238 */     // GIR_Coverage, 1090,
     /* 187238 */     GIR_EraseRootFromParent_Done,
     /* 187239 */   // Label 3443: @187239
     /* 187239 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(187284), // Rule ID 1091 //
     /* 187244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 187255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 187258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 187261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187273 */     // (intrinsic_wo_chain:{ *:[v16i8] } 754:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 187273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 187276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187282 */     GIR_RootConstrainSelectedInstOperands,
     /* 187283 */     // GIR_Coverage, 1091,
     /* 187283 */     GIR_EraseRootFromParent_Done,
     /* 187284 */   // Label 3444: @187284
     /* 187284 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(187329), // Rule ID 1092 //
     /* 187289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187318 */     // (intrinsic_wo_chain:{ *:[v4i16] } 754:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 187318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 187321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187327 */     GIR_RootConstrainSelectedInstOperands,
     /* 187328 */     // GIR_Coverage, 1092,
     /* 187328 */     GIR_EraseRootFromParent_Done,
     /* 187329 */   // Label 3445: @187329
     /* 187329 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(187374), // Rule ID 1093 //
     /* 187334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187363 */     // (intrinsic_wo_chain:{ *:[v8i16] } 754:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 187363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 187366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187372 */     GIR_RootConstrainSelectedInstOperands,
     /* 187373 */     // GIR_Coverage, 1093,
     /* 187373 */     GIR_EraseRootFromParent_Done,
     /* 187374 */   // Label 3446: @187374
     /* 187374 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(187419), // Rule ID 1094 //
     /* 187379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187408 */     // (intrinsic_wo_chain:{ *:[v2i32] } 754:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 187408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 187411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187417 */     GIR_RootConstrainSelectedInstOperands,
     /* 187418 */     // GIR_Coverage, 1094,
     /* 187418 */     GIR_EraseRootFromParent_Done,
     /* 187419 */   // Label 3447: @187419
     /* 187419 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(187464), // Rule ID 1095 //
     /* 187424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187453 */     // (intrinsic_wo_chain:{ *:[v4i32] } 754:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 187453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 187456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187462 */     GIR_RootConstrainSelectedInstOperands,
     /* 187463 */     // GIR_Coverage, 1095,
     /* 187463 */     GIR_EraseRootFromParent_Done,
     /* 187464 */   // Label 3448: @187464
     /* 187464 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(187509), // Rule ID 1096 //
     /* 187469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 187477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187498 */     // (intrinsic_wo_chain:{ *:[v2i64] } 754:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 187498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 187501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 187505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 187507 */     GIR_RootConstrainSelectedInstOperands,
     /* 187508 */     // GIR_Coverage, 1096,
     /* 187508 */     GIR_EraseRootFromParent_Done,
     /* 187509 */   // Label 3449: @187509
     /* 187509 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(187554), // Rule ID 1108 //
     /* 187514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 187525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 187528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 187531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187543 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 187543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 187546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187552 */     GIR_RootConstrainSelectedInstOperands,
     /* 187553 */     // GIR_Coverage, 1108,
     /* 187553 */     GIR_EraseRootFromParent_Done,
     /* 187554 */   // Label 3450: @187554
     /* 187554 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(187599), // Rule ID 1110 //
     /* 187559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 187570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 187573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 187576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187588 */     // (intrinsic_wo_chain:{ *:[v16i8] } 570:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 187588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 187591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187597 */     GIR_RootConstrainSelectedInstOperands,
     /* 187598 */     // GIR_Coverage, 1110,
     /* 187598 */     GIR_EraseRootFromParent_Done,
     /* 187599 */   // Label 3451: @187599
     /* 187599 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(187644), // Rule ID 1112 //
     /* 187604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187633 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 187633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 187636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187642 */     GIR_RootConstrainSelectedInstOperands,
     /* 187643 */     // GIR_Coverage, 1112,
     /* 187643 */     GIR_EraseRootFromParent_Done,
     /* 187644 */   // Label 3452: @187644
     /* 187644 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(187689), // Rule ID 1114 //
     /* 187649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187678 */     // (intrinsic_wo_chain:{ *:[v8i16] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 187678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 187681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187687 */     GIR_RootConstrainSelectedInstOperands,
     /* 187688 */     // GIR_Coverage, 1114,
     /* 187688 */     GIR_EraseRootFromParent_Done,
     /* 187689 */   // Label 3453: @187689
     /* 187689 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(187734), // Rule ID 1116 //
     /* 187694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187723 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 187723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 187726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187732 */     GIR_RootConstrainSelectedInstOperands,
     /* 187733 */     // GIR_Coverage, 1116,
     /* 187733 */     GIR_EraseRootFromParent_Done,
     /* 187734 */   // Label 3454: @187734
     /* 187734 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(187779), // Rule ID 1118 //
     /* 187739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187768 */     // (intrinsic_wo_chain:{ *:[v4i32] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 187768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 187771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187777 */     GIR_RootConstrainSelectedInstOperands,
     /* 187778 */     // GIR_Coverage, 1118,
     /* 187778 */     GIR_EraseRootFromParent_Done,
     /* 187779 */   // Label 3455: @187779
     /* 187779 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(187824), // Rule ID 1120 //
     /* 187784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187813 */     // (intrinsic_wo_chain:{ *:[v2i64] } 570:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 187813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 187816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187822 */     GIR_RootConstrainSelectedInstOperands,
     /* 187823 */     // GIR_Coverage, 1120,
     /* 187823 */     GIR_EraseRootFromParent_Done,
     /* 187824 */   // Label 3456: @187824
     /* 187824 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(187869), // Rule ID 1163 //
     /* 187829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187858 */     // (intrinsic_wo_chain:{ *:[v4f16] } 576:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 187861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187867 */     GIR_RootConstrainSelectedInstOperands,
     /* 187868 */     // GIR_Coverage, 1163,
     /* 187868 */     GIR_EraseRootFromParent_Done,
     /* 187869 */   // Label 3457: @187869
     /* 187869 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(187914), // Rule ID 1164 //
     /* 187874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187903 */     // (intrinsic_wo_chain:{ *:[v8f16] } 576:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 187906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187912 */     GIR_RootConstrainSelectedInstOperands,
     /* 187913 */     // GIR_Coverage, 1164,
     /* 187913 */     GIR_EraseRootFromParent_Done,
     /* 187914 */   // Label 3458: @187914
     /* 187914 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(187959), // Rule ID 1165 //
     /* 187919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187948 */     // (intrinsic_wo_chain:{ *:[v2f32] } 576:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 187951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187957 */     GIR_RootConstrainSelectedInstOperands,
     /* 187958 */     // GIR_Coverage, 1165,
     /* 187958 */     GIR_EraseRootFromParent_Done,
     /* 187959 */   // Label 3459: @187959
     /* 187959 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(188004), // Rule ID 1166 //
     /* 187964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187993 */     // (intrinsic_wo_chain:{ *:[v4f32] } 576:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 187996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188002 */     GIR_RootConstrainSelectedInstOperands,
     /* 188003 */     // GIR_Coverage, 1166,
     /* 188003 */     GIR_EraseRootFromParent_Done,
     /* 188004 */   // Label 3460: @188004
     /* 188004 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(188049), // Rule ID 1167 //
     /* 188009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 188017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188038 */     // (intrinsic_wo_chain:{ *:[v2f64] } 576:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 188041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188047 */     GIR_RootConstrainSelectedInstOperands,
     /* 188048 */     // GIR_Coverage, 1167,
     /* 188048 */     GIR_EraseRootFromParent_Done,
     /* 188049 */   // Label 3461: @188049
     /* 188049 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(188094), // Rule ID 1169 //
     /* 188054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 188062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188083 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 188086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188092 */     GIR_RootConstrainSelectedInstOperands,
     /* 188093 */     // GIR_Coverage, 1169,
     /* 188093 */     GIR_EraseRootFromParent_Done,
     /* 188094 */   // Label 3462: @188094
     /* 188094 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(188139), // Rule ID 1171 //
     /* 188099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 188107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188128 */     // (intrinsic_wo_chain:{ *:[v8i16] } 577:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 188131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188137 */     GIR_RootConstrainSelectedInstOperands,
     /* 188138 */     // GIR_Coverage, 1171,
     /* 188138 */     GIR_EraseRootFromParent_Done,
     /* 188139 */   // Label 3463: @188139
     /* 188139 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(188184), // Rule ID 1173 //
     /* 188144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 188152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188173 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 188176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188182 */     GIR_RootConstrainSelectedInstOperands,
     /* 188183 */     // GIR_Coverage, 1173,
     /* 188183 */     GIR_EraseRootFromParent_Done,
     /* 188184 */   // Label 3464: @188184
     /* 188184 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(188229), // Rule ID 1175 //
     /* 188189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 188197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188218 */     // (intrinsic_wo_chain:{ *:[v4i32] } 577:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 188221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188227 */     GIR_RootConstrainSelectedInstOperands,
     /* 188228 */     // GIR_Coverage, 1175,
     /* 188228 */     GIR_EraseRootFromParent_Done,
     /* 188229 */   // Label 3465: @188229
     /* 188229 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(188274), // Rule ID 1177 //
     /* 188234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 188242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188263 */     // (intrinsic_wo_chain:{ *:[v2i64] } 577:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 188266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188272 */     GIR_RootConstrainSelectedInstOperands,
     /* 188273 */     // GIR_Coverage, 1177,
     /* 188273 */     GIR_EraseRootFromParent_Done,
     /* 188274 */   // Label 3466: @188274
     /* 188274 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(188319), // Rule ID 1179 //
     /* 188279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 188287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188308 */     // (intrinsic_wo_chain:{ *:[v4i16] } 578:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 188311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188317 */     GIR_RootConstrainSelectedInstOperands,
     /* 188318 */     // GIR_Coverage, 1179,
     /* 188318 */     GIR_EraseRootFromParent_Done,
     /* 188319 */   // Label 3467: @188319
     /* 188319 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(188364), // Rule ID 1181 //
     /* 188324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 188332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188353 */     // (intrinsic_wo_chain:{ *:[v8i16] } 578:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 188356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188362 */     GIR_RootConstrainSelectedInstOperands,
     /* 188363 */     // GIR_Coverage, 1181,
     /* 188363 */     GIR_EraseRootFromParent_Done,
     /* 188364 */   // Label 3468: @188364
     /* 188364 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(188409), // Rule ID 1183 //
     /* 188369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 188377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188398 */     // (intrinsic_wo_chain:{ *:[v2i32] } 578:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 188401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188407 */     GIR_RootConstrainSelectedInstOperands,
     /* 188408 */     // GIR_Coverage, 1183,
     /* 188408 */     GIR_EraseRootFromParent_Done,
     /* 188409 */   // Label 3469: @188409
     /* 188409 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(188454), // Rule ID 1185 //
     /* 188414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 188422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188443 */     // (intrinsic_wo_chain:{ *:[v4i32] } 578:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 188446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188452 */     GIR_RootConstrainSelectedInstOperands,
     /* 188453 */     // GIR_Coverage, 1185,
     /* 188453 */     GIR_EraseRootFromParent_Done,
     /* 188454 */   // Label 3470: @188454
     /* 188454 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(188499), // Rule ID 1187 //
     /* 188459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 188467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188488 */     // (intrinsic_wo_chain:{ *:[v2i64] } 578:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 188491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188497 */     GIR_RootConstrainSelectedInstOperands,
     /* 188498 */     // GIR_Coverage, 1187,
     /* 188498 */     GIR_EraseRootFromParent_Done,
     /* 188499 */   // Label 3471: @188499
     /* 188499 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(188544), // Rule ID 1189 //
     /* 188504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188533 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 188536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188542 */     GIR_RootConstrainSelectedInstOperands,
     /* 188543 */     // GIR_Coverage, 1189,
     /* 188543 */     GIR_EraseRootFromParent_Done,
     /* 188544 */   // Label 3472: @188544
     /* 188544 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(188589), // Rule ID 1191 //
     /* 188549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188578 */     // (intrinsic_wo_chain:{ *:[v8f16] } 579:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 188581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188587 */     GIR_RootConstrainSelectedInstOperands,
     /* 188588 */     // GIR_Coverage, 1191,
     /* 188588 */     GIR_EraseRootFromParent_Done,
     /* 188589 */   // Label 3473: @188589
     /* 188589 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(188634), // Rule ID 1193 //
     /* 188594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188623 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 188626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188632 */     GIR_RootConstrainSelectedInstOperands,
     /* 188633 */     // GIR_Coverage, 1193,
     /* 188633 */     GIR_EraseRootFromParent_Done,
     /* 188634 */   // Label 3474: @188634
     /* 188634 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(188679), // Rule ID 1195 //
     /* 188639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188668 */     // (intrinsic_wo_chain:{ *:[v4f32] } 579:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 188671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188677 */     GIR_RootConstrainSelectedInstOperands,
     /* 188678 */     // GIR_Coverage, 1195,
     /* 188678 */     GIR_EraseRootFromParent_Done,
     /* 188679 */   // Label 3475: @188679
     /* 188679 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(188724), // Rule ID 1197 //
     /* 188684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188713 */     // (intrinsic_wo_chain:{ *:[v2f64] } 579:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 188716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188722 */     GIR_RootConstrainSelectedInstOperands,
     /* 188723 */     // GIR_Coverage, 1197,
     /* 188723 */     GIR_EraseRootFromParent_Done,
     /* 188724 */   // Label 3476: @188724
     /* 188724 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(188769), // Rule ID 1233 //
     /* 188729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188758 */     // (intrinsic_wo_chain:{ *:[v4f16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 188761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188767 */     GIR_RootConstrainSelectedInstOperands,
     /* 188768 */     // GIR_Coverage, 1233,
     /* 188768 */     GIR_EraseRootFromParent_Done,
     /* 188769 */   // Label 3477: @188769
     /* 188769 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(188814), // Rule ID 1234 //
     /* 188774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188803 */     // (intrinsic_wo_chain:{ *:[v8f16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 188806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188812 */     GIR_RootConstrainSelectedInstOperands,
     /* 188813 */     // GIR_Coverage, 1234,
     /* 188813 */     GIR_EraseRootFromParent_Done,
     /* 188814 */   // Label 3478: @188814
     /* 188814 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(188859), // Rule ID 1235 //
     /* 188819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188848 */     // (intrinsic_wo_chain:{ *:[v2f32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 188851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188857 */     GIR_RootConstrainSelectedInstOperands,
     /* 188858 */     // GIR_Coverage, 1235,
     /* 188858 */     GIR_EraseRootFromParent_Done,
     /* 188859 */   // Label 3479: @188859
     /* 188859 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(188904), // Rule ID 1236 //
     /* 188864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188893 */     // (intrinsic_wo_chain:{ *:[v4f32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 188896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188902 */     GIR_RootConstrainSelectedInstOperands,
     /* 188903 */     // GIR_Coverage, 1236,
     /* 188903 */     GIR_EraseRootFromParent_Done,
     /* 188904 */   // Label 3480: @188904
     /* 188904 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(188949), // Rule ID 1237 //
     /* 188909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188938 */     // (intrinsic_wo_chain:{ *:[v2f64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 188941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188947 */     GIR_RootConstrainSelectedInstOperands,
     /* 188948 */     // GIR_Coverage, 1237,
     /* 188948 */     GIR_EraseRootFromParent_Done,
     /* 188949 */   // Label 3481: @188949
     /* 188949 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(188994), // Rule ID 1248 //
     /* 188954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188983 */     // (intrinsic_wo_chain:{ *:[v4f16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 188986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188992 */     GIR_RootConstrainSelectedInstOperands,
     /* 188993 */     // GIR_Coverage, 1248,
     /* 188993 */     GIR_EraseRootFromParent_Done,
     /* 188994 */   // Label 3482: @188994
     /* 188994 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(189039), // Rule ID 1249 //
     /* 188999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 189007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189028 */     // (intrinsic_wo_chain:{ *:[v8f16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 189031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189037 */     GIR_RootConstrainSelectedInstOperands,
     /* 189038 */     // GIR_Coverage, 1249,
     /* 189038 */     GIR_EraseRootFromParent_Done,
     /* 189039 */   // Label 3483: @189039
     /* 189039 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(189084), // Rule ID 1250 //
     /* 189044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 189052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189073 */     // (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 189076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189082 */     GIR_RootConstrainSelectedInstOperands,
     /* 189083 */     // GIR_Coverage, 1250,
     /* 189083 */     GIR_EraseRootFromParent_Done,
     /* 189084 */   // Label 3484: @189084
     /* 189084 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(189129), // Rule ID 1251 //
     /* 189089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 189097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189118 */     // (intrinsic_wo_chain:{ *:[v4f32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 189121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189127 */     GIR_RootConstrainSelectedInstOperands,
     /* 189128 */     // GIR_Coverage, 1251,
     /* 189128 */     GIR_EraseRootFromParent_Done,
     /* 189129 */   // Label 3485: @189129
     /* 189129 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(189174), // Rule ID 1252 //
     /* 189134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 189142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189163 */     // (intrinsic_wo_chain:{ *:[v2f64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 189166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189172 */     GIR_RootConstrainSelectedInstOperands,
     /* 189173 */     // GIR_Coverage, 1252,
     /* 189173 */     GIR_EraseRootFromParent_Done,
     /* 189174 */   // Label 3486: @189174
     /* 189174 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(189219), // Rule ID 1263 //
     /* 189179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 189187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189208 */     // (intrinsic_wo_chain:{ *:[v4f16] } 602:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 189211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189217 */     GIR_RootConstrainSelectedInstOperands,
     /* 189218 */     // GIR_Coverage, 1263,
     /* 189218 */     GIR_EraseRootFromParent_Done,
     /* 189219 */   // Label 3487: @189219
     /* 189219 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(189264), // Rule ID 1264 //
     /* 189224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 189232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189253 */     // (intrinsic_wo_chain:{ *:[v8f16] } 602:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 189256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189262 */     GIR_RootConstrainSelectedInstOperands,
     /* 189263 */     // GIR_Coverage, 1264,
     /* 189263 */     GIR_EraseRootFromParent_Done,
     /* 189264 */   // Label 3488: @189264
     /* 189264 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(189309), // Rule ID 1265 //
     /* 189269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 189277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189298 */     // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 189301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189307 */     GIR_RootConstrainSelectedInstOperands,
     /* 189308 */     // GIR_Coverage, 1265,
     /* 189308 */     GIR_EraseRootFromParent_Done,
     /* 189309 */   // Label 3489: @189309
     /* 189309 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(189354), // Rule ID 1266 //
     /* 189314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 189322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189343 */     // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 189346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189352 */     GIR_RootConstrainSelectedInstOperands,
     /* 189353 */     // GIR_Coverage, 1266,
     /* 189353 */     GIR_EraseRootFromParent_Done,
     /* 189354 */   // Label 3490: @189354
     /* 189354 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(189399), // Rule ID 1267 //
     /* 189359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 189367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189388 */     // (intrinsic_wo_chain:{ *:[v2f64] } 602:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 189391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189397 */     GIR_RootConstrainSelectedInstOperands,
     /* 189398 */     // GIR_Coverage, 1267,
     /* 189398 */     GIR_EraseRootFromParent_Done,
     /* 189399 */   // Label 3491: @189399
     /* 189399 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(189444), // Rule ID 1278 //
     /* 189404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 189412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189433 */     // (intrinsic_wo_chain:{ *:[v4f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 189436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189442 */     GIR_RootConstrainSelectedInstOperands,
     /* 189443 */     // GIR_Coverage, 1278,
     /* 189443 */     GIR_EraseRootFromParent_Done,
     /* 189444 */   // Label 3492: @189444
     /* 189444 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(189489), // Rule ID 1279 //
     /* 189449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 189457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189478 */     // (intrinsic_wo_chain:{ *:[v8f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 189481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189487 */     GIR_RootConstrainSelectedInstOperands,
     /* 189488 */     // GIR_Coverage, 1279,
     /* 189488 */     GIR_EraseRootFromParent_Done,
     /* 189489 */   // Label 3493: @189489
     /* 189489 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(189534), // Rule ID 1280 //
     /* 189494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 189502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189523 */     // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 189526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189532 */     GIR_RootConstrainSelectedInstOperands,
     /* 189533 */     // GIR_Coverage, 1280,
     /* 189533 */     GIR_EraseRootFromParent_Done,
     /* 189534 */   // Label 3494: @189534
     /* 189534 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(189579), // Rule ID 1281 //
     /* 189539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 189547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189568 */     // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 189571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189577 */     GIR_RootConstrainSelectedInstOperands,
     /* 189578 */     // GIR_Coverage, 1281,
     /* 189578 */     GIR_EraseRootFromParent_Done,
     /* 189579 */   // Label 3495: @189579
     /* 189579 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(189624), // Rule ID 1282 //
     /* 189584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 189592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189613 */     // (intrinsic_wo_chain:{ *:[v2f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 189616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189622 */     GIR_RootConstrainSelectedInstOperands,
     /* 189623 */     // GIR_Coverage, 1282,
     /* 189623 */     GIR_EraseRootFromParent_Done,
     /* 189624 */   // Label 3496: @189624
     /* 189624 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(189669), // Rule ID 1313 //
     /* 189629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189658 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 189661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189667 */     GIR_RootConstrainSelectedInstOperands,
     /* 189668 */     // GIR_Coverage, 1313,
     /* 189668 */     GIR_EraseRootFromParent_Done,
     /* 189669 */   // Label 3497: @189669
     /* 189669 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(189714), // Rule ID 1314 //
     /* 189674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189703 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 189706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189712 */     GIR_RootConstrainSelectedInstOperands,
     /* 189713 */     // GIR_Coverage, 1314,
     /* 189713 */     GIR_EraseRootFromParent_Done,
     /* 189714 */   // Label 3498: @189714
     /* 189714 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(189759), // Rule ID 1315 //
     /* 189719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189748 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 189751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189757 */     GIR_RootConstrainSelectedInstOperands,
     /* 189758 */     // GIR_Coverage, 1315,
     /* 189758 */     GIR_EraseRootFromParent_Done,
     /* 189759 */   // Label 3499: @189759
     /* 189759 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(189804), // Rule ID 1316 //
     /* 189764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189793 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 189796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189802 */     GIR_RootConstrainSelectedInstOperands,
     /* 189803 */     // GIR_Coverage, 1316,
     /* 189803 */     GIR_EraseRootFromParent_Done,
     /* 189804 */   // Label 3500: @189804
     /* 189804 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(189849), // Rule ID 1317 //
     /* 189809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189838 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 189841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189847 */     GIR_RootConstrainSelectedInstOperands,
     /* 189848 */     // GIR_Coverage, 1317,
     /* 189848 */     GIR_EraseRootFromParent_Done,
     /* 189849 */   // Label 3501: @189849
     /* 189849 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(189894), // Rule ID 1328 //
     /* 189854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189883 */     // (intrinsic_wo_chain:{ *:[v4f16] } 633:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 189886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189892 */     GIR_RootConstrainSelectedInstOperands,
     /* 189893 */     // GIR_Coverage, 1328,
     /* 189893 */     GIR_EraseRootFromParent_Done,
     /* 189894 */   // Label 3502: @189894
     /* 189894 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(189939), // Rule ID 1329 //
     /* 189899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189928 */     // (intrinsic_wo_chain:{ *:[v8f16] } 633:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 189931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189937 */     GIR_RootConstrainSelectedInstOperands,
     /* 189938 */     // GIR_Coverage, 1329,
     /* 189938 */     GIR_EraseRootFromParent_Done,
     /* 189939 */   // Label 3503: @189939
     /* 189939 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(189984), // Rule ID 1330 //
     /* 189944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189973 */     // (intrinsic_wo_chain:{ *:[v2f32] } 633:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 189976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189982 */     GIR_RootConstrainSelectedInstOperands,
     /* 189983 */     // GIR_Coverage, 1330,
     /* 189983 */     GIR_EraseRootFromParent_Done,
     /* 189984 */   // Label 3504: @189984
     /* 189984 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(190029), // Rule ID 1331 //
     /* 189989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190018 */     // (intrinsic_wo_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 190018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 190021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190027 */     GIR_RootConstrainSelectedInstOperands,
     /* 190028 */     // GIR_Coverage, 1331,
     /* 190028 */     GIR_EraseRootFromParent_Done,
     /* 190029 */   // Label 3505: @190029
     /* 190029 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(190074), // Rule ID 1332 //
     /* 190034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 190042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 190048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 190051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190063 */     // (intrinsic_wo_chain:{ *:[v2f64] } 633:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 190063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 190066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190072 */     GIR_RootConstrainSelectedInstOperands,
     /* 190073 */     // GIR_Coverage, 1332,
     /* 190073 */     GIR_EraseRootFromParent_Done,
     /* 190074 */   // Label 3506: @190074
     /* 190074 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(190119), // Rule ID 1333 //
     /* 190079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 190082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 190087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190108 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 190108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 190111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190117 */     GIR_RootConstrainSelectedInstOperands,
     /* 190118 */     // GIR_Coverage, 1333,
     /* 190118 */     GIR_EraseRootFromParent_Done,
     /* 190119 */   // Label 3507: @190119
     /* 190119 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(190164), // Rule ID 1334 //
     /* 190124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 190127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 190132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190153 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 190153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 190156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190162 */     GIR_RootConstrainSelectedInstOperands,
     /* 190163 */     // GIR_Coverage, 1334,
     /* 190163 */     GIR_EraseRootFromParent_Done,
     /* 190164 */   // Label 3508: @190164
     /* 190164 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(190209), // Rule ID 1335 //
     /* 190169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 190177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190198 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 190198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 190201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190207 */     GIR_RootConstrainSelectedInstOperands,
     /* 190208 */     // GIR_Coverage, 1335,
     /* 190208 */     GIR_EraseRootFromParent_Done,
     /* 190209 */   // Label 3509: @190209
     /* 190209 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(190254), // Rule ID 1336 //
     /* 190214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 190222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190243 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 190243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 190246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190252 */     GIR_RootConstrainSelectedInstOperands,
     /* 190253 */     // GIR_Coverage, 1336,
     /* 190253 */     GIR_EraseRootFromParent_Done,
     /* 190254 */   // Label 3510: @190254
     /* 190254 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(190299), // Rule ID 1337 //
     /* 190259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 190267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 190270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 190273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 190276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190288 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 190288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 190291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190297 */     GIR_RootConstrainSelectedInstOperands,
     /* 190298 */     // GIR_Coverage, 1337,
     /* 190298 */     GIR_EraseRootFromParent_Done,
     /* 190299 */   // Label 3511: @190299
     /* 190299 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(190344), // Rule ID 1354 //
     /* 190304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 190312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190333 */     // (intrinsic_wo_chain:{ *:[v8i8] } 653:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 190336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190342 */     GIR_RootConstrainSelectedInstOperands,
     /* 190343 */     // GIR_Coverage, 1354,
     /* 190343 */     GIR_EraseRootFromParent_Done,
     /* 190344 */   // Label 3512: @190344
     /* 190344 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(190389), // Rule ID 1355 //
     /* 190349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 190357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190378 */     // (intrinsic_wo_chain:{ *:[v16i8] } 653:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 190381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190387 */     GIR_RootConstrainSelectedInstOperands,
     /* 190388 */     // GIR_Coverage, 1355,
     /* 190388 */     GIR_EraseRootFromParent_Done,
     /* 190389 */   // Label 3513: @190389
     /* 190389 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(190434), // Rule ID 1369 //
     /* 190394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190423 */     // (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 190426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190432 */     GIR_RootConstrainSelectedInstOperands,
     /* 190433 */     // GIR_Coverage, 1369,
     /* 190433 */     GIR_EraseRootFromParent_Done,
     /* 190434 */   // Label 3514: @190434
     /* 190434 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(190479), // Rule ID 1371 //
     /* 190439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190468 */     // (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 190471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190477 */     GIR_RootConstrainSelectedInstOperands,
     /* 190478 */     // GIR_Coverage, 1371,
     /* 190478 */     GIR_EraseRootFromParent_Done,
     /* 190479 */   // Label 3515: @190479
     /* 190479 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(190524), // Rule ID 1373 //
     /* 190484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190513 */     // (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 190516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190522 */     GIR_RootConstrainSelectedInstOperands,
     /* 190523 */     // GIR_Coverage, 1373,
     /* 190523 */     GIR_EraseRootFromParent_Done,
     /* 190524 */   // Label 3516: @190524
     /* 190524 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(190569), // Rule ID 1375 //
     /* 190529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190558 */     // (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 190561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190567 */     GIR_RootConstrainSelectedInstOperands,
     /* 190568 */     // GIR_Coverage, 1375,
     /* 190568 */     GIR_EraseRootFromParent_Done,
     /* 190569 */   // Label 3517: @190569
     /* 190569 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(190614), // Rule ID 1377 //
     /* 190574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190603 */     // (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 190606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190612 */     GIR_RootConstrainSelectedInstOperands,
     /* 190613 */     // GIR_Coverage, 1377,
     /* 190613 */     GIR_EraseRootFromParent_Done,
     /* 190614 */   // Label 3518: @190614
     /* 190614 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(190659), // Rule ID 1379 //
     /* 190619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 190627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190648 */     // (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 190651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190657 */     GIR_RootConstrainSelectedInstOperands,
     /* 190658 */     // GIR_Coverage, 1379,
     /* 190658 */     GIR_EraseRootFromParent_Done,
     /* 190659 */   // Label 3519: @190659
     /* 190659 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(190704), // Rule ID 1386 //
     /* 190664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190693 */     // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 190696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190702 */     GIR_RootConstrainSelectedInstOperands,
     /* 190703 */     // GIR_Coverage, 1386,
     /* 190703 */     GIR_EraseRootFromParent_Done,
     /* 190704 */   // Label 3520: @190704
     /* 190704 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(190749), // Rule ID 1387 //
     /* 190709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190738 */     // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 190741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190747 */     GIR_RootConstrainSelectedInstOperands,
     /* 190748 */     // GIR_Coverage, 1387,
     /* 190748 */     GIR_EraseRootFromParent_Done,
     /* 190749 */   // Label 3521: @190749
     /* 190749 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(190794), // Rule ID 1388 //
     /* 190754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190783 */     // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 190786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190792 */     GIR_RootConstrainSelectedInstOperands,
     /* 190793 */     // GIR_Coverage, 1388,
     /* 190793 */     GIR_EraseRootFromParent_Done,
     /* 190794 */   // Label 3522: @190794
     /* 190794 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(190839), // Rule ID 1389 //
     /* 190799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190828 */     // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 190831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190837 */     GIR_RootConstrainSelectedInstOperands,
     /* 190838 */     // GIR_Coverage, 1389,
     /* 190838 */     GIR_EraseRootFromParent_Done,
     /* 190839 */   // Label 3523: @190839
     /* 190839 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(190884), // Rule ID 1390 //
     /* 190844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190873 */     // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 190876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190882 */     GIR_RootConstrainSelectedInstOperands,
     /* 190883 */     // GIR_Coverage, 1390,
     /* 190883 */     GIR_EraseRootFromParent_Done,
     /* 190884 */   // Label 3524: @190884
     /* 190884 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(190929), // Rule ID 1391 //
     /* 190889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190918 */     // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 190921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190927 */     GIR_RootConstrainSelectedInstOperands,
     /* 190928 */     // GIR_Coverage, 1391,
     /* 190928 */     GIR_EraseRootFromParent_Done,
     /* 190929 */   // Label 3525: @190929
     /* 190929 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(190974), // Rule ID 1392 //
     /* 190934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190963 */     // (intrinsic_wo_chain:{ *:[v8i8] } 671:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 190966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190972 */     GIR_RootConstrainSelectedInstOperands,
     /* 190973 */     // GIR_Coverage, 1392,
     /* 190973 */     GIR_EraseRootFromParent_Done,
     /* 190974 */   // Label 3526: @190974
     /* 190974 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(191019), // Rule ID 1393 //
     /* 190979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191008 */     // (intrinsic_wo_chain:{ *:[v16i8] } 671:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 191011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191017 */     GIR_RootConstrainSelectedInstOperands,
     /* 191018 */     // GIR_Coverage, 1393,
     /* 191018 */     GIR_EraseRootFromParent_Done,
     /* 191019 */   // Label 3527: @191019
     /* 191019 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(191064), // Rule ID 1394 //
     /* 191024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 191032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191053 */     // (intrinsic_wo_chain:{ *:[v4i16] } 671:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 191056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191062 */     GIR_RootConstrainSelectedInstOperands,
     /* 191063 */     // GIR_Coverage, 1394,
     /* 191063 */     GIR_EraseRootFromParent_Done,
     /* 191064 */   // Label 3528: @191064
     /* 191064 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(191109), // Rule ID 1395 //
     /* 191069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 191077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191098 */     // (intrinsic_wo_chain:{ *:[v8i16] } 671:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 191101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191107 */     GIR_RootConstrainSelectedInstOperands,
     /* 191108 */     // GIR_Coverage, 1395,
     /* 191108 */     GIR_EraseRootFromParent_Done,
     /* 191109 */   // Label 3529: @191109
     /* 191109 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(191154), // Rule ID 1396 //
     /* 191114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 191122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191143 */     // (intrinsic_wo_chain:{ *:[v2i32] } 671:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 191146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191152 */     GIR_RootConstrainSelectedInstOperands,
     /* 191153 */     // GIR_Coverage, 1396,
     /* 191153 */     GIR_EraseRootFromParent_Done,
     /* 191154 */   // Label 3530: @191154
     /* 191154 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(191199), // Rule ID 1397 //
     /* 191159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 191167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191188 */     // (intrinsic_wo_chain:{ *:[v4i32] } 671:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 191191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191197 */     GIR_RootConstrainSelectedInstOperands,
     /* 191198 */     // GIR_Coverage, 1397,
     /* 191198 */     GIR_EraseRootFromParent_Done,
     /* 191199 */   // Label 3531: @191199
     /* 191199 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(191244), // Rule ID 1404 //
     /* 191204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 191212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191233 */     // (intrinsic_wo_chain:{ *:[v8i8] } 674:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 191236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191242 */     GIR_RootConstrainSelectedInstOperands,
     /* 191243 */     // GIR_Coverage, 1404,
     /* 191243 */     GIR_EraseRootFromParent_Done,
     /* 191244 */   // Label 3532: @191244
     /* 191244 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(191289), // Rule ID 1405 //
     /* 191249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 191257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191278 */     // (intrinsic_wo_chain:{ *:[v16i8] } 674:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 191281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191287 */     GIR_RootConstrainSelectedInstOperands,
     /* 191288 */     // GIR_Coverage, 1405,
     /* 191288 */     GIR_EraseRootFromParent_Done,
     /* 191289 */   // Label 3533: @191289
     /* 191289 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(191334), // Rule ID 1406 //
     /* 191294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 191302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191323 */     // (intrinsic_wo_chain:{ *:[v4i16] } 674:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 191326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191332 */     GIR_RootConstrainSelectedInstOperands,
     /* 191333 */     // GIR_Coverage, 1406,
     /* 191333 */     GIR_EraseRootFromParent_Done,
     /* 191334 */   // Label 3534: @191334
     /* 191334 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(191379), // Rule ID 1407 //
     /* 191339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 191347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191368 */     // (intrinsic_wo_chain:{ *:[v8i16] } 674:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 191371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191377 */     GIR_RootConstrainSelectedInstOperands,
     /* 191378 */     // GIR_Coverage, 1407,
     /* 191378 */     GIR_EraseRootFromParent_Done,
     /* 191379 */   // Label 3535: @191379
     /* 191379 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(191424), // Rule ID 1408 //
     /* 191384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 191392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191413 */     // (intrinsic_wo_chain:{ *:[v2i32] } 674:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 191416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191422 */     GIR_RootConstrainSelectedInstOperands,
     /* 191423 */     // GIR_Coverage, 1408,
     /* 191423 */     GIR_EraseRootFromParent_Done,
     /* 191424 */   // Label 3536: @191424
     /* 191424 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(191469), // Rule ID 1409 //
     /* 191429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 191437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191458 */     // (intrinsic_wo_chain:{ *:[v4i32] } 674:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 191461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191467 */     GIR_RootConstrainSelectedInstOperands,
     /* 191468 */     // GIR_Coverage, 1409,
     /* 191468 */     GIR_EraseRootFromParent_Done,
     /* 191469 */   // Label 3537: @191469
     /* 191469 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(191514), // Rule ID 1416 //
     /* 191474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 191482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191503 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 191506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191512 */     GIR_RootConstrainSelectedInstOperands,
     /* 191513 */     // GIR_Coverage, 1416,
     /* 191513 */     GIR_EraseRootFromParent_Done,
     /* 191514 */   // Label 3538: @191514
     /* 191514 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(191559), // Rule ID 1417 //
     /* 191519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 191527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191548 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 191551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191557 */     GIR_RootConstrainSelectedInstOperands,
     /* 191558 */     // GIR_Coverage, 1417,
     /* 191558 */     GIR_EraseRootFromParent_Done,
     /* 191559 */   // Label 3539: @191559
     /* 191559 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(191604), // Rule ID 1418 //
     /* 191564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 191572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191593 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 191596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191602 */     GIR_RootConstrainSelectedInstOperands,
     /* 191603 */     // GIR_Coverage, 1418,
     /* 191603 */     GIR_EraseRootFromParent_Done,
     /* 191604 */   // Label 3540: @191604
     /* 191604 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(191649), // Rule ID 1419 //
     /* 191609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 191617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191638 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 191641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191647 */     GIR_RootConstrainSelectedInstOperands,
     /* 191648 */     // GIR_Coverage, 1419,
     /* 191648 */     GIR_EraseRootFromParent_Done,
     /* 191649 */   // Label 3541: @191649
     /* 191649 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(191694), // Rule ID 1420 //
     /* 191654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 191662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191683 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 191686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191692 */     GIR_RootConstrainSelectedInstOperands,
     /* 191693 */     // GIR_Coverage, 1420,
     /* 191693 */     GIR_EraseRootFromParent_Done,
     /* 191694 */   // Label 3542: @191694
     /* 191694 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(191739), // Rule ID 1421 //
     /* 191699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 191707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191728 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 191731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191737 */     GIR_RootConstrainSelectedInstOperands,
     /* 191738 */     // GIR_Coverage, 1421,
     /* 191738 */     GIR_EraseRootFromParent_Done,
     /* 191739 */   // Label 3543: @191739
     /* 191739 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(191784), // Rule ID 1422 //
     /* 191744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 191752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 191755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 191758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 191761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191773 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 191773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 191776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191782 */     GIR_RootConstrainSelectedInstOperands,
     /* 191783 */     // GIR_Coverage, 1422,
     /* 191783 */     GIR_EraseRootFromParent_Done,
     /* 191784 */   // Label 3544: @191784
     /* 191784 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(191829), // Rule ID 1423 //
     /* 191789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 191797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191818 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 191821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191827 */     GIR_RootConstrainSelectedInstOperands,
     /* 191828 */     // GIR_Coverage, 1423,
     /* 191828 */     GIR_EraseRootFromParent_Done,
     /* 191829 */   // Label 3545: @191829
     /* 191829 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(191874), // Rule ID 1424 //
     /* 191834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 191842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191863 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 191866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191872 */     GIR_RootConstrainSelectedInstOperands,
     /* 191873 */     // GIR_Coverage, 1424,
     /* 191873 */     GIR_EraseRootFromParent_Done,
     /* 191874 */   // Label 3546: @191874
     /* 191874 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(191919), // Rule ID 1425 //
     /* 191879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 191887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191908 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 191911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191917 */     GIR_RootConstrainSelectedInstOperands,
     /* 191918 */     // GIR_Coverage, 1425,
     /* 191918 */     GIR_EraseRootFromParent_Done,
     /* 191919 */   // Label 3547: @191919
     /* 191919 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(191964), // Rule ID 1426 //
     /* 191924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 191932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191953 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 191956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191962 */     GIR_RootConstrainSelectedInstOperands,
     /* 191963 */     // GIR_Coverage, 1426,
     /* 191963 */     GIR_EraseRootFromParent_Done,
     /* 191964 */   // Label 3548: @191964
     /* 191964 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(192009), // Rule ID 1427 //
     /* 191969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 191977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191998 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 192001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192007 */     GIR_RootConstrainSelectedInstOperands,
     /* 192008 */     // GIR_Coverage, 1427,
     /* 192008 */     GIR_EraseRootFromParent_Done,
     /* 192009 */   // Label 3549: @192009
     /* 192009 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(192054), // Rule ID 1428 //
     /* 192014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 192022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192043 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 192046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192052 */     GIR_RootConstrainSelectedInstOperands,
     /* 192053 */     // GIR_Coverage, 1428,
     /* 192053 */     GIR_EraseRootFromParent_Done,
     /* 192054 */   // Label 3550: @192054
     /* 192054 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(192099), // Rule ID 1429 //
     /* 192059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 192067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192088 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 192091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192097 */     GIR_RootConstrainSelectedInstOperands,
     /* 192098 */     // GIR_Coverage, 1429,
     /* 192098 */     GIR_EraseRootFromParent_Done,
     /* 192099 */   // Label 3551: @192099
     /* 192099 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(192144), // Rule ID 1430 //
     /* 192104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 192112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192133 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 192136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192142 */     GIR_RootConstrainSelectedInstOperands,
     /* 192143 */     // GIR_Coverage, 1430,
     /* 192143 */     GIR_EraseRootFromParent_Done,
     /* 192144 */   // Label 3552: @192144
     /* 192144 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(192189), // Rule ID 1431 //
     /* 192149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 192157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192178 */     // (intrinsic_wo_chain:{ *:[v8i8] } 691:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 192181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192187 */     GIR_RootConstrainSelectedInstOperands,
     /* 192188 */     // GIR_Coverage, 1431,
     /* 192188 */     GIR_EraseRootFromParent_Done,
     /* 192189 */   // Label 3553: @192189
     /* 192189 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(192234), // Rule ID 1432 //
     /* 192194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 192202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192223 */     // (intrinsic_wo_chain:{ *:[v16i8] } 691:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 192226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192232 */     GIR_RootConstrainSelectedInstOperands,
     /* 192233 */     // GIR_Coverage, 1432,
     /* 192233 */     GIR_EraseRootFromParent_Done,
     /* 192234 */   // Label 3554: @192234
     /* 192234 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(192279), // Rule ID 1433 //
     /* 192239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 192247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192268 */     // (intrinsic_wo_chain:{ *:[v4i16] } 691:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 192271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192277 */     GIR_RootConstrainSelectedInstOperands,
     /* 192278 */     // GIR_Coverage, 1433,
     /* 192278 */     GIR_EraseRootFromParent_Done,
     /* 192279 */   // Label 3555: @192279
     /* 192279 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(192324), // Rule ID 1434 //
     /* 192284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 192292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192313 */     // (intrinsic_wo_chain:{ *:[v8i16] } 691:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 192316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192322 */     GIR_RootConstrainSelectedInstOperands,
     /* 192323 */     // GIR_Coverage, 1434,
     /* 192323 */     GIR_EraseRootFromParent_Done,
     /* 192324 */   // Label 3556: @192324
     /* 192324 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(192369), // Rule ID 1435 //
     /* 192329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 192337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192358 */     // (intrinsic_wo_chain:{ *:[v2i32] } 691:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 192361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192367 */     GIR_RootConstrainSelectedInstOperands,
     /* 192368 */     // GIR_Coverage, 1435,
     /* 192368 */     GIR_EraseRootFromParent_Done,
     /* 192369 */   // Label 3557: @192369
     /* 192369 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(192414), // Rule ID 1436 //
     /* 192374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 192382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192403 */     // (intrinsic_wo_chain:{ *:[v4i32] } 691:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 192406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192412 */     GIR_RootConstrainSelectedInstOperands,
     /* 192413 */     // GIR_Coverage, 1436,
     /* 192413 */     GIR_EraseRootFromParent_Done,
     /* 192414 */   // Label 3558: @192414
     /* 192414 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(192459), // Rule ID 1437 //
     /* 192419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 192427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192448 */     // (intrinsic_wo_chain:{ *:[v2i64] } 691:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 192451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192457 */     GIR_RootConstrainSelectedInstOperands,
     /* 192458 */     // GIR_Coverage, 1437,
     /* 192458 */     GIR_EraseRootFromParent_Done,
     /* 192459 */   // Label 3559: @192459
     /* 192459 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(192504), // Rule ID 1438 //
     /* 192464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192493 */     // (intrinsic_wo_chain:{ *:[v8i8] } 694:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 192496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192502 */     GIR_RootConstrainSelectedInstOperands,
     /* 192503 */     // GIR_Coverage, 1438,
     /* 192503 */     GIR_EraseRootFromParent_Done,
     /* 192504 */   // Label 3560: @192504
     /* 192504 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(192549), // Rule ID 1439 //
     /* 192509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192538 */     // (intrinsic_wo_chain:{ *:[v16i8] } 694:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 192541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192547 */     GIR_RootConstrainSelectedInstOperands,
     /* 192548 */     // GIR_Coverage, 1439,
     /* 192548 */     GIR_EraseRootFromParent_Done,
     /* 192549 */   // Label 3561: @192549
     /* 192549 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(192594), // Rule ID 1440 //
     /* 192554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192583 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 192586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192592 */     GIR_RootConstrainSelectedInstOperands,
     /* 192593 */     // GIR_Coverage, 1440,
     /* 192593 */     GIR_EraseRootFromParent_Done,
     /* 192594 */   // Label 3562: @192594
     /* 192594 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(192639), // Rule ID 1441 //
     /* 192599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192628 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 192631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192637 */     GIR_RootConstrainSelectedInstOperands,
     /* 192638 */     // GIR_Coverage, 1441,
     /* 192638 */     GIR_EraseRootFromParent_Done,
     /* 192639 */   // Label 3563: @192639
     /* 192639 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(192684), // Rule ID 1442 //
     /* 192644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192673 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 192676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192682 */     GIR_RootConstrainSelectedInstOperands,
     /* 192683 */     // GIR_Coverage, 1442,
     /* 192683 */     GIR_EraseRootFromParent_Done,
     /* 192684 */   // Label 3564: @192684
     /* 192684 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(192729), // Rule ID 1443 //
     /* 192689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192718 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 192721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192727 */     GIR_RootConstrainSelectedInstOperands,
     /* 192728 */     // GIR_Coverage, 1443,
     /* 192728 */     GIR_EraseRootFromParent_Done,
     /* 192729 */   // Label 3565: @192729
     /* 192729 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(192774), // Rule ID 1444 //
     /* 192734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 192742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192763 */     // (intrinsic_wo_chain:{ *:[v2i64] } 694:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 192766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192772 */     GIR_RootConstrainSelectedInstOperands,
     /* 192773 */     // GIR_Coverage, 1444,
     /* 192773 */     GIR_EraseRootFromParent_Done,
     /* 192774 */   // Label 3566: @192774
     /* 192774 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(192819), // Rule ID 1445 //
     /* 192779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 192787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192808 */     // (intrinsic_wo_chain:{ *:[v8i8] } 698:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 192811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192817 */     GIR_RootConstrainSelectedInstOperands,
     /* 192818 */     // GIR_Coverage, 1445,
     /* 192818 */     GIR_EraseRootFromParent_Done,
     /* 192819 */   // Label 3567: @192819
     /* 192819 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(192864), // Rule ID 1446 //
     /* 192824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 192832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192853 */     // (intrinsic_wo_chain:{ *:[v16i8] } 698:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 192856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192862 */     GIR_RootConstrainSelectedInstOperands,
     /* 192863 */     // GIR_Coverage, 1446,
     /* 192863 */     GIR_EraseRootFromParent_Done,
     /* 192864 */   // Label 3568: @192864
     /* 192864 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(192909), // Rule ID 1447 //
     /* 192869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 192877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192898 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 192901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192907 */     GIR_RootConstrainSelectedInstOperands,
     /* 192908 */     // GIR_Coverage, 1447,
     /* 192908 */     GIR_EraseRootFromParent_Done,
     /* 192909 */   // Label 3569: @192909
     /* 192909 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(192954), // Rule ID 1448 //
     /* 192914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 192922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192943 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 192946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192952 */     GIR_RootConstrainSelectedInstOperands,
     /* 192953 */     // GIR_Coverage, 1448,
     /* 192953 */     GIR_EraseRootFromParent_Done,
     /* 192954 */   // Label 3570: @192954
     /* 192954 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(192999), // Rule ID 1449 //
     /* 192959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 192967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192988 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 192991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192997 */     GIR_RootConstrainSelectedInstOperands,
     /* 192998 */     // GIR_Coverage, 1449,
     /* 192998 */     GIR_EraseRootFromParent_Done,
     /* 192999 */   // Label 3571: @192999
     /* 192999 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(193044), // Rule ID 1450 //
     /* 193004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 193012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193033 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 193036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193042 */     GIR_RootConstrainSelectedInstOperands,
     /* 193043 */     // GIR_Coverage, 1450,
     /* 193043 */     GIR_EraseRootFromParent_Done,
     /* 193044 */   // Label 3572: @193044
     /* 193044 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(193089), // Rule ID 1451 //
     /* 193049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 193057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 193060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 193063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 193066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193078 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 193078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 193081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193087 */     GIR_RootConstrainSelectedInstOperands,
     /* 193088 */     // GIR_Coverage, 1451,
     /* 193088 */     GIR_EraseRootFromParent_Done,
     /* 193089 */   // Label 3573: @193089
     /* 193089 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(193134), // Rule ID 1458 //
     /* 193094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 193102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193123 */     // (intrinsic_wo_chain:{ *:[v8i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 193126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193132 */     GIR_RootConstrainSelectedInstOperands,
     /* 193133 */     // GIR_Coverage, 1458,
     /* 193133 */     GIR_EraseRootFromParent_Done,
     /* 193134 */   // Label 3574: @193134
     /* 193134 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(193179), // Rule ID 1459 //
     /* 193139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 193147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193168 */     // (intrinsic_wo_chain:{ *:[v16i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 193171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193177 */     GIR_RootConstrainSelectedInstOperands,
     /* 193178 */     // GIR_Coverage, 1459,
     /* 193178 */     GIR_EraseRootFromParent_Done,
     /* 193179 */   // Label 3575: @193179
     /* 193179 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(193224), // Rule ID 1460 //
     /* 193184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 193192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193213 */     // (intrinsic_wo_chain:{ *:[v4i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 193216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193222 */     GIR_RootConstrainSelectedInstOperands,
     /* 193223 */     // GIR_Coverage, 1460,
     /* 193223 */     GIR_EraseRootFromParent_Done,
     /* 193224 */   // Label 3576: @193224
     /* 193224 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(193269), // Rule ID 1461 //
     /* 193229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 193237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193258 */     // (intrinsic_wo_chain:{ *:[v8i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 193261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193267 */     GIR_RootConstrainSelectedInstOperands,
     /* 193268 */     // GIR_Coverage, 1461,
     /* 193268 */     GIR_EraseRootFromParent_Done,
     /* 193269 */   // Label 3577: @193269
     /* 193269 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(193314), // Rule ID 1462 //
     /* 193274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 193282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193303 */     // (intrinsic_wo_chain:{ *:[v2i32] } 702:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 193306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193312 */     GIR_RootConstrainSelectedInstOperands,
     /* 193313 */     // GIR_Coverage, 1462,
     /* 193313 */     GIR_EraseRootFromParent_Done,
     /* 193314 */   // Label 3578: @193314
     /* 193314 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(193359), // Rule ID 1463 //
     /* 193319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 193327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193348 */     // (intrinsic_wo_chain:{ *:[v4i32] } 702:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 193351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193357 */     GIR_RootConstrainSelectedInstOperands,
     /* 193358 */     // GIR_Coverage, 1463,
     /* 193358 */     GIR_EraseRootFromParent_Done,
     /* 193359 */   // Label 3579: @193359
     /* 193359 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(193404), // Rule ID 1464 //
     /* 193364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 193372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 193375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 193378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 193381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193393 */     // (intrinsic_wo_chain:{ *:[v2i64] } 702:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 193393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 193396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193402 */     GIR_RootConstrainSelectedInstOperands,
     /* 193403 */     // GIR_Coverage, 1464,
     /* 193403 */     GIR_EraseRootFromParent_Done,
     /* 193404 */   // Label 3580: @193404
     /* 193404 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(193449), // Rule ID 1465 //
     /* 193409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 193417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193438 */     // (intrinsic_wo_chain:{ *:[v8i8] } 703:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 193441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193447 */     GIR_RootConstrainSelectedInstOperands,
     /* 193448 */     // GIR_Coverage, 1465,
     /* 193448 */     GIR_EraseRootFromParent_Done,
     /* 193449 */   // Label 3581: @193449
     /* 193449 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(193494), // Rule ID 1466 //
     /* 193454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 193462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193483 */     // (intrinsic_wo_chain:{ *:[v16i8] } 703:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 193486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193492 */     GIR_RootConstrainSelectedInstOperands,
     /* 193493 */     // GIR_Coverage, 1466,
     /* 193493 */     GIR_EraseRootFromParent_Done,
     /* 193494 */   // Label 3582: @193494
     /* 193494 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(193539), // Rule ID 1467 //
     /* 193499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 193507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193528 */     // (intrinsic_wo_chain:{ *:[v4i16] } 703:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 193531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193537 */     GIR_RootConstrainSelectedInstOperands,
     /* 193538 */     // GIR_Coverage, 1467,
     /* 193538 */     GIR_EraseRootFromParent_Done,
     /* 193539 */   // Label 3583: @193539
     /* 193539 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(193584), // Rule ID 1468 //
     /* 193544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 193552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193573 */     // (intrinsic_wo_chain:{ *:[v8i16] } 703:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 193576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193582 */     GIR_RootConstrainSelectedInstOperands,
     /* 193583 */     // GIR_Coverage, 1468,
     /* 193583 */     GIR_EraseRootFromParent_Done,
     /* 193584 */   // Label 3584: @193584
     /* 193584 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(193629), // Rule ID 1469 //
     /* 193589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 193597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193618 */     // (intrinsic_wo_chain:{ *:[v2i32] } 703:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 193621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193627 */     GIR_RootConstrainSelectedInstOperands,
     /* 193628 */     // GIR_Coverage, 1469,
     /* 193628 */     GIR_EraseRootFromParent_Done,
     /* 193629 */   // Label 3585: @193629
     /* 193629 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(193674), // Rule ID 1470 //
     /* 193634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 193642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193663 */     // (intrinsic_wo_chain:{ *:[v4i32] } 703:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 193666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193672 */     GIR_RootConstrainSelectedInstOperands,
     /* 193673 */     // GIR_Coverage, 1470,
     /* 193673 */     GIR_EraseRootFromParent_Done,
     /* 193674 */   // Label 3586: @193674
     /* 193674 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(193719), // Rule ID 1471 //
     /* 193679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 193687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 193690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 193693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 193696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193708 */     // (intrinsic_wo_chain:{ *:[v2i64] } 703:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 193708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 193711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193717 */     GIR_RootConstrainSelectedInstOperands,
     /* 193718 */     // GIR_Coverage, 1471,
     /* 193718 */     GIR_EraseRootFromParent_Done,
     /* 193719 */   // Label 3587: @193719
     /* 193719 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(193764), // Rule ID 1492 //
     /* 193724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 193732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193753 */     // (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 193756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193762 */     GIR_RootConstrainSelectedInstOperands,
     /* 193763 */     // GIR_Coverage, 1492,
     /* 193763 */     GIR_EraseRootFromParent_Done,
     /* 193764 */   // Label 3588: @193764
     /* 193764 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(193809), // Rule ID 1494 //
     /* 193769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 193777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193798 */     // (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 193801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193807 */     GIR_RootConstrainSelectedInstOperands,
     /* 193808 */     // GIR_Coverage, 1494,
     /* 193808 */     GIR_EraseRootFromParent_Done,
     /* 193809 */   // Label 3589: @193809
     /* 193809 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(193854), // Rule ID 1496 //
     /* 193814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 193822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193843 */     // (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 193846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193852 */     GIR_RootConstrainSelectedInstOperands,
     /* 193853 */     // GIR_Coverage, 1496,
     /* 193853 */     GIR_EraseRootFromParent_Done,
     /* 193854 */   // Label 3590: @193854
     /* 193854 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(193899), // Rule ID 1498 //
     /* 193859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 193867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193888 */     // (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 193891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193897 */     GIR_RootConstrainSelectedInstOperands,
     /* 193898 */     // GIR_Coverage, 1498,
     /* 193898 */     GIR_EraseRootFromParent_Done,
     /* 193899 */   // Label 3591: @193899
     /* 193899 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(193944), // Rule ID 1500 //
     /* 193904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 193912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193933 */     // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 193936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193942 */     GIR_RootConstrainSelectedInstOperands,
     /* 193943 */     // GIR_Coverage, 1500,
     /* 193943 */     GIR_EraseRootFromParent_Done,
     /* 193944 */   // Label 3592: @193944
     /* 193944 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(193989), // Rule ID 1502 //
     /* 193949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 193957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193978 */     // (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 193981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193987 */     GIR_RootConstrainSelectedInstOperands,
     /* 193988 */     // GIR_Coverage, 1502,
     /* 193988 */     GIR_EraseRootFromParent_Done,
     /* 193989 */   // Label 3593: @193989
     /* 193989 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(194034), // Rule ID 1509 //
     /* 193994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 194002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194023 */     // (intrinsic_wo_chain:{ *:[v8i8] } 730:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 194026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194032 */     GIR_RootConstrainSelectedInstOperands,
     /* 194033 */     // GIR_Coverage, 1509,
     /* 194033 */     GIR_EraseRootFromParent_Done,
     /* 194034 */   // Label 3594: @194034
     /* 194034 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(194079), // Rule ID 1510 //
     /* 194039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 194047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194068 */     // (intrinsic_wo_chain:{ *:[v16i8] } 730:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 194071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194077 */     GIR_RootConstrainSelectedInstOperands,
     /* 194078 */     // GIR_Coverage, 1510,
     /* 194078 */     GIR_EraseRootFromParent_Done,
     /* 194079 */   // Label 3595: @194079
     /* 194079 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(194124), // Rule ID 1511 //
     /* 194084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 194092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194113 */     // (intrinsic_wo_chain:{ *:[v4i16] } 730:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 194116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194122 */     GIR_RootConstrainSelectedInstOperands,
     /* 194123 */     // GIR_Coverage, 1511,
     /* 194123 */     GIR_EraseRootFromParent_Done,
     /* 194124 */   // Label 3596: @194124
     /* 194124 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(194169), // Rule ID 1512 //
     /* 194129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 194137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194158 */     // (intrinsic_wo_chain:{ *:[v8i16] } 730:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 194161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194167 */     GIR_RootConstrainSelectedInstOperands,
     /* 194168 */     // GIR_Coverage, 1512,
     /* 194168 */     GIR_EraseRootFromParent_Done,
     /* 194169 */   // Label 3597: @194169
     /* 194169 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(194214), // Rule ID 1513 //
     /* 194174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 194182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194203 */     // (intrinsic_wo_chain:{ *:[v2i32] } 730:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 194206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194212 */     GIR_RootConstrainSelectedInstOperands,
     /* 194213 */     // GIR_Coverage, 1513,
     /* 194213 */     GIR_EraseRootFromParent_Done,
     /* 194214 */   // Label 3598: @194214
     /* 194214 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(194259), // Rule ID 1514 //
     /* 194219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 194227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194248 */     // (intrinsic_wo_chain:{ *:[v4i32] } 730:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 194251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194257 */     GIR_RootConstrainSelectedInstOperands,
     /* 194258 */     // GIR_Coverage, 1514,
     /* 194258 */     GIR_EraseRootFromParent_Done,
     /* 194259 */   // Label 3599: @194259
     /* 194259 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(194304), // Rule ID 1515 //
     /* 194264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 194272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194293 */     // (intrinsic_wo_chain:{ *:[v8i8] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 194296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194302 */     GIR_RootConstrainSelectedInstOperands,
     /* 194303 */     // GIR_Coverage, 1515,
     /* 194303 */     GIR_EraseRootFromParent_Done,
     /* 194304 */   // Label 3600: @194304
     /* 194304 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(194349), // Rule ID 1516 //
     /* 194309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 194317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194338 */     // (intrinsic_wo_chain:{ *:[v16i8] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 194341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194347 */     GIR_RootConstrainSelectedInstOperands,
     /* 194348 */     // GIR_Coverage, 1516,
     /* 194348 */     GIR_EraseRootFromParent_Done,
     /* 194349 */   // Label 3601: @194349
     /* 194349 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(194394), // Rule ID 1517 //
     /* 194354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 194362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194383 */     // (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 194386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194392 */     GIR_RootConstrainSelectedInstOperands,
     /* 194393 */     // GIR_Coverage, 1517,
     /* 194393 */     GIR_EraseRootFromParent_Done,
     /* 194394 */   // Label 3602: @194394
     /* 194394 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(194439), // Rule ID 1518 //
     /* 194399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 194407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194428 */     // (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 194431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194437 */     GIR_RootConstrainSelectedInstOperands,
     /* 194438 */     // GIR_Coverage, 1518,
     /* 194438 */     GIR_EraseRootFromParent_Done,
     /* 194439 */   // Label 3603: @194439
     /* 194439 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(194484), // Rule ID 1519 //
     /* 194444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 194452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194473 */     // (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 194476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194482 */     GIR_RootConstrainSelectedInstOperands,
     /* 194483 */     // GIR_Coverage, 1519,
     /* 194483 */     GIR_EraseRootFromParent_Done,
     /* 194484 */   // Label 3604: @194484
     /* 194484 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(194529), // Rule ID 1520 //
     /* 194489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 194497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194518 */     // (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 194521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194527 */     GIR_RootConstrainSelectedInstOperands,
     /* 194528 */     // GIR_Coverage, 1520,
     /* 194528 */     GIR_EraseRootFromParent_Done,
     /* 194529 */   // Label 3605: @194529
     /* 194529 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(194574), // Rule ID 1527 //
     /* 194534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 194542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194563 */     // (intrinsic_wo_chain:{ *:[v8i8] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 194566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194572 */     GIR_RootConstrainSelectedInstOperands,
     /* 194573 */     // GIR_Coverage, 1527,
     /* 194573 */     GIR_EraseRootFromParent_Done,
     /* 194574 */   // Label 3606: @194574
     /* 194574 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(194619), // Rule ID 1528 //
     /* 194579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 194587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194608 */     // (intrinsic_wo_chain:{ *:[v16i8] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 194611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194617 */     GIR_RootConstrainSelectedInstOperands,
     /* 194618 */     // GIR_Coverage, 1528,
     /* 194618 */     GIR_EraseRootFromParent_Done,
     /* 194619 */   // Label 3607: @194619
     /* 194619 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(194664), // Rule ID 1529 //
     /* 194624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 194632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194653 */     // (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 194656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194662 */     GIR_RootConstrainSelectedInstOperands,
     /* 194663 */     // GIR_Coverage, 1529,
     /* 194663 */     GIR_EraseRootFromParent_Done,
     /* 194664 */   // Label 3608: @194664
     /* 194664 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(194709), // Rule ID 1530 //
     /* 194669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 194677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194698 */     // (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 194701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194707 */     GIR_RootConstrainSelectedInstOperands,
     /* 194708 */     // GIR_Coverage, 1530,
     /* 194708 */     GIR_EraseRootFromParent_Done,
     /* 194709 */   // Label 3609: @194709
     /* 194709 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(194754), // Rule ID 1531 //
     /* 194714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 194722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194743 */     // (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 194746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194752 */     GIR_RootConstrainSelectedInstOperands,
     /* 194753 */     // GIR_Coverage, 1531,
     /* 194753 */     GIR_EraseRootFromParent_Done,
     /* 194754 */   // Label 3610: @194754
     /* 194754 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(194799), // Rule ID 1532 //
     /* 194759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 194767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194788 */     // (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 194791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194797 */     GIR_RootConstrainSelectedInstOperands,
     /* 194798 */     // GIR_Coverage, 1532,
     /* 194798 */     GIR_EraseRootFromParent_Done,
     /* 194799 */   // Label 3611: @194799
     /* 194799 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(194844), // Rule ID 1539 //
     /* 194804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 194812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194833 */     // (intrinsic_wo_chain:{ *:[v8i8] } 739:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 194836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194842 */     GIR_RootConstrainSelectedInstOperands,
     /* 194843 */     // GIR_Coverage, 1539,
     /* 194843 */     GIR_EraseRootFromParent_Done,
     /* 194844 */   // Label 3612: @194844
     /* 194844 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(194889), // Rule ID 1540 //
     /* 194849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 194857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194878 */     // (intrinsic_wo_chain:{ *:[v16i8] } 739:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 194881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194887 */     GIR_RootConstrainSelectedInstOperands,
     /* 194888 */     // GIR_Coverage, 1540,
     /* 194888 */     GIR_EraseRootFromParent_Done,
     /* 194889 */   // Label 3613: @194889
     /* 194889 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(194934), // Rule ID 1541 //
     /* 194894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 194902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194923 */     // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 194926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194932 */     GIR_RootConstrainSelectedInstOperands,
     /* 194933 */     // GIR_Coverage, 1541,
     /* 194933 */     GIR_EraseRootFromParent_Done,
     /* 194934 */   // Label 3614: @194934
     /* 194934 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(194979), // Rule ID 1542 //
     /* 194939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 194947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194968 */     // (intrinsic_wo_chain:{ *:[v8i16] } 739:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 194971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194977 */     GIR_RootConstrainSelectedInstOperands,
     /* 194978 */     // GIR_Coverage, 1542,
     /* 194978 */     GIR_EraseRootFromParent_Done,
     /* 194979 */   // Label 3615: @194979
     /* 194979 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(195024), // Rule ID 1543 //
     /* 194984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 194992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 195001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195013 */     // (intrinsic_wo_chain:{ *:[v2i32] } 739:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 195013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 195016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195022 */     GIR_RootConstrainSelectedInstOperands,
     /* 195023 */     // GIR_Coverage, 1543,
     /* 195023 */     GIR_EraseRootFromParent_Done,
     /* 195024 */   // Label 3616: @195024
     /* 195024 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(195069), // Rule ID 1544 //
     /* 195029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 195037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195058 */     // (intrinsic_wo_chain:{ *:[v4i32] } 739:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 195058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 195061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195067 */     GIR_RootConstrainSelectedInstOperands,
     /* 195068 */     // GIR_Coverage, 1544,
     /* 195068 */     GIR_EraseRootFromParent_Done,
     /* 195069 */   // Label 3617: @195069
     /* 195069 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(195114), // Rule ID 1545 //
     /* 195074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 195082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 195088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 195091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195103 */     // (intrinsic_wo_chain:{ *:[v2i64] } 739:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 195103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 195106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195112 */     GIR_RootConstrainSelectedInstOperands,
     /* 195113 */     // GIR_Coverage, 1545,
     /* 195113 */     GIR_EraseRootFromParent_Done,
     /* 195114 */   // Label 3618: @195114
     /* 195114 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(195159), // Rule ID 1546 //
     /* 195119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 195130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 195133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 195136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195148 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 195148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 195151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195157 */     GIR_RootConstrainSelectedInstOperands,
     /* 195158 */     // GIR_Coverage, 1546,
     /* 195158 */     GIR_EraseRootFromParent_Done,
     /* 195159 */   // Label 3619: @195159
     /* 195159 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(195204), // Rule ID 1547 //
     /* 195164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 195175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 195178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 195181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195193 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 195193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 195196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195202 */     GIR_RootConstrainSelectedInstOperands,
     /* 195203 */     // GIR_Coverage, 1547,
     /* 195203 */     GIR_EraseRootFromParent_Done,
     /* 195204 */   // Label 3620: @195204
     /* 195204 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(195249), // Rule ID 1548 //
     /* 195209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195238 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 195238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 195241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195247 */     GIR_RootConstrainSelectedInstOperands,
     /* 195248 */     // GIR_Coverage, 1548,
     /* 195248 */     GIR_EraseRootFromParent_Done,
     /* 195249 */   // Label 3621: @195249
     /* 195249 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(195294), // Rule ID 1549 //
     /* 195254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195283 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 195283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 195286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195292 */     GIR_RootConstrainSelectedInstOperands,
     /* 195293 */     // GIR_Coverage, 1549,
     /* 195293 */     GIR_EraseRootFromParent_Done,
     /* 195294 */   // Label 3622: @195294
     /* 195294 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(195339), // Rule ID 1550 //
     /* 195299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 195313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 195316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195328 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 195328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 195331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195337 */     GIR_RootConstrainSelectedInstOperands,
     /* 195338 */     // GIR_Coverage, 1550,
     /* 195338 */     GIR_EraseRootFromParent_Done,
     /* 195339 */   // Label 3623: @195339
     /* 195339 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(195384), // Rule ID 1551 //
     /* 195344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195373 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 195373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 195376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195382 */     GIR_RootConstrainSelectedInstOperands,
     /* 195383 */     // GIR_Coverage, 1551,
     /* 195383 */     GIR_EraseRootFromParent_Done,
     /* 195384 */   // Label 3624: @195384
     /* 195384 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(195429), // Rule ID 1552 //
     /* 195389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 195403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 195406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195418 */     // (intrinsic_wo_chain:{ *:[v2i64] } 740:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 195418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 195421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195427 */     GIR_RootConstrainSelectedInstOperands,
     /* 195428 */     // GIR_Coverage, 1552,
     /* 195428 */     GIR_EraseRootFromParent_Done,
     /* 195429 */   // Label 3625: @195429
     /* 195429 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(195474), // Rule ID 1553 //
     /* 195434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 195445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 195448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 195451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195463 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 195463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 195466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195472 */     GIR_RootConstrainSelectedInstOperands,
     /* 195473 */     // GIR_Coverage, 1553,
     /* 195473 */     GIR_EraseRootFromParent_Done,
     /* 195474 */   // Label 3626: @195474
     /* 195474 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(195519), // Rule ID 1554 //
     /* 195479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 195490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 195493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 195496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195508 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 195508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 195511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195517 */     GIR_RootConstrainSelectedInstOperands,
     /* 195518 */     // GIR_Coverage, 1554,
     /* 195518 */     GIR_EraseRootFromParent_Done,
     /* 195519 */   // Label 3627: @195519
     /* 195519 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(195564), // Rule ID 1555 //
     /* 195524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195553 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 195553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 195556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195562 */     GIR_RootConstrainSelectedInstOperands,
     /* 195563 */     // GIR_Coverage, 1555,
     /* 195563 */     GIR_EraseRootFromParent_Done,
     /* 195564 */   // Label 3628: @195564
     /* 195564 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(195609), // Rule ID 1556 //
     /* 195569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195598 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 195598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 195601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195607 */     GIR_RootConstrainSelectedInstOperands,
     /* 195608 */     // GIR_Coverage, 1556,
     /* 195608 */     GIR_EraseRootFromParent_Done,
     /* 195609 */   // Label 3629: @195609
     /* 195609 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(195654), // Rule ID 1557 //
     /* 195614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 195628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 195631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195643 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 195643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 195646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195652 */     GIR_RootConstrainSelectedInstOperands,
     /* 195653 */     // GIR_Coverage, 1557,
     /* 195653 */     GIR_EraseRootFromParent_Done,
     /* 195654 */   // Label 3630: @195654
     /* 195654 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(195699), // Rule ID 1558 //
     /* 195659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195688 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 195688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 195691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195697 */     GIR_RootConstrainSelectedInstOperands,
     /* 195698 */     // GIR_Coverage, 1558,
     /* 195698 */     GIR_EraseRootFromParent_Done,
     /* 195699 */   // Label 3631: @195699
     /* 195699 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(195744), // Rule ID 1559 //
     /* 195704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 195715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 195718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 195721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195733 */     // (intrinsic_wo_chain:{ *:[v2i64] } 742:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 195733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 195736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195742 */     GIR_RootConstrainSelectedInstOperands,
     /* 195743 */     // GIR_Coverage, 1559,
     /* 195743 */     GIR_EraseRootFromParent_Done,
     /* 195744 */   // Label 3632: @195744
     /* 195744 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(195789), // Rule ID 1560 //
     /* 195749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 195757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 195760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 195763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 195766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195778 */     // (intrinsic_wo_chain:{ *:[v8i8] } 744:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 195778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 195781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195787 */     GIR_RootConstrainSelectedInstOperands,
     /* 195788 */     // GIR_Coverage, 1560,
     /* 195788 */     GIR_EraseRootFromParent_Done,
     /* 195789 */   // Label 3633: @195789
     /* 195789 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(195834), // Rule ID 1561 //
     /* 195794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 195802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 195805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 195808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 195811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195823 */     // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 195823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 195826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195832 */     GIR_RootConstrainSelectedInstOperands,
     /* 195833 */     // GIR_Coverage, 1561,
     /* 195833 */     GIR_EraseRootFromParent_Done,
     /* 195834 */   // Label 3634: @195834
     /* 195834 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(195879), // Rule ID 1562 //
     /* 195839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 195847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 195850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 195853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 195856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195868 */     // (intrinsic_wo_chain:{ *:[v4i16] } 744:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 195868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 195871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195877 */     GIR_RootConstrainSelectedInstOperands,
     /* 195878 */     // GIR_Coverage, 1562,
     /* 195878 */     GIR_EraseRootFromParent_Done,
     /* 195879 */   // Label 3635: @195879
     /* 195879 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(195924), // Rule ID 1563 //
     /* 195884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 195892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 195895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 195898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 195901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195913 */     // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 195913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 195916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195922 */     GIR_RootConstrainSelectedInstOperands,
     /* 195923 */     // GIR_Coverage, 1563,
     /* 195923 */     GIR_EraseRootFromParent_Done,
     /* 195924 */   // Label 3636: @195924
     /* 195924 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(195969), // Rule ID 1564 //
     /* 195929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 195937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 195940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 195943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 195946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195958 */     // (intrinsic_wo_chain:{ *:[v2i32] } 744:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 195958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 195961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195967 */     GIR_RootConstrainSelectedInstOperands,
     /* 195968 */     // GIR_Coverage, 1564,
     /* 195968 */     GIR_EraseRootFromParent_Done,
     /* 195969 */   // Label 3637: @195969
     /* 195969 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(196014), // Rule ID 1565 //
     /* 195974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 195982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 195985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 195988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 195991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 195999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196003 */     // (intrinsic_wo_chain:{ *:[v4i32] } 744:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 196006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196012 */     GIR_RootConstrainSelectedInstOperands,
     /* 196013 */     // GIR_Coverage, 1565,
     /* 196013 */     GIR_EraseRootFromParent_Done,
     /* 196014 */   // Label 3638: @196014
     /* 196014 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(196059), // Rule ID 1566 //
     /* 196019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 196027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196048 */     // (intrinsic_wo_chain:{ *:[v2i64] } 744:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 196051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196057 */     GIR_RootConstrainSelectedInstOperands,
     /* 196058 */     // GIR_Coverage, 1566,
     /* 196058 */     GIR_EraseRootFromParent_Done,
     /* 196059 */   // Label 3639: @196059
     /* 196059 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(196104), // Rule ID 1573 //
     /* 196064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 196072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 196078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 196081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196093 */     // (intrinsic_wo_chain:{ *:[v8i8] } 748:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 196093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 196096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196102 */     GIR_RootConstrainSelectedInstOperands,
     /* 196103 */     // GIR_Coverage, 1573,
     /* 196103 */     GIR_EraseRootFromParent_Done,
     /* 196104 */   // Label 3640: @196104
     /* 196104 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(196149), // Rule ID 1574 //
     /* 196109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 196117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 196123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 196126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196138 */     // (intrinsic_wo_chain:{ *:[v16i8] } 748:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 196138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 196141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196147 */     GIR_RootConstrainSelectedInstOperands,
     /* 196148 */     // GIR_Coverage, 1574,
     /* 196148 */     GIR_EraseRootFromParent_Done,
     /* 196149 */   // Label 3641: @196149
     /* 196149 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(196194), // Rule ID 1575 //
     /* 196154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 196162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 196168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196183 */     // (intrinsic_wo_chain:{ *:[v4i16] } 748:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 196183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 196186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196192 */     GIR_RootConstrainSelectedInstOperands,
     /* 196193 */     // GIR_Coverage, 1575,
     /* 196193 */     GIR_EraseRootFromParent_Done,
     /* 196194 */   // Label 3642: @196194
     /* 196194 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(196239), // Rule ID 1576 //
     /* 196199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 196207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196228 */     // (intrinsic_wo_chain:{ *:[v8i16] } 748:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 196231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196237 */     GIR_RootConstrainSelectedInstOperands,
     /* 196238 */     // GIR_Coverage, 1576,
     /* 196238 */     GIR_EraseRootFromParent_Done,
     /* 196239 */   // Label 3643: @196239
     /* 196239 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(196284), // Rule ID 1577 //
     /* 196244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 196252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 196261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196273 */     // (intrinsic_wo_chain:{ *:[v2i32] } 748:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 196273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 196276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196282 */     GIR_RootConstrainSelectedInstOperands,
     /* 196283 */     // GIR_Coverage, 1577,
     /* 196283 */     GIR_EraseRootFromParent_Done,
     /* 196284 */   // Label 3644: @196284
     /* 196284 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(196329), // Rule ID 1578 //
     /* 196289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 196297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196318 */     // (intrinsic_wo_chain:{ *:[v4i32] } 748:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 196321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196327 */     GIR_RootConstrainSelectedInstOperands,
     /* 196328 */     // GIR_Coverage, 1578,
     /* 196328 */     GIR_EraseRootFromParent_Done,
     /* 196329 */   // Label 3645: @196329
     /* 196329 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(196374), // Rule ID 1579 //
     /* 196334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 196342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196363 */     // (intrinsic_wo_chain:{ *:[v2i64] } 748:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 196366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196372 */     GIR_RootConstrainSelectedInstOperands,
     /* 196373 */     // GIR_Coverage, 1579,
     /* 196373 */     GIR_EraseRootFromParent_Done,
     /* 196374 */   // Label 3646: @196374
     /* 196374 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(196419), // Rule ID 1580 //
     /* 196379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 196387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 196393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 196396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196408 */     // (intrinsic_wo_chain:{ *:[v8i8] } 751:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 196408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 196411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196417 */     GIR_RootConstrainSelectedInstOperands,
     /* 196418 */     // GIR_Coverage, 1580,
     /* 196418 */     GIR_EraseRootFromParent_Done,
     /* 196419 */   // Label 3647: @196419
     /* 196419 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(196464), // Rule ID 1581 //
     /* 196424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 196432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 196438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 196441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196453 */     // (intrinsic_wo_chain:{ *:[v16i8] } 751:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 196453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 196456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196462 */     GIR_RootConstrainSelectedInstOperands,
     /* 196463 */     // GIR_Coverage, 1581,
     /* 196463 */     GIR_EraseRootFromParent_Done,
     /* 196464 */   // Label 3648: @196464
     /* 196464 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(196509), // Rule ID 1582 //
     /* 196469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 196477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 196483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196498 */     // (intrinsic_wo_chain:{ *:[v4i16] } 751:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 196498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 196501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196507 */     GIR_RootConstrainSelectedInstOperands,
     /* 196508 */     // GIR_Coverage, 1582,
     /* 196508 */     GIR_EraseRootFromParent_Done,
     /* 196509 */   // Label 3649: @196509
     /* 196509 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(196554), // Rule ID 1583 //
     /* 196514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 196522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196543 */     // (intrinsic_wo_chain:{ *:[v8i16] } 751:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 196546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196552 */     GIR_RootConstrainSelectedInstOperands,
     /* 196553 */     // GIR_Coverage, 1583,
     /* 196553 */     GIR_EraseRootFromParent_Done,
     /* 196554 */   // Label 3650: @196554
     /* 196554 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(196599), // Rule ID 1584 //
     /* 196559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 196567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 196576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196588 */     // (intrinsic_wo_chain:{ *:[v2i32] } 751:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 196588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 196591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196597 */     GIR_RootConstrainSelectedInstOperands,
     /* 196598 */     // GIR_Coverage, 1584,
     /* 196598 */     GIR_EraseRootFromParent_Done,
     /* 196599 */   // Label 3651: @196599
     /* 196599 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(196644), // Rule ID 1585 //
     /* 196604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 196612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196633 */     // (intrinsic_wo_chain:{ *:[v4i32] } 751:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 196636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196642 */     GIR_RootConstrainSelectedInstOperands,
     /* 196643 */     // GIR_Coverage, 1585,
     /* 196643 */     GIR_EraseRootFromParent_Done,
     /* 196644 */   // Label 3652: @196644
     /* 196644 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(196689), // Rule ID 1586 //
     /* 196649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 196657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196678 */     // (intrinsic_wo_chain:{ *:[v2i64] } 751:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 196681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196687 */     GIR_RootConstrainSelectedInstOperands,
     /* 196688 */     // GIR_Coverage, 1586,
     /* 196688 */     GIR_EraseRootFromParent_Done,
     /* 196689 */   // Label 3653: @196689
     /* 196689 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(196734), // Rule ID 1614 //
     /* 196694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 196702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196723 */     // (intrinsic_wo_chain:{ *:[f64] } 785:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 196723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 196726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196732 */     GIR_RootConstrainSelectedInstOperands,
     /* 196733 */     // GIR_Coverage, 1614,
     /* 196733 */     GIR_EraseRootFromParent_Done,
     /* 196734 */   // Label 3654: @196734
     /* 196734 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(196779), // Rule ID 1615 //
     /* 196739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 196747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196768 */     // (intrinsic_wo_chain:{ *:[f32] } 785:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 196768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 196771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196777 */     GIR_RootConstrainSelectedInstOperands,
     /* 196778 */     // GIR_Coverage, 1615,
     /* 196778 */     GIR_EraseRootFromParent_Done,
     /* 196779 */   // Label 3655: @196779
     /* 196779 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(196824), // Rule ID 1616 //
     /* 196784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 196787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 196792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 196795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 196798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 196801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 196805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 196809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 196813 */     // (intrinsic_wo_chain:{ *:[f16] } 785:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 196813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 196816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196822 */     GIR_RootConstrainSelectedInstOperands,
     /* 196823 */     // GIR_Coverage, 1616,
     /* 196823 */     GIR_EraseRootFromParent_Done,
     /* 196824 */   // Label 3656: @196824
     /* 196824 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(196869), // Rule ID 1617 //
     /* 196829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 196837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196858 */     // (intrinsic_wo_chain:{ *:[i64] } 577:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 196858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 196861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196867 */     GIR_RootConstrainSelectedInstOperands,
     /* 196868 */     // GIR_Coverage, 1617,
     /* 196868 */     GIR_EraseRootFromParent_Done,
     /* 196869 */   // Label 3657: @196869
     /* 196869 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(196914), // Rule ID 1618 //
     /* 196874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 196882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196903 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 196903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 196906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196912 */     GIR_RootConstrainSelectedInstOperands,
     /* 196913 */     // GIR_Coverage, 1618,
     /* 196913 */     GIR_EraseRootFromParent_Done,
     /* 196914 */   // Label 3658: @196914
     /* 196914 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(196959), // Rule ID 1619 //
     /* 196919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 196927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196948 */     // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 196948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 196951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196957 */     GIR_RootConstrainSelectedInstOperands,
     /* 196958 */     // GIR_Coverage, 1619,
     /* 196958 */     GIR_EraseRootFromParent_Done,
     /* 196959 */   // Label 3659: @196959
     /* 196959 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(197004), // Rule ID 1620 //
     /* 196964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 196972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196993 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 196993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 196996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197002 */     GIR_RootConstrainSelectedInstOperands,
     /* 197003 */     // GIR_Coverage, 1620,
     /* 197003 */     GIR_EraseRootFromParent_Done,
     /* 197004 */   // Label 3660: @197004
     /* 197004 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(197049), // Rule ID 1627 //
     /* 197009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 197012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 197017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197038 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 197038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 197041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197047 */     GIR_RootConstrainSelectedInstOperands,
     /* 197048 */     // GIR_Coverage, 1627,
     /* 197048 */     GIR_EraseRootFromParent_Done,
     /* 197049 */   // Label 3661: @197049
     /* 197049 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(197094), // Rule ID 1628 //
     /* 197054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 197057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 197062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197083 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 197083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 197086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197092 */     GIR_RootConstrainSelectedInstOperands,
     /* 197093 */     // GIR_Coverage, 1628,
     /* 197093 */     GIR_EraseRootFromParent_Done,
     /* 197094 */   // Label 3662: @197094
     /* 197094 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(197139), // Rule ID 1629 //
     /* 197099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 197102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 197107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 197110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 197113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 197116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197128 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 197128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 197131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197137 */     GIR_RootConstrainSelectedInstOperands,
     /* 197138 */     // GIR_Coverage, 1629,
     /* 197138 */     GIR_EraseRootFromParent_Done,
     /* 197139 */   // Label 3663: @197139
     /* 197139 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(197184), // Rule ID 1630 //
     /* 197144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 197147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 197152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197173 */     // (intrinsic_wo_chain:{ *:[f64] } 633:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 197173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 197176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197182 */     GIR_RootConstrainSelectedInstOperands,
     /* 197183 */     // GIR_Coverage, 1630,
     /* 197183 */     GIR_EraseRootFromParent_Done,
     /* 197184 */   // Label 3664: @197184
     /* 197184 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(197229), // Rule ID 1631 //
     /* 197189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 197192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 197197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197218 */     // (intrinsic_wo_chain:{ *:[f32] } 633:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 197218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 197221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197227 */     GIR_RootConstrainSelectedInstOperands,
     /* 197228 */     // GIR_Coverage, 1631,
     /* 197228 */     GIR_EraseRootFromParent_Done,
     /* 197229 */   // Label 3665: @197229
     /* 197229 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(197274), // Rule ID 1632 //
     /* 197234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 197237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 197242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 197245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 197248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 197251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197263 */     // (intrinsic_wo_chain:{ *:[f16] } 633:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 197263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 197266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197272 */     GIR_RootConstrainSelectedInstOperands,
     /* 197273 */     // GIR_Coverage, 1632,
     /* 197273 */     GIR_EraseRootFromParent_Done,
     /* 197274 */   // Label 3666: @197274
     /* 197274 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(197319), // Rule ID 1633 //
     /* 197279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 197282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 197287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197308 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 197308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 197311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197317 */     GIR_RootConstrainSelectedInstOperands,
     /* 197318 */     // GIR_Coverage, 1633,
     /* 197318 */     GIR_EraseRootFromParent_Done,
     /* 197319 */   // Label 3667: @197319
     /* 197319 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(197364), // Rule ID 1634 //
     /* 197324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 197327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 197332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197353 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 197353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 197356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197362 */     GIR_RootConstrainSelectedInstOperands,
     /* 197363 */     // GIR_Coverage, 1634,
     /* 197363 */     GIR_EraseRootFromParent_Done,
     /* 197364 */   // Label 3668: @197364
     /* 197364 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(197409), // Rule ID 1635 //
     /* 197369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 197372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 197377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 197380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 197383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 197386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 197398 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 197398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 197401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197407 */     GIR_RootConstrainSelectedInstOperands,
     /* 197408 */     // GIR_Coverage, 1635,
     /* 197408 */     GIR_EraseRootFromParent_Done,
     /* 197409 */   // Label 3669: @197409
     /* 197409 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(197454), // Rule ID 1636 //
     /* 197414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 197422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197443 */     // (intrinsic_wo_chain:{ *:[v1i64] } 679:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 197446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197452 */     GIR_RootConstrainSelectedInstOperands,
     /* 197453 */     // GIR_Coverage, 1636,
     /* 197453 */     GIR_EraseRootFromParent_Done,
     /* 197454 */   // Label 3670: @197454
     /* 197454 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(197499), // Rule ID 1637 //
     /* 197459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 197467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197488 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 197488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 197491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197497 */     GIR_RootConstrainSelectedInstOperands,
     /* 197498 */     // GIR_Coverage, 1637,
     /* 197498 */     GIR_EraseRootFromParent_Done,
     /* 197499 */   // Label 3671: @197499
     /* 197499 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(197544), // Rule ID 1638 //
     /* 197504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 197512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197533 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 197533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 197536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197542 */     GIR_RootConstrainSelectedInstOperands,
     /* 197543 */     // GIR_Coverage, 1638,
     /* 197543 */     GIR_EraseRootFromParent_Done,
     /* 197544 */   // Label 3672: @197544
     /* 197544 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(197589), // Rule ID 1639 //
     /* 197549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 197557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197578 */     // (intrinsic_wo_chain:{ *:[v1i64] } 691:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 197581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197587 */     GIR_RootConstrainSelectedInstOperands,
     /* 197588 */     // GIR_Coverage, 1639,
     /* 197588 */     GIR_EraseRootFromParent_Done,
     /* 197589 */   // Label 3673: @197589
     /* 197589 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(197634), // Rule ID 1640 //
     /* 197594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 197602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197623 */     // (intrinsic_wo_chain:{ *:[v1i64] } 694:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 197626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197632 */     GIR_RootConstrainSelectedInstOperands,
     /* 197633 */     // GIR_Coverage, 1640,
     /* 197633 */     GIR_EraseRootFromParent_Done,
     /* 197634 */   // Label 3674: @197634
     /* 197634 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(197679), // Rule ID 1641 //
     /* 197639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 197647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197668 */     // (intrinsic_wo_chain:{ *:[v1i64] } 698:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 197671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197677 */     GIR_RootConstrainSelectedInstOperands,
     /* 197678 */     // GIR_Coverage, 1641,
     /* 197678 */     GIR_EraseRootFromParent_Done,
     /* 197679 */   // Label 3675: @197679
     /* 197679 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(197724), // Rule ID 1642 //
     /* 197684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 197692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197713 */     // (intrinsic_wo_chain:{ *:[v1i64] } 702:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 197716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197722 */     GIR_RootConstrainSelectedInstOperands,
     /* 197723 */     // GIR_Coverage, 1642,
     /* 197723 */     GIR_EraseRootFromParent_Done,
     /* 197724 */   // Label 3676: @197724
     /* 197724 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(197769), // Rule ID 1643 //
     /* 197729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 197737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197758 */     // (intrinsic_wo_chain:{ *:[v1i64] } 703:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 197761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197767 */     GIR_RootConstrainSelectedInstOperands,
     /* 197768 */     // GIR_Coverage, 1643,
     /* 197768 */     GIR_EraseRootFromParent_Done,
     /* 197769 */   // Label 3677: @197769
     /* 197769 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(197814), // Rule ID 1645 //
     /* 197774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 197782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197803 */     // (intrinsic_wo_chain:{ *:[v1i64] } 739:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 197806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197812 */     GIR_RootConstrainSelectedInstOperands,
     /* 197813 */     // GIR_Coverage, 1645,
     /* 197813 */     GIR_EraseRootFromParent_Done,
     /* 197814 */   // Label 3678: @197814
     /* 197814 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(197859), // Rule ID 1646 //
     /* 197819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 197827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197848 */     // (intrinsic_wo_chain:{ *:[v1i64] } 740:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 197851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197857 */     GIR_RootConstrainSelectedInstOperands,
     /* 197858 */     // GIR_Coverage, 1646,
     /* 197858 */     GIR_EraseRootFromParent_Done,
     /* 197859 */   // Label 3679: @197859
     /* 197859 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(197904), // Rule ID 1647 //
     /* 197864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 197872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197893 */     // (intrinsic_wo_chain:{ *:[v1i64] } 742:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 197896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197902 */     GIR_RootConstrainSelectedInstOperands,
     /* 197903 */     // GIR_Coverage, 1647,
     /* 197903 */     GIR_EraseRootFromParent_Done,
     /* 197904 */   // Label 3680: @197904
     /* 197904 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(197949), // Rule ID 1648 //
     /* 197909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 197917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197938 */     // (intrinsic_wo_chain:{ *:[v1i64] } 744:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 197941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197947 */     GIR_RootConstrainSelectedInstOperands,
     /* 197948 */     // GIR_Coverage, 1648,
     /* 197948 */     GIR_EraseRootFromParent_Done,
     /* 197949 */   // Label 3681: @197949
     /* 197949 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(197994), // Rule ID 1649 //
     /* 197954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 197962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197983 */     // (intrinsic_wo_chain:{ *:[v1i64] } 748:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 197983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 197986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197992 */     GIR_RootConstrainSelectedInstOperands,
     /* 197993 */     // GIR_Coverage, 1649,
     /* 197993 */     GIR_EraseRootFromParent_Done,
     /* 197994 */   // Label 3682: @197994
     /* 197994 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(198039), // Rule ID 1650 //
     /* 197999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 198007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198028 */     // (intrinsic_wo_chain:{ *:[v1i64] } 751:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 198028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 198031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198037 */     GIR_RootConstrainSelectedInstOperands,
     /* 198038 */     // GIR_Coverage, 1650,
     /* 198038 */     GIR_EraseRootFromParent_Done,
     /* 198039 */   // Label 3683: @198039
     /* 198039 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(198084), // Rule ID 1651 //
     /* 198044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 198052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198073 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 198073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 198076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198082 */     GIR_RootConstrainSelectedInstOperands,
     /* 198083 */     // GIR_Coverage, 1651,
     /* 198083 */     GIR_EraseRootFromParent_Done,
     /* 198084 */   // Label 3684: @198084
     /* 198084 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(198129), // Rule ID 1665 //
     /* 198089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 198097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198118 */     // (intrinsic_wo_chain:{ *:[i64] } 715:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 198118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 198121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198127 */     GIR_RootConstrainSelectedInstOperands,
     /* 198128 */     // GIR_Coverage, 1665,
     /* 198128 */     GIR_EraseRootFromParent_Done,
     /* 198129 */   // Label 3685: @198129
     /* 198129 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(198174), // Rule ID 1666 //
     /* 198134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 198142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198163 */     // (intrinsic_wo_chain:{ *:[i32] } 715:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 198163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 198166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198172 */     GIR_RootConstrainSelectedInstOperands,
     /* 198173 */     // GIR_Coverage, 1666,
     /* 198173 */     GIR_EraseRootFromParent_Done,
     /* 198174 */   // Label 3686: @198174
     /* 198174 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(198219), // Rule ID 1671 //
     /* 198179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 198187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 198196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198208 */     // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 198208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 198211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198217 */     GIR_RootConstrainSelectedInstOperands,
     /* 198218 */     // GIR_Coverage, 1671,
     /* 198218 */     GIR_EraseRootFromParent_Done,
     /* 198219 */   // Label 3687: @198219
     /* 198219 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(198264), // Rule ID 1672 //
     /* 198224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 198232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 198241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 198253 */     // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 198253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 198256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198262 */     GIR_RootConstrainSelectedInstOperands,
     /* 198263 */     // GIR_Coverage, 1672,
     /* 198263 */     GIR_EraseRootFromParent_Done,
     /* 198264 */   // Label 3688: @198264
     /* 198264 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(198309), // Rule ID 1673 //
     /* 198269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 198277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 198280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198298 */     // (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 198298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 198301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198307 */     GIR_RootConstrainSelectedInstOperands,
     /* 198308 */     // GIR_Coverage, 1673,
     /* 198308 */     GIR_EraseRootFromParent_Done,
     /* 198309 */   // Label 3689: @198309
     /* 198309 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(198354), // Rule ID 1674 //
     /* 198314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 198322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198343 */     // (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 198343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 198346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198352 */     GIR_RootConstrainSelectedInstOperands,
     /* 198353 */     // GIR_Coverage, 1674,
     /* 198353 */     GIR_EraseRootFromParent_Done,
     /* 198354 */   // Label 3690: @198354
     /* 198354 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(198399), // Rule ID 1675 //
     /* 198359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 198367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198388 */     // (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 198388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 198391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198397 */     GIR_RootConstrainSelectedInstOperands,
     /* 198398 */     // GIR_Coverage, 1675,
     /* 198398 */     GIR_EraseRootFromParent_Done,
     /* 198399 */   // Label 3691: @198399
     /* 198399 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(198444), // Rule ID 1676 //
     /* 198404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 198412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 198415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198433 */     // (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 198433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 198436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198442 */     GIR_RootConstrainSelectedInstOperands,
     /* 198443 */     // GIR_Coverage, 1676,
     /* 198443 */     GIR_EraseRootFromParent_Done,
     /* 198444 */   // Label 3692: @198444
     /* 198444 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(198489), // Rule ID 1677 //
     /* 198449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 198457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198478 */     // (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 198478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 198481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198487 */     GIR_RootConstrainSelectedInstOperands,
     /* 198488 */     // GIR_Coverage, 1677,
     /* 198488 */     GIR_EraseRootFromParent_Done,
     /* 198489 */   // Label 3693: @198489
     /* 198489 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(198534), // Rule ID 1678 //
     /* 198494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 198502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198523 */     // (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 198523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 198526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198532 */     GIR_RootConstrainSelectedInstOperands,
     /* 198533 */     // GIR_Coverage, 1678,
     /* 198533 */     GIR_EraseRootFromParent_Done,
     /* 198534 */   // Label 3694: @198534
     /* 198534 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(198579), // Rule ID 1679 //
     /* 198539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 198547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 198550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198568 */     // (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 198568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 198571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198577 */     GIR_RootConstrainSelectedInstOperands,
     /* 198578 */     // GIR_Coverage, 1679,
     /* 198578 */     GIR_EraseRootFromParent_Done,
     /* 198579 */   // Label 3695: @198579
     /* 198579 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(198624), // Rule ID 1680 //
     /* 198584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 198592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198613 */     // (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 198613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 198616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198622 */     GIR_RootConstrainSelectedInstOperands,
     /* 198623 */     // GIR_Coverage, 1680,
     /* 198623 */     GIR_EraseRootFromParent_Done,
     /* 198624 */   // Label 3696: @198624
     /* 198624 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(198669), // Rule ID 1681 //
     /* 198629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 198637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198658 */     // (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 198658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 198661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198667 */     GIR_RootConstrainSelectedInstOperands,
     /* 198668 */     // GIR_Coverage, 1681,
     /* 198668 */     GIR_EraseRootFromParent_Done,
     /* 198669 */   // Label 3697: @198669
     /* 198669 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(198714), // Rule ID 1682 //
     /* 198674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 198682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 198685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198703 */     // (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 198703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 198706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198712 */     GIR_RootConstrainSelectedInstOperands,
     /* 198713 */     // GIR_Coverage, 1682,
     /* 198713 */     GIR_EraseRootFromParent_Done,
     /* 198714 */   // Label 3698: @198714
     /* 198714 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(198759), // Rule ID 1683 //
     /* 198719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 198727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198748 */     // (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 198748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 198751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198757 */     GIR_RootConstrainSelectedInstOperands,
     /* 198758 */     // GIR_Coverage, 1683,
     /* 198758 */     GIR_EraseRootFromParent_Done,
     /* 198759 */   // Label 3699: @198759
     /* 198759 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(198804), // Rule ID 1684 //
     /* 198764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 198772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198793 */     // (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 198793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 198796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198802 */     GIR_RootConstrainSelectedInstOperands,
     /* 198803 */     // GIR_Coverage, 1684,
     /* 198803 */     GIR_EraseRootFromParent_Done,
     /* 198804 */   // Label 3700: @198804
     /* 198804 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(198849), // Rule ID 1750 //
     /* 198809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 198817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198838 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 198838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 198841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198847 */     GIR_RootConstrainSelectedInstOperands,
     /* 198848 */     // GIR_Coverage, 1750,
     /* 198848 */     GIR_EraseRootFromParent_Done,
     /* 198849 */   // Label 3701: @198849
     /* 198849 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(198894), // Rule ID 1752 //
     /* 198854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 198857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 198862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 198868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 198871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198883 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 198883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 198886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198892 */     GIR_RootConstrainSelectedInstOperands,
     /* 198893 */     // GIR_Coverage, 1752,
     /* 198893 */     GIR_EraseRootFromParent_Done,
     /* 198894 */   // Label 3702: @198894
     /* 198894 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(198939), // Rule ID 2303 //
     /* 198899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 198902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 198907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 198910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 198913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 198916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198928 */     // (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 198928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 198931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198937 */     GIR_RootConstrainSelectedInstOperands,
     /* 198938 */     // GIR_Coverage, 2303,
     /* 198938 */     GIR_EraseRootFromParent_Done,
     /* 198939 */   // Label 3703: @198939
     /* 198939 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(198984), // Rule ID 2304 //
     /* 198944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 198947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 198952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 198955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 198958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 198961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198973 */     // (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 198973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 198976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198982 */     GIR_RootConstrainSelectedInstOperands,
     /* 198983 */     // GIR_Coverage, 2304,
     /* 198983 */     GIR_EraseRootFromParent_Done,
     /* 198984 */   // Label 3704: @198984
     /* 198984 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(199029), // Rule ID 2315 //
     /* 198989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 198992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 198997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199018 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 199018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 199021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199027 */     GIR_RootConstrainSelectedInstOperands,
     /* 199028 */     // GIR_Coverage, 2315,
     /* 199028 */     GIR_EraseRootFromParent_Done,
     /* 199029 */   // Label 3705: @199029
     /* 199029 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(199074), // Rule ID 2316 //
     /* 199034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 199037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 199042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199063 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 199063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 199066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199072 */     GIR_RootConstrainSelectedInstOperands,
     /* 199073 */     // GIR_Coverage, 2316,
     /* 199073 */     GIR_EraseRootFromParent_Done,
     /* 199074 */   // Label 3706: @199074
     /* 199074 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(199119), // Rule ID 2339 //
     /* 199079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 199082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 199087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199108 */     // (intrinsic_wo_chain:{ *:[v4f16] } 631:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 199108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 199111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199117 */     GIR_RootConstrainSelectedInstOperands,
     /* 199118 */     // GIR_Coverage, 2339,
     /* 199118 */     GIR_EraseRootFromParent_Done,
     /* 199119 */   // Label 3707: @199119
     /* 199119 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(199164), // Rule ID 2340 //
     /* 199124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 199127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 199132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199153 */     // (intrinsic_wo_chain:{ *:[v8f16] } 631:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 199153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 199156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199162 */     GIR_RootConstrainSelectedInstOperands,
     /* 199163 */     // GIR_Coverage, 2340,
     /* 199163 */     GIR_EraseRootFromParent_Done,
     /* 199164 */   // Label 3708: @199164
     /* 199164 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(199209), // Rule ID 2341 //
     /* 199169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 199172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 199177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 199180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 199183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 199186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199198 */     // (intrinsic_wo_chain:{ *:[v2f32] } 631:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 199198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 199201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199207 */     GIR_RootConstrainSelectedInstOperands,
     /* 199208 */     // GIR_Coverage, 2341,
     /* 199208 */     GIR_EraseRootFromParent_Done,
     /* 199209 */   // Label 3709: @199209
     /* 199209 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(199254), // Rule ID 2342 //
     /* 199214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 199217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 199222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199243 */     // (intrinsic_wo_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 199243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 199246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199252 */     GIR_RootConstrainSelectedInstOperands,
     /* 199253 */     // GIR_Coverage, 2342,
     /* 199253 */     GIR_EraseRootFromParent_Done,
     /* 199254 */   // Label 3710: @199254
     /* 199254 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(199299), // Rule ID 2343 //
     /* 199259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 199262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 199267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 199270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 199273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 199276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199288 */     // (intrinsic_wo_chain:{ *:[v2f64] } 631:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 199288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 199291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199297 */     GIR_RootConstrainSelectedInstOperands,
     /* 199298 */     // GIR_Coverage, 2343,
     /* 199298 */     GIR_EraseRootFromParent_Done,
     /* 199299 */   // Label 3711: @199299
     /* 199299 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(199344), // Rule ID 2344 //
     /* 199304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 199312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199333 */     // (intrinsic_wo_chain:{ *:[v4f16] } 581:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 199333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 199336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199342 */     GIR_RootConstrainSelectedInstOperands,
     /* 199343 */     // GIR_Coverage, 2344,
     /* 199343 */     GIR_EraseRootFromParent_Done,
     /* 199344 */   // Label 3712: @199344
     /* 199344 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(199389), // Rule ID 2347 //
     /* 199349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 199357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199378 */     // (intrinsic_wo_chain:{ *:[v8f16] } 581:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 199378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 199381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199387 */     GIR_RootConstrainSelectedInstOperands,
     /* 199388 */     // GIR_Coverage, 2347,
     /* 199388 */     GIR_EraseRootFromParent_Done,
     /* 199389 */   // Label 3713: @199389
     /* 199389 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(199434), // Rule ID 2350 //
     /* 199394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 199402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 199405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 199408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 199411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199423 */     // (intrinsic_wo_chain:{ *:[v2f32] } 581:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 199423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 199426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199432 */     GIR_RootConstrainSelectedInstOperands,
     /* 199433 */     // GIR_Coverage, 2350,
     /* 199433 */     GIR_EraseRootFromParent_Done,
     /* 199434 */   // Label 3714: @199434
     /* 199434 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(199479), // Rule ID 2353 //
     /* 199439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 199447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199468 */     // (intrinsic_wo_chain:{ *:[v4f32] } 581:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 199468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 199471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199477 */     GIR_RootConstrainSelectedInstOperands,
     /* 199478 */     // GIR_Coverage, 2353,
     /* 199478 */     GIR_EraseRootFromParent_Done,
     /* 199479 */   // Label 3715: @199479
     /* 199479 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(199524), // Rule ID 2356 //
     /* 199484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 199492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 199495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 199498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 199501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199513 */     // (intrinsic_wo_chain:{ *:[v2f64] } 581:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 199513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 199516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199522 */     GIR_RootConstrainSelectedInstOperands,
     /* 199523 */     // GIR_Coverage, 2356,
     /* 199523 */     GIR_EraseRootFromParent_Done,
     /* 199524 */   // Label 3716: @199524
     /* 199524 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(199569), // Rule ID 2359 //
     /* 199529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 199537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199558 */     // (intrinsic_wo_chain:{ *:[v4f16] } 582:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 199558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 199561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199567 */     GIR_RootConstrainSelectedInstOperands,
     /* 199568 */     // GIR_Coverage, 2359,
     /* 199568 */     GIR_EraseRootFromParent_Done,
     /* 199569 */   // Label 3717: @199569
     /* 199569 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(199614), // Rule ID 2362 //
     /* 199574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 199582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199603 */     // (intrinsic_wo_chain:{ *:[v8f16] } 582:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 199603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 199606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199612 */     GIR_RootConstrainSelectedInstOperands,
     /* 199613 */     // GIR_Coverage, 2362,
     /* 199613 */     GIR_EraseRootFromParent_Done,
     /* 199614 */   // Label 3718: @199614
     /* 199614 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(199659), // Rule ID 2365 //
     /* 199619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 199627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 199630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 199633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 199636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199648 */     // (intrinsic_wo_chain:{ *:[v2f32] } 582:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 199648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 199651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199657 */     GIR_RootConstrainSelectedInstOperands,
     /* 199658 */     // GIR_Coverage, 2365,
     /* 199658 */     GIR_EraseRootFromParent_Done,
     /* 199659 */   // Label 3719: @199659
     /* 199659 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(199704), // Rule ID 2368 //
     /* 199664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 199672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 199675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 199678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 199681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199693 */     // (intrinsic_wo_chain:{ *:[v4f32] } 582:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 199693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 199696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199702 */     GIR_RootConstrainSelectedInstOperands,
     /* 199703 */     // GIR_Coverage, 2368,
     /* 199703 */     GIR_EraseRootFromParent_Done,
     /* 199704 */   // Label 3720: @199704
     /* 199704 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(199749), // Rule ID 2371 //
     /* 199709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 199712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 199717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 199720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 199723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 199726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199738 */     // (intrinsic_wo_chain:{ *:[v2f64] } 582:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 199738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 199741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199747 */     GIR_RootConstrainSelectedInstOperands,
     /* 199748 */     // GIR_Coverage, 2371,
     /* 199748 */     GIR_EraseRootFromParent_Done,
     /* 199749 */   // Label 3721: @199749
     /* 199749 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(199794), // Rule ID 2508 //
     /* 199754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 199762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199783 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 199786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199792 */     GIR_RootConstrainSelectedInstOperands,
     /* 199793 */     // GIR_Coverage, 2508,
     /* 199793 */     GIR_EraseRootFromParent_Done,
     /* 199794 */   // Label 3722: @199794
     /* 199794 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(199839), // Rule ID 2509 //
     /* 199799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 199807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199828 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 199831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199837 */     GIR_RootConstrainSelectedInstOperands,
     /* 199838 */     // GIR_Coverage, 2509,
     /* 199838 */     GIR_EraseRootFromParent_Done,
     /* 199839 */   // Label 3723: @199839
     /* 199839 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(199884), // Rule ID 2510 //
     /* 199844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 199852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199873 */     // (intrinsic_wo_chain:{ *:[v1f64] } 785:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 199876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199882 */     GIR_RootConstrainSelectedInstOperands,
     /* 199883 */     // GIR_Coverage, 2510,
     /* 199883 */     GIR_EraseRootFromParent_Done,
     /* 199884 */   // Label 3724: @199884
     /* 199884 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(199929), // Rule ID 2511 //
     /* 199889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 199897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199918 */     // (intrinsic_wo_chain:{ *:[v1i64] } 577:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 199921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199927 */     GIR_RootConstrainSelectedInstOperands,
     /* 199928 */     // GIR_Coverage, 2511,
     /* 199928 */     GIR_EraseRootFromParent_Done,
     /* 199929 */   // Label 3725: @199929
     /* 199929 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(199974), // Rule ID 2516 //
     /* 199934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 199942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199963 */     // (intrinsic_wo_chain:{ *:[v1i64] } 715:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 199963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 199966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199972 */     GIR_RootConstrainSelectedInstOperands,
     /* 199973 */     // GIR_Coverage, 2516,
     /* 199973 */     GIR_EraseRootFromParent_Done,
     /* 199974 */   // Label 3726: @199974
     /* 199974 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(200019), // Rule ID 2634 //
     /* 199979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 199982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 199987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 199996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200008 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 200008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 200011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200017 */     GIR_RootConstrainSelectedInstOperands,
     /* 200018 */     // GIR_Coverage, 2634,
     /* 200018 */     GIR_EraseRootFromParent_Done,
     /* 200019 */   // Label 3727: @200019
     /* 200019 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(200064), // Rule ID 2635 //
     /* 200024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 200032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 200041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200053 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 200053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 200056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200062 */     GIR_RootConstrainSelectedInstOperands,
     /* 200063 */     // GIR_Coverage, 2635,
     /* 200063 */     GIR_EraseRootFromParent_Done,
     /* 200064 */   // Label 3728: @200064
     /* 200064 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(200109), // Rule ID 2636 //
     /* 200069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 200077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 200086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200098 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 200098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 200101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200107 */     GIR_RootConstrainSelectedInstOperands,
     /* 200108 */     // GIR_Coverage, 2636,
     /* 200108 */     GIR_EraseRootFromParent_Done,
     /* 200109 */   // Label 3729: @200109
     /* 200109 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(200154), // Rule ID 2637 //
     /* 200114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 200122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 200131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200143 */     // (intrinsic_wo_chain:{ *:[i32] } 2025:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 200143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 200146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200152 */     GIR_RootConstrainSelectedInstOperands,
     /* 200153 */     // GIR_Coverage, 2637,
     /* 200153 */     GIR_EraseRootFromParent_Done,
     /* 200154 */   // Label 3730: @200154
     /* 200154 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(200199), // Rule ID 2638 //
     /* 200159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 200167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200188 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 200191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200197 */     GIR_RootConstrainSelectedInstOperands,
     /* 200198 */     // GIR_Coverage, 2638,
     /* 200198 */     GIR_EraseRootFromParent_Done,
     /* 200199 */   // Label 3731: @200199
     /* 200199 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(200244), // Rule ID 2639 //
     /* 200204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 200212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 200221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200233 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 200236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200242 */     GIR_RootConstrainSelectedInstOperands,
     /* 200243 */     // GIR_Coverage, 2639,
     /* 200243 */     GIR_EraseRootFromParent_Done,
     /* 200244 */   // Label 3732: @200244
     /* 200244 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(200289), // Rule ID 2640 //
     /* 200249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 200257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 200266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200278 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 200281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200287 */     GIR_RootConstrainSelectedInstOperands,
     /* 200288 */     // GIR_Coverage, 2640,
     /* 200288 */     GIR_EraseRootFromParent_Done,
     /* 200289 */   // Label 3733: @200289
     /* 200289 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(200334), // Rule ID 2641 //
     /* 200294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 200302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 200311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200323 */     // (intrinsic_wo_chain:{ *:[i64] } 1815:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 200326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200332 */     GIR_RootConstrainSelectedInstOperands,
     /* 200333 */     // GIR_Coverage, 2641,
     /* 200333 */     GIR_EraseRootFromParent_Done,
     /* 200334 */   // Label 3734: @200334
     /* 200334 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(200379), // Rule ID 3815 //
     /* 200339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 200342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 200347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 200350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 200353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 200356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200368 */     // (intrinsic_wo_chain:{ *:[v2i64] } 532:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 200368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 200371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 200373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 200375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 200377 */     GIR_RootConstrainSelectedInstOperands,
     /* 200378 */     // GIR_Coverage, 3815,
     /* 200378 */     GIR_EraseRootFromParent_Done,
     /* 200379 */   // Label 3735: @200379
     /* 200379 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(200424), // Rule ID 3843 //
     /* 200384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 200387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 200392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 200395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 200398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 200401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200413 */     // (intrinsic_wo_chain:{ *:[v2i64] } 519:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 200413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 200416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 200418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 200420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 200422 */     GIR_RootConstrainSelectedInstOperands,
     /* 200423 */     // GIR_Coverage, 3843,
     /* 200423 */     GIR_EraseRootFromParent_Done,
     /* 200424 */   // Label 3736: @200424
     /* 200424 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(200469), // Rule ID 3853 //
     /* 200429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 200432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 200437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200458 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 200458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 200461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 200463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 200465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 200467 */     GIR_RootConstrainSelectedInstOperands,
     /* 200468 */     // GIR_Coverage, 3853,
     /* 200468 */     GIR_EraseRootFromParent_Done,
     /* 200469 */   // Label 3737: @200469
     /* 200469 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(200514), // Rule ID 3854 //
     /* 200474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 200477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 200482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200503 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 200503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 200506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 200508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 200510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 200512 */     GIR_RootConstrainSelectedInstOperands,
     /* 200513 */     // GIR_Coverage, 3854,
     /* 200513 */     GIR_EraseRootFromParent_Done,
     /* 200514 */   // Label 3738: @200514
     /* 200514 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(200562), // Rule ID 3855 //
     /* 200519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 200522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 200527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 200530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 200533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 200536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200548 */     // (intrinsic_wo_chain:{ *:[v4f16] } 756:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 200548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 200551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200560 */     GIR_RootConstrainSelectedInstOperands,
     /* 200561 */     // GIR_Coverage, 3855,
     /* 200561 */     GIR_EraseRootFromParent_Done,
     /* 200562 */   // Label 3739: @200562
     /* 200562 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(200610), // Rule ID 3856 //
     /* 200567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 200570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 200575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 200578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 200581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 200584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200596 */     // (intrinsic_wo_chain:{ *:[v4f16] } 755:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 200596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 200599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200608 */     GIR_RootConstrainSelectedInstOperands,
     /* 200609 */     // GIR_Coverage, 3856,
     /* 200609 */     GIR_EraseRootFromParent_Done,
     /* 200610 */   // Label 3740: @200610
     /* 200610 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(200658), // Rule ID 3857 //
     /* 200615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 200618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 200623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 200626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 200629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 200632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200644 */     // (intrinsic_wo_chain:{ *:[v8f16] } 756:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 200644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 200647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200656 */     GIR_RootConstrainSelectedInstOperands,
     /* 200657 */     // GIR_Coverage, 3857,
     /* 200657 */     GIR_EraseRootFromParent_Done,
     /* 200658 */   // Label 3741: @200658
     /* 200658 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(200706), // Rule ID 3858 //
     /* 200663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 200666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 200671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 200674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 200677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 200680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200692 */     // (intrinsic_wo_chain:{ *:[v8f16] } 755:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 200692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 200695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200704 */     GIR_RootConstrainSelectedInstOperands,
     /* 200705 */     // GIR_Coverage, 3858,
     /* 200705 */     GIR_EraseRootFromParent_Done,
     /* 200706 */   // Label 3742: @200706
     /* 200706 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(200754), // Rule ID 3859 //
     /* 200711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 200719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 200722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 200725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 200728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200740 */     // (intrinsic_wo_chain:{ *:[v2f32] } 756:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 200740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 200743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200752 */     GIR_RootConstrainSelectedInstOperands,
     /* 200753 */     // GIR_Coverage, 3859,
     /* 200753 */     GIR_EraseRootFromParent_Done,
     /* 200754 */   // Label 3743: @200754
     /* 200754 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(200802), // Rule ID 3860 //
     /* 200759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 200767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 200770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 200773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 200776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200788 */     // (intrinsic_wo_chain:{ *:[v2f32] } 755:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 200788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 200791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200800 */     GIR_RootConstrainSelectedInstOperands,
     /* 200801 */     // GIR_Coverage, 3860,
     /* 200801 */     GIR_EraseRootFromParent_Done,
     /* 200802 */   // Label 3744: @200802
     /* 200802 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(200850), // Rule ID 3861 //
     /* 200807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 200815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200836 */     // (intrinsic_wo_chain:{ *:[v4f32] } 756:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 200836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 200839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200848 */     GIR_RootConstrainSelectedInstOperands,
     /* 200849 */     // GIR_Coverage, 3861,
     /* 200849 */     GIR_EraseRootFromParent_Done,
     /* 200850 */   // Label 3745: @200850
     /* 200850 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(200898), // Rule ID 3862 //
     /* 200855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 200863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200884 */     // (intrinsic_wo_chain:{ *:[v4f32] } 755:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 200884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 200887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200896 */     GIR_RootConstrainSelectedInstOperands,
     /* 200897 */     // GIR_Coverage, 3862,
     /* 200897 */     GIR_EraseRootFromParent_Done,
     /* 200898 */   // Label 3746: @200898
     /* 200898 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(200946), // Rule ID 3863 //
     /* 200903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 200911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 200914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 200917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 200920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200932 */     // (intrinsic_wo_chain:{ *:[v2f64] } 756:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 200932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 200935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200944 */     GIR_RootConstrainSelectedInstOperands,
     /* 200945 */     // GIR_Coverage, 3863,
     /* 200945 */     GIR_EraseRootFromParent_Done,
     /* 200946 */   // Label 3747: @200946
     /* 200946 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(200994), // Rule ID 3864 //
     /* 200951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 200959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 200962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 200965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 200968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200980 */     // (intrinsic_wo_chain:{ *:[v2f64] } 755:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 200980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 200983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200992 */     GIR_RootConstrainSelectedInstOperands,
     /* 200993 */     // GIR_Coverage, 3864,
     /* 200993 */     GIR_EraseRootFromParent_Done,
     /* 200994 */   // Label 3748: @200994
     /* 200994 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(201036), // Rule ID 3929 //
     /* 200999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 201004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201025 */     // (intrinsic_wo_chain:{ *:[i32] } 2169:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 201025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 201028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201034 */     GIR_RootConstrainSelectedInstOperands,
     /* 201035 */     // GIR_Coverage, 3929,
     /* 201035 */     GIR_EraseRootFromParent_Done,
     /* 201036 */   // Label 3749: @201036
     /* 201036 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(201078), // Rule ID 3930 //
     /* 201041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 201046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201067 */     // (intrinsic_wo_chain:{ *:[i64] } 2169:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 201067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 201070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201076 */     GIR_RootConstrainSelectedInstOperands,
     /* 201077 */     // GIR_Coverage, 3930,
     /* 201077 */     GIR_EraseRootFromParent_Done,
     /* 201078 */   // Label 3750: @201078
     /* 201078 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(201120), // Rule ID 3931 //
     /* 201083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 201088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201109 */     // (intrinsic_wo_chain:{ *:[i32] } 779:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 201109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 201112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201118 */     GIR_RootConstrainSelectedInstOperands,
     /* 201119 */     // GIR_Coverage, 3931,
     /* 201119 */     GIR_EraseRootFromParent_Done,
     /* 201120 */   // Label 3751: @201120
     /* 201120 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(201162), // Rule ID 3932 //
     /* 201125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 201130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201151 */     // (intrinsic_wo_chain:{ *:[i64] } 779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 201151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 201154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201160 */     GIR_RootConstrainSelectedInstOperands,
     /* 201161 */     // GIR_Coverage, 3932,
     /* 201161 */     GIR_EraseRootFromParent_Done,
     /* 201162 */   // Label 3752: @201162
     /* 201162 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(201204), // Rule ID 5243 //
     /* 201167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 201172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201193 */     // (intrinsic_wo_chain:{ *:[v1f64] } 576:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 201193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 201196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201202 */     GIR_RootConstrainSelectedInstOperands,
     /* 201203 */     // GIR_Coverage, 5243,
     /* 201203 */     GIR_EraseRootFromParent_Done,
     /* 201204 */   // Label 3753: @201204
     /* 201204 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(201249), // Rule ID 5247 //
     /* 201209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 201217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201238 */     // (intrinsic_wo_chain:{ *:[v1i64] } 578:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 201238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 201241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201247 */     GIR_RootConstrainSelectedInstOperands,
     /* 201248 */     // GIR_Coverage, 5247,
     /* 201248 */     GIR_EraseRootFromParent_Done,
     /* 201249 */   // Label 3754: @201249
     /* 201249 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(201294), // Rule ID 5251 //
     /* 201254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 201262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201283 */     // (intrinsic_wo_chain:{ *:[v1f64] } 610:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 201283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 201286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201292 */     GIR_RootConstrainSelectedInstOperands,
     /* 201293 */     // GIR_Coverage, 5251,
     /* 201293 */     GIR_EraseRootFromParent_Done,
     /* 201294 */   // Label 3755: @201294
     /* 201294 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(201339), // Rule ID 5252 //
     /* 201299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 201307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201328 */     // (intrinsic_wo_chain:{ *:[v1f64] } 633:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 201328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 201331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201337 */     GIR_RootConstrainSelectedInstOperands,
     /* 201338 */     // GIR_Coverage, 5252,
     /* 201338 */     GIR_EraseRootFromParent_Done,
     /* 201339 */   // Label 3756: @201339
     /* 201339 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(201384), // Rule ID 5253 //
     /* 201344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 201352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201373 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 201373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 201376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201382 */     GIR_RootConstrainSelectedInstOperands,
     /* 201383 */     // GIR_Coverage, 5253,
     /* 201383 */     GIR_EraseRootFromParent_Done,
     /* 201384 */   // Label 3757: @201384
     /* 201384 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(201429), // Rule ID 5254 //
     /* 201389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 201397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201418 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 201418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 201421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201427 */     GIR_RootConstrainSelectedInstOperands,
     /* 201428 */     // GIR_Coverage, 5254,
     /* 201428 */     GIR_EraseRootFromParent_Done,
     /* 201429 */   // Label 3758: @201429
     /* 201429 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(201474), // Rule ID 5255 //
     /* 201434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 201442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201463 */     // (intrinsic_wo_chain:{ *:[i32] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 201463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 201466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201472 */     GIR_RootConstrainSelectedInstOperands,
     /* 201473 */     // GIR_Coverage, 5255,
     /* 201473 */     GIR_EraseRootFromParent_Done,
     /* 201474 */   // Label 3759: @201474
     /* 201474 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(201519), // Rule ID 5256 //
     /* 201479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 201487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201508 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 201508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 201511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201517 */     GIR_RootConstrainSelectedInstOperands,
     /* 201518 */     // GIR_Coverage, 5256,
     /* 201518 */     GIR_EraseRootFromParent_Done,
     /* 201519 */   // Label 3760: @201519
     /* 201519 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(201564), // Rule ID 5257 //
     /* 201524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 201532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201553 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 201553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 201556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201562 */     GIR_RootConstrainSelectedInstOperands,
     /* 201563 */     // GIR_Coverage, 5257,
     /* 201563 */     GIR_EraseRootFromParent_Done,
     /* 201564 */   // Label 3761: @201564
     /* 201564 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(201609), // Rule ID 5258 //
     /* 201569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 201577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201598 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 201598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 201601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201607 */     GIR_RootConstrainSelectedInstOperands,
     /* 201608 */     // GIR_Coverage, 5258,
     /* 201608 */     GIR_EraseRootFromParent_Done,
     /* 201609 */   // Label 3762: @201609
     /* 201609 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(201654), // Rule ID 5259 //
     /* 201614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 201622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201643 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 201643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 201646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201652 */     GIR_RootConstrainSelectedInstOperands,
     /* 201653 */     // GIR_Coverage, 5259,
     /* 201653 */     GIR_EraseRootFromParent_Done,
     /* 201654 */   // Label 3763: @201654
     /* 201654 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(201699), // Rule ID 5260 //
     /* 201659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 201667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201688 */     // (intrinsic_wo_chain:{ *:[i64] } 739:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 201688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 201691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201697 */     GIR_RootConstrainSelectedInstOperands,
     /* 201698 */     // GIR_Coverage, 5260,
     /* 201698 */     GIR_EraseRootFromParent_Done,
     /* 201699 */   // Label 3764: @201699
     /* 201699 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(201744), // Rule ID 5261 //
     /* 201704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 201712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201733 */     // (intrinsic_wo_chain:{ *:[i32] } 739:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 201733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 201736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201742 */     GIR_RootConstrainSelectedInstOperands,
     /* 201743 */     // GIR_Coverage, 5261,
     /* 201743 */     GIR_EraseRootFromParent_Done,
     /* 201744 */   // Label 3765: @201744
     /* 201744 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(201789), // Rule ID 5262 //
     /* 201749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 201757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201778 */     // (intrinsic_wo_chain:{ *:[i64] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 201778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 201781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201787 */     GIR_RootConstrainSelectedInstOperands,
     /* 201788 */     // GIR_Coverage, 5262,
     /* 201788 */     GIR_EraseRootFromParent_Done,
     /* 201789 */   // Label 3766: @201789
     /* 201789 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(201834), // Rule ID 5263 //
     /* 201794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 201802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201823 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 201823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 201826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201832 */     GIR_RootConstrainSelectedInstOperands,
     /* 201833 */     // GIR_Coverage, 5263,
     /* 201833 */     GIR_EraseRootFromParent_Done,
     /* 201834 */   // Label 3767: @201834
     /* 201834 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(201879), // Rule ID 5264 //
     /* 201839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 201847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201868 */     // (intrinsic_wo_chain:{ *:[i64] } 742:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 201868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 201871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201877 */     GIR_RootConstrainSelectedInstOperands,
     /* 201878 */     // GIR_Coverage, 5264,
     /* 201878 */     GIR_EraseRootFromParent_Done,
     /* 201879 */   // Label 3768: @201879
     /* 201879 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(201924), // Rule ID 5265 //
     /* 201884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 201892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201913 */     // (intrinsic_wo_chain:{ *:[i32] } 742:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 201913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 201916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201922 */     GIR_RootConstrainSelectedInstOperands,
     /* 201923 */     // GIR_Coverage, 5265,
     /* 201923 */     GIR_EraseRootFromParent_Done,
     /* 201924 */   // Label 3769: @201924
     /* 201924 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(201969), // Rule ID 5266 //
     /* 201929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 201937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 201958 */     // (intrinsic_wo_chain:{ *:[i64] } 744:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 201958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 201961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201967 */     GIR_RootConstrainSelectedInstOperands,
     /* 201968 */     // GIR_Coverage, 5266,
     /* 201968 */     GIR_EraseRootFromParent_Done,
     /* 201969 */   // Label 3770: @201969
     /* 201969 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(202014), // Rule ID 5267 //
     /* 201974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 201977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 201982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 201991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 201999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202003 */     // (intrinsic_wo_chain:{ *:[i32] } 744:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 202003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 202006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 202012 */     GIR_RootConstrainSelectedInstOperands,
     /* 202013 */     // GIR_Coverage, 5267,
     /* 202013 */     GIR_EraseRootFromParent_Done,
     /* 202014 */   // Label 3771: @202014
     /* 202014 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(202059), // Rule ID 5286 //
     /* 202019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 202022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 202027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202048 */     // (intrinsic_wo_chain:{ *:[v1i64] } 754:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 202048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 202051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202057 */     GIR_RootConstrainSelectedInstOperands,
     /* 202058 */     // GIR_Coverage, 5286,
     /* 202058 */     GIR_EraseRootFromParent_Done,
     /* 202059 */   // Label 3772: @202059
     /* 202059 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(202101), // Rule ID 5620 //
     /* 202064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 202069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 202072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 202075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 202078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202090 */     // (intrinsic_wo_chain:{ *:[v8i8] } 716:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 202090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 202093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 202095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 202099 */     GIR_RootConstrainSelectedInstOperands,
     /* 202100 */     // GIR_Coverage, 5620,
     /* 202100 */     GIR_EraseRootFromParent_Done,
     /* 202101 */   // Label 3773: @202101
     /* 202101 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(202143), // Rule ID 5621 //
     /* 202106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 202111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 202114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 202117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 202120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202132 */     // (intrinsic_wo_chain:{ *:[v16i8] } 716:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 202132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 202135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 202137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 202139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202141 */     GIR_RootConstrainSelectedInstOperands,
     /* 202142 */     // GIR_Coverage, 5621,
     /* 202142 */     GIR_EraseRootFromParent_Done,
     /* 202143 */   // Label 3774: @202143
     /* 202143 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(202240), // Rule ID 6342 //
     /* 202148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 202153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 202156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 202159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 202162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 202170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 202174 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 202174 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 202177 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 202181 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202186 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 202190 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 202194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 202196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 202199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 202218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 202221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 202224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202234 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 202239 */     // GIR_Coverage, 6342,
     /* 202239 */     GIR_EraseRootFromParent_Done,
     /* 202240 */   // Label 3775: @202240
     /* 202240 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(202337), // Rule ID 6343 //
     /* 202245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 202250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 202253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 202256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 202259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 202267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 202271 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 202271 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 202274 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 202278 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202283 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 202287 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 202291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 202293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 202296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 202307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 202315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 202318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 202321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202326 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 202331 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 202336 */     // GIR_Coverage, 6343,
     /* 202336 */     GIR_EraseRootFromParent_Done,
     /* 202337 */   // Label 3776: @202337
     /* 202337 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(202379), // Rule ID 6990 //
     /* 202342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 202347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202368 */     // (intrinsic_wo_chain:{ *:[i64] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 202368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 202371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 202377 */     GIR_RootConstrainSelectedInstOperands,
     /* 202378 */     // GIR_Coverage, 6990,
     /* 202378 */     GIR_EraseRootFromParent_Done,
     /* 202379 */   // Label 3777: @202379
     /* 202379 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(202421), // Rule ID 6991 //
     /* 202384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 202389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202410 */     // (intrinsic_wo_chain:{ *:[i64] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 202410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 202413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 202419 */     GIR_RootConstrainSelectedInstOperands,
     /* 202420 */     // GIR_Coverage, 6991,
     /* 202420 */     GIR_EraseRootFromParent_Done,
     /* 202421 */   // Label 3778: @202421
     /* 202421 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(202463), // Rule ID 6992 //
     /* 202426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 202431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202452 */     // (intrinsic_wo_chain:{ *:[i64] } 702:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 202452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 202455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 202461 */     GIR_RootConstrainSelectedInstOperands,
     /* 202462 */     // GIR_Coverage, 6992,
     /* 202462 */     GIR_EraseRootFromParent_Done,
     /* 202463 */   // Label 3779: @202463
     /* 202463 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(202505), // Rule ID 6993 //
     /* 202468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 202473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202494 */     // (intrinsic_wo_chain:{ *:[i64] } 748:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 202494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 202497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 202503 */     GIR_RootConstrainSelectedInstOperands,
     /* 202504 */     // GIR_Coverage, 6993,
     /* 202504 */     GIR_EraseRootFromParent_Done,
     /* 202505 */   // Label 3780: @202505
     /* 202505 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(202553), // Rule ID 7033 //
     /* 202510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 202515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 202524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202536 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 202536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 202539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 202548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 202551 */     GIR_RootConstrainSelectedInstOperands,
     /* 202552 */     // GIR_Coverage, 7033,
     /* 202552 */     GIR_EraseRootFromParent_Done,
     /* 202553 */   // Label 3781: @202553
     /* 202553 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(202598), // Rule ID 10091 //
     /* 202558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 202566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202587 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 202587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 202590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202596 */     GIR_RootConstrainSelectedInstOperands,
     /* 202597 */     // GIR_Coverage, 10091,
     /* 202597 */     GIR_EraseRootFromParent_Done,
     /* 202598 */   // Label 3782: @202598
     /* 202598 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(202643), // Rule ID 10092 //
     /* 202603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 202611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202632 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 202632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 202635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202641 */     GIR_RootConstrainSelectedInstOperands,
     /* 202642 */     // GIR_Coverage, 10092,
     /* 202642 */     GIR_EraseRootFromParent_Done,
     /* 202643 */   // Label 3783: @202643
     /* 202643 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(202688), // Rule ID 10093 //
     /* 202648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 202656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202677 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 202677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 202680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202686 */     GIR_RootConstrainSelectedInstOperands,
     /* 202687 */     // GIR_Coverage, 10093,
     /* 202687 */     GIR_EraseRootFromParent_Done,
     /* 202688 */   // Label 3784: @202688
     /* 202688 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(202733), // Rule ID 10094 //
     /* 202693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 202701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202722 */     // (intrinsic_wo_chain:{ *:[i64] } 2026:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 202722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 202725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202731 */     GIR_RootConstrainSelectedInstOperands,
     /* 202732 */     // GIR_Coverage, 10094,
     /* 202732 */     GIR_EraseRootFromParent_Done,
     /* 202733 */   // Label 3785: @202733
     /* 202733 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(202778), // Rule ID 10103 //
     /* 202738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 202746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202767 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 202767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 202770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202776 */     GIR_RootConstrainSelectedInstOperands,
     /* 202777 */     // GIR_Coverage, 10103,
     /* 202777 */     GIR_EraseRootFromParent_Done,
     /* 202778 */   // Label 3786: @202778
     /* 202778 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(202823), // Rule ID 10104 //
     /* 202783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 202791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202812 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 202812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 202815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202821 */     GIR_RootConstrainSelectedInstOperands,
     /* 202822 */     // GIR_Coverage, 10104,
     /* 202822 */     GIR_EraseRootFromParent_Done,
     /* 202823 */   // Label 3787: @202823
     /* 202823 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(202868), // Rule ID 10105 //
     /* 202828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 202836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202857 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 202857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 202860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202866 */     GIR_RootConstrainSelectedInstOperands,
     /* 202867 */     // GIR_Coverage, 10105,
     /* 202867 */     GIR_EraseRootFromParent_Done,
     /* 202868 */   // Label 3788: @202868
     /* 202868 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(202913), // Rule ID 10106 //
     /* 202873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 202881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202902 */     // (intrinsic_wo_chain:{ *:[i64] } 1781:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 202902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 202905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202911 */     GIR_RootConstrainSelectedInstOperands,
     /* 202912 */     // GIR_Coverage, 10106,
     /* 202912 */     GIR_EraseRootFromParent_Done,
     /* 202913 */   // Label 3789: @202913
     /* 202913 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(202958), // Rule ID 10107 //
     /* 202918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 202926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 202929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 202939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 202943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202947 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 202947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 202950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202956 */     GIR_RootConstrainSelectedInstOperands,
     /* 202957 */     // GIR_Coverage, 10107,
     /* 202957 */     GIR_EraseRootFromParent_Done,
     /* 202958 */   // Label 3790: @202958
     /* 202958 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(203003), // Rule ID 10108 //
     /* 202963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 202971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 202974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 202977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 202984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 202988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202992 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 202992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 202995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 202999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203001 */     GIR_RootConstrainSelectedInstOperands,
     /* 203002 */     // GIR_Coverage, 10108,
     /* 203002 */     GIR_EraseRootFromParent_Done,
     /* 203003 */   // Label 3791: @203003
     /* 203003 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(203048), // Rule ID 10109 //
     /* 203008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 203016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 203025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203037 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 203037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 203040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 203044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203046 */     GIR_RootConstrainSelectedInstOperands,
     /* 203047 */     // GIR_Coverage, 10109,
     /* 203047 */     GIR_EraseRootFromParent_Done,
     /* 203048 */   // Label 3792: @203048
     /* 203048 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(203093), // Rule ID 10110 //
     /* 203053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 203061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 203064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 203070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 203078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203082 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 203082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 203085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 203089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203091 */     GIR_RootConstrainSelectedInstOperands,
     /* 203092 */     // GIR_Coverage, 10110,
     /* 203092 */     GIR_EraseRootFromParent_Done,
     /* 203093 */   // Label 3793: @203093
     /* 203093 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(203138), // Rule ID 10111 //
     /* 203098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 203106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203127 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 203127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 203130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 203134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203136 */     GIR_RootConstrainSelectedInstOperands,
     /* 203137 */     // GIR_Coverage, 10111,
     /* 203137 */     GIR_EraseRootFromParent_Done,
     /* 203138 */   // Label 3794: @203138
     /* 203138 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(203183), // Rule ID 10112 //
     /* 203143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 203151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 203160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203172 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 203172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 203175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 203179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203181 */     GIR_RootConstrainSelectedInstOperands,
     /* 203182 */     // GIR_Coverage, 10112,
     /* 203182 */     GIR_EraseRootFromParent_Done,
     /* 203183 */   // Label 3795: @203183
     /* 203183 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(203228), // Rule ID 10113 //
     /* 203188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 203196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 203205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203217 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 203217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 203220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 203224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203226 */     GIR_RootConstrainSelectedInstOperands,
     /* 203227 */     // GIR_Coverage, 10113,
     /* 203227 */     GIR_EraseRootFromParent_Done,
     /* 203228 */   // Label 3796: @203228
     /* 203228 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(203273), // Rule ID 10114 //
     /* 203233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 203241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 203250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203262 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 203262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 203265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 203267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 203269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203271 */     GIR_RootConstrainSelectedInstOperands,
     /* 203272 */     // GIR_Coverage, 10114,
     /* 203272 */     GIR_EraseRootFromParent_Done,
     /* 203273 */   // Label 3797: @203273
     /* 203273 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(203319), // Rule ID 138 //
     /* 203278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 203281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 203286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 203292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203296 */     // MIs[0] Rn
     /* 203296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 203300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 203304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203308 */     // (intrinsic_wo_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 203308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 203311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 203313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 203317 */     GIR_RootConstrainSelectedInstOperands,
     /* 203318 */     // GIR_Coverage, 138,
     /* 203318 */     GIR_EraseRootFromParent_Done,
     /* 203319 */   // Label 3798: @203319
     /* 203319 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(203366), // Rule ID 139 //
     /* 203324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 203327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 203332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 203335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 203339 */     // MIs[0] Rn
     /* 203339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 203343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 203347 */     // MIs[0] Rm
     /* 203347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 203351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 203355 */     // (intrinsic_wo_chain:{ *:[i64] } 1242:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 203355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 203358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 203360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 203362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 203364 */     GIR_RootConstrainSelectedInstOperands,
     /* 203365 */     // GIR_Coverage, 139,
     /* 203365 */     GIR_EraseRootFromParent_Done,
     /* 203366 */   // Label 3799: @203366
     /* 203366 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(203403), // Rule ID 2399 //
     /* 203371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 203379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203392 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2151:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 203395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203401 */     GIR_RootConstrainSelectedInstOperands,
     /* 203402 */     // GIR_Coverage, 2399,
     /* 203402 */     GIR_EraseRootFromParent_Done,
     /* 203403 */   // Label 3800: @203403
     /* 203403 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(203440), // Rule ID 2400 //
     /* 203408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 203416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203429 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2152:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 203432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203438 */     GIR_RootConstrainSelectedInstOperands,
     /* 203439 */     // GIR_Coverage, 2400,
     /* 203439 */     GIR_EraseRootFromParent_Done,
     /* 203440 */   // Label 3801: @203440
     /* 203440 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(203477), // Rule ID 2401 //
     /* 203445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 203453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203466 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2153:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 203469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203475 */     GIR_RootConstrainSelectedInstOperands,
     /* 203476 */     // GIR_Coverage, 2401,
     /* 203476 */     GIR_EraseRootFromParent_Done,
     /* 203477 */   // Label 3802: @203477
     /* 203477 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(203514), // Rule ID 2403 //
     /* 203482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 203490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203503 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2156:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 203506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203512 */     GIR_RootConstrainSelectedInstOperands,
     /* 203513 */     // GIR_Coverage, 2403,
     /* 203513 */     GIR_EraseRootFromParent_Done,
     /* 203514 */   // Label 3803: @203514
     /* 203514 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(203551), // Rule ID 2404 //
     /* 203519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 203527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203540 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2157:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 203543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203549 */     GIR_RootConstrainSelectedInstOperands,
     /* 203550 */     // GIR_Coverage, 2404,
     /* 203550 */     GIR_EraseRootFromParent_Done,
     /* 203551 */   // Label 3804: @203551
     /* 203551 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(203588), // Rule ID 2405 //
     /* 203556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 203564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203577 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2158:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 203580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203586 */     GIR_RootConstrainSelectedInstOperands,
     /* 203587 */     // GIR_Coverage, 2405,
     /* 203587 */     GIR_EraseRootFromParent_Done,
     /* 203588 */   // Label 3805: @203588
     /* 203588 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(203625), // Rule ID 2407 //
     /* 203593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 203601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203614 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2077:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 203617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203623 */     GIR_RootConstrainSelectedInstOperands,
     /* 203624 */     // GIR_Coverage, 2407,
     /* 203624 */     GIR_EraseRootFromParent_Done,
     /* 203625 */   // Label 3806: @203625
     /* 203625 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(203662), // Rule ID 2408 //
     /* 203630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 203638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203651 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2078:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 203654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203660 */     GIR_RootConstrainSelectedInstOperands,
     /* 203661 */     // GIR_Coverage, 2408,
     /* 203661 */     GIR_EraseRootFromParent_Done,
     /* 203662 */   // Label 3807: @203662
     /* 203662 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(203699), // Rule ID 2409 //
     /* 203667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 203675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203688 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2079:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 203691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203697 */     GIR_RootConstrainSelectedInstOperands,
     /* 203698 */     // GIR_Coverage, 2409,
     /* 203698 */     GIR_EraseRootFromParent_Done,
     /* 203699 */   // Label 3808: @203699
     /* 203699 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(203736), // Rule ID 2411 //
     /* 203704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 203712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203725 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2082:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 203728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203734 */     GIR_RootConstrainSelectedInstOperands,
     /* 203735 */     // GIR_Coverage, 2411,
     /* 203735 */     GIR_EraseRootFromParent_Done,
     /* 203736 */   // Label 3809: @203736
     /* 203736 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(203773), // Rule ID 2412 //
     /* 203741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 203749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203762 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2083:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 203765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203771 */     GIR_RootConstrainSelectedInstOperands,
     /* 203772 */     // GIR_Coverage, 2412,
     /* 203772 */     GIR_EraseRootFromParent_Done,
     /* 203773 */   // Label 3810: @203773
     /* 203773 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(203810), // Rule ID 2413 //
     /* 203778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 203786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203799 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2084:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 203802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203808 */     GIR_RootConstrainSelectedInstOperands,
     /* 203809 */     // GIR_Coverage, 2413,
     /* 203809 */     GIR_EraseRootFromParent_Done,
     /* 203810 */   // Label 3811: @203810
     /* 203810 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(203847), // Rule ID 2415 //
     /* 203815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 203823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203836 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1921:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 203839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203845 */     GIR_RootConstrainSelectedInstOperands,
     /* 203846 */     // GIR_Coverage, 2415,
     /* 203846 */     GIR_EraseRootFromParent_Done,
     /* 203847 */   // Label 3812: @203847
     /* 203847 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(203884), // Rule ID 2416 //
     /* 203852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 203860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203873 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1922:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 203876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203882 */     GIR_RootConstrainSelectedInstOperands,
     /* 203883 */     // GIR_Coverage, 2416,
     /* 203883 */     GIR_EraseRootFromParent_Done,
     /* 203884 */   // Label 3813: @203884
     /* 203884 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(203921), // Rule ID 2417 //
     /* 203889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 203897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203910 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1923:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 203913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203919 */     GIR_RootConstrainSelectedInstOperands,
     /* 203920 */     // GIR_Coverage, 2417,
     /* 203920 */     GIR_EraseRootFromParent_Done,
     /* 203921 */   // Label 3814: @203921
     /* 203921 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(203958), // Rule ID 2419 //
     /* 203926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 203934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203947 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1926:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 203950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203956 */     GIR_RootConstrainSelectedInstOperands,
     /* 203957 */     // GIR_Coverage, 2419,
     /* 203957 */     GIR_EraseRootFromParent_Done,
     /* 203958 */   // Label 3815: @203958
     /* 203958 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(203995), // Rule ID 2420 //
     /* 203963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 203971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 203977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 203980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203984 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1927:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 203984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 203987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 203991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 203993 */     GIR_RootConstrainSelectedInstOperands,
     /* 203994 */     // GIR_Coverage, 2420,
     /* 203994 */     GIR_EraseRootFromParent_Done,
     /* 203995 */   // Label 3816: @203995
     /* 203995 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(204032), // Rule ID 2421 //
     /* 204000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 204008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 204017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204021 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1928:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 204021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 204024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 204028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 204030 */     GIR_RootConstrainSelectedInstOperands,
     /* 204031 */     // GIR_Coverage, 2421,
     /* 204031 */     GIR_EraseRootFromParent_Done,
     /* 204032 */   // Label 3817: @204032
     /* 204032 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(204069), // Rule ID 2422 //
     /* 204037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 204040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 204045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204058 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1546:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 204058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 204061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 204065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 204067 */     GIR_RootConstrainSelectedInstOperands,
     /* 204068 */     // GIR_Coverage, 2422,
     /* 204068 */     GIR_EraseRootFromParent_Done,
     /* 204069 */   // Label 3818: @204069
     /* 204069 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(204109), // Rule ID 2621 //
     /* 204074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 204082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 204091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204095 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1625:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 204095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 204098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 204100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204107 */     GIR_RootConstrainSelectedInstOperands,
     /* 204108 */     // GIR_Coverage, 2621,
     /* 204108 */     GIR_EraseRootFromParent_Done,
     /* 204109 */   // Label 3819: @204109
     /* 204109 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(204149), // Rule ID 2622 //
     /* 204114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 204122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 204131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204135 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1633:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 204135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 204138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 204140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204144 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204147 */     GIR_RootConstrainSelectedInstOperands,
     /* 204148 */     // GIR_Coverage, 2622,
     /* 204148 */     GIR_EraseRootFromParent_Done,
     /* 204149 */   // Label 3820: @204149
     /* 204149 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(204189), // Rule ID 2623 //
     /* 204154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 204162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 204165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 204171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204175 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1633:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 204175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 204178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 204180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204187 */     GIR_RootConstrainSelectedInstOperands,
     /* 204188 */     // GIR_Coverage, 2623,
     /* 204188 */     GIR_EraseRootFromParent_Done,
     /* 204189 */   // Label 3821: @204189
     /* 204189 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(204229), // Rule ID 2624 //
     /* 204194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 204202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 204205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 204211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204215 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1633:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 204215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 204218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 204220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204227 */     GIR_RootConstrainSelectedInstOperands,
     /* 204228 */     // GIR_Coverage, 2624,
     /* 204228 */     GIR_EraseRootFromParent_Done,
     /* 204229 */   // Label 3822: @204229
     /* 204229 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(204269), // Rule ID 2625 //
     /* 204234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 204242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 204245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 204251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204255 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1633:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 204255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 204258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 204260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 204267 */     GIR_RootConstrainSelectedInstOperands,
     /* 204268 */     // GIR_Coverage, 2625,
     /* 204268 */     GIR_EraseRootFromParent_Done,
     /* 204269 */   // Label 3823: @204269
     /* 204269 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(204306), // Rule ID 2642 //
     /* 204274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 204282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 204291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204295 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1813:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 204295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 204298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204304 */     GIR_RootConstrainSelectedInstOperands,
     /* 204305 */     // GIR_Coverage, 2642,
     /* 204305 */     GIR_EraseRootFromParent_Done,
     /* 204306 */   // Label 3824: @204306
     /* 204306 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(204343), // Rule ID 2643 //
     /* 204311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 204319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 204328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204332 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1813:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 204332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 204335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204341 */     GIR_RootConstrainSelectedInstOperands,
     /* 204342 */     // GIR_Coverage, 2643,
     /* 204342 */     GIR_EraseRootFromParent_Done,
     /* 204343 */   // Label 3825: @204343
     /* 204343 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(204380), // Rule ID 2644 //
     /* 204348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 204356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 204365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204369 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1813:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 204369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 204372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204378 */     GIR_RootConstrainSelectedInstOperands,
     /* 204379 */     // GIR_Coverage, 2644,
     /* 204379 */     GIR_EraseRootFromParent_Done,
     /* 204380 */   // Label 3826: @204380
     /* 204380 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(204417), // Rule ID 2645 //
     /* 204385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 204393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 204396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 204402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204406 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 204406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 204409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 204411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204415 */     GIR_RootConstrainSelectedInstOperands,
     /* 204416 */     // GIR_Coverage, 2645,
     /* 204416 */     GIR_EraseRootFromParent_Done,
     /* 204417 */   // Label 3827: @204417
     /* 204417 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(204454), // Rule ID 2646 //
     /* 204422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 204430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 204433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 204439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204443 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 204443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 204446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 204448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204452 */     GIR_RootConstrainSelectedInstOperands,
     /* 204453 */     // GIR_Coverage, 2646,
     /* 204453 */     GIR_EraseRootFromParent_Done,
     /* 204454 */   // Label 3828: @204454
     /* 204454 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(204491), // Rule ID 2647 //
     /* 204459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 204467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 204470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 204476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204480 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 204480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 204483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 204485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204489 */     GIR_RootConstrainSelectedInstOperands,
     /* 204490 */     // GIR_Coverage, 2647,
     /* 204490 */     GIR_EraseRootFromParent_Done,
     /* 204491 */   // Label 3829: @204491
     /* 204491 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(204528), // Rule ID 2648 //
     /* 204496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 204504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 204507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 204513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 204517 */     // (intrinsic_wo_chain:{ *:[i64] } 1335:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 204517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 204520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 204522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204526 */     GIR_RootConstrainSelectedInstOperands,
     /* 204527 */     // GIR_Coverage, 2648,
     /* 204527 */     GIR_EraseRootFromParent_Done,
     /* 204528 */   // Label 3830: @204528
     /* 204528 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(204565), // Rule ID 2826 //
     /* 204533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 204541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204554 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1543:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 204557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204563 */     GIR_RootConstrainSelectedInstOperands,
     /* 204564 */     // GIR_Coverage, 2826,
     /* 204564 */     GIR_EraseRootFromParent_Done,
     /* 204565 */   // Label 3831: @204565
     /* 204565 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(204602), // Rule ID 2827 //
     /* 204570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 204578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204591 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1543:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 204594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204600 */     GIR_RootConstrainSelectedInstOperands,
     /* 204601 */     // GIR_Coverage, 2827,
     /* 204601 */     GIR_EraseRootFromParent_Done,
     /* 204602 */   // Label 3832: @204602
     /* 204602 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(204639), // Rule ID 2828 //
     /* 204607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 204615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204628 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1543:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 204631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204637 */     GIR_RootConstrainSelectedInstOperands,
     /* 204638 */     // GIR_Coverage, 2828,
     /* 204638 */     GIR_EraseRootFromParent_Done,
     /* 204639 */   // Label 3833: @204639
     /* 204639 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(204676), // Rule ID 2999 //
     /* 204644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 204652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204665 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1795:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 204668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204674 */     GIR_RootConstrainSelectedInstOperands,
     /* 204675 */     // GIR_Coverage, 2999,
     /* 204675 */     GIR_EraseRootFromParent_Done,
     /* 204676 */   // Label 3834: @204676
     /* 204676 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(204713), // Rule ID 3000 //
     /* 204681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 204689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204702 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1795:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 204705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204711 */     GIR_RootConstrainSelectedInstOperands,
     /* 204712 */     // GIR_Coverage, 3000,
     /* 204712 */     GIR_EraseRootFromParent_Done,
     /* 204713 */   // Label 3835: @204713
     /* 204713 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(204750), // Rule ID 3001 //
     /* 204718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 204726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204739 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1795:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 204742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204748 */     GIR_RootConstrainSelectedInstOperands,
     /* 204749 */     // GIR_Coverage, 3001,
     /* 204749 */     GIR_EraseRootFromParent_Done,
     /* 204750 */   // Label 3836: @204750
     /* 204750 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(204787), // Rule ID 3002 //
     /* 204755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 204763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1795:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 204779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204785 */     GIR_RootConstrainSelectedInstOperands,
     /* 204786 */     // GIR_Coverage, 3002,
     /* 204786 */     GIR_EraseRootFromParent_Done,
     /* 204787 */   // Label 3837: @204787
     /* 204787 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(204824), // Rule ID 3003 //
     /* 204792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 204800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204813 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1630:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 204816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204822 */     GIR_RootConstrainSelectedInstOperands,
     /* 204823 */     // GIR_Coverage, 3003,
     /* 204823 */     GIR_EraseRootFromParent_Done,
     /* 204824 */   // Label 3838: @204824
     /* 204824 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(204861), // Rule ID 3025 //
     /* 204829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 204837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204850 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1688:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 204853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204859 */     GIR_RootConstrainSelectedInstOperands,
     /* 204860 */     // GIR_Coverage, 3025,
     /* 204860 */     GIR_EraseRootFromParent_Done,
     /* 204861 */   // Label 3839: @204861
     /* 204861 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(204898), // Rule ID 3026 //
     /* 204866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 204874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204887 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 204890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204896 */     GIR_RootConstrainSelectedInstOperands,
     /* 204897 */     // GIR_Coverage, 3026,
     /* 204897 */     GIR_EraseRootFromParent_Done,
     /* 204898 */   // Label 3840: @204898
     /* 204898 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(204935), // Rule ID 3027 //
     /* 204903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 204911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204924 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1688:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 204927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204933 */     GIR_RootConstrainSelectedInstOperands,
     /* 204934 */     // GIR_Coverage, 3027,
     /* 204934 */     GIR_EraseRootFromParent_Done,
     /* 204935 */   // Label 3841: @204935
     /* 204935 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(204972), // Rule ID 3031 //
     /* 204940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 204943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 204948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1631:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 204964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204970 */     GIR_RootConstrainSelectedInstOperands,
     /* 204971 */     // GIR_Coverage, 3031,
     /* 204971 */     GIR_EraseRootFromParent_Done,
     /* 204972 */   // Label 3842: @204972
     /* 204972 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(205009), // Rule ID 3032 //
     /* 204977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 204980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 204985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204998 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1631:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 205001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205007 */     GIR_RootConstrainSelectedInstOperands,
     /* 205008 */     // GIR_Coverage, 3032,
     /* 205008 */     GIR_EraseRootFromParent_Done,
     /* 205009 */   // Label 3843: @205009
     /* 205009 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(205046), // Rule ID 3033 //
     /* 205014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 205022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205035 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1631:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 205038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205044 */     GIR_RootConstrainSelectedInstOperands,
     /* 205045 */     // GIR_Coverage, 3033,
     /* 205045 */     GIR_EraseRootFromParent_Done,
     /* 205046 */   // Label 3844: @205046
     /* 205046 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(205083), // Rule ID 3034 //
     /* 205051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 205054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 205059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205072 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1273:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 205075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205081 */     GIR_RootConstrainSelectedInstOperands,
     /* 205082 */     // GIR_Coverage, 3034,
     /* 205082 */     GIR_EraseRootFromParent_Done,
     /* 205083 */   // Label 3845: @205083
     /* 205083 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(205120), // Rule ID 3035 //
     /* 205088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 205091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 205096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205109 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1273:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 205112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205118 */     GIR_RootConstrainSelectedInstOperands,
     /* 205119 */     // GIR_Coverage, 3035,
     /* 205119 */     GIR_EraseRootFromParent_Done,
     /* 205120 */   // Label 3846: @205120
     /* 205120 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(205157), // Rule ID 3036 //
     /* 205125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 205128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 205133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1273:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 205149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205155 */     GIR_RootConstrainSelectedInstOperands,
     /* 205156 */     // GIR_Coverage, 3036,
     /* 205156 */     GIR_EraseRootFromParent_Done,
     /* 205157 */   // Label 3847: @205157
     /* 205157 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(205194), // Rule ID 3037 //
     /* 205162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 205165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 205170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205183 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1273:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 205186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205192 */     GIR_RootConstrainSelectedInstOperands,
     /* 205193 */     // GIR_Coverage, 3037,
     /* 205193 */     GIR_EraseRootFromParent_Done,
     /* 205194 */   // Label 3848: @205194
     /* 205194 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(205231), // Rule ID 3038 //
     /* 205199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 205207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205220 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1689:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 205223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205229 */     GIR_RootConstrainSelectedInstOperands,
     /* 205230 */     // GIR_Coverage, 3038,
     /* 205230 */     GIR_EraseRootFromParent_Done,
     /* 205231 */   // Label 3849: @205231
     /* 205231 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(205268), // Rule ID 3039 //
     /* 205236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 205244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205257 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1689:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 205260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205266 */     GIR_RootConstrainSelectedInstOperands,
     /* 205267 */     // GIR_Coverage, 3039,
     /* 205267 */     GIR_EraseRootFromParent_Done,
     /* 205268 */   // Label 3850: @205268
     /* 205268 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(205305), // Rule ID 3040 //
     /* 205273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 205281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205294 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1689:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 205297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205303 */     GIR_RootConstrainSelectedInstOperands,
     /* 205304 */     // GIR_Coverage, 3040,
     /* 205304 */     GIR_EraseRootFromParent_Done,
     /* 205305 */   // Label 3851: @205305
     /* 205305 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(205342), // Rule ID 3087 //
     /* 205310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 205318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205331 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1250:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 205334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205340 */     GIR_RootConstrainSelectedInstOperands,
     /* 205341 */     // GIR_Coverage, 3087,
     /* 205341 */     GIR_EraseRootFromParent_Done,
     /* 205342 */   // Label 3852: @205342
     /* 205342 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(205379), // Rule ID 3088 //
     /* 205347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 205355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205368 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1250:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 205371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205377 */     GIR_RootConstrainSelectedInstOperands,
     /* 205378 */     // GIR_Coverage, 3088,
     /* 205378 */     GIR_EraseRootFromParent_Done,
     /* 205379 */   // Label 3853: @205379
     /* 205379 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(205416), // Rule ID 3089 //
     /* 205384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 205392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205405 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1250:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 205408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205414 */     GIR_RootConstrainSelectedInstOperands,
     /* 205415 */     // GIR_Coverage, 3089,
     /* 205415 */     GIR_EraseRootFromParent_Done,
     /* 205416 */   // Label 3854: @205416
     /* 205416 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(205453), // Rule ID 3096 //
     /* 205421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 205429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205442 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1852:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 205445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205451 */     GIR_RootConstrainSelectedInstOperands,
     /* 205452 */     // GIR_Coverage, 3096,
     /* 205452 */     GIR_EraseRootFromParent_Done,
     /* 205453 */   // Label 3855: @205453
     /* 205453 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(205490), // Rule ID 3097 //
     /* 205458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 205466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205479 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1852:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 205482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205488 */     GIR_RootConstrainSelectedInstOperands,
     /* 205489 */     // GIR_Coverage, 3097,
     /* 205489 */     GIR_EraseRootFromParent_Done,
     /* 205490 */   // Label 3856: @205490
     /* 205490 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(205527), // Rule ID 3098 //
     /* 205495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 205498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 205503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205516 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1852:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 205519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205525 */     GIR_RootConstrainSelectedInstOperands,
     /* 205526 */     // GIR_Coverage, 3098,
     /* 205526 */     GIR_EraseRootFromParent_Done,
     /* 205527 */   // Label 3857: @205527
     /* 205527 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(205567), // Rule ID 3202 //
     /* 205532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 205540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 205543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205553 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 205556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205565 */     GIR_RootConstrainSelectedInstOperands,
     /* 205566 */     // GIR_Coverage, 3202,
     /* 205566 */     GIR_EraseRootFromParent_Done,
     /* 205567 */   // Label 3858: @205567
     /* 205567 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(205607), // Rule ID 3203 //
     /* 205572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 205580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 205583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205593 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 205596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205605 */     GIR_RootConstrainSelectedInstOperands,
     /* 205606 */     // GIR_Coverage, 3203,
     /* 205606 */     GIR_EraseRootFromParent_Done,
     /* 205607 */   // Label 3859: @205607
     /* 205607 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(205647), // Rule ID 3204 //
     /* 205612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 205620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 205623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205633 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 205636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205645 */     GIR_RootConstrainSelectedInstOperands,
     /* 205646 */     // GIR_Coverage, 3204,
     /* 205646 */     GIR_EraseRootFromParent_Done,
     /* 205647 */   // Label 3860: @205647
     /* 205647 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(205687), // Rule ID 3205 //
     /* 205652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 205660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 205663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205673 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2132:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 205676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205685 */     GIR_RootConstrainSelectedInstOperands,
     /* 205686 */     // GIR_Coverage, 3205,
     /* 205686 */     GIR_EraseRootFromParent_Done,
     /* 205687 */   // Label 3861: @205687
     /* 205687 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(205727), // Rule ID 3210 //
     /* 205692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 205700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 205703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 205706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 205709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205713 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 205713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 205716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205725 */     GIR_RootConstrainSelectedInstOperands,
     /* 205726 */     // GIR_Coverage, 3210,
     /* 205726 */     GIR_EraseRootFromParent_Done,
     /* 205727 */   // Label 3862: @205727
     /* 205727 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(205767), // Rule ID 3211 //
     /* 205732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 205740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 205743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 205746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 205749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205753 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 205753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 205756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205765 */     GIR_RootConstrainSelectedInstOperands,
     /* 205766 */     // GIR_Coverage, 3211,
     /* 205766 */     GIR_EraseRootFromParent_Done,
     /* 205767 */   // Label 3863: @205767
     /* 205767 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(205807), // Rule ID 3212 //
     /* 205772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 205780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 205783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 205786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 205789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205793 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 205793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 205796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205805 */     GIR_RootConstrainSelectedInstOperands,
     /* 205806 */     // GIR_Coverage, 3212,
     /* 205806 */     GIR_EraseRootFromParent_Done,
     /* 205807 */   // Label 3864: @205807
     /* 205807 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(205847), // Rule ID 3213 //
     /* 205812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 205820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 205823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 205826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 205829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205833 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2132:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 205833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 205836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205845 */     GIR_RootConstrainSelectedInstOperands,
     /* 205846 */     // GIR_Coverage, 3213,
     /* 205846 */     GIR_EraseRootFromParent_Done,
     /* 205847 */   // Label 3865: @205847
     /* 205847 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(205884), // Rule ID 3402 //
     /* 205852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 205855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 205860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205873 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1341:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 205876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205882 */     GIR_RootConstrainSelectedInstOperands,
     /* 205883 */     // GIR_Coverage, 3402,
     /* 205883 */     GIR_EraseRootFromParent_Done,
     /* 205884 */   // Label 3866: @205884
     /* 205884 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(205921), // Rule ID 3403 //
     /* 205889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 205892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 205897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205910 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1341:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 205910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 205913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205919 */     GIR_RootConstrainSelectedInstOperands,
     /* 205920 */     // GIR_Coverage, 3403,
     /* 205920 */     GIR_EraseRootFromParent_Done,
     /* 205921 */   // Label 3867: @205921
     /* 205921 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(205958), // Rule ID 3404 //
     /* 205926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 205929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 205934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205947 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1341:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 205950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205956 */     GIR_RootConstrainSelectedInstOperands,
     /* 205957 */     // GIR_Coverage, 3404,
     /* 205957 */     GIR_EraseRootFromParent_Done,
     /* 205958 */   // Label 3868: @205958
     /* 205958 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(205995), // Rule ID 3405 //
     /* 205963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 205966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 205971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205984 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1341:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 205984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 205987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205993 */     GIR_RootConstrainSelectedInstOperands,
     /* 205994 */     // GIR_Coverage, 3405,
     /* 205994 */     GIR_EraseRootFromParent_Done,
     /* 205995 */   // Label 3869: @205995
     /* 205995 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(206032), // Rule ID 3427 //
     /* 206000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 206003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 206008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206021 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1544:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 206024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206030 */     GIR_RootConstrainSelectedInstOperands,
     /* 206031 */     // GIR_Coverage, 3427,
     /* 206031 */     GIR_EraseRootFromParent_Done,
     /* 206032 */   // Label 3870: @206032
     /* 206032 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(206069), // Rule ID 3428 //
     /* 206037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 206040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 206045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206058 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1544:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 206061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206067 */     GIR_RootConstrainSelectedInstOperands,
     /* 206068 */     // GIR_Coverage, 3428,
     /* 206068 */     GIR_EraseRootFromParent_Done,
     /* 206069 */   // Label 3871: @206069
     /* 206069 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(206106), // Rule ID 3429 //
     /* 206074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 206077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 206082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206095 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1544:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 206098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206104 */     GIR_RootConstrainSelectedInstOperands,
     /* 206105 */     // GIR_Coverage, 3429,
     /* 206105 */     GIR_EraseRootFromParent_Done,
     /* 206106 */   // Label 3872: @206106
     /* 206106 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(206143), // Rule ID 3451 //
     /* 206111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 206119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 206122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 206125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 206128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206132 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1294:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 206132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 206135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206141 */     GIR_RootConstrainSelectedInstOperands,
     /* 206142 */     // GIR_Coverage, 3451,
     /* 206142 */     GIR_EraseRootFromParent_Done,
     /* 206143 */   // Label 3873: @206143
     /* 206143 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(206180), // Rule ID 3456 //
     /* 206148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 206151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 206156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206169 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1724:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 206172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206178 */     GIR_RootConstrainSelectedInstOperands,
     /* 206179 */     // GIR_Coverage, 3456,
     /* 206179 */     GIR_EraseRootFromParent_Done,
     /* 206180 */   // Label 3874: @206180
     /* 206180 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(206217), // Rule ID 3457 //
     /* 206185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 206188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 206193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206206 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1259:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 206209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206215 */     GIR_RootConstrainSelectedInstOperands,
     /* 206216 */     // GIR_Coverage, 3457,
     /* 206216 */     GIR_EraseRootFromParent_Done,
     /* 206217 */   // Label 3875: @206217
     /* 206217 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(206254), // Rule ID 3466 //
     /* 206222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 206230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206243 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2154:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 206246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206252 */     GIR_RootConstrainSelectedInstOperands,
     /* 206253 */     // GIR_Coverage, 3466,
     /* 206253 */     GIR_EraseRootFromParent_Done,
     /* 206254 */   // Label 3876: @206254
     /* 206254 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(206291), // Rule ID 3467 //
     /* 206259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 206267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206280 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2154:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 206283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206289 */     GIR_RootConstrainSelectedInstOperands,
     /* 206290 */     // GIR_Coverage, 3467,
     /* 206290 */     GIR_EraseRootFromParent_Done,
     /* 206291 */   // Label 3877: @206291
     /* 206291 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(206328), // Rule ID 3468 //
     /* 206296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 206304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206317 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2154:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 206317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 206320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206326 */     GIR_RootConstrainSelectedInstOperands,
     /* 206327 */     // GIR_Coverage, 3468,
     /* 206327 */     GIR_EraseRootFromParent_Done,
     /* 206328 */   // Label 3878: @206328
     /* 206328 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(206365), // Rule ID 3469 //
     /* 206333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 206341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206354 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2154:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 206357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206363 */     GIR_RootConstrainSelectedInstOperands,
     /* 206364 */     // GIR_Coverage, 3469,
     /* 206364 */     GIR_EraseRootFromParent_Done,
     /* 206365 */   // Label 3879: @206365
     /* 206365 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(206402), // Rule ID 3470 //
     /* 206370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 206378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206391 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2154:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 206391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 206394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206400 */     GIR_RootConstrainSelectedInstOperands,
     /* 206401 */     // GIR_Coverage, 3470,
     /* 206401 */     GIR_EraseRootFromParent_Done,
     /* 206402 */   // Label 3880: @206402
     /* 206402 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(206439), // Rule ID 3471 //
     /* 206407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 206415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206428 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2154:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 206431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206437 */     GIR_RootConstrainSelectedInstOperands,
     /* 206438 */     // GIR_Coverage, 3471,
     /* 206438 */     GIR_EraseRootFromParent_Done,
     /* 206439 */   // Label 3881: @206439
     /* 206439 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(206476), // Rule ID 3472 //
     /* 206444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 206452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206465 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2154:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 206465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 206468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206474 */     GIR_RootConstrainSelectedInstOperands,
     /* 206475 */     // GIR_Coverage, 3472,
     /* 206475 */     GIR_EraseRootFromParent_Done,
     /* 206476 */   // Label 3882: @206476
     /* 206476 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(206513), // Rule ID 3527 //
     /* 206481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 206489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 206492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206502 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1367:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 206502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 206505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 206507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206511 */     GIR_RootConstrainSelectedInstOperands,
     /* 206512 */     // GIR_Coverage, 3527,
     /* 206512 */     GIR_EraseRootFromParent_Done,
     /* 206513 */   // Label 3883: @206513
     /* 206513 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(206550), // Rule ID 3528 //
     /* 206518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 206526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 206529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206539 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1367:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 206539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 206542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 206544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206548 */     GIR_RootConstrainSelectedInstOperands,
     /* 206549 */     // GIR_Coverage, 3528,
     /* 206549 */     GIR_EraseRootFromParent_Done,
     /* 206550 */   // Label 3884: @206550
     /* 206550 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(206587), // Rule ID 3529 //
     /* 206555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 206563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 206566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206576 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1367:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 206576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 206579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 206581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206585 */     GIR_RootConstrainSelectedInstOperands,
     /* 206586 */     // GIR_Coverage, 3529,
     /* 206586 */     GIR_EraseRootFromParent_Done,
     /* 206587 */   // Label 3885: @206587
     /* 206587 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(206624), // Rule ID 3559 //
     /* 206592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 206600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 206603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 206606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206613 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1618:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 206616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 206618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206622 */     GIR_RootConstrainSelectedInstOperands,
     /* 206623 */     // GIR_Coverage, 3559,
     /* 206623 */     GIR_EraseRootFromParent_Done,
     /* 206624 */   // Label 3886: @206624
     /* 206624 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(206661), // Rule ID 3560 //
     /* 206629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 206637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 206640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206650 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1618:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 206653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 206655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206659 */     GIR_RootConstrainSelectedInstOperands,
     /* 206660 */     // GIR_Coverage, 3560,
     /* 206660 */     GIR_EraseRootFromParent_Done,
     /* 206661 */   // Label 3887: @206661
     /* 206661 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(206698), // Rule ID 3561 //
     /* 206666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 206674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 206677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206687 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1618:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 206690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 206692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206696 */     GIR_RootConstrainSelectedInstOperands,
     /* 206697 */     // GIR_Coverage, 3561,
     /* 206697 */     GIR_EraseRootFromParent_Done,
     /* 206698 */   // Label 3888: @206698
     /* 206698 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(206735), // Rule ID 3562 //
     /* 206703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 206711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 206714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 206724 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1618:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 206727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 206729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206733 */     GIR_RootConstrainSelectedInstOperands,
     /* 206734 */     // GIR_Coverage, 3562,
     /* 206734 */     GIR_EraseRootFromParent_Done,
     /* 206735 */   // Label 3889: @206735
     /* 206735 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(206772), // Rule ID 3563 //
     /* 206740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 206748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206761 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2162:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 206764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206770 */     GIR_RootConstrainSelectedInstOperands,
     /* 206771 */     // GIR_Coverage, 3563,
     /* 206771 */     GIR_EraseRootFromParent_Done,
     /* 206772 */   // Label 3890: @206772
     /* 206772 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(206809), // Rule ID 3564 //
     /* 206777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 206785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206798 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2162:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 206801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206807 */     GIR_RootConstrainSelectedInstOperands,
     /* 206808 */     // GIR_Coverage, 3564,
     /* 206808 */     GIR_EraseRootFromParent_Done,
     /* 206809 */   // Label 3891: @206809
     /* 206809 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(206846), // Rule ID 3565 //
     /* 206814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 206822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206835 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2162:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 206838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206844 */     GIR_RootConstrainSelectedInstOperands,
     /* 206845 */     // GIR_Coverage, 3565,
     /* 206845 */     GIR_EraseRootFromParent_Done,
     /* 206846 */   // Label 3892: @206846
     /* 206846 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(206883), // Rule ID 3566 //
     /* 206851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 206859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206872 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2162:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 206875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206881 */     GIR_RootConstrainSelectedInstOperands,
     /* 206882 */     // GIR_Coverage, 3566,
     /* 206882 */     GIR_EraseRootFromParent_Done,
     /* 206883 */   // Label 3893: @206883
     /* 206883 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(206920), // Rule ID 3567 //
     /* 206888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 206896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206909 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2162:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 206909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 206912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206918 */     GIR_RootConstrainSelectedInstOperands,
     /* 206919 */     // GIR_Coverage, 3567,
     /* 206919 */     GIR_EraseRootFromParent_Done,
     /* 206920 */   // Label 3894: @206920
     /* 206920 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(206957), // Rule ID 3568 //
     /* 206925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 206933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206946 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2162:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 206946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 206949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206955 */     GIR_RootConstrainSelectedInstOperands,
     /* 206956 */     // GIR_Coverage, 3568,
     /* 206956 */     GIR_EraseRootFromParent_Done,
     /* 206957 */   // Label 3895: @206957
     /* 206957 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(206994), // Rule ID 3569 //
     /* 206962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 206965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 206970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206983 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2162:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 206983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 206986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206992 */     GIR_RootConstrainSelectedInstOperands,
     /* 206993 */     // GIR_Coverage, 3569,
     /* 206993 */     GIR_EraseRootFromParent_Done,
     /* 206994 */   // Label 3896: @206994
     /* 206994 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(207031), // Rule ID 3570 //
     /* 206999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 207007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207020 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1917:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 207023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207029 */     GIR_RootConstrainSelectedInstOperands,
     /* 207030 */     // GIR_Coverage, 3570,
     /* 207030 */     GIR_EraseRootFromParent_Done,
     /* 207031 */   // Label 3897: @207031
     /* 207031 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(207068), // Rule ID 3571 //
     /* 207036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 207044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207057 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1917:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 207060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207066 */     GIR_RootConstrainSelectedInstOperands,
     /* 207067 */     // GIR_Coverage, 3571,
     /* 207067 */     GIR_EraseRootFromParent_Done,
     /* 207068 */   // Label 3898: @207068
     /* 207068 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(207105), // Rule ID 3572 //
     /* 207073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 207081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207094 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1917:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 207097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207103 */     GIR_RootConstrainSelectedInstOperands,
     /* 207104 */     // GIR_Coverage, 3572,
     /* 207104 */     GIR_EraseRootFromParent_Done,
     /* 207105 */   // Label 3899: @207105
     /* 207105 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(207142), // Rule ID 3573 //
     /* 207110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 207118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207131 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1917:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 207134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207140 */     GIR_RootConstrainSelectedInstOperands,
     /* 207141 */     // GIR_Coverage, 3573,
     /* 207141 */     GIR_EraseRootFromParent_Done,
     /* 207142 */   // Label 3900: @207142
     /* 207142 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(207179), // Rule ID 3574 //
     /* 207147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 207155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207168 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1917:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 207171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207177 */     GIR_RootConstrainSelectedInstOperands,
     /* 207178 */     // GIR_Coverage, 3574,
     /* 207178 */     GIR_EraseRootFromParent_Done,
     /* 207179 */   // Label 3901: @207179
     /* 207179 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(207216), // Rule ID 3575 //
     /* 207184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 207192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207205 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1917:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 207208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207214 */     GIR_RootConstrainSelectedInstOperands,
     /* 207215 */     // GIR_Coverage, 3575,
     /* 207215 */     GIR_EraseRootFromParent_Done,
     /* 207216 */   // Label 3902: @207216
     /* 207216 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(207253), // Rule ID 3576 //
     /* 207221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 207224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 207229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207242 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1917:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 207245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207251 */     GIR_RootConstrainSelectedInstOperands,
     /* 207252 */     // GIR_Coverage, 3576,
     /* 207252 */     GIR_EraseRootFromParent_Done,
     /* 207253 */   // Label 3903: @207253
     /* 207253 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(207290), // Rule ID 8474 //
     /* 207258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 207266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 207269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 207272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 207275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207279 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1296:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 207279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 207282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207288 */     GIR_RootConstrainSelectedInstOperands,
     /* 207289 */     // GIR_Coverage, 8474,
     /* 207289 */     GIR_EraseRootFromParent_Done,
     /* 207290 */   // Label 3904: @207290
     /* 207290 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(207327), // Rule ID 8950 //
     /* 207295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 207303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1254:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 207319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207325 */     GIR_RootConstrainSelectedInstOperands,
     /* 207326 */     // GIR_Coverage, 8950,
     /* 207326 */     GIR_EraseRootFromParent_Done,
     /* 207327 */   // Label 3905: @207327
     /* 207327 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(207364), // Rule ID 8951 //
     /* 207332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 207340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207353 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1256:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 207356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207362 */     GIR_RootConstrainSelectedInstOperands,
     /* 207363 */     // GIR_Coverage, 8951,
     /* 207363 */     GIR_EraseRootFromParent_Done,
     /* 207364 */   // Label 3906: @207364
     /* 207364 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(207401), // Rule ID 8952 //
     /* 207369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 207377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207390 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1257:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 207393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207399 */     GIR_RootConstrainSelectedInstOperands,
     /* 207400 */     // GIR_Coverage, 8952,
     /* 207400 */     GIR_EraseRootFromParent_Done,
     /* 207401 */   // Label 3907: @207401
     /* 207401 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(207438), // Rule ID 8953 //
     /* 207406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 207414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207427 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1255:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 207430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207436 */     GIR_RootConstrainSelectedInstOperands,
     /* 207437 */     // GIR_Coverage, 8953,
     /* 207437 */     GIR_EraseRootFromParent_Done,
     /* 207438 */   // Label 3908: @207438
     /* 207438 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(207475), // Rule ID 8954 //
     /* 207443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 207451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207464 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1254:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 207467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207473 */     GIR_RootConstrainSelectedInstOperands,
     /* 207474 */     // GIR_Coverage, 8954,
     /* 207474 */     GIR_EraseRootFromParent_Done,
     /* 207475 */   // Label 3909: @207475
     /* 207475 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(207512), // Rule ID 8955 //
     /* 207480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 207488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207501 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1256:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 207504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207510 */     GIR_RootConstrainSelectedInstOperands,
     /* 207511 */     // GIR_Coverage, 8955,
     /* 207511 */     GIR_EraseRootFromParent_Done,
     /* 207512 */   // Label 3910: @207512
     /* 207512 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(207549), // Rule ID 8956 //
     /* 207517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 207525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207538 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1257:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 207541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207547 */     GIR_RootConstrainSelectedInstOperands,
     /* 207548 */     // GIR_Coverage, 8956,
     /* 207548 */     GIR_EraseRootFromParent_Done,
     /* 207549 */   // Label 3911: @207549
     /* 207549 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(207586), // Rule ID 8957 //
     /* 207554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 207557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 207562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207575 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1255:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 207578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207584 */     GIR_RootConstrainSelectedInstOperands,
     /* 207585 */     // GIR_Coverage, 8957,
     /* 207585 */     GIR_EraseRootFromParent_Done,
     /* 207586 */   // Label 3912: @207586
     /* 207586 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(207626), // Rule ID 9957 //
     /* 207591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 207599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 207602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207612 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 207615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207624 */     GIR_RootConstrainSelectedInstOperands,
     /* 207625 */     // GIR_Coverage, 9957,
     /* 207625 */     GIR_EraseRootFromParent_Done,
     /* 207626 */   // Label 3913: @207626
     /* 207626 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(207666), // Rule ID 9958 //
     /* 207631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 207639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 207642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207652 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 207655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207661 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207664 */     GIR_RootConstrainSelectedInstOperands,
     /* 207665 */     // GIR_Coverage, 9958,
     /* 207665 */     GIR_EraseRootFromParent_Done,
     /* 207666 */   // Label 3914: @207666
     /* 207666 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(207706), // Rule ID 9959 //
     /* 207671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 207679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 207682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207692 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 207695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207704 */     GIR_RootConstrainSelectedInstOperands,
     /* 207705 */     // GIR_Coverage, 9959,
     /* 207705 */     GIR_EraseRootFromParent_Done,
     /* 207706 */   // Label 3915: @207706
     /* 207706 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(207746), // Rule ID 9960 //
     /* 207711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 207719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 207722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207732 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2114:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 207735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207744 */     GIR_RootConstrainSelectedInstOperands,
     /* 207745 */     // GIR_Coverage, 9960,
     /* 207745 */     GIR_EraseRootFromParent_Done,
     /* 207746 */   // Label 3916: @207746
     /* 207746 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(207786), // Rule ID 9961 //
     /* 207751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 207759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 207762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207772 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_B),
     /* 207775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207784 */     GIR_RootConstrainSelectedInstOperands,
     /* 207785 */     // GIR_Coverage, 9961,
     /* 207785 */     GIR_EraseRootFromParent_Done,
     /* 207786 */   // Label 3917: @207786
     /* 207786 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(207826), // Rule ID 9962 //
     /* 207791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 207799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 207802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207812 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_H),
     /* 207815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207824 */     GIR_RootConstrainSelectedInstOperands,
     /* 207825 */     // GIR_Coverage, 9962,
     /* 207825 */     GIR_EraseRootFromParent_Done,
     /* 207826 */   // Label 3918: @207826
     /* 207826 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(207866), // Rule ID 9963 //
     /* 207831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 207839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 207842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207852 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_S),
     /* 207855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207864 */     GIR_RootConstrainSelectedInstOperands,
     /* 207865 */     // GIR_Coverage, 9963,
     /* 207865 */     GIR_EraseRootFromParent_Done,
     /* 207866 */   // Label 3919: @207866
     /* 207866 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(207906), // Rule ID 9964 //
     /* 207871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 207879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 207882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207892 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2120:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_D),
     /* 207895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207904 */     GIR_RootConstrainSelectedInstOperands,
     /* 207905 */     // GIR_Coverage, 9964,
     /* 207905 */     GIR_EraseRootFromParent_Done,
     /* 207906 */   // Label 3920: @207906
     /* 207906 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(207946), // Rule ID 9969 //
     /* 207911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 207919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 207922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207932 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 207935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207944 */     GIR_RootConstrainSelectedInstOperands,
     /* 207945 */     // GIR_Coverage, 9969,
     /* 207945 */     GIR_EraseRootFromParent_Done,
     /* 207946 */   // Label 3921: @207946
     /* 207946 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(207986), // Rule ID 9970 //
     /* 207951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 207959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 207962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 207965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 207968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 207972 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 207972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 207975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 207977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 207984 */     GIR_RootConstrainSelectedInstOperands,
     /* 207985 */     // GIR_Coverage, 9970,
     /* 207985 */     GIR_EraseRootFromParent_Done,
     /* 207986 */   // Label 3922: @207986
     /* 207986 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(208026), // Rule ID 9971 //
     /* 207991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 207999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 208002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 208005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 208008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208012 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 208012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 208015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208024 */     GIR_RootConstrainSelectedInstOperands,
     /* 208025 */     // GIR_Coverage, 9971,
     /* 208025 */     GIR_EraseRootFromParent_Done,
     /* 208026 */   // Label 3923: @208026
     /* 208026 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(208066), // Rule ID 9972 //
     /* 208031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 208039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 208042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 208045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 208048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208052 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2126:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 208052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 208055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208064 */     GIR_RootConstrainSelectedInstOperands,
     /* 208065 */     // GIR_Coverage, 9972,
     /* 208065 */     GIR_EraseRootFromParent_Done,
     /* 208066 */   // Label 3924: @208066
     /* 208066 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(208106), // Rule ID 9973 //
     /* 208071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 208079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 208082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208092 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 208095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208101 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208104 */     GIR_RootConstrainSelectedInstOperands,
     /* 208105 */     // GIR_Coverage, 9973,
     /* 208105 */     GIR_EraseRootFromParent_Done,
     /* 208106 */   // Label 3925: @208106
     /* 208106 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(208146), // Rule ID 9974 //
     /* 208111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 208119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 208122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208132 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 208135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208144 */     GIR_RootConstrainSelectedInstOperands,
     /* 208145 */     // GIR_Coverage, 9974,
     /* 208145 */     GIR_EraseRootFromParent_Done,
     /* 208146 */   // Label 3926: @208146
     /* 208146 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(208186), // Rule ID 9975 //
     /* 208151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 208159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 208162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208172 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 208175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208184 */     GIR_RootConstrainSelectedInstOperands,
     /* 208185 */     // GIR_Coverage, 9975,
     /* 208185 */     GIR_EraseRootFromParent_Done,
     /* 208186 */   // Label 3927: @208186
     /* 208186 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(208226), // Rule ID 9976 //
     /* 208191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 208199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 208202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208212 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2114:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 208215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208221 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208224 */     GIR_RootConstrainSelectedInstOperands,
     /* 208225 */     // GIR_Coverage, 9976,
     /* 208225 */     GIR_EraseRootFromParent_Done,
     /* 208226 */   // Label 3928: @208226
     /* 208226 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(208266), // Rule ID 9977 //
     /* 208231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 208239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 208242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208252 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_B),
     /* 208255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208264 */     GIR_RootConstrainSelectedInstOperands,
     /* 208265 */     // GIR_Coverage, 9977,
     /* 208265 */     GIR_EraseRootFromParent_Done,
     /* 208266 */   // Label 3929: @208266
     /* 208266 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(208306), // Rule ID 9978 //
     /* 208271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 208279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 208282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208292 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_H),
     /* 208295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208304 */     GIR_RootConstrainSelectedInstOperands,
     /* 208305 */     // GIR_Coverage, 9978,
     /* 208305 */     GIR_EraseRootFromParent_Done,
     /* 208306 */   // Label 3930: @208306
     /* 208306 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(208346), // Rule ID 9979 //
     /* 208311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 208319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 208322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208332 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_S),
     /* 208335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208341 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208344 */     GIR_RootConstrainSelectedInstOperands,
     /* 208345 */     // GIR_Coverage, 9979,
     /* 208345 */     GIR_EraseRootFromParent_Done,
     /* 208346 */   // Label 3931: @208346
     /* 208346 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(208386), // Rule ID 9980 //
     /* 208351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 208359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 208362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208372 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2120:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_D),
     /* 208375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208384 */     GIR_RootConstrainSelectedInstOperands,
     /* 208385 */     // GIR_Coverage, 9980,
     /* 208385 */     GIR_EraseRootFromParent_Done,
     /* 208386 */   // Label 3932: @208386
     /* 208386 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(208426), // Rule ID 9985 //
     /* 208391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 208399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 208402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208412 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 208415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208424 */     GIR_RootConstrainSelectedInstOperands,
     /* 208425 */     // GIR_Coverage, 9985,
     /* 208425 */     GIR_EraseRootFromParent_Done,
     /* 208426 */   // Label 3933: @208426
     /* 208426 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(208466), // Rule ID 9986 //
     /* 208431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 208439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 208442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208452 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 208455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208464 */     GIR_RootConstrainSelectedInstOperands,
     /* 208465 */     // GIR_Coverage, 9986,
     /* 208465 */     GIR_EraseRootFromParent_Done,
     /* 208466 */   // Label 3934: @208466
     /* 208466 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(208506), // Rule ID 9987 //
     /* 208471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 208479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 208482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208492 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 208495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208504 */     GIR_RootConstrainSelectedInstOperands,
     /* 208505 */     // GIR_Coverage, 9987,
     /* 208505 */     GIR_EraseRootFromParent_Done,
     /* 208506 */   // Label 3935: @208506
     /* 208506 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(208546), // Rule ID 9988 //
     /* 208511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 208519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 208522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 208528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208532 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 208532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 208535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 208537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 208544 */     GIR_RootConstrainSelectedInstOperands,
     /* 208545 */     // GIR_Coverage, 9988,
     /* 208545 */     GIR_EraseRootFromParent_Done,
     /* 208546 */   // Label 3936: @208546
     /* 208546 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(208583), // Rule ID 10147 //
     /* 208551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 208559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 208568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208572 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2024:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 208572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 208575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208581 */     GIR_RootConstrainSelectedInstOperands,
     /* 208582 */     // GIR_Coverage, 10147,
     /* 208582 */     GIR_EraseRootFromParent_Done,
     /* 208583 */   // Label 3937: @208583
     /* 208583 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(208620), // Rule ID 10148 //
     /* 208588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 208596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 208605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208609 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2024:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 208609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 208612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208618 */     GIR_RootConstrainSelectedInstOperands,
     /* 208619 */     // GIR_Coverage, 10148,
     /* 208619 */     GIR_EraseRootFromParent_Done,
     /* 208620 */   // Label 3938: @208620
     /* 208620 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(208657), // Rule ID 10149 //
     /* 208625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 208633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 208642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2024:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 208646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 208649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208655 */     GIR_RootConstrainSelectedInstOperands,
     /* 208656 */     // GIR_Coverage, 10149,
     /* 208656 */     GIR_EraseRootFromParent_Done,
     /* 208657 */   // Label 3939: @208657
     /* 208657 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(208694), // Rule ID 10150 //
     /* 208662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 208670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 208679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208683 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1779:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 208683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 208686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208692 */     GIR_RootConstrainSelectedInstOperands,
     /* 208693 */     // GIR_Coverage, 10150,
     /* 208693 */     GIR_EraseRootFromParent_Done,
     /* 208694 */   // Label 3940: @208694
     /* 208694 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(208731), // Rule ID 10151 //
     /* 208699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 208707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 208716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208720 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1779:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 208720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 208723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208729 */     GIR_RootConstrainSelectedInstOperands,
     /* 208730 */     // GIR_Coverage, 10151,
     /* 208730 */     GIR_EraseRootFromParent_Done,
     /* 208731 */   // Label 3941: @208731
     /* 208731 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(208768), // Rule ID 10152 //
     /* 208736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 208744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 208753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208757 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1779:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 208757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 208760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208766 */     GIR_RootConstrainSelectedInstOperands,
     /* 208767 */     // GIR_Coverage, 10152,
     /* 208767 */     GIR_EraseRootFromParent_Done,
     /* 208768 */   // Label 3942: @208768
     /* 208768 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(208805), // Rule ID 10153 //
     /* 208773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 208781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 208790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2010:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 208794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 208797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208803 */     GIR_RootConstrainSelectedInstOperands,
     /* 208804 */     // GIR_Coverage, 10153,
     /* 208804 */     GIR_EraseRootFromParent_Done,
     /* 208805 */   // Label 3943: @208805
     /* 208805 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(208842), // Rule ID 10154 //
     /* 208810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 208818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 208827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208831 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2010:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 208831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 208834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208840 */     GIR_RootConstrainSelectedInstOperands,
     /* 208841 */     // GIR_Coverage, 10154,
     /* 208841 */     GIR_EraseRootFromParent_Done,
     /* 208842 */   // Label 3944: @208842
     /* 208842 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(208879), // Rule ID 10155 //
     /* 208847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 208855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 208864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2010:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 208868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 208871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208877 */     GIR_RootConstrainSelectedInstOperands,
     /* 208878 */     // GIR_Coverage, 10155,
     /* 208878 */     GIR_EraseRootFromParent_Done,
     /* 208879 */   // Label 3945: @208879
     /* 208879 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(208916), // Rule ID 11343 //
     /* 208884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 208892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 208895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208905 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2159:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 208908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208914 */     GIR_RootConstrainSelectedInstOperands,
     /* 208915 */     // GIR_Coverage, 11343,
     /* 208915 */     GIR_EraseRootFromParent_Done,
     /* 208916 */   // Label 3946: @208916
     /* 208916 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(208953), // Rule ID 11344 //
     /* 208921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 208929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208942 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2159:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 208945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208951 */     GIR_RootConstrainSelectedInstOperands,
     /* 208952 */     // GIR_Coverage, 11344,
     /* 208952 */     GIR_EraseRootFromParent_Done,
     /* 208953 */   // Label 3947: @208953
     /* 208953 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(208990), // Rule ID 11345 //
     /* 208958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 208966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208979 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2159:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 208979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 208982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208988 */     GIR_RootConstrainSelectedInstOperands,
     /* 208989 */     // GIR_Coverage, 11345,
     /* 208989 */     GIR_EraseRootFromParent_Done,
     /* 208990 */   // Label 3948: @208990
     /* 208990 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(209027), // Rule ID 11346 //
     /* 208995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 208998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 209003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209016 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2159:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 209019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209025 */     GIR_RootConstrainSelectedInstOperands,
     /* 209026 */     // GIR_Coverage, 11346,
     /* 209026 */     GIR_EraseRootFromParent_Done,
     /* 209027 */   // Label 3949: @209027
     /* 209027 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(209064), // Rule ID 11347 //
     /* 209032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 209040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209053 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2159:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 209053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 209056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209062 */     GIR_RootConstrainSelectedInstOperands,
     /* 209063 */     // GIR_Coverage, 11347,
     /* 209063 */     GIR_EraseRootFromParent_Done,
     /* 209064 */   // Label 3950: @209064
     /* 209064 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(209101), // Rule ID 11348 //
     /* 209069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 209077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209090 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2159:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 209093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209099 */     GIR_RootConstrainSelectedInstOperands,
     /* 209100 */     // GIR_Coverage, 11348,
     /* 209100 */     GIR_EraseRootFromParent_Done,
     /* 209101 */   // Label 3951: @209101
     /* 209101 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(209138), // Rule ID 11349 //
     /* 209106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 209114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209127 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2159:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 209127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 209130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209136 */     GIR_RootConstrainSelectedInstOperands,
     /* 209137 */     // GIR_Coverage, 11349,
     /* 209137 */     GIR_EraseRootFromParent_Done,
     /* 209138 */   // Label 3952: @209138
     /* 209138 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(209175), // Rule ID 11350 //
     /* 209143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 209151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209164 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2080:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 209167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209173 */     GIR_RootConstrainSelectedInstOperands,
     /* 209174 */     // GIR_Coverage, 11350,
     /* 209174 */     GIR_EraseRootFromParent_Done,
     /* 209175 */   // Label 3953: @209175
     /* 209175 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(209212), // Rule ID 11351 //
     /* 209180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 209188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209201 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2080:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 209204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209210 */     GIR_RootConstrainSelectedInstOperands,
     /* 209211 */     // GIR_Coverage, 11351,
     /* 209211 */     GIR_EraseRootFromParent_Done,
     /* 209212 */   // Label 3954: @209212
     /* 209212 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(209249), // Rule ID 11352 //
     /* 209217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 209225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209238 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2080:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 209238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 209241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209247 */     GIR_RootConstrainSelectedInstOperands,
     /* 209248 */     // GIR_Coverage, 11352,
     /* 209248 */     GIR_EraseRootFromParent_Done,
     /* 209249 */   // Label 3955: @209249
     /* 209249 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(209286), // Rule ID 11353 //
     /* 209254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 209262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209275 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2080:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 209278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209284 */     GIR_RootConstrainSelectedInstOperands,
     /* 209285 */     // GIR_Coverage, 11353,
     /* 209285 */     GIR_EraseRootFromParent_Done,
     /* 209286 */   // Label 3956: @209286
     /* 209286 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(209323), // Rule ID 11354 //
     /* 209291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 209299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209312 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2080:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 209312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 209315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209321 */     GIR_RootConstrainSelectedInstOperands,
     /* 209322 */     // GIR_Coverage, 11354,
     /* 209322 */     GIR_EraseRootFromParent_Done,
     /* 209323 */   // Label 3957: @209323
     /* 209323 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(209360), // Rule ID 11355 //
     /* 209328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 209336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209349 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2080:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 209352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209358 */     GIR_RootConstrainSelectedInstOperands,
     /* 209359 */     // GIR_Coverage, 11355,
     /* 209359 */     GIR_EraseRootFromParent_Done,
     /* 209360 */   // Label 3958: @209360
     /* 209360 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(209397), // Rule ID 11356 //
     /* 209365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 209373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209386 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2080:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 209386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 209389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209395 */     GIR_RootConstrainSelectedInstOperands,
     /* 209396 */     // GIR_Coverage, 11356,
     /* 209396 */     GIR_EraseRootFromParent_Done,
     /* 209397 */   // Label 3959: @209397
     /* 209397 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(209434), // Rule ID 11357 //
     /* 209402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 209410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209423 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2085:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 209426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209432 */     GIR_RootConstrainSelectedInstOperands,
     /* 209433 */     // GIR_Coverage, 11357,
     /* 209433 */     GIR_EraseRootFromParent_Done,
     /* 209434 */   // Label 3960: @209434
     /* 209434 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(209471), // Rule ID 11358 //
     /* 209439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 209447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209460 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2085:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 209463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209469 */     GIR_RootConstrainSelectedInstOperands,
     /* 209470 */     // GIR_Coverage, 11358,
     /* 209470 */     GIR_EraseRootFromParent_Done,
     /* 209471 */   // Label 3961: @209471
     /* 209471 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(209508), // Rule ID 11359 //
     /* 209476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 209484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209497 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2085:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 209497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 209500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209506 */     GIR_RootConstrainSelectedInstOperands,
     /* 209507 */     // GIR_Coverage, 11359,
     /* 209507 */     GIR_EraseRootFromParent_Done,
     /* 209508 */   // Label 3962: @209508
     /* 209508 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(209545), // Rule ID 11360 //
     /* 209513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 209521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209534 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2085:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 209537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209543 */     GIR_RootConstrainSelectedInstOperands,
     /* 209544 */     // GIR_Coverage, 11360,
     /* 209544 */     GIR_EraseRootFromParent_Done,
     /* 209545 */   // Label 3963: @209545
     /* 209545 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(209582), // Rule ID 11361 //
     /* 209550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 209558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209571 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2085:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 209571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 209574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209580 */     GIR_RootConstrainSelectedInstOperands,
     /* 209581 */     // GIR_Coverage, 11361,
     /* 209581 */     GIR_EraseRootFromParent_Done,
     /* 209582 */   // Label 3964: @209582
     /* 209582 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(209619), // Rule ID 11362 //
     /* 209587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 209595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209608 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2085:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 209611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209617 */     GIR_RootConstrainSelectedInstOperands,
     /* 209618 */     // GIR_Coverage, 11362,
     /* 209618 */     GIR_EraseRootFromParent_Done,
     /* 209619 */   // Label 3965: @209619
     /* 209619 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(209656), // Rule ID 11363 //
     /* 209624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 209632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209645 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2085:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 209645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 209648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209654 */     GIR_RootConstrainSelectedInstOperands,
     /* 209655 */     // GIR_Coverage, 11363,
     /* 209655 */     GIR_EraseRootFromParent_Done,
     /* 209656 */   // Label 3966: @209656
     /* 209656 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(209693), // Rule ID 11364 //
     /* 209661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 209669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209682 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1924:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 209685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209691 */     GIR_RootConstrainSelectedInstOperands,
     /* 209692 */     // GIR_Coverage, 11364,
     /* 209692 */     GIR_EraseRootFromParent_Done,
     /* 209693 */   // Label 3967: @209693
     /* 209693 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(209730), // Rule ID 11365 //
     /* 209698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 209706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209719 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1924:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 209722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209728 */     GIR_RootConstrainSelectedInstOperands,
     /* 209729 */     // GIR_Coverage, 11365,
     /* 209729 */     GIR_EraseRootFromParent_Done,
     /* 209730 */   // Label 3968: @209730
     /* 209730 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(209767), // Rule ID 11366 //
     /* 209735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 209743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209756 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1924:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 209756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 209759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209765 */     GIR_RootConstrainSelectedInstOperands,
     /* 209766 */     // GIR_Coverage, 11366,
     /* 209766 */     GIR_EraseRootFromParent_Done,
     /* 209767 */   // Label 3969: @209767
     /* 209767 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(209804), // Rule ID 11367 //
     /* 209772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 209780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1924:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 209796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209802 */     GIR_RootConstrainSelectedInstOperands,
     /* 209803 */     // GIR_Coverage, 11367,
     /* 209803 */     GIR_EraseRootFromParent_Done,
     /* 209804 */   // Label 3970: @209804
     /* 209804 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(209841), // Rule ID 11368 //
     /* 209809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 209817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209830 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1924:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 209830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 209833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209839 */     GIR_RootConstrainSelectedInstOperands,
     /* 209840 */     // GIR_Coverage, 11368,
     /* 209840 */     GIR_EraseRootFromParent_Done,
     /* 209841 */   // Label 3971: @209841
     /* 209841 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(209878), // Rule ID 11369 //
     /* 209846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 209854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209867 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1924:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 209867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 209870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209876 */     GIR_RootConstrainSelectedInstOperands,
     /* 209877 */     // GIR_Coverage, 11369,
     /* 209877 */     GIR_EraseRootFromParent_Done,
     /* 209878 */   // Label 3972: @209878
     /* 209878 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(209915), // Rule ID 11370 //
     /* 209883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 209891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209904 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1924:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 209904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 209907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209913 */     GIR_RootConstrainSelectedInstOperands,
     /* 209914 */     // GIR_Coverage, 11370,
     /* 209914 */     GIR_EraseRootFromParent_Done,
     /* 209915 */   // Label 3973: @209915
     /* 209915 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(209952), // Rule ID 11371 //
     /* 209920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 209928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209941 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1929:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 209944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209950 */     GIR_RootConstrainSelectedInstOperands,
     /* 209951 */     // GIR_Coverage, 11371,
     /* 209951 */     GIR_EraseRootFromParent_Done,
     /* 209952 */   // Label 3974: @209952
     /* 209952 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(209989), // Rule ID 11372 //
     /* 209957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 209965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1929:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 209981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209987 */     GIR_RootConstrainSelectedInstOperands,
     /* 209988 */     // GIR_Coverage, 11372,
     /* 209988 */     GIR_EraseRootFromParent_Done,
     /* 209989 */   // Label 3975: @209989
     /* 209989 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(210026), // Rule ID 11373 //
     /* 209994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 209997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 210002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210015 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1929:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 210015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 210018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210024 */     GIR_RootConstrainSelectedInstOperands,
     /* 210025 */     // GIR_Coverage, 11373,
     /* 210025 */     GIR_EraseRootFromParent_Done,
     /* 210026 */   // Label 3976: @210026
     /* 210026 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(210063), // Rule ID 11374 //
     /* 210031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 210034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 210039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1929:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 210055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210061 */     GIR_RootConstrainSelectedInstOperands,
     /* 210062 */     // GIR_Coverage, 11374,
     /* 210062 */     GIR_EraseRootFromParent_Done,
     /* 210063 */   // Label 3977: @210063
     /* 210063 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(210100), // Rule ID 11375 //
     /* 210068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 210071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 210076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210089 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1929:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 210089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 210092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210098 */     GIR_RootConstrainSelectedInstOperands,
     /* 210099 */     // GIR_Coverage, 11375,
     /* 210099 */     GIR_EraseRootFromParent_Done,
     /* 210100 */   // Label 3978: @210100
     /* 210100 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(210137), // Rule ID 11376 //
     /* 210105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 210108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 210113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210126 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1929:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 210129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210135 */     GIR_RootConstrainSelectedInstOperands,
     /* 210136 */     // GIR_Coverage, 11376,
     /* 210136 */     GIR_EraseRootFromParent_Done,
     /* 210137 */   // Label 3979: @210137
     /* 210137 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(210174), // Rule ID 11377 //
     /* 210142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 210145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 210150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210163 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1929:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 210163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 210166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210172 */     GIR_RootConstrainSelectedInstOperands,
     /* 210173 */     // GIR_Coverage, 11377,
     /* 210173 */     GIR_EraseRootFromParent_Done,
     /* 210174 */   // Label 3980: @210174
     /* 210174 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(210211), // Rule ID 11397 //
     /* 210179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 210187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210200 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1826:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 210203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210209 */     GIR_RootConstrainSelectedInstOperands,
     /* 210210 */     // GIR_Coverage, 11397,
     /* 210210 */     GIR_EraseRootFromParent_Done,
     /* 210211 */   // Label 3981: @210211
     /* 210211 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(210248), // Rule ID 11398 //
     /* 210216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 210224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210237 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1826:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 210240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210246 */     GIR_RootConstrainSelectedInstOperands,
     /* 210247 */     // GIR_Coverage, 11398,
     /* 210247 */     GIR_EraseRootFromParent_Done,
     /* 210248 */   // Label 3982: @210248
     /* 210248 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(210285), // Rule ID 11399 //
     /* 210253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 210261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 210277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210283 */     GIR_RootConstrainSelectedInstOperands,
     /* 210284 */     // GIR_Coverage, 11399,
     /* 210284 */     GIR_EraseRootFromParent_Done,
     /* 210285 */   // Label 3983: @210285
     /* 210285 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(210322), // Rule ID 11400 //
     /* 210290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 210298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210311 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1826:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 210314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210320 */     GIR_RootConstrainSelectedInstOperands,
     /* 210321 */     // GIR_Coverage, 11400,
     /* 210321 */     GIR_EraseRootFromParent_Done,
     /* 210322 */   // Label 3984: @210322
     /* 210322 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(210359), // Rule ID 11688 //
     /* 210327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 210335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1690:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 210351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210357 */     GIR_RootConstrainSelectedInstOperands,
     /* 210358 */     // GIR_Coverage, 11688,
     /* 210358 */     GIR_EraseRootFromParent_Done,
     /* 210359 */   // Label 3985: @210359
     /* 210359 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(210396), // Rule ID 11689 //
     /* 210364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 210372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210385 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1690:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 210388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210394 */     GIR_RootConstrainSelectedInstOperands,
     /* 210395 */     // GIR_Coverage, 11689,
     /* 210395 */     GIR_EraseRootFromParent_Done,
     /* 210396 */   // Label 3986: @210396
     /* 210396 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(210433), // Rule ID 11690 //
     /* 210401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 210409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210422 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1690:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 210425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210431 */     GIR_RootConstrainSelectedInstOperands,
     /* 210432 */     // GIR_Coverage, 11690,
     /* 210432 */     GIR_EraseRootFromParent_Done,
     /* 210433 */   // Label 3987: @210433
     /* 210433 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(210470), // Rule ID 11691 //
     /* 210438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 210446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210459 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1938:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 210462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210468 */     GIR_RootConstrainSelectedInstOperands,
     /* 210469 */     // GIR_Coverage, 11691,
     /* 210469 */     GIR_EraseRootFromParent_Done,
     /* 210470 */   // Label 3988: @210470
     /* 210470 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(210507), // Rule ID 11692 //
     /* 210475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 210483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210496 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1938:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 210499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210505 */     GIR_RootConstrainSelectedInstOperands,
     /* 210506 */     // GIR_Coverage, 11692,
     /* 210506 */     GIR_EraseRootFromParent_Done,
     /* 210507 */   // Label 3989: @210507
     /* 210507 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(210544), // Rule ID 11693 //
     /* 210512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 210520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210533 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1938:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 210536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210542 */     GIR_RootConstrainSelectedInstOperands,
     /* 210543 */     // GIR_Coverage, 11693,
     /* 210543 */     GIR_EraseRootFromParent_Done,
     /* 210544 */   // Label 3990: @210544
     /* 210544 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(210581), // Rule ID 11694 //
     /* 210549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 210557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210570 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1939:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 210573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210579 */     GIR_RootConstrainSelectedInstOperands,
     /* 210580 */     // GIR_Coverage, 11694,
     /* 210580 */     GIR_EraseRootFromParent_Done,
     /* 210581 */   // Label 3991: @210581
     /* 210581 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(210618), // Rule ID 11695 //
     /* 210586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 210594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210607 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1939:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 210610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210616 */     GIR_RootConstrainSelectedInstOperands,
     /* 210617 */     // GIR_Coverage, 11695,
     /* 210617 */     GIR_EraseRootFromParent_Done,
     /* 210618 */   // Label 3992: @210618
     /* 210618 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(210655), // Rule ID 11696 //
     /* 210623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 210631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210644 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1939:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 210647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210653 */     GIR_RootConstrainSelectedInstOperands,
     /* 210654 */     // GIR_Coverage, 11696,
     /* 210654 */     GIR_EraseRootFromParent_Done,
     /* 210655 */   // Label 3993: @210655
     /* 210655 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(210692), // Rule ID 11697 //
     /* 210660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 210668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210681 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1867:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 210684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210690 */     GIR_RootConstrainSelectedInstOperands,
     /* 210691 */     // GIR_Coverage, 11697,
     /* 210691 */     GIR_EraseRootFromParent_Done,
     /* 210692 */   // Label 3994: @210692
     /* 210692 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(210729), // Rule ID 11698 //
     /* 210697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 210705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1867:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 210721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210727 */     GIR_RootConstrainSelectedInstOperands,
     /* 210728 */     // GIR_Coverage, 11698,
     /* 210728 */     GIR_EraseRootFromParent_Done,
     /* 210729 */   // Label 3995: @210729
     /* 210729 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(210766), // Rule ID 11699 //
     /* 210734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 210742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210755 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1867:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 210758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210764 */     GIR_RootConstrainSelectedInstOperands,
     /* 210765 */     // GIR_Coverage, 11699,
     /* 210765 */     GIR_EraseRootFromParent_Done,
     /* 210766 */   // Label 3996: @210766
     /* 210766 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(210803), // Rule ID 11700 //
     /* 210771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 210779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210792 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1869:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 210795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210801 */     GIR_RootConstrainSelectedInstOperands,
     /* 210802 */     // GIR_Coverage, 11700,
     /* 210802 */     GIR_EraseRootFromParent_Done,
     /* 210803 */   // Label 3997: @210803
     /* 210803 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(210840), // Rule ID 11701 //
     /* 210808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 210816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210829 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1869:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 210832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210838 */     GIR_RootConstrainSelectedInstOperands,
     /* 210839 */     // GIR_Coverage, 11701,
     /* 210839 */     GIR_EraseRootFromParent_Done,
     /* 210840 */   // Label 3998: @210840
     /* 210840 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(210877), // Rule ID 11702 //
     /* 210845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 210853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210866 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1869:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 210869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210875 */     GIR_RootConstrainSelectedInstOperands,
     /* 210876 */     // GIR_Coverage, 11702,
     /* 210876 */     GIR_EraseRootFromParent_Done,
     /* 210877 */   // Label 3999: @210877
     /* 210877 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(210914), // Rule ID 11703 //
     /* 210882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 210890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210903 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2063:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 210906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210912 */     GIR_RootConstrainSelectedInstOperands,
     /* 210913 */     // GIR_Coverage, 11703,
     /* 210913 */     GIR_EraseRootFromParent_Done,
     /* 210914 */   // Label 4000: @210914
     /* 210914 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(210951), // Rule ID 11704 //
     /* 210919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 210927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2063:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 210943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210949 */     GIR_RootConstrainSelectedInstOperands,
     /* 210950 */     // GIR_Coverage, 11704,
     /* 210950 */     GIR_EraseRootFromParent_Done,
     /* 210951 */   // Label 4001: @210951
     /* 210951 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(210988), // Rule ID 11705 //
     /* 210956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 210964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210977 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2063:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 210980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210986 */     GIR_RootConstrainSelectedInstOperands,
     /* 210987 */     // GIR_Coverage, 11705,
     /* 210987 */     GIR_EraseRootFromParent_Done,
     /* 210988 */   // Label 4002: @210988
     /* 210988 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(211025), // Rule ID 11706 //
     /* 210993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 211001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2064:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 211017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211023 */     GIR_RootConstrainSelectedInstOperands,
     /* 211024 */     // GIR_Coverage, 11706,
     /* 211024 */     GIR_EraseRootFromParent_Done,
     /* 211025 */   // Label 4003: @211025
     /* 211025 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(211062), // Rule ID 11707 //
     /* 211030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 211038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211051 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2064:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 211054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211060 */     GIR_RootConstrainSelectedInstOperands,
     /* 211061 */     // GIR_Coverage, 11707,
     /* 211061 */     GIR_EraseRootFromParent_Done,
     /* 211062 */   // Label 4004: @211062
     /* 211062 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(211099), // Rule ID 11708 //
     /* 211067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 211075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211088 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2064:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 211091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211097 */     GIR_RootConstrainSelectedInstOperands,
     /* 211098 */     // GIR_Coverage, 11708,
     /* 211098 */     GIR_EraseRootFromParent_Done,
     /* 211099 */   // Label 4005: @211099
     /* 211099 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(211136), // Rule ID 11709 //
     /* 211104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 211112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211125 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1685:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 211128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211134 */     GIR_RootConstrainSelectedInstOperands,
     /* 211135 */     // GIR_Coverage, 11709,
     /* 211135 */     GIR_EraseRootFromParent_Done,
     /* 211136 */   // Label 4006: @211136
     /* 211136 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(211173), // Rule ID 11710 //
     /* 211141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 211149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1685:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 211165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211171 */     GIR_RootConstrainSelectedInstOperands,
     /* 211172 */     // GIR_Coverage, 11710,
     /* 211172 */     GIR_EraseRootFromParent_Done,
     /* 211173 */   // Label 4007: @211173
     /* 211173 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(211210), // Rule ID 11711 //
     /* 211178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 211186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211199 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1685:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 211202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211208 */     GIR_RootConstrainSelectedInstOperands,
     /* 211209 */     // GIR_Coverage, 11711,
     /* 211209 */     GIR_EraseRootFromParent_Done,
     /* 211210 */   // Label 4008: @211210
     /* 211210 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(211247), // Rule ID 11712 //
     /* 211215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 211223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211236 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1686:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 211239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211245 */     GIR_RootConstrainSelectedInstOperands,
     /* 211246 */     // GIR_Coverage, 11712,
     /* 211246 */     GIR_EraseRootFromParent_Done,
     /* 211247 */   // Label 4009: @211247
     /* 211247 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(211284), // Rule ID 11713 //
     /* 211252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 211260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211273 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1686:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 211276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211282 */     GIR_RootConstrainSelectedInstOperands,
     /* 211283 */     // GIR_Coverage, 11713,
     /* 211283 */     GIR_EraseRootFromParent_Done,
     /* 211284 */   // Label 4010: @211284
     /* 211284 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(211321), // Rule ID 11714 //
     /* 211289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 211297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211310 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1686:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 211313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211319 */     GIR_RootConstrainSelectedInstOperands,
     /* 211320 */     // GIR_Coverage, 11714,
     /* 211320 */     GIR_EraseRootFromParent_Done,
     /* 211321 */   // Label 4011: @211321
     /* 211321 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(211358), // Rule ID 11715 //
     /* 211326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 211334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211347 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1935:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 211350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211356 */     GIR_RootConstrainSelectedInstOperands,
     /* 211357 */     // GIR_Coverage, 11715,
     /* 211357 */     GIR_EraseRootFromParent_Done,
     /* 211358 */   // Label 4012: @211358
     /* 211358 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(211395), // Rule ID 11716 //
     /* 211363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 211371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211384 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1935:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 211387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211393 */     GIR_RootConstrainSelectedInstOperands,
     /* 211394 */     // GIR_Coverage, 11716,
     /* 211394 */     GIR_EraseRootFromParent_Done,
     /* 211395 */   // Label 4013: @211395
     /* 211395 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(211432), // Rule ID 11717 //
     /* 211400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 211408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211421 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1935:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 211424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211430 */     GIR_RootConstrainSelectedInstOperands,
     /* 211431 */     // GIR_Coverage, 11717,
     /* 211431 */     GIR_EraseRootFromParent_Done,
     /* 211432 */   // Label 4014: @211432
     /* 211432 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(211469), // Rule ID 11718 //
     /* 211437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 211445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211458 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1936:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 211461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211467 */     GIR_RootConstrainSelectedInstOperands,
     /* 211468 */     // GIR_Coverage, 11718,
     /* 211468 */     GIR_EraseRootFromParent_Done,
     /* 211469 */   // Label 4015: @211469
     /* 211469 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(211506), // Rule ID 11719 //
     /* 211474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 211482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211495 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1936:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 211498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211504 */     GIR_RootConstrainSelectedInstOperands,
     /* 211505 */     // GIR_Coverage, 11719,
     /* 211505 */     GIR_EraseRootFromParent_Done,
     /* 211506 */   // Label 4016: @211506
     /* 211506 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(211543), // Rule ID 11720 //
     /* 211511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 211519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211532 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1936:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 211535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211541 */     GIR_RootConstrainSelectedInstOperands,
     /* 211542 */     // GIR_Coverage, 11720,
     /* 211542 */     GIR_EraseRootFromParent_Done,
     /* 211543 */   // Label 4017: @211543
     /* 211543 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(211580), // Rule ID 11730 //
     /* 211548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 211556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211569 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1871:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 211572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211578 */     GIR_RootConstrainSelectedInstOperands,
     /* 211579 */     // GIR_Coverage, 11730,
     /* 211579 */     GIR_EraseRootFromParent_Done,
     /* 211580 */   // Label 4018: @211580
     /* 211580 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(211617), // Rule ID 11731 //
     /* 211585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 211593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211606 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1871:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 211609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211615 */     GIR_RootConstrainSelectedInstOperands,
     /* 211616 */     // GIR_Coverage, 11731,
     /* 211616 */     GIR_EraseRootFromParent_Done,
     /* 211617 */   // Label 4019: @211617
     /* 211617 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(211654), // Rule ID 11732 //
     /* 211622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 211630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211643 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1871:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 211646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211652 */     GIR_RootConstrainSelectedInstOperands,
     /* 211653 */     // GIR_Coverage, 11732,
     /* 211653 */     GIR_EraseRootFromParent_Done,
     /* 211654 */   // Label 4020: @211654
     /* 211654 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(211691), // Rule ID 11733 //
     /* 211659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 211667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211680 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1872:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 211683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211689 */     GIR_RootConstrainSelectedInstOperands,
     /* 211690 */     // GIR_Coverage, 11733,
     /* 211690 */     GIR_EraseRootFromParent_Done,
     /* 211691 */   // Label 4021: @211691
     /* 211691 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(211728), // Rule ID 11734 //
     /* 211696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 211704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211717 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1872:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 211720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211726 */     GIR_RootConstrainSelectedInstOperands,
     /* 211727 */     // GIR_Coverage, 11734,
     /* 211727 */     GIR_EraseRootFromParent_Done,
     /* 211728 */   // Label 4022: @211728
     /* 211728 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(211765), // Rule ID 11735 //
     /* 211733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 211741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211754 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1872:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 211757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211763 */     GIR_RootConstrainSelectedInstOperands,
     /* 211764 */     // GIR_Coverage, 11735,
     /* 211764 */     GIR_EraseRootFromParent_Done,
     /* 211765 */   // Label 4023: @211765
     /* 211765 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(211802), // Rule ID 11736 //
     /* 211770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 211778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211791 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2065:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 211794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211800 */     GIR_RootConstrainSelectedInstOperands,
     /* 211801 */     // GIR_Coverage, 11736,
     /* 211801 */     GIR_EraseRootFromParent_Done,
     /* 211802 */   // Label 4024: @211802
     /* 211802 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(211839), // Rule ID 11737 //
     /* 211807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 211815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211828 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2065:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 211831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211837 */     GIR_RootConstrainSelectedInstOperands,
     /* 211838 */     // GIR_Coverage, 11737,
     /* 211838 */     GIR_EraseRootFromParent_Done,
     /* 211839 */   // Label 4025: @211839
     /* 211839 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(211876), // Rule ID 11738 //
     /* 211844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 211852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211865 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2065:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 211868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211874 */     GIR_RootConstrainSelectedInstOperands,
     /* 211875 */     // GIR_Coverage, 11738,
     /* 211875 */     GIR_EraseRootFromParent_Done,
     /* 211876 */   // Label 4026: @211876
     /* 211876 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(211913), // Rule ID 11739 //
     /* 211881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 211889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211902 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2066:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 211905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211911 */     GIR_RootConstrainSelectedInstOperands,
     /* 211912 */     // GIR_Coverage, 11739,
     /* 211912 */     GIR_EraseRootFromParent_Done,
     /* 211913 */   // Label 4027: @211913
     /* 211913 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(211950), // Rule ID 11740 //
     /* 211918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 211926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211939 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2066:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 211942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211948 */     GIR_RootConstrainSelectedInstOperands,
     /* 211949 */     // GIR_Coverage, 11740,
     /* 211949 */     GIR_EraseRootFromParent_Done,
     /* 211950 */   // Label 4028: @211950
     /* 211950 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(211987), // Rule ID 11741 //
     /* 211955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 211963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2066:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 211979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211985 */     GIR_RootConstrainSelectedInstOperands,
     /* 211986 */     // GIR_Coverage, 11741,
     /* 211986 */     GIR_EraseRootFromParent_Done,
     /* 211987 */   // Label 4029: @211987
     /* 211987 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(212024), // Rule ID 11742 //
     /* 211992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 212000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212013 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1801:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 212016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212022 */     GIR_RootConstrainSelectedInstOperands,
     /* 212023 */     // GIR_Coverage, 11742,
     /* 212023 */     GIR_EraseRootFromParent_Done,
     /* 212024 */   // Label 4030: @212024
     /* 212024 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(212061), // Rule ID 11743 //
     /* 212029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 212037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212050 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1801:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 212053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212059 */     GIR_RootConstrainSelectedInstOperands,
     /* 212060 */     // GIR_Coverage, 11743,
     /* 212060 */     GIR_EraseRootFromParent_Done,
     /* 212061 */   // Label 4031: @212061
     /* 212061 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(212098), // Rule ID 11744 //
     /* 212066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 212074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212087 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1801:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 212090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212096 */     GIR_RootConstrainSelectedInstOperands,
     /* 212097 */     // GIR_Coverage, 11744,
     /* 212097 */     GIR_EraseRootFromParent_Done,
     /* 212098 */   // Label 4032: @212098
     /* 212098 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(212135), // Rule ID 11745 //
     /* 212103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 212111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1803:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 212127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212133 */     GIR_RootConstrainSelectedInstOperands,
     /* 212134 */     // GIR_Coverage, 11745,
     /* 212134 */     GIR_EraseRootFromParent_Done,
     /* 212135 */   // Label 4033: @212135
     /* 212135 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(212172), // Rule ID 11746 //
     /* 212140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 212148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212161 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1803:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 212164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212170 */     GIR_RootConstrainSelectedInstOperands,
     /* 212171 */     // GIR_Coverage, 11746,
     /* 212171 */     GIR_EraseRootFromParent_Done,
     /* 212172 */   // Label 4034: @212172
     /* 212172 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(212209), // Rule ID 11747 //
     /* 212177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 212185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212198 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1803:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 212201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212207 */     GIR_RootConstrainSelectedInstOperands,
     /* 212208 */     // GIR_Coverage, 11747,
     /* 212208 */     GIR_EraseRootFromParent_Done,
     /* 212209 */   // Label 4035: @212209
     /* 212209 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(212246), // Rule ID 11748 //
     /* 212214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 212222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212235 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1754:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 212238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212244 */     GIR_RootConstrainSelectedInstOperands,
     /* 212245 */     // GIR_Coverage, 11748,
     /* 212245 */     GIR_EraseRootFromParent_Done,
     /* 212246 */   // Label 4036: @212246
     /* 212246 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(212283), // Rule ID 11749 //
     /* 212251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 212259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212272 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1754:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 212275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212281 */     GIR_RootConstrainSelectedInstOperands,
     /* 212282 */     // GIR_Coverage, 11749,
     /* 212282 */     GIR_EraseRootFromParent_Done,
     /* 212283 */   // Label 4037: @212283
     /* 212283 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(212320), // Rule ID 11750 //
     /* 212288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 212296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212309 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1754:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 212312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212318 */     GIR_RootConstrainSelectedInstOperands,
     /* 212319 */     // GIR_Coverage, 11750,
     /* 212319 */     GIR_EraseRootFromParent_Done,
     /* 212320 */   // Label 4038: @212320
     /* 212320 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(212357), // Rule ID 11751 //
     /* 212325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 212333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1756:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 212349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212355 */     GIR_RootConstrainSelectedInstOperands,
     /* 212356 */     // GIR_Coverage, 11751,
     /* 212356 */     GIR_EraseRootFromParent_Done,
     /* 212357 */   // Label 4039: @212357
     /* 212357 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(212394), // Rule ID 11752 //
     /* 212362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 212370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212383 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 212386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212392 */     GIR_RootConstrainSelectedInstOperands,
     /* 212393 */     // GIR_Coverage, 11752,
     /* 212393 */     GIR_EraseRootFromParent_Done,
     /* 212394 */   // Label 4040: @212394
     /* 212394 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(212431), // Rule ID 11753 //
     /* 212399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 212407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212420 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 212423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212429 */     GIR_RootConstrainSelectedInstOperands,
     /* 212430 */     // GIR_Coverage, 11753,
     /* 212430 */     GIR_EraseRootFromParent_Done,
     /* 212431 */   // Label 4041: @212431
     /* 212431 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(212468), // Rule ID 11754 //
     /* 212436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 212444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212457 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1992:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 212460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212466 */     GIR_RootConstrainSelectedInstOperands,
     /* 212467 */     // GIR_Coverage, 11754,
     /* 212467 */     GIR_EraseRootFromParent_Done,
     /* 212468 */   // Label 4042: @212468
     /* 212468 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(212505), // Rule ID 11755 //
     /* 212473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 212481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212494 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1992:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 212497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212503 */     GIR_RootConstrainSelectedInstOperands,
     /* 212504 */     // GIR_Coverage, 11755,
     /* 212504 */     GIR_EraseRootFromParent_Done,
     /* 212505 */   // Label 4043: @212505
     /* 212505 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(212542), // Rule ID 11756 //
     /* 212510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 212518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212531 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1992:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 212534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212540 */     GIR_RootConstrainSelectedInstOperands,
     /* 212541 */     // GIR_Coverage, 11756,
     /* 212541 */     GIR_EraseRootFromParent_Done,
     /* 212542 */   // Label 4044: @212542
     /* 212542 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(212579), // Rule ID 11757 //
     /* 212547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 212555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212568 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1994:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 212571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212577 */     GIR_RootConstrainSelectedInstOperands,
     /* 212578 */     // GIR_Coverage, 11757,
     /* 212578 */     GIR_EraseRootFromParent_Done,
     /* 212579 */   // Label 4045: @212579
     /* 212579 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(212616), // Rule ID 11758 //
     /* 212584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 212592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212605 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1994:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 212608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212614 */     GIR_RootConstrainSelectedInstOperands,
     /* 212615 */     // GIR_Coverage, 11758,
     /* 212615 */     GIR_EraseRootFromParent_Done,
     /* 212616 */   // Label 4046: @212616
     /* 212616 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(212653), // Rule ID 11759 //
     /* 212621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 212629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212642 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1994:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 212645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212651 */     GIR_RootConstrainSelectedInstOperands,
     /* 212652 */     // GIR_Coverage, 11759,
     /* 212652 */     GIR_EraseRootFromParent_Done,
     /* 212653 */   // Label 4047: @212653
     /* 212653 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(212690), // Rule ID 11760 //
     /* 212658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 212666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212679 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1632:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 212682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212688 */     GIR_RootConstrainSelectedInstOperands,
     /* 212689 */     // GIR_Coverage, 11760,
     /* 212689 */     GIR_EraseRootFromParent_Done,
     /* 212690 */   // Label 4048: @212690
     /* 212690 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(212727), // Rule ID 11761 //
     /* 212695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 212703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212716 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1632:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 212719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212725 */     GIR_RootConstrainSelectedInstOperands,
     /* 212726 */     // GIR_Coverage, 11761,
     /* 212726 */     GIR_EraseRootFromParent_Done,
     /* 212727 */   // Label 4049: @212727
     /* 212727 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(212764), // Rule ID 11862 //
     /* 212732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 212740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212753 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1662:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 212756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212762 */     GIR_RootConstrainSelectedInstOperands,
     /* 212763 */     // GIR_Coverage, 11862,
     /* 212763 */     GIR_EraseRootFromParent_Done,
     /* 212764 */   // Label 4050: @212764
     /* 212764 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(212801), // Rule ID 11863 //
     /* 212769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 212777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212790 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1662:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 212793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212799 */     GIR_RootConstrainSelectedInstOperands,
     /* 212800 */     // GIR_Coverage, 11863,
     /* 212800 */     GIR_EraseRootFromParent_Done,
     /* 212801 */   // Label 4051: @212801
     /* 212801 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(212838), // Rule ID 11864 //
     /* 212806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 212814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1662:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 212830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212836 */     GIR_RootConstrainSelectedInstOperands,
     /* 212837 */     // GIR_Coverage, 11864,
     /* 212837 */     GIR_EraseRootFromParent_Done,
     /* 212838 */   // Label 4052: @212838
     /* 212838 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(212875), // Rule ID 11865 //
     /* 212843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 212851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212864 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1903:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 212867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212873 */     GIR_RootConstrainSelectedInstOperands,
     /* 212874 */     // GIR_Coverage, 11865,
     /* 212874 */     GIR_EraseRootFromParent_Done,
     /* 212875 */   // Label 4053: @212875
     /* 212875 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(212912), // Rule ID 11866 //
     /* 212880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 212888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212901 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1903:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 212904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212910 */     GIR_RootConstrainSelectedInstOperands,
     /* 212911 */     // GIR_Coverage, 11866,
     /* 212911 */     GIR_EraseRootFromParent_Done,
     /* 212912 */   // Label 4054: @212912
     /* 212912 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(212949), // Rule ID 11867 //
     /* 212917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 212925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212938 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1903:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 212941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212947 */     GIR_RootConstrainSelectedInstOperands,
     /* 212948 */     // GIR_Coverage, 11867,
     /* 212948 */     GIR_EraseRootFromParent_Done,
     /* 212949 */   // Label 4055: @212949
     /* 212949 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(212986), // Rule ID 11868 //
     /* 212954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 212962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212975 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1678:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 212978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212984 */     GIR_RootConstrainSelectedInstOperands,
     /* 212985 */     // GIR_Coverage, 11868,
     /* 212985 */     GIR_EraseRootFromParent_Done,
     /* 212986 */   // Label 4056: @212986
     /* 212986 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(213023), // Rule ID 11869 //
     /* 212991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 212999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213012 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1678:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 213015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213021 */     GIR_RootConstrainSelectedInstOperands,
     /* 213022 */     // GIR_Coverage, 11869,
     /* 213022 */     GIR_EraseRootFromParent_Done,
     /* 213023 */   // Label 4057: @213023
     /* 213023 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(213060), // Rule ID 11870 //
     /* 213028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 213036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213049 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1678:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 213052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213058 */     GIR_RootConstrainSelectedInstOperands,
     /* 213059 */     // GIR_Coverage, 11870,
     /* 213059 */     GIR_EraseRootFromParent_Done,
     /* 213060 */   // Label 4058: @213060
     /* 213060 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(213097), // Rule ID 11886 //
     /* 213065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 213073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213086 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2045:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 213089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213095 */     GIR_RootConstrainSelectedInstOperands,
     /* 213096 */     // GIR_Coverage, 11886,
     /* 213096 */     GIR_EraseRootFromParent_Done,
     /* 213097 */   // Label 4059: @213097
     /* 213097 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(213134), // Rule ID 11887 //
     /* 213102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 213110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213123 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2045:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 213126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213132 */     GIR_RootConstrainSelectedInstOperands,
     /* 213133 */     // GIR_Coverage, 11887,
     /* 213133 */     GIR_EraseRootFromParent_Done,
     /* 213134 */   // Label 4060: @213134
     /* 213134 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(213171), // Rule ID 11888 //
     /* 213139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 213147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2045:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 213163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213169 */     GIR_RootConstrainSelectedInstOperands,
     /* 213170 */     // GIR_Coverage, 11888,
     /* 213170 */     GIR_EraseRootFromParent_Done,
     /* 213171 */   // Label 4061: @213171
     /* 213171 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(213208), // Rule ID 11889 //
     /* 213176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 213184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213197 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1854:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 213200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213206 */     GIR_RootConstrainSelectedInstOperands,
     /* 213207 */     // GIR_Coverage, 11889,
     /* 213207 */     GIR_EraseRootFromParent_Done,
     /* 213208 */   // Label 4062: @213208
     /* 213208 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(213245), // Rule ID 11890 //
     /* 213213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 213221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213234 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1854:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 213237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213243 */     GIR_RootConstrainSelectedInstOperands,
     /* 213244 */     // GIR_Coverage, 11890,
     /* 213244 */     GIR_EraseRootFromParent_Done,
     /* 213245 */   // Label 4063: @213245
     /* 213245 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(213282), // Rule ID 11891 //
     /* 213250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 213258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1854:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 213274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213280 */     GIR_RootConstrainSelectedInstOperands,
     /* 213281 */     // GIR_Coverage, 11891,
     /* 213281 */     GIR_EraseRootFromParent_Done,
     /* 213282 */   // Label 4064: @213282
     /* 213282 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(213319), // Rule ID 11907 //
     /* 213287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 213295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1868:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 213311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213317 */     GIR_RootConstrainSelectedInstOperands,
     /* 213318 */     // GIR_Coverage, 11907,
     /* 213318 */     GIR_EraseRootFromParent_Done,
     /* 213319 */   // Label 4065: @213319
     /* 213319 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(213356), // Rule ID 11908 //
     /* 213324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 213332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213345 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1868:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 213348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213354 */     GIR_RootConstrainSelectedInstOperands,
     /* 213355 */     // GIR_Coverage, 11908,
     /* 213355 */     GIR_EraseRootFromParent_Done,
     /* 213356 */   // Label 4066: @213356
     /* 213356 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(213393), // Rule ID 11909 //
     /* 213361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 213369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213382 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1868:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 213385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213391 */     GIR_RootConstrainSelectedInstOperands,
     /* 213392 */     // GIR_Coverage, 11909,
     /* 213392 */     GIR_EraseRootFromParent_Done,
     /* 213393 */   // Label 4067: @213393
     /* 213393 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(213430), // Rule ID 11910 //
     /* 213398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 213406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213419 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1870:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 213422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213428 */     GIR_RootConstrainSelectedInstOperands,
     /* 213429 */     // GIR_Coverage, 11910,
     /* 213429 */     GIR_EraseRootFromParent_Done,
     /* 213430 */   // Label 4068: @213430
     /* 213430 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(213467), // Rule ID 11911 //
     /* 213435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 213443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213456 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1870:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 213459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213465 */     GIR_RootConstrainSelectedInstOperands,
     /* 213466 */     // GIR_Coverage, 11911,
     /* 213466 */     GIR_EraseRootFromParent_Done,
     /* 213467 */   // Label 4069: @213467
     /* 213467 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(213504), // Rule ID 11912 //
     /* 213472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 213480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213493 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1870:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 213496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213502 */     GIR_RootConstrainSelectedInstOperands,
     /* 213503 */     // GIR_Coverage, 11912,
     /* 213503 */     GIR_EraseRootFromParent_Done,
     /* 213504 */   // Label 4070: @213504
     /* 213504 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(213544), // Rule ID 11999 //
     /* 213509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 213517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 213520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213530 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 213533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213542 */     GIR_RootConstrainSelectedInstOperands,
     /* 213543 */     // GIR_Coverage, 11999,
     /* 213543 */     GIR_EraseRootFromParent_Done,
     /* 213544 */   // Label 4071: @213544
     /* 213544 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(213584), // Rule ID 12000 //
     /* 213549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 213557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 213560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213570 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 213573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213582 */     GIR_RootConstrainSelectedInstOperands,
     /* 213583 */     // GIR_Coverage, 12000,
     /* 213583 */     GIR_EraseRootFromParent_Done,
     /* 213584 */   // Label 4072: @213584
     /* 213584 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(213624), // Rule ID 12001 //
     /* 213589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 213597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 213600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213610 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 213613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213622 */     GIR_RootConstrainSelectedInstOperands,
     /* 213623 */     // GIR_Coverage, 12001,
     /* 213623 */     GIR_EraseRootFromParent_Done,
     /* 213624 */   // Label 4073: @213624
     /* 213624 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(213664), // Rule ID 12002 //
     /* 213629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 213637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 213640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213650 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2090:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 213653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213662 */     GIR_RootConstrainSelectedInstOperands,
     /* 213663 */     // GIR_Coverage, 12002,
     /* 213663 */     GIR_EraseRootFromParent_Done,
     /* 213664 */   // Label 4074: @213664
     /* 213664 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(213704), // Rule ID 12003 //
     /* 213669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 213677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 213680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213690 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 213693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213699 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213702 */     GIR_RootConstrainSelectedInstOperands,
     /* 213703 */     // GIR_Coverage, 12003,
     /* 213703 */     GIR_EraseRootFromParent_Done,
     /* 213704 */   // Label 4075: @213704
     /* 213704 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(213744), // Rule ID 12004 //
     /* 213709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 213717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 213720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213730 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 213733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213742 */     GIR_RootConstrainSelectedInstOperands,
     /* 213743 */     // GIR_Coverage, 12004,
     /* 213743 */     GIR_EraseRootFromParent_Done,
     /* 213744 */   // Label 4076: @213744
     /* 213744 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(213784), // Rule ID 12005 //
     /* 213749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 213757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 213760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213770 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 213773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213782 */     GIR_RootConstrainSelectedInstOperands,
     /* 213783 */     // GIR_Coverage, 12005,
     /* 213783 */     GIR_EraseRootFromParent_Done,
     /* 213784 */   // Label 4077: @213784
     /* 213784 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(213824), // Rule ID 12006 //
     /* 213789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 213797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 213800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213810 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2096:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 213813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213822 */     GIR_RootConstrainSelectedInstOperands,
     /* 213823 */     // GIR_Coverage, 12006,
     /* 213823 */     GIR_EraseRootFromParent_Done,
     /* 213824 */   // Label 4078: @213824
     /* 213824 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(213864), // Rule ID 12011 //
     /* 213829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 213837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 213840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213850 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 213853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213862 */     GIR_RootConstrainSelectedInstOperands,
     /* 213863 */     // GIR_Coverage, 12011,
     /* 213863 */     GIR_EraseRootFromParent_Done,
     /* 213864 */   // Label 4079: @213864
     /* 213864 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(213904), // Rule ID 12012 //
     /* 213869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 213877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 213880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213890 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 213893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213902 */     GIR_RootConstrainSelectedInstOperands,
     /* 213903 */     // GIR_Coverage, 12012,
     /* 213903 */     GIR_EraseRootFromParent_Done,
     /* 213904 */   // Label 4080: @213904
     /* 213904 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(213944), // Rule ID 12013 //
     /* 213909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 213917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 213920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213930 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 213933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213942 */     GIR_RootConstrainSelectedInstOperands,
     /* 213943 */     // GIR_Coverage, 12013,
     /* 213943 */     GIR_EraseRootFromParent_Done,
     /* 213944 */   // Label 4081: @213944
     /* 213944 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(213984), // Rule ID 12014 //
     /* 213949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 213957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 213960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 213963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 213966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 213970 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2108:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 213970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 213973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 213975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 213982 */     GIR_RootConstrainSelectedInstOperands,
     /* 213983 */     // GIR_Coverage, 12014,
     /* 213983 */     GIR_EraseRootFromParent_Done,
     /* 213984 */   // Label 4082: @213984
     /* 213984 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(214024), // Rule ID 12015 //
     /* 213989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 213997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 214000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 214003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214010 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 214010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 214013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214022 */     GIR_RootConstrainSelectedInstOperands,
     /* 214023 */     // GIR_Coverage, 12015,
     /* 214023 */     GIR_EraseRootFromParent_Done,
     /* 214024 */   // Label 4083: @214024
     /* 214024 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(214064), // Rule ID 12016 //
     /* 214029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 214037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 214040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 214043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214050 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 214050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 214053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214059 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214062 */     GIR_RootConstrainSelectedInstOperands,
     /* 214063 */     // GIR_Coverage, 12016,
     /* 214063 */     GIR_EraseRootFromParent_Done,
     /* 214064 */   // Label 4084: @214064
     /* 214064 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(214104), // Rule ID 12017 //
     /* 214069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 214077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 214080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 214083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214090 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 214090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 214093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214102 */     GIR_RootConstrainSelectedInstOperands,
     /* 214103 */     // GIR_Coverage, 12017,
     /* 214103 */     GIR_EraseRootFromParent_Done,
     /* 214104 */   // Label 4085: @214104
     /* 214104 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(214144), // Rule ID 12018 //
     /* 214109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 214117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 214120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 214123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 214126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214130 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2102:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 214130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 214133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214142 */     GIR_RootConstrainSelectedInstOperands,
     /* 214143 */     // GIR_Coverage, 12018,
     /* 214143 */     GIR_EraseRootFromParent_Done,
     /* 214144 */   // Label 4086: @214144
     /* 214144 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(214184), // Rule ID 12023 //
     /* 214149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 214157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 214160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214170 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 214173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214182 */     GIR_RootConstrainSelectedInstOperands,
     /* 214183 */     // GIR_Coverage, 12023,
     /* 214183 */     GIR_EraseRootFromParent_Done,
     /* 214184 */   // Label 4087: @214184
     /* 214184 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(214224), // Rule ID 12024 //
     /* 214189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 214197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 214200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214210 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 214213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214222 */     GIR_RootConstrainSelectedInstOperands,
     /* 214223 */     // GIR_Coverage, 12024,
     /* 214223 */     GIR_EraseRootFromParent_Done,
     /* 214224 */   // Label 4088: @214224
     /* 214224 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(214264), // Rule ID 12025 //
     /* 214229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 214237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 214240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214250 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 214253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214262 */     GIR_RootConstrainSelectedInstOperands,
     /* 214263 */     // GIR_Coverage, 12025,
     /* 214263 */     GIR_EraseRootFromParent_Done,
     /* 214264 */   // Label 4089: @214264
     /* 214264 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(214304), // Rule ID 12026 //
     /* 214269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 214277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 214280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214290 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2090:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 214293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214302 */     GIR_RootConstrainSelectedInstOperands,
     /* 214303 */     // GIR_Coverage, 12026,
     /* 214303 */     GIR_EraseRootFromParent_Done,
     /* 214304 */   // Label 4090: @214304
     /* 214304 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(214344), // Rule ID 12027 //
     /* 214309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 214317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 214320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214330 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 214333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214342 */     GIR_RootConstrainSelectedInstOperands,
     /* 214343 */     // GIR_Coverage, 12027,
     /* 214343 */     GIR_EraseRootFromParent_Done,
     /* 214344 */   // Label 4091: @214344
     /* 214344 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(214384), // Rule ID 12028 //
     /* 214349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 214357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 214360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214370 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 214373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214382 */     GIR_RootConstrainSelectedInstOperands,
     /* 214383 */     // GIR_Coverage, 12028,
     /* 214383 */     GIR_EraseRootFromParent_Done,
     /* 214384 */   // Label 4092: @214384
     /* 214384 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(214424), // Rule ID 12029 //
     /* 214389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 214397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 214400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214410 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 214413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214422 */     GIR_RootConstrainSelectedInstOperands,
     /* 214423 */     // GIR_Coverage, 12029,
     /* 214423 */     GIR_EraseRootFromParent_Done,
     /* 214424 */   // Label 4093: @214424
     /* 214424 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(214464), // Rule ID 12030 //
     /* 214429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 214437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 214440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214450 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2096:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 214453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214462 */     GIR_RootConstrainSelectedInstOperands,
     /* 214463 */     // GIR_Coverage, 12030,
     /* 214463 */     GIR_EraseRootFromParent_Done,
     /* 214464 */   // Label 4094: @214464
     /* 214464 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(214504), // Rule ID 12035 //
     /* 214469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 214477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 214480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214490 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 214493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214499 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214502 */     GIR_RootConstrainSelectedInstOperands,
     /* 214503 */     // GIR_Coverage, 12035,
     /* 214503 */     GIR_EraseRootFromParent_Done,
     /* 214504 */   // Label 4095: @214504
     /* 214504 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(214544), // Rule ID 12036 //
     /* 214509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 214517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 214520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214530 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 214533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214542 */     GIR_RootConstrainSelectedInstOperands,
     /* 214543 */     // GIR_Coverage, 12036,
     /* 214543 */     GIR_EraseRootFromParent_Done,
     /* 214544 */   // Label 4096: @214544
     /* 214544 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(214584), // Rule ID 12037 //
     /* 214549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 214557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 214560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214570 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 214573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214582 */     GIR_RootConstrainSelectedInstOperands,
     /* 214583 */     // GIR_Coverage, 12037,
     /* 214583 */     GIR_EraseRootFromParent_Done,
     /* 214584 */   // Label 4097: @214584
     /* 214584 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(214624), // Rule ID 12038 //
     /* 214589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 214597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 214600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214610 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2108:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 214613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214622 */     GIR_RootConstrainSelectedInstOperands,
     /* 214623 */     // GIR_Coverage, 12038,
     /* 214623 */     GIR_EraseRootFromParent_Done,
     /* 214624 */   // Label 4098: @214624
     /* 214624 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(214664), // Rule ID 12039 //
     /* 214629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 214637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 214640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214650 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 214653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214662 */     GIR_RootConstrainSelectedInstOperands,
     /* 214663 */     // GIR_Coverage, 12039,
     /* 214663 */     GIR_EraseRootFromParent_Done,
     /* 214664 */   // Label 4099: @214664
     /* 214664 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(214704), // Rule ID 12040 //
     /* 214669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 214677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 214680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214690 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 214693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214699 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214702 */     GIR_RootConstrainSelectedInstOperands,
     /* 214703 */     // GIR_Coverage, 12040,
     /* 214703 */     GIR_EraseRootFromParent_Done,
     /* 214704 */   // Label 4100: @214704
     /* 214704 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(214744), // Rule ID 12041 //
     /* 214709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 214717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 214720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214730 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 214733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214742 */     GIR_RootConstrainSelectedInstOperands,
     /* 214743 */     // GIR_Coverage, 12041,
     /* 214743 */     GIR_EraseRootFromParent_Done,
     /* 214744 */   // Label 4101: @214744
     /* 214744 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(214784), // Rule ID 12042 //
     /* 214749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 214757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 214760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 214763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 214766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 214770 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2102:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 214770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 214773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 214775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 214782 */     GIR_RootConstrainSelectedInstOperands,
     /* 214783 */     // GIR_Coverage, 12042,
     /* 214783 */     GIR_EraseRootFromParent_Done,
     /* 214784 */   // Label 4102: @214784
     /* 214784 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(214821), // Rule ID 12051 //
     /* 214789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 214792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 214797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214810 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1258:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 214813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 214815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214819 */     GIR_RootConstrainSelectedInstOperands,
     /* 214820 */     // GIR_Coverage, 12051,
     /* 214820 */     GIR_EraseRootFromParent_Done,
     /* 214821 */   // Label 4103: @214821
     /* 214821 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(214858), // Rule ID 12053 //
     /* 214826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 214829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 214834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214847 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1632:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 214850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214856 */     GIR_RootConstrainSelectedInstOperands,
     /* 214857 */     // GIR_Coverage, 12053,
     /* 214857 */     GIR_EraseRootFromParent_Done,
     /* 214858 */   // Label 4104: @214858
     /* 214858 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(214895), // Rule ID 12054 //
     /* 214863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 214866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 214871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214884 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1723:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 214887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 214889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214893 */     GIR_RootConstrainSelectedInstOperands,
     /* 214894 */     // GIR_Coverage, 12054,
     /* 214894 */     GIR_EraseRootFromParent_Done,
     /* 214895 */   // Label 4105: @214895
     /* 214895 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(214932), // Rule ID 12055 //
     /* 214900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 214903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 214908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214921 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1664:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 214924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214930 */     GIR_RootConstrainSelectedInstOperands,
     /* 214931 */     // GIR_Coverage, 12055,
     /* 214931 */     GIR_EraseRootFromParent_Done,
     /* 214932 */   // Label 4106: @214932
     /* 214932 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(214969), // Rule ID 12056 //
     /* 214937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 214940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 214945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214958 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1272:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 214961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214967 */     GIR_RootConstrainSelectedInstOperands,
     /* 214968 */     // GIR_Coverage, 12056,
     /* 214968 */     GIR_EraseRootFromParent_Done,
     /* 214969 */   // Label 4107: @214969
     /* 214969 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(215006), // Rule ID 12057 //
     /* 214974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 214977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 214982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214995 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1272:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 214998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215004 */     GIR_RootConstrainSelectedInstOperands,
     /* 215005 */     // GIR_Coverage, 12057,
     /* 215005 */     GIR_EraseRootFromParent_Done,
     /* 215006 */   // Label 4108: @215006
     /* 215006 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(215043), // Rule ID 12058 //
     /* 215011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 215014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 215019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1272:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 215035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215041 */     GIR_RootConstrainSelectedInstOperands,
     /* 215042 */     // GIR_Coverage, 12058,
     /* 215042 */     GIR_EraseRootFromParent_Done,
     /* 215043 */   // Label 4109: @215043
     /* 215043 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(215080), // Rule ID 12059 //
     /* 215048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 215051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 215056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215069 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1272:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 215072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215078 */     GIR_RootConstrainSelectedInstOperands,
     /* 215079 */     // GIR_Coverage, 12059,
     /* 215079 */     GIR_EraseRootFromParent_Done,
     /* 215080 */   // Label 4110: @215080
     /* 215080 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(215117), // Rule ID 12060 //
     /* 215085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 215088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 215093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 215096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 215099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215106 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1289:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 215109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215115 */     GIR_RootConstrainSelectedInstOperands,
     /* 215116 */     // GIR_Coverage, 12060,
     /* 215116 */     GIR_EraseRootFromParent_Done,
     /* 215117 */   // Label 4111: @215117
     /* 215117 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(215154), // Rule ID 12061 //
     /* 215122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 215125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 215130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 215133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 215136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215143 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1289:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 215146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215152 */     GIR_RootConstrainSelectedInstOperands,
     /* 215153 */     // GIR_Coverage, 12061,
     /* 215153 */     GIR_EraseRootFromParent_Done,
     /* 215154 */   // Label 4112: @215154
     /* 215154 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(215191), // Rule ID 12062 //
     /* 215159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 215162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 215167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215180 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1289:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 215183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215189 */     GIR_RootConstrainSelectedInstOperands,
     /* 215190 */     // GIR_Coverage, 12062,
     /* 215190 */     GIR_EraseRootFromParent_Done,
     /* 215191 */   // Label 4113: @215191
     /* 215191 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(215228), // Rule ID 12063 //
     /* 215196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 215199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 215204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215217 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1289:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 215220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215226 */     GIR_RootConstrainSelectedInstOperands,
     /* 215227 */     // GIR_Coverage, 12063,
     /* 215227 */     GIR_EraseRootFromParent_Done,
     /* 215228 */   // Label 4114: @215228
     /* 215228 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(215265), // Rule ID 12176 //
     /* 215233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 215241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215254 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1438:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 215254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 215257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215263 */     GIR_RootConstrainSelectedInstOperands,
     /* 215264 */     // GIR_Coverage, 12176,
     /* 215264 */     GIR_EraseRootFromParent_Done,
     /* 215265 */   // Label 4115: @215265
     /* 215265 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(215302), // Rule ID 12177 //
     /* 215270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 215278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215291 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1438:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 215291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 215294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215300 */     GIR_RootConstrainSelectedInstOperands,
     /* 215301 */     // GIR_Coverage, 12177,
     /* 215301 */     GIR_EraseRootFromParent_Done,
     /* 215302 */   // Label 4116: @215302
     /* 215302 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(215339), // Rule ID 12178 //
     /* 215307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 215315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215328 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1438:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 215328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 215331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215337 */     GIR_RootConstrainSelectedInstOperands,
     /* 215338 */     // GIR_Coverage, 12178,
     /* 215338 */     GIR_EraseRootFromParent_Done,
     /* 215339 */   // Label 4117: @215339
     /* 215339 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(215376), // Rule ID 12179 //
     /* 215344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 215352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215365 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1456:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 215365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 215368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215374 */     GIR_RootConstrainSelectedInstOperands,
     /* 215375 */     // GIR_Coverage, 12179,
     /* 215375 */     GIR_EraseRootFromParent_Done,
     /* 215376 */   // Label 4118: @215376
     /* 215376 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(215413), // Rule ID 12180 //
     /* 215381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 215389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215402 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1456:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 215402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 215405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215411 */     GIR_RootConstrainSelectedInstOperands,
     /* 215412 */     // GIR_Coverage, 12180,
     /* 215412 */     GIR_EraseRootFromParent_Done,
     /* 215413 */   // Label 4119: @215413
     /* 215413 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(215450), // Rule ID 12181 //
     /* 215418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 215426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215439 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1456:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 215439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 215442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215448 */     GIR_RootConstrainSelectedInstOperands,
     /* 215449 */     // GIR_Coverage, 12181,
     /* 215449 */     GIR_EraseRootFromParent_Done,
     /* 215450 */   // Label 4120: @215450
     /* 215450 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(215487), // Rule ID 12182 //
     /* 215455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 215463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215476 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1441:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 215476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 215479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215485 */     GIR_RootConstrainSelectedInstOperands,
     /* 215486 */     // GIR_Coverage, 12182,
     /* 215486 */     GIR_EraseRootFromParent_Done,
     /* 215487 */   // Label 4121: @215487
     /* 215487 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(215524), // Rule ID 12183 //
     /* 215492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 215500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215513 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1441:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 215513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 215516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215522 */     GIR_RootConstrainSelectedInstOperands,
     /* 215523 */     // GIR_Coverage, 12183,
     /* 215523 */     GIR_EraseRootFromParent_Done,
     /* 215524 */   // Label 4122: @215524
     /* 215524 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(215561), // Rule ID 12184 //
     /* 215529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 215537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215550 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1441:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 215550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 215553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215559 */     GIR_RootConstrainSelectedInstOperands,
     /* 215560 */     // GIR_Coverage, 12184,
     /* 215560 */     GIR_EraseRootFromParent_Done,
     /* 215561 */   // Label 4123: @215561
     /* 215561 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(215598), // Rule ID 12185 //
     /* 215566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 215574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215587 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1459:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 215587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 215590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215596 */     GIR_RootConstrainSelectedInstOperands,
     /* 215597 */     // GIR_Coverage, 12185,
     /* 215597 */     GIR_EraseRootFromParent_Done,
     /* 215598 */   // Label 4124: @215598
     /* 215598 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(215635), // Rule ID 12186 //
     /* 215603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 215611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215624 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1459:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 215624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 215627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215633 */     GIR_RootConstrainSelectedInstOperands,
     /* 215634 */     // GIR_Coverage, 12186,
     /* 215634 */     GIR_EraseRootFromParent_Done,
     /* 215635 */   // Label 4125: @215635
     /* 215635 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(215672), // Rule ID 12187 //
     /* 215640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 215648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215661 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1459:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 215661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 215664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215670 */     GIR_RootConstrainSelectedInstOperands,
     /* 215671 */     // GIR_Coverage, 12187,
     /* 215671 */     GIR_EraseRootFromParent_Done,
     /* 215672 */   // Label 4126: @215672
     /* 215672 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(215709), // Rule ID 12188 //
     /* 215677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 215685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215698 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1353:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 215701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215707 */     GIR_RootConstrainSelectedInstOperands,
     /* 215708 */     // GIR_Coverage, 12188,
     /* 215708 */     GIR_EraseRootFromParent_Done,
     /* 215709 */   // Label 4127: @215709
     /* 215709 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(215746), // Rule ID 12189 //
     /* 215714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 215722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215735 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1353:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 215738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215744 */     GIR_RootConstrainSelectedInstOperands,
     /* 215745 */     // GIR_Coverage, 12189,
     /* 215745 */     GIR_EraseRootFromParent_Done,
     /* 215746 */   // Label 4128: @215746
     /* 215746 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(215783), // Rule ID 12190 //
     /* 215751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 215759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215772 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1353:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 215775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215781 */     GIR_RootConstrainSelectedInstOperands,
     /* 215782 */     // GIR_Coverage, 12190,
     /* 215782 */     GIR_EraseRootFromParent_Done,
     /* 215783 */   // Label 4129: @215783
     /* 215783 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(215820), // Rule ID 12191 //
     /* 215788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 215796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215809 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1353:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 215812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215818 */     GIR_RootConstrainSelectedInstOperands,
     /* 215819 */     // GIR_Coverage, 12191,
     /* 215819 */     GIR_EraseRootFromParent_Done,
     /* 215820 */   // Label 4130: @215820
     /* 215820 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(215857), // Rule ID 12192 //
     /* 215825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 215833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215846 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1265:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 215849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215855 */     GIR_RootConstrainSelectedInstOperands,
     /* 215856 */     // GIR_Coverage, 12192,
     /* 215856 */     GIR_EraseRootFromParent_Done,
     /* 215857 */   // Label 4131: @215857
     /* 215857 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(215894), // Rule ID 12193 //
     /* 215862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 215870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 215876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 215879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215883 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1265:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 215883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 215886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215892 */     GIR_RootConstrainSelectedInstOperands,
     /* 215893 */     // GIR_Coverage, 12193,
     /* 215893 */     GIR_EraseRootFromParent_Done,
     /* 215894 */   // Label 4132: @215894
     /* 215894 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(215931), // Rule ID 12194 //
     /* 215899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 215907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 215913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215920 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1265:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 215920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 215923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215929 */     GIR_RootConstrainSelectedInstOperands,
     /* 215930 */     // GIR_Coverage, 12194,
     /* 215930 */     GIR_EraseRootFromParent_Done,
     /* 215931 */   // Label 4133: @215931
     /* 215931 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(215968), // Rule ID 12195 //
     /* 215936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 215944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 215950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215957 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1265:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 215957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 215960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215966 */     GIR_RootConstrainSelectedInstOperands,
     /* 215967 */     // GIR_Coverage, 12195,
     /* 215967 */     GIR_EraseRootFromParent_Done,
     /* 215968 */   // Label 4134: @215968
     /* 215968 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(216005), // Rule ID 12196 //
     /* 215973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 215981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 215984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 215990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215994 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1253:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 215994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 215997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 215999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216003 */     GIR_RootConstrainSelectedInstOperands,
     /* 216004 */     // GIR_Coverage, 12196,
     /* 216004 */     GIR_EraseRootFromParent_Done,
     /* 216005 */   // Label 4135: @216005
     /* 216005 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(216042), // Rule ID 12197 //
     /* 216010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 216018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216031 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1253:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 216031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 216034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216040 */     GIR_RootConstrainSelectedInstOperands,
     /* 216041 */     // GIR_Coverage, 12197,
     /* 216041 */     GIR_EraseRootFromParent_Done,
     /* 216042 */   // Label 4136: @216042
     /* 216042 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(216079), // Rule ID 12198 //
     /* 216047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 216055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216068 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1253:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 216068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 216071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216077 */     GIR_RootConstrainSelectedInstOperands,
     /* 216078 */     // GIR_Coverage, 12198,
     /* 216078 */     GIR_EraseRootFromParent_Done,
     /* 216079 */   // Label 4137: @216079
     /* 216079 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(216116), // Rule ID 12199 //
     /* 216084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 216092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216105 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1253:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 216105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 216108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216114 */     GIR_RootConstrainSelectedInstOperands,
     /* 216115 */     // GIR_Coverage, 12199,
     /* 216115 */     GIR_EraseRootFromParent_Done,
     /* 216116 */   // Label 4138: @216116
     /* 216116 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(216153), // Rule ID 12200 //
     /* 216121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 216129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216142 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1732:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 216142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 216145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216151 */     GIR_RootConstrainSelectedInstOperands,
     /* 216152 */     // GIR_Coverage, 12200,
     /* 216152 */     GIR_EraseRootFromParent_Done,
     /* 216153 */   // Label 4139: @216153
     /* 216153 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(216190), // Rule ID 12201 //
     /* 216158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 216166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216179 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1732:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 216179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 216182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216188 */     GIR_RootConstrainSelectedInstOperands,
     /* 216189 */     // GIR_Coverage, 12201,
     /* 216189 */     GIR_EraseRootFromParent_Done,
     /* 216190 */   // Label 4140: @216190
     /* 216190 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(216227), // Rule ID 12202 //
     /* 216195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 216203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216216 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1732:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 216216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 216219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216225 */     GIR_RootConstrainSelectedInstOperands,
     /* 216226 */     // GIR_Coverage, 12202,
     /* 216226 */     GIR_EraseRootFromParent_Done,
     /* 216227 */   // Label 4141: @216227
     /* 216227 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(216264), // Rule ID 12203 //
     /* 216232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 216240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216253 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1732:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 216253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 216256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216262 */     GIR_RootConstrainSelectedInstOperands,
     /* 216263 */     // GIR_Coverage, 12203,
     /* 216263 */     GIR_EraseRootFromParent_Done,
     /* 216264 */   // Label 4142: @216264
     /* 216264 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(216301), // Rule ID 12204 //
     /* 216269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 216277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216290 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1970:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 216290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 216293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216299 */     GIR_RootConstrainSelectedInstOperands,
     /* 216300 */     // GIR_Coverage, 12204,
     /* 216300 */     GIR_EraseRootFromParent_Done,
     /* 216301 */   // Label 4143: @216301
     /* 216301 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(216338), // Rule ID 12205 //
     /* 216306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 216314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216327 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1970:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 216327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 216330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216336 */     GIR_RootConstrainSelectedInstOperands,
     /* 216337 */     // GIR_Coverage, 12205,
     /* 216337 */     GIR_EraseRootFromParent_Done,
     /* 216338 */   // Label 4144: @216338
     /* 216338 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(216375), // Rule ID 12206 //
     /* 216343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 216351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216364 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1970:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 216364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 216367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216373 */     GIR_RootConstrainSelectedInstOperands,
     /* 216374 */     // GIR_Coverage, 12206,
     /* 216374 */     GIR_EraseRootFromParent_Done,
     /* 216375 */   // Label 4145: @216375
     /* 216375 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(216412), // Rule ID 12207 //
     /* 216380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 216388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216401 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1970:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 216401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 216404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216410 */     GIR_RootConstrainSelectedInstOperands,
     /* 216411 */     // GIR_Coverage, 12207,
     /* 216411 */     GIR_EraseRootFromParent_Done,
     /* 216412 */   // Label 4146: @216412
     /* 216412 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(216449), // Rule ID 12208 //
     /* 216417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 216425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216438 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1741:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 216438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 216441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216447 */     GIR_RootConstrainSelectedInstOperands,
     /* 216448 */     // GIR_Coverage, 12208,
     /* 216448 */     GIR_EraseRootFromParent_Done,
     /* 216449 */   // Label 4147: @216449
     /* 216449 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(216486), // Rule ID 12209 //
     /* 216454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 216462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216475 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1741:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 216475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 216478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216484 */     GIR_RootConstrainSelectedInstOperands,
     /* 216485 */     // GIR_Coverage, 12209,
     /* 216485 */     GIR_EraseRootFromParent_Done,
     /* 216486 */   // Label 4148: @216486
     /* 216486 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(216523), // Rule ID 12210 //
     /* 216491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 216499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216512 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1741:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 216512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 216515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216521 */     GIR_RootConstrainSelectedInstOperands,
     /* 216522 */     // GIR_Coverage, 12210,
     /* 216522 */     GIR_EraseRootFromParent_Done,
     /* 216523 */   // Label 4149: @216523
     /* 216523 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(216560), // Rule ID 12211 //
     /* 216528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 216536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216549 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1741:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 216549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 216552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216558 */     GIR_RootConstrainSelectedInstOperands,
     /* 216559 */     // GIR_Coverage, 12211,
     /* 216559 */     GIR_EraseRootFromParent_Done,
     /* 216560 */   // Label 4150: @216560
     /* 216560 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(216597), // Rule ID 12212 //
     /* 216565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 216573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 216579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216586 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1979:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 216586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 216589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216595 */     GIR_RootConstrainSelectedInstOperands,
     /* 216596 */     // GIR_Coverage, 12212,
     /* 216596 */     GIR_EraseRootFromParent_Done,
     /* 216597 */   // Label 4151: @216597
     /* 216597 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(216634), // Rule ID 12213 //
     /* 216602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 216610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 216616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216623 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1979:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 216623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 216626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216632 */     GIR_RootConstrainSelectedInstOperands,
     /* 216633 */     // GIR_Coverage, 12213,
     /* 216633 */     GIR_EraseRootFromParent_Done,
     /* 216634 */   // Label 4152: @216634
     /* 216634 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(216671), // Rule ID 12214 //
     /* 216639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 216647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 216653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216660 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1979:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 216660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 216663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216669 */     GIR_RootConstrainSelectedInstOperands,
     /* 216670 */     // GIR_Coverage, 12214,
     /* 216670 */     GIR_EraseRootFromParent_Done,
     /* 216671 */   // Label 4153: @216671
     /* 216671 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(216708), // Rule ID 12215 //
     /* 216676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 216684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 216690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216697 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1979:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 216697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 216700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216706 */     GIR_RootConstrainSelectedInstOperands,
     /* 216707 */     // GIR_Coverage, 12215,
     /* 216707 */     GIR_EraseRootFromParent_Done,
     /* 216708 */   // Label 4154: @216708
     /* 216708 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(216745), // Rule ID 12216 //
     /* 216713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 216721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 216727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216734 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2163:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 216734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 216737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216743 */     GIR_RootConstrainSelectedInstOperands,
     /* 216744 */     // GIR_Coverage, 12216,
     /* 216744 */     GIR_EraseRootFromParent_Done,
     /* 216745 */   // Label 4155: @216745
     /* 216745 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(216782), // Rule ID 12217 //
     /* 216750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 216758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 216764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216771 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2163:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 216771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 216774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216780 */     GIR_RootConstrainSelectedInstOperands,
     /* 216781 */     // GIR_Coverage, 12217,
     /* 216781 */     GIR_EraseRootFromParent_Done,
     /* 216782 */   // Label 4156: @216782
     /* 216782 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(216819), // Rule ID 12218 //
     /* 216787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 216795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216808 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2163:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 216808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 216811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216817 */     GIR_RootConstrainSelectedInstOperands,
     /* 216818 */     // GIR_Coverage, 12218,
     /* 216818 */     GIR_EraseRootFromParent_Done,
     /* 216819 */   // Label 4157: @216819
     /* 216819 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(216856), // Rule ID 12219 //
     /* 216824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 216832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216845 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2163:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 216845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 216848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216854 */     GIR_RootConstrainSelectedInstOperands,
     /* 216855 */     // GIR_Coverage, 12219,
     /* 216855 */     GIR_EraseRootFromParent_Done,
     /* 216856 */   // Label 4158: @216856
     /* 216856 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(216893), // Rule ID 12220 //
     /* 216861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 216869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 216872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 216875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 216878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216882 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2163:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 216882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 216885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216891 */     GIR_RootConstrainSelectedInstOperands,
     /* 216892 */     // GIR_Coverage, 12220,
     /* 216892 */     GIR_EraseRootFromParent_Done,
     /* 216893 */   // Label 4159: @216893
     /* 216893 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(216930), // Rule ID 12221 //
     /* 216898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 216906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 216909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 216912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 216915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216919 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2163:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 216919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 216922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216928 */     GIR_RootConstrainSelectedInstOperands,
     /* 216929 */     // GIR_Coverage, 12221,
     /* 216929 */     GIR_EraseRootFromParent_Done,
     /* 216930 */   // Label 4160: @216930
     /* 216930 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(216967), // Rule ID 12222 //
     /* 216935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 216943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 216946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 216949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 216952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216956 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2163:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 216956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 216959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 216963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 216965 */     GIR_RootConstrainSelectedInstOperands,
     /* 216966 */     // GIR_Coverage, 12222,
     /* 216966 */     GIR_EraseRootFromParent_Done,
     /* 216967 */   // Label 4161: @216967
     /* 216967 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(217004), // Rule ID 12223 //
     /* 216972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 216975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 216980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 216983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 216986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 216989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 216993 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2088:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 216993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 216996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 216998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217002 */     GIR_RootConstrainSelectedInstOperands,
     /* 217003 */     // GIR_Coverage, 12223,
     /* 217003 */     GIR_EraseRootFromParent_Done,
     /* 217004 */   // Label 4162: @217004
     /* 217004 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(217041), // Rule ID 12224 //
     /* 217009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 217017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217030 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2088:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 217030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 217033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217039 */     GIR_RootConstrainSelectedInstOperands,
     /* 217040 */     // GIR_Coverage, 12224,
     /* 217040 */     GIR_EraseRootFromParent_Done,
     /* 217041 */   // Label 4163: @217041
     /* 217041 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(217078), // Rule ID 12225 //
     /* 217046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 217054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217067 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2088:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 217067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 217070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217076 */     GIR_RootConstrainSelectedInstOperands,
     /* 217077 */     // GIR_Coverage, 12225,
     /* 217077 */     GIR_EraseRootFromParent_Done,
     /* 217078 */   // Label 4164: @217078
     /* 217078 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(217115), // Rule ID 12226 //
     /* 217083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 217091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2088:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 217104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 217107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217113 */     GIR_RootConstrainSelectedInstOperands,
     /* 217114 */     // GIR_Coverage, 12226,
     /* 217114 */     GIR_EraseRootFromParent_Done,
     /* 217115 */   // Label 4165: @217115
     /* 217115 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(217152), // Rule ID 12227 //
     /* 217120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 217128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217141 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2088:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 217141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 217144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217150 */     GIR_RootConstrainSelectedInstOperands,
     /* 217151 */     // GIR_Coverage, 12227,
     /* 217151 */     GIR_EraseRootFromParent_Done,
     /* 217152 */   // Label 4166: @217152
     /* 217152 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(217189), // Rule ID 12228 //
     /* 217157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 217165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217178 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2088:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 217178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 217181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217187 */     GIR_RootConstrainSelectedInstOperands,
     /* 217188 */     // GIR_Coverage, 12228,
     /* 217188 */     GIR_EraseRootFromParent_Done,
     /* 217189 */   // Label 4167: @217189
     /* 217189 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(217226), // Rule ID 12229 //
     /* 217194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 217202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217215 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2088:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 217215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 217218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217224 */     GIR_RootConstrainSelectedInstOperands,
     /* 217225 */     // GIR_Coverage, 12229,
     /* 217225 */     GIR_EraseRootFromParent_Done,
     /* 217226 */   // Label 4168: @217226
     /* 217226 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(217263), // Rule ID 12230 //
     /* 217231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 217239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 217242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 217245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 217248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217252 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2089:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 217252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 217255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217261 */     GIR_RootConstrainSelectedInstOperands,
     /* 217262 */     // GIR_Coverage, 12230,
     /* 217262 */     GIR_EraseRootFromParent_Done,
     /* 217263 */   // Label 4169: @217263
     /* 217263 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(217300), // Rule ID 12231 //
     /* 217268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 217276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217289 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2089:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 217289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 217292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217298 */     GIR_RootConstrainSelectedInstOperands,
     /* 217299 */     // GIR_Coverage, 12231,
     /* 217299 */     GIR_EraseRootFromParent_Done,
     /* 217300 */   // Label 4170: @217300
     /* 217300 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(217337), // Rule ID 12232 //
     /* 217305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 217313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217326 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2089:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 217326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 217329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217335 */     GIR_RootConstrainSelectedInstOperands,
     /* 217336 */     // GIR_Coverage, 12232,
     /* 217336 */     GIR_EraseRootFromParent_Done,
     /* 217337 */   // Label 4171: @217337
     /* 217337 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(217374), // Rule ID 12233 //
     /* 217342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 217350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217363 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2089:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 217363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 217366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217372 */     GIR_RootConstrainSelectedInstOperands,
     /* 217373 */     // GIR_Coverage, 12233,
     /* 217373 */     GIR_EraseRootFromParent_Done,
     /* 217374 */   // Label 4172: @217374
     /* 217374 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(217411), // Rule ID 12234 //
     /* 217379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 217387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 217396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217400 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2089:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 217400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 217403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217409 */     GIR_RootConstrainSelectedInstOperands,
     /* 217410 */     // GIR_Coverage, 12234,
     /* 217410 */     GIR_EraseRootFromParent_Done,
     /* 217411 */   // Label 4173: @217411
     /* 217411 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(217448), // Rule ID 12235 //
     /* 217416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 217424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 217427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 217430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 217433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217437 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2089:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 217437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 217440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217446 */     GIR_RootConstrainSelectedInstOperands,
     /* 217447 */     // GIR_Coverage, 12235,
     /* 217447 */     GIR_EraseRootFromParent_Done,
     /* 217448 */   // Label 4174: @217448
     /* 217448 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(217485), // Rule ID 12236 //
     /* 217453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 217456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 217461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 217464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 217467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 217470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217474 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2089:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 217474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 217477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 217479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217483 */     GIR_RootConstrainSelectedInstOperands,
     /* 217484 */     // GIR_Coverage, 12236,
     /* 217484 */     GIR_EraseRootFromParent_Done,
     /* 217485 */   // Label 4175: @217485
     /* 217485 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(217527), // Rule ID 3218 //
     /* 217490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 217498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 217501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217505 */     // MIs[0] Op1
     /* 217505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 217509 */     // MIs[0] Op2
     /* 217509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 217513 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2142:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 217513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 217516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217525 */     GIR_RootConstrainSelectedInstOperands,
     /* 217526 */     // GIR_Coverage, 3218,
     /* 217526 */     GIR_EraseRootFromParent_Done,
     /* 217527 */   // Label 4176: @217527
     /* 217527 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(217569), // Rule ID 3219 //
     /* 217532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 217540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 217543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217547 */     // MIs[0] Op1
     /* 217547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 217551 */     // MIs[0] Op2
     /* 217551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 217555 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2144:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 217555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 217558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217567 */     GIR_RootConstrainSelectedInstOperands,
     /* 217568 */     // GIR_Coverage, 3219,
     /* 217568 */     GIR_EraseRootFromParent_Done,
     /* 217569 */   // Label 4177: @217569
     /* 217569 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(217611), // Rule ID 3220 //
     /* 217574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 217582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 217585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217589 */     // MIs[0] Op1
     /* 217589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 217593 */     // MIs[0] Op2
     /* 217593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 217597 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2145:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 217597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 217600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217609 */     GIR_RootConstrainSelectedInstOperands,
     /* 217610 */     // GIR_Coverage, 3220,
     /* 217610 */     GIR_EraseRootFromParent_Done,
     /* 217611 */   // Label 4178: @217611
     /* 217611 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(217653), // Rule ID 3221 //
     /* 217616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 217624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 217627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217631 */     // MIs[0] Op1
     /* 217631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 217635 */     // MIs[0] Op2
     /* 217635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 217639 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2143:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 217639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 217642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217651 */     GIR_RootConstrainSelectedInstOperands,
     /* 217652 */     // GIR_Coverage, 3221,
     /* 217652 */     GIR_EraseRootFromParent_Done,
     /* 217653 */   // Label 4179: @217653
     /* 217653 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(217695), // Rule ID 12047 //
     /* 217658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 217666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 217669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217673 */     // MIs[0] Op1
     /* 217673 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 217677 */     // MIs[0] Op2
     /* 217677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 217681 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2138:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 217681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 217684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217693 */     GIR_RootConstrainSelectedInstOperands,
     /* 217694 */     // GIR_Coverage, 12047,
     /* 217694 */     GIR_EraseRootFromParent_Done,
     /* 217695 */   // Label 4180: @217695
     /* 217695 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(217737), // Rule ID 12048 //
     /* 217700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 217708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 217711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217715 */     // MIs[0] Op1
     /* 217715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 217719 */     // MIs[0] Op2
     /* 217719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 217723 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2140:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 217723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 217726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217735 */     GIR_RootConstrainSelectedInstOperands,
     /* 217736 */     // GIR_Coverage, 12048,
     /* 217736 */     GIR_EraseRootFromParent_Done,
     /* 217737 */   // Label 4181: @217737
     /* 217737 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(217779), // Rule ID 12049 //
     /* 217742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 217750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 217753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217757 */     // MIs[0] Op1
     /* 217757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 217761 */     // MIs[0] Op2
     /* 217761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 217765 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2141:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 217765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 217768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217777 */     GIR_RootConstrainSelectedInstOperands,
     /* 217778 */     // GIR_Coverage, 12049,
     /* 217778 */     GIR_EraseRootFromParent_Done,
     /* 217779 */   // Label 4182: @217779
     /* 217779 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(217821), // Rule ID 12050 //
     /* 217784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 217787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 217792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 217795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 217799 */     // MIs[0] Op1
     /* 217799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 217803 */     // MIs[0] Op2
     /* 217803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 217807 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 217807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 217810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 217812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 217814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 217816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 217819 */     GIR_RootConstrainSelectedInstOperands,
     /* 217820 */     // GIR_Coverage, 12050,
     /* 217820 */     GIR_EraseRootFromParent_Done,
     /* 217821 */   // Label 4183: @217821
     /* 217821 */   GIM_Reject,
     /* 217822 */ // Label 3230: @217822
     /* 217822 */ GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(260933),
     /* 217827 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 217830 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(217943), // Rule ID 2069 //
     /* 217835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 217838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 217843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 217846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 217849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 217852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 217855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 217875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 217879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 217883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 217887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 217891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 217900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217908 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 217912 */     // MIs[3] Operand 1
     /* 217912 */     // No operand predicates
     /* 217912 */     // MIs[1] Operand 2
     /* 217912 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 217923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217925 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 217925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 217928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217941 */     GIR_RootConstrainSelectedInstOperands,
     /* 217942 */     // GIR_Coverage, 2069,
     /* 217942 */     GIR_EraseRootFromParent_Done,
     /* 217943 */   // Label 4185: @217943
     /* 217943 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(218056), // Rule ID 2076 //
     /* 217948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 217951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 217956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 217959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 217962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 217965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 217968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 217988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 217992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 217996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 218000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 218004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 218013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218021 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 218025 */     // MIs[3] Operand 1
     /* 218025 */     // No operand predicates
     /* 218025 */     // MIs[1] Operand 2
     /* 218025 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 218036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218038 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 218041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218054 */     GIR_RootConstrainSelectedInstOperands,
     /* 218055 */     // GIR_Coverage, 2076,
     /* 218055 */     GIR_EraseRootFromParent_Done,
     /* 218056 */   // Label 4186: @218056
     /* 218056 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(218169), // Rule ID 2072 //
     /* 218061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 218064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 218069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 218072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 218075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 218078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 218081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 218101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218134 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 218138 */     // MIs[3] Operand 1
     /* 218138 */     // No operand predicates
     /* 218138 */     // MIs[1] Operand 2
     /* 218138 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 218149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218151 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 218154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218167 */     GIR_RootConstrainSelectedInstOperands,
     /* 218168 */     // GIR_Coverage, 2072,
     /* 218168 */     GIR_EraseRootFromParent_Done,
     /* 218169 */   // Label 4187: @218169
     /* 218169 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(218282), // Rule ID 2079 //
     /* 218174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 218177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 218182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 218185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 218188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 218191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 218194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 218214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218234 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218247 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 218251 */     // MIs[3] Operand 1
     /* 218251 */     // No operand predicates
     /* 218251 */     // MIs[1] Operand 2
     /* 218251 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 218262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218264 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 218264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 218267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218280 */     GIR_RootConstrainSelectedInstOperands,
     /* 218281 */     // GIR_Coverage, 2079,
     /* 218281 */     GIR_EraseRootFromParent_Done,
     /* 218282 */   // Label 4188: @218282
     /* 218282 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(218387), // Rule ID 3869 //
     /* 218287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 218295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 218298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 218301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 218327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 218331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218352 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218356 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218360 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 218364 */     // MIs[3] Operand 1
     /* 218364 */     // No operand predicates
     /* 218364 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218366 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 218366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 218369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218385 */     GIR_RootConstrainSelectedInstOperands,
     /* 218386 */     // GIR_Coverage, 3869,
     /* 218386 */     GIR_EraseRootFromParent_Done,
     /* 218387 */   // Label 4189: @218387
     /* 218387 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(218492), // Rule ID 3870 //
     /* 218392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 218400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 218403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 218406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 218432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 218436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218465 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 218469 */     // MIs[3] Operand 1
     /* 218469 */     // No operand predicates
     /* 218469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218471 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 218471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 218474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218490 */     GIR_RootConstrainSelectedInstOperands,
     /* 218491 */     // GIR_Coverage, 3870,
     /* 218491 */     GIR_EraseRootFromParent_Done,
     /* 218492 */   // Label 4190: @218492
     /* 218492 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(218597), // Rule ID 3871 //
     /* 218497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 218505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 218508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 218511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 218537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 218541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218570 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 218574 */     // MIs[3] Operand 1
     /* 218574 */     // No operand predicates
     /* 218574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218576 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 218576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 218579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 218595 */     GIR_RootConstrainSelectedInstOperands,
     /* 218596 */     // GIR_Coverage, 3871,
     /* 218596 */     GIR_EraseRootFromParent_Done,
     /* 218597 */   // Label 4191: @218597
     /* 218597 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(218702), // Rule ID 3872 //
     /* 218602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 218610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 218613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 218616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 218619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 218622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 218642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 218646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218658 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218667 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218671 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218675 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 218679 */     // MIs[3] Operand 1
     /* 218679 */     // No operand predicates
     /* 218679 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218681 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 218681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 218684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 218700 */     GIR_RootConstrainSelectedInstOperands,
     /* 218701 */     // GIR_Coverage, 3872,
     /* 218701 */     GIR_EraseRootFromParent_Done,
     /* 218702 */   // Label 4192: @218702
     /* 218702 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(218807), // Rule ID 3877 //
     /* 218707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 218715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 218747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218780 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 218784 */     // MIs[3] Operand 1
     /* 218784 */     // No operand predicates
     /* 218784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218786 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 218786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 218789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218805 */     GIR_RootConstrainSelectedInstOperands,
     /* 218806 */     // GIR_Coverage, 3877,
     /* 218806 */     GIR_EraseRootFromParent_Done,
     /* 218807 */   // Label 4193: @218807
     /* 218807 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(218912), // Rule ID 3878 //
     /* 218812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 218820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 218852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218872 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218877 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218881 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218885 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 218889 */     // MIs[3] Operand 1
     /* 218889 */     // No operand predicates
     /* 218889 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218891 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 218891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 218894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 218904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 218907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218910 */     GIR_RootConstrainSelectedInstOperands,
     /* 218911 */     // GIR_Coverage, 3878,
     /* 218911 */     GIR_EraseRootFromParent_Done,
     /* 218912 */   // Label 4194: @218912
     /* 218912 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(219017), // Rule ID 3879 //
     /* 218917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 218920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 218925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 218928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 218931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 218934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 218937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 218953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 218957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 218965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 218969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 218973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 218977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 218986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 218990 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 218994 */     // MIs[3] Operand 1
     /* 218994 */     // No operand predicates
     /* 218994 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 218996 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 218996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 218999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 219009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 219012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 219015 */     GIR_RootConstrainSelectedInstOperands,
     /* 219016 */     // GIR_Coverage, 3879,
     /* 219016 */     GIR_EraseRootFromParent_Done,
     /* 219017 */   // Label 4195: @219017
     /* 219017 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(219122), // Rule ID 3880 //
     /* 219022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 219025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 219030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 219033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 219036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 219062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 219066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 219074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 219078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 219082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 219091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219095 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 219099 */     // MIs[3] Operand 1
     /* 219099 */     // No operand predicates
     /* 219099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 219101 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 219101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 219104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 219114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 219117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 219120 */     GIR_RootConstrainSelectedInstOperands,
     /* 219121 */     // GIR_Coverage, 3880,
     /* 219121 */     GIR_EraseRootFromParent_Done,
     /* 219122 */   // Label 4196: @219122
     /* 219122 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(219227), // Rule ID 3893 //
     /* 219127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 219135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 219167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 219171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 219179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 219183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 219187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219192 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 219196 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219200 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 219204 */     // MIs[3] Operand 1
     /* 219204 */     // No operand predicates
     /* 219204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 219206 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 219206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 219209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 219219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 219222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 219225 */     GIR_RootConstrainSelectedInstOperands,
     /* 219226 */     // GIR_Coverage, 3893,
     /* 219226 */     GIR_EraseRootFromParent_Done,
     /* 219227 */   // Label 4197: @219227
     /* 219227 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(219332), // Rule ID 3894 //
     /* 219232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 219240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 219272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 219276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 219284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 219288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 219292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 219301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219305 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 219309 */     // MIs[3] Operand 1
     /* 219309 */     // No operand predicates
     /* 219309 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 219311 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 219311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 219314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 219324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 219327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 219330 */     GIR_RootConstrainSelectedInstOperands,
     /* 219331 */     // GIR_Coverage, 3894,
     /* 219331 */     GIR_EraseRootFromParent_Done,
     /* 219332 */   // Label 4198: @219332
     /* 219332 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(219437), // Rule ID 3895 //
     /* 219337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 219345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 219377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 219381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 219389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 219393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 219397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 219406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219410 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 219414 */     // MIs[3] Operand 1
     /* 219414 */     // No operand predicates
     /* 219414 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 219416 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 219416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 219419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 219429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 219432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 219435 */     GIR_RootConstrainSelectedInstOperands,
     /* 219436 */     // GIR_Coverage, 3895,
     /* 219436 */     GIR_EraseRootFromParent_Done,
     /* 219437 */   // Label 4199: @219437
     /* 219437 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(219542), // Rule ID 3896 //
     /* 219442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 219445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 219450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 219459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 219462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 219482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 219486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 219490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 219494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 219498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 219502 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 219511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219515 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 219519 */     // MIs[3] Operand 1
     /* 219519 */     // No operand predicates
     /* 219519 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 219521 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 219521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 219524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 219534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 219537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 219540 */     GIR_RootConstrainSelectedInstOperands,
     /* 219541 */     // GIR_Coverage, 3896,
     /* 219541 */     GIR_EraseRootFromParent_Done,
     /* 219542 */   // Label 4200: @219542
     /* 219542 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(219596), // Rule ID 59 //
     /* 219547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 219550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 219555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 219564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219572 */     // MIs[0] Operand 3
     /* 219572 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 219583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 219587 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 219587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 219590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219594 */     GIR_RootConstrainSelectedInstOperands,
     /* 219595 */     // GIR_Coverage, 59,
     /* 219595 */     GIR_EraseRootFromParent_Done,
     /* 219596 */   // Label 4201: @219596
     /* 219596 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(219650), // Rule ID 60 //
     /* 219601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 219604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 219609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 219618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219626 */     // MIs[0] Operand 3
     /* 219626 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 219637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 219641 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 219641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 219644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219648 */     GIR_RootConstrainSelectedInstOperands,
     /* 219649 */     // GIR_Coverage, 60,
     /* 219649 */     GIR_EraseRootFromParent_Done,
     /* 219650 */   // Label 4202: @219650
     /* 219650 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(219704), // Rule ID 61 //
     /* 219655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 219658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 219663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 219672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219680 */     // MIs[0] Operand 3
     /* 219680 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 219691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 219695 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 219695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 219698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219702 */     GIR_RootConstrainSelectedInstOperands,
     /* 219703 */     // GIR_Coverage, 61,
     /* 219703 */     GIR_EraseRootFromParent_Done,
     /* 219704 */   // Label 4203: @219704
     /* 219704 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(219758), // Rule ID 62 //
     /* 219709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 219712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 219717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 219726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219734 */     // MIs[0] Operand 3
     /* 219734 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 219745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 219749 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 219749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 219752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219756 */     GIR_RootConstrainSelectedInstOperands,
     /* 219757 */     // GIR_Coverage, 62,
     /* 219757 */     GIR_EraseRootFromParent_Done,
     /* 219758 */   // Label 4204: @219758
     /* 219758 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(219814), // Rule ID 2652 //
     /* 219763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 219771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219785 */     // MIs[0] pattern
     /* 219785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219793 */     // MIs[0] imm4
     /* 219793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219801 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1810:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 219804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219808 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219810 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219812 */     GIR_RootConstrainSelectedInstOperands,
     /* 219813 */     // GIR_Coverage, 2652,
     /* 219813 */     GIR_EraseRootFromParent_Done,
     /* 219814 */   // Label 4205: @219814
     /* 219814 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(219870), // Rule ID 2661 //
     /* 219819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 219827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 219830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 219833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 219837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 219841 */     // MIs[0] pattern
     /* 219841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219849 */     // MIs[0] imm4
     /* 219849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219857 */     // (intrinsic_wo_chain:{ *:[i32] } 2016:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 219860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 219862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 219864 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219866 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219868 */     GIR_RootConstrainSelectedInstOperands,
     /* 219869 */     // GIR_Coverage, 2661,
     /* 219869 */     GIR_EraseRootFromParent_Done,
     /* 219870 */   // Label 4206: @219870
     /* 219870 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(219926), // Rule ID 2662 //
     /* 219875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 219883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 219897 */     // MIs[0] pattern
     /* 219897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219900 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219905 */     // MIs[0] imm4
     /* 219905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219908 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219913 */     // (intrinsic_wo_chain:{ *:[i64] } 1806:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 219916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 219918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 219920 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219922 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219924 */     GIR_RootConstrainSelectedInstOperands,
     /* 219925 */     // GIR_Coverage, 2662,
     /* 219925 */     GIR_EraseRootFromParent_Done,
     /* 219926 */   // Label 4207: @219926
     /* 219926 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(219982), // Rule ID 10046 //
     /* 219931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 219939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 219942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 219945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 219949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 219953 */     // MIs[0] pattern
     /* 219953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219956 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219961 */     // MIs[0] imm4
     /* 219961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219964 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219969 */     // (intrinsic_wo_chain:{ *:[i32] } 2002:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 219972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 219974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 219976 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219978 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219980 */     GIR_RootConstrainSelectedInstOperands,
     /* 219981 */     // GIR_Coverage, 10046,
     /* 219981 */     GIR_EraseRootFromParent_Done,
     /* 219982 */   // Label 4208: @219982
     /* 219982 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(220038), // Rule ID 10047 //
     /* 219987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 219995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 219998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220009 */     // MIs[0] pattern
     /* 220009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220017 */     // MIs[0] imm4
     /* 220017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220025 */     // (intrinsic_wo_chain:{ *:[i64] } 2017:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 220028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220032 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220034 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220036 */     GIR_RootConstrainSelectedInstOperands,
     /* 220037 */     // GIR_Coverage, 10047,
     /* 220037 */     GIR_EraseRootFromParent_Done,
     /* 220038 */   // Label 4209: @220038
     /* 220038 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(220094), // Rule ID 10048 //
     /* 220043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 220051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220065 */     // MIs[0] pattern
     /* 220065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220073 */     // MIs[0] imm4
     /* 220073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220081 */     // (intrinsic_wo_chain:{ *:[i64] } 1772:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 220084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220088 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220090 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220092 */     GIR_RootConstrainSelectedInstOperands,
     /* 220093 */     // GIR_Coverage, 10048,
     /* 220093 */     GIR_EraseRootFromParent_Done,
     /* 220094 */   // Label 4210: @220094
     /* 220094 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(220150), // Rule ID 10049 //
     /* 220099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 220107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220121 */     // MIs[0] pattern
     /* 220121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220124 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220129 */     // MIs[0] imm4
     /* 220129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220132 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220137 */     // (intrinsic_wo_chain:{ *:[i64] } 2003:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 220140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220144 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220146 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220148 */     GIR_RootConstrainSelectedInstOperands,
     /* 220149 */     // GIR_Coverage, 10049,
     /* 220149 */     GIR_EraseRootFromParent_Done,
     /* 220150 */   // Label 4211: @220150
     /* 220150 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(220206), // Rule ID 10052 //
     /* 220155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 220163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220177 */     // MIs[0] pattern
     /* 220177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220185 */     // MIs[0] imm4
     /* 220185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220193 */     // (intrinsic_wo_chain:{ *:[i32] } 2022:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 220196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220200 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220202 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220204 */     GIR_RootConstrainSelectedInstOperands,
     /* 220205 */     // GIR_Coverage, 10052,
     /* 220205 */     GIR_EraseRootFromParent_Done,
     /* 220206 */   // Label 4212: @220206
     /* 220206 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(220262), // Rule ID 10055 //
     /* 220211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 220219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220233 */     // MIs[0] pattern
     /* 220233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220241 */     // MIs[0] imm4
     /* 220241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220244 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220249 */     // (intrinsic_wo_chain:{ *:[i32] } 2008:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 220252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220256 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220258 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220260 */     GIR_RootConstrainSelectedInstOperands,
     /* 220261 */     // GIR_Coverage, 10055,
     /* 220261 */     GIR_EraseRootFromParent_Done,
     /* 220262 */   // Label 4213: @220262
     /* 220262 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(220318), // Rule ID 10056 //
     /* 220267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 220275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220289 */     // MIs[0] pattern
     /* 220289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220297 */     // MIs[0] imm4
     /* 220297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220300 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220305 */     // (intrinsic_wo_chain:{ *:[i64] } 1812:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 220308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220312 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220314 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220316 */     GIR_RootConstrainSelectedInstOperands,
     /* 220317 */     // GIR_Coverage, 10056,
     /* 220317 */     GIR_EraseRootFromParent_Done,
     /* 220318 */   // Label 4214: @220318
     /* 220318 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(220374), // Rule ID 10057 //
     /* 220323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 220331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220345 */     // MIs[0] pattern
     /* 220345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220348 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220353 */     // MIs[0] imm4
     /* 220353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220361 */     // (intrinsic_wo_chain:{ *:[i64] } 2023:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 220364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220368 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220370 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220372 */     GIR_RootConstrainSelectedInstOperands,
     /* 220373 */     // GIR_Coverage, 10057,
     /* 220373 */     GIR_EraseRootFromParent_Done,
     /* 220374 */   // Label 4215: @220374
     /* 220374 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(220430), // Rule ID 10058 //
     /* 220379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 220387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220401 */     // MIs[0] pattern
     /* 220401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220404 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220409 */     // MIs[0] imm4
     /* 220409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220412 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220417 */     // (intrinsic_wo_chain:{ *:[i64] } 1778:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 220420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220424 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220426 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220428 */     GIR_RootConstrainSelectedInstOperands,
     /* 220429 */     // GIR_Coverage, 10058,
     /* 220429 */     GIR_EraseRootFromParent_Done,
     /* 220430 */   // Label 4216: @220430
     /* 220430 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(220486), // Rule ID 10059 //
     /* 220435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 220443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220457 */     // MIs[0] pattern
     /* 220457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220465 */     // MIs[0] imm4
     /* 220465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220468 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220473 */     // (intrinsic_wo_chain:{ *:[i64] } 2009:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 220476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220480 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220482 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220484 */     GIR_RootConstrainSelectedInstOperands,
     /* 220485 */     // GIR_Coverage, 10059,
     /* 220485 */     GIR_EraseRootFromParent_Done,
     /* 220486 */   // Label 4217: @220486
     /* 220486 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(220542), // Rule ID 10062 //
     /* 220491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 220499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220513 */     // MIs[0] pattern
     /* 220513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220521 */     // MIs[0] imm4
     /* 220521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220529 */     // (intrinsic_wo_chain:{ *:[i32] } 2028:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 220532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220536 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220538 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220540 */     GIR_RootConstrainSelectedInstOperands,
     /* 220541 */     // GIR_Coverage, 10062,
     /* 220541 */     GIR_EraseRootFromParent_Done,
     /* 220542 */   // Label 4218: @220542
     /* 220542 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(220598), // Rule ID 10065 //
     /* 220547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 220555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220569 */     // MIs[0] pattern
     /* 220569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220572 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220577 */     // MIs[0] imm4
     /* 220577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220580 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220585 */     // (intrinsic_wo_chain:{ *:[i32] } 2014:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 220588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220592 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220594 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220596 */     GIR_RootConstrainSelectedInstOperands,
     /* 220597 */     // GIR_Coverage, 10065,
     /* 220597 */     GIR_EraseRootFromParent_Done,
     /* 220598 */   // Label 4219: @220598
     /* 220598 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(220654), // Rule ID 10066 //
     /* 220603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 220611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220625 */     // MIs[0] pattern
     /* 220625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220628 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220633 */     // MIs[0] imm4
     /* 220633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220636 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220641 */     // (intrinsic_wo_chain:{ *:[i64] } 1818:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 220644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220648 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220650 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220652 */     GIR_RootConstrainSelectedInstOperands,
     /* 220653 */     // GIR_Coverage, 10066,
     /* 220653 */     GIR_EraseRootFromParent_Done,
     /* 220654 */   // Label 4220: @220654
     /* 220654 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(220710), // Rule ID 10067 //
     /* 220659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 220667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220681 */     // MIs[0] pattern
     /* 220681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220689 */     // MIs[0] imm4
     /* 220689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220692 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220697 */     // (intrinsic_wo_chain:{ *:[i64] } 2029:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 220700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220704 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220706 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220708 */     GIR_RootConstrainSelectedInstOperands,
     /* 220709 */     // GIR_Coverage, 10067,
     /* 220709 */     GIR_EraseRootFromParent_Done,
     /* 220710 */   // Label 4221: @220710
     /* 220710 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(220766), // Rule ID 10068 //
     /* 220715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 220723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220737 */     // MIs[0] pattern
     /* 220737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220740 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220745 */     // MIs[0] imm4
     /* 220745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220748 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220753 */     // (intrinsic_wo_chain:{ *:[i64] } 1784:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 220756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220760 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220762 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220764 */     GIR_RootConstrainSelectedInstOperands,
     /* 220765 */     // GIR_Coverage, 10068,
     /* 220765 */     GIR_EraseRootFromParent_Done,
     /* 220766 */   // Label 4222: @220766
     /* 220766 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(220822), // Rule ID 10069 //
     /* 220771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 220779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220793 */     // MIs[0] pattern
     /* 220793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220801 */     // MIs[0] imm4
     /* 220801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220804 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220809 */     // (intrinsic_wo_chain:{ *:[i64] } 2015:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 220812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220816 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220818 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220820 */     GIR_RootConstrainSelectedInstOperands,
     /* 220821 */     // GIR_Coverage, 10069,
     /* 220821 */     GIR_EraseRootFromParent_Done,
     /* 220822 */   // Label 4223: @220822
     /* 220822 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(220878), // Rule ID 10072 //
     /* 220827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 220835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220849 */     // MIs[0] pattern
     /* 220849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220857 */     // MIs[0] imm4
     /* 220857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220865 */     // (intrinsic_wo_chain:{ *:[i32] } 2019:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 220868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220872 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220874 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220876 */     GIR_RootConstrainSelectedInstOperands,
     /* 220877 */     // GIR_Coverage, 10072,
     /* 220877 */     GIR_EraseRootFromParent_Done,
     /* 220878 */   // Label 4224: @220878
     /* 220878 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(220934), // Rule ID 10075 //
     /* 220883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 220891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 220905 */     // MIs[0] pattern
     /* 220905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220908 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220913 */     // MIs[0] imm4
     /* 220913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220916 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220921 */     // (intrinsic_wo_chain:{ *:[i32] } 2005:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 220924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220928 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220930 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220932 */     GIR_RootConstrainSelectedInstOperands,
     /* 220933 */     // GIR_Coverage, 10075,
     /* 220933 */     GIR_EraseRootFromParent_Done,
     /* 220934 */   // Label 4225: @220934
     /* 220934 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(220990), // Rule ID 10076 //
     /* 220939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 220947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 220950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 220953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 220961 */     // MIs[0] pattern
     /* 220961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 220964 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 220969 */     // MIs[0] imm4
     /* 220969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 220972 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 220977 */     // (intrinsic_wo_chain:{ *:[i64] } 1809:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 220977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 220980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 220982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 220984 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 220986 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 220988 */     GIR_RootConstrainSelectedInstOperands,
     /* 220989 */     // GIR_Coverage, 10076,
     /* 220989 */     GIR_EraseRootFromParent_Done,
     /* 220990 */   // Label 4226: @220990
     /* 220990 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(221046), // Rule ID 10077 //
     /* 220995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 220998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 221003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 221006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 221009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 221013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 221017 */     // MIs[0] pattern
     /* 221017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221025 */     // MIs[0] imm4
     /* 221025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221033 */     // (intrinsic_wo_chain:{ *:[i64] } 2020:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 221036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 221038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 221040 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221042 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221044 */     GIR_RootConstrainSelectedInstOperands,
     /* 221045 */     // GIR_Coverage, 10077,
     /* 221045 */     GIR_EraseRootFromParent_Done,
     /* 221046 */   // Label 4227: @221046
     /* 221046 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(221102), // Rule ID 10078 //
     /* 221051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 221059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 221062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 221065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 221069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 221073 */     // MIs[0] pattern
     /* 221073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221081 */     // MIs[0] imm4
     /* 221081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221084 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221089 */     // (intrinsic_wo_chain:{ *:[i64] } 1775:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 221092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 221094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 221096 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221098 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221100 */     GIR_RootConstrainSelectedInstOperands,
     /* 221101 */     // GIR_Coverage, 10078,
     /* 221101 */     GIR_EraseRootFromParent_Done,
     /* 221102 */   // Label 4228: @221102
     /* 221102 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(221158), // Rule ID 10079 //
     /* 221107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 221115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 221118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 221121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 221125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 221129 */     // MIs[0] pattern
     /* 221129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221132 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221137 */     // MIs[0] imm4
     /* 221137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221140 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221145 */     // (intrinsic_wo_chain:{ *:[i64] } 2006:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 221148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 221150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 221152 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221154 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221156 */     GIR_RootConstrainSelectedInstOperands,
     /* 221157 */     // GIR_Coverage, 10079,
     /* 221157 */     GIR_EraseRootFromParent_Done,
     /* 221158 */   // Label 4229: @221158
     /* 221158 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(221214), // Rule ID 10080 //
     /* 221163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 221171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221185 */     // MIs[0] pattern
     /* 221185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221193 */     // MIs[0] imm4
     /* 221193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221201 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2021:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 221204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221208 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221210 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221212 */     GIR_RootConstrainSelectedInstOperands,
     /* 221213 */     // GIR_Coverage, 10080,
     /* 221213 */     GIR_EraseRootFromParent_Done,
     /* 221214 */   // Label 4230: @221214
     /* 221214 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(221270), // Rule ID 10081 //
     /* 221219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 221227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221241 */     // MIs[0] pattern
     /* 221241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221244 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221249 */     // MIs[0] imm4
     /* 221249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221257 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1776:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 221260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221264 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221266 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221268 */     GIR_RootConstrainSelectedInstOperands,
     /* 221269 */     // GIR_Coverage, 10081,
     /* 221269 */     GIR_EraseRootFromParent_Done,
     /* 221270 */   // Label 4231: @221270
     /* 221270 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(221326), // Rule ID 10082 //
     /* 221275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 221283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221297 */     // MIs[0] pattern
     /* 221297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221300 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221305 */     // MIs[0] imm4
     /* 221305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221308 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221313 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2007:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 221316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221320 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221322 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221324 */     GIR_RootConstrainSelectedInstOperands,
     /* 221325 */     // GIR_Coverage, 10082,
     /* 221325 */     GIR_EraseRootFromParent_Done,
     /* 221326 */   // Label 4232: @221326
     /* 221326 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(221382), // Rule ID 10083 //
     /* 221331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 221339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221353 */     // MIs[0] pattern
     /* 221353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221361 */     // MIs[0] imm4
     /* 221361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221369 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1816:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 221372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221376 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221378 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221380 */     GIR_RootConstrainSelectedInstOperands,
     /* 221381 */     // GIR_Coverage, 10083,
     /* 221381 */     GIR_EraseRootFromParent_Done,
     /* 221382 */   // Label 4233: @221382
     /* 221382 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(221438), // Rule ID 10084 //
     /* 221387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 221395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221409 */     // MIs[0] pattern
     /* 221409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221412 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221417 */     // MIs[0] imm4
     /* 221417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221420 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2027:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 221428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221432 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221434 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221436 */     GIR_RootConstrainSelectedInstOperands,
     /* 221437 */     // GIR_Coverage, 10084,
     /* 221437 */     GIR_EraseRootFromParent_Done,
     /* 221438 */   // Label 4234: @221438
     /* 221438 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(221494), // Rule ID 10085 //
     /* 221443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 221451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221465 */     // MIs[0] pattern
     /* 221465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221468 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221473 */     // MIs[0] imm4
     /* 221473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221476 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221481 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1782:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 221484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221488 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221490 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221492 */     GIR_RootConstrainSelectedInstOperands,
     /* 221493 */     // GIR_Coverage, 10085,
     /* 221493 */     GIR_EraseRootFromParent_Done,
     /* 221494 */   // Label 4235: @221494
     /* 221494 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(221550), // Rule ID 10086 //
     /* 221499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 221507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221521 */     // MIs[0] pattern
     /* 221521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221529 */     // MIs[0] imm4
     /* 221529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221537 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2013:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 221540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221544 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221546 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221548 */     GIR_RootConstrainSelectedInstOperands,
     /* 221549 */     // GIR_Coverage, 10086,
     /* 221549 */     GIR_EraseRootFromParent_Done,
     /* 221550 */   // Label 4236: @221550
     /* 221550 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(221606), // Rule ID 10087 //
     /* 221555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 221563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221577 */     // MIs[0] pattern
     /* 221577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221580 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221585 */     // MIs[0] imm4
     /* 221585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221588 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221593 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1807:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 221596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221600 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221602 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221604 */     GIR_RootConstrainSelectedInstOperands,
     /* 221605 */     // GIR_Coverage, 10087,
     /* 221605 */     GIR_EraseRootFromParent_Done,
     /* 221606 */   // Label 4237: @221606
     /* 221606 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(221662), // Rule ID 10088 //
     /* 221611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 221619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221633 */     // MIs[0] pattern
     /* 221633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221636 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221641 */     // MIs[0] imm4
     /* 221641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221644 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2018:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 221652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221656 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221658 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221660 */     GIR_RootConstrainSelectedInstOperands,
     /* 221661 */     // GIR_Coverage, 10088,
     /* 221661 */     GIR_EraseRootFromParent_Done,
     /* 221662 */   // Label 4238: @221662
     /* 221662 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(221718), // Rule ID 10089 //
     /* 221667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 221675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221689 */     // MIs[0] pattern
     /* 221689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221692 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221697 */     // MIs[0] imm4
     /* 221697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221700 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221705 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1773:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 221708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221712 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221714 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221716 */     GIR_RootConstrainSelectedInstOperands,
     /* 221717 */     // GIR_Coverage, 10089,
     /* 221717 */     GIR_EraseRootFromParent_Done,
     /* 221718 */   // Label 4239: @221718
     /* 221718 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(221774), // Rule ID 10090 //
     /* 221723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 221731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221745 */     // MIs[0] pattern
     /* 221745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 221748 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 221753 */     // MIs[0] imm4
     /* 221753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 221756 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 221761 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2004:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 221761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 221764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 221768 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 221770 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 221772 */     GIR_RootConstrainSelectedInstOperands,
     /* 221773 */     // GIR_Coverage, 10090,
     /* 221773 */     GIR_EraseRootFromParent_Done,
     /* 221774 */   // Label 4240: @221774
     /* 221774 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(221864), // Rule ID 47 //
     /* 221779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 221782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 221787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 221790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 221793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 221796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 221799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 221819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 221823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 221827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 221832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 221836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 221840 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 221844 */     // MIs[2] Operand 1
     /* 221844 */     // No operand predicates
     /* 221844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221846 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 221846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 221849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 221855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 221859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 221862 */     GIR_RootConstrainSelectedInstOperands,
     /* 221863 */     // GIR_Coverage, 47,
     /* 221863 */     GIR_EraseRootFromParent_Done,
     /* 221864 */   // Label 4241: @221864
     /* 221864 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(221954), // Rule ID 48 //
     /* 221869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 221872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 221877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 221880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 221883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 221886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 221889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 221901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 221909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 221913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 221917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 221922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 221926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 221930 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 221934 */     // MIs[2] Operand 1
     /* 221934 */     // No operand predicates
     /* 221934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221936 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 221936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 221939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 221943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 221945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 221949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 221952 */     GIR_RootConstrainSelectedInstOperands,
     /* 221953 */     // GIR_Coverage, 48,
     /* 221953 */     GIR_EraseRootFromParent_Done,
     /* 221954 */   // Label 4242: @221954
     /* 221954 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(222044), // Rule ID 49 //
     /* 221959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 221962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 221967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 221970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 221973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 221976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 221979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 221991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 221999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222020 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222024 */     // MIs[2] Operand 1
     /* 222024 */     // No operand predicates
     /* 222024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222026 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 222029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222042 */     GIR_RootConstrainSelectedInstOperands,
     /* 222043 */     // GIR_Coverage, 49,
     /* 222043 */     GIR_EraseRootFromParent_Done,
     /* 222044 */   // Label 4243: @222044
     /* 222044 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(222134), // Rule ID 50 //
     /* 222049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 222052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 222057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 222060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 222063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 222066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 222069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 222089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222110 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222114 */     // MIs[2] Operand 1
     /* 222114 */     // No operand predicates
     /* 222114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222116 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 222119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222132 */     GIR_RootConstrainSelectedInstOperands,
     /* 222133 */     // GIR_Coverage, 50,
     /* 222133 */     GIR_EraseRootFromParent_Done,
     /* 222134 */   // Label 4244: @222134
     /* 222134 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(222224), // Rule ID 51 //
     /* 222139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 222142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 222147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 222150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 222153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 222156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 222159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 222179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222200 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222204 */     // MIs[2] Operand 1
     /* 222204 */     // No operand predicates
     /* 222204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222206 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 222209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222222 */     GIR_RootConstrainSelectedInstOperands,
     /* 222223 */     // GIR_Coverage, 51,
     /* 222223 */     GIR_EraseRootFromParent_Done,
     /* 222224 */   // Label 4245: @222224
     /* 222224 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(222314), // Rule ID 52 //
     /* 222229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 222232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 222237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 222240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 222243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 222246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 222249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 222269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222290 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222294 */     // MIs[2] Operand 1
     /* 222294 */     // No operand predicates
     /* 222294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222296 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 222299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222312 */     GIR_RootConstrainSelectedInstOperands,
     /* 222313 */     // GIR_Coverage, 52,
     /* 222313 */     GIR_EraseRootFromParent_Done,
     /* 222314 */   // Label 4246: @222314
     /* 222314 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(222404), // Rule ID 53 //
     /* 222319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 222322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 222327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 222330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 222333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 222336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 222339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 222359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222380 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222384 */     // MIs[2] Operand 1
     /* 222384 */     // No operand predicates
     /* 222384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222386 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 222389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222402 */     GIR_RootConstrainSelectedInstOperands,
     /* 222403 */     // GIR_Coverage, 53,
     /* 222403 */     GIR_EraseRootFromParent_Done,
     /* 222404 */   // Label 4247: @222404
     /* 222404 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(222494), // Rule ID 54 //
     /* 222409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 222412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 222417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 222420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 222423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 222426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 222429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 222449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222470 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222474 */     // MIs[2] Operand 1
     /* 222474 */     // No operand predicates
     /* 222474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222476 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 222479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222492 */     GIR_RootConstrainSelectedInstOperands,
     /* 222493 */     // GIR_Coverage, 54,
     /* 222493 */     GIR_EraseRootFromParent_Done,
     /* 222494 */   // Label 4248: @222494
     /* 222494 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(222584), // Rule ID 2070 //
     /* 222499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 222502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 222507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 222510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 222513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 222516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 222519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 222539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222560 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222564 */     // MIs[2] Operand 1
     /* 222564 */     // No operand predicates
     /* 222564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222566 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 222569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222582 */     GIR_RootConstrainSelectedInstOperands,
     /* 222583 */     // GIR_Coverage, 2070,
     /* 222583 */     GIR_EraseRootFromParent_Done,
     /* 222584 */   // Label 4249: @222584
     /* 222584 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(222674), // Rule ID 2071 //
     /* 222589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 222592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 222597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 222600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 222603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 222606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 222609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 222629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222650 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222654 */     // MIs[2] Operand 1
     /* 222654 */     // No operand predicates
     /* 222654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222656 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 222659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222672 */     GIR_RootConstrainSelectedInstOperands,
     /* 222673 */     // GIR_Coverage, 2071,
     /* 222673 */     GIR_EraseRootFromParent_Done,
     /* 222674 */   // Label 4250: @222674
     /* 222674 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(222764), // Rule ID 2077 //
     /* 222679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 222682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 222687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 222690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 222693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 222696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 222699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 222719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222740 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222744 */     // MIs[2] Operand 1
     /* 222744 */     // No operand predicates
     /* 222744 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222746 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 222749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222762 */     GIR_RootConstrainSelectedInstOperands,
     /* 222763 */     // GIR_Coverage, 2077,
     /* 222763 */     GIR_EraseRootFromParent_Done,
     /* 222764 */   // Label 4251: @222764
     /* 222764 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(222854), // Rule ID 2078 //
     /* 222769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 222772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 222777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 222780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 222783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 222786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 222789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 222809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 222822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222830 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 222834 */     // MIs[2] Operand 1
     /* 222834 */     // No operand predicates
     /* 222834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222836 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 222839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222852 */     GIR_RootConstrainSelectedInstOperands,
     /* 222853 */     // GIR_Coverage, 2078,
     /* 222853 */     GIR_EraseRootFromParent_Done,
     /* 222854 */   // Label 4252: @222854
     /* 222854 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(222944), // Rule ID 2073 //
     /* 222859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 222862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 222867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 222870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 222873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 222876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 222879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 222891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 222899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 222903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 222916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 222920 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 222924 */     // MIs[2] Operand 1
     /* 222924 */     // No operand predicates
     /* 222924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222926 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 222926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 222929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 222933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 222935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 222939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 222942 */     GIR_RootConstrainSelectedInstOperands,
     /* 222943 */     // GIR_Coverage, 2073,
     /* 222943 */     GIR_EraseRootFromParent_Done,
     /* 222944 */   // Label 4253: @222944
     /* 222944 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(223034), // Rule ID 2074 //
     /* 222949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 222952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 222957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 222960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 222963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 222966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 222969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 222981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 222989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 222993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 222997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 223002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 223006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 223010 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 223014 */     // MIs[2] Operand 1
     /* 223014 */     // No operand predicates
     /* 223014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223016 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 223016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 223019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 223023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 223025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 223029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 223032 */     GIR_RootConstrainSelectedInstOperands,
     /* 223033 */     // GIR_Coverage, 2074,
     /* 223033 */     GIR_EraseRootFromParent_Done,
     /* 223034 */   // Label 4254: @223034
     /* 223034 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(223124), // Rule ID 2080 //
     /* 223039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 223042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 223047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 223050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 223053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 223056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 223059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 223063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 223067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 223071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 223079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 223083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 223087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 223092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 223096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 223100 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 223104 */     // MIs[2] Operand 1
     /* 223104 */     // No operand predicates
     /* 223104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223106 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 223106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 223109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 223113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 223115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 223119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 223122 */     GIR_RootConstrainSelectedInstOperands,
     /* 223123 */     // GIR_Coverage, 2080,
     /* 223123 */     GIR_EraseRootFromParent_Done,
     /* 223124 */   // Label 4255: @223124
     /* 223124 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(223214), // Rule ID 2081 //
     /* 223129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 223132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 223137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 223140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 223143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 223146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 223149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 223153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 223157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 223161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 223169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 223173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 223177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 223182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 223186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 223190 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 223194 */     // MIs[2] Operand 1
     /* 223194 */     // No operand predicates
     /* 223194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223196 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 223196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 223199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 223203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 223205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 223209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 223212 */     GIR_RootConstrainSelectedInstOperands,
     /* 223213 */     // GIR_Coverage, 2081,
     /* 223213 */     GIR_EraseRootFromParent_Done,
     /* 223214 */   // Label 4256: @223214
     /* 223214 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(223304), // Rule ID 2075 //
     /* 223219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 223222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 223227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 223230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 223233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 223236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 223239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 223243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 223247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 223251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 223259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 223263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 223267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 223272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 223276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 223280 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 223284 */     // MIs[2] Operand 1
     /* 223284 */     // No operand predicates
     /* 223284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223286 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 223286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 223289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 223293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 223295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 223299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 223302 */     GIR_RootConstrainSelectedInstOperands,
     /* 223303 */     // GIR_Coverage, 2075,
     /* 223303 */     GIR_EraseRootFromParent_Done,
     /* 223304 */   // Label 4257: @223304
     /* 223304 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(223394), // Rule ID 2082 //
     /* 223309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 223312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 223317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 223320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 223323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 223326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 223329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 223333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 223337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 223341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 223349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 223353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 223357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 223362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 223366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 223370 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 223374 */     // MIs[2] Operand 1
     /* 223374 */     // No operand predicates
     /* 223374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223376 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 223376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 223379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 223383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 223385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 223389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 223392 */     GIR_RootConstrainSelectedInstOperands,
     /* 223393 */     // GIR_Coverage, 2082,
     /* 223393 */     GIR_EraseRootFromParent_Done,
     /* 223394 */   // Label 4258: @223394
     /* 223394 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(223471), // Rule ID 2781 //
     /* 223399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 223407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223451 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 223455 */     // MIs[2] Operand 1
     /* 223455 */     // No operand predicates
     /* 223455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223457 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 223457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 223460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223469 */     GIR_RootConstrainSelectedInstOperands,
     /* 223470 */     // GIR_Coverage, 2781,
     /* 223470 */     GIR_EraseRootFromParent_Done,
     /* 223471 */   // Label 4259: @223471
     /* 223471 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(223548), // Rule ID 2782 //
     /* 223476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 223484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223528 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223532 */     // MIs[2] Operand 1
     /* 223532 */     // No operand predicates
     /* 223532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223534 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 223534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 223537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223546 */     GIR_RootConstrainSelectedInstOperands,
     /* 223547 */     // GIR_Coverage, 2782,
     /* 223547 */     GIR_EraseRootFromParent_Done,
     /* 223548 */   // Label 4260: @223548
     /* 223548 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(223625), // Rule ID 2783 //
     /* 223553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 223561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223605 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 223609 */     // MIs[2] Operand 1
     /* 223609 */     // No operand predicates
     /* 223609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223611 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 223611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 223614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223623 */     GIR_RootConstrainSelectedInstOperands,
     /* 223624 */     // GIR_Coverage, 2783,
     /* 223624 */     GIR_EraseRootFromParent_Done,
     /* 223625 */   // Label 4261: @223625
     /* 223625 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(223702), // Rule ID 2784 //
     /* 223630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 223638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223682 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223686 */     // MIs[2] Operand 1
     /* 223686 */     // No operand predicates
     /* 223686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223688 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 223688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 223691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223700 */     GIR_RootConstrainSelectedInstOperands,
     /* 223701 */     // GIR_Coverage, 2784,
     /* 223701 */     GIR_EraseRootFromParent_Done,
     /* 223702 */   // Label 4262: @223702
     /* 223702 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(223779), // Rule ID 2785 //
     /* 223707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 223715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223759 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 223763 */     // MIs[2] Operand 1
     /* 223763 */     // No operand predicates
     /* 223763 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223765 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 223765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 223768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223777 */     GIR_RootConstrainSelectedInstOperands,
     /* 223778 */     // GIR_Coverage, 2785,
     /* 223778 */     GIR_EraseRootFromParent_Done,
     /* 223779 */   // Label 4263: @223779
     /* 223779 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(223856), // Rule ID 2786 //
     /* 223784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 223792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223836 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223840 */     // MIs[2] Operand 1
     /* 223840 */     // No operand predicates
     /* 223840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223842 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 223842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 223845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223854 */     GIR_RootConstrainSelectedInstOperands,
     /* 223855 */     // GIR_Coverage, 2786,
     /* 223855 */     GIR_EraseRootFromParent_Done,
     /* 223856 */   // Label 4264: @223856
     /* 223856 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(223933), // Rule ID 7933 //
     /* 223861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 223869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223913 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 223917 */     // MIs[2] Operand 1
     /* 223917 */     // No operand predicates
     /* 223917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223919 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 223919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 223922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223931 */     GIR_RootConstrainSelectedInstOperands,
     /* 223932 */     // GIR_Coverage, 7933,
     /* 223932 */     GIR_EraseRootFromParent_Done,
     /* 223933 */   // Label 4265: @223933
     /* 223933 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(224010), // Rule ID 7934 //
     /* 223938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 223946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223990 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223994 */     // MIs[2] Operand 1
     /* 223994 */     // No operand predicates
     /* 223994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223996 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 223996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 223999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224008 */     GIR_RootConstrainSelectedInstOperands,
     /* 224009 */     // GIR_Coverage, 7934,
     /* 224009 */     GIR_EraseRootFromParent_Done,
     /* 224010 */   // Label 4266: @224010
     /* 224010 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(224087), // Rule ID 7935 //
     /* 224015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 224023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224067 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 224071 */     // MIs[2] Operand 1
     /* 224071 */     // No operand predicates
     /* 224071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224073 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 224073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 224076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224085 */     GIR_RootConstrainSelectedInstOperands,
     /* 224086 */     // GIR_Coverage, 7935,
     /* 224086 */     GIR_EraseRootFromParent_Done,
     /* 224087 */   // Label 4267: @224087
     /* 224087 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(224164), // Rule ID 7936 //
     /* 224092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 224100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224144 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224148 */     // MIs[2] Operand 1
     /* 224148 */     // No operand predicates
     /* 224148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224150 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 224150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 224153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224162 */     GIR_RootConstrainSelectedInstOperands,
     /* 224163 */     // GIR_Coverage, 7936,
     /* 224163 */     GIR_EraseRootFromParent_Done,
     /* 224164 */   // Label 4268: @224164
     /* 224164 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(224241), // Rule ID 7937 //
     /* 224169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 224177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224221 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 224225 */     // MIs[2] Operand 1
     /* 224225 */     // No operand predicates
     /* 224225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224227 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 224227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 224230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224239 */     GIR_RootConstrainSelectedInstOperands,
     /* 224240 */     // GIR_Coverage, 7937,
     /* 224240 */     GIR_EraseRootFromParent_Done,
     /* 224241 */   // Label 4269: @224241
     /* 224241 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(224318), // Rule ID 7938 //
     /* 224246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 224254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224298 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224302 */     // MIs[2] Operand 1
     /* 224302 */     // No operand predicates
     /* 224302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224304 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1539:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 224304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 224307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224316 */     GIR_RootConstrainSelectedInstOperands,
     /* 224317 */     // GIR_Coverage, 7938,
     /* 224317 */     GIR_EraseRootFromParent_Done,
     /* 224318 */   // Label 4270: @224318
     /* 224318 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(224395), // Rule ID 7939 //
     /* 224323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 224331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224375 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 224379 */     // MIs[2] Operand 1
     /* 224379 */     // No operand predicates
     /* 224379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224381 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 224381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 224384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224393 */     GIR_RootConstrainSelectedInstOperands,
     /* 224394 */     // GIR_Coverage, 7939,
     /* 224394 */     GIR_EraseRootFromParent_Done,
     /* 224395 */   // Label 4271: @224395
     /* 224395 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(224472), // Rule ID 7940 //
     /* 224400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 224408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224452 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 224456 */     // MIs[2] Operand 1
     /* 224456 */     // No operand predicates
     /* 224456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224458 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 224458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 224461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224470 */     GIR_RootConstrainSelectedInstOperands,
     /* 224471 */     // GIR_Coverage, 7940,
     /* 224471 */     GIR_EraseRootFromParent_Done,
     /* 224472 */   // Label 4272: @224472
     /* 224472 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(224549), // Rule ID 7941 //
     /* 224477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 224485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224529 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 224533 */     // MIs[2] Operand 1
     /* 224533 */     // No operand predicates
     /* 224533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224535 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 224535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 224538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224547 */     GIR_RootConstrainSelectedInstOperands,
     /* 224548 */     // GIR_Coverage, 7941,
     /* 224548 */     GIR_EraseRootFromParent_Done,
     /* 224549 */   // Label 4273: @224549
     /* 224549 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(224626), // Rule ID 7942 //
     /* 224554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 224562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224606 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 224610 */     // MIs[2] Operand 1
     /* 224610 */     // No operand predicates
     /* 224610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224612 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 224612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 224615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224624 */     GIR_RootConstrainSelectedInstOperands,
     /* 224625 */     // GIR_Coverage, 7942,
     /* 224625 */     GIR_EraseRootFromParent_Done,
     /* 224626 */   // Label 4274: @224626
     /* 224626 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(224703), // Rule ID 7943 //
     /* 224631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 224639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224683 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 224687 */     // MIs[2] Operand 1
     /* 224687 */     // No operand predicates
     /* 224687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224689 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 224689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 224692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224701 */     GIR_RootConstrainSelectedInstOperands,
     /* 224702 */     // GIR_Coverage, 7943,
     /* 224702 */     GIR_EraseRootFromParent_Done,
     /* 224703 */   // Label 4275: @224703
     /* 224703 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(224780), // Rule ID 7944 //
     /* 224708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 224716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224760 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 224764 */     // MIs[2] Operand 1
     /* 224764 */     // No operand predicates
     /* 224764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224766 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1477:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 224766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 224769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224778 */     GIR_RootConstrainSelectedInstOperands,
     /* 224779 */     // GIR_Coverage, 7944,
     /* 224779 */     GIR_EraseRootFromParent_Done,
     /* 224780 */   // Label 4276: @224780
     /* 224780 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(224857), // Rule ID 7945 //
     /* 224785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224837 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 224841 */     // MIs[2] Operand 1
     /* 224841 */     // No operand predicates
     /* 224841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224843 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 224843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 224846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224855 */     GIR_RootConstrainSelectedInstOperands,
     /* 224856 */     // GIR_Coverage, 7945,
     /* 224856 */     GIR_EraseRootFromParent_Done,
     /* 224857 */   // Label 4277: @224857
     /* 224857 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(224934), // Rule ID 7946 //
     /* 224862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224914 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224918 */     // MIs[2] Operand 1
     /* 224918 */     // No operand predicates
     /* 224918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224920 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 224920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 224923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224932 */     GIR_RootConstrainSelectedInstOperands,
     /* 224933 */     // GIR_Coverage, 7946,
     /* 224933 */     GIR_EraseRootFromParent_Done,
     /* 224934 */   // Label 4278: @224934
     /* 224934 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(225011), // Rule ID 7947 //
     /* 224939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 224947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224991 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 224995 */     // MIs[2] Operand 1
     /* 224995 */     // No operand predicates
     /* 224995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224997 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 224997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 225000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225009 */     GIR_RootConstrainSelectedInstOperands,
     /* 225010 */     // GIR_Coverage, 7947,
     /* 225010 */     GIR_EraseRootFromParent_Done,
     /* 225011 */   // Label 4279: @225011
     /* 225011 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(225088), // Rule ID 7948 //
     /* 225016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 225024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 225060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225068 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 225072 */     // MIs[2] Operand 1
     /* 225072 */     // No operand predicates
     /* 225072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225074 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 225074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 225077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225086 */     GIR_RootConstrainSelectedInstOperands,
     /* 225087 */     // GIR_Coverage, 7948,
     /* 225087 */     GIR_EraseRootFromParent_Done,
     /* 225088 */   // Label 4280: @225088
     /* 225088 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(225165), // Rule ID 7949 //
     /* 225093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 225101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 225137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225145 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 225149 */     // MIs[2] Operand 1
     /* 225149 */     // No operand predicates
     /* 225149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225151 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 225151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 225154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225163 */     GIR_RootConstrainSelectedInstOperands,
     /* 225164 */     // GIR_Coverage, 7949,
     /* 225164 */     GIR_EraseRootFromParent_Done,
     /* 225165 */   // Label 4281: @225165
     /* 225165 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(225242), // Rule ID 7950 //
     /* 225170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 225178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 225214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225222 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 225226 */     // MIs[2] Operand 1
     /* 225226 */     // No operand predicates
     /* 225226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225228 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1541:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 225228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 225231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225240 */     GIR_RootConstrainSelectedInstOperands,
     /* 225241 */     // GIR_Coverage, 7950,
     /* 225241 */     GIR_EraseRootFromParent_Done,
     /* 225242 */   // Label 4282: @225242
     /* 225242 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(225319), // Rule ID 7951 //
     /* 225247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 225255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 225291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225299 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 225303 */     // MIs[2] Operand 1
     /* 225303 */     // No operand predicates
     /* 225303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225305 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 225305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 225308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225317 */     GIR_RootConstrainSelectedInstOperands,
     /* 225318 */     // GIR_Coverage, 7951,
     /* 225318 */     GIR_EraseRootFromParent_Done,
     /* 225319 */   // Label 4283: @225319
     /* 225319 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(225396), // Rule ID 7952 //
     /* 225324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 225332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 225368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225376 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 225380 */     // MIs[2] Operand 1
     /* 225380 */     // No operand predicates
     /* 225380 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225382 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 225382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 225385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225394 */     GIR_RootConstrainSelectedInstOperands,
     /* 225395 */     // GIR_Coverage, 7952,
     /* 225395 */     GIR_EraseRootFromParent_Done,
     /* 225396 */   // Label 4284: @225396
     /* 225396 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(225473), // Rule ID 7953 //
     /* 225401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 225409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 225445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225453 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 225457 */     // MIs[2] Operand 1
     /* 225457 */     // No operand predicates
     /* 225457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225459 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 225459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 225462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225471 */     GIR_RootConstrainSelectedInstOperands,
     /* 225472 */     // GIR_Coverage, 7953,
     /* 225472 */     GIR_EraseRootFromParent_Done,
     /* 225473 */   // Label 4285: @225473
     /* 225473 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(225550), // Rule ID 7954 //
     /* 225478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 225486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 225522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225530 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 225534 */     // MIs[2] Operand 1
     /* 225534 */     // No operand predicates
     /* 225534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225536 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 225536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 225539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225548 */     GIR_RootConstrainSelectedInstOperands,
     /* 225549 */     // GIR_Coverage, 7954,
     /* 225549 */     GIR_EraseRootFromParent_Done,
     /* 225550 */   // Label 4286: @225550
     /* 225550 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(225627), // Rule ID 7955 //
     /* 225555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 225563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 225599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225607 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 225611 */     // MIs[2] Operand 1
     /* 225611 */     // No operand predicates
     /* 225611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225613 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 225613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 225616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225625 */     GIR_RootConstrainSelectedInstOperands,
     /* 225626 */     // GIR_Coverage, 7955,
     /* 225626 */     GIR_EraseRootFromParent_Done,
     /* 225627 */   // Label 4287: @225627
     /* 225627 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(225704), // Rule ID 7956 //
     /* 225632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 225640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 225676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225684 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 225688 */     // MIs[2] Operand 1
     /* 225688 */     // No operand predicates
     /* 225688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225690 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1431:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 225690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 225693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225702 */     GIR_RootConstrainSelectedInstOperands,
     /* 225703 */     // GIR_Coverage, 7956,
     /* 225703 */     GIR_EraseRootFromParent_Done,
     /* 225704 */   // Label 4288: @225704
     /* 225704 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(225781), // Rule ID 7957 //
     /* 225709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 225717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 225753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225761 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 225765 */     // MIs[2] Operand 1
     /* 225765 */     // No operand predicates
     /* 225765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225767 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 225767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 225770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225779 */     GIR_RootConstrainSelectedInstOperands,
     /* 225780 */     // GIR_Coverage, 7957,
     /* 225780 */     GIR_EraseRootFromParent_Done,
     /* 225781 */   // Label 4289: @225781
     /* 225781 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(225858), // Rule ID 7958 //
     /* 225786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 225794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 225830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225838 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 225842 */     // MIs[2] Operand 1
     /* 225842 */     // No operand predicates
     /* 225842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225844 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 225844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 225847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 225856 */     GIR_RootConstrainSelectedInstOperands,
     /* 225857 */     // GIR_Coverage, 7958,
     /* 225857 */     GIR_EraseRootFromParent_Done,
     /* 225858 */   // Label 4290: @225858
     /* 225858 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(225935), // Rule ID 7959 //
     /* 225863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 225871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 225907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225915 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 225919 */     // MIs[2] Operand 1
     /* 225919 */     // No operand predicates
     /* 225919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225921 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 225921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 225924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 225928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 225930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 225933 */     GIR_RootConstrainSelectedInstOperands,
     /* 225934 */     // GIR_Coverage, 7959,
     /* 225934 */     GIR_EraseRootFromParent_Done,
     /* 225935 */   // Label 4291: @225935
     /* 225935 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(226012), // Rule ID 7960 //
     /* 225940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 225948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 225968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 225976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 225980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 225984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 225988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 225992 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 225996 */     // MIs[2] Operand 1
     /* 225996 */     // No operand predicates
     /* 225996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 225998 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 225998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 226001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226010 */     GIR_RootConstrainSelectedInstOperands,
     /* 226011 */     // GIR_Coverage, 7960,
     /* 226011 */     GIR_EraseRootFromParent_Done,
     /* 226012 */   // Label 4292: @226012
     /* 226012 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(226089), // Rule ID 7961 //
     /* 226017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 226025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 226061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226069 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 226073 */     // MIs[2] Operand 1
     /* 226073 */     // No operand predicates
     /* 226073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226075 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 226075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 226078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226087 */     GIR_RootConstrainSelectedInstOperands,
     /* 226088 */     // GIR_Coverage, 7961,
     /* 226088 */     GIR_EraseRootFromParent_Done,
     /* 226089 */   // Label 4293: @226089
     /* 226089 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(226166), // Rule ID 7962 //
     /* 226094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 226102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 226138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226146 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 226150 */     // MIs[2] Operand 1
     /* 226150 */     // No operand predicates
     /* 226150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226152 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1449:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 226152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 226155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226164 */     GIR_RootConstrainSelectedInstOperands,
     /* 226165 */     // GIR_Coverage, 7962,
     /* 226165 */     GIR_EraseRootFromParent_Done,
     /* 226166 */   // Label 4294: @226166
     /* 226166 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(226243), // Rule ID 7963 //
     /* 226171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 226179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 226215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226223 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 226227 */     // MIs[2] Operand 1
     /* 226227 */     // No operand predicates
     /* 226227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226229 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 226229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 226232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226241 */     GIR_RootConstrainSelectedInstOperands,
     /* 226242 */     // GIR_Coverage, 7963,
     /* 226242 */     GIR_EraseRootFromParent_Done,
     /* 226243 */   // Label 4295: @226243
     /* 226243 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(226320), // Rule ID 7964 //
     /* 226248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 226256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 226292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226300 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 226304 */     // MIs[2] Operand 1
     /* 226304 */     // No operand predicates
     /* 226304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226306 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 226306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 226309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226318 */     GIR_RootConstrainSelectedInstOperands,
     /* 226319 */     // GIR_Coverage, 7964,
     /* 226319 */     GIR_EraseRootFromParent_Done,
     /* 226320 */   // Label 4296: @226320
     /* 226320 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(226397), // Rule ID 7965 //
     /* 226325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 226333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 226369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226377 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 226381 */     // MIs[2] Operand 1
     /* 226381 */     // No operand predicates
     /* 226381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226383 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 226383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 226386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226395 */     GIR_RootConstrainSelectedInstOperands,
     /* 226396 */     // GIR_Coverage, 7965,
     /* 226396 */     GIR_EraseRootFromParent_Done,
     /* 226397 */   // Label 4297: @226397
     /* 226397 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(226474), // Rule ID 7966 //
     /* 226402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 226410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 226446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226454 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 226458 */     // MIs[2] Operand 1
     /* 226458 */     // No operand predicates
     /* 226458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226460 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 226460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 226463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226472 */     GIR_RootConstrainSelectedInstOperands,
     /* 226473 */     // GIR_Coverage, 7966,
     /* 226473 */     GIR_EraseRootFromParent_Done,
     /* 226474 */   // Label 4298: @226474
     /* 226474 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(226551), // Rule ID 7967 //
     /* 226479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 226487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 226523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226531 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 226535 */     // MIs[2] Operand 1
     /* 226535 */     // No operand predicates
     /* 226535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226537 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 226537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 226540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226549 */     GIR_RootConstrainSelectedInstOperands,
     /* 226550 */     // GIR_Coverage, 7967,
     /* 226550 */     GIR_EraseRootFromParent_Done,
     /* 226551 */   // Label 4299: @226551
     /* 226551 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(226628), // Rule ID 7968 //
     /* 226556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 226564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 226600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226608 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 226612 */     // MIs[2] Operand 1
     /* 226612 */     // No operand predicates
     /* 226612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226614 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1425:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 226614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 226617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226626 */     GIR_RootConstrainSelectedInstOperands,
     /* 226627 */     // GIR_Coverage, 7968,
     /* 226627 */     GIR_EraseRootFromParent_Done,
     /* 226628 */   // Label 4300: @226628
     /* 226628 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(226705), // Rule ID 7969 //
     /* 226633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 226641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 226677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226685 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 226689 */     // MIs[2] Operand 1
     /* 226689 */     // No operand predicates
     /* 226689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226691 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 226691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 226694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226703 */     GIR_RootConstrainSelectedInstOperands,
     /* 226704 */     // GIR_Coverage, 7969,
     /* 226704 */     GIR_EraseRootFromParent_Done,
     /* 226705 */   // Label 4301: @226705
     /* 226705 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(226782), // Rule ID 7970 //
     /* 226710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 226718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 226730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 226754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226762 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 226766 */     // MIs[2] Operand 1
     /* 226766 */     // No operand predicates
     /* 226766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226768 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 226768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 226771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226780 */     GIR_RootConstrainSelectedInstOperands,
     /* 226781 */     // GIR_Coverage, 7970,
     /* 226781 */     GIR_EraseRootFromParent_Done,
     /* 226782 */   // Label 4302: @226782
     /* 226782 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(226859), // Rule ID 7971 //
     /* 226787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 226795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 226831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226839 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 226843 */     // MIs[2] Operand 1
     /* 226843 */     // No operand predicates
     /* 226843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226845 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 226845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 226848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 226857 */     GIR_RootConstrainSelectedInstOperands,
     /* 226858 */     // GIR_Coverage, 7971,
     /* 226858 */     GIR_EraseRootFromParent_Done,
     /* 226859 */   // Label 4303: @226859
     /* 226859 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(226936), // Rule ID 7972 //
     /* 226864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 226872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 226908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226916 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 226920 */     // MIs[2] Operand 1
     /* 226920 */     // No operand predicates
     /* 226920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226922 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 226922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 226925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 226929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 226931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 226934 */     GIR_RootConstrainSelectedInstOperands,
     /* 226935 */     // GIR_Coverage, 7972,
     /* 226935 */     GIR_EraseRootFromParent_Done,
     /* 226936 */   // Label 4304: @226936
     /* 226936 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(227013), // Rule ID 7973 //
     /* 226941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 226949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 226969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 226977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 226981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 226985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 226989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 226993 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 226997 */     // MIs[2] Operand 1
     /* 226997 */     // No operand predicates
     /* 226997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 226999 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 226999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 227002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 227006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 227008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 227011 */     GIR_RootConstrainSelectedInstOperands,
     /* 227012 */     // GIR_Coverage, 7973,
     /* 227012 */     GIR_EraseRootFromParent_Done,
     /* 227013 */   // Label 4305: @227013
     /* 227013 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(227090), // Rule ID 7974 //
     /* 227018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 227026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 227046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 227054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 227058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 227062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 227066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 227070 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 227074 */     // MIs[2] Operand 1
     /* 227074 */     // No operand predicates
     /* 227074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 227076 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1443:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 227076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 227079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 227083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 227085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 227088 */     GIR_RootConstrainSelectedInstOperands,
     /* 227089 */     // GIR_Coverage, 7974,
     /* 227089 */     GIR_EraseRootFromParent_Done,
     /* 227090 */   // Label 4306: @227090
     /* 227090 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(227146), // Rule ID 55 //
     /* 227095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 227098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 227103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 227106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 227109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 227112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 227116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 227120 */     // MIs[0] Operand 3
     /* 227120 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 227131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 227135 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 227135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 227138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 227142 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 227144 */     GIR_RootConstrainSelectedInstOperands,
     /* 227145 */     // GIR_Coverage, 55,
     /* 227145 */     GIR_EraseRootFromParent_Done,
     /* 227146 */   // Label 4307: @227146
     /* 227146 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(227202), // Rule ID 56 //
     /* 227151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 227154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 227159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 227162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 227165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 227168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 227172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 227176 */     // MIs[0] Operand 3
     /* 227176 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 227187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 227191 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 227191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 227194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 227198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 227200 */     GIR_RootConstrainSelectedInstOperands,
     /* 227201 */     // GIR_Coverage, 56,
     /* 227201 */     GIR_EraseRootFromParent_Done,
     /* 227202 */   // Label 4308: @227202
     /* 227202 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(227258), // Rule ID 57 //
     /* 227207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 227210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 227215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 227218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 227221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 227224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 227228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 227232 */     // MIs[0] Operand 3
     /* 227232 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 227243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 227247 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 227247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 227250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 227254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 227256 */     GIR_RootConstrainSelectedInstOperands,
     /* 227257 */     // GIR_Coverage, 57,
     /* 227257 */     GIR_EraseRootFromParent_Done,
     /* 227258 */   // Label 4309: @227258
     /* 227258 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(227314), // Rule ID 58 //
     /* 227263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 227266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 227271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 227274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 227277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 227280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 227284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 227288 */     // MIs[0] Operand 3
     /* 227288 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 227299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 227303 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 227303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 227306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 227310 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 227312 */     GIR_RootConstrainSelectedInstOperands,
     /* 227313 */     // GIR_Coverage, 58,
     /* 227313 */     GIR_EraseRootFromParent_Done,
     /* 227314 */   // Label 4310: @227314
     /* 227314 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(227369), // Rule ID 2799 //
     /* 227319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 227322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 227327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227348 */     // MIs[0] imm
     /* 227348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 227356 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1542:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 227356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 227359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 227363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 227365 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 227367 */     GIR_RootConstrainSelectedInstOperands,
     /* 227368 */     // GIR_Coverage, 2799,
     /* 227368 */     GIR_EraseRootFromParent_Done,
     /* 227369 */   // Label 4311: @227369
     /* 227369 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(227424), // Rule ID 2800 //
     /* 227374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 227377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 227382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227403 */     // MIs[0] imm
     /* 227403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 227411 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1542:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 227411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 227414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 227418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 227420 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 227422 */     GIR_RootConstrainSelectedInstOperands,
     /* 227423 */     // GIR_Coverage, 2800,
     /* 227423 */     GIR_EraseRootFromParent_Done,
     /* 227424 */   // Label 4312: @227424
     /* 227424 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(227479), // Rule ID 2801 //
     /* 227429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 227432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 227437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227458 */     // MIs[0] imm
     /* 227458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227461 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 227466 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1542:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 227466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 227469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 227473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 227475 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 227477 */     GIR_RootConstrainSelectedInstOperands,
     /* 227478 */     // GIR_Coverage, 2801,
     /* 227478 */     GIR_EraseRootFromParent_Done,
     /* 227479 */   // Label 4313: @227479
     /* 227479 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(227534), // Rule ID 3552 //
     /* 227484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 227487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 227492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 227501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227513 */     // MIs[0] Idx
     /* 227513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 227521 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 227521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 227524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 227528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 227530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 227532 */     GIR_RootConstrainSelectedInstOperands,
     /* 227533 */     // GIR_Coverage, 3552,
     /* 227533 */     GIR_EraseRootFromParent_Done,
     /* 227534 */   // Label 4314: @227534
     /* 227534 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(227589), // Rule ID 3553 //
     /* 227539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 227542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 227547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 227556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227568 */     // MIs[0] Idx
     /* 227568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227571 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 227576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 227576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 227579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 227583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 227585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 227587 */     GIR_RootConstrainSelectedInstOperands,
     /* 227588 */     // GIR_Coverage, 3553,
     /* 227588 */     GIR_EraseRootFromParent_Done,
     /* 227589 */   // Label 4315: @227589
     /* 227589 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(227644), // Rule ID 3554 //
     /* 227594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 227597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 227602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 227611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227623 */     // MIs[0] Idx
     /* 227623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 227631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1628:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 227631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 227634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 227638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 227640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 227642 */     GIR_RootConstrainSelectedInstOperands,
     /* 227643 */     // GIR_Coverage, 3554,
     /* 227643 */     GIR_EraseRootFromParent_Done,
     /* 227644 */   // Label 4316: @227644
     /* 227644 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(227699), // Rule ID 3844 //
     /* 227649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 227652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 227657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 227660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 227663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 227666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 227670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 227674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 227678 */     // MIs[0] imm
     /* 227678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 227686 */     // (intrinsic_wo_chain:{ *:[v2i64] } 543:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 227686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 227689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 227691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 227693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 227695 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 227697 */     GIR_RootConstrainSelectedInstOperands,
     /* 227698 */     // GIR_Coverage, 3844,
     /* 227698 */     GIR_EraseRootFromParent_Done,
     /* 227699 */   // Label 4317: @227699
     /* 227699 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(227746), // Rule ID 2853 //
     /* 227704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 227712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227725 */     // MIs[0] idx
     /* 227725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227728 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227733 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1478:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 227733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 227736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227742 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 227744 */     GIR_RootConstrainSelectedInstOperands,
     /* 227745 */     // GIR_Coverage, 2853,
     /* 227745 */     GIR_EraseRootFromParent_Done,
     /* 227746 */   // Label 4318: @227746
     /* 227746 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(227793), // Rule ID 2854 //
     /* 227751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 227759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227772 */     // MIs[0] idx
     /* 227772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227775 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227780 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1478:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 227780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 227783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227789 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 227791 */     GIR_RootConstrainSelectedInstOperands,
     /* 227792 */     // GIR_Coverage, 2854,
     /* 227792 */     GIR_EraseRootFromParent_Done,
     /* 227793 */   // Label 4319: @227793
     /* 227793 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(227840), // Rule ID 2855 //
     /* 227798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 227806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227819 */     // MIs[0] idx
     /* 227819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227822 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 227827 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1478:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 227827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 227830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227836 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 227838 */     GIR_RootConstrainSelectedInstOperands,
     /* 227839 */     // GIR_Coverage, 2855,
     /* 227839 */     GIR_EraseRootFromParent_Done,
     /* 227840 */   // Label 4320: @227840
     /* 227840 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(227887), // Rule ID 3004 //
     /* 227845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 227853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227866 */     // MIs[0] Op3
     /* 227866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227869 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227874 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1609:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 227877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227883 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227885 */     GIR_RootConstrainSelectedInstOperands,
     /* 227886 */     // GIR_Coverage, 3004,
     /* 227886 */     GIR_EraseRootFromParent_Done,
     /* 227887 */   // Label 4321: @227887
     /* 227887 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(227934), // Rule ID 3005 //
     /* 227892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 227900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227913 */     // MIs[0] Op3
     /* 227913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227916 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227921 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1609:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 227924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227932 */     GIR_RootConstrainSelectedInstOperands,
     /* 227933 */     // GIR_Coverage, 3005,
     /* 227933 */     GIR_EraseRootFromParent_Done,
     /* 227934 */   // Label 4322: @227934
     /* 227934 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(227981), // Rule ID 3006 //
     /* 227939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 227947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227960 */     // MIs[0] Op3
     /* 227960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 227968 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1609:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 227968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 227971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227979 */     GIR_RootConstrainSelectedInstOperands,
     /* 227980 */     // GIR_Coverage, 3006,
     /* 227980 */     GIR_EraseRootFromParent_Done,
     /* 227981 */   // Label 4323: @227981
     /* 227981 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(228028), // Rule ID 3007 //
     /* 227986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 227994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228007 */     // MIs[0] Op3
     /* 228007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 228015 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1755:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 228015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 228018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228024 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228026 */     GIR_RootConstrainSelectedInstOperands,
     /* 228027 */     // GIR_Coverage, 3007,
     /* 228027 */     GIR_EraseRootFromParent_Done,
     /* 228028 */   // Label 4324: @228028
     /* 228028 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(228075), // Rule ID 3008 //
     /* 228033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 228041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228054 */     // MIs[0] Op3
     /* 228054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 228062 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1755:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 228062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 228065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228073 */     GIR_RootConstrainSelectedInstOperands,
     /* 228074 */     // GIR_Coverage, 3008,
     /* 228074 */     GIR_EraseRootFromParent_Done,
     /* 228075 */   // Label 4325: @228075
     /* 228075 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(228122), // Rule ID 3056 //
     /* 228080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 228088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228101 */     // MIs[0] Op3
     /* 228101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228104 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228109 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1866:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 228112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228120 */     GIR_RootConstrainSelectedInstOperands,
     /* 228121 */     // GIR_Coverage, 3056,
     /* 228121 */     GIR_EraseRootFromParent_Done,
     /* 228122 */   // Label 4326: @228122
     /* 228122 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(228169), // Rule ID 3058 //
     /* 228127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 228135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228148 */     // MIs[0] Op3
     /* 228148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228151 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228156 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1866:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 228159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228167 */     GIR_RootConstrainSelectedInstOperands,
     /* 228168 */     // GIR_Coverage, 3058,
     /* 228168 */     GIR_EraseRootFromParent_Done,
     /* 228169 */   // Label 4327: @228169
     /* 228169 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(228216), // Rule ID 3060 //
     /* 228174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 228182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228195 */     // MIs[0] Op3
     /* 228195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228203 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1866:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 228206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228214 */     GIR_RootConstrainSelectedInstOperands,
     /* 228215 */     // GIR_Coverage, 3060,
     /* 228215 */     GIR_EraseRootFromParent_Done,
     /* 228216 */   // Label 4328: @228216
     /* 228216 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(228263), // Rule ID 3062 //
     /* 228221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 228229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228242 */     // MIs[0] Op3
     /* 228242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228245 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228250 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1866:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 228253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228261 */     GIR_RootConstrainSelectedInstOperands,
     /* 228262 */     // GIR_Coverage, 3062,
     /* 228262 */     GIR_EraseRootFromParent_Done,
     /* 228263 */   // Label 4329: @228263
     /* 228263 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(228310), // Rule ID 3084 //
     /* 228268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 228276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228289 */     // MIs[0] Op3
     /* 228289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228292 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228297 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1846:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 228300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228308 */     GIR_RootConstrainSelectedInstOperands,
     /* 228309 */     // GIR_Coverage, 3084,
     /* 228309 */     GIR_EraseRootFromParent_Done,
     /* 228310 */   // Label 4330: @228310
     /* 228310 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(228357), // Rule ID 3085 //
     /* 228315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 228323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228336 */     // MIs[0] Op3
     /* 228336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228339 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228344 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1846:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 228347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228353 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228355 */     GIR_RootConstrainSelectedInstOperands,
     /* 228356 */     // GIR_Coverage, 3085,
     /* 228356 */     GIR_EraseRootFromParent_Done,
     /* 228357 */   // Label 4331: @228357
     /* 228357 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(228404), // Rule ID 3086 //
     /* 228362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 228370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228383 */     // MIs[0] Op3
     /* 228383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228391 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1846:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 228394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228402 */     GIR_RootConstrainSelectedInstOperands,
     /* 228403 */     // GIR_Coverage, 3086,
     /* 228403 */     GIR_EraseRootFromParent_Done,
     /* 228404 */   // Label 4332: @228404
     /* 228404 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(228451), // Rule ID 3155 //
     /* 228409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 228417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228430 */     // MIs[0] Op3
     /* 228430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228438 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2147:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 228441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228449 */     GIR_RootConstrainSelectedInstOperands,
     /* 228450 */     // GIR_Coverage, 3155,
     /* 228450 */     GIR_EraseRootFromParent_Done,
     /* 228451 */   // Label 4333: @228451
     /* 228451 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(228498), // Rule ID 3156 //
     /* 228456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 228464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228477 */     // MIs[0] Op3
     /* 228477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228480 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228485 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2147:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 228488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228496 */     GIR_RootConstrainSelectedInstOperands,
     /* 228497 */     // GIR_Coverage, 3156,
     /* 228497 */     GIR_EraseRootFromParent_Done,
     /* 228498 */   // Label 4334: @228498
     /* 228498 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(228545), // Rule ID 3157 //
     /* 228503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 228511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228524 */     // MIs[0] Op3
     /* 228524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228527 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228532 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2147:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 228535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228541 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228543 */     GIR_RootConstrainSelectedInstOperands,
     /* 228544 */     // GIR_Coverage, 3157,
     /* 228544 */     GIR_EraseRootFromParent_Done,
     /* 228545 */   // Label 4335: @228545
     /* 228545 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(228592), // Rule ID 3158 //
     /* 228550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 228558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228571 */     // MIs[0] Op3
     /* 228571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228579 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2147:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 228582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228590 */     GIR_RootConstrainSelectedInstOperands,
     /* 228591 */     // GIR_Coverage, 3158,
     /* 228591 */     GIR_EraseRootFromParent_Done,
     /* 228592 */   // Label 4336: @228592
     /* 228592 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(228639), // Rule ID 3537 //
     /* 228597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 228600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 228605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228618 */     // MIs[0] Op3
     /* 228618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 228626 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1357:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 228626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 228629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 228631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228637 */     GIR_RootConstrainSelectedInstOperands,
     /* 228638 */     // GIR_Coverage, 3537,
     /* 228638 */     GIR_EraseRootFromParent_Done,
     /* 228639 */   // Label 4337: @228639
     /* 228639 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(228686), // Rule ID 3585 //
     /* 228644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 228647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 228652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228665 */     // MIs[0] Op3
     /* 228665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 228673 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1596:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 228673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 228676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228682 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228684 */     GIR_RootConstrainSelectedInstOperands,
     /* 228685 */     // GIR_Coverage, 3585,
     /* 228685 */     GIR_EraseRootFromParent_Done,
     /* 228686 */   // Label 4338: @228686
     /* 228686 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(228733), // Rule ID 3586 //
     /* 228691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 228694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 228699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228712 */     // MIs[0] Op3
     /* 228712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228715 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 228720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1596:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 228720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 228723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228731 */     GIR_RootConstrainSelectedInstOperands,
     /* 228732 */     // GIR_Coverage, 3586,
     /* 228732 */     GIR_EraseRootFromParent_Done,
     /* 228733 */   // Label 4339: @228733
     /* 228733 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(228780), // Rule ID 3587 //
     /* 228738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 228741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 228746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228759 */     // MIs[0] Op3
     /* 228759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228762 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 228767 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1596:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 228767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 228770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228778 */     GIR_RootConstrainSelectedInstOperands,
     /* 228779 */     // GIR_Coverage, 3587,
     /* 228779 */     GIR_EraseRootFromParent_Done,
     /* 228780 */   // Label 4340: @228780
     /* 228780 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(228827), // Rule ID 3588 //
     /* 228785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 228788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 228793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228806 */     // MIs[0] Op3
     /* 228806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 228814 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1597:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 228814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 228817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228825 */     GIR_RootConstrainSelectedInstOperands,
     /* 228826 */     // GIR_Coverage, 3588,
     /* 228826 */     GIR_EraseRootFromParent_Done,
     /* 228827 */   // Label 4341: @228827
     /* 228827 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(228874), // Rule ID 3589 //
     /* 228832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 228835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 228840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228853 */     // MIs[0] Op3
     /* 228853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228856 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 228861 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1597:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 228861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 228864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228872 */     GIR_RootConstrainSelectedInstOperands,
     /* 228873 */     // GIR_Coverage, 3589,
     /* 228873 */     GIR_EraseRootFromParent_Done,
     /* 228874 */   // Label 4342: @228874
     /* 228874 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(228921), // Rule ID 3590 //
     /* 228879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 228882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 228887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228900 */     // MIs[0] Op3
     /* 228900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 228908 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1597:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 228908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 228911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228919 */     GIR_RootConstrainSelectedInstOperands,
     /* 228920 */     // GIR_Coverage, 3590,
     /* 228920 */     GIR_EraseRootFromParent_Done,
     /* 228921 */   // Label 4343: @228921
     /* 228921 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(228968), // Rule ID 11391 //
     /* 228926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 228934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228947 */     // MIs[0] Op3
     /* 228947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228950 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 228955 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1796:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 228955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 228958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228966 */     GIR_RootConstrainSelectedInstOperands,
     /* 228967 */     // GIR_Coverage, 11391,
     /* 228967 */     GIR_EraseRootFromParent_Done,
     /* 228968 */   // Label 4344: @228968
     /* 228968 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(229015), // Rule ID 11392 //
     /* 228973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 228981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228994 */     // MIs[0] Op3
     /* 228994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228997 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 229002 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1796:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 229002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 229005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229011 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229013 */     GIR_RootConstrainSelectedInstOperands,
     /* 229014 */     // GIR_Coverage, 11392,
     /* 229014 */     GIR_EraseRootFromParent_Done,
     /* 229015 */   // Label 4345: @229015
     /* 229015 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(229062), // Rule ID 11393 //
     /* 229020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 229028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229041 */     // MIs[0] Op3
     /* 229041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 229049 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1796:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 229049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 229052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229060 */     GIR_RootConstrainSelectedInstOperands,
     /* 229061 */     // GIR_Coverage, 11393,
     /* 229061 */     GIR_EraseRootFromParent_Done,
     /* 229062 */   // Label 4346: @229062
     /* 229062 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(229109), // Rule ID 11394 //
     /* 229067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 229075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229088 */     // MIs[0] Op3
     /* 229088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229091 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 229096 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1827:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 229096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 229099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229107 */     GIR_RootConstrainSelectedInstOperands,
     /* 229108 */     // GIR_Coverage, 11394,
     /* 229108 */     GIR_EraseRootFromParent_Done,
     /* 229109 */   // Label 4347: @229109
     /* 229109 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(229156), // Rule ID 11395 //
     /* 229114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 229122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229135 */     // MIs[0] Op3
     /* 229135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 229143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1827:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 229143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 229146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229154 */     GIR_RootConstrainSelectedInstOperands,
     /* 229155 */     // GIR_Coverage, 11395,
     /* 229155 */     GIR_EraseRootFromParent_Done,
     /* 229156 */   // Label 4348: @229156
     /* 229156 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(229203), // Rule ID 11396 //
     /* 229161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 229169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229182 */     // MIs[0] Op3
     /* 229182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229185 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 229190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1827:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 229190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 229193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229201 */     GIR_RootConstrainSelectedInstOperands,
     /* 229202 */     // GIR_Coverage, 11396,
     /* 229202 */     GIR_EraseRootFromParent_Done,
     /* 229203 */   // Label 4349: @229203
     /* 229203 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(229250), // Rule ID 11419 //
     /* 229208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 229216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229229 */     // MIs[0] Op3
     /* 229229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 229237 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 229237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 229240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229248 */     GIR_RootConstrainSelectedInstOperands,
     /* 229249 */     // GIR_Coverage, 11419,
     /* 229249 */     GIR_EraseRootFromParent_Done,
     /* 229250 */   // Label 4350: @229250
     /* 229250 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(229297), // Rule ID 11420 //
     /* 229255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 229263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229276 */     // MIs[0] Op3
     /* 229276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 229284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 229284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 229287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229295 */     GIR_RootConstrainSelectedInstOperands,
     /* 229296 */     // GIR_Coverage, 11420,
     /* 229296 */     GIR_EraseRootFromParent_Done,
     /* 229297 */   // Label 4351: @229297
     /* 229297 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(229344), // Rule ID 11421 //
     /* 229302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 229310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229323 */     // MIs[0] Op3
     /* 229323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229326 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 229331 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1993:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 229331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 229334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229342 */     GIR_RootConstrainSelectedInstOperands,
     /* 229343 */     // GIR_Coverage, 11421,
     /* 229343 */     GIR_EraseRootFromParent_Done,
     /* 229344 */   // Label 4352: @229344
     /* 229344 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(229391), // Rule ID 11422 //
     /* 229349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 229357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229370 */     // MIs[0] Op3
     /* 229370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229373 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 229378 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1993:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 229378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 229381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229387 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229389 */     GIR_RootConstrainSelectedInstOperands,
     /* 229390 */     // GIR_Coverage, 11422,
     /* 229390 */     GIR_EraseRootFromParent_Done,
     /* 229391 */   // Label 4353: @229391
     /* 229391 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(229438), // Rule ID 11423 //
     /* 229396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 229404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229417 */     // MIs[0] Op3
     /* 229417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229420 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 229425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1995:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 229425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 229428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229436 */     GIR_RootConstrainSelectedInstOperands,
     /* 229437 */     // GIR_Coverage, 11423,
     /* 229437 */     GIR_EraseRootFromParent_Done,
     /* 229438 */   // Label 4354: @229438
     /* 229438 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(229485), // Rule ID 11424 //
     /* 229443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 229451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229464 */     // MIs[0] Op3
     /* 229464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 229472 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1995:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 229472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 229475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229481 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229483 */     GIR_RootConstrainSelectedInstOperands,
     /* 229484 */     // GIR_Coverage, 11424,
     /* 229484 */     GIR_EraseRootFromParent_Done,
     /* 229485 */   // Label 4355: @229485
     /* 229485 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(229532), // Rule ID 11425 //
     /* 229490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 229498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229511 */     // MIs[0] Op3
     /* 229511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 229519 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1802:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 229519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 229522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229530 */     GIR_RootConstrainSelectedInstOperands,
     /* 229531 */     // GIR_Coverage, 11425,
     /* 229531 */     GIR_EraseRootFromParent_Done,
     /* 229532 */   // Label 4356: @229532
     /* 229532 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(229579), // Rule ID 11426 //
     /* 229537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 229545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229558 */     // MIs[0] Op3
     /* 229558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 229566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1802:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 229566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 229569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229577 */     GIR_RootConstrainSelectedInstOperands,
     /* 229578 */     // GIR_Coverage, 11426,
     /* 229578 */     GIR_EraseRootFromParent_Done,
     /* 229579 */   // Label 4357: @229579
     /* 229579 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(229626), // Rule ID 11427 //
     /* 229584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 229592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229605 */     // MIs[0] Op3
     /* 229605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229608 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 229613 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1804:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 229613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 229616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229624 */     GIR_RootConstrainSelectedInstOperands,
     /* 229625 */     // GIR_Coverage, 11427,
     /* 229625 */     GIR_EraseRootFromParent_Done,
     /* 229626 */   // Label 4358: @229626
     /* 229626 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(229673), // Rule ID 11428 //
     /* 229631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 229639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229652 */     // MIs[0] Op3
     /* 229652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 229660 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1804:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 229660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 229663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229671 */     GIR_RootConstrainSelectedInstOperands,
     /* 229672 */     // GIR_Coverage, 11428,
     /* 229672 */     GIR_EraseRootFromParent_Done,
     /* 229673 */   // Label 4359: @229673
     /* 229673 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(229720), // Rule ID 11672 //
     /* 229678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 229686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229699 */     // MIs[0] Op3
     /* 229699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229707 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1862:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 229710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229718 */     GIR_RootConstrainSelectedInstOperands,
     /* 229719 */     // GIR_Coverage, 11672,
     /* 229719 */     GIR_EraseRootFromParent_Done,
     /* 229720 */   // Label 4360: @229720
     /* 229720 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(229767), // Rule ID 11673 //
     /* 229725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 229733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229746 */     // MIs[0] Op3
     /* 229746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229749 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229754 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1862:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 229757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229765 */     GIR_RootConstrainSelectedInstOperands,
     /* 229766 */     // GIR_Coverage, 11673,
     /* 229766 */     GIR_EraseRootFromParent_Done,
     /* 229767 */   // Label 4361: @229767
     /* 229767 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(229814), // Rule ID 11674 //
     /* 229772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 229780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229793 */     // MIs[0] Op3
     /* 229793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229801 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1862:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 229804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229812 */     GIR_RootConstrainSelectedInstOperands,
     /* 229813 */     // GIR_Coverage, 11674,
     /* 229813 */     GIR_EraseRootFromParent_Done,
     /* 229814 */   // Label 4362: @229814
     /* 229814 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(229861), // Rule ID 11675 //
     /* 229819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 229827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229840 */     // MIs[0] Op3
     /* 229840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 229848 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1862:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 229848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 229851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229859 */     GIR_RootConstrainSelectedInstOperands,
     /* 229860 */     // GIR_Coverage, 11675,
     /* 229860 */     GIR_EraseRootFromParent_Done,
     /* 229861 */   // Label 4363: @229861
     /* 229861 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(229908), // Rule ID 11676 //
     /* 229866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 229874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229887 */     // MIs[0] Op3
     /* 229887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229895 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2053:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 229898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229906 */     GIR_RootConstrainSelectedInstOperands,
     /* 229907 */     // GIR_Coverage, 11676,
     /* 229907 */     GIR_EraseRootFromParent_Done,
     /* 229908 */   // Label 4364: @229908
     /* 229908 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(229955), // Rule ID 11678 //
     /* 229913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 229921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229934 */     // MIs[0] Op3
     /* 229934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229942 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2053:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 229945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229951 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229953 */     GIR_RootConstrainSelectedInstOperands,
     /* 229954 */     // GIR_Coverage, 11678,
     /* 229954 */     GIR_EraseRootFromParent_Done,
     /* 229955 */   // Label 4365: @229955
     /* 229955 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(230002), // Rule ID 11680 //
     /* 229960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 229968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229981 */     // MIs[0] Op3
     /* 229981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229989 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 229992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230000 */     GIR_RootConstrainSelectedInstOperands,
     /* 230001 */     // GIR_Coverage, 11680,
     /* 230001 */     GIR_EraseRootFromParent_Done,
     /* 230002 */   // Label 4366: @230002
     /* 230002 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(230049), // Rule ID 11682 //
     /* 230007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 230015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230028 */     // MIs[0] Op3
     /* 230028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 230036 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2053:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 230036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 230039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230047 */     GIR_RootConstrainSelectedInstOperands,
     /* 230048 */     // GIR_Coverage, 11682,
     /* 230048 */     GIR_EraseRootFromParent_Done,
     /* 230049 */   // Label 4367: @230049
     /* 230049 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(230096), // Rule ID 11684 //
     /* 230054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 230062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 230068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230075 */     // MIs[0] Op3
     /* 230075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 230083 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1842:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 230083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 230086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230094 */     GIR_RootConstrainSelectedInstOperands,
     /* 230095 */     // GIR_Coverage, 11684,
     /* 230095 */     GIR_EraseRootFromParent_Done,
     /* 230096 */   // Label 4368: @230096
     /* 230096 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(230143), // Rule ID 11685 //
     /* 230101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 230109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 230115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230122 */     // MIs[0] Op3
     /* 230122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230125 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 230130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1842:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 230130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 230133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230141 */     GIR_RootConstrainSelectedInstOperands,
     /* 230142 */     // GIR_Coverage, 11685,
     /* 230142 */     GIR_EraseRootFromParent_Done,
     /* 230143 */   // Label 4369: @230143
     /* 230143 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(230190), // Rule ID 11686 //
     /* 230148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 230156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 230162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230169 */     // MIs[0] Op3
     /* 230169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 230177 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1842:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 230177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 230180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230188 */     GIR_RootConstrainSelectedInstOperands,
     /* 230189 */     // GIR_Coverage, 11686,
     /* 230189 */     GIR_EraseRootFromParent_Done,
     /* 230190 */   // Label 4370: @230190
     /* 230190 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(230237), // Rule ID 11687 //
     /* 230195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 230203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 230209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230216 */     // MIs[0] Op3
     /* 230216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 230224 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1842:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 230224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 230227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 230229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230235 */     GIR_RootConstrainSelectedInstOperands,
     /* 230236 */     // GIR_Coverage, 11687,
     /* 230236 */     GIR_EraseRootFromParent_Done,
     /* 230237 */   // Label 4371: @230237
     /* 230237 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(230284), // Rule ID 11762 //
     /* 230242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 230250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230263 */     // MIs[0] Op3
     /* 230263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 230271 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2062:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 230271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 230274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230282 */     GIR_RootConstrainSelectedInstOperands,
     /* 230283 */     // GIR_Coverage, 11762,
     /* 230283 */     GIR_EraseRootFromParent_Done,
     /* 230284 */   // Label 4372: @230284
     /* 230284 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(230331), // Rule ID 11764 //
     /* 230289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 230297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230310 */     // MIs[0] Op3
     /* 230310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230313 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 230318 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2062:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 230318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 230321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230327 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230329 */     GIR_RootConstrainSelectedInstOperands,
     /* 230330 */     // GIR_Coverage, 11764,
     /* 230330 */     GIR_EraseRootFromParent_Done,
     /* 230331 */   // Label 4373: @230331
     /* 230331 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(230378), // Rule ID 11766 //
     /* 230336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 230344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230357 */     // MIs[0] Op3
     /* 230357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 230365 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2062:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 230365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 230368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230376 */     GIR_RootConstrainSelectedInstOperands,
     /* 230377 */     // GIR_Coverage, 11766,
     /* 230377 */     GIR_EraseRootFromParent_Done,
     /* 230378 */   // Label 4374: @230378
     /* 230378 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(230425), // Rule ID 11768 //
     /* 230383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 230391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230404 */     // MIs[0] Op3
     /* 230404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 230412 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2062:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 230412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 230415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230423 */     GIR_RootConstrainSelectedInstOperands,
     /* 230424 */     // GIR_Coverage, 11768,
     /* 230424 */     GIR_EraseRootFromParent_Done,
     /* 230425 */   // Label 4375: @230425
     /* 230425 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(230472), // Rule ID 11770 //
     /* 230430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 230438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230451 */     // MIs[0] Op3
     /* 230451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 230459 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1863:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 230459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 230462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230470 */     GIR_RootConstrainSelectedInstOperands,
     /* 230471 */     // GIR_Coverage, 11770,
     /* 230471 */     GIR_EraseRootFromParent_Done,
     /* 230472 */   // Label 4376: @230472
     /* 230472 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(230519), // Rule ID 11771 //
     /* 230477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 230485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230498 */     // MIs[0] Op3
     /* 230498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230501 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 230506 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1863:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 230506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 230509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230515 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230517 */     GIR_RootConstrainSelectedInstOperands,
     /* 230518 */     // GIR_Coverage, 11771,
     /* 230518 */     GIR_EraseRootFromParent_Done,
     /* 230519 */   // Label 4377: @230519
     /* 230519 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(230566), // Rule ID 11772 //
     /* 230524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 230532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230545 */     // MIs[0] Op3
     /* 230545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 230553 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1863:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 230553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 230556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230562 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230564 */     GIR_RootConstrainSelectedInstOperands,
     /* 230565 */     // GIR_Coverage, 11772,
     /* 230565 */     GIR_EraseRootFromParent_Done,
     /* 230566 */   // Label 4378: @230566
     /* 230566 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(230613), // Rule ID 11773 //
     /* 230571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 230579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230592 */     // MIs[0] Op3
     /* 230592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 230600 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1863:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 230600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 230603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230611 */     GIR_RootConstrainSelectedInstOperands,
     /* 230612 */     // GIR_Coverage, 11773,
     /* 230612 */     GIR_EraseRootFromParent_Done,
     /* 230613 */   // Label 4379: @230613
     /* 230613 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(230660), // Rule ID 11778 //
     /* 230618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 230626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230639 */     // MIs[0] Op3
     /* 230639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 230647 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2055:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 230647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 230650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230658 */     GIR_RootConstrainSelectedInstOperands,
     /* 230659 */     // GIR_Coverage, 11778,
     /* 230659 */     GIR_EraseRootFromParent_Done,
     /* 230660 */   // Label 4380: @230660
     /* 230660 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(230707), // Rule ID 11779 //
     /* 230665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 230673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230686 */     // MIs[0] Op3
     /* 230686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230689 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 230694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2055:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 230694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 230697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230705 */     GIR_RootConstrainSelectedInstOperands,
     /* 230706 */     // GIR_Coverage, 11779,
     /* 230706 */     GIR_EraseRootFromParent_Done,
     /* 230707 */   // Label 4381: @230707
     /* 230707 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(230754), // Rule ID 11780 //
     /* 230712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 230720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230733 */     // MIs[0] Op3
     /* 230733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230736 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 230741 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2055:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 230741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 230744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230752 */     GIR_RootConstrainSelectedInstOperands,
     /* 230753 */     // GIR_Coverage, 11780,
     /* 230753 */     GIR_EraseRootFromParent_Done,
     /* 230754 */   // Label 4382: @230754
     /* 230754 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(230801), // Rule ID 11781 //
     /* 230759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 230767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230780 */     // MIs[0] Op3
     /* 230780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 230788 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2055:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 230788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 230791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230799 */     GIR_RootConstrainSelectedInstOperands,
     /* 230800 */     // GIR_Coverage, 11781,
     /* 230800 */     GIR_EraseRootFromParent_Done,
     /* 230801 */   // Label 4383: @230801
     /* 230801 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(230848), // Rule ID 11841 //
     /* 230806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 230814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230827 */     // MIs[0] Op3
     /* 230827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 230835 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1840:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 230835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 230838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230846 */     GIR_RootConstrainSelectedInstOperands,
     /* 230847 */     // GIR_Coverage, 11841,
     /* 230847 */     GIR_EraseRootFromParent_Done,
     /* 230848 */   // Label 4384: @230848
     /* 230848 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(230895), // Rule ID 11842 //
     /* 230853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 230861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230874 */     // MIs[0] Op3
     /* 230874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 230882 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1840:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 230882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 230885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230893 */     GIR_RootConstrainSelectedInstOperands,
     /* 230894 */     // GIR_Coverage, 11842,
     /* 230894 */     GIR_EraseRootFromParent_Done,
     /* 230895 */   // Label 4385: @230895
     /* 230895 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(230942), // Rule ID 11843 //
     /* 230900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 230908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230921 */     // MIs[0] Op3
     /* 230921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230924 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 230929 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1840:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 230929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 230932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230940 */     GIR_RootConstrainSelectedInstOperands,
     /* 230941 */     // GIR_Coverage, 11843,
     /* 230941 */     GIR_EraseRootFromParent_Done,
     /* 230942 */   // Label 4386: @230942
     /* 230942 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(230989), // Rule ID 11844 //
     /* 230947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 230955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230968 */     // MIs[0] Op3
     /* 230968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 230971 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 230976 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1719:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 230976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 230979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230987 */     GIR_RootConstrainSelectedInstOperands,
     /* 230988 */     // GIR_Coverage, 11844,
     /* 230988 */     GIR_EraseRootFromParent_Done,
     /* 230989 */   // Label 4387: @230989
     /* 230989 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(231036), // Rule ID 11845 //
     /* 230994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 231002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231015 */     // MIs[0] Op3
     /* 231015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 231023 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1719:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 231023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 231026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231032 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231034 */     GIR_RootConstrainSelectedInstOperands,
     /* 231035 */     // GIR_Coverage, 11845,
     /* 231035 */     GIR_EraseRootFromParent_Done,
     /* 231036 */   // Label 4388: @231036
     /* 231036 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(231083), // Rule ID 11846 //
     /* 231041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 231049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231062 */     // MIs[0] Op3
     /* 231062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 231070 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1719:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 231070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 231073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231081 */     GIR_RootConstrainSelectedInstOperands,
     /* 231082 */     // GIR_Coverage, 11846,
     /* 231082 */     GIR_EraseRootFromParent_Done,
     /* 231083 */   // Label 4389: @231083
     /* 231083 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(231130), // Rule ID 11847 //
     /* 231088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 231096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231109 */     // MIs[0] Op3
     /* 231109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 231117 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1677:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 231117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 231120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231128 */     GIR_RootConstrainSelectedInstOperands,
     /* 231129 */     // GIR_Coverage, 11847,
     /* 231129 */     GIR_EraseRootFromParent_Done,
     /* 231130 */   // Label 4390: @231130
     /* 231130 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(231177), // Rule ID 11848 //
     /* 231135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 231143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231156 */     // MIs[0] Op3
     /* 231156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231159 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 231164 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1677:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 231164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 231167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231175 */     GIR_RootConstrainSelectedInstOperands,
     /* 231176 */     // GIR_Coverage, 11848,
     /* 231176 */     GIR_EraseRootFromParent_Done,
     /* 231177 */   // Label 4391: @231177
     /* 231177 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(231224), // Rule ID 11849 //
     /* 231182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 231190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231203 */     // MIs[0] Op3
     /* 231203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 231211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1677:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 231211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 231214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231222 */     GIR_RootConstrainSelectedInstOperands,
     /* 231223 */     // GIR_Coverage, 11849,
     /* 231223 */     GIR_EraseRootFromParent_Done,
     /* 231224 */   // Label 4392: @231224
     /* 231224 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(231271), // Rule ID 11850 //
     /* 231229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 231237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231250 */     // MIs[0] Op3
     /* 231250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 231258 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1844:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 231258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 231261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231269 */     GIR_RootConstrainSelectedInstOperands,
     /* 231270 */     // GIR_Coverage, 11850,
     /* 231270 */     GIR_EraseRootFromParent_Done,
     /* 231271 */   // Label 4393: @231271
     /* 231271 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(231318), // Rule ID 11851 //
     /* 231276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 231284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231297 */     // MIs[0] Op3
     /* 231297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231300 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 231305 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1844:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 231305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 231308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231316 */     GIR_RootConstrainSelectedInstOperands,
     /* 231317 */     // GIR_Coverage, 11851,
     /* 231317 */     GIR_EraseRootFromParent_Done,
     /* 231318 */   // Label 4394: @231318
     /* 231318 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(231365), // Rule ID 11852 //
     /* 231323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 231331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231344 */     // MIs[0] Op3
     /* 231344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231347 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 231352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1844:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 231352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 231355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231363 */     GIR_RootConstrainSelectedInstOperands,
     /* 231364 */     // GIR_Coverage, 11852,
     /* 231364 */     GIR_EraseRootFromParent_Done,
     /* 231365 */   // Label 4395: @231365
     /* 231365 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(231412), // Rule ID 11853 //
     /* 231370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 231378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231391 */     // MIs[0] Op3
     /* 231391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 231399 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1834:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 231399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 231402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231410 */     GIR_RootConstrainSelectedInstOperands,
     /* 231411 */     // GIR_Coverage, 11853,
     /* 231411 */     GIR_EraseRootFromParent_Done,
     /* 231412 */   // Label 4396: @231412
     /* 231412 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(231459), // Rule ID 11854 //
     /* 231417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 231425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231438 */     // MIs[0] Op3
     /* 231438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 231446 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1834:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 231446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 231449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231455 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231457 */     GIR_RootConstrainSelectedInstOperands,
     /* 231458 */     // GIR_Coverage, 11854,
     /* 231458 */     GIR_EraseRootFromParent_Done,
     /* 231459 */   // Label 4397: @231459
     /* 231459 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(231506), // Rule ID 11855 //
     /* 231464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 231472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231485 */     // MIs[0] Op3
     /* 231485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 231493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1834:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 231493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 231496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231504 */     GIR_RootConstrainSelectedInstOperands,
     /* 231505 */     // GIR_Coverage, 11855,
     /* 231505 */     GIR_EraseRootFromParent_Done,
     /* 231506 */   // Label 4398: @231506
     /* 231506 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(231553), // Rule ID 11856 //
     /* 231511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 231519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231532 */     // MIs[0] Op3
     /* 231532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 231540 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2039:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 231540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 231543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231549 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231551 */     GIR_RootConstrainSelectedInstOperands,
     /* 231552 */     // GIR_Coverage, 11856,
     /* 231552 */     GIR_EraseRootFromParent_Done,
     /* 231553 */   // Label 4399: @231553
     /* 231553 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(231600), // Rule ID 11857 //
     /* 231558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 231566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231579 */     // MIs[0] Op3
     /* 231579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 231587 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2039:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 231587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 231590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231598 */     GIR_RootConstrainSelectedInstOperands,
     /* 231599 */     // GIR_Coverage, 11857,
     /* 231599 */     GIR_EraseRootFromParent_Done,
     /* 231600 */   // Label 4400: @231600
     /* 231600 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(231647), // Rule ID 11858 //
     /* 231605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 231613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231626 */     // MIs[0] Op3
     /* 231626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 231634 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2039:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 231634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 231637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231645 */     GIR_RootConstrainSelectedInstOperands,
     /* 231646 */     // GIR_Coverage, 11858,
     /* 231646 */     GIR_EraseRootFromParent_Done,
     /* 231647 */   // Label 4401: @231647
     /* 231647 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(231694), // Rule ID 11859 //
     /* 231652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 231660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231673 */     // MIs[0] Op3
     /* 231673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 231681 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2036:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 231681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 231684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231692 */     GIR_RootConstrainSelectedInstOperands,
     /* 231693 */     // GIR_Coverage, 11859,
     /* 231693 */     GIR_EraseRootFromParent_Done,
     /* 231694 */   // Label 4402: @231694
     /* 231694 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(231741), // Rule ID 11860 //
     /* 231699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 231707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231720 */     // MIs[0] Op3
     /* 231720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 231728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2036:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 231728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 231731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231737 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231739 */     GIR_RootConstrainSelectedInstOperands,
     /* 231740 */     // GIR_Coverage, 11860,
     /* 231740 */     GIR_EraseRootFromParent_Done,
     /* 231741 */   // Label 4403: @231741
     /* 231741 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(231788), // Rule ID 11861 //
     /* 231746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 231754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 231763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231767 */     // MIs[0] Op3
     /* 231767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 231770 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 231775 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2036:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 231775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 231778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231786 */     GIR_RootConstrainSelectedInstOperands,
     /* 231787 */     // GIR_Coverage, 11861,
     /* 231787 */     GIR_EraseRootFromParent_Done,
     /* 231788 */   // Label 4404: @231788
     /* 231788 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(231855), // Rule ID 2604 //
     /* 231793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 231801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 231810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 231825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 231827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 231830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 231834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 231844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 231851 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 231853 */     GIR_RootConstrainSelectedInstOperands,
     /* 231854 */     // GIR_Coverage, 2604,
     /* 231854 */     GIR_EraseRootFromParent_Done,
     /* 231855 */   // Label 4405: @231855
     /* 231855 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(231922), // Rule ID 7772 //
     /* 231860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 231868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 231871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 231874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 231877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 231892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231894 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 231894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 231897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 231901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 231911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 231918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 231920 */     GIR_RootConstrainSelectedInstOperands,
     /* 231921 */     // GIR_Coverage, 7772,
     /* 231921 */     GIR_EraseRootFromParent_Done,
     /* 231922 */   // Label 4406: @231922
     /* 231922 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(231989), // Rule ID 7774 //
     /* 231927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 231935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 231944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 231959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231961 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 231961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 231964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 231968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 231973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 231975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 231978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 231980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 231983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 231985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 231987 */     GIR_RootConstrainSelectedInstOperands,
     /* 231988 */     // GIR_Coverage, 7774,
     /* 231988 */     GIR_EraseRootFromParent_Done,
     /* 231989 */   // Label 4407: @231989
     /* 231989 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(232056), // Rule ID 7776 //
     /* 231994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 231997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 232002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232028 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 232028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 232045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232054 */     GIR_RootConstrainSelectedInstOperands,
     /* 232055 */     // GIR_Coverage, 7776,
     /* 232055 */     GIR_EraseRootFromParent_Done,
     /* 232056 */   // Label 4408: @232056
     /* 232056 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(232123), // Rule ID 7778 //
     /* 232061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 232069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232095 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1310:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 232095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 232112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232119 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232121 */     GIR_RootConstrainSelectedInstOperands,
     /* 232122 */     // GIR_Coverage, 7778,
     /* 232122 */     GIR_EraseRootFromParent_Done,
     /* 232123 */   // Label 4409: @232123
     /* 232123 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(232190), // Rule ID 7808 //
     /* 232128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 232136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 232142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 232145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232162 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 232162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 232179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232188 */     GIR_RootConstrainSelectedInstOperands,
     /* 232189 */     // GIR_Coverage, 7808,
     /* 232189 */     GIR_EraseRootFromParent_Done,
     /* 232190 */   // Label 4410: @232190
     /* 232190 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(232257), // Rule ID 7810 //
     /* 232195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 232203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 232212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232229 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 232229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 232246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232255 */     GIR_RootConstrainSelectedInstOperands,
     /* 232256 */     // GIR_Coverage, 7810,
     /* 232256 */     GIR_EraseRootFromParent_Done,
     /* 232257 */   // Label 4411: @232257
     /* 232257 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(232324), // Rule ID 7812 //
     /* 232262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 232270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 232296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 232313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232322 */     GIR_RootConstrainSelectedInstOperands,
     /* 232323 */     // GIR_Coverage, 7812,
     /* 232323 */     GIR_EraseRootFromParent_Done,
     /* 232324 */   // Label 4412: @232324
     /* 232324 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(232391), // Rule ID 7814 //
     /* 232329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 232337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232363 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1330:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 232363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 232380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232387 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232389 */     GIR_RootConstrainSelectedInstOperands,
     /* 232390 */     // GIR_Coverage, 7814,
     /* 232390 */     GIR_EraseRootFromParent_Done,
     /* 232391 */   // Label 4413: @232391
     /* 232391 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(232458), // Rule ID 7820 //
     /* 232396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 232404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 232410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 232413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232430 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 232430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 232447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232456 */     GIR_RootConstrainSelectedInstOperands,
     /* 232457 */     // GIR_Coverage, 7820,
     /* 232457 */     GIR_EraseRootFromParent_Done,
     /* 232458 */   // Label 4414: @232458
     /* 232458 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(232525), // Rule ID 7822 //
     /* 232463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 232471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 232480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232497 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 232497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 232514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232523 */     GIR_RootConstrainSelectedInstOperands,
     /* 232524 */     // GIR_Coverage, 7822,
     /* 232524 */     GIR_EraseRootFromParent_Done,
     /* 232525 */   // Label 4415: @232525
     /* 232525 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(232592), // Rule ID 7824 //
     /* 232530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 232538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 232564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 232581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232590 */     GIR_RootConstrainSelectedInstOperands,
     /* 232591 */     // GIR_Coverage, 7824,
     /* 232591 */     GIR_EraseRootFromParent_Done,
     /* 232592 */   // Label 4416: @232592
     /* 232592 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(232659), // Rule ID 7826 //
     /* 232597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 232600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 232605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 232631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 232648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232657 */     GIR_RootConstrainSelectedInstOperands,
     /* 232658 */     // GIR_Coverage, 7826,
     /* 232658 */     GIR_EraseRootFromParent_Done,
     /* 232659 */   // Label 4417: @232659
     /* 232659 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(232726), // Rule ID 11554 //
     /* 232664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 232672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 232698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 232715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232724 */     GIR_RootConstrainSelectedInstOperands,
     /* 232725 */     // GIR_Coverage, 11554,
     /* 232725 */     GIR_EraseRootFromParent_Done,
     /* 232726 */   // Label 4418: @232726
     /* 232726 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(232793), // Rule ID 11556 //
     /* 232731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 232739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 232745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 232748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232765 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 232765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 232782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232791 */     GIR_RootConstrainSelectedInstOperands,
     /* 232792 */     // GIR_Coverage, 11556,
     /* 232792 */     GIR_EraseRootFromParent_Done,
     /* 232793 */   // Label 4419: @232793
     /* 232793 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(232860), // Rule ID 11558 //
     /* 232798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 232806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 232815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232832 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 232832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 232849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232856 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232858 */     GIR_RootConstrainSelectedInstOperands,
     /* 232859 */     // GIR_Coverage, 11558,
     /* 232859 */     GIR_EraseRootFromParent_Done,
     /* 232860 */   // Label 4420: @232860
     /* 232860 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(232927), // Rule ID 11560 //
     /* 232865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 232873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232899 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 232899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 232916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232925 */     GIR_RootConstrainSelectedInstOperands,
     /* 232926 */     // GIR_Coverage, 11560,
     /* 232926 */     GIR_EraseRootFromParent_Done,
     /* 232927 */   // Label 4421: @232927
     /* 232927 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(232994), // Rule ID 11562 //
     /* 232932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 232940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 232964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232966 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 232966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 232969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 232973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 232978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 232980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 232983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 232985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 232988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 232990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 232992 */     GIR_RootConstrainSelectedInstOperands,
     /* 232993 */     // GIR_Coverage, 11562,
     /* 232993 */     GIR_EraseRootFromParent_Done,
     /* 232994 */   // Label 4422: @232994
     /* 232994 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(233061), // Rule ID 11568 //
     /* 232999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 233007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 233013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 233016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 233027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 233031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233033 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 233033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 233036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 233050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 233057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 233059 */     GIR_RootConstrainSelectedInstOperands,
     /* 233060 */     // GIR_Coverage, 11568,
     /* 233060 */     GIR_EraseRootFromParent_Done,
     /* 233061 */   // Label 4423: @233061
     /* 233061 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(233128), // Rule ID 11570 //
     /* 233066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 233074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 233080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 233083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 233094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 233098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233100 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 233100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 233103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 233117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 233124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 233126 */     GIR_RootConstrainSelectedInstOperands,
     /* 233127 */     // GIR_Coverage, 11570,
     /* 233127 */     GIR_EraseRootFromParent_Done,
     /* 233128 */   // Label 4424: @233128
     /* 233128 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(233195), // Rule ID 11572 //
     /* 233133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 233141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 233147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 233150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 233161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 233165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233167 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 233167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 233170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 233184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 233191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 233193 */     GIR_RootConstrainSelectedInstOperands,
     /* 233194 */     // GIR_Coverage, 11572,
     /* 233194 */     GIR_EraseRootFromParent_Done,
     /* 233195 */   // Label 4425: @233195
     /* 233195 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(233262), // Rule ID 11574 //
     /* 233200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 233208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 233214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 233217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 233228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 233232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1819:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 233234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 233237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 233251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 233253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 233258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 233260 */     GIR_RootConstrainSelectedInstOperands,
     /* 233261 */     // GIR_Coverage, 11574,
     /* 233261 */     GIR_EraseRootFromParent_Done,
     /* 233262 */   // Label 4426: @233262
     /* 233262 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(233316), // Rule ID 30 //
     /* 233267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 233270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 233275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233303 */     // (intrinsic_wo_chain:{ *:[v4i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 233303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 233306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233312 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233314 */     GIR_RootConstrainSelectedInstOperands,
     /* 233315 */     // GIR_Coverage, 30,
     /* 233315 */     GIR_EraseRootFromParent_Done,
     /* 233316 */   // Label 4427: @233316
     /* 233316 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(233370), // Rule ID 31 //
     /* 233321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 233324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 233329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233357 */     // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 233357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 233360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233368 */     GIR_RootConstrainSelectedInstOperands,
     /* 233369 */     // GIR_Coverage, 31,
     /* 233369 */     GIR_EraseRootFromParent_Done,
     /* 233370 */   // Label 4428: @233370
     /* 233370 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(233424), // Rule ID 32 //
     /* 233375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 233378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 233383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233411 */     // (intrinsic_wo_chain:{ *:[v4i32] } 753:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 233411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 233414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233422 */     GIR_RootConstrainSelectedInstOperands,
     /* 233423 */     // GIR_Coverage, 32,
     /* 233423 */     GIR_EraseRootFromParent_Done,
     /* 233424 */   // Label 4429: @233424
     /* 233424 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(233478), // Rule ID 39 //
     /* 233429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 233432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 233437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 233440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 233443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233465 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 233465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 233468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233476 */     GIR_RootConstrainSelectedInstOperands,
     /* 233477 */     // GIR_Coverage, 39,
     /* 233477 */     GIR_EraseRootFromParent_Done,
     /* 233478 */   // Label 4430: @233478
     /* 233478 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(233532), // Rule ID 40 //
     /* 233483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 233486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 233491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233519 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 233519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 233522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233530 */     GIR_RootConstrainSelectedInstOperands,
     /* 233531 */     // GIR_Coverage, 40,
     /* 233531 */     GIR_EraseRootFromParent_Done,
     /* 233532 */   // Label 4431: @233532
     /* 233532 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(233586), // Rule ID 41 //
     /* 233537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 233540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 233545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 233548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 233551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233573 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 233573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 233576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233584 */     GIR_RootConstrainSelectedInstOperands,
     /* 233585 */     // GIR_Coverage, 41,
     /* 233585 */     GIR_EraseRootFromParent_Done,
     /* 233586 */   // Label 4432: @233586
     /* 233586 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(233640), // Rule ID 42 //
     /* 233591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 233594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 233599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233627 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 233627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 233630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233638 */     GIR_RootConstrainSelectedInstOperands,
     /* 233639 */     // GIR_Coverage, 42,
     /* 233639 */     GIR_EraseRootFromParent_Done,
     /* 233640 */   // Label 4433: @233640
     /* 233640 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(233694), // Rule ID 43 //
     /* 233645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 233648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 233653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 233656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 233659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233681 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 233681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 233684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233692 */     GIR_RootConstrainSelectedInstOperands,
     /* 233693 */     // GIR_Coverage, 43,
     /* 233693 */     GIR_EraseRootFromParent_Done,
     /* 233694 */   // Label 4434: @233694
     /* 233694 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(233748), // Rule ID 44 //
     /* 233699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 233702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 233707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233735 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 233735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 233738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233746 */     GIR_RootConstrainSelectedInstOperands,
     /* 233747 */     // GIR_Coverage, 44,
     /* 233747 */     GIR_EraseRootFromParent_Done,
     /* 233748 */   // Label 4435: @233748
     /* 233748 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(233802), // Rule ID 45 //
     /* 233753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 233756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 233761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 233764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 233767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233789 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 233789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 233792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233800 */     GIR_RootConstrainSelectedInstOperands,
     /* 233801 */     // GIR_Coverage, 45,
     /* 233801 */     GIR_EraseRootFromParent_Done,
     /* 233802 */   // Label 4436: @233802
     /* 233802 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(233856), // Rule ID 46 //
     /* 233807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 233810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 233815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233843 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 233843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 233846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233854 */     GIR_RootConstrainSelectedInstOperands,
     /* 233855 */     // GIR_Coverage, 46,
     /* 233855 */     GIR_EraseRootFromParent_Done,
     /* 233856 */   // Label 4437: @233856
     /* 233856 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(233910), // Rule ID 1587 //
     /* 233861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 233864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 233869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 233872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 233875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233897 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 233897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 233900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233906 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233908 */     GIR_RootConstrainSelectedInstOperands,
     /* 233909 */     // GIR_Coverage, 1587,
     /* 233909 */     GIR_EraseRootFromParent_Done,
     /* 233910 */   // Label 4438: @233910
     /* 233910 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(233964), // Rule ID 1588 //
     /* 233915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 233918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 233923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233951 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 233951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 233954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233962 */     GIR_RootConstrainSelectedInstOperands,
     /* 233963 */     // GIR_Coverage, 1588,
     /* 233963 */     GIR_EraseRootFromParent_Done,
     /* 233964 */   // Label 4439: @233964
     /* 233964 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(234018), // Rule ID 1589 //
     /* 233969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 233972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 233977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 233980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 233983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 233986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 233989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234005 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 234005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 234008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234016 */     GIR_RootConstrainSelectedInstOperands,
     /* 234017 */     // GIR_Coverage, 1589,
     /* 234017 */     GIR_EraseRootFromParent_Done,
     /* 234018 */   // Label 4440: @234018
     /* 234018 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(234072), // Rule ID 1590 //
     /* 234023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 234026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 234031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234059 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 234062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234070 */     GIR_RootConstrainSelectedInstOperands,
     /* 234071 */     // GIR_Coverage, 1590,
     /* 234071 */     GIR_EraseRootFromParent_Done,
     /* 234072 */   // Label 4441: @234072
     /* 234072 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(234126), // Rule ID 1591 //
     /* 234077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 234080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 234085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 234088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 234091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 234094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 234097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234113 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 234113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 234116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234124 */     GIR_RootConstrainSelectedInstOperands,
     /* 234125 */     // GIR_Coverage, 1591,
     /* 234125 */     GIR_EraseRootFromParent_Done,
     /* 234126 */   // Label 4442: @234126
     /* 234126 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(234180), // Rule ID 1592 //
     /* 234131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 234134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 234139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 234142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 234145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 234148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 234151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234167 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 234167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 234170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234178 */     GIR_RootConstrainSelectedInstOperands,
     /* 234179 */     // GIR_Coverage, 1592,
     /* 234179 */     GIR_EraseRootFromParent_Done,
     /* 234180 */   // Label 4443: @234180
     /* 234180 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(234234), // Rule ID 1593 //
     /* 234185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 234188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 234193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234221 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 234221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 234224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234232 */     GIR_RootConstrainSelectedInstOperands,
     /* 234233 */     // GIR_Coverage, 1593,
     /* 234233 */     GIR_EraseRootFromParent_Done,
     /* 234234 */   // Label 4444: @234234
     /* 234234 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(234288), // Rule ID 1594 //
     /* 234239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 234242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 234247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234275 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 234278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234286 */     GIR_RootConstrainSelectedInstOperands,
     /* 234287 */     // GIR_Coverage, 1594,
     /* 234287 */     GIR_EraseRootFromParent_Done,
     /* 234288 */   // Label 4445: @234288
     /* 234288 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(234342), // Rule ID 2307 //
     /* 234293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 234296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 234301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234329 */     // (intrinsic_wo_chain:{ *:[v4i32] } 520:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 234332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234340 */     GIR_RootConstrainSelectedInstOperands,
     /* 234341 */     // GIR_Coverage, 2307,
     /* 234341 */     GIR_EraseRootFromParent_Done,
     /* 234342 */   // Label 4446: @234342
     /* 234342 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(234396), // Rule ID 2308 //
     /* 234347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 234350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 234355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234383 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 234386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234394 */     GIR_RootConstrainSelectedInstOperands,
     /* 234395 */     // GIR_Coverage, 2308,
     /* 234395 */     GIR_EraseRootFromParent_Done,
     /* 234396 */   // Label 4447: @234396
     /* 234396 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(234450), // Rule ID 2309 //
     /* 234401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 234404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 234409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234437 */     // (intrinsic_wo_chain:{ *:[v4i32] } 522:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 234440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234448 */     GIR_RootConstrainSelectedInstOperands,
     /* 234449 */     // GIR_Coverage, 2309,
     /* 234449 */     GIR_EraseRootFromParent_Done,
     /* 234450 */   // Label 4448: @234450
     /* 234450 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(234504), // Rule ID 2310 //
     /* 234455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 234458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 234463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234491 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 234494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234502 */     GIR_RootConstrainSelectedInstOperands,
     /* 234503 */     // GIR_Coverage, 2310,
     /* 234503 */     GIR_EraseRootFromParent_Done,
     /* 234504 */   // Label 4449: @234504
     /* 234504 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(234558), // Rule ID 2311 //
     /* 234509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 234512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 234517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234545 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 234548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234556 */     GIR_RootConstrainSelectedInstOperands,
     /* 234557 */     // GIR_Coverage, 2311,
     /* 234557 */     GIR_EraseRootFromParent_Done,
     /* 234558 */   // Label 4450: @234558
     /* 234558 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(234612), // Rule ID 2312 //
     /* 234563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 234566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 234571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234599 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 234602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234610 */     GIR_RootConstrainSelectedInstOperands,
     /* 234611 */     // GIR_Coverage, 2312,
     /* 234611 */     GIR_EraseRootFromParent_Done,
     /* 234612 */   // Label 4451: @234612
     /* 234612 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(234666), // Rule ID 2313 //
     /* 234617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 234620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 234625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234653 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 234653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 234656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234662 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234664 */     GIR_RootConstrainSelectedInstOperands,
     /* 234665 */     // GIR_Coverage, 2313,
     /* 234665 */     GIR_EraseRootFromParent_Done,
     /* 234666 */   // Label 4452: @234666
     /* 234666 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(234723), // Rule ID 3640 //
     /* 234671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 234674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 234679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 234682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 234688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 234695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 234707 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 234707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 234710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 234712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 234714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 234716 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 234718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234721 */     GIR_RootConstrainSelectedInstOperands,
     /* 234722 */     // GIR_Coverage, 3640,
     /* 234722 */     GIR_EraseRootFromParent_Done,
     /* 234723 */   // Label 4453: @234723
     /* 234723 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(234780), // Rule ID 3641 //
     /* 234728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 234731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 234736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 234739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 234745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 234752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 234764 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 234764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 234767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 234769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 234771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 234773 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 234775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234778 */     GIR_RootConstrainSelectedInstOperands,
     /* 234779 */     // GIR_Coverage, 3641,
     /* 234779 */     GIR_EraseRootFromParent_Done,
     /* 234780 */   // Label 4454: @234780
     /* 234780 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(234837), // Rule ID 3642 //
     /* 234785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 234788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 234793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 234796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 234809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 234821 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 234821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 234824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 234826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 234828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 234830 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 234832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234835 */     GIR_RootConstrainSelectedInstOperands,
     /* 234836 */     // GIR_Coverage, 3642,
     /* 234836 */     GIR_EraseRootFromParent_Done,
     /* 234837 */   // Label 4455: @234837
     /* 234837 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(234894), // Rule ID 3643 //
     /* 234842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 234845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 234850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 234853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 234859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 234866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 234874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 234878 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1651:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 234878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 234881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 234883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 234885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 234887 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 234889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234892 */     GIR_RootConstrainSelectedInstOperands,
     /* 234893 */     // GIR_Coverage, 3643,
     /* 234893 */     GIR_EraseRootFromParent_Done,
     /* 234894 */   // Label 4456: @234894
     /* 234894 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(234948), // Rule ID 3816 //
     /* 234899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 234902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 234907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234935 */     // (intrinsic_wo_chain:{ *:[v2i64] } 530:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 234935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 234938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 234940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 234942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 234944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 234946 */     GIR_RootConstrainSelectedInstOperands,
     /* 234947 */     // GIR_Coverage, 3816,
     /* 234947 */     GIR_EraseRootFromParent_Done,
     /* 234948 */   // Label 4457: @234948
     /* 234948 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(235002), // Rule ID 3817 //
     /* 234953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 234956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 234961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234989 */     // (intrinsic_wo_chain:{ *:[v2i64] } 531:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 234989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 234992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 234994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 234996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 234998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235000 */     GIR_RootConstrainSelectedInstOperands,
     /* 235001 */     // GIR_Coverage, 3817,
     /* 235001 */     GIR_EraseRootFromParent_Done,
     /* 235002 */   // Label 4458: @235002
     /* 235002 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(235056), // Rule ID 3818 //
     /* 235007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 235015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 235018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 235021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 235024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 235027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235043 */     // (intrinsic_wo_chain:{ *:[v2i64] } 533:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 235043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 235046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 235048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235054 */     GIR_RootConstrainSelectedInstOperands,
     /* 235055 */     // GIR_Coverage, 3818,
     /* 235055 */     GIR_EraseRootFromParent_Done,
     /* 235056 */   // Label 4459: @235056
     /* 235056 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(235110), // Rule ID 3819 //
     /* 235061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 235069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 235081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235097 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 235097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 235100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235108 */     GIR_RootConstrainSelectedInstOperands,
     /* 235109 */     // GIR_Coverage, 3819,
     /* 235109 */     GIR_EraseRootFromParent_Done,
     /* 235110 */   // Label 4460: @235110
     /* 235110 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(235164), // Rule ID 3820 //
     /* 235115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 235123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 235132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 235135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235151 */     // (intrinsic_wo_chain:{ *:[v8i16] } 518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 235151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 235154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235162 */     GIR_RootConstrainSelectedInstOperands,
     /* 235163 */     // GIR_Coverage, 3820,
     /* 235163 */     GIR_EraseRootFromParent_Done,
     /* 235164 */   // Label 4461: @235164
     /* 235164 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(235218), // Rule ID 3821 //
     /* 235169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 235177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 235180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 235183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 235186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 235189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235205 */     // (intrinsic_wo_chain:{ *:[v4i32] } 518:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 235205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 235208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235216 */     GIR_RootConstrainSelectedInstOperands,
     /* 235217 */     // GIR_Coverage, 3821,
     /* 235217 */     GIR_EraseRootFromParent_Done,
     /* 235218 */   // Label 4462: @235218
     /* 235218 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(235272), // Rule ID 3822 //
     /* 235223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 235231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 235234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 235237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 235240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 235243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235259 */     // (intrinsic_wo_chain:{ *:[v2i64] } 518:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 235259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 235262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235270 */     GIR_RootConstrainSelectedInstOperands,
     /* 235271 */     // GIR_Coverage, 3822,
     /* 235271 */     GIR_EraseRootFromParent_Done,
     /* 235272 */   // Label 4463: @235272
     /* 235272 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(235326), // Rule ID 3831 //
     /* 235277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 235285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 235297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235313 */     // (intrinsic_wo_chain:{ *:[v16i8] } 516:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 235313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 235316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235322 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235324 */     GIR_RootConstrainSelectedInstOperands,
     /* 235325 */     // GIR_Coverage, 3831,
     /* 235325 */     GIR_EraseRootFromParent_Done,
     /* 235326 */   // Label 4464: @235326
     /* 235326 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(235380), // Rule ID 3832 //
     /* 235331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 235339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 235348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 235351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235367 */     // (intrinsic_wo_chain:{ *:[v8i16] } 516:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 235367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 235370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235378 */     GIR_RootConstrainSelectedInstOperands,
     /* 235379 */     // GIR_Coverage, 3832,
     /* 235379 */     GIR_EraseRootFromParent_Done,
     /* 235380 */   // Label 4465: @235380
     /* 235380 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(235434), // Rule ID 3833 //
     /* 235385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 235393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 235396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 235399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 235402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 235405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235421 */     // (intrinsic_wo_chain:{ *:[v4i32] } 516:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 235421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 235424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235432 */     GIR_RootConstrainSelectedInstOperands,
     /* 235433 */     // GIR_Coverage, 3833,
     /* 235433 */     GIR_EraseRootFromParent_Done,
     /* 235434 */   // Label 4466: @235434
     /* 235434 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(235488), // Rule ID 3834 //
     /* 235439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 235447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 235450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 235453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 235456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 235459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235475 */     // (intrinsic_wo_chain:{ *:[v2i64] } 516:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 235475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 235478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235486 */     GIR_RootConstrainSelectedInstOperands,
     /* 235487 */     // GIR_Coverage, 3834,
     /* 235487 */     GIR_EraseRootFromParent_Done,
     /* 235488 */   // Label 4467: @235488
     /* 235488 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(235542), // Rule ID 3835 //
     /* 235493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 235501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 235513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235529 */     // (intrinsic_wo_chain:{ *:[v16i8] } 517:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 235529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 235532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235540 */     GIR_RootConstrainSelectedInstOperands,
     /* 235541 */     // GIR_Coverage, 3835,
     /* 235541 */     GIR_EraseRootFromParent_Done,
     /* 235542 */   // Label 4468: @235542
     /* 235542 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(235596), // Rule ID 3836 //
     /* 235547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 235555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 235564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 235567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235583 */     // (intrinsic_wo_chain:{ *:[v8i16] } 517:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 235583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 235586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235594 */     GIR_RootConstrainSelectedInstOperands,
     /* 235595 */     // GIR_Coverage, 3836,
     /* 235595 */     GIR_EraseRootFromParent_Done,
     /* 235596 */   // Label 4469: @235596
     /* 235596 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(235650), // Rule ID 3837 //
     /* 235601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 235609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 235612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 235615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 235618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 235621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235637 */     // (intrinsic_wo_chain:{ *:[v4i32] } 517:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 235637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 235640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235646 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235648 */     GIR_RootConstrainSelectedInstOperands,
     /* 235649 */     // GIR_Coverage, 3837,
     /* 235649 */     GIR_EraseRootFromParent_Done,
     /* 235650 */   // Label 4470: @235650
     /* 235650 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(235704), // Rule ID 3838 //
     /* 235655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 235663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 235666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 235669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 235672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 235675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235691 */     // (intrinsic_wo_chain:{ *:[v2i64] } 517:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 235691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 235694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235700 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235702 */     GIR_RootConstrainSelectedInstOperands,
     /* 235703 */     // GIR_Coverage, 3838,
     /* 235703 */     GIR_EraseRootFromParent_Done,
     /* 235704 */   // Label 4471: @235704
     /* 235704 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(235758), // Rule ID 3839 //
     /* 235709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 235717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 235720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 235723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 235726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 235729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235745 */     // (intrinsic_wo_chain:{ *:[v16i8] } 515:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 235745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 235748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235756 */     GIR_RootConstrainSelectedInstOperands,
     /* 235757 */     // GIR_Coverage, 3839,
     /* 235757 */     GIR_EraseRootFromParent_Done,
     /* 235758 */   // Label 4472: @235758
     /* 235758 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(235812), // Rule ID 3840 //
     /* 235763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 235771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 235774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 235777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 235780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 235783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235799 */     // (intrinsic_wo_chain:{ *:[v8i16] } 515:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 235799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 235802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235810 */     GIR_RootConstrainSelectedInstOperands,
     /* 235811 */     // GIR_Coverage, 3840,
     /* 235811 */     GIR_EraseRootFromParent_Done,
     /* 235812 */   // Label 4473: @235812
     /* 235812 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(235866), // Rule ID 3841 //
     /* 235817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 235825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 235828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 235831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 235834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 235837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235853 */     // (intrinsic_wo_chain:{ *:[v4i32] } 515:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 235853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 235856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235864 */     GIR_RootConstrainSelectedInstOperands,
     /* 235865 */     // GIR_Coverage, 3841,
     /* 235865 */     GIR_EraseRootFromParent_Done,
     /* 235866 */   // Label 4474: @235866
     /* 235866 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(235920), // Rule ID 3842 //
     /* 235871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 235874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 235879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 235882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 235885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 235888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 235891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235907 */     // (intrinsic_wo_chain:{ *:[v2i64] } 515:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 235907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 235910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 235914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 235916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 235918 */     GIR_RootConstrainSelectedInstOperands,
     /* 235919 */     // GIR_Coverage, 3842,
     /* 235919 */     GIR_EraseRootFromParent_Done,
     /* 235920 */   // Label 4475: @235920
     /* 235920 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(235974), // Rule ID 3846 //
     /* 235925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 235928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 235933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 235936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 235939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 235942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 235945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235961 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 235961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 235964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 235966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 235968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 235970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 235972 */     GIR_RootConstrainSelectedInstOperands,
     /* 235973 */     // GIR_Coverage, 3846,
     /* 235973 */     GIR_EraseRootFromParent_Done,
     /* 235974 */   // Label 4476: @235974
     /* 235974 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(236028), // Rule ID 3847 //
     /* 235979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 235982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 235987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 235990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 235993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 235996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 235999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236015 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 236015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 236018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 236020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 236024 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 236026 */     GIR_RootConstrainSelectedInstOperands,
     /* 236027 */     // GIR_Coverage, 3847,
     /* 236027 */     GIR_EraseRootFromParent_Done,
     /* 236028 */   // Label 4477: @236028
     /* 236028 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(236082), // Rule ID 3848 //
     /* 236033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 236036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 236041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236069 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 236069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 236072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 236074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 236076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 236078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 236080 */     GIR_RootConstrainSelectedInstOperands,
     /* 236081 */     // GIR_Coverage, 3848,
     /* 236081 */     GIR_EraseRootFromParent_Done,
     /* 236082 */   // Label 4478: @236082
     /* 236082 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(236139), // Rule ID 3865 //
     /* 236087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 236090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 236095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 236098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 236101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 236104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 236107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236123 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 236123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 236126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236137 */     GIR_RootConstrainSelectedInstOperands,
     /* 236138 */     // GIR_Coverage, 3865,
     /* 236138 */     GIR_EraseRootFromParent_Done,
     /* 236139 */   // Label 4479: @236139
     /* 236139 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(236196), // Rule ID 3866 //
     /* 236144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 236147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 236152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 236155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 236158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 236161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 236164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236180 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 236180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 236183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 236194 */     GIR_RootConstrainSelectedInstOperands,
     /* 236195 */     // GIR_Coverage, 3866,
     /* 236195 */     GIR_EraseRootFromParent_Done,
     /* 236196 */   // Label 4480: @236196
     /* 236196 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(236253), // Rule ID 3867 //
     /* 236201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 236204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 236209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 236212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 236215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 236218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 236221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236237 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 236237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 236240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 236251 */     GIR_RootConstrainSelectedInstOperands,
     /* 236252 */     // GIR_Coverage, 3867,
     /* 236252 */     GIR_EraseRootFromParent_Done,
     /* 236253 */   // Label 4481: @236253
     /* 236253 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(236310), // Rule ID 3868 //
     /* 236258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 236261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 236266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 236269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 236272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 236275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 236278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236294 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 236294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 236297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236303 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 236308 */     GIR_RootConstrainSelectedInstOperands,
     /* 236309 */     // GIR_Coverage, 3868,
     /* 236309 */     GIR_EraseRootFromParent_Done,
     /* 236310 */   // Label 4482: @236310
     /* 236310 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(236367), // Rule ID 3873 //
     /* 236315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 236318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 236323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 236326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 236329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 236332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 236335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236351 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 236351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 236354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236360 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236365 */     GIR_RootConstrainSelectedInstOperands,
     /* 236366 */     // GIR_Coverage, 3873,
     /* 236366 */     GIR_EraseRootFromParent_Done,
     /* 236367 */   // Label 4483: @236367
     /* 236367 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(236424), // Rule ID 3874 //
     /* 236372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 236375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 236380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 236383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 236386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 236389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 236392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236408 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 236408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 236411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 236422 */     GIR_RootConstrainSelectedInstOperands,
     /* 236423 */     // GIR_Coverage, 3874,
     /* 236423 */     GIR_EraseRootFromParent_Done,
     /* 236424 */   // Label 4484: @236424
     /* 236424 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(236481), // Rule ID 3875 //
     /* 236429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 236432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 236437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 236440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 236443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 236446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 236449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236465 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 236465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 236468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 236479 */     GIR_RootConstrainSelectedInstOperands,
     /* 236480 */     // GIR_Coverage, 3875,
     /* 236480 */     GIR_EraseRootFromParent_Done,
     /* 236481 */   // Label 4485: @236481
     /* 236481 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(236538), // Rule ID 3876 //
     /* 236486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 236489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 236494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 236497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 236500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 236503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 236506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236522 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 236522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 236525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236531 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 236536 */     GIR_RootConstrainSelectedInstOperands,
     /* 236537 */     // GIR_Coverage, 3876,
     /* 236537 */     GIR_EraseRootFromParent_Done,
     /* 236538 */   // Label 4486: @236538
     /* 236538 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(236595), // Rule ID 3881 //
     /* 236543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 236551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 236554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 236557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 236560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 236563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236579 */     // (intrinsic_wo_chain:{ *:[v2f32] } 757:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 236579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 236582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236593 */     GIR_RootConstrainSelectedInstOperands,
     /* 236594 */     // GIR_Coverage, 3881,
     /* 236594 */     GIR_EraseRootFromParent_Done,
     /* 236595 */   // Label 4487: @236595
     /* 236595 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(236652), // Rule ID 3882 //
     /* 236600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 236608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 236611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 236614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 236617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 236620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236636 */     // (intrinsic_wo_chain:{ *:[v2f32] } 760:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 236636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 236639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 236650 */     GIR_RootConstrainSelectedInstOperands,
     /* 236651 */     // GIR_Coverage, 3882,
     /* 236651 */     GIR_EraseRootFromParent_Done,
     /* 236652 */   // Label 4488: @236652
     /* 236652 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(236709), // Rule ID 3883 //
     /* 236657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 236665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 236668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 236671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 236674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 236677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236693 */     // (intrinsic_wo_chain:{ *:[v2f32] } 758:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 236693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 236696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 236707 */     GIR_RootConstrainSelectedInstOperands,
     /* 236708 */     // GIR_Coverage, 3883,
     /* 236708 */     GIR_EraseRootFromParent_Done,
     /* 236709 */   // Label 4489: @236709
     /* 236709 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(236766), // Rule ID 3884 //
     /* 236714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 236722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 236725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 236728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 236731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 236734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 236750 */     // (intrinsic_wo_chain:{ *:[v2f32] } 759:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 236750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 236753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 236764 */     GIR_RootConstrainSelectedInstOperands,
     /* 236765 */     // GIR_Coverage, 3884,
     /* 236765 */     GIR_EraseRootFromParent_Done,
     /* 236766 */   // Label 4490: @236766
     /* 236766 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(236823), // Rule ID 3885 //
     /* 236771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 236779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236807 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 236807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 236810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 236821 */     GIR_RootConstrainSelectedInstOperands,
     /* 236822 */     // GIR_Coverage, 3885,
     /* 236822 */     GIR_EraseRootFromParent_Done,
     /* 236823 */   // Label 4491: @236823
     /* 236823 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(236880), // Rule ID 3886 //
     /* 236828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 236836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236864 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 236864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 236867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 236878 */     GIR_RootConstrainSelectedInstOperands,
     /* 236879 */     // GIR_Coverage, 3886,
     /* 236879 */     GIR_EraseRootFromParent_Done,
     /* 236880 */   // Label 4492: @236880
     /* 236880 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(236937), // Rule ID 3887 //
     /* 236885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 236893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236921 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 236921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 236924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 236935 */     GIR_RootConstrainSelectedInstOperands,
     /* 236936 */     // GIR_Coverage, 3887,
     /* 236936 */     GIR_EraseRootFromParent_Done,
     /* 236937 */   // Label 4493: @236937
     /* 236937 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(236994), // Rule ID 3888 //
     /* 236942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 236945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 236950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 236953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 236956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 236959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 236962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 236978 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 236978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 236981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 236983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 236985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 236987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 236989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 236992 */     GIR_RootConstrainSelectedInstOperands,
     /* 236993 */     // GIR_Coverage, 3888,
     /* 236993 */     GIR_EraseRootFromParent_Done,
     /* 236994 */   // Label 4494: @236994
     /* 236994 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(237051), // Rule ID 3889 //
     /* 236999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 237002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 237007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 237010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 237013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 237016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 237019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237035 */     // (intrinsic_wo_chain:{ *:[v2f64] } 757:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 237035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 237038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 237040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 237042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 237044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 237046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 237049 */     GIR_RootConstrainSelectedInstOperands,
     /* 237050 */     // GIR_Coverage, 3889,
     /* 237050 */     GIR_EraseRootFromParent_Done,
     /* 237051 */   // Label 4495: @237051
     /* 237051 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(237108), // Rule ID 3890 //
     /* 237056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 237059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 237064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 237067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 237070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 237073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 237076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237092 */     // (intrinsic_wo_chain:{ *:[v2f64] } 760:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 237092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 237095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 237097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 237099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 237101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 237103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 237106 */     GIR_RootConstrainSelectedInstOperands,
     /* 237107 */     // GIR_Coverage, 3890,
     /* 237107 */     GIR_EraseRootFromParent_Done,
     /* 237108 */   // Label 4496: @237108
     /* 237108 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(237165), // Rule ID 3891 //
     /* 237113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 237116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 237121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 237124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 237127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 237130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 237133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237149 */     // (intrinsic_wo_chain:{ *:[v2f64] } 758:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 237149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 237152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 237154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 237156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 237158 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 237160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 237163 */     GIR_RootConstrainSelectedInstOperands,
     /* 237164 */     // GIR_Coverage, 3891,
     /* 237164 */     GIR_EraseRootFromParent_Done,
     /* 237165 */   // Label 4497: @237165
     /* 237165 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(237222), // Rule ID 3892 //
     /* 237170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 237173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 237178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 237181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 237184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 237187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 237190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237206 */     // (intrinsic_wo_chain:{ *:[v2f64] } 759:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 237206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 237209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 237211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 237213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 237215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 237217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 237220 */     GIR_RootConstrainSelectedInstOperands,
     /* 237221 */     // GIR_Coverage, 3892,
     /* 237221 */     GIR_EraseRootFromParent_Done,
     /* 237222 */   // Label 4498: @237222
     /* 237222 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(237276), // Rule ID 5268 //
     /* 237227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 237230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 237235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 237251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 237255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 237259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 237263 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 237263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 237266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 237268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 237270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 237272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 237274 */     GIR_RootConstrainSelectedInstOperands,
     /* 237275 */     // GIR_Coverage, 5268,
     /* 237275 */     GIR_EraseRootFromParent_Done,
     /* 237276 */   // Label 4499: @237276
     /* 237276 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(237330), // Rule ID 5269 //
     /* 237281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 237284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 237289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 237292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 237295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 237298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 237301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 237305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 237309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 237313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 237317 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 237317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 237320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 237322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 237324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 237326 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 237328 */     GIR_RootConstrainSelectedInstOperands,
     /* 237329 */     // GIR_Coverage, 5269,
     /* 237329 */     GIR_EraseRootFromParent_Done,
     /* 237330 */   // Label 4500: @237330
     /* 237330 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(237381), // Rule ID 5622 //
     /* 237335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 237340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 237343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 237346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 237349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 237352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 237356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 237360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 237368 */     // (intrinsic_wo_chain:{ *:[v8i8] } 720:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 237368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 237371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 237373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 237375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 237377 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 237379 */     GIR_RootConstrainSelectedInstOperands,
     /* 237380 */     // GIR_Coverage, 5622,
     /* 237380 */     GIR_EraseRootFromParent_Done,
     /* 237381 */   // Label 4501: @237381
     /* 237381 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(237432), // Rule ID 5623 //
     /* 237386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 237391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 237394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 237397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 237400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 237403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 237419 */     // (intrinsic_wo_chain:{ *:[v16i8] } 720:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 237419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 237422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 237424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 237426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 237428 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 237430 */     GIR_RootConstrainSelectedInstOperands,
     /* 237431 */     // GIR_Coverage, 5623,
     /* 237431 */     GIR_EraseRootFromParent_Done,
     /* 237432 */   // Label 4502: @237432
     /* 237432 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(237474), // Rule ID 2699 //
     /* 237437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 237445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237461 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1918:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 237464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237470 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237472 */     GIR_RootConstrainSelectedInstOperands,
     /* 237473 */     // GIR_Coverage, 2699,
     /* 237473 */     GIR_EraseRootFromParent_Done,
     /* 237474 */   // Label 4503: @237474
     /* 237474 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(237516), // Rule ID 2700 //
     /* 237479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 237487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237503 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1918:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 237506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237512 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237514 */     GIR_RootConstrainSelectedInstOperands,
     /* 237515 */     // GIR_Coverage, 2700,
     /* 237515 */     GIR_EraseRootFromParent_Done,
     /* 237516 */   // Label 4504: @237516
     /* 237516 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(237558), // Rule ID 2701 //
     /* 237521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 237529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237545 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1918:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 237548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237556 */     GIR_RootConstrainSelectedInstOperands,
     /* 237557 */     // GIR_Coverage, 2701,
     /* 237557 */     GIR_EraseRootFromParent_Done,
     /* 237558 */   // Label 4505: @237558
     /* 237558 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(237600), // Rule ID 2702 //
     /* 237563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 237571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237587 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1918:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 237590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237598 */     GIR_RootConstrainSelectedInstOperands,
     /* 237599 */     // GIR_Coverage, 2702,
     /* 237599 */     GIR_EraseRootFromParent_Done,
     /* 237600 */   // Label 4506: @237600
     /* 237600 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(237642), // Rule ID 2703 //
     /* 237605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 237613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237629 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1918:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 237632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237640 */     GIR_RootConstrainSelectedInstOperands,
     /* 237641 */     // GIR_Coverage, 2703,
     /* 237641 */     GIR_EraseRootFromParent_Done,
     /* 237642 */   // Label 4507: @237642
     /* 237642 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(237684), // Rule ID 2704 //
     /* 237647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 237655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237671 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1918:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 237674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237680 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237682 */     GIR_RootConstrainSelectedInstOperands,
     /* 237683 */     // GIR_Coverage, 2704,
     /* 237683 */     GIR_EraseRootFromParent_Done,
     /* 237684 */   // Label 4508: @237684
     /* 237684 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(237726), // Rule ID 2705 //
     /* 237689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 237697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237713 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1918:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 237716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237724 */     GIR_RootConstrainSelectedInstOperands,
     /* 237725 */     // GIR_Coverage, 2705,
     /* 237725 */     GIR_EraseRootFromParent_Done,
     /* 237726 */   // Label 4509: @237726
     /* 237726 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(237768), // Rule ID 2744 //
     /* 237731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 237739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 237742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 237748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 237751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 237755 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1264:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 237755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 237758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237764 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237766 */     GIR_RootConstrainSelectedInstOperands,
     /* 237767 */     // GIR_Coverage, 2744,
     /* 237767 */     GIR_EraseRootFromParent_Done,
     /* 237768 */   // Label 4510: @237768
     /* 237768 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(237810), // Rule ID 2745 //
     /* 237773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 237781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 237784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 237790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 237793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 237797 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1264:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 237797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 237800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237806 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237808 */     GIR_RootConstrainSelectedInstOperands,
     /* 237809 */     // GIR_Coverage, 2745,
     /* 237809 */     GIR_EraseRootFromParent_Done,
     /* 237810 */   // Label 4511: @237810
     /* 237810 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(237852), // Rule ID 2746 //
     /* 237815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 237823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 237826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 237832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 237835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 237839 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1264:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 237839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 237842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237850 */     GIR_RootConstrainSelectedInstOperands,
     /* 237851 */     // GIR_Coverage, 2746,
     /* 237851 */     GIR_EraseRootFromParent_Done,
     /* 237852 */   // Label 4512: @237852
     /* 237852 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(237894), // Rule ID 2747 //
     /* 237857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 237865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 237868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 237874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 237877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 237881 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1264:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 237881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 237884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237890 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237892 */     GIR_RootConstrainSelectedInstOperands,
     /* 237893 */     // GIR_Coverage, 2747,
     /* 237893 */     GIR_EraseRootFromParent_Done,
     /* 237894 */   // Label 4513: @237894
     /* 237894 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(237936), // Rule ID 2748 //
     /* 237899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 237907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 237910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 237913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 237916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 237919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 237923 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1264:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 237923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 237926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 237928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237932 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237934 */     GIR_RootConstrainSelectedInstOperands,
     /* 237935 */     // GIR_Coverage, 2748,
     /* 237935 */     GIR_EraseRootFromParent_Done,
     /* 237936 */   // Label 4514: @237936
     /* 237936 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(237978), // Rule ID 2787 //
     /* 237941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 237949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237965 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1363:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 237965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 237968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237976 */     GIR_RootConstrainSelectedInstOperands,
     /* 237977 */     // GIR_Coverage, 2787,
     /* 237977 */     GIR_EraseRootFromParent_Done,
     /* 237978 */   // Label 4515: @237978
     /* 237978 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(238020), // Rule ID 2789 //
     /* 237983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 237991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238007 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1363:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 238010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238016 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238018 */     GIR_RootConstrainSelectedInstOperands,
     /* 238019 */     // GIR_Coverage, 2789,
     /* 238019 */     GIR_EraseRootFromParent_Done,
     /* 238020 */   // Label 4516: @238020
     /* 238020 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(238062), // Rule ID 2791 //
     /* 238025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 238033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238049 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1363:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 238052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238060 */     GIR_RootConstrainSelectedInstOperands,
     /* 238061 */     // GIR_Coverage, 2791,
     /* 238061 */     GIR_EraseRootFromParent_Done,
     /* 238062 */   // Label 4517: @238062
     /* 238062 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(238104), // Rule ID 2793 //
     /* 238067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 238075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238091 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1537:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 238094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238102 */     GIR_RootConstrainSelectedInstOperands,
     /* 238103 */     // GIR_Coverage, 2793,
     /* 238103 */     GIR_EraseRootFromParent_Done,
     /* 238104 */   // Label 4518: @238104
     /* 238104 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(238146), // Rule ID 2794 //
     /* 238109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 238117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238133 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1537:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 238136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238142 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238144 */     GIR_RootConstrainSelectedInstOperands,
     /* 238145 */     // GIR_Coverage, 2794,
     /* 238145 */     GIR_EraseRootFromParent_Done,
     /* 238146 */   // Label 4519: @238146
     /* 238146 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(238188), // Rule ID 2795 //
     /* 238151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 238159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238175 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1537:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 238178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238184 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238186 */     GIR_RootConstrainSelectedInstOperands,
     /* 238187 */     // GIR_Coverage, 2795,
     /* 238187 */     GIR_EraseRootFromParent_Done,
     /* 238188 */   // Label 4520: @238188
     /* 238188 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(238230), // Rule ID 2864 //
     /* 238193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 238201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 238210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238217 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1399:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 238220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238226 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238228 */     GIR_RootConstrainSelectedInstOperands,
     /* 238229 */     // GIR_Coverage, 2864,
     /* 238229 */     GIR_EraseRootFromParent_Done,
     /* 238230 */   // Label 4521: @238230
     /* 238230 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(238272), // Rule ID 2865 //
     /* 238235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 238243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 238252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238259 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1400:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 238262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238270 */     GIR_RootConstrainSelectedInstOperands,
     /* 238271 */     // GIR_Coverage, 2865,
     /* 238271 */     GIR_EraseRootFromParent_Done,
     /* 238272 */   // Label 4522: @238272
     /* 238272 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(238314), // Rule ID 2866 //
     /* 238277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 238285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 238294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238301 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1395:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 238304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238310 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238312 */     GIR_RootConstrainSelectedInstOperands,
     /* 238313 */     // GIR_Coverage, 2866,
     /* 238313 */     GIR_EraseRootFromParent_Done,
     /* 238314 */   // Label 4523: @238314
     /* 238314 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(238356), // Rule ID 2867 //
     /* 238319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 238327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 238336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238343 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1396:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 238346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238354 */     GIR_RootConstrainSelectedInstOperands,
     /* 238355 */     // GIR_Coverage, 2867,
     /* 238355 */     GIR_EraseRootFromParent_Done,
     /* 238356 */   // Label 4524: @238356
     /* 238356 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(238398), // Rule ID 2868 //
     /* 238361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 238369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 238378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238385 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1402:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 238388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238394 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238396 */     GIR_RootConstrainSelectedInstOperands,
     /* 238397 */     // GIR_Coverage, 2868,
     /* 238397 */     GIR_EraseRootFromParent_Done,
     /* 238398 */   // Label 4525: @238398
     /* 238398 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(238440), // Rule ID 2869 //
     /* 238403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 238411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238427 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1366:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 238430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238436 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238438 */     GIR_RootConstrainSelectedInstOperands,
     /* 238439 */     // GIR_Coverage, 2869,
     /* 238439 */     GIR_EraseRootFromParent_Done,
     /* 238440 */   // Label 4526: @238440
     /* 238440 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(238482), // Rule ID 2870 //
     /* 238445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 238453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238469 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1366:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 238472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238478 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238480 */     GIR_RootConstrainSelectedInstOperands,
     /* 238481 */     // GIR_Coverage, 2870,
     /* 238481 */     GIR_EraseRootFromParent_Done,
     /* 238482 */   // Label 4527: @238482
     /* 238482 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(238524), // Rule ID 2871 //
     /* 238487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 238495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238511 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 238514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238522 */     GIR_RootConstrainSelectedInstOperands,
     /* 238523 */     // GIR_Coverage, 2871,
     /* 238523 */     GIR_EraseRootFromParent_Done,
     /* 238524 */   // Label 4528: @238524
     /* 238524 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(238566), // Rule ID 2882 //
     /* 238529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 238537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 238546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238553 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1388:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 238556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238562 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238564 */     GIR_RootConstrainSelectedInstOperands,
     /* 238565 */     // GIR_Coverage, 2882,
     /* 238565 */     GIR_EraseRootFromParent_Done,
     /* 238566 */   // Label 4529: @238566
     /* 238566 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(238608), // Rule ID 2884 //
     /* 238571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 238579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 238588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238595 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1386:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 238598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238604 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238606 */     GIR_RootConstrainSelectedInstOperands,
     /* 238607 */     // GIR_Coverage, 2884,
     /* 238607 */     GIR_EraseRootFromParent_Done,
     /* 238608 */   // Label 4530: @238608
     /* 238608 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(238650), // Rule ID 2892 //
     /* 238613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 238621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 238630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238637 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1423:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 238640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238646 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238648 */     GIR_RootConstrainSelectedInstOperands,
     /* 238649 */     // GIR_Coverage, 2892,
     /* 238649 */     GIR_EraseRootFromParent_Done,
     /* 238650 */   // Label 4531: @238650
     /* 238650 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(238692), // Rule ID 2893 //
     /* 238655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 238663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 238672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238679 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1423:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 238682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238690 */     GIR_RootConstrainSelectedInstOperands,
     /* 238691 */     // GIR_Coverage, 2893,
     /* 238691 */     GIR_EraseRootFromParent_Done,
     /* 238692 */   // Label 4532: @238692
     /* 238692 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(238734), // Rule ID 2894 //
     /* 238697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 238705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 238714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238721 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1423:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 238724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238730 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238732 */     GIR_RootConstrainSelectedInstOperands,
     /* 238733 */     // GIR_Coverage, 2894,
     /* 238733 */     GIR_EraseRootFromParent_Done,
     /* 238734 */   // Label 4533: @238734
     /* 238734 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(238776), // Rule ID 2898 //
     /* 238739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 238747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 238756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238763 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1401:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 238766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238774 */     GIR_RootConstrainSelectedInstOperands,
     /* 238775 */     // GIR_Coverage, 2898,
     /* 238775 */     GIR_EraseRootFromParent_Done,
     /* 238776 */   // Label 4534: @238776
     /* 238776 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(238818), // Rule ID 2943 //
     /* 238781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 238789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238805 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1706:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 238808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238816 */     GIR_RootConstrainSelectedInstOperands,
     /* 238817 */     // GIR_Coverage, 2943,
     /* 238817 */     GIR_EraseRootFromParent_Done,
     /* 238818 */   // Label 4535: @238818
     /* 238818 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(238860), // Rule ID 2944 //
     /* 238823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 238831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238847 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1706:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 238850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238856 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238858 */     GIR_RootConstrainSelectedInstOperands,
     /* 238859 */     // GIR_Coverage, 2944,
     /* 238859 */     GIR_EraseRootFromParent_Done,
     /* 238860 */   // Label 4536: @238860
     /* 238860 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(238902), // Rule ID 2973 //
     /* 238865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 238873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238889 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1822:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 238892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238898 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238900 */     GIR_RootConstrainSelectedInstOperands,
     /* 238901 */     // GIR_Coverage, 2973,
     /* 238901 */     GIR_EraseRootFromParent_Done,
     /* 238902 */   // Label 4537: @238902
     /* 238902 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(238944), // Rule ID 2974 //
     /* 238907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 238915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238931 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1822:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 238934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238940 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238942 */     GIR_RootConstrainSelectedInstOperands,
     /* 238943 */     // GIR_Coverage, 2974,
     /* 238943 */     GIR_EraseRootFromParent_Done,
     /* 238944 */   // Label 4538: @238944
     /* 238944 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(238986), // Rule ID 2975 //
     /* 238949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 238957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238973 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1822:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 238976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 238978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238984 */     GIR_RootConstrainSelectedInstOperands,
     /* 238985 */     // GIR_Coverage, 2975,
     /* 238985 */     GIR_EraseRootFromParent_Done,
     /* 238986 */   // Label 4539: @238986
     /* 238986 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(239028), // Rule ID 2976 //
     /* 238991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 238999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239015 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1822:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 239018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239024 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239026 */     GIR_RootConstrainSelectedInstOperands,
     /* 239027 */     // GIR_Coverage, 2976,
     /* 239027 */     GIR_EraseRootFromParent_Done,
     /* 239028 */   // Label 4540: @239028
     /* 239028 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(239070), // Rule ID 2977 //
     /* 239033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 239041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239057 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1743:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 239060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239066 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239068 */     GIR_RootConstrainSelectedInstOperands,
     /* 239069 */     // GIR_Coverage, 2977,
     /* 239069 */     GIR_EraseRootFromParent_Done,
     /* 239070 */   // Label 4541: @239070
     /* 239070 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(239112), // Rule ID 2978 //
     /* 239075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 239083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239099 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1743:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 239102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239108 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239110 */     GIR_RootConstrainSelectedInstOperands,
     /* 239111 */     // GIR_Coverage, 2978,
     /* 239111 */     GIR_EraseRootFromParent_Done,
     /* 239112 */   // Label 4542: @239112
     /* 239112 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(239154), // Rule ID 2979 //
     /* 239117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 239125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239141 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1743:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 239144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239150 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239152 */     GIR_RootConstrainSelectedInstOperands,
     /* 239153 */     // GIR_Coverage, 2979,
     /* 239153 */     GIR_EraseRootFromParent_Done,
     /* 239154 */   // Label 4543: @239154
     /* 239154 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(239196), // Rule ID 3009 //
     /* 239159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 239167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239183 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1717:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 239186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239192 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239194 */     GIR_RootConstrainSelectedInstOperands,
     /* 239195 */     // GIR_Coverage, 3009,
     /* 239195 */     GIR_EraseRootFromParent_Done,
     /* 239196 */   // Label 4544: @239196
     /* 239196 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(239238), // Rule ID 3011 //
     /* 239201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 239209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239225 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1717:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 239228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239234 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239236 */     GIR_RootConstrainSelectedInstOperands,
     /* 239237 */     // GIR_Coverage, 3011,
     /* 239237 */     GIR_EraseRootFromParent_Done,
     /* 239238 */   // Label 4545: @239238
     /* 239238 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(239280), // Rule ID 3013 //
     /* 239243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 239251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239267 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1717:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 239270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239276 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239278 */     GIR_RootConstrainSelectedInstOperands,
     /* 239279 */     // GIR_Coverage, 3013,
     /* 239279 */     GIR_EraseRootFromParent_Done,
     /* 239280 */   // Label 4546: @239280
     /* 239280 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(239322), // Rule ID 3015 //
     /* 239285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 239293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239309 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1717:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 239312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239320 */     GIR_RootConstrainSelectedInstOperands,
     /* 239321 */     // GIR_Coverage, 3015,
     /* 239321 */     GIR_EraseRootFromParent_Done,
     /* 239322 */   // Label 4547: @239322
     /* 239322 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(239364), // Rule ID 3017 //
     /* 239327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 239335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239351 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1687:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 239354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239360 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239362 */     GIR_RootConstrainSelectedInstOperands,
     /* 239363 */     // GIR_Coverage, 3017,
     /* 239363 */     GIR_EraseRootFromParent_Done,
     /* 239364 */   // Label 4548: @239364
     /* 239364 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(239406), // Rule ID 3018 //
     /* 239369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 239377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239393 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1687:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 239396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239402 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239404 */     GIR_RootConstrainSelectedInstOperands,
     /* 239405 */     // GIR_Coverage, 3018,
     /* 239405 */     GIR_EraseRootFromParent_Done,
     /* 239406 */   // Label 4549: @239406
     /* 239406 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(239448), // Rule ID 3019 //
     /* 239411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 239419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239435 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1687:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 239438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239444 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239446 */     GIR_RootConstrainSelectedInstOperands,
     /* 239447 */     // GIR_Coverage, 3019,
     /* 239447 */     GIR_EraseRootFromParent_Done,
     /* 239448 */   // Label 4550: @239448
     /* 239448 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(239490), // Rule ID 3020 //
     /* 239453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 239461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 239470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239477 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 239480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239486 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239488 */     GIR_RootConstrainSelectedInstOperands,
     /* 239489 */     // GIR_Coverage, 3020,
     /* 239489 */     GIR_EraseRootFromParent_Done,
     /* 239490 */   // Label 4551: @239490
     /* 239490 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(239532), // Rule ID 3021 //
     /* 239495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 239503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239519 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 239522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239530 */     GIR_RootConstrainSelectedInstOperands,
     /* 239531 */     // GIR_Coverage, 3021,
     /* 239531 */     GIR_EraseRootFromParent_Done,
     /* 239532 */   // Label 4552: @239532
     /* 239532 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(239574), // Rule ID 3022 //
     /* 239537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 239545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 239554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239561 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 239564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239572 */     GIR_RootConstrainSelectedInstOperands,
     /* 239573 */     // GIR_Coverage, 3022,
     /* 239573 */     GIR_EraseRootFromParent_Done,
     /* 239574 */   // Label 4553: @239574
     /* 239574 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(239616), // Rule ID 3023 //
     /* 239579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 239587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 239596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239603 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 239606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239612 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239614 */     GIR_RootConstrainSelectedInstOperands,
     /* 239615 */     // GIR_Coverage, 3023,
     /* 239615 */     GIR_EraseRootFromParent_Done,
     /* 239616 */   // Label 4554: @239616
     /* 239616 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(239658), // Rule ID 3024 //
     /* 239621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 239629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 239638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239645 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 239648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239654 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239656 */     GIR_RootConstrainSelectedInstOperands,
     /* 239657 */     // GIR_Coverage, 3024,
     /* 239657 */     GIR_EraseRootFromParent_Done,
     /* 239658 */   // Label 4555: @239658
     /* 239658 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(239700), // Rule ID 3041 //
     /* 239663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 239671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239687 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1352:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 239690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239696 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239698 */     GIR_RootConstrainSelectedInstOperands,
     /* 239699 */     // GIR_Coverage, 3041,
     /* 239699 */     GIR_EraseRootFromParent_Done,
     /* 239700 */   // Label 4556: @239700
     /* 239700 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(239742), // Rule ID 3042 //
     /* 239705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 239713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239729 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1352:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 239732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239740 */     GIR_RootConstrainSelectedInstOperands,
     /* 239741 */     // GIR_Coverage, 3042,
     /* 239741 */     GIR_EraseRootFromParent_Done,
     /* 239742 */   // Label 4557: @239742
     /* 239742 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(239784), // Rule ID 3043 //
     /* 239747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 239755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239771 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1352:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 239774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239782 */     GIR_RootConstrainSelectedInstOperands,
     /* 239783 */     // GIR_Coverage, 3043,
     /* 239783 */     GIR_EraseRootFromParent_Done,
     /* 239784 */   // Label 4558: @239784
     /* 239784 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(239826), // Rule ID 3044 //
     /* 239789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 239797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239813 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1352:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 239816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239822 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239824 */     GIR_RootConstrainSelectedInstOperands,
     /* 239825 */     // GIR_Coverage, 3044,
     /* 239825 */     GIR_EraseRootFromParent_Done,
     /* 239826 */   // Label 4559: @239826
     /* 239826 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(239868), // Rule ID 3068 //
     /* 239831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 239839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239855 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1680:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 239858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239864 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239866 */     GIR_RootConstrainSelectedInstOperands,
     /* 239867 */     // GIR_Coverage, 3068,
     /* 239867 */     GIR_EraseRootFromParent_Done,
     /* 239868 */   // Label 4560: @239868
     /* 239868 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(239910), // Rule ID 3070 //
     /* 239873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 239881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239897 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1680:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 239900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239906 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239908 */     GIR_RootConstrainSelectedInstOperands,
     /* 239909 */     // GIR_Coverage, 3070,
     /* 239909 */     GIR_EraseRootFromParent_Done,
     /* 239910 */   // Label 4561: @239910
     /* 239910 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(239952), // Rule ID 3072 //
     /* 239915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 239923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239939 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1680:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 239942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239948 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239950 */     GIR_RootConstrainSelectedInstOperands,
     /* 239951 */     // GIR_Coverage, 3072,
     /* 239951 */     GIR_EraseRootFromParent_Done,
     /* 239952 */   // Label 4562: @239952
     /* 239952 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(239994), // Rule ID 3074 //
     /* 239957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 239965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239981 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1680:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 239984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239992 */     GIR_RootConstrainSelectedInstOperands,
     /* 239993 */     // GIR_Coverage, 3074,
     /* 239993 */     GIR_EraseRootFromParent_Done,
     /* 239994 */   // Label 4563: @239994
     /* 239994 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(240036), // Rule ID 3076 //
     /* 239999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 240007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240023 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1681:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 240026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240032 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240034 */     GIR_RootConstrainSelectedInstOperands,
     /* 240035 */     // GIR_Coverage, 3076,
     /* 240035 */     GIR_EraseRootFromParent_Done,
     /* 240036 */   // Label 4564: @240036
     /* 240036 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(240078), // Rule ID 3077 //
     /* 240041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 240049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240065 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1681:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 240068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240074 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240076 */     GIR_RootConstrainSelectedInstOperands,
     /* 240077 */     // GIR_Coverage, 3077,
     /* 240077 */     GIR_EraseRootFromParent_Done,
     /* 240078 */   // Label 4565: @240078
     /* 240078 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(240120), // Rule ID 3078 //
     /* 240083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 240091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240107 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1681:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 240110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240118 */     GIR_RootConstrainSelectedInstOperands,
     /* 240119 */     // GIR_Coverage, 3078,
     /* 240119 */     GIR_EraseRootFromParent_Done,
     /* 240120 */   // Label 4566: @240120
     /* 240120 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(240162), // Rule ID 3079 //
     /* 240125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 240133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240149 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1244:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 240152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240158 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240160 */     GIR_RootConstrainSelectedInstOperands,
     /* 240161 */     // GIR_Coverage, 3079,
     /* 240161 */     GIR_EraseRootFromParent_Done,
     /* 240162 */   // Label 4567: @240162
     /* 240162 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(240204), // Rule ID 3080 //
     /* 240167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 240175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240191 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1244:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 240194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240202 */     GIR_RootConstrainSelectedInstOperands,
     /* 240203 */     // GIR_Coverage, 3080,
     /* 240203 */     GIR_EraseRootFromParent_Done,
     /* 240204 */   // Label 4568: @240204
     /* 240204 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(240246), // Rule ID 3090 //
     /* 240209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 240217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240233 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1251:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 240236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240242 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240244 */     GIR_RootConstrainSelectedInstOperands,
     /* 240245 */     // GIR_Coverage, 3090,
     /* 240245 */     GIR_EraseRootFromParent_Done,
     /* 240246 */   // Label 4569: @240246
     /* 240246 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(240288), // Rule ID 3091 //
     /* 240251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 240259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240275 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1251:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 240278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240286 */     GIR_RootConstrainSelectedInstOperands,
     /* 240287 */     // GIR_Coverage, 3091,
     /* 240287 */     GIR_EraseRootFromParent_Done,
     /* 240288 */   // Label 4570: @240288
     /* 240288 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(240330), // Rule ID 3092 //
     /* 240293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 240301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240317 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1251:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 240320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240326 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240328 */     GIR_RootConstrainSelectedInstOperands,
     /* 240329 */     // GIR_Coverage, 3092,
     /* 240329 */     GIR_EraseRootFromParent_Done,
     /* 240330 */   // Label 4571: @240330
     /* 240330 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(240372), // Rule ID 3109 //
     /* 240335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 240343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 240352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240359 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1310:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 240359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 240362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 240366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 240368 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 240370 */     GIR_RootConstrainSelectedInstOperands,
     /* 240371 */     // GIR_Coverage, 3109,
     /* 240371 */     GIR_EraseRootFromParent_Done,
     /* 240372 */   // Label 4572: @240372
     /* 240372 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(240414), // Rule ID 3110 //
     /* 240377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 240385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 240394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240401 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1310:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 240401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 240404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 240408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 240410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 240412 */     GIR_RootConstrainSelectedInstOperands,
     /* 240413 */     // GIR_Coverage, 3110,
     /* 240413 */     GIR_EraseRootFromParent_Done,
     /* 240414 */   // Label 4573: @240414
     /* 240414 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(240456), // Rule ID 3111 //
     /* 240419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 240427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 240436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240443 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1310:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 240443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 240446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 240450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 240452 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 240454 */     GIR_RootConstrainSelectedInstOperands,
     /* 240455 */     // GIR_Coverage, 3111,
     /* 240455 */     GIR_EraseRootFromParent_Done,
     /* 240456 */   // Label 4574: @240456
     /* 240456 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(240498), // Rule ID 3112 //
     /* 240461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 240469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 240478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240485 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1310:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 240485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 240488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 240492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 240494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 240496 */     GIR_RootConstrainSelectedInstOperands,
     /* 240497 */     // GIR_Coverage, 3112,
     /* 240497 */     GIR_EraseRootFromParent_Done,
     /* 240498 */   // Label 4575: @240498
     /* 240498 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(240540), // Rule ID 3147 //
     /* 240503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 240511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240527 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1351:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 240530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240536 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240538 */     GIR_RootConstrainSelectedInstOperands,
     /* 240539 */     // GIR_Coverage, 3147,
     /* 240539 */     GIR_EraseRootFromParent_Done,
     /* 240540 */   // Label 4576: @240540
     /* 240540 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(240582), // Rule ID 3149 //
     /* 240545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 240553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240569 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1351:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 240572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240578 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240580 */     GIR_RootConstrainSelectedInstOperands,
     /* 240581 */     // GIR_Coverage, 3149,
     /* 240581 */     GIR_EraseRootFromParent_Done,
     /* 240582 */   // Label 4577: @240582
     /* 240582 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(240624), // Rule ID 3151 //
     /* 240587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 240595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240611 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1351:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 240614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240620 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240622 */     GIR_RootConstrainSelectedInstOperands,
     /* 240623 */     // GIR_Coverage, 3151,
     /* 240623 */     GIR_EraseRootFromParent_Done,
     /* 240624 */   // Label 4578: @240624
     /* 240624 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(240666), // Rule ID 3153 //
     /* 240629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 240637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240653 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1351:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 240656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240662 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240664 */     GIR_RootConstrainSelectedInstOperands,
     /* 240665 */     // GIR_Coverage, 3153,
     /* 240665 */     GIR_EraseRootFromParent_Done,
     /* 240666 */   // Label 4579: @240666
     /* 240666 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(240711), // Rule ID 3192 //
     /* 240671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 240679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 240682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240695 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1315:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 240698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 240709 */     GIR_RootConstrainSelectedInstOperands,
     /* 240710 */     // GIR_Coverage, 3192,
     /* 240710 */     GIR_EraseRootFromParent_Done,
     /* 240711 */   // Label 4580: @240711
     /* 240711 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(240756), // Rule ID 3193 //
     /* 240716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 240724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 240727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240740 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 240743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240749 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 240754 */     GIR_RootConstrainSelectedInstOperands,
     /* 240755 */     // GIR_Coverage, 3193,
     /* 240755 */     GIR_EraseRootFromParent_Done,
     /* 240756 */   // Label 4581: @240756
     /* 240756 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(240801), // Rule ID 3194 //
     /* 240761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 240769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 240772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240785 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 240788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 240799 */     GIR_RootConstrainSelectedInstOperands,
     /* 240800 */     // GIR_Coverage, 3194,
     /* 240800 */     GIR_EraseRootFromParent_Done,
     /* 240801 */   // Label 4582: @240801
     /* 240801 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(240846), // Rule ID 3195 //
     /* 240806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 240814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 240817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240830 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1317:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 240833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 240844 */     GIR_RootConstrainSelectedInstOperands,
     /* 240845 */     // GIR_Coverage, 3195,
     /* 240845 */     GIR_EraseRootFromParent_Done,
     /* 240846 */   // Label 4583: @240846
     /* 240846 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(240891), // Rule ID 3196 //
     /* 240851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 240859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 240862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240875 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1317:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 240878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 240889 */     GIR_RootConstrainSelectedInstOperands,
     /* 240890 */     // GIR_Coverage, 3196,
     /* 240890 */     GIR_EraseRootFromParent_Done,
     /* 240891 */   // Label 4584: @240891
     /* 240891 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(240936), // Rule ID 3197 //
     /* 240896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 240904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 240907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240920 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1317:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 240923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 240934 */     GIR_RootConstrainSelectedInstOperands,
     /* 240935 */     // GIR_Coverage, 3197,
     /* 240935 */     GIR_EraseRootFromParent_Done,
     /* 240936 */   // Label 4585: @240936
     /* 240936 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(240978), // Rule ID 3252 //
     /* 240941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 240949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 240952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 240965 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1361:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 240968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 240970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240976 */     GIR_RootConstrainSelectedInstOperands,
     /* 240977 */     // GIR_Coverage, 3252,
     /* 240977 */     GIR_EraseRootFromParent_Done,
     /* 240978 */   // Label 4586: @240978
     /* 240978 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(241020), // Rule ID 3253 //
     /* 240983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 240991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 240994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 241007 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1361:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 241010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241016 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241018 */     GIR_RootConstrainSelectedInstOperands,
     /* 241019 */     // GIR_Coverage, 3253,
     /* 241019 */     GIR_EraseRootFromParent_Done,
     /* 241020 */   // Label 4587: @241020
     /* 241020 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(241062), // Rule ID 3254 //
     /* 241025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 241033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 241036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 241049 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1361:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 241052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241060 */     GIR_RootConstrainSelectedInstOperands,
     /* 241061 */     // GIR_Coverage, 3254,
     /* 241061 */     GIR_EraseRootFromParent_Done,
     /* 241062 */   // Label 4588: @241062
     /* 241062 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(241104), // Rule ID 3306 //
     /* 241067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 241075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241091 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1267:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 241094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241102 */     GIR_RootConstrainSelectedInstOperands,
     /* 241103 */     // GIR_Coverage, 3306,
     /* 241103 */     GIR_EraseRootFromParent_Done,
     /* 241104 */   // Label 4589: @241104
     /* 241104 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(241146), // Rule ID 3307 //
     /* 241109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 241117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241133 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1267:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 241136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241142 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241144 */     GIR_RootConstrainSelectedInstOperands,
     /* 241145 */     // GIR_Coverage, 3307,
     /* 241145 */     GIR_EraseRootFromParent_Done,
     /* 241146 */   // Label 4590: @241146
     /* 241146 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(241188), // Rule ID 3308 //
     /* 241151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 241159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241175 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1267:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 241178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241184 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241186 */     GIR_RootConstrainSelectedInstOperands,
     /* 241187 */     // GIR_Coverage, 3308,
     /* 241187 */     GIR_EraseRootFromParent_Done,
     /* 241188 */   // Label 4591: @241188
     /* 241188 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(241230), // Rule ID 3309 //
     /* 241193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 241201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241217 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1267:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 241220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241226 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241228 */     GIR_RootConstrainSelectedInstOperands,
     /* 241229 */     // GIR_Coverage, 3309,
     /* 241229 */     GIR_EraseRootFromParent_Done,
     /* 241230 */   // Label 4592: @241230
     /* 241230 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(241272), // Rule ID 3318 //
     /* 241235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 241243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241259 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1269:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 241262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241270 */     GIR_RootConstrainSelectedInstOperands,
     /* 241271 */     // GIR_Coverage, 3318,
     /* 241271 */     GIR_EraseRootFromParent_Done,
     /* 241272 */   // Label 4593: @241272
     /* 241272 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(241314), // Rule ID 3319 //
     /* 241277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 241285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241301 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1269:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 241304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241310 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241312 */     GIR_RootConstrainSelectedInstOperands,
     /* 241313 */     // GIR_Coverage, 3319,
     /* 241313 */     GIR_EraseRootFromParent_Done,
     /* 241314 */   // Label 4594: @241314
     /* 241314 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(241356), // Rule ID 3320 //
     /* 241319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 241327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241343 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1269:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 241346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241354 */     GIR_RootConstrainSelectedInstOperands,
     /* 241355 */     // GIR_Coverage, 3320,
     /* 241355 */     GIR_EraseRootFromParent_Done,
     /* 241356 */   // Label 4595: @241356
     /* 241356 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(241398), // Rule ID 3359 //
     /* 241361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 241369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241385 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1306:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 241388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241394 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241396 */     GIR_RootConstrainSelectedInstOperands,
     /* 241397 */     // GIR_Coverage, 3359,
     /* 241397 */     GIR_EraseRootFromParent_Done,
     /* 241398 */   // Label 4596: @241398
     /* 241398 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(241440), // Rule ID 3360 //
     /* 241403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 241411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241427 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1306:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 241430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241436 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241438 */     GIR_RootConstrainSelectedInstOperands,
     /* 241439 */     // GIR_Coverage, 3360,
     /* 241439 */     GIR_EraseRootFromParent_Done,
     /* 241440 */   // Label 4597: @241440
     /* 241440 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(241482), // Rule ID 3361 //
     /* 241445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 241453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241469 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1306:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 241472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241478 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241480 */     GIR_RootConstrainSelectedInstOperands,
     /* 241481 */     // GIR_Coverage, 3361,
     /* 241481 */     GIR_EraseRootFromParent_Done,
     /* 241482 */   // Label 4598: @241482
     /* 241482 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(241524), // Rule ID 3362 //
     /* 241487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 241495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241511 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1306:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 241514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241522 */     GIR_RootConstrainSelectedInstOperands,
     /* 241523 */     // GIR_Coverage, 3362,
     /* 241523 */     GIR_EraseRootFromParent_Done,
     /* 241524 */   // Label 4599: @241524
     /* 241524 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(241566), // Rule ID 3363 //
     /* 241529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 241537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241553 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1306:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 241556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241562 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241564 */     GIR_RootConstrainSelectedInstOperands,
     /* 241565 */     // GIR_Coverage, 3363,
     /* 241565 */     GIR_EraseRootFromParent_Done,
     /* 241566 */   // Label 4600: @241566
     /* 241566 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(241608), // Rule ID 3364 //
     /* 241571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 241579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241595 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1306:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 241598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241604 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241606 */     GIR_RootConstrainSelectedInstOperands,
     /* 241607 */     // GIR_Coverage, 3364,
     /* 241607 */     GIR_EraseRootFromParent_Done,
     /* 241608 */   // Label 4601: @241608
     /* 241608 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(241650), // Rule ID 3365 //
     /* 241613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 241621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241637 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1306:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 241640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241646 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241648 */     GIR_RootConstrainSelectedInstOperands,
     /* 241649 */     // GIR_Coverage, 3365,
     /* 241649 */     GIR_EraseRootFromParent_Done,
     /* 241650 */   // Label 4602: @241650
     /* 241650 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(241692), // Rule ID 3448 //
     /* 241655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 241663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 241675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 241679 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1298:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 241679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 241682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241690 */     GIR_RootConstrainSelectedInstOperands,
     /* 241691 */     // GIR_Coverage, 3448,
     /* 241691 */     GIR_EraseRootFromParent_Done,
     /* 241692 */   // Label 4603: @241692
     /* 241692 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(241734), // Rule ID 3449 //
     /* 241697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 241705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 241717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 241721 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1297:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 241721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 241724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 241726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241730 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241732 */     GIR_RootConstrainSelectedInstOperands,
     /* 241733 */     // GIR_Coverage, 3449,
     /* 241733 */     GIR_EraseRootFromParent_Done,
     /* 241734 */   // Label 4604: @241734
     /* 241734 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(241776), // Rule ID 3450 //
     /* 241739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 241747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 241759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 241763 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1293:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 241763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 241766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241774 */     GIR_RootConstrainSelectedInstOperands,
     /* 241775 */     // GIR_Coverage, 3450,
     /* 241775 */     GIR_EraseRootFromParent_Done,
     /* 241776 */   // Label 4605: @241776
     /* 241776 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(241821), // Rule ID 3452 //
     /* 241781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 241784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 241789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 241792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 241805 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1600:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 241808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 241819 */     GIR_RootConstrainSelectedInstOperands,
     /* 241820 */     // GIR_Coverage, 3452,
     /* 241820 */     GIR_EraseRootFromParent_Done,
     /* 241821 */   // Label 4606: @241821
     /* 241821 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(241866), // Rule ID 3453 //
     /* 241826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 241829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 241834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 241837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 241850 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1600:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 241853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 241855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241859 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 241864 */     GIR_RootConstrainSelectedInstOperands,
     /* 241865 */     // GIR_Coverage, 3453,
     /* 241865 */     GIR_EraseRootFromParent_Done,
     /* 241866 */   // Label 4607: @241866
     /* 241866 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(241908), // Rule ID 3454 //
     /* 241871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 241874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 241879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241895 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1545:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 241898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241906 */     GIR_RootConstrainSelectedInstOperands,
     /* 241907 */     // GIR_Coverage, 3454,
     /* 241907 */     GIR_EraseRootFromParent_Done,
     /* 241908 */   // Label 4608: @241908
     /* 241908 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(241950), // Rule ID 3455 //
     /* 241913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 241916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 241921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241937 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1545:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 241940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241948 */     GIR_RootConstrainSelectedInstOperands,
     /* 241949 */     // GIR_Coverage, 3455,
     /* 241949 */     GIR_EraseRootFromParent_Done,
     /* 241950 */   // Label 4609: @241950
     /* 241950 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(241992), // Rule ID 3460 //
     /* 241955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 241958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 241963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241979 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 241982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 241984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241990 */     GIR_RootConstrainSelectedInstOperands,
     /* 241991 */     // GIR_Coverage, 3460,
     /* 241991 */     GIR_EraseRootFromParent_Done,
     /* 241992 */   // Label 4610: @241992
     /* 241992 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(242034), // Rule ID 3499 //
     /* 241997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 242000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 242005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 242011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242021 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1374:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 242024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242032 */     GIR_RootConstrainSelectedInstOperands,
     /* 242033 */     // GIR_Coverage, 3499,
     /* 242033 */     GIR_EraseRootFromParent_Done,
     /* 242034 */   // Label 4611: @242034
     /* 242034 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(242076), // Rule ID 3501 //
     /* 242039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 242042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 242047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242063 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1374:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 242066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242074 */     GIR_RootConstrainSelectedInstOperands,
     /* 242075 */     // GIR_Coverage, 3501,
     /* 242075 */     GIR_EraseRootFromParent_Done,
     /* 242076 */   // Label 4612: @242076
     /* 242076 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(242118), // Rule ID 3503 //
     /* 242081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 242084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 242089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 242095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242105 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1374:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 242108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242116 */     GIR_RootConstrainSelectedInstOperands,
     /* 242117 */     // GIR_Coverage, 3503,
     /* 242117 */     GIR_EraseRootFromParent_Done,
     /* 242118 */   // Label 4613: @242118
     /* 242118 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(242160), // Rule ID 3505 //
     /* 242123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 242126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 242131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242147 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1712:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 242150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 242152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242158 */     GIR_RootConstrainSelectedInstOperands,
     /* 242159 */     // GIR_Coverage, 3505,
     /* 242159 */     GIR_EraseRootFromParent_Done,
     /* 242160 */   // Label 4614: @242160
     /* 242160 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(242202), // Rule ID 3632 //
     /* 242165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 242168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 242173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 242179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242189 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1696:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 242189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 242192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242200 */     GIR_RootConstrainSelectedInstOperands,
     /* 242201 */     // GIR_Coverage, 3632,
     /* 242201 */     GIR_EraseRootFromParent_Done,
     /* 242202 */   // Label 4615: @242202
     /* 242202 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(242244), // Rule ID 3634 //
     /* 242207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 242210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 242215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 242221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242231 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1696:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 242234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242242 */     GIR_RootConstrainSelectedInstOperands,
     /* 242243 */     // GIR_Coverage, 3634,
     /* 242243 */     GIR_EraseRootFromParent_Done,
     /* 242244 */   // Label 4616: @242244
     /* 242244 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(242286), // Rule ID 3636 //
     /* 242249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 242252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 242257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 242263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242273 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 242276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242284 */     GIR_RootConstrainSelectedInstOperands,
     /* 242285 */     // GIR_Coverage, 3636,
     /* 242285 */     GIR_EraseRootFromParent_Done,
     /* 242286 */   // Label 4617: @242286
     /* 242286 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(242328), // Rule ID 3638 //
     /* 242291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 242294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 242299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 242305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242315 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 242318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242326 */     GIR_RootConstrainSelectedInstOperands,
     /* 242327 */     // GIR_Coverage, 3638,
     /* 242327 */     GIR_EraseRootFromParent_Done,
     /* 242328 */   // Label 4618: @242328
     /* 242328 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(242370), // Rule ID 7554 //
     /* 242333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 242341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242357 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1905:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 242357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 242360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242368 */     GIR_RootConstrainSelectedInstOperands,
     /* 242369 */     // GIR_Coverage, 7554,
     /* 242369 */     GIR_EraseRootFromParent_Done,
     /* 242370 */   // Label 4619: @242370
     /* 242370 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(242412), // Rule ID 7556 //
     /* 242375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 242383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242399 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1905:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 242402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242410 */     GIR_RootConstrainSelectedInstOperands,
     /* 242411 */     // GIR_Coverage, 7556,
     /* 242411 */     GIR_EraseRootFromParent_Done,
     /* 242412 */   // Label 4620: @242412
     /* 242412 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(242454), // Rule ID 7558 //
     /* 242417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 242425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242441 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1905:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 242444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242452 */     GIR_RootConstrainSelectedInstOperands,
     /* 242453 */     // GIR_Coverage, 7558,
     /* 242453 */     GIR_EraseRootFromParent_Done,
     /* 242454 */   // Label 4621: @242454
     /* 242454 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(242496), // Rule ID 7560 //
     /* 242459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 242467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242483 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1905:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 242486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242494 */     GIR_RootConstrainSelectedInstOperands,
     /* 242495 */     // GIR_Coverage, 7560,
     /* 242495 */     GIR_EraseRootFromParent_Done,
     /* 242496 */   // Label 4622: @242496
     /* 242496 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(242538), // Rule ID 7578 //
     /* 242501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 242509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242525 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1290:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 242525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 242528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242536 */     GIR_RootConstrainSelectedInstOperands,
     /* 242537 */     // GIR_Coverage, 7578,
     /* 242537 */     GIR_EraseRootFromParent_Done,
     /* 242538 */   // Label 4623: @242538
     /* 242538 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(242580), // Rule ID 7579 //
     /* 242543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 242551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242567 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1290:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 242570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242578 */     GIR_RootConstrainSelectedInstOperands,
     /* 242579 */     // GIR_Coverage, 7579,
     /* 242579 */     GIR_EraseRootFromParent_Done,
     /* 242580 */   // Label 4624: @242580
     /* 242580 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(242622), // Rule ID 7580 //
     /* 242585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 242593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242609 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1290:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 242612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242620 */     GIR_RootConstrainSelectedInstOperands,
     /* 242621 */     // GIR_Coverage, 7580,
     /* 242621 */     GIR_EraseRootFromParent_Done,
     /* 242622 */   // Label 4625: @242622
     /* 242622 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(242664), // Rule ID 7581 //
     /* 242627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 242635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242651 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1290:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 242654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242662 */     GIR_RootConstrainSelectedInstOperands,
     /* 242663 */     // GIR_Coverage, 7581,
     /* 242663 */     GIR_EraseRootFromParent_Done,
     /* 242664 */   // Label 4626: @242664
     /* 242664 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(242706), // Rule ID 7694 //
     /* 242669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 242677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242693 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1752:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 242693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 242696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242704 */     GIR_RootConstrainSelectedInstOperands,
     /* 242705 */     // GIR_Coverage, 7694,
     /* 242705 */     GIR_EraseRootFromParent_Done,
     /* 242706 */   // Label 4627: @242706
     /* 242706 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(242748), // Rule ID 7695 //
     /* 242711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 242719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242735 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1752:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 242738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242746 */     GIR_RootConstrainSelectedInstOperands,
     /* 242747 */     // GIR_Coverage, 7695,
     /* 242747 */     GIR_EraseRootFromParent_Done,
     /* 242748 */   // Label 4628: @242748
     /* 242748 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(242790), // Rule ID 7696 //
     /* 242753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 242761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242777 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1752:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 242780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242788 */     GIR_RootConstrainSelectedInstOperands,
     /* 242789 */     // GIR_Coverage, 7696,
     /* 242789 */     GIR_EraseRootFromParent_Done,
     /* 242790 */   // Label 4629: @242790
     /* 242790 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(242832), // Rule ID 7697 //
     /* 242795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 242803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242819 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1752:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 242822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242830 */     GIR_RootConstrainSelectedInstOperands,
     /* 242831 */     // GIR_Coverage, 7697,
     /* 242831 */     GIR_EraseRootFromParent_Done,
     /* 242832 */   // Label 4630: @242832
     /* 242832 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(242874), // Rule ID 7698 //
     /* 242837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 242845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242861 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1990:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 242861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 242864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242872 */     GIR_RootConstrainSelectedInstOperands,
     /* 242873 */     // GIR_Coverage, 7698,
     /* 242873 */     GIR_EraseRootFromParent_Done,
     /* 242874 */   // Label 4631: @242874
     /* 242874 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(242916), // Rule ID 7699 //
     /* 242879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 242887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242903 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1990:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 242903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 242906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242914 */     GIR_RootConstrainSelectedInstOperands,
     /* 242915 */     // GIR_Coverage, 7699,
     /* 242915 */     GIR_EraseRootFromParent_Done,
     /* 242916 */   // Label 4632: @242916
     /* 242916 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(242958), // Rule ID 7700 //
     /* 242921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 242929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242945 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1990:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 242945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 242948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242956 */     GIR_RootConstrainSelectedInstOperands,
     /* 242957 */     // GIR_Coverage, 7700,
     /* 242957 */     GIR_EraseRootFromParent_Done,
     /* 242958 */   // Label 4633: @242958
     /* 242958 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(243000), // Rule ID 7701 //
     /* 242963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 242971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242987 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1990:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 242987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 242990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242998 */     GIR_RootConstrainSelectedInstOperands,
     /* 242999 */     // GIR_Coverage, 7701,
     /* 242999 */     GIR_EraseRootFromParent_Done,
     /* 243000 */   // Label 4634: @243000
     /* 243000 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(243042), // Rule ID 7710 //
     /* 243005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 243013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243029 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1953:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 243029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 243032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243040 */     GIR_RootConstrainSelectedInstOperands,
     /* 243041 */     // GIR_Coverage, 7710,
     /* 243041 */     GIR_EraseRootFromParent_Done,
     /* 243042 */   // Label 4635: @243042
     /* 243042 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(243084), // Rule ID 7711 //
     /* 243047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 243055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243071 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1953:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 243074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243082 */     GIR_RootConstrainSelectedInstOperands,
     /* 243083 */     // GIR_Coverage, 7711,
     /* 243083 */     GIR_EraseRootFromParent_Done,
     /* 243084 */   // Label 4636: @243084
     /* 243084 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(243126), // Rule ID 7712 //
     /* 243089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 243097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243113 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1708:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 243113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 243116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243124 */     GIR_RootConstrainSelectedInstOperands,
     /* 243125 */     // GIR_Coverage, 7712,
     /* 243125 */     GIR_EraseRootFromParent_Done,
     /* 243126 */   // Label 4637: @243126
     /* 243126 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(243168), // Rule ID 7713 //
     /* 243131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 243139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243155 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1708:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 243158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243166 */     GIR_RootConstrainSelectedInstOperands,
     /* 243167 */     // GIR_Coverage, 7713,
     /* 243167 */     GIR_EraseRootFromParent_Done,
     /* 243168 */   // Label 4638: @243168
     /* 243168 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(243210), // Rule ID 7714 //
     /* 243173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 243181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1955:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 243197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 243200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243208 */     GIR_RootConstrainSelectedInstOperands,
     /* 243209 */     // GIR_Coverage, 7714,
     /* 243209 */     GIR_EraseRootFromParent_Done,
     /* 243210 */   // Label 4639: @243210
     /* 243210 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(243252), // Rule ID 7715 //
     /* 243215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 243223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243239 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1955:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 243242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243250 */     GIR_RootConstrainSelectedInstOperands,
     /* 243251 */     // GIR_Coverage, 7715,
     /* 243251 */     GIR_EraseRootFromParent_Done,
     /* 243252 */   // Label 4640: @243252
     /* 243252 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(243294), // Rule ID 7804 //
     /* 243257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 243265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 243268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 243271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243281 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1330:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 243281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 243284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 243288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 243290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 243292 */     GIR_RootConstrainSelectedInstOperands,
     /* 243293 */     // GIR_Coverage, 7804,
     /* 243293 */     GIR_EraseRootFromParent_Done,
     /* 243294 */   // Label 4641: @243294
     /* 243294 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(243336), // Rule ID 7805 //
     /* 243299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 243307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243323 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1330:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 243323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 243326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 243330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 243332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 243334 */     GIR_RootConstrainSelectedInstOperands,
     /* 243335 */     // GIR_Coverage, 7805,
     /* 243335 */     GIR_EraseRootFromParent_Done,
     /* 243336 */   // Label 4642: @243336
     /* 243336 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(243378), // Rule ID 7806 //
     /* 243341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 243349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243365 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1330:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 243365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 243368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 243372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 243374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 243376 */     GIR_RootConstrainSelectedInstOperands,
     /* 243377 */     // GIR_Coverage, 7806,
     /* 243377 */     GIR_EraseRootFromParent_Done,
     /* 243378 */   // Label 4643: @243378
     /* 243378 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(243420), // Rule ID 7807 //
     /* 243383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 243391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243407 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1330:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 243407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 243410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 243414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 243416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 243418 */     GIR_RootConstrainSelectedInstOperands,
     /* 243419 */     // GIR_Coverage, 7807,
     /* 243419 */     GIR_EraseRootFromParent_Done,
     /* 243420 */   // Label 4644: @243420
     /* 243420 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(243462), // Rule ID 7816 //
     /* 243425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 243433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 243436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 243439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243449 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 243449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 243452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 243456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 243458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 243460 */     GIR_RootConstrainSelectedInstOperands,
     /* 243461 */     // GIR_Coverage, 7816,
     /* 243461 */     GIR_EraseRootFromParent_Done,
     /* 243462 */   // Label 4645: @243462
     /* 243462 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(243504), // Rule ID 7817 //
     /* 243467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 243475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243491 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 243491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 243494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 243498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 243500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 243502 */     GIR_RootConstrainSelectedInstOperands,
     /* 243503 */     // GIR_Coverage, 7817,
     /* 243503 */     GIR_EraseRootFromParent_Done,
     /* 243504 */   // Label 4646: @243504
     /* 243504 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(243546), // Rule ID 7818 //
     /* 243509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 243517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243533 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 243533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 243536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 243540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 243542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 243544 */     GIR_RootConstrainSelectedInstOperands,
     /* 243545 */     // GIR_Coverage, 7818,
     /* 243545 */     GIR_EraseRootFromParent_Done,
     /* 243546 */   // Label 4647: @243546
     /* 243546 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(243588), // Rule ID 7819 //
     /* 243551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 243559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243575 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 243575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 243578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 243582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 243584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 243586 */     GIR_RootConstrainSelectedInstOperands,
     /* 243587 */     // GIR_Coverage, 7819,
     /* 243587 */     GIR_EraseRootFromParent_Done,
     /* 243588 */   // Label 4648: @243588
     /* 243588 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(243630), // Rule ID 7898 //
     /* 243593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 243601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 243604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243617 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1683:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 243617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 243620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243628 */     GIR_RootConstrainSelectedInstOperands,
     /* 243629 */     // GIR_Coverage, 7898,
     /* 243629 */     GIR_EraseRootFromParent_Done,
     /* 243630 */   // Label 4649: @243630
     /* 243630 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(243672), // Rule ID 7899 //
     /* 243635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 243643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243659 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1683:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 243659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 243662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243670 */     GIR_RootConstrainSelectedInstOperands,
     /* 243671 */     // GIR_Coverage, 7899,
     /* 243671 */     GIR_EraseRootFromParent_Done,
     /* 243672 */   // Label 4650: @243672
     /* 243672 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(243714), // Rule ID 7900 //
     /* 243677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 243685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243701 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1683:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 243701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 243704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243712 */     GIR_RootConstrainSelectedInstOperands,
     /* 243713 */     // GIR_Coverage, 7900,
     /* 243713 */     GIR_EraseRootFromParent_Done,
     /* 243714 */   // Label 4651: @243714
     /* 243714 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(243756), // Rule ID 7901 //
     /* 243719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 243727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243743 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1683:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 243746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243754 */     GIR_RootConstrainSelectedInstOperands,
     /* 243755 */     // GIR_Coverage, 7901,
     /* 243755 */     GIR_EraseRootFromParent_Done,
     /* 243756 */   // Label 4652: @243756
     /* 243756 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(243798), // Rule ID 7902 //
     /* 243761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 243769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 243772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 243778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 243781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243785 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1933:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 243785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 243788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243796 */     GIR_RootConstrainSelectedInstOperands,
     /* 243797 */     // GIR_Coverage, 7902,
     /* 243797 */     GIR_EraseRootFromParent_Done,
     /* 243798 */   // Label 4653: @243798
     /* 243798 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(243840), // Rule ID 7903 //
     /* 243803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 243811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243827 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1933:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 243827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 243830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243838 */     GIR_RootConstrainSelectedInstOperands,
     /* 243839 */     // GIR_Coverage, 7903,
     /* 243839 */     GIR_EraseRootFromParent_Done,
     /* 243840 */   // Label 4654: @243840
     /* 243840 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(243882), // Rule ID 7904 //
     /* 243845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 243853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243869 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1933:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 243869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 243872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243880 */     GIR_RootConstrainSelectedInstOperands,
     /* 243881 */     // GIR_Coverage, 7904,
     /* 243881 */     GIR_EraseRootFromParent_Done,
     /* 243882 */   // Label 4655: @243882
     /* 243882 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(243924), // Rule ID 7905 //
     /* 243887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 243895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243911 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1933:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 243911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 243914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243922 */     GIR_RootConstrainSelectedInstOperands,
     /* 243923 */     // GIR_Coverage, 7905,
     /* 243923 */     GIR_EraseRootFromParent_Done,
     /* 243924 */   // Label 4656: @243924
     /* 243924 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(243966), // Rule ID 8101 //
     /* 243929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 243937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243953 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1539:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 243953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 243956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 243958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243964 */     GIR_RootConstrainSelectedInstOperands,
     /* 243965 */     // GIR_Coverage, 8101,
     /* 243965 */     GIR_EraseRootFromParent_Done,
     /* 243966 */   // Label 4657: @243966
     /* 243966 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(244008), // Rule ID 8103 //
     /* 243971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 243979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243995 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1539:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 243995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 243998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244006 */     GIR_RootConstrainSelectedInstOperands,
     /* 244007 */     // GIR_Coverage, 8103,
     /* 244007 */     GIR_EraseRootFromParent_Done,
     /* 244008 */   // Label 4658: @244008
     /* 244008 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(244050), // Rule ID 8105 //
     /* 244013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 244021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244037 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1539:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 244040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244048 */     GIR_RootConstrainSelectedInstOperands,
     /* 244049 */     // GIR_Coverage, 8105,
     /* 244049 */     GIR_EraseRootFromParent_Done,
     /* 244050 */   // Label 4659: @244050
     /* 244050 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(244092), // Rule ID 8113 //
     /* 244055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 244063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244079 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1541:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 244082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244090 */     GIR_RootConstrainSelectedInstOperands,
     /* 244091 */     // GIR_Coverage, 8113,
     /* 244091 */     GIR_EraseRootFromParent_Done,
     /* 244092 */   // Label 4660: @244092
     /* 244092 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(244134), // Rule ID 8115 //
     /* 244097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 244105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244121 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1541:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 244124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244132 */     GIR_RootConstrainSelectedInstOperands,
     /* 244133 */     // GIR_Coverage, 8115,
     /* 244133 */     GIR_EraseRootFromParent_Done,
     /* 244134 */   // Label 4661: @244134
     /* 244134 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(244176), // Rule ID 8117 //
     /* 244139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 244147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244163 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1541:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 244166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244174 */     GIR_RootConstrainSelectedInstOperands,
     /* 244175 */     // GIR_Coverage, 8117,
     /* 244175 */     GIR_EraseRootFromParent_Done,
     /* 244176 */   // Label 4662: @244176
     /* 244176 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(244218), // Rule ID 8155 //
     /* 244181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 244189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244205 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1358:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 244208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244216 */     GIR_RootConstrainSelectedInstOperands,
     /* 244217 */     // GIR_Coverage, 8155,
     /* 244217 */     GIR_EraseRootFromParent_Done,
     /* 244218 */   // Label 4663: @244218
     /* 244218 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(244260), // Rule ID 8156 //
     /* 244223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 244231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244247 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1358:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 244250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244258 */     GIR_RootConstrainSelectedInstOperands,
     /* 244259 */     // GIR_Coverage, 8156,
     /* 244259 */     GIR_EraseRootFromParent_Done,
     /* 244260 */   // Label 4664: @244260
     /* 244260 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(244302), // Rule ID 8157 //
     /* 244265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 244273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244289 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1358:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 244292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244300 */     GIR_RootConstrainSelectedInstOperands,
     /* 244301 */     // GIR_Coverage, 8157,
     /* 244301 */     GIR_EraseRootFromParent_Done,
     /* 244302 */   // Label 4665: @244302
     /* 244302 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(244344), // Rule ID 8158 //
     /* 244307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 244315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244331 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1480:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 244334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244342 */     GIR_RootConstrainSelectedInstOperands,
     /* 244343 */     // GIR_Coverage, 8158,
     /* 244343 */     GIR_EraseRootFromParent_Done,
     /* 244344 */   // Label 4666: @244344
     /* 244344 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(244386), // Rule ID 8159 //
     /* 244349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 244357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244373 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1480:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 244376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244384 */     GIR_RootConstrainSelectedInstOperands,
     /* 244385 */     // GIR_Coverage, 8159,
     /* 244385 */     GIR_EraseRootFromParent_Done,
     /* 244386 */   // Label 4667: @244386
     /* 244386 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(244428), // Rule ID 8160 //
     /* 244391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 244399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244415 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1480:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 244418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244426 */     GIR_RootConstrainSelectedInstOperands,
     /* 244427 */     // GIR_Coverage, 8160,
     /* 244427 */     GIR_EraseRootFromParent_Done,
     /* 244428 */   // Label 4668: @244428
     /* 244428 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(244470), // Rule ID 8161 //
     /* 244433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 244441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244457 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1419:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 244460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244468 */     GIR_RootConstrainSelectedInstOperands,
     /* 244469 */     // GIR_Coverage, 8161,
     /* 244469 */     GIR_EraseRootFromParent_Done,
     /* 244470 */   // Label 4669: @244470
     /* 244470 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(244512), // Rule ID 8162 //
     /* 244475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 244483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244499 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1419:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 244502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244510 */     GIR_RootConstrainSelectedInstOperands,
     /* 244511 */     // GIR_Coverage, 8162,
     /* 244511 */     GIR_EraseRootFromParent_Done,
     /* 244512 */   // Label 4670: @244512
     /* 244512 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(244554), // Rule ID 8163 //
     /* 244517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 244525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244541 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1419:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 244544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244552 */     GIR_RootConstrainSelectedInstOperands,
     /* 244553 */     // GIR_Coverage, 8163,
     /* 244553 */     GIR_EraseRootFromParent_Done,
     /* 244554 */   // Label 4671: @244554
     /* 244554 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(244596), // Rule ID 8164 //
     /* 244559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 244567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244583 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1417:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 244586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244594 */     GIR_RootConstrainSelectedInstOperands,
     /* 244595 */     // GIR_Coverage, 8164,
     /* 244595 */     GIR_EraseRootFromParent_Done,
     /* 244596 */   // Label 4672: @244596
     /* 244596 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(244638), // Rule ID 8165 //
     /* 244601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 244609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244625 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 244628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244636 */     GIR_RootConstrainSelectedInstOperands,
     /* 244637 */     // GIR_Coverage, 8165,
     /* 244637 */     GIR_EraseRootFromParent_Done,
     /* 244638 */   // Label 4673: @244638
     /* 244638 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(244680), // Rule ID 8166 //
     /* 244643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 244651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244667 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1417:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 244670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244678 */     GIR_RootConstrainSelectedInstOperands,
     /* 244679 */     // GIR_Coverage, 8166,
     /* 244679 */     GIR_EraseRootFromParent_Done,
     /* 244680 */   // Label 4674: @244680
     /* 244680 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(244722), // Rule ID 8203 //
     /* 244685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 244693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244709 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1359:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 244712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244720 */     GIR_RootConstrainSelectedInstOperands,
     /* 244721 */     // GIR_Coverage, 8203,
     /* 244721 */     GIR_EraseRootFromParent_Done,
     /* 244722 */   // Label 4675: @244722
     /* 244722 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(244764), // Rule ID 8205 //
     /* 244727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 244735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 244738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 244744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 244747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244751 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1359:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 244751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 244754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244762 */     GIR_RootConstrainSelectedInstOperands,
     /* 244763 */     // GIR_Coverage, 8205,
     /* 244763 */     GIR_EraseRootFromParent_Done,
     /* 244764 */   // Label 4676: @244764
     /* 244764 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(244806), // Rule ID 8207 //
     /* 244769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 244777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 244780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 244786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 244789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244793 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 244793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 244796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244804 */     GIR_RootConstrainSelectedInstOperands,
     /* 244805 */     // GIR_Coverage, 8207,
     /* 244805 */     GIR_EraseRootFromParent_Done,
     /* 244806 */   // Label 4677: @244806
     /* 244806 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(244848), // Rule ID 8209 //
     /* 244811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 244819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244835 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1359:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 244838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244846 */     GIR_RootConstrainSelectedInstOperands,
     /* 244847 */     // GIR_Coverage, 8209,
     /* 244847 */     GIR_EraseRootFromParent_Done,
     /* 244848 */   // Label 4678: @244848
     /* 244848 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(244890), // Rule ID 8211 //
     /* 244853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 244861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 244864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 244870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 244873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244877 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 244877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 244880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244888 */     GIR_RootConstrainSelectedInstOperands,
     /* 244889 */     // GIR_Coverage, 8211,
     /* 244889 */     GIR_EraseRootFromParent_Done,
     /* 244890 */   // Label 4679: @244890
     /* 244890 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(244932), // Rule ID 8213 //
     /* 244895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 244903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244919 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1359:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 244922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244930 */     GIR_RootConstrainSelectedInstOperands,
     /* 244931 */     // GIR_Coverage, 8213,
     /* 244931 */     GIR_EraseRootFromParent_Done,
     /* 244932 */   // Label 4680: @244932
     /* 244932 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(244974), // Rule ID 8215 //
     /* 244937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 244945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244961 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1481:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 244964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 244966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244972 */     GIR_RootConstrainSelectedInstOperands,
     /* 244973 */     // GIR_Coverage, 8215,
     /* 244973 */     GIR_EraseRootFromParent_Done,
     /* 244974 */   // Label 4681: @244974
     /* 244974 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(245016), // Rule ID 8216 //
     /* 244979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 244987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 244990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 244996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 244999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245003 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1481:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 245003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 245006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245014 */     GIR_RootConstrainSelectedInstOperands,
     /* 245015 */     // GIR_Coverage, 8216,
     /* 245015 */     GIR_EraseRootFromParent_Done,
     /* 245016 */   // Label 4682: @245016
     /* 245016 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(245058), // Rule ID 8217 //
     /* 245021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 245029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 245032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 245038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 245041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245045 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 245045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 245048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245056 */     GIR_RootConstrainSelectedInstOperands,
     /* 245057 */     // GIR_Coverage, 8217,
     /* 245057 */     GIR_EraseRootFromParent_Done,
     /* 245058 */   // Label 4683: @245058
     /* 245058 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(245100), // Rule ID 8218 //
     /* 245063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 245071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245087 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1481:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 245087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 245090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245098 */     GIR_RootConstrainSelectedInstOperands,
     /* 245099 */     // GIR_Coverage, 8218,
     /* 245099 */     GIR_EraseRootFromParent_Done,
     /* 245100 */   // Label 4684: @245100
     /* 245100 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(245142), // Rule ID 8219 //
     /* 245105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 245113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 245116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 245122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 245125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245129 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 245129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 245132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245140 */     GIR_RootConstrainSelectedInstOperands,
     /* 245141 */     // GIR_Coverage, 8219,
     /* 245141 */     GIR_EraseRootFromParent_Done,
     /* 245142 */   // Label 4685: @245142
     /* 245142 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(245184), // Rule ID 8220 //
     /* 245147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 245155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245171 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1481:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 245171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 245174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 245176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245182 */     GIR_RootConstrainSelectedInstOperands,
     /* 245183 */     // GIR_Coverage, 8220,
     /* 245183 */     GIR_EraseRootFromParent_Done,
     /* 245184 */   // Label 4686: @245184
     /* 245184 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(245226), // Rule ID 8473 //
     /* 245189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 245197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 245206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 245209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245213 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1299:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 245213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 245216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245224 */     GIR_RootConstrainSelectedInstOperands,
     /* 245225 */     // GIR_Coverage, 8473,
     /* 245225 */     GIR_EraseRootFromParent_Done,
     /* 245226 */   // Label 4687: @245226
     /* 245226 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(245268), // Rule ID 8475 //
     /* 245231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 245239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 245248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 245251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245255 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1295:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 245255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 245258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245266 */     GIR_RootConstrainSelectedInstOperands,
     /* 245267 */     // GIR_Coverage, 8475,
     /* 245267 */     GIR_EraseRootFromParent_Done,
     /* 245268 */   // Label 4688: @245268
     /* 245268 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(245310), // Rule ID 8476 //
     /* 245273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 245281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 245290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 245293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245297 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1292:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 245297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 245300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245308 */     GIR_RootConstrainSelectedInstOperands,
     /* 245309 */     // GIR_Coverage, 8476,
     /* 245309 */     GIR_EraseRootFromParent_Done,
     /* 245310 */   // Label 4689: @245310
     /* 245310 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(245352), // Rule ID 8477 //
     /* 245315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 245323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 245332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 245335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245339 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1292:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 245339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 245342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245350 */     GIR_RootConstrainSelectedInstOperands,
     /* 245351 */     // GIR_Coverage, 8477,
     /* 245351 */     GIR_EraseRootFromParent_Done,
     /* 245352 */   // Label 4690: @245352
     /* 245352 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(245394), // Rule ID 8478 //
     /* 245357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 245365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 245374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 245377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245381 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1292:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 245381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 245384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245392 */     GIR_RootConstrainSelectedInstOperands,
     /* 245393 */     // GIR_Coverage, 8478,
     /* 245393 */     GIR_EraseRootFromParent_Done,
     /* 245394 */   // Label 4691: @245394
     /* 245394 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(245436), // Rule ID 8479 //
     /* 245399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 245407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 245410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 245419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245423 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1292:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 245423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 245426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245432 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245434 */     GIR_RootConstrainSelectedInstOperands,
     /* 245435 */     // GIR_Coverage, 8479,
     /* 245435 */     GIR_EraseRootFromParent_Done,
     /* 245436 */   // Label 4692: @245436
     /* 245436 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(245478), // Rule ID 8480 //
     /* 245441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 245449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 245452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 245455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 245458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 245461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245465 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1292:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 245465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 245468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245474 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245476 */     GIR_RootConstrainSelectedInstOperands,
     /* 245477 */     // GIR_Coverage, 8480,
     /* 245477 */     GIR_EraseRootFromParent_Done,
     /* 245478 */   // Label 4693: @245478
     /* 245478 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(245520), // Rule ID 8501 //
     /* 245483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 245491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 245500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 245503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245507 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1350:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 245507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 245510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245518 */     GIR_RootConstrainSelectedInstOperands,
     /* 245519 */     // GIR_Coverage, 8501,
     /* 245519 */     GIR_EraseRootFromParent_Done,
     /* 245520 */   // Label 4694: @245520
     /* 245520 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(245562), // Rule ID 8502 //
     /* 245525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 245533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 245542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 245545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245549 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1350:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 245549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 245552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245560 */     GIR_RootConstrainSelectedInstOperands,
     /* 245561 */     // GIR_Coverage, 8502,
     /* 245561 */     GIR_EraseRootFromParent_Done,
     /* 245562 */   // Label 4695: @245562
     /* 245562 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(245604), // Rule ID 8503 //
     /* 245567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 245575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 245584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 245587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245591 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1350:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 245591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 245594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245600 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245602 */     GIR_RootConstrainSelectedInstOperands,
     /* 245603 */     // GIR_Coverage, 8503,
     /* 245603 */     GIR_EraseRootFromParent_Done,
     /* 245604 */   // Label 4696: @245604
     /* 245604 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(245646), // Rule ID 8504 //
     /* 245609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 245617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 245620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 245629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245633 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1350:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 245633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 245636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245644 */     GIR_RootConstrainSelectedInstOperands,
     /* 245645 */     // GIR_Coverage, 8504,
     /* 245645 */     GIR_EraseRootFromParent_Done,
     /* 245646 */   // Label 4697: @245646
     /* 245646 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(245688), // Rule ID 8505 //
     /* 245651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 245659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 245662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 245665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 245668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 245671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245675 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1350:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 245675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 245678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245684 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245686 */     GIR_RootConstrainSelectedInstOperands,
     /* 245687 */     // GIR_Coverage, 8505,
     /* 245687 */     GIR_EraseRootFromParent_Done,
     /* 245688 */   // Label 4698: @245688
     /* 245688 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(245730), // Rule ID 8521 //
     /* 245693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 245701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 245710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 245713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245717 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1621:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 245717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 245720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245728 */     GIR_RootConstrainSelectedInstOperands,
     /* 245729 */     // GIR_Coverage, 8521,
     /* 245729 */     GIR_EraseRootFromParent_Done,
     /* 245730 */   // Label 4699: @245730
     /* 245730 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(245772), // Rule ID 8522 //
     /* 245735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 245743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 245752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 245755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245759 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1621:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 245759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 245762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245770 */     GIR_RootConstrainSelectedInstOperands,
     /* 245771 */     // GIR_Coverage, 8522,
     /* 245771 */     GIR_EraseRootFromParent_Done,
     /* 245772 */   // Label 4700: @245772
     /* 245772 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(245814), // Rule ID 8523 //
     /* 245777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 245785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 245794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 245797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245801 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1621:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 245801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 245804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245812 */     GIR_RootConstrainSelectedInstOperands,
     /* 245813 */     // GIR_Coverage, 8523,
     /* 245813 */     GIR_EraseRootFromParent_Done,
     /* 245814 */   // Label 4701: @245814
     /* 245814 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(245856), // Rule ID 8524 //
     /* 245819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 245827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 245830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 245836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 245839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245843 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1621:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 245843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 245846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245854 */     GIR_RootConstrainSelectedInstOperands,
     /* 245855 */     // GIR_Coverage, 8524,
     /* 245855 */     GIR_EraseRootFromParent_Done,
     /* 245856 */   // Label 4702: @245856
     /* 245856 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(245898), // Rule ID 8525 //
     /* 245861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 245869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 245872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 245875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 245878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 245881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245885 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1621:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 245885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 245888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245896 */     GIR_RootConstrainSelectedInstOperands,
     /* 245897 */     // GIR_Coverage, 8525,
     /* 245897 */     GIR_EraseRootFromParent_Done,
     /* 245898 */   // Label 4703: @245898
     /* 245898 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(245940), // Rule ID 8526 //
     /* 245903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 245911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 245920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 245923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245927 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1617:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 245927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 245930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245938 */     GIR_RootConstrainSelectedInstOperands,
     /* 245939 */     // GIR_Coverage, 8526,
     /* 245939 */     GIR_EraseRootFromParent_Done,
     /* 245940 */   // Label 4704: @245940
     /* 245940 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(245982), // Rule ID 8527 //
     /* 245945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 245953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 245962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 245965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 245969 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1617:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 245969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 245972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245978 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245980 */     GIR_RootConstrainSelectedInstOperands,
     /* 245981 */     // GIR_Coverage, 8527,
     /* 245981 */     GIR_EraseRootFromParent_Done,
     /* 245982 */   // Label 4705: @245982
     /* 245982 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(246024), // Rule ID 8528 //
     /* 245987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 245995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 246004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 246007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246011 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1617:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 246011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 246014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246022 */     GIR_RootConstrainSelectedInstOperands,
     /* 246023 */     // GIR_Coverage, 8528,
     /* 246023 */     GIR_EraseRootFromParent_Done,
     /* 246024 */   // Label 4706: @246024
     /* 246024 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(246066), // Rule ID 8529 //
     /* 246029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 246037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 246040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 246049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246053 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1617:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 246053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 246056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246062 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246064 */     GIR_RootConstrainSelectedInstOperands,
     /* 246065 */     // GIR_Coverage, 8529,
     /* 246065 */     GIR_EraseRootFromParent_Done,
     /* 246066 */   // Label 4707: @246066
     /* 246066 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(246108), // Rule ID 8530 //
     /* 246071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 246079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 246082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 246085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 246088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 246091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246095 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1617:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 246095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 246098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246106 */     GIR_RootConstrainSelectedInstOperands,
     /* 246107 */     // GIR_Coverage, 8530,
     /* 246107 */     GIR_EraseRootFromParent_Done,
     /* 246108 */   // Label 4708: @246108
     /* 246108 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(246150), // Rule ID 8531 //
     /* 246113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 246121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 246124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 246130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 246133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246137 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1615:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 246137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 246140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246146 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246148 */     GIR_RootConstrainSelectedInstOperands,
     /* 246149 */     // GIR_Coverage, 8531,
     /* 246149 */     GIR_EraseRootFromParent_Done,
     /* 246150 */   // Label 4709: @246150
     /* 246150 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(246192), // Rule ID 8532 //
     /* 246155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 246163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 246166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 246172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 246175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246179 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1615:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 246179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 246182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246188 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246190 */     GIR_RootConstrainSelectedInstOperands,
     /* 246191 */     // GIR_Coverage, 8532,
     /* 246191 */     GIR_EraseRootFromParent_Done,
     /* 246192 */   // Label 4710: @246192
     /* 246192 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(246234), // Rule ID 8533 //
     /* 246197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 246205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 246208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 246214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 246217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246221 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1615:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 246221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 246224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246230 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246232 */     GIR_RootConstrainSelectedInstOperands,
     /* 246233 */     // GIR_Coverage, 8533,
     /* 246233 */     GIR_EraseRootFromParent_Done,
     /* 246234 */   // Label 4711: @246234
     /* 246234 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(246276), // Rule ID 8534 //
     /* 246239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 246247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 246250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 246259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246263 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1615:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 246263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 246266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246274 */     GIR_RootConstrainSelectedInstOperands,
     /* 246275 */     // GIR_Coverage, 8534,
     /* 246275 */     GIR_EraseRootFromParent_Done,
     /* 246276 */   // Label 4712: @246276
     /* 246276 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(246318), // Rule ID 8535 //
     /* 246281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 246289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 246292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 246295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 246298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 246301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246305 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1615:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 246305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 246308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246316 */     GIR_RootConstrainSelectedInstOperands,
     /* 246317 */     // GIR_Coverage, 8535,
     /* 246317 */     GIR_EraseRootFromParent_Done,
     /* 246318 */   // Label 4713: @246318
     /* 246318 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(246360), // Rule ID 8536 //
     /* 246323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 246331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 246334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 246340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 246343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246347 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1611:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 246347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 246350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246358 */     GIR_RootConstrainSelectedInstOperands,
     /* 246359 */     // GIR_Coverage, 8536,
     /* 246359 */     GIR_EraseRootFromParent_Done,
     /* 246360 */   // Label 4714: @246360
     /* 246360 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(246402), // Rule ID 8537 //
     /* 246365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 246373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 246376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 246382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 246385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246389 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1611:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 246389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 246392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246398 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246400 */     GIR_RootConstrainSelectedInstOperands,
     /* 246401 */     // GIR_Coverage, 8537,
     /* 246401 */     GIR_EraseRootFromParent_Done,
     /* 246402 */   // Label 4715: @246402
     /* 246402 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(246444), // Rule ID 8538 //
     /* 246407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 246415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 246418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 246424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 246427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246431 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1611:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 246431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 246434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246442 */     GIR_RootConstrainSelectedInstOperands,
     /* 246443 */     // GIR_Coverage, 8538,
     /* 246443 */     GIR_EraseRootFromParent_Done,
     /* 246444 */   // Label 4716: @246444
     /* 246444 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(246486), // Rule ID 8539 //
     /* 246449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 246457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 246460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 246469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246473 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1611:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 246473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 246476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246484 */     GIR_RootConstrainSelectedInstOperands,
     /* 246485 */     // GIR_Coverage, 8539,
     /* 246485 */     GIR_EraseRootFromParent_Done,
     /* 246486 */   // Label 4717: @246486
     /* 246486 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(246528), // Rule ID 8540 //
     /* 246491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 246499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 246502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 246505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 246508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 246511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 246515 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1611:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 246515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 246518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246526 */     GIR_RootConstrainSelectedInstOperands,
     /* 246527 */     // GIR_Coverage, 8540,
     /* 246527 */     GIR_EraseRootFromParent_Done,
     /* 246528 */   // Label 4718: @246528
     /* 246528 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(246570), // Rule ID 8548 //
     /* 246533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 246541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246557 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1308:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 246557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 246560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246566 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246568 */     GIR_RootConstrainSelectedInstOperands,
     /* 246569 */     // GIR_Coverage, 8548,
     /* 246569 */     GIR_EraseRootFromParent_Done,
     /* 246570 */   // Label 4719: @246570
     /* 246570 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(246612), // Rule ID 8549 //
     /* 246575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 246583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246599 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1308:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 246599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 246602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246610 */     GIR_RootConstrainSelectedInstOperands,
     /* 246611 */     // GIR_Coverage, 8549,
     /* 246611 */     GIR_EraseRootFromParent_Done,
     /* 246612 */   // Label 4720: @246612
     /* 246612 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(246654), // Rule ID 8550 //
     /* 246617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 246625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246641 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1308:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 246644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246652 */     GIR_RootConstrainSelectedInstOperands,
     /* 246653 */     // GIR_Coverage, 8550,
     /* 246653 */     GIR_EraseRootFromParent_Done,
     /* 246654 */   // Label 4721: @246654
     /* 246654 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(246696), // Rule ID 8551 //
     /* 246659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 246667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246683 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1308:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 246686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246692 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246694 */     GIR_RootConstrainSelectedInstOperands,
     /* 246695 */     // GIR_Coverage, 8551,
     /* 246695 */     GIR_EraseRootFromParent_Done,
     /* 246696 */   // Label 4722: @246696
     /* 246696 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(246738), // Rule ID 8552 //
     /* 246701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 246709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246725 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1308:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 246725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 246728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246736 */     GIR_RootConstrainSelectedInstOperands,
     /* 246737 */     // GIR_Coverage, 8552,
     /* 246737 */     GIR_EraseRootFromParent_Done,
     /* 246738 */   // Label 4723: @246738
     /* 246738 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(246780), // Rule ID 8553 //
     /* 246743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 246751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246767 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1308:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 246767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 246770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246776 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246778 */     GIR_RootConstrainSelectedInstOperands,
     /* 246779 */     // GIR_Coverage, 8553,
     /* 246779 */     GIR_EraseRootFromParent_Done,
     /* 246780 */   // Label 4724: @246780
     /* 246780 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(246822), // Rule ID 8554 //
     /* 246785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 246793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246809 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1308:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 246812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246820 */     GIR_RootConstrainSelectedInstOperands,
     /* 246821 */     // GIR_Coverage, 8554,
     /* 246821 */     GIR_EraseRootFromParent_Done,
     /* 246822 */   // Label 4725: @246822
     /* 246822 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(246867), // Rule ID 9250 //
     /* 246827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 246835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 246838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246851 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1329:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 246854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246860 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 246865 */     GIR_RootConstrainSelectedInstOperands,
     /* 246866 */     // GIR_Coverage, 9250,
     /* 246866 */     GIR_EraseRootFromParent_Done,
     /* 246867 */   // Label 4726: @246867
     /* 246867 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(246912), // Rule ID 9251 //
     /* 246872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 246880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 246883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246896 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1329:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 246899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246905 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 246910 */     GIR_RootConstrainSelectedInstOperands,
     /* 246911 */     // GIR_Coverage, 9251,
     /* 246911 */     GIR_EraseRootFromParent_Done,
     /* 246912 */   // Label 4727: @246912
     /* 246912 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(246957), // Rule ID 9252 //
     /* 246917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 246925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 246928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246941 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1329:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 246944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 246955 */     GIR_RootConstrainSelectedInstOperands,
     /* 246956 */     // GIR_Coverage, 9252,
     /* 246956 */     GIR_EraseRootFromParent_Done,
     /* 246957 */   // Label 4728: @246957
     /* 246957 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(247002), // Rule ID 9253 //
     /* 246962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 246970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 246973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 246986 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1319:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 246989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 246991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246995 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247000 */     GIR_RootConstrainSelectedInstOperands,
     /* 247001 */     // GIR_Coverage, 9253,
     /* 247001 */     GIR_EraseRootFromParent_Done,
     /* 247002 */   // Label 4729: @247002
     /* 247002 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(247047), // Rule ID 9254 //
     /* 247007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 247015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 247018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247031 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1319:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 247034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247045 */     GIR_RootConstrainSelectedInstOperands,
     /* 247046 */     // GIR_Coverage, 9254,
     /* 247046 */     GIR_EraseRootFromParent_Done,
     /* 247047 */   // Label 4730: @247047
     /* 247047 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(247092), // Rule ID 9255 //
     /* 247052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 247060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 247063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247076 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1319:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 247079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247090 */     GIR_RootConstrainSelectedInstOperands,
     /* 247091 */     // GIR_Coverage, 9255,
     /* 247091 */     GIR_EraseRootFromParent_Done,
     /* 247092 */   // Label 4731: @247092
     /* 247092 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(247137), // Rule ID 9256 //
     /* 247097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 247105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 247108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247121 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1327:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 247124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247132 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247135 */     GIR_RootConstrainSelectedInstOperands,
     /* 247136 */     // GIR_Coverage, 9256,
     /* 247136 */     GIR_EraseRootFromParent_Done,
     /* 247137 */   // Label 4732: @247137
     /* 247137 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(247182), // Rule ID 9257 //
     /* 247142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 247150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 247153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247166 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1327:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 247169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247180 */     GIR_RootConstrainSelectedInstOperands,
     /* 247181 */     // GIR_Coverage, 9257,
     /* 247181 */     GIR_EraseRootFromParent_Done,
     /* 247182 */   // Label 4733: @247182
     /* 247182 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(247227), // Rule ID 9258 //
     /* 247187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 247195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 247198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247211 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 247214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247225 */     GIR_RootConstrainSelectedInstOperands,
     /* 247226 */     // GIR_Coverage, 9258,
     /* 247226 */     GIR_EraseRootFromParent_Done,
     /* 247227 */   // Label 4734: @247227
     /* 247227 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(247272), // Rule ID 9259 //
     /* 247232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 247240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 247243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247256 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1324:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 247259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247270 */     GIR_RootConstrainSelectedInstOperands,
     /* 247271 */     // GIR_Coverage, 9259,
     /* 247271 */     GIR_EraseRootFromParent_Done,
     /* 247272 */   // Label 4735: @247272
     /* 247272 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(247317), // Rule ID 9260 //
     /* 247277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 247285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 247288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247301 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1324:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 247304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247310 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247315 */     GIR_RootConstrainSelectedInstOperands,
     /* 247316 */     // GIR_Coverage, 9260,
     /* 247316 */     GIR_EraseRootFromParent_Done,
     /* 247317 */   // Label 4736: @247317
     /* 247317 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(247362), // Rule ID 9261 //
     /* 247322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 247330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 247333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247346 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1324:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 247349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247355 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247357 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247360 */     GIR_RootConstrainSelectedInstOperands,
     /* 247361 */     // GIR_Coverage, 9261,
     /* 247361 */     GIR_EraseRootFromParent_Done,
     /* 247362 */   // Label 4737: @247362
     /* 247362 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(247407), // Rule ID 9262 //
     /* 247367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 247375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 247378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247391 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1323:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 247394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247405 */     GIR_RootConstrainSelectedInstOperands,
     /* 247406 */     // GIR_Coverage, 9262,
     /* 247406 */     GIR_EraseRootFromParent_Done,
     /* 247407 */   // Label 4738: @247407
     /* 247407 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(247452), // Rule ID 9263 //
     /* 247412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 247420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 247423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247436 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1323:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 247439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247445 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247450 */     GIR_RootConstrainSelectedInstOperands,
     /* 247451 */     // GIR_Coverage, 9263,
     /* 247451 */     GIR_EraseRootFromParent_Done,
     /* 247452 */   // Label 4739: @247452
     /* 247452 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(247497), // Rule ID 9264 //
     /* 247457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 247465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 247468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247481 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1323:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 247484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247495 */     GIR_RootConstrainSelectedInstOperands,
     /* 247496 */     // GIR_Coverage, 9264,
     /* 247496 */     GIR_EraseRootFromParent_Done,
     /* 247497 */   // Label 4740: @247497
     /* 247497 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(247542), // Rule ID 9265 //
     /* 247502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 247510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 247513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247526 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1321:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 247529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247535 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247540 */     GIR_RootConstrainSelectedInstOperands,
     /* 247541 */     // GIR_Coverage, 9265,
     /* 247541 */     GIR_EraseRootFromParent_Done,
     /* 247542 */   // Label 4741: @247542
     /* 247542 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(247587), // Rule ID 9266 //
     /* 247547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 247555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 247558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247571 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1321:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 247574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247585 */     GIR_RootConstrainSelectedInstOperands,
     /* 247586 */     // GIR_Coverage, 9266,
     /* 247586 */     GIR_EraseRootFromParent_Done,
     /* 247587 */   // Label 4742: @247587
     /* 247587 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(247632), // Rule ID 9267 //
     /* 247592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 247600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 247603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247616 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1321:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 247619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247630 */     GIR_RootConstrainSelectedInstOperands,
     /* 247631 */     // GIR_Coverage, 9267,
     /* 247631 */     GIR_EraseRootFromParent_Done,
     /* 247632 */   // Label 4743: @247632
     /* 247632 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(247677), // Rule ID 9268 //
     /* 247637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 247645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 247648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247661 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1325:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 247664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247675 */     GIR_RootConstrainSelectedInstOperands,
     /* 247676 */     // GIR_Coverage, 9268,
     /* 247676 */     GIR_EraseRootFromParent_Done,
     /* 247677 */   // Label 4744: @247677
     /* 247677 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(247722), // Rule ID 9269 //
     /* 247682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 247690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 247693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247706 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1325:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 247709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247715 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247720 */     GIR_RootConstrainSelectedInstOperands,
     /* 247721 */     // GIR_Coverage, 9269,
     /* 247721 */     GIR_EraseRootFromParent_Done,
     /* 247722 */   // Label 4745: @247722
     /* 247722 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(247767), // Rule ID 9270 //
     /* 247727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 247735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 247738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247751 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1325:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 247754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247765 */     GIR_RootConstrainSelectedInstOperands,
     /* 247766 */     // GIR_Coverage, 9270,
     /* 247766 */     GIR_EraseRootFromParent_Done,
     /* 247767 */   // Label 4746: @247767
     /* 247767 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(247812), // Rule ID 9271 //
     /* 247772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 247780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 247783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247796 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1326:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 247799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247810 */     GIR_RootConstrainSelectedInstOperands,
     /* 247811 */     // GIR_Coverage, 9271,
     /* 247811 */     GIR_EraseRootFromParent_Done,
     /* 247812 */   // Label 4747: @247812
     /* 247812 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(247857), // Rule ID 9272 //
     /* 247817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 247825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 247828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247841 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1326:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 247844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247850 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247855 */     GIR_RootConstrainSelectedInstOperands,
     /* 247856 */     // GIR_Coverage, 9272,
     /* 247856 */     GIR_EraseRootFromParent_Done,
     /* 247857 */   // Label 4748: @247857
     /* 247857 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(247902), // Rule ID 9273 //
     /* 247862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 247870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 247873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247886 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1326:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 247889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 247900 */     GIR_RootConstrainSelectedInstOperands,
     /* 247901 */     // GIR_Coverage, 9273,
     /* 247901 */     GIR_EraseRootFromParent_Done,
     /* 247902 */   // Label 4749: @247902
     /* 247902 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(247944), // Rule ID 9670 //
     /* 247907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 247915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 247918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247931 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1362:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 247931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 247934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247940 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247942 */     GIR_RootConstrainSelectedInstOperands,
     /* 247943 */     // GIR_Coverage, 9670,
     /* 247943 */     GIR_EraseRootFromParent_Done,
     /* 247944 */   // Label 4750: @247944
     /* 247944 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(247986), // Rule ID 9671 //
     /* 247949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 247957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 247960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 247973 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1362:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 247973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 247976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 247978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247984 */     GIR_RootConstrainSelectedInstOperands,
     /* 247985 */     // GIR_Coverage, 9671,
     /* 247985 */     GIR_EraseRootFromParent_Done,
     /* 247986 */   // Label 4751: @247986
     /* 247986 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(248028), // Rule ID 9672 //
     /* 247991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 247999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 248002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 248015 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1362:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 248015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 248018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 248020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248024 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248026 */     GIR_RootConstrainSelectedInstOperands,
     /* 248027 */     // GIR_Coverage, 9672,
     /* 248027 */     GIR_EraseRootFromParent_Done,
     /* 248028 */   // Label 4752: @248028
     /* 248028 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(248070), // Rule ID 10210 //
     /* 248033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 248041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248057 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1593:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 248060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248066 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248068 */     GIR_RootConstrainSelectedInstOperands,
     /* 248069 */     // GIR_Coverage, 10210,
     /* 248069 */     GIR_EraseRootFromParent_Done,
     /* 248070 */   // Label 4753: @248070
     /* 248070 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(248112), // Rule ID 10211 //
     /* 248075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 248083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248099 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1593:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 248102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248108 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248110 */     GIR_RootConstrainSelectedInstOperands,
     /* 248111 */     // GIR_Coverage, 10211,
     /* 248111 */     GIR_EraseRootFromParent_Done,
     /* 248112 */   // Label 4754: @248112
     /* 248112 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(248154), // Rule ID 10212 //
     /* 248117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 248125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248141 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1593:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 248144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248150 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248152 */     GIR_RootConstrainSelectedInstOperands,
     /* 248153 */     // GIR_Coverage, 10212,
     /* 248153 */     GIR_EraseRootFromParent_Done,
     /* 248154 */   // Label 4755: @248154
     /* 248154 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(248196), // Rule ID 10213 //
     /* 248159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 248167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248183 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1593:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 248186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248192 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248194 */     GIR_RootConstrainSelectedInstOperands,
     /* 248195 */     // GIR_Coverage, 10213,
     /* 248195 */     GIR_EraseRootFromParent_Done,
     /* 248196 */   // Label 4756: @248196
     /* 248196 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(248238), // Rule ID 10214 //
     /* 248201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 248209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248225 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1590:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 248228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248234 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248236 */     GIR_RootConstrainSelectedInstOperands,
     /* 248237 */     // GIR_Coverage, 10214,
     /* 248237 */     GIR_EraseRootFromParent_Done,
     /* 248238 */   // Label 4757: @248238
     /* 248238 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(248280), // Rule ID 10215 //
     /* 248243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 248251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248267 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1590:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 248270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248276 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248278 */     GIR_RootConstrainSelectedInstOperands,
     /* 248279 */     // GIR_Coverage, 10215,
     /* 248279 */     GIR_EraseRootFromParent_Done,
     /* 248280 */   // Label 4758: @248280
     /* 248280 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(248322), // Rule ID 10216 //
     /* 248285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 248293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248309 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1590:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 248312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248320 */     GIR_RootConstrainSelectedInstOperands,
     /* 248321 */     // GIR_Coverage, 10216,
     /* 248321 */     GIR_EraseRootFromParent_Done,
     /* 248322 */   // Label 4759: @248322
     /* 248322 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(248364), // Rule ID 10217 //
     /* 248327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 248335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248351 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1590:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 248354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248360 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248362 */     GIR_RootConstrainSelectedInstOperands,
     /* 248363 */     // GIR_Coverage, 10217,
     /* 248363 */     GIR_EraseRootFromParent_Done,
     /* 248364 */   // Label 4760: @248364
     /* 248364 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(248406), // Rule ID 10230 //
     /* 248369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 248377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248393 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1595:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 248396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248402 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248404 */     GIR_RootConstrainSelectedInstOperands,
     /* 248405 */     // GIR_Coverage, 10230,
     /* 248405 */     GIR_EraseRootFromParent_Done,
     /* 248406 */   // Label 4761: @248406
     /* 248406 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(248448), // Rule ID 10231 //
     /* 248411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 248419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248435 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1595:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 248438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248444 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248446 */     GIR_RootConstrainSelectedInstOperands,
     /* 248447 */     // GIR_Coverage, 10231,
     /* 248447 */     GIR_EraseRootFromParent_Done,
     /* 248448 */   // Label 4762: @248448
     /* 248448 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(248490), // Rule ID 10232 //
     /* 248453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 248461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248477 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1595:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 248480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248486 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248488 */     GIR_RootConstrainSelectedInstOperands,
     /* 248489 */     // GIR_Coverage, 10232,
     /* 248489 */     GIR_EraseRootFromParent_Done,
     /* 248490 */   // Label 4763: @248490
     /* 248490 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(248532), // Rule ID 10233 //
     /* 248495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 248503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 248506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 248509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248519 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1592:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 248522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248530 */     GIR_RootConstrainSelectedInstOperands,
     /* 248531 */     // GIR_Coverage, 10233,
     /* 248531 */     GIR_EraseRootFromParent_Done,
     /* 248532 */   // Label 4764: @248532
     /* 248532 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(248574), // Rule ID 10234 //
     /* 248537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 248545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248561 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1592:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 248564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248572 */     GIR_RootConstrainSelectedInstOperands,
     /* 248573 */     // GIR_Coverage, 10234,
     /* 248573 */     GIR_EraseRootFromParent_Done,
     /* 248574 */   // Label 4765: @248574
     /* 248574 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(248616), // Rule ID 10235 //
     /* 248579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 248587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248603 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1592:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 248606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248612 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248614 */     GIR_RootConstrainSelectedInstOperands,
     /* 248615 */     // GIR_Coverage, 10235,
     /* 248615 */     GIR_EraseRootFromParent_Done,
     /* 248616 */   // Label 4766: @248616
     /* 248616 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(248658), // Rule ID 10262 //
     /* 248621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 248629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248645 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1387:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 248645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 248648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248654 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248656 */     GIR_RootConstrainSelectedInstOperands,
     /* 248657 */     // GIR_Coverage, 10262,
     /* 248657 */     GIR_EraseRootFromParent_Done,
     /* 248658 */   // Label 4767: @248658
     /* 248658 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(248700), // Rule ID 10266 //
     /* 248663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 248671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248687 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1390:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 248687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 248690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248696 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248698 */     GIR_RootConstrainSelectedInstOperands,
     /* 248699 */     // GIR_Coverage, 10266,
     /* 248699 */     GIR_EraseRootFromParent_Done,
     /* 248700 */   // Label 4768: @248700
     /* 248700 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(248742), // Rule ID 10270 //
     /* 248705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 248713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248729 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1389:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 248729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 248732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248740 */     GIR_RootConstrainSelectedInstOperands,
     /* 248741 */     // GIR_Coverage, 10270,
     /* 248741 */     GIR_EraseRootFromParent_Done,
     /* 248742 */   // Label 4769: @248742
     /* 248742 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(248784), // Rule ID 10274 //
     /* 248747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 248755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248771 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1391:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 248771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 248774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248782 */     GIR_RootConstrainSelectedInstOperands,
     /* 248783 */     // GIR_Coverage, 10274,
     /* 248783 */     GIR_EraseRootFromParent_Done,
     /* 248784 */   // Label 4770: @248784
     /* 248784 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(248826), // Rule ID 10278 //
     /* 248789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 248797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248813 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1703:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 248816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248822 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248824 */     GIR_RootConstrainSelectedInstOperands,
     /* 248825 */     // GIR_Coverage, 10278,
     /* 248825 */     GIR_EraseRootFromParent_Done,
     /* 248826 */   // Label 4771: @248826
     /* 248826 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(248868), // Rule ID 10279 //
     /* 248831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 248839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248855 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1950:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 248858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248864 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248866 */     GIR_RootConstrainSelectedInstOperands,
     /* 248867 */     // GIR_Coverage, 10279,
     /* 248867 */     GIR_EraseRootFromParent_Done,
     /* 248868 */   // Label 4772: @248868
     /* 248868 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(248910), // Rule ID 10280 //
     /* 248873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 248881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 248890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248897 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1947:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 248900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248906 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248908 */     GIR_RootConstrainSelectedInstOperands,
     /* 248909 */     // GIR_Coverage, 10280,
     /* 248909 */     GIR_EraseRootFromParent_Done,
     /* 248910 */   // Label 4773: @248910
     /* 248910 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(248952), // Rule ID 10284 //
     /* 248915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 248923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 248932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248939 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1702:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 248939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 248942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248948 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248950 */     GIR_RootConstrainSelectedInstOperands,
     /* 248951 */     // GIR_Coverage, 10284,
     /* 248951 */     GIR_EraseRootFromParent_Done,
     /* 248952 */   // Label 4774: @248952
     /* 248952 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(248994), // Rule ID 10288 //
     /* 248957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 248965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 248974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248981 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1700:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 248984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248992 */     GIR_RootConstrainSelectedInstOperands,
     /* 248993 */     // GIR_Coverage, 10288,
     /* 248993 */     GIR_EraseRootFromParent_Done,
     /* 248994 */   // Label 4775: @248994
     /* 248994 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(249036), // Rule ID 10292 //
     /* 248999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 249007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 249016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249023 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1701:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 249026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249032 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249034 */     GIR_RootConstrainSelectedInstOperands,
     /* 249035 */     // GIR_Coverage, 10292,
     /* 249035 */     GIR_EraseRootFromParent_Done,
     /* 249036 */   // Label 4776: @249036
     /* 249036 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(249078), // Rule ID 10296 //
     /* 249041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 249049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 249058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249065 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1949:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 249068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249074 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249076 */     GIR_RootConstrainSelectedInstOperands,
     /* 249077 */     // GIR_Coverage, 10296,
     /* 249077 */     GIR_EraseRootFromParent_Done,
     /* 249078 */   // Label 4777: @249078
     /* 249078 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(249120), // Rule ID 10300 //
     /* 249083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 249091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 249100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249107 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1948:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 249110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249118 */     GIR_RootConstrainSelectedInstOperands,
     /* 249119 */     // GIR_Coverage, 10300,
     /* 249119 */     GIR_EraseRootFromParent_Done,
     /* 249120 */   // Label 4778: @249120
     /* 249120 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(249162), // Rule ID 10310 //
     /* 249125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 249133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 249142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249149 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1405:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 249149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 249152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249158 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249160 */     GIR_RootConstrainSelectedInstOperands,
     /* 249161 */     // GIR_Coverage, 10310,
     /* 249161 */     GIR_EraseRootFromParent_Done,
     /* 249162 */   // Label 4779: @249162
     /* 249162 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(249204), // Rule ID 10311 //
     /* 249167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 249175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 249184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249191 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1412:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 249191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 249194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249202 */     GIR_RootConstrainSelectedInstOperands,
     /* 249203 */     // GIR_Coverage, 10311,
     /* 249203 */     GIR_EraseRootFromParent_Done,
     /* 249204 */   // Label 4780: @249204
     /* 249204 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(249246), // Rule ID 10312 //
     /* 249209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 249217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 249226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249233 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1407:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 249233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 249236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249242 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249244 */     GIR_RootConstrainSelectedInstOperands,
     /* 249245 */     // GIR_Coverage, 10312,
     /* 249245 */     GIR_EraseRootFromParent_Done,
     /* 249246 */   // Label 4781: @249246
     /* 249246 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(249288), // Rule ID 10316 //
     /* 249251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 249259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 249268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249275 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1404:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 249275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 249278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249286 */     GIR_RootConstrainSelectedInstOperands,
     /* 249287 */     // GIR_Coverage, 10316,
     /* 249287 */     GIR_EraseRootFromParent_Done,
     /* 249288 */   // Label 4782: @249288
     /* 249288 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(249330), // Rule ID 10320 //
     /* 249293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 249301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 249310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249317 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1406:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 249317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 249320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249326 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249328 */     GIR_RootConstrainSelectedInstOperands,
     /* 249329 */     // GIR_Coverage, 10320,
     /* 249329 */     GIR_EraseRootFromParent_Done,
     /* 249330 */   // Label 4783: @249330
     /* 249330 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(249372), // Rule ID 10324 //
     /* 249335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 249343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 249352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249359 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1411:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 249359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 249362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249368 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249370 */     GIR_RootConstrainSelectedInstOperands,
     /* 249371 */     // GIR_Coverage, 10324,
     /* 249371 */     GIR_EraseRootFromParent_Done,
     /* 249372 */   // Label 4784: @249372
     /* 249372 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(249414), // Rule ID 10328 //
     /* 249377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 249385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 249394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249401 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1413:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 249401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 249404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249412 */     GIR_RootConstrainSelectedInstOperands,
     /* 249413 */     // GIR_Coverage, 10328,
     /* 249413 */     GIR_EraseRootFromParent_Done,
     /* 249414 */   // Label 4785: @249414
     /* 249414 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(249456), // Rule ID 10332 //
     /* 249419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 249427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 249436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249443 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1414:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 249443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 249446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249452 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249454 */     GIR_RootConstrainSelectedInstOperands,
     /* 249455 */     // GIR_Coverage, 10332,
     /* 249455 */     GIR_EraseRootFromParent_Done,
     /* 249456 */   // Label 4786: @249456
     /* 249456 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(249498), // Rule ID 11329 //
     /* 249461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 249464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 249469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249485 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1989:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 249488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249496 */     GIR_RootConstrainSelectedInstOperands,
     /* 249497 */     // GIR_Coverage, 11329,
     /* 249497 */     GIR_EraseRootFromParent_Done,
     /* 249498 */   // Label 4787: @249498
     /* 249498 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(249540), // Rule ID 11330 //
     /* 249503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 249506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 249511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249527 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2060:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 249530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249536 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249538 */     GIR_RootConstrainSelectedInstOperands,
     /* 249539 */     // GIR_Coverage, 11330,
     /* 249539 */     GIR_EraseRootFromParent_Done,
     /* 249540 */   // Label 4788: @249540
     /* 249540 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(249582), // Rule ID 11332 //
     /* 249545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 249548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 249553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249569 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1475:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 249569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 249572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249578 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249580 */     GIR_RootConstrainSelectedInstOperands,
     /* 249581 */     // GIR_Coverage, 11332,
     /* 249581 */     GIR_EraseRootFromParent_Done,
     /* 249582 */   // Label 4789: @249582
     /* 249582 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(249624), // Rule ID 11333 //
     /* 249587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 249590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 249595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249611 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1475:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 249611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 249614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249620 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249622 */     GIR_RootConstrainSelectedInstOperands,
     /* 249623 */     // GIR_Coverage, 11333,
     /* 249623 */     GIR_EraseRootFromParent_Done,
     /* 249624 */   // Label 4790: @249624
     /* 249624 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(249666), // Rule ID 11387 //
     /* 249629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 249637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 249643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249653 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1824:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 249656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249662 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249664 */     GIR_RootConstrainSelectedInstOperands,
     /* 249665 */     // GIR_Coverage, 11387,
     /* 249665 */     GIR_EraseRootFromParent_Done,
     /* 249666 */   // Label 4791: @249666
     /* 249666 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(249708), // Rule ID 11388 //
     /* 249671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 249679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249695 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1824:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 249698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249706 */     GIR_RootConstrainSelectedInstOperands,
     /* 249707 */     // GIR_Coverage, 11388,
     /* 249707 */     GIR_EraseRootFromParent_Done,
     /* 249708 */   // Label 4792: @249708
     /* 249708 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(249750), // Rule ID 11389 //
     /* 249713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 249721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249737 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1824:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 249740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249748 */     GIR_RootConstrainSelectedInstOperands,
     /* 249749 */     // GIR_Coverage, 11389,
     /* 249749 */     GIR_EraseRootFromParent_Done,
     /* 249750 */   // Label 4793: @249750
     /* 249750 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(249792), // Rule ID 11390 //
     /* 249755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 249763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249779 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1824:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 249782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249788 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249790 */     GIR_RootConstrainSelectedInstOperands,
     /* 249791 */     // GIR_Coverage, 11390,
     /* 249791 */     GIR_EraseRootFromParent_Done,
     /* 249792 */   // Label 4794: @249792
     /* 249792 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(249834), // Rule ID 11443 //
     /* 249797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 249805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249821 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 249824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249830 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249832 */     GIR_RootConstrainSelectedInstOperands,
     /* 249833 */     // GIR_Coverage, 11443,
     /* 249833 */     GIR_EraseRootFromParent_Done,
     /* 249834 */   // Label 4795: @249834
     /* 249834 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(249876), // Rule ID 11444 //
     /* 249839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 249847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249863 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 249866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249872 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249874 */     GIR_RootConstrainSelectedInstOperands,
     /* 249875 */     // GIR_Coverage, 11444,
     /* 249875 */     GIR_EraseRootFromParent_Done,
     /* 249876 */   // Label 4796: @249876
     /* 249876 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(249918), // Rule ID 11445 //
     /* 249881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 249889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249905 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1745:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 249908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249914 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249916 */     GIR_RootConstrainSelectedInstOperands,
     /* 249917 */     // GIR_Coverage, 11445,
     /* 249917 */     GIR_EraseRootFromParent_Done,
     /* 249918 */   // Label 4797: @249918
     /* 249918 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(249960), // Rule ID 11446 //
     /* 249923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 249931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 249937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249947 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1981:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 249950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249958 */     GIR_RootConstrainSelectedInstOperands,
     /* 249959 */     // GIR_Coverage, 11446,
     /* 249959 */     GIR_EraseRootFromParent_Done,
     /* 249960 */   // Label 4798: @249960
     /* 249960 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(250002), // Rule ID 11447 //
     /* 249965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 249973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 249979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249989 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1981:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 249992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250000 */     GIR_RootConstrainSelectedInstOperands,
     /* 250001 */     // GIR_Coverage, 11447,
     /* 250001 */     GIR_EraseRootFromParent_Done,
     /* 250002 */   // Label 4799: @250002
     /* 250002 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(250044), // Rule ID 11448 //
     /* 250007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 250015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250031 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1981:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 250034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250042 */     GIR_RootConstrainSelectedInstOperands,
     /* 250043 */     // GIR_Coverage, 11448,
     /* 250043 */     GIR_EraseRootFromParent_Done,
     /* 250044 */   // Label 4800: @250044
     /* 250044 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(250086), // Rule ID 11449 //
     /* 250049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 250057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250073 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1983:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 250076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250082 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250084 */     GIR_RootConstrainSelectedInstOperands,
     /* 250085 */     // GIR_Coverage, 11449,
     /* 250085 */     GIR_EraseRootFromParent_Done,
     /* 250086 */   // Label 4801: @250086
     /* 250086 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(250128), // Rule ID 11450 //
     /* 250091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 250099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250115 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1983:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 250118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250126 */     GIR_RootConstrainSelectedInstOperands,
     /* 250127 */     // GIR_Coverage, 11450,
     /* 250127 */     GIR_EraseRootFromParent_Done,
     /* 250128 */   // Label 4802: @250128
     /* 250128 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(250170), // Rule ID 11451 //
     /* 250133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 250141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250157 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1983:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 250160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250166 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250168 */     GIR_RootConstrainSelectedInstOperands,
     /* 250169 */     // GIR_Coverage, 11451,
     /* 250169 */     GIR_EraseRootFromParent_Done,
     /* 250170 */   // Label 4803: @250170
     /* 250170 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(250212), // Rule ID 11452 //
     /* 250175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 250183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250199 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1747:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 250202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250210 */     GIR_RootConstrainSelectedInstOperands,
     /* 250211 */     // GIR_Coverage, 11452,
     /* 250211 */     GIR_EraseRootFromParent_Done,
     /* 250212 */   // Label 4804: @250212
     /* 250212 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(250254), // Rule ID 11453 //
     /* 250217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 250225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250241 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1747:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 250244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250252 */     GIR_RootConstrainSelectedInstOperands,
     /* 250253 */     // GIR_Coverage, 11453,
     /* 250253 */     GIR_EraseRootFromParent_Done,
     /* 250254 */   // Label 4805: @250254
     /* 250254 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(250296), // Rule ID 11454 //
     /* 250259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 250267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250283 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1747:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 250286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250294 */     GIR_RootConstrainSelectedInstOperands,
     /* 250295 */     // GIR_Coverage, 11454,
     /* 250295 */     GIR_EraseRootFromParent_Done,
     /* 250296 */   // Label 4806: @250296
     /* 250296 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(250338), // Rule ID 11455 //
     /* 250301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 250309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250325 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1749:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 250328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250336 */     GIR_RootConstrainSelectedInstOperands,
     /* 250337 */     // GIR_Coverage, 11455,
     /* 250337 */     GIR_EraseRootFromParent_Done,
     /* 250338 */   // Label 4807: @250338
     /* 250338 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(250380), // Rule ID 11456 //
     /* 250343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 250351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250367 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1749:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 250370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250378 */     GIR_RootConstrainSelectedInstOperands,
     /* 250379 */     // GIR_Coverage, 11456,
     /* 250379 */     GIR_EraseRootFromParent_Done,
     /* 250380 */   // Label 4808: @250380
     /* 250380 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(250422), // Rule ID 11457 //
     /* 250385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 250393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250409 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1749:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 250412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250418 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250420 */     GIR_RootConstrainSelectedInstOperands,
     /* 250421 */     // GIR_Coverage, 11457,
     /* 250421 */     GIR_EraseRootFromParent_Done,
     /* 250422 */   // Label 4809: @250422
     /* 250422 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(250464), // Rule ID 11458 //
     /* 250427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 250435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250451 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1985:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 250454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250462 */     GIR_RootConstrainSelectedInstOperands,
     /* 250463 */     // GIR_Coverage, 11458,
     /* 250463 */     GIR_EraseRootFromParent_Done,
     /* 250464 */   // Label 4810: @250464
     /* 250464 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(250506), // Rule ID 11459 //
     /* 250469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 250477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1985:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 250496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250504 */     GIR_RootConstrainSelectedInstOperands,
     /* 250505 */     // GIR_Coverage, 11459,
     /* 250505 */     GIR_EraseRootFromParent_Done,
     /* 250506 */   // Label 4811: @250506
     /* 250506 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(250548), // Rule ID 11460 //
     /* 250511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 250519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250535 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1985:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 250538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250546 */     GIR_RootConstrainSelectedInstOperands,
     /* 250547 */     // GIR_Coverage, 11460,
     /* 250547 */     GIR_EraseRootFromParent_Done,
     /* 250548 */   // Label 4812: @250548
     /* 250548 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(250590), // Rule ID 11461 //
     /* 250553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 250561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250577 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1987:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 250580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250588 */     GIR_RootConstrainSelectedInstOperands,
     /* 250589 */     // GIR_Coverage, 11461,
     /* 250589 */     GIR_EraseRootFromParent_Done,
     /* 250590 */   // Label 4813: @250590
     /* 250590 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(250632), // Rule ID 11462 //
     /* 250595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 250603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250619 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1987:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 250622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250630 */     GIR_RootConstrainSelectedInstOperands,
     /* 250631 */     // GIR_Coverage, 11462,
     /* 250631 */     GIR_EraseRootFromParent_Done,
     /* 250632 */   // Label 4814: @250632
     /* 250632 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(250674), // Rule ID 11463 //
     /* 250637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 250645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250661 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1987:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 250664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250672 */     GIR_RootConstrainSelectedInstOperands,
     /* 250673 */     // GIR_Coverage, 11463,
     /* 250673 */     GIR_EraseRootFromParent_Done,
     /* 250674 */   // Label 4815: @250674
     /* 250674 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(250716), // Rule ID 11472 //
     /* 250679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 250687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250703 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1785:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 250706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250714 */     GIR_RootConstrainSelectedInstOperands,
     /* 250715 */     // GIR_Coverage, 11472,
     /* 250715 */     GIR_EraseRootFromParent_Done,
     /* 250716 */   // Label 4816: @250716
     /* 250716 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(250758), // Rule ID 11473 //
     /* 250721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 250729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250745 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1785:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 250748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250756 */     GIR_RootConstrainSelectedInstOperands,
     /* 250757 */     // GIR_Coverage, 11473,
     /* 250757 */     GIR_EraseRootFromParent_Done,
     /* 250758 */   // Label 4817: @250758
     /* 250758 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(250800), // Rule ID 11474 //
     /* 250763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 250771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250787 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1785:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 250790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250798 */     GIR_RootConstrainSelectedInstOperands,
     /* 250799 */     // GIR_Coverage, 11474,
     /* 250799 */     GIR_EraseRootFromParent_Done,
     /* 250800 */   // Label 4818: @250800
     /* 250800 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(250842), // Rule ID 11475 //
     /* 250805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 250813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250829 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1788:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 250832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250840 */     GIR_RootConstrainSelectedInstOperands,
     /* 250841 */     // GIR_Coverage, 11475,
     /* 250841 */     GIR_EraseRootFromParent_Done,
     /* 250842 */   // Label 4819: @250842
     /* 250842 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(250884), // Rule ID 11476 //
     /* 250847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 250855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250871 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1788:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 250874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250882 */     GIR_RootConstrainSelectedInstOperands,
     /* 250883 */     // GIR_Coverage, 11476,
     /* 250883 */     GIR_EraseRootFromParent_Done,
     /* 250884 */   // Label 4820: @250884
     /* 250884 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(250926), // Rule ID 11477 //
     /* 250889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 250897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 250903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250913 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1788:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 250916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250924 */     GIR_RootConstrainSelectedInstOperands,
     /* 250925 */     // GIR_Coverage, 11477,
     /* 250925 */     GIR_EraseRootFromParent_Done,
     /* 250926 */   // Label 4821: @250926
     /* 250926 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(250968), // Rule ID 11478 //
     /* 250931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 250939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 250945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250955 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1790:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 250958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250966 */     GIR_RootConstrainSelectedInstOperands,
     /* 250967 */     // GIR_Coverage, 11478,
     /* 250967 */     GIR_EraseRootFromParent_Done,
     /* 250968 */   // Label 4822: @250968
     /* 250968 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(251010), // Rule ID 11479 //
     /* 250973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 250981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 250987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250997 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1790:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 251000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 251002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251008 */     GIR_RootConstrainSelectedInstOperands,
     /* 251009 */     // GIR_Coverage, 11479,
     /* 251009 */     GIR_EraseRootFromParent_Done,
     /* 251010 */   // Label 4823: @251010
     /* 251010 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(251052), // Rule ID 11480 //
     /* 251015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 251023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 251029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251039 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1790:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 251042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 251044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251050 */     GIR_RootConstrainSelectedInstOperands,
     /* 251051 */     // GIR_Coverage, 11480,
     /* 251051 */     GIR_EraseRootFromParent_Done,
     /* 251052 */   // Label 4824: @251052
     /* 251052 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(251094), // Rule ID 11481 //
     /* 251057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 251065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 251071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251081 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1793:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 251084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 251086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251092 */     GIR_RootConstrainSelectedInstOperands,
     /* 251093 */     // GIR_Coverage, 11481,
     /* 251093 */     GIR_EraseRootFromParent_Done,
     /* 251094 */   // Label 4825: @251094
     /* 251094 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(251136), // Rule ID 11482 //
     /* 251099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 251107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 251113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251123 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1793:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 251126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 251128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251134 */     GIR_RootConstrainSelectedInstOperands,
     /* 251135 */     // GIR_Coverage, 11482,
     /* 251135 */     GIR_EraseRootFromParent_Done,
     /* 251136 */   // Label 4826: @251136
     /* 251136 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(251178), // Rule ID 11483 //
     /* 251141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 251149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 251155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251165 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1793:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 251168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 251170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251176 */     GIR_RootConstrainSelectedInstOperands,
     /* 251177 */     // GIR_Coverage, 11483,
     /* 251177 */     GIR_EraseRootFromParent_Done,
     /* 251178 */   // Label 4827: @251178
     /* 251178 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(251220), // Rule ID 11484 //
     /* 251183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 251191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 251197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251207 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1787:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 251210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 251212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251218 */     GIR_RootConstrainSelectedInstOperands,
     /* 251219 */     // GIR_Coverage, 11484,
     /* 251219 */     GIR_EraseRootFromParent_Done,
     /* 251220 */   // Label 4828: @251220
     /* 251220 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(251262), // Rule ID 11485 //
     /* 251225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 251233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 251239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251249 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1787:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 251252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 251254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251260 */     GIR_RootConstrainSelectedInstOperands,
     /* 251261 */     // GIR_Coverage, 11485,
     /* 251261 */     GIR_EraseRootFromParent_Done,
     /* 251262 */   // Label 4829: @251262
     /* 251262 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(251304), // Rule ID 11486 //
     /* 251267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 251275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 251281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251291 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1787:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 251294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 251296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251302 */     GIR_RootConstrainSelectedInstOperands,
     /* 251303 */     // GIR_Coverage, 11486,
     /* 251303 */     GIR_EraseRootFromParent_Done,
     /* 251304 */   // Label 4830: @251304
     /* 251304 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(251346), // Rule ID 11487 //
     /* 251309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 251317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 251323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251333 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1792:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 251336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 251338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251344 */     GIR_RootConstrainSelectedInstOperands,
     /* 251345 */     // GIR_Coverage, 11487,
     /* 251345 */     GIR_EraseRootFromParent_Done,
     /* 251346 */   // Label 4831: @251346
     /* 251346 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(251388), // Rule ID 11488 //
     /* 251351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 251359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 251365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251375 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1792:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 251378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 251380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251384 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251386 */     GIR_RootConstrainSelectedInstOperands,
     /* 251387 */     // GIR_Coverage, 11488,
     /* 251387 */     GIR_EraseRootFromParent_Done,
     /* 251388 */   // Label 4832: @251388
     /* 251388 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(251430), // Rule ID 11489 //
     /* 251393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 251401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 251407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251417 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1792:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 251420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 251422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251428 */     GIR_RootConstrainSelectedInstOperands,
     /* 251429 */     // GIR_Coverage, 11489,
     /* 251429 */     GIR_EraseRootFromParent_Done,
     /* 251430 */   // Label 4833: @251430
     /* 251430 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(251472), // Rule ID 11490 //
     /* 251435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 251443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251459 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1960:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 251462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251470 */     GIR_RootConstrainSelectedInstOperands,
     /* 251471 */     // GIR_Coverage, 11490,
     /* 251471 */     GIR_EraseRootFromParent_Done,
     /* 251472 */   // Label 4834: @251472
     /* 251472 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(251514), // Rule ID 11492 //
     /* 251477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 251485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251501 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1960:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 251504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251510 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251512 */     GIR_RootConstrainSelectedInstOperands,
     /* 251513 */     // GIR_Coverage, 11492,
     /* 251513 */     GIR_EraseRootFromParent_Done,
     /* 251514 */   // Label 4835: @251514
     /* 251514 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(251556), // Rule ID 11494 //
     /* 251519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 251527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251543 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 251546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251554 */     GIR_RootConstrainSelectedInstOperands,
     /* 251555 */     // GIR_Coverage, 11494,
     /* 251555 */     GIR_EraseRootFromParent_Done,
     /* 251556 */   // Label 4836: @251556
     /* 251556 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(251598), // Rule ID 11496 //
     /* 251561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 251569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251585 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1960:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 251588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251596 */     GIR_RootConstrainSelectedInstOperands,
     /* 251597 */     // GIR_Coverage, 11496,
     /* 251597 */     GIR_EraseRootFromParent_Done,
     /* 251598 */   // Label 4837: @251598
     /* 251598 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(251640), // Rule ID 11498 //
     /* 251603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 251611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251627 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1720:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 251630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251638 */     GIR_RootConstrainSelectedInstOperands,
     /* 251639 */     // GIR_Coverage, 11498,
     /* 251639 */     GIR_EraseRootFromParent_Done,
     /* 251640 */   // Label 4838: @251640
     /* 251640 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(251682), // Rule ID 11499 //
     /* 251645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 251653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251669 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1720:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 251672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251680 */     GIR_RootConstrainSelectedInstOperands,
     /* 251681 */     // GIR_Coverage, 11499,
     /* 251681 */     GIR_EraseRootFromParent_Done,
     /* 251682 */   // Label 4839: @251682
     /* 251682 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(251724), // Rule ID 11500 //
     /* 251687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 251695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251711 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1720:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 251714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251722 */     GIR_RootConstrainSelectedInstOperands,
     /* 251723 */     // GIR_Coverage, 11500,
     /* 251723 */     GIR_EraseRootFromParent_Done,
     /* 251724 */   // Label 4840: @251724
     /* 251724 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(251766), // Rule ID 11501 //
     /* 251729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 251737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251753 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1720:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 251756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251762 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251764 */     GIR_RootConstrainSelectedInstOperands,
     /* 251765 */     // GIR_Coverage, 11501,
     /* 251765 */     GIR_EraseRootFromParent_Done,
     /* 251766 */   // Label 4841: @251766
     /* 251766 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(251808), // Rule ID 11502 //
     /* 251771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 251779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251795 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1961:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 251798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251806 */     GIR_RootConstrainSelectedInstOperands,
     /* 251807 */     // GIR_Coverage, 11502,
     /* 251807 */     GIR_EraseRootFromParent_Done,
     /* 251808 */   // Label 4842: @251808
     /* 251808 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(251850), // Rule ID 11503 //
     /* 251813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 251821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251837 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1961:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 251840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251846 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251848 */     GIR_RootConstrainSelectedInstOperands,
     /* 251849 */     // GIR_Coverage, 11503,
     /* 251849 */     GIR_EraseRootFromParent_Done,
     /* 251850 */   // Label 4843: @251850
     /* 251850 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(251892), // Rule ID 11504 //
     /* 251855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 251863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251879 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1961:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 251882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251890 */     GIR_RootConstrainSelectedInstOperands,
     /* 251891 */     // GIR_Coverage, 11504,
     /* 251891 */     GIR_EraseRootFromParent_Done,
     /* 251892 */   // Label 4844: @251892
     /* 251892 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(251934), // Rule ID 11505 //
     /* 251897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 251905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251921 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1961:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 251924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251932 */     GIR_RootConstrainSelectedInstOperands,
     /* 251933 */     // GIR_Coverage, 11505,
     /* 251933 */     GIR_EraseRootFromParent_Done,
     /* 251934 */   // Label 4845: @251934
     /* 251934 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(251976), // Rule ID 11506 //
     /* 251939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 251947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251963 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1855:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 251966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251974 */     GIR_RootConstrainSelectedInstOperands,
     /* 251975 */     // GIR_Coverage, 11506,
     /* 251975 */     GIR_EraseRootFromParent_Done,
     /* 251976 */   // Label 4846: @251976
     /* 251976 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(252018), // Rule ID 11508 //
     /* 251981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 251989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252005 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1855:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 252008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252016 */     GIR_RootConstrainSelectedInstOperands,
     /* 252017 */     // GIR_Coverage, 11508,
     /* 252017 */     GIR_EraseRootFromParent_Done,
     /* 252018 */   // Label 4847: @252018
     /* 252018 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(252060), // Rule ID 11510 //
     /* 252023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 252031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252047 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1855:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 252050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252058 */     GIR_RootConstrainSelectedInstOperands,
     /* 252059 */     // GIR_Coverage, 11510,
     /* 252059 */     GIR_EraseRootFromParent_Done,
     /* 252060 */   // Label 4848: @252060
     /* 252060 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(252102), // Rule ID 11512 //
     /* 252065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 252073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252089 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1855:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 252092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252100 */     GIR_RootConstrainSelectedInstOperands,
     /* 252101 */     // GIR_Coverage, 11512,
     /* 252101 */     GIR_EraseRootFromParent_Done,
     /* 252102 */   // Label 4849: @252102
     /* 252102 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(252144), // Rule ID 11514 //
     /* 252107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 252115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252131 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2047:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 252134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252142 */     GIR_RootConstrainSelectedInstOperands,
     /* 252143 */     // GIR_Coverage, 11514,
     /* 252143 */     GIR_EraseRootFromParent_Done,
     /* 252144 */   // Label 4850: @252144
     /* 252144 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(252186), // Rule ID 11516 //
     /* 252149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 252157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252173 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2047:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 252176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252184 */     GIR_RootConstrainSelectedInstOperands,
     /* 252185 */     // GIR_Coverage, 11516,
     /* 252185 */     GIR_EraseRootFromParent_Done,
     /* 252186 */   // Label 4851: @252186
     /* 252186 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(252228), // Rule ID 11518 //
     /* 252191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 252199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252215 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 252218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252226 */     GIR_RootConstrainSelectedInstOperands,
     /* 252227 */     // GIR_Coverage, 11518,
     /* 252227 */     GIR_EraseRootFromParent_Done,
     /* 252228 */   // Label 4852: @252228
     /* 252228 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(252270), // Rule ID 11520 //
     /* 252233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 252241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252257 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2047:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 252260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252268 */     GIR_RootConstrainSelectedInstOperands,
     /* 252269 */     // GIR_Coverage, 11520,
     /* 252269 */     GIR_EraseRootFromParent_Done,
     /* 252270 */   // Label 4853: @252270
     /* 252270 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(252312), // Rule ID 11522 //
     /* 252275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 252283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252299 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1721:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 252302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252310 */     GIR_RootConstrainSelectedInstOperands,
     /* 252311 */     // GIR_Coverage, 11522,
     /* 252311 */     GIR_EraseRootFromParent_Done,
     /* 252312 */   // Label 4854: @252312
     /* 252312 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(252354), // Rule ID 11523 //
     /* 252317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 252325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252341 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1721:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 252344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252352 */     GIR_RootConstrainSelectedInstOperands,
     /* 252353 */     // GIR_Coverage, 11523,
     /* 252353 */     GIR_EraseRootFromParent_Done,
     /* 252354 */   // Label 4855: @252354
     /* 252354 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(252396), // Rule ID 11524 //
     /* 252359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 252367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252383 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1721:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 252386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252394 */     GIR_RootConstrainSelectedInstOperands,
     /* 252395 */     // GIR_Coverage, 11524,
     /* 252395 */     GIR_EraseRootFromParent_Done,
     /* 252396 */   // Label 4856: @252396
     /* 252396 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(252438), // Rule ID 11525 //
     /* 252401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 252409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252425 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1721:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 252428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252436 */     GIR_RootConstrainSelectedInstOperands,
     /* 252437 */     // GIR_Coverage, 11525,
     /* 252437 */     GIR_EraseRootFromParent_Done,
     /* 252438 */   // Label 4857: @252438
     /* 252438 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(252480), // Rule ID 11526 //
     /* 252443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 252451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252467 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1962:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 252470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252478 */     GIR_RootConstrainSelectedInstOperands,
     /* 252479 */     // GIR_Coverage, 11526,
     /* 252479 */     GIR_EraseRootFromParent_Done,
     /* 252480 */   // Label 4858: @252480
     /* 252480 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(252522), // Rule ID 11527 //
     /* 252485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 252493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252509 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1962:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 252512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252520 */     GIR_RootConstrainSelectedInstOperands,
     /* 252521 */     // GIR_Coverage, 11527,
     /* 252521 */     GIR_EraseRootFromParent_Done,
     /* 252522 */   // Label 4859: @252522
     /* 252522 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(252564), // Rule ID 11528 //
     /* 252527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 252535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252551 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1962:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 252554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252562 */     GIR_RootConstrainSelectedInstOperands,
     /* 252563 */     // GIR_Coverage, 11528,
     /* 252563 */     GIR_EraseRootFromParent_Done,
     /* 252564 */   // Label 4860: @252564
     /* 252564 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(252606), // Rule ID 11529 //
     /* 252569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 252577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252593 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1962:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 252596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252604 */     GIR_RootConstrainSelectedInstOperands,
     /* 252605 */     // GIR_Coverage, 11529,
     /* 252605 */     GIR_EraseRootFromParent_Done,
     /* 252606 */   // Label 4861: @252606
     /* 252606 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(252648), // Rule ID 11530 //
     /* 252611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 252619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252635 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1937:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 252638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252646 */     GIR_RootConstrainSelectedInstOperands,
     /* 252647 */     // GIR_Coverage, 11530,
     /* 252647 */     GIR_EraseRootFromParent_Done,
     /* 252648 */   // Label 4862: @252648
     /* 252648 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(252690), // Rule ID 11531 //
     /* 252653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 252661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252677 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1937:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 252680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252688 */     GIR_RootConstrainSelectedInstOperands,
     /* 252689 */     // GIR_Coverage, 11531,
     /* 252689 */     GIR_EraseRootFromParent_Done,
     /* 252690 */   // Label 4863: @252690
     /* 252690 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(252732), // Rule ID 11532 //
     /* 252695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 252703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252719 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1937:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 252722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 252724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252730 */     GIR_RootConstrainSelectedInstOperands,
     /* 252731 */     // GIR_Coverage, 11532,
     /* 252731 */     GIR_EraseRootFromParent_Done,
     /* 252732 */   // Label 4864: @252732
     /* 252732 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(252774), // Rule ID 11533 //
     /* 252737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 252745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252761 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1252:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 252764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252772 */     GIR_RootConstrainSelectedInstOperands,
     /* 252773 */     // GIR_Coverage, 11533,
     /* 252773 */     GIR_EraseRootFromParent_Done,
     /* 252774 */   // Label 4865: @252774
     /* 252774 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(252816), // Rule ID 11534 //
     /* 252779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 252787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252803 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1252:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 252806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252814 */     GIR_RootConstrainSelectedInstOperands,
     /* 252815 */     // GIR_Coverage, 11534,
     /* 252815 */     GIR_EraseRootFromParent_Done,
     /* 252816 */   // Label 4866: @252816
     /* 252816 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(252858), // Rule ID 11535 //
     /* 252821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 252829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252845 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1252:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 252848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252856 */     GIR_RootConstrainSelectedInstOperands,
     /* 252857 */     // GIR_Coverage, 11535,
     /* 252857 */     GIR_EraseRootFromParent_Done,
     /* 252858 */   // Label 4867: @252858
     /* 252858 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(252900), // Rule ID 11536 //
     /* 252863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 252871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252887 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1252:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 252890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252898 */     GIR_RootConstrainSelectedInstOperands,
     /* 252899 */     // GIR_Coverage, 11536,
     /* 252899 */     GIR_EraseRootFromParent_Done,
     /* 252900 */   // Label 4868: @252900
     /* 252900 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(252942), // Rule ID 11537 //
     /* 252905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 252913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252929 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1731:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 252932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252940 */     GIR_RootConstrainSelectedInstOperands,
     /* 252941 */     // GIR_Coverage, 11537,
     /* 252941 */     GIR_EraseRootFromParent_Done,
     /* 252942 */   // Label 4869: @252942
     /* 252942 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(252984), // Rule ID 11538 //
     /* 252947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 252955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252971 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1731:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 252974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252982 */     GIR_RootConstrainSelectedInstOperands,
     /* 252983 */     // GIR_Coverage, 11538,
     /* 252983 */     GIR_EraseRootFromParent_Done,
     /* 252984 */   // Label 4870: @252984
     /* 252984 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(253026), // Rule ID 11539 //
     /* 252989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 252997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253013 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 253016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253024 */     GIR_RootConstrainSelectedInstOperands,
     /* 253025 */     // GIR_Coverage, 11539,
     /* 253025 */     GIR_EraseRootFromParent_Done,
     /* 253026 */   // Label 4871: @253026
     /* 253026 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(253068), // Rule ID 11540 //
     /* 253031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 253039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253055 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1731:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 253058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253066 */     GIR_RootConstrainSelectedInstOperands,
     /* 253067 */     // GIR_Coverage, 11540,
     /* 253067 */     GIR_EraseRootFromParent_Done,
     /* 253068 */   // Label 4872: @253068
     /* 253068 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(253110), // Rule ID 11541 //
     /* 253073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 253081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253097 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1969:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 253100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253108 */     GIR_RootConstrainSelectedInstOperands,
     /* 253109 */     // GIR_Coverage, 11541,
     /* 253109 */     GIR_EraseRootFromParent_Done,
     /* 253110 */   // Label 4873: @253110
     /* 253110 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(253152), // Rule ID 11542 //
     /* 253115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 253123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253139 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1969:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 253142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253150 */     GIR_RootConstrainSelectedInstOperands,
     /* 253151 */     // GIR_Coverage, 11542,
     /* 253151 */     GIR_EraseRootFromParent_Done,
     /* 253152 */   // Label 4874: @253152
     /* 253152 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(253194), // Rule ID 11543 //
     /* 253157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 253165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253181 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 253184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253192 */     GIR_RootConstrainSelectedInstOperands,
     /* 253193 */     // GIR_Coverage, 11543,
     /* 253193 */     GIR_EraseRootFromParent_Done,
     /* 253194 */   // Label 4875: @253194
     /* 253194 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(253236), // Rule ID 11544 //
     /* 253199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 253207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253223 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1969:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 253226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253234 */     GIR_RootConstrainSelectedInstOperands,
     /* 253235 */     // GIR_Coverage, 11544,
     /* 253235 */     GIR_EraseRootFromParent_Done,
     /* 253236 */   // Label 4876: @253236
     /* 253236 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(253278), // Rule ID 11545 //
     /* 253241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 253249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253265 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1740:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 253268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253276 */     GIR_RootConstrainSelectedInstOperands,
     /* 253277 */     // GIR_Coverage, 11545,
     /* 253277 */     GIR_EraseRootFromParent_Done,
     /* 253278 */   // Label 4877: @253278
     /* 253278 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(253320), // Rule ID 11546 //
     /* 253283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 253291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253307 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1740:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 253310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253318 */     GIR_RootConstrainSelectedInstOperands,
     /* 253319 */     // GIR_Coverage, 11546,
     /* 253319 */     GIR_EraseRootFromParent_Done,
     /* 253320 */   // Label 4878: @253320
     /* 253320 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(253362), // Rule ID 11547 //
     /* 253325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 253333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253349 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1740:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 253352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253360 */     GIR_RootConstrainSelectedInstOperands,
     /* 253361 */     // GIR_Coverage, 11547,
     /* 253361 */     GIR_EraseRootFromParent_Done,
     /* 253362 */   // Label 4879: @253362
     /* 253362 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(253404), // Rule ID 11548 //
     /* 253367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 253375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253391 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1740:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 253394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253402 */     GIR_RootConstrainSelectedInstOperands,
     /* 253403 */     // GIR_Coverage, 11548,
     /* 253403 */     GIR_EraseRootFromParent_Done,
     /* 253404 */   // Label 4880: @253404
     /* 253404 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(253446), // Rule ID 11549 //
     /* 253409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 253417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253433 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1978:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 253436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253444 */     GIR_RootConstrainSelectedInstOperands,
     /* 253445 */     // GIR_Coverage, 11549,
     /* 253445 */     GIR_EraseRootFromParent_Done,
     /* 253446 */   // Label 4881: @253446
     /* 253446 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(253488), // Rule ID 11550 //
     /* 253451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 253459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253475 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1978:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 253478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253486 */     GIR_RootConstrainSelectedInstOperands,
     /* 253487 */     // GIR_Coverage, 11550,
     /* 253487 */     GIR_EraseRootFromParent_Done,
     /* 253488 */   // Label 4882: @253488
     /* 253488 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(253530), // Rule ID 11551 //
     /* 253493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 253501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253517 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1978:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 253520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253528 */     GIR_RootConstrainSelectedInstOperands,
     /* 253529 */     // GIR_Coverage, 11551,
     /* 253529 */     GIR_EraseRootFromParent_Done,
     /* 253530 */   // Label 4883: @253530
     /* 253530 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(253572), // Rule ID 11552 //
     /* 253535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 253543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253559 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1978:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 253562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253570 */     GIR_RootConstrainSelectedInstOperands,
     /* 253571 */     // GIR_Coverage, 11552,
     /* 253571 */     GIR_EraseRootFromParent_Done,
     /* 253572 */   // Label 4884: @253572
     /* 253572 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(253614), // Rule ID 11553 //
     /* 253577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 253585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 253594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253601 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 253604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253610 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253612 */     GIR_RootConstrainSelectedInstOperands,
     /* 253613 */     // GIR_Coverage, 11553,
     /* 253613 */     GIR_EraseRootFromParent_Done,
     /* 253614 */   // Label 4885: @253614
     /* 253614 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(253656), // Rule ID 11564 //
     /* 253619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 253627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 253636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253643 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1819:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 253646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253654 */     GIR_RootConstrainSelectedInstOperands,
     /* 253655 */     // GIR_Coverage, 11564,
     /* 253655 */     GIR_EraseRootFromParent_Done,
     /* 253656 */   // Label 4886: @253656
     /* 253656 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(253698), // Rule ID 11565 //
     /* 253661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 253669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 253678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253685 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1819:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 253688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253696 */     GIR_RootConstrainSelectedInstOperands,
     /* 253697 */     // GIR_Coverage, 11565,
     /* 253697 */     GIR_EraseRootFromParent_Done,
     /* 253698 */   // Label 4887: @253698
     /* 253698 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(253740), // Rule ID 11566 //
     /* 253703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 253711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 253720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253727 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1819:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 253730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253738 */     GIR_RootConstrainSelectedInstOperands,
     /* 253739 */     // GIR_Coverage, 11566,
     /* 253739 */     GIR_EraseRootFromParent_Done,
     /* 253740 */   // Label 4888: @253740
     /* 253740 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(253782), // Rule ID 11567 //
     /* 253745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 253753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 253759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 253762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253769 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1819:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 253772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 253774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253778 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253780 */     GIR_RootConstrainSelectedInstOperands,
     /* 253781 */     // GIR_Coverage, 11567,
     /* 253781 */     GIR_EraseRootFromParent_Done,
     /* 253782 */   // Label 4889: @253782
     /* 253782 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(253824), // Rule ID 11576 //
     /* 253787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 253795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253811 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1760:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 253814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253820 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253822 */     GIR_RootConstrainSelectedInstOperands,
     /* 253823 */     // GIR_Coverage, 11576,
     /* 253823 */     GIR_EraseRootFromParent_Done,
     /* 253824 */   // Label 4890: @253824
     /* 253824 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(253866), // Rule ID 11577 //
     /* 253829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 253837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253853 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1760:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 253856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253864 */     GIR_RootConstrainSelectedInstOperands,
     /* 253865 */     // GIR_Coverage, 11577,
     /* 253865 */     GIR_EraseRootFromParent_Done,
     /* 253866 */   // Label 4891: @253866
     /* 253866 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(253908), // Rule ID 11578 //
     /* 253871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 253879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253895 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1760:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 253898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253906 */     GIR_RootConstrainSelectedInstOperands,
     /* 253907 */     // GIR_Coverage, 11578,
     /* 253907 */     GIR_EraseRootFromParent_Done,
     /* 253908 */   // Label 4892: @253908
     /* 253908 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(253950), // Rule ID 11579 //
     /* 253913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 253921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253937 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1760:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 253940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253948 */     GIR_RootConstrainSelectedInstOperands,
     /* 253949 */     // GIR_Coverage, 11579,
     /* 253949 */     GIR_EraseRootFromParent_Done,
     /* 253950 */   // Label 4893: @253950
     /* 253950 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(253992), // Rule ID 11580 //
     /* 253955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 253963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253979 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1996:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 253982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253990 */     GIR_RootConstrainSelectedInstOperands,
     /* 253991 */     // GIR_Coverage, 11580,
     /* 253991 */     GIR_EraseRootFromParent_Done,
     /* 253992 */   // Label 4894: @253992
     /* 253992 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(254034), // Rule ID 11581 //
     /* 253997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 254005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254021 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1996:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 254024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254032 */     GIR_RootConstrainSelectedInstOperands,
     /* 254033 */     // GIR_Coverage, 11581,
     /* 254033 */     GIR_EraseRootFromParent_Done,
     /* 254034 */   // Label 4895: @254034
     /* 254034 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(254076), // Rule ID 11582 //
     /* 254039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 254047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254063 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1996:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 254066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254074 */     GIR_RootConstrainSelectedInstOperands,
     /* 254075 */     // GIR_Coverage, 11582,
     /* 254075 */     GIR_EraseRootFromParent_Done,
     /* 254076 */   // Label 4896: @254076
     /* 254076 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(254118), // Rule ID 11583 //
     /* 254081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 254089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254105 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1996:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 254108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254116 */     GIR_RootConstrainSelectedInstOperands,
     /* 254117 */     // GIR_Coverage, 11583,
     /* 254117 */     GIR_EraseRootFromParent_Done,
     /* 254118 */   // Label 4897: @254118
     /* 254118 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(254160), // Rule ID 11584 //
     /* 254123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 254131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254147 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1847:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 254150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254158 */     GIR_RootConstrainSelectedInstOperands,
     /* 254159 */     // GIR_Coverage, 11584,
     /* 254159 */     GIR_EraseRootFromParent_Done,
     /* 254160 */   // Label 4898: @254160
     /* 254160 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(254202), // Rule ID 11585 //
     /* 254165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 254173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254189 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1847:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 254192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254200 */     GIR_RootConstrainSelectedInstOperands,
     /* 254201 */     // GIR_Coverage, 11585,
     /* 254201 */     GIR_EraseRootFromParent_Done,
     /* 254202 */   // Label 4899: @254202
     /* 254202 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(254244), // Rule ID 11586 //
     /* 254207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 254215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254231 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1847:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 254234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254242 */     GIR_RootConstrainSelectedInstOperands,
     /* 254243 */     // GIR_Coverage, 11586,
     /* 254243 */     GIR_EraseRootFromParent_Done,
     /* 254244 */   // Label 4900: @254244
     /* 254244 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(254286), // Rule ID 11587 //
     /* 254249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 254257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254273 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1847:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 254276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254284 */     GIR_RootConstrainSelectedInstOperands,
     /* 254285 */     // GIR_Coverage, 11587,
     /* 254285 */     GIR_EraseRootFromParent_Done,
     /* 254286 */   // Label 4901: @254286
     /* 254286 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(254328), // Rule ID 11588 //
     /* 254291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 254299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254315 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2040:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 254318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254326 */     GIR_RootConstrainSelectedInstOperands,
     /* 254327 */     // GIR_Coverage, 11588,
     /* 254327 */     GIR_EraseRootFromParent_Done,
     /* 254328 */   // Label 4902: @254328
     /* 254328 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(254370), // Rule ID 11589 //
     /* 254333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 254341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254357 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2040:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 254360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254368 */     GIR_RootConstrainSelectedInstOperands,
     /* 254369 */     // GIR_Coverage, 11589,
     /* 254369 */     GIR_EraseRootFromParent_Done,
     /* 254370 */   // Label 4903: @254370
     /* 254370 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(254412), // Rule ID 11590 //
     /* 254375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 254383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254399 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2040:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 254402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254410 */     GIR_RootConstrainSelectedInstOperands,
     /* 254411 */     // GIR_Coverage, 11590,
     /* 254411 */     GIR_EraseRootFromParent_Done,
     /* 254412 */   // Label 4904: @254412
     /* 254412 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(254454), // Rule ID 11591 //
     /* 254417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 254425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254441 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2040:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 254444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254452 */     GIR_RootConstrainSelectedInstOperands,
     /* 254453 */     // GIR_Coverage, 11591,
     /* 254453 */     GIR_EraseRootFromParent_Done,
     /* 254454 */   // Label 4905: @254454
     /* 254454 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(254496), // Rule ID 11592 //
     /* 254459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 254467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254483 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1911:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 254486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254494 */     GIR_RootConstrainSelectedInstOperands,
     /* 254495 */     // GIR_Coverage, 11592,
     /* 254495 */     GIR_EraseRootFromParent_Done,
     /* 254496 */   // Label 4906: @254496
     /* 254496 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(254538), // Rule ID 11593 //
     /* 254501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 254509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254525 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1911:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 254528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254536 */     GIR_RootConstrainSelectedInstOperands,
     /* 254537 */     // GIR_Coverage, 11593,
     /* 254537 */     GIR_EraseRootFromParent_Done,
     /* 254538 */   // Label 4907: @254538
     /* 254538 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(254580), // Rule ID 11594 //
     /* 254543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 254551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254567 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1911:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 254570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254578 */     GIR_RootConstrainSelectedInstOperands,
     /* 254579 */     // GIR_Coverage, 11594,
     /* 254579 */     GIR_EraseRootFromParent_Done,
     /* 254580 */   // Label 4908: @254580
     /* 254580 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(254622), // Rule ID 11595 //
     /* 254585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 254593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254609 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1911:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 254612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254620 */     GIR_RootConstrainSelectedInstOperands,
     /* 254621 */     // GIR_Coverage, 11595,
     /* 254621 */     GIR_EraseRootFromParent_Done,
     /* 254622 */   // Label 4909: @254622
     /* 254622 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(254664), // Rule ID 11596 //
     /* 254627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 254635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254651 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2061:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 254654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254662 */     GIR_RootConstrainSelectedInstOperands,
     /* 254663 */     // GIR_Coverage, 11596,
     /* 254663 */     GIR_EraseRootFromParent_Done,
     /* 254664 */   // Label 4910: @254664
     /* 254664 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(254706), // Rule ID 11597 //
     /* 254669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 254677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254693 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2061:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 254696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254704 */     GIR_RootConstrainSelectedInstOperands,
     /* 254705 */     // GIR_Coverage, 11597,
     /* 254705 */     GIR_EraseRootFromParent_Done,
     /* 254706 */   // Label 4911: @254706
     /* 254706 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(254748), // Rule ID 11598 //
     /* 254711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 254719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254735 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2061:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 254738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254746 */     GIR_RootConstrainSelectedInstOperands,
     /* 254747 */     // GIR_Coverage, 11598,
     /* 254747 */     GIR_EraseRootFromParent_Done,
     /* 254748 */   // Label 4912: @254748
     /* 254748 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(254790), // Rule ID 11599 //
     /* 254753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 254761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254777 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2061:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 254780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254788 */     GIR_RootConstrainSelectedInstOperands,
     /* 254789 */     // GIR_Coverage, 11599,
     /* 254789 */     GIR_EraseRootFromParent_Done,
     /* 254790 */   // Label 4913: @254790
     /* 254790 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(254832), // Rule ID 11600 //
     /* 254795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 254803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254819 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1850:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 254822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254830 */     GIR_RootConstrainSelectedInstOperands,
     /* 254831 */     // GIR_Coverage, 11600,
     /* 254831 */     GIR_EraseRootFromParent_Done,
     /* 254832 */   // Label 4914: @254832
     /* 254832 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(254874), // Rule ID 11601 //
     /* 254837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 254845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254861 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1850:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 254864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254872 */     GIR_RootConstrainSelectedInstOperands,
     /* 254873 */     // GIR_Coverage, 11601,
     /* 254873 */     GIR_EraseRootFromParent_Done,
     /* 254874 */   // Label 4915: @254874
     /* 254874 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(254916), // Rule ID 11602 //
     /* 254879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 254887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 254893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254903 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1850:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 254906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254914 */     GIR_RootConstrainSelectedInstOperands,
     /* 254915 */     // GIR_Coverage, 11602,
     /* 254915 */     GIR_EraseRootFromParent_Done,
     /* 254916 */   // Label 4916: @254916
     /* 254916 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(254958), // Rule ID 11603 //
     /* 254921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 254929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 254935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254945 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1850:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 254948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254956 */     GIR_RootConstrainSelectedInstOperands,
     /* 254957 */     // GIR_Coverage, 11603,
     /* 254957 */     GIR_EraseRootFromParent_Done,
     /* 254958 */   // Label 4917: @254958
     /* 254958 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(255000), // Rule ID 11604 //
     /* 254963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 254971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254987 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2043:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 254990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 254992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254998 */     GIR_RootConstrainSelectedInstOperands,
     /* 254999 */     // GIR_Coverage, 11604,
     /* 254999 */     GIR_EraseRootFromParent_Done,
     /* 255000 */   // Label 4918: @255000
     /* 255000 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(255042), // Rule ID 11605 //
     /* 255005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 255013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255029 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2043:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 255032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255040 */     GIR_RootConstrainSelectedInstOperands,
     /* 255041 */     // GIR_Coverage, 11605,
     /* 255041 */     GIR_EraseRootFromParent_Done,
     /* 255042 */   // Label 4919: @255042
     /* 255042 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(255084), // Rule ID 11606 //
     /* 255047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 255055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255071 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2043:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 255074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255082 */     GIR_RootConstrainSelectedInstOperands,
     /* 255083 */     // GIR_Coverage, 11606,
     /* 255083 */     GIR_EraseRootFromParent_Done,
     /* 255084 */   // Label 4920: @255084
     /* 255084 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(255126), // Rule ID 11607 //
     /* 255089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 255097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255113 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2043:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 255116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255124 */     GIR_RootConstrainSelectedInstOperands,
     /* 255125 */     // GIR_Coverage, 11607,
     /* 255125 */     GIR_EraseRootFromParent_Done,
     /* 255126 */   // Label 4921: @255126
     /* 255126 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(255168), // Rule ID 11608 //
     /* 255131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 255139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 255145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255155 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1857:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 255158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255166 */     GIR_RootConstrainSelectedInstOperands,
     /* 255167 */     // GIR_Coverage, 11608,
     /* 255167 */     GIR_EraseRootFromParent_Done,
     /* 255168 */   // Label 4922: @255168
     /* 255168 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(255210), // Rule ID 11609 //
     /* 255173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 255181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255197 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1857:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 255200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255208 */     GIR_RootConstrainSelectedInstOperands,
     /* 255209 */     // GIR_Coverage, 11609,
     /* 255209 */     GIR_EraseRootFromParent_Done,
     /* 255210 */   // Label 4923: @255210
     /* 255210 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(255252), // Rule ID 11610 //
     /* 255215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 255223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255239 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1857:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 255242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255250 */     GIR_RootConstrainSelectedInstOperands,
     /* 255251 */     // GIR_Coverage, 11610,
     /* 255251 */     GIR_EraseRootFromParent_Done,
     /* 255252 */   // Label 4924: @255252
     /* 255252 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(255294), // Rule ID 11611 //
     /* 255257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 255265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255281 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1857:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 255284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255292 */     GIR_RootConstrainSelectedInstOperands,
     /* 255293 */     // GIR_Coverage, 11611,
     /* 255293 */     GIR_EraseRootFromParent_Done,
     /* 255294 */   // Label 4925: @255294
     /* 255294 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(255336), // Rule ID 11612 //
     /* 255299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 255307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 255313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255323 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2048:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 255326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255334 */     GIR_RootConstrainSelectedInstOperands,
     /* 255335 */     // GIR_Coverage, 11612,
     /* 255335 */     GIR_EraseRootFromParent_Done,
     /* 255336 */   // Label 4926: @255336
     /* 255336 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(255378), // Rule ID 11613 //
     /* 255341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 255349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255365 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2048:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 255368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255376 */     GIR_RootConstrainSelectedInstOperands,
     /* 255377 */     // GIR_Coverage, 11613,
     /* 255377 */     GIR_EraseRootFromParent_Done,
     /* 255378 */   // Label 4927: @255378
     /* 255378 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(255420), // Rule ID 11614 //
     /* 255383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 255391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2048:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 255410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255418 */     GIR_RootConstrainSelectedInstOperands,
     /* 255419 */     // GIR_Coverage, 11614,
     /* 255419 */     GIR_EraseRootFromParent_Done,
     /* 255420 */   // Label 4928: @255420
     /* 255420 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(255462), // Rule ID 11615 //
     /* 255425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 255433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255449 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2048:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 255452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255460 */     GIR_RootConstrainSelectedInstOperands,
     /* 255461 */     // GIR_Coverage, 11615,
     /* 255461 */     GIR_EraseRootFromParent_Done,
     /* 255462 */   // Label 4929: @255462
     /* 255462 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(255504), // Rule ID 11616 //
     /* 255467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 255475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 255481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255491 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1841:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 255494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255500 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255502 */     GIR_RootConstrainSelectedInstOperands,
     /* 255503 */     // GIR_Coverage, 11616,
     /* 255503 */     GIR_EraseRootFromParent_Done,
     /* 255504 */   // Label 4930: @255504
     /* 255504 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(255546), // Rule ID 11617 //
     /* 255509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 255517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255533 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 255536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255544 */     GIR_RootConstrainSelectedInstOperands,
     /* 255545 */     // GIR_Coverage, 11617,
     /* 255545 */     GIR_EraseRootFromParent_Done,
     /* 255546 */   // Label 4931: @255546
     /* 255546 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(255588), // Rule ID 11618 //
     /* 255551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 255559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255575 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 255578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255586 */     GIR_RootConstrainSelectedInstOperands,
     /* 255587 */     // GIR_Coverage, 11618,
     /* 255587 */     GIR_EraseRootFromParent_Done,
     /* 255588 */   // Label 4932: @255588
     /* 255588 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(255630), // Rule ID 11619 //
     /* 255593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 255601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255617 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1841:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 255620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255626 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255628 */     GIR_RootConstrainSelectedInstOperands,
     /* 255629 */     // GIR_Coverage, 11619,
     /* 255629 */     GIR_EraseRootFromParent_Done,
     /* 255630 */   // Label 4933: @255630
     /* 255630 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(255672), // Rule ID 11620 //
     /* 255635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 255643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 255649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255659 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2037:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 255662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255670 */     GIR_RootConstrainSelectedInstOperands,
     /* 255671 */     // GIR_Coverage, 11620,
     /* 255671 */     GIR_EraseRootFromParent_Done,
     /* 255672 */   // Label 4934: @255672
     /* 255672 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(255714), // Rule ID 11621 //
     /* 255677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 255685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255701 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2037:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 255704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255710 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255712 */     GIR_RootConstrainSelectedInstOperands,
     /* 255713 */     // GIR_Coverage, 11621,
     /* 255713 */     GIR_EraseRootFromParent_Done,
     /* 255714 */   // Label 4935: @255714
     /* 255714 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(255756), // Rule ID 11622 //
     /* 255719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 255727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255743 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2037:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 255746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255754 */     GIR_RootConstrainSelectedInstOperands,
     /* 255755 */     // GIR_Coverage, 11622,
     /* 255755 */     GIR_EraseRootFromParent_Done,
     /* 255756 */   // Label 4936: @255756
     /* 255756 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(255798), // Rule ID 11623 //
     /* 255761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 255769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255785 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2037:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 255788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255796 */     GIR_RootConstrainSelectedInstOperands,
     /* 255797 */     // GIR_Coverage, 11623,
     /* 255797 */     GIR_EraseRootFromParent_Done,
     /* 255798 */   // Label 4937: @255798
     /* 255798 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(255840), // Rule ID 11624 //
     /* 255803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 255811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 255817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255827 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1828:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 255830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255838 */     GIR_RootConstrainSelectedInstOperands,
     /* 255839 */     // GIR_Coverage, 11624,
     /* 255839 */     GIR_EraseRootFromParent_Done,
     /* 255840 */   // Label 4938: @255840
     /* 255840 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(255882), // Rule ID 11625 //
     /* 255845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 255853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255869 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1828:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 255872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255880 */     GIR_RootConstrainSelectedInstOperands,
     /* 255881 */     // GIR_Coverage, 11625,
     /* 255881 */     GIR_EraseRootFromParent_Done,
     /* 255882 */   // Label 4939: @255882
     /* 255882 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(255924), // Rule ID 11626 //
     /* 255887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 255895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255911 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1828:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 255914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255922 */     GIR_RootConstrainSelectedInstOperands,
     /* 255923 */     // GIR_Coverage, 11626,
     /* 255923 */     GIR_EraseRootFromParent_Done,
     /* 255924 */   // Label 4940: @255924
     /* 255924 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(255966), // Rule ID 11627 //
     /* 255929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 255937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255953 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1828:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 255956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255964 */     GIR_RootConstrainSelectedInstOperands,
     /* 255965 */     // GIR_Coverage, 11627,
     /* 255965 */     GIR_EraseRootFromParent_Done,
     /* 255966 */   // Label 4941: @255966
     /* 255966 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(256008), // Rule ID 11628 //
     /* 255971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 255979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 255985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255995 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2030:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 255998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256006 */     GIR_RootConstrainSelectedInstOperands,
     /* 256007 */     // GIR_Coverage, 11628,
     /* 256007 */     GIR_EraseRootFromParent_Done,
     /* 256008 */   // Label 4942: @256008
     /* 256008 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(256050), // Rule ID 11629 //
     /* 256013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 256021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 256027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256037 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2030:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 256040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256046 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256048 */     GIR_RootConstrainSelectedInstOperands,
     /* 256049 */     // GIR_Coverage, 11629,
     /* 256049 */     GIR_EraseRootFromParent_Done,
     /* 256050 */   // Label 4943: @256050
     /* 256050 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(256092), // Rule ID 11630 //
     /* 256055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 256063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 256069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256079 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2030:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 256082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256090 */     GIR_RootConstrainSelectedInstOperands,
     /* 256091 */     // GIR_Coverage, 11630,
     /* 256091 */     GIR_EraseRootFromParent_Done,
     /* 256092 */   // Label 4944: @256092
     /* 256092 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(256134), // Rule ID 11631 //
     /* 256097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 256105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 256111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2030:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 256124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256132 */     GIR_RootConstrainSelectedInstOperands,
     /* 256133 */     // GIR_Coverage, 11631,
     /* 256133 */     GIR_EraseRootFromParent_Done,
     /* 256134 */   // Label 4945: @256134
     /* 256134 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(256176), // Rule ID 11794 //
     /* 256139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 256147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 256150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 256153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256163 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1930:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 256166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256170 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256172 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256174 */     GIR_RootConstrainSelectedInstOperands,
     /* 256175 */     // GIR_Coverage, 11794,
     /* 256175 */     GIR_EraseRootFromParent_Done,
     /* 256176 */   // Label 4946: @256176
     /* 256176 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(256218), // Rule ID 11796 //
     /* 256181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 256189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256205 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1930:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 256208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256216 */     GIR_RootConstrainSelectedInstOperands,
     /* 256217 */     // GIR_Coverage, 11796,
     /* 256217 */     GIR_EraseRootFromParent_Done,
     /* 256218 */   // Label 4947: @256218
     /* 256218 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(256260), // Rule ID 11798 //
     /* 256223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 256231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256247 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1930:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 256250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256258 */     GIR_RootConstrainSelectedInstOperands,
     /* 256259 */     // GIR_Coverage, 11798,
     /* 256259 */     GIR_EraseRootFromParent_Done,
     /* 256260 */   // Label 4948: @256260
     /* 256260 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(256302), // Rule ID 11800 //
     /* 256265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 256273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256289 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1930:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 256292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256300 */     GIR_RootConstrainSelectedInstOperands,
     /* 256301 */     // GIR_Coverage, 11800,
     /* 256301 */     GIR_EraseRootFromParent_Done,
     /* 256302 */   // Label 4949: @256302
     /* 256302 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(256344), // Rule ID 11802 //
     /* 256307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 256315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256331 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1682:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 256334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256340 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256342 */     GIR_RootConstrainSelectedInstOperands,
     /* 256343 */     // GIR_Coverage, 11802,
     /* 256343 */     GIR_EraseRootFromParent_Done,
     /* 256344 */   // Label 4950: @256344
     /* 256344 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(256386), // Rule ID 11803 //
     /* 256349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 256357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1682:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 256376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256384 */     GIR_RootConstrainSelectedInstOperands,
     /* 256385 */     // GIR_Coverage, 11803,
     /* 256385 */     GIR_EraseRootFromParent_Done,
     /* 256386 */   // Label 4951: @256386
     /* 256386 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(256428), // Rule ID 11804 //
     /* 256391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 256399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256415 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1682:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 256418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256426 */     GIR_RootConstrainSelectedInstOperands,
     /* 256427 */     // GIR_Coverage, 11804,
     /* 256427 */     GIR_EraseRootFromParent_Done,
     /* 256428 */   // Label 4952: @256428
     /* 256428 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(256470), // Rule ID 11805 //
     /* 256433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 256441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256457 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1931:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 256460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256468 */     GIR_RootConstrainSelectedInstOperands,
     /* 256469 */     // GIR_Coverage, 11805,
     /* 256469 */     GIR_EraseRootFromParent_Done,
     /* 256470 */   // Label 4953: @256470
     /* 256470 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(256512), // Rule ID 11806 //
     /* 256475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 256483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256499 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1931:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 256502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256508 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256510 */     GIR_RootConstrainSelectedInstOperands,
     /* 256511 */     // GIR_Coverage, 11806,
     /* 256511 */     GIR_EraseRootFromParent_Done,
     /* 256512 */   // Label 4954: @256512
     /* 256512 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(256554), // Rule ID 11807 //
     /* 256517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 256525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256541 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1931:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 256544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256552 */     GIR_RootConstrainSelectedInstOperands,
     /* 256553 */     // GIR_Coverage, 11807,
     /* 256553 */     GIR_EraseRootFromParent_Done,
     /* 256554 */   // Label 4955: @256554
     /* 256554 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(256596), // Rule ID 11808 //
     /* 256559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 256567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256583 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1932:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 256586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256592 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256594 */     GIR_RootConstrainSelectedInstOperands,
     /* 256595 */     // GIR_Coverage, 11808,
     /* 256595 */     GIR_EraseRootFromParent_Done,
     /* 256596 */   // Label 4956: @256596
     /* 256596 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(256638), // Rule ID 11809 //
     /* 256601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 256609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256625 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1932:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 256628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256636 */     GIR_RootConstrainSelectedInstOperands,
     /* 256637 */     // GIR_Coverage, 11809,
     /* 256637 */     GIR_EraseRootFromParent_Done,
     /* 256638 */   // Label 4957: @256638
     /* 256638 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(256680), // Rule ID 11810 //
     /* 256643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 256651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256667 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1932:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 256670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256678 */     GIR_RootConstrainSelectedInstOperands,
     /* 256679 */     // GIR_Coverage, 11810,
     /* 256679 */     GIR_EraseRootFromParent_Done,
     /* 256680 */   // Label 4958: @256680
     /* 256680 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(256722), // Rule ID 11811 //
     /* 256685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 256693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256709 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1245:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 256712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256718 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256720 */     GIR_RootConstrainSelectedInstOperands,
     /* 256721 */     // GIR_Coverage, 11811,
     /* 256721 */     GIR_EraseRootFromParent_Done,
     /* 256722 */   // Label 4959: @256722
     /* 256722 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(256764), // Rule ID 11812 //
     /* 256727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 256735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256751 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1245:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 256754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256762 */     GIR_RootConstrainSelectedInstOperands,
     /* 256763 */     // GIR_Coverage, 11812,
     /* 256763 */     GIR_EraseRootFromParent_Done,
     /* 256764 */   // Label 4960: @256764
     /* 256764 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(256806), // Rule ID 11813 //
     /* 256769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 256777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1694:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 256796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256804 */     GIR_RootConstrainSelectedInstOperands,
     /* 256805 */     // GIR_Coverage, 11813,
     /* 256805 */     GIR_EraseRootFromParent_Done,
     /* 256806 */   // Label 4961: @256806
     /* 256806 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(256848), // Rule ID 11814 //
     /* 256811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 256819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256835 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1694:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 256838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256846 */     GIR_RootConstrainSelectedInstOperands,
     /* 256847 */     // GIR_Coverage, 11814,
     /* 256847 */     GIR_EraseRootFromParent_Done,
     /* 256848 */   // Label 4962: @256848
     /* 256848 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(256890), // Rule ID 11815 //
     /* 256853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 256861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1695:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 256880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256888 */     GIR_RootConstrainSelectedInstOperands,
     /* 256889 */     // GIR_Coverage, 11815,
     /* 256889 */     GIR_EraseRootFromParent_Done,
     /* 256890 */   // Label 4963: @256890
     /* 256890 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(256932), // Rule ID 11816 //
     /* 256895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 256903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256919 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1695:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 256922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256930 */     GIR_RootConstrainSelectedInstOperands,
     /* 256931 */     // GIR_Coverage, 11816,
     /* 256931 */     GIR_EraseRootFromParent_Done,
     /* 256932 */   // Label 4964: @256932
     /* 256932 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(256974), // Rule ID 11871 //
     /* 256937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 256945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 256948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 256951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256961 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1663:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 256964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256970 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256972 */     GIR_RootConstrainSelectedInstOperands,
     /* 256973 */     // GIR_Coverage, 11871,
     /* 256973 */     GIR_EraseRootFromParent_Done,
     /* 256974 */   // Label 4965: @256974
     /* 256974 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(257016), // Rule ID 11872 //
     /* 256979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 256982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 256987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257003 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1663:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 257003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 257006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257012 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257014 */     GIR_RootConstrainSelectedInstOperands,
     /* 257015 */     // GIR_Coverage, 11872,
     /* 257015 */     GIR_EraseRootFromParent_Done,
     /* 257016 */   // Label 4966: @257016
     /* 257016 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(257058), // Rule ID 11873 //
     /* 257021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 257029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257045 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1663:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 257045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 257048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257054 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257056 */     GIR_RootConstrainSelectedInstOperands,
     /* 257057 */     // GIR_Coverage, 11873,
     /* 257057 */     GIR_EraseRootFromParent_Done,
     /* 257058 */   // Label 4967: @257058
     /* 257058 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(257100), // Rule ID 11874 //
     /* 257063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 257071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 257074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 257077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257087 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1904:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 257087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 257090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257098 */     GIR_RootConstrainSelectedInstOperands,
     /* 257099 */     // GIR_Coverage, 11874,
     /* 257099 */     GIR_EraseRootFromParent_Done,
     /* 257100 */   // Label 4968: @257100
     /* 257100 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(257142), // Rule ID 11875 //
     /* 257105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 257113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257129 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1904:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 257129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 257132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257138 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257140 */     GIR_RootConstrainSelectedInstOperands,
     /* 257141 */     // GIR_Coverage, 11875,
     /* 257141 */     GIR_EraseRootFromParent_Done,
     /* 257142 */   // Label 4969: @257142
     /* 257142 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(257184), // Rule ID 11876 //
     /* 257147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 257155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257171 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1904:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 257171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 257174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257182 */     GIR_RootConstrainSelectedInstOperands,
     /* 257183 */     // GIR_Coverage, 11876,
     /* 257183 */     GIR_EraseRootFromParent_Done,
     /* 257184 */   // Label 4970: @257184
     /* 257184 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(257226), // Rule ID 11877 //
     /* 257189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 257197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 257200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 257203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257213 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1679:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 257213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 257216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257224 */     GIR_RootConstrainSelectedInstOperands,
     /* 257225 */     // GIR_Coverage, 11877,
     /* 257225 */     GIR_EraseRootFromParent_Done,
     /* 257226 */   // Label 4971: @257226
     /* 257226 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(257268), // Rule ID 11878 //
     /* 257231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 257239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257255 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1679:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 257255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 257258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257266 */     GIR_RootConstrainSelectedInstOperands,
     /* 257267 */     // GIR_Coverage, 11878,
     /* 257267 */     GIR_EraseRootFromParent_Done,
     /* 257268 */   // Label 4972: @257268
     /* 257268 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(257310), // Rule ID 11879 //
     /* 257273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 257281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257297 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1679:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 257297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 257300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257308 */     GIR_RootConstrainSelectedInstOperands,
     /* 257309 */     // GIR_Coverage, 11879,
     /* 257309 */     GIR_EraseRootFromParent_Done,
     /* 257310 */   // Label 4973: @257310
     /* 257310 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(257355), // Rule ID 11892 //
     /* 257315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 257318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 257323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 257326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 257329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 257339 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1614:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 257342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 257344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 257353 */     GIR_RootConstrainSelectedInstOperands,
     /* 257354 */     // GIR_Coverage, 11892,
     /* 257354 */     GIR_EraseRootFromParent_Done,
     /* 257355 */   // Label 4974: @257355
     /* 257355 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(257400), // Rule ID 11893 //
     /* 257360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 257363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 257368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 257371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 257384 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1614:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 257384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 257387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 257389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257395 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 257398 */     GIR_RootConstrainSelectedInstOperands,
     /* 257399 */     // GIR_Coverage, 11893,
     /* 257399 */     GIR_EraseRootFromParent_Done,
     /* 257400 */   // Label 4975: @257400
     /* 257400 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(257442), // Rule ID 11894 //
     /* 257405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 257413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 257416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 257419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257429 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1354:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 257432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257438 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257440 */     GIR_RootConstrainSelectedInstOperands,
     /* 257441 */     // GIR_Coverage, 11894,
     /* 257441 */     GIR_EraseRootFromParent_Done,
     /* 257442 */   // Label 4976: @257442
     /* 257442 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(257484), // Rule ID 11895 //
     /* 257447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 257455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1354:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 257471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 257474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257482 */     GIR_RootConstrainSelectedInstOperands,
     /* 257483 */     // GIR_Coverage, 11895,
     /* 257483 */     GIR_EraseRootFromParent_Done,
     /* 257484 */   // Label 4977: @257484
     /* 257484 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(257526), // Rule ID 11896 //
     /* 257489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 257497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257513 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1354:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 257513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 257516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257522 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257524 */     GIR_RootConstrainSelectedInstOperands,
     /* 257525 */     // GIR_Coverage, 11896,
     /* 257525 */     GIR_EraseRootFromParent_Done,
     /* 257526 */   // Label 4978: @257526
     /* 257526 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(257568), // Rule ID 11897 //
     /* 257531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 257539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 257545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257555 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1354:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 257555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 257558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257566 */     GIR_RootConstrainSelectedInstOperands,
     /* 257567 */     // GIR_Coverage, 11897,
     /* 257567 */     GIR_EraseRootFromParent_Done,
     /* 257568 */   // Label 4979: @257568
     /* 257568 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(257610), // Rule ID 11913 //
     /* 257573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 257581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257597 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1437:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 257600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257608 */     GIR_RootConstrainSelectedInstOperands,
     /* 257609 */     // GIR_Coverage, 11913,
     /* 257609 */     GIR_EraseRootFromParent_Done,
     /* 257610 */   // Label 4980: @257610
     /* 257610 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(257652), // Rule ID 11914 //
     /* 257615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 257623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257639 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1437:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 257639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 257642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257650 */     GIR_RootConstrainSelectedInstOperands,
     /* 257651 */     // GIR_Coverage, 11914,
     /* 257651 */     GIR_EraseRootFromParent_Done,
     /* 257652 */   // Label 4981: @257652
     /* 257652 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(257694), // Rule ID 11915 //
     /* 257657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 257665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257681 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1437:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 257684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257692 */     GIR_RootConstrainSelectedInstOperands,
     /* 257693 */     // GIR_Coverage, 11915,
     /* 257693 */     GIR_EraseRootFromParent_Done,
     /* 257694 */   // Label 4982: @257694
     /* 257694 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(257736), // Rule ID 11916 //
     /* 257699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 257707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257723 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1455:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 257726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257734 */     GIR_RootConstrainSelectedInstOperands,
     /* 257735 */     // GIR_Coverage, 11916,
     /* 257735 */     GIR_EraseRootFromParent_Done,
     /* 257736 */   // Label 4983: @257736
     /* 257736 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(257778), // Rule ID 11917 //
     /* 257741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 257749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257765 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1455:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 257765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 257768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257776 */     GIR_RootConstrainSelectedInstOperands,
     /* 257777 */     // GIR_Coverage, 11917,
     /* 257777 */     GIR_EraseRootFromParent_Done,
     /* 257778 */   // Label 4984: @257778
     /* 257778 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(257820), // Rule ID 11918 //
     /* 257783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 257791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257807 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1455:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 257810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257816 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257818 */     GIR_RootConstrainSelectedInstOperands,
     /* 257819 */     // GIR_Coverage, 11918,
     /* 257819 */     GIR_EraseRootFromParent_Done,
     /* 257820 */   // Label 4985: @257820
     /* 257820 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(257862), // Rule ID 11919 //
     /* 257825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 257833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257849 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1440:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 257852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257858 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257860 */     GIR_RootConstrainSelectedInstOperands,
     /* 257861 */     // GIR_Coverage, 11919,
     /* 257861 */     GIR_EraseRootFromParent_Done,
     /* 257862 */   // Label 4986: @257862
     /* 257862 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(257904), // Rule ID 11920 //
     /* 257867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 257875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257891 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1440:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 257891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 257894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257900 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257902 */     GIR_RootConstrainSelectedInstOperands,
     /* 257903 */     // GIR_Coverage, 11920,
     /* 257903 */     GIR_EraseRootFromParent_Done,
     /* 257904 */   // Label 4987: @257904
     /* 257904 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(257946), // Rule ID 11921 //
     /* 257909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 257917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257933 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1440:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 257936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257942 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257944 */     GIR_RootConstrainSelectedInstOperands,
     /* 257945 */     // GIR_Coverage, 11921,
     /* 257945 */     GIR_EraseRootFromParent_Done,
     /* 257946 */   // Label 4988: @257946
     /* 257946 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(257988), // Rule ID 11922 //
     /* 257951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 257959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257975 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1458:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 257978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 257980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257986 */     GIR_RootConstrainSelectedInstOperands,
     /* 257987 */     // GIR_Coverage, 11922,
     /* 257987 */     GIR_EraseRootFromParent_Done,
     /* 257988 */   // Label 4989: @257988
     /* 257988 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(258030), // Rule ID 11923 //
     /* 257993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 257996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 258001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258017 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1458:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 258017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 258020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258028 */     GIR_RootConstrainSelectedInstOperands,
     /* 258029 */     // GIR_Coverage, 11923,
     /* 258029 */     GIR_EraseRootFromParent_Done,
     /* 258030 */   // Label 4990: @258030
     /* 258030 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(258072), // Rule ID 11924 //
     /* 258035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 258043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 258049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258059 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1458:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 258059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 258062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258070 */     GIR_RootConstrainSelectedInstOperands,
     /* 258071 */     // GIR_Coverage, 11924,
     /* 258071 */     GIR_EraseRootFromParent_Done,
     /* 258072 */   // Label 4991: @258072
     /* 258072 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(258114), // Rule ID 11929 //
     /* 258077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 258085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258101 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1464:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 258101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 258104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258112 */     GIR_RootConstrainSelectedInstOperands,
     /* 258113 */     // GIR_Coverage, 11929,
     /* 258113 */     GIR_EraseRootFromParent_Done,
     /* 258114 */   // Label 4992: @258114
     /* 258114 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(258156), // Rule ID 11930 //
     /* 258119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 258127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258143 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1466:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 258143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 258146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258154 */     GIR_RootConstrainSelectedInstOperands,
     /* 258155 */     // GIR_Coverage, 11930,
     /* 258155 */     GIR_EraseRootFromParent_Done,
     /* 258156 */   // Label 4993: @258156
     /* 258156 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(258198), // Rule ID 11931 //
     /* 258161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 258169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258185 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1471:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 258185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 258188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258196 */     GIR_RootConstrainSelectedInstOperands,
     /* 258197 */     // GIR_Coverage, 11931,
     /* 258197 */     GIR_EraseRootFromParent_Done,
     /* 258198 */   // Label 4994: @258198
     /* 258198 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(258240), // Rule ID 11932 //
     /* 258203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 258211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258227 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 258227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 258230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258238 */     GIR_RootConstrainSelectedInstOperands,
     /* 258239 */     // GIR_Coverage, 11932,
     /* 258239 */     GIR_EraseRootFromParent_Done,
     /* 258240 */   // Label 4995: @258240
     /* 258240 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(258282), // Rule ID 11933 //
     /* 258245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 258253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 258256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 258259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258269 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1271:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 258269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 258272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258280 */     GIR_RootConstrainSelectedInstOperands,
     /* 258281 */     // GIR_Coverage, 11933,
     /* 258281 */     GIR_EraseRootFromParent_Done,
     /* 258282 */   // Label 4996: @258282
     /* 258282 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(258324), // Rule ID 11935 //
     /* 258287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 258295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258311 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1271:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 258311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 258314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258322 */     GIR_RootConstrainSelectedInstOperands,
     /* 258323 */     // GIR_Coverage, 11935,
     /* 258323 */     GIR_EraseRootFromParent_Done,
     /* 258324 */   // Label 4997: @258324
     /* 258324 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(258366), // Rule ID 11937 //
     /* 258329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 258337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258353 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1271:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 258353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 258356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258364 */     GIR_RootConstrainSelectedInstOperands,
     /* 258365 */     // GIR_Coverage, 11937,
     /* 258365 */     GIR_EraseRootFromParent_Done,
     /* 258366 */   // Label 4998: @258366
     /* 258366 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(258408), // Rule ID 11939 //
     /* 258371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 258374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 258379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258395 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1271:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 258395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 258398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258406 */     GIR_RootConstrainSelectedInstOperands,
     /* 258407 */     // GIR_Coverage, 11939,
     /* 258407 */     GIR_EraseRootFromParent_Done,
     /* 258408 */   // Label 4999: @258408
     /* 258408 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(258450), // Rule ID 12064 //
     /* 258413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 258416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 258421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 258424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 258427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258437 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1943:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 258437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 258440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258448 */     GIR_RootConstrainSelectedInstOperands,
     /* 258449 */     // GIR_Coverage, 12064,
     /* 258449 */     GIR_EraseRootFromParent_Done,
     /* 258450 */   // Label 5000: @258450
     /* 258450 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(258492), // Rule ID 12066 //
     /* 258455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 258458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 258463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258479 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1943:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 258479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 258482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258490 */     GIR_RootConstrainSelectedInstOperands,
     /* 258491 */     // GIR_Coverage, 12066,
     /* 258491 */     GIR_EraseRootFromParent_Done,
     /* 258492 */   // Label 5001: @258492
     /* 258492 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(258534), // Rule ID 12068 //
     /* 258497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 258500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 258505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258521 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 258521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 258524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258532 */     GIR_RootConstrainSelectedInstOperands,
     /* 258533 */     // GIR_Coverage, 12068,
     /* 258533 */     GIR_EraseRootFromParent_Done,
     /* 258534 */   // Label 5002: @258534
     /* 258534 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(258576), // Rule ID 12070 //
     /* 258539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 258542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 258547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258563 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 258563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 258566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258574 */     GIR_RootConstrainSelectedInstOperands,
     /* 258575 */     // GIR_Coverage, 12070,
     /* 258575 */     GIR_EraseRootFromParent_Done,
     /* 258576 */   // Label 5003: @258576
     /* 258576 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(258618), // Rule ID 12072 //
     /* 258581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 258584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 258589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258605 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1421:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 258605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 258608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258616 */     GIR_RootConstrainSelectedInstOperands,
     /* 258617 */     // GIR_Coverage, 12072,
     /* 258617 */     GIR_EraseRootFromParent_Done,
     /* 258618 */   // Label 5004: @258618
     /* 258618 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(258660), // Rule ID 12074 //
     /* 258623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 258626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 258631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258647 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1959:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 258647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 258650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258658 */     GIR_RootConstrainSelectedInstOperands,
     /* 258659 */     // GIR_Coverage, 12074,
     /* 258659 */     GIR_EraseRootFromParent_Done,
     /* 258660 */   // Label 5005: @258660
     /* 258660 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(258702), // Rule ID 12237 //
     /* 258665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 258668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 258673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 258676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 258679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258689 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1919:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 258689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 258692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258700 */     GIR_RootConstrainSelectedInstOperands,
     /* 258701 */     // GIR_Coverage, 12237,
     /* 258701 */     GIR_EraseRootFromParent_Done,
     /* 258702 */   // Label 5006: @258702
     /* 258702 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(258744), // Rule ID 12238 //
     /* 258707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 258710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 258715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1919:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 258731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 258734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258742 */     GIR_RootConstrainSelectedInstOperands,
     /* 258743 */     // GIR_Coverage, 12238,
     /* 258743 */     GIR_EraseRootFromParent_Done,
     /* 258744 */   // Label 5007: @258744
     /* 258744 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(258786), // Rule ID 12239 //
     /* 258749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 258752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 258757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1919:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 258773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 258776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258784 */     GIR_RootConstrainSelectedInstOperands,
     /* 258785 */     // GIR_Coverage, 12239,
     /* 258785 */     GIR_EraseRootFromParent_Done,
     /* 258786 */   // Label 5008: @258786
     /* 258786 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(258828), // Rule ID 12240 //
     /* 258791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 258794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 258799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258815 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1919:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 258815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 258818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258826 */     GIR_RootConstrainSelectedInstOperands,
     /* 258827 */     // GIR_Coverage, 12240,
     /* 258827 */     GIR_EraseRootFromParent_Done,
     /* 258828 */   // Label 5009: @258828
     /* 258828 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(258870), // Rule ID 12241 //
     /* 258833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 258836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 258841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 258847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258857 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1919:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 258857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 258860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258868 */     GIR_RootConstrainSelectedInstOperands,
     /* 258869 */     // GIR_Coverage, 12241,
     /* 258869 */     GIR_EraseRootFromParent_Done,
     /* 258870 */   // Label 5010: @258870
     /* 258870 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(258912), // Rule ID 12242 //
     /* 258875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 258878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 258883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258899 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1919:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 258899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 258902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258910 */     GIR_RootConstrainSelectedInstOperands,
     /* 258911 */     // GIR_Coverage, 12242,
     /* 258911 */     GIR_EraseRootFromParent_Done,
     /* 258912 */   // Label 5011: @258912
     /* 258912 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(258954), // Rule ID 12243 //
     /* 258917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 258920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 258925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 258931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258941 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1919:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 258941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 258944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258952 */     GIR_RootConstrainSelectedInstOperands,
     /* 258953 */     // GIR_Coverage, 12243,
     /* 258953 */     GIR_EraseRootFromParent_Done,
     /* 258954 */   // Label 5012: @258954
     /* 258954 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(258996), // Rule ID 12588 //
     /* 258959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 258962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 258967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258983 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1371:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 258983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 258986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 258988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258994 */     GIR_RootConstrainSelectedInstOperands,
     /* 258995 */     // GIR_Coverage, 12588,
     /* 258995 */     GIR_EraseRootFromParent_Done,
     /* 258996 */   // Label 5013: @258996
     /* 258996 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(259038), // Rule ID 12589 //
     /* 259001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 259009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259025 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1371:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 259025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 259028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 259030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259036 */     GIR_RootConstrainSelectedInstOperands,
     /* 259037 */     // GIR_Coverage, 12589,
     /* 259037 */     GIR_EraseRootFromParent_Done,
     /* 259038 */   // Label 5014: @259038
     /* 259038 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(259080), // Rule ID 12590 //
     /* 259043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 259051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259067 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1371:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 259067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 259070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 259072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259078 */     GIR_RootConstrainSelectedInstOperands,
     /* 259079 */     // GIR_Coverage, 12590,
     /* 259079 */     GIR_EraseRootFromParent_Done,
     /* 259080 */   // Label 5015: @259080
     /* 259080 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(259122), // Rule ID 12591 //
     /* 259085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 259093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259109 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1369:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 259109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 259112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 259114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259120 */     GIR_RootConstrainSelectedInstOperands,
     /* 259121 */     // GIR_Coverage, 12591,
     /* 259121 */     GIR_EraseRootFromParent_Done,
     /* 259122 */   // Label 5016: @259122
     /* 259122 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(259164), // Rule ID 12592 //
     /* 259127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 259135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259151 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1369:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 259151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 259154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 259156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259162 */     GIR_RootConstrainSelectedInstOperands,
     /* 259163 */     // GIR_Coverage, 12592,
     /* 259163 */     GIR_EraseRootFromParent_Done,
     /* 259164 */   // Label 5017: @259164
     /* 259164 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(259206), // Rule ID 12593 //
     /* 259169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 259177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259193 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 259193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 259196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 259198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259204 */     GIR_RootConstrainSelectedInstOperands,
     /* 259205 */     // GIR_Coverage, 12593,
     /* 259205 */     GIR_EraseRootFromParent_Done,
     /* 259206 */   // Label 5018: @259206
     /* 259206 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(259248), // Rule ID 12594 //
     /* 259211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 259219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259235 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1370:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 259235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 259238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259246 */     GIR_RootConstrainSelectedInstOperands,
     /* 259247 */     // GIR_Coverage, 12594,
     /* 259247 */     GIR_EraseRootFromParent_Done,
     /* 259248 */   // Label 5019: @259248
     /* 259248 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(259290), // Rule ID 12597 //
     /* 259253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 259261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 259264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 259270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 259273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259277 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1370:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 259277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 259280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259288 */     GIR_RootConstrainSelectedInstOperands,
     /* 259289 */     // GIR_Coverage, 12597,
     /* 259289 */     GIR_EraseRootFromParent_Done,
     /* 259290 */   // Label 5020: @259290
     /* 259290 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(259332), // Rule ID 12600 //
     /* 259295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 259303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 259306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 259312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 259315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259319 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 259319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 259322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259330 */     GIR_RootConstrainSelectedInstOperands,
     /* 259331 */     // GIR_Coverage, 12600,
     /* 259331 */     GIR_EraseRootFromParent_Done,
     /* 259332 */   // Label 5021: @259332
     /* 259332 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(259374), // Rule ID 12603 //
     /* 259337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 259345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259361 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 259361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 259364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259372 */     GIR_RootConstrainSelectedInstOperands,
     /* 259373 */     // GIR_Coverage, 12603,
     /* 259373 */     GIR_EraseRootFromParent_Done,
     /* 259374 */   // Label 5022: @259374
     /* 259374 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(259416), // Rule ID 12606 //
     /* 259379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 259387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 259390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 259396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 259399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259403 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 259403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 259406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259414 */     GIR_RootConstrainSelectedInstOperands,
     /* 259415 */     // GIR_Coverage, 12606,
     /* 259415 */     GIR_EraseRootFromParent_Done,
     /* 259416 */   // Label 5023: @259416
     /* 259416 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(259458), // Rule ID 12609 //
     /* 259421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 259429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259445 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 259445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 259448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259456 */     GIR_RootConstrainSelectedInstOperands,
     /* 259457 */     // GIR_Coverage, 12609,
     /* 259457 */     GIR_EraseRootFromParent_Done,
     /* 259458 */   // Label 5024: @259458
     /* 259458 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(259500), // Rule ID 12612 //
     /* 259463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 259471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259487 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1372:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 259487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 259490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259498 */     GIR_RootConstrainSelectedInstOperands,
     /* 259499 */     // GIR_Coverage, 12612,
     /* 259499 */     GIR_EraseRootFromParent_Done,
     /* 259500 */   // Label 5025: @259500
     /* 259500 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(259542), // Rule ID 12615 //
     /* 259505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 259513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 259516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 259522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 259525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259529 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1372:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 259529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 259532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259540 */     GIR_RootConstrainSelectedInstOperands,
     /* 259541 */     // GIR_Coverage, 12615,
     /* 259541 */     GIR_EraseRootFromParent_Done,
     /* 259542 */   // Label 5026: @259542
     /* 259542 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(259584), // Rule ID 12618 //
     /* 259547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 259555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 259558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 259564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 259567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259571 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 259571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 259574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259582 */     GIR_RootConstrainSelectedInstOperands,
     /* 259583 */     // GIR_Coverage, 12618,
     /* 259583 */     GIR_EraseRootFromParent_Done,
     /* 259584 */   // Label 5027: @259584
     /* 259584 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(259626), // Rule ID 12621 //
     /* 259589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 259597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259613 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1372:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 259613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 259616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259624 */     GIR_RootConstrainSelectedInstOperands,
     /* 259625 */     // GIR_Coverage, 12621,
     /* 259625 */     GIR_EraseRootFromParent_Done,
     /* 259626 */   // Label 5028: @259626
     /* 259626 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(259668), // Rule ID 12624 //
     /* 259631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 259639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 259642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 259648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 259651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259655 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 259655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 259658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259666 */     GIR_RootConstrainSelectedInstOperands,
     /* 259667 */     // GIR_Coverage, 12624,
     /* 259667 */     GIR_EraseRootFromParent_Done,
     /* 259668 */   // Label 5029: @259668
     /* 259668 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(259710), // Rule ID 12627 //
     /* 259673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 259676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 259681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259697 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1372:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 259697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 259700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 259702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259708 */     GIR_RootConstrainSelectedInstOperands,
     /* 259709 */     // GIR_Coverage, 12627,
     /* 259709 */     GIR_EraseRootFromParent_Done,
     /* 259710 */   // Label 5030: @259710
     /* 259710 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(259853), // Rule ID 5624 //
     /* 259715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 259718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 259723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 259726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 259729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 259732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259736 */     // MIs[0] idx
     /* 259736 */     // No operand predicates
     /* 259736 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 259736 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 259739 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259743 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 259750 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 259753 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259757 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259762 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 259765 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 259769 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 259772 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259777 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259782 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259787 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 259790 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259794 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 259804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259813 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 259816 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 259820 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 259823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 259841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 259849 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 259851 */     GIR_RootConstrainSelectedInstOperands,
     /* 259852 */     // GIR_Coverage, 5624,
     /* 259852 */     GIR_EraseRootFromParent_Done,
     /* 259853 */   // Label 5031: @259853
     /* 259853 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(259944), // Rule ID 5625 //
     /* 259858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 259861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 259866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 259869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 259872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 259875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259879 */     // MIs[0] idx
     /* 259879 */     // No operand predicates
     /* 259879 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 259879 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 259882 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259886 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 259896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259905 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 259908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 259912 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 259915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 259930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 259933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 259935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 259938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 259940 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 259942 */     GIR_RootConstrainSelectedInstOperands,
     /* 259943 */     // GIR_Coverage, 5625,
     /* 259943 */     GIR_EraseRootFromParent_Done,
     /* 259944 */   // Label 5032: @259944
     /* 259944 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(260035), // Rule ID 5626 //
     /* 259949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 259952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 259957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 259960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 259963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 259966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259970 */     // MIs[0] idx
     /* 259970 */     // No operand predicates
     /* 259970 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 259970 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 259973 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 259977 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 259984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 259987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 259991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 259996 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 259999 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 260003 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 260006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260016 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 260024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 260028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260031 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260033 */     GIR_RootConstrainSelectedInstOperands,
     /* 260034 */     // GIR_Coverage, 5626,
     /* 260034 */     GIR_EraseRootFromParent_Done,
     /* 260035 */   // Label 5033: @260035
     /* 260035 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(260074), // Rule ID 5627 //
     /* 260040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 260048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 260051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 260054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260061 */     // MIs[0] idx
     /* 260061 */     // No operand predicates
     /* 260061 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 260064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 260068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 260070 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260072 */     GIR_RootConstrainSelectedInstOperands,
     /* 260073 */     // GIR_Coverage, 5627,
     /* 260073 */     GIR_EraseRootFromParent_Done,
     /* 260074 */   // Label 5034: @260074
     /* 260074 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(260217), // Rule ID 5628 //
     /* 260079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 260087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 260093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 260096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260100 */     // MIs[0] idx
     /* 260100 */     // No operand predicates
     /* 260100 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260100 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 260103 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260107 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260114 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 260117 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260121 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260126 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 260129 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 260133 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 260136 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260141 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260146 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260151 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 260154 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260158 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 260165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 260168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260177 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 260180 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 260184 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 260187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 260205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 260213 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260215 */     GIR_RootConstrainSelectedInstOperands,
     /* 260216 */     // GIR_Coverage, 5628,
     /* 260216 */     GIR_EraseRootFromParent_Done,
     /* 260217 */   // Label 5035: @260217
     /* 260217 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(260308), // Rule ID 5629 //
     /* 260222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 260230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 260236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260243 */     // MIs[0] idx
     /* 260243 */     // No operand predicates
     /* 260243 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260243 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 260246 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260250 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 260257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 260260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260269 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 260272 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 260276 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 260279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 260297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 260304 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260306 */     GIR_RootConstrainSelectedInstOperands,
     /* 260307 */     // GIR_Coverage, 5629,
     /* 260307 */     GIR_EraseRootFromParent_Done,
     /* 260308 */   // Label 5036: @260308
     /* 260308 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(260399), // Rule ID 5630 //
     /* 260313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 260321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 260330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260334 */     // MIs[0] idx
     /* 260334 */     // No operand predicates
     /* 260334 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260334 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 260337 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260341 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 260348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 260351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260360 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 260363 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 260367 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 260370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 260388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 260392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260395 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260397 */     GIR_RootConstrainSelectedInstOperands,
     /* 260398 */     // GIR_Coverage, 5630,
     /* 260398 */     GIR_EraseRootFromParent_Done,
     /* 260399 */   // Label 5037: @260399
     /* 260399 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(260438), // Rule ID 5631 //
     /* 260404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 260412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260425 */     // MIs[0] idx
     /* 260425 */     // No operand predicates
     /* 260425 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 260428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 260432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 260434 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260436 */     GIR_RootConstrainSelectedInstOperands,
     /* 260437 */     // GIR_Coverage, 5631,
     /* 260437 */     GIR_EraseRootFromParent_Done,
     /* 260438 */   // Label 5038: @260438
     /* 260438 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(260581), // Rule ID 5632 //
     /* 260443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 260451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 260457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 260460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260464 */     // MIs[0] idx
     /* 260464 */     // No operand predicates
     /* 260464 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260464 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 260467 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260471 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 260478 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 260481 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260485 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260490 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 260493 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 260497 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 260500 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260505 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260510 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260515 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 260518 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260522 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 260529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 260532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260541 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 260544 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 260548 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 260551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 260569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 260577 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260579 */     GIR_RootConstrainSelectedInstOperands,
     /* 260580 */     // GIR_Coverage, 5632,
     /* 260580 */     GIR_EraseRootFromParent_Done,
     /* 260581 */   // Label 5039: @260581
     /* 260581 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(260672), // Rule ID 5633 //
     /* 260586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 260594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 260600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260607 */     // MIs[0] idx
     /* 260607 */     // No operand predicates
     /* 260607 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260607 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 260610 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260614 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 260621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 260624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260633 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 260636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 260640 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 260643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 260661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 260668 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260670 */     GIR_RootConstrainSelectedInstOperands,
     /* 260671 */     // GIR_Coverage, 5633,
     /* 260671 */     GIR_EraseRootFromParent_Done,
     /* 260672 */   // Label 5040: @260672
     /* 260672 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(260763), // Rule ID 5634 //
     /* 260677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 260685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 260694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260698 */     // MIs[0] idx
     /* 260698 */     // No operand predicates
     /* 260698 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260698 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 260701 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260705 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 260712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 260715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260724 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 260727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 260731 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 260734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 260752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 260756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260759 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260761 */     GIR_RootConstrainSelectedInstOperands,
     /* 260762 */     // GIR_Coverage, 5634,
     /* 260762 */     GIR_EraseRootFromParent_Done,
     /* 260763 */   // Label 5041: @260763
     /* 260763 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(260802), // Rule ID 5635 //
     /* 260768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 260776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 260779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 260782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260789 */     // MIs[0] idx
     /* 260789 */     // No operand predicates
     /* 260789 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 260792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 260796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 260798 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260800 */     GIR_RootConstrainSelectedInstOperands,
     /* 260801 */     // GIR_Coverage, 5635,
     /* 260801 */     GIR_EraseRootFromParent_Done,
     /* 260802 */   // Label 5042: @260802
     /* 260802 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(260841), // Rule ID 5636 //
     /* 260807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 260815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 260818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 260821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 260824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260828 */     // MIs[0] idx
     /* 260828 */     // No operand predicates
     /* 260828 */     // (intrinsic_wo_chain:{ *:[v16i8] } 772:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 260828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 260831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 260835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 260837 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260839 */     GIR_RootConstrainSelectedInstOperands,
     /* 260840 */     // GIR_Coverage, 5636,
     /* 260840 */     GIR_EraseRootFromParent_Done,
     /* 260841 */   // Label 5043: @260841
     /* 260841 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(260932), // Rule ID 5637 //
     /* 260846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 260849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 260854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 260857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 260860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 260863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260867 */     // MIs[0] idx
     /* 260867 */     // No operand predicates
     /* 260867 */     // (intrinsic_wo_chain:{ *:[v16i8] } 770:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 260867 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 260870 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 260874 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 260881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 260884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 260888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 260893 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 260896 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 260900 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 260903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 260913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 260918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 260921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 260923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 260925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 260928 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 260930 */     GIR_RootConstrainSelectedInstOperands,
     /* 260931 */     // GIR_Coverage, 5637,
     /* 260931 */     GIR_EraseRootFromParent_Done,
     /* 260932 */   // Label 5044: @260932
     /* 260932 */   GIM_Reject,
     /* 260933 */ // Label 4184: @260933
     /* 260933 */ GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(268044),
     /* 260938 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 260941 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(260988), // Rule ID 2965 //
     /* 260946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 260954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 260957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 260960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 260969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260973 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1603:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 260973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 260976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 260978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260984 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260986 */     GIR_RootConstrainSelectedInstOperands,
     /* 260987 */     // GIR_Coverage, 2965,
     /* 260987 */     GIR_EraseRootFromParent_Done,
     /* 260988 */   // Label 5046: @260988
     /* 260988 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(261035), // Rule ID 2967 //
     /* 260993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 261001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1603:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 261020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 261023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 261025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261031 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261033 */     GIR_RootConstrainSelectedInstOperands,
     /* 261034 */     // GIR_Coverage, 2967,
     /* 261034 */     GIR_EraseRootFromParent_Done,
     /* 261035 */   // Label 5047: @261035
     /* 261035 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(261082), // Rule ID 2969 //
     /* 261040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 261048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261067 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1603:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 261067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 261070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 261072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261078 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261080 */     GIR_RootConstrainSelectedInstOperands,
     /* 261081 */     // GIR_Coverage, 2969,
     /* 261081 */     GIR_EraseRootFromParent_Done,
     /* 261082 */   // Label 5048: @261082
     /* 261082 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(261129), // Rule ID 2971 //
     /* 261087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 261095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 261110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261114 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1603:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 261114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 261117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 261119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261125 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261127 */     GIR_RootConstrainSelectedInstOperands,
     /* 261128 */     // GIR_Coverage, 2971,
     /* 261128 */     GIR_EraseRootFromParent_Done,
     /* 261129 */   // Label 5049: @261129
     /* 261129 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(261176), // Rule ID 7650 //
     /* 261134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 261142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 261145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 261148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 261157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261161 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1606:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 261161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 261164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 261166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261172 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261174 */     GIR_RootConstrainSelectedInstOperands,
     /* 261175 */     // GIR_Coverage, 7650,
     /* 261175 */     GIR_EraseRootFromParent_Done,
     /* 261176 */   // Label 5050: @261176
     /* 261176 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(261223), // Rule ID 7652 //
     /* 261181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 261189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 261195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 261204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261208 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1606:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 261208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 261211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 261213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261219 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261221 */     GIR_RootConstrainSelectedInstOperands,
     /* 261222 */     // GIR_Coverage, 7652,
     /* 261222 */     GIR_EraseRootFromParent_Done,
     /* 261223 */   // Label 5051: @261223
     /* 261223 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(261270), // Rule ID 7654 //
     /* 261228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 261236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 261242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 261251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261255 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1606:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 261255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 261258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 261260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261266 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261268 */     GIR_RootConstrainSelectedInstOperands,
     /* 261269 */     // GIR_Coverage, 7654,
     /* 261269 */     GIR_EraseRootFromParent_Done,
     /* 261270 */   // Label 5052: @261270
     /* 261270 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(261317), // Rule ID 7656 //
     /* 261275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 261283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 261289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 261292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 261295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 261298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1606:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 261302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 261305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 261307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261313 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261315 */     GIR_RootConstrainSelectedInstOperands,
     /* 261316 */     // GIR_Coverage, 7656,
     /* 261316 */     GIR_EraseRootFromParent_Done,
     /* 261317 */   // Label 5053: @261317
     /* 261317 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(261397), // Rule ID 5744 //
     /* 261322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 261327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 261330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 261333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 261336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 261339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 261342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 261354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 261362 */     // MIs[1] Operand 1
     /* 261362 */     // No operand predicates
     /* 261362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 261370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261374 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 261378 */     // MIs[2] Operand 1
     /* 261378 */     // No operand predicates
     /* 261378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261380 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 261380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 261383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 261387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 261390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 261392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 261395 */     GIR_RootConstrainSelectedInstOperands,
     /* 261396 */     // GIR_Coverage, 5744,
     /* 261396 */     GIR_EraseRootFromParent_Done,
     /* 261397 */   // Label 5054: @261397
     /* 261397 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(261477), // Rule ID 5745 //
     /* 261402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 261407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 261410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 261413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 261416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 261419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 261422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 261434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 261442 */     // MIs[1] Operand 1
     /* 261442 */     // No operand predicates
     /* 261442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 261450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261454 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 261458 */     // MIs[2] Operand 1
     /* 261458 */     // No operand predicates
     /* 261458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261460 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 261460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 261463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 261467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 261470 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 261472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 261475 */     GIR_RootConstrainSelectedInstOperands,
     /* 261476 */     // GIR_Coverage, 5745,
     /* 261476 */     GIR_EraseRootFromParent_Done,
     /* 261477 */   // Label 5055: @261477
     /* 261477 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(261557), // Rule ID 5746 //
     /* 261482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 261487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 261496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 261502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 261514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261518 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 261522 */     // MIs[1] Operand 1
     /* 261522 */     // No operand predicates
     /* 261522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 261530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261534 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 261538 */     // MIs[2] Operand 1
     /* 261538 */     // No operand predicates
     /* 261538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261540 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 261540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 261543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 261547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 261550 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 261552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 261555 */     GIR_RootConstrainSelectedInstOperands,
     /* 261556 */     // GIR_Coverage, 5746,
     /* 261556 */     GIR_EraseRootFromParent_Done,
     /* 261557 */   // Label 5056: @261557
     /* 261557 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(261637), // Rule ID 5747 //
     /* 261562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 261567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 261570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 261573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 261576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 261579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 261582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 261594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 261602 */     // MIs[1] Operand 1
     /* 261602 */     // No operand predicates
     /* 261602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 261610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261614 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 261618 */     // MIs[2] Operand 1
     /* 261618 */     // No operand predicates
     /* 261618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261620 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 261620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 261623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 261627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 261630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 261632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 261635 */     GIR_RootConstrainSelectedInstOperands,
     /* 261636 */     // GIR_Coverage, 5747,
     /* 261636 */     GIR_EraseRootFromParent_Done,
     /* 261637 */   // Label 5057: @261637
     /* 261637 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(261701), // Rule ID 3849 //
     /* 261642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 261645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 261650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 261659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261678 */     // MIs[0] imm
     /* 261678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 261686 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 261686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 261689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 261691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 261693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 261695 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 261697 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 261699 */     GIR_RootConstrainSelectedInstOperands,
     /* 261700 */     // GIR_Coverage, 3849,
     /* 261700 */     GIR_EraseRootFromParent_Done,
     /* 261701 */   // Label 5058: @261701
     /* 261701 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(261765), // Rule ID 3850 //
     /* 261706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 261709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 261714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 261723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261742 */     // MIs[0] imm
     /* 261742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261745 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 261750 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 261750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 261753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 261755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 261757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 261759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 261761 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 261763 */     GIR_RootConstrainSelectedInstOperands,
     /* 261764 */     // GIR_Coverage, 3850,
     /* 261764 */     GIR_EraseRootFromParent_Done,
     /* 261765 */   // Label 5059: @261765
     /* 261765 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(261829), // Rule ID 3851 //
     /* 261770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 261773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 261778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 261787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261806 */     // MIs[0] imm
     /* 261806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 261814 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 261814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 261817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 261819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 261821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 261823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 261825 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 261827 */     GIR_RootConstrainSelectedInstOperands,
     /* 261828 */     // GIR_Coverage, 3851,
     /* 261828 */     GIR_EraseRootFromParent_Done,
     /* 261829 */   // Label 5060: @261829
     /* 261829 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(261893), // Rule ID 3852 //
     /* 261834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 261837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 261842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 261845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 261851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 261854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261870 */     // MIs[0] imm
     /* 261870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261873 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 261878 */     // (intrinsic_wo_chain:{ *:[v4i32] } 540:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 261878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 261881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 261883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 261885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 261887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 261889 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 261891 */     GIR_RootConstrainSelectedInstOperands,
     /* 261892 */     // GIR_Coverage, 3852,
     /* 261892 */     GIR_EraseRootFromParent_Done,
     /* 261893 */   // Label 5061: @261893
     /* 261893 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(261945), // Rule ID 2850 //
     /* 261898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 261906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 261909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 261912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261922 */     // MIs[0] idx
     /* 261922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261925 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261930 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1462:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 261930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 261933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261941 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 261943 */     GIR_RootConstrainSelectedInstOperands,
     /* 261944 */     // GIR_Coverage, 2850,
     /* 261944 */     GIR_EraseRootFromParent_Done,
     /* 261945 */   // Label 5062: @261945
     /* 261945 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(261997), // Rule ID 2851 //
     /* 261950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 261953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 261958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261974 */     // MIs[0] idx
     /* 261974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261977 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261982 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1462:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 261982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 261985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261993 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 261995 */     GIR_RootConstrainSelectedInstOperands,
     /* 261996 */     // GIR_Coverage, 2851,
     /* 261996 */     GIR_EraseRootFromParent_Done,
     /* 261997 */   // Label 5063: @261997
     /* 261997 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(262049), // Rule ID 2852 //
     /* 262002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 262010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262026 */     // MIs[0] idx
     /* 262026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262029 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 262034 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1462:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 262034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 262037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262043 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262045 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 262047 */     GIR_RootConstrainSelectedInstOperands,
     /* 262048 */     // GIR_Coverage, 2852,
     /* 262048 */     GIR_EraseRootFromParent_Done,
     /* 262049 */   // Label 5064: @262049
     /* 262049 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(262101), // Rule ID 2980 //
     /* 262054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 262062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 262068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262078 */     // MIs[0] Op4
     /* 262078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262081 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262086 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 262089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262095 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262097 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262099 */     GIR_RootConstrainSelectedInstOperands,
     /* 262100 */     // GIR_Coverage, 2980,
     /* 262100 */     GIR_EraseRootFromParent_Done,
     /* 262101 */   // Label 5065: @262101
     /* 262101 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(262153), // Rule ID 2981 //
     /* 262106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 262114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262130 */     // MIs[0] Op4
     /* 262130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262138 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 262141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262149 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262151 */     GIR_RootConstrainSelectedInstOperands,
     /* 262152 */     // GIR_Coverage, 2981,
     /* 262152 */     GIR_EraseRootFromParent_Done,
     /* 262153 */   // Label 5066: @262153
     /* 262153 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(262205), // Rule ID 2982 //
     /* 262158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 262166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262182 */     // MIs[0] Op4
     /* 262182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262185 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 262190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1602:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 262190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 262193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262201 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262203 */     GIR_RootConstrainSelectedInstOperands,
     /* 262204 */     // GIR_Coverage, 2982,
     /* 262204 */     GIR_EraseRootFromParent_Done,
     /* 262205 */   // Label 5067: @262205
     /* 262205 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(262257), // Rule ID 2983 //
     /* 262210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 262218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262234 */     // MIs[0] Op4
     /* 262234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262237 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1744:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 262245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262253 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262255 */     GIR_RootConstrainSelectedInstOperands,
     /* 262256 */     // GIR_Coverage, 2983,
     /* 262256 */     GIR_EraseRootFromParent_Done,
     /* 262257 */   // Label 5068: @262257
     /* 262257 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(262309), // Rule ID 2984 //
     /* 262262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 262270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262286 */     // MIs[0] Op4
     /* 262286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262294 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1744:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 262297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262303 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262305 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262307 */     GIR_RootConstrainSelectedInstOperands,
     /* 262308 */     // GIR_Coverage, 2984,
     /* 262308 */     GIR_EraseRootFromParent_Done,
     /* 262309 */   // Label 5069: @262309
     /* 262309 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(262361), // Rule ID 2987 //
     /* 262314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 262322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262338 */     // MIs[0] Op4
     /* 262338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262341 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262346 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1710:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 262349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262355 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262357 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262359 */     GIR_RootConstrainSelectedInstOperands,
     /* 262360 */     // GIR_Coverage, 2987,
     /* 262360 */     GIR_EraseRootFromParent_Done,
     /* 262361 */   // Label 5070: @262361
     /* 262361 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(262413), // Rule ID 2988 //
     /* 262366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 262374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262390 */     // MIs[0] Op4
     /* 262390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262393 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 262398 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1710:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 262398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 262401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262407 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262409 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262411 */     GIR_RootConstrainSelectedInstOperands,
     /* 262412 */     // GIR_Coverage, 2988,
     /* 262412 */     GIR_EraseRootFromParent_Done,
     /* 262413 */   // Label 5071: @262413
     /* 262413 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(262465), // Rule ID 3462 //
     /* 262418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 262421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 262426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262442 */     // MIs[0] Op4
     /* 262442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262445 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262450 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2057:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 262453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262461 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262463 */     GIR_RootConstrainSelectedInstOperands,
     /* 262464 */     // GIR_Coverage, 3462,
     /* 262464 */     GIR_EraseRootFromParent_Done,
     /* 262465 */   // Label 5072: @262465
     /* 262465 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(262517), // Rule ID 3506 //
     /* 262470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 262473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 262478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262494 */     // MIs[0] Op4
     /* 262494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262497 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1711:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 262505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262513 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262515 */     GIR_RootConstrainSelectedInstOperands,
     /* 262516 */     // GIR_Coverage, 3506,
     /* 262516 */     GIR_EraseRootFromParent_Done,
     /* 262517 */   // Label 5073: @262517
     /* 262517 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(262569), // Rule ID 7724 //
     /* 262522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 262530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262546 */     // MIs[0] Op4
     /* 262546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262549 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262554 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1957:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 262557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262563 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262565 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262567 */     GIR_RootConstrainSelectedInstOperands,
     /* 262568 */     // GIR_Coverage, 7724,
     /* 262568 */     GIR_EraseRootFromParent_Done,
     /* 262569 */   // Label 5074: @262569
     /* 262569 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(262621), // Rule ID 7725 //
     /* 262574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 262582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262598 */     // MIs[0] Op4
     /* 262598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262601 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 262606 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1957:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 262606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 262609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262617 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262619 */     GIR_RootConstrainSelectedInstOperands,
     /* 262620 */     // GIR_Coverage, 7725,
     /* 262620 */     GIR_EraseRootFromParent_Done,
     /* 262621 */   // Label 5075: @262621
     /* 262621 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(262673), // Rule ID 8365 //
     /* 262626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 262634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 262640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262650 */     // MIs[0] idx
     /* 262650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262653 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262658 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1469:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 262658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 262661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262667 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262669 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 262671 */     GIR_RootConstrainSelectedInstOperands,
     /* 262672 */     // GIR_Coverage, 8365,
     /* 262672 */     GIR_EraseRootFromParent_Done,
     /* 262673 */   // Label 5076: @262673
     /* 262673 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(262725), // Rule ID 8366 //
     /* 262678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 262686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262702 */     // MIs[0] idx
     /* 262702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262705 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262710 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1469:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 262710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 262713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262721 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 262723 */     GIR_RootConstrainSelectedInstOperands,
     /* 262724 */     // GIR_Coverage, 8366,
     /* 262724 */     GIR_EraseRootFromParent_Done,
     /* 262725 */   // Label 5077: @262725
     /* 262725 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(262777), // Rule ID 8367 //
     /* 262730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 262738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262754 */     // MIs[0] idx
     /* 262754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262757 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 262762 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1469:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 262762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 262765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262773 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 262775 */     GIR_RootConstrainSelectedInstOperands,
     /* 262776 */     // GIR_Coverage, 8367,
     /* 262776 */     GIR_EraseRootFromParent_Done,
     /* 262777 */   // Label 5078: @262777
     /* 262777 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(262829), // Rule ID 11331 //
     /* 262782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 262785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 262790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262806 */     // MIs[0] Op4
     /* 262806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262814 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1906:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 262817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262825 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262827 */     GIR_RootConstrainSelectedInstOperands,
     /* 262828 */     // GIR_Coverage, 11331,
     /* 262828 */     GIR_EraseRootFromParent_Done,
     /* 262829 */   // Label 5079: @262829
     /* 262829 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(262881), // Rule ID 11378 //
     /* 262834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 262842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 262848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262858 */     // MIs[0] Op4
     /* 262858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262861 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1605:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 262869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262875 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262877 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262879 */     GIR_RootConstrainSelectedInstOperands,
     /* 262880 */     // GIR_Coverage, 11378,
     /* 262880 */     GIR_EraseRootFromParent_Done,
     /* 262881 */   // Label 5080: @262881
     /* 262881 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(262933), // Rule ID 11379 //
     /* 262886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 262894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262910 */     // MIs[0] Op4
     /* 262910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262913 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262918 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1605:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 262921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262927 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262929 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262931 */     GIR_RootConstrainSelectedInstOperands,
     /* 262932 */     // GIR_Coverage, 11379,
     /* 262932 */     GIR_EraseRootFromParent_Done,
     /* 262933 */   // Label 5081: @262933
     /* 262933 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(262985), // Rule ID 11380 //
     /* 262938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 262946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262962 */     // MIs[0] Op4
     /* 262962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262965 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 262970 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1605:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 262970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 262973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262979 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262981 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262983 */     GIR_RootConstrainSelectedInstOperands,
     /* 262984 */     // GIR_Coverage, 11380,
     /* 262984 */     GIR_EraseRootFromParent_Done,
     /* 262985 */   // Label 5082: @262985
     /* 262985 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(263037), // Rule ID 11381 //
     /* 262990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 262998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 263004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263014 */     // MIs[0] Op4
     /* 263014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263017 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263022 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1823:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 263025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263031 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263033 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263035 */     GIR_RootConstrainSelectedInstOperands,
     /* 263036 */     // GIR_Coverage, 11381,
     /* 263036 */     GIR_EraseRootFromParent_Done,
     /* 263037 */   // Label 5083: @263037
     /* 263037 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(263089), // Rule ID 11382 //
     /* 263042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 263050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263066 */     // MIs[0] Op4
     /* 263066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263069 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263074 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 263077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263085 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263087 */     GIR_RootConstrainSelectedInstOperands,
     /* 263088 */     // GIR_Coverage, 11382,
     /* 263088 */     GIR_EraseRootFromParent_Done,
     /* 263089 */   // Label 5084: @263089
     /* 263089 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(263141), // Rule ID 11383 //
     /* 263094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 263102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263118 */     // MIs[0] Op4
     /* 263118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 263126 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1823:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 263126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 263129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263135 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263137 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263139 */     GIR_RootConstrainSelectedInstOperands,
     /* 263140 */     // GIR_Coverage, 11383,
     /* 263140 */     GIR_EraseRootFromParent_Done,
     /* 263141 */   // Label 5085: @263141
     /* 263141 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(263193), // Rule ID 11384 //
     /* 263146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 263154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 263160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263170 */     // MIs[0] Op4
     /* 263170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263173 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263178 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1825:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 263181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263187 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263189 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263191 */     GIR_RootConstrainSelectedInstOperands,
     /* 263192 */     // GIR_Coverage, 11384,
     /* 263192 */     GIR_EraseRootFromParent_Done,
     /* 263193 */   // Label 5086: @263193
     /* 263193 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(263245), // Rule ID 11385 //
     /* 263198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 263206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263222 */     // MIs[0] Op4
     /* 263222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263225 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1825:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 263233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263241 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263243 */     GIR_RootConstrainSelectedInstOperands,
     /* 263244 */     // GIR_Coverage, 11385,
     /* 263244 */     GIR_EraseRootFromParent_Done,
     /* 263245 */   // Label 5087: @263245
     /* 263245 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(263297), // Rule ID 11386 //
     /* 263250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 263258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263274 */     // MIs[0] Op4
     /* 263274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 263282 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1825:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 263282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 263285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263293 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263295 */     GIR_RootConstrainSelectedInstOperands,
     /* 263296 */     // GIR_Coverage, 11386,
     /* 263296 */     GIR_EraseRootFromParent_Done,
     /* 263297 */   // Label 5088: @263297
     /* 263297 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(263349), // Rule ID 11429 //
     /* 263302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 263310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263326 */     // MIs[0] Op4
     /* 263326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263329 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263334 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1746:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 263337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263345 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263347 */     GIR_RootConstrainSelectedInstOperands,
     /* 263348 */     // GIR_Coverage, 11429,
     /* 263348 */     GIR_EraseRootFromParent_Done,
     /* 263349 */   // Label 5089: @263349
     /* 263349 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(263401), // Rule ID 11430 //
     /* 263354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 263362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263378 */     // MIs[0] Op4
     /* 263378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263381 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263386 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1746:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 263389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263395 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263397 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263399 */     GIR_RootConstrainSelectedInstOperands,
     /* 263400 */     // GIR_Coverage, 11430,
     /* 263400 */     GIR_EraseRootFromParent_Done,
     /* 263401 */   // Label 5090: @263401
     /* 263401 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(263453), // Rule ID 11431 //
     /* 263406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 263414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263430 */     // MIs[0] Op4
     /* 263430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263438 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1982:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 263441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263449 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263451 */     GIR_RootConstrainSelectedInstOperands,
     /* 263452 */     // GIR_Coverage, 11431,
     /* 263452 */     GIR_EraseRootFromParent_Done,
     /* 263453 */   // Label 5091: @263453
     /* 263453 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(263505), // Rule ID 11432 //
     /* 263458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 263466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263482 */     // MIs[0] Op4
     /* 263482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263485 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263490 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1982:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 263493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263499 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263501 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263503 */     GIR_RootConstrainSelectedInstOperands,
     /* 263504 */     // GIR_Coverage, 11432,
     /* 263504 */     GIR_EraseRootFromParent_Done,
     /* 263505 */   // Label 5092: @263505
     /* 263505 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(263557), // Rule ID 11433 //
     /* 263510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 263518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263534 */     // MIs[0] Op4
     /* 263534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263537 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263542 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1984:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 263545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263553 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263555 */     GIR_RootConstrainSelectedInstOperands,
     /* 263556 */     // GIR_Coverage, 11433,
     /* 263556 */     GIR_EraseRootFromParent_Done,
     /* 263557 */   // Label 5093: @263557
     /* 263557 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(263609), // Rule ID 11434 //
     /* 263562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 263570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263586 */     // MIs[0] Op4
     /* 263586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263589 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263594 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1984:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 263597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263605 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263607 */     GIR_RootConstrainSelectedInstOperands,
     /* 263608 */     // GIR_Coverage, 11434,
     /* 263608 */     GIR_EraseRootFromParent_Done,
     /* 263609 */   // Label 5094: @263609
     /* 263609 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(263661), // Rule ID 11435 //
     /* 263614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 263622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263638 */     // MIs[0] Op4
     /* 263638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263641 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263646 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1748:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 263649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263657 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263659 */     GIR_RootConstrainSelectedInstOperands,
     /* 263660 */     // GIR_Coverage, 11435,
     /* 263660 */     GIR_EraseRootFromParent_Done,
     /* 263661 */   // Label 5095: @263661
     /* 263661 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(263713), // Rule ID 11436 //
     /* 263666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 263674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263690 */     // MIs[0] Op4
     /* 263690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263693 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263698 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1748:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 263701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263709 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263711 */     GIR_RootConstrainSelectedInstOperands,
     /* 263712 */     // GIR_Coverage, 11436,
     /* 263712 */     GIR_EraseRootFromParent_Done,
     /* 263713 */   // Label 5096: @263713
     /* 263713 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(263765), // Rule ID 11437 //
     /* 263718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 263726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263742 */     // MIs[0] Op4
     /* 263742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263745 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263750 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 263753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263761 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263763 */     GIR_RootConstrainSelectedInstOperands,
     /* 263764 */     // GIR_Coverage, 11437,
     /* 263764 */     GIR_EraseRootFromParent_Done,
     /* 263765 */   // Label 5097: @263765
     /* 263765 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(263817), // Rule ID 11438 //
     /* 263770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 263778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263794 */     // MIs[0] Op4
     /* 263794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263797 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1750:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 263805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263813 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263815 */     GIR_RootConstrainSelectedInstOperands,
     /* 263816 */     // GIR_Coverage, 11438,
     /* 263816 */     GIR_EraseRootFromParent_Done,
     /* 263817 */   // Label 5098: @263817
     /* 263817 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(263869), // Rule ID 11439 //
     /* 263822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 263830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263846 */     // MIs[0] Op4
     /* 263846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263849 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263854 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1986:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 263857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263865 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263867 */     GIR_RootConstrainSelectedInstOperands,
     /* 263868 */     // GIR_Coverage, 11439,
     /* 263868 */     GIR_EraseRootFromParent_Done,
     /* 263869 */   // Label 5099: @263869
     /* 263869 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(263921), // Rule ID 11440 //
     /* 263874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 263882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263898 */     // MIs[0] Op4
     /* 263898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263901 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 263906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1986:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 263906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 263909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263915 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263917 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263919 */     GIR_RootConstrainSelectedInstOperands,
     /* 263920 */     // GIR_Coverage, 11440,
     /* 263920 */     GIR_EraseRootFromParent_Done,
     /* 263921 */   // Label 5100: @263921
     /* 263921 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(263973), // Rule ID 11441 //
     /* 263926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 263934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 263940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263950 */     // MIs[0] Op4
     /* 263950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 263953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 263958 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1988:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 263958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 263961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263967 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263969 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263971 */     GIR_RootConstrainSelectedInstOperands,
     /* 263972 */     // GIR_Coverage, 11441,
     /* 263972 */     GIR_EraseRootFromParent_Done,
     /* 263973 */   // Label 5101: @263973
     /* 263973 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(264025), // Rule ID 11442 //
     /* 263978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 263981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 263986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 263992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264002 */     // MIs[0] Op4
     /* 264002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264005 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 264010 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1988:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 264010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 264013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264021 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264023 */     GIR_RootConstrainSelectedInstOperands,
     /* 264024 */     // GIR_Coverage, 11442,
     /* 264024 */     GIR_EraseRootFromParent_Done,
     /* 264025 */   // Label 5102: @264025
     /* 264025 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(264077), // Rule ID 11464 //
     /* 264030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 264038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264054 */     // MIs[0] Op4
     /* 264054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 264062 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1786:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 264062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 264065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264073 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264075 */     GIR_RootConstrainSelectedInstOperands,
     /* 264076 */     // GIR_Coverage, 11464,
     /* 264076 */     GIR_EraseRootFromParent_Done,
     /* 264077 */   // Label 5103: @264077
     /* 264077 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(264129), // Rule ID 11465 //
     /* 264082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 264090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 264096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264106 */     // MIs[0] Op4
     /* 264106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264109 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 264114 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1786:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 264114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 264117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264125 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264127 */     GIR_RootConstrainSelectedInstOperands,
     /* 264128 */     // GIR_Coverage, 11465,
     /* 264128 */     GIR_EraseRootFromParent_Done,
     /* 264129 */   // Label 5104: @264129
     /* 264129 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(264181), // Rule ID 11466 //
     /* 264134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 264142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264158 */     // MIs[0] Op4
     /* 264158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264161 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 264166 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1789:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 264166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 264169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264177 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264179 */     GIR_RootConstrainSelectedInstOperands,
     /* 264180 */     // GIR_Coverage, 11466,
     /* 264180 */     GIR_EraseRootFromParent_Done,
     /* 264181 */   // Label 5105: @264181
     /* 264181 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(264233), // Rule ID 11467 //
     /* 264186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 264194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 264200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264210 */     // MIs[0] Op4
     /* 264210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264213 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 264218 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1789:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 264218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 264221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264227 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264229 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264231 */     GIR_RootConstrainSelectedInstOperands,
     /* 264232 */     // GIR_Coverage, 11467,
     /* 264232 */     GIR_EraseRootFromParent_Done,
     /* 264233 */   // Label 5106: @264233
     /* 264233 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(264285), // Rule ID 11468 //
     /* 264238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 264246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264262 */     // MIs[0] Op4
     /* 264262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264265 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 264270 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1791:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 264270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 264273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264279 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264281 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264283 */     GIR_RootConstrainSelectedInstOperands,
     /* 264284 */     // GIR_Coverage, 11468,
     /* 264284 */     GIR_EraseRootFromParent_Done,
     /* 264285 */   // Label 5107: @264285
     /* 264285 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(264337), // Rule ID 11469 //
     /* 264290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 264298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 264304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264314 */     // MIs[0] Op4
     /* 264314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264317 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 264322 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1791:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 264322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 264325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264333 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264335 */     GIR_RootConstrainSelectedInstOperands,
     /* 264336 */     // GIR_Coverage, 11469,
     /* 264336 */     GIR_EraseRootFromParent_Done,
     /* 264337 */   // Label 5108: @264337
     /* 264337 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(264389), // Rule ID 11470 //
     /* 264342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 264350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264366 */     // MIs[0] Op4
     /* 264366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264369 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 264374 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1794:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 264374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 264377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264385 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264387 */     GIR_RootConstrainSelectedInstOperands,
     /* 264388 */     // GIR_Coverage, 11470,
     /* 264388 */     GIR_EraseRootFromParent_Done,
     /* 264389 */   // Label 5109: @264389
     /* 264389 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(264441), // Rule ID 11471 //
     /* 264394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 264402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 264408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264418 */     // MIs[0] Op4
     /* 264418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264421 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 264426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1794:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 264426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 264429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264437 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264439 */     GIR_RootConstrainSelectedInstOperands,
     /* 264440 */     // GIR_Coverage, 11471,
     /* 264440 */     GIR_EraseRootFromParent_Done,
     /* 264441 */   // Label 5110: @264441
     /* 264441 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(264493), // Rule ID 11925 //
     /* 264446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 264454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264470 */     // MIs[0] Op4
     /* 264470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 264478 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1465:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 264478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 264481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264487 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264489 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264491 */     GIR_RootConstrainSelectedInstOperands,
     /* 264492 */     // GIR_Coverage, 11925,
     /* 264492 */     GIR_EraseRootFromParent_Done,
     /* 264493 */   // Label 5111: @264493
     /* 264493 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(264545), // Rule ID 11926 //
     /* 264498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 264506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264522 */     // MIs[0] Op4
     /* 264522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264525 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 264530 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1467:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 264530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 264533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264541 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264543 */     GIR_RootConstrainSelectedInstOperands,
     /* 264544 */     // GIR_Coverage, 11926,
     /* 264544 */     GIR_EraseRootFromParent_Done,
     /* 264545 */   // Label 5112: @264545
     /* 264545 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(264597), // Rule ID 11927 //
     /* 264550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 264558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264574 */     // MIs[0] Op4
     /* 264574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 264582 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1472:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 264582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 264585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264591 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264593 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264595 */     GIR_RootConstrainSelectedInstOperands,
     /* 264596 */     // GIR_Coverage, 11927,
     /* 264596 */     GIR_EraseRootFromParent_Done,
     /* 264597 */   // Label 5113: @264597
     /* 264597 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(264649), // Rule ID 11928 //
     /* 264602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 264605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 264610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264626 */     // MIs[0] Op4
     /* 264626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 264634 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1474:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 264634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 264637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264645 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264647 */     GIR_RootConstrainSelectedInstOperands,
     /* 264648 */     // GIR_Coverage, 11928,
     /* 264648 */     GIR_EraseRootFromParent_Done,
     /* 264649 */   // Label 5114: @264649
     /* 264649 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(264701), // Rule ID 12073 //
     /* 264654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 264657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 264662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264678 */     // MIs[0] Op4
     /* 264678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 264686 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1420:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 264686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 264689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264695 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264697 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264699 */     GIR_RootConstrainSelectedInstOperands,
     /* 264700 */     // GIR_Coverage, 12073,
     /* 264700 */     GIR_EraseRootFromParent_Done,
     /* 264701 */   // Label 5115: @264701
     /* 264701 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(264753), // Rule ID 12075 //
     /* 264706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 264709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 264714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 264720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264730 */     // MIs[0] Op4
     /* 264730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 264733 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 264738 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1958:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 264738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 264741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264747 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264749 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264751 */     GIR_RootConstrainSelectedInstOperands,
     /* 264752 */     // GIR_Coverage, 12075,
     /* 264752 */     GIR_EraseRootFromParent_Done,
     /* 264753 */   // Label 5116: @264753
     /* 264753 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(264800), // Rule ID 2829 //
     /* 264758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 264766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264785 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1461:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 264788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264794 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264796 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264798 */     GIR_RootConstrainSelectedInstOperands,
     /* 264799 */     // GIR_Coverage, 2829,
     /* 264799 */     GIR_EraseRootFromParent_Done,
     /* 264800 */   // Label 5117: @264800
     /* 264800 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(264847), // Rule ID 2832 //
     /* 264805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 264813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 264816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 264822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 264825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 264828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264832 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1461:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 264832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 264835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264841 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264843 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264845 */     GIR_RootConstrainSelectedInstOperands,
     /* 264846 */     // GIR_Coverage, 2832,
     /* 264846 */     GIR_EraseRootFromParent_Done,
     /* 264847 */   // Label 5118: @264847
     /* 264847 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(264894), // Rule ID 2835 //
     /* 264852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 264860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 264863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 264869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 264872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 264875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264879 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1461:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 264879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 264882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264890 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264892 */     GIR_RootConstrainSelectedInstOperands,
     /* 264893 */     // GIR_Coverage, 2835,
     /* 264893 */     GIR_EraseRootFromParent_Done,
     /* 264894 */   // Label 5119: @264894
     /* 264894 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(264941), // Rule ID 2838 //
     /* 264899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 264907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264926 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1461:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 264929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264935 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264937 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264939 */     GIR_RootConstrainSelectedInstOperands,
     /* 264940 */     // GIR_Coverage, 2838,
     /* 264940 */     GIR_EraseRootFromParent_Done,
     /* 264941 */   // Label 5120: @264941
     /* 264941 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(264988), // Rule ID 2841 //
     /* 264946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 264954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 264957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 264963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 264966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 264969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264973 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1461:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 264973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 264976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264984 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264986 */     GIR_RootConstrainSelectedInstOperands,
     /* 264987 */     // GIR_Coverage, 2841,
     /* 264987 */     GIR_EraseRootFromParent_Done,
     /* 264988 */   // Label 5121: @264988
     /* 264988 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(265035), // Rule ID 2844 //
     /* 264993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 265001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265020 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1461:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 265020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 265023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265031 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265033 */     GIR_RootConstrainSelectedInstOperands,
     /* 265034 */     // GIR_Coverage, 2844,
     /* 265034 */     GIR_EraseRootFromParent_Done,
     /* 265035 */   // Label 5122: @265035
     /* 265035 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(265082), // Rule ID 2847 //
     /* 265040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 265048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265067 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1424:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 265067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 265070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265078 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265080 */     GIR_RootConstrainSelectedInstOperands,
     /* 265081 */     // GIR_Coverage, 2847,
     /* 265081 */     GIR_EraseRootFromParent_Done,
     /* 265082 */   // Label 5123: @265082
     /* 265082 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(265129), // Rule ID 2848 //
     /* 265087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 265095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265114 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1424:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 265114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 265117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265125 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265127 */     GIR_RootConstrainSelectedInstOperands,
     /* 265128 */     // GIR_Coverage, 2848,
     /* 265128 */     GIR_EraseRootFromParent_Done,
     /* 265129 */   // Label 5124: @265129
     /* 265129 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(265176), // Rule ID 2849 //
     /* 265134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 265142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265161 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1424:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 265161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 265164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265172 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265174 */     GIR_RootConstrainSelectedInstOperands,
     /* 265175 */     // GIR_Coverage, 2849,
     /* 265175 */     GIR_EraseRootFromParent_Done,
     /* 265176 */   // Label 5125: @265176
     /* 265176 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(265223), // Rule ID 2945 //
     /* 265181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 265189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 265192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 265195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 265198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 265201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 265204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265208 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1599:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 265208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 265211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265219 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265221 */     GIR_RootConstrainSelectedInstOperands,
     /* 265222 */     // GIR_Coverage, 2945,
     /* 265222 */     GIR_EraseRootFromParent_Done,
     /* 265223 */   // Label 5126: @265223
     /* 265223 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(265270), // Rule ID 2948 //
     /* 265228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 265236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265255 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1599:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 265255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 265258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265264 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265266 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265268 */     GIR_RootConstrainSelectedInstOperands,
     /* 265269 */     // GIR_Coverage, 2948,
     /* 265269 */     GIR_EraseRootFromParent_Done,
     /* 265270 */   // Label 5127: @265270
     /* 265270 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(265317), // Rule ID 2951 //
     /* 265275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 265283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1599:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 265302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 265305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265311 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265313 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265315 */     GIR_RootConstrainSelectedInstOperands,
     /* 265316 */     // GIR_Coverage, 2951,
     /* 265316 */     GIR_EraseRootFromParent_Done,
     /* 265317 */   // Label 5128: @265317
     /* 265317 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(265364), // Rule ID 2954 //
     /* 265322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 265330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265349 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1599:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 265349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 265352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265360 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265362 */     GIR_RootConstrainSelectedInstOperands,
     /* 265363 */     // GIR_Coverage, 2954,
     /* 265363 */     GIR_EraseRootFromParent_Done,
     /* 265364 */   // Label 5129: @265364
     /* 265364 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(265411), // Rule ID 2957 //
     /* 265369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 265377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 265380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 265383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 265386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 265389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 265392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1601:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 265396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 265399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265407 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265409 */     GIR_RootConstrainSelectedInstOperands,
     /* 265410 */     // GIR_Coverage, 2957,
     /* 265410 */     GIR_EraseRootFromParent_Done,
     /* 265411 */   // Label 5130: @265411
     /* 265411 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(265458), // Rule ID 2959 //
     /* 265416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 265424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265443 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1601:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 265443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 265446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265452 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265454 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265456 */     GIR_RootConstrainSelectedInstOperands,
     /* 265457 */     // GIR_Coverage, 2959,
     /* 265457 */     GIR_EraseRootFromParent_Done,
     /* 265458 */   // Label 5131: @265458
     /* 265458 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(265505), // Rule ID 2961 //
     /* 265463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 265471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265490 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1601:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 265490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 265493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265499 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265501 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265503 */     GIR_RootConstrainSelectedInstOperands,
     /* 265504 */     // GIR_Coverage, 2961,
     /* 265504 */     GIR_EraseRootFromParent_Done,
     /* 265505 */   // Label 5132: @265505
     /* 265505 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(265552), // Rule ID 2963 //
     /* 265510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 265518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265537 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1601:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 265537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 265540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265548 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265550 */     GIR_RootConstrainSelectedInstOperands,
     /* 265551 */     // GIR_Coverage, 2963,
     /* 265551 */     GIR_EraseRootFromParent_Done,
     /* 265552 */   // Label 5133: @265552
     /* 265552 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(265599), // Rule ID 7630 //
     /* 265557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 265565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 265568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 265571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 265574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 265577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 265580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1607:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 265584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 265587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265595 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265597 */     GIR_RootConstrainSelectedInstOperands,
     /* 265598 */     // GIR_Coverage, 7630,
     /* 265598 */     GIR_EraseRootFromParent_Done,
     /* 265599 */   // Label 5134: @265599
     /* 265599 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(265646), // Rule ID 7633 //
     /* 265604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 265612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265631 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1607:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 265631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 265634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265640 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265642 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265644 */     GIR_RootConstrainSelectedInstOperands,
     /* 265645 */     // GIR_Coverage, 7633,
     /* 265645 */     GIR_EraseRootFromParent_Done,
     /* 265646 */   // Label 5135: @265646
     /* 265646 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(265693), // Rule ID 7636 //
     /* 265651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 265659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265678 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1607:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 265678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 265681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265689 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265691 */     GIR_RootConstrainSelectedInstOperands,
     /* 265692 */     // GIR_Coverage, 7636,
     /* 265692 */     GIR_EraseRootFromParent_Done,
     /* 265693 */   // Label 5136: @265693
     /* 265693 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(265740), // Rule ID 7639 //
     /* 265698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 265706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265725 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1607:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 265725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 265728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 265730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265734 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265736 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265738 */     GIR_RootConstrainSelectedInstOperands,
     /* 265739 */     // GIR_Coverage, 7639,
     /* 265739 */     GIR_EraseRootFromParent_Done,
     /* 265740 */   // Label 5137: @265740
     /* 265740 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(265787), // Rule ID 7642 //
     /* 265745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 265753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 265756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 265759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 265762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 265765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 265768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265772 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1604:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 265772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 265775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265783 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265785 */     GIR_RootConstrainSelectedInstOperands,
     /* 265786 */     // GIR_Coverage, 7642,
     /* 265786 */     GIR_EraseRootFromParent_Done,
     /* 265787 */   // Label 5138: @265787
     /* 265787 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(265834), // Rule ID 7644 //
     /* 265792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 265800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265819 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1604:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 265819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 265822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265830 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265832 */     GIR_RootConstrainSelectedInstOperands,
     /* 265833 */     // GIR_Coverage, 7644,
     /* 265833 */     GIR_EraseRootFromParent_Done,
     /* 265834 */   // Label 5139: @265834
     /* 265834 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(265881), // Rule ID 7646 //
     /* 265839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 265847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265866 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1604:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 265866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 265869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265875 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265877 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265879 */     GIR_RootConstrainSelectedInstOperands,
     /* 265880 */     // GIR_Coverage, 7646,
     /* 265880 */     GIR_EraseRootFromParent_Done,
     /* 265881 */   // Label 5140: @265881
     /* 265881 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(265928), // Rule ID 7648 //
     /* 265886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 265894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265913 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1604:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 265913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 265916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265924 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265926 */     GIR_RootConstrainSelectedInstOperands,
     /* 265927 */     // GIR_Coverage, 7648,
     /* 265927 */     GIR_EraseRootFromParent_Done,
     /* 265928 */   // Label 5141: @265928
     /* 265928 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(265975), // Rule ID 8278 //
     /* 265933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 265941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265960 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1468:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 265960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 265963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 265965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265969 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265971 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265973 */     GIR_RootConstrainSelectedInstOperands,
     /* 265974 */     // GIR_Coverage, 8278,
     /* 265974 */     GIR_EraseRootFromParent_Done,
     /* 265975 */   // Label 5142: @265975
     /* 265975 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(266022), // Rule ID 8281 //
     /* 265980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 265988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 265991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 265997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 266000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 266003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266007 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 266007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 266010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266016 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266018 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266020 */     GIR_RootConstrainSelectedInstOperands,
     /* 266021 */     // GIR_Coverage, 8281,
     /* 266021 */     GIR_EraseRootFromParent_Done,
     /* 266022 */   // Label 5143: @266022
     /* 266022 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(266069), // Rule ID 8284 //
     /* 266027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 266035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 266038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 266044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 266047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 266050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266054 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 266054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 266057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266065 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266067 */     GIR_RootConstrainSelectedInstOperands,
     /* 266068 */     // GIR_Coverage, 8284,
     /* 266068 */     GIR_EraseRootFromParent_Done,
     /* 266069 */   // Label 5144: @266069
     /* 266069 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(266116), // Rule ID 8287 //
     /* 266074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 266082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 266085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 266088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 266091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 266094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 266097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266101 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 266101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 266104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266112 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266114 */     GIR_RootConstrainSelectedInstOperands,
     /* 266115 */     // GIR_Coverage, 8287,
     /* 266115 */     GIR_EraseRootFromParent_Done,
     /* 266116 */   // Label 5145: @266116
     /* 266116 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(266163), // Rule ID 8290 //
     /* 266121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 266129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 266132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 266138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 266141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 266144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266148 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 266148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 266151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266157 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266159 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266161 */     GIR_RootConstrainSelectedInstOperands,
     /* 266162 */     // GIR_Coverage, 8290,
     /* 266162 */     GIR_EraseRootFromParent_Done,
     /* 266163 */   // Label 5146: @266163
     /* 266163 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(266210), // Rule ID 8293 //
     /* 266168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 266176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 266179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 266185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 266188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 266191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266195 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 266195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 266198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266206 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266208 */     GIR_RootConstrainSelectedInstOperands,
     /* 266209 */     // GIR_Coverage, 8293,
     /* 266209 */     GIR_EraseRootFromParent_Done,
     /* 266210 */   // Label 5147: @266210
     /* 266210 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(266257), // Rule ID 8296 //
     /* 266215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 266223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 266226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 266229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 266232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 266235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 266238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266242 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1484:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 266242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 266245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266251 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266253 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266255 */     GIR_RootConstrainSelectedInstOperands,
     /* 266256 */     // GIR_Coverage, 8296,
     /* 266256 */     GIR_EraseRootFromParent_Done,
     /* 266257 */   // Label 5148: @266257
     /* 266257 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(266304), // Rule ID 8297 //
     /* 266262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 266270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 266273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 266276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 266279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 266282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 266285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266289 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1484:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 266289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 266292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266300 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266302 */     GIR_RootConstrainSelectedInstOperands,
     /* 266303 */     // GIR_Coverage, 8297,
     /* 266303 */     GIR_EraseRootFromParent_Done,
     /* 266304 */   // Label 5149: @266304
     /* 266304 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(266351), // Rule ID 8298 //
     /* 266309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 266317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 266320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 266326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 266329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 266332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266336 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 266336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 266339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266347 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266349 */     GIR_RootConstrainSelectedInstOperands,
     /* 266350 */     // GIR_Coverage, 8298,
     /* 266350 */     GIR_EraseRootFromParent_Done,
     /* 266351 */   // Label 5150: @266351
     /* 266351 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(266398), // Rule ID 8299 //
     /* 266356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 266364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 266367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 266370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 266373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 266376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 266379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266383 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1484:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 266383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 266386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266394 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266396 */     GIR_RootConstrainSelectedInstOperands,
     /* 266397 */     // GIR_Coverage, 8299,
     /* 266397 */     GIR_EraseRootFromParent_Done,
     /* 266398 */   // Label 5151: @266398
     /* 266398 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(266445), // Rule ID 8300 //
     /* 266403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 266411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 266414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 266420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 266423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 266426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266430 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 266430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 266433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266441 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266443 */     GIR_RootConstrainSelectedInstOperands,
     /* 266444 */     // GIR_Coverage, 8300,
     /* 266444 */     GIR_EraseRootFromParent_Done,
     /* 266445 */   // Label 5152: @266445
     /* 266445 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(266492), // Rule ID 8301 //
     /* 266450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 266458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 266461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 266467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 266470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 266473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266477 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1484:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 266477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 266480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266486 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266488 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266490 */     GIR_RootConstrainSelectedInstOperands,
     /* 266491 */     // GIR_Coverage, 8301,
     /* 266491 */     GIR_EraseRootFromParent_Done,
     /* 266492 */   // Label 5153: @266492
     /* 266492 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(266539), // Rule ID 8302 //
     /* 266497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 266505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 266508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 266511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 266514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 266517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 266520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266524 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1486:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 266524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 266527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266535 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266537 */     GIR_RootConstrainSelectedInstOperands,
     /* 266538 */     // GIR_Coverage, 8302,
     /* 266538 */     GIR_EraseRootFromParent_Done,
     /* 266539 */   // Label 5154: @266539
     /* 266539 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(266586), // Rule ID 8303 //
     /* 266544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 266552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 266555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 266558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 266561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 266564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 266567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266571 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1486:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 266571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 266574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266582 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266584 */     GIR_RootConstrainSelectedInstOperands,
     /* 266585 */     // GIR_Coverage, 8303,
     /* 266585 */     GIR_EraseRootFromParent_Done,
     /* 266586 */   // Label 5155: @266586
     /* 266586 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(266633), // Rule ID 8304 //
     /* 266591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 266599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 266602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 266608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 266611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 266614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266618 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 266618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 266621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266629 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266631 */     GIR_RootConstrainSelectedInstOperands,
     /* 266632 */     // GIR_Coverage, 8304,
     /* 266632 */     GIR_EraseRootFromParent_Done,
     /* 266633 */   // Label 5156: @266633
     /* 266633 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(266680), // Rule ID 8305 //
     /* 266638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 266646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 266649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 266652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 266655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 266658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 266661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266665 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1486:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 266665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 266668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266676 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266678 */     GIR_RootConstrainSelectedInstOperands,
     /* 266679 */     // GIR_Coverage, 8305,
     /* 266679 */     GIR_EraseRootFromParent_Done,
     /* 266680 */   // Label 5157: @266680
     /* 266680 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(266727), // Rule ID 8306 //
     /* 266685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 266693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 266696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 266702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 266705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 266708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266712 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 266712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 266715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266723 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266725 */     GIR_RootConstrainSelectedInstOperands,
     /* 266726 */     // GIR_Coverage, 8306,
     /* 266726 */     GIR_EraseRootFromParent_Done,
     /* 266727 */   // Label 5158: @266727
     /* 266727 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(266774), // Rule ID 8307 //
     /* 266732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 266740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 266743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 266749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 266752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 266755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266759 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1486:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 266759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 266762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 266764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266770 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266772 */     GIR_RootConstrainSelectedInstOperands,
     /* 266773 */     // GIR_Coverage, 8307,
     /* 266773 */     GIR_EraseRootFromParent_Done,
     /* 266774 */   // Label 5159: @266774
     /* 266774 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(266821), // Rule ID 8308 //
     /* 266779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 266787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 266790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 266793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 266796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 266799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 266802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266806 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1476:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 266806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 266809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 266811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266817 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266819 */     GIR_RootConstrainSelectedInstOperands,
     /* 266820 */     // GIR_Coverage, 8308,
     /* 266820 */     GIR_EraseRootFromParent_Done,
     /* 266821 */   // Label 5160: @266821
     /* 266821 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(266868), // Rule ID 8309 //
     /* 266826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 266834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 266837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 266840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 266843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 266846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 266849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266853 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1476:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 266853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 266856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 266858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266864 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266866 */     GIR_RootConstrainSelectedInstOperands,
     /* 266867 */     // GIR_Coverage, 8309,
     /* 266867 */     GIR_EraseRootFromParent_Done,
     /* 266868 */   // Label 5161: @266868
     /* 266868 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(266915), // Rule ID 8310 //
     /* 266873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 266881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 266884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 266887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 266890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 266893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 266896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266900 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1476:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 266900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 266903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 266905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266911 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266913 */     GIR_RootConstrainSelectedInstOperands,
     /* 266914 */     // GIR_Coverage, 8310,
     /* 266914 */     GIR_EraseRootFromParent_Done,
     /* 266915 */   // Label 5162: @266915
     /* 266915 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(266962), // Rule ID 8311 //
     /* 266920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 266928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 266931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 266934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 266937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 266940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 266943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266947 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1483:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 266947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 266950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 266952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 266954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 266956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 266958 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 266960 */     GIR_RootConstrainSelectedInstOperands,
     /* 266961 */     // GIR_Coverage, 8311,
     /* 266961 */     GIR_EraseRootFromParent_Done,
     /* 266962 */   // Label 5163: @266962
     /* 266962 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(267009), // Rule ID 8312 //
     /* 266967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 266975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 266978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 266981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 266984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 266987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 266990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266994 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1483:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 266994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 266997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 266999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267003 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267005 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267007 */     GIR_RootConstrainSelectedInstOperands,
     /* 267008 */     // GIR_Coverage, 8312,
     /* 267008 */     GIR_EraseRootFromParent_Done,
     /* 267009 */   // Label 5164: @267009
     /* 267009 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(267056), // Rule ID 8313 //
     /* 267014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 267022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 267025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 267031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 267034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 267037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267041 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1483:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 267041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 267044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 267046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267052 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267054 */     GIR_RootConstrainSelectedInstOperands,
     /* 267055 */     // GIR_Coverage, 8313,
     /* 267055 */     GIR_EraseRootFromParent_Done,
     /* 267056 */   // Label 5165: @267056
     /* 267056 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(267103), // Rule ID 8314 //
     /* 267061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 267069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 267075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 267081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 267084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267088 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1488:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 267088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 267091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 267093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267099 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267101 */     GIR_RootConstrainSelectedInstOperands,
     /* 267102 */     // GIR_Coverage, 8314,
     /* 267102 */     GIR_EraseRootFromParent_Done,
     /* 267103 */   // Label 5166: @267103
     /* 267103 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(267150), // Rule ID 8315 //
     /* 267108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 267116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 267119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 267122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 267125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 267128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 267131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267135 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1488:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 267135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 267138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 267140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267146 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267148 */     GIR_RootConstrainSelectedInstOperands,
     /* 267149 */     // GIR_Coverage, 8315,
     /* 267149 */     GIR_EraseRootFromParent_Done,
     /* 267150 */   // Label 5167: @267150
     /* 267150 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(267197), // Rule ID 8316 //
     /* 267155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 267163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 267166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 267172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 267175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 267178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267182 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 267182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 267185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 267187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267193 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267195 */     GIR_RootConstrainSelectedInstOperands,
     /* 267196 */     // GIR_Coverage, 8316,
     /* 267196 */     GIR_EraseRootFromParent_Done,
     /* 267197 */   // Label 5168: @267197
     /* 267197 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(267244), // Rule ID 8317 //
     /* 267202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 267210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 267216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 267222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 267225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267229 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1470:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 267229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 267232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267240 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267242 */     GIR_RootConstrainSelectedInstOperands,
     /* 267243 */     // GIR_Coverage, 8317,
     /* 267243 */     GIR_EraseRootFromParent_Done,
     /* 267244 */   // Label 5169: @267244
     /* 267244 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(267291), // Rule ID 8320 //
     /* 267249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 267257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 267260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 267263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 267266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 267269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 267272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267276 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 267276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 267279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267287 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267289 */     GIR_RootConstrainSelectedInstOperands,
     /* 267290 */     // GIR_Coverage, 8320,
     /* 267290 */     GIR_EraseRootFromParent_Done,
     /* 267291 */   // Label 5170: @267291
     /* 267291 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(267338), // Rule ID 8323 //
     /* 267296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 267304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 267307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 267313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 267316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 267319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267323 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 267323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 267326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267334 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267336 */     GIR_RootConstrainSelectedInstOperands,
     /* 267337 */     // GIR_Coverage, 8323,
     /* 267337 */     GIR_EraseRootFromParent_Done,
     /* 267338 */   // Label 5171: @267338
     /* 267338 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(267385), // Rule ID 8326 //
     /* 267343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 267351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 267354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 267357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 267360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 267363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 267366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267370 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 267370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 267373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267381 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267383 */     GIR_RootConstrainSelectedInstOperands,
     /* 267384 */     // GIR_Coverage, 8326,
     /* 267384 */     GIR_EraseRootFromParent_Done,
     /* 267385 */   // Label 5172: @267385
     /* 267385 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(267432), // Rule ID 8329 //
     /* 267390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 267398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 267401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 267407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 267410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 267413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267417 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 267417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 267420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267428 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267430 */     GIR_RootConstrainSelectedInstOperands,
     /* 267431 */     // GIR_Coverage, 8329,
     /* 267431 */     GIR_EraseRootFromParent_Done,
     /* 267432 */   // Label 5173: @267432
     /* 267432 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(267479), // Rule ID 8332 //
     /* 267437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 267445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 267448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 267454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 267457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 267460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267464 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 267464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 267467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267475 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267477 */     GIR_RootConstrainSelectedInstOperands,
     /* 267478 */     // GIR_Coverage, 8332,
     /* 267478 */     GIR_EraseRootFromParent_Done,
     /* 267479 */   // Label 5174: @267479
     /* 267479 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(267526), // Rule ID 8335 //
     /* 267484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 267492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 267498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 267504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 267507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267511 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1485:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 267511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 267514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267522 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267524 */     GIR_RootConstrainSelectedInstOperands,
     /* 267525 */     // GIR_Coverage, 8335,
     /* 267525 */     GIR_EraseRootFromParent_Done,
     /* 267526 */   // Label 5175: @267526
     /* 267526 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(267573), // Rule ID 8338 //
     /* 267531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 267539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 267542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 267545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 267548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 267551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 267554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267558 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1485:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 267558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 267561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267569 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267571 */     GIR_RootConstrainSelectedInstOperands,
     /* 267572 */     // GIR_Coverage, 8338,
     /* 267572 */     GIR_EraseRootFromParent_Done,
     /* 267573 */   // Label 5176: @267573
     /* 267573 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(267620), // Rule ID 8341 //
     /* 267578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 267586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 267589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 267595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 267598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 267601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267605 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 267605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 267608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267616 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267618 */     GIR_RootConstrainSelectedInstOperands,
     /* 267619 */     // GIR_Coverage, 8341,
     /* 267619 */     GIR_EraseRootFromParent_Done,
     /* 267620 */   // Label 5177: @267620
     /* 267620 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(267667), // Rule ID 8344 //
     /* 267625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 267633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 267636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 267639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 267642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 267645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 267648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267652 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1485:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 267652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 267655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267663 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267665 */     GIR_RootConstrainSelectedInstOperands,
     /* 267666 */     // GIR_Coverage, 8344,
     /* 267666 */     GIR_EraseRootFromParent_Done,
     /* 267667 */   // Label 5178: @267667
     /* 267667 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(267714), // Rule ID 8347 //
     /* 267672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 267680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 267683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 267689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 267692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 267695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267699 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 267699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 267702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267710 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267712 */     GIR_RootConstrainSelectedInstOperands,
     /* 267713 */     // GIR_Coverage, 8347,
     /* 267713 */     GIR_EraseRootFromParent_Done,
     /* 267714 */   // Label 5179: @267714
     /* 267714 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(267761), // Rule ID 8350 //
     /* 267719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 267727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 267730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 267736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 267739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 267742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267746 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1485:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 267746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 267749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267757 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267759 */     GIR_RootConstrainSelectedInstOperands,
     /* 267760 */     // GIR_Coverage, 8350,
     /* 267760 */     GIR_EraseRootFromParent_Done,
     /* 267761 */   // Label 5180: @267761
     /* 267761 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(267808), // Rule ID 8353 //
     /* 267766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 267774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 267780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 267783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 267786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 267789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267793 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1487:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 267793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 267796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267804 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267806 */     GIR_RootConstrainSelectedInstOperands,
     /* 267807 */     // GIR_Coverage, 8353,
     /* 267807 */     GIR_EraseRootFromParent_Done,
     /* 267808 */   // Label 5181: @267808
     /* 267808 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(267855), // Rule ID 8355 //
     /* 267813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 267821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 267824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 267827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 267830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 267833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 267836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267840 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1487:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 267840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 267843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267851 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267853 */     GIR_RootConstrainSelectedInstOperands,
     /* 267854 */     // GIR_Coverage, 8355,
     /* 267854 */     GIR_EraseRootFromParent_Done,
     /* 267855 */   // Label 5182: @267855
     /* 267855 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(267902), // Rule ID 8357 //
     /* 267860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 267868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 267871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 267877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 267880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 267883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267887 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 267887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 267890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267898 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267900 */     GIR_RootConstrainSelectedInstOperands,
     /* 267901 */     // GIR_Coverage, 8357,
     /* 267901 */     GIR_EraseRootFromParent_Done,
     /* 267902 */   // Label 5183: @267902
     /* 267902 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(267949), // Rule ID 8359 //
     /* 267907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 267915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 267918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 267921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 267924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 267927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 267930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267934 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1487:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 267934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 267937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267945 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267947 */     GIR_RootConstrainSelectedInstOperands,
     /* 267948 */     // GIR_Coverage, 8359,
     /* 267948 */     GIR_EraseRootFromParent_Done,
     /* 267949 */   // Label 5184: @267949
     /* 267949 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(267996), // Rule ID 8361 //
     /* 267954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 267957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 267962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 267965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 267968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 267971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 267974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 267977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267981 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 267981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 267984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 267990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 267992 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 267994 */     GIR_RootConstrainSelectedInstOperands,
     /* 267995 */     // GIR_Coverage, 8361,
     /* 267995 */     GIR_EraseRootFromParent_Done,
     /* 267996 */   // Label 5185: @267996
     /* 267996 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(268043), // Rule ID 8363 //
     /* 268001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 268004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 268009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 268012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 268015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 268018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 268021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 268024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 268028 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 268028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 268031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 268033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 268035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 268037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 268039 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 268041 */     GIR_RootConstrainSelectedInstOperands,
     /* 268042 */     // GIR_Coverage, 8363,
     /* 268042 */     GIR_EraseRootFromParent_Done,
     /* 268043 */   // Label 5186: @268043
     /* 268043 */   GIM_Reject,
     /* 268044 */ // Label 5045: @268044
     /* 268044 */ GIM_Reject,
     /* 268045 */ // Label 38: @268045
     /* 268045 */ GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(268123),
     /* 268050 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 268053 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(268075), // Rule ID 78 //
     /* 268058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 268061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 268066 */     // (intrinsic_void 2166:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 268066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 268069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268073 */     GIR_RootConstrainSelectedInstOperands,
     /* 268074 */     // GIR_Coverage, 78,
     /* 268074 */     GIR_EraseRootFromParent_Done,
     /* 268075 */   // Label 5188: @268075
     /* 268075 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(268100), // Rule ID 2386 //
     /* 268080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 268083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 268088 */     // (intrinsic_void 1716:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 268088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 268091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 268094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268098 */     GIR_RootConstrainSelectedInstOperands,
     /* 268099 */     // GIR_Coverage, 2386,
     /* 268099 */     GIR_EraseRootFromParent_Done,
     /* 268100 */   // Label 5189: @268100
     /* 268100 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(268122), // Rule ID 7184 //
     /* 268105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 268110 */     // (intrinsic_void 500:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 268110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 268113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 268116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268120 */     GIR_RootConstrainSelectedInstOperands,
     /* 268121 */     // GIR_Coverage, 7184,
     /* 268121 */     GIR_EraseRootFromParent_Done,
     /* 268122 */   // Label 5190: @268122
     /* 268122 */   GIM_Reject,
     /* 268123 */ // Label 5187: @268123
     /* 268123 */ GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(268723),
     /* 268128 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 268131 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(268163), // Rule ID 79 //
     /* 268136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 268139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 268144 */     // MIs[0] imm
     /* 268144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268147 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 268152 */     // (intrinsic_void 2165:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 268152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 268155 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 268157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268161 */     GIR_RootConstrainSelectedInstOperands,
     /* 268162 */     // GIR_Coverage, 79,
     /* 268162 */     GIR_EraseRootFromParent_Done,
     /* 268163 */   // Label 5192: @268163
     /* 268163 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(268188), // Rule ID 227 //
     /* 268168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 268173 */     // MIs[0] imm
     /* 268173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 268181 */     // (intrinsic_void 498:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 268181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 268184 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 268186 */     GIR_RootConstrainSelectedInstOperands,
     /* 268187 */     // GIR_Coverage, 227,
     /* 268187 */     GIR_EraseRootFromParent_Done,
     /* 268188 */   // Label 5193: @268188
     /* 268188 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(268213), // Rule ID 228 //
     /* 268193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 268198 */     // MIs[0] imm
     /* 268198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268201 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 268206 */     // (intrinsic_void 557:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 268206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 268209 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 268211 */     GIR_RootConstrainSelectedInstOperands,
     /* 268212 */     // GIR_Coverage, 228,
     /* 268212 */     GIR_EraseRootFromParent_Done,
     /* 268213 */   // Label 5194: @268213
     /* 268213 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(268245), // Rule ID 3624 //
     /* 268218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 268221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 268226 */     // MIs[0] imm
     /* 268226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268229 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 268234 */     // (intrinsic_void 1222:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 268234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 268237 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 268239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268243 */     GIR_RootConstrainSelectedInstOperands,
     /* 268244 */     // GIR_Coverage, 3624,
     /* 268244 */     GIR_EraseRootFromParent_Done,
     /* 268245 */   // Label 5195: @268245
     /* 268245 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(268285), // Rule ID 16 //
     /* 268250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 268255 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 268258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 268270 */     // MIs[1] Operand 1
     /* 268270 */     // No operand predicates
     /* 268270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268272 */     // (intrinsic_void 556:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 268272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 268275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 268278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268283 */     GIR_RootConstrainSelectedInstOperands,
     /* 268284 */     // GIR_Coverage, 16,
     /* 268284 */     GIR_EraseRootFromParent_Done,
     /* 268285 */   // Label 5196: @268285
     /* 268285 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(268325), // Rule ID 17 //
     /* 268290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 268295 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 268298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 268310 */     // MIs[1] Operand 1
     /* 268310 */     // No operand predicates
     /* 268310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268312 */     // (intrinsic_void 544:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 268312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 268315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 268318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268323 */     GIR_RootConstrainSelectedInstOperands,
     /* 268324 */     // GIR_Coverage, 17,
     /* 268324 */     GIR_EraseRootFromParent_Done,
     /* 268325 */   // Label 5197: @268325
     /* 268325 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(268365), // Rule ID 18 //
     /* 268330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 268335 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 268338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 268350 */     // MIs[1] Operand 1
     /* 268350 */     // No operand predicates
     /* 268350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268352 */     // (intrinsic_void 545:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 268352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 268355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 268358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268363 */     GIR_RootConstrainSelectedInstOperands,
     /* 268364 */     // GIR_Coverage, 18,
     /* 268364 */     GIR_EraseRootFromParent_Done,
     /* 268365 */   // Label 5198: @268365
     /* 268365 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(268405), // Rule ID 19 //
     /* 268370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 268375 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 268378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 268386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 268390 */     // MIs[1] Operand 1
     /* 268390 */     // No operand predicates
     /* 268390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268392 */     // (intrinsic_void 560:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 268392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 268395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 268398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268403 */     GIR_RootConstrainSelectedInstOperands,
     /* 268404 */     // GIR_Coverage, 19,
     /* 268404 */     GIR_EraseRootFromParent_Done,
     /* 268405 */   // Label 5199: @268405
     /* 268405 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(268429), // Rule ID 72 //
     /* 268410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 268415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268422 */     // (intrinsic_w_chain:{ *:[i64] } 553:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 268422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 268425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268427 */     GIR_RootConstrainSelectedInstOperands,
     /* 268428 */     // GIR_Coverage, 72,
     /* 268428 */     GIR_EraseRootFromParent_Done,
     /* 268429 */   // Label 5200: @268429
     /* 268429 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(268453), // Rule ID 74 //
     /* 268434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 268439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268446 */     // (intrinsic_w_chain:{ *:[i64] } 554:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 268446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 268449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268451 */     GIR_RootConstrainSelectedInstOperands,
     /* 268452 */     // GIR_Coverage, 74,
     /* 268452 */     GIR_EraseRootFromParent_Done,
     /* 268453 */   // Label 5201: @268453
     /* 268453 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(268484), // Rule ID 77 //
     /* 268458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 268461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 268466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268473 */     // (intrinsic_w_chain:{ *:[i64] } 2167:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 268473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 268476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 268478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268482 */     GIR_RootConstrainSelectedInstOperands,
     /* 268483 */     // GIR_Coverage, 77,
     /* 268483 */     GIR_EraseRootFromParent_Done,
     /* 268484 */   // Label 5202: @268484
     /* 268484 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(268511), // Rule ID 80 //
     /* 268489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 268492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 268497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268504 */     // (intrinsic_w_chain:{ *:[i64] } 2168:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 268504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 268507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 268509 */     GIR_RootConstrainSelectedInstOperands,
     /* 268510 */     // GIR_Coverage, 80,
     /* 268510 */     GIR_EraseRootFromParent_Done,
     /* 268511 */   // Label 5203: @268511
     /* 268511 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(268542), // Rule ID 2385 //
     /* 268516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 268519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 268524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 268527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 268531 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1666:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 268531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 268534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 268536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268540 */     GIR_RootConstrainSelectedInstOperands,
     /* 268541 */     // GIR_Coverage, 2385,
     /* 268541 */     GIR_EraseRootFromParent_Done,
     /* 268542 */   // Label 5204: @268542
     /* 268542 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(268582), // Rule ID 12859 //
     /* 268547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 268550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 268555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268562 */     // (intrinsic_w_chain:{ *:[i64] } 891:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 268562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 268565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 268567 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 268577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 268580 */     GIR_RootConstrainSelectedInstOperands,
     /* 268581 */     // GIR_Coverage, 12859,
     /* 268581 */     GIR_EraseRootFromParent_Done,
     /* 268582 */   // Label 5205: @268582
     /* 268582 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(268616), // Rule ID 2387 //
     /* 268587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 268590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 268595 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 268598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 268602 */     // (intrinsic_void 2146:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 268602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 268605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 268607 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 268610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268614 */     GIR_RootConstrainSelectedInstOperands,
     /* 268615 */     // GIR_Coverage, 2387,
     /* 268615 */     GIR_EraseRootFromParent_Done,
     /* 268616 */   // Label 5206: @268616
     /* 268616 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(268639), // Rule ID 73 //
     /* 268621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 268626 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 268629 */     // (intrinsic_void 780:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 268629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 268632 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 268634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 268637 */     GIR_RootConstrainSelectedInstOperands,
     /* 268638 */     // GIR_Coverage, 73,
     /* 268638 */     GIR_EraseRootFromParent_Done,
     /* 268639 */   // Label 5207: @268639
     /* 268639 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(268662), // Rule ID 75 //
     /* 268644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 268649 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 268652 */     // (intrinsic_void 782:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 268652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 268655 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 268657 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 268660 */     GIR_RootConstrainSelectedInstOperands,
     /* 268661 */     // GIR_Coverage, 75,
     /* 268661 */     GIR_EraseRootFromParent_Done,
     /* 268662 */   // Label 5208: @268662
     /* 268662 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(268689), // Rule ID 76 //
     /* 268667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 268672 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 268675 */     // (intrinsic_void 781:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 268675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 268678 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 268680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 268683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268687 */     GIR_RootConstrainSelectedInstOperands,
     /* 268688 */     // GIR_Coverage, 76,
     /* 268688 */     GIR_EraseRootFromParent_Done,
     /* 268689 */   // Label 5209: @268689
     /* 268689 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(268722), // Rule ID 12858 //
     /* 268694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 268697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 268702 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 268705 */     // (intrinsic_void 966:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 268705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 268708 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 268718 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 268720 */     GIR_RootConstrainSelectedInstOperands,
     /* 268721 */     // GIR_Coverage, 12858,
     /* 268721 */     GIR_EraseRootFromParent_Done,
     /* 268722 */   // Label 5210: @268722
     /* 268722 */   GIM_Reject,
     /* 268723 */ // Label 5191: @268723
     /* 268723 */ GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(269694),
     /* 268728 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 268731 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(268807), // Rule ID 7150 //
     /* 268736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 268741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268748 */     // MIs[0] addr
     /* 268748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268756 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 268760 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 268760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 268767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 268776 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 268785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 268796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268806 */     // GIR_Coverage, 7150,
     /* 268806 */     GIR_EraseRootFromParent_Done,
     /* 268807 */   // Label 5212: @268807
     /* 268807 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(268883), // Rule ID 7151 //
     /* 268812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 268817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268824 */     // MIs[0] addr
     /* 268824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268832 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 268836 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 268836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 268843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268848 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 268852 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 268861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 268872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268877 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268882 */     // GIR_Coverage, 7151,
     /* 268882 */     GIR_EraseRootFromParent_Done,
     /* 268883 */   // Label 5213: @268883
     /* 268883 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(268959), // Rule ID 7152 //
     /* 268888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 268893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268900 */     // MIs[0] addr
     /* 268900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268908 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 268912 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 268912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 268919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 268928 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 268934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 268937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 268948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 268953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268958 */     // GIR_Coverage, 7152,
     /* 268958 */     GIR_EraseRootFromParent_Done,
     /* 268959 */   // Label 5214: @268959
     /* 268959 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(269001), // Rule ID 7153 //
     /* 268964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 268969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 268972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268976 */     // MIs[0] addr
     /* 268976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 268980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268984 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 268988 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 268988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 268991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 268993 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 268995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268999 */     GIR_RootConstrainSelectedInstOperands,
     /* 269000 */     // GIR_Coverage, 7153,
     /* 269000 */     GIR_EraseRootFromParent_Done,
     /* 269001 */   // Label 5215: @269001
     /* 269001 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(269077), // Rule ID 7157 //
     /* 269006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 269011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 269014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269018 */     // MIs[0] addr
     /* 269018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 269022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269026 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 269030 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 269030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 269037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 269046 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 269052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 269055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 269066 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269076 */     // GIR_Coverage, 7157,
     /* 269076 */     GIR_EraseRootFromParent_Done,
     /* 269077 */   // Label 5216: @269077
     /* 269077 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(269153), // Rule ID 7158 //
     /* 269082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 269087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 269090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269094 */     // MIs[0] addr
     /* 269094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 269098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269102 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 269106 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 269106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 269113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269118 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 269122 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 269128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 269131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 269142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269152 */     // GIR_Coverage, 7158,
     /* 269152 */     GIR_EraseRootFromParent_Done,
     /* 269153 */   // Label 5217: @269153
     /* 269153 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(269229), // Rule ID 7159 //
     /* 269158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 269163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 269166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269170 */     // MIs[0] addr
     /* 269170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 269174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269178 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 269182 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 269182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 269185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 269189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269194 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 269198 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 269204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 269207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 269209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 269218 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269228 */     // GIR_Coverage, 7159,
     /* 269228 */     GIR_EraseRootFromParent_Done,
     /* 269229 */   // Label 5218: @269229
     /* 269229 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(269271), // Rule ID 7160 //
     /* 269234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 269239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 269242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269246 */     // MIs[0] addr
     /* 269246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 269250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269254 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 269258 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 269258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 269261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 269263 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 269265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269269 */     GIR_RootConstrainSelectedInstOperands,
     /* 269270 */     // GIR_Coverage, 7160,
     /* 269270 */     GIR_EraseRootFromParent_Done,
     /* 269271 */   // Label 5219: @269271
     /* 269271 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(269311), // Rule ID 20 //
     /* 269276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 269279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 269284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 269287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269298 */     // (intrinsic_w_chain:{ *:[i64] } 551:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 269298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 269301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 269303 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 269305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269309 */     GIR_RootConstrainSelectedInstOperands,
     /* 269310 */     // GIR_Coverage, 20,
     /* 269310 */     GIR_EraseRootFromParent_Done,
     /* 269311 */   // Label 5220: @269311
     /* 269311 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(269351), // Rule ID 2384 //
     /* 269316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 269319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 269324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 269327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 269330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 269334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 269338 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1667:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 269338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 269341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 269343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 269345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269349 */     GIR_RootConstrainSelectedInstOperands,
     /* 269350 */     // GIR_Coverage, 2384,
     /* 269350 */     GIR_EraseRootFromParent_Done,
     /* 269351 */   // Label 5221: @269351
     /* 269351 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(269391), // Rule ID 2495 //
     /* 269356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 269359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 269364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 269367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269378 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 269378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 269381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269389 */     GIR_RootConstrainSelectedInstOperands,
     /* 269390 */     // GIR_Coverage, 2495,
     /* 269390 */     GIR_EraseRootFromParent_Done,
     /* 269391 */   // Label 5222: @269391
     /* 269391 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(269431), // Rule ID 2496 //
     /* 269396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 269399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 269404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 269407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 269410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269418 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 269418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 269421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269429 */     GIR_RootConstrainSelectedInstOperands,
     /* 269430 */     // GIR_Coverage, 2496,
     /* 269430 */     GIR_EraseRootFromParent_Done,
     /* 269431 */   // Label 5223: @269431
     /* 269431 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(269471), // Rule ID 7037 //
     /* 269436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 269439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 269444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 269447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269458 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 269458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 269461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269469 */     GIR_RootConstrainSelectedInstOperands,
     /* 269470 */     // GIR_Coverage, 7037,
     /* 269470 */     GIR_EraseRootFromParent_Done,
     /* 269471 */   // Label 5224: @269471
     /* 269471 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(269511), // Rule ID 7038 //
     /* 269476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 269479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 269484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 269487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 269490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269498 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 269498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 269501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 269505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269509 */     GIR_RootConstrainSelectedInstOperands,
     /* 269510 */     // GIR_Coverage, 7038,
     /* 269510 */     GIR_EraseRootFromParent_Done,
     /* 269511 */   // Label 5225: @269511
     /* 269511 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(269547), // Rule ID 3577 //
     /* 269516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 269519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 269524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 269527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269534 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1491:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 269534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 269537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 269539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 269541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269545 */     GIR_RootConstrainSelectedInstOperands,
     /* 269546 */     // GIR_Coverage, 3577,
     /* 269546 */     GIR_EraseRootFromParent_Done,
     /* 269547 */   // Label 5226: @269547
     /* 269547 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(269585), // Rule ID 4001 //
     /* 269552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 269555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 269560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 269563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269570 */     // (intrinsic_w_chain:{ *:[i64] } 559:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 269570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 269573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 269581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 269583 */     GIR_RootConstrainSelectedInstOperands,
     /* 269584 */     // GIR_Coverage, 4001,
     /* 269584 */     GIR_EraseRootFromParent_Done,
     /* 269585 */   // Label 5227: @269585
     /* 269585 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(269621), // Rule ID 12584 //
     /* 269590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 269593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 269598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 269601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269608 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1493:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 269608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 269611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 269613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 269615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269619 */     GIR_RootConstrainSelectedInstOperands,
     /* 269620 */     // GIR_Coverage, 12584,
     /* 269620 */     GIR_EraseRootFromParent_Done,
     /* 269621 */   // Label 5228: @269621
     /* 269621 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(269657), // Rule ID 12585 //
     /* 269626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 269629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 269634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 269637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269644 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1497:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 269644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 269647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 269649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 269651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269655 */     GIR_RootConstrainSelectedInstOperands,
     /* 269656 */     // GIR_Coverage, 12585,
     /* 269656 */     GIR_EraseRootFromParent_Done,
     /* 269657 */   // Label 5229: @269657
     /* 269657 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(269693), // Rule ID 12586 //
     /* 269662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 269665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 269670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 269673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 269680 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1498:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 269680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 269683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 269685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 269687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269691 */     GIR_RootConstrainSelectedInstOperands,
     /* 269692 */     // GIR_Coverage, 12586,
     /* 269692 */     GIR_EraseRootFromParent_Done,
     /* 269693 */   // Label 5230: @269693
     /* 269693 */   GIM_Reject,
     /* 269694 */ // Label 5211: @269694
     /* 269694 */ GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(273862),
     /* 269699 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 269702 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(269799), // Rule ID 7168 //
     /* 269707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 269712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 269738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 269742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 269750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269755 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 269766 */     // MIs[0] addr
     /* 269766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 269778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 269780 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 269780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 269783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 269789 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 269797 */     GIR_RootConstrainSelectedInstOperands,
     /* 269798 */     // GIR_Coverage, 7168,
     /* 269798 */     GIR_EraseRootFromParent_Done,
     /* 269799 */   // Label 5232: @269799
     /* 269799 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(269896), // Rule ID 7169 //
     /* 269804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 269809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 269835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 269839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 269847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269852 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 269863 */     // MIs[0] addr
     /* 269863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 269875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 269877 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 269877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 269880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 269886 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 269894 */     GIR_RootConstrainSelectedInstOperands,
     /* 269895 */     // GIR_Coverage, 7169,
     /* 269895 */     GIR_EraseRootFromParent_Done,
     /* 269896 */   // Label 5233: @269896
     /* 269896 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(269993), // Rule ID 7178 //
     /* 269901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 269906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 269909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 269932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 269936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 269940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 269944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269949 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 269960 */     // MIs[0] addr
     /* 269960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 269964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 269968 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 269972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 269974 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 269974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 269977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 269979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 269983 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 269985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 269991 */     GIR_RootConstrainSelectedInstOperands,
     /* 269992 */     // GIR_Coverage, 7178,
     /* 269992 */     GIR_EraseRootFromParent_Done,
     /* 269993 */   // Label 5234: @269993
     /* 269993 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(270090), // Rule ID 7179 //
     /* 269998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 270029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 270033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 270037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 270041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270046 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 270057 */     // MIs[0] addr
     /* 270057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 270069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270071 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 270071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 270074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 270080 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 270088 */     GIR_RootConstrainSelectedInstOperands,
     /* 270089 */     // GIR_Coverage, 7179,
     /* 270089 */     GIR_EraseRootFromParent_Done,
     /* 270090 */   // Label 5235: @270090
     /* 270090 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(270201), // Rule ID 7171 //
     /* 270095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 270118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 270126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270131 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 270142 */     // MIs[0] addr
     /* 270142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270150 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 270154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270156 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270168 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 270187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270192 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270199 */     GIR_RootConstrainSelectedInstOperands,
     /* 270200 */     // GIR_Coverage, 7171,
     /* 270200 */     GIR_EraseRootFromParent_Done,
     /* 270201 */   // Label 5236: @270201
     /* 270201 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(270312), // Rule ID 7172 //
     /* 270206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 270229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 270237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270242 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 270253 */     // MIs[0] addr
     /* 270253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270261 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 270265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270267 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270279 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 270298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270303 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270310 */     GIR_RootConstrainSelectedInstOperands,
     /* 270311 */     // GIR_Coverage, 7172,
     /* 270311 */     GIR_EraseRootFromParent_Done,
     /* 270312 */   // Label 5237: @270312
     /* 270312 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(270423), // Rule ID 7173 //
     /* 270317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 270340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 270348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270353 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 270364 */     // MIs[0] addr
     /* 270364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270372 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 270376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270378 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270390 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 270409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270414 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270421 */     GIR_RootConstrainSelectedInstOperands,
     /* 270422 */     // GIR_Coverage, 7173,
     /* 270422 */     GIR_EraseRootFromParent_Done,
     /* 270423 */   // Label 5238: @270423
     /* 270423 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(270534), // Rule ID 7181 //
     /* 270428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 270451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 270459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270464 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 270475 */     // MIs[0] addr
     /* 270475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270483 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 270487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270489 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270501 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 270520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270525 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270532 */     GIR_RootConstrainSelectedInstOperands,
     /* 270533 */     // GIR_Coverage, 7181,
     /* 270533 */     GIR_EraseRootFromParent_Done,
     /* 270534 */   // Label 5239: @270534
     /* 270534 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(270645), // Rule ID 7182 //
     /* 270539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 270562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 270570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270575 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 270586 */     // MIs[0] addr
     /* 270586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270594 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 270598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270600 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270612 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 270631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270636 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270643 */     GIR_RootConstrainSelectedInstOperands,
     /* 270644 */     // GIR_Coverage, 7182,
     /* 270644 */     GIR_EraseRootFromParent_Done,
     /* 270645 */   // Label 5240: @270645
     /* 270645 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(270756), // Rule ID 7183 //
     /* 270650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 270673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 270677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 270681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270686 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 270697 */     // MIs[0] addr
     /* 270697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270705 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 270709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270711 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270723 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 270742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270747 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270754 */     GIR_RootConstrainSelectedInstOperands,
     /* 270755 */     // GIR_Coverage, 7183,
     /* 270755 */     GIR_EraseRootFromParent_Done,
     /* 270756 */   // Label 5241: @270756
     /* 270756 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(270807), // Rule ID 70 //
     /* 270761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 270766 */     // MIs[0] ptr
     /* 270766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 270770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 270774 */     // MIs[0] accessinfo
     /* 270774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 270777 */     // MIs[0] fixed_shadow
     /* 270777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270780 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 270780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 270783 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 270785 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 270787 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 270789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 270792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 270795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 270798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 270801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270805 */     GIR_RootConstrainSelectedInstOperands,
     /* 270806 */     // GIR_Coverage, 70,
     /* 270806 */     GIR_EraseRootFromParent_Done,
     /* 270807 */   // Label 5242: @270807
     /* 270807 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(270858), // Rule ID 71 //
     /* 270812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 270817 */     // MIs[0] ptr
     /* 270817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 270821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 270825 */     // MIs[0] accessinfo
     /* 270825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 270828 */     // MIs[0] fixed_shadow
     /* 270828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270831 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 270831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 270834 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 270836 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 270838 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 270840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 270843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 270846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 270849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 270852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270856 */     GIR_RootConstrainSelectedInstOperands,
     /* 270857 */     // GIR_Coverage, 71,
     /* 270857 */     GIR_EraseRootFromParent_Done,
     /* 270858 */   // Label 5243: @270858
     /* 270858 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(270927), // Rule ID 7170 //
     /* 270863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270895 */     // MIs[0] addr
     /* 270895 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270903 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 270907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270909 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 270909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 270912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 270918 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270925 */     GIR_RootConstrainSelectedInstOperands,
     /* 270926 */     // GIR_Coverage, 7170,
     /* 270926 */     GIR_EraseRootFromParent_Done,
     /* 270927 */   // Label 5244: @270927
     /* 270927 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(270996), // Rule ID 7180 //
     /* 270932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270964 */     // MIs[0] addr
     /* 270964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270972 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 270976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270978 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 270978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 270981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 270987 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270994 */     GIR_RootConstrainSelectedInstOperands,
     /* 270995 */     // GIR_Coverage, 7180,
     /* 270995 */     GIR_EraseRootFromParent_Done,
     /* 270996 */   // Label 5245: @270996
     /* 270996 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(271038), // Rule ID 3601 //
     /* 271001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 271009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271015 */     // MIs[0] tile
     /* 271015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271023 */     // (intrinsic_void 1015:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_BToS_PSEUDO),
     /* 271026 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271036 */     GIR_RootConstrainSelectedInstOperands,
     /* 271037 */     // GIR_Coverage, 3601,
     /* 271037 */     GIR_EraseRootFromParent_Done,
     /* 271038 */   // Label 5246: @271038
     /* 271038 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(271080), // Rule ID 3605 //
     /* 271043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 271051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271057 */     // MIs[0] tile
     /* 271057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271065 */     // (intrinsic_void 1015:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HToS_PSEUDO),
     /* 271068 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271078 */     GIR_RootConstrainSelectedInstOperands,
     /* 271079 */     // GIR_Coverage, 3605,
     /* 271079 */     GIR_EraseRootFromParent_Done,
     /* 271080 */   // Label 5247: @271080
     /* 271080 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(271122), // Rule ID 3609 //
     /* 271085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 271088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_za64_wide_1x1),
     /* 271093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271099 */     // MIs[0] tile
     /* 271099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271107 */     // (intrinsic_void 1019:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HtoD_PSEUDO),
     /* 271110 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271120 */     GIR_RootConstrainSelectedInstOperands,
     /* 271121 */     // GIR_Coverage, 3609,
     /* 271121 */     GIR_EraseRootFromParent_Done,
     /* 271122 */   // Label 5248: @271122
     /* 271122 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(271164), // Rule ID 3779 //
     /* 271127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 271130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 271135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271141 */     // MIs[0] tile
     /* 271141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271144 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 271149 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 271149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_H_PSEUDO),
     /* 271152 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271162 */     GIR_RootConstrainSelectedInstOperands,
     /* 271163 */     // GIR_Coverage, 3779,
     /* 271163 */     GIR_EraseRootFromParent_Done,
     /* 271164 */   // Label 5249: @271164
     /* 271164 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(271206), // Rule ID 3783 //
     /* 271169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32_HasSME_MOP4),
     /* 271172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za32_1x1),
     /* 271177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271183 */     // MIs[0] tile
     /* 271183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271191 */     // (intrinsic_void 875:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoS_PSEUDO),
     /* 271194 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271204 */     GIR_RootConstrainSelectedInstOperands,
     /* 271205 */     // GIR_Coverage, 3783,
     /* 271205 */     GIR_EraseRootFromParent_Done,
     /* 271206 */   // Label 5250: @271206
     /* 271206 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(271248), // Rule ID 3787 //
     /* 271211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 271219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 271222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 271225 */     // MIs[0] tile
     /* 271225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271228 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271233 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4A_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 271233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_S_PSEUDO),
     /* 271236 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271246 */     GIR_RootConstrainSelectedInstOperands,
     /* 271247 */     // GIR_Coverage, 3787,
     /* 271247 */     GIR_EraseRootFromParent_Done,
     /* 271248 */   // Label 5251: @271248
     /* 271248 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(271290), // Rule ID 3791 //
     /* 271253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 271256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 271261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 271264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271267 */     // MIs[0] tile
     /* 271267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271270 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271275 */     // (intrinsic_void 912:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4A_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 271275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_D_PSEUDO),
     /* 271278 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271288 */     GIR_RootConstrainSelectedInstOperands,
     /* 271289 */     // GIR_Coverage, 3791,
     /* 271289 */     GIR_EraseRootFromParent_Done,
     /* 271290 */   // Label 5252: @271290
     /* 271290 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(271332), // Rule ID 3795 //
     /* 271295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_wide_1x1),
     /* 271303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271309 */     // MIs[0] tile
     /* 271309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271312 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271317 */     // (intrinsic_void 916:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 271317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_HtoS_PSEUDO),
     /* 271320 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271330 */     GIR_RootConstrainSelectedInstOperands,
     /* 271331 */     // GIR_Coverage, 3795,
     /* 271331 */     GIR_EraseRootFromParent_Done,
     /* 271332 */   // Label 5253: @271332
     /* 271332 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(271374), // Rule ID 3799 //
     /* 271337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16_HasSME_MOP4),
     /* 271340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za16_1x1),
     /* 271345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271351 */     // MIs[0] tile
     /* 271351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271354 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 271359 */     // (intrinsic_void 871:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoH_PSEUDO),
     /* 271362 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271372 */     GIR_RootConstrainSelectedInstOperands,
     /* 271373 */     // GIR_Coverage, 3799,
     /* 271373 */     GIR_EraseRootFromParent_Done,
     /* 271374 */   // Label 5254: @271374
     /* 271374 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(271416), // Rule ID 12663 //
     /* 271379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 271387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271393 */     // MIs[0] tile
     /* 271393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271401 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_BToS_PSEUDO),
     /* 271404 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271414 */     GIR_RootConstrainSelectedInstOperands,
     /* 271415 */     // GIR_Coverage, 12663,
     /* 271415 */     GIR_EraseRootFromParent_Done,
     /* 271416 */   // Label 5255: @271416
     /* 271416 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(271458), // Rule ID 12667 //
     /* 271421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_wide_1x1),
     /* 271429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271435 */     // MIs[0] tile
     /* 271435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271438 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271443 */     // (intrinsic_void 1067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_BToS_PSEUDO),
     /* 271446 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271456 */     GIR_RootConstrainSelectedInstOperands,
     /* 271457 */     // GIR_Coverage, 12667,
     /* 271457 */     GIR_EraseRootFromParent_Done,
     /* 271458 */   // Label 5256: @271458
     /* 271458 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(271500), // Rule ID 12671 //
     /* 271463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_wide_1x1),
     /* 271471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271477 */     // MIs[0] tile
     /* 271477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271480 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271485 */     // (intrinsic_void 1075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_BToS_PSEUDO),
     /* 271488 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271498 */     GIR_RootConstrainSelectedInstOperands,
     /* 271499 */     // GIR_Coverage, 12671,
     /* 271499 */     GIR_EraseRootFromParent_Done,
     /* 271500 */   // Label 5257: @271500
     /* 271500 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(271542), // Rule ID 12675 //
     /* 271505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_wide_1x1),
     /* 271513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271519 */     // MIs[0] tile
     /* 271519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271522 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271527 */     // (intrinsic_void 1184:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_BToS_PSEUDO),
     /* 271530 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271540 */     GIR_RootConstrainSelectedInstOperands,
     /* 271541 */     // GIR_Coverage, 12675,
     /* 271541 */     GIR_EraseRootFromParent_Done,
     /* 271542 */   // Label 5258: @271542
     /* 271542 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(271584), // Rule ID 12679 //
     /* 271547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_wide_1x1),
     /* 271555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271561 */     // MIs[0] tile
     /* 271561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271569 */     // (intrinsic_void 1192:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_BToS_PSEUDO),
     /* 271572 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271582 */     GIR_RootConstrainSelectedInstOperands,
     /* 271583 */     // GIR_Coverage, 12679,
     /* 271583 */     GIR_EraseRootFromParent_Done,
     /* 271584 */   // Label 5259: @271584
     /* 271584 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(271626), // Rule ID 12683 //
     /* 271589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 271597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271603 */     // MIs[0] tile
     /* 271603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271606 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271611 */     // (intrinsic_void 1150:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_BToS_PSEUDO),
     /* 271614 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271624 */     GIR_RootConstrainSelectedInstOperands,
     /* 271625 */     // GIR_Coverage, 12683,
     /* 271625 */     GIR_EraseRootFromParent_Done,
     /* 271626 */   // Label 5260: @271626
     /* 271626 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(271668), // Rule ID 12687 //
     /* 271631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 271639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 271642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 271645 */     // MIs[0] tile
     /* 271645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271648 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271653 */     // (intrinsic_void 1158:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 271653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_BToS_PSEUDO),
     /* 271656 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271666 */     GIR_RootConstrainSelectedInstOperands,
     /* 271667 */     // GIR_Coverage, 12687,
     /* 271667 */     GIR_EraseRootFromParent_Done,
     /* 271668 */   // Label 5261: @271668
     /* 271668 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(271710), // Rule ID 12691 //
     /* 271673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 271681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271687 */     // MIs[0] tile
     /* 271687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271690 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271695 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HToS_PSEUDO),
     /* 271698 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271708 */     GIR_RootConstrainSelectedInstOperands,
     /* 271709 */     // GIR_Coverage, 12691,
     /* 271709 */     GIR_EraseRootFromParent_Done,
     /* 271710 */   // Label 5262: @271710
     /* 271710 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(271752), // Rule ID 12695 //
     /* 271715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 271723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271729 */     // MIs[0] tile
     /* 271729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271737 */     // (intrinsic_void 1150:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HToS_PSEUDO),
     /* 271740 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271750 */     GIR_RootConstrainSelectedInstOperands,
     /* 271751 */     // GIR_Coverage, 12695,
     /* 271751 */     GIR_EraseRootFromParent_Done,
     /* 271752 */   // Label 5263: @271752
     /* 271752 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(271794), // Rule ID 12699 //
     /* 271757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 271760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 271765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271771 */     // MIs[0] tile
     /* 271771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271774 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271779 */     // (intrinsic_void 1158:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HToS_PSEUDO),
     /* 271782 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271792 */     GIR_RootConstrainSelectedInstOperands,
     /* 271793 */     // GIR_Coverage, 12699,
     /* 271793 */     GIR_EraseRootFromParent_Done,
     /* 271794 */   // Label 5264: @271794
     /* 271794 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(271836), // Rule ID 12703 //
     /* 271799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 271802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_za64_wide_1x1),
     /* 271807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271813 */     // MIs[0] tile
     /* 271813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271816 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271821 */     // (intrinsic_void 1027:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HtoD_PSEUDO),
     /* 271824 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271834 */     GIR_RootConstrainSelectedInstOperands,
     /* 271835 */     // GIR_Coverage, 12703,
     /* 271835 */     GIR_EraseRootFromParent_Done,
     /* 271836 */   // Label 5265: @271836
     /* 271836 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(271878), // Rule ID 12707 //
     /* 271841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 271844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_za64_wide_1x1),
     /* 271849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271855 */     // MIs[0] tile
     /* 271855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271858 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271863 */     // (intrinsic_void 1071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_HtoD_PSEUDO),
     /* 271866 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271876 */     GIR_RootConstrainSelectedInstOperands,
     /* 271877 */     // GIR_Coverage, 12707,
     /* 271877 */     GIR_EraseRootFromParent_Done,
     /* 271878 */   // Label 5266: @271878
     /* 271878 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(271920), // Rule ID 12711 //
     /* 271883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 271886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_za64_wide_1x1),
     /* 271891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271897 */     // MIs[0] tile
     /* 271897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271900 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271905 */     // (intrinsic_void 1079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_HtoD_PSEUDO),
     /* 271908 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271918 */     GIR_RootConstrainSelectedInstOperands,
     /* 271919 */     // GIR_Coverage, 12711,
     /* 271919 */     GIR_EraseRootFromParent_Done,
     /* 271920 */   // Label 5267: @271920
     /* 271920 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(271962), // Rule ID 12715 //
     /* 271925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 271928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_za64_wide_1x1),
     /* 271933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271939 */     // MIs[0] tile
     /* 271939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271942 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271947 */     // (intrinsic_void 1154:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HtoD_PSEUDO),
     /* 271950 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271960 */     GIR_RootConstrainSelectedInstOperands,
     /* 271961 */     // GIR_Coverage, 12715,
     /* 271961 */     GIR_EraseRootFromParent_Done,
     /* 271962 */   // Label 5268: @271962
     /* 271962 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(272004), // Rule ID 12719 //
     /* 271967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 271970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_za64_wide_1x1),
     /* 271975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 271978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 271981 */     // MIs[0] tile
     /* 271981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271989 */     // (intrinsic_void 1162:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 271989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HtoD_PSEUDO),
     /* 271992 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272002 */     GIR_RootConstrainSelectedInstOperands,
     /* 272003 */     // GIR_Coverage, 12719,
     /* 272003 */     GIR_EraseRootFromParent_Done,
     /* 272004 */   // Label 5269: @272004
     /* 272004 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(272046), // Rule ID 12723 //
     /* 272009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 272012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_za64_wide_1x1),
     /* 272017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 272020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 272023 */     // MIs[0] tile
     /* 272023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 272026 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 272031 */     // (intrinsic_void 1188:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 272031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_HtoD_PSEUDO),
     /* 272034 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 272036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 272038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272044 */     GIR_RootConstrainSelectedInstOperands,
     /* 272045 */     // GIR_Coverage, 12723,
     /* 272045 */     GIR_EraseRootFromParent_Done,
     /* 272046 */   // Label 5270: @272046
     /* 272046 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(272088), // Rule ID 12727 //
     /* 272051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 272054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_za64_wide_1x1),
     /* 272059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 272062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 272065 */     // MIs[0] tile
     /* 272065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 272068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 272073 */     // (intrinsic_void 1196:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 272073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_HtoD_PSEUDO),
     /* 272076 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 272078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 272080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272086 */     GIR_RootConstrainSelectedInstOperands,
     /* 272087 */     // GIR_Coverage, 12727,
     /* 272087 */     GIR_EraseRootFromParent_Done,
     /* 272088 */   // Label 5271: @272088
     /* 272088 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(272130), // Rule ID 13182 //
     /* 272093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 272096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_wide_1x1),
     /* 272101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 272104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 272107 */     // MIs[0] tile
     /* 272107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 272110 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 272115 */     // (intrinsic_void 924:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 272115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_HtoS_PSEUDO),
     /* 272118 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 272120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 272122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272128 */     GIR_RootConstrainSelectedInstOperands,
     /* 272129 */     // GIR_Coverage, 13182,
     /* 272129 */     GIR_EraseRootFromParent_Done,
     /* 272130 */   // Label 5272: @272130
     /* 272130 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(272172), // Rule ID 13186 //
     /* 272135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 272138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 272143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 272146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272149 */     // MIs[0] tile
     /* 272149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 272152 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 272157 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4S_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 272157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_S_PSEUDO),
     /* 272160 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 272162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 272164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272170 */     GIR_RootConstrainSelectedInstOperands,
     /* 272171 */     // GIR_Coverage, 13186,
     /* 272171 */     GIR_EraseRootFromParent_Done,
     /* 272172 */   // Label 5273: @272172
     /* 272172 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(272214), // Rule ID 13190 //
     /* 272177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 272180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 272185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 272188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 272191 */     // MIs[0] tile
     /* 272191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 272194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 272199 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 272199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_H_PSEUDO),
     /* 272202 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 272204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 272206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272212 */     GIR_RootConstrainSelectedInstOperands,
     /* 272213 */     // GIR_Coverage, 13190,
     /* 272213 */     GIR_EraseRootFromParent_Done,
     /* 272214 */   // Label 5274: @272214
     /* 272214 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(272256), // Rule ID 13194 //
     /* 272219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 272222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 272227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 272230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272233 */     // MIs[0] tile
     /* 272233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 272236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 272241 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4S_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 272241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_D_PSEUDO),
     /* 272244 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 272246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 272248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272254 */     GIR_RootConstrainSelectedInstOperands,
     /* 272255 */     // GIR_Coverage, 13194,
     /* 272255 */     GIR_EraseRootFromParent_Done,
     /* 272256 */   // Label 5275: @272256
     /* 272256 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(272310), // Rule ID 8917 //
     /* 272261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 272269 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 272272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272276 */     // MIs[0] base
     /* 272276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272284 */     // MIs[0] prfop
     /* 272284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 272287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272292 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 272292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 272295 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 272297 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 272299 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 272301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 272304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272308 */     GIR_RootConstrainSelectedInstOperands,
     /* 272309 */     // GIR_Coverage, 8917,
     /* 272309 */     GIR_EraseRootFromParent_Done,
     /* 272310 */   // Label 5276: @272310
     /* 272310 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(272364), // Rule ID 8920 //
     /* 272315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 272323 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 272326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272330 */     // MIs[0] base
     /* 272330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272338 */     // MIs[0] prfop
     /* 272338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 272341 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272346 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 272346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 272349 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 272351 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 272353 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 272355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 272358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272362 */     GIR_RootConstrainSelectedInstOperands,
     /* 272363 */     // GIR_Coverage, 8920,
     /* 272363 */     GIR_EraseRootFromParent_Done,
     /* 272364 */   // Label 5277: @272364
     /* 272364 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(272418), // Rule ID 8923 //
     /* 272369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 272377 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272384 */     // MIs[0] base
     /* 272384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272392 */     // MIs[0] prfop
     /* 272392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 272395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272400 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 272400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 272403 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 272405 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 272407 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 272409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 272412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272416 */     GIR_RootConstrainSelectedInstOperands,
     /* 272417 */     // GIR_Coverage, 8923,
     /* 272417 */     GIR_EraseRootFromParent_Done,
     /* 272418 */   // Label 5278: @272418
     /* 272418 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(272472), // Rule ID 8926 //
     /* 272423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 272426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 272431 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272438 */     // MIs[0] base
     /* 272438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272446 */     // MIs[0] prfop
     /* 272446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 272449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272454 */     // (intrinsic_void 1634:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 272454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 272457 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 272459 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 272461 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 272463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 272466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272470 */     GIR_RootConstrainSelectedInstOperands,
     /* 272471 */     // GIR_Coverage, 8926,
     /* 272471 */     GIR_EraseRootFromParent_Done,
     /* 272472 */   // Label 5279: @272472
     /* 272472 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(272526), // Rule ID 15 //
     /* 272477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 272482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 272485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 272488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 272491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 272503 */     // MIs[1] Operand 1
     /* 272503 */     // No operand predicates
     /* 272503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272509 */     // (intrinsic_w_chain:{ *:[i64] } 1232:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 272509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 272512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 272517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 272524 */     GIR_RootConstrainSelectedInstOperands,
     /* 272525 */     // GIR_Coverage, 15,
     /* 272525 */     GIR_EraseRootFromParent_Done,
     /* 272526 */   // Label 5280: @272526
     /* 272526 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(272594), // Rule ID 68 //
     /* 272531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 272536 */     // MIs[0] Operand 1
     /* 272536 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 272540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 272544 */     // MIs[0] ptr
     /* 272544 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 272552 */     // MIs[0] accessinfo
     /* 272552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 272555 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 272555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272559 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 272569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 272572 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 272574 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 272576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 272579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 272582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 272585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 272588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272592 */     GIR_RootConstrainSelectedInstOperands,
     /* 272593 */     // GIR_Coverage, 68,
     /* 272593 */     GIR_EraseRootFromParent_Done,
     /* 272594 */   // Label 5281: @272594
     /* 272594 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(272662), // Rule ID 69 //
     /* 272599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 272604 */     // MIs[0] Operand 1
     /* 272604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 272608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 272612 */     // MIs[0] ptr
     /* 272612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 272620 */     // MIs[0] accessinfo
     /* 272620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 272623 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 272623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272627 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272633 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 272637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 272640 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 272642 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 272644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 272647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 272650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 272653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 272656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272660 */     GIR_RootConstrainSelectedInstOperands,
     /* 272661 */     // GIR_Coverage, 69,
     /* 272661 */     GIR_EraseRootFromParent_Done,
     /* 272662 */   // Label 5282: @272662
     /* 272662 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(272742), // Rule ID 7164 //
     /* 272667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 272672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272686 */     // MIs[0] addr
     /* 272686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 272690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272694 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 272698 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 272698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 272701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272710 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 272716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 272729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 272731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272734 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 272736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272740 */     GIR_RootConstrainSelectedInstOperands,
     /* 272741 */     // GIR_Coverage, 7164,
     /* 272741 */     GIR_EraseRootFromParent_Done,
     /* 272742 */   // Label 5283: @272742
     /* 272742 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(272822), // Rule ID 7165 //
     /* 272747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 272752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272766 */     // MIs[0] addr
     /* 272766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 272770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272774 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 272778 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 272778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 272781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272790 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 272796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 272809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 272811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272814 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 272816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272820 */     GIR_RootConstrainSelectedInstOperands,
     /* 272821 */     // GIR_Coverage, 7165,
     /* 272821 */     GIR_EraseRootFromParent_Done,
     /* 272822 */   // Label 5284: @272822
     /* 272822 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(272902), // Rule ID 7166 //
     /* 272827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 272832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272846 */     // MIs[0] addr
     /* 272846 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 272850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272854 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 272858 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 272858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 272861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 272870 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 272876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 272889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 272891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272894 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 272896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272900 */     GIR_RootConstrainSelectedInstOperands,
     /* 272901 */     // GIR_Coverage, 7166,
     /* 272901 */     GIR_EraseRootFromParent_Done,
     /* 272902 */   // Label 5285: @272902
     /* 272902 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(272953), // Rule ID 7167 //
     /* 272907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 272912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272926 */     // MIs[0] addr
     /* 272926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 272930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272934 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 272938 */     // (intrinsic_w_chain:{ *:[i32] } 1241:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 272938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 272941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 272943 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 272945 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 272947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272951 */     GIR_RootConstrainSelectedInstOperands,
     /* 272952 */     // GIR_Coverage, 7167,
     /* 272952 */     GIR_EraseRootFromParent_Done,
     /* 272953 */   // Label 5286: @272953
     /* 272953 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(273033), // Rule ID 7174 //
     /* 272958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 272963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 272966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272977 */     // MIs[0] addr
     /* 272977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 272981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272985 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 272989 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 272989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 272992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 272996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273001 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 273007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 273020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 273022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273025 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 273027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273031 */     GIR_RootConstrainSelectedInstOperands,
     /* 273032 */     // GIR_Coverage, 7174,
     /* 273032 */     GIR_EraseRootFromParent_Done,
     /* 273033 */   // Label 5287: @273033
     /* 273033 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(273113), // Rule ID 7175 //
     /* 273038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 273043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 273046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273057 */     // MIs[0] addr
     /* 273057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273065 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 273069 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 273069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 273072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273081 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 273087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 273100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 273102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273105 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 273107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273111 */     GIR_RootConstrainSelectedInstOperands,
     /* 273112 */     // GIR_Coverage, 7175,
     /* 273112 */     GIR_EraseRootFromParent_Done,
     /* 273113 */   // Label 5288: @273113
     /* 273113 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(273193), // Rule ID 7176 //
     /* 273118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 273123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 273126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273137 */     // MIs[0] addr
     /* 273137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273145 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 273149 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 273149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 273152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 273156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 273161 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 273167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 273180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 273182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 273185 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 273187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273191 */     GIR_RootConstrainSelectedInstOperands,
     /* 273192 */     // GIR_Coverage, 7176,
     /* 273192 */     GIR_EraseRootFromParent_Done,
     /* 273193 */   // Label 5289: @273193
     /* 273193 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(273244), // Rule ID 7177 //
     /* 273198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 273203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 273206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273217 */     // MIs[0] addr
     /* 273217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273225 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 273229 */     // (intrinsic_w_chain:{ *:[i32] } 1239:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 273229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 273232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 273234 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 273236 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 273238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273242 */     GIR_RootConstrainSelectedInstOperands,
     /* 273243 */     // GIR_Coverage, 7177,
     /* 273243 */     GIR_EraseRootFromParent_Done,
     /* 273244 */   // Label 5290: @273244
     /* 273244 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(273293), // Rule ID 2488 //
     /* 273249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 273252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 273257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 273260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 273263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 273266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273278 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 273278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 273281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273291 */     GIR_RootConstrainSelectedInstOperands,
     /* 273292 */     // GIR_Coverage, 2488,
     /* 273292 */     GIR_EraseRootFromParent_Done,
     /* 273293 */   // Label 5291: @273293
     /* 273293 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(273342), // Rule ID 2489 //
     /* 273298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 273301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 273306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 273309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 273315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273327 */     // (intrinsic_w_chain:{ *:[v16i8] } 613:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 273327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 273330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273340 */     GIR_RootConstrainSelectedInstOperands,
     /* 273341 */     // GIR_Coverage, 2489,
     /* 273341 */     GIR_EraseRootFromParent_Done,
     /* 273342 */   // Label 5292: @273342
     /* 273342 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(273391), // Rule ID 2490 //
     /* 273347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 273350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 273355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 273358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273376 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 273376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 273379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273389 */     GIR_RootConstrainSelectedInstOperands,
     /* 273390 */     // GIR_Coverage, 2490,
     /* 273390 */     GIR_EraseRootFromParent_Done,
     /* 273391 */   // Label 5293: @273391
     /* 273391 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(273444), // Rule ID 8803 //
     /* 273396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 273404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 273407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 273410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273418 */     // MIs[0] base
     /* 273418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273426 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1567:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 273426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 273429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 273431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 273433 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 273435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273442 */     GIR_RootConstrainSelectedInstOperands,
     /* 273443 */     // GIR_Coverage, 8803,
     /* 273443 */     GIR_EraseRootFromParent_Done,
     /* 273444 */   // Label 5294: @273444
     /* 273444 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(273497), // Rule ID 8806 //
     /* 273449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 273457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 273460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 273463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273471 */     // MIs[0] base
     /* 273471 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273479 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1567:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 273479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 273482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 273484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 273486 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 273488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273495 */     GIR_RootConstrainSelectedInstOperands,
     /* 273496 */     // GIR_Coverage, 8806,
     /* 273496 */     GIR_EraseRootFromParent_Done,
     /* 273497 */   // Label 5295: @273497
     /* 273497 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(273550), // Rule ID 8815 //
     /* 273502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 273510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 273513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 273516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273524 */     // MIs[0] base
     /* 273524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273532 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1566:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 273532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 273535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 273537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 273539 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 273541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273548 */     GIR_RootConstrainSelectedInstOperands,
     /* 273549 */     // GIR_Coverage, 8815,
     /* 273549 */     GIR_EraseRootFromParent_Done,
     /* 273550 */   // Label 5296: @273550
     /* 273550 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(273603), // Rule ID 8818 //
     /* 273555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 273563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 273566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 273569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273577 */     // MIs[0] base
     /* 273577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273585 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1566:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 273585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 273588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 273590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 273592 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 273594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273601 */     GIR_RootConstrainSelectedInstOperands,
     /* 273602 */     // GIR_Coverage, 8818,
     /* 273602 */     GIR_EraseRootFromParent_Done,
     /* 273603 */   // Label 5297: @273603
     /* 273603 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(273649), // Rule ID 137 //
     /* 273608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 273611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 273616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 273619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 273622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273626 */     // MIs[0] Rn
     /* 273626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273638 */     // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 273638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 273641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273647 */     GIR_RootConstrainSelectedInstOperands,
     /* 273648 */     // GIR_Coverage, 137,
     /* 273648 */     GIR_EraseRootFromParent_Done,
     /* 273649 */   // Label 5298: @273649
     /* 273649 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(273702), // Rule ID 8809 //
     /* 273654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 273662 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 273665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 273668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273676 */     // MIs[0] base
     /* 273676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273684 */     // (intrinsic_void 1887:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 273684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 273687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 273689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 273691 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 273693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273700 */     GIR_RootConstrainSelectedInstOperands,
     /* 273701 */     // GIR_Coverage, 8809,
     /* 273701 */     GIR_EraseRootFromParent_Done,
     /* 273702 */   // Label 5299: @273702
     /* 273702 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(273755), // Rule ID 8812 //
     /* 273707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 273715 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 273718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 273721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273729 */     // MIs[0] base
     /* 273729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273737 */     // (intrinsic_void 1887:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 273737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 273740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 273742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 273744 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 273746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273753 */     GIR_RootConstrainSelectedInstOperands,
     /* 273754 */     // GIR_Coverage, 8812,
     /* 273754 */     GIR_EraseRootFromParent_Done,
     /* 273755 */   // Label 5300: @273755
     /* 273755 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(273808), // Rule ID 8821 //
     /* 273760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 273768 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 273771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 273774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273782 */     // MIs[0] base
     /* 273782 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273790 */     // (intrinsic_void 1883:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 273790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 273793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 273795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 273797 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 273799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273806 */     GIR_RootConstrainSelectedInstOperands,
     /* 273807 */     // GIR_Coverage, 8821,
     /* 273807 */     GIR_EraseRootFromParent_Done,
     /* 273808 */   // Label 5301: @273808
     /* 273808 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(273861), // Rule ID 8824 //
     /* 273813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 273816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 273821 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 273824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 273827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273835 */     // MIs[0] base
     /* 273835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 273839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273843 */     // (intrinsic_void 1883:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 273843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 273846 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 273848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 273850 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 273852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 273855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273859 */     GIR_RootConstrainSelectedInstOperands,
     /* 273860 */     // GIR_Coverage, 8824,
     /* 273860 */     GIR_EraseRootFromParent_Done,
     /* 273861 */   // Label 5302: @273861
     /* 273861 */   GIM_Reject,
     /* 273862 */ // Label 5231: @273862
     /* 273862 */ GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(276567),
     /* 273867 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 273870 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(273941), // Rule ID 3413 //
     /* 273875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 273883 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 273886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 273889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 273892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 273912 */     // MIs[1] Operand 1
     /* 273912 */     // No operand predicates
     /* 273912 */     // MIs[0] prfop
     /* 273912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273915 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273922 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 273922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 273925 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 273931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 273934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 273939 */     GIR_RootConstrainSelectedInstOperands,
     /* 273940 */     // GIR_Coverage, 3413,
     /* 273940 */     GIR_EraseRootFromParent_Done,
     /* 273941 */   // Label 5304: @273941
     /* 273941 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(274012), // Rule ID 3426 //
     /* 273946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 273949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 273954 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 273957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 273960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 273963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 273979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 273983 */     // MIs[1] Operand 1
     /* 273983 */     // No operand predicates
     /* 273983 */     // MIs[0] prfop
     /* 273983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273986 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273993 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 273993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 273996 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 274002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 274005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 274010 */     GIR_RootConstrainSelectedInstOperands,
     /* 274011 */     // GIR_Coverage, 3426,
     /* 274011 */     GIR_EraseRootFromParent_Done,
     /* 274012 */   // Label 5305: @274012
     /* 274012 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(274071), // Rule ID 3613 //
     /* 274017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 274025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 274028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 274031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 274034 */     // MIs[0] tile
     /* 274034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274037 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274054 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 274054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 274057 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274059 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 274061 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 274063 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 274065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274069 */     GIR_RootConstrainSelectedInstOperands,
     /* 274070 */     // GIR_Coverage, 3613,
     /* 274070 */     GIR_EraseRootFromParent_Done,
     /* 274071 */   // Label 5306: @274071
     /* 274071 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(274130), // Rule ID 3614 //
     /* 274076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 274079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 274084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 274087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 274090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 274093 */     // MIs[0] tile
     /* 274093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 274101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274113 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 274113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 274116 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274118 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 274120 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 274122 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 274124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274128 */     GIR_RootConstrainSelectedInstOperands,
     /* 274129 */     // GIR_Coverage, 3614,
     /* 274129 */     GIR_EraseRootFromParent_Done,
     /* 274130 */   // Label 5307: @274130
     /* 274130 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(274189), // Rule ID 12644 //
     /* 274135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 274143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 274146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 274149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 274152 */     // MIs[0] tile
     /* 274152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274155 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274172 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 274172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 274175 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274177 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 274179 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 274181 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 274183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274187 */     GIR_RootConstrainSelectedInstOperands,
     /* 274188 */     // GIR_Coverage, 12644,
     /* 274188 */     GIR_EraseRootFromParent_Done,
     /* 274189 */   // Label 5308: @274189
     /* 274189 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(274248), // Rule ID 12645 //
     /* 274194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 274197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 274202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 274205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 274208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 274211 */     // MIs[0] tile
     /* 274211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 274219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274231 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 274231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 274234 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274236 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 274238 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 274240 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 274242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274246 */     GIR_RootConstrainSelectedInstOperands,
     /* 274247 */     // GIR_Coverage, 12645,
     /* 274247 */     GIR_EraseRootFromParent_Done,
     /* 274248 */   // Label 5309: @274248
     /* 274248 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(274308), // Rule ID 3411 //
     /* 274253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 274261 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 274264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 274267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274271 */     // MIs[0] Rn
     /* 274271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274283 */     // MIs[0] prfop
     /* 274283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274291 */     // (intrinsic_void 1638:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 274291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 274294 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274306 */     GIR_RootConstrainSelectedInstOperands,
     /* 274307 */     // GIR_Coverage, 3411,
     /* 274307 */     GIR_EraseRootFromParent_Done,
     /* 274308 */   // Label 5310: @274308
     /* 274308 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(274368), // Rule ID 3412 //
     /* 274313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 274321 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 274324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 274327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274331 */     // MIs[0] Rn
     /* 274331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274343 */     // MIs[0] prfop
     /* 274343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274346 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274351 */     // (intrinsic_void 1637:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 274351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 274354 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274366 */     GIR_RootConstrainSelectedInstOperands,
     /* 274367 */     // GIR_Coverage, 3412,
     /* 274367 */     GIR_EraseRootFromParent_Done,
     /* 274368 */   // Label 5311: @274368
     /* 274368 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(274428), // Rule ID 3423 //
     /* 274373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 274381 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 274384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 274387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274391 */     // MIs[0] Rn
     /* 274391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274403 */     // MIs[0] prfop
     /* 274403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274411 */     // (intrinsic_void 1638:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 274411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 274414 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274416 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274426 */     GIR_RootConstrainSelectedInstOperands,
     /* 274427 */     // GIR_Coverage, 3423,
     /* 274427 */     GIR_EraseRootFromParent_Done,
     /* 274428 */   // Label 5312: @274428
     /* 274428 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(274488), // Rule ID 3424 //
     /* 274433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 274441 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 274444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 274447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274451 */     // MIs[0] Rn
     /* 274451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274463 */     // MIs[0] prfop
     /* 274463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274466 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274471 */     // (intrinsic_void 1637:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 274471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 274474 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274486 */     GIR_RootConstrainSelectedInstOperands,
     /* 274487 */     // GIR_Coverage, 3424,
     /* 274487 */     GIR_EraseRootFromParent_Done,
     /* 274488 */   // Label 5313: @274488
     /* 274488 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(274548), // Rule ID 3425 //
     /* 274493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 274501 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 274504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 274507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274511 */     // MIs[0] Rn
     /* 274511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274523 */     // MIs[0] prfop
     /* 274523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274531 */     // (intrinsic_void 1635:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 274531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 274534 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274546 */     GIR_RootConstrainSelectedInstOperands,
     /* 274547 */     // GIR_Coverage, 3425,
     /* 274547 */     GIR_EraseRootFromParent_Done,
     /* 274548 */   // Label 5314: @274548
     /* 274548 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(274608), // Rule ID 8929 //
     /* 274553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 274561 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 274564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 274567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274571 */     // MIs[0] Rn
     /* 274571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274583 */     // MIs[0] prfop
     /* 274583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274586 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274591 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 274591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 274594 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274606 */     GIR_RootConstrainSelectedInstOperands,
     /* 274607 */     // GIR_Coverage, 8929,
     /* 274607 */     GIR_EraseRootFromParent_Done,
     /* 274608 */   // Label 5315: @274608
     /* 274608 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(274668), // Rule ID 8930 //
     /* 274613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 274621 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 274624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 274627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274631 */     // MIs[0] Rn
     /* 274631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274643 */     // MIs[0] prfop
     /* 274643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274646 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274651 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 274651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 274654 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274666 */     GIR_RootConstrainSelectedInstOperands,
     /* 274667 */     // GIR_Coverage, 8930,
     /* 274667 */     GIR_EraseRootFromParent_Done,
     /* 274668 */   // Label 5316: @274668
     /* 274668 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(274728), // Rule ID 8931 //
     /* 274673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 274681 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 274684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 274687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274691 */     // MIs[0] Rn
     /* 274691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274703 */     // MIs[0] prfop
     /* 274703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274706 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274711 */     // (intrinsic_void 1650:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 274711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 274714 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274726 */     GIR_RootConstrainSelectedInstOperands,
     /* 274727 */     // GIR_Coverage, 8931,
     /* 274727 */     GIR_EraseRootFromParent_Done,
     /* 274728 */   // Label 5317: @274728
     /* 274728 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(274788), // Rule ID 8932 //
     /* 274733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 274741 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 274744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 274747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274751 */     // MIs[0] Rn
     /* 274751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274763 */     // MIs[0] prfop
     /* 274763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274766 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274771 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 274771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 274774 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274786 */     GIR_RootConstrainSelectedInstOperands,
     /* 274787 */     // GIR_Coverage, 8932,
     /* 274787 */     GIR_EraseRootFromParent_Done,
     /* 274788 */   // Label 5318: @274788
     /* 274788 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(274848), // Rule ID 8933 //
     /* 274793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 274801 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 274804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 274807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274811 */     // MIs[0] Rn
     /* 274811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274823 */     // MIs[0] prfop
     /* 274823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274831 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 274831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 274834 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274846 */     GIR_RootConstrainSelectedInstOperands,
     /* 274847 */     // GIR_Coverage, 8933,
     /* 274847 */     GIR_EraseRootFromParent_Done,
     /* 274848 */   // Label 5319: @274848
     /* 274848 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(274908), // Rule ID 8934 //
     /* 274853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 274861 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 274864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 274867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274871 */     // MIs[0] Rn
     /* 274871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274883 */     // MIs[0] prfop
     /* 274883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274891 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 274891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 274894 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274906 */     GIR_RootConstrainSelectedInstOperands,
     /* 274907 */     // GIR_Coverage, 8934,
     /* 274907 */     GIR_EraseRootFromParent_Done,
     /* 274908 */   // Label 5320: @274908
     /* 274908 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(274968), // Rule ID 8935 //
     /* 274913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 274921 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 274924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 274927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274931 */     // MIs[0] Rn
     /* 274931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274943 */     // MIs[0] prfop
     /* 274943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 274946 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 274951 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 274951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 274954 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 274956 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 274958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 274962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274966 */     GIR_RootConstrainSelectedInstOperands,
     /* 274967 */     // GIR_Coverage, 8935,
     /* 274967 */     GIR_EraseRootFromParent_Done,
     /* 274968 */   // Label 5321: @274968
     /* 274968 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(275028), // Rule ID 8936 //
     /* 274973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 274976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 274981 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 274984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 274987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274991 */     // MIs[0] Rn
     /* 274991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 274995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 274999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275003 */     // MIs[0] prfop
     /* 275003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 275006 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 275011 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 275011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 275014 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 275016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 275018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 275022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275026 */     GIR_RootConstrainSelectedInstOperands,
     /* 275027 */     // GIR_Coverage, 8936,
     /* 275027 */     GIR_EraseRootFromParent_Done,
     /* 275028 */   // Label 5322: @275028
     /* 275028 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(275088), // Rule ID 8937 //
     /* 275033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 275036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 275041 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 275044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 275047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275051 */     // MIs[0] Rn
     /* 275051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 275055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 275059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275063 */     // MIs[0] prfop
     /* 275063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 275066 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 275071 */     // (intrinsic_void 1650:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 275071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 275074 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 275076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 275078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 275082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275086 */     GIR_RootConstrainSelectedInstOperands,
     /* 275087 */     // GIR_Coverage, 8937,
     /* 275087 */     GIR_EraseRootFromParent_Done,
     /* 275088 */   // Label 5323: @275088
     /* 275088 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(275148), // Rule ID 8938 //
     /* 275093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 275096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 275101 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 275104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 275107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275111 */     // MIs[0] Rn
     /* 275111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 275115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 275119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275123 */     // MIs[0] prfop
     /* 275123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 275126 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 275131 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 275131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 275134 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 275136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 275138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 275142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275146 */     GIR_RootConstrainSelectedInstOperands,
     /* 275147 */     // GIR_Coverage, 8938,
     /* 275147 */     GIR_EraseRootFromParent_Done,
     /* 275148 */   // Label 5324: @275148
     /* 275148 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(275208), // Rule ID 8939 //
     /* 275153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 275156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 275161 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 275164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 275167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275171 */     // MIs[0] Rn
     /* 275171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 275175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 275179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275183 */     // MIs[0] prfop
     /* 275183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 275186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 275191 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 275191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 275194 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 275196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 275198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 275202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275206 */     GIR_RootConstrainSelectedInstOperands,
     /* 275207 */     // GIR_Coverage, 8939,
     /* 275207 */     GIR_EraseRootFromParent_Done,
     /* 275208 */   // Label 5325: @275208
     /* 275208 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(275268), // Rule ID 8940 //
     /* 275213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 275216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 275221 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 275224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 275227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275231 */     // MIs[0] Rn
     /* 275231 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 275235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 275239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275243 */     // MIs[0] prfop
     /* 275243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 275246 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 275251 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 275251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 275254 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 275256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 275258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 275262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275266 */     GIR_RootConstrainSelectedInstOperands,
     /* 275267 */     // GIR_Coverage, 8940,
     /* 275267 */     GIR_EraseRootFromParent_Done,
     /* 275268 */   // Label 5326: @275268
     /* 275268 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(275328), // Rule ID 8941 //
     /* 275273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 275276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 275281 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 275284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 275287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275291 */     // MIs[0] Rn
     /* 275291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 275295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 275299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275303 */     // MIs[0] prfop
     /* 275303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 275306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 275311 */     // (intrinsic_void 1643:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 275311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 275314 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 275316 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 275318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 275322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275326 */     GIR_RootConstrainSelectedInstOperands,
     /* 275327 */     // GIR_Coverage, 8941,
     /* 275327 */     GIR_EraseRootFromParent_Done,
     /* 275328 */   // Label 5327: @275328
     /* 275328 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(275388), // Rule ID 8942 //
     /* 275333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 275336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 275341 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 275344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 275347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275351 */     // MIs[0] Rn
     /* 275351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 275355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 275359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275363 */     // MIs[0] prfop
     /* 275363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 275366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 275371 */     // (intrinsic_void 1647:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 275371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 275374 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 275376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 275378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 275382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275386 */     GIR_RootConstrainSelectedInstOperands,
     /* 275387 */     // GIR_Coverage, 8942,
     /* 275387 */     GIR_EraseRootFromParent_Done,
     /* 275388 */   // Label 5328: @275388
     /* 275388 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(275448), // Rule ID 8943 //
     /* 275393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 275396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 275401 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 275404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 275407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275411 */     // MIs[0] Rn
     /* 275411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 275415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 275419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 275423 */     // MIs[0] prfop
     /* 275423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 275426 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 275431 */     // (intrinsic_void 1639:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 275431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 275434 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 275436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 275438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 275442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275446 */     GIR_RootConstrainSelectedInstOperands,
     /* 275447 */     // GIR_Coverage, 8943,
     /* 275447 */     GIR_EraseRootFromParent_Done,
     /* 275448 */   // Label 5329: @275448
     /* 275448 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(275506), // Rule ID 2374 //
     /* 275453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 275456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 275461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 275464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 275467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275489 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 275492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275504 */     GIR_RootConstrainSelectedInstOperands,
     /* 275505 */     // GIR_Coverage, 2374,
     /* 275505 */     GIR_EraseRootFromParent_Done,
     /* 275506 */   // Label 5330: @275506
     /* 275506 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(275564), // Rule ID 2375 //
     /* 275511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 275514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 275519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 275522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 275525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275547 */     // (intrinsic_w_chain:{ *:[v8f16] } 629:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 275550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275556 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275562 */     GIR_RootConstrainSelectedInstOperands,
     /* 275563 */     // GIR_Coverage, 2375,
     /* 275563 */     GIR_EraseRootFromParent_Done,
     /* 275564 */   // Label 5331: @275564
     /* 275564 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(275622), // Rule ID 2376 //
     /* 275569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 275572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 275577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275605 */     // (intrinsic_w_chain:{ *:[v4f32] } 621:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 275608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275620 */     GIR_RootConstrainSelectedInstOperands,
     /* 275621 */     // GIR_Coverage, 2376,
     /* 275621 */     GIR_EraseRootFromParent_Done,
     /* 275622 */   // Label 5332: @275622
     /* 275622 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(275680), // Rule ID 2377 //
     /* 275627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 275630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 275635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275663 */     // (intrinsic_w_chain:{ *:[v4f32] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 275666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275678 */     GIR_RootConstrainSelectedInstOperands,
     /* 275679 */     // GIR_Coverage, 2377,
     /* 275679 */     GIR_EraseRootFromParent_Done,
     /* 275680 */   // Label 5333: @275680
     /* 275680 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(275738), // Rule ID 2378 //
     /* 275685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 275688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 275693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275721 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 275724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275730 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275736 */     GIR_RootConstrainSelectedInstOperands,
     /* 275737 */     // GIR_Coverage, 2378,
     /* 275737 */     GIR_EraseRootFromParent_Done,
     /* 275738 */   // Label 5334: @275738
     /* 275738 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(275796), // Rule ID 2379 //
     /* 275743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 275746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 275751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275779 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 275782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275788 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275794 */     GIR_RootConstrainSelectedInstOperands,
     /* 275795 */     // GIR_Coverage, 2379,
     /* 275795 */     GIR_EraseRootFromParent_Done,
     /* 275796 */   // Label 5335: @275796
     /* 275796 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(275854), // Rule ID 2380 //
     /* 275801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 275804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 275809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 275812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 275815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 275818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 275821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275837 */     // (intrinsic_w_chain:{ *:[v4f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 275837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 275840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275846 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275852 */     GIR_RootConstrainSelectedInstOperands,
     /* 275853 */     // GIR_Coverage, 2380,
     /* 275853 */     GIR_EraseRootFromParent_Done,
     /* 275854 */   // Label 5336: @275854
     /* 275854 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(275912), // Rule ID 2381 //
     /* 275859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 275862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 275867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 275870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 275873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275895 */     // (intrinsic_w_chain:{ *:[v8f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 275895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 275898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275910 */     GIR_RootConstrainSelectedInstOperands,
     /* 275911 */     // GIR_Coverage, 2381,
     /* 275911 */     GIR_EraseRootFromParent_Done,
     /* 275912 */   // Label 5337: @275912
     /* 275912 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(275970), // Rule ID 2382 //
     /* 275917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 275920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 275925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 275928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 275931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 275934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 275937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275953 */     // (intrinsic_w_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 275953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 275956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 275958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 275960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275962 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 275964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275968 */     GIR_RootConstrainSelectedInstOperands,
     /* 275969 */     // GIR_Coverage, 2382,
     /* 275969 */     GIR_EraseRootFromParent_Done,
     /* 275970 */   // Label 5338: @275970
     /* 275970 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(276028), // Rule ID 2383 //
     /* 275975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 275978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 275983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 275986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 275992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 275995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276011 */     // (intrinsic_w_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 276011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 276014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 276018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276020 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276026 */     GIR_RootConstrainSelectedInstOperands,
     /* 276027 */     // GIR_Coverage, 2383,
     /* 276027 */     GIR_EraseRootFromParent_Done,
     /* 276028 */   // Label 5339: @276028
     /* 276028 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(276086), // Rule ID 2491 //
     /* 276033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 276036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 276041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 276044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 276047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 276050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 276053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276069 */     // (intrinsic_w_chain:{ *:[v16i8] } 614:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 276069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 276072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276074 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 276076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276084 */     GIR_RootConstrainSelectedInstOperands,
     /* 276085 */     // GIR_Coverage, 2491,
     /* 276085 */     GIR_EraseRootFromParent_Done,
     /* 276086 */   // Label 5340: @276086
     /* 276086 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(276142), // Rule ID 13203 //
     /* 276091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 276096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 276099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 276102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 276105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 276109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 276113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 276117 */     // MIs[0] addr
     /* 276117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 276121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 276125 */     // (intrinsic_w_chain:{ *:[i32] } 1238:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 276125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 276128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 276130 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 276132 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 276134 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 276136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276140 */     GIR_RootConstrainSelectedInstOperands,
     /* 276141 */     // GIR_Coverage, 13203,
     /* 276141 */     GIR_EraseRootFromParent_Done,
     /* 276142 */   // Label 5341: @276142
     /* 276142 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(276198), // Rule ID 13204 //
     /* 276147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 276152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 276155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 276158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 276161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 276165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 276169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 276173 */     // MIs[0] addr
     /* 276173 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 276177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 276181 */     // (intrinsic_w_chain:{ *:[i32] } 1240:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 276181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 276184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 276186 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 276188 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 276190 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 276192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276196 */     GIR_RootConstrainSelectedInstOperands,
     /* 276197 */     // GIR_Coverage, 13204,
     /* 276197 */     GIR_EraseRootFromParent_Done,
     /* 276198 */   // Label 5342: @276198
     /* 276198 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(276244), // Rule ID 3459 //
     /* 276203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 276206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 276211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 276214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 276217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276227 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1503:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 276230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276242 */     GIR_RootConstrainSelectedInstOperands,
     /* 276243 */     // GIR_Coverage, 3459,
     /* 276243 */     GIR_EraseRootFromParent_Done,
     /* 276244 */   // Label 5343: @276244
     /* 276244 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(276290), // Rule ID 3581 //
     /* 276249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 276257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 276260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 276263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276273 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1505:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 276276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276288 */     GIR_RootConstrainSelectedInstOperands,
     /* 276289 */     // GIR_Coverage, 3581,
     /* 276289 */     GIR_EraseRootFromParent_Done,
     /* 276290 */   // Label 5344: @276290
     /* 276290 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(276336), // Rule ID 12631 //
     /* 276295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 276303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 276306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 276309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276319 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1515:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 276322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276334 */     GIR_RootConstrainSelectedInstOperands,
     /* 276335 */     // GIR_Coverage, 12631,
     /* 276335 */     GIR_EraseRootFromParent_Done,
     /* 276336 */   // Label 5345: @276336
     /* 276336 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(276382), // Rule ID 12635 //
     /* 276341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 276349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 276352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 276355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276365 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1507:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 276368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276380 */     GIR_RootConstrainSelectedInstOperands,
     /* 276381 */     // GIR_Coverage, 12635,
     /* 276381 */     GIR_EraseRootFromParent_Done,
     /* 276382 */   // Label 5346: @276382
     /* 276382 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(276428), // Rule ID 12636 //
     /* 276387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 276395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 276398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 276401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276411 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1509:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 276414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276426 */     GIR_RootConstrainSelectedInstOperands,
     /* 276427 */     // GIR_Coverage, 12636,
     /* 276427 */     GIR_EraseRootFromParent_Done,
     /* 276428 */   // Label 5347: @276428
     /* 276428 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(276474), // Rule ID 12637 //
     /* 276433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 276441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 276444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 276447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276457 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1511:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 276460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276472 */     GIR_RootConstrainSelectedInstOperands,
     /* 276473 */     // GIR_Coverage, 12637,
     /* 276473 */     GIR_EraseRootFromParent_Done,
     /* 276474 */   // Label 5348: @276474
     /* 276474 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(276520), // Rule ID 12638 //
     /* 276479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 276487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 276490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 276493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276503 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1513:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 276506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276512 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276518 */     GIR_RootConstrainSelectedInstOperands,
     /* 276519 */     // GIR_Coverage, 12638,
     /* 276519 */     GIR_EraseRootFromParent_Done,
     /* 276520 */   // Label 5349: @276520
     /* 276520 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(276566), // Rule ID 12639 //
     /* 276525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 276528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 276533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 276536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 276539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276549 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1503:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 276549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 276552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276564 */     GIR_RootConstrainSelectedInstOperands,
     /* 276565 */     // GIR_Coverage, 12639,
     /* 276565 */     GIR_EraseRootFromParent_Done,
     /* 276566 */   // Label 5350: @276566
     /* 276566 */   GIM_Reject,
     /* 276567 */ // Label 5303: @276567
     /* 276567 */ GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(279560),
     /* 276572 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 276575 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(276643), // Rule ID 2518 //
     /* 276580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 276583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 276588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 276591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 276594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 276597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 276600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 276616 */     // MIs[0] Idx
     /* 276616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 276624 */     // (intrinsic_w_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 276624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 276627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 276631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276633 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276635 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 276637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276641 */     GIR_RootConstrainSelectedInstOperands,
     /* 276642 */     // GIR_Coverage, 2518,
     /* 276642 */     GIR_EraseRootFromParent_Done,
     /* 276643 */   // Label 5352: @276643
     /* 276643 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(276711), // Rule ID 2519 //
     /* 276648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 276651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 276656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 276659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 276665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 276668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 276684 */     // MIs[0] Idx
     /* 276684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 276692 */     // (intrinsic_w_chain:{ *:[v4f32] } 622:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 276692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 276695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 276699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276703 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 276705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276709 */     GIR_RootConstrainSelectedInstOperands,
     /* 276710 */     // GIR_Coverage, 2519,
     /* 276710 */     GIR_EraseRootFromParent_Done,
     /* 276711 */   // Label 5353: @276711
     /* 276711 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(276779), // Rule ID 2520 //
     /* 276716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 276719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 276724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 276727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 276730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 276733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 276736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276752 */     // MIs[0] Idx
     /* 276752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276755 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 276760 */     // (intrinsic_w_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 276760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 276763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 276767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276771 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 276773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276777 */     GIR_RootConstrainSelectedInstOperands,
     /* 276778 */     // GIR_Coverage, 2520,
     /* 276778 */     GIR_EraseRootFromParent_Done,
     /* 276779 */   // Label 5354: @276779
     /* 276779 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(276847), // Rule ID 2521 //
     /* 276784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 276787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 276792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 276795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 276798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 276801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 276804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276820 */     // MIs[0] Idx
     /* 276820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276823 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 276828 */     // (intrinsic_w_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 276828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 276831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 276835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276839 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 276841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276845 */     GIR_RootConstrainSelectedInstOperands,
     /* 276846 */     // GIR_Coverage, 2521,
     /* 276846 */     GIR_EraseRootFromParent_Done,
     /* 276847 */   // Label 5355: @276847
     /* 276847 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(276915), // Rule ID 2522 //
     /* 276852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 276855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 276860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 276863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 276866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 276869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 276872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 276888 */     // MIs[0] Idx
     /* 276888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276891 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 276896 */     // (intrinsic_w_chain:{ *:[v4f16] } 616:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 276896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 276899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 276903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276905 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276907 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 276909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276913 */     GIR_RootConstrainSelectedInstOperands,
     /* 276914 */     // GIR_Coverage, 2522,
     /* 276914 */     GIR_EraseRootFromParent_Done,
     /* 276915 */   // Label 5356: @276915
     /* 276915 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(276983), // Rule ID 2523 //
     /* 276920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 276923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 276928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 276931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 276934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 276937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 276940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 276956 */     // MIs[0] Idx
     /* 276956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 276959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 276964 */     // (intrinsic_w_chain:{ *:[v8f16] } 616:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 276964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 276967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 276969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 276971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 276975 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 276977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276981 */     GIR_RootConstrainSelectedInstOperands,
     /* 276982 */     // GIR_Coverage, 2523,
     /* 276982 */     GIR_EraseRootFromParent_Done,
     /* 276983 */   // Label 5357: @276983
     /* 276983 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(277051), // Rule ID 7039 //
     /* 276988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 276991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 276996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 276999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 277002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 277005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 277008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 277024 */     // MIs[0] Idx
     /* 277024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 277027 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 277032 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 277032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 277035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 277039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277041 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 277043 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 277045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277049 */     GIR_RootConstrainSelectedInstOperands,
     /* 277050 */     // GIR_Coverage, 7039,
     /* 277050 */     GIR_EraseRootFromParent_Done,
     /* 277051 */   // Label 5358: @277051
     /* 277051 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(277119), // Rule ID 7040 //
     /* 277056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 277059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 277064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 277067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 277070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 277073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 277076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 277092 */     // MIs[0] Idx
     /* 277092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 277095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 277100 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 277100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 277103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 277107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 277111 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 277113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277117 */     GIR_RootConstrainSelectedInstOperands,
     /* 277118 */     // GIR_Coverage, 7040,
     /* 277118 */     GIR_EraseRootFromParent_Done,
     /* 277119 */   // Label 5359: @277119
     /* 277119 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(277187), // Rule ID 7041 //
     /* 277124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 277127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 277132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 277135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 277138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 277141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 277144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 277160 */     // MIs[0] Idx
     /* 277160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 277163 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 277168 */     // (intrinsic_w_chain:{ *:[v4f32] } 626:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 277168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 277171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 277175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277177 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 277179 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 277181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277185 */     GIR_RootConstrainSelectedInstOperands,
     /* 277186 */     // GIR_Coverage, 7041,
     /* 277186 */     GIR_EraseRootFromParent_Done,
     /* 277187 */   // Label 5360: @277187
     /* 277187 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(277255), // Rule ID 7042 //
     /* 277192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 277195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 277200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 277203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 277206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 277209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 277212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 277228 */     // MIs[0] Idx
     /* 277228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 277231 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 277236 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 277236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 277239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 277243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 277247 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 277249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277253 */     GIR_RootConstrainSelectedInstOperands,
     /* 277254 */     // GIR_Coverage, 7042,
     /* 277254 */     GIR_EraseRootFromParent_Done,
     /* 277255 */   // Label 5361: @277255
     /* 277255 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(277315), // Rule ID 3593 //
     /* 277260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 277263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 277268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 277271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 277274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 277277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 277280 */     // MIs[0] tile
     /* 277280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277296 */     // (intrinsic_void 928:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 277296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 277299 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277307 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277313 */     GIR_RootConstrainSelectedInstOperands,
     /* 277314 */     // GIR_Coverage, 3593,
     /* 277314 */     GIR_EraseRootFromParent_Done,
     /* 277315 */   // Label 5362: @277315
     /* 277315 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(277375), // Rule ID 3594 //
     /* 277320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 277323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 277328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 277331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 277334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 277340 */     // MIs[0] tile
     /* 277340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277356 */     // (intrinsic_void 880:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 277356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 277359 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277367 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277373 */     GIR_RootConstrainSelectedInstOperands,
     /* 277374 */     // GIR_Coverage, 3594,
     /* 277374 */     GIR_EraseRootFromParent_Done,
     /* 277375 */   // Label 5363: @277375
     /* 277375 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(277435), // Rule ID 3595 //
     /* 277380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 277383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 277388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 277391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 277394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 277397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 277400 */     // MIs[0] tile
     /* 277400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 277408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277416 */     // (intrinsic_void 928:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 277416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 277419 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277427 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277433 */     GIR_RootConstrainSelectedInstOperands,
     /* 277434 */     // GIR_Coverage, 3595,
     /* 277434 */     GIR_EraseRootFromParent_Done,
     /* 277435 */   // Label 5364: @277435
     /* 277435 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(277495), // Rule ID 3596 //
     /* 277440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 277443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 277448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 277451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 277454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 277460 */     // MIs[0] tile
     /* 277460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277463 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 277468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277476 */     // (intrinsic_void 879:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 277476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 277479 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277487 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277493 */     GIR_RootConstrainSelectedInstOperands,
     /* 277494 */     // GIR_Coverage, 3596,
     /* 277494 */     GIR_EraseRootFromParent_Done,
     /* 277495 */   // Label 5365: @277495
     /* 277495 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(277555), // Rule ID 3597 //
     /* 277500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 277503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 277508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 277511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 277514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 277517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 277520 */     // MIs[0] tile
     /* 277520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277523 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 277528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277536 */     // (intrinsic_void 928:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 277536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 277539 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277547 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277553 */     GIR_RootConstrainSelectedInstOperands,
     /* 277554 */     // GIR_Coverage, 3597,
     /* 277554 */     GIR_EraseRootFromParent_Done,
     /* 277555 */   // Label 5366: @277555
     /* 277555 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(277615), // Rule ID 3598 //
     /* 277560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 277563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 277568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 277571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 277574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 277580 */     // MIs[0] tile
     /* 277580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277583 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277596 */     // (intrinsic_void 1031:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 277596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 277599 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277607 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277613 */     GIR_RootConstrainSelectedInstOperands,
     /* 277614 */     // GIR_Coverage, 3598,
     /* 277614 */     GIR_EraseRootFromParent_Done,
     /* 277615 */   // Label 5367: @277615
     /* 277615 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(277675), // Rule ID 3599 //
     /* 277620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 277623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 277628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 277631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 277634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 277637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 277640 */     // MIs[0] tile
     /* 277640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277643 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 277648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277656 */     // (intrinsic_void 1031:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 277656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 277659 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277665 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277667 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277673 */     GIR_RootConstrainSelectedInstOperands,
     /* 277674 */     // GIR_Coverage, 3599,
     /* 277674 */     GIR_EraseRootFromParent_Done,
     /* 277675 */   // Label 5368: @277675
     /* 277675 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(277735), // Rule ID 3600 //
     /* 277680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 277683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 277688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 277691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 277694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 277697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 277700 */     // MIs[0] tile
     /* 277700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277703 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277716 */     // (intrinsic_void 930:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 277716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 277719 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277725 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277727 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277733 */     GIR_RootConstrainSelectedInstOperands,
     /* 277734 */     // GIR_Coverage, 3600,
     /* 277734 */     GIR_EraseRootFromParent_Done,
     /* 277735 */   // Label 5369: @277735
     /* 277735 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(277795), // Rule ID 3694 //
     /* 277740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 277743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 277748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 277751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 277754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 277757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 277760 */     // MIs[0] tile
     /* 277760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277763 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277776 */     // (intrinsic_void 1032:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 277776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 277779 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277787 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277793 */     GIR_RootConstrainSelectedInstOperands,
     /* 277794 */     // GIR_Coverage, 3694,
     /* 277794 */     GIR_EraseRootFromParent_Done,
     /* 277795 */   // Label 5370: @277795
     /* 277795 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(277855), // Rule ID 3695 //
     /* 277800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 277803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 277808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 277811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 277814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 277817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 277820 */     // MIs[0] tile
     /* 277820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277823 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277836 */     // (intrinsic_void 799:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 277836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 277839 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277845 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277847 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277853 */     GIR_RootConstrainSelectedInstOperands,
     /* 277854 */     // GIR_Coverage, 3695,
     /* 277854 */     GIR_EraseRootFromParent_Done,
     /* 277855 */   // Label 5371: @277855
     /* 277855 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(277915), // Rule ID 12646 //
     /* 277860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 277863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 277868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 277871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 277874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 277877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 277880 */     // MIs[0] tile
     /* 277880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277883 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 277888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277896 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 277896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 277899 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277905 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277907 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277913 */     GIR_RootConstrainSelectedInstOperands,
     /* 277914 */     // GIR_Coverage, 12646,
     /* 277914 */     GIR_EraseRootFromParent_Done,
     /* 277915 */   // Label 5372: @277915
     /* 277915 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(277975), // Rule ID 12647 //
     /* 277920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 277923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 277928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 277931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 277934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 277937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 277940 */     // MIs[0] tile
     /* 277940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 277943 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 277948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 277956 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 277956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 277959 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 277961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 277963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 277965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 277967 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 277969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277973 */     GIR_RootConstrainSelectedInstOperands,
     /* 277974 */     // GIR_Coverage, 12647,
     /* 277974 */     GIR_EraseRootFromParent_Done,
     /* 277975 */   // Label 5373: @277975
     /* 277975 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(278035), // Rule ID 12648 //
     /* 277980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 277983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 277988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 277991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 277994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 277997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278000 */     // MIs[0] tile
     /* 278000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278003 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278016 */     // (intrinsic_void 933:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 278016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 278019 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278025 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278027 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278033 */     GIR_RootConstrainSelectedInstOperands,
     /* 278034 */     // GIR_Coverage, 12648,
     /* 278034 */     GIR_EraseRootFromParent_Done,
     /* 278035 */   // Label 5374: @278035
     /* 278035 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(278095), // Rule ID 12649 //
     /* 278040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 278043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 278048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 278051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 278054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 278057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 278060 */     // MIs[0] tile
     /* 278060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278076 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 278076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 278079 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278087 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278093 */     GIR_RootConstrainSelectedInstOperands,
     /* 278094 */     // GIR_Coverage, 12649,
     /* 278094 */     GIR_EraseRootFromParent_Done,
     /* 278095 */   // Label 5375: @278095
     /* 278095 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(278155), // Rule ID 12650 //
     /* 278100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 278103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 278108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 278111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 278114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 278117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 278120 */     // MIs[0] tile
     /* 278120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278136 */     // (intrinsic_void 1166:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 278136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 278139 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278145 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278147 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278153 */     GIR_RootConstrainSelectedInstOperands,
     /* 278154 */     // GIR_Coverage, 12650,
     /* 278154 */     GIR_EraseRootFromParent_Done,
     /* 278155 */   // Label 5376: @278155
     /* 278155 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(278215), // Rule ID 12651 //
     /* 278160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 278163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 278168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 278171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 278174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 278177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 278180 */     // MIs[0] tile
     /* 278180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278183 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278196 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 278196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 278199 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278205 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278207 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278213 */     GIR_RootConstrainSelectedInstOperands,
     /* 278214 */     // GIR_Coverage, 12651,
     /* 278214 */     GIR_EraseRootFromParent_Done,
     /* 278215 */   // Label 5377: @278215
     /* 278215 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(278275), // Rule ID 12652 //
     /* 278220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 278223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 278228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 278231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 278234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 278237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 278240 */     // MIs[0] tile
     /* 278240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278243 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278256 */     // (intrinsic_void 1083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 278256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 278259 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278267 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278273 */     GIR_RootConstrainSelectedInstOperands,
     /* 278274 */     // GIR_Coverage, 12652,
     /* 278274 */     GIR_EraseRootFromParent_Done,
     /* 278275 */   // Label 5378: @278275
     /* 278275 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(278335), // Rule ID 12653 //
     /* 278280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 278283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 278288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 278291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 278294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 278297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 278300 */     // MIs[0] tile
     /* 278300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278316 */     // (intrinsic_void 1084:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 278316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 278319 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278327 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278333 */     GIR_RootConstrainSelectedInstOperands,
     /* 278334 */     // GIR_Coverage, 12653,
     /* 278334 */     GIR_EraseRootFromParent_Done,
     /* 278335 */   // Label 5379: @278335
     /* 278335 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(278395), // Rule ID 12654 //
     /* 278340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 278343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 278348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 278351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 278354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 278357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 278360 */     // MIs[0] tile
     /* 278360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278363 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278376 */     // (intrinsic_void 1200:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 278376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 278379 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278387 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278393 */     GIR_RootConstrainSelectedInstOperands,
     /* 278394 */     // GIR_Coverage, 12654,
     /* 278394 */     GIR_EraseRootFromParent_Done,
     /* 278395 */   // Label 5380: @278395
     /* 278395 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(278455), // Rule ID 12655 //
     /* 278400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 278403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 278408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 278411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 278414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 278417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 278420 */     // MIs[0] tile
     /* 278420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278423 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278436 */     // (intrinsic_void 1201:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 278436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 278439 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278445 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278447 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278453 */     GIR_RootConstrainSelectedInstOperands,
     /* 278454 */     // GIR_Coverage, 12655,
     /* 278454 */     GIR_EraseRootFromParent_Done,
     /* 278455 */   // Label 5381: @278455
     /* 278455 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(278515), // Rule ID 12656 //
     /* 278460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 278463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 278468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278480 */     // MIs[0] tile
     /* 278480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278483 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 278488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278496 */     // (intrinsic_void 1033:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 278499 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278505 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278507 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278513 */     GIR_RootConstrainSelectedInstOperands,
     /* 278514 */     // GIR_Coverage, 12656,
     /* 278514 */     GIR_EraseRootFromParent_Done,
     /* 278515 */   // Label 5382: @278515
     /* 278515 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(278575), // Rule ID 12657 //
     /* 278520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 278523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 278528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278540 */     // MIs[0] tile
     /* 278540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278543 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 278548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278556 */     // (intrinsic_void 1166:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 278559 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278567 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278573 */     GIR_RootConstrainSelectedInstOperands,
     /* 278574 */     // GIR_Coverage, 12657,
     /* 278574 */     GIR_EraseRootFromParent_Done,
     /* 278575 */   // Label 5383: @278575
     /* 278575 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(278635), // Rule ID 12658 //
     /* 278580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 278583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 278588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278600 */     // MIs[0] tile
     /* 278600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 278608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278616 */     // (intrinsic_void 1168:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 278619 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278627 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278633 */     GIR_RootConstrainSelectedInstOperands,
     /* 278634 */     // GIR_Coverage, 12658,
     /* 278634 */     GIR_EraseRootFromParent_Done,
     /* 278635 */   // Label 5384: @278635
     /* 278635 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(278695), // Rule ID 12659 //
     /* 278640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 278643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 278648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278660 */     // MIs[0] tile
     /* 278660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 278668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278676 */     // (intrinsic_void 1083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 278679 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278687 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278693 */     GIR_RootConstrainSelectedInstOperands,
     /* 278694 */     // GIR_Coverage, 12659,
     /* 278694 */     GIR_EraseRootFromParent_Done,
     /* 278695 */   // Label 5385: @278695
     /* 278695 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(278755), // Rule ID 12660 //
     /* 278700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 278703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 278708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278720 */     // MIs[0] tile
     /* 278720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 278728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278736 */     // (intrinsic_void 1084:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 278739 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278747 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278753 */     GIR_RootConstrainSelectedInstOperands,
     /* 278754 */     // GIR_Coverage, 12660,
     /* 278754 */     GIR_EraseRootFromParent_Done,
     /* 278755 */   // Label 5386: @278755
     /* 278755 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(278815), // Rule ID 12661 //
     /* 278760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 278763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 278768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278780 */     // MIs[0] tile
     /* 278780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 278788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278796 */     // (intrinsic_void 1200:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 278799 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278807 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278813 */     GIR_RootConstrainSelectedInstOperands,
     /* 278814 */     // GIR_Coverage, 12661,
     /* 278814 */     GIR_EraseRootFromParent_Done,
     /* 278815 */   // Label 5387: @278815
     /* 278815 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(278875), // Rule ID 12662 //
     /* 278820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 278823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 278828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278840 */     // MIs[0] tile
     /* 278840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 278848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278856 */     // (intrinsic_void 1201:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 278859 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278867 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278873 */     GIR_RootConstrainSelectedInstOperands,
     /* 278874 */     // GIR_Coverage, 12662,
     /* 278874 */     GIR_EraseRootFromParent_Done,
     /* 278875 */   // Label 5388: @278875
     /* 278875 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(278935), // Rule ID 13036 //
     /* 278880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 278883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 278888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 278891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 278894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 278897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 278900 */     // MIs[0] tile
     /* 278900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278916 */     // (intrinsic_void 800:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 278916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 278919 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278925 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278927 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278933 */     GIR_RootConstrainSelectedInstOperands,
     /* 278934 */     // GIR_Coverage, 13036,
     /* 278934 */     GIR_EraseRootFromParent_Done,
     /* 278935 */   // Label 5389: @278935
     /* 278935 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(278995), // Rule ID 13037 //
     /* 278940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 278943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 278948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 278951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 278954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 278957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 278960 */     // MIs[0] tile
     /* 278960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 278963 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 278968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 278976 */     // (intrinsic_void 1034:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 278976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 278979 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 278981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 278983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 278985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 278987 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 278989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 278993 */     GIR_RootConstrainSelectedInstOperands,
     /* 278994 */     // GIR_Coverage, 13037,
     /* 278994 */     GIR_EraseRootFromParent_Done,
     /* 278995 */   // Label 5390: @278995
     /* 278995 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(279055), // Rule ID 13038 //
     /* 279000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 279003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 279008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 279011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 279014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 279017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 279020 */     // MIs[0] tile
     /* 279020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 279023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 279028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 279032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 279036 */     // (intrinsic_void 1167:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 279036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 279039 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 279041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 279043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 279045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 279047 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 279049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279053 */     GIR_RootConstrainSelectedInstOperands,
     /* 279054 */     // GIR_Coverage, 13038,
     /* 279054 */     GIR_EraseRootFromParent_Done,
     /* 279055 */   // Label 5391: @279055
     /* 279055 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(279115), // Rule ID 13039 //
     /* 279060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 279063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 279068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 279071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 279074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 279077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 279080 */     // MIs[0] tile
     /* 279080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 279083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 279088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 279092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 279096 */     // (intrinsic_void 1169:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 279096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 279099 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 279101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 279103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 279105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 279107 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 279109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279113 */     GIR_RootConstrainSelectedInstOperands,
     /* 279114 */     // GIR_Coverage, 13039,
     /* 279114 */     GIR_EraseRootFromParent_Done,
     /* 279115 */   // Label 5392: @279115
     /* 279115 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(279175), // Rule ID 13150 //
     /* 279120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 279123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 279128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 279131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 279134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 279137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 279140 */     // MIs[0] tile
     /* 279140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 279143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 279148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 279152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 279156 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 279156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 279159 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 279161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 279163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 279165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 279167 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 279169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279173 */     GIR_RootConstrainSelectedInstOperands,
     /* 279174 */     // GIR_Coverage, 13150,
     /* 279174 */     GIR_EraseRootFromParent_Done,
     /* 279175 */   // Label 5393: @279175
     /* 279175 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(279223), // Rule ID 3580 //
     /* 279180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 279183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 279188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 279191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 279194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 279197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 279200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279204 */     // MIs[0] Op4
     /* 279204 */     // No operand predicates
     /* 279204 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1506:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 279204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 279207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 279209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 279211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 279213 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 279215 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 279217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279221 */     GIR_RootConstrainSelectedInstOperands,
     /* 279222 */     // GIR_Coverage, 3580,
     /* 279222 */     GIR_EraseRootFromParent_Done,
     /* 279223 */   // Label 5394: @279223
     /* 279223 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(279271), // Rule ID 3582 //
     /* 279228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 279231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 279236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 279239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 279242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 279245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 279248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279252 */     // MIs[0] Op4
     /* 279252 */     // No operand predicates
     /* 279252 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1508:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 279252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 279255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 279257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 279259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 279261 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 279263 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 279265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279269 */     GIR_RootConstrainSelectedInstOperands,
     /* 279270 */     // GIR_Coverage, 3582,
     /* 279270 */     GIR_EraseRootFromParent_Done,
     /* 279271 */   // Label 5395: @279271
     /* 279271 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(279319), // Rule ID 3583 //
     /* 279276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 279279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 279284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 279287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 279290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 279293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 279296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279300 */     // MIs[0] Op4
     /* 279300 */     // No operand predicates
     /* 279300 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1504:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 279300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 279303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 279305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 279307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 279309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 279311 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 279313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279317 */     GIR_RootConstrainSelectedInstOperands,
     /* 279318 */     // GIR_Coverage, 3583,
     /* 279318 */     GIR_EraseRootFromParent_Done,
     /* 279319 */   // Label 5396: @279319
     /* 279319 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(279367), // Rule ID 3584 //
     /* 279324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 279327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 279332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 279335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 279338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 279341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 279344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279348 */     // MIs[0] Op4
     /* 279348 */     // No operand predicates
     /* 279348 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1504:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 279348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 279351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 279353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 279355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 279357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 279359 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 279361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279365 */     GIR_RootConstrainSelectedInstOperands,
     /* 279366 */     // GIR_Coverage, 3584,
     /* 279366 */     GIR_EraseRootFromParent_Done,
     /* 279367 */   // Label 5397: @279367
     /* 279367 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(279415), // Rule ID 12630 //
     /* 279372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 279375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 279380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 279383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 279386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 279389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 279392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279396 */     // MIs[0] Op4
     /* 279396 */     // No operand predicates
     /* 279396 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1516:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 279396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 279399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 279401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 279403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 279405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 279407 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 279409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279413 */     GIR_RootConstrainSelectedInstOperands,
     /* 279414 */     // GIR_Coverage, 12630,
     /* 279414 */     GIR_EraseRootFromParent_Done,
     /* 279415 */   // Label 5398: @279415
     /* 279415 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(279463), // Rule ID 12632 //
     /* 279420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 279423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 279428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 279431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 279434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 279437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 279440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279444 */     // MIs[0] Op4
     /* 279444 */     // No operand predicates
     /* 279444 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1510:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 279444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 279447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 279449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 279451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 279453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 279455 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 279457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279461 */     GIR_RootConstrainSelectedInstOperands,
     /* 279462 */     // GIR_Coverage, 12632,
     /* 279462 */     GIR_EraseRootFromParent_Done,
     /* 279463 */   // Label 5399: @279463
     /* 279463 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(279511), // Rule ID 12633 //
     /* 279468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 279471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 279476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 279479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 279482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 279485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 279488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279492 */     // MIs[0] Op4
     /* 279492 */     // No operand predicates
     /* 279492 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1512:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 279492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 279495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 279497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 279499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 279501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 279503 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 279505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279509 */     GIR_RootConstrainSelectedInstOperands,
     /* 279510 */     // GIR_Coverage, 12633,
     /* 279510 */     GIR_EraseRootFromParent_Done,
     /* 279511 */   // Label 5400: @279511
     /* 279511 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(279559), // Rule ID 12634 //
     /* 279516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 279519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 279524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 279527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 279530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 279533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 279536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279540 */     // MIs[0] Op4
     /* 279540 */     // No operand predicates
     /* 279540 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1514:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 279540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 279543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 279545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 279547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 279549 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 279551 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 279553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 279557 */     GIR_RootConstrainSelectedInstOperands,
     /* 279558 */     // GIR_Coverage, 12634,
     /* 279558 */     GIR_EraseRootFromParent_Done,
     /* 279559 */   // Label 5401: @279559
     /* 279559 */   GIM_Reject,
     /* 279560 */ // Label 5351: @279560
     /* 279560 */ GIM_Reject,
     /* 279561 */ // Label 39: @279561
     /* 279561 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5406*/ GIMT_Encode4(279850),
     /* 279572 */ /*GILLT_s64*//*Label 5402*/ GIMT_Encode4(279604), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 279584 */ /*GILLT_v2s64*//*Label 5403*/ GIMT_Encode4(279664), GIMT_Encode4(0),
     /* 279592 */ /*GILLT_v4s32*//*Label 5404*/ GIMT_Encode4(279726), GIMT_Encode4(0),
     /* 279600 */ /*GILLT_v8s16*//*Label 5405*/ GIMT_Encode4(279788),
     /* 279604 */ // Label 5402: @279604
     /* 279604 */ GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(279663), // Rule ID 6551 //
     /* 279609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 279612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 279616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279620 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 279620 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 279623 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279627 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279639 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279642 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 279644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 279647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 279652 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 279657 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279662 */   // GIR_Coverage, 6551,
     /* 279662 */   GIR_EraseRootFromParent_Done,
     /* 279663 */ // Label 5407: @279663
     /* 279663 */ GIM_Reject,
     /* 279664 */ // Label 5403: @279664
     /* 279664 */ GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(279725),
     /* 279669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 279672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279676 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(279703), // Rule ID 6421 //
     /* 279681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 279688 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 279688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 279691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 279698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279701 */     GIR_RootConstrainSelectedInstOperands,
     /* 279702 */     // GIR_Coverage, 6421,
     /* 279702 */     GIR_EraseRootFromParent_Done,
     /* 279703 */   // Label 5409: @279703
     /* 279703 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(279724), // Rule ID 6414 //
     /* 279708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279712 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 279712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 279715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 279719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279722 */     GIR_RootConstrainSelectedInstOperands,
     /* 279723 */     // GIR_Coverage, 6414,
     /* 279723 */     GIR_EraseRootFromParent_Done,
     /* 279724 */   // Label 5410: @279724
     /* 279724 */   GIM_Reject,
     /* 279725 */ // Label 5408: @279725
     /* 279725 */ GIM_Reject,
     /* 279726 */ // Label 5404: @279726
     /* 279726 */ GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(279787),
     /* 279731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 279734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279738 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(279765), // Rule ID 6418 //
     /* 279743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 279750 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 279750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 279753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 279760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279763 */     GIR_RootConstrainSelectedInstOperands,
     /* 279764 */     // GIR_Coverage, 6418,
     /* 279764 */     GIR_EraseRootFromParent_Done,
     /* 279765 */   // Label 5412: @279765
     /* 279765 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(279786), // Rule ID 6411 //
     /* 279770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279774 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 279774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 279777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 279781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279784 */     GIR_RootConstrainSelectedInstOperands,
     /* 279785 */     // GIR_Coverage, 6411,
     /* 279785 */     GIR_EraseRootFromParent_Done,
     /* 279786 */   // Label 5413: @279786
     /* 279786 */   GIM_Reject,
     /* 279787 */ // Label 5411: @279787
     /* 279787 */ GIM_Reject,
     /* 279788 */ // Label 5405: @279788
     /* 279788 */ GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(279849),
     /* 279793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 279796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279800 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(279827), // Rule ID 6415 //
     /* 279805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 279812 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 279812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 279815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 279822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279825 */     GIR_RootConstrainSelectedInstOperands,
     /* 279826 */     // GIR_Coverage, 6415,
     /* 279826 */     GIR_EraseRootFromParent_Done,
     /* 279827 */   // Label 5415: @279827
     /* 279827 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(279848), // Rule ID 6408 //
     /* 279832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279836 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 279836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 279839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 279843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279846 */     GIR_RootConstrainSelectedInstOperands,
     /* 279847 */     // GIR_Coverage, 6408,
     /* 279847 */     GIR_EraseRootFromParent_Done,
     /* 279848 */   // Label 5416: @279848
     /* 279848 */   GIM_Reject,
     /* 279849 */ // Label 5414: @279849
     /* 279849 */ GIM_Reject,
     /* 279850 */ // Label 5406: @279850
     /* 279850 */ GIM_Reject,
     /* 279851 */ // Label 40: @279851
     /* 279851 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5421*/ GIMT_Encode4(281287),
     /* 279862 */ /*GILLT_s32*//*Label 5417*/ GIMT_Encode4(279894), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 279874 */ /*GILLT_v2s32*//*Label 5418*/ GIMT_Encode4(279933), GIMT_Encode4(0),
     /* 279882 */ /*GILLT_v4s16*//*Label 5419*/ GIMT_Encode4(280289), GIMT_Encode4(0),
     /* 279890 */ /*GILLT_v8s8*//*Label 5420*/ GIMT_Encode4(280788),
     /* 279894 */ // Label 5417: @279894
     /* 279894 */ GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(279932), // Rule ID 6572 //
     /* 279899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 279902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 279906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 279910 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 279910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279915 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 279921 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 279926 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 279931 */   // GIR_Coverage, 6572,
     /* 279931 */   GIR_EraseRootFromParent_Done,
     /* 279932 */ // Label 5422: @279932
     /* 279932 */ GIM_Reject,
     /* 279933 */ // Label 5418: @279933
     /* 279933 */ GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(280288),
     /* 279938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279945 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(280023), // Rule ID 5466 //
     /* 279950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 279958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 279970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 279974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 279978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 279987 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279993 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 279995 */     // MIs[1] Operand 2
     /* 279995 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 280006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280008 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 280008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 280011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 280017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280021 */     GIR_RootConstrainSelectedInstOperands,
     /* 280022 */     // GIR_Coverage, 5466,
     /* 280022 */     GIR_EraseRootFromParent_Done,
     /* 280023 */   // Label 5424: @280023
     /* 280023 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(280094), // Rule ID 5462 //
     /* 280028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 280048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 280056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280066 */     // MIs[1] Operand 2
     /* 280066 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 280077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280079 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 280079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 280082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 280092 */     GIR_RootConstrainSelectedInstOperands,
     /* 280093 */     // GIR_Coverage, 5462,
     /* 280093 */     GIR_EraseRootFromParent_Done,
     /* 280094 */   // Label 5425: @280094
     /* 280094 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(280165), // Rule ID 5464 //
     /* 280099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280123 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 280127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280137 */     // MIs[1] Operand 2
     /* 280137 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 280148 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280150 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 280150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 280153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 280163 */     GIR_RootConstrainSelectedInstOperands,
     /* 280164 */     // GIR_Coverage, 5464,
     /* 280164 */     GIR_EraseRootFromParent_Done,
     /* 280165 */   // Label 5426: @280165
     /* 280165 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(280218), // Rule ID 2162 //
     /* 280170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 280181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280190 */     // MIs[1] imm
     /* 280190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280198 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 280202 */     // MIs[2] Operand 1
     /* 280202 */     // No operand predicates
     /* 280202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280204 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 280204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 280207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 280216 */     GIR_RootConstrainSelectedInstOperands,
     /* 280217 */     // GIR_Coverage, 2162,
     /* 280217 */     GIR_EraseRootFromParent_Done,
     /* 280218 */   // Label 5427: @280218
     /* 280218 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(280268), // Rule ID 6396 //
     /* 280223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280240 */     // MIs[1] imm
     /* 280240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280248 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 280252 */     // MIs[2] Operand 1
     /* 280252 */     // No operand predicates
     /* 280252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280254 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 280254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 280257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 280266 */     GIR_RootConstrainSelectedInstOperands,
     /* 280267 */     // GIR_Coverage, 6396,
     /* 280267 */     GIR_EraseRootFromParent_Done,
     /* 280268 */   // Label 5428: @280268
     /* 280268 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(280287), // Rule ID 1099 //
     /* 280273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280280 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 280280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 280285 */     GIR_RootConstrainSelectedInstOperands,
     /* 280286 */     // GIR_Coverage, 1099,
     /* 280286 */     GIR_Done,
     /* 280287 */   // Label 5429: @280287
     /* 280287 */   GIM_Reject,
     /* 280288 */ // Label 5423: @280288
     /* 280288 */ GIM_Reject,
     /* 280289 */ // Label 5419: @280289
     /* 280289 */ GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(280787),
     /* 280294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280301 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(280379), // Rule ID 5460 //
     /* 280306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 280326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 280334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280343 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280349 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 280351 */     // MIs[1] Operand 2
     /* 280351 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 280362 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280364 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 280364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 280367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 280373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280377 */     GIR_RootConstrainSelectedInstOperands,
     /* 280378 */     // GIR_Coverage, 5460,
     /* 280378 */     GIR_EraseRootFromParent_Done,
     /* 280379 */   // Label 5431: @280379
     /* 280379 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(280450), // Rule ID 5456 //
     /* 280384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 280404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 280412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280422 */     // MIs[1] Operand 2
     /* 280422 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 280433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280435 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 280435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 280438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 280448 */     GIR_RootConstrainSelectedInstOperands,
     /* 280449 */     // GIR_Coverage, 5456,
     /* 280449 */     GIR_EraseRootFromParent_Done,
     /* 280450 */   // Label 5432: @280450
     /* 280450 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(280521), // Rule ID 5458 //
     /* 280455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 280483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280493 */     // MIs[1] Operand 2
     /* 280493 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 280504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280506 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 280506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 280509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 280519 */     GIR_RootConstrainSelectedInstOperands,
     /* 280520 */     // GIR_Coverage, 5458,
     /* 280520 */     GIR_EraseRootFromParent_Done,
     /* 280521 */   // Label 5433: @280521
     /* 280521 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(280613), // Rule ID 5582 //
     /* 280526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 280534 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 280541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 280545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 280553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 280566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 280570 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 280574 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280581 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 280581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 280584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 280588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 280597 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 280601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 280603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 280606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280611 */     GIR_RootConstrainSelectedInstOperands,
     /* 280612 */     // GIR_Coverage, 5582,
     /* 280612 */     GIR_EraseRootFromParent_Done,
     /* 280613 */   // Label 5434: @280613
     /* 280613 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(280666), // Rule ID 2161 //
     /* 280618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 280629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280638 */     // MIs[1] imm
     /* 280638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280646 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 280650 */     // MIs[2] Operand 1
     /* 280650 */     // No operand predicates
     /* 280650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280652 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 280652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 280655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 280664 */     GIR_RootConstrainSelectedInstOperands,
     /* 280665 */     // GIR_Coverage, 2161,
     /* 280665 */     GIR_EraseRootFromParent_Done,
     /* 280666 */   // Label 5435: @280666
     /* 280666 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(280716), // Rule ID 6395 //
     /* 280671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280688 */     // MIs[1] imm
     /* 280688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280696 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 280700 */     // MIs[2] Operand 1
     /* 280700 */     // No operand predicates
     /* 280700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280702 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 280702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 280705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 280714 */     GIR_RootConstrainSelectedInstOperands,
     /* 280715 */     // GIR_Coverage, 6395,
     /* 280715 */     GIR_EraseRootFromParent_Done,
     /* 280716 */   // Label 5436: @280716
     /* 280716 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(280767), // Rule ID 5610 //
     /* 280721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 280729 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 280736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 280740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280752 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 280752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 280755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 280761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 280765 */     GIR_RootConstrainSelectedInstOperands,
     /* 280766 */     // GIR_Coverage, 5610,
     /* 280766 */     GIR_EraseRootFromParent_Done,
     /* 280767 */   // Label 5437: @280767
     /* 280767 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(280786), // Rule ID 1098 //
     /* 280772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280779 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 280779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 280784 */     GIR_RootConstrainSelectedInstOperands,
     /* 280785 */     // GIR_Coverage, 1098,
     /* 280785 */     GIR_Done,
     /* 280786 */   // Label 5438: @280786
     /* 280786 */   GIM_Reject,
     /* 280787 */ // Label 5430: @280787
     /* 280787 */ GIM_Reject,
     /* 280788 */ // Label 5420: @280788
     /* 280788 */ GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(281286),
     /* 280793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280800 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(280878), // Rule ID 5454 //
     /* 280805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 280825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 280842 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 280848 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 280850 */     // MIs[1] Operand 2
     /* 280850 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 280861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 280863 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 280863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 280866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 280872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280876 */     GIR_RootConstrainSelectedInstOperands,
     /* 280877 */     // GIR_Coverage, 5454,
     /* 280877 */     GIR_EraseRootFromParent_Done,
     /* 280878 */   // Label 5440: @280878
     /* 280878 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(280949), // Rule ID 5450 //
     /* 280883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 280903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280921 */     // MIs[1] Operand 2
     /* 280921 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 280932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280934 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 280934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 280937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 280943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 280947 */     GIR_RootConstrainSelectedInstOperands,
     /* 280948 */     // GIR_Coverage, 5450,
     /* 280948 */     GIR_EraseRootFromParent_Done,
     /* 280949 */   // Label 5441: @280949
     /* 280949 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(281020), // Rule ID 5452 //
     /* 280954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 280962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 280978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280992 */     // MIs[1] Operand 2
     /* 280992 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 281003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281005 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 281005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 281008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 281014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 281018 */     GIR_RootConstrainSelectedInstOperands,
     /* 281019 */     // GIR_Coverage, 5452,
     /* 281019 */     GIR_EraseRootFromParent_Done,
     /* 281020 */   // Label 5442: @281020
     /* 281020 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(281112), // Rule ID 5555 //
     /* 281025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 281033 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 281040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 281044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 281052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 281056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 281065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 281069 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 281073 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281080 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 281080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 281087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 281096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 281100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 281105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281110 */     GIR_RootConstrainSelectedInstOperands,
     /* 281111 */     // GIR_Coverage, 5555,
     /* 281111 */     GIR_EraseRootFromParent_Done,
     /* 281112 */   // Label 5443: @281112
     /* 281112 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(281165), // Rule ID 2160 //
     /* 281117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 281128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281137 */     // MIs[1] imm
     /* 281137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281145 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 281149 */     // MIs[2] Operand 1
     /* 281149 */     // No operand predicates
     /* 281149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281151 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 281151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 281154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 281163 */     GIR_RootConstrainSelectedInstOperands,
     /* 281164 */     // GIR_Coverage, 2160,
     /* 281164 */     GIR_EraseRootFromParent_Done,
     /* 281165 */   // Label 5444: @281165
     /* 281165 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(281215), // Rule ID 6394 //
     /* 281170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 281178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281187 */     // MIs[1] imm
     /* 281187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281195 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 281199 */     // MIs[2] Operand 1
     /* 281199 */     // No operand predicates
     /* 281199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281201 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 281201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 281204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 281213 */     GIR_RootConstrainSelectedInstOperands,
     /* 281214 */     // GIR_Coverage, 6394,
     /* 281214 */     GIR_EraseRootFromParent_Done,
     /* 281215 */   // Label 5445: @281215
     /* 281215 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(281266), // Rule ID 5609 //
     /* 281220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 281228 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 281235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 281239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281251 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 281251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 281254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 281260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 281264 */     GIR_RootConstrainSelectedInstOperands,
     /* 281265 */     // GIR_Coverage, 5609,
     /* 281265 */     GIR_EraseRootFromParent_Done,
     /* 281266 */   // Label 5446: @281266
     /* 281266 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(281285), // Rule ID 1097 //
     /* 281271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281278 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 281278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 281283 */     GIR_RootConstrainSelectedInstOperands,
     /* 281284 */     // GIR_Coverage, 1097,
     /* 281284 */     GIR_Done,
     /* 281285 */   // Label 5447: @281285
     /* 281285 */   GIM_Reject,
     /* 281286 */ // Label 5439: @281286
     /* 281286 */ GIM_Reject,
     /* 281287 */ // Label 5421: @281287
     /* 281287 */ GIM_Reject,
     /* 281288 */ // Label 41: @281288
     /* 281288 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5450*/ GIMT_Encode4(281407),
     /* 281299 */ /*GILLT_s32*//*Label 5448*/ GIMT_Encode4(281307),
     /* 281303 */ /*GILLT_s64*//*Label 5449*/ GIMT_Encode4(281327),
     /* 281307 */ // Label 5448: @281307
     /* 281307 */ GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(281326), // Rule ID 81 //
     /* 281312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281316 */   // MIs[0] Operand 1
     /* 281316 */   // No operand predicates
     /* 281316 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 281316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 281319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281321 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 281324 */   GIR_RootConstrainSelectedInstOperands,
     /* 281325 */   // GIR_Coverage, 81,
     /* 281325 */   GIR_EraseRootFromParent_Done,
     /* 281326 */ // Label 5451: @281326
     /* 281326 */ GIM_Reject,
     /* 281327 */ // Label 5449: @281327
     /* 281327 */ GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(281387), // Rule ID 3905 //
     /* 281332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 281335 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 281339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 281343 */   // MIs[0] Operand 1
     /* 281343 */   // No operand predicates
     /* 281343 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 281343 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 281346 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 281350 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281355 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 281360 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 281365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 281376 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 281381 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281386 */   // GIR_Coverage, 3905,
     /* 281386 */   GIR_EraseRootFromParent_Done,
     /* 281387 */ // Label 5452: @281387
     /* 281387 */ GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(281406), // Rule ID 82 //
     /* 281392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 281396 */   // MIs[0] Operand 1
     /* 281396 */   // No operand predicates
     /* 281396 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 281396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 281399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281401 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 281404 */   GIR_RootConstrainSelectedInstOperands,
     /* 281405 */   // GIR_Coverage, 82,
     /* 281405 */   GIR_EraseRootFromParent_Done,
     /* 281406 */ // Label 5453: @281406
     /* 281406 */ GIM_Reject,
     /* 281407 */ // Label 5450: @281407
     /* 281407 */ GIM_Reject,
     /* 281408 */ // Label 42: @281408
     /* 281408 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5457*/ GIMT_Encode4(281648),
     /* 281419 */ /*GILLT_s16*//*Label 5454*/ GIMT_Encode4(281431),
     /* 281423 */ /*GILLT_s32*//*Label 5455*/ GIMT_Encode4(281483),
     /* 281427 */ /*GILLT_s64*//*Label 5456*/ GIMT_Encode4(281596),
     /* 281431 */ // Label 5454: @281431
     /* 281431 */ GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(281454), // Rule ID 506 //
     /* 281436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 281439 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 281443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281447 */   // MIs[0] Operand 1
     /* 281447 */   // No operand predicates
     /* 281447 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 281447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 281450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281452 */   GIR_RootConstrainSelectedInstOperands,
     /* 281453 */   // GIR_Coverage, 506,
     /* 281453 */   GIR_EraseRootFromParent_Done,
     /* 281454 */ // Label 5458: @281454
     /* 281454 */ GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(281482), // Rule ID 688 //
     /* 281459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 281462 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 281466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 281470 */   // MIs[0] Operand 1
     /* 281470 */   // No operand predicates
     /* 281470 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 281470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 281473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281475 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 281480 */   GIR_RootConstrainSelectedInstOperands,
     /* 281481 */   // GIR_Coverage, 688,
     /* 281481 */   GIR_EraseRootFromParent_Done,
     /* 281482 */ // Label 5459: @281482
     /* 281482 */ GIM_Reject,
     /* 281483 */ // Label 5455: @281483
     /* 281483 */ GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(281506), // Rule ID 507 //
     /* 281488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 281491 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 281495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281499 */   // MIs[0] Operand 1
     /* 281499 */   // No operand predicates
     /* 281499 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 281499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 281502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281504 */   GIR_RootConstrainSelectedInstOperands,
     /* 281505 */   // GIR_Coverage, 507,
     /* 281505 */   GIR_EraseRootFromParent_Done,
     /* 281506 */ // Label 5460: @281506
     /* 281506 */ GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(281534), // Rule ID 689 //
     /* 281511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 281514 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 281518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281522 */   // MIs[0] Operand 1
     /* 281522 */   // No operand predicates
     /* 281522 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 281522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 281525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281527 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 281532 */   GIR_RootConstrainSelectedInstOperands,
     /* 281533 */   // GIR_Coverage, 689,
     /* 281533 */   GIR_EraseRootFromParent_Done,
     /* 281534 */ // Label 5461: @281534
     /* 281534 */ GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(281595), // Rule ID 6083 //
     /* 281539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281542 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 281546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281550 */   // MIs[0] Operand 1
     /* 281550 */   // No operand predicates
     /* 281550 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 281550 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 281553 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 281557 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281562 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 281567 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 281570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 281577 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 281584 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 281589 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281594 */   // GIR_Coverage, 6083,
     /* 281594 */   GIR_EraseRootFromParent_Done,
     /* 281595 */ // Label 5462: @281595
     /* 281595 */ GIM_Reject,
     /* 281596 */ // Label 5456: @281596
     /* 281596 */ GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(281619), // Rule ID 508 //
     /* 281601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 281604 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 281608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281612 */   // MIs[0] Operand 1
     /* 281612 */   // No operand predicates
     /* 281612 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 281612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 281615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281617 */   GIR_RootConstrainSelectedInstOperands,
     /* 281618 */   // GIR_Coverage, 508,
     /* 281618 */   GIR_EraseRootFromParent_Done,
     /* 281619 */ // Label 5463: @281619
     /* 281619 */ GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(281647), // Rule ID 690 //
     /* 281624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 281627 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 281631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281635 */   // MIs[0] Operand 1
     /* 281635 */   // No operand predicates
     /* 281635 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 281635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 281638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281640 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 281645 */   GIR_RootConstrainSelectedInstOperands,
     /* 281646 */   // GIR_Coverage, 690,
     /* 281646 */   GIR_EraseRootFromParent_Done,
     /* 281647 */ // Label 5464: @281647
     /* 281647 */ GIM_Reject,
     /* 281648 */ // Label 5457: @281648
     /* 281648 */ GIM_Reject,
     /* 281649 */ // Label 43: @281649
     /* 281649 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5470*/ GIMT_Encode4(283546),
     /* 281660 */ /*GILLT_s32*//*Label 5465*/ GIMT_Encode4(281696),
     /* 281664 */ /*GILLT_s64*//*Label 5466*/ GIMT_Encode4(283137), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281676 */ /*GILLT_v2s64*//*Label 5467*/ GIMT_Encode4(283360), GIMT_Encode4(0),
     /* 281684 */ /*GILLT_v4s32*//*Label 5468*/ GIMT_Encode4(283422), GIMT_Encode4(0),
     /* 281692 */ /*GILLT_v8s16*//*Label 5469*/ GIMT_Encode4(283484),
     /* 281696 */ // Label 5465: @281696
     /* 281696 */ GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(281816), // Rule ID 13205 //
     /* 281701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 281704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281708 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281712 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281716 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281719 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 281724 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 281728 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281733 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281735 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 281735 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 281738 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 281742 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281747 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281753 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 281756 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281760 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281767 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 281770 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281774 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281779 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281782 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281785 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 281788 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281793 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281798 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 281803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 281806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281814 */   GIR_RootConstrainSelectedInstOperands,
     /* 281815 */   // GIR_Coverage, 13205,
     /* 281815 */   GIR_EraseRootFromParent_Done,
     /* 281816 */ // Label 5471: @281816
     /* 281816 */ GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(281936), // Rule ID 13207 //
     /* 281821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 281824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281828 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281832 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281836 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281839 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 281844 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 281848 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281853 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281855 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 281855 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 281858 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 281862 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281867 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281871 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281873 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 281876 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 281880 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 281887 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 281890 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 281894 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281899 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281902 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281905 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 281908 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281913 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281918 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 281923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 281926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281928 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281934 */   GIR_RootConstrainSelectedInstOperands,
     /* 281935 */   // GIR_Coverage, 13207,
     /* 281935 */   GIR_EraseRootFromParent_Done,
     /* 281936 */ // Label 5472: @281936
     /* 281936 */ GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(282056), // Rule ID 13209 //
     /* 281941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 281944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281948 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281952 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 281956 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 281959 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 281964 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 281968 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281973 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 281975 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 281975 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 281978 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 281982 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281987 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 281991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 281993 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 281996 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282000 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282007 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282010 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282014 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282019 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282022 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282025 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 282028 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282033 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282038 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 282046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282048 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282054 */   GIR_RootConstrainSelectedInstOperands,
     /* 282055 */   // GIR_Coverage, 13209,
     /* 282055 */   GIR_EraseRootFromParent_Done,
     /* 282056 */ // Label 5473: @282056
     /* 282056 */ GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(282176), // Rule ID 13211 //
     /* 282061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282068 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282072 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282076 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282079 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 282084 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282088 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282093 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282095 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 282095 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 282098 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 282102 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282107 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282113 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282116 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282120 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282127 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282134 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282139 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282142 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282145 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 282148 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282153 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282158 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 282166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282168 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282174 */   GIR_RootConstrainSelectedInstOperands,
     /* 282175 */   // GIR_Coverage, 13211,
     /* 282175 */   GIR_EraseRootFromParent_Done,
     /* 282176 */ // Label 5474: @282176
     /* 282176 */ GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(282296), // Rule ID 13227 //
     /* 282181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282188 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282192 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282196 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282199 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 282204 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282208 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282213 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282215 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 282215 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 282218 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 282222 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282227 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282233 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282236 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282240 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282245 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282247 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282250 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282254 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282259 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282262 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282265 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 282268 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282273 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282278 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 282286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282288 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282294 */   GIR_RootConstrainSelectedInstOperands,
     /* 282295 */   // GIR_Coverage, 13227,
     /* 282295 */   GIR_EraseRootFromParent_Done,
     /* 282296 */ // Label 5475: @282296
     /* 282296 */ GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(282416), // Rule ID 13229 //
     /* 282301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282308 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282316 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282319 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 282324 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282328 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282333 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282335 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 282335 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 282338 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 282342 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282347 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282353 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282356 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282360 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282367 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282370 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282374 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282379 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282382 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282385 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 282388 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282393 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282398 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 282406 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282414 */   GIR_RootConstrainSelectedInstOperands,
     /* 282415 */   // GIR_Coverage, 13229,
     /* 282415 */   GIR_EraseRootFromParent_Done,
     /* 282416 */ // Label 5476: @282416
     /* 282416 */ GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(282536), // Rule ID 13231 //
     /* 282421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282428 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282432 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282436 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282439 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 282444 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282448 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282453 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282455 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 282455 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 282458 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 282462 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282467 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282471 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282473 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282476 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282480 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282487 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282490 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282494 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282499 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282502 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282505 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 282508 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282513 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282518 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 282526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282534 */   GIR_RootConstrainSelectedInstOperands,
     /* 282535 */   // GIR_Coverage, 13231,
     /* 282535 */   GIR_EraseRootFromParent_Done,
     /* 282536 */ // Label 5477: @282536
     /* 282536 */ GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(282656), // Rule ID 13233 //
     /* 282541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282548 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282552 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282556 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282559 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 282564 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282568 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282573 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282575 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 282575 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 282578 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 282582 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282587 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282593 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282596 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282600 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282605 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282607 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282610 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282614 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282619 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282622 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282625 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 282628 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282633 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282638 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 282643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 282646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282648 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282654 */   GIR_RootConstrainSelectedInstOperands,
     /* 282655 */   // GIR_Coverage, 13233,
     /* 282655 */   GIR_EraseRootFromParent_Done,
     /* 282656 */ // Label 5478: @282656
     /* 282656 */ GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(282776), // Rule ID 13237 //
     /* 282661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282668 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282672 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282676 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282679 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 282684 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282688 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282693 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282695 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 282695 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 282698 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 282702 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282707 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282711 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282713 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282716 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282720 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282727 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282730 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282734 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282739 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282742 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282745 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 282748 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282753 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282758 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 282766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282768 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282774 */   GIR_RootConstrainSelectedInstOperands,
     /* 282775 */   // GIR_Coverage, 13237,
     /* 282775 */   GIR_EraseRootFromParent_Done,
     /* 282776 */ // Label 5479: @282776
     /* 282776 */ GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(282896), // Rule ID 13239 //
     /* 282781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282788 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282792 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282796 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282799 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 282804 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282808 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282813 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282815 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 282815 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 282818 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 282822 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282827 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282833 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282836 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282840 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282847 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282850 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282854 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282859 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282862 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282865 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 282868 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282873 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282878 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 282886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282894 */   GIR_RootConstrainSelectedInstOperands,
     /* 282895 */   // GIR_Coverage, 13239,
     /* 282895 */   GIR_EraseRootFromParent_Done,
     /* 282896 */ // Label 5480: @282896
     /* 282896 */ GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(283016), // Rule ID 13241 //
     /* 282901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 282904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282908 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282912 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282916 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282919 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 282924 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282928 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282933 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282935 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 282935 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 282938 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 282942 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282947 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282953 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282956 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282960 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282967 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 282970 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282974 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282979 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 282982 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 282985 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 282988 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282993 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282998 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 283006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283014 */   GIR_RootConstrainSelectedInstOperands,
     /* 283015 */   // GIR_Coverage, 13241,
     /* 283015 */   GIR_EraseRootFromParent_Done,
     /* 283016 */ // Label 5481: @283016
     /* 283016 */ GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(283136), // Rule ID 13243 //
     /* 283021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283028 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283032 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283036 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283039 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 283044 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 283048 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283053 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283055 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 283055 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 283058 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 283062 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283067 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283071 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283073 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283076 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283080 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 283087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 283090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283099 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 283102 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 283105 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 283108 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283113 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283118 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 283126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283134 */   GIR_RootConstrainSelectedInstOperands,
     /* 283135 */   // GIR_Coverage, 13243,
     /* 283135 */   GIR_EraseRootFromParent_Done,
     /* 283136 */ // Label 5482: @283136
     /* 283136 */ GIM_Reject,
     /* 283137 */ // Label 5466: @283137
     /* 283137 */ GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(283359),
     /* 283142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 283145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 283149 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(283203), // Rule ID 5693 //
     /* 283154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283183 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 283187 */     // MIs[2] Operand 1
     /* 283187 */     // No operand predicates
     /* 283187 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283189 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 283189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 283192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283201 */     GIR_RootConstrainSelectedInstOperands,
     /* 283202 */     // GIR_Coverage, 5693,
     /* 283202 */     GIR_EraseRootFromParent_Done,
     /* 283203 */   // Label 5484: @283203
     /* 283203 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(283282), // Rule ID 11298 //
     /* 283208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 283223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283235 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 283239 */     // MIs[2] Operand 1
     /* 283239 */     // No operand predicates
     /* 283239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283241 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 283241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 283244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283253 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 283259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 283272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 283280 */     GIR_RootConstrainSelectedInstOperands,
     /* 283281 */     // GIR_Coverage, 11298,
     /* 283281 */     GIR_EraseRootFromParent_Done,
     /* 283282 */   // Label 5485: @283282
     /* 283282 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(283358), // Rule ID 6553 //
     /* 283287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283291 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 283291 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 283294 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283298 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 283305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283317 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 283320 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 283324 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 283327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 283332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 283337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 283345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 283356 */     GIR_RootConstrainSelectedInstOperands,
     /* 283357 */     // GIR_Coverage, 6553,
     /* 283357 */     GIR_EraseRootFromParent_Done,
     /* 283358 */   // Label 5486: @283358
     /* 283358 */   GIM_Reject,
     /* 283359 */ // Label 5483: @283359
     /* 283359 */ GIM_Reject,
     /* 283360 */ // Label 5467: @283360
     /* 283360 */ GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(283421),
     /* 283365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283372 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(283399), // Rule ID 6423 //
     /* 283377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 283384 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 283384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 283387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283397 */     GIR_RootConstrainSelectedInstOperands,
     /* 283398 */     // GIR_Coverage, 6423,
     /* 283398 */     GIR_EraseRootFromParent_Done,
     /* 283399 */   // Label 5488: @283399
     /* 283399 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(283420), // Rule ID 6412 //
     /* 283404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283408 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 283408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 283411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283418 */     GIR_RootConstrainSelectedInstOperands,
     /* 283419 */     // GIR_Coverage, 6412,
     /* 283419 */     GIR_EraseRootFromParent_Done,
     /* 283420 */   // Label 5489: @283420
     /* 283420 */   GIM_Reject,
     /* 283421 */ // Label 5487: @283421
     /* 283421 */ GIM_Reject,
     /* 283422 */ // Label 5468: @283422
     /* 283422 */ GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(283483),
     /* 283427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 283430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283434 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(283461), // Rule ID 6420 //
     /* 283439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 283446 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 283446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 283449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283459 */     GIR_RootConstrainSelectedInstOperands,
     /* 283460 */     // GIR_Coverage, 6420,
     /* 283460 */     GIR_EraseRootFromParent_Done,
     /* 283461 */   // Label 5491: @283461
     /* 283461 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(283482), // Rule ID 6409 //
     /* 283466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283470 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 283470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 283473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283480 */     GIR_RootConstrainSelectedInstOperands,
     /* 283481 */     // GIR_Coverage, 6409,
     /* 283481 */     GIR_EraseRootFromParent_Done,
     /* 283482 */   // Label 5492: @283482
     /* 283482 */   GIM_Reject,
     /* 283483 */ // Label 5490: @283483
     /* 283483 */ GIM_Reject,
     /* 283484 */ // Label 5469: @283484
     /* 283484 */ GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(283545),
     /* 283489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 283492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283496 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(283523), // Rule ID 6417 //
     /* 283501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 283508 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 283508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 283511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 283518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283521 */     GIR_RootConstrainSelectedInstOperands,
     /* 283522 */     // GIR_Coverage, 6417,
     /* 283522 */     GIR_EraseRootFromParent_Done,
     /* 283523 */   // Label 5494: @283523
     /* 283523 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(283544), // Rule ID 6406 //
     /* 283528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283532 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 283532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 283535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 283539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 283542 */     GIR_RootConstrainSelectedInstOperands,
     /* 283543 */     // GIR_Coverage, 6406,
     /* 283543 */     GIR_EraseRootFromParent_Done,
     /* 283544 */   // Label 5495: @283544
     /* 283544 */   GIM_Reject,
     /* 283545 */ // Label 5493: @283545
     /* 283545 */ GIM_Reject,
     /* 283546 */ // Label 5470: @283546
     /* 283546 */ GIM_Reject,
     /* 283547 */ // Label 44: @283547
     /* 283547 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5501*/ GIMT_Encode4(285200),
     /* 283558 */ /*GILLT_s32*//*Label 5496*/ GIMT_Encode4(283638),
     /* 283562 */ /*GILLT_s64*//*Label 5497*/ GIMT_Encode4(284132), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283614 */ /*GILLT_nxv2s64*//*Label 5498*/ GIMT_Encode4(284774), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283626 */ /*GILLT_nxv4s32*//*Label 5499*/ GIMT_Encode4(284983), GIMT_Encode4(0),
     /* 283634 */ /*GILLT_nxv8s16*//*Label 5500*/ GIMT_Encode4(285127),
     /* 283638 */ // Label 5496: @283638
     /* 283638 */ GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(284131),
     /* 283643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 283646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283650 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(283715), // Rule ID 5688 //
     /* 283655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 283667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283684 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 283688 */     // MIs[2] Operand 1
     /* 283688 */     // No operand predicates
     /* 283688 */     // MIs[0] Operand 2
     /* 283688 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 283699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283701 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 283701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 283704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283713 */     GIR_RootConstrainSelectedInstOperands,
     /* 283714 */     // GIR_Coverage, 5688,
     /* 283714 */     GIR_EraseRootFromParent_Done,
     /* 283715 */   // Label 5503: @283715
     /* 283715 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(283780), // Rule ID 5690 //
     /* 283720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283749 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 283753 */     // MIs[2] Operand 1
     /* 283753 */     // No operand predicates
     /* 283753 */     // MIs[0] Operand 2
     /* 283753 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 283764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283766 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 283766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 283769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283778 */     GIR_RootConstrainSelectedInstOperands,
     /* 283779 */     // GIR_Coverage, 5690,
     /* 283779 */     GIR_EraseRootFromParent_Done,
     /* 283780 */   // Label 5504: @283780
     /* 283780 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(283845), // Rule ID 5692 //
     /* 283785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283814 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 283818 */     // MIs[2] Operand 1
     /* 283818 */     // No operand predicates
     /* 283818 */     // MIs[0] Operand 2
     /* 283818 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 283829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283831 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 283831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 283834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 283840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 283843 */     GIR_RootConstrainSelectedInstOperands,
     /* 283844 */     // GIR_Coverage, 5692,
     /* 283844 */     GIR_EraseRootFromParent_Done,
     /* 283845 */   // Label 5505: @283845
     /* 283845 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(283935), // Rule ID 11294 //
     /* 283850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 283865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283877 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 283881 */     // MIs[2] Operand 1
     /* 283881 */     // No operand predicates
     /* 283881 */     // MIs[0] Operand 2
     /* 283881 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 283892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283894 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 283894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 283897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283906 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 283912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 283925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 283933 */     GIR_RootConstrainSelectedInstOperands,
     /* 283934 */     // GIR_Coverage, 11294,
     /* 283934 */     GIR_EraseRootFromParent_Done,
     /* 283935 */   // Label 5506: @283935
     /* 283935 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(284025), // Rule ID 11296 //
     /* 283940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 283955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 283963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 283967 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 283971 */     // MIs[2] Operand 1
     /* 283971 */     // No operand predicates
     /* 283971 */     // MIs[0] Operand 2
     /* 283971 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 283982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283984 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 283984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 283987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283996 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 284002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284007 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 284015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 284023 */     GIR_RootConstrainSelectedInstOperands,
     /* 284024 */     // GIR_Coverage, 11296,
     /* 284024 */     GIR_EraseRootFromParent_Done,
     /* 284025 */   // Label 5507: @284025
     /* 284025 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(284060), // Rule ID 6558 //
     /* 284030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284034 */     // MIs[0] Operand 2
     /* 284034 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 284045 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 284045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 284048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 284052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 284058 */     GIR_RootConstrainSelectedInstOperands,
     /* 284059 */     // GIR_Coverage, 6558,
     /* 284059 */     GIR_EraseRootFromParent_Done,
     /* 284060 */   // Label 5508: @284060
     /* 284060 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(284095), // Rule ID 6559 //
     /* 284065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284069 */     // MIs[0] Operand 2
     /* 284069 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 284080 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 284080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 284083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284085 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 284087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 284093 */     GIR_RootConstrainSelectedInstOperands,
     /* 284094 */     // GIR_Coverage, 6559,
     /* 284094 */     GIR_EraseRootFromParent_Done,
     /* 284095 */   // Label 5509: @284095
     /* 284095 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(284130), // Rule ID 6560 //
     /* 284100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284104 */     // MIs[0] Operand 2
     /* 284104 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 284115 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 284115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 284118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284120 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 284122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284128 */     GIR_RootConstrainSelectedInstOperands,
     /* 284129 */     // GIR_Coverage, 6560,
     /* 284129 */     GIR_EraseRootFromParent_Done,
     /* 284130 */   // Label 5510: @284130
     /* 284130 */   GIM_Reject,
     /* 284131 */ // Label 5502: @284131
     /* 284131 */ GIM_Reject,
     /* 284132 */ // Label 5497: @284132
     /* 284132 */ GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(284773),
     /* 284137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 284140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284144 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(284221), // Rule ID 5694 //
     /* 284149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 284157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 284173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284190 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 284194 */     // MIs[3] Operand 1
     /* 284194 */     // No operand predicates
     /* 284194 */     // MIs[0] Operand 2
     /* 284194 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 284205 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284207 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 284207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 284210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 284216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284219 */     GIR_RootConstrainSelectedInstOperands,
     /* 284220 */     // GIR_Coverage, 5694,
     /* 284220 */     GIR_EraseRootFromParent_Done,
     /* 284221 */   // Label 5512: @284221
     /* 284221 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(284298), // Rule ID 5695 //
     /* 284226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 284234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284267 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 284271 */     // MIs[3] Operand 1
     /* 284271 */     // No operand predicates
     /* 284271 */     // MIs[0] Operand 2
     /* 284271 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 284282 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284284 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 284284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 284287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 284293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 284296 */     GIR_RootConstrainSelectedInstOperands,
     /* 284297 */     // GIR_Coverage, 5695,
     /* 284297 */     GIR_EraseRootFromParent_Done,
     /* 284298 */   // Label 5513: @284298
     /* 284298 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(284400), // Rule ID 11295 //
     /* 284303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 284314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 284330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284342 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 284346 */     // MIs[3] Operand 1
     /* 284346 */     // No operand predicates
     /* 284346 */     // MIs[0] Operand 2
     /* 284346 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 284357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284359 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 284359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 284362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284371 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 284377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 284390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 284398 */     GIR_RootConstrainSelectedInstOperands,
     /* 284399 */     // GIR_Coverage, 11295,
     /* 284399 */     GIR_EraseRootFromParent_Done,
     /* 284400 */   // Label 5514: @284400
     /* 284400 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(284502), // Rule ID 11297 //
     /* 284405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 284416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 284420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 284424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 284432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 284440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284444 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 284448 */     // MIs[3] Operand 1
     /* 284448 */     // No operand predicates
     /* 284448 */     // MIs[0] Operand 2
     /* 284448 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 284459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 284461 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 284461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 284464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284473 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 284479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 284492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 284500 */     GIR_RootConstrainSelectedInstOperands,
     /* 284501 */     // GIR_Coverage, 11297,
     /* 284501 */     GIR_EraseRootFromParent_Done,
     /* 284502 */   // Label 5515: @284502
     /* 284502 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(284567), // Rule ID 5689 //
     /* 284507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 284519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284536 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 284540 */     // MIs[2] Operand 1
     /* 284540 */     // No operand predicates
     /* 284540 */     // MIs[0] Operand 2
     /* 284540 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 284551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284553 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 284553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 284556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284565 */     GIR_RootConstrainSelectedInstOperands,
     /* 284566 */     // GIR_Coverage, 5689,
     /* 284566 */     GIR_EraseRootFromParent_Done,
     /* 284567 */   // Label 5516: @284567
     /* 284567 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(284632), // Rule ID 5691 //
     /* 284572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 284597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 284601 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 284605 */     // MIs[2] Operand 1
     /* 284605 */     // No operand predicates
     /* 284605 */     // MIs[0] Operand 2
     /* 284605 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 284616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284618 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 284618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 284621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 284630 */     GIR_RootConstrainSelectedInstOperands,
     /* 284631 */     // GIR_Coverage, 5691,
     /* 284631 */     GIR_EraseRootFromParent_Done,
     /* 284632 */   // Label 5517: @284632
     /* 284632 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(284667), // Rule ID 6554 //
     /* 284637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284641 */     // MIs[0] Operand 2
     /* 284641 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 284652 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 284652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 284655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284657 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 284659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 284665 */     GIR_RootConstrainSelectedInstOperands,
     /* 284666 */     // GIR_Coverage, 6554,
     /* 284666 */     GIR_EraseRootFromParent_Done,
     /* 284667 */   // Label 5518: @284667
     /* 284667 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(284702), // Rule ID 6555 //
     /* 284672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284676 */     // MIs[0] Operand 2
     /* 284676 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 284687 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 284687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 284690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284692 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 284694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 284700 */     GIR_RootConstrainSelectedInstOperands,
     /* 284701 */     // GIR_Coverage, 6555,
     /* 284701 */     GIR_EraseRootFromParent_Done,
     /* 284702 */   // Label 5519: @284702
     /* 284702 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(284737), // Rule ID 6556 //
     /* 284707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284711 */     // MIs[0] Operand 2
     /* 284711 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 284722 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 284722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 284725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284727 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 284729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 284735 */     GIR_RootConstrainSelectedInstOperands,
     /* 284736 */     // GIR_Coverage, 6556,
     /* 284736 */     GIR_EraseRootFromParent_Done,
     /* 284737 */   // Label 5520: @284737
     /* 284737 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(284772), // Rule ID 6557 //
     /* 284742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 284746 */     // MIs[0] Operand 2
     /* 284746 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 284757 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 284757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 284760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284762 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 284764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284770 */     GIR_RootConstrainSelectedInstOperands,
     /* 284771 */     // GIR_Coverage, 6557,
     /* 284771 */     GIR_EraseRootFromParent_Done,
     /* 284772 */   // Label 5521: @284772
     /* 284772 */   GIM_Reject,
     /* 284773 */ // Label 5511: @284773
     /* 284773 */ GIM_Reject,
     /* 284774 */ // Label 5498: @284774
     /* 284774 */ GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(284982),
     /* 284779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 284782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284786 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(284851), // Rule ID 10566 //
     /* 284791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284794 */     // MIs[0] Operand 2
     /* 284794 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 284805 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 284805 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 284808 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 284812 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284817 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 284820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 284825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 284839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 284841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 284847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 284849 */     GIR_RootConstrainSelectedInstOperands,
     /* 284850 */     // GIR_Coverage, 10566,
     /* 284850 */     GIR_EraseRootFromParent_Done,
     /* 284851 */   // Label 5523: @284851
     /* 284851 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(284916), // Rule ID 10567 //
     /* 284856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284859 */     // MIs[0] Operand 2
     /* 284859 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 284870 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 284870 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 284873 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 284877 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284882 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 284885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 284890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 284904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 284906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 284912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 284914 */     GIR_RootConstrainSelectedInstOperands,
     /* 284915 */     // GIR_Coverage, 10567,
     /* 284915 */     GIR_EraseRootFromParent_Done,
     /* 284916 */   // Label 5524: @284916
     /* 284916 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(284981), // Rule ID 10568 //
     /* 284921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 284924 */     // MIs[0] Operand 2
     /* 284924 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 284935 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 284935 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 284938 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 284942 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284947 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 284950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 284952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 284955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 284966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 284969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 284971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 284977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 284979 */     GIR_RootConstrainSelectedInstOperands,
     /* 284980 */     // GIR_Coverage, 10568,
     /* 284980 */     GIR_EraseRootFromParent_Done,
     /* 284981 */   // Label 5525: @284981
     /* 284981 */   GIM_Reject,
     /* 284982 */ // Label 5522: @284982
     /* 284982 */ GIM_Reject,
     /* 284983 */ // Label 5499: @284983
     /* 284983 */ GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(285126),
     /* 284988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 284991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 284995 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(285060), // Rule ID 10569 //
     /* 285000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285003 */     // MIs[0] Operand 2
     /* 285003 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 285014 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 285014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 285017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 285021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285026 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 285029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 285031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 285034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 285045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 285048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 285050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 285056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 285058 */     GIR_RootConstrainSelectedInstOperands,
     /* 285059 */     // GIR_Coverage, 10569,
     /* 285059 */     GIR_EraseRootFromParent_Done,
     /* 285060 */   // Label 5527: @285060
     /* 285060 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(285125), // Rule ID 10570 //
     /* 285065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285068 */     // MIs[0] Operand 2
     /* 285068 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 285079 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 285079 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 285082 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 285086 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285091 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 285094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 285096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 285099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 285110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 285113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 285115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 285121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 285123 */     GIR_RootConstrainSelectedInstOperands,
     /* 285124 */     // GIR_Coverage, 10570,
     /* 285124 */     GIR_EraseRootFromParent_Done,
     /* 285125 */   // Label 5528: @285125
     /* 285125 */   GIM_Reject,
     /* 285126 */ // Label 5526: @285126
     /* 285126 */ GIM_Reject,
     /* 285127 */ // Label 5500: @285127
     /* 285127 */ GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(285199), // Rule ID 10571 //
     /* 285132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 285138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285142 */   // MIs[0] Operand 2
     /* 285142 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 285153 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 285153 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 285156 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 285160 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285165 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 285168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 285170 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 285173 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285177 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 285184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 285187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 285189 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285192 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 285195 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 285197 */   GIR_RootConstrainSelectedInstOperands,
     /* 285198 */   // GIR_Coverage, 10571,
     /* 285198 */   GIR_EraseRootFromParent_Done,
     /* 285199 */ // Label 5529: @285199
     /* 285199 */ GIM_Reject,
     /* 285200 */ // Label 5501: @285200
     /* 285200 */ GIM_Reject,
     /* 285201 */ // Label 45: @285201
     /* 285201 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5534*/ GIMT_Encode4(287979),
     /* 285212 */ /*GILLT_s32*//*Label 5530*/ GIMT_Encode4(285248), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285228 */ /*GILLT_v2s64*//*Label 5531*/ GIMT_Encode4(287049), GIMT_Encode4(0),
     /* 285236 */ /*GILLT_v4s32*//*Label 5532*/ GIMT_Encode4(287359), GIMT_Encode4(0),
     /* 285244 */ /*GILLT_v8s16*//*Label 5533*/ GIMT_Encode4(287669),
     /* 285248 */ // Label 5530: @285248
     /* 285248 */ GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(285398), // Rule ID 13214 //
     /* 285253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 285256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285260 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285264 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285268 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 285271 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 285276 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285280 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285285 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285287 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 285287 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 285290 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 285294 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285299 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285305 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 285308 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285312 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285319 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 285322 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285326 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285331 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 285334 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 285337 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 285340 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285345 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285350 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 285355 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285358 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285362 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285367 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 285374 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285379 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285392 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285397 */   // GIR_Coverage, 13214,
     /* 285397 */   GIR_EraseRootFromParent_Done,
     /* 285398 */ // Label 5535: @285398
     /* 285398 */ GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(285548), // Rule ID 13216 //
     /* 285403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 285406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285410 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285414 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285418 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 285421 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 285426 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 285430 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285435 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285437 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 285437 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 285440 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 285444 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285449 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285455 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 285458 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285462 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285469 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 285472 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285476 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285481 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 285484 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 285487 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 285490 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285495 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285500 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 285505 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285512 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285517 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 285524 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285529 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285539 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285542 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285547 */   // GIR_Coverage, 13216,
     /* 285547 */   GIR_EraseRootFromParent_Done,
     /* 285548 */ // Label 5536: @285548
     /* 285548 */ GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(285698), // Rule ID 13218 //
     /* 285553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 285556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285560 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285564 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285568 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 285571 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 285576 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285580 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285585 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285587 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 285587 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 285590 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 285594 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285599 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285605 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 285608 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285612 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285617 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285619 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 285622 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285626 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285631 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 285634 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 285637 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 285640 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285645 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285650 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285655 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285658 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285662 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285667 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 285674 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285679 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285689 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285692 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285697 */   // GIR_Coverage, 13218,
     /* 285697 */   GIR_EraseRootFromParent_Done,
     /* 285698 */ // Label 5537: @285698
     /* 285698 */ GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(285848), // Rule ID 13220 //
     /* 285703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 285706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285710 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285714 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285718 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 285721 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 285726 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 285730 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285735 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285737 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 285737 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 285740 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 285744 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285749 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285755 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 285758 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285762 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285769 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 285772 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285776 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285781 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 285784 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 285787 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 285790 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285795 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285800 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285805 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285808 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285812 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285817 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 285824 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285829 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285839 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285842 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285847 */   // GIR_Coverage, 13220,
     /* 285847 */   GIR_EraseRootFromParent_Done,
     /* 285848 */ // Label 5538: @285848
     /* 285848 */ GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(285998), // Rule ID 13247 //
     /* 285853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 285856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285860 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285864 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285868 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 285871 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 285876 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285880 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285885 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285887 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 285887 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 285890 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 285894 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285899 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285903 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285905 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 285908 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285912 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285919 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 285922 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285926 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285931 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 285934 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 285937 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 285940 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285945 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285950 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 285955 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285958 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285962 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285967 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 285974 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285979 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285992 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285997 */   // GIR_Coverage, 13247,
     /* 285997 */   GIR_EraseRootFromParent_Done,
     /* 285998 */ // Label 5539: @285998
     /* 285998 */ GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(286148), // Rule ID 13249 //
     /* 286003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 286006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286010 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286014 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 286018 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 286021 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 286026 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 286030 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286035 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286037 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 286037 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 286040 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 286044 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286049 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 286053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 286055 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 286058 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 286062 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286067 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 286069 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 286072 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 286076 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286081 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 286084 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 286087 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 286090 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286095 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286100 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 286105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286117 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 286124 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286129 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286139 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286142 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286147 */   // GIR_Coverage, 13249,
     /* 286147 */   GIR_EraseRootFromParent_Done,
     /* 286148 */ // Label 5540: @286148
     /* 286148 */ GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(286298), // Rule ID 13251 //
     /* 286153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 286156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286160 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286164 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 286168 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 286171 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 286176 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 286180 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286185 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286187 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 286187 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 286190 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 286194 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286199 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 286203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 286205 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 286208 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 286212 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 286219 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 286222 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 286226 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286231 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 286234 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 286237 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 286240 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286245 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286250 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286255 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286258 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286262 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286267 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 286274 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286279 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286292 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286297 */   // GIR_Coverage, 13251,
     /* 286297 */   GIR_EraseRootFromParent_Done,
     /* 286298 */ // Label 5541: @286298
     /* 286298 */ GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(286448), // Rule ID 13253 //
     /* 286303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 286306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286310 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286314 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 286318 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 286321 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 286326 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 286330 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286335 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286337 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 286337 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 286340 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 286344 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286349 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 286353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 286355 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 286358 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 286362 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 286369 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 286372 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 286376 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286381 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 286384 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 286387 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 286390 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286395 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286400 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286405 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286408 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286412 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286417 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 286424 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286429 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286439 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286442 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286447 */   // GIR_Coverage, 13253,
     /* 286447 */   GIR_EraseRootFromParent_Done,
     /* 286448 */ // Label 5542: @286448
     /* 286448 */ GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(286598), // Rule ID 13257 //
     /* 286453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 286456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286460 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286464 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 286468 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 286471 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 286476 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 286480 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286485 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286487 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 286487 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 286490 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 286494 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286499 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 286503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 286505 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 286508 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 286512 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 286519 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 286522 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 286526 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286531 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 286534 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 286537 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 286540 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286545 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286550 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 286555 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286558 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286562 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286567 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 286574 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286579 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286592 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286597 */   // GIR_Coverage, 13257,
     /* 286597 */   GIR_EraseRootFromParent_Done,
     /* 286598 */ // Label 5543: @286598
     /* 286598 */ GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(286748), // Rule ID 13259 //
     /* 286603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 286606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286610 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 286618 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 286621 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 286626 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 286630 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286635 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286637 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 286637 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 286640 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 286644 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286649 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 286653 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 286655 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 286658 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 286662 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286667 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 286669 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 286672 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 286676 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286681 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 286684 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 286687 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 286690 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286695 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286700 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 286705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286717 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 286724 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286729 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286739 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286742 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286747 */   // GIR_Coverage, 13259,
     /* 286747 */   GIR_EraseRootFromParent_Done,
     /* 286748 */ // Label 5544: @286748
     /* 286748 */ GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(286898), // Rule ID 13261 //
     /* 286753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 286756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286760 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286764 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 286768 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 286771 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 286776 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 286780 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286785 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286787 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 286787 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 286790 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 286794 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286799 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 286803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 286805 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 286808 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 286812 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286817 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 286819 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 286822 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 286826 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286831 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 286834 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 286837 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 286840 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286845 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286850 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286855 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286858 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286862 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286867 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 286874 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286879 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286889 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286892 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286897 */   // GIR_Coverage, 13261,
     /* 286897 */   GIR_EraseRootFromParent_Done,
     /* 286898 */ // Label 5545: @286898
     /* 286898 */ GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(287048), // Rule ID 13263 //
     /* 286903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 286906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286910 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286914 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 286918 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 286921 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 286926 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 286930 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286935 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286937 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 286937 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 286940 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 286944 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286949 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 286953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 286955 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 286958 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 286962 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 286969 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 286972 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 286976 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286981 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 286984 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 286987 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 286990 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286995 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287000 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 287005 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 287008 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287012 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287017 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 287024 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287029 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 287039 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287047 */   // GIR_Coverage, 13263,
     /* 287047 */   GIR_EraseRootFromParent_Done,
     /* 287048 */ // Label 5546: @287048
     /* 287048 */ GIM_Reject,
     /* 287049 */ // Label 5531: @287049
     /* 287049 */ GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(287358),
     /* 287054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 287057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287061 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(287126), // Rule ID 702 //
     /* 287066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287077 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287080 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 287085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 287089 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 287093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 287102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 287109 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 287109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 287112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 287119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 287124 */     GIR_RootConstrainSelectedInstOperands,
     /* 287125 */     // GIR_Coverage, 702,
     /* 287125 */     GIR_EraseRootFromParent_Done,
     /* 287126 */   // Label 5548: @287126
     /* 287126 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(287191), // Rule ID 1711 //
     /* 287131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287142 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287145 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 287150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 287154 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 287158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 287167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 287174 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 287174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 287177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 287184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 287189 */     GIR_RootConstrainSelectedInstOperands,
     /* 287190 */     // GIR_Coverage, 1711,
     /* 287190 */     GIR_EraseRootFromParent_Done,
     /* 287191 */   // Label 5549: @287191
     /* 287191 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(287250), // Rule ID 700 //
     /* 287196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287207 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287210 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 287215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 287219 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 287223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287235 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 287235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 287238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 287244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 287248 */     GIR_RootConstrainSelectedInstOperands,
     /* 287249 */     // GIR_Coverage, 700,
     /* 287249 */     GIR_EraseRootFromParent_Done,
     /* 287250 */   // Label 5550: @287250
     /* 287250 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(287309), // Rule ID 1709 //
     /* 287255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287266 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287269 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 287274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 287278 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 287282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287294 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 287294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 287297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 287303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 287307 */     GIR_RootConstrainSelectedInstOperands,
     /* 287308 */     // GIR_Coverage, 1709,
     /* 287308 */     GIR_EraseRootFromParent_Done,
     /* 287309 */   // Label 5551: @287309
     /* 287309 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(287336), // Rule ID 6422 //
     /* 287314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 287321 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 287321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 287324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 287331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287334 */     GIR_RootConstrainSelectedInstOperands,
     /* 287335 */     // GIR_Coverage, 6422,
     /* 287335 */     GIR_EraseRootFromParent_Done,
     /* 287336 */   // Label 5552: @287336
     /* 287336 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(287357), // Rule ID 6413 //
     /* 287341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287345 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 287345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 287348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287355 */     GIR_RootConstrainSelectedInstOperands,
     /* 287356 */     // GIR_Coverage, 6413,
     /* 287356 */     GIR_EraseRootFromParent_Done,
     /* 287357 */   // Label 5553: @287357
     /* 287357 */   GIM_Reject,
     /* 287358 */ // Label 5547: @287358
     /* 287358 */ GIM_Reject,
     /* 287359 */ // Label 5532: @287359
     /* 287359 */ GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(287668),
     /* 287364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 287367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287371 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(287436), // Rule ID 698 //
     /* 287376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287387 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287390 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 287395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 287399 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 287403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287405 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 287412 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 287419 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 287419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 287422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 287429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 287434 */     GIR_RootConstrainSelectedInstOperands,
     /* 287435 */     // GIR_Coverage, 698,
     /* 287435 */     GIR_EraseRootFromParent_Done,
     /* 287436 */   // Label 5555: @287436
     /* 287436 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(287501), // Rule ID 1707 //
     /* 287441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287452 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287455 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 287460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 287464 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 287468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 287477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 287484 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 287484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 287487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 287494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 287499 */     GIR_RootConstrainSelectedInstOperands,
     /* 287500 */     // GIR_Coverage, 1707,
     /* 287500 */     GIR_EraseRootFromParent_Done,
     /* 287501 */   // Label 5556: @287501
     /* 287501 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(287560), // Rule ID 696 //
     /* 287506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287517 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287520 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 287525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 287529 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 287533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287545 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 287545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 287548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 287554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 287558 */     GIR_RootConstrainSelectedInstOperands,
     /* 287559 */     // GIR_Coverage, 696,
     /* 287559 */     GIR_EraseRootFromParent_Done,
     /* 287560 */   // Label 5557: @287560
     /* 287560 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(287619), // Rule ID 1705 //
     /* 287565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287576 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287579 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 287584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 287588 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 287592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287604 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 287604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 287607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 287613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 287617 */     GIR_RootConstrainSelectedInstOperands,
     /* 287618 */     // GIR_Coverage, 1705,
     /* 287618 */     GIR_EraseRootFromParent_Done,
     /* 287619 */   // Label 5558: @287619
     /* 287619 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(287646), // Rule ID 6419 //
     /* 287624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 287631 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 287631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 287634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 287641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287644 */     GIR_RootConstrainSelectedInstOperands,
     /* 287645 */     // GIR_Coverage, 6419,
     /* 287645 */     GIR_EraseRootFromParent_Done,
     /* 287646 */   // Label 5559: @287646
     /* 287646 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(287667), // Rule ID 6410 //
     /* 287651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287655 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 287655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 287658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287665 */     GIR_RootConstrainSelectedInstOperands,
     /* 287666 */     // GIR_Coverage, 6410,
     /* 287666 */     GIR_EraseRootFromParent_Done,
     /* 287667 */   // Label 5560: @287667
     /* 287667 */   GIM_Reject,
     /* 287668 */ // Label 5554: @287668
     /* 287668 */ GIM_Reject,
     /* 287669 */ // Label 5533: @287669
     /* 287669 */ GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(287978),
     /* 287674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 287677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287681 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(287746), // Rule ID 694 //
     /* 287686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287697 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287700 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 287705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 287709 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 287713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 287722 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 287729 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 287729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 287732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 287739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 287744 */     GIR_RootConstrainSelectedInstOperands,
     /* 287745 */     // GIR_Coverage, 694,
     /* 287745 */     GIR_EraseRootFromParent_Done,
     /* 287746 */   // Label 5562: @287746
     /* 287746 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(287811), // Rule ID 1703 //
     /* 287751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287762 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287765 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 287770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 287774 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 287778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 287787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 287794 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 287794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 287797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 287804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 287809 */     GIR_RootConstrainSelectedInstOperands,
     /* 287810 */     // GIR_Coverage, 1703,
     /* 287810 */     GIR_EraseRootFromParent_Done,
     /* 287811 */   // Label 5563: @287811
     /* 287811 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(287870), // Rule ID 692 //
     /* 287816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287827 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287830 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 287835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 287839 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 287843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287855 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 287855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 287858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 287864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 287868 */     GIR_RootConstrainSelectedInstOperands,
     /* 287869 */     // GIR_Coverage, 692,
     /* 287869 */     GIR_EraseRootFromParent_Done,
     /* 287870 */   // Label 5564: @287870
     /* 287870 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(287929), // Rule ID 1701 //
     /* 287875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 287886 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 287889 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 287894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 287898 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 287902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287914 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 287914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 287917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 287923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 287927 */     GIR_RootConstrainSelectedInstOperands,
     /* 287928 */     // GIR_Coverage, 1701,
     /* 287928 */     GIR_EraseRootFromParent_Done,
     /* 287929 */   // Label 5565: @287929
     /* 287929 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(287956), // Rule ID 6416 //
     /* 287934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 287941 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 287941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 287944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 287951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287954 */     GIR_RootConstrainSelectedInstOperands,
     /* 287955 */     // GIR_Coverage, 6416,
     /* 287955 */     GIR_EraseRootFromParent_Done,
     /* 287956 */   // Label 5566: @287956
     /* 287956 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(287977), // Rule ID 6407 //
     /* 287961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287965 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 287965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 287968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 287975 */     GIR_RootConstrainSelectedInstOperands,
     /* 287976 */     // GIR_Coverage, 6407,
     /* 287976 */     GIR_EraseRootFromParent_Done,
     /* 287977 */   // Label 5567: @287977
     /* 287977 */   GIM_Reject,
     /* 287978 */ // Label 5561: @287978
     /* 287978 */ GIM_Reject,
     /* 287979 */ // Label 5534: @287979
     /* 287979 */ GIM_Reject,
     /* 287980 */ // Label 46: @287980
     /* 287980 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5573*/ GIMT_Encode4(288804),
     /* 287991 */ /*GILLT_s32*//*Label 5568*/ GIMT_Encode4(288027),
     /* 287995 */ /*GILLT_s64*//*Label 5569*/ GIMT_Encode4(288204), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 288007 */ /*GILLT_v2s64*//*Label 5570*/ GIMT_Encode4(288377), GIMT_Encode4(0),
     /* 288015 */ /*GILLT_v4s32*//*Label 5571*/ GIMT_Encode4(288522), GIMT_Encode4(0),
     /* 288023 */ /*GILLT_v8s16*//*Label 5572*/ GIMT_Encode4(288663),
     /* 288027 */ // Label 5568: @288027
     /* 288027 */ GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(288203),
     /* 288032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 288035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288046 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(288083), // Rule ID 3935 //
     /* 288051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 288059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288070 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 288073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288081 */     GIR_RootConstrainSelectedInstOperands,
     /* 288082 */     // GIR_Coverage, 3935,
     /* 288082 */     GIR_EraseRootFromParent_Done,
     /* 288083 */   // Label 5575: @288083
     /* 288083 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(288120), // Rule ID 3936 //
     /* 288088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288107 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 288110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288118 */     GIR_RootConstrainSelectedInstOperands,
     /* 288119 */     // GIR_Coverage, 3936,
     /* 288119 */     GIR_EraseRootFromParent_Done,
     /* 288120 */   // Label 5576: @288120
     /* 288120 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(288157), // Rule ID 3934 //
     /* 288125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288144 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 288147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288155 */     GIR_RootConstrainSelectedInstOperands,
     /* 288156 */     // GIR_Coverage, 3934,
     /* 288156 */     GIR_EraseRootFromParent_Done,
     /* 288157 */   // Label 5577: @288157
     /* 288157 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(288202), // Rule ID 3933 //
     /* 288162 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 288162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 288165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288174 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 288180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 288193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288200 */     GIR_RootConstrainSelectedInstOperands,
     /* 288201 */     // GIR_Coverage, 3933,
     /* 288201 */     GIR_EraseRootFromParent_Done,
     /* 288202 */   // Label 5578: @288202
     /* 288202 */   GIM_Reject,
     /* 288203 */ // Label 5574: @288203
     /* 288203 */ GIM_Reject,
     /* 288204 */ // Label 5569: @288204
     /* 288204 */ GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(288376),
     /* 288209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 288212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288223 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(288291), // Rule ID 3937 //
     /* 288228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288247 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 288247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288259 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288266 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 288282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288289 */     GIR_RootConstrainSelectedInstOperands,
     /* 288290 */     // GIR_Coverage, 3937,
     /* 288290 */     GIR_EraseRootFromParent_Done,
     /* 288291 */   // Label 5580: @288291
     /* 288291 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(288359), // Rule ID 3938 //
     /* 288296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288315 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 288315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288327 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288334 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 288350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288357 */     GIR_RootConstrainSelectedInstOperands,
     /* 288358 */     // GIR_Coverage, 3938,
     /* 288358 */     GIR_EraseRootFromParent_Done,
     /* 288359 */   // Label 5581: @288359
     /* 288359 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(288375), // Rule ID 120 //
     /* 288364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288368 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 288368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 288373 */     GIR_RootConstrainSelectedInstOperands,
     /* 288374 */     // GIR_Coverage, 120,
     /* 288374 */     GIR_Done,
     /* 288375 */   // Label 5582: @288375
     /* 288375 */   GIM_Reject,
     /* 288376 */ // Label 5579: @288376
     /* 288376 */ GIM_Reject,
     /* 288377 */ // Label 5570: @288377
     /* 288377 */ GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(288521),
     /* 288382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 288388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288392 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(288456), // Rule ID 6405 //
     /* 288397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 288422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 288426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 288430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288434 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 288438 */     // MIs[3] Operand 1
     /* 288438 */     // No operand predicates
     /* 288438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288440 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 288440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 288443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288449 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 288454 */     GIR_RootConstrainSelectedInstOperands,
     /* 288455 */     // GIR_Coverage, 6405,
     /* 288455 */     GIR_EraseRootFromParent_Done,
     /* 288456 */   // Label 5584: @288456
     /* 288456 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(288520), // Rule ID 6402 //
     /* 288461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 288486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 288490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 288494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288498 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 288502 */     // MIs[3] Operand 1
     /* 288502 */     // No operand predicates
     /* 288502 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288504 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 288504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 288507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288513 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 288518 */     GIR_RootConstrainSelectedInstOperands,
     /* 288519 */     // GIR_Coverage, 6402,
     /* 288519 */     GIR_EraseRootFromParent_Done,
     /* 288520 */   // Label 5585: @288520
     /* 288520 */   GIM_Reject,
     /* 288521 */ // Label 5583: @288521
     /* 288521 */ GIM_Reject,
     /* 288522 */ // Label 5571: @288522
     /* 288522 */ GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(288662),
     /* 288527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 288533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288537 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(288599), // Rule ID 6404 //
     /* 288542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 288554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 288567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 288571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 288575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288579 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 288583 */     // MIs[3] Operand 1
     /* 288583 */     // No operand predicates
     /* 288583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288585 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 288585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 288588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 288597 */     GIR_RootConstrainSelectedInstOperands,
     /* 288598 */     // GIR_Coverage, 6404,
     /* 288598 */     GIR_EraseRootFromParent_Done,
     /* 288599 */   // Label 5587: @288599
     /* 288599 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(288661), // Rule ID 6401 //
     /* 288604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 288616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 288629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 288633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 288637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288641 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 288645 */     // MIs[3] Operand 1
     /* 288645 */     // No operand predicates
     /* 288645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288647 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 288647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 288650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 288659 */     GIR_RootConstrainSelectedInstOperands,
     /* 288660 */     // GIR_Coverage, 6401,
     /* 288660 */     GIR_EraseRootFromParent_Done,
     /* 288661 */   // Label 5588: @288661
     /* 288661 */   GIM_Reject,
     /* 288662 */ // Label 5586: @288662
     /* 288662 */ GIM_Reject,
     /* 288663 */ // Label 5572: @288663
     /* 288663 */ GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(288803),
     /* 288668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 288671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 288674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288678 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(288740), // Rule ID 6403 //
     /* 288683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 288695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 288708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 288712 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 288716 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288720 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 288724 */     // MIs[3] Operand 1
     /* 288724 */     // No operand predicates
     /* 288724 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288726 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 288726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 288729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 288738 */     GIR_RootConstrainSelectedInstOperands,
     /* 288739 */     // GIR_Coverage, 6403,
     /* 288739 */     GIR_EraseRootFromParent_Done,
     /* 288740 */   // Label 5590: @288740
     /* 288740 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(288802), // Rule ID 6400 //
     /* 288745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 288757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 288766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 288770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 288774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 288778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288782 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 288786 */     // MIs[3] Operand 1
     /* 288786 */     // No operand predicates
     /* 288786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288788 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 288788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 288791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 288800 */     GIR_RootConstrainSelectedInstOperands,
     /* 288801 */     // GIR_Coverage, 6400,
     /* 288801 */     GIR_EraseRootFromParent_Done,
     /* 288802 */   // Label 5591: @288802
     /* 288802 */   GIM_Reject,
     /* 288803 */ // Label 5589: @288803
     /* 288803 */ GIM_Reject,
     /* 288804 */ // Label 5573: @288804
     /* 288804 */ GIM_Reject,
     /* 288805 */ // Label 47: @288805
     /* 288805 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5594*/ GIMT_Encode4(289242),
     /* 288816 */ /*GILLT_s32*//*Label 5592*/ GIMT_Encode4(288824),
     /* 288820 */ /*GILLT_s64*//*Label 5593*/ GIMT_Encode4(289035),
     /* 288824 */ // Label 5592: @288824
     /* 288824 */ GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(289034),
     /* 288829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 288832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288843 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(288877), // Rule ID 4024 //
     /* 288848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 288860 */     // MIs[1] Operand 1
     /* 288860 */     // No operand predicates
     /* 288860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288862 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 288862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 288865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 288872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 288875 */     GIR_RootConstrainSelectedInstOperands,
     /* 288876 */     // GIR_Coverage, 4024,
     /* 288876 */     GIR_EraseRootFromParent_Done,
     /* 288877 */   // Label 5596: @288877
     /* 288877 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(288914), // Rule ID 3941 //
     /* 288882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 288890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288901 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 288904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288912 */     GIR_RootConstrainSelectedInstOperands,
     /* 288913 */     // GIR_Coverage, 3941,
     /* 288913 */     GIR_EraseRootFromParent_Done,
     /* 288914 */   // Label 5597: @288914
     /* 288914 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(288951), // Rule ID 3942 //
     /* 288919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288938 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 288941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288949 */     GIR_RootConstrainSelectedInstOperands,
     /* 288950 */     // GIR_Coverage, 3942,
     /* 288950 */     GIR_EraseRootFromParent_Done,
     /* 288951 */   // Label 5598: @288951
     /* 288951 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(288988), // Rule ID 3940 //
     /* 288956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288975 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 288978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288986 */     GIR_RootConstrainSelectedInstOperands,
     /* 288987 */     // GIR_Coverage, 3940,
     /* 288987 */     GIR_EraseRootFromParent_Done,
     /* 288988 */   // Label 5599: @288988
     /* 288988 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(289033), // Rule ID 3939 //
     /* 288993 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 288993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 288996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289005 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 289011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289016 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 289024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289031 */     GIR_RootConstrainSelectedInstOperands,
     /* 289032 */     // GIR_Coverage, 3939,
     /* 289032 */     GIR_EraseRootFromParent_Done,
     /* 289033 */   // Label 5600: @289033
     /* 289033 */   GIM_Reject,
     /* 289034 */ // Label 5595: @289034
     /* 289034 */ GIM_Reject,
     /* 289035 */ // Label 5593: @289035
     /* 289035 */ GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(289241),
     /* 289040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 289043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 289046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289054 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(289088), // Rule ID 4025 //
     /* 289059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 289071 */     // MIs[1] Operand 1
     /* 289071 */     // No operand predicates
     /* 289071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289073 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 289073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 289076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 289083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 289086 */     GIR_RootConstrainSelectedInstOperands,
     /* 289087 */     // GIR_Coverage, 4025,
     /* 289087 */     GIR_EraseRootFromParent_Done,
     /* 289088 */   // Label 5602: @289088
     /* 289088 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(289156), // Rule ID 3943 //
     /* 289093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 289101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289112 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 289112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289124 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289127 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289131 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 289134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 289139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 289147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289154 */     GIR_RootConstrainSelectedInstOperands,
     /* 289155 */     // GIR_Coverage, 3943,
     /* 289155 */     GIR_EraseRootFromParent_Done,
     /* 289156 */   // Label 5603: @289156
     /* 289156 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(289224), // Rule ID 3944 //
     /* 289161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 289169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289180 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 289180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289192 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289195 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289199 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 289202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 289207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 289215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289217 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289222 */     GIR_RootConstrainSelectedInstOperands,
     /* 289223 */     // GIR_Coverage, 3944,
     /* 289223 */     GIR_EraseRootFromParent_Done,
     /* 289224 */   // Label 5604: @289224
     /* 289224 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(289240), // Rule ID 121 //
     /* 289229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289233 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 289233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 289238 */     GIR_RootConstrainSelectedInstOperands,
     /* 289239 */     // GIR_Coverage, 121,
     /* 289239 */     GIR_Done,
     /* 289240 */   // Label 5605: @289240
     /* 289240 */   GIM_Reject,
     /* 289241 */ // Label 5601: @289241
     /* 289241 */ GIM_Reject,
     /* 289242 */ // Label 5594: @289242
     /* 289242 */ GIM_Reject,
     /* 289243 */ // Label 48: @289243
     /* 289243 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5608*/ GIMT_Encode4(290067),
     /* 289254 */ /*GILLT_s32*//*Label 5606*/ GIMT_Encode4(289262),
     /* 289258 */ /*GILLT_s64*//*Label 5607*/ GIMT_Encode4(289617),
     /* 289262 */ // Label 5606: @289262
     /* 289262 */ GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(289616),
     /* 289267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 289270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 289273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289277 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(289341), // Rule ID 6567 //
     /* 289282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 289290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289299 */     // MIs[1] Operand 2
     /* 289299 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 289310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289318 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 289322 */     // MIs[2] Operand 1
     /* 289322 */     // No operand predicates
     /* 289322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289324 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 289324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 289327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 289333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 289336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 289339 */     GIR_RootConstrainSelectedInstOperands,
     /* 289340 */     // GIR_Coverage, 6567,
     /* 289340 */     GIR_EraseRootFromParent_Done,
     /* 289341 */   // Label 5610: @289341
     /* 289341 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(289405), // Rule ID 6569 //
     /* 289346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 289354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289363 */     // MIs[1] Operand 2
     /* 289363 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 289374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289382 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 289386 */     // MIs[2] Operand 1
     /* 289386 */     // No operand predicates
     /* 289386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289388 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 289388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 289391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 289397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 289400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 289403 */     GIR_RootConstrainSelectedInstOperands,
     /* 289404 */     // GIR_Coverage, 6569,
     /* 289404 */     GIR_EraseRootFromParent_Done,
     /* 289405 */   // Label 5611: @289405
     /* 289405 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(289443), // Rule ID 4022 //
     /* 289410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 289426 */     // MIs[1] Operand 1
     /* 289426 */     // No operand predicates
     /* 289426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289428 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 289428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 289431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 289438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 289441 */     GIR_RootConstrainSelectedInstOperands,
     /* 289442 */     // GIR_Coverage, 4022,
     /* 289442 */     GIR_EraseRootFromParent_Done,
     /* 289443 */   // Label 5612: @289443
     /* 289443 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(289484), // Rule ID 2435 //
     /* 289448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 289460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289471 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 289471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 289474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289482 */     GIR_RootConstrainSelectedInstOperands,
     /* 289483 */     // GIR_Coverage, 2435,
     /* 289483 */     GIR_EraseRootFromParent_Done,
     /* 289484 */   // Label 5613: @289484
     /* 289484 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(289525), // Rule ID 2436 //
     /* 289489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 289501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289512 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 289512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 289515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289523 */     GIR_RootConstrainSelectedInstOperands,
     /* 289524 */     // GIR_Coverage, 2436,
     /* 289524 */     GIR_EraseRootFromParent_Done,
     /* 289525 */   // Label 5614: @289525
     /* 289525 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(289566), // Rule ID 2434 //
     /* 289530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 289542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289553 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 289553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 289556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289564 */     GIR_RootConstrainSelectedInstOperands,
     /* 289565 */     // GIR_Coverage, 2434,
     /* 289565 */     GIR_EraseRootFromParent_Done,
     /* 289566 */   // Label 5615: @289566
     /* 289566 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(289615), // Rule ID 2433 //
     /* 289571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289575 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 289575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 289578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289587 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 289593 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 289606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289613 */     GIR_RootConstrainSelectedInstOperands,
     /* 289614 */     // GIR_Coverage, 2433,
     /* 289614 */     GIR_EraseRootFromParent_Done,
     /* 289615 */   // Label 5616: @289615
     /* 289615 */   GIM_Reject,
     /* 289616 */ // Label 5609: @289616
     /* 289616 */ GIM_Reject,
     /* 289617 */ // Label 5607: @289617
     /* 289617 */ GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(290066),
     /* 289622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 289625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 289628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289632 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(289696), // Rule ID 6568 //
     /* 289637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 289645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 289649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289654 */     // MIs[1] Operand 2
     /* 289654 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 289665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289673 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 289677 */     // MIs[2] Operand 1
     /* 289677 */     // No operand predicates
     /* 289677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289679 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 289679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 289682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 289688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 289691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 289694 */     GIR_RootConstrainSelectedInstOperands,
     /* 289695 */     // GIR_Coverage, 6568,
     /* 289695 */     GIR_EraseRootFromParent_Done,
     /* 289696 */   // Label 5618: @289696
     /* 289696 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(289760), // Rule ID 6570 //
     /* 289701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 289709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 289713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289718 */     // MIs[1] Operand 2
     /* 289718 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 289729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289737 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 289741 */     // MIs[2] Operand 1
     /* 289741 */     // No operand predicates
     /* 289741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289743 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 289743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 289746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 289752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 289755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 289758 */     GIR_RootConstrainSelectedInstOperands,
     /* 289759 */     // GIR_Coverage, 6570,
     /* 289759 */     GIR_EraseRootFromParent_Done,
     /* 289760 */   // Label 5619: @289760
     /* 289760 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(289863), // Rule ID 6571 //
     /* 289765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 289773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 289786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289790 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 289794 */     // MIs[2] Operand 1
     /* 289794 */     // No operand predicates
     /* 289794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289796 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 289796 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 289799 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 289803 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 289810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 289817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 289825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 289829 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 289832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 289837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 289842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 289850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 289858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 289861 */     GIR_RootConstrainSelectedInstOperands,
     /* 289862 */     // GIR_Coverage, 6571,
     /* 289862 */     GIR_EraseRootFromParent_Done,
     /* 289863 */   // Label 5620: @289863
     /* 289863 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(289901), // Rule ID 4023 //
     /* 289868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 289884 */     // MIs[1] Operand 1
     /* 289884 */     // No operand predicates
     /* 289884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289886 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 289886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 289889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 289896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 289899 */     GIR_RootConstrainSelectedInstOperands,
     /* 289900 */     // GIR_Coverage, 4023,
     /* 289900 */     GIR_EraseRootFromParent_Done,
     /* 289901 */   // Label 5621: @289901
     /* 289901 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(289973), // Rule ID 2437 //
     /* 289906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 289918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289929 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 289929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 289932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 289936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289941 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 289944 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289948 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 289951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 289956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 289964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289971 */     GIR_RootConstrainSelectedInstOperands,
     /* 289972 */     // GIR_Coverage, 2437,
     /* 289972 */     GIR_EraseRootFromParent_Done,
     /* 289973 */   // Label 5622: @289973
     /* 289973 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(290045), // Rule ID 2438 //
     /* 289978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 289982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 289990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 289999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290001 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 290001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 290004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290013 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290016 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290020 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 290023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 290028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 290036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290043 */     GIR_RootConstrainSelectedInstOperands,
     /* 290044 */     // GIR_Coverage, 2438,
     /* 290044 */     GIR_EraseRootFromParent_Done,
     /* 290045 */   // Label 5623: @290045
     /* 290045 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(290065), // Rule ID 119 //
     /* 290050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290058 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 290058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 290063 */     GIR_RootConstrainSelectedInstOperands,
     /* 290064 */     // GIR_Coverage, 119,
     /* 290064 */     GIR_Done,
     /* 290065 */   // Label 5624: @290065
     /* 290065 */   GIM_Reject,
     /* 290066 */ // Label 5617: @290066
     /* 290066 */ GIM_Reject,
     /* 290067 */ // Label 5608: @290067
     /* 290067 */ GIM_Reject,
     /* 290068 */ // Label 49: @290068
     /* 290068 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5627*/ GIMT_Encode4(290197),
     /* 290079 */ /*GILLT_s32*//*Label 5625*/ GIMT_Encode4(290087),
     /* 290083 */ /*GILLT_s64*//*Label 5626*/ GIMT_Encode4(290142),
     /* 290087 */ // Label 5625: @290087
     /* 290087 */ GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(290141), // Rule ID 188 //
     /* 290092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 290095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 290098 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 290101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290113 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290117 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290121 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 290125 */   // MIs[1] Operand 1
     /* 290125 */   // No operand predicates
     /* 290125 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290127 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 290127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 290130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290132 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290134 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 290136 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 290139 */   GIR_RootConstrainSelectedInstOperands,
     /* 290140 */   // GIR_Coverage, 188,
     /* 290140 */   GIR_EraseRootFromParent_Done,
     /* 290141 */ // Label 5628: @290141
     /* 290141 */ GIM_Reject,
     /* 290142 */ // Label 5626: @290142
     /* 290142 */ GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(290196), // Rule ID 189 //
     /* 290147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 290150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 290153 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 290156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290164 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290168 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290172 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290176 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 290180 */   // MIs[1] Operand 1
     /* 290180 */   // No operand predicates
     /* 290180 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290182 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 290182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 290185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290187 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290189 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 290191 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 290194 */   GIR_RootConstrainSelectedInstOperands,
     /* 290195 */   // GIR_Coverage, 189,
     /* 290195 */   GIR_EraseRootFromParent_Done,
     /* 290196 */ // Label 5629: @290196
     /* 290196 */ GIM_Reject,
     /* 290197 */ // Label 5627: @290197
     /* 290197 */ GIM_Reject,
     /* 290198 */ // Label 50: @290198
     /* 290198 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5632*/ GIMT_Encode4(290739),
     /* 290209 */ /*GILLT_s32*//*Label 5630*/ GIMT_Encode4(290217),
     /* 290213 */ /*GILLT_s64*//*Label 5631*/ GIMT_Encode4(290482),
     /* 290217 */ // Label 5630: @290217
     /* 290217 */ GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(290481),
     /* 290222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 290225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 290228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290232 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(290271), // Rule ID 184 //
     /* 290237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 290245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 290258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290260 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 290260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 290263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 290269 */     GIR_RootConstrainSelectedInstOperands,
     /* 290270 */     // GIR_Coverage, 184,
     /* 290270 */     GIR_EraseRootFromParent_Done,
     /* 290271 */   // Label 5634: @290271
     /* 290271 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(290308), // Rule ID 4018 //
     /* 290276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 290292 */     // MIs[1] Operand 1
     /* 290292 */     // No operand predicates
     /* 290292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290294 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 290294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 290297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 290306 */     GIR_RootConstrainSelectedInstOperands,
     /* 290307 */     // GIR_Coverage, 4018,
     /* 290307 */     GIR_EraseRootFromParent_Done,
     /* 290308 */   // Label 5635: @290308
     /* 290308 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(290349), // Rule ID 3947 //
     /* 290313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 290325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290336 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 290336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 290339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290341 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290347 */     GIR_RootConstrainSelectedInstOperands,
     /* 290348 */     // GIR_Coverage, 3947,
     /* 290348 */     GIR_EraseRootFromParent_Done,
     /* 290349 */   // Label 5636: @290349
     /* 290349 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(290390), // Rule ID 3948 //
     /* 290354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 290366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290377 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 290377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 290380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290388 */     GIR_RootConstrainSelectedInstOperands,
     /* 290389 */     // GIR_Coverage, 3948,
     /* 290389 */     GIR_EraseRootFromParent_Done,
     /* 290390 */   // Label 5637: @290390
     /* 290390 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(290431), // Rule ID 3946 //
     /* 290395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 290407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290418 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 290418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 290421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290429 */     GIR_RootConstrainSelectedInstOperands,
     /* 290430 */     // GIR_Coverage, 3946,
     /* 290430 */     GIR_EraseRootFromParent_Done,
     /* 290431 */   // Label 5638: @290431
     /* 290431 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(290480), // Rule ID 3945 //
     /* 290436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290440 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 290440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 290443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290452 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 290458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 290471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290478 */     GIR_RootConstrainSelectedInstOperands,
     /* 290479 */     // GIR_Coverage, 3945,
     /* 290479 */     GIR_EraseRootFromParent_Done,
     /* 290480 */   // Label 5639: @290480
     /* 290480 */   GIM_Reject,
     /* 290481 */ // Label 5633: @290481
     /* 290481 */ GIM_Reject,
     /* 290482 */ // Label 5631: @290482
     /* 290482 */ GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(290738),
     /* 290487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 290490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 290493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290497 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(290536), // Rule ID 187 //
     /* 290502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 290510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 290514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 290523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290525 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 290525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 290528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 290534 */     GIR_RootConstrainSelectedInstOperands,
     /* 290535 */     // GIR_Coverage, 187,
     /* 290535 */     GIR_EraseRootFromParent_Done,
     /* 290536 */   // Label 5641: @290536
     /* 290536 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(290573), // Rule ID 4019 //
     /* 290541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 290557 */     // MIs[1] Operand 1
     /* 290557 */     // No operand predicates
     /* 290557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290559 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 290559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 290562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 290571 */     GIR_RootConstrainSelectedInstOperands,
     /* 290572 */     // GIR_Coverage, 4019,
     /* 290572 */     GIR_EraseRootFromParent_Done,
     /* 290573 */   // Label 5642: @290573
     /* 290573 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(290645), // Rule ID 3949 //
     /* 290578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 290590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290601 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 290601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 290604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290613 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290616 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290620 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 290623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 290628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 290636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290643 */     GIR_RootConstrainSelectedInstOperands,
     /* 290644 */     // GIR_Coverage, 3949,
     /* 290644 */     GIR_EraseRootFromParent_Done,
     /* 290645 */   // Label 5643: @290645
     /* 290645 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(290717), // Rule ID 3950 //
     /* 290650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 290662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 290666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290673 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 290673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 290676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 290680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290685 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 290688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290692 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 290695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 290700 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 290705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 290708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 290712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290715 */     GIR_RootConstrainSelectedInstOperands,
     /* 290716 */     // GIR_Coverage, 3950,
     /* 290716 */     GIR_EraseRootFromParent_Done,
     /* 290717 */   // Label 5644: @290717
     /* 290717 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(290737), // Rule ID 122 //
     /* 290722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 290730 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 290730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 290735 */     GIR_RootConstrainSelectedInstOperands,
     /* 290736 */     // GIR_Coverage, 122,
     /* 290736 */     GIR_Done,
     /* 290737 */   // Label 5645: @290737
     /* 290737 */   GIM_Reject,
     /* 290738 */ // Label 5640: @290738
     /* 290738 */ GIM_Reject,
     /* 290739 */ // Label 5632: @290739
     /* 290739 */ GIM_Reject,
     /* 290740 */ // Label 51: @290740
     /* 290740 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5654*/ GIMT_Encode4(298516),
     /* 290751 */ /*GILLT_s64*//*Label 5646*/ GIMT_Encode4(290787), GIMT_Encode4(0),
     /* 290759 */ /*GILLT_v2s32*//*Label 5647*/ GIMT_Encode4(291180),
     /* 290763 */ /*GILLT_v2s64*//*Label 5648*/ GIMT_Encode4(292228),
     /* 290767 */ /*GILLT_v4s16*//*Label 5649*/ GIMT_Encode4(293276),
     /* 290771 */ /*GILLT_v4s32*//*Label 5650*/ GIMT_Encode4(294324),
     /* 290775 */ /*GILLT_v8s8*//*Label 5651*/ GIMT_Encode4(295372),
     /* 290779 */ /*GILLT_v8s16*//*Label 5652*/ GIMT_Encode4(296420),
     /* 290783 */ /*GILLT_v16s8*//*Label 5653*/ GIMT_Encode4(297468),
     /* 290787 */ // Label 5646: @290787
     /* 290787 */ GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(291179),
     /* 290792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 290795 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 290798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290802 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(290838), // Rule ID 5278 //
     /* 290807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290810 */     // MIs[0] Operand 1
     /* 290810 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290819 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290825 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290829 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 290829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv1i64rz),
     /* 290832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290836 */     GIR_RootConstrainSelectedInstOperands,
     /* 290837 */     // GIR_Coverage, 5278,
     /* 290837 */     GIR_EraseRootFromParent_Done,
     /* 290838 */   // Label 5656: @290838
     /* 290838 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(290874), // Rule ID 5279 //
     /* 290843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290846 */     // MIs[0] Operand 1
     /* 290846 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290855 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290861 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290865 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 290865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 290868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290872 */     GIR_RootConstrainSelectedInstOperands,
     /* 290873 */     // GIR_Coverage, 5279,
     /* 290873 */     GIR_EraseRootFromParent_Done,
     /* 290874 */   // Label 5657: @290874
     /* 290874 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(290910), // Rule ID 2512 //
     /* 290879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290882 */     // MIs[0] Operand 1
     /* 290882 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290891 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290897 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290901 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 290901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64rz),
     /* 290904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290908 */     GIR_RootConstrainSelectedInstOperands,
     /* 290909 */     // GIR_Coverage, 2512,
     /* 290909 */     GIR_EraseRootFromParent_Done,
     /* 290910 */   // Label 5658: @290910
     /* 290910 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(290946), // Rule ID 5275 //
     /* 290915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290918 */     // MIs[0] Operand 1
     /* 290918 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290927 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290933 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290937 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGE:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 290937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 290940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290944 */     GIR_RootConstrainSelectedInstOperands,
     /* 290945 */     // GIR_Coverage, 5275,
     /* 290945 */     GIR_EraseRootFromParent_Done,
     /* 290946 */   // Label 5659: @290946
     /* 290946 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(290982), // Rule ID 5276 //
     /* 290951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290954 */     // MIs[0] Operand 1
     /* 290954 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290963 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290969 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 290971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290973 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 290973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 290976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290980 */     GIR_RootConstrainSelectedInstOperands,
     /* 290981 */     // GIR_Coverage, 5276,
     /* 290981 */     GIR_EraseRootFromParent_Done,
     /* 290982 */   // Label 5660: @290982
     /* 290982 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(291018), // Rule ID 5277 //
     /* 290987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290990 */     // MIs[0] Operand 1
     /* 290990 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290999 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291005 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291009 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 291009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64rz),
     /* 291012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291016 */     GIR_RootConstrainSelectedInstOperands,
     /* 291017 */     // GIR_Coverage, 5277,
     /* 291017 */     GIR_EraseRootFromParent_Done,
     /* 291018 */   // Label 5661: @291018
     /* 291018 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(291050), // Rule ID 1608 //
     /* 291023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291026 */     // MIs[0] Operand 1
     /* 291026 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291039 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 291039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64),
     /* 291042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291048 */     GIR_RootConstrainSelectedInstOperands,
     /* 291049 */     // GIR_Coverage, 1608,
     /* 291049 */     GIR_EraseRootFromParent_Done,
     /* 291050 */   // Label 5662: @291050
     /* 291050 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(291082), // Rule ID 1609 //
     /* 291055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291058 */     // MIs[0] Operand 1
     /* 291058 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291071 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 291071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64),
     /* 291074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291080 */     GIR_RootConstrainSelectedInstOperands,
     /* 291081 */     // GIR_Coverage, 1609,
     /* 291081 */     GIR_EraseRootFromParent_Done,
     /* 291082 */   // Label 5663: @291082
     /* 291082 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(291114), // Rule ID 1610 //
     /* 291087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291090 */     // MIs[0] Operand 1
     /* 291090 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291103 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 291103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64),
     /* 291106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291112 */     GIR_RootConstrainSelectedInstOperands,
     /* 291113 */     // GIR_Coverage, 1610,
     /* 291113 */     GIR_EraseRootFromParent_Done,
     /* 291114 */   // Label 5664: @291114
     /* 291114 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(291146), // Rule ID 1611 //
     /* 291119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291122 */     // MIs[0] Operand 1
     /* 291122 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 291127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291135 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 291135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv1i64),
     /* 291138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291144 */     GIR_RootConstrainSelectedInstOperands,
     /* 291145 */     // GIR_Coverage, 1611,
     /* 291145 */     GIR_EraseRootFromParent_Done,
     /* 291146 */   // Label 5665: @291146
     /* 291146 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(291178), // Rule ID 1612 //
     /* 291151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291154 */     // MIs[0] Operand 1
     /* 291154 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 291159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291167 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 291167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv1i64),
     /* 291170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291176 */     GIR_RootConstrainSelectedInstOperands,
     /* 291177 */     // GIR_Coverage, 1612,
     /* 291177 */     GIR_EraseRootFromParent_Done,
     /* 291178 */   // Label 5666: @291178
     /* 291178 */   GIM_Reject,
     /* 291179 */ // Label 5655: @291179
     /* 291179 */ GIM_Reject,
     /* 291180 */ // Label 5647: @291180
     /* 291180 */ GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(292227),
     /* 291185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 291188 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 291191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291195 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(291235), // Rule ID 754 //
     /* 291200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291203 */     // MIs[0] Operand 1
     /* 291203 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291212 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291218 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291226 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 291229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291233 */     GIR_RootConstrainSelectedInstOperands,
     /* 291234 */     // GIR_Coverage, 754,
     /* 291234 */     GIR_EraseRootFromParent_Done,
     /* 291235 */   // Label 5668: @291235
     /* 291235 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(291275), // Rule ID 761 //
     /* 291240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291243 */     // MIs[0] Operand 1
     /* 291243 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291252 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291258 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291266 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 291269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291273 */     GIR_RootConstrainSelectedInstOperands,
     /* 291274 */     // GIR_Coverage, 761,
     /* 291274 */     GIR_EraseRootFromParent_Done,
     /* 291275 */   // Label 5669: @291275
     /* 291275 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(291312), // Rule ID 5212 //
     /* 291280 */     // MIs[0] Operand 1
     /* 291280 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291289 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291295 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291303 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 291306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291310 */     GIR_RootConstrainSelectedInstOperands,
     /* 291311 */     // GIR_Coverage, 5212,
     /* 291311 */     GIR_EraseRootFromParent_Done,
     /* 291312 */   // Label 5670: @291312
     /* 291312 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(291349), // Rule ID 5219 //
     /* 291317 */     // MIs[0] Operand 1
     /* 291317 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291326 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291332 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291340 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 291343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291347 */     GIR_RootConstrainSelectedInstOperands,
     /* 291348 */     // GIR_Coverage, 5219,
     /* 291348 */     GIR_EraseRootFromParent_Done,
     /* 291349 */   // Label 5671: @291349
     /* 291349 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(291386), // Rule ID 5226 //
     /* 291354 */     // MIs[0] Operand 1
     /* 291354 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291363 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291369 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291377 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 291380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291384 */     GIR_RootConstrainSelectedInstOperands,
     /* 291385 */     // GIR_Coverage, 5226,
     /* 291385 */     GIR_EraseRootFromParent_Done,
     /* 291386 */   // Label 5672: @291386
     /* 291386 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(291423), // Rule ID 5233 //
     /* 291391 */     // MIs[0] Operand 1
     /* 291391 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291400 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291406 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291414 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 291417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291421 */     GIR_RootConstrainSelectedInstOperands,
     /* 291422 */     // GIR_Coverage, 5233,
     /* 291422 */     GIR_EraseRootFromParent_Done,
     /* 291423 */   // Label 5673: @291423
     /* 291423 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(291460), // Rule ID 5240 //
     /* 291428 */     // MIs[0] Operand 1
     /* 291428 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291437 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291443 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291451 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 291454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291458 */     GIR_RootConstrainSelectedInstOperands,
     /* 291459 */     // GIR_Coverage, 5240,
     /* 291459 */     GIR_EraseRootFromParent_Done,
     /* 291460 */   // Label 5674: @291460
     /* 291460 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(291500), // Rule ID 726 //
     /* 291465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291468 */     // MIs[0] Operand 1
     /* 291468 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291481 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291487 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291491 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 291494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291498 */     GIR_RootConstrainSelectedInstOperands,
     /* 291499 */     // GIR_Coverage, 726,
     /* 291499 */     GIR_EraseRootFromParent_Done,
     /* 291500 */   // Label 5675: @291500
     /* 291500 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(291540), // Rule ID 737 //
     /* 291505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291508 */     // MIs[0] Operand 1
     /* 291508 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291521 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291527 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291531 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 291534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291538 */     GIR_RootConstrainSelectedInstOperands,
     /* 291539 */     // GIR_Coverage, 737,
     /* 291539 */     GIR_EraseRootFromParent_Done,
     /* 291540 */   // Label 5676: @291540
     /* 291540 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(291580), // Rule ID 738 //
     /* 291545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291548 */     // MIs[0] Operand 1
     /* 291548 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291561 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291567 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 291569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291571 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 291574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291578 */     GIR_RootConstrainSelectedInstOperands,
     /* 291579 */     // GIR_Coverage, 738,
     /* 291579 */     GIR_EraseRootFromParent_Done,
     /* 291580 */   // Label 5677: @291580
     /* 291580 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(291620), // Rule ID 747 //
     /* 291585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291588 */     // MIs[0] Operand 1
     /* 291588 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291601 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291607 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291611 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 291614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291618 */     GIR_RootConstrainSelectedInstOperands,
     /* 291619 */     // GIR_Coverage, 747,
     /* 291619 */     GIR_EraseRootFromParent_Done,
     /* 291620 */   // Label 5678: @291620
     /* 291620 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(291657), // Rule ID 5177 //
     /* 291625 */     // MIs[0] Operand 1
     /* 291625 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291638 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291644 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291648 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 291651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291655 */     GIR_RootConstrainSelectedInstOperands,
     /* 291656 */     // GIR_Coverage, 5177,
     /* 291656 */     GIR_EraseRootFromParent_Done,
     /* 291657 */   // Label 5679: @291657
     /* 291657 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(291694), // Rule ID 5184 //
     /* 291662 */     // MIs[0] Operand 1
     /* 291662 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291675 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291681 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291685 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 291688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291692 */     GIR_RootConstrainSelectedInstOperands,
     /* 291693 */     // GIR_Coverage, 5184,
     /* 291693 */     GIR_EraseRootFromParent_Done,
     /* 291694 */   // Label 5680: @291694
     /* 291694 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(291731), // Rule ID 5191 //
     /* 291699 */     // MIs[0] Operand 1
     /* 291699 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291712 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291718 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291722 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 291725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291729 */     GIR_RootConstrainSelectedInstOperands,
     /* 291730 */     // GIR_Coverage, 5191,
     /* 291730 */     GIR_EraseRootFromParent_Done,
     /* 291731 */   // Label 5681: @291731
     /* 291731 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(291768), // Rule ID 5198 //
     /* 291736 */     // MIs[0] Operand 1
     /* 291736 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291749 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291755 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291759 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 291762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291766 */     GIR_RootConstrainSelectedInstOperands,
     /* 291767 */     // GIR_Coverage, 5198,
     /* 291767 */     GIR_EraseRootFromParent_Done,
     /* 291768 */   // Label 5682: @291768
     /* 291768 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(291805), // Rule ID 5205 //
     /* 291773 */     // MIs[0] Operand 1
     /* 291773 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291786 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291792 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291796 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 291796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 291799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291803 */     GIR_RootConstrainSelectedInstOperands,
     /* 291804 */     // GIR_Coverage, 5205,
     /* 291804 */     GIR_EraseRootFromParent_Done,
     /* 291805 */   // Label 5683: @291805
     /* 291805 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(291837), // Rule ID 1125 //
     /* 291810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291813 */     // MIs[0] Operand 1
     /* 291813 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291826 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 291826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 291829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291835 */     GIR_RootConstrainSelectedInstOperands,
     /* 291836 */     // GIR_Coverage, 1125,
     /* 291836 */     GIR_EraseRootFromParent_Done,
     /* 291837 */   // Label 5684: @291837
     /* 291837 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(291869), // Rule ID 1132 //
     /* 291842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291845 */     // MIs[0] Operand 1
     /* 291845 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291858 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 291858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 291861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291867 */     GIR_RootConstrainSelectedInstOperands,
     /* 291868 */     // GIR_Coverage, 1132,
     /* 291868 */     GIR_EraseRootFromParent_Done,
     /* 291869 */   // Label 5685: @291869
     /* 291869 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(291901), // Rule ID 1139 //
     /* 291874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291877 */     // MIs[0] Operand 1
     /* 291877 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291890 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 291890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 291893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291899 */     GIR_RootConstrainSelectedInstOperands,
     /* 291900 */     // GIR_Coverage, 1139,
     /* 291900 */     GIR_EraseRootFromParent_Done,
     /* 291901 */   // Label 5686: @291901
     /* 291901 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(291933), // Rule ID 1146 //
     /* 291906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291909 */     // MIs[0] Operand 1
     /* 291909 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 291914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291922 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 291922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 291925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291931 */     GIR_RootConstrainSelectedInstOperands,
     /* 291932 */     // GIR_Coverage, 1146,
     /* 291932 */     GIR_EraseRootFromParent_Done,
     /* 291933 */   // Label 5687: @291933
     /* 291933 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(291965), // Rule ID 1153 //
     /* 291938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291941 */     // MIs[0] Operand 1
     /* 291941 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 291946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291954 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 291954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 291957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291963 */     GIR_RootConstrainSelectedInstOperands,
     /* 291964 */     // GIR_Coverage, 1153,
     /* 291964 */     GIR_EraseRootFromParent_Done,
     /* 291965 */   // Label 5688: @291965
     /* 291965 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(291994), // Rule ID 5114 //
     /* 291970 */     // MIs[0] Operand 1
     /* 291970 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291983 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 291983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 291986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291992 */     GIR_RootConstrainSelectedInstOperands,
     /* 291993 */     // GIR_Coverage, 5114,
     /* 291993 */     GIR_EraseRootFromParent_Done,
     /* 291994 */   // Label 5689: @291994
     /* 291994 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(292023), // Rule ID 5121 //
     /* 291999 */     // MIs[0] Operand 1
     /* 291999 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292012 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 292012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 292015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292021 */     GIR_RootConstrainSelectedInstOperands,
     /* 292022 */     // GIR_Coverage, 5121,
     /* 292022 */     GIR_EraseRootFromParent_Done,
     /* 292023 */   // Label 5690: @292023
     /* 292023 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(292052), // Rule ID 5128 //
     /* 292028 */     // MIs[0] Operand 1
     /* 292028 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292041 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 292041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 292044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292050 */     GIR_RootConstrainSelectedInstOperands,
     /* 292051 */     // GIR_Coverage, 5128,
     /* 292051 */     GIR_EraseRootFromParent_Done,
     /* 292052 */   // Label 5691: @292052
     /* 292052 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(292081), // Rule ID 5135 //
     /* 292057 */     // MIs[0] Operand 1
     /* 292057 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 292062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292070 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 292070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 292073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292079 */     GIR_RootConstrainSelectedInstOperands,
     /* 292080 */     // GIR_Coverage, 5135,
     /* 292080 */     GIR_EraseRootFromParent_Done,
     /* 292081 */   // Label 5692: @292081
     /* 292081 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(292110), // Rule ID 5142 //
     /* 292086 */     // MIs[0] Operand 1
     /* 292086 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 292091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292099 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 292099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 292102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292108 */     GIR_RootConstrainSelectedInstOperands,
     /* 292109 */     // GIR_Coverage, 5142,
     /* 292109 */     GIR_EraseRootFromParent_Done,
     /* 292110 */   // Label 5693: @292110
     /* 292110 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(292139), // Rule ID 5149 //
     /* 292115 */     // MIs[0] Operand 1
     /* 292115 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292128 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 292128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 292131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292137 */     GIR_RootConstrainSelectedInstOperands,
     /* 292138 */     // GIR_Coverage, 5149,
     /* 292138 */     GIR_EraseRootFromParent_Done,
     /* 292139 */   // Label 5694: @292139
     /* 292139 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(292168), // Rule ID 5156 //
     /* 292144 */     // MIs[0] Operand 1
     /* 292144 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292157 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 292157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 292160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292166 */     GIR_RootConstrainSelectedInstOperands,
     /* 292167 */     // GIR_Coverage, 5156,
     /* 292167 */     GIR_EraseRootFromParent_Done,
     /* 292168 */   // Label 5695: @292168
     /* 292168 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(292197), // Rule ID 5163 //
     /* 292173 */     // MIs[0] Operand 1
     /* 292173 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 292178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292186 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 292186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 292189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292195 */     GIR_RootConstrainSelectedInstOperands,
     /* 292196 */     // GIR_Coverage, 5163,
     /* 292196 */     GIR_EraseRootFromParent_Done,
     /* 292197 */   // Label 5696: @292197
     /* 292197 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(292226), // Rule ID 5170 //
     /* 292202 */     // MIs[0] Operand 1
     /* 292202 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 292207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292215 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 292215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 292218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292224 */     GIR_RootConstrainSelectedInstOperands,
     /* 292225 */     // GIR_Coverage, 5170,
     /* 292225 */     GIR_EraseRootFromParent_Done,
     /* 292226 */   // Label 5697: @292226
     /* 292226 */   GIM_Reject,
     /* 292227 */ // Label 5667: @292227
     /* 292227 */ GIM_Reject,
     /* 292228 */ // Label 5648: @292228
     /* 292228 */ GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(293275),
     /* 292233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 292236 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 292239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292243 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(292283), // Rule ID 756 //
     /* 292248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292251 */     // MIs[0] Operand 1
     /* 292251 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292260 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292266 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292274 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 292277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292281 */     GIR_RootConstrainSelectedInstOperands,
     /* 292282 */     // GIR_Coverage, 756,
     /* 292282 */     GIR_EraseRootFromParent_Done,
     /* 292283 */   // Label 5699: @292283
     /* 292283 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(292323), // Rule ID 763 //
     /* 292288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292291 */     // MIs[0] Operand 1
     /* 292291 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292300 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292306 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292314 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 292317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292321 */     GIR_RootConstrainSelectedInstOperands,
     /* 292322 */     // GIR_Coverage, 763,
     /* 292322 */     GIR_EraseRootFromParent_Done,
     /* 292323 */   // Label 5700: @292323
     /* 292323 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(292360), // Rule ID 5214 //
     /* 292328 */     // MIs[0] Operand 1
     /* 292328 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292337 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292343 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292351 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 292354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292358 */     GIR_RootConstrainSelectedInstOperands,
     /* 292359 */     // GIR_Coverage, 5214,
     /* 292359 */     GIR_EraseRootFromParent_Done,
     /* 292360 */   // Label 5701: @292360
     /* 292360 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(292397), // Rule ID 5221 //
     /* 292365 */     // MIs[0] Operand 1
     /* 292365 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292374 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292380 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292388 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 292391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292395 */     GIR_RootConstrainSelectedInstOperands,
     /* 292396 */     // GIR_Coverage, 5221,
     /* 292396 */     GIR_EraseRootFromParent_Done,
     /* 292397 */   // Label 5702: @292397
     /* 292397 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(292434), // Rule ID 5228 //
     /* 292402 */     // MIs[0] Operand 1
     /* 292402 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292411 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292417 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292425 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 292428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292432 */     GIR_RootConstrainSelectedInstOperands,
     /* 292433 */     // GIR_Coverage, 5228,
     /* 292433 */     GIR_EraseRootFromParent_Done,
     /* 292434 */   // Label 5703: @292434
     /* 292434 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(292471), // Rule ID 5235 //
     /* 292439 */     // MIs[0] Operand 1
     /* 292439 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292448 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292454 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292462 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 292465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292469 */     GIR_RootConstrainSelectedInstOperands,
     /* 292470 */     // GIR_Coverage, 5235,
     /* 292470 */     GIR_EraseRootFromParent_Done,
     /* 292471 */   // Label 5704: @292471
     /* 292471 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(292508), // Rule ID 5242 //
     /* 292476 */     // MIs[0] Operand 1
     /* 292476 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292485 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292491 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292499 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 292502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292506 */     GIR_RootConstrainSelectedInstOperands,
     /* 292507 */     // GIR_Coverage, 5242,
     /* 292507 */     GIR_EraseRootFromParent_Done,
     /* 292508 */   // Label 5705: @292508
     /* 292508 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(292548), // Rule ID 728 //
     /* 292513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292516 */     // MIs[0] Operand 1
     /* 292516 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292529 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292535 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292539 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 292542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292546 */     GIR_RootConstrainSelectedInstOperands,
     /* 292547 */     // GIR_Coverage, 728,
     /* 292547 */     GIR_EraseRootFromParent_Done,
     /* 292548 */   // Label 5706: @292548
     /* 292548 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(292588), // Rule ID 741 //
     /* 292553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292556 */     // MIs[0] Operand 1
     /* 292556 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292569 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292575 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292579 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 292582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292586 */     GIR_RootConstrainSelectedInstOperands,
     /* 292587 */     // GIR_Coverage, 741,
     /* 292587 */     GIR_EraseRootFromParent_Done,
     /* 292588 */   // Label 5707: @292588
     /* 292588 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(292628), // Rule ID 742 //
     /* 292593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292596 */     // MIs[0] Operand 1
     /* 292596 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292609 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292615 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 292617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292619 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 292622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292626 */     GIR_RootConstrainSelectedInstOperands,
     /* 292627 */     // GIR_Coverage, 742,
     /* 292627 */     GIR_EraseRootFromParent_Done,
     /* 292628 */   // Label 5708: @292628
     /* 292628 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(292668), // Rule ID 749 //
     /* 292633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292636 */     // MIs[0] Operand 1
     /* 292636 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292649 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292655 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292659 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 292662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292666 */     GIR_RootConstrainSelectedInstOperands,
     /* 292667 */     // GIR_Coverage, 749,
     /* 292667 */     GIR_EraseRootFromParent_Done,
     /* 292668 */   // Label 5709: @292668
     /* 292668 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(292705), // Rule ID 5179 //
     /* 292673 */     // MIs[0] Operand 1
     /* 292673 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292686 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292692 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292696 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 292699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292703 */     GIR_RootConstrainSelectedInstOperands,
     /* 292704 */     // GIR_Coverage, 5179,
     /* 292704 */     GIR_EraseRootFromParent_Done,
     /* 292705 */   // Label 5710: @292705
     /* 292705 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(292742), // Rule ID 5186 //
     /* 292710 */     // MIs[0] Operand 1
     /* 292710 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292723 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292729 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292733 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 292736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292740 */     GIR_RootConstrainSelectedInstOperands,
     /* 292741 */     // GIR_Coverage, 5186,
     /* 292741 */     GIR_EraseRootFromParent_Done,
     /* 292742 */   // Label 5711: @292742
     /* 292742 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(292779), // Rule ID 5193 //
     /* 292747 */     // MIs[0] Operand 1
     /* 292747 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292760 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292766 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292770 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 292773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292777 */     GIR_RootConstrainSelectedInstOperands,
     /* 292778 */     // GIR_Coverage, 5193,
     /* 292778 */     GIR_EraseRootFromParent_Done,
     /* 292779 */   // Label 5712: @292779
     /* 292779 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(292816), // Rule ID 5200 //
     /* 292784 */     // MIs[0] Operand 1
     /* 292784 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292797 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292803 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292807 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 292810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292814 */     GIR_RootConstrainSelectedInstOperands,
     /* 292815 */     // GIR_Coverage, 5200,
     /* 292815 */     GIR_EraseRootFromParent_Done,
     /* 292816 */   // Label 5713: @292816
     /* 292816 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(292853), // Rule ID 5207 //
     /* 292821 */     // MIs[0] Operand 1
     /* 292821 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292834 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292840 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292844 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 292844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 292847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292851 */     GIR_RootConstrainSelectedInstOperands,
     /* 292852 */     // GIR_Coverage, 5207,
     /* 292852 */     GIR_EraseRootFromParent_Done,
     /* 292853 */   // Label 5714: @292853
     /* 292853 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(292885), // Rule ID 1127 //
     /* 292858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292861 */     // MIs[0] Operand 1
     /* 292861 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292874 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 292874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 292877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292883 */     GIR_RootConstrainSelectedInstOperands,
     /* 292884 */     // GIR_Coverage, 1127,
     /* 292884 */     GIR_EraseRootFromParent_Done,
     /* 292885 */   // Label 5715: @292885
     /* 292885 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(292917), // Rule ID 1134 //
     /* 292890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292893 */     // MIs[0] Operand 1
     /* 292893 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292906 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 292906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 292909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292915 */     GIR_RootConstrainSelectedInstOperands,
     /* 292916 */     // GIR_Coverage, 1134,
     /* 292916 */     GIR_EraseRootFromParent_Done,
     /* 292917 */   // Label 5716: @292917
     /* 292917 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(292949), // Rule ID 1141 //
     /* 292922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292925 */     // MIs[0] Operand 1
     /* 292925 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292938 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 292938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 292941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292947 */     GIR_RootConstrainSelectedInstOperands,
     /* 292948 */     // GIR_Coverage, 1141,
     /* 292948 */     GIR_EraseRootFromParent_Done,
     /* 292949 */   // Label 5717: @292949
     /* 292949 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(292981), // Rule ID 1148 //
     /* 292954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292957 */     // MIs[0] Operand 1
     /* 292957 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 292962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292970 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 292970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 292973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292979 */     GIR_RootConstrainSelectedInstOperands,
     /* 292980 */     // GIR_Coverage, 1148,
     /* 292980 */     GIR_EraseRootFromParent_Done,
     /* 292981 */   // Label 5718: @292981
     /* 292981 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(293013), // Rule ID 1155 //
     /* 292986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292989 */     // MIs[0] Operand 1
     /* 292989 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 292994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293002 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 293002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 293005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293011 */     GIR_RootConstrainSelectedInstOperands,
     /* 293012 */     // GIR_Coverage, 1155,
     /* 293012 */     GIR_EraseRootFromParent_Done,
     /* 293013 */   // Label 5719: @293013
     /* 293013 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(293042), // Rule ID 5116 //
     /* 293018 */     // MIs[0] Operand 1
     /* 293018 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293031 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 293031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 293034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293040 */     GIR_RootConstrainSelectedInstOperands,
     /* 293041 */     // GIR_Coverage, 5116,
     /* 293041 */     GIR_EraseRootFromParent_Done,
     /* 293042 */   // Label 5720: @293042
     /* 293042 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(293071), // Rule ID 5123 //
     /* 293047 */     // MIs[0] Operand 1
     /* 293047 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293060 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 293060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 293063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293069 */     GIR_RootConstrainSelectedInstOperands,
     /* 293070 */     // GIR_Coverage, 5123,
     /* 293070 */     GIR_EraseRootFromParent_Done,
     /* 293071 */   // Label 5721: @293071
     /* 293071 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(293100), // Rule ID 5130 //
     /* 293076 */     // MIs[0] Operand 1
     /* 293076 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293089 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 293089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 293092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293098 */     GIR_RootConstrainSelectedInstOperands,
     /* 293099 */     // GIR_Coverage, 5130,
     /* 293099 */     GIR_EraseRootFromParent_Done,
     /* 293100 */   // Label 5722: @293100
     /* 293100 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(293129), // Rule ID 5137 //
     /* 293105 */     // MIs[0] Operand 1
     /* 293105 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 293110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293118 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 293118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 293121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293127 */     GIR_RootConstrainSelectedInstOperands,
     /* 293128 */     // GIR_Coverage, 5137,
     /* 293128 */     GIR_EraseRootFromParent_Done,
     /* 293129 */   // Label 5723: @293129
     /* 293129 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(293158), // Rule ID 5144 //
     /* 293134 */     // MIs[0] Operand 1
     /* 293134 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 293139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293147 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 293147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 293150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293156 */     GIR_RootConstrainSelectedInstOperands,
     /* 293157 */     // GIR_Coverage, 5144,
     /* 293157 */     GIR_EraseRootFromParent_Done,
     /* 293158 */   // Label 5724: @293158
     /* 293158 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(293187), // Rule ID 5151 //
     /* 293163 */     // MIs[0] Operand 1
     /* 293163 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293176 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 293176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 293179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293185 */     GIR_RootConstrainSelectedInstOperands,
     /* 293186 */     // GIR_Coverage, 5151,
     /* 293186 */     GIR_EraseRootFromParent_Done,
     /* 293187 */   // Label 5725: @293187
     /* 293187 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(293216), // Rule ID 5158 //
     /* 293192 */     // MIs[0] Operand 1
     /* 293192 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293205 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 293205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 293208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293214 */     GIR_RootConstrainSelectedInstOperands,
     /* 293215 */     // GIR_Coverage, 5158,
     /* 293215 */     GIR_EraseRootFromParent_Done,
     /* 293216 */   // Label 5726: @293216
     /* 293216 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(293245), // Rule ID 5165 //
     /* 293221 */     // MIs[0] Operand 1
     /* 293221 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 293226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293234 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 293234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 293237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293243 */     GIR_RootConstrainSelectedInstOperands,
     /* 293244 */     // GIR_Coverage, 5165,
     /* 293244 */     GIR_EraseRootFromParent_Done,
     /* 293245 */   // Label 5727: @293245
     /* 293245 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(293274), // Rule ID 5172 //
     /* 293250 */     // MIs[0] Operand 1
     /* 293250 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 293255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293263 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 293263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 293266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293272 */     GIR_RootConstrainSelectedInstOperands,
     /* 293273 */     // GIR_Coverage, 5172,
     /* 293273 */     GIR_EraseRootFromParent_Done,
     /* 293274 */   // Label 5728: @293274
     /* 293274 */   GIM_Reject,
     /* 293275 */ // Label 5698: @293275
     /* 293275 */ GIM_Reject,
     /* 293276 */ // Label 5649: @293276
     /* 293276 */ GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(294323),
     /* 293281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 293284 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 293287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293291 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(293331), // Rule ID 752 //
     /* 293296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293299 */     // MIs[0] Operand 1
     /* 293299 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293308 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293314 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293322 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 293325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293329 */     GIR_RootConstrainSelectedInstOperands,
     /* 293330 */     // GIR_Coverage, 752,
     /* 293330 */     GIR_EraseRootFromParent_Done,
     /* 293331 */   // Label 5730: @293331
     /* 293331 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(293371), // Rule ID 759 //
     /* 293336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293339 */     // MIs[0] Operand 1
     /* 293339 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293348 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293354 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293362 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 293365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293369 */     GIR_RootConstrainSelectedInstOperands,
     /* 293370 */     // GIR_Coverage, 759,
     /* 293370 */     GIR_EraseRootFromParent_Done,
     /* 293371 */   // Label 5731: @293371
     /* 293371 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(293408), // Rule ID 5210 //
     /* 293376 */     // MIs[0] Operand 1
     /* 293376 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293385 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293391 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293399 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 293402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293406 */     GIR_RootConstrainSelectedInstOperands,
     /* 293407 */     // GIR_Coverage, 5210,
     /* 293407 */     GIR_EraseRootFromParent_Done,
     /* 293408 */   // Label 5732: @293408
     /* 293408 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(293445), // Rule ID 5217 //
     /* 293413 */     // MIs[0] Operand 1
     /* 293413 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293422 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293428 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293436 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 293439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293443 */     GIR_RootConstrainSelectedInstOperands,
     /* 293444 */     // GIR_Coverage, 5217,
     /* 293444 */     GIR_EraseRootFromParent_Done,
     /* 293445 */   // Label 5733: @293445
     /* 293445 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(293482), // Rule ID 5224 //
     /* 293450 */     // MIs[0] Operand 1
     /* 293450 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293459 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293465 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293473 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 293476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293480 */     GIR_RootConstrainSelectedInstOperands,
     /* 293481 */     // GIR_Coverage, 5224,
     /* 293481 */     GIR_EraseRootFromParent_Done,
     /* 293482 */   // Label 5734: @293482
     /* 293482 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(293519), // Rule ID 5231 //
     /* 293487 */     // MIs[0] Operand 1
     /* 293487 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293496 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293502 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293510 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 293513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293517 */     GIR_RootConstrainSelectedInstOperands,
     /* 293518 */     // GIR_Coverage, 5231,
     /* 293518 */     GIR_EraseRootFromParent_Done,
     /* 293519 */   // Label 5735: @293519
     /* 293519 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(293556), // Rule ID 5238 //
     /* 293524 */     // MIs[0] Operand 1
     /* 293524 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293533 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293539 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293547 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 293550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293554 */     GIR_RootConstrainSelectedInstOperands,
     /* 293555 */     // GIR_Coverage, 5238,
     /* 293555 */     GIR_EraseRootFromParent_Done,
     /* 293556 */   // Label 5736: @293556
     /* 293556 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(293596), // Rule ID 724 //
     /* 293561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293564 */     // MIs[0] Operand 1
     /* 293564 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293577 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293583 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293587 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 293590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293594 */     GIR_RootConstrainSelectedInstOperands,
     /* 293595 */     // GIR_Coverage, 724,
     /* 293595 */     GIR_EraseRootFromParent_Done,
     /* 293596 */   // Label 5737: @293596
     /* 293596 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(293636), // Rule ID 733 //
     /* 293601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293604 */     // MIs[0] Operand 1
     /* 293604 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293617 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293623 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293627 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 293630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293634 */     GIR_RootConstrainSelectedInstOperands,
     /* 293635 */     // GIR_Coverage, 733,
     /* 293635 */     GIR_EraseRootFromParent_Done,
     /* 293636 */   // Label 5738: @293636
     /* 293636 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(293676), // Rule ID 734 //
     /* 293641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293644 */     // MIs[0] Operand 1
     /* 293644 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293657 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293663 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 293665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293667 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 293670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293674 */     GIR_RootConstrainSelectedInstOperands,
     /* 293675 */     // GIR_Coverage, 734,
     /* 293675 */     GIR_EraseRootFromParent_Done,
     /* 293676 */   // Label 5739: @293676
     /* 293676 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(293716), // Rule ID 745 //
     /* 293681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293684 */     // MIs[0] Operand 1
     /* 293684 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293697 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293703 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293707 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 293710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293714 */     GIR_RootConstrainSelectedInstOperands,
     /* 293715 */     // GIR_Coverage, 745,
     /* 293715 */     GIR_EraseRootFromParent_Done,
     /* 293716 */   // Label 5740: @293716
     /* 293716 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(293753), // Rule ID 5175 //
     /* 293721 */     // MIs[0] Operand 1
     /* 293721 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293734 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293740 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293744 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 293747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293751 */     GIR_RootConstrainSelectedInstOperands,
     /* 293752 */     // GIR_Coverage, 5175,
     /* 293752 */     GIR_EraseRootFromParent_Done,
     /* 293753 */   // Label 5741: @293753
     /* 293753 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(293790), // Rule ID 5182 //
     /* 293758 */     // MIs[0] Operand 1
     /* 293758 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293771 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293777 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293781 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 293784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293788 */     GIR_RootConstrainSelectedInstOperands,
     /* 293789 */     // GIR_Coverage, 5182,
     /* 293789 */     GIR_EraseRootFromParent_Done,
     /* 293790 */   // Label 5742: @293790
     /* 293790 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(293827), // Rule ID 5189 //
     /* 293795 */     // MIs[0] Operand 1
     /* 293795 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293808 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293814 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293818 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 293821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293825 */     GIR_RootConstrainSelectedInstOperands,
     /* 293826 */     // GIR_Coverage, 5189,
     /* 293826 */     GIR_EraseRootFromParent_Done,
     /* 293827 */   // Label 5743: @293827
     /* 293827 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(293864), // Rule ID 5196 //
     /* 293832 */     // MIs[0] Operand 1
     /* 293832 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293845 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293851 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293855 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 293858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293862 */     GIR_RootConstrainSelectedInstOperands,
     /* 293863 */     // GIR_Coverage, 5196,
     /* 293863 */     GIR_EraseRootFromParent_Done,
     /* 293864 */   // Label 5744: @293864
     /* 293864 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(293901), // Rule ID 5203 //
     /* 293869 */     // MIs[0] Operand 1
     /* 293869 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293882 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293888 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293892 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 293892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 293895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293899 */     GIR_RootConstrainSelectedInstOperands,
     /* 293900 */     // GIR_Coverage, 5203,
     /* 293900 */     GIR_EraseRootFromParent_Done,
     /* 293901 */   // Label 5745: @293901
     /* 293901 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(293933), // Rule ID 1123 //
     /* 293906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293909 */     // MIs[0] Operand 1
     /* 293909 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293922 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 293922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 293925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293931 */     GIR_RootConstrainSelectedInstOperands,
     /* 293932 */     // GIR_Coverage, 1123,
     /* 293932 */     GIR_EraseRootFromParent_Done,
     /* 293933 */   // Label 5746: @293933
     /* 293933 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(293965), // Rule ID 1130 //
     /* 293938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293941 */     // MIs[0] Operand 1
     /* 293941 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293954 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 293954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 293957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293963 */     GIR_RootConstrainSelectedInstOperands,
     /* 293964 */     // GIR_Coverage, 1130,
     /* 293964 */     GIR_EraseRootFromParent_Done,
     /* 293965 */   // Label 5747: @293965
     /* 293965 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(293997), // Rule ID 1137 //
     /* 293970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293973 */     // MIs[0] Operand 1
     /* 293973 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293986 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 293986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 293989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293995 */     GIR_RootConstrainSelectedInstOperands,
     /* 293996 */     // GIR_Coverage, 1137,
     /* 293996 */     GIR_EraseRootFromParent_Done,
     /* 293997 */   // Label 5748: @293997
     /* 293997 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(294029), // Rule ID 1144 //
     /* 294002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294005 */     // MIs[0] Operand 1
     /* 294005 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 294010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294018 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 294018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 294021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294027 */     GIR_RootConstrainSelectedInstOperands,
     /* 294028 */     // GIR_Coverage, 1144,
     /* 294028 */     GIR_EraseRootFromParent_Done,
     /* 294029 */   // Label 5749: @294029
     /* 294029 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(294061), // Rule ID 1151 //
     /* 294034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294037 */     // MIs[0] Operand 1
     /* 294037 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 294042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294050 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 294050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 294053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294059 */     GIR_RootConstrainSelectedInstOperands,
     /* 294060 */     // GIR_Coverage, 1151,
     /* 294060 */     GIR_EraseRootFromParent_Done,
     /* 294061 */   // Label 5750: @294061
     /* 294061 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(294090), // Rule ID 5112 //
     /* 294066 */     // MIs[0] Operand 1
     /* 294066 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294079 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 294079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 294082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294088 */     GIR_RootConstrainSelectedInstOperands,
     /* 294089 */     // GIR_Coverage, 5112,
     /* 294089 */     GIR_EraseRootFromParent_Done,
     /* 294090 */   // Label 5751: @294090
     /* 294090 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(294119), // Rule ID 5119 //
     /* 294095 */     // MIs[0] Operand 1
     /* 294095 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294108 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 294108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 294111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294117 */     GIR_RootConstrainSelectedInstOperands,
     /* 294118 */     // GIR_Coverage, 5119,
     /* 294118 */     GIR_EraseRootFromParent_Done,
     /* 294119 */   // Label 5752: @294119
     /* 294119 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(294148), // Rule ID 5126 //
     /* 294124 */     // MIs[0] Operand 1
     /* 294124 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294137 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 294137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 294140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294146 */     GIR_RootConstrainSelectedInstOperands,
     /* 294147 */     // GIR_Coverage, 5126,
     /* 294147 */     GIR_EraseRootFromParent_Done,
     /* 294148 */   // Label 5753: @294148
     /* 294148 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(294177), // Rule ID 5133 //
     /* 294153 */     // MIs[0] Operand 1
     /* 294153 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 294158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294166 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 294166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 294169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294175 */     GIR_RootConstrainSelectedInstOperands,
     /* 294176 */     // GIR_Coverage, 5133,
     /* 294176 */     GIR_EraseRootFromParent_Done,
     /* 294177 */   // Label 5754: @294177
     /* 294177 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(294206), // Rule ID 5140 //
     /* 294182 */     // MIs[0] Operand 1
     /* 294182 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 294187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294195 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 294195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 294198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294204 */     GIR_RootConstrainSelectedInstOperands,
     /* 294205 */     // GIR_Coverage, 5140,
     /* 294205 */     GIR_EraseRootFromParent_Done,
     /* 294206 */   // Label 5755: @294206
     /* 294206 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(294235), // Rule ID 5147 //
     /* 294211 */     // MIs[0] Operand 1
     /* 294211 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294224 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 294224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 294227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294233 */     GIR_RootConstrainSelectedInstOperands,
     /* 294234 */     // GIR_Coverage, 5147,
     /* 294234 */     GIR_EraseRootFromParent_Done,
     /* 294235 */   // Label 5756: @294235
     /* 294235 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(294264), // Rule ID 5154 //
     /* 294240 */     // MIs[0] Operand 1
     /* 294240 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294253 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 294253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 294256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294262 */     GIR_RootConstrainSelectedInstOperands,
     /* 294263 */     // GIR_Coverage, 5154,
     /* 294263 */     GIR_EraseRootFromParent_Done,
     /* 294264 */   // Label 5757: @294264
     /* 294264 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(294293), // Rule ID 5161 //
     /* 294269 */     // MIs[0] Operand 1
     /* 294269 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 294274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294282 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 294282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 294285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294291 */     GIR_RootConstrainSelectedInstOperands,
     /* 294292 */     // GIR_Coverage, 5161,
     /* 294292 */     GIR_EraseRootFromParent_Done,
     /* 294293 */   // Label 5758: @294293
     /* 294293 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(294322), // Rule ID 5168 //
     /* 294298 */     // MIs[0] Operand 1
     /* 294298 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 294303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294311 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 294311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 294314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294320 */     GIR_RootConstrainSelectedInstOperands,
     /* 294321 */     // GIR_Coverage, 5168,
     /* 294321 */     GIR_EraseRootFromParent_Done,
     /* 294322 */   // Label 5759: @294322
     /* 294322 */   GIM_Reject,
     /* 294323 */ // Label 5729: @294323
     /* 294323 */ GIM_Reject,
     /* 294324 */ // Label 5650: @294324
     /* 294324 */ GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(295371),
     /* 294329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 294332 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 294335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294339 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(294379), // Rule ID 755 //
     /* 294344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294347 */     // MIs[0] Operand 1
     /* 294347 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294356 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294362 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294370 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 294373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294377 */     GIR_RootConstrainSelectedInstOperands,
     /* 294378 */     // GIR_Coverage, 755,
     /* 294378 */     GIR_EraseRootFromParent_Done,
     /* 294379 */   // Label 5761: @294379
     /* 294379 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(294419), // Rule ID 762 //
     /* 294384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294387 */     // MIs[0] Operand 1
     /* 294387 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294396 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294402 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294410 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 294413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294417 */     GIR_RootConstrainSelectedInstOperands,
     /* 294418 */     // GIR_Coverage, 762,
     /* 294418 */     GIR_EraseRootFromParent_Done,
     /* 294419 */   // Label 5762: @294419
     /* 294419 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(294456), // Rule ID 5213 //
     /* 294424 */     // MIs[0] Operand 1
     /* 294424 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294433 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294439 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294447 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 294450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294454 */     GIR_RootConstrainSelectedInstOperands,
     /* 294455 */     // GIR_Coverage, 5213,
     /* 294455 */     GIR_EraseRootFromParent_Done,
     /* 294456 */   // Label 5763: @294456
     /* 294456 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(294493), // Rule ID 5220 //
     /* 294461 */     // MIs[0] Operand 1
     /* 294461 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294470 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294476 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294484 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 294487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294491 */     GIR_RootConstrainSelectedInstOperands,
     /* 294492 */     // GIR_Coverage, 5220,
     /* 294492 */     GIR_EraseRootFromParent_Done,
     /* 294493 */   // Label 5764: @294493
     /* 294493 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(294530), // Rule ID 5227 //
     /* 294498 */     // MIs[0] Operand 1
     /* 294498 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294507 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294513 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294521 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 294524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294528 */     GIR_RootConstrainSelectedInstOperands,
     /* 294529 */     // GIR_Coverage, 5227,
     /* 294529 */     GIR_EraseRootFromParent_Done,
     /* 294530 */   // Label 5765: @294530
     /* 294530 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(294567), // Rule ID 5234 //
     /* 294535 */     // MIs[0] Operand 1
     /* 294535 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294544 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294550 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294558 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 294561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294565 */     GIR_RootConstrainSelectedInstOperands,
     /* 294566 */     // GIR_Coverage, 5234,
     /* 294566 */     GIR_EraseRootFromParent_Done,
     /* 294567 */   // Label 5766: @294567
     /* 294567 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(294604), // Rule ID 5241 //
     /* 294572 */     // MIs[0] Operand 1
     /* 294572 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294581 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294587 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294595 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 294598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294602 */     GIR_RootConstrainSelectedInstOperands,
     /* 294603 */     // GIR_Coverage, 5241,
     /* 294603 */     GIR_EraseRootFromParent_Done,
     /* 294604 */   // Label 5767: @294604
     /* 294604 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(294644), // Rule ID 727 //
     /* 294609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294612 */     // MIs[0] Operand 1
     /* 294612 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294625 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294631 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294635 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 294638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294642 */     GIR_RootConstrainSelectedInstOperands,
     /* 294643 */     // GIR_Coverage, 727,
     /* 294643 */     GIR_EraseRootFromParent_Done,
     /* 294644 */   // Label 5768: @294644
     /* 294644 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(294684), // Rule ID 739 //
     /* 294649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294652 */     // MIs[0] Operand 1
     /* 294652 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294665 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294671 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294675 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 294678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294682 */     GIR_RootConstrainSelectedInstOperands,
     /* 294683 */     // GIR_Coverage, 739,
     /* 294683 */     GIR_EraseRootFromParent_Done,
     /* 294684 */   // Label 5769: @294684
     /* 294684 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(294724), // Rule ID 740 //
     /* 294689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294692 */     // MIs[0] Operand 1
     /* 294692 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294705 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294711 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 294713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294715 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 294718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294722 */     GIR_RootConstrainSelectedInstOperands,
     /* 294723 */     // GIR_Coverage, 740,
     /* 294723 */     GIR_EraseRootFromParent_Done,
     /* 294724 */   // Label 5770: @294724
     /* 294724 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(294764), // Rule ID 748 //
     /* 294729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294732 */     // MIs[0] Operand 1
     /* 294732 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294745 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294751 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294755 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 294758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294762 */     GIR_RootConstrainSelectedInstOperands,
     /* 294763 */     // GIR_Coverage, 748,
     /* 294763 */     GIR_EraseRootFromParent_Done,
     /* 294764 */   // Label 5771: @294764
     /* 294764 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(294801), // Rule ID 5178 //
     /* 294769 */     // MIs[0] Operand 1
     /* 294769 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294782 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294788 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294792 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 294795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294799 */     GIR_RootConstrainSelectedInstOperands,
     /* 294800 */     // GIR_Coverage, 5178,
     /* 294800 */     GIR_EraseRootFromParent_Done,
     /* 294801 */   // Label 5772: @294801
     /* 294801 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(294838), // Rule ID 5185 //
     /* 294806 */     // MIs[0] Operand 1
     /* 294806 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294819 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294825 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294829 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 294832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294836 */     GIR_RootConstrainSelectedInstOperands,
     /* 294837 */     // GIR_Coverage, 5185,
     /* 294837 */     GIR_EraseRootFromParent_Done,
     /* 294838 */   // Label 5773: @294838
     /* 294838 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(294875), // Rule ID 5192 //
     /* 294843 */     // MIs[0] Operand 1
     /* 294843 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294856 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294862 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294866 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 294869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294873 */     GIR_RootConstrainSelectedInstOperands,
     /* 294874 */     // GIR_Coverage, 5192,
     /* 294874 */     GIR_EraseRootFromParent_Done,
     /* 294875 */   // Label 5774: @294875
     /* 294875 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(294912), // Rule ID 5199 //
     /* 294880 */     // MIs[0] Operand 1
     /* 294880 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294893 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294899 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294903 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 294906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294910 */     GIR_RootConstrainSelectedInstOperands,
     /* 294911 */     // GIR_Coverage, 5199,
     /* 294911 */     GIR_EraseRootFromParent_Done,
     /* 294912 */   // Label 5775: @294912
     /* 294912 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(294949), // Rule ID 5206 //
     /* 294917 */     // MIs[0] Operand 1
     /* 294917 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294930 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294936 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294940 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 294940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 294943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294947 */     GIR_RootConstrainSelectedInstOperands,
     /* 294948 */     // GIR_Coverage, 5206,
     /* 294948 */     GIR_EraseRootFromParent_Done,
     /* 294949 */   // Label 5776: @294949
     /* 294949 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(294981), // Rule ID 1126 //
     /* 294954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294957 */     // MIs[0] Operand 1
     /* 294957 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294970 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 294970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 294973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294979 */     GIR_RootConstrainSelectedInstOperands,
     /* 294980 */     // GIR_Coverage, 1126,
     /* 294980 */     GIR_EraseRootFromParent_Done,
     /* 294981 */   // Label 5777: @294981
     /* 294981 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(295013), // Rule ID 1133 //
     /* 294986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294989 */     // MIs[0] Operand 1
     /* 294989 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295002 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 295002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 295005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295011 */     GIR_RootConstrainSelectedInstOperands,
     /* 295012 */     // GIR_Coverage, 1133,
     /* 295012 */     GIR_EraseRootFromParent_Done,
     /* 295013 */   // Label 5778: @295013
     /* 295013 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(295045), // Rule ID 1140 //
     /* 295018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295021 */     // MIs[0] Operand 1
     /* 295021 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295034 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 295034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 295037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295043 */     GIR_RootConstrainSelectedInstOperands,
     /* 295044 */     // GIR_Coverage, 1140,
     /* 295044 */     GIR_EraseRootFromParent_Done,
     /* 295045 */   // Label 5779: @295045
     /* 295045 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(295077), // Rule ID 1147 //
     /* 295050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295053 */     // MIs[0] Operand 1
     /* 295053 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 295058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295066 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 295066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 295069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295075 */     GIR_RootConstrainSelectedInstOperands,
     /* 295076 */     // GIR_Coverage, 1147,
     /* 295076 */     GIR_EraseRootFromParent_Done,
     /* 295077 */   // Label 5780: @295077
     /* 295077 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(295109), // Rule ID 1154 //
     /* 295082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295085 */     // MIs[0] Operand 1
     /* 295085 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 295090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295098 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 295098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 295101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295107 */     GIR_RootConstrainSelectedInstOperands,
     /* 295108 */     // GIR_Coverage, 1154,
     /* 295108 */     GIR_EraseRootFromParent_Done,
     /* 295109 */   // Label 5781: @295109
     /* 295109 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(295138), // Rule ID 5115 //
     /* 295114 */     // MIs[0] Operand 1
     /* 295114 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295127 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 295127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 295130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295136 */     GIR_RootConstrainSelectedInstOperands,
     /* 295137 */     // GIR_Coverage, 5115,
     /* 295137 */     GIR_EraseRootFromParent_Done,
     /* 295138 */   // Label 5782: @295138
     /* 295138 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(295167), // Rule ID 5122 //
     /* 295143 */     // MIs[0] Operand 1
     /* 295143 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295156 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 295156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 295159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295165 */     GIR_RootConstrainSelectedInstOperands,
     /* 295166 */     // GIR_Coverage, 5122,
     /* 295166 */     GIR_EraseRootFromParent_Done,
     /* 295167 */   // Label 5783: @295167
     /* 295167 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(295196), // Rule ID 5129 //
     /* 295172 */     // MIs[0] Operand 1
     /* 295172 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295185 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 295185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 295188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295194 */     GIR_RootConstrainSelectedInstOperands,
     /* 295195 */     // GIR_Coverage, 5129,
     /* 295195 */     GIR_EraseRootFromParent_Done,
     /* 295196 */   // Label 5784: @295196
     /* 295196 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(295225), // Rule ID 5136 //
     /* 295201 */     // MIs[0] Operand 1
     /* 295201 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 295206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295214 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 295214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 295217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295223 */     GIR_RootConstrainSelectedInstOperands,
     /* 295224 */     // GIR_Coverage, 5136,
     /* 295224 */     GIR_EraseRootFromParent_Done,
     /* 295225 */   // Label 5785: @295225
     /* 295225 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(295254), // Rule ID 5143 //
     /* 295230 */     // MIs[0] Operand 1
     /* 295230 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 295235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295243 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 295243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 295246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295252 */     GIR_RootConstrainSelectedInstOperands,
     /* 295253 */     // GIR_Coverage, 5143,
     /* 295253 */     GIR_EraseRootFromParent_Done,
     /* 295254 */   // Label 5786: @295254
     /* 295254 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(295283), // Rule ID 5150 //
     /* 295259 */     // MIs[0] Operand 1
     /* 295259 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295272 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 295272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 295275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295281 */     GIR_RootConstrainSelectedInstOperands,
     /* 295282 */     // GIR_Coverage, 5150,
     /* 295282 */     GIR_EraseRootFromParent_Done,
     /* 295283 */   // Label 5787: @295283
     /* 295283 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(295312), // Rule ID 5157 //
     /* 295288 */     // MIs[0] Operand 1
     /* 295288 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295301 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 295301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 295304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295310 */     GIR_RootConstrainSelectedInstOperands,
     /* 295311 */     // GIR_Coverage, 5157,
     /* 295311 */     GIR_EraseRootFromParent_Done,
     /* 295312 */   // Label 5788: @295312
     /* 295312 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(295341), // Rule ID 5164 //
     /* 295317 */     // MIs[0] Operand 1
     /* 295317 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 295322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295330 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 295330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 295333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295339 */     GIR_RootConstrainSelectedInstOperands,
     /* 295340 */     // GIR_Coverage, 5164,
     /* 295340 */     GIR_EraseRootFromParent_Done,
     /* 295341 */   // Label 5789: @295341
     /* 295341 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(295370), // Rule ID 5171 //
     /* 295346 */     // MIs[0] Operand 1
     /* 295346 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 295351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295359 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 295359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 295362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295368 */     GIR_RootConstrainSelectedInstOperands,
     /* 295369 */     // GIR_Coverage, 5171,
     /* 295369 */     GIR_EraseRootFromParent_Done,
     /* 295370 */   // Label 5790: @295370
     /* 295370 */   GIM_Reject,
     /* 295371 */ // Label 5760: @295371
     /* 295371 */ GIM_Reject,
     /* 295372 */ // Label 5651: @295372
     /* 295372 */ GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(296419),
     /* 295377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 295380 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 295383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295387 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(295427), // Rule ID 750 //
     /* 295392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295395 */     // MIs[0] Operand 1
     /* 295395 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295404 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295410 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295418 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 295421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295425 */     GIR_RootConstrainSelectedInstOperands,
     /* 295426 */     // GIR_Coverage, 750,
     /* 295426 */     GIR_EraseRootFromParent_Done,
     /* 295427 */   // Label 5792: @295427
     /* 295427 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(295467), // Rule ID 757 //
     /* 295432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295435 */     // MIs[0] Operand 1
     /* 295435 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295444 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295450 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295458 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 295461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295465 */     GIR_RootConstrainSelectedInstOperands,
     /* 295466 */     // GIR_Coverage, 757,
     /* 295466 */     GIR_EraseRootFromParent_Done,
     /* 295467 */   // Label 5793: @295467
     /* 295467 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(295504), // Rule ID 5208 //
     /* 295472 */     // MIs[0] Operand 1
     /* 295472 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295481 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295487 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295495 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 295498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295502 */     GIR_RootConstrainSelectedInstOperands,
     /* 295503 */     // GIR_Coverage, 5208,
     /* 295503 */     GIR_EraseRootFromParent_Done,
     /* 295504 */   // Label 5794: @295504
     /* 295504 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(295541), // Rule ID 5215 //
     /* 295509 */     // MIs[0] Operand 1
     /* 295509 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295518 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295524 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295532 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 295535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295539 */     GIR_RootConstrainSelectedInstOperands,
     /* 295540 */     // GIR_Coverage, 5215,
     /* 295540 */     GIR_EraseRootFromParent_Done,
     /* 295541 */   // Label 5795: @295541
     /* 295541 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(295578), // Rule ID 5222 //
     /* 295546 */     // MIs[0] Operand 1
     /* 295546 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295555 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295561 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295569 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 295572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295576 */     GIR_RootConstrainSelectedInstOperands,
     /* 295577 */     // GIR_Coverage, 5222,
     /* 295577 */     GIR_EraseRootFromParent_Done,
     /* 295578 */   // Label 5796: @295578
     /* 295578 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(295615), // Rule ID 5229 //
     /* 295583 */     // MIs[0] Operand 1
     /* 295583 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295592 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295598 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295606 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 295609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295613 */     GIR_RootConstrainSelectedInstOperands,
     /* 295614 */     // GIR_Coverage, 5229,
     /* 295614 */     GIR_EraseRootFromParent_Done,
     /* 295615 */   // Label 5797: @295615
     /* 295615 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(295652), // Rule ID 5236 //
     /* 295620 */     // MIs[0] Operand 1
     /* 295620 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295629 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295635 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295643 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 295646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295650 */     GIR_RootConstrainSelectedInstOperands,
     /* 295651 */     // GIR_Coverage, 5236,
     /* 295651 */     GIR_EraseRootFromParent_Done,
     /* 295652 */   // Label 5798: @295652
     /* 295652 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(295692), // Rule ID 722 //
     /* 295657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295660 */     // MIs[0] Operand 1
     /* 295660 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295673 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295679 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295683 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 295686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295690 */     GIR_RootConstrainSelectedInstOperands,
     /* 295691 */     // GIR_Coverage, 722,
     /* 295691 */     GIR_EraseRootFromParent_Done,
     /* 295692 */   // Label 5799: @295692
     /* 295692 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(295732), // Rule ID 729 //
     /* 295697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295700 */     // MIs[0] Operand 1
     /* 295700 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295713 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295719 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295723 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 295726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295730 */     GIR_RootConstrainSelectedInstOperands,
     /* 295731 */     // GIR_Coverage, 729,
     /* 295731 */     GIR_EraseRootFromParent_Done,
     /* 295732 */   // Label 5800: @295732
     /* 295732 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(295772), // Rule ID 730 //
     /* 295737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295740 */     // MIs[0] Operand 1
     /* 295740 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295753 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295759 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 295761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295763 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 295766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295770 */     GIR_RootConstrainSelectedInstOperands,
     /* 295771 */     // GIR_Coverage, 730,
     /* 295771 */     GIR_EraseRootFromParent_Done,
     /* 295772 */   // Label 5801: @295772
     /* 295772 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(295812), // Rule ID 743 //
     /* 295777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295780 */     // MIs[0] Operand 1
     /* 295780 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295793 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295799 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295803 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 295806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295810 */     GIR_RootConstrainSelectedInstOperands,
     /* 295811 */     // GIR_Coverage, 743,
     /* 295811 */     GIR_EraseRootFromParent_Done,
     /* 295812 */   // Label 5802: @295812
     /* 295812 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(295849), // Rule ID 5173 //
     /* 295817 */     // MIs[0] Operand 1
     /* 295817 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295830 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295836 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295840 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 295843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295847 */     GIR_RootConstrainSelectedInstOperands,
     /* 295848 */     // GIR_Coverage, 5173,
     /* 295848 */     GIR_EraseRootFromParent_Done,
     /* 295849 */   // Label 5803: @295849
     /* 295849 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(295886), // Rule ID 5180 //
     /* 295854 */     // MIs[0] Operand 1
     /* 295854 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295867 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295873 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295877 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 295880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295884 */     GIR_RootConstrainSelectedInstOperands,
     /* 295885 */     // GIR_Coverage, 5180,
     /* 295885 */     GIR_EraseRootFromParent_Done,
     /* 295886 */   // Label 5804: @295886
     /* 295886 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(295923), // Rule ID 5187 //
     /* 295891 */     // MIs[0] Operand 1
     /* 295891 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295904 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295910 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295914 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 295917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295921 */     GIR_RootConstrainSelectedInstOperands,
     /* 295922 */     // GIR_Coverage, 5187,
     /* 295922 */     GIR_EraseRootFromParent_Done,
     /* 295923 */   // Label 5805: @295923
     /* 295923 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(295960), // Rule ID 5194 //
     /* 295928 */     // MIs[0] Operand 1
     /* 295928 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295941 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295947 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295951 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 295954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295958 */     GIR_RootConstrainSelectedInstOperands,
     /* 295959 */     // GIR_Coverage, 5194,
     /* 295959 */     GIR_EraseRootFromParent_Done,
     /* 295960 */   // Label 5806: @295960
     /* 295960 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(295997), // Rule ID 5201 //
     /* 295965 */     // MIs[0] Operand 1
     /* 295965 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 295974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295978 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295984 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295988 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 295988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 295991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295995 */     GIR_RootConstrainSelectedInstOperands,
     /* 295996 */     // GIR_Coverage, 5201,
     /* 295996 */     GIR_EraseRootFromParent_Done,
     /* 295997 */   // Label 5807: @295997
     /* 295997 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(296029), // Rule ID 1121 //
     /* 296002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296005 */     // MIs[0] Operand 1
     /* 296005 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 296010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296018 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 296018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 296021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296027 */     GIR_RootConstrainSelectedInstOperands,
     /* 296028 */     // GIR_Coverage, 1121,
     /* 296028 */     GIR_EraseRootFromParent_Done,
     /* 296029 */   // Label 5808: @296029
     /* 296029 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(296061), // Rule ID 1128 //
     /* 296034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296037 */     // MIs[0] Operand 1
     /* 296037 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296050 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 296050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 296053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296059 */     GIR_RootConstrainSelectedInstOperands,
     /* 296060 */     // GIR_Coverage, 1128,
     /* 296060 */     GIR_EraseRootFromParent_Done,
     /* 296061 */   // Label 5809: @296061
     /* 296061 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(296093), // Rule ID 1135 //
     /* 296066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296069 */     // MIs[0] Operand 1
     /* 296069 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296082 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 296082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 296085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296091 */     GIR_RootConstrainSelectedInstOperands,
     /* 296092 */     // GIR_Coverage, 1135,
     /* 296092 */     GIR_EraseRootFromParent_Done,
     /* 296093 */   // Label 5810: @296093
     /* 296093 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(296125), // Rule ID 1142 //
     /* 296098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296101 */     // MIs[0] Operand 1
     /* 296101 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 296106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296114 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 296114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 296117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296123 */     GIR_RootConstrainSelectedInstOperands,
     /* 296124 */     // GIR_Coverage, 1142,
     /* 296124 */     GIR_EraseRootFromParent_Done,
     /* 296125 */   // Label 5811: @296125
     /* 296125 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(296157), // Rule ID 1149 //
     /* 296130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296133 */     // MIs[0] Operand 1
     /* 296133 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 296138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296146 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 296146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 296149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296155 */     GIR_RootConstrainSelectedInstOperands,
     /* 296156 */     // GIR_Coverage, 1149,
     /* 296156 */     GIR_EraseRootFromParent_Done,
     /* 296157 */   // Label 5812: @296157
     /* 296157 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(296186), // Rule ID 5110 //
     /* 296162 */     // MIs[0] Operand 1
     /* 296162 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 296167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296175 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 296175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 296178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296184 */     GIR_RootConstrainSelectedInstOperands,
     /* 296185 */     // GIR_Coverage, 5110,
     /* 296185 */     GIR_EraseRootFromParent_Done,
     /* 296186 */   // Label 5813: @296186
     /* 296186 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(296215), // Rule ID 5117 //
     /* 296191 */     // MIs[0] Operand 1
     /* 296191 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296204 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 296204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 296207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296213 */     GIR_RootConstrainSelectedInstOperands,
     /* 296214 */     // GIR_Coverage, 5117,
     /* 296214 */     GIR_EraseRootFromParent_Done,
     /* 296215 */   // Label 5814: @296215
     /* 296215 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(296244), // Rule ID 5124 //
     /* 296220 */     // MIs[0] Operand 1
     /* 296220 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296233 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 296233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 296236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296242 */     GIR_RootConstrainSelectedInstOperands,
     /* 296243 */     // GIR_Coverage, 5124,
     /* 296243 */     GIR_EraseRootFromParent_Done,
     /* 296244 */   // Label 5815: @296244
     /* 296244 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(296273), // Rule ID 5131 //
     /* 296249 */     // MIs[0] Operand 1
     /* 296249 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 296254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296262 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 296262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 296265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296271 */     GIR_RootConstrainSelectedInstOperands,
     /* 296272 */     // GIR_Coverage, 5131,
     /* 296272 */     GIR_EraseRootFromParent_Done,
     /* 296273 */   // Label 5816: @296273
     /* 296273 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(296302), // Rule ID 5138 //
     /* 296278 */     // MIs[0] Operand 1
     /* 296278 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 296283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296291 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 296291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 296294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296300 */     GIR_RootConstrainSelectedInstOperands,
     /* 296301 */     // GIR_Coverage, 5138,
     /* 296301 */     GIR_EraseRootFromParent_Done,
     /* 296302 */   // Label 5817: @296302
     /* 296302 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(296331), // Rule ID 5145 //
     /* 296307 */     // MIs[0] Operand 1
     /* 296307 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 296312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296320 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 296320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 296323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296329 */     GIR_RootConstrainSelectedInstOperands,
     /* 296330 */     // GIR_Coverage, 5145,
     /* 296330 */     GIR_EraseRootFromParent_Done,
     /* 296331 */   // Label 5818: @296331
     /* 296331 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(296360), // Rule ID 5152 //
     /* 296336 */     // MIs[0] Operand 1
     /* 296336 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 296341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296349 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 296349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 296352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296358 */     GIR_RootConstrainSelectedInstOperands,
     /* 296359 */     // GIR_Coverage, 5152,
     /* 296359 */     GIR_EraseRootFromParent_Done,
     /* 296360 */   // Label 5819: @296360
     /* 296360 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(296389), // Rule ID 5159 //
     /* 296365 */     // MIs[0] Operand 1
     /* 296365 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 296370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296378 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 296378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 296381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296387 */     GIR_RootConstrainSelectedInstOperands,
     /* 296388 */     // GIR_Coverage, 5159,
     /* 296388 */     GIR_EraseRootFromParent_Done,
     /* 296389 */   // Label 5820: @296389
     /* 296389 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(296418), // Rule ID 5166 //
     /* 296394 */     // MIs[0] Operand 1
     /* 296394 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 296399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296407 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 296407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 296410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296416 */     GIR_RootConstrainSelectedInstOperands,
     /* 296417 */     // GIR_Coverage, 5166,
     /* 296417 */     GIR_EraseRootFromParent_Done,
     /* 296418 */   // Label 5821: @296418
     /* 296418 */   GIM_Reject,
     /* 296419 */ // Label 5791: @296419
     /* 296419 */ GIM_Reject,
     /* 296420 */ // Label 5652: @296420
     /* 296420 */ GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(297467),
     /* 296425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 296428 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 296431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296435 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(296475), // Rule ID 753 //
     /* 296440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296443 */     // MIs[0] Operand 1
     /* 296443 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296452 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296458 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296466 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 296469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 296473 */     GIR_RootConstrainSelectedInstOperands,
     /* 296474 */     // GIR_Coverage, 753,
     /* 296474 */     GIR_EraseRootFromParent_Done,
     /* 296475 */   // Label 5823: @296475
     /* 296475 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(296515), // Rule ID 760 //
     /* 296480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296483 */     // MIs[0] Operand 1
     /* 296483 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296492 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296498 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296506 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 296509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 296513 */     GIR_RootConstrainSelectedInstOperands,
     /* 296514 */     // GIR_Coverage, 760,
     /* 296514 */     GIR_EraseRootFromParent_Done,
     /* 296515 */   // Label 5824: @296515
     /* 296515 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(296552), // Rule ID 5211 //
     /* 296520 */     // MIs[0] Operand 1
     /* 296520 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 296525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296529 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296535 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296543 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 296546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 296550 */     GIR_RootConstrainSelectedInstOperands,
     /* 296551 */     // GIR_Coverage, 5211,
     /* 296551 */     GIR_EraseRootFromParent_Done,
     /* 296552 */   // Label 5825: @296552
     /* 296552 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(296589), // Rule ID 5218 //
     /* 296557 */     // MIs[0] Operand 1
     /* 296557 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296566 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296572 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296580 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 296583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 296587 */     GIR_RootConstrainSelectedInstOperands,
     /* 296588 */     // GIR_Coverage, 5218,
     /* 296588 */     GIR_EraseRootFromParent_Done,
     /* 296589 */   // Label 5826: @296589
     /* 296589 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(296626), // Rule ID 5225 //
     /* 296594 */     // MIs[0] Operand 1
     /* 296594 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296603 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296609 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296617 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 296620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 296624 */     GIR_RootConstrainSelectedInstOperands,
     /* 296625 */     // GIR_Coverage, 5225,
     /* 296625 */     GIR_EraseRootFromParent_Done,
     /* 296626 */   // Label 5827: @296626
     /* 296626 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(296663), // Rule ID 5232 //
     /* 296631 */     // MIs[0] Operand 1
     /* 296631 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 296636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296640 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296646 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296654 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 296657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 296661 */     GIR_RootConstrainSelectedInstOperands,
     /* 296662 */     // GIR_Coverage, 5232,
     /* 296662 */     GIR_EraseRootFromParent_Done,
     /* 296663 */   // Label 5828: @296663
     /* 296663 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(296700), // Rule ID 5239 //
     /* 296668 */     // MIs[0] Operand 1
     /* 296668 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 296673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296677 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296683 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296691 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 296694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 296698 */     GIR_RootConstrainSelectedInstOperands,
     /* 296699 */     // GIR_Coverage, 5239,
     /* 296699 */     GIR_EraseRootFromParent_Done,
     /* 296700 */   // Label 5829: @296700
     /* 296700 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(296740), // Rule ID 725 //
     /* 296705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296708 */     // MIs[0] Operand 1
     /* 296708 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 296713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296721 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296727 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296731 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 296734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296738 */     GIR_RootConstrainSelectedInstOperands,
     /* 296739 */     // GIR_Coverage, 725,
     /* 296739 */     GIR_EraseRootFromParent_Done,
     /* 296740 */   // Label 5830: @296740
     /* 296740 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(296780), // Rule ID 735 //
     /* 296745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296748 */     // MIs[0] Operand 1
     /* 296748 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296761 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296767 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296771 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 296774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296778 */     GIR_RootConstrainSelectedInstOperands,
     /* 296779 */     // GIR_Coverage, 735,
     /* 296779 */     GIR_EraseRootFromParent_Done,
     /* 296780 */   // Label 5831: @296780
     /* 296780 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(296820), // Rule ID 736 //
     /* 296785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296788 */     // MIs[0] Operand 1
     /* 296788 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296801 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296807 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 296809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296811 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 296814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296818 */     GIR_RootConstrainSelectedInstOperands,
     /* 296819 */     // GIR_Coverage, 736,
     /* 296819 */     GIR_EraseRootFromParent_Done,
     /* 296820 */   // Label 5832: @296820
     /* 296820 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(296860), // Rule ID 746 //
     /* 296825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296828 */     // MIs[0] Operand 1
     /* 296828 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296841 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296847 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296851 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 296854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296858 */     GIR_RootConstrainSelectedInstOperands,
     /* 296859 */     // GIR_Coverage, 746,
     /* 296859 */     GIR_EraseRootFromParent_Done,
     /* 296860 */   // Label 5833: @296860
     /* 296860 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(296897), // Rule ID 5176 //
     /* 296865 */     // MIs[0] Operand 1
     /* 296865 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 296870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296878 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296884 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296888 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 296891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296895 */     GIR_RootConstrainSelectedInstOperands,
     /* 296896 */     // GIR_Coverage, 5176,
     /* 296896 */     GIR_EraseRootFromParent_Done,
     /* 296897 */   // Label 5834: @296897
     /* 296897 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(296934), // Rule ID 5183 //
     /* 296902 */     // MIs[0] Operand 1
     /* 296902 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 296907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296915 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296921 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296925 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 296928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296932 */     GIR_RootConstrainSelectedInstOperands,
     /* 296933 */     // GIR_Coverage, 5183,
     /* 296933 */     GIR_EraseRootFromParent_Done,
     /* 296934 */   // Label 5835: @296934
     /* 296934 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(296971), // Rule ID 5190 //
     /* 296939 */     // MIs[0] Operand 1
     /* 296939 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296952 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296958 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296962 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 296965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296969 */     GIR_RootConstrainSelectedInstOperands,
     /* 296970 */     // GIR_Coverage, 5190,
     /* 296970 */     GIR_EraseRootFromParent_Done,
     /* 296971 */   // Label 5836: @296971
     /* 296971 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(297008), // Rule ID 5197 //
     /* 296976 */     // MIs[0] Operand 1
     /* 296976 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 296981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296989 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 296995 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 296997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296999 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 296999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 297002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297006 */     GIR_RootConstrainSelectedInstOperands,
     /* 297007 */     // GIR_Coverage, 5197,
     /* 297007 */     GIR_EraseRootFromParent_Done,
     /* 297008 */   // Label 5837: @297008
     /* 297008 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(297045), // Rule ID 5204 //
     /* 297013 */     // MIs[0] Operand 1
     /* 297013 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 297018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297026 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297032 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297036 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 297036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 297039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297043 */     GIR_RootConstrainSelectedInstOperands,
     /* 297044 */     // GIR_Coverage, 5204,
     /* 297044 */     GIR_EraseRootFromParent_Done,
     /* 297045 */   // Label 5838: @297045
     /* 297045 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(297077), // Rule ID 1124 //
     /* 297050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297053 */     // MIs[0] Operand 1
     /* 297053 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 297058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297066 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 297066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 297069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297075 */     GIR_RootConstrainSelectedInstOperands,
     /* 297076 */     // GIR_Coverage, 1124,
     /* 297076 */     GIR_EraseRootFromParent_Done,
     /* 297077 */   // Label 5839: @297077
     /* 297077 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(297109), // Rule ID 1131 //
     /* 297082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297085 */     // MIs[0] Operand 1
     /* 297085 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 297090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297098 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 297098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 297101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297107 */     GIR_RootConstrainSelectedInstOperands,
     /* 297108 */     // GIR_Coverage, 1131,
     /* 297108 */     GIR_EraseRootFromParent_Done,
     /* 297109 */   // Label 5840: @297109
     /* 297109 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(297141), // Rule ID 1138 //
     /* 297114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297117 */     // MIs[0] Operand 1
     /* 297117 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 297122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297130 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 297130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 297133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297139 */     GIR_RootConstrainSelectedInstOperands,
     /* 297140 */     // GIR_Coverage, 1138,
     /* 297140 */     GIR_EraseRootFromParent_Done,
     /* 297141 */   // Label 5841: @297141
     /* 297141 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(297173), // Rule ID 1145 //
     /* 297146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297149 */     // MIs[0] Operand 1
     /* 297149 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 297154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297162 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 297162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 297165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297171 */     GIR_RootConstrainSelectedInstOperands,
     /* 297172 */     // GIR_Coverage, 1145,
     /* 297172 */     GIR_EraseRootFromParent_Done,
     /* 297173 */   // Label 5842: @297173
     /* 297173 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(297205), // Rule ID 1152 //
     /* 297178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297181 */     // MIs[0] Operand 1
     /* 297181 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 297186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297194 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 297194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 297197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297203 */     GIR_RootConstrainSelectedInstOperands,
     /* 297204 */     // GIR_Coverage, 1152,
     /* 297204 */     GIR_EraseRootFromParent_Done,
     /* 297205 */   // Label 5843: @297205
     /* 297205 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(297234), // Rule ID 5113 //
     /* 297210 */     // MIs[0] Operand 1
     /* 297210 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 297215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297223 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 297223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 297226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297232 */     GIR_RootConstrainSelectedInstOperands,
     /* 297233 */     // GIR_Coverage, 5113,
     /* 297233 */     GIR_EraseRootFromParent_Done,
     /* 297234 */   // Label 5844: @297234
     /* 297234 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(297263), // Rule ID 5120 //
     /* 297239 */     // MIs[0] Operand 1
     /* 297239 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 297244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297252 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 297252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 297255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297261 */     GIR_RootConstrainSelectedInstOperands,
     /* 297262 */     // GIR_Coverage, 5120,
     /* 297262 */     GIR_EraseRootFromParent_Done,
     /* 297263 */   // Label 5845: @297263
     /* 297263 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(297292), // Rule ID 5127 //
     /* 297268 */     // MIs[0] Operand 1
     /* 297268 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 297273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297281 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 297281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 297284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297290 */     GIR_RootConstrainSelectedInstOperands,
     /* 297291 */     // GIR_Coverage, 5127,
     /* 297291 */     GIR_EraseRootFromParent_Done,
     /* 297292 */   // Label 5846: @297292
     /* 297292 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(297321), // Rule ID 5134 //
     /* 297297 */     // MIs[0] Operand 1
     /* 297297 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 297302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297310 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 297310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 297313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297319 */     GIR_RootConstrainSelectedInstOperands,
     /* 297320 */     // GIR_Coverage, 5134,
     /* 297320 */     GIR_EraseRootFromParent_Done,
     /* 297321 */   // Label 5847: @297321
     /* 297321 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(297350), // Rule ID 5141 //
     /* 297326 */     // MIs[0] Operand 1
     /* 297326 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 297331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297339 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 297339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 297342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297348 */     GIR_RootConstrainSelectedInstOperands,
     /* 297349 */     // GIR_Coverage, 5141,
     /* 297349 */     GIR_EraseRootFromParent_Done,
     /* 297350 */   // Label 5848: @297350
     /* 297350 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(297379), // Rule ID 5148 //
     /* 297355 */     // MIs[0] Operand 1
     /* 297355 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 297360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297368 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 297368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 297371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297377 */     GIR_RootConstrainSelectedInstOperands,
     /* 297378 */     // GIR_Coverage, 5148,
     /* 297378 */     GIR_EraseRootFromParent_Done,
     /* 297379 */   // Label 5849: @297379
     /* 297379 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(297408), // Rule ID 5155 //
     /* 297384 */     // MIs[0] Operand 1
     /* 297384 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 297389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297397 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 297397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 297400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297406 */     GIR_RootConstrainSelectedInstOperands,
     /* 297407 */     // GIR_Coverage, 5155,
     /* 297407 */     GIR_EraseRootFromParent_Done,
     /* 297408 */   // Label 5850: @297408
     /* 297408 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(297437), // Rule ID 5162 //
     /* 297413 */     // MIs[0] Operand 1
     /* 297413 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 297418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297426 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 297426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 297429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297435 */     GIR_RootConstrainSelectedInstOperands,
     /* 297436 */     // GIR_Coverage, 5162,
     /* 297436 */     GIR_EraseRootFromParent_Done,
     /* 297437 */   // Label 5851: @297437
     /* 297437 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(297466), // Rule ID 5169 //
     /* 297442 */     // MIs[0] Operand 1
     /* 297442 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 297447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297455 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 297455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 297458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 297462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297464 */     GIR_RootConstrainSelectedInstOperands,
     /* 297465 */     // GIR_Coverage, 5169,
     /* 297465 */     GIR_EraseRootFromParent_Done,
     /* 297466 */   // Label 5852: @297466
     /* 297466 */   GIM_Reject,
     /* 297467 */ // Label 5822: @297467
     /* 297467 */ GIM_Reject,
     /* 297468 */ // Label 5653: @297468
     /* 297468 */ GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(298515),
     /* 297473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 297476 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 297479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297483 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(297523), // Rule ID 751 //
     /* 297488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297491 */     // MIs[0] Operand 1
     /* 297491 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 297496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297500 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297506 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297514 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 297517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 297521 */     GIR_RootConstrainSelectedInstOperands,
     /* 297522 */     // GIR_Coverage, 751,
     /* 297522 */     GIR_EraseRootFromParent_Done,
     /* 297523 */   // Label 5854: @297523
     /* 297523 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(297563), // Rule ID 758 //
     /* 297528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297531 */     // MIs[0] Operand 1
     /* 297531 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 297536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297540 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297546 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297554 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 297557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 297561 */     GIR_RootConstrainSelectedInstOperands,
     /* 297562 */     // GIR_Coverage, 758,
     /* 297562 */     GIR_EraseRootFromParent_Done,
     /* 297563 */   // Label 5855: @297563
     /* 297563 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(297600), // Rule ID 5209 //
     /* 297568 */     // MIs[0] Operand 1
     /* 297568 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 297573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297577 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297583 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297591 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 297594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 297598 */     GIR_RootConstrainSelectedInstOperands,
     /* 297599 */     // GIR_Coverage, 5209,
     /* 297599 */     GIR_EraseRootFromParent_Done,
     /* 297600 */   // Label 5856: @297600
     /* 297600 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(297637), // Rule ID 5216 //
     /* 297605 */     // MIs[0] Operand 1
     /* 297605 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 297610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297614 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297620 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297628 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 297631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 297635 */     GIR_RootConstrainSelectedInstOperands,
     /* 297636 */     // GIR_Coverage, 5216,
     /* 297636 */     GIR_EraseRootFromParent_Done,
     /* 297637 */   // Label 5857: @297637
     /* 297637 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(297674), // Rule ID 5223 //
     /* 297642 */     // MIs[0] Operand 1
     /* 297642 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 297647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297651 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297657 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297665 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 297668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 297672 */     GIR_RootConstrainSelectedInstOperands,
     /* 297673 */     // GIR_Coverage, 5223,
     /* 297673 */     GIR_EraseRootFromParent_Done,
     /* 297674 */   // Label 5858: @297674
     /* 297674 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(297711), // Rule ID 5230 //
     /* 297679 */     // MIs[0] Operand 1
     /* 297679 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 297684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297688 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297694 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297702 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 297705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 297709 */     GIR_RootConstrainSelectedInstOperands,
     /* 297710 */     // GIR_Coverage, 5230,
     /* 297710 */     GIR_EraseRootFromParent_Done,
     /* 297711 */   // Label 5859: @297711
     /* 297711 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(297748), // Rule ID 5237 //
     /* 297716 */     // MIs[0] Operand 1
     /* 297716 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 297721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297725 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297731 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297739 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 297742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 297746 */     GIR_RootConstrainSelectedInstOperands,
     /* 297747 */     // GIR_Coverage, 5237,
     /* 297747 */     GIR_EraseRootFromParent_Done,
     /* 297748 */   // Label 5860: @297748
     /* 297748 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(297788), // Rule ID 723 //
     /* 297753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297756 */     // MIs[0] Operand 1
     /* 297756 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 297761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297769 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297775 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297779 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 297782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297786 */     GIR_RootConstrainSelectedInstOperands,
     /* 297787 */     // GIR_Coverage, 723,
     /* 297787 */     GIR_EraseRootFromParent_Done,
     /* 297788 */   // Label 5861: @297788
     /* 297788 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(297828), // Rule ID 731 //
     /* 297793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297796 */     // MIs[0] Operand 1
     /* 297796 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 297801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297809 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297815 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297819 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 297822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297826 */     GIR_RootConstrainSelectedInstOperands,
     /* 297827 */     // GIR_Coverage, 731,
     /* 297827 */     GIR_EraseRootFromParent_Done,
     /* 297828 */   // Label 5862: @297828
     /* 297828 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(297868), // Rule ID 732 //
     /* 297833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297836 */     // MIs[0] Operand 1
     /* 297836 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 297841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297849 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297855 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 297857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297859 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 297862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297866 */     GIR_RootConstrainSelectedInstOperands,
     /* 297867 */     // GIR_Coverage, 732,
     /* 297867 */     GIR_EraseRootFromParent_Done,
     /* 297868 */   // Label 5863: @297868
     /* 297868 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(297908), // Rule ID 744 //
     /* 297873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297876 */     // MIs[0] Operand 1
     /* 297876 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 297881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297889 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297895 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297899 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 297902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297906 */     GIR_RootConstrainSelectedInstOperands,
     /* 297907 */     // GIR_Coverage, 744,
     /* 297907 */     GIR_EraseRootFromParent_Done,
     /* 297908 */   // Label 5864: @297908
     /* 297908 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(297945), // Rule ID 5174 //
     /* 297913 */     // MIs[0] Operand 1
     /* 297913 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 297918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297926 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297932 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297936 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 297939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297943 */     GIR_RootConstrainSelectedInstOperands,
     /* 297944 */     // GIR_Coverage, 5174,
     /* 297944 */     GIR_EraseRootFromParent_Done,
     /* 297945 */   // Label 5865: @297945
     /* 297945 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(297982), // Rule ID 5181 //
     /* 297950 */     // MIs[0] Operand 1
     /* 297950 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 297955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 297963 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 297969 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 297971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297973 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 297973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 297976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 297980 */     GIR_RootConstrainSelectedInstOperands,
     /* 297981 */     // GIR_Coverage, 5181,
     /* 297981 */     GIR_EraseRootFromParent_Done,
     /* 297982 */   // Label 5866: @297982
     /* 297982 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(298019), // Rule ID 5188 //
     /* 297987 */     // MIs[0] Operand 1
     /* 297987 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 297992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 298000 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 298006 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 298008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298010 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 298010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 298013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298017 */     GIR_RootConstrainSelectedInstOperands,
     /* 298018 */     // GIR_Coverage, 5188,
     /* 298018 */     GIR_EraseRootFromParent_Done,
     /* 298019 */   // Label 5867: @298019
     /* 298019 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(298056), // Rule ID 5195 //
     /* 298024 */     // MIs[0] Operand 1
     /* 298024 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 298029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 298037 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 298043 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 298045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298047 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 298047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 298050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298054 */     GIR_RootConstrainSelectedInstOperands,
     /* 298055 */     // GIR_Coverage, 5195,
     /* 298055 */     GIR_EraseRootFromParent_Done,
     /* 298056 */   // Label 5868: @298056
     /* 298056 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(298093), // Rule ID 5202 //
     /* 298061 */     // MIs[0] Operand 1
     /* 298061 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 298066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 298074 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 298080 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 298082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298084 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 298084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 298087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298091 */     GIR_RootConstrainSelectedInstOperands,
     /* 298092 */     // GIR_Coverage, 5202,
     /* 298092 */     GIR_EraseRootFromParent_Done,
     /* 298093 */   // Label 5869: @298093
     /* 298093 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(298125), // Rule ID 1122 //
     /* 298098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298101 */     // MIs[0] Operand 1
     /* 298101 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 298106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298114 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 298117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298123 */     GIR_RootConstrainSelectedInstOperands,
     /* 298124 */     // GIR_Coverage, 1122,
     /* 298124 */     GIR_EraseRootFromParent_Done,
     /* 298125 */   // Label 5870: @298125
     /* 298125 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(298157), // Rule ID 1129 //
     /* 298130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298133 */     // MIs[0] Operand 1
     /* 298133 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 298138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298146 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 298149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298155 */     GIR_RootConstrainSelectedInstOperands,
     /* 298156 */     // GIR_Coverage, 1129,
     /* 298156 */     GIR_EraseRootFromParent_Done,
     /* 298157 */   // Label 5871: @298157
     /* 298157 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(298189), // Rule ID 1136 //
     /* 298162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298165 */     // MIs[0] Operand 1
     /* 298165 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 298170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298178 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 298181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298187 */     GIR_RootConstrainSelectedInstOperands,
     /* 298188 */     // GIR_Coverage, 1136,
     /* 298188 */     GIR_EraseRootFromParent_Done,
     /* 298189 */   // Label 5872: @298189
     /* 298189 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(298221), // Rule ID 1143 //
     /* 298194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298197 */     // MIs[0] Operand 1
     /* 298197 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 298202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298210 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 298213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298219 */     GIR_RootConstrainSelectedInstOperands,
     /* 298220 */     // GIR_Coverage, 1143,
     /* 298220 */     GIR_EraseRootFromParent_Done,
     /* 298221 */   // Label 5873: @298221
     /* 298221 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(298253), // Rule ID 1150 //
     /* 298226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298229 */     // MIs[0] Operand 1
     /* 298229 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 298234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298242 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 298245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298251 */     GIR_RootConstrainSelectedInstOperands,
     /* 298252 */     // GIR_Coverage, 1150,
     /* 298252 */     GIR_EraseRootFromParent_Done,
     /* 298253 */   // Label 5874: @298253
     /* 298253 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(298282), // Rule ID 5111 //
     /* 298258 */     // MIs[0] Operand 1
     /* 298258 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 298263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298271 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 298274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298280 */     GIR_RootConstrainSelectedInstOperands,
     /* 298281 */     // GIR_Coverage, 5111,
     /* 298281 */     GIR_EraseRootFromParent_Done,
     /* 298282 */   // Label 5875: @298282
     /* 298282 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(298311), // Rule ID 5118 //
     /* 298287 */     // MIs[0] Operand 1
     /* 298287 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 298292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298300 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 298303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298309 */     GIR_RootConstrainSelectedInstOperands,
     /* 298310 */     // GIR_Coverage, 5118,
     /* 298310 */     GIR_EraseRootFromParent_Done,
     /* 298311 */   // Label 5876: @298311
     /* 298311 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(298340), // Rule ID 5125 //
     /* 298316 */     // MIs[0] Operand 1
     /* 298316 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 298321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298329 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 298332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298338 */     GIR_RootConstrainSelectedInstOperands,
     /* 298339 */     // GIR_Coverage, 5125,
     /* 298339 */     GIR_EraseRootFromParent_Done,
     /* 298340 */   // Label 5877: @298340
     /* 298340 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(298369), // Rule ID 5132 //
     /* 298345 */     // MIs[0] Operand 1
     /* 298345 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 298350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298358 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 298361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298367 */     GIR_RootConstrainSelectedInstOperands,
     /* 298368 */     // GIR_Coverage, 5132,
     /* 298368 */     GIR_EraseRootFromParent_Done,
     /* 298369 */   // Label 5878: @298369
     /* 298369 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(298398), // Rule ID 5139 //
     /* 298374 */     // MIs[0] Operand 1
     /* 298374 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 298379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298387 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 298390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298396 */     GIR_RootConstrainSelectedInstOperands,
     /* 298397 */     // GIR_Coverage, 5139,
     /* 298397 */     GIR_EraseRootFromParent_Done,
     /* 298398 */   // Label 5879: @298398
     /* 298398 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(298427), // Rule ID 5146 //
     /* 298403 */     // MIs[0] Operand 1
     /* 298403 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 298408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298416 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 298416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 298419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298425 */     GIR_RootConstrainSelectedInstOperands,
     /* 298426 */     // GIR_Coverage, 5146,
     /* 298426 */     GIR_EraseRootFromParent_Done,
     /* 298427 */   // Label 5880: @298427
     /* 298427 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(298456), // Rule ID 5153 //
     /* 298432 */     // MIs[0] Operand 1
     /* 298432 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 298437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298445 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 298445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 298448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298454 */     GIR_RootConstrainSelectedInstOperands,
     /* 298455 */     // GIR_Coverage, 5153,
     /* 298455 */     GIR_EraseRootFromParent_Done,
     /* 298456 */   // Label 5881: @298456
     /* 298456 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(298485), // Rule ID 5160 //
     /* 298461 */     // MIs[0] Operand 1
     /* 298461 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 298466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298474 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 298474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 298477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298483 */     GIR_RootConstrainSelectedInstOperands,
     /* 298484 */     // GIR_Coverage, 5160,
     /* 298484 */     GIR_EraseRootFromParent_Done,
     /* 298485 */   // Label 5882: @298485
     /* 298485 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(298514), // Rule ID 5167 //
     /* 298490 */     // MIs[0] Operand 1
     /* 298490 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 298495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298503 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 298503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 298506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 298510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298512 */     GIR_RootConstrainSelectedInstOperands,
     /* 298513 */     // GIR_Coverage, 5167,
     /* 298513 */     GIR_EraseRootFromParent_Done,
     /* 298514 */   // Label 5883: @298514
     /* 298514 */   GIM_Reject,
     /* 298515 */ // Label 5853: @298515
     /* 298515 */ GIM_Reject,
     /* 298516 */ // Label 5654: @298516
     /* 298516 */ GIM_Reject,
     /* 298517 */ // Label 52: @298517
     /* 298517 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5896*/ GIMT_Encode4(299561),
     /* 298528 */ /*GILLT_nxv1s1*//*Label 5884*/ GIMT_Encode4(298576),
     /* 298532 */ /*GILLT_nxv2s1*//*Label 5885*/ GIMT_Encode4(298605),
     /* 298536 */ /*GILLT_nxv2s16*//*Label 5886*/ GIMT_Encode4(298634),
     /* 298540 */ /*GILLT_nxv2s32*//*Label 5887*/ GIMT_Encode4(298719),
     /* 298544 */ /*GILLT_nxv2s64*//*Label 5888*/ GIMT_Encode4(298804),
     /* 298548 */ /*GILLT_nxv4s1*//*Label 5889*/ GIMT_Encode4(298970),
     /* 298552 */ /*GILLT_nxv4s16*//*Label 5890*/ GIMT_Encode4(298999),
     /* 298556 */ /*GILLT_nxv4s32*//*Label 5891*/ GIMT_Encode4(299084),
     /* 298560 */ /*GILLT_nxv8s1*//*Label 5892*/ GIMT_Encode4(299250),
     /* 298564 */ /*GILLT_nxv8s16*//*Label 5893*/ GIMT_Encode4(299279),
     /* 298568 */ /*GILLT_nxv16s1*//*Label 5894*/ GIMT_Encode4(299445),
     /* 298572 */ /*GILLT_nxv16s8*//*Label 5895*/ GIMT_Encode4(299474),
     /* 298576 */ // Label 5884: @298576
     /* 298576 */ GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(298604), // Rule ID 8515 //
     /* 298581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 298587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 298590 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 298593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 298597 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 298597 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 298602 */   GIR_RootConstrainSelectedInstOperands,
     /* 298603 */   // GIR_Coverage, 8515,
     /* 298603 */   GIR_Done,
     /* 298604 */ // Label 5897: @298604
     /* 298604 */ GIM_Reject,
     /* 298605 */ // Label 5885: @298605
     /* 298605 */ GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(298633), // Rule ID 8514 //
     /* 298610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 298616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 298619 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 298622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 298626 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 298626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 298631 */   GIR_RootConstrainSelectedInstOperands,
     /* 298632 */   // GIR_Coverage, 8514,
     /* 298632 */   GIR_Done,
     /* 298633 */ // Label 5898: @298633
     /* 298633 */ GIM_Reject,
     /* 298634 */ // Label 5886: @298634
     /* 298634 */ GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(298718),
     /* 298639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 298642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 298645 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 298648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298652 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(298702), // Rule ID 3161 //
     /* 298657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 298668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 298672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 298680 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 298684 */     // MIs[2] Operand 1
     /* 298684 */     // No operand predicates
     /* 298684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298686 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 298686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 298689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 298691 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 298693 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 298695 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 298700 */     GIR_RootConstrainSelectedInstOperands,
     /* 298701 */     // GIR_Coverage, 3161,
     /* 298701 */     GIR_EraseRootFromParent_Done,
     /* 298702 */   // Label 5900: @298702
     /* 298702 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(298717), // Rule ID 2741 //
     /* 298707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298710 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 298710 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 298715 */     GIR_RootConstrainSelectedInstOperands,
     /* 298716 */     // GIR_Coverage, 2741,
     /* 298716 */     GIR_Done,
     /* 298717 */   // Label 5901: @298717
     /* 298717 */   GIM_Reject,
     /* 298718 */ // Label 5899: @298718
     /* 298718 */ GIM_Reject,
     /* 298719 */ // Label 5887: @298719
     /* 298719 */ GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(298803),
     /* 298724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 298727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 298730 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 298733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298737 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(298787), // Rule ID 3163 //
     /* 298742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 298753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 298757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 298765 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 298769 */     // MIs[2] Operand 1
     /* 298769 */     // No operand predicates
     /* 298769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298771 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 298771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 298774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 298776 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 298778 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 298780 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 298785 */     GIR_RootConstrainSelectedInstOperands,
     /* 298786 */     // GIR_Coverage, 3163,
     /* 298786 */     GIR_EraseRootFromParent_Done,
     /* 298787 */   // Label 5903: @298787
     /* 298787 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(298802), // Rule ID 2742 //
     /* 298792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298795 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 298795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 298800 */     GIR_RootConstrainSelectedInstOperands,
     /* 298801 */     // GIR_Coverage, 2742,
     /* 298801 */     GIR_Done,
     /* 298802 */   // Label 5904: @298802
     /* 298802 */   GIM_Reject,
     /* 298803 */ // Label 5902: @298803
     /* 298803 */ GIM_Reject,
     /* 298804 */ // Label 5888: @298804
     /* 298804 */ GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(298969),
     /* 298809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 298812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 298815 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(298872), // Rule ID 3164 //
     /* 298820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 298826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 298838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 298850 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 298854 */     // MIs[2] Operand 1
     /* 298854 */     // No operand predicates
     /* 298854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298856 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 298856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 298859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 298861 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 298863 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 298865 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 298870 */     GIR_RootConstrainSelectedInstOperands,
     /* 298871 */     // GIR_Coverage, 3164,
     /* 298871 */     GIR_EraseRootFromParent_Done,
     /* 298872 */   // Label 5906: @298872
     /* 298872 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(298924), // Rule ID 7561 //
     /* 298877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 298892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 298896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 298900 */     // MIs[0] Op2
     /* 298900 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 298905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298907 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 298907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 298910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 298912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 298914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 298918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 298922 */     GIR_RootConstrainSelectedInstOperands,
     /* 298923 */     // GIR_Coverage, 7561,
     /* 298923 */     GIR_EraseRootFromParent_Done,
     /* 298924 */   // Label 5907: @298924
     /* 298924 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(298946), // Rule ID 2737 //
     /* 298929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 298935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298939 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 298939 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 298944 */     GIR_RootConstrainSelectedInstOperands,
     /* 298945 */     // GIR_Coverage, 2737,
     /* 298945 */     GIR_Done,
     /* 298946 */   // Label 5908: @298946
     /* 298946 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(298968), // Rule ID 2743 //
     /* 298951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 298957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298961 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 298961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 298966 */     GIR_RootConstrainSelectedInstOperands,
     /* 298967 */     // GIR_Coverage, 2743,
     /* 298967 */     GIR_Done,
     /* 298968 */   // Label 5909: @298968
     /* 298968 */   GIM_Reject,
     /* 298969 */ // Label 5905: @298969
     /* 298969 */ GIM_Reject,
     /* 298970 */ // Label 5889: @298970
     /* 298970 */ GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(298998), // Rule ID 8513 //
     /* 298975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 298981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 298984 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 298987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 298991 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 298991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 298996 */   GIR_RootConstrainSelectedInstOperands,
     /* 298997 */   // GIR_Coverage, 8513,
     /* 298997 */   GIR_Done,
     /* 298998 */ // Label 5910: @298998
     /* 298998 */ GIM_Reject,
     /* 298999 */ // Label 5890: @298999
     /* 298999 */ GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(299083),
     /* 299004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 299007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 299010 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 299013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299017 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(299067), // Rule ID 3160 //
     /* 299022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 299033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 299045 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 299049 */     // MIs[2] Operand 1
     /* 299049 */     // No operand predicates
     /* 299049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299051 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 299051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 299054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 299056 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 299058 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 299060 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 299065 */     GIR_RootConstrainSelectedInstOperands,
     /* 299066 */     // GIR_Coverage, 3160,
     /* 299066 */     GIR_EraseRootFromParent_Done,
     /* 299067 */   // Label 5912: @299067
     /* 299067 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(299082), // Rule ID 2739 //
     /* 299072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299075 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 299075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 299080 */     GIR_RootConstrainSelectedInstOperands,
     /* 299081 */     // GIR_Coverage, 2739,
     /* 299081 */     GIR_Done,
     /* 299082 */   // Label 5913: @299082
     /* 299082 */   GIM_Reject,
     /* 299083 */ // Label 5911: @299083
     /* 299083 */ GIM_Reject,
     /* 299084 */ // Label 5891: @299084
     /* 299084 */ GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(299249),
     /* 299089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 299092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 299095 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(299152), // Rule ID 3162 //
     /* 299100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 299106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 299118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 299122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 299130 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 299134 */     // MIs[2] Operand 1
     /* 299134 */     // No operand predicates
     /* 299134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299136 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 299136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 299139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 299141 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 299143 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 299145 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 299150 */     GIR_RootConstrainSelectedInstOperands,
     /* 299151 */     // GIR_Coverage, 3162,
     /* 299151 */     GIR_EraseRootFromParent_Done,
     /* 299152 */   // Label 5915: @299152
     /* 299152 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(299204), // Rule ID 7559 //
     /* 299157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 299172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 299176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 299180 */     // MIs[0] Op2
     /* 299180 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 299185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299187 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 299187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 299190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 299192 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 299194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 299198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 299202 */     GIR_RootConstrainSelectedInstOperands,
     /* 299203 */     // GIR_Coverage, 7559,
     /* 299203 */     GIR_EraseRootFromParent_Done,
     /* 299204 */   // Label 5916: @299204
     /* 299204 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(299226), // Rule ID 2736 //
     /* 299209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 299215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299219 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 299219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 299224 */     GIR_RootConstrainSelectedInstOperands,
     /* 299225 */     // GIR_Coverage, 2736,
     /* 299225 */     GIR_Done,
     /* 299226 */   // Label 5917: @299226
     /* 299226 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(299248), // Rule ID 2740 //
     /* 299231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 299237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299241 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 299241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 299246 */     GIR_RootConstrainSelectedInstOperands,
     /* 299247 */     // GIR_Coverage, 2740,
     /* 299247 */     GIR_Done,
     /* 299248 */   // Label 5918: @299248
     /* 299248 */   GIM_Reject,
     /* 299249 */ // Label 5914: @299249
     /* 299249 */ GIM_Reject,
     /* 299250 */ // Label 5892: @299250
     /* 299250 */ GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(299278), // Rule ID 8512 //
     /* 299255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 299261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 299264 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 299267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 299271 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 299271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 299276 */   GIR_RootConstrainSelectedInstOperands,
     /* 299277 */   // GIR_Coverage, 8512,
     /* 299277 */   GIR_Done,
     /* 299278 */ // Label 5919: @299278
     /* 299278 */ GIM_Reject,
     /* 299279 */ // Label 5893: @299279
     /* 299279 */ GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(299444),
     /* 299284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 299287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 299290 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(299347), // Rule ID 3159 //
     /* 299295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 299301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 299313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 299317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 299325 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 299329 */     // MIs[2] Operand 1
     /* 299329 */     // No operand predicates
     /* 299329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299331 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 299331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 299334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 299336 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 299338 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 299340 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 299345 */     GIR_RootConstrainSelectedInstOperands,
     /* 299346 */     // GIR_Coverage, 3159,
     /* 299346 */     GIR_EraseRootFromParent_Done,
     /* 299347 */   // Label 5921: @299347
     /* 299347 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(299399), // Rule ID 7557 //
     /* 299352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 299367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 299371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 299375 */     // MIs[0] Op2
     /* 299375 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 299380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299382 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 299382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 299385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 299387 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 299389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 299393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 299397 */     GIR_RootConstrainSelectedInstOperands,
     /* 299398 */     // GIR_Coverage, 7557,
     /* 299398 */     GIR_EraseRootFromParent_Done,
     /* 299399 */   // Label 5922: @299399
     /* 299399 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(299421), // Rule ID 2735 //
     /* 299404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 299410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299414 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 299414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 299419 */     GIR_RootConstrainSelectedInstOperands,
     /* 299420 */     // GIR_Coverage, 2735,
     /* 299420 */     GIR_Done,
     /* 299421 */   // Label 5923: @299421
     /* 299421 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(299443), // Rule ID 2738 //
     /* 299426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 299432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299436 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 299436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 299441 */     GIR_RootConstrainSelectedInstOperands,
     /* 299442 */     // GIR_Coverage, 2738,
     /* 299442 */     GIR_Done,
     /* 299443 */   // Label 5924: @299443
     /* 299443 */   GIM_Reject,
     /* 299444 */ // Label 5920: @299444
     /* 299444 */ GIM_Reject,
     /* 299445 */ // Label 5894: @299445
     /* 299445 */ GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(299473), // Rule ID 8511 //
     /* 299450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 299456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 299459 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 299462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 299466 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 299466 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 299471 */   GIR_RootConstrainSelectedInstOperands,
     /* 299472 */   // GIR_Coverage, 8511,
     /* 299472 */   GIR_Done,
     /* 299473 */ // Label 5925: @299473
     /* 299473 */ GIM_Reject,
     /* 299474 */ // Label 5895: @299474
     /* 299474 */ GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(299560),
     /* 299479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 299482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 299485 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(299537), // Rule ID 7555 //
     /* 299490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 299505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 299509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 299513 */     // MIs[0] Op2
     /* 299513 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 299518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299520 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 299520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 299523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 299525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 299527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 299531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 299535 */     GIR_RootConstrainSelectedInstOperands,
     /* 299536 */     // GIR_Coverage, 7555,
     /* 299536 */     GIR_EraseRootFromParent_Done,
     /* 299537 */   // Label 5927: @299537
     /* 299537 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(299559), // Rule ID 2734 //
     /* 299542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 299545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 299548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 299552 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 299552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 299557 */     GIR_RootConstrainSelectedInstOperands,
     /* 299558 */     // GIR_Coverage, 2734,
     /* 299558 */     GIR_Done,
     /* 299559 */   // Label 5928: @299559
     /* 299559 */   GIM_Reject,
     /* 299560 */ // Label 5926: @299560
     /* 299560 */ GIM_Reject,
     /* 299561 */ // Label 5896: @299561
     /* 299561 */ GIM_Reject,
     /* 299562 */ // Label 53: @299562
     /* 299562 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5933*/ GIMT_Encode4(300045),
     /* 299573 */ /*GILLT_s64*//*Label 5929*/ GIMT_Encode4(299609), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 299593 */ /*GILLT_v4s32*//*Label 5930*/ GIMT_Encode4(299640), GIMT_Encode4(0),
     /* 299601 */ /*GILLT_v8s16*//*Label 5931*/ GIMT_Encode4(299775),
     /* 299605 */ /*GILLT_v16s8*//*Label 5932*/ GIMT_Encode4(299910),
     /* 299609 */ // Label 5929: @299609
     /* 299609 */ GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(299639), // Rule ID 128 //
     /* 299614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 299617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 299620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 299624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 299628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 299632 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 299632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 299637 */   GIR_RootConstrainSelectedInstOperands,
     /* 299638 */   // GIR_Coverage, 128,
     /* 299638 */   GIR_Done,
     /* 299639 */ // Label 5934: @299639
     /* 299639 */ GIM_Reject,
     /* 299640 */ // Label 5930: @299640
     /* 299640 */ GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(299774), // Rule ID 6581 //
     /* 299645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 299651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299663 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 299663 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 299666 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 299670 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299675 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 299679 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 299683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 299685 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 299688 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299692 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299697 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 299703 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299708 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299713 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 299716 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299720 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299725 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299731 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299736 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 299744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 299748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299753 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 299756 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 299759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 299764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299766 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299769 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 299772 */   GIR_RootConstrainSelectedInstOperands,
     /* 299773 */   // GIR_Coverage, 6581,
     /* 299773 */   GIR_EraseRootFromParent_Done,
     /* 299774 */ // Label 5935: @299774
     /* 299774 */ GIM_Reject,
     /* 299775 */ // Label 5931: @299775
     /* 299775 */ GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(299909), // Rule ID 6580 //
     /* 299780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 299786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299794 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299798 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 299798 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 299801 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 299805 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299810 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 299814 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 299818 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 299820 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 299823 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299827 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299832 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 299838 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299843 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299848 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 299851 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299855 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299860 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 299866 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299871 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 299879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 299883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299888 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 299891 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 299894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 299896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 299899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299904 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 299907 */   GIR_RootConstrainSelectedInstOperands,
     /* 299908 */   // GIR_Coverage, 6580,
     /* 299908 */   GIR_EraseRootFromParent_Done,
     /* 299909 */ // Label 5936: @299909
     /* 299909 */ GIM_Reject,
     /* 299910 */ // Label 5932: @299910
     /* 299910 */ GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(300044), // Rule ID 6579 //
     /* 299915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 299918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 299921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299929 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299933 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 299933 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 299936 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 299940 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299945 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 299949 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 299953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 299955 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 299958 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299962 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299967 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 299973 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299978 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299983 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 299986 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 299990 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 299995 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 300001 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300006 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300011 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300014 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 300018 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300023 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 300026 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 300029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 300034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300039 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 300042 */   GIR_RootConstrainSelectedInstOperands,
     /* 300043 */   // GIR_Coverage, 6579,
     /* 300043 */   GIR_EraseRootFromParent_Done,
     /* 300044 */ // Label 5937: @300044
     /* 300044 */ GIM_Reject,
     /* 300045 */ // Label 5933: @300045
     /* 300045 */ GIM_Reject,
     /* 300046 */ // Label 54: @300046
     /* 300046 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5942*/ GIMT_Encode4(300529),
     /* 300057 */ /*GILLT_s64*//*Label 5938*/ GIMT_Encode4(300093), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 300077 */ /*GILLT_v4s32*//*Label 5939*/ GIMT_Encode4(300124), GIMT_Encode4(0),
     /* 300085 */ /*GILLT_v8s16*//*Label 5940*/ GIMT_Encode4(300259),
     /* 300089 */ /*GILLT_v16s8*//*Label 5941*/ GIMT_Encode4(300394),
     /* 300093 */ // Label 5938: @300093
     /* 300093 */ GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(300123), // Rule ID 127 //
     /* 300098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 300101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 300104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300112 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 300116 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 300116 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 300121 */   GIR_RootConstrainSelectedInstOperands,
     /* 300122 */   // GIR_Coverage, 127,
     /* 300122 */   GIR_Done,
     /* 300123 */ // Label 5943: @300123
     /* 300123 */ GIM_Reject,
     /* 300124 */ // Label 5939: @300124
     /* 300124 */ GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(300258), // Rule ID 6578 //
     /* 300129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 300135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300143 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300147 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 300147 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 300150 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 300154 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300159 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 300163 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 300167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 300169 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 300172 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300176 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300181 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 300187 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300192 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300197 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 300200 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300204 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300209 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 300215 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300220 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300225 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300228 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 300232 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300237 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 300240 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 300243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 300248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300250 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300253 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 300256 */   GIR_RootConstrainSelectedInstOperands,
     /* 300257 */   // GIR_Coverage, 6578,
     /* 300257 */   GIR_EraseRootFromParent_Done,
     /* 300258 */ // Label 5944: @300258
     /* 300258 */ GIM_Reject,
     /* 300259 */ // Label 5940: @300259
     /* 300259 */ GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(300393), // Rule ID 6577 //
     /* 300264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 300270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300282 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 300282 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 300285 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 300289 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300294 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 300298 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 300302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 300304 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 300307 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300311 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300316 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 300322 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300327 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300332 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 300335 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300339 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300344 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 300350 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300355 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 300367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300372 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 300375 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 300378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 300383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300385 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300388 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 300391 */   GIR_RootConstrainSelectedInstOperands,
     /* 300392 */   // GIR_Coverage, 6577,
     /* 300392 */   GIR_EraseRootFromParent_Done,
     /* 300393 */ // Label 5945: @300393
     /* 300393 */ GIM_Reject,
     /* 300394 */ // Label 5941: @300394
     /* 300394 */ GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(300528), // Rule ID 6576 //
     /* 300399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 300402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 300405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300417 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 300417 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 300420 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 300424 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300429 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 300433 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 300437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 300439 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 300442 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300446 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300451 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 300457 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300462 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300467 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 300470 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 300474 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300479 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 300485 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300490 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300495 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300498 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 300502 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300507 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 300510 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 300513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 300515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 300518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 300520 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 300526 */   GIR_RootConstrainSelectedInstOperands,
     /* 300527 */   // GIR_Coverage, 6576,
     /* 300527 */   GIR_EraseRootFromParent_Done,
     /* 300528 */ // Label 5946: @300528
     /* 300528 */ GIM_Reject,
     /* 300529 */ // Label 5942: @300529
     /* 300529 */ GIM_Reject,
     /* 300530 */ // Label 55: @300530
     /* 300530 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5958*/ GIMT_Encode4(300959),
     /* 300541 */ /*GILLT_v2s32*//*Label 5947*/ GIMT_Encode4(300617),
     /* 300545 */ /*GILLT_v2s64*//*Label 5948*/ GIMT_Encode4(300651),
     /* 300549 */ /*GILLT_v4s16*//*Label 5949*/ GIMT_Encode4(300685),
     /* 300553 */ /*GILLT_v4s32*//*Label 5950*/ GIMT_Encode4(300719),
     /* 300557 */ /*GILLT_v8s8*//*Label 5951*/ GIMT_Encode4(300753),
     /* 300561 */ /*GILLT_v8s16*//*Label 5952*/ GIMT_Encode4(300787),
     /* 300565 */ /*GILLT_v16s8*//*Label 5953*/ GIMT_Encode4(300821), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 300585 */ /*GILLT_nxv2s64*//*Label 5954*/ GIMT_Encode4(300855), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 300597 */ /*GILLT_nxv4s32*//*Label 5955*/ GIMT_Encode4(300881), GIMT_Encode4(0),
     /* 300605 */ /*GILLT_nxv8s16*//*Label 5956*/ GIMT_Encode4(300907), GIMT_Encode4(0),
     /* 300613 */ /*GILLT_nxv16s8*//*Label 5957*/ GIMT_Encode4(300933),
     /* 300617 */ // Label 5947: @300617
     /* 300617 */ GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(300650), // Rule ID 5059 //
     /* 300622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 300631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300643 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 300643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 300648 */   GIR_RootConstrainSelectedInstOperands,
     /* 300649 */   // GIR_Coverage, 5059,
     /* 300649 */   GIR_Done,
     /* 300650 */ // Label 5959: @300650
     /* 300650 */ GIM_Reject,
     /* 300651 */ // Label 5948: @300651
     /* 300651 */ GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(300684), // Rule ID 5063 //
     /* 300656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 300662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 300665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300673 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300677 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 300677 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 300682 */   GIR_RootConstrainSelectedInstOperands,
     /* 300683 */   // GIR_Coverage, 5063,
     /* 300683 */   GIR_Done,
     /* 300684 */ // Label 5960: @300684
     /* 300684 */ GIM_Reject,
     /* 300685 */ // Label 5949: @300685
     /* 300685 */ GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(300718), // Rule ID 5058 //
     /* 300690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 300696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300707 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300711 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 300711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 300716 */   GIR_RootConstrainSelectedInstOperands,
     /* 300717 */   // GIR_Coverage, 5058,
     /* 300717 */   GIR_Done,
     /* 300718 */ // Label 5961: @300718
     /* 300718 */ GIM_Reject,
     /* 300719 */ // Label 5950: @300719
     /* 300719 */ GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(300752), // Rule ID 5062 //
     /* 300724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 300733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300741 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300745 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 300745 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 300750 */   GIR_RootConstrainSelectedInstOperands,
     /* 300751 */   // GIR_Coverage, 5062,
     /* 300751 */   GIR_Done,
     /* 300752 */ // Label 5962: @300752
     /* 300752 */ GIM_Reject,
     /* 300753 */ // Label 5951: @300753
     /* 300753 */ GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(300786), // Rule ID 5057 //
     /* 300758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 300764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 300767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300779 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 300779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 300784 */   GIR_RootConstrainSelectedInstOperands,
     /* 300785 */   // GIR_Coverage, 5057,
     /* 300785 */   GIR_Done,
     /* 300786 */ // Label 5963: @300786
     /* 300786 */ GIM_Reject,
     /* 300787 */ // Label 5952: @300787
     /* 300787 */ GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(300820), // Rule ID 5061 //
     /* 300792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 300801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300813 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 300813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 300818 */   GIR_RootConstrainSelectedInstOperands,
     /* 300819 */   // GIR_Coverage, 5061,
     /* 300819 */   GIR_Done,
     /* 300820 */ // Label 5964: @300820
     /* 300820 */ GIM_Reject,
     /* 300821 */ // Label 5953: @300821
     /* 300821 */ GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(300854), // Rule ID 5060 //
     /* 300826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 300832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 300835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300843 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300847 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 300847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 300852 */   GIR_RootConstrainSelectedInstOperands,
     /* 300853 */   // GIR_Coverage, 5060,
     /* 300853 */   GIR_Done,
     /* 300854 */ // Label 5965: @300854
     /* 300854 */ GIM_Reject,
     /* 300855 */ // Label 5954: @300855
     /* 300855 */ GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(300880), // Rule ID 7513 //
     /* 300860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 300863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 300866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 300869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 300873 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 300873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 300878 */   GIR_RootConstrainSelectedInstOperands,
     /* 300879 */   // GIR_Coverage, 7513,
     /* 300879 */   GIR_Done,
     /* 300880 */ // Label 5966: @300880
     /* 300880 */ GIM_Reject,
     /* 300881 */ // Label 5955: @300881
     /* 300881 */ GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(300906), // Rule ID 7512 //
     /* 300886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 300889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 300892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 300895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 300899 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 300899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 300904 */   GIR_RootConstrainSelectedInstOperands,
     /* 300905 */   // GIR_Coverage, 7512,
     /* 300905 */   GIR_Done,
     /* 300906 */ // Label 5967: @300906
     /* 300906 */ GIM_Reject,
     /* 300907 */ // Label 5956: @300907
     /* 300907 */ GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(300932), // Rule ID 7511 //
     /* 300912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 300915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 300918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 300921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 300925 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 300925 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 300930 */   GIR_RootConstrainSelectedInstOperands,
     /* 300931 */   // GIR_Coverage, 7511,
     /* 300931 */   GIR_Done,
     /* 300932 */ // Label 5968: @300932
     /* 300932 */ GIM_Reject,
     /* 300933 */ // Label 5957: @300933
     /* 300933 */ GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(300958), // Rule ID 7510 //
     /* 300938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 300941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 300944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 300947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 300951 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 300951 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 300956 */   GIR_RootConstrainSelectedInstOperands,
     /* 300957 */   // GIR_Coverage, 7510,
     /* 300957 */   GIR_Done,
     /* 300958 */ // Label 5969: @300958
     /* 300958 */ GIM_Reject,
     /* 300959 */ // Label 5958: @300959
     /* 300959 */ GIM_Reject,
     /* 300960 */ // Label 56: @300960
     /* 300960 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5981*/ GIMT_Encode4(301389),
     /* 300971 */ /*GILLT_v2s32*//*Label 5970*/ GIMT_Encode4(301047),
     /* 300975 */ /*GILLT_v2s64*//*Label 5971*/ GIMT_Encode4(301081),
     /* 300979 */ /*GILLT_v4s16*//*Label 5972*/ GIMT_Encode4(301115),
     /* 300983 */ /*GILLT_v4s32*//*Label 5973*/ GIMT_Encode4(301149),
     /* 300987 */ /*GILLT_v8s8*//*Label 5974*/ GIMT_Encode4(301183),
     /* 300991 */ /*GILLT_v8s16*//*Label 5975*/ GIMT_Encode4(301217),
     /* 300995 */ /*GILLT_v16s8*//*Label 5976*/ GIMT_Encode4(301251), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301015 */ /*GILLT_nxv2s64*//*Label 5977*/ GIMT_Encode4(301285), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301027 */ /*GILLT_nxv4s32*//*Label 5978*/ GIMT_Encode4(301311), GIMT_Encode4(0),
     /* 301035 */ /*GILLT_nxv8s16*//*Label 5979*/ GIMT_Encode4(301337), GIMT_Encode4(0),
     /* 301043 */ /*GILLT_nxv16s8*//*Label 5980*/ GIMT_Encode4(301363),
     /* 301047 */ // Label 5970: @301047
     /* 301047 */ GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(301080), // Rule ID 2477 //
     /* 301052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301073 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 301073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 301078 */   GIR_RootConstrainSelectedInstOperands,
     /* 301079 */   // GIR_Coverage, 2477,
     /* 301079 */   GIR_Done,
     /* 301080 */ // Label 5982: @301080
     /* 301080 */ GIM_Reject,
     /* 301081 */ // Label 5971: @301081
     /* 301081 */ GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(301114), // Rule ID 2481 //
     /* 301086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 301095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301107 */   // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 301107 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 301112 */   GIR_RootConstrainSelectedInstOperands,
     /* 301113 */   // GIR_Coverage, 2481,
     /* 301113 */   GIR_Done,
     /* 301114 */ // Label 5983: @301114
     /* 301114 */ GIM_Reject,
     /* 301115 */ // Label 5972: @301115
     /* 301115 */ GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(301148), // Rule ID 2476 //
     /* 301120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 301126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 301129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301141 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 301141 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 301146 */   GIR_RootConstrainSelectedInstOperands,
     /* 301147 */   // GIR_Coverage, 2476,
     /* 301147 */   GIR_Done,
     /* 301148 */ // Label 5984: @301148
     /* 301148 */ GIM_Reject,
     /* 301149 */ // Label 5973: @301149
     /* 301149 */ GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(301182), // Rule ID 2480 //
     /* 301154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 301163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301171 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301175 */   // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 301175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 301180 */   GIR_RootConstrainSelectedInstOperands,
     /* 301181 */   // GIR_Coverage, 2480,
     /* 301181 */   GIR_Done,
     /* 301182 */ // Label 5985: @301182
     /* 301182 */ GIM_Reject,
     /* 301183 */ // Label 5974: @301183
     /* 301183 */ GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(301216), // Rule ID 2475 //
     /* 301188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 301194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 301197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301209 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 301209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 301214 */   GIR_RootConstrainSelectedInstOperands,
     /* 301215 */   // GIR_Coverage, 2475,
     /* 301215 */   GIR_Done,
     /* 301216 */ // Label 5986: @301216
     /* 301216 */ GIM_Reject,
     /* 301217 */ // Label 5975: @301217
     /* 301217 */ GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(301250), // Rule ID 2479 //
     /* 301222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 301231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301243 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 301243 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 301248 */   GIR_RootConstrainSelectedInstOperands,
     /* 301249 */   // GIR_Coverage, 2479,
     /* 301249 */   GIR_Done,
     /* 301250 */ // Label 5987: @301250
     /* 301250 */ GIM_Reject,
     /* 301251 */ // Label 5976: @301251
     /* 301251 */ GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(301284), // Rule ID 2478 //
     /* 301256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 301262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 301265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301277 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 301277 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 301282 */   GIR_RootConstrainSelectedInstOperands,
     /* 301283 */   // GIR_Coverage, 2478,
     /* 301283 */   GIR_Done,
     /* 301284 */ // Label 5988: @301284
     /* 301284 */ GIM_Reject,
     /* 301285 */ // Label 5977: @301285
     /* 301285 */ GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(301310), // Rule ID 7509 //
     /* 301290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 301296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 301299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301303 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 301303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 301308 */   GIR_RootConstrainSelectedInstOperands,
     /* 301309 */   // GIR_Coverage, 7509,
     /* 301309 */   GIR_Done,
     /* 301310 */ // Label 5989: @301310
     /* 301310 */ GIM_Reject,
     /* 301311 */ // Label 5978: @301311
     /* 301311 */ GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(301336), // Rule ID 7508 //
     /* 301316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 301322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 301325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301329 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 301329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 301334 */   GIR_RootConstrainSelectedInstOperands,
     /* 301335 */   // GIR_Coverage, 7508,
     /* 301335 */   GIR_Done,
     /* 301336 */ // Label 5990: @301336
     /* 301336 */ GIM_Reject,
     /* 301337 */ // Label 5979: @301337
     /* 301337 */ GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(301362), // Rule ID 7507 //
     /* 301342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 301348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 301351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301355 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 301355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 301360 */   GIR_RootConstrainSelectedInstOperands,
     /* 301361 */   // GIR_Coverage, 7507,
     /* 301361 */   GIR_Done,
     /* 301362 */ // Label 5991: @301362
     /* 301362 */ GIM_Reject,
     /* 301363 */ // Label 5980: @301363
     /* 301363 */ GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(301388), // Rule ID 7506 //
     /* 301368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 301374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 301377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301381 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 301381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 301386 */   GIR_RootConstrainSelectedInstOperands,
     /* 301387 */   // GIR_Coverage, 7506,
     /* 301387 */   GIR_Done,
     /* 301388 */ // Label 5992: @301388
     /* 301388 */ GIM_Reject,
     /* 301389 */ // Label 5981: @301389
     /* 301389 */ GIM_Reject,
     /* 301390 */ // Label 57: @301390
     /* 301390 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 6004*/ GIMT_Encode4(301819),
     /* 301401 */ /*GILLT_v2s32*//*Label 5993*/ GIMT_Encode4(301477),
     /* 301405 */ /*GILLT_v2s64*//*Label 5994*/ GIMT_Encode4(301511),
     /* 301409 */ /*GILLT_v4s16*//*Label 5995*/ GIMT_Encode4(301545),
     /* 301413 */ /*GILLT_v4s32*//*Label 5996*/ GIMT_Encode4(301579),
     /* 301417 */ /*GILLT_v8s8*//*Label 5997*/ GIMT_Encode4(301613),
     /* 301421 */ /*GILLT_v8s16*//*Label 5998*/ GIMT_Encode4(301647),
     /* 301425 */ /*GILLT_v16s8*//*Label 5999*/ GIMT_Encode4(301681), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301445 */ /*GILLT_nxv2s64*//*Label 6000*/ GIMT_Encode4(301715), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301457 */ /*GILLT_nxv4s32*//*Label 6001*/ GIMT_Encode4(301741), GIMT_Encode4(0),
     /* 301465 */ /*GILLT_nxv8s16*//*Label 6002*/ GIMT_Encode4(301767), GIMT_Encode4(0),
     /* 301473 */ /*GILLT_nxv16s8*//*Label 6003*/ GIMT_Encode4(301793),
     /* 301477 */ // Label 5993: @301477
     /* 301477 */ GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(301510), // Rule ID 5073 //
     /* 301482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301499 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301503 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 301503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 301508 */   GIR_RootConstrainSelectedInstOperands,
     /* 301509 */   // GIR_Coverage, 5073,
     /* 301509 */   GIR_Done,
     /* 301510 */ // Label 6005: @301510
     /* 301510 */ GIM_Reject,
     /* 301511 */ // Label 5994: @301511
     /* 301511 */ GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(301544), // Rule ID 5077 //
     /* 301516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 301525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301537 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 301537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 301542 */   GIR_RootConstrainSelectedInstOperands,
     /* 301543 */   // GIR_Coverage, 5077,
     /* 301543 */   GIR_Done,
     /* 301544 */ // Label 6006: @301544
     /* 301544 */ GIM_Reject,
     /* 301545 */ // Label 5995: @301545
     /* 301545 */ GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(301578), // Rule ID 5072 //
     /* 301550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 301556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 301559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301571 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 301571 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 301576 */   GIR_RootConstrainSelectedInstOperands,
     /* 301577 */   // GIR_Coverage, 5072,
     /* 301577 */   GIR_Done,
     /* 301578 */ // Label 6007: @301578
     /* 301578 */ GIM_Reject,
     /* 301579 */ // Label 5996: @301579
     /* 301579 */ GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(301612), // Rule ID 5076 //
     /* 301584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 301593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301601 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301605 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 301605 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 301610 */   GIR_RootConstrainSelectedInstOperands,
     /* 301611 */   // GIR_Coverage, 5076,
     /* 301611 */   GIR_Done,
     /* 301612 */ // Label 6008: @301612
     /* 301612 */ GIM_Reject,
     /* 301613 */ // Label 5997: @301613
     /* 301613 */ GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(301646), // Rule ID 5071 //
     /* 301618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 301624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 301627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301639 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 301639 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 301644 */   GIR_RootConstrainSelectedInstOperands,
     /* 301645 */   // GIR_Coverage, 5071,
     /* 301645 */   GIR_Done,
     /* 301646 */ // Label 6009: @301646
     /* 301646 */ GIM_Reject,
     /* 301647 */ // Label 5998: @301647
     /* 301647 */ GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(301680), // Rule ID 5075 //
     /* 301652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 301661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301673 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 301673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 301678 */   GIR_RootConstrainSelectedInstOperands,
     /* 301679 */   // GIR_Coverage, 5075,
     /* 301679 */   GIR_Done,
     /* 301680 */ // Label 6010: @301680
     /* 301680 */ GIM_Reject,
     /* 301681 */ // Label 5999: @301681
     /* 301681 */ GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(301714), // Rule ID 5074 //
     /* 301686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 301692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 301695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301707 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 301707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 301712 */   GIR_RootConstrainSelectedInstOperands,
     /* 301713 */   // GIR_Coverage, 5074,
     /* 301713 */   GIR_Done,
     /* 301714 */ // Label 6011: @301714
     /* 301714 */ GIM_Reject,
     /* 301715 */ // Label 6000: @301715
     /* 301715 */ GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(301740), // Rule ID 7521 //
     /* 301720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 301726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 301729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301733 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 301733 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 301738 */   GIR_RootConstrainSelectedInstOperands,
     /* 301739 */   // GIR_Coverage, 7521,
     /* 301739 */   GIR_Done,
     /* 301740 */ // Label 6012: @301740
     /* 301740 */ GIM_Reject,
     /* 301741 */ // Label 6001: @301741
     /* 301741 */ GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(301766), // Rule ID 7520 //
     /* 301746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 301752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 301755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301759 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 301759 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 301764 */   GIR_RootConstrainSelectedInstOperands,
     /* 301765 */   // GIR_Coverage, 7520,
     /* 301765 */   GIR_Done,
     /* 301766 */ // Label 6013: @301766
     /* 301766 */ GIM_Reject,
     /* 301767 */ // Label 6002: @301767
     /* 301767 */ GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(301792), // Rule ID 7519 //
     /* 301772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 301778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 301781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301785 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 301785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 301790 */   GIR_RootConstrainSelectedInstOperands,
     /* 301791 */   // GIR_Coverage, 7519,
     /* 301791 */   GIR_Done,
     /* 301792 */ // Label 6014: @301792
     /* 301792 */ GIM_Reject,
     /* 301793 */ // Label 6003: @301793
     /* 301793 */ GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(301818), // Rule ID 7518 //
     /* 301798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 301804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 301807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301811 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 301811 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 301816 */   GIR_RootConstrainSelectedInstOperands,
     /* 301817 */   // GIR_Coverage, 7518,
     /* 301817 */   GIR_Done,
     /* 301818 */ // Label 6015: @301818
     /* 301818 */ GIM_Reject,
     /* 301819 */ // Label 6004: @301819
     /* 301819 */ GIM_Reject,
     /* 301820 */ // Label 58: @301820
     /* 301820 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 6027*/ GIMT_Encode4(302249),
     /* 301831 */ /*GILLT_v2s32*//*Label 6016*/ GIMT_Encode4(301907),
     /* 301835 */ /*GILLT_v2s64*//*Label 6017*/ GIMT_Encode4(301941),
     /* 301839 */ /*GILLT_v4s16*//*Label 6018*/ GIMT_Encode4(301975),
     /* 301843 */ /*GILLT_v4s32*//*Label 6019*/ GIMT_Encode4(302009),
     /* 301847 */ /*GILLT_v8s8*//*Label 6020*/ GIMT_Encode4(302043),
     /* 301851 */ /*GILLT_v8s16*//*Label 6021*/ GIMT_Encode4(302077),
     /* 301855 */ /*GILLT_v16s8*//*Label 6022*/ GIMT_Encode4(302111), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301875 */ /*GILLT_nxv2s64*//*Label 6023*/ GIMT_Encode4(302145), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301887 */ /*GILLT_nxv4s32*//*Label 6024*/ GIMT_Encode4(302171), GIMT_Encode4(0),
     /* 301895 */ /*GILLT_nxv8s16*//*Label 6025*/ GIMT_Encode4(302197), GIMT_Encode4(0),
     /* 301903 */ /*GILLT_nxv16s8*//*Label 6026*/ GIMT_Encode4(302223),
     /* 301907 */ // Label 6016: @301907
     /* 301907 */ GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(301940), // Rule ID 5066 //
     /* 301912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301929 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301933 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 301933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 301938 */   GIR_RootConstrainSelectedInstOperands,
     /* 301939 */   // GIR_Coverage, 5066,
     /* 301939 */   GIR_Done,
     /* 301940 */ // Label 6028: @301940
     /* 301940 */ GIM_Reject,
     /* 301941 */ // Label 6017: @301941
     /* 301941 */ GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(301974), // Rule ID 5070 //
     /* 301946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 301955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301963 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301967 */   // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 301967 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 301972 */   GIR_RootConstrainSelectedInstOperands,
     /* 301973 */   // GIR_Coverage, 5070,
     /* 301973 */   GIR_Done,
     /* 301974 */ // Label 6029: @301974
     /* 301974 */ GIM_Reject,
     /* 301975 */ // Label 6018: @301975
     /* 301975 */ GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(302008), // Rule ID 5065 //
     /* 301980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 301986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 301989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302001 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 302001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 302006 */   GIR_RootConstrainSelectedInstOperands,
     /* 302007 */   // GIR_Coverage, 5065,
     /* 302007 */   GIR_Done,
     /* 302008 */ // Label 6030: @302008
     /* 302008 */ GIM_Reject,
     /* 302009 */ // Label 6019: @302009
     /* 302009 */ GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(302042), // Rule ID 5069 //
     /* 302014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 302023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302035 */   // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 302035 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 302040 */   GIR_RootConstrainSelectedInstOperands,
     /* 302041 */   // GIR_Coverage, 5069,
     /* 302041 */   GIR_Done,
     /* 302042 */ // Label 6031: @302042
     /* 302042 */ GIM_Reject,
     /* 302043 */ // Label 6020: @302043
     /* 302043 */ GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(302076), // Rule ID 5064 //
     /* 302048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 302054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 302057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302069 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 302069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 302074 */   GIR_RootConstrainSelectedInstOperands,
     /* 302075 */   // GIR_Coverage, 5064,
     /* 302075 */   GIR_Done,
     /* 302076 */ // Label 6032: @302076
     /* 302076 */ GIM_Reject,
     /* 302077 */ // Label 6021: @302077
     /* 302077 */ GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(302110), // Rule ID 5068 //
     /* 302082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 302091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302099 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302103 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 302103 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 302108 */   GIR_RootConstrainSelectedInstOperands,
     /* 302109 */   // GIR_Coverage, 5068,
     /* 302109 */   GIR_Done,
     /* 302110 */ // Label 6033: @302110
     /* 302110 */ GIM_Reject,
     /* 302111 */ // Label 6022: @302111
     /* 302111 */ GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(302144), // Rule ID 5067 //
     /* 302116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 302122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 302125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302137 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 302137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 302142 */   GIR_RootConstrainSelectedInstOperands,
     /* 302143 */   // GIR_Coverage, 5067,
     /* 302143 */   GIR_Done,
     /* 302144 */ // Label 6034: @302144
     /* 302144 */ GIM_Reject,
     /* 302145 */ // Label 6023: @302145
     /* 302145 */ GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(302170), // Rule ID 7517 //
     /* 302150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 302153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 302156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 302159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 302163 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 302163 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 302168 */   GIR_RootConstrainSelectedInstOperands,
     /* 302169 */   // GIR_Coverage, 7517,
     /* 302169 */   GIR_Done,
     /* 302170 */ // Label 6035: @302170
     /* 302170 */ GIM_Reject,
     /* 302171 */ // Label 6024: @302171
     /* 302171 */ GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(302196), // Rule ID 7516 //
     /* 302176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 302179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 302182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 302185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 302189 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 302189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 302194 */   GIR_RootConstrainSelectedInstOperands,
     /* 302195 */   // GIR_Coverage, 7516,
     /* 302195 */   GIR_Done,
     /* 302196 */ // Label 6036: @302196
     /* 302196 */ GIM_Reject,
     /* 302197 */ // Label 6025: @302197
     /* 302197 */ GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(302222), // Rule ID 7515 //
     /* 302202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 302205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 302208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 302211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 302215 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 302215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 302220 */   GIR_RootConstrainSelectedInstOperands,
     /* 302221 */   // GIR_Coverage, 7515,
     /* 302221 */   GIR_Done,
     /* 302222 */ // Label 6037: @302222
     /* 302222 */ GIM_Reject,
     /* 302223 */ // Label 6026: @302223
     /* 302223 */ GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(302248), // Rule ID 7514 //
     /* 302228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 302231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 302234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 302237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 302241 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 302241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 302246 */   GIR_RootConstrainSelectedInstOperands,
     /* 302247 */   // GIR_Coverage, 7514,
     /* 302247 */   GIR_Done,
     /* 302248 */ // Label 6038: @302248
     /* 302248 */ GIM_Reject,
     /* 302249 */ // Label 6027: @302249
     /* 302249 */ GIM_Reject,
     /* 302250 */ // Label 59: @302250
     /* 302250 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6050*/ GIMT_Encode4(304047),
     /* 302261 */ /*GILLT_s16*//*Label 6039*/ GIMT_Encode4(302345),
     /* 302265 */ /*GILLT_s32*//*Label 6040*/ GIMT_Encode4(302571),
     /* 302269 */ /*GILLT_s64*//*Label 6041*/ GIMT_Encode4(302925), GIMT_Encode4(0),
     /* 302277 */ /*GILLT_v2s32*//*Label 6042*/ GIMT_Encode4(303097),
     /* 302281 */ /*GILLT_v2s64*//*Label 6043*/ GIMT_Encode4(303135),
     /* 302285 */ /*GILLT_v4s16*//*Label 6044*/ GIMT_Encode4(303311),
     /* 302289 */ /*GILLT_v4s32*//*Label 6045*/ GIMT_Encode4(303349), GIMT_Encode4(0),
     /* 302297 */ /*GILLT_v8s16*//*Label 6046*/ GIMT_Encode4(303525), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 302321 */ /*GILLT_nxv2s64*//*Label 6047*/ GIMT_Encode4(303969), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 302333 */ /*GILLT_nxv4s32*//*Label 6048*/ GIMT_Encode4(303995), GIMT_Encode4(0),
     /* 302341 */ /*GILLT_nxv8s16*//*Label 6049*/ GIMT_Encode4(304021),
     /* 302345 */ // Label 6039: @302345
     /* 302345 */ GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(302570),
     /* 302350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 302353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 302356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302360 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(302451), // Rule ID 6969 //
     /* 302365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302386 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 302390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302402 */     // MIs[2] Rn
     /* 302402 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302407 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 302411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302413 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 302413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 302416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302425 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 302431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 302444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302449 */     GIR_RootConstrainSelectedInstOperands,
     /* 302450 */     // GIR_Coverage, 6969,
     /* 302450 */     GIR_EraseRootFromParent_Done,
     /* 302451 */   // Label 6052: @302451
     /* 302451 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(302542), // Rule ID 14016 //
     /* 302456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302477 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 302481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302493 */     // MIs[2] Rn
     /* 302493 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302498 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 302502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302504 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 302504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 302507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302516 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 302522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 302535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302540 */     GIR_RootConstrainSelectedInstOperands,
     /* 302541 */     // GIR_Coverage, 14016,
     /* 302541 */     GIR_EraseRootFromParent_Done,
     /* 302542 */   // Label 6053: @302542
     /* 302542 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(302569), // Rule ID 584 //
     /* 302547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 302550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 302558 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 302558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 302563 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302567 */     GIR_RootConstrainSelectedInstOperands,
     /* 302568 */     // GIR_Coverage, 584,
     /* 302568 */     GIR_Done,
     /* 302569 */   // Label 6054: @302569
     /* 302569 */   GIM_Reject,
     /* 302570 */ // Label 6051: @302570
     /* 302570 */ GIM_Reject,
     /* 302571 */ // Label 6040: @302571
     /* 302571 */ GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(302924),
     /* 302576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 302579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 302582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302586 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(302677), // Rule ID 6967 //
     /* 302591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302612 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 302616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302628 */     // MIs[2] Rn
     /* 302628 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302633 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 302637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302639 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 302639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 302642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302651 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 302657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 302670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302675 */     GIR_RootConstrainSelectedInstOperands,
     /* 302676 */     // GIR_Coverage, 6967,
     /* 302676 */     GIR_EraseRootFromParent_Done,
     /* 302677 */   // Label 6056: @302677
     /* 302677 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(302741), // Rule ID 13198 //
     /* 302682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302703 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 302707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302719 */     // MIs[2] Rn
     /* 302719 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302724 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 302728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302730 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 302730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 302733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302739 */     GIR_RootConstrainSelectedInstOperands,
     /* 302740 */     // GIR_Coverage, 13198,
     /* 302740 */     GIR_EraseRootFromParent_Done,
     /* 302741 */   // Label 6057: @302741
     /* 302741 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(302832), // Rule ID 14014 //
     /* 302746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302767 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 302771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302783 */     // MIs[2] Rn
     /* 302783 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302788 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 302792 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302794 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 302794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 302797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 302801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302806 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 302812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 302825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302830 */     GIR_RootConstrainSelectedInstOperands,
     /* 302831 */     // GIR_Coverage, 14014,
     /* 302831 */     GIR_EraseRootFromParent_Done,
     /* 302832 */   // Label 6058: @302832
     /* 302832 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(302896), // Rule ID 15841 //
     /* 302837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 302849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302858 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 302862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302874 */     // MIs[2] Rn
     /* 302874 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302879 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 302883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302885 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 302885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 302888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302894 */     GIR_RootConstrainSelectedInstOperands,
     /* 302895 */     // GIR_Coverage, 15841,
     /* 302895 */     GIR_EraseRootFromParent_Done,
     /* 302896 */   // Label 6059: @302896
     /* 302896 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(302923), // Rule ID 586 //
     /* 302901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 302904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 302912 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 302912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 302917 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 302921 */     GIR_RootConstrainSelectedInstOperands,
     /* 302922 */     // GIR_Coverage, 586,
     /* 302922 */     GIR_Done,
     /* 302923 */   // Label 6060: @302923
     /* 302923 */   GIM_Reject,
     /* 302924 */ // Label 6055: @302924
     /* 302924 */ GIM_Reject,
     /* 302925 */ // Label 6041: @302925
     /* 302925 */ GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(303096),
     /* 302930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 302933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 302936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302940 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(303004), // Rule ID 6965 //
     /* 302945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302966 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 302970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 302978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302982 */     // MIs[2] Rn
     /* 302982 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 302987 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 302991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302993 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 302993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 302996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 302998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303002 */     GIR_RootConstrainSelectedInstOperands,
     /* 303003 */     // GIR_Coverage, 6965,
     /* 303003 */     GIR_EraseRootFromParent_Done,
     /* 303004 */   // Label 6062: @303004
     /* 303004 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(303068), // Rule ID 14012 //
     /* 303009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303030 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 303034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303046 */     // MIs[2] Rn
     /* 303046 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303051 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303057 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 303057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 303060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303066 */     GIR_RootConstrainSelectedInstOperands,
     /* 303067 */     // GIR_Coverage, 14012,
     /* 303067 */     GIR_EraseRootFromParent_Done,
     /* 303068 */   // Label 6063: @303068
     /* 303068 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(303095), // Rule ID 588 //
     /* 303073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303084 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 303084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 303089 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303093 */     GIR_RootConstrainSelectedInstOperands,
     /* 303094 */     // GIR_Coverage, 588,
     /* 303094 */     GIR_Done,
     /* 303095 */   // Label 6064: @303095
     /* 303095 */   GIM_Reject,
     /* 303096 */ // Label 6061: @303096
     /* 303096 */ GIM_Reject,
     /* 303097 */ // Label 6042: @303097
     /* 303097 */ GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(303134), // Rule ID 1203 //
     /* 303102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 303111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303123 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 303123 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 303128 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303132 */   GIR_RootConstrainSelectedInstOperands,
     /* 303133 */   // GIR_Coverage, 1203,
     /* 303133 */   GIR_Done,
     /* 303134 */ // Label 6065: @303134
     /* 303134 */ GIM_Reject,
     /* 303135 */ // Label 6043: @303135
     /* 303135 */ GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(303310),
     /* 303140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 303146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303150 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(303216), // Rule ID 6987 //
     /* 303155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 303163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 303171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 303189 */     // MIs[2] Rn
     /* 303189 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303194 */     // MIs[2] Rm
     /* 303194 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 303199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303201 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 303201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 303204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303214 */     GIR_RootConstrainSelectedInstOperands,
     /* 303215 */     // GIR_Coverage, 6987,
     /* 303215 */     GIR_EraseRootFromParent_Done,
     /* 303216 */   // Label 6067: @303216
     /* 303216 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(303282), // Rule ID 14024 //
     /* 303221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 303229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 303237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 303255 */     // MIs[2] Rn
     /* 303255 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303260 */     // MIs[2] Rm
     /* 303260 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 303265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303267 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 303267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 303270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303280 */     GIR_RootConstrainSelectedInstOperands,
     /* 303281 */     // GIR_Coverage, 14024,
     /* 303281 */     GIR_EraseRootFromParent_Done,
     /* 303282 */   // Label 6068: @303282
     /* 303282 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(303309), // Rule ID 1207 //
     /* 303287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303298 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 303298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 303303 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303307 */     GIR_RootConstrainSelectedInstOperands,
     /* 303308 */     // GIR_Coverage, 1207,
     /* 303308 */     GIR_Done,
     /* 303309 */   // Label 6069: @303309
     /* 303309 */   GIM_Reject,
     /* 303310 */ // Label 6066: @303310
     /* 303310 */ GIM_Reject,
     /* 303311 */ // Label 6044: @303311
     /* 303311 */ GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(303348), // Rule ID 1199 //
     /* 303316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 303325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303337 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 303337 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 303342 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303346 */   GIR_RootConstrainSelectedInstOperands,
     /* 303347 */   // GIR_Coverage, 1199,
     /* 303347 */   GIR_Done,
     /* 303348 */ // Label 6070: @303348
     /* 303348 */ GIM_Reject,
     /* 303349 */ // Label 6045: @303349
     /* 303349 */ GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(303524),
     /* 303354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 303360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303364 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(303430), // Rule ID 6988 //
     /* 303369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 303377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 303385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 303403 */     // MIs[2] Rn
     /* 303403 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303408 */     // MIs[2] Rm
     /* 303408 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 303413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303415 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 303415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 303418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303428 */     GIR_RootConstrainSelectedInstOperands,
     /* 303429 */     // GIR_Coverage, 6988,
     /* 303429 */     GIR_EraseRootFromParent_Done,
     /* 303430 */   // Label 6072: @303430
     /* 303430 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(303496), // Rule ID 14025 //
     /* 303435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 303443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 303451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 303469 */     // MIs[2] Rn
     /* 303469 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303474 */     // MIs[2] Rm
     /* 303474 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 303479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303481 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 303481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 303484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303494 */     GIR_RootConstrainSelectedInstOperands,
     /* 303495 */     // GIR_Coverage, 14025,
     /* 303495 */     GIR_EraseRootFromParent_Done,
     /* 303496 */   // Label 6073: @303496
     /* 303496 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(303523), // Rule ID 1205 //
     /* 303501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303512 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 303512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 303517 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303521 */     GIR_RootConstrainSelectedInstOperands,
     /* 303522 */     // GIR_Coverage, 1205,
     /* 303522 */     GIR_Done,
     /* 303523 */   // Label 6074: @303523
     /* 303523 */   GIM_Reject,
     /* 303524 */ // Label 6071: @303524
     /* 303524 */ GIM_Reject,
     /* 303525 */ // Label 6046: @303525
     /* 303525 */ GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(303968),
     /* 303530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 303536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303540 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(303609), // Rule ID 6989 //
     /* 303545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 303556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 303564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 303582 */     // MIs[2] Rn
     /* 303582 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303587 */     // MIs[2] Rm
     /* 303587 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 303592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303594 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 303594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 303597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303607 */     GIR_RootConstrainSelectedInstOperands,
     /* 303608 */     // GIR_Coverage, 6989,
     /* 303608 */     GIR_EraseRootFromParent_Done,
     /* 303609 */   // Label 6076: @303609
     /* 303609 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(303678), // Rule ID 14026 //
     /* 303614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 303625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 303633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 303651 */     // MIs[2] Rn
     /* 303651 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303656 */     // MIs[2] Rm
     /* 303656 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 303661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303663 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 303663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 303666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303676 */     GIR_RootConstrainSelectedInstOperands,
     /* 303677 */     // GIR_Coverage, 14026,
     /* 303677 */     GIR_EraseRootFromParent_Done,
     /* 303678 */   // Label 6077: @303678
     /* 303678 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(303705), // Rule ID 1201 //
     /* 303683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303694 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 303694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 303699 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303703 */     GIR_RootConstrainSelectedInstOperands,
     /* 303704 */     // GIR_Coverage, 1201,
     /* 303704 */     GIR_Done,
     /* 303705 */   // Label 6078: @303705
     /* 303705 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(303967), // Rule ID 7058 //
     /* 303710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 303713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303721 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 303721 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 303724 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 303728 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303733 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 303737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 303739 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 303742 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 303746 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303751 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 303755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 303757 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 303760 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 303764 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303769 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 303772 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 303775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 303777 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 303780 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303784 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303789 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 303795 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303800 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303805 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 303808 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 303812 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303817 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 303820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 303822 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 303825 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303829 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303834 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303840 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303845 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303850 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 303853 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 303857 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303862 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 303865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 303867 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 303870 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 303874 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303879 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 303882 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 303885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 303887 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 303890 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 303894 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303899 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 303902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 303904 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 303907 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 303911 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 303918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 303921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 303925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303930 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 303933 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 303936 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 303939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 303957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 303965 */     GIR_RootConstrainSelectedInstOperands,
     /* 303966 */     // GIR_Coverage, 7058,
     /* 303966 */     GIR_EraseRootFromParent_Done,
     /* 303967 */   // Label 6079: @303967
     /* 303967 */   GIM_Reject,
     /* 303968 */ // Label 6075: @303968
     /* 303968 */ GIM_Reject,
     /* 303969 */ // Label 6047: @303969
     /* 303969 */ GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(303994), // Rule ID 2824 //
     /* 303974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 303977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 303980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 303983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 303987 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 303987 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 303992 */   GIR_RootConstrainSelectedInstOperands,
     /* 303993 */   // GIR_Coverage, 2824,
     /* 303993 */   GIR_Done,
     /* 303994 */ // Label 6080: @303994
     /* 303994 */ GIM_Reject,
     /* 303995 */ // Label 6048: @303995
     /* 303995 */ GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(304020), // Rule ID 2822 //
     /* 304000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 304006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 304009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304013 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 304013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 304018 */   GIR_RootConstrainSelectedInstOperands,
     /* 304019 */   // GIR_Coverage, 2822,
     /* 304019 */   GIR_Done,
     /* 304020 */ // Label 6081: @304020
     /* 304020 */ GIM_Reject,
     /* 304021 */ // Label 6049: @304021
     /* 304021 */ GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(304046), // Rule ID 2820 //
     /* 304026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 304032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 304035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304039 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 304039 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 304044 */   GIR_RootConstrainSelectedInstOperands,
     /* 304045 */   // GIR_Coverage, 2820,
     /* 304045 */   GIR_Done,
     /* 304046 */ // Label 6082: @304046
     /* 304046 */ GIM_Reject,
     /* 304047 */ // Label 6050: @304047
     /* 304047 */ GIM_Reject,
     /* 304048 */ // Label 60: @304048
     /* 304048 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6094*/ GIMT_Encode4(304785),
     /* 304059 */ /*GILLT_s16*//*Label 6083*/ GIMT_Encode4(304143),
     /* 304063 */ /*GILLT_s32*//*Label 6084*/ GIMT_Encode4(304181),
     /* 304067 */ /*GILLT_s64*//*Label 6085*/ GIMT_Encode4(304219), GIMT_Encode4(0),
     /* 304075 */ /*GILLT_v2s32*//*Label 6086*/ GIMT_Encode4(304257),
     /* 304079 */ /*GILLT_v2s64*//*Label 6087*/ GIMT_Encode4(304295),
     /* 304083 */ /*GILLT_v4s16*//*Label 6088*/ GIMT_Encode4(304333),
     /* 304087 */ /*GILLT_v4s32*//*Label 6089*/ GIMT_Encode4(304371), GIMT_Encode4(0),
     /* 304095 */ /*GILLT_v8s16*//*Label 6090*/ GIMT_Encode4(304409), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 304119 */ /*GILLT_nxv2s64*//*Label 6091*/ GIMT_Encode4(304707), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 304131 */ /*GILLT_nxv4s32*//*Label 6092*/ GIMT_Encode4(304733), GIMT_Encode4(0),
     /* 304139 */ /*GILLT_nxv8s16*//*Label 6093*/ GIMT_Encode4(304759),
     /* 304143 */ // Label 6083: @304143
     /* 304143 */ GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(304180), // Rule ID 632 //
     /* 304148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 304157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304169 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 304169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 304174 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304178 */   GIR_RootConstrainSelectedInstOperands,
     /* 304179 */   // GIR_Coverage, 632,
     /* 304179 */   GIR_Done,
     /* 304180 */ // Label 6095: @304180
     /* 304180 */ GIM_Reject,
     /* 304181 */ // Label 6084: @304181
     /* 304181 */ GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(304218), // Rule ID 634 //
     /* 304186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 304195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304207 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 304207 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 304212 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304216 */   GIR_RootConstrainSelectedInstOperands,
     /* 304217 */   // GIR_Coverage, 634,
     /* 304217 */   GIR_Done,
     /* 304218 */ // Label 6096: @304218
     /* 304218 */ GIM_Reject,
     /* 304219 */ // Label 6085: @304219
     /* 304219 */ GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(304256), // Rule ID 636 //
     /* 304224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 304233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304241 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304245 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 304245 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 304250 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304254 */   GIR_RootConstrainSelectedInstOperands,
     /* 304255 */   // GIR_Coverage, 636,
     /* 304255 */   GIR_Done,
     /* 304256 */ // Label 6097: @304256
     /* 304256 */ GIM_Reject,
     /* 304257 */ // Label 6086: @304257
     /* 304257 */ GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(304294), // Rule ID 1343 //
     /* 304262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 304268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 304271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304283 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 304283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 304288 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304292 */   GIR_RootConstrainSelectedInstOperands,
     /* 304293 */   // GIR_Coverage, 1343,
     /* 304293 */   GIR_Done,
     /* 304294 */ // Label 6098: @304294
     /* 304294 */ GIM_Reject,
     /* 304295 */ // Label 6087: @304295
     /* 304295 */ GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(304332), // Rule ID 1347 //
     /* 304300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 304306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 304309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304321 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 304321 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 304326 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304330 */   GIR_RootConstrainSelectedInstOperands,
     /* 304331 */   // GIR_Coverage, 1347,
     /* 304331 */   GIR_Done,
     /* 304332 */ // Label 6099: @304332
     /* 304332 */ GIM_Reject,
     /* 304333 */ // Label 6088: @304333
     /* 304333 */ GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(304370), // Rule ID 1339 //
     /* 304338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 304347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304359 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 304359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 304364 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304368 */   GIR_RootConstrainSelectedInstOperands,
     /* 304369 */   // GIR_Coverage, 1339,
     /* 304369 */   GIR_Done,
     /* 304370 */ // Label 6100: @304370
     /* 304370 */ GIM_Reject,
     /* 304371 */ // Label 6089: @304371
     /* 304371 */ GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(304408), // Rule ID 1345 //
     /* 304376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 304385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304397 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 304397 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 304402 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304406 */   GIR_RootConstrainSelectedInstOperands,
     /* 304407 */   // GIR_Coverage, 1345,
     /* 304407 */   GIR_Done,
     /* 304408 */ // Label 6101: @304408
     /* 304408 */ GIM_Reject,
     /* 304409 */ // Label 6090: @304409
     /* 304409 */ GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(304706),
     /* 304414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 304420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304432 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(304451), // Rule ID 1341 //
     /* 304437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304440 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 304440 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 304445 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304449 */     GIR_RootConstrainSelectedInstOperands,
     /* 304450 */     // GIR_Coverage, 1341,
     /* 304450 */     GIR_Done,
     /* 304451 */   // Label 6103: @304451
     /* 304451 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(304705), // Rule ID 7064 //
     /* 304456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 304459 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 304459 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 304462 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 304466 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304471 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 304475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 304477 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 304480 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 304484 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304489 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 304493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 304495 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 304498 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 304502 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304507 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 304510 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 304513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 304515 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 304518 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304522 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304527 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 304533 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304538 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304543 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 304546 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 304550 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304555 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 304558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 304560 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 304563 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304567 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304572 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 304578 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304583 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304588 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 304591 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 304595 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304600 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 304603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 304605 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 304608 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 304612 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304617 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 304620 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 304623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304625 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 304628 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 304632 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304637 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 304640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 304642 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304645 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304649 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304668 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 304671 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 304674 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 304695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 304703 */     GIR_RootConstrainSelectedInstOperands,
     /* 304704 */     // GIR_Coverage, 7064,
     /* 304704 */     GIR_EraseRootFromParent_Done,
     /* 304705 */   // Label 6104: @304705
     /* 304705 */   GIM_Reject,
     /* 304706 */ // Label 6102: @304706
     /* 304706 */ GIM_Reject,
     /* 304707 */ // Label 6091: @304707
     /* 304707 */ GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(304732), // Rule ID 8264 //
     /* 304712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 304718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 304721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304725 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 304725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 304730 */   GIR_RootConstrainSelectedInstOperands,
     /* 304731 */   // GIR_Coverage, 8264,
     /* 304731 */   GIR_Done,
     /* 304732 */ // Label 6105: @304732
     /* 304732 */ GIM_Reject,
     /* 304733 */ // Label 6092: @304733
     /* 304733 */ GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(304758), // Rule ID 8262 //
     /* 304738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 304744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 304747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304751 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 304751 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 304756 */   GIR_RootConstrainSelectedInstOperands,
     /* 304757 */   // GIR_Coverage, 8262,
     /* 304757 */   GIR_Done,
     /* 304758 */ // Label 6106: @304758
     /* 304758 */ GIM_Reject,
     /* 304759 */ // Label 6093: @304759
     /* 304759 */ GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(304784), // Rule ID 8260 //
     /* 304764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 304770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 304773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304777 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 304777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 304782 */   GIR_RootConstrainSelectedInstOperands,
     /* 304783 */   // GIR_Coverage, 8260,
     /* 304783 */   GIR_Done,
     /* 304784 */ // Label 6107: @304784
     /* 304784 */ GIM_Reject,
     /* 304785 */ // Label 6094: @304785
     /* 304785 */ GIM_Reject,
     /* 304786 */ // Label 61: @304786
     /* 304786 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6119*/ GIMT_Encode4(308881),
     /* 304797 */ /*GILLT_s16*//*Label 6108*/ GIMT_Encode4(304881),
     /* 304801 */ /*GILLT_s32*//*Label 6109*/ GIMT_Encode4(305523),
     /* 304805 */ /*GILLT_s64*//*Label 6110*/ GIMT_Encode4(306153), GIMT_Encode4(0),
     /* 304813 */ /*GILLT_v2s32*//*Label 6111*/ GIMT_Encode4(306783),
     /* 304817 */ /*GILLT_v2s64*//*Label 6112*/ GIMT_Encode4(307313),
     /* 304821 */ /*GILLT_v4s16*//*Label 6113*/ GIMT_Encode4(307671),
     /* 304825 */ /*GILLT_v4s32*//*Label 6114*/ GIMT_Encode4(308013), GIMT_Encode4(0),
     /* 304833 */ /*GILLT_v8s16*//*Label 6115*/ GIMT_Encode4(308371), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 304857 */ /*GILLT_nxv2s64*//*Label 6116*/ GIMT_Encode4(308803), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 304869 */ /*GILLT_nxv4s32*//*Label 6117*/ GIMT_Encode4(308829), GIMT_Encode4(0),
     /* 304877 */ /*GILLT_nxv8s16*//*Label 6118*/ GIMT_Encode4(308855),
     /* 304881 */ // Label 6108: @304881
     /* 304881 */ GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(305522),
     /* 304886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 304892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304896 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(305009), // Rule ID 6297 //
     /* 304901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304925 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 304929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 304937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304945 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 304954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304958 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 304962 */     // MIs[3] Operand 1
     /* 304962 */     // No operand predicates
     /* 304962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304964 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 304964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 304967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304976 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 304982 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 304995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305007 */     GIR_RootConstrainSelectedInstOperands,
     /* 305008 */     // GIR_Coverage, 6297,
     /* 305008 */     GIR_EraseRootFromParent_Done,
     /* 305009 */   // Label 6121: @305009
     /* 305009 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(305122), // Rule ID 13993 //
     /* 305014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305046 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305050 */     // MIs[2] Operand 1
     /* 305050 */     // No operand predicates
     /* 305050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 305054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305058 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305062 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 305066 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305071 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 305075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305077 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305089 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 305095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 305108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305120 */     GIR_RootConstrainSelectedInstOperands,
     /* 305121 */     // GIR_Coverage, 13993,
     /* 305121 */     GIR_EraseRootFromParent_Done,
     /* 305122 */   // Label 6122: @305122
     /* 305122 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(305201), // Rule ID 13927 //
     /* 305127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 305130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305151 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305161 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 305161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305173 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 305179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 305192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305199 */     GIR_RootConstrainSelectedInstOperands,
     /* 305200 */     // GIR_Coverage, 13927,
     /* 305200 */     GIR_EraseRootFromParent_Done,
     /* 305201 */   // Label 6123: @305201
     /* 305201 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(305280), // Rule ID 4839 //
     /* 305206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 305209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305234 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305240 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 305240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305252 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 305258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 305271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305278 */     GIR_RootConstrainSelectedInstOperands,
     /* 305279 */     // GIR_Coverage, 4839,
     /* 305279 */     GIR_EraseRootFromParent_Done,
     /* 305280 */   // Label 6124: @305280
     /* 305280 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(305343), // Rule ID 13542 //
     /* 305285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305317 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305321 */     // MIs[2] Operand 1
     /* 305321 */     // No operand predicates
     /* 305321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305327 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 305330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305341 */     GIR_RootConstrainSelectedInstOperands,
     /* 305342 */     // GIR_Coverage, 13542,
     /* 305342 */     GIR_EraseRootFromParent_Done,
     /* 305343 */   // Label 6125: @305343
     /* 305343 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(305406), // Rule ID 2012 //
     /* 305348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305388 */     // MIs[2] Operand 1
     /* 305388 */     // No operand predicates
     /* 305388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305390 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 305393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305404 */     GIR_RootConstrainSelectedInstOperands,
     /* 305405 */     // GIR_Coverage, 2012,
     /* 305405 */     GIR_EraseRootFromParent_Done,
     /* 305406 */   // Label 6126: @305406
     /* 305406 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(305450), // Rule ID 4844 //
     /* 305411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 305414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305437 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 305437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 305440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 305446 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 305448 */     GIR_RootConstrainSelectedInstOperands,
     /* 305449 */     // GIR_Coverage, 4844,
     /* 305449 */     GIR_EraseRootFromParent_Done,
     /* 305450 */   // Label 6127: @305450
     /* 305450 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(305494), // Rule ID 13932 //
     /* 305455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 305458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305481 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 305481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 305484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 305490 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 305492 */     GIR_RootConstrainSelectedInstOperands,
     /* 305493 */     // GIR_Coverage, 13932,
     /* 305493 */     GIR_EraseRootFromParent_Done,
     /* 305494 */   // Label 6128: @305494
     /* 305494 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(305521), // Rule ID 620 //
     /* 305499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 305502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305510 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 305510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 305515 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305519 */     GIR_RootConstrainSelectedInstOperands,
     /* 305520 */     // GIR_Coverage, 620,
     /* 305520 */     GIR_Done,
     /* 305521 */   // Label 6129: @305521
     /* 305521 */   GIM_Reject,
     /* 305522 */ // Label 6120: @305522
     /* 305522 */ GIM_Reject,
     /* 305523 */ // Label 6109: @305523
     /* 305523 */ GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(306152),
     /* 305528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 305531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 305534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305538 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(305651), // Rule ID 6299 //
     /* 305543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305567 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305583 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305600 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 305604 */     // MIs[3] Operand 1
     /* 305604 */     // No operand predicates
     /* 305604 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305606 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 305606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 305609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305618 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 305624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 305637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305649 */     GIR_RootConstrainSelectedInstOperands,
     /* 305650 */     // GIR_Coverage, 6299,
     /* 305650 */     GIR_EraseRootFromParent_Done,
     /* 305651 */   // Label 6131: @305651
     /* 305651 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(305764), // Rule ID 13995 //
     /* 305656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305688 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 305692 */     // MIs[2] Operand 1
     /* 305692 */     // No operand predicates
     /* 305692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 305696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305700 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305704 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 305708 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305713 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 305717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305719 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 305719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 305722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305731 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 305737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 305750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305762 */     GIR_RootConstrainSelectedInstOperands,
     /* 305763 */     // GIR_Coverage, 13995,
     /* 305763 */     GIR_EraseRootFromParent_Done,
     /* 305764 */   // Label 6132: @305764
     /* 305764 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(305840), // Rule ID 13929 //
     /* 305769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305790 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305800 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 305800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 305803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305812 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 305818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 305831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305838 */     GIR_RootConstrainSelectedInstOperands,
     /* 305839 */     // GIR_Coverage, 13929,
     /* 305839 */     GIR_EraseRootFromParent_Done,
     /* 305840 */   // Label 6133: @305840
     /* 305840 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(305916), // Rule ID 4841 //
     /* 305845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305870 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305876 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 305876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 305879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305888 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 305894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 305907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305914 */     GIR_RootConstrainSelectedInstOperands,
     /* 305915 */     // GIR_Coverage, 4841,
     /* 305915 */     GIR_EraseRootFromParent_Done,
     /* 305916 */   // Label 6134: @305916
     /* 305916 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(305979), // Rule ID 13544 //
     /* 305921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305953 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 305957 */     // MIs[2] Operand 1
     /* 305957 */     // No operand predicates
     /* 305957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305963 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 305963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 305966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305977 */     GIR_RootConstrainSelectedInstOperands,
     /* 305978 */     // GIR_Coverage, 13544,
     /* 305978 */     GIR_EraseRootFromParent_Done,
     /* 305979 */   // Label 6135: @305979
     /* 305979 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(306042), // Rule ID 2014 //
     /* 305984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306020 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306024 */     // MIs[2] Operand 1
     /* 306024 */     // No operand predicates
     /* 306024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306026 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 306029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306040 */     GIR_RootConstrainSelectedInstOperands,
     /* 306041 */     // GIR_Coverage, 2014,
     /* 306041 */     GIR_EraseRootFromParent_Done,
     /* 306042 */   // Label 6136: @306042
     /* 306042 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(306083), // Rule ID 4845 //
     /* 306047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306070 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 306070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 306073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306079 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 306081 */     GIR_RootConstrainSelectedInstOperands,
     /* 306082 */     // GIR_Coverage, 4845,
     /* 306082 */     GIR_EraseRootFromParent_Done,
     /* 306083 */   // Label 6137: @306083
     /* 306083 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(306124), // Rule ID 13933 //
     /* 306088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306111 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 306111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 306114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306120 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 306122 */     GIR_RootConstrainSelectedInstOperands,
     /* 306123 */     // GIR_Coverage, 13933,
     /* 306123 */     GIR_EraseRootFromParent_Done,
     /* 306124 */   // Label 6138: @306124
     /* 306124 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(306151), // Rule ID 622 //
     /* 306129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306140 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 306140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 306145 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306149 */     GIR_RootConstrainSelectedInstOperands,
     /* 306150 */     // GIR_Coverage, 622,
     /* 306150 */     GIR_Done,
     /* 306151 */   // Label 6139: @306151
     /* 306151 */   GIM_Reject,
     /* 306152 */ // Label 6130: @306152
     /* 306152 */ GIM_Reject,
     /* 306153 */ // Label 6110: @306153
     /* 306153 */ GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(306782),
     /* 306158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 306164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306168 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(306281), // Rule ID 6301 //
     /* 306173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306197 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 306205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306230 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 306234 */     // MIs[3] Operand 1
     /* 306234 */     // No operand predicates
     /* 306234 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306236 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 306236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 306239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306248 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 306254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 306267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306279 */     GIR_RootConstrainSelectedInstOperands,
     /* 306280 */     // GIR_Coverage, 6301,
     /* 306280 */     GIR_EraseRootFromParent_Done,
     /* 306281 */   // Label 6141: @306281
     /* 306281 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(306394), // Rule ID 13997 //
     /* 306286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306318 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 306322 */     // MIs[2] Operand 1
     /* 306322 */     // No operand predicates
     /* 306322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 306326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306330 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306334 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 306338 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306343 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 306347 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306349 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 306349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 306352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306361 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 306367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 306380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306392 */     GIR_RootConstrainSelectedInstOperands,
     /* 306393 */     // GIR_Coverage, 13997,
     /* 306393 */     GIR_EraseRootFromParent_Done,
     /* 306394 */   // Label 6142: @306394
     /* 306394 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(306470), // Rule ID 13931 //
     /* 306399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306420 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306430 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 306430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 306433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306442 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 306448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 306461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306468 */     GIR_RootConstrainSelectedInstOperands,
     /* 306469 */     // GIR_Coverage, 13931,
     /* 306469 */     GIR_EraseRootFromParent_Done,
     /* 306470 */   // Label 6143: @306470
     /* 306470 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(306546), // Rule ID 4843 //
     /* 306475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306500 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306506 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 306506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 306509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306518 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 306524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 306537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306544 */     GIR_RootConstrainSelectedInstOperands,
     /* 306545 */     // GIR_Coverage, 4843,
     /* 306545 */     GIR_EraseRootFromParent_Done,
     /* 306546 */   // Label 6144: @306546
     /* 306546 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(306609), // Rule ID 13546 //
     /* 306551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306583 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 306587 */     // MIs[2] Operand 1
     /* 306587 */     // No operand predicates
     /* 306587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306593 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 306596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306607 */     GIR_RootConstrainSelectedInstOperands,
     /* 306608 */     // GIR_Coverage, 13546,
     /* 306608 */     GIR_EraseRootFromParent_Done,
     /* 306609 */   // Label 6145: @306609
     /* 306609 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(306672), // Rule ID 2016 //
     /* 306614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306650 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 306654 */     // MIs[2] Operand 1
     /* 306654 */     // No operand predicates
     /* 306654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306656 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 306659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306670 */     GIR_RootConstrainSelectedInstOperands,
     /* 306671 */     // GIR_Coverage, 2016,
     /* 306671 */     GIR_EraseRootFromParent_Done,
     /* 306672 */   // Label 6146: @306672
     /* 306672 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(306713), // Rule ID 4846 //
     /* 306677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 306689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306700 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 306700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 306703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306709 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 306711 */     GIR_RootConstrainSelectedInstOperands,
     /* 306712 */     // GIR_Coverage, 4846,
     /* 306712 */     GIR_EraseRootFromParent_Done,
     /* 306713 */   // Label 6147: @306713
     /* 306713 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(306754), // Rule ID 13934 //
     /* 306718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 306734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306741 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 306741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 306744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306750 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 306752 */     GIR_RootConstrainSelectedInstOperands,
     /* 306753 */     // GIR_Coverage, 13934,
     /* 306753 */     GIR_EraseRootFromParent_Done,
     /* 306754 */   // Label 6148: @306754
     /* 306754 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(306781), // Rule ID 624 //
     /* 306759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306770 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 306770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 306775 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306779 */     GIR_RootConstrainSelectedInstOperands,
     /* 306780 */     // GIR_Coverage, 624,
     /* 306780 */     GIR_Done,
     /* 306781 */   // Label 6149: @306781
     /* 306781 */   GIM_Reject,
     /* 306782 */ // Label 6140: @306782
     /* 306782 */ GIM_Reject,
     /* 306783 */ // Label 6111: @306783
     /* 306783 */ GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(307312),
     /* 306788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 306791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 306794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306798 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(306884), // Rule ID 13535 //
     /* 306803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 306814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306830 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306847 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306851 */     // MIs[3] Operand 1
     /* 306851 */     // No operand predicates
     /* 306851 */     // MIs[1] Operand 2
     /* 306851 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 306862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306866 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306868 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306882 */     GIR_RootConstrainSelectedInstOperands,
     /* 306883 */     // GIR_Coverage, 13535,
     /* 306883 */     GIR_EraseRootFromParent_Done,
     /* 306884 */   // Label 6151: @306884
     /* 306884 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(306970), // Rule ID 2005 //
     /* 306889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 306904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306937 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306941 */     // MIs[3] Operand 1
     /* 306941 */     // No operand predicates
     /* 306941 */     // MIs[1] Operand 2
     /* 306941 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 306952 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306954 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 306957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306968 */     GIR_RootConstrainSelectedInstOperands,
     /* 306969 */     // GIR_Coverage, 2005,
     /* 306969 */     GIR_EraseRootFromParent_Done,
     /* 306970 */   // Label 6152: @306970
     /* 306970 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(307033), // Rule ID 13536 //
     /* 306975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 306986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307007 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307011 */     // MIs[2] Operand 1
     /* 307011 */     // No operand predicates
     /* 307011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307017 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307031 */     GIR_RootConstrainSelectedInstOperands,
     /* 307032 */     // GIR_Coverage, 13536,
     /* 307032 */     GIR_EraseRootFromParent_Done,
     /* 307033 */   // Label 6153: @307033
     /* 307033 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(307096), // Rule ID 2006 //
     /* 307038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307074 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307078 */     // MIs[2] Operand 1
     /* 307078 */     // No operand predicates
     /* 307078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307080 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307094 */     GIR_RootConstrainSelectedInstOperands,
     /* 307095 */     // GIR_Coverage, 2006,
     /* 307095 */     GIR_EraseRootFromParent_Done,
     /* 307096 */   // Label 6154: @307096
     /* 307096 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(307190), // Rule ID 13999 //
     /* 307101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307124 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307124 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 307127 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307131 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 307141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307150 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307153 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307157 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307188 */     GIR_RootConstrainSelectedInstOperands,
     /* 307189 */     // GIR_Coverage, 13999,
     /* 307189 */     GIR_EraseRootFromParent_Done,
     /* 307190 */   // Label 6155: @307190
     /* 307190 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(307284), // Rule ID 6303 //
     /* 307195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307218 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307218 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 307221 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307225 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 307235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307244 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307247 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307251 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307282 */     GIR_RootConstrainSelectedInstOperands,
     /* 307283 */     // GIR_Coverage, 6303,
     /* 307283 */     GIR_EraseRootFromParent_Done,
     /* 307284 */   // Label 6156: @307284
     /* 307284 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(307311), // Rule ID 1323 //
     /* 307289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307300 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 307300 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 307305 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307309 */     GIR_RootConstrainSelectedInstOperands,
     /* 307310 */     // GIR_Coverage, 1323,
     /* 307310 */     GIR_Done,
     /* 307311 */   // Label 6157: @307311
     /* 307311 */   GIM_Reject,
     /* 307312 */ // Label 6150: @307312
     /* 307312 */ GIM_Reject,
     /* 307313 */ // Label 6112: @307313
     /* 307313 */ GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(307670),
     /* 307318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 307324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307328 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(307391), // Rule ID 13540 //
     /* 307333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 307344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307365 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307369 */     // MIs[2] Operand 1
     /* 307369 */     // No operand predicates
     /* 307369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307375 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 307378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307389 */     GIR_RootConstrainSelectedInstOperands,
     /* 307390 */     // GIR_Coverage, 13540,
     /* 307390 */     GIR_EraseRootFromParent_Done,
     /* 307391 */   // Label 6159: @307391
     /* 307391 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(307454), // Rule ID 2010 //
     /* 307396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 307411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307432 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307436 */     // MIs[2] Operand 1
     /* 307436 */     // No operand predicates
     /* 307436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307438 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 307441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307452 */     GIR_RootConstrainSelectedInstOperands,
     /* 307453 */     // GIR_Coverage, 2010,
     /* 307453 */     GIR_EraseRootFromParent_Done,
     /* 307454 */   // Label 6160: @307454
     /* 307454 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(307548), // Rule ID 14003 //
     /* 307459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307482 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307482 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 307485 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307489 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 307499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307508 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307515 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 307518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307528 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 307536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307546 */     GIR_RootConstrainSelectedInstOperands,
     /* 307547 */     // GIR_Coverage, 14003,
     /* 307547 */     GIR_EraseRootFromParent_Done,
     /* 307548 */   // Label 6161: @307548
     /* 307548 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(307642), // Rule ID 6307 //
     /* 307553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307576 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307576 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 307579 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307583 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 307593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307602 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307605 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307609 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 307612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 307630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307640 */     GIR_RootConstrainSelectedInstOperands,
     /* 307641 */     // GIR_Coverage, 6307,
     /* 307641 */     GIR_EraseRootFromParent_Done,
     /* 307642 */   // Label 6162: @307642
     /* 307642 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(307669), // Rule ID 1327 //
     /* 307647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307658 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 307658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 307663 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307667 */     GIR_RootConstrainSelectedInstOperands,
     /* 307668 */     // GIR_Coverage, 1327,
     /* 307668 */     GIR_Done,
     /* 307669 */   // Label 6163: @307669
     /* 307669 */   GIM_Reject,
     /* 307670 */ // Label 6158: @307670
     /* 307670 */ GIM_Reject,
     /* 307671 */ // Label 6113: @307671
     /* 307671 */ GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(308012),
     /* 307676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 307679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 307682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307686 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(307772), // Rule ID 13529 //
     /* 307691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 307702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307735 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307739 */     // MIs[3] Operand 1
     /* 307739 */     // No operand predicates
     /* 307739 */     // MIs[1] Operand 2
     /* 307739 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 307750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307756 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 307759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307770 */     GIR_RootConstrainSelectedInstOperands,
     /* 307771 */     // GIR_Coverage, 13529,
     /* 307771 */     GIR_EraseRootFromParent_Done,
     /* 307772 */   // Label 6165: @307772
     /* 307772 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(307858), // Rule ID 1999 //
     /* 307777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 307792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307825 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307829 */     // MIs[3] Operand 1
     /* 307829 */     // No operand predicates
     /* 307829 */     // MIs[1] Operand 2
     /* 307829 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 307840 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307842 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 307845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307856 */     GIR_RootConstrainSelectedInstOperands,
     /* 307857 */     // GIR_Coverage, 1999,
     /* 307857 */     GIR_EraseRootFromParent_Done,
     /* 307858 */   // Label 6166: @307858
     /* 307858 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(307921), // Rule ID 13530 //
     /* 307863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307895 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307899 */     // MIs[2] Operand 1
     /* 307899 */     // No operand predicates
     /* 307899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307905 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 307908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307919 */     GIR_RootConstrainSelectedInstOperands,
     /* 307920 */     // GIR_Coverage, 13530,
     /* 307920 */     GIR_EraseRootFromParent_Done,
     /* 307921 */   // Label 6167: @307921
     /* 307921 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(307984), // Rule ID 2000 //
     /* 307926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 307941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 307954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307962 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 307966 */     // MIs[2] Operand 1
     /* 307966 */     // No operand predicates
     /* 307966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307968 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 307971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307982 */     GIR_RootConstrainSelectedInstOperands,
     /* 307983 */     // GIR_Coverage, 2000,
     /* 307983 */     GIR_EraseRootFromParent_Done,
     /* 307984 */   // Label 6168: @307984
     /* 307984 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(308011), // Rule ID 1319 //
     /* 307989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 307992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308000 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 308000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 308005 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308009 */     GIR_RootConstrainSelectedInstOperands,
     /* 308010 */     // GIR_Coverage, 1319,
     /* 308010 */     GIR_Done,
     /* 308011 */   // Label 6169: @308011
     /* 308011 */   GIM_Reject,
     /* 308012 */ // Label 6164: @308012
     /* 308012 */ GIM_Reject,
     /* 308013 */ // Label 6114: @308013
     /* 308013 */ GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(308370),
     /* 308018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 308024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308028 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(308091), // Rule ID 13538 //
     /* 308033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 308044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308065 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 308069 */     // MIs[2] Operand 1
     /* 308069 */     // No operand predicates
     /* 308069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308075 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 308078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308089 */     GIR_RootConstrainSelectedInstOperands,
     /* 308090 */     // GIR_Coverage, 13538,
     /* 308090 */     GIR_EraseRootFromParent_Done,
     /* 308091 */   // Label 6171: @308091
     /* 308091 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(308154), // Rule ID 2008 //
     /* 308096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 308111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308132 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 308136 */     // MIs[2] Operand 1
     /* 308136 */     // No operand predicates
     /* 308136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308138 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 308141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308152 */     GIR_RootConstrainSelectedInstOperands,
     /* 308153 */     // GIR_Coverage, 2008,
     /* 308153 */     GIR_EraseRootFromParent_Done,
     /* 308154 */   // Label 6172: @308154
     /* 308154 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(308248), // Rule ID 14001 //
     /* 308159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308182 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308182 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308185 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308189 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308208 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308211 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308215 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 308236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308246 */     GIR_RootConstrainSelectedInstOperands,
     /* 308247 */     // GIR_Coverage, 14001,
     /* 308247 */     GIR_EraseRootFromParent_Done,
     /* 308248 */   // Label 6173: @308248
     /* 308248 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(308342), // Rule ID 6305 //
     /* 308253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308276 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308276 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308279 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308283 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308302 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308305 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308309 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 308330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308340 */     GIR_RootConstrainSelectedInstOperands,
     /* 308341 */     // GIR_Coverage, 6305,
     /* 308341 */     GIR_EraseRootFromParent_Done,
     /* 308342 */   // Label 6174: @308342
     /* 308342 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(308369), // Rule ID 1325 //
     /* 308347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308358 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 308358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 308363 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308367 */     GIR_RootConstrainSelectedInstOperands,
     /* 308368 */     // GIR_Coverage, 1325,
     /* 308368 */     GIR_Done,
     /* 308369 */   // Label 6175: @308369
     /* 308369 */   GIM_Reject,
     /* 308370 */ // Label 6170: @308370
     /* 308370 */ GIM_Reject,
     /* 308371 */ // Label 6115: @308371
     /* 308371 */ GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(308802),
     /* 308376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 308382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308386 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(308449), // Rule ID 13532 //
     /* 308391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308423 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308427 */     // MIs[2] Operand 1
     /* 308427 */     // No operand predicates
     /* 308427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308433 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 308436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308447 */     GIR_RootConstrainSelectedInstOperands,
     /* 308448 */     // GIR_Coverage, 13532,
     /* 308448 */     GIR_EraseRootFromParent_Done,
     /* 308449 */   // Label 6177: @308449
     /* 308449 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(308512), // Rule ID 2002 //
     /* 308454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308490 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308494 */     // MIs[2] Operand 1
     /* 308494 */     // No operand predicates
     /* 308494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308496 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 308499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308501 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308510 */     GIR_RootConstrainSelectedInstOperands,
     /* 308511 */     // GIR_Coverage, 2002,
     /* 308511 */     GIR_EraseRootFromParent_Done,
     /* 308512 */   // Label 6178: @308512
     /* 308512 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(308539), // Rule ID 1321 //
     /* 308517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308528 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 308528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 308533 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308537 */     GIR_RootConstrainSelectedInstOperands,
     /* 308538 */     // GIR_Coverage, 1321,
     /* 308538 */     GIR_Done,
     /* 308539 */   // Label 6179: @308539
     /* 308539 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(308801), // Rule ID 7062 //
     /* 308544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 308547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308555 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 308555 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 308558 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 308562 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308567 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 308571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 308573 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 308576 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 308580 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308585 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 308589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 308591 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 308594 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 308598 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308603 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 308606 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 308609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 308611 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 308614 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308618 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308623 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 308629 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308634 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308639 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 308642 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 308646 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308651 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 308654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 308656 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 308659 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308663 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308668 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 308674 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308679 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308684 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 308687 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 308691 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308696 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 308699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 308701 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 308704 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 308708 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308713 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 308716 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 308719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 308721 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 308724 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 308728 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308733 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 308736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 308738 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 308741 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308745 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 308755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308764 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 308770 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 308773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 308791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 308799 */     GIR_RootConstrainSelectedInstOperands,
     /* 308800 */     // GIR_Coverage, 7062,
     /* 308800 */     GIR_EraseRootFromParent_Done,
     /* 308801 */   // Label 6180: @308801
     /* 308801 */   GIM_Reject,
     /* 308802 */ // Label 6176: @308802
     /* 308802 */ GIM_Reject,
     /* 308803 */ // Label 6116: @308803
     /* 308803 */ GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(308828), // Rule ID 8270 //
     /* 308808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 308811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 308814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 308817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 308821 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 308821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 308826 */   GIR_RootConstrainSelectedInstOperands,
     /* 308827 */   // GIR_Coverage, 8270,
     /* 308827 */   GIR_Done,
     /* 308828 */ // Label 6181: @308828
     /* 308828 */ GIM_Reject,
     /* 308829 */ // Label 6117: @308829
     /* 308829 */ GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(308854), // Rule ID 8268 //
     /* 308834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 308837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 308840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 308843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 308847 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 308847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 308852 */   GIR_RootConstrainSelectedInstOperands,
     /* 308853 */   // GIR_Coverage, 8268,
     /* 308853 */   GIR_Done,
     /* 308854 */ // Label 6182: @308854
     /* 308854 */ GIM_Reject,
     /* 308855 */ // Label 6118: @308855
     /* 308855 */ GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(308880), // Rule ID 8266 //
     /* 308860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 308863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 308866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 308869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 308873 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 308873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 308878 */   GIR_RootConstrainSelectedInstOperands,
     /* 308879 */   // GIR_Coverage, 8266,
     /* 308879 */   GIR_Done,
     /* 308880 */ // Label 6183: @308880
     /* 308880 */ GIM_Reject,
     /* 308881 */ // Label 6119: @308881
     /* 308881 */ GIM_Reject,
     /* 308882 */ // Label 62: @308882
     /* 308882 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6192*/ GIMT_Encode4(325154),
     /* 308893 */ /*GILLT_s16*//*Label 6184*/ GIMT_Encode4(308933),
     /* 308897 */ /*GILLT_s32*//*Label 6185*/ GIMT_Encode4(311937),
     /* 308901 */ /*GILLT_s64*//*Label 6186*/ GIMT_Encode4(315085), GIMT_Encode4(0),
     /* 308909 */ /*GILLT_v2s32*//*Label 6187*/ GIMT_Encode4(318233),
     /* 308913 */ /*GILLT_v2s64*//*Label 6188*/ GIMT_Encode4(319754),
     /* 308917 */ /*GILLT_v4s16*//*Label 6189*/ GIMT_Encode4(321275),
     /* 308921 */ /*GILLT_v4s32*//*Label 6190*/ GIMT_Encode4(322454), GIMT_Encode4(0),
     /* 308929 */ /*GILLT_v8s16*//*Label 6191*/ GIMT_Encode4(323975),
     /* 308933 */ // Label 6184: @308933
     /* 308933 */ GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(311936),
     /* 308938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 308941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 308944 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 308947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308951 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(309101), // Rule ID 4901 //
     /* 308956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308980 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 308984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 308988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309005 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 309013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309017 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 309021 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309026 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309028 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309028 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 309031 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309035 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309040 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309051 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309068 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 309087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 309099 */     GIR_RootConstrainSelectedInstOperands,
     /* 309100 */     // GIR_Coverage, 4901,
     /* 309100 */     GIR_EraseRootFromParent_Done,
     /* 309101 */   // Label 6194: @309101
     /* 309101 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(309248), // Rule ID 4865 //
     /* 309106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309130 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309146 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 309150 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309154 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309158 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309162 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309167 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309175 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309177 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309177 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 309180 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309184 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309189 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309195 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309200 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309217 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 309236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 309246 */     GIR_RootConstrainSelectedInstOperands,
     /* 309247 */     // GIR_Coverage, 4865,
     /* 309247 */     GIR_EraseRootFromParent_Done,
     /* 309248 */   // Label 6195: @309248
     /* 309248 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(309395), // Rule ID 13940 //
     /* 309253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309280 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309289 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 309297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309301 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309305 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309309 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309314 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309322 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309324 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309324 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 309327 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309331 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309336 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309342 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309347 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309364 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 309383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 309393 */     GIR_RootConstrainSelectedInstOperands,
     /* 309394 */     // GIR_Coverage, 13940,
     /* 309394 */     GIR_EraseRootFromParent_Done,
     /* 309395 */   // Label 6196: @309395
     /* 309395 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(309526), // Rule ID 6135 //
     /* 309400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309424 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 309444 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309448 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309452 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309456 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309461 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 309465 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309469 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309473 */     // MIs[4] Operand 1
     /* 309473 */     // No operand predicates
     /* 309473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309477 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 309479 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 309479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309491 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 309510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 309514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 309521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 309524 */     GIR_RootConstrainSelectedInstOperands,
     /* 309525 */     // GIR_Coverage, 6135,
     /* 309525 */     GIR_EraseRootFromParent_Done,
     /* 309526 */   // Label 6197: @309526
     /* 309526 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(309657), // Rule ID 6167 //
     /* 309531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309563 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309567 */     // MIs[2] Operand 1
     /* 309567 */     // No operand predicates
     /* 309567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 309571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309575 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 309579 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 309583 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309587 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309591 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 309595 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309600 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 309604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309608 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 309610 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 309610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309622 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 309641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 309645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 309655 */     GIR_RootConstrainSelectedInstOperands,
     /* 309656 */     // GIR_Coverage, 6167,
     /* 309656 */     GIR_EraseRootFromParent_Done,
     /* 309657 */   // Label 6198: @309657
     /* 309657 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(309788), // Rule ID 6231 //
     /* 309662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309698 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 309706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309710 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309714 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309718 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309723 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 309727 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309731 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309735 */     // MIs[4] Operand 1
     /* 309735 */     // No operand predicates
     /* 309735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309739 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 309741 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 309741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309753 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 309772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 309776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 309783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 309786 */     GIR_RootConstrainSelectedInstOperands,
     /* 309787 */     // GIR_Coverage, 6231,
     /* 309787 */     GIR_EraseRootFromParent_Done,
     /* 309788 */   // Label 6199: @309788
     /* 309788 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(309919), // Rule ID 6199 //
     /* 309793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 309833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309837 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309841 */     // MIs[3] Operand 1
     /* 309841 */     // No operand predicates
     /* 309841 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 309845 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309849 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309853 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 309857 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309862 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 309866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309870 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 309872 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 309872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309884 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 309903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 309907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 309914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 309917 */     GIR_RootConstrainSelectedInstOperands,
     /* 309918 */     // GIR_Coverage, 6199,
     /* 309918 */     GIR_EraseRootFromParent_Done,
     /* 309919 */   // Label 6200: @309919
     /* 309919 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(310054), // Rule ID 2456 //
     /* 309924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309948 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309973 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309983 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309983 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 309986 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309990 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309995 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310006 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310023 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 310042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310052 */     GIR_RootConstrainSelectedInstOperands,
     /* 310053 */     // GIR_Coverage, 2456,
     /* 310053 */     GIR_EraseRootFromParent_Done,
     /* 310054 */   // Label 6201: @310054
     /* 310054 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(310173), // Rule ID 6103 //
     /* 310059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310083 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310116 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310120 */     // MIs[3] Operand 1
     /* 310120 */     // No operand predicates
     /* 310120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310124 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310126 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310138 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 310157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 310168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 310171 */     GIR_RootConstrainSelectedInstOperands,
     /* 310172 */     // GIR_Coverage, 6103,
     /* 310172 */     GIR_EraseRootFromParent_Done,
     /* 310173 */   // Label 6202: @310173
     /* 310173 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(310292), // Rule ID 2538 //
     /* 310178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310210 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310214 */     // MIs[2] Operand 1
     /* 310214 */     // No operand predicates
     /* 310214 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 310218 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310222 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310226 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310230 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310235 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 310239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310245 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310257 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 310276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 310290 */     GIR_RootConstrainSelectedInstOperands,
     /* 310291 */     // GIR_Coverage, 2538,
     /* 310291 */     GIR_EraseRootFromParent_Done,
     /* 310292 */   // Label 6203: @310292
     /* 310292 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(310392), // Rule ID 4863 //
     /* 310297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310321 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310348 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310360 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 310388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310390 */     GIR_RootConstrainSelectedInstOperands,
     /* 310391 */     // GIR_Coverage, 4863,
     /* 310391 */     GIR_EraseRootFromParent_Done,
     /* 310392 */   // Label 6204: @310392
     /* 310392 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(310492), // Rule ID 4899 //
     /* 310397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310421 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 310433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310448 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310460 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 310479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 310486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 310490 */     GIR_RootConstrainSelectedInstOperands,
     /* 310491 */     // GIR_Coverage, 4899,
     /* 310491 */     GIR_EraseRootFromParent_Done,
     /* 310492 */   // Label 6205: @310492
     /* 310492 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(310589), // Rule ID 13936 //
     /* 310497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310533 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310547 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310559 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 310582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310587 */     GIR_RootConstrainSelectedInstOperands,
     /* 310588 */     // GIR_Coverage, 13936,
     /* 310588 */     GIR_EraseRootFromParent_Done,
     /* 310589 */   // Label 6206: @310589
     /* 310589 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(310689), // Rule ID 13938 //
     /* 310594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310635 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310645 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 310645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310657 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310687 */     GIR_RootConstrainSelectedInstOperands,
     /* 310688 */     // GIR_Coverage, 13938,
     /* 310688 */     GIR_EraseRootFromParent_Done,
     /* 310689 */   // Label 6207: @310689
     /* 310689 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(310789), // Rule ID 4897 //
     /* 310694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310722 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 310730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310745 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310757 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 310776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310778 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 310787 */     GIR_RootConstrainSelectedInstOperands,
     /* 310788 */     // GIR_Coverage, 4897,
     /* 310788 */     GIR_EraseRootFromParent_Done,
     /* 310789 */   // Label 6208: @310789
     /* 310789 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(310886), // Rule ID 4861 //
     /* 310794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 310805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310834 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310844 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310856 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310884 */     GIR_RootConstrainSelectedInstOperands,
     /* 310885 */     // GIR_Coverage, 4861,
     /* 310885 */     GIR_EraseRootFromParent_Done,
     /* 310886 */   // Label 6209: @310886
     /* 310886 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(310970), // Rule ID 6165 //
     /* 310891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310923 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310927 */     // MIs[2] Operand 1
     /* 310927 */     // No operand predicates
     /* 310927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 310931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310935 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 310939 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310950 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 310961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 310968 */     GIR_RootConstrainSelectedInstOperands,
     /* 310969 */     // GIR_Coverage, 6165,
     /* 310969 */     GIR_EraseRootFromParent_Done,
     /* 310970 */   // Label 6210: @310970
     /* 310970 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(311051), // Rule ID 6197 //
     /* 310975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311019 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311023 */     // MIs[3] Operand 1
     /* 311023 */     // No operand predicates
     /* 311023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311031 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311033 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 311036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 311042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 311046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 311049 */     GIR_RootConstrainSelectedInstOperands,
     /* 311050 */     // GIR_Coverage, 6197,
     /* 311050 */     GIR_EraseRootFromParent_Done,
     /* 311051 */   // Label 6211: @311051
     /* 311051 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(311135), // Rule ID 6229 //
     /* 311056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311105 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311109 */     // MIs[3] Operand 1
     /* 311109 */     // No operand predicates
     /* 311109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311115 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 311118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 311130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 311133 */     GIR_RootConstrainSelectedInstOperands,
     /* 311134 */     // GIR_Coverage, 6229,
     /* 311134 */     GIR_EraseRootFromParent_Done,
     /* 311135 */   // Label 6212: @311135
     /* 311135 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(311216), // Rule ID 6133 //
     /* 311140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311171 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311175 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311188 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311192 */     // MIs[3] Operand 1
     /* 311192 */     // No operand predicates
     /* 311192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311196 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311198 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 311201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 311211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 311214 */     GIR_RootConstrainSelectedInstOperands,
     /* 311215 */     // GIR_Coverage, 6133,
     /* 311215 */     GIR_EraseRootFromParent_Done,
     /* 311216 */   // Label 6213: @311216
     /* 311216 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(311301), // Rule ID 2454 //
     /* 311221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311245 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311259 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311271 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311282 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 311290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 311297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311299 */     GIR_RootConstrainSelectedInstOperands,
     /* 311300 */     // GIR_Coverage, 2454,
     /* 311300 */     GIR_EraseRootFromParent_Done,
     /* 311301 */   // Label 6214: @311301
     /* 311301 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(311386), // Rule ID 2452 //
     /* 311306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311334 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311344 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 311344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311356 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 311362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 311375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311384 */     GIR_RootConstrainSelectedInstOperands,
     /* 311385 */     // GIR_Coverage, 2452,
     /* 311385 */     GIR_EraseRootFromParent_Done,
     /* 311386 */   // Label 6215: @311386
     /* 311386 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(311455), // Rule ID 2536 //
     /* 311391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 311419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311423 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311427 */     // MIs[2] Operand 1
     /* 311427 */     // No operand predicates
     /* 311427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311437 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 311440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 311446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 311453 */     GIR_RootConstrainSelectedInstOperands,
     /* 311454 */     // GIR_Coverage, 2536,
     /* 311454 */     GIR_EraseRootFromParent_Done,
     /* 311455 */   // Label 6216: @311455
     /* 311455 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(311524), // Rule ID 6101 //
     /* 311460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 311492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311496 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311500 */     // MIs[2] Operand 1
     /* 311500 */     // No operand predicates
     /* 311500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311506 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 311509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 311522 */     GIR_RootConstrainSelectedInstOperands,
     /* 311523 */     // GIR_Coverage, 6101,
     /* 311523 */     GIR_EraseRootFromParent_Done,
     /* 311524 */   // Label 6217: @311524
     /* 311524 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(311589), // Rule ID 4917 //
     /* 311529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 311557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311572 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 311575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 311583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 311587 */     GIR_RootConstrainSelectedInstOperands,
     /* 311588 */     // GIR_Coverage, 4917,
     /* 311588 */     GIR_EraseRootFromParent_Done,
     /* 311589 */   // Label 6218: @311589
     /* 311589 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(311654), // Rule ID 13956 //
     /* 311594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 311622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311637 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 311640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 311648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 311652 */     GIR_RootConstrainSelectedInstOperands,
     /* 311653 */     // GIR_Coverage, 13956,
     /* 311653 */     GIR_EraseRootFromParent_Done,
     /* 311654 */   // Label 6219: @311654
     /* 311654 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(311704), // Rule ID 4914 //
     /* 311659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311689 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 311700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311702 */     GIR_RootConstrainSelectedInstOperands,
     /* 311703 */     // GIR_Coverage, 4914,
     /* 311703 */     GIR_EraseRootFromParent_Done,
     /* 311704 */   // Label 6220: @311704
     /* 311704 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(311754), // Rule ID 13382 //
     /* 311709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311739 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 311746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311752 */     GIR_RootConstrainSelectedInstOperands,
     /* 311753 */     // GIR_Coverage, 13382,
     /* 311753 */     GIR_EraseRootFromParent_Done,
     /* 311754 */   // Label 6221: @311754
     /* 311754 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(311804), // Rule ID 644 //
     /* 311759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311789 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311802 */     GIR_RootConstrainSelectedInstOperands,
     /* 311803 */     // GIR_Coverage, 644,
     /* 311803 */     GIR_EraseRootFromParent_Done,
     /* 311804 */   // Label 6222: @311804
     /* 311804 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(311854), // Rule ID 13953 //
     /* 311809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311839 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 311850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311852 */     GIR_RootConstrainSelectedInstOperands,
     /* 311853 */     // GIR_Coverage, 13953,
     /* 311853 */     GIR_EraseRootFromParent_Done,
     /* 311854 */   // Label 6223: @311854
     /* 311854 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(311904), // Rule ID 656 //
     /* 311859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 311874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311889 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 311892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 311898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 311902 */     GIR_RootConstrainSelectedInstOperands,
     /* 311903 */     // GIR_Coverage, 656,
     /* 311903 */     GIR_EraseRootFromParent_Done,
     /* 311904 */   // Label 6224: @311904
     /* 311904 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(311935), // Rule ID 638 //
     /* 311909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311924 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 311929 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311933 */     GIR_RootConstrainSelectedInstOperands,
     /* 311934 */     // GIR_Coverage, 638,
     /* 311934 */     GIR_Done,
     /* 311935 */   // Label 6225: @311935
     /* 311935 */   GIM_Reject,
     /* 311936 */ // Label 6193: @311936
     /* 311936 */ GIM_Reject,
     /* 311937 */ // Label 6185: @311937
     /* 311937 */ GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(315084),
     /* 311942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 311948 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 311951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311955 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(312105), // Rule ID 4907 //
     /* 311960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311984 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312009 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 312017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312021 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 312025 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312032 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312032 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 312035 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312039 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312044 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 312050 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312055 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312072 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 312091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 312099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 312103 */     GIR_RootConstrainSelectedInstOperands,
     /* 312104 */     // GIR_Coverage, 4907,
     /* 312104 */     GIR_EraseRootFromParent_Done,
     /* 312105 */   // Label 6227: @312105
     /* 312105 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(312252), // Rule ID 4871 //
     /* 312110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312134 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 312150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312158 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312162 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 312166 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312171 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 312175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312179 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312181 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312181 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 312184 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312188 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312193 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 312199 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312204 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312221 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 312240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 312248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312250 */     GIR_RootConstrainSelectedInstOperands,
     /* 312251 */     // GIR_Coverage, 4871,
     /* 312251 */     GIR_EraseRootFromParent_Done,
     /* 312252 */   // Label 6228: @312252
     /* 312252 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(312399), // Rule ID 13946 //
     /* 312257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312293 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 312301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312305 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312309 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 312313 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312318 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 312322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312326 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312328 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312328 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 312331 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312335 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312340 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 312346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312368 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 312387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 312395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312397 */     GIR_RootConstrainSelectedInstOperands,
     /* 312398 */     // GIR_Coverage, 13946,
     /* 312398 */     GIR_EraseRootFromParent_Done,
     /* 312399 */   // Label 6229: @312399
     /* 312399 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(312530), // Rule ID 6151 //
     /* 312404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312428 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 312444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312452 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312456 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 312460 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312465 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 312469 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312473 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 312477 */     // MIs[4] Operand 1
     /* 312477 */     // No operand predicates
     /* 312477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312481 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 312483 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 312483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312495 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 312514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 312525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 312528 */     GIR_RootConstrainSelectedInstOperands,
     /* 312529 */     // GIR_Coverage, 6151,
     /* 312529 */     GIR_EraseRootFromParent_Done,
     /* 312530 */   // Label 6230: @312530
     /* 312530 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(312661), // Rule ID 6183 //
     /* 312535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312567 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 312571 */     // MIs[2] Operand 1
     /* 312571 */     // No operand predicates
     /* 312571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 312575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312579 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 312583 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 312587 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312591 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312595 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 312599 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312604 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 312608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312612 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 312614 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 312614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312626 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312632 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 312645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 312659 */     GIR_RootConstrainSelectedInstOperands,
     /* 312660 */     // GIR_Coverage, 6183,
     /* 312660 */     GIR_EraseRootFromParent_Done,
     /* 312661 */   // Label 6231: @312661
     /* 312661 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(312792), // Rule ID 6247 //
     /* 312666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312702 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 312710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 312722 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312727 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 312731 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312735 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 312739 */     // MIs[4] Operand 1
     /* 312739 */     // No operand predicates
     /* 312739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312743 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 312745 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 312745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312757 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 312776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 312787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 312790 */     GIR_RootConstrainSelectedInstOperands,
     /* 312791 */     // GIR_Coverage, 6247,
     /* 312791 */     GIR_EraseRootFromParent_Done,
     /* 312792 */   // Label 6232: @312792
     /* 312792 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(312923), // Rule ID 6215 //
     /* 312797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312824 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 312837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312841 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 312845 */     // MIs[3] Operand 1
     /* 312845 */     // No operand predicates
     /* 312845 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 312849 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312853 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312857 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 312861 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312866 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 312870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312874 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 312876 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 312876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312888 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 312907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 312918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 312921 */     GIR_RootConstrainSelectedInstOperands,
     /* 312922 */     // GIR_Coverage, 6215,
     /* 312922 */     GIR_EraseRootFromParent_Done,
     /* 312923 */   // Label 6233: @312923
     /* 312923 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(313058), // Rule ID 2462 //
     /* 312928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312952 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312977 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312987 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312987 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 312990 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312994 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312999 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313005 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313010 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313027 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 313046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 313054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313056 */     GIR_RootConstrainSelectedInstOperands,
     /* 313057 */     // GIR_Coverage, 2462,
     /* 313057 */     GIR_EraseRootFromParent_Done,
     /* 313058 */   // Label 6234: @313058
     /* 313058 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(313177), // Rule ID 6119 //
     /* 313063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313087 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313120 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313124 */     // MIs[3] Operand 1
     /* 313124 */     // No operand predicates
     /* 313124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313128 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313130 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313142 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 313161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313175 */     GIR_RootConstrainSelectedInstOperands,
     /* 313176 */     // GIR_Coverage, 6119,
     /* 313176 */     GIR_EraseRootFromParent_Done,
     /* 313177 */   // Label 6235: @313177
     /* 313177 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(313296), // Rule ID 2554 //
     /* 313182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 313210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313214 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313218 */     // MIs[2] Operand 1
     /* 313218 */     // No operand predicates
     /* 313218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 313222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313226 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313230 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 313234 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313239 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 313243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313247 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313249 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313261 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 313280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 313294 */     GIR_RootConstrainSelectedInstOperands,
     /* 313295 */     // GIR_Coverage, 2554,
     /* 313295 */     GIR_EraseRootFromParent_Done,
     /* 313296 */   // Label 6236: @313296
     /* 313296 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(313396), // Rule ID 4869 //
     /* 313301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313325 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 313341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313352 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 313352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313364 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313394 */     GIR_RootConstrainSelectedInstOperands,
     /* 313395 */     // GIR_Coverage, 4869,
     /* 313395 */     GIR_EraseRootFromParent_Done,
     /* 313396 */   // Label 6237: @313396
     /* 313396 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(313496), // Rule ID 4905 //
     /* 313401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313425 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 313437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 313445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313452 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 313452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313464 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 313483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 313490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 313494 */     GIR_RootConstrainSelectedInstOperands,
     /* 313495 */     // GIR_Coverage, 4905,
     /* 313495 */     GIR_EraseRootFromParent_Done,
     /* 313496 */   // Label 6238: @313496
     /* 313496 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(313593), // Rule ID 13942 //
     /* 313501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313537 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313551 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313563 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 313586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313591 */     GIR_RootConstrainSelectedInstOperands,
     /* 313592 */     // GIR_Coverage, 13942,
     /* 313592 */     GIR_EraseRootFromParent_Done,
     /* 313593 */   // Label 6239: @313593
     /* 313593 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(313693), // Rule ID 13944 //
     /* 313598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313639 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313649 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 313649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313661 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313691 */     GIR_RootConstrainSelectedInstOperands,
     /* 313692 */     // GIR_Coverage, 13944,
     /* 313692 */     GIR_EraseRootFromParent_Done,
     /* 313693 */   // Label 6240: @313693
     /* 313693 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(313793), // Rule ID 4903 //
     /* 313698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313726 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 313734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 313742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313749 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313761 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 313780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 313791 */     GIR_RootConstrainSelectedInstOperands,
     /* 313792 */     // GIR_Coverage, 4903,
     /* 313792 */     GIR_EraseRootFromParent_Done,
     /* 313793 */   // Label 6241: @313793
     /* 313793 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(313890), // Rule ID 4867 //
     /* 313798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 313809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313838 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313848 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313860 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 313883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313888 */     GIR_RootConstrainSelectedInstOperands,
     /* 313889 */     // GIR_Coverage, 4867,
     /* 313889 */     GIR_EraseRootFromParent_Done,
     /* 313890 */   // Label 6242: @313890
     /* 313890 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(313968), // Rule ID 6269 //
     /* 313895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 313932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313936 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313940 */     // MIs[3] Operand 1
     /* 313940 */     // No operand predicates
     /* 313940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313950 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 313959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313966 */     GIR_RootConstrainSelectedInstOperands,
     /* 313967 */     // GIR_Coverage, 6269,
     /* 313967 */     GIR_EraseRootFromParent_Done,
     /* 313968 */   // Label 6243: @313968
     /* 313968 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(314052), // Rule ID 6181 //
     /* 313973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 314001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314005 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314009 */     // MIs[2] Operand 1
     /* 314009 */     // No operand predicates
     /* 314009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 314013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314017 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 314021 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314032 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 314043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 314050 */     GIR_RootConstrainSelectedInstOperands,
     /* 314051 */     // GIR_Coverage, 6181,
     /* 314051 */     GIR_EraseRootFromParent_Done,
     /* 314052 */   // Label 6244: @314052
     /* 314052 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(314133), // Rule ID 6213 //
     /* 314057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314101 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314105 */     // MIs[3] Operand 1
     /* 314105 */     // No operand predicates
     /* 314105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314115 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 314124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314131 */     GIR_RootConstrainSelectedInstOperands,
     /* 314132 */     // GIR_Coverage, 6213,
     /* 314132 */     GIR_EraseRootFromParent_Done,
     /* 314133 */   // Label 6245: @314133
     /* 314133 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(314217), // Rule ID 6245 //
     /* 314138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314170 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314187 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314191 */     // MIs[3] Operand 1
     /* 314191 */     // No operand predicates
     /* 314191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314197 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314215 */     GIR_RootConstrainSelectedInstOperands,
     /* 314216 */     // GIR_Coverage, 6245,
     /* 314216 */     GIR_EraseRootFromParent_Done,
     /* 314217 */   // Label 6246: @314217
     /* 314217 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(314295), // Rule ID 6291 //
     /* 314222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 314263 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314267 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314271 */     // MIs[3] Operand 1
     /* 314271 */     // No operand predicates
     /* 314271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314277 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314293 */     GIR_RootConstrainSelectedInstOperands,
     /* 314294 */     // GIR_Coverage, 6291,
     /* 314294 */     GIR_EraseRootFromParent_Done,
     /* 314295 */   // Label 6247: @314295
     /* 314295 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(314376), // Rule ID 6149 //
     /* 314300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314348 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314352 */     // MIs[3] Operand 1
     /* 314352 */     // No operand predicates
     /* 314352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314358 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314374 */     GIR_RootConstrainSelectedInstOperands,
     /* 314375 */     // GIR_Coverage, 6149,
     /* 314375 */     GIR_EraseRootFromParent_Done,
     /* 314376 */   // Label 6248: @314376
     /* 314376 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(314461), // Rule ID 2460 //
     /* 314381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314405 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314419 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314431 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314437 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 314450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 314457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314459 */     GIR_RootConstrainSelectedInstOperands,
     /* 314460 */     // GIR_Coverage, 2460,
     /* 314460 */     GIR_EraseRootFromParent_Done,
     /* 314461 */   // Label 6249: @314461
     /* 314461 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(314546), // Rule ID 2458 //
     /* 314466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314494 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314504 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 314504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314516 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 314522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 314535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314544 */     GIR_RootConstrainSelectedInstOperands,
     /* 314545 */     // GIR_Coverage, 2458,
     /* 314545 */     GIR_EraseRootFromParent_Done,
     /* 314546 */   // Label 6250: @314546
     /* 314546 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(314615), // Rule ID 2552 //
     /* 314551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 314579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314583 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314587 */     // MIs[2] Operand 1
     /* 314587 */     // No operand predicates
     /* 314587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314597 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 314600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 314606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 314613 */     GIR_RootConstrainSelectedInstOperands,
     /* 314614 */     // GIR_Coverage, 2552,
     /* 314614 */     GIR_EraseRootFromParent_Done,
     /* 314615 */   // Label 6251: @314615
     /* 314615 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(314684), // Rule ID 6117 //
     /* 314620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 314652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314656 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314660 */     // MIs[2] Operand 1
     /* 314660 */     // No operand predicates
     /* 314660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314666 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 314669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 314682 */     GIR_RootConstrainSelectedInstOperands,
     /* 314683 */     // GIR_Coverage, 6117,
     /* 314683 */     GIR_EraseRootFromParent_Done,
     /* 314684 */   // Label 6252: @314684
     /* 314684 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(314746), // Rule ID 4918 //
     /* 314689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 314714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 314722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314729 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 314732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 314740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 314744 */     GIR_RootConstrainSelectedInstOperands,
     /* 314745 */     // GIR_Coverage, 4918,
     /* 314745 */     GIR_EraseRootFromParent_Done,
     /* 314746 */   // Label 6253: @314746
     /* 314746 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(314808), // Rule ID 13957 //
     /* 314751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 314776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 314784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314791 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 314794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314800 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 314802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 314806 */     GIR_RootConstrainSelectedInstOperands,
     /* 314807 */     // GIR_Coverage, 13957,
     /* 314807 */     GIR_EraseRootFromParent_Done,
     /* 314808 */   // Label 6254: @314808
     /* 314808 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(314855), // Rule ID 4915 //
     /* 314813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314840 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 314851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314853 */     GIR_RootConstrainSelectedInstOperands,
     /* 314854 */     // GIR_Coverage, 4915,
     /* 314854 */     GIR_EraseRootFromParent_Done,
     /* 314855 */   // Label 6255: @314855
     /* 314855 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(314905), // Rule ID 13384 //
     /* 314860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314890 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 314897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314903 */     GIR_RootConstrainSelectedInstOperands,
     /* 314904 */     // GIR_Coverage, 13384,
     /* 314904 */     GIR_EraseRootFromParent_Done,
     /* 314905 */   // Label 6256: @314905
     /* 314905 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(314955), // Rule ID 646 //
     /* 314910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314940 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314953 */     GIR_RootConstrainSelectedInstOperands,
     /* 314954 */     // GIR_Coverage, 646,
     /* 314954 */     GIR_EraseRootFromParent_Done,
     /* 314955 */   // Label 6257: @314955
     /* 314955 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(315002), // Rule ID 13954 //
     /* 314960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314987 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 314998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315000 */     GIR_RootConstrainSelectedInstOperands,
     /* 315001 */     // GIR_Coverage, 13954,
     /* 315001 */     GIR_EraseRootFromParent_Done,
     /* 315002 */   // Label 6258: @315002
     /* 315002 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(315052), // Rule ID 658 //
     /* 315007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 315022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315037 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 315040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 315046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 315050 */     GIR_RootConstrainSelectedInstOperands,
     /* 315051 */     // GIR_Coverage, 658,
     /* 315051 */     GIR_EraseRootFromParent_Done,
     /* 315052 */   // Label 6259: @315052
     /* 315052 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(315083), // Rule ID 640 //
     /* 315057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315072 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 315077 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315081 */     GIR_RootConstrainSelectedInstOperands,
     /* 315082 */     // GIR_Coverage, 640,
     /* 315082 */     GIR_Done,
     /* 315083 */   // Label 6260: @315083
     /* 315083 */   GIM_Reject,
     /* 315084 */ // Label 6226: @315084
     /* 315084 */ GIM_Reject,
     /* 315085 */ // Label 6186: @315085
     /* 315085 */ GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(318232),
     /* 315090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 315096 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 315099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315103 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(315253), // Rule ID 4913 //
     /* 315108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315132 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315157 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315161 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 315165 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315169 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 315173 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315180 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 315180 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315183 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315187 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315192 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 315198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315220 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 315239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 315247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 315251 */     GIR_RootConstrainSelectedInstOperands,
     /* 315252 */     // GIR_Coverage, 4913,
     /* 315252 */     GIR_EraseRootFromParent_Done,
     /* 315253 */   // Label 6262: @315253
     /* 315253 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(315400), // Rule ID 4877 //
     /* 315258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315282 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 315298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 315302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315306 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315310 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 315314 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315319 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 315323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315327 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315329 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 315329 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315332 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315336 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315341 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 315347 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315352 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315369 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 315388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 315396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315398 */     GIR_RootConstrainSelectedInstOperands,
     /* 315399 */     // GIR_Coverage, 4877,
     /* 315399 */     GIR_EraseRootFromParent_Done,
     /* 315400 */   // Label 6263: @315400
     /* 315400 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(315547), // Rule ID 13952 //
     /* 315405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 315420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315441 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 315449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315453 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315457 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 315461 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315466 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 315470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315474 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315476 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 315476 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315479 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315483 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315488 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 315494 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315499 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315516 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 315535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 315543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315545 */     GIR_RootConstrainSelectedInstOperands,
     /* 315546 */     // GIR_Coverage, 13952,
     /* 315546 */     GIR_EraseRootFromParent_Done,
     /* 315547 */   // Label 6264: @315547
     /* 315547 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(315678), // Rule ID 6155 //
     /* 315552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315576 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 315592 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 315596 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315600 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315604 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 315608 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315613 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 315617 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315621 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 315625 */     // MIs[4] Operand 1
     /* 315625 */     // No operand predicates
     /* 315625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315629 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 315631 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 315631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315643 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 315662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 315673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 315676 */     GIR_RootConstrainSelectedInstOperands,
     /* 315677 */     // GIR_Coverage, 6155,
     /* 315677 */     GIR_EraseRootFromParent_Done,
     /* 315678 */   // Label 6265: @315678
     /* 315678 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(315809), // Rule ID 6187 //
     /* 315683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 315711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315715 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 315719 */     // MIs[2] Operand 1
     /* 315719 */     // No operand predicates
     /* 315719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 315723 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315727 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 315731 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 315735 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315739 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315743 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 315747 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315752 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 315756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315760 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 315762 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 315762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315774 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315780 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 315793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 315807 */     GIR_RootConstrainSelectedInstOperands,
     /* 315808 */     // GIR_Coverage, 6187,
     /* 315808 */     GIR_EraseRootFromParent_Done,
     /* 315809 */   // Label 6266: @315809
     /* 315809 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(315940), // Rule ID 6251 //
     /* 315814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 315829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315850 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 315858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315862 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315866 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 315870 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315875 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 315879 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315883 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 315887 */     // MIs[4] Operand 1
     /* 315887 */     // No operand predicates
     /* 315887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315891 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 315893 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 315893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315905 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315916 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 315924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 315935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 315938 */     GIR_RootConstrainSelectedInstOperands,
     /* 315939 */     // GIR_Coverage, 6251,
     /* 315939 */     GIR_EraseRootFromParent_Done,
     /* 315940 */   // Label 6267: @315940
     /* 315940 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(316071), // Rule ID 6219 //
     /* 315945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 315960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315989 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 315993 */     // MIs[3] Operand 1
     /* 315993 */     // No operand predicates
     /* 315993 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 315997 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316001 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316005 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 316009 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316014 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 316018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316022 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 316024 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316036 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316069 */     GIR_RootConstrainSelectedInstOperands,
     /* 316070 */     // GIR_Coverage, 6219,
     /* 316070 */     GIR_EraseRootFromParent_Done,
     /* 316071 */   // Label 6268: @316071
     /* 316071 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(316206), // Rule ID 2468 //
     /* 316076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316100 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316125 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316135 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316135 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 316138 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316142 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316147 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316153 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316158 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316175 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316181 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 316194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 316202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316204 */     GIR_RootConstrainSelectedInstOperands,
     /* 316205 */     // GIR_Coverage, 2468,
     /* 316205 */     GIR_EraseRootFromParent_Done,
     /* 316206 */   // Label 6269: @316206
     /* 316206 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(316325), // Rule ID 6123 //
     /* 316211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316235 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316251 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316255 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316260 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316264 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316268 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316272 */     // MIs[3] Operand 1
     /* 316272 */     // No operand predicates
     /* 316272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316276 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316278 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316290 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 316309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316323 */     GIR_RootConstrainSelectedInstOperands,
     /* 316324 */     // GIR_Coverage, 6123,
     /* 316324 */     GIR_EraseRootFromParent_Done,
     /* 316325 */   // Label 6270: @316325
     /* 316325 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(316444), // Rule ID 2558 //
     /* 316330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 316358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316362 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316366 */     // MIs[2] Operand 1
     /* 316366 */     // No operand predicates
     /* 316366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 316370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316374 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316378 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 316382 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316387 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 316391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316395 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316397 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316409 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 316428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 316442 */     GIR_RootConstrainSelectedInstOperands,
     /* 316443 */     // GIR_Coverage, 2558,
     /* 316443 */     GIR_EraseRootFromParent_Done,
     /* 316444 */   // Label 6271: @316444
     /* 316444 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(316544), // Rule ID 4875 //
     /* 316449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316473 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 316489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316500 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 316500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316512 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 316531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316542 */     GIR_RootConstrainSelectedInstOperands,
     /* 316543 */     // GIR_Coverage, 4875,
     /* 316543 */     GIR_EraseRootFromParent_Done,
     /* 316544 */   // Label 6272: @316544
     /* 316544 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(316644), // Rule ID 4911 //
     /* 316549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316573 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 316585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 316593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316600 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 316600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316612 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 316631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 316638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 316642 */     GIR_RootConstrainSelectedInstOperands,
     /* 316643 */     // GIR_Coverage, 4911,
     /* 316643 */     GIR_EraseRootFromParent_Done,
     /* 316644 */   // Label 6273: @316644
     /* 316644 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(316741), // Rule ID 13948 //
     /* 316649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316685 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316697 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316699 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316711 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 316730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 316734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316739 */     GIR_RootConstrainSelectedInstOperands,
     /* 316740 */     // GIR_Coverage, 13948,
     /* 316740 */     GIR_EraseRootFromParent_Done,
     /* 316741 */   // Label 6274: @316741
     /* 316741 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(316841), // Rule ID 13950 //
     /* 316746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316787 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316795 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316797 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 316797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316809 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316815 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316820 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 316828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316839 */     GIR_RootConstrainSelectedInstOperands,
     /* 316840 */     // GIR_Coverage, 13950,
     /* 316840 */     GIR_EraseRootFromParent_Done,
     /* 316841 */   // Label 6275: @316841
     /* 316841 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(316941), // Rule ID 4909 //
     /* 316846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316874 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 316882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 316890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316897 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316909 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 316928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316930 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 316932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 316939 */     GIR_RootConstrainSelectedInstOperands,
     /* 316940 */     // GIR_Coverage, 4909,
     /* 316940 */     GIR_EraseRootFromParent_Done,
     /* 316941 */   // Label 6276: @316941
     /* 316941 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(317038), // Rule ID 4873 //
     /* 316946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 316957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316986 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316996 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317008 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 317014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317036 */     GIR_RootConstrainSelectedInstOperands,
     /* 317037 */     // GIR_Coverage, 4873,
     /* 317037 */     GIR_EraseRootFromParent_Done,
     /* 317038 */   // Label 6277: @317038
     /* 317038 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(317116), // Rule ID 6273 //
     /* 317043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317084 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317088 */     // MIs[3] Operand 1
     /* 317088 */     // No operand predicates
     /* 317088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317096 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317098 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317114 */     GIR_RootConstrainSelectedInstOperands,
     /* 317115 */     // GIR_Coverage, 6273,
     /* 317115 */     GIR_EraseRootFromParent_Done,
     /* 317116 */   // Label 6278: @317116
     /* 317116 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(317200), // Rule ID 6185 //
     /* 317121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317153 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317157 */     // MIs[2] Operand 1
     /* 317157 */     // No operand predicates
     /* 317157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 317161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317165 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 317169 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317180 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 317191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317198 */     GIR_RootConstrainSelectedInstOperands,
     /* 317199 */     // GIR_Coverage, 6185,
     /* 317199 */     GIR_EraseRootFromParent_Done,
     /* 317200 */   // Label 6279: @317200
     /* 317200 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(317281), // Rule ID 6217 //
     /* 317205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317249 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317253 */     // MIs[3] Operand 1
     /* 317253 */     // No operand predicates
     /* 317253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317261 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317263 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317279 */     GIR_RootConstrainSelectedInstOperands,
     /* 317280 */     // GIR_Coverage, 6217,
     /* 317280 */     GIR_EraseRootFromParent_Done,
     /* 317281 */   // Label 6280: @317281
     /* 317281 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(317365), // Rule ID 6249 //
     /* 317286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317335 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317339 */     // MIs[3] Operand 1
     /* 317339 */     // No operand predicates
     /* 317339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317343 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317345 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317363 */     GIR_RootConstrainSelectedInstOperands,
     /* 317364 */     // GIR_Coverage, 6249,
     /* 317364 */     GIR_EraseRootFromParent_Done,
     /* 317365 */   // Label 6281: @317365
     /* 317365 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(317443), // Rule ID 6295 //
     /* 317370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317415 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317419 */     // MIs[3] Operand 1
     /* 317419 */     // No operand predicates
     /* 317419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317425 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317441 */     GIR_RootConstrainSelectedInstOperands,
     /* 317442 */     // GIR_Coverage, 6295,
     /* 317442 */     GIR_EraseRootFromParent_Done,
     /* 317443 */   // Label 6282: @317443
     /* 317443 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(317524), // Rule ID 6153 //
     /* 317448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317483 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317492 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317496 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317500 */     // MIs[3] Operand 1
     /* 317500 */     // No operand predicates
     /* 317500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317506 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317522 */     GIR_RootConstrainSelectedInstOperands,
     /* 317523 */     // GIR_Coverage, 6153,
     /* 317523 */     GIR_EraseRootFromParent_Done,
     /* 317524 */   // Label 6283: @317524
     /* 317524 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(317609), // Rule ID 2466 //
     /* 317529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317553 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317567 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317579 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 317598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 317605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317607 */     GIR_RootConstrainSelectedInstOperands,
     /* 317608 */     // GIR_Coverage, 2466,
     /* 317608 */     GIR_EraseRootFromParent_Done,
     /* 317609 */   // Label 6284: @317609
     /* 317609 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(317694), // Rule ID 2464 //
     /* 317614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317642 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317652 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 317652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317664 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 317670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 317683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317692 */     GIR_RootConstrainSelectedInstOperands,
     /* 317693 */     // GIR_Coverage, 2464,
     /* 317693 */     GIR_EraseRootFromParent_Done,
     /* 317694 */   // Label 6285: @317694
     /* 317694 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(317763), // Rule ID 2556 //
     /* 317699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317731 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317735 */     // MIs[2] Operand 1
     /* 317735 */     // No operand predicates
     /* 317735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317745 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 317748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317761 */     GIR_RootConstrainSelectedInstOperands,
     /* 317762 */     // GIR_Coverage, 2556,
     /* 317762 */     GIR_EraseRootFromParent_Done,
     /* 317763 */   // Label 6286: @317763
     /* 317763 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(317832), // Rule ID 6121 //
     /* 317768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317804 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317808 */     // MIs[2] Operand 1
     /* 317808 */     // No operand predicates
     /* 317808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317814 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 317817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317830 */     GIR_RootConstrainSelectedInstOperands,
     /* 317831 */     // GIR_Coverage, 6121,
     /* 317831 */     GIR_EraseRootFromParent_Done,
     /* 317832 */   // Label 6287: @317832
     /* 317832 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(317894), // Rule ID 4919 //
     /* 317837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 317862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 317870 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317877 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 317880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 317888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 317892 */     GIR_RootConstrainSelectedInstOperands,
     /* 317893 */     // GIR_Coverage, 4919,
     /* 317893 */     GIR_EraseRootFromParent_Done,
     /* 317894 */   // Label 6288: @317894
     /* 317894 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(317956), // Rule ID 13958 //
     /* 317899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 317924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 317932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317939 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 317942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 317950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 317954 */     GIR_RootConstrainSelectedInstOperands,
     /* 317955 */     // GIR_Coverage, 13958,
     /* 317955 */     GIR_EraseRootFromParent_Done,
     /* 317956 */   // Label 6289: @317956
     /* 317956 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(318003), // Rule ID 4916 //
     /* 317961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317988 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 317999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318001 */     GIR_RootConstrainSelectedInstOperands,
     /* 318002 */     // GIR_Coverage, 4916,
     /* 318002 */     GIR_EraseRootFromParent_Done,
     /* 318003 */   // Label 6290: @318003
     /* 318003 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(318053), // Rule ID 13386 //
     /* 318008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318038 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318051 */     GIR_RootConstrainSelectedInstOperands,
     /* 318052 */     // GIR_Coverage, 13386,
     /* 318052 */     GIR_EraseRootFromParent_Done,
     /* 318053 */   // Label 6291: @318053
     /* 318053 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(318103), // Rule ID 648 //
     /* 318058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318088 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318101 */     GIR_RootConstrainSelectedInstOperands,
     /* 318102 */     // GIR_Coverage, 648,
     /* 318102 */     GIR_EraseRootFromParent_Done,
     /* 318103 */   // Label 6292: @318103
     /* 318103 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(318150), // Rule ID 13955 //
     /* 318108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318135 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 318146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318148 */     GIR_RootConstrainSelectedInstOperands,
     /* 318149 */     // GIR_Coverage, 13955,
     /* 318149 */     GIR_EraseRootFromParent_Done,
     /* 318150 */   // Label 6293: @318150
     /* 318150 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(318200), // Rule ID 660 //
     /* 318155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 318170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318185 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 318188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 318194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 318198 */     GIR_RootConstrainSelectedInstOperands,
     /* 318199 */     // GIR_Coverage, 660,
     /* 318199 */     GIR_EraseRootFromParent_Done,
     /* 318200 */   // Label 6294: @318200
     /* 318200 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(318231), // Rule ID 642 //
     /* 318205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318220 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 318225 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318229 */     GIR_RootConstrainSelectedInstOperands,
     /* 318230 */     // GIR_Coverage, 642,
     /* 318230 */     GIR_Done,
     /* 318231 */   // Label 6295: @318231
     /* 318231 */   GIM_Reject,
     /* 318232 */ // Label 6261: @318232
     /* 318232 */ GIM_Reject,
     /* 318233 */ // Label 6187: @318233
     /* 318233 */ GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(319753),
     /* 318238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 318244 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 318247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318251 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(318329), // Rule ID 6253 //
     /* 318256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 318293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318297 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318301 */     // MIs[3] Operand 1
     /* 318301 */     // No operand predicates
     /* 318301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318309 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318311 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318327 */     GIR_RootConstrainSelectedInstOperands,
     /* 318328 */     // GIR_Coverage, 6253,
     /* 318328 */     GIR_EraseRootFromParent_Done,
     /* 318329 */   // Label 6297: @318329
     /* 318329 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(318413), // Rule ID 6169 //
     /* 318334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 318362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318366 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318370 */     // MIs[2] Operand 1
     /* 318370 */     // No operand predicates
     /* 318370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 318374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318378 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318382 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318391 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318393 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 318404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 318411 */     GIR_RootConstrainSelectedInstOperands,
     /* 318412 */     // GIR_Coverage, 6169,
     /* 318412 */     GIR_EraseRootFromParent_Done,
     /* 318413 */   // Label 6298: @318413
     /* 318413 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(318494), // Rule ID 6201 //
     /* 318418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318462 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318466 */     // MIs[3] Operand 1
     /* 318466 */     // No operand predicates
     /* 318466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318474 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318476 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318492 */     GIR_RootConstrainSelectedInstOperands,
     /* 318493 */     // GIR_Coverage, 6201,
     /* 318493 */     GIR_EraseRootFromParent_Done,
     /* 318494 */   // Label 6299: @318494
     /* 318494 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(318578), // Rule ID 6233 //
     /* 318499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318531 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318535 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318548 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318552 */     // MIs[3] Operand 1
     /* 318552 */     // No operand predicates
     /* 318552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318556 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318558 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318576 */     GIR_RootConstrainSelectedInstOperands,
     /* 318577 */     // GIR_Coverage, 6233,
     /* 318577 */     GIR_EraseRootFromParent_Done,
     /* 318578 */   // Label 6300: @318578
     /* 318578 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(318656), // Rule ID 6275 //
     /* 318583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 318624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318628 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318632 */     // MIs[3] Operand 1
     /* 318632 */     // No operand predicates
     /* 318632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318638 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318645 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318654 */     GIR_RootConstrainSelectedInstOperands,
     /* 318655 */     // GIR_Coverage, 6275,
     /* 318655 */     GIR_EraseRootFromParent_Done,
     /* 318656 */   // Label 6301: @318656
     /* 318656 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(318737), // Rule ID 6137 //
     /* 318661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318709 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318713 */     // MIs[3] Operand 1
     /* 318713 */     // No operand predicates
     /* 318713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318717 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318719 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318735 */     GIR_RootConstrainSelectedInstOperands,
     /* 318736 */     // GIR_Coverage, 6137,
     /* 318736 */     GIR_EraseRootFromParent_Done,
     /* 318737 */   // Label 6302: @318737
     /* 318737 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(318806), // Rule ID 2540 //
     /* 318742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 318770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318774 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318778 */     // MIs[2] Operand 1
     /* 318778 */     // No operand predicates
     /* 318778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318788 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 318791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 318804 */     GIR_RootConstrainSelectedInstOperands,
     /* 318805 */     // GIR_Coverage, 2540,
     /* 318805 */     GIR_EraseRootFromParent_Done,
     /* 318806 */   // Label 6303: @318806
     /* 318806 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(318875), // Rule ID 6105 //
     /* 318811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 318843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318847 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318851 */     // MIs[2] Operand 1
     /* 318851 */     // No operand predicates
     /* 318851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318857 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 318860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 318873 */     GIR_RootConstrainSelectedInstOperands,
     /* 318874 */     // GIR_Coverage, 6105,
     /* 318874 */     GIR_EraseRootFromParent_Done,
     /* 318875 */   // Label 6304: @318875
     /* 318875 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(318968), // Rule ID 6257 //
     /* 318880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 318888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 318892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 318904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318919 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 318919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 318922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 318926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318931 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 318934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318938 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 318941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 318954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 318966 */     GIR_RootConstrainSelectedInstOperands,
     /* 318967 */     // GIR_Coverage, 6257,
     /* 318967 */     GIR_EraseRootFromParent_Done,
     /* 318968 */   // Label 6305: @318968
     /* 318968 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(319067), // Rule ID 6171 //
     /* 318973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 318984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 318988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319016 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319028 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319031 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319035 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 319059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319065 */     GIR_RootConstrainSelectedInstOperands,
     /* 319066 */     // GIR_Coverage, 6171,
     /* 319066 */     GIR_EraseRootFromParent_Done,
     /* 319067 */   // Label 6306: @319067
     /* 319067 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(319163), // Rule ID 6203 //
     /* 319072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 319095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 319099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319114 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319126 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319133 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319161 */     GIR_RootConstrainSelectedInstOperands,
     /* 319162 */     // GIR_Coverage, 6203,
     /* 319162 */     GIR_EraseRootFromParent_Done,
     /* 319163 */   // Label 6307: @319163
     /* 319163 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(319262), // Rule ID 6235 //
     /* 319168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 319196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 319200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319211 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319223 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319226 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319230 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319260 */     GIR_RootConstrainSelectedInstOperands,
     /* 319261 */     // GIR_Coverage, 6235,
     /* 319261 */     GIR_EraseRootFromParent_Done,
     /* 319262 */   // Label 6308: @319262
     /* 319262 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(319355), // Rule ID 6279 //
     /* 319267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 319283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 319295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319306 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319318 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319325 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319353 */     GIR_RootConstrainSelectedInstOperands,
     /* 319354 */     // GIR_Coverage, 6279,
     /* 319354 */     GIR_EraseRootFromParent_Done,
     /* 319355 */   // Label 6309: @319355
     /* 319355 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(319451), // Rule ID 6139 //
     /* 319360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 319387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 319391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319402 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319414 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319417 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319421 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319449 */     GIR_RootConstrainSelectedInstOperands,
     /* 319450 */     // GIR_Coverage, 6139,
     /* 319450 */     GIR_EraseRootFromParent_Done,
     /* 319451 */   // Label 6310: @319451
     /* 319451 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(319535), // Rule ID 2542 //
     /* 319456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 319471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319486 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319498 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319501 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319505 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 319521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319533 */     GIR_RootConstrainSelectedInstOperands,
     /* 319534 */     // GIR_Coverage, 2542,
     /* 319534 */     GIR_EraseRootFromParent_Done,
     /* 319535 */   // Label 6311: @319535
     /* 319535 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(319585), // Rule ID 13416 //
     /* 319540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319570 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 319570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 319573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319583 */     GIR_RootConstrainSelectedInstOperands,
     /* 319584 */     // GIR_Coverage, 13416,
     /* 319584 */     GIR_EraseRootFromParent_Done,
     /* 319585 */   // Label 6312: @319585
     /* 319585 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(319669), // Rule ID 6107 //
     /* 319590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 319609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319620 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319632 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319639 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319647 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 319655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319667 */     GIR_RootConstrainSelectedInstOperands,
     /* 319668 */     // GIR_Coverage, 6107,
     /* 319668 */     GIR_EraseRootFromParent_Done,
     /* 319669 */   // Label 6313: @319669
     /* 319669 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(319719), // Rule ID 1308 //
     /* 319674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319704 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 319704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 319707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319717 */     GIR_RootConstrainSelectedInstOperands,
     /* 319718 */     // GIR_Coverage, 1308,
     /* 319718 */     GIR_EraseRootFromParent_Done,
     /* 319719 */   // Label 6314: @319719
     /* 319719 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(319752), // Rule ID 1298 //
     /* 319724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319739 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 319739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 319742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 319750 */     GIR_RootConstrainSelectedInstOperands,
     /* 319751 */     // GIR_Coverage, 1298,
     /* 319751 */     GIR_EraseRootFromParent_Done,
     /* 319752 */   // Label 6315: @319752
     /* 319752 */   GIM_Reject,
     /* 319753 */ // Label 6296: @319753
     /* 319753 */ GIM_Reject,
     /* 319754 */ // Label 6188: @319754
     /* 319754 */ GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(321274),
     /* 319759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 319765 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 319768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319772 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(319850), // Rule ID 6265 //
     /* 319777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319814 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319818 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319822 */     // MIs[3] Operand 1
     /* 319822 */     // No operand predicates
     /* 319822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319832 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319848 */     GIR_RootConstrainSelectedInstOperands,
     /* 319849 */     // GIR_Coverage, 6265,
     /* 319849 */     GIR_EraseRootFromParent_Done,
     /* 319850 */   // Label 6317: @319850
     /* 319850 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(319934), // Rule ID 6177 //
     /* 319855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319887 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319891 */     // MIs[2] Operand 1
     /* 319891 */     // No operand predicates
     /* 319891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 319895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319899 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319903 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319914 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 319917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 319925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319932 */     GIR_RootConstrainSelectedInstOperands,
     /* 319933 */     // GIR_Coverage, 6177,
     /* 319933 */     GIR_EraseRootFromParent_Done,
     /* 319934 */   // Label 6318: @319934
     /* 319934 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(320015), // Rule ID 6209 //
     /* 319939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 319962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 319966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319983 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 319987 */     // MIs[3] Operand 1
     /* 319987 */     // No operand predicates
     /* 319987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319997 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320013 */     GIR_RootConstrainSelectedInstOperands,
     /* 320014 */     // GIR_Coverage, 6209,
     /* 320014 */     GIR_EraseRootFromParent_Done,
     /* 320015 */   // Label 6319: @320015
     /* 320015 */   GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(320099), // Rule ID 6241 //
     /* 320020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320069 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320073 */     // MIs[3] Operand 1
     /* 320073 */     // No operand predicates
     /* 320073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320077 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320079 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320097 */     GIR_RootConstrainSelectedInstOperands,
     /* 320098 */     // GIR_Coverage, 6241,
     /* 320098 */     GIR_EraseRootFromParent_Done,
     /* 320099 */   // Label 6320: @320099
     /* 320099 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(320177), // Rule ID 6287 //
     /* 320104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 320145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320149 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320153 */     // MIs[3] Operand 1
     /* 320153 */     // No operand predicates
     /* 320153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320157 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320159 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320175 */     GIR_RootConstrainSelectedInstOperands,
     /* 320176 */     // GIR_Coverage, 6287,
     /* 320176 */     GIR_EraseRootFromParent_Done,
     /* 320177 */   // Label 6321: @320177
     /* 320177 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(320258), // Rule ID 6145 //
     /* 320182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320230 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320234 */     // MIs[3] Operand 1
     /* 320234 */     // No operand predicates
     /* 320234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320240 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320247 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320256 */     GIR_RootConstrainSelectedInstOperands,
     /* 320257 */     // GIR_Coverage, 6145,
     /* 320257 */     GIR_EraseRootFromParent_Done,
     /* 320258 */   // Label 6322: @320258
     /* 320258 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(320327), // Rule ID 2548 //
     /* 320263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320295 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320299 */     // MIs[2] Operand 1
     /* 320299 */     // No operand predicates
     /* 320299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320309 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 320312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320325 */     GIR_RootConstrainSelectedInstOperands,
     /* 320326 */     // GIR_Coverage, 2548,
     /* 320326 */     GIR_EraseRootFromParent_Done,
     /* 320327 */   // Label 6323: @320327
     /* 320327 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(320396), // Rule ID 6113 //
     /* 320332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320368 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320372 */     // MIs[2] Operand 1
     /* 320372 */     // No operand predicates
     /* 320372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320378 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 320381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320394 */     GIR_RootConstrainSelectedInstOperands,
     /* 320395 */     // GIR_Coverage, 6113,
     /* 320395 */     GIR_EraseRootFromParent_Done,
     /* 320396 */   // Label 6324: @320396
     /* 320396 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(320489), // Rule ID 6267 //
     /* 320401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 320425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320440 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320452 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320459 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320487 */     GIR_RootConstrainSelectedInstOperands,
     /* 320488 */     // GIR_Coverage, 6267,
     /* 320488 */     GIR_EraseRootFromParent_Done,
     /* 320489 */   // Label 6325: @320489
     /* 320489 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(320588), // Rule ID 6179 //
     /* 320494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320537 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320549 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320552 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320556 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 320580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320586 */     GIR_RootConstrainSelectedInstOperands,
     /* 320587 */     // GIR_Coverage, 6179,
     /* 320587 */     GIR_EraseRootFromParent_Done,
     /* 320588 */   // Label 6326: @320588
     /* 320588 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(320684), // Rule ID 6211 //
     /* 320593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 320620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320635 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320647 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320654 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320682 */     GIR_RootConstrainSelectedInstOperands,
     /* 320683 */     // GIR_Coverage, 6211,
     /* 320683 */     GIR_EraseRootFromParent_Done,
     /* 320684 */   // Label 6327: @320684
     /* 320684 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(320783), // Rule ID 6243 //
     /* 320689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 320721 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320732 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320744 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320781 */     GIR_RootConstrainSelectedInstOperands,
     /* 320782 */     // GIR_Coverage, 6243,
     /* 320782 */     GIR_EraseRootFromParent_Done,
     /* 320783 */   // Label 6328: @320783
     /* 320783 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(320876), // Rule ID 6289 //
     /* 320788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 320816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320827 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320839 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320842 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320846 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320874 */     GIR_RootConstrainSelectedInstOperands,
     /* 320875 */     // GIR_Coverage, 6289,
     /* 320875 */     GIR_EraseRootFromParent_Done,
     /* 320876 */   // Label 6329: @320876
     /* 320876 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(320972), // Rule ID 6147 //
     /* 320881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 320912 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320923 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320935 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320942 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 320945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320970 */     GIR_RootConstrainSelectedInstOperands,
     /* 320971 */     // GIR_Coverage, 6147,
     /* 320971 */     GIR_EraseRootFromParent_Done,
     /* 320972 */   // Label 6330: @320972
     /* 320972 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(321056), // Rule ID 2550 //
     /* 320977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321007 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321019 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321022 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321026 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 321042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321054 */     GIR_RootConstrainSelectedInstOperands,
     /* 321055 */     // GIR_Coverage, 2550,
     /* 321055 */     GIR_EraseRootFromParent_Done,
     /* 321056 */   // Label 6331: @321056
     /* 321056 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(321106), // Rule ID 13420 //
     /* 321061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321091 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 321091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 321094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321104 */     GIR_RootConstrainSelectedInstOperands,
     /* 321105 */     // GIR_Coverage, 13420,
     /* 321105 */     GIR_EraseRootFromParent_Done,
     /* 321106 */   // Label 6332: @321106
     /* 321106 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(321190), // Rule ID 6115 //
     /* 321111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 321130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321141 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321153 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321160 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 321176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321188 */     GIR_RootConstrainSelectedInstOperands,
     /* 321189 */     // GIR_Coverage, 6115,
     /* 321189 */     GIR_EraseRootFromParent_Done,
     /* 321190 */   // Label 6333: @321190
     /* 321190 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(321240), // Rule ID 1312 //
     /* 321195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321225 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 321225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 321228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321238 */     GIR_RootConstrainSelectedInstOperands,
     /* 321239 */     // GIR_Coverage, 1312,
     /* 321239 */     GIR_EraseRootFromParent_Done,
     /* 321240 */   // Label 6334: @321240
     /* 321240 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(321273), // Rule ID 1302 //
     /* 321245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321260 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 321260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 321263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321269 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 321271 */     GIR_RootConstrainSelectedInstOperands,
     /* 321272 */     // GIR_Coverage, 1302,
     /* 321272 */     GIR_EraseRootFromParent_Done,
     /* 321273 */   // Label 6335: @321273
     /* 321273 */   GIM_Reject,
     /* 321274 */ // Label 6316: @321274
     /* 321274 */ GIM_Reject,
     /* 321275 */ // Label 6189: @321275
     /* 321275 */ GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(322453),
     /* 321280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 321286 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 321289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321293 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(321377), // Rule ID 6161 //
     /* 321298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 321309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 321322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321330 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 321334 */     // MIs[2] Operand 1
     /* 321334 */     // No operand predicates
     /* 321334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 321338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321342 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321346 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321355 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321357 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 321357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 321368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 321375 */     GIR_RootConstrainSelectedInstOperands,
     /* 321376 */     // GIR_Coverage, 6161,
     /* 321376 */     GIR_EraseRootFromParent_Done,
     /* 321377 */   // Label 6337: @321377
     /* 321377 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(321458), // Rule ID 6193 //
     /* 321382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 321405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 321418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321426 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 321430 */     // MIs[3] Operand 1
     /* 321430 */     // No operand predicates
     /* 321430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321438 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321440 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 321440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321456 */     GIR_RootConstrainSelectedInstOperands,
     /* 321457 */     // GIR_Coverage, 6193,
     /* 321457 */     GIR_EraseRootFromParent_Done,
     /* 321458 */   // Label 6338: @321458
     /* 321458 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(321542), // Rule ID 6225 //
     /* 321463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 321491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321495 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 321504 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321508 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321512 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 321516 */     // MIs[3] Operand 1
     /* 321516 */     // No operand predicates
     /* 321516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321520 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321522 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 321522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321540 */     GIR_RootConstrainSelectedInstOperands,
     /* 321541 */     // GIR_Coverage, 6225,
     /* 321541 */     GIR_EraseRootFromParent_Done,
     /* 321542 */   // Label 6339: @321542
     /* 321542 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(321623), // Rule ID 6129 //
     /* 321547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 321574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321578 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 321582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 321587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 321591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321595 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 321599 */     // MIs[3] Operand 1
     /* 321599 */     // No operand predicates
     /* 321599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 321605 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 321605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 321621 */     GIR_RootConstrainSelectedInstOperands,
     /* 321622 */     // GIR_Coverage, 6129,
     /* 321622 */     GIR_EraseRootFromParent_Done,
     /* 321623 */   // Label 6340: @321623
     /* 321623 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(321692), // Rule ID 2532 //
     /* 321628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 321639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 321652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321660 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 321664 */     // MIs[2] Operand 1
     /* 321664 */     // No operand predicates
     /* 321664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321674 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 321674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 321677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 321690 */     GIR_RootConstrainSelectedInstOperands,
     /* 321691 */     // GIR_Coverage, 2532,
     /* 321691 */     GIR_EraseRootFromParent_Done,
     /* 321692 */   // Label 6341: @321692
     /* 321692 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(321761), // Rule ID 6097 //
     /* 321697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 321712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 321725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321733 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 321737 */     // MIs[2] Operand 1
     /* 321737 */     // No operand predicates
     /* 321737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321743 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 321743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 321746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321750 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 321759 */     GIR_RootConstrainSelectedInstOperands,
     /* 321760 */     // GIR_Coverage, 6097,
     /* 321760 */     GIR_EraseRootFromParent_Done,
     /* 321761 */   // Label 6342: @321761
     /* 321761 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(321860), // Rule ID 6163 //
     /* 321766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 321781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321809 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 321812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321821 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321824 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321828 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 321852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321858 */     GIR_RootConstrainSelectedInstOperands,
     /* 321859 */     // GIR_Coverage, 6163,
     /* 321859 */     GIR_EraseRootFromParent_Done,
     /* 321860 */   // Label 6343: @321860
     /* 321860 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(321956), // Rule ID 6195 //
     /* 321865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321907 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 321910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321919 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321926 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 321929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 321942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321954 */     GIR_RootConstrainSelectedInstOperands,
     /* 321955 */     // GIR_Coverage, 6195,
     /* 321955 */     GIR_EraseRootFromParent_Done,
     /* 321956 */   // Label 6344: @321956
     /* 321956 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(322055), // Rule ID 6227 //
     /* 321961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 321993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 321998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322004 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 322007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322016 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322019 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322023 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322053 */     GIR_RootConstrainSelectedInstOperands,
     /* 322054 */     // GIR_Coverage, 6227,
     /* 322054 */     GIR_EraseRootFromParent_Done,
     /* 322055 */   // Label 6345: @322055
     /* 322055 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(322151), // Rule ID 6131 //
     /* 322060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322091 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322102 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 322105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322114 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322117 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322121 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322141 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322149 */     GIR_RootConstrainSelectedInstOperands,
     /* 322150 */     // GIR_Coverage, 6131,
     /* 322150 */     GIR_EraseRootFromParent_Done,
     /* 322151 */   // Label 6346: @322151
     /* 322151 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(322235), // Rule ID 2534 //
     /* 322156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322186 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 322189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322198 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322205 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 322221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322233 */     GIR_RootConstrainSelectedInstOperands,
     /* 322234 */     // GIR_Coverage, 2534,
     /* 322234 */     GIR_EraseRootFromParent_Done,
     /* 322235 */   // Label 6347: @322235
     /* 322235 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(322285), // Rule ID 13412 //
     /* 322240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322270 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 322270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 322273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322283 */     GIR_RootConstrainSelectedInstOperands,
     /* 322284 */     // GIR_Coverage, 13412,
     /* 322284 */     GIR_EraseRootFromParent_Done,
     /* 322285 */   // Label 6348: @322285
     /* 322285 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(322369), // Rule ID 6099 //
     /* 322290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322320 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 322323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322332 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322335 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322339 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 322355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322359 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322367 */     GIR_RootConstrainSelectedInstOperands,
     /* 322368 */     // GIR_Coverage, 6099,
     /* 322368 */     GIR_EraseRootFromParent_Done,
     /* 322369 */   // Label 6349: @322369
     /* 322369 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(322419), // Rule ID 1304 //
     /* 322374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322404 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 322404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 322407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322417 */     GIR_RootConstrainSelectedInstOperands,
     /* 322418 */     // GIR_Coverage, 1304,
     /* 322418 */     GIR_EraseRootFromParent_Done,
     /* 322419 */   // Label 6350: @322419
     /* 322419 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(322452), // Rule ID 1294 //
     /* 322424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322439 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 322439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 322442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 322450 */     GIR_RootConstrainSelectedInstOperands,
     /* 322451 */     // GIR_Coverage, 1294,
     /* 322451 */     GIR_EraseRootFromParent_Done,
     /* 322452 */   // Label 6351: @322452
     /* 322452 */   GIM_Reject,
     /* 322453 */ // Label 6336: @322453
     /* 322453 */ GIM_Reject,
     /* 322454 */ // Label 6190: @322454
     /* 322454 */ GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(323974),
     /* 322459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 322465 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 322468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322472 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(322550), // Rule ID 6259 //
     /* 322477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 322514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322518 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322522 */     // MIs[3] Operand 1
     /* 322522 */     // No operand predicates
     /* 322522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322532 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322548 */     GIR_RootConstrainSelectedInstOperands,
     /* 322549 */     // GIR_Coverage, 6259,
     /* 322549 */     GIR_EraseRootFromParent_Done,
     /* 322550 */   // Label 6353: @322550
     /* 322550 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(322634), // Rule ID 6173 //
     /* 322555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322587 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322591 */     // MIs[2] Operand 1
     /* 322591 */     // No operand predicates
     /* 322591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322599 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322603 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322612 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322614 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 322625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322632 */     GIR_RootConstrainSelectedInstOperands,
     /* 322633 */     // GIR_Coverage, 6173,
     /* 322633 */     GIR_EraseRootFromParent_Done,
     /* 322634 */   // Label 6354: @322634
     /* 322634 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(322715), // Rule ID 6205 //
     /* 322639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322683 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322687 */     // MIs[3] Operand 1
     /* 322687 */     // No operand predicates
     /* 322687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322697 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322713 */     GIR_RootConstrainSelectedInstOperands,
     /* 322714 */     // GIR_Coverage, 6205,
     /* 322714 */     GIR_EraseRootFromParent_Done,
     /* 322715 */   // Label 6355: @322715
     /* 322715 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(322799), // Rule ID 6237 //
     /* 322720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322765 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322769 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322773 */     // MIs[3] Operand 1
     /* 322773 */     // No operand predicates
     /* 322773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322779 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322797 */     GIR_RootConstrainSelectedInstOperands,
     /* 322798 */     // GIR_Coverage, 6237,
     /* 322798 */     GIR_EraseRootFromParent_Done,
     /* 322799 */   // Label 6356: @322799
     /* 322799 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(322877), // Rule ID 6281 //
     /* 322804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 322845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322849 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322853 */     // MIs[3] Operand 1
     /* 322853 */     // No operand predicates
     /* 322853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322857 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322859 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322875 */     GIR_RootConstrainSelectedInstOperands,
     /* 322876 */     // GIR_Coverage, 6281,
     /* 322876 */     GIR_EraseRootFromParent_Done,
     /* 322877 */   // Label 6357: @322877
     /* 322877 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(322958), // Rule ID 6141 //
     /* 322882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322913 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322930 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322934 */     // MIs[3] Operand 1
     /* 322934 */     // No operand predicates
     /* 322934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322940 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 322940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 322943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322947 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322956 */     GIR_RootConstrainSelectedInstOperands,
     /* 322957 */     // GIR_Coverage, 6141,
     /* 322957 */     GIR_EraseRootFromParent_Done,
     /* 322958 */   // Label 6358: @322958
     /* 322958 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(323027), // Rule ID 2544 //
     /* 322963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 322974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322995 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 322999 */     // MIs[2] Operand 1
     /* 322999 */     // No operand predicates
     /* 322999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323009 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 323012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323025 */     GIR_RootConstrainSelectedInstOperands,
     /* 323026 */     // GIR_Coverage, 2544,
     /* 323026 */     GIR_EraseRootFromParent_Done,
     /* 323027 */   // Label 6359: @323027
     /* 323027 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(323096), // Rule ID 6109 //
     /* 323032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323068 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323072 */     // MIs[2] Operand 1
     /* 323072 */     // No operand predicates
     /* 323072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323078 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 323081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323094 */     GIR_RootConstrainSelectedInstOperands,
     /* 323095 */     // GIR_Coverage, 6109,
     /* 323095 */     GIR_EraseRootFromParent_Done,
     /* 323096 */   // Label 6360: @323096
     /* 323096 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(323189), // Rule ID 6263 //
     /* 323101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 323113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 323125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323140 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323152 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323155 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323159 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323187 */     GIR_RootConstrainSelectedInstOperands,
     /* 323188 */     // GIR_Coverage, 6263,
     /* 323188 */     GIR_EraseRootFromParent_Done,
     /* 323189 */   // Label 6361: @323189
     /* 323189 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(323288), // Rule ID 6175 //
     /* 323194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 323209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323237 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323249 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323252 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323256 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 323280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323286 */     GIR_RootConstrainSelectedInstOperands,
     /* 323287 */     // GIR_Coverage, 6175,
     /* 323287 */     GIR_EraseRootFromParent_Done,
     /* 323288 */   // Label 6362: @323288
     /* 323288 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(323384), // Rule ID 6207 //
     /* 323293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 323320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323335 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323347 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323354 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323382 */     GIR_RootConstrainSelectedInstOperands,
     /* 323383 */     // GIR_Coverage, 6207,
     /* 323383 */     GIR_EraseRootFromParent_Done,
     /* 323384 */   // Label 6363: @323384
     /* 323384 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(323483), // Rule ID 6239 //
     /* 323389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 323421 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323432 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323444 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323447 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323451 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323481 */     GIR_RootConstrainSelectedInstOperands,
     /* 323482 */     // GIR_Coverage, 6239,
     /* 323482 */     GIR_EraseRootFromParent_Done,
     /* 323483 */   // Label 6364: @323483
     /* 323483 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(323576), // Rule ID 6285 //
     /* 323488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 323504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 323516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323527 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323539 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323546 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323574 */     GIR_RootConstrainSelectedInstOperands,
     /* 323575 */     // GIR_Coverage, 6285,
     /* 323575 */     GIR_EraseRootFromParent_Done,
     /* 323576 */   // Label 6365: @323576
     /* 323576 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(323672), // Rule ID 6143 //
     /* 323581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 323608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 323612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323623 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323635 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323642 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323670 */     GIR_RootConstrainSelectedInstOperands,
     /* 323671 */     // GIR_Coverage, 6143,
     /* 323671 */     GIR_EraseRootFromParent_Done,
     /* 323672 */   // Label 6366: @323672
     /* 323672 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(323756), // Rule ID 2546 //
     /* 323677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 323692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323707 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323719 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323722 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323726 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 323742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323754 */     GIR_RootConstrainSelectedInstOperands,
     /* 323755 */     // GIR_Coverage, 2546,
     /* 323755 */     GIR_EraseRootFromParent_Done,
     /* 323756 */   // Label 6367: @323756
     /* 323756 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(323806), // Rule ID 13418 //
     /* 323761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323791 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 323794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323804 */     GIR_RootConstrainSelectedInstOperands,
     /* 323805 */     // GIR_Coverage, 13418,
     /* 323805 */     GIR_EraseRootFromParent_Done,
     /* 323806 */   // Label 6368: @323806
     /* 323806 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(323890), // Rule ID 6111 //
     /* 323811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 323830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323841 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323853 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323860 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 323876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323888 */     GIR_RootConstrainSelectedInstOperands,
     /* 323889 */     // GIR_Coverage, 6111,
     /* 323889 */     GIR_EraseRootFromParent_Done,
     /* 323890 */   // Label 6369: @323890
     /* 323890 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(323940), // Rule ID 1310 //
     /* 323895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323925 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 323928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323938 */     GIR_RootConstrainSelectedInstOperands,
     /* 323939 */     // GIR_Coverage, 1310,
     /* 323939 */     GIR_EraseRootFromParent_Done,
     /* 323940 */   // Label 6370: @323940
     /* 323940 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(323973), // Rule ID 1300 //
     /* 323945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323960 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 323963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323969 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 323971 */     GIR_RootConstrainSelectedInstOperands,
     /* 323972 */     // GIR_Coverage, 1300,
     /* 323972 */     GIR_EraseRootFromParent_Done,
     /* 323973 */   // Label 6371: @323973
     /* 323973 */   GIM_Reject,
     /* 323974 */ // Label 6352: @323974
     /* 323974 */ GIM_Reject,
     /* 323975 */ // Label 6191: @323975
     /* 323975 */ GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(325153),
     /* 323980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323986 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 323989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323993 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(324077), // Rule ID 6157 //
     /* 323998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 324009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 324022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324030 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 324034 */     // MIs[2] Operand 1
     /* 324034 */     // No operand predicates
     /* 324034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324038 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324042 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324046 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324055 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324057 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 324057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 324068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 324075 */     GIR_RootConstrainSelectedInstOperands,
     /* 324076 */     // GIR_Coverage, 6157,
     /* 324076 */     GIR_EraseRootFromParent_Done,
     /* 324077 */   // Label 6373: @324077
     /* 324077 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(324158), // Rule ID 6189 //
     /* 324082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 324105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 324113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 324118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 324122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324126 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 324130 */     // MIs[3] Operand 1
     /* 324130 */     // No operand predicates
     /* 324130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324140 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 324140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324156 */     GIR_RootConstrainSelectedInstOperands,
     /* 324157 */     // GIR_Coverage, 6189,
     /* 324157 */     GIR_EraseRootFromParent_Done,
     /* 324158 */   // Label 6374: @324158
     /* 324158 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(324242), // Rule ID 6221 //
     /* 324163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 324191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324195 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 324199 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 324204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 324208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324212 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 324216 */     // MIs[3] Operand 1
     /* 324216 */     // No operand predicates
     /* 324216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324222 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 324222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324240 */     GIR_RootConstrainSelectedInstOperands,
     /* 324241 */     // GIR_Coverage, 6221,
     /* 324241 */     GIR_EraseRootFromParent_Done,
     /* 324242 */   // Label 6375: @324242
     /* 324242 */   GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(324323), // Rule ID 6125 //
     /* 324247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 324274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 324282 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 324287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 324291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324295 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 324299 */     // MIs[3] Operand 1
     /* 324299 */     // No operand predicates
     /* 324299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324305 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 324305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324321 */     GIR_RootConstrainSelectedInstOperands,
     /* 324322 */     // GIR_Coverage, 6125,
     /* 324322 */     GIR_EraseRootFromParent_Done,
     /* 324323 */   // Label 6376: @324323
     /* 324323 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(324392), // Rule ID 2528 //
     /* 324328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 324339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 324352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324360 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 324364 */     // MIs[2] Operand 1
     /* 324364 */     // No operand predicates
     /* 324364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324374 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 324374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 324377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 324390 */     GIR_RootConstrainSelectedInstOperands,
     /* 324391 */     // GIR_Coverage, 2528,
     /* 324391 */     GIR_EraseRootFromParent_Done,
     /* 324392 */   // Label 6377: @324392
     /* 324392 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(324461), // Rule ID 6093 //
     /* 324397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 324412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 324425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324433 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 324437 */     // MIs[2] Operand 1
     /* 324437 */     // No operand predicates
     /* 324437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324443 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 324443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 324446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 324459 */     GIR_RootConstrainSelectedInstOperands,
     /* 324460 */     // GIR_Coverage, 6093,
     /* 324460 */     GIR_EraseRootFromParent_Done,
     /* 324461 */   // Label 6378: @324461
     /* 324461 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(324560), // Rule ID 6159 //
     /* 324466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324509 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 324512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324521 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324524 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324528 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 324531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 324552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324558 */     GIR_RootConstrainSelectedInstOperands,
     /* 324559 */     // GIR_Coverage, 6159,
     /* 324559 */     GIR_EraseRootFromParent_Done,
     /* 324560 */   // Label 6379: @324560
     /* 324560 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(324656), // Rule ID 6191 //
     /* 324565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 324588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324607 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 324610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324619 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324626 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 324629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324654 */     GIR_RootConstrainSelectedInstOperands,
     /* 324655 */     // GIR_Coverage, 6191,
     /* 324655 */     GIR_EraseRootFromParent_Done,
     /* 324656 */   // Label 6380: @324656
     /* 324656 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(324755), // Rule ID 6223 //
     /* 324661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 324689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324704 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 324707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324716 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324719 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324723 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 324726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324753 */     GIR_RootConstrainSelectedInstOperands,
     /* 324754 */     // GIR_Coverage, 6223,
     /* 324754 */     GIR_EraseRootFromParent_Done,
     /* 324755 */   // Label 6381: @324755
     /* 324755 */   GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(324851), // Rule ID 6127 //
     /* 324760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 324787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 324791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324802 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 324805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324814 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324821 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 324824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324849 */     GIR_RootConstrainSelectedInstOperands,
     /* 324850 */     // GIR_Coverage, 6127,
     /* 324850 */     GIR_EraseRootFromParent_Done,
     /* 324851 */   // Label 6382: @324851
     /* 324851 */   GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(324935), // Rule ID 2530 //
     /* 324856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 324871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324886 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 324889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324898 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324901 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324905 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 324908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 324918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 324921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324933 */     GIR_RootConstrainSelectedInstOperands,
     /* 324934 */     // GIR_Coverage, 2530,
     /* 324934 */     GIR_EraseRootFromParent_Done,
     /* 324935 */   // Label 6383: @324935
     /* 324935 */   GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(324985), // Rule ID 13414 //
     /* 324940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324970 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 324973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324983 */     GIR_RootConstrainSelectedInstOperands,
     /* 324984 */     // GIR_Coverage, 13414,
     /* 324984 */     GIR_EraseRootFromParent_Done,
     /* 324985 */   // Label 6384: @324985
     /* 324985 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(325069), // Rule ID 6095 //
     /* 324990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 325005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325020 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 325023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325032 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325035 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325039 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 325042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 325055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325067 */     GIR_RootConstrainSelectedInstOperands,
     /* 325068 */     // GIR_Coverage, 6095,
     /* 325068 */     GIR_EraseRootFromParent_Done,
     /* 325069 */   // Label 6385: @325069
     /* 325069 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(325119), // Rule ID 1306 //
     /* 325074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325104 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 325107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325117 */     GIR_RootConstrainSelectedInstOperands,
     /* 325118 */     // GIR_Coverage, 1306,
     /* 325118 */     GIR_EraseRootFromParent_Done,
     /* 325119 */   // Label 6386: @325119
     /* 325119 */   GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(325152), // Rule ID 1296 //
     /* 325124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325139 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 325142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 325150 */     GIR_RootConstrainSelectedInstOperands,
     /* 325151 */     // GIR_Coverage, 1296,
     /* 325151 */     GIR_EraseRootFromParent_Done,
     /* 325152 */   // Label 6387: @325152
     /* 325152 */   GIM_Reject,
     /* 325153 */ // Label 6372: @325153
     /* 325153 */ GIM_Reject,
     /* 325154 */ // Label 6192: @325154
     /* 325154 */ GIM_Reject,
     /* 325155 */ // Label 63: @325155
     /* 325155 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6396*/ GIMT_Encode4(325770),
     /* 325166 */ /*GILLT_s16*//*Label 6388*/ GIMT_Encode4(325206),
     /* 325170 */ /*GILLT_s32*//*Label 6389*/ GIMT_Encode4(325244),
     /* 325174 */ /*GILLT_s64*//*Label 6390*/ GIMT_Encode4(325282), GIMT_Encode4(0),
     /* 325182 */ /*GILLT_v2s32*//*Label 6391*/ GIMT_Encode4(325320),
     /* 325186 */ /*GILLT_v2s64*//*Label 6392*/ GIMT_Encode4(325358),
     /* 325190 */ /*GILLT_v4s16*//*Label 6393*/ GIMT_Encode4(325396),
     /* 325194 */ /*GILLT_v4s32*//*Label 6394*/ GIMT_Encode4(325434), GIMT_Encode4(0),
     /* 325202 */ /*GILLT_v8s16*//*Label 6395*/ GIMT_Encode4(325472),
     /* 325206 */ // Label 6388: @325206
     /* 325206 */ GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(325243), // Rule ID 590 //
     /* 325211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 325217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 325220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325232 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 325232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 325237 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325241 */   GIR_RootConstrainSelectedInstOperands,
     /* 325242 */   // GIR_Coverage, 590,
     /* 325242 */   GIR_Done,
     /* 325243 */ // Label 6397: @325243
     /* 325243 */ GIM_Reject,
     /* 325244 */ // Label 6389: @325244
     /* 325244 */ GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(325281), // Rule ID 592 //
     /* 325249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 325252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 325258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325270 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 325270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 325275 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325279 */   GIR_RootConstrainSelectedInstOperands,
     /* 325280 */   // GIR_Coverage, 592,
     /* 325280 */   GIR_Done,
     /* 325281 */ // Label 6398: @325281
     /* 325281 */ GIM_Reject,
     /* 325282 */ // Label 6390: @325282
     /* 325282 */ GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(325319), // Rule ID 594 //
     /* 325287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 325290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 325296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325308 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 325308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 325313 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325317 */   GIR_RootConstrainSelectedInstOperands,
     /* 325318 */   // GIR_Coverage, 594,
     /* 325318 */   GIR_Done,
     /* 325319 */ // Label 6399: @325319
     /* 325319 */ GIM_Reject,
     /* 325320 */ // Label 6391: @325320
     /* 325320 */ GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(325357), // Rule ID 1228 //
     /* 325325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 325334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325346 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 325346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 325351 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325355 */   GIR_RootConstrainSelectedInstOperands,
     /* 325356 */   // GIR_Coverage, 1228,
     /* 325356 */   GIR_Done,
     /* 325357 */ // Label 6400: @325357
     /* 325357 */ GIM_Reject,
     /* 325358 */ // Label 6392: @325358
     /* 325358 */ GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(325395), // Rule ID 1232 //
     /* 325363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 325372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325384 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 325384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 325389 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325393 */   GIR_RootConstrainSelectedInstOperands,
     /* 325394 */   // GIR_Coverage, 1232,
     /* 325394 */   GIR_Done,
     /* 325395 */ // Label 6401: @325395
     /* 325395 */ GIM_Reject,
     /* 325396 */ // Label 6393: @325396
     /* 325396 */ GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(325433), // Rule ID 1224 //
     /* 325401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325418 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325422 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 325422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 325427 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325431 */   GIR_RootConstrainSelectedInstOperands,
     /* 325432 */   // GIR_Coverage, 1224,
     /* 325432 */   GIR_Done,
     /* 325433 */ // Label 6402: @325433
     /* 325433 */ GIM_Reject,
     /* 325434 */ // Label 6394: @325434
     /* 325434 */ GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(325471), // Rule ID 1230 //
     /* 325439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 325448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325460 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 325465 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325469 */   GIR_RootConstrainSelectedInstOperands,
     /* 325470 */   // GIR_Coverage, 1230,
     /* 325470 */   GIR_Done,
     /* 325471 */ // Label 6403: @325471
     /* 325471 */ GIM_Reject,
     /* 325472 */ // Label 6395: @325472
     /* 325472 */ GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(325769),
     /* 325477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325495 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(325514), // Rule ID 1226 //
     /* 325500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325503 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 325508 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325512 */     GIR_RootConstrainSelectedInstOperands,
     /* 325513 */     // GIR_Coverage, 1226,
     /* 325513 */     GIR_Done,
     /* 325514 */   // Label 6405: @325514
     /* 325514 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(325768), // Rule ID 7060 //
     /* 325519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 325522 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 325522 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 325525 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 325529 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325534 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 325538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 325540 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 325543 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 325547 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325552 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 325556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 325558 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 325561 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 325565 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325570 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 325573 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 325576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 325578 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 325581 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325585 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325590 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 325596 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325601 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325606 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 325609 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 325613 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325618 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 325621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 325623 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 325626 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325630 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325635 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 325641 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325646 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325651 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 325654 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 325658 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325663 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 325666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 325668 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 325671 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 325675 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325680 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 325683 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 325686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 325688 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 325691 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 325695 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325700 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 325703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 325705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 325708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 325712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 325719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 325722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 325726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325731 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 325734 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 325737 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 325740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 325758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 325766 */     GIR_RootConstrainSelectedInstOperands,
     /* 325767 */     // GIR_Coverage, 7060,
     /* 325767 */     GIR_EraseRootFromParent_Done,
     /* 325768 */   // Label 6406: @325768
     /* 325768 */   GIM_Reject,
     /* 325769 */ // Label 6404: @325769
     /* 325769 */ GIM_Reject,
     /* 325770 */ // Label 6396: @325770
     /* 325770 */ GIM_Reject,
     /* 325771 */ // Label 64: @325771
     /* 325771 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6415*/ GIMT_Encode4(329277),
     /* 325782 */ /*GILLT_s16*//*Label 6407*/ GIMT_Encode4(325822),
     /* 325786 */ /*GILLT_s32*//*Label 6408*/ GIMT_Encode4(326990),
     /* 325790 */ /*GILLT_s64*//*Label 6409*/ GIMT_Encode4(328013), GIMT_Encode4(0),
     /* 325798 */ /*GILLT_v2s32*//*Label 6410*/ GIMT_Encode4(329036),
     /* 325802 */ /*GILLT_v2s64*//*Label 6411*/ GIMT_Encode4(329063),
     /* 325806 */ /*GILLT_v4s16*//*Label 6412*/ GIMT_Encode4(329090),
     /* 325810 */ /*GILLT_v4s32*//*Label 6413*/ GIMT_Encode4(329170), GIMT_Encode4(0),
     /* 325818 */ /*GILLT_v8s16*//*Label 6414*/ GIMT_Encode4(329197),
     /* 325822 */ // Label 6407: @325822
     /* 325822 */ GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(326989),
     /* 325827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 325830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325834 */   GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(325992), // Rule ID 4883 //
     /* 325839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 325850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 325858 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 325862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 325878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325883 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 325887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 325891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 325895 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325899 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 325903 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325908 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 325912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 325919 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 325919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 325922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325931 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 325937 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325942 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 325950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 325954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325959 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 325965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 325978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 325986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 325990 */     GIR_RootConstrainSelectedInstOperands,
     /* 325991 */     // GIR_Coverage, 4883,
     /* 325991 */     GIR_EraseRootFromParent_Done,
     /* 325992 */   // Label 6417: @325992
     /* 325992 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(326150), // Rule ID 4882 //
     /* 325997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326016 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326041 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 326049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326053 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326057 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 326061 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326066 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 326070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326077 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 326077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 326080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326089 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 326095 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326100 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 326108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326117 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 326123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 326144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326148 */     GIR_RootConstrainSelectedInstOperands,
     /* 326149 */     // GIR_Coverage, 4882,
     /* 326149 */     GIR_EraseRootFromParent_Done,
     /* 326150 */   // Label 6418: @326150
     /* 326150 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(326261), // Rule ID 4881 //
     /* 326155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326174 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326190 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326199 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326215 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 326215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 326218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326227 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 326233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326259 */     GIR_RootConstrainSelectedInstOperands,
     /* 326260 */     // GIR_Coverage, 4881,
     /* 326260 */     GIR_EraseRootFromParent_Done,
     /* 326261 */   // Label 6419: @326261
     /* 326261 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(326372), // Rule ID 4879 //
     /* 326266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326285 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326306 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326315 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326326 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 326326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 326329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326338 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 326344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326370 */     GIR_RootConstrainSelectedInstOperands,
     /* 326371 */     // GIR_Coverage, 4879,
     /* 326371 */     GIR_EraseRootFromParent_Done,
     /* 326372 */   // Label 6420: @326372
     /* 326372 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(326483), // Rule ID 4880 //
     /* 326377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326396 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326412 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326421 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326437 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 326437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 326440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326449 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 326455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326481 */     GIR_RootConstrainSelectedInstOperands,
     /* 326482 */     // GIR_Coverage, 4880,
     /* 326482 */     GIR_EraseRootFromParent_Done,
     /* 326483 */   // Label 6421: @326483
     /* 326483 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(326594), // Rule ID 4878 //
     /* 326488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326507 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326537 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326548 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 326548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 326551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326560 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 326566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326592 */     GIR_RootConstrainSelectedInstOperands,
     /* 326593 */     // GIR_Coverage, 4878,
     /* 326593 */     GIR_EraseRootFromParent_Done,
     /* 326594 */   // Label 6422: @326594
     /* 326594 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(326658), // Rule ID 650 //
     /* 326599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326618 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326639 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 326639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326656 */     GIR_RootConstrainSelectedInstOperands,
     /* 326657 */     // GIR_Coverage, 650,
     /* 326657 */     GIR_EraseRootFromParent_Done,
     /* 326658 */   // Label 6423: @326658
     /* 326658 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(326722), // Rule ID 649 //
     /* 326663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326682 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326703 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 326703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326720 */     GIR_RootConstrainSelectedInstOperands,
     /* 326721 */     // GIR_Coverage, 649,
     /* 326721 */     GIR_EraseRootFromParent_Done,
     /* 326722 */   // Label 6424: @326722
     /* 326722 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(326773), // Rule ID 626 //
     /* 326727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 326738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326758 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 326758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 326761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326771 */     GIR_RootConstrainSelectedInstOperands,
     /* 326772 */     // GIR_Coverage, 626,
     /* 326772 */     GIR_EraseRootFromParent_Done,
     /* 326773 */   // Label 6425: @326773
     /* 326773 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(326824), // Rule ID 625 //
     /* 326778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 326789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326809 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 326809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 326812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 326818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326822 */     GIR_RootConstrainSelectedInstOperands,
     /* 326823 */     // GIR_Coverage, 625,
     /* 326823 */     GIR_EraseRootFromParent_Done,
     /* 326824 */   // Label 6426: @326824
     /* 326824 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(326843), // Rule ID 524 //
     /* 326829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326836 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 326836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 326841 */     GIR_RootConstrainSelectedInstOperands,
     /* 326842 */     // GIR_Coverage, 524,
     /* 326842 */     GIR_Done,
     /* 326843 */   // Label 6427: @326843
     /* 326843 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(326988), // Rule ID 6425 //
     /* 326848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326852 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 326852 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 326855 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326859 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 326866 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 326869 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326873 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326878 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 326881 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 326885 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 326888 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326893 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326898 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326903 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 326906 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326910 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326915 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 326918 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326923 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 326926 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 326930 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326935 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 326938 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 326943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 326948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326957 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326970 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 326977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 326987 */     // GIR_Coverage, 6425,
     /* 326987 */     GIR_EraseRootFromParent_Done,
     /* 326988 */   // Label 6428: @326988
     /* 326988 */   GIM_Reject,
     /* 326989 */ // Label 6416: @326989
     /* 326989 */ GIM_Reject,
     /* 326990 */ // Label 6408: @326990
     /* 326990 */ GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(328012),
     /* 326995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327002 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(327160), // Rule ID 4889 //
     /* 327007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327026 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327046 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327051 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327063 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327067 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 327071 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327076 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 327080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327087 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 327087 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 327090 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327094 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327099 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 327105 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327110 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327127 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 327133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 327154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327158 */     GIR_RootConstrainSelectedInstOperands,
     /* 327159 */     // GIR_Coverage, 4889,
     /* 327159 */     GIR_EraseRootFromParent_Done,
     /* 327160 */   // Label 6430: @327160
     /* 327160 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(327318), // Rule ID 4888 //
     /* 327165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327184 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327200 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327209 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327221 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327225 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 327229 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327234 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 327238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327245 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 327245 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 327248 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327252 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327257 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 327263 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327268 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327285 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 327291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 327312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327316 */     GIR_RootConstrainSelectedInstOperands,
     /* 327317 */     // GIR_Coverage, 4888,
     /* 327317 */     GIR_EraseRootFromParent_Done,
     /* 327318 */   // Label 6431: @327318
     /* 327318 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(327429), // Rule ID 4887 //
     /* 327323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327342 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327367 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327383 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 327383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327395 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 327401 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327427 */     GIR_RootConstrainSelectedInstOperands,
     /* 327428 */     // GIR_Coverage, 4887,
     /* 327428 */     GIR_EraseRootFromParent_Done,
     /* 327429 */   // Label 6432: @327429
     /* 327429 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(327540), // Rule ID 4885 //
     /* 327434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327453 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327483 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327494 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 327494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327506 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 327512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327538 */     GIR_RootConstrainSelectedInstOperands,
     /* 327539 */     // GIR_Coverage, 4885,
     /* 327539 */     GIR_EraseRootFromParent_Done,
     /* 327540 */   // Label 6433: @327540
     /* 327540 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(327651), // Rule ID 4886 //
     /* 327545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327564 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327589 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327605 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 327605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327617 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 327623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327649 */     GIR_RootConstrainSelectedInstOperands,
     /* 327650 */     // GIR_Coverage, 4886,
     /* 327650 */     GIR_EraseRootFromParent_Done,
     /* 327651 */   // Label 6434: @327651
     /* 327651 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(327762), // Rule ID 4884 //
     /* 327656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327675 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327700 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327705 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327716 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 327716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327728 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 327734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327760 */     GIR_RootConstrainSelectedInstOperands,
     /* 327761 */     // GIR_Coverage, 4884,
     /* 327761 */     GIR_EraseRootFromParent_Done,
     /* 327762 */   // Label 6435: @327762
     /* 327762 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(327826), // Rule ID 652 //
     /* 327767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327786 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327807 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 327807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327824 */     GIR_RootConstrainSelectedInstOperands,
     /* 327825 */     // GIR_Coverage, 652,
     /* 327825 */     GIR_EraseRootFromParent_Done,
     /* 327826 */   // Label 6436: @327826
     /* 327826 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(327890), // Rule ID 651 //
     /* 327831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327850 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327871 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 327871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327888 */     GIR_RootConstrainSelectedInstOperands,
     /* 327889 */     // GIR_Coverage, 651,
     /* 327889 */     GIR_EraseRootFromParent_Done,
     /* 327890 */   // Label 6437: @327890
     /* 327890 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(327941), // Rule ID 628 //
     /* 327895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 327906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327926 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 327926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 327929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327939 */     GIR_RootConstrainSelectedInstOperands,
     /* 327940 */     // GIR_Coverage, 628,
     /* 327940 */     GIR_EraseRootFromParent_Done,
     /* 327941 */   // Label 6438: @327941
     /* 327941 */   GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(327992), // Rule ID 627 //
     /* 327946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 327957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327977 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 327977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 327980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327990 */     GIR_RootConstrainSelectedInstOperands,
     /* 327991 */     // GIR_Coverage, 627,
     /* 327991 */     GIR_EraseRootFromParent_Done,
     /* 327992 */   // Label 6439: @327992
     /* 327992 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(328011), // Rule ID 525 //
     /* 327997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328004 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 328004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 328009 */     GIR_RootConstrainSelectedInstOperands,
     /* 328010 */     // GIR_Coverage, 525,
     /* 328010 */     GIR_Done,
     /* 328011 */   // Label 6440: @328011
     /* 328011 */   GIM_Reject,
     /* 328012 */ // Label 6429: @328012
     /* 328012 */ GIM_Reject,
     /* 328013 */ // Label 6409: @328013
     /* 328013 */ GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(329035),
     /* 328018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328025 */   GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(328183), // Rule ID 4895 //
     /* 328030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328049 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328065 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328074 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328086 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328090 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 328094 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328099 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 328103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328110 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 328110 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 328113 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328117 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328122 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 328128 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328133 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328150 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 328177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328181 */     GIR_RootConstrainSelectedInstOperands,
     /* 328182 */     // GIR_Coverage, 4895,
     /* 328182 */     GIR_EraseRootFromParent_Done,
     /* 328183 */   // Label 6442: @328183
     /* 328183 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(328341), // Rule ID 4894 //
     /* 328188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328207 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328223 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328232 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328244 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328248 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 328252 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328257 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 328261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328268 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 328268 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 328271 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328275 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328280 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 328286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328291 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328308 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 328335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328339 */     GIR_RootConstrainSelectedInstOperands,
     /* 328340 */     // GIR_Coverage, 4894,
     /* 328340 */     GIR_EraseRootFromParent_Done,
     /* 328341 */   // Label 6443: @328341
     /* 328341 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(328452), // Rule ID 4893 //
     /* 328346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328365 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328390 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328406 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 328406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328418 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328450 */     GIR_RootConstrainSelectedInstOperands,
     /* 328451 */     // GIR_Coverage, 4893,
     /* 328451 */     GIR_EraseRootFromParent_Done,
     /* 328452 */   // Label 6444: @328452
     /* 328452 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(328563), // Rule ID 4891 //
     /* 328457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328476 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328501 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328506 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328517 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 328517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328529 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 328535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328561 */     GIR_RootConstrainSelectedInstOperands,
     /* 328562 */     // GIR_Coverage, 4891,
     /* 328562 */     GIR_EraseRootFromParent_Done,
     /* 328563 */   // Label 6445: @328563
     /* 328563 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(328674), // Rule ID 4892 //
     /* 328568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328587 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328607 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328612 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328628 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 328628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328640 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328646 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328651 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328672 */     GIR_RootConstrainSelectedInstOperands,
     /* 328673 */     // GIR_Coverage, 4892,
     /* 328673 */     GIR_EraseRootFromParent_Done,
     /* 328674 */   // Label 6446: @328674
     /* 328674 */   GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(328785), // Rule ID 4890 //
     /* 328679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328698 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328728 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328739 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 328739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328751 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 328757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328783 */     GIR_RootConstrainSelectedInstOperands,
     /* 328784 */     // GIR_Coverage, 4890,
     /* 328784 */     GIR_EraseRootFromParent_Done,
     /* 328785 */   // Label 6447: @328785
     /* 328785 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(328849), // Rule ID 654 //
     /* 328790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328809 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328830 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 328830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328847 */     GIR_RootConstrainSelectedInstOperands,
     /* 328848 */     // GIR_Coverage, 654,
     /* 328848 */     GIR_EraseRootFromParent_Done,
     /* 328849 */   // Label 6448: @328849
     /* 328849 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(328913), // Rule ID 653 //
     /* 328854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328873 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328894 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 328894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328911 */     GIR_RootConstrainSelectedInstOperands,
     /* 328912 */     // GIR_Coverage, 653,
     /* 328912 */     GIR_EraseRootFromParent_Done,
     /* 328913 */   // Label 6449: @328913
     /* 328913 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(328964), // Rule ID 630 //
     /* 328918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 328929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328949 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 328949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 328952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328962 */     GIR_RootConstrainSelectedInstOperands,
     /* 328963 */     // GIR_Coverage, 630,
     /* 328963 */     GIR_EraseRootFromParent_Done,
     /* 328964 */   // Label 6450: @328964
     /* 328964 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(329015), // Rule ID 629 //
     /* 328969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 328980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329000 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 329000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 329003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329013 */     GIR_RootConstrainSelectedInstOperands,
     /* 329014 */     // GIR_Coverage, 629,
     /* 329014 */     GIR_EraseRootFromParent_Done,
     /* 329015 */   // Label 6451: @329015
     /* 329015 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(329034), // Rule ID 526 //
     /* 329020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329027 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 329027 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 329032 */     GIR_RootConstrainSelectedInstOperands,
     /* 329033 */     // GIR_Coverage, 526,
     /* 329033 */     GIR_Done,
     /* 329034 */   // Label 6452: @329034
     /* 329034 */   GIM_Reject,
     /* 329035 */ // Label 6441: @329035
     /* 329035 */ GIM_Reject,
     /* 329036 */ // Label 6410: @329036
     /* 329036 */ GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(329062), // Rule ID 860 //
     /* 329041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 329047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329055 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 329055 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 329060 */   GIR_RootConstrainSelectedInstOperands,
     /* 329061 */   // GIR_Coverage, 860,
     /* 329061 */   GIR_Done,
     /* 329062 */ // Label 6453: @329062
     /* 329062 */ GIM_Reject,
     /* 329063 */ // Label 6411: @329063
     /* 329063 */ GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(329089), // Rule ID 862 //
     /* 329068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329082 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 329082 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 329087 */   GIR_RootConstrainSelectedInstOperands,
     /* 329088 */   // GIR_Coverage, 862,
     /* 329088 */   GIR_Done,
     /* 329089 */ // Label 6454: @329089
     /* 329089 */ GIM_Reject,
     /* 329090 */ // Label 6412: @329090
     /* 329090 */ GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(329169),
     /* 329095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329106 */   GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(329121), // Rule ID 858 //
     /* 329111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 329114 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 329114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 329119 */     GIR_RootConstrainSelectedInstOperands,
     /* 329120 */     // GIR_Coverage, 858,
     /* 329120 */     GIR_Done,
     /* 329121 */   // Label 6456: @329121
     /* 329121 */   GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(329168), // Rule ID 6428 //
     /* 329126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329129 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 329129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 329136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329141 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 329151 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 329159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329166 */     GIR_RootConstrainSelectedInstOperands,
     /* 329167 */     // GIR_Coverage, 6428,
     /* 329167 */     GIR_EraseRootFromParent_Done,
     /* 329168 */   // Label 6457: @329168
     /* 329168 */   GIM_Reject,
     /* 329169 */ // Label 6455: @329169
     /* 329169 */ GIM_Reject,
     /* 329170 */ // Label 6413: @329170
     /* 329170 */ GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(329196), // Rule ID 861 //
     /* 329175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329189 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 329189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 329194 */   GIR_RootConstrainSelectedInstOperands,
     /* 329195 */   // GIR_Coverage, 861,
     /* 329195 */   GIR_Done,
     /* 329196 */ // Label 6458: @329196
     /* 329196 */ GIM_Reject,
     /* 329197 */ // Label 6414: @329197
     /* 329197 */ GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(329276),
     /* 329202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 329205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329213 */   GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(329228), // Rule ID 859 //
     /* 329218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 329221 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 329221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 329226 */     GIR_RootConstrainSelectedInstOperands,
     /* 329227 */     // GIR_Coverage, 859,
     /* 329227 */     GIR_Done,
     /* 329228 */   // Label 6460: @329228
     /* 329228 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(329275), // Rule ID 6429 //
     /* 329233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329236 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 329236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 329243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329248 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 329258 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 329266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329273 */     GIR_RootConstrainSelectedInstOperands,
     /* 329274 */     // GIR_Coverage, 6429,
     /* 329274 */     GIR_EraseRootFromParent_Done,
     /* 329275 */   // Label 6461: @329275
     /* 329275 */   GIM_Reject,
     /* 329276 */ // Label 6459: @329276
     /* 329276 */ GIM_Reject,
     /* 329277 */ // Label 6415: @329277
     /* 329277 */ GIM_Reject,
     /* 329278 */ // Label 65: @329278
     /* 329278 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6466*/ GIMT_Encode4(329525),
     /* 329289 */ /*GILLT_s32*//*Label 6462*/ GIMT_Encode4(329317),
     /* 329293 */ /*GILLT_s64*//*Label 6463*/ GIMT_Encode4(329348), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 329305 */ /*GILLT_v2s64*//*Label 6464*/ GIMT_Encode4(329409), GIMT_Encode4(0),
     /* 329313 */ /*GILLT_v4s32*//*Label 6465*/ GIMT_Encode4(329467),
     /* 329317 */ // Label 6462: @329317
     /* 329317 */ GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(329347), // Rule ID 516 //
     /* 329322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 329328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329336 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 329336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 329341 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329345 */   GIR_RootConstrainSelectedInstOperands,
     /* 329346 */   // GIR_Coverage, 516,
     /* 329346 */   GIR_Done,
     /* 329347 */ // Label 6467: @329347
     /* 329347 */ GIM_Reject,
     /* 329348 */ // Label 6463: @329348
     /* 329348 */ GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(329378), // Rule ID 514 //
     /* 329353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 329359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329367 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 329367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 329372 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329376 */   GIR_RootConstrainSelectedInstOperands,
     /* 329377 */   // GIR_Coverage, 514,
     /* 329377 */   GIR_Done,
     /* 329378 */ // Label 6468: @329378
     /* 329378 */ GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(329408), // Rule ID 518 //
     /* 329383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329397 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 329397 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 329402 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329406 */   GIR_RootConstrainSelectedInstOperands,
     /* 329407 */   // GIR_Coverage, 518,
     /* 329407 */   GIR_Done,
     /* 329408 */ // Label 6469: @329408
     /* 329408 */ GIM_Reject,
     /* 329409 */ // Label 6464: @329409
     /* 329409 */ GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(329466),
     /* 329414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 329417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329421 */   GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(329445), // Rule ID 4938 //
     /* 329426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 329433 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 329433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 329436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 329443 */     GIR_RootConstrainSelectedInstOperands,
     /* 329444 */     // GIR_Coverage, 4938,
     /* 329444 */     GIR_EraseRootFromParent_Done,
     /* 329445 */   // Label 6471: @329445
     /* 329445 */   GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(329465), // Rule ID 4936 //
     /* 329450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329454 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 329454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 329459 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329463 */     GIR_RootConstrainSelectedInstOperands,
     /* 329464 */     // GIR_Coverage, 4936,
     /* 329464 */     GIR_Done,
     /* 329465 */   // Label 6472: @329465
     /* 329465 */   GIM_Reject,
     /* 329466 */ // Label 6470: @329466
     /* 329466 */ GIM_Reject,
     /* 329467 */ // Label 6465: @329467
     /* 329467 */ GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(329524),
     /* 329472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329479 */   GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(329503), // Rule ID 4942 //
     /* 329484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 329491 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 329491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 329494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 329501 */     GIR_RootConstrainSelectedInstOperands,
     /* 329502 */     // GIR_Coverage, 4942,
     /* 329502 */     GIR_EraseRootFromParent_Done,
     /* 329503 */   // Label 6474: @329503
     /* 329503 */   GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(329523), // Rule ID 4940 //
     /* 329508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329512 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 329512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 329517 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329521 */     GIR_RootConstrainSelectedInstOperands,
     /* 329522 */     // GIR_Coverage, 4940,
     /* 329522 */     GIR_Done,
     /* 329523 */   // Label 6475: @329523
     /* 329523 */   GIM_Reject,
     /* 329524 */ // Label 6473: @329524
     /* 329524 */ GIM_Reject,
     /* 329525 */ // Label 6466: @329525
     /* 329525 */ GIM_Reject,
     /* 329526 */ // Label 66: @329526
     /* 329526 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6480*/ GIMT_Encode4(329713),
     /* 329537 */ /*GILLT_s16*//*Label 6476*/ GIMT_Encode4(329565),
     /* 329541 */ /*GILLT_s32*//*Label 6477*/ GIMT_Encode4(329626), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 329553 */ /*GILLT_v2s32*//*Label 6478*/ GIMT_Encode4(329657), GIMT_Encode4(0),
     /* 329561 */ /*GILLT_v4s16*//*Label 6479*/ GIMT_Encode4(329685),
     /* 329565 */ // Label 6476: @329565
     /* 329565 */ GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(329595), // Rule ID 510 //
     /* 329570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329584 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 329584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 329589 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329593 */   GIR_RootConstrainSelectedInstOperands,
     /* 329594 */   // GIR_Coverage, 510,
     /* 329594 */   GIR_Done,
     /* 329595 */ // Label 6481: @329595
     /* 329595 */ GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(329625), // Rule ID 520 //
     /* 329600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 329610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329614 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 329614 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 329619 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329623 */   GIR_RootConstrainSelectedInstOperands,
     /* 329624 */   // GIR_Coverage, 520,
     /* 329624 */   GIR_Done,
     /* 329625 */ // Label 6482: @329625
     /* 329625 */ GIM_Reject,
     /* 329626 */ // Label 6477: @329626
     /* 329626 */ GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(329656), // Rule ID 512 //
     /* 329631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 329641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329645 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 329645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 329650 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329654 */   GIR_RootConstrainSelectedInstOperands,
     /* 329655 */   // GIR_Coverage, 512,
     /* 329655 */   GIR_Done,
     /* 329656 */ // Label 6483: @329656
     /* 329656 */ GIM_Reject,
     /* 329657 */ // Label 6478: @329657
     /* 329657 */ GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(329684), // Rule ID 4946 //
     /* 329662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329673 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 329673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 329678 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329682 */   GIR_RootConstrainSelectedInstOperands,
     /* 329683 */   // GIR_Coverage, 4946,
     /* 329683 */   GIR_Done,
     /* 329684 */ // Label 6484: @329684
     /* 329684 */ GIM_Reject,
     /* 329685 */ // Label 6479: @329685
     /* 329685 */ GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(329712), // Rule ID 4948 //
     /* 329690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329701 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 329701 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 329706 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 329710 */   GIR_RootConstrainSelectedInstOperands,
     /* 329711 */   // GIR_Coverage, 4948,
     /* 329711 */   GIR_Done,
     /* 329712 */ // Label 6485: @329712
     /* 329712 */ GIM_Reject,
     /* 329713 */ // Label 6480: @329713
     /* 329713 */ GIM_Reject,
     /* 329714 */ // Label 67: @329714
     /* 329714 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6493*/ GIMT_Encode4(330690),
     /* 329725 */ /*GILLT_s32*//*Label 6486*/ GIMT_Encode4(329761),
     /* 329729 */ /*GILLT_s64*//*Label 6487*/ GIMT_Encode4(330148), GIMT_Encode4(0),
     /* 329737 */ /*GILLT_v2s32*//*Label 6488*/ GIMT_Encode4(330535),
     /* 329741 */ /*GILLT_v2s64*//*Label 6489*/ GIMT_Encode4(330566),
     /* 329745 */ /*GILLT_v4s16*//*Label 6490*/ GIMT_Encode4(330597),
     /* 329749 */ /*GILLT_v4s32*//*Label 6491*/ GIMT_Encode4(330628), GIMT_Encode4(0),
     /* 329757 */ /*GILLT_v8s16*//*Label 6492*/ GIMT_Encode4(330659),
     /* 329761 */ // Label 6486: @329761
     /* 329761 */ GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(329798), // Rule ID 4685 //
     /* 329766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329773 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329777 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 329781 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329785 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329787 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 329790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329792 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329796 */   GIR_RootConstrainSelectedInstOperands,
     /* 329797 */   // GIR_Coverage, 4685,
     /* 329797 */   GIR_EraseRootFromParent_Done,
     /* 329798 */ // Label 6494: @329798
     /* 329798 */ GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(329835), // Rule ID 4687 //
     /* 329803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329810 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329814 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 329818 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329822 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329824 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 329824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 329827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329829 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329833 */   GIR_RootConstrainSelectedInstOperands,
     /* 329834 */   // GIR_Coverage, 4687,
     /* 329834 */   GIR_EraseRootFromParent_Done,
     /* 329835 */ // Label 6495: @329835
     /* 329835 */ GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(329872), // Rule ID 4705 //
     /* 329840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329847 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 329855 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329859 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329861 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 329864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329866 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329870 */   GIR_RootConstrainSelectedInstOperands,
     /* 329871 */   // GIR_Coverage, 4705,
     /* 329871 */   GIR_EraseRootFromParent_Done,
     /* 329872 */ // Label 6496: @329872
     /* 329872 */ GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(329909), // Rule ID 4707 //
     /* 329877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329884 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329888 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 329892 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329896 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329898 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 329898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 329901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329903 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329907 */   GIR_RootConstrainSelectedInstOperands,
     /* 329908 */   // GIR_Coverage, 4707,
     /* 329908 */   GIR_EraseRootFromParent_Done,
     /* 329909 */ // Label 6497: @329909
     /* 329909 */ GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(329946), // Rule ID 4745 //
     /* 329914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329921 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329925 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 329929 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 329933 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329935 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 329935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 329938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329940 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329944 */   GIR_RootConstrainSelectedInstOperands,
     /* 329945 */   // GIR_Coverage, 4745,
     /* 329945 */   GIR_EraseRootFromParent_Done,
     /* 329946 */ // Label 6498: @329946
     /* 329946 */ GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(329983), // Rule ID 4747 //
     /* 329951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 329954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329958 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329962 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 329966 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329970 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329972 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 329972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 329975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329977 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329981 */   GIR_RootConstrainSelectedInstOperands,
     /* 329982 */   // GIR_Coverage, 4747,
     /* 329982 */   GIR_EraseRootFromParent_Done,
     /* 329983 */ // Label 6499: @329983
     /* 329983 */ GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(330020), // Rule ID 4725 //
     /* 329988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 329991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 329995 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329999 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330003 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330007 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330009 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 330012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330014 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330018 */   GIR_RootConstrainSelectedInstOperands,
     /* 330019 */   // GIR_Coverage, 4725,
     /* 330019 */   GIR_EraseRootFromParent_Done,
     /* 330020 */ // Label 6500: @330020
     /* 330020 */ GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(330057), // Rule ID 4727 //
     /* 330025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330032 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330040 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330044 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330046 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 330049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330051 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330055 */   GIR_RootConstrainSelectedInstOperands,
     /* 330056 */   // GIR_Coverage, 4727,
     /* 330056 */   GIR_EraseRootFromParent_Done,
     /* 330057 */ // Label 6501: @330057
     /* 330057 */ GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(330087), // Rule ID 395 //
     /* 330062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 330065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330076 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 330076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 330081 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330085 */   GIR_RootConstrainSelectedInstOperands,
     /* 330086 */   // GIR_Coverage, 395,
     /* 330086 */   GIR_Done,
     /* 330087 */ // Label 6502: @330087
     /* 330087 */ GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(330117), // Rule ID 399 //
     /* 330092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330106 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 330106 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 330111 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330115 */   GIR_RootConstrainSelectedInstOperands,
     /* 330116 */   // GIR_Coverage, 399,
     /* 330116 */   GIR_Done,
     /* 330117 */ // Label 6503: @330117
     /* 330117 */ GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(330147), // Rule ID 403 //
     /* 330122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330136 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 330136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 330141 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330145 */   GIR_RootConstrainSelectedInstOperands,
     /* 330146 */   // GIR_Coverage, 403,
     /* 330146 */   GIR_Done,
     /* 330147 */ // Label 6504: @330147
     /* 330147 */ GIM_Reject,
     /* 330148 */ // Label 6487: @330148
     /* 330148 */ GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(330185), // Rule ID 4686 //
     /* 330153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330160 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330164 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330168 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330172 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330174 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 330177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330179 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330183 */   GIR_RootConstrainSelectedInstOperands,
     /* 330184 */   // GIR_Coverage, 4686,
     /* 330184 */   GIR_EraseRootFromParent_Done,
     /* 330185 */ // Label 6505: @330185
     /* 330185 */ GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(330222), // Rule ID 4688 //
     /* 330190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330197 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330201 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330205 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330209 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330211 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 330214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330216 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330220 */   GIR_RootConstrainSelectedInstOperands,
     /* 330221 */   // GIR_Coverage, 4688,
     /* 330221 */   GIR_EraseRootFromParent_Done,
     /* 330222 */ // Label 6506: @330222
     /* 330222 */ GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(330259), // Rule ID 4706 //
     /* 330227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330234 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330238 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330242 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330246 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330248 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 330251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330253 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330257 */   GIR_RootConstrainSelectedInstOperands,
     /* 330258 */   // GIR_Coverage, 4706,
     /* 330258 */   GIR_EraseRootFromParent_Done,
     /* 330259 */ // Label 6507: @330259
     /* 330259 */ GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(330296), // Rule ID 4708 //
     /* 330264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330271 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330275 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330279 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330283 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330285 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 330288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330290 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330294 */   GIR_RootConstrainSelectedInstOperands,
     /* 330295 */   // GIR_Coverage, 4708,
     /* 330295 */   GIR_EraseRootFromParent_Done,
     /* 330296 */ // Label 6508: @330296
     /* 330296 */ GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(330333), // Rule ID 4746 //
     /* 330301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330308 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330316 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330320 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330322 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 330325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330327 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330331 */   GIR_RootConstrainSelectedInstOperands,
     /* 330332 */   // GIR_Coverage, 4746,
     /* 330332 */   GIR_EraseRootFromParent_Done,
     /* 330333 */ // Label 6509: @330333
     /* 330333 */ GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(330370), // Rule ID 4748 //
     /* 330338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330345 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330349 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330353 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330357 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330359 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 330362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330364 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330368 */   GIR_RootConstrainSelectedInstOperands,
     /* 330369 */   // GIR_Coverage, 4748,
     /* 330369 */   GIR_EraseRootFromParent_Done,
     /* 330370 */ // Label 6510: @330370
     /* 330370 */ GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(330407), // Rule ID 4726 //
     /* 330375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330382 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330390 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330394 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330396 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 330399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330401 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330405 */   GIR_RootConstrainSelectedInstOperands,
     /* 330406 */   // GIR_Coverage, 4726,
     /* 330406 */   GIR_EraseRootFromParent_Done,
     /* 330407 */ // Label 6511: @330407
     /* 330407 */ GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(330444), // Rule ID 4728 //
     /* 330412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330419 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330423 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330427 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330433 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 330436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330438 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330442 */   GIR_RootConstrainSelectedInstOperands,
     /* 330443 */   // GIR_Coverage, 4728,
     /* 330443 */   GIR_EraseRootFromParent_Done,
     /* 330444 */ // Label 6512: @330444
     /* 330444 */ GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(330474), // Rule ID 397 //
     /* 330449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 330452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330463 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 330463 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 330468 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330472 */   GIR_RootConstrainSelectedInstOperands,
     /* 330473 */   // GIR_Coverage, 397,
     /* 330473 */   GIR_Done,
     /* 330474 */ // Label 6513: @330474
     /* 330474 */ GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(330504), // Rule ID 401 //
     /* 330479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330493 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 330493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 330498 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330502 */   GIR_RootConstrainSelectedInstOperands,
     /* 330503 */   // GIR_Coverage, 401,
     /* 330503 */   GIR_Done,
     /* 330504 */ // Label 6514: @330504
     /* 330504 */ GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(330534), // Rule ID 405 //
     /* 330509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330523 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 330523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 330528 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330532 */   GIR_RootConstrainSelectedInstOperands,
     /* 330533 */   // GIR_Coverage, 405,
     /* 330533 */   GIR_Done,
     /* 330534 */ // Label 6515: @330534
     /* 330534 */ GIM_Reject,
     /* 330535 */ // Label 6488: @330535
     /* 330535 */ GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(330565), // Rule ID 843 //
     /* 330540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330554 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 330554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 330559 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330563 */   GIR_RootConstrainSelectedInstOperands,
     /* 330564 */   // GIR_Coverage, 843,
     /* 330564 */   GIR_Done,
     /* 330565 */ // Label 6516: @330565
     /* 330565 */ GIM_Reject,
     /* 330566 */ // Label 6489: @330566
     /* 330566 */ GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(330596), // Rule ID 847 //
     /* 330571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330585 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 330585 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 330590 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330594 */   GIR_RootConstrainSelectedInstOperands,
     /* 330595 */   // GIR_Coverage, 847,
     /* 330595 */   GIR_Done,
     /* 330596 */ // Label 6517: @330596
     /* 330596 */ GIM_Reject,
     /* 330597 */ // Label 6490: @330597
     /* 330597 */ GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(330627), // Rule ID 839 //
     /* 330602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 330605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330616 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 330616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 330621 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330625 */   GIR_RootConstrainSelectedInstOperands,
     /* 330626 */   // GIR_Coverage, 839,
     /* 330626 */   GIR_Done,
     /* 330627 */ // Label 6518: @330627
     /* 330627 */ GIM_Reject,
     /* 330628 */ // Label 6491: @330628
     /* 330628 */ GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(330658), // Rule ID 845 //
     /* 330633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 330636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330647 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 330647 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 330652 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330656 */   GIR_RootConstrainSelectedInstOperands,
     /* 330657 */   // GIR_Coverage, 845,
     /* 330657 */   GIR_Done,
     /* 330658 */ // Label 6519: @330658
     /* 330658 */ GIM_Reject,
     /* 330659 */ // Label 6492: @330659
     /* 330659 */ GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(330689), // Rule ID 841 //
     /* 330664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 330667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 330670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330678 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 330678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 330683 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330687 */   GIR_RootConstrainSelectedInstOperands,
     /* 330688 */   // GIR_Coverage, 841,
     /* 330688 */   GIR_Done,
     /* 330689 */ // Label 6520: @330689
     /* 330689 */ GIM_Reject,
     /* 330690 */ // Label 6493: @330690
     /* 330690 */ GIM_Reject,
     /* 330691 */ // Label 68: @330691
     /* 330691 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6528*/ GIMT_Encode4(331667),
     /* 330702 */ /*GILLT_s32*//*Label 6521*/ GIMT_Encode4(330738),
     /* 330706 */ /*GILLT_s64*//*Label 6522*/ GIMT_Encode4(331125), GIMT_Encode4(0),
     /* 330714 */ /*GILLT_v2s32*//*Label 6523*/ GIMT_Encode4(331512),
     /* 330718 */ /*GILLT_v2s64*//*Label 6524*/ GIMT_Encode4(331543),
     /* 330722 */ /*GILLT_v4s16*//*Label 6525*/ GIMT_Encode4(331574),
     /* 330726 */ /*GILLT_v4s32*//*Label 6526*/ GIMT_Encode4(331605), GIMT_Encode4(0),
     /* 330734 */ /*GILLT_v8s16*//*Label 6527*/ GIMT_Encode4(331636),
     /* 330738 */ // Label 6521: @330738
     /* 330738 */ GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(330775), // Rule ID 4695 //
     /* 330743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330750 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330758 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330762 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330764 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 330767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330769 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330773 */   GIR_RootConstrainSelectedInstOperands,
     /* 330774 */   // GIR_Coverage, 4695,
     /* 330774 */   GIR_EraseRootFromParent_Done,
     /* 330775 */ // Label 6529: @330775
     /* 330775 */ GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(330812), // Rule ID 4697 //
     /* 330780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330787 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330791 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330795 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330799 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330801 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 330804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330806 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330810 */   GIR_RootConstrainSelectedInstOperands,
     /* 330811 */   // GIR_Coverage, 4697,
     /* 330811 */   GIR_EraseRootFromParent_Done,
     /* 330812 */ // Label 6530: @330812
     /* 330812 */ GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(330849), // Rule ID 4715 //
     /* 330817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330824 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330828 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330832 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330836 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330838 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 330841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330843 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330847 */   GIR_RootConstrainSelectedInstOperands,
     /* 330848 */   // GIR_Coverage, 4715,
     /* 330848 */   GIR_EraseRootFromParent_Done,
     /* 330849 */ // Label 6531: @330849
     /* 330849 */ GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(330886), // Rule ID 4717 //
     /* 330854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330861 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330865 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330869 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330873 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330875 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 330878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330880 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330884 */   GIR_RootConstrainSelectedInstOperands,
     /* 330885 */   // GIR_Coverage, 4717,
     /* 330885 */   GIR_EraseRootFromParent_Done,
     /* 330886 */ // Label 6532: @330886
     /* 330886 */ GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(330923), // Rule ID 4755 //
     /* 330891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330898 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330902 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330906 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330910 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330912 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 330915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330917 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330921 */   GIR_RootConstrainSelectedInstOperands,
     /* 330922 */   // GIR_Coverage, 4755,
     /* 330922 */   GIR_EraseRootFromParent_Done,
     /* 330923 */ // Label 6533: @330923
     /* 330923 */ GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(330960), // Rule ID 4757 //
     /* 330928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330935 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330939 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330943 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330947 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330949 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 330952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330954 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330958 */   GIR_RootConstrainSelectedInstOperands,
     /* 330959 */   // GIR_Coverage, 4757,
     /* 330959 */   GIR_EraseRootFromParent_Done,
     /* 330960 */ // Label 6534: @330960
     /* 330960 */ GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(330997), // Rule ID 4735 //
     /* 330965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330972 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330976 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330980 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330984 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330986 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 330989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330991 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330995 */   GIR_RootConstrainSelectedInstOperands,
     /* 330996 */   // GIR_Coverage, 4735,
     /* 330996 */   GIR_EraseRootFromParent_Done,
     /* 330997 */ // Label 6535: @330997
     /* 330997 */ GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(331034), // Rule ID 4737 //
     /* 331002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331009 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331013 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331017 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331021 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331023 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 331026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331028 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331032 */   GIR_RootConstrainSelectedInstOperands,
     /* 331033 */   // GIR_Coverage, 4737,
     /* 331033 */   GIR_EraseRootFromParent_Done,
     /* 331034 */ // Label 6536: @331034
     /* 331034 */ GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(331064), // Rule ID 407 //
     /* 331039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 331045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331053 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 331053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 331058 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331062 */   GIR_RootConstrainSelectedInstOperands,
     /* 331063 */   // GIR_Coverage, 407,
     /* 331063 */   GIR_Done,
     /* 331064 */ // Label 6537: @331064
     /* 331064 */ GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(331094), // Rule ID 411 //
     /* 331069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331083 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 331083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 331088 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331092 */   GIR_RootConstrainSelectedInstOperands,
     /* 331093 */   // GIR_Coverage, 411,
     /* 331093 */   GIR_Done,
     /* 331094 */ // Label 6538: @331094
     /* 331094 */ GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(331124), // Rule ID 415 //
     /* 331099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331113 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 331113 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 331118 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331122 */   GIR_RootConstrainSelectedInstOperands,
     /* 331123 */   // GIR_Coverage, 415,
     /* 331123 */   GIR_Done,
     /* 331124 */ // Label 6539: @331124
     /* 331124 */ GIM_Reject,
     /* 331125 */ // Label 6522: @331125
     /* 331125 */ GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(331162), // Rule ID 4696 //
     /* 331130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331137 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331141 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331145 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331149 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331151 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 331154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331156 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331160 */   GIR_RootConstrainSelectedInstOperands,
     /* 331161 */   // GIR_Coverage, 4696,
     /* 331161 */   GIR_EraseRootFromParent_Done,
     /* 331162 */ // Label 6540: @331162
     /* 331162 */ GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(331199), // Rule ID 4698 //
     /* 331167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331174 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331178 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331182 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331186 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331188 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 331191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331193 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331197 */   GIR_RootConstrainSelectedInstOperands,
     /* 331198 */   // GIR_Coverage, 4698,
     /* 331198 */   GIR_EraseRootFromParent_Done,
     /* 331199 */ // Label 6541: @331199
     /* 331199 */ GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(331236), // Rule ID 4716 //
     /* 331204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331211 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331215 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331219 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331223 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331225 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 331228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331230 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331234 */   GIR_RootConstrainSelectedInstOperands,
     /* 331235 */   // GIR_Coverage, 4716,
     /* 331235 */   GIR_EraseRootFromParent_Done,
     /* 331236 */ // Label 6542: @331236
     /* 331236 */ GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(331273), // Rule ID 4718 //
     /* 331241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331248 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331252 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331256 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331260 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331262 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 331265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331267 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331271 */   GIR_RootConstrainSelectedInstOperands,
     /* 331272 */   // GIR_Coverage, 4718,
     /* 331272 */   GIR_EraseRootFromParent_Done,
     /* 331273 */ // Label 6543: @331273
     /* 331273 */ GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(331310), // Rule ID 4756 //
     /* 331278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331285 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331289 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331293 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331297 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331299 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 331302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331304 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331308 */   GIR_RootConstrainSelectedInstOperands,
     /* 331309 */   // GIR_Coverage, 4756,
     /* 331309 */   GIR_EraseRootFromParent_Done,
     /* 331310 */ // Label 6544: @331310
     /* 331310 */ GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(331347), // Rule ID 4758 //
     /* 331315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331322 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331326 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331330 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331334 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331336 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 331339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331341 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331345 */   GIR_RootConstrainSelectedInstOperands,
     /* 331346 */   // GIR_Coverage, 4758,
     /* 331346 */   GIR_EraseRootFromParent_Done,
     /* 331347 */ // Label 6545: @331347
     /* 331347 */ GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(331384), // Rule ID 4736 //
     /* 331352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331359 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331367 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331371 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331373 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 331376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331378 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331382 */   GIR_RootConstrainSelectedInstOperands,
     /* 331383 */   // GIR_Coverage, 4736,
     /* 331383 */   GIR_EraseRootFromParent_Done,
     /* 331384 */ // Label 6546: @331384
     /* 331384 */ GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(331421), // Rule ID 4738 //
     /* 331389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331396 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331400 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331404 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331408 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331410 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 331413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331415 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331419 */   GIR_RootConstrainSelectedInstOperands,
     /* 331420 */   // GIR_Coverage, 4738,
     /* 331420 */   GIR_EraseRootFromParent_Done,
     /* 331421 */ // Label 6547: @331421
     /* 331421 */ GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(331451), // Rule ID 409 //
     /* 331426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 331432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331440 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 331440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 331445 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331449 */   GIR_RootConstrainSelectedInstOperands,
     /* 331450 */   // GIR_Coverage, 409,
     /* 331450 */   GIR_Done,
     /* 331451 */ // Label 6548: @331451
     /* 331451 */ GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(331481), // Rule ID 413 //
     /* 331456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331470 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 331470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 331475 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331479 */   GIR_RootConstrainSelectedInstOperands,
     /* 331480 */   // GIR_Coverage, 413,
     /* 331480 */   GIR_Done,
     /* 331481 */ // Label 6549: @331481
     /* 331481 */ GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(331511), // Rule ID 417 //
     /* 331486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331500 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 331500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 331505 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331509 */   GIR_RootConstrainSelectedInstOperands,
     /* 331510 */   // GIR_Coverage, 417,
     /* 331510 */   GIR_Done,
     /* 331511 */ // Label 6550: @331511
     /* 331511 */ GIM_Reject,
     /* 331512 */ // Label 6523: @331512
     /* 331512 */ GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(331542), // Rule ID 853 //
     /* 331517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 331523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331531 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 331531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 331536 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331540 */   GIR_RootConstrainSelectedInstOperands,
     /* 331541 */   // GIR_Coverage, 853,
     /* 331541 */   GIR_Done,
     /* 331542 */ // Label 6551: @331542
     /* 331542 */ GIM_Reject,
     /* 331543 */ // Label 6524: @331543
     /* 331543 */ GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(331573), // Rule ID 857 //
     /* 331548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 331554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331562 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 331562 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 331567 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331571 */   GIR_RootConstrainSelectedInstOperands,
     /* 331572 */   // GIR_Coverage, 857,
     /* 331572 */   GIR_Done,
     /* 331573 */ // Label 6552: @331573
     /* 331573 */ GIM_Reject,
     /* 331574 */ // Label 6525: @331574
     /* 331574 */ GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(331604), // Rule ID 849 //
     /* 331579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 331582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 331585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331593 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 331593 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 331598 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331602 */   GIR_RootConstrainSelectedInstOperands,
     /* 331603 */   // GIR_Coverage, 849,
     /* 331603 */   GIR_Done,
     /* 331604 */ // Label 6553: @331604
     /* 331604 */ GIM_Reject,
     /* 331605 */ // Label 6526: @331605
     /* 331605 */ GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(331635), // Rule ID 855 //
     /* 331610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 331616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331624 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 331624 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 331629 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331633 */   GIR_RootConstrainSelectedInstOperands,
     /* 331634 */   // GIR_Coverage, 855,
     /* 331634 */   GIR_Done,
     /* 331635 */ // Label 6554: @331635
     /* 331635 */ GIM_Reject,
     /* 331636 */ // Label 6527: @331636
     /* 331636 */ GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(331666), // Rule ID 851 //
     /* 331641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 331644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 331647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331655 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 331655 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 331660 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331664 */   GIR_RootConstrainSelectedInstOperands,
     /* 331665 */   // GIR_Coverage, 851,
     /* 331665 */   GIR_Done,
     /* 331666 */ // Label 6555: @331666
     /* 331666 */ GIM_Reject,
     /* 331667 */ // Label 6528: @331667
     /* 331667 */ GIM_Reject,
     /* 331668 */ // Label 69: @331668
     /* 331668 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6564*/ GIMT_Encode4(336295),
     /* 331679 */ /*GILLT_s16*//*Label 6556*/ GIMT_Encode4(331719),
     /* 331683 */ /*GILLT_s32*//*Label 6557*/ GIMT_Encode4(332160),
     /* 331687 */ /*GILLT_s64*//*Label 6558*/ GIMT_Encode4(334156), GIMT_Encode4(0),
     /* 331695 */ /*GILLT_v2s32*//*Label 6559*/ GIMT_Encode4(336140),
     /* 331699 */ /*GILLT_v2s64*//*Label 6560*/ GIMT_Encode4(336171),
     /* 331703 */ /*GILLT_v4s16*//*Label 6561*/ GIMT_Encode4(336202),
     /* 331707 */ /*GILLT_v4s32*//*Label 6562*/ GIMT_Encode4(336233), GIMT_Encode4(0),
     /* 331715 */ /*GILLT_v8s16*//*Label 6563*/ GIMT_Encode4(336264),
     /* 331719 */ // Label 6556: @331719
     /* 331719 */ GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(331822), // Rule ID 5359 //
     /* 331724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 331727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331734 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331738 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 331742 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331746 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 331750 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331754 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 331758 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 331762 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331767 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 331771 */   // MIs[1] Operand 2
     /* 331771 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 331782 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 331784 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 331784 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 331787 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331791 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331796 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 331802 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331807 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 331815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331817 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331820 */   GIR_RootConstrainSelectedInstOperands,
     /* 331821 */   // GIR_Coverage, 5359,
     /* 331821 */   GIR_EraseRootFromParent_Done,
     /* 331822 */ // Label 6565: @331822
     /* 331822 */ GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(331902), // Rule ID 2444 //
     /* 331827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 331830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331837 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331841 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331845 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 331849 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331853 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331858 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 331862 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331864 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 331864 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 331867 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331871 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331876 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 331882 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331887 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 331895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331897 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331900 */   GIR_RootConstrainSelectedInstOperands,
     /* 331901 */   // GIR_Coverage, 2444,
     /* 331901 */   GIR_EraseRootFromParent_Done,
     /* 331902 */ // Label 6566: @331902
     /* 331902 */ GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(331982), // Rule ID 2448 //
     /* 331907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 331910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331917 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331921 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 331925 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 331929 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 331933 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331938 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 331942 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331944 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 331944 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 331947 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 331951 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331956 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 331962 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331967 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 331975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331980 */   GIR_RootConstrainSelectedInstOperands,
     /* 331981 */   // GIR_Coverage, 2448,
     /* 331981 */   GIR_EraseRootFromParent_Done,
     /* 331982 */ // Label 6567: @331982
     /* 331982 */ GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(332039), // Rule ID 5350 //
     /* 331987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 331990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331997 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332001 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 332005 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332009 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332011 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 332011 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 332014 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 332018 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332023 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 332032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332037 */   GIR_RootConstrainSelectedInstOperands,
     /* 332038 */   // GIR_Coverage, 5350,
     /* 332038 */   GIR_EraseRootFromParent_Done,
     /* 332039 */ // Label 6568: @332039
     /* 332039 */ GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(332069), // Rule ID 443 //
     /* 332044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 332047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332058 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 332058 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 332063 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332067 */   GIR_RootConstrainSelectedInstOperands,
     /* 332068 */   // GIR_Coverage, 443,
     /* 332068 */   GIR_Done,
     /* 332069 */ // Label 6569: @332069
     /* 332069 */ GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(332099), // Rule ID 449 //
     /* 332074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 332077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332088 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 332088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 332093 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332097 */   GIR_RootConstrainSelectedInstOperands,
     /* 332098 */   // GIR_Coverage, 449,
     /* 332098 */   GIR_Done,
     /* 332099 */ // Label 6570: @332099
     /* 332099 */ GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(332129), // Rule ID 491 //
     /* 332104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 332107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332118 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 332118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 332123 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332127 */   GIR_RootConstrainSelectedInstOperands,
     /* 332128 */   // GIR_Coverage, 491,
     /* 332128 */   GIR_Done,
     /* 332129 */ // Label 6571: @332129
     /* 332129 */ GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(332159), // Rule ID 495 //
     /* 332134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 332137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332148 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 332148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 332153 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332157 */   GIR_RootConstrainSelectedInstOperands,
     /* 332158 */   // GIR_Coverage, 495,
     /* 332158 */   GIR_Done,
     /* 332159 */ // Label 6572: @332159
     /* 332159 */ GIM_Reject,
     /* 332160 */ // Label 6557: @332160
     /* 332160 */ GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(332398), // Rule ID 6430 //
     /* 332165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332175 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332179 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332183 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332186 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 332193 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332197 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332199 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 332206 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332206 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 332209 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 332213 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 332228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 332233 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 332240 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 332243 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332247 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 332254 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 332257 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332261 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332266 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 332269 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 332272 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 332275 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332280 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332285 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 332290 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 332293 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 332297 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332302 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 332305 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 332308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332310 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332313 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332317 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332322 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332329 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332334 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332339 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332342 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332346 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332351 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332354 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332359 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332362 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332366 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332371 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332378 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332383 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332396 */   GIR_RootConstrainSelectedInstOperands,
     /* 332397 */   // GIR_Coverage, 6430,
     /* 332397 */   GIR_EraseRootFromParent_Done,
     /* 332398 */ // Label 6573: @332398
     /* 332398 */ GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(332636), // Rule ID 6431 //
     /* 332403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332421 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332424 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 332431 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332435 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332437 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 332444 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332444 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 332447 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 332451 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332456 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 332466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 332471 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 332478 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 332481 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332485 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 332492 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 332495 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332499 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332504 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 332507 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 332510 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 332513 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332518 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332523 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 332528 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 332531 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 332535 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332540 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 332543 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 332546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332548 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332551 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332555 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332560 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 332567 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332572 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332577 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332580 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332584 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332589 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332592 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332597 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332600 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332604 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332609 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332616 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332621 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332631 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332634 */   GIR_RootConstrainSelectedInstOperands,
     /* 332635 */   // GIR_Coverage, 6431,
     /* 332635 */   GIR_EraseRootFromParent_Done,
     /* 332636 */ // Label 6574: @332636
     /* 332636 */ GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(332825), // Rule ID 6434 //
     /* 332641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332651 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332655 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332659 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332662 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 332669 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332673 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332675 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 332682 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332682 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 332685 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 332689 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 332704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 332709 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 332716 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 332719 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332723 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332730 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332733 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332737 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332742 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 332745 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 332748 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 332751 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332756 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332761 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332766 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332769 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332773 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332778 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332781 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332784 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332786 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332789 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332793 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332798 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332805 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332810 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 332818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332823 */   GIR_RootConstrainSelectedInstOperands,
     /* 332824 */   // GIR_Coverage, 6434,
     /* 332824 */   GIR_EraseRootFromParent_Done,
     /* 332825 */ // Label 6575: @332825
     /* 332825 */ GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(333014), // Rule ID 6435 //
     /* 332830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332840 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332844 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332848 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332851 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 332858 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332862 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332864 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 332871 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332871 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 332874 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 332878 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332883 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 332893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 332898 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332903 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 332905 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 332908 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332912 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 332919 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 332922 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332926 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332931 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 332934 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 332937 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 332940 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332945 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332950 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332955 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 332958 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 332962 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332967 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332970 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 332973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332975 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332978 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332982 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332987 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 332994 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332999 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333009 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333012 */   GIR_RootConstrainSelectedInstOperands,
     /* 333013 */   // GIR_Coverage, 6435,
     /* 333013 */   GIR_EraseRootFromParent_Done,
     /* 333014 */ // Label 6576: @333014
     /* 333014 */ GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(333247), // Rule ID 6432 //
     /* 333019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333029 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333033 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333037 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333040 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 333047 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333053 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 333060 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333060 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 333063 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 333067 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 333082 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 333089 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 333092 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333096 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 333103 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 333106 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333110 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333115 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 333118 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 333121 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 333124 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333129 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333134 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 333139 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 333142 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 333146 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333151 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333154 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 333157 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333159 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333162 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333166 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333171 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333178 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333183 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333188 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333191 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333195 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333200 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333203 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333206 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333208 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333211 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333215 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333220 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333227 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333232 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333242 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333245 */   GIR_RootConstrainSelectedInstOperands,
     /* 333246 */   // GIR_Coverage, 6432,
     /* 333246 */   GIR_EraseRootFromParent_Done,
     /* 333247 */ // Label 6577: @333247
     /* 333247 */ GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(333480), // Rule ID 6433 //
     /* 333252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333262 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333266 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333270 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333273 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 333280 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333284 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333286 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 333293 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333293 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 333296 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 333300 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333305 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333310 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 333315 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333320 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 333322 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 333325 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333329 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 333336 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 333339 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333343 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333348 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 333351 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 333354 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 333357 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333362 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333367 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 333372 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 333375 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 333379 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333384 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333387 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 333390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333392 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333395 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333399 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333404 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333411 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333416 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333421 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333424 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333428 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333433 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333436 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333441 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333444 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333448 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333453 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333460 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333465 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333475 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333478 */   GIR_RootConstrainSelectedInstOperands,
     /* 333479 */   // GIR_Coverage, 6433,
     /* 333479 */   GIR_EraseRootFromParent_Done,
     /* 333480 */ // Label 6578: @333480
     /* 333480 */ GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(333664), // Rule ID 6436 //
     /* 333485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333495 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333499 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333503 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333506 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333513 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333517 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333519 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 333526 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333526 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 333529 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 333533 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333538 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333543 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 333548 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 333555 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 333558 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333562 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333569 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333572 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333576 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333581 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 333584 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 333587 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 333590 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333595 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333600 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333605 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333608 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333612 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333617 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333620 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333625 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333628 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333632 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333637 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333644 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333649 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333659 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333662 */   GIR_RootConstrainSelectedInstOperands,
     /* 333663 */   // GIR_Coverage, 6436,
     /* 333663 */   GIR_EraseRootFromParent_Done,
     /* 333664 */ // Label 6579: @333664
     /* 333664 */ GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(333848), // Rule ID 6437 //
     /* 333669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333679 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333683 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333687 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333690 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333697 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333701 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333703 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 333710 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333710 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 333713 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 333717 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 333732 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 333739 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 333742 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333746 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333753 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333756 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333760 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333765 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 333768 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 333771 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 333774 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333779 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333784 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333789 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333792 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333796 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333801 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333804 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333821 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333828 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333843 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333846 */   GIR_RootConstrainSelectedInstOperands,
     /* 333847 */   // GIR_Coverage, 6437,
     /* 333847 */   GIR_EraseRootFromParent_Done,
     /* 333848 */ // Label 6580: @333848
     /* 333848 */ GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(333928), // Rule ID 2450 //
     /* 333853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 333856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 333859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333863 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333867 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333871 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 333875 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333879 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333884 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 333888 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333890 */   // (sint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 333890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 333893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333902 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 333908 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333913 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 333921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333923 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333926 */   GIR_RootConstrainSelectedInstOperands,
     /* 333927 */   // GIR_Coverage, 2450,
     /* 333927 */   GIR_EraseRootFromParent_Done,
     /* 333928 */ // Label 6581: @333928
     /* 333928 */ GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(334008), // Rule ID 5355 //
     /* 333933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 333936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333943 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333947 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 333951 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 333955 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 333959 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333964 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 333968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333970 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 333970 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333973 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333977 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333982 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 333988 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333993 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334006 */   GIR_RootConstrainSelectedInstOperands,
     /* 334007 */   // GIR_Coverage, 5355,
     /* 334007 */   GIR_EraseRootFromParent_Done,
     /* 334008 */ // Label 6582: @334008
     /* 334008 */ GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(334065), // Rule ID 5338 //
     /* 334013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 334016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334023 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334027 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 334031 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 334035 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334037 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 334037 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334040 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 334044 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334049 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 334053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334060 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334063 */   GIR_RootConstrainSelectedInstOperands,
     /* 334064 */   // GIR_Coverage, 5338,
     /* 334064 */   GIR_EraseRootFromParent_Done,
     /* 334065 */ // Label 6583: @334065
     /* 334065 */ GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(334095), // Rule ID 445 //
     /* 334070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 334073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 334084 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 334084 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 334089 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 334093 */   GIR_RootConstrainSelectedInstOperands,
     /* 334094 */   // GIR_Coverage, 445,
     /* 334094 */   GIR_Done,
     /* 334095 */ // Label 6584: @334095
     /* 334095 */ GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(334125), // Rule ID 451 //
     /* 334100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 334103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 334106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 334114 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 334114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 334119 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 334123 */   GIR_RootConstrainSelectedInstOperands,
     /* 334124 */   // GIR_Coverage, 451,
     /* 334124 */   GIR_Done,
     /* 334125 */ // Label 6585: @334125
     /* 334125 */ GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(334155), // Rule ID 497 //
     /* 334130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 334133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 334136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334144 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 334144 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 334149 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 334153 */   GIR_RootConstrainSelectedInstOperands,
     /* 334154 */   // GIR_Coverage, 497,
     /* 334154 */   GIR_Done,
     /* 334155 */ // Label 6586: @334155
     /* 334155 */ GIM_Reject,
     /* 334156 */ // Label 6558: @334156
     /* 334156 */ GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(334342), // Rule ID 6442 //
     /* 334161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334171 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334175 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334179 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334182 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 334186 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334190 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334192 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 334199 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334199 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 334202 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 334206 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334211 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334216 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 334226 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334233 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334236 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334240 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334245 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334247 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334250 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334254 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334259 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334262 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334265 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 334268 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334273 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334278 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334283 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334286 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334290 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334295 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334298 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334303 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334306 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334310 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334315 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334322 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334327 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334337 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334340 */   GIR_RootConstrainSelectedInstOperands,
     /* 334341 */   // GIR_Coverage, 6442,
     /* 334341 */   GIR_EraseRootFromParent_Done,
     /* 334342 */ // Label 6587: @334342
     /* 334342 */ GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(334528), // Rule ID 6443 //
     /* 334347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334357 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334361 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334365 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334368 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 334372 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334376 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334378 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 334385 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334385 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 334388 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 334392 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 334412 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334419 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334422 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334426 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334431 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334433 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334436 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334440 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334445 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334448 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334451 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 334454 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334459 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334464 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334469 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334472 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334476 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334481 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334484 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334487 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334496 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334501 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334508 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334513 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334526 */   GIR_RootConstrainSelectedInstOperands,
     /* 334527 */   // GIR_Coverage, 6443,
     /* 334527 */   GIR_EraseRootFromParent_Done,
     /* 334528 */ // Label 6588: @334528
     /* 334528 */ GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(334766), // Rule ID 6438 //
     /* 334533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334543 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334547 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334551 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334554 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334561 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334565 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334567 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 334574 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334574 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 334577 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 334581 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 334601 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 334608 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 334611 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334615 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 334622 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 334625 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334629 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334634 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 334637 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 334640 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 334643 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334648 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334653 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334658 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 334661 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334665 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334670 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 334673 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 334676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334678 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334681 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334685 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334690 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334697 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334702 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334707 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334710 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334714 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334719 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334722 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334727 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334730 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334734 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334739 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334746 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334751 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334764 */   GIR_RootConstrainSelectedInstOperands,
     /* 334765 */   // GIR_Coverage, 6438,
     /* 334765 */   GIR_EraseRootFromParent_Done,
     /* 334766 */ // Label 6589: @334766
     /* 334766 */ GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(335004), // Rule ID 6439 //
     /* 334771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334781 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334785 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334789 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334792 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334799 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334803 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334805 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 334812 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334812 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 334815 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 334819 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 334839 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 334846 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 334849 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334853 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 334860 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 334863 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334867 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334872 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 334875 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 334878 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 334881 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334886 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334891 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334896 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 334899 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334903 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334908 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 334911 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 334914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334916 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334919 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334923 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334928 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334935 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334940 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334945 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334948 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334952 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334957 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334960 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334965 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334968 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334972 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334977 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334984 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334989 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 334997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334999 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335002 */   GIR_RootConstrainSelectedInstOperands,
     /* 335003 */   // GIR_Coverage, 6439,
     /* 335003 */   GIR_EraseRootFromParent_Done,
     /* 335004 */ // Label 6590: @335004
     /* 335004 */ GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(335185), // Rule ID 6444 //
     /* 335009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335019 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335023 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335027 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335030 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335034 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335038 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335040 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335047 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335047 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 335050 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335054 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335069 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 335076 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 335079 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335083 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335090 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335093 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335097 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335102 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 335105 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 335108 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 335111 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335116 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335121 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335126 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335129 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335133 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335138 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335141 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335158 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335165 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335170 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335180 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335183 */   GIR_RootConstrainSelectedInstOperands,
     /* 335184 */   // GIR_Coverage, 6444,
     /* 335184 */   GIR_EraseRootFromParent_Done,
     /* 335185 */ // Label 6591: @335185
     /* 335185 */ GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(335366), // Rule ID 6445 //
     /* 335190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335200 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335204 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335208 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335211 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335215 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335219 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335221 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335228 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335228 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 335231 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335235 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335240 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335250 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 335257 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 335260 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335264 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335271 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335274 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335278 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335283 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 335286 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 335289 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 335292 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335297 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335302 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335307 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335310 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335314 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335319 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335322 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335339 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335346 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335351 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335364 */   GIR_RootConstrainSelectedInstOperands,
     /* 335365 */   // GIR_Coverage, 6445,
     /* 335365 */   GIR_EraseRootFromParent_Done,
     /* 335366 */ // Label 6592: @335366
     /* 335366 */ GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(335599), // Rule ID 6440 //
     /* 335371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335381 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335385 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 335389 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335392 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 335399 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335403 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335405 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 335412 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335412 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 335415 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 335419 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335434 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 335441 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 335444 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335448 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 335455 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 335458 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335462 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335467 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 335470 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 335473 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 335476 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335481 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335486 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335491 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 335494 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 335498 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335503 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 335506 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 335509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335511 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335514 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335518 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335523 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335530 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335535 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335540 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335543 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335547 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335552 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335555 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335560 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335563 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335567 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335572 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335579 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335584 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335594 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335597 */   GIR_RootConstrainSelectedInstOperands,
     /* 335598 */   // GIR_Coverage, 6440,
     /* 335598 */   GIR_EraseRootFromParent_Done,
     /* 335599 */ // Label 6593: @335599
     /* 335599 */ GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(335832), // Rule ID 6441 //
     /* 335604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335614 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335618 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 335622 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335625 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 335632 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335636 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335638 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 335645 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335645 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 335648 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 335652 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335662 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335667 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 335674 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 335677 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335681 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 335688 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 335691 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335695 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335700 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 335703 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 335706 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 335709 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335714 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335719 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335724 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 335727 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 335731 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335736 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 335739 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 335742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335744 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335747 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335751 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335756 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335763 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335768 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335773 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335776 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335780 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335785 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335788 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335805 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335812 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335817 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335827 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335830 */   GIR_RootConstrainSelectedInstOperands,
     /* 335831 */   // GIR_Coverage, 6441,
     /* 335831 */   GIR_EraseRootFromParent_Done,
     /* 335832 */ // Label 6594: @335832
     /* 335832 */ GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(335912), // Rule ID 2446 //
     /* 335837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 335840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335847 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335855 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 335859 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335863 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335868 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 335872 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335874 */   // (sint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 335874 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335877 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335881 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335886 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 335892 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335897 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 335905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335907 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335910 */   GIR_RootConstrainSelectedInstOperands,
     /* 335911 */   // GIR_Coverage, 2446,
     /* 335911 */   GIR_EraseRootFromParent_Done,
     /* 335912 */ // Label 6595: @335912
     /* 335912 */ GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(335992), // Rule ID 5357 //
     /* 335917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 335920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 335923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335927 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335931 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 335935 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 335939 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 335943 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335948 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 335952 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335954 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 335954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335966 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 335972 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335977 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335987 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335990 */   GIR_RootConstrainSelectedInstOperands,
     /* 335991 */   // GIR_Coverage, 5357,
     /* 335991 */   GIR_EraseRootFromParent_Done,
     /* 335992 */ // Label 6596: @335992
     /* 335992 */ GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(336049), // Rule ID 5334 //
     /* 335997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336007 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336011 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 336015 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 336019 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336021 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 336021 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336024 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 336028 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336033 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336047 */   GIR_RootConstrainSelectedInstOperands,
     /* 336048 */   // GIR_Coverage, 5334,
     /* 336048 */   GIR_EraseRootFromParent_Done,
     /* 336049 */ // Label 6597: @336049
     /* 336049 */ GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(336079), // Rule ID 447 //
     /* 336054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 336057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 336068 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 336068 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 336073 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336077 */   GIR_RootConstrainSelectedInstOperands,
     /* 336078 */   // GIR_Coverage, 447,
     /* 336078 */   GIR_Done,
     /* 336079 */ // Label 6598: @336079
     /* 336079 */ GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(336109), // Rule ID 453 //
     /* 336084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 336087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 336098 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 336098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 336103 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336107 */   GIR_RootConstrainSelectedInstOperands,
     /* 336108 */   // GIR_Coverage, 453,
     /* 336108 */   GIR_Done,
     /* 336109 */ // Label 6599: @336109
     /* 336109 */ GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(336139), // Rule ID 493 //
     /* 336114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 336117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336128 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 336128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 336133 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336137 */   GIR_RootConstrainSelectedInstOperands,
     /* 336138 */   // GIR_Coverage, 493,
     /* 336138 */   GIR_Done,
     /* 336139 */ // Label 6600: @336139
     /* 336139 */ GIM_Reject,
     /* 336140 */ // Label 6559: @336140
     /* 336140 */ GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(336170), // Rule ID 1017 //
     /* 336145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 336148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 336151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336159 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 336159 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 336164 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336168 */   GIR_RootConstrainSelectedInstOperands,
     /* 336169 */   // GIR_Coverage, 1017,
     /* 336169 */   GIR_Done,
     /* 336170 */ // Label 6601: @336170
     /* 336170 */ GIM_Reject,
     /* 336171 */ // Label 6560: @336171
     /* 336171 */ GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(336201), // Rule ID 1021 //
     /* 336176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 336179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 336182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336190 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 336190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 336195 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336199 */   GIR_RootConstrainSelectedInstOperands,
     /* 336200 */   // GIR_Coverage, 1021,
     /* 336200 */   GIR_Done,
     /* 336201 */ // Label 6602: @336201
     /* 336201 */ GIM_Reject,
     /* 336202 */ // Label 6561: @336202
     /* 336202 */ GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(336232), // Rule ID 1013 //
     /* 336207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 336210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 336213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336221 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 336221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 336226 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336230 */   GIR_RootConstrainSelectedInstOperands,
     /* 336231 */   // GIR_Coverage, 1013,
     /* 336231 */   GIR_Done,
     /* 336232 */ // Label 6603: @336232
     /* 336232 */ GIM_Reject,
     /* 336233 */ // Label 6562: @336233
     /* 336233 */ GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(336263), // Rule ID 1019 //
     /* 336238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 336241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 336244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336252 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 336252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 336257 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336261 */   GIR_RootConstrainSelectedInstOperands,
     /* 336262 */   // GIR_Coverage, 1019,
     /* 336262 */   GIR_Done,
     /* 336263 */ // Label 6604: @336263
     /* 336263 */ GIM_Reject,
     /* 336264 */ // Label 6563: @336264
     /* 336264 */ GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(336294), // Rule ID 1015 //
     /* 336269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 336272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 336275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336283 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 336283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 336288 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336292 */   GIR_RootConstrainSelectedInstOperands,
     /* 336293 */   // GIR_Coverage, 1015,
     /* 336293 */   GIR_Done,
     /* 336294 */ // Label 6605: @336294
     /* 336294 */ GIM_Reject,
     /* 336295 */ // Label 6564: @336295
     /* 336295 */ GIM_Reject,
     /* 336296 */ // Label 70: @336296
     /* 336296 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6614*/ GIMT_Encode4(340301),
     /* 336307 */ /*GILLT_s16*//*Label 6606*/ GIMT_Encode4(336347),
     /* 336311 */ /*GILLT_s32*//*Label 6607*/ GIMT_Encode4(336792),
     /* 336315 */ /*GILLT_s64*//*Label 6608*/ GIMT_Encode4(338200), GIMT_Encode4(0),
     /* 336323 */ /*GILLT_v2s32*//*Label 6609*/ GIMT_Encode4(340146),
     /* 336327 */ /*GILLT_v2s64*//*Label 6610*/ GIMT_Encode4(340177),
     /* 336331 */ /*GILLT_v4s16*//*Label 6611*/ GIMT_Encode4(340208),
     /* 336335 */ /*GILLT_v4s32*//*Label 6612*/ GIMT_Encode4(340239), GIMT_Encode4(0),
     /* 336343 */ /*GILLT_v8s16*//*Label 6613*/ GIMT_Encode4(340270),
     /* 336347 */ // Label 6606: @336347
     /* 336347 */ GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(336454), // Rule ID 5360 //
     /* 336352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 336355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336362 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336366 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 336370 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 336374 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 336378 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 336382 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336386 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 336390 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 336394 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336399 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 336403 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 336414 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336416 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 336416 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 336419 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336423 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336428 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 336434 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336439 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 336447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336449 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336452 */   GIR_RootConstrainSelectedInstOperands,
     /* 336453 */   // GIR_Coverage, 5360,
     /* 336453 */   GIR_EraseRootFromParent_Done,
     /* 336454 */ // Label 6615: @336454
     /* 336454 */ GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(336534), // Rule ID 4784 //
     /* 336459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 336462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336469 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336473 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336477 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 336481 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336485 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336490 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 336494 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336496 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 336496 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336499 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336503 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336508 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 336514 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336519 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 336527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336529 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336532 */   GIR_RootConstrainSelectedInstOperands,
     /* 336533 */   // GIR_Coverage, 4784,
     /* 336533 */   GIR_EraseRootFromParent_Done,
     /* 336534 */ // Label 6616: @336534
     /* 336534 */ GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(336614), // Rule ID 4788 //
     /* 336539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 336542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336549 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336553 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336557 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 336561 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336565 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336570 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 336574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336576 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 336576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336588 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 336594 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336599 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 336607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336609 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336612 */   GIR_RootConstrainSelectedInstOperands,
     /* 336613 */   // GIR_Coverage, 4788,
     /* 336613 */   GIR_EraseRootFromParent_Done,
     /* 336614 */ // Label 6617: @336614
     /* 336614 */ GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(336671), // Rule ID 5354 //
     /* 336619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 336622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336629 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336633 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 336637 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 336641 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336643 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 336643 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 336646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 336650 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336655 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336659 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 336664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336669 */   GIR_RootConstrainSelectedInstOperands,
     /* 336670 */   // GIR_Coverage, 5354,
     /* 336670 */   GIR_EraseRootFromParent_Done,
     /* 336671 */ // Label 6618: @336671
     /* 336671 */ GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(336701), // Rule ID 467 //
     /* 336676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 336679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 336690 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 336690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 336695 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336699 */   GIR_RootConstrainSelectedInstOperands,
     /* 336700 */   // GIR_Coverage, 467,
     /* 336700 */   GIR_Done,
     /* 336701 */ // Label 6619: @336701
     /* 336701 */ GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(336731), // Rule ID 473 //
     /* 336706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 336709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 336720 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 336720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 336725 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336729 */   GIR_RootConstrainSelectedInstOperands,
     /* 336730 */   // GIR_Coverage, 473,
     /* 336730 */   GIR_Done,
     /* 336731 */ // Label 6620: @336731
     /* 336731 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(336761), // Rule ID 499 //
     /* 336736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 336739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336750 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 336750 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 336755 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336759 */   GIR_RootConstrainSelectedInstOperands,
     /* 336760 */   // GIR_Coverage, 499,
     /* 336760 */   GIR_Done,
     /* 336761 */ // Label 6621: @336761
     /* 336761 */ GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(336791), // Rule ID 503 //
     /* 336766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 336769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336780 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 336780 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 336785 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336789 */   GIR_RootConstrainSelectedInstOperands,
     /* 336790 */   // GIR_Coverage, 503,
     /* 336790 */   GIR_Done,
     /* 336791 */ // Label 6622: @336791
     /* 336791 */ GIM_Reject,
     /* 336792 */ // Label 6607: @336792
     /* 336792 */ GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(336932), // Rule ID 5361 //
     /* 336797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336807 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336811 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336815 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336818 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336825 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336829 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336831 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 336838 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 336838 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 336841 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 336845 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 336860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 336865 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 336872 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 336875 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336879 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336884 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336886 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336889 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336893 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336898 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336901 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 336904 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 336907 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336912 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336917 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 336922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 336925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336927 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336930 */   GIR_RootConstrainSelectedInstOperands,
     /* 336931 */   // GIR_Coverage, 5361,
     /* 336931 */   GIR_EraseRootFromParent_Done,
     /* 336932 */ // Label 6623: @336932
     /* 336932 */ GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(337072), // Rule ID 5362 //
     /* 336937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336947 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336951 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 336955 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336958 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336965 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336969 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336971 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 336978 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 336978 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 336981 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 336985 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336990 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337005 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337012 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337015 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337019 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337038 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337041 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337044 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 337047 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337052 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337057 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337070 */   GIR_RootConstrainSelectedInstOperands,
     /* 337071 */   // GIR_Coverage, 5362,
     /* 337071 */   GIR_EraseRootFromParent_Done,
     /* 337072 */ // Label 6624: @337072
     /* 337072 */ GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(337212), // Rule ID 5365 //
     /* 337077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337087 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337091 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337095 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337098 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337105 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337109 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337111 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 337118 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 337118 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 337121 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 337125 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337130 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337145 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337152 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337155 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337159 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337166 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337169 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337173 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337178 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337181 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337184 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 337187 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337192 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337197 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337207 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337210 */   GIR_RootConstrainSelectedInstOperands,
     /* 337211 */   // GIR_Coverage, 5365,
     /* 337211 */   GIR_EraseRootFromParent_Done,
     /* 337212 */ // Label 6625: @337212
     /* 337212 */ GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(337352), // Rule ID 5366 //
     /* 337217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337227 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337231 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337235 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337238 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337245 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337249 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337251 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 337258 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 337258 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 337261 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 337265 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337285 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337292 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337295 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337299 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337318 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337321 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337324 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 337327 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337332 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337337 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337347 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337350 */   GIR_RootConstrainSelectedInstOperands,
     /* 337351 */   // GIR_Coverage, 5366,
     /* 337351 */   GIR_EraseRootFromParent_Done,
     /* 337352 */ // Label 6626: @337352
     /* 337352 */ GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(337487), // Rule ID 5363 //
     /* 337357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337367 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337371 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337375 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337378 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337385 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337389 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337391 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 337398 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 337398 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 337401 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 337405 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337420 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337427 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337430 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337434 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337441 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337444 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337448 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337453 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337456 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337459 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 337462 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337467 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337472 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337485 */   GIR_RootConstrainSelectedInstOperands,
     /* 337486 */   // GIR_Coverage, 5363,
     /* 337486 */   GIR_EraseRootFromParent_Done,
     /* 337487 */ // Label 6627: @337487
     /* 337487 */ GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(337622), // Rule ID 5364 //
     /* 337492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337502 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337506 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337510 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337513 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337520 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337524 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337526 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 337533 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 337533 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 337536 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 337540 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337555 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337562 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337565 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337569 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337588 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337591 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337594 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 337597 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337602 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337607 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337620 */   GIR_RootConstrainSelectedInstOperands,
     /* 337621 */   // GIR_Coverage, 5364,
     /* 337621 */   GIR_EraseRootFromParent_Done,
     /* 337622 */ // Label 6628: @337622
     /* 337622 */ GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(337757), // Rule ID 5367 //
     /* 337627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337637 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337641 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337645 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337648 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337655 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337659 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337661 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 337668 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 337668 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 337671 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 337675 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337690 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337697 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337700 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337704 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337711 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337714 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337718 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337723 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337726 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337729 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 337732 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337737 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337742 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337755 */   GIR_RootConstrainSelectedInstOperands,
     /* 337756 */   // GIR_Coverage, 5367,
     /* 337756 */   GIR_EraseRootFromParent_Done,
     /* 337757 */ // Label 6629: @337757
     /* 337757 */ GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(337892), // Rule ID 5368 //
     /* 337762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337772 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337776 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337780 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337783 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337790 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337794 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337796 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 337803 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 337803 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 337806 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 337810 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 337825 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337830 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337832 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337835 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337839 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337846 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337849 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337853 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337858 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337861 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337864 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 337867 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337872 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337877 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337887 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337890 */   GIR_RootConstrainSelectedInstOperands,
     /* 337891 */   // GIR_Coverage, 5368,
     /* 337891 */   GIR_EraseRootFromParent_Done,
     /* 337892 */ // Label 6630: @337892
     /* 337892 */ GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(337972), // Rule ID 4790 //
     /* 337897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337907 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337911 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337915 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 337919 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337923 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337928 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337932 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337934 */   // (uint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 337934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337946 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 337952 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337957 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 337965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337967 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337970 */   GIR_RootConstrainSelectedInstOperands,
     /* 337971 */   // GIR_Coverage, 4790,
     /* 337971 */   GIR_EraseRootFromParent_Done,
     /* 337972 */ // Label 6631: @337972
     /* 337972 */ GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(338052), // Rule ID 5356 //
     /* 337977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337987 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337991 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337995 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 337999 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 338003 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338008 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 338012 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338014 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 338014 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338017 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338021 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338026 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 338032 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338037 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338050 */   GIR_RootConstrainSelectedInstOperands,
     /* 338051 */   // GIR_Coverage, 5356,
     /* 338051 */   GIR_EraseRootFromParent_Done,
     /* 338052 */ // Label 6632: @338052
     /* 338052 */ GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(338109), // Rule ID 5346 //
     /* 338057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338067 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338071 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 338075 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 338079 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338081 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 338081 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338084 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 338088 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338093 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 338097 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338104 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338107 */   GIR_RootConstrainSelectedInstOperands,
     /* 338108 */   // GIR_Coverage, 5346,
     /* 338108 */   GIR_EraseRootFromParent_Done,
     /* 338109 */ // Label 6633: @338109
     /* 338109 */ GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(338139), // Rule ID 469 //
     /* 338114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 338117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 338128 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 338128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 338133 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338137 */   GIR_RootConstrainSelectedInstOperands,
     /* 338138 */   // GIR_Coverage, 469,
     /* 338138 */   GIR_Done,
     /* 338139 */ // Label 6634: @338139
     /* 338139 */ GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(338169), // Rule ID 475 //
     /* 338144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 338147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 338150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 338158 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 338158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 338163 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338167 */   GIR_RootConstrainSelectedInstOperands,
     /* 338168 */   // GIR_Coverage, 475,
     /* 338168 */   GIR_Done,
     /* 338169 */ // Label 6635: @338169
     /* 338169 */ GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(338199), // Rule ID 505 //
     /* 338174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 338177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 338180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338188 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 338188 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 338193 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338197 */   GIR_RootConstrainSelectedInstOperands,
     /* 338198 */   // GIR_Coverage, 505,
     /* 338198 */   GIR_Done,
     /* 338199 */ // Label 6636: @338199
     /* 338199 */ GIM_Reject,
     /* 338200 */ // Label 6608: @338200
     /* 338200 */ GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(338337), // Rule ID 5377 //
     /* 338205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338215 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338219 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338223 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338226 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 338230 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338234 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338236 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 338243 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 338243 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 338246 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 338250 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338270 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338277 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338280 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338284 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338291 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338294 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338298 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338303 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338306 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338309 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 338312 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338317 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338322 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338335 */   GIR_RootConstrainSelectedInstOperands,
     /* 338336 */   // GIR_Coverage, 5377,
     /* 338336 */   GIR_EraseRootFromParent_Done,
     /* 338337 */ // Label 6637: @338337
     /* 338337 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(338474), // Rule ID 5378 //
     /* 338342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338352 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338356 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338360 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338363 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 338367 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338371 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338373 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 338380 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 338380 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 338383 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 338387 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338392 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338397 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338407 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338414 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338417 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338421 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338428 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338431 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338435 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338440 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338443 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338446 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 338449 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338454 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338459 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338469 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338472 */   GIR_RootConstrainSelectedInstOperands,
     /* 338473 */   // GIR_Coverage, 5378,
     /* 338473 */   GIR_EraseRootFromParent_Done,
     /* 338474 */ // Label 6638: @338474
     /* 338474 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(338614), // Rule ID 5369 //
     /* 338479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338489 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338493 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338497 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338500 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338507 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338511 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338513 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 338520 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 338520 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338523 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 338527 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338542 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338547 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338554 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338557 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338561 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338580 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338583 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338586 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338589 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338594 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338599 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338609 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338612 */   GIR_RootConstrainSelectedInstOperands,
     /* 338613 */   // GIR_Coverage, 5369,
     /* 338613 */   GIR_EraseRootFromParent_Done,
     /* 338614 */ // Label 6639: @338614
     /* 338614 */ GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(338754), // Rule ID 5370 //
     /* 338619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338629 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338633 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338637 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338640 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338647 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338651 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338653 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 338660 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 338660 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338663 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 338667 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338677 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338682 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338687 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338692 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338694 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338697 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338701 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338706 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338708 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338711 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338715 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338720 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338723 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338726 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338729 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338734 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338739 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338749 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338752 */   GIR_RootConstrainSelectedInstOperands,
     /* 338753 */   // GIR_Coverage, 5370,
     /* 338753 */   GIR_EraseRootFromParent_Done,
     /* 338754 */ // Label 6640: @338754
     /* 338754 */ GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(338894), // Rule ID 5373 //
     /* 338759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338769 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338773 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338777 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338780 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338787 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338791 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338793 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 338800 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 338800 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338803 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 338807 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338827 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338832 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338834 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338837 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338841 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338846 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338848 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338851 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338855 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338860 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338863 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338866 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338869 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338874 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338879 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 338887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338889 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338892 */   GIR_RootConstrainSelectedInstOperands,
     /* 338893 */   // GIR_Coverage, 5373,
     /* 338893 */   GIR_EraseRootFromParent_Done,
     /* 338894 */ // Label 6641: @338894
     /* 338894 */ GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(339034), // Rule ID 5374 //
     /* 338899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338909 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338917 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338920 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338927 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338931 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338933 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 338940 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 338940 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338943 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 338947 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338967 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338974 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338977 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338981 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338988 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338991 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338995 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339000 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339003 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339006 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 339009 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339014 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339019 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339029 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339032 */   GIR_RootConstrainSelectedInstOperands,
     /* 339033 */   // GIR_Coverage, 5374,
     /* 339033 */   GIR_EraseRootFromParent_Done,
     /* 339034 */ // Label 6642: @339034
     /* 339034 */ GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(339166), // Rule ID 5379 //
     /* 339039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339049 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339053 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339057 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339060 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 339064 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339068 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339070 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 339077 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 339077 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 339080 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 339084 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339094 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339099 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339106 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339109 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339113 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339118 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339132 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339135 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339138 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 339141 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339146 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339151 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339161 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339164 */   GIR_RootConstrainSelectedInstOperands,
     /* 339165 */   // GIR_Coverage, 5379,
     /* 339165 */   GIR_EraseRootFromParent_Done,
     /* 339166 */ // Label 6643: @339166
     /* 339166 */ GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(339298), // Rule ID 5380 //
     /* 339171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339181 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339185 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339189 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339192 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 339196 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339200 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339202 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 339209 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 339209 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 339212 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 339216 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339231 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339238 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339241 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339245 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339252 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339255 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339259 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339264 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339267 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339270 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 339273 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339278 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339283 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339293 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339296 */   GIR_RootConstrainSelectedInstOperands,
     /* 339297 */   // GIR_Coverage, 5380,
     /* 339297 */   GIR_EraseRootFromParent_Done,
     /* 339298 */ // Label 6644: @339298
     /* 339298 */ GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(339433), // Rule ID 5371 //
     /* 339303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339313 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339317 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339321 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339324 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339331 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339335 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339337 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 339344 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 339344 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 339347 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 339351 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339356 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339361 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339366 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339373 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339376 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339380 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339385 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339399 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339402 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339405 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 339408 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339413 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339418 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339428 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339431 */   GIR_RootConstrainSelectedInstOperands,
     /* 339432 */   // GIR_Coverage, 5371,
     /* 339432 */   GIR_EraseRootFromParent_Done,
     /* 339433 */ // Label 6645: @339433
     /* 339433 */ GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(339568), // Rule ID 5372 //
     /* 339438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339448 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339452 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339456 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339459 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339466 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339470 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339472 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 339479 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 339479 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 339482 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 339486 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339501 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339508 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339511 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339515 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339522 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339525 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339529 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339534 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339537 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339540 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 339543 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339548 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339553 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339563 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339566 */   GIR_RootConstrainSelectedInstOperands,
     /* 339567 */   // GIR_Coverage, 5372,
     /* 339567 */   GIR_EraseRootFromParent_Done,
     /* 339568 */ // Label 6646: @339568
     /* 339568 */ GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(339703), // Rule ID 5375 //
     /* 339573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339583 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339587 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339591 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339594 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339601 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339605 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339607 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 339614 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 339614 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 339617 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 339621 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339626 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339631 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339636 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339641 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339643 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339646 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339650 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339669 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339672 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339675 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 339678 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339683 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339688 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339698 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339701 */   GIR_RootConstrainSelectedInstOperands,
     /* 339702 */   // GIR_Coverage, 5375,
     /* 339702 */   GIR_EraseRootFromParent_Done,
     /* 339703 */ // Label 6647: @339703
     /* 339703 */ GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(339838), // Rule ID 5376 //
     /* 339708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339718 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339722 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339726 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339729 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339736 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339740 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339742 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 339749 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 339749 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 339752 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 339756 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339771 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339776 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339778 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339781 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339785 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339790 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339792 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339795 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339799 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339804 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339807 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339810 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 339813 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339818 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339823 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339833 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339836 */   GIR_RootConstrainSelectedInstOperands,
     /* 339837 */   // GIR_Coverage, 5376,
     /* 339837 */   GIR_EraseRootFromParent_Done,
     /* 339838 */ // Label 6648: @339838
     /* 339838 */ GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(339918), // Rule ID 4786 //
     /* 339843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 339846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339853 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339857 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339861 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 339865 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339869 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339874 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 339878 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339880 */   // (uint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 339880 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 339883 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339887 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339892 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 339898 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339903 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 339911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339916 */   GIR_RootConstrainSelectedInstOperands,
     /* 339917 */   // GIR_Coverage, 4786,
     /* 339917 */   GIR_EraseRootFromParent_Done,
     /* 339918 */ // Label 6649: @339918
     /* 339918 */ GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(339998), // Rule ID 5358 //
     /* 339923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 339929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339933 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339937 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 339941 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 339945 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 339949 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339954 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 339958 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339960 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 339960 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339963 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 339967 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339972 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 339978 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339983 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339993 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339996 */   GIR_RootConstrainSelectedInstOperands,
     /* 339997 */   // GIR_Coverage, 5358,
     /* 339997 */   GIR_EraseRootFromParent_Done,
     /* 339998 */ // Label 6650: @339998
     /* 339998 */ GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(340055), // Rule ID 5342 //
     /* 340003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340013 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340017 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 340021 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 340025 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340027 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 340027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 340034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340039 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340050 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340053 */   GIR_RootConstrainSelectedInstOperands,
     /* 340054 */   // GIR_Coverage, 5342,
     /* 340054 */   GIR_EraseRootFromParent_Done,
     /* 340055 */ // Label 6651: @340055
     /* 340055 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(340085), // Rule ID 471 //
     /* 340060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 340063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340074 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 340074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 340079 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340083 */   GIR_RootConstrainSelectedInstOperands,
     /* 340084 */   // GIR_Coverage, 471,
     /* 340084 */   GIR_Done,
     /* 340085 */ // Label 6652: @340085
     /* 340085 */ GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(340115), // Rule ID 477 //
     /* 340090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 340093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340104 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 340104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 340109 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340113 */   GIR_RootConstrainSelectedInstOperands,
     /* 340114 */   // GIR_Coverage, 477,
     /* 340114 */   GIR_Done,
     /* 340115 */ // Label 6653: @340115
     /* 340115 */ GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(340145), // Rule ID 501 //
     /* 340120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 340123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340134 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 340134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 340139 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340143 */   GIR_RootConstrainSelectedInstOperands,
     /* 340144 */   // GIR_Coverage, 501,
     /* 340144 */   GIR_Done,
     /* 340145 */ // Label 6654: @340145
     /* 340145 */ GIM_Reject,
     /* 340146 */ // Label 6609: @340146
     /* 340146 */ GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(340176), // Rule ID 1078 //
     /* 340151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 340157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340165 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 340165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 340170 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340174 */   GIR_RootConstrainSelectedInstOperands,
     /* 340175 */   // GIR_Coverage, 1078,
     /* 340175 */   GIR_Done,
     /* 340176 */ // Label 6655: @340176
     /* 340176 */ GIM_Reject,
     /* 340177 */ // Label 6610: @340177
     /* 340177 */ GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(340207), // Rule ID 1082 //
     /* 340182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340196 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 340196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 340201 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340205 */   GIR_RootConstrainSelectedInstOperands,
     /* 340206 */   // GIR_Coverage, 1082,
     /* 340206 */   GIR_Done,
     /* 340207 */ // Label 6656: @340207
     /* 340207 */ GIM_Reject,
     /* 340208 */ // Label 6611: @340208
     /* 340208 */ GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(340238), // Rule ID 1074 //
     /* 340213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340227 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 340227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 340232 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340236 */   GIR_RootConstrainSelectedInstOperands,
     /* 340237 */   // GIR_Coverage, 1074,
     /* 340237 */   GIR_Done,
     /* 340238 */ // Label 6657: @340238
     /* 340238 */ GIM_Reject,
     /* 340239 */ // Label 6612: @340239
     /* 340239 */ GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(340269), // Rule ID 1080 //
     /* 340244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 340250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340258 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 340258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 340263 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340267 */   GIR_RootConstrainSelectedInstOperands,
     /* 340268 */   // GIR_Coverage, 1080,
     /* 340268 */   GIR_Done,
     /* 340269 */ // Label 6658: @340269
     /* 340269 */ GIM_Reject,
     /* 340270 */ // Label 6613: @340270
     /* 340270 */ GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(340300), // Rule ID 1076 //
     /* 340275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340289 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 340289 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 340294 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340298 */   GIR_RootConstrainSelectedInstOperands,
     /* 340299 */   // GIR_Coverage, 1076,
     /* 340299 */   GIR_Done,
     /* 340300 */ // Label 6659: @340300
     /* 340300 */ GIM_Reject,
     /* 340301 */ // Label 6614: @340301
     /* 340301 */ GIM_Reject,
     /* 340302 */ // Label 71: @340302
     /* 340302 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6667*/ GIMT_Encode4(340621),
     /* 340313 */ /*GILLT_s32*//*Label 6660*/ GIMT_Encode4(340349),
     /* 340317 */ /*GILLT_s64*//*Label 6661*/ GIMT_Encode4(340422), GIMT_Encode4(0),
     /* 340325 */ /*GILLT_v2s32*//*Label 6662*/ GIMT_Encode4(340495),
     /* 340329 */ /*GILLT_v2s64*//*Label 6663*/ GIMT_Encode4(340519),
     /* 340333 */ /*GILLT_v4s16*//*Label 6664*/ GIMT_Encode4(340543),
     /* 340337 */ /*GILLT_v4s32*//*Label 6665*/ GIMT_Encode4(340570), GIMT_Encode4(0),
     /* 340345 */ /*GILLT_v8s16*//*Label 6666*/ GIMT_Encode4(340594),
     /* 340349 */ // Label 6660: @340349
     /* 340349 */ GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(340375), // Rule ID 4619 //
     /* 340354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 340360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340364 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 340364 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 340369 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340373 */   GIR_RootConstrainSelectedInstOperands,
     /* 340374 */   // GIR_Coverage, 4619,
     /* 340374 */   GIR_Done,
     /* 340375 */ // Label 6668: @340375
     /* 340375 */ GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(340398), // Rule ID 4621 //
     /* 340380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340387 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 340387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 340392 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340396 */   GIR_RootConstrainSelectedInstOperands,
     /* 340397 */   // GIR_Coverage, 4621,
     /* 340397 */   GIR_Done,
     /* 340398 */ // Label 6669: @340398
     /* 340398 */ GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(340421), // Rule ID 4623 //
     /* 340403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340410 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 340410 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 340415 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340419 */   GIR_RootConstrainSelectedInstOperands,
     /* 340420 */   // GIR_Coverage, 4623,
     /* 340420 */   GIR_Done,
     /* 340421 */ // Label 6670: @340421
     /* 340421 */ GIM_Reject,
     /* 340422 */ // Label 6661: @340422
     /* 340422 */ GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(340448), // Rule ID 4620 //
     /* 340427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 340433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340437 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 340437 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 340442 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340446 */   GIR_RootConstrainSelectedInstOperands,
     /* 340447 */   // GIR_Coverage, 4620,
     /* 340447 */   GIR_Done,
     /* 340448 */ // Label 6671: @340448
     /* 340448 */ GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(340471), // Rule ID 4622 //
     /* 340453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340460 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 340460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 340465 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340469 */   GIR_RootConstrainSelectedInstOperands,
     /* 340470 */   // GIR_Coverage, 4622,
     /* 340470 */   GIR_Done,
     /* 340471 */ // Label 6672: @340471
     /* 340471 */ GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(340494), // Rule ID 4624 //
     /* 340476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340483 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 340483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 340488 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340492 */   GIR_RootConstrainSelectedInstOperands,
     /* 340493 */   // GIR_Coverage, 4624,
     /* 340493 */   GIR_Done,
     /* 340494 */ // Label 6673: @340494
     /* 340494 */ GIM_Reject,
     /* 340495 */ // Label 6662: @340495
     /* 340495 */ GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(340518), // Rule ID 4960 //
     /* 340500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 340503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340507 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 340507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 340512 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340516 */   GIR_RootConstrainSelectedInstOperands,
     /* 340517 */   // GIR_Coverage, 4960,
     /* 340517 */   GIR_Done,
     /* 340518 */ // Label 6674: @340518
     /* 340518 */ GIM_Reject,
     /* 340519 */ // Label 6663: @340519
     /* 340519 */ GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(340542), // Rule ID 4962 //
     /* 340524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340531 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 340531 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 340536 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340540 */   GIR_RootConstrainSelectedInstOperands,
     /* 340541 */   // GIR_Coverage, 4962,
     /* 340541 */   GIR_Done,
     /* 340542 */ // Label 6675: @340542
     /* 340542 */ GIM_Reject,
     /* 340543 */ // Label 6664: @340543
     /* 340543 */ GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(340569), // Rule ID 4955 //
     /* 340548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340558 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 340558 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 340563 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340567 */   GIR_RootConstrainSelectedInstOperands,
     /* 340568 */   // GIR_Coverage, 4955,
     /* 340568 */   GIR_Done,
     /* 340569 */ // Label 6676: @340569
     /* 340569 */ GIM_Reject,
     /* 340570 */ // Label 6665: @340570
     /* 340570 */ GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(340593), // Rule ID 4961 //
     /* 340575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 340578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340582 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 340582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 340587 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340591 */   GIR_RootConstrainSelectedInstOperands,
     /* 340592 */   // GIR_Coverage, 4961,
     /* 340592 */   GIR_Done,
     /* 340593 */ // Label 6677: @340593
     /* 340593 */ GIM_Reject,
     /* 340594 */ // Label 6666: @340594
     /* 340594 */ GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(340620), // Rule ID 4956 //
     /* 340599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340609 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 340609 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 340614 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340618 */   GIR_RootConstrainSelectedInstOperands,
     /* 340619 */   // GIR_Coverage, 4956,
     /* 340619 */   GIR_Done,
     /* 340620 */ // Label 6678: @340620
     /* 340620 */ GIM_Reject,
     /* 340621 */ // Label 6667: @340621
     /* 340621 */ GIM_Reject,
     /* 340622 */ // Label 72: @340622
     /* 340622 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6686*/ GIMT_Encode4(340941),
     /* 340633 */ /*GILLT_s32*//*Label 6679*/ GIMT_Encode4(340669),
     /* 340637 */ /*GILLT_s64*//*Label 6680*/ GIMT_Encode4(340742), GIMT_Encode4(0),
     /* 340645 */ /*GILLT_v2s32*//*Label 6681*/ GIMT_Encode4(340815),
     /* 340649 */ /*GILLT_v2s64*//*Label 6682*/ GIMT_Encode4(340839),
     /* 340653 */ /*GILLT_v4s16*//*Label 6683*/ GIMT_Encode4(340863),
     /* 340657 */ /*GILLT_v4s32*//*Label 6684*/ GIMT_Encode4(340890), GIMT_Encode4(0),
     /* 340665 */ /*GILLT_v8s16*//*Label 6685*/ GIMT_Encode4(340914),
     /* 340669 */ // Label 6679: @340669
     /* 340669 */ GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(340695), // Rule ID 4643 //
     /* 340674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 340680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340684 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 340684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 340689 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340693 */   GIR_RootConstrainSelectedInstOperands,
     /* 340694 */   // GIR_Coverage, 4643,
     /* 340694 */   GIR_Done,
     /* 340695 */ // Label 6687: @340695
     /* 340695 */ GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(340718), // Rule ID 4645 //
     /* 340700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340707 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 340707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 340712 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340716 */   GIR_RootConstrainSelectedInstOperands,
     /* 340717 */   // GIR_Coverage, 4645,
     /* 340717 */   GIR_Done,
     /* 340718 */ // Label 6688: @340718
     /* 340718 */ GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(340741), // Rule ID 4647 //
     /* 340723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340730 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 340730 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 340735 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340739 */   GIR_RootConstrainSelectedInstOperands,
     /* 340740 */   // GIR_Coverage, 4647,
     /* 340740 */   GIR_Done,
     /* 340741 */ // Label 6689: @340741
     /* 340741 */ GIM_Reject,
     /* 340742 */ // Label 6680: @340742
     /* 340742 */ GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(340768), // Rule ID 4644 //
     /* 340747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 340753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340757 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 340757 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 340762 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340766 */   GIR_RootConstrainSelectedInstOperands,
     /* 340767 */   // GIR_Coverage, 4644,
     /* 340767 */   GIR_Done,
     /* 340768 */ // Label 6690: @340768
     /* 340768 */ GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(340791), // Rule ID 4646 //
     /* 340773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340780 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 340780 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 340785 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340789 */   GIR_RootConstrainSelectedInstOperands,
     /* 340790 */   // GIR_Coverage, 4646,
     /* 340790 */   GIR_Done,
     /* 340791 */ // Label 6691: @340791
     /* 340791 */ GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(340814), // Rule ID 4648 //
     /* 340796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340803 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 340803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 340808 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340812 */   GIR_RootConstrainSelectedInstOperands,
     /* 340813 */   // GIR_Coverage, 4648,
     /* 340813 */   GIR_Done,
     /* 340814 */ // Label 6692: @340814
     /* 340814 */ GIM_Reject,
     /* 340815 */ // Label 6681: @340815
     /* 340815 */ GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(340838), // Rule ID 4970 //
     /* 340820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 340823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340827 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 340827 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 340832 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340836 */   GIR_RootConstrainSelectedInstOperands,
     /* 340837 */   // GIR_Coverage, 4970,
     /* 340837 */   GIR_Done,
     /* 340838 */ // Label 6693: @340838
     /* 340838 */ GIM_Reject,
     /* 340839 */ // Label 6682: @340839
     /* 340839 */ GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(340862), // Rule ID 4972 //
     /* 340844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340851 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 340851 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 340856 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340860 */   GIR_RootConstrainSelectedInstOperands,
     /* 340861 */   // GIR_Coverage, 4972,
     /* 340861 */   GIR_Done,
     /* 340862 */ // Label 6694: @340862
     /* 340862 */ GIM_Reject,
     /* 340863 */ // Label 6683: @340863
     /* 340863 */ GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(340889), // Rule ID 4965 //
     /* 340868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340878 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 340878 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 340883 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340887 */   GIR_RootConstrainSelectedInstOperands,
     /* 340888 */   // GIR_Coverage, 4965,
     /* 340888 */   GIR_Done,
     /* 340889 */ // Label 6695: @340889
     /* 340889 */ GIM_Reject,
     /* 340890 */ // Label 6684: @340890
     /* 340890 */ GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(340913), // Rule ID 4971 //
     /* 340895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 340898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340902 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 340902 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 340907 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340911 */   GIR_RootConstrainSelectedInstOperands,
     /* 340912 */   // GIR_Coverage, 4971,
     /* 340912 */   GIR_Done,
     /* 340913 */ // Label 6696: @340913
     /* 340913 */ GIM_Reject,
     /* 340914 */ // Label 6685: @340914
     /* 340914 */ GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(340940), // Rule ID 4966 //
     /* 340919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 340922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340929 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 340929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 340934 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340938 */   GIR_RootConstrainSelectedInstOperands,
     /* 340939 */   // GIR_Coverage, 4966,
     /* 340939 */   GIR_Done,
     /* 340940 */ // Label 6697: @340940
     /* 340940 */ GIM_Reject,
     /* 340941 */ // Label 6686: @340941
     /* 340941 */ GIM_Reject,
     /* 340942 */ // Label 73: @340942
     /* 340942 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6706*/ GIMT_Encode4(341798),
     /* 340953 */ /*GILLT_s16*//*Label 6698*/ GIMT_Encode4(340993),
     /* 340957 */ /*GILLT_s32*//*Label 6699*/ GIMT_Encode4(341212),
     /* 340961 */ /*GILLT_s64*//*Label 6700*/ GIMT_Encode4(341286), GIMT_Encode4(0),
     /* 340969 */ /*GILLT_v2s32*//*Label 6701*/ GIMT_Encode4(341360),
     /* 340973 */ /*GILLT_v2s64*//*Label 6702*/ GIMT_Encode4(341434),
     /* 340977 */ /*GILLT_v4s16*//*Label 6703*/ GIMT_Encode4(341508),
     /* 340981 */ /*GILLT_v4s32*//*Label 6704*/ GIMT_Encode4(341616), GIMT_Encode4(0),
     /* 340989 */ /*GILLT_v8s16*//*Label 6705*/ GIMT_Encode4(341690),
     /* 340993 */ // Label 6698: @340993
     /* 340993 */ GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(341211),
     /* 340998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341005 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(341046), // Rule ID 5244 //
     /* 341010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341031 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 341031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 341034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341044 */     GIR_RootConstrainSelectedInstOperands,
     /* 341045 */     // GIR_Coverage, 5244,
     /* 341045 */     GIR_EraseRootFromParent_Done,
     /* 341046 */   // Label 6708: @341046
     /* 341046 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(341065), // Rule ID 521 //
     /* 341051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341058 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 341058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 341063 */     GIR_RootConstrainSelectedInstOperands,
     /* 341064 */     // GIR_Coverage, 521,
     /* 341064 */     GIR_Done,
     /* 341065 */   // Label 6709: @341065
     /* 341065 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(341210), // Rule ID 6424 //
     /* 341070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341074 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 341074 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 341077 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 341081 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 341088 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 341091 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 341095 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341100 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 341103 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 341107 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 341110 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341115 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341120 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341125 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 341128 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 341132 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341137 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 341140 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341145 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 341148 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 341152 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341157 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 341160 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 341165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 341167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 341170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 341174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341179 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 341182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 341190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341192 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 341199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341209 */     // GIR_Coverage, 6424,
     /* 341209 */     GIR_EraseRootFromParent_Done,
     /* 341210 */   // Label 6710: @341210
     /* 341210 */   GIM_Reject,
     /* 341211 */ // Label 6707: @341211
     /* 341211 */ GIM_Reject,
     /* 341212 */ // Label 6699: @341212
     /* 341212 */ GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(341285),
     /* 341217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341224 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(341265), // Rule ID 5245 //
     /* 341229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 341244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 341248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341250 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 341250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 341253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341263 */     GIR_RootConstrainSelectedInstOperands,
     /* 341264 */     // GIR_Coverage, 5245,
     /* 341264 */     GIR_EraseRootFromParent_Done,
     /* 341265 */   // Label 6712: @341265
     /* 341265 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(341284), // Rule ID 522 //
     /* 341270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341277 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 341277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 341282 */     GIR_RootConstrainSelectedInstOperands,
     /* 341283 */     // GIR_Coverage, 522,
     /* 341283 */     GIR_Done,
     /* 341284 */   // Label 6713: @341284
     /* 341284 */   GIM_Reject,
     /* 341285 */ // Label 6711: @341285
     /* 341285 */ GIM_Reject,
     /* 341286 */ // Label 6700: @341286
     /* 341286 */ GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(341359),
     /* 341291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341298 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(341339), // Rule ID 5246 //
     /* 341303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 341318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 341322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341324 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 341324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 341327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341337 */     GIR_RootConstrainSelectedInstOperands,
     /* 341338 */     // GIR_Coverage, 5246,
     /* 341338 */     GIR_EraseRootFromParent_Done,
     /* 341339 */   // Label 6715: @341339
     /* 341339 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(341358), // Rule ID 523 //
     /* 341344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341351 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 341351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 341356 */     GIR_RootConstrainSelectedInstOperands,
     /* 341357 */     // GIR_Coverage, 523,
     /* 341357 */     GIR_Done,
     /* 341358 */   // Label 6716: @341358
     /* 341358 */   GIM_Reject,
     /* 341359 */ // Label 6714: @341359
     /* 341359 */ GIM_Reject,
     /* 341360 */ // Label 6701: @341360
     /* 341360 */ GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(341433),
     /* 341365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341372 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(341413), // Rule ID 5037 //
     /* 341377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 341396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341398 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 341398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 341401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341411 */     GIR_RootConstrainSelectedInstOperands,
     /* 341412 */     // GIR_Coverage, 5037,
     /* 341412 */     GIR_EraseRootFromParent_Done,
     /* 341413 */   // Label 6718: @341413
     /* 341413 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(341432), // Rule ID 768 //
     /* 341418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341425 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 341425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 341430 */     GIR_RootConstrainSelectedInstOperands,
     /* 341431 */     // GIR_Coverage, 768,
     /* 341431 */     GIR_Done,
     /* 341432 */   // Label 6719: @341432
     /* 341432 */   GIM_Reject,
     /* 341433 */ // Label 6717: @341433
     /* 341433 */ GIM_Reject,
     /* 341434 */ // Label 6702: @341434
     /* 341434 */ GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(341507),
     /* 341439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341446 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(341487), // Rule ID 5039 //
     /* 341451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 341470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341472 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 341472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 341475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341485 */     GIR_RootConstrainSelectedInstOperands,
     /* 341486 */     // GIR_Coverage, 5039,
     /* 341486 */     GIR_EraseRootFromParent_Done,
     /* 341487 */   // Label 6721: @341487
     /* 341487 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(341506), // Rule ID 770 //
     /* 341492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341499 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 341499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 341504 */     GIR_RootConstrainSelectedInstOperands,
     /* 341505 */     // GIR_Coverage, 770,
     /* 341505 */     GIR_Done,
     /* 341506 */   // Label 6722: @341506
     /* 341506 */   GIM_Reject,
     /* 341507 */ // Label 6720: @341507
     /* 341507 */ GIM_Reject,
     /* 341508 */ // Label 6703: @341508
     /* 341508 */ GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(341615),
     /* 341513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341520 */   GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(341561), // Rule ID 5040 //
     /* 341525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 341544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341546 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 341546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 341549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341559 */     GIR_RootConstrainSelectedInstOperands,
     /* 341560 */     // GIR_Coverage, 5040,
     /* 341560 */     GIR_EraseRootFromParent_Done,
     /* 341561 */   // Label 6724: @341561
     /* 341561 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(341580), // Rule ID 766 //
     /* 341566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341573 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 341573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 341578 */     GIR_RootConstrainSelectedInstOperands,
     /* 341579 */     // GIR_Coverage, 766,
     /* 341579 */     GIR_Done,
     /* 341580 */   // Label 6725: @341580
     /* 341580 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(341614), // Rule ID 6426 //
     /* 341585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341592 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 341592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 341595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341599 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 341609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 341612 */     GIR_RootConstrainSelectedInstOperands,
     /* 341613 */     // GIR_Coverage, 6426,
     /* 341613 */     GIR_EraseRootFromParent_Done,
     /* 341614 */   // Label 6726: @341614
     /* 341614 */   GIM_Reject,
     /* 341615 */ // Label 6723: @341615
     /* 341615 */ GIM_Reject,
     /* 341616 */ // Label 6704: @341616
     /* 341616 */ GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(341689),
     /* 341621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341628 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(341669), // Rule ID 5038 //
     /* 341633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 341652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341654 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 341654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 341657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341667 */     GIR_RootConstrainSelectedInstOperands,
     /* 341668 */     // GIR_Coverage, 5038,
     /* 341668 */     GIR_EraseRootFromParent_Done,
     /* 341669 */   // Label 6728: @341669
     /* 341669 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(341688), // Rule ID 769 //
     /* 341674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341681 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 341681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 341686 */     GIR_RootConstrainSelectedInstOperands,
     /* 341687 */     // GIR_Coverage, 769,
     /* 341687 */     GIR_Done,
     /* 341688 */   // Label 6729: @341688
     /* 341688 */   GIM_Reject,
     /* 341689 */ // Label 6727: @341689
     /* 341689 */ GIM_Reject,
     /* 341690 */ // Label 6705: @341690
     /* 341690 */ GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(341797),
     /* 341695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341702 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(341743), // Rule ID 5041 //
     /* 341707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 341726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341728 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 341728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 341731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341741 */     GIR_RootConstrainSelectedInstOperands,
     /* 341742 */     // GIR_Coverage, 5041,
     /* 341742 */     GIR_EraseRootFromParent_Done,
     /* 341743 */   // Label 6731: @341743
     /* 341743 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(341762), // Rule ID 767 //
     /* 341748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341755 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 341755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 341760 */     GIR_RootConstrainSelectedInstOperands,
     /* 341761 */     // GIR_Coverage, 767,
     /* 341761 */     GIR_Done,
     /* 341762 */   // Label 6732: @341762
     /* 341762 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(341796), // Rule ID 6427 //
     /* 341767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341774 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 341774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 341777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341781 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 341791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 341794 */     GIR_RootConstrainSelectedInstOperands,
     /* 341795 */     // GIR_Coverage, 6427,
     /* 341795 */     GIR_EraseRootFromParent_Done,
     /* 341796 */   // Label 6733: @341796
     /* 341796 */   GIM_Reject,
     /* 341797 */ // Label 6730: @341797
     /* 341797 */ GIM_Reject,
     /* 341798 */ // Label 6706: @341798
     /* 341798 */ GIM_Reject,
     /* 341799 */ // Label 74: @341799
     /* 341799 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6742*/ GIMT_Encode4(342080),
     /* 341810 */ /*GILLT_s16*//*Label 6734*/ GIMT_Encode4(341850),
     /* 341814 */ /*GILLT_s32*//*Label 6735*/ GIMT_Encode4(341877),
     /* 341818 */ /*GILLT_s64*//*Label 6736*/ GIMT_Encode4(341901), GIMT_Encode4(0),
     /* 341826 */ /*GILLT_v2s32*//*Label 6737*/ GIMT_Encode4(341925),
     /* 341830 */ /*GILLT_v2s64*//*Label 6738*/ GIMT_Encode4(341956),
     /* 341834 */ /*GILLT_v4s16*//*Label 6739*/ GIMT_Encode4(341987),
     /* 341838 */ /*GILLT_v4s32*//*Label 6740*/ GIMT_Encode4(342018), GIMT_Encode4(0),
     /* 341846 */ /*GILLT_v8s16*//*Label 6741*/ GIMT_Encode4(342049),
     /* 341850 */ // Label 6734: @341850
     /* 341850 */ GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(341876), // Rule ID 4859 //
     /* 341855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341865 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 341865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 341868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341870 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 341872 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 341874 */   GIR_RootConstrainSelectedInstOperands,
     /* 341875 */   // GIR_Coverage, 4859,
     /* 341875 */   GIR_EraseRootFromParent_Done,
     /* 341876 */ // Label 6743: @341876
     /* 341876 */ GIM_Reject,
     /* 341877 */ // Label 6735: @341877
     /* 341877 */ GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(341900), // Rule ID 4856 //
     /* 341882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341889 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 341889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 341892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341894 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 341896 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 341898 */   GIR_RootConstrainSelectedInstOperands,
     /* 341899 */   // GIR_Coverage, 4856,
     /* 341899 */   GIR_EraseRootFromParent_Done,
     /* 341900 */ // Label 6744: @341900
     /* 341900 */ GIM_Reject,
     /* 341901 */ // Label 6736: @341901
     /* 341901 */ GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(341924), // Rule ID 4853 //
     /* 341906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341913 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 341913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 341916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341918 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 341920 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 341922 */   GIR_RootConstrainSelectedInstOperands,
     /* 341923 */   // GIR_Coverage, 4853,
     /* 341923 */   GIR_EraseRootFromParent_Done,
     /* 341924 */ // Label 6745: @341924
     /* 341924 */ GIM_Reject,
     /* 341925 */ // Label 6737: @341925
     /* 341925 */ GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(341955), // Rule ID 5050 //
     /* 341930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341944 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 341944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 341947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341949 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341951 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341953 */   GIR_RootConstrainSelectedInstOperands,
     /* 341954 */   // GIR_Coverage, 5050,
     /* 341954 */   GIR_EraseRootFromParent_Done,
     /* 341955 */ // Label 6746: @341955
     /* 341955 */ GIM_Reject,
     /* 341956 */ // Label 6738: @341956
     /* 341956 */ GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(341986), // Rule ID 5044 //
     /* 341961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341975 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 341975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 341978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341980 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341982 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341984 */   GIR_RootConstrainSelectedInstOperands,
     /* 341985 */   // GIR_Coverage, 5044,
     /* 341985 */   GIR_EraseRootFromParent_Done,
     /* 341986 */ // Label 6747: @341986
     /* 341986 */ GIM_Reject,
     /* 341987 */ // Label 6739: @341987
     /* 341987 */ GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(342017), // Rule ID 5056 //
     /* 341992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342006 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 342006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 342009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342011 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342013 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342015 */   GIR_RootConstrainSelectedInstOperands,
     /* 342016 */   // GIR_Coverage, 5056,
     /* 342016 */   GIR_EraseRootFromParent_Done,
     /* 342017 */ // Label 6748: @342017
     /* 342017 */ GIM_Reject,
     /* 342018 */ // Label 6740: @342018
     /* 342018 */ GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(342048), // Rule ID 5047 //
     /* 342023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342037 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 342037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 342040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342042 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342044 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342046 */   GIR_RootConstrainSelectedInstOperands,
     /* 342047 */   // GIR_Coverage, 5047,
     /* 342047 */   GIR_EraseRootFromParent_Done,
     /* 342048 */ // Label 6749: @342048
     /* 342048 */ GIM_Reject,
     /* 342049 */ // Label 6741: @342049
     /* 342049 */ GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(342079), // Rule ID 5053 //
     /* 342054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342068 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 342068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 342071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342073 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342075 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342077 */   GIR_RootConstrainSelectedInstOperands,
     /* 342078 */   // GIR_Coverage, 5053,
     /* 342078 */   GIR_EraseRootFromParent_Done,
     /* 342079 */ // Label 6750: @342079
     /* 342079 */ GIM_Reject,
     /* 342080 */ // Label 6742: @342080
     /* 342080 */ GIM_Reject,
     /* 342081 */ // Label 75: @342081
     /* 342081 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6759*/ GIMT_Encode4(342458),
     /* 342092 */ /*GILLT_s16*//*Label 6751*/ GIMT_Encode4(342132),
     /* 342096 */ /*GILLT_s32*//*Label 6752*/ GIMT_Encode4(342170),
     /* 342100 */ /*GILLT_s64*//*Label 6753*/ GIMT_Encode4(342208), GIMT_Encode4(0),
     /* 342108 */ /*GILLT_v2s32*//*Label 6754*/ GIMT_Encode4(342268),
     /* 342112 */ /*GILLT_v2s64*//*Label 6755*/ GIMT_Encode4(342306),
     /* 342116 */ /*GILLT_v4s16*//*Label 6756*/ GIMT_Encode4(342344),
     /* 342120 */ /*GILLT_v4s32*//*Label 6757*/ GIMT_Encode4(342382), GIMT_Encode4(0),
     /* 342128 */ /*GILLT_v8s16*//*Label 6758*/ GIMT_Encode4(342420),
     /* 342132 */ // Label 6751: @342132
     /* 342132 */ GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(342169), // Rule ID 608 //
     /* 342137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342158 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 342158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 342163 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342167 */   GIR_RootConstrainSelectedInstOperands,
     /* 342168 */   // GIR_Coverage, 608,
     /* 342168 */   GIR_Done,
     /* 342169 */ // Label 6760: @342169
     /* 342169 */ GIM_Reject,
     /* 342170 */ // Label 6752: @342170
     /* 342170 */ GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(342207), // Rule ID 610 //
     /* 342175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342196 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 342196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 342201 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342205 */   GIR_RootConstrainSelectedInstOperands,
     /* 342206 */   // GIR_Coverage, 610,
     /* 342206 */   GIR_Done,
     /* 342207 */ // Label 6761: @342207
     /* 342207 */ GIM_Reject,
     /* 342208 */ // Label 6753: @342208
     /* 342208 */ GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(342267),
     /* 342213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 342219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342227 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342231 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(342250), // Rule ID 612 //
     /* 342236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342239 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 342239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 342244 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342248 */     GIR_RootConstrainSelectedInstOperands,
     /* 342249 */     // GIR_Coverage, 612,
     /* 342249 */     GIR_Done,
     /* 342250 */   // Label 6763: @342250
     /* 342250 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(342266), // Rule ID 4850 //
     /* 342255 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 342255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 342260 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342264 */     GIR_RootConstrainSelectedInstOperands,
     /* 342265 */     // GIR_Coverage, 4850,
     /* 342265 */     GIR_Done,
     /* 342266 */   // Label 6764: @342266
     /* 342266 */   GIM_Reject,
     /* 342267 */ // Label 6762: @342267
     /* 342267 */ GIM_Reject,
     /* 342268 */ // Label 6754: @342268
     /* 342268 */ GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(342305), // Rule ID 1273 //
     /* 342273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 342282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342294 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 342294 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 342299 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342303 */   GIR_RootConstrainSelectedInstOperands,
     /* 342304 */   // GIR_Coverage, 1273,
     /* 342304 */   GIR_Done,
     /* 342305 */ // Label 6765: @342305
     /* 342305 */ GIM_Reject,
     /* 342306 */ // Label 6755: @342306
     /* 342306 */ GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(342343), // Rule ID 1277 //
     /* 342311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 342320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342328 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342332 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 342332 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 342337 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342341 */   GIR_RootConstrainSelectedInstOperands,
     /* 342342 */   // GIR_Coverage, 1277,
     /* 342342 */   GIR_Done,
     /* 342343 */ // Label 6766: @342343
     /* 342343 */ GIM_Reject,
     /* 342344 */ // Label 6756: @342344
     /* 342344 */ GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(342381), // Rule ID 1269 //
     /* 342349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 342358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342366 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342370 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 342370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 342375 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342379 */   GIR_RootConstrainSelectedInstOperands,
     /* 342380 */   // GIR_Coverage, 1269,
     /* 342380 */   GIR_Done,
     /* 342381 */ // Label 6767: @342381
     /* 342381 */ GIM_Reject,
     /* 342382 */ // Label 6757: @342382
     /* 342382 */ GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(342419), // Rule ID 1275 //
     /* 342387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 342396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342404 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342408 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 342408 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 342413 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342417 */   GIR_RootConstrainSelectedInstOperands,
     /* 342418 */   // GIR_Coverage, 1275,
     /* 342418 */   GIR_Done,
     /* 342419 */ // Label 6768: @342419
     /* 342419 */ GIM_Reject,
     /* 342420 */ // Label 6758: @342420
     /* 342420 */ GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(342457), // Rule ID 1271 //
     /* 342425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 342434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342442 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342446 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 342446 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 342451 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342455 */   GIR_RootConstrainSelectedInstOperands,
     /* 342456 */   // GIR_Coverage, 1271,
     /* 342456 */   GIR_Done,
     /* 342457 */ // Label 6769: @342457
     /* 342457 */ GIM_Reject,
     /* 342458 */ // Label 6759: @342458
     /* 342458 */ GIM_Reject,
     /* 342459 */ // Label 76: @342459
     /* 342459 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6778*/ GIMT_Encode4(342836),
     /* 342470 */ /*GILLT_s16*//*Label 6770*/ GIMT_Encode4(342510),
     /* 342474 */ /*GILLT_s32*//*Label 6771*/ GIMT_Encode4(342548),
     /* 342478 */ /*GILLT_s64*//*Label 6772*/ GIMT_Encode4(342586), GIMT_Encode4(0),
     /* 342486 */ /*GILLT_v2s32*//*Label 6773*/ GIMT_Encode4(342646),
     /* 342490 */ /*GILLT_v2s64*//*Label 6774*/ GIMT_Encode4(342684),
     /* 342494 */ /*GILLT_v4s16*//*Label 6775*/ GIMT_Encode4(342722),
     /* 342498 */ /*GILLT_v4s32*//*Label 6776*/ GIMT_Encode4(342760), GIMT_Encode4(0),
     /* 342506 */ /*GILLT_v8s16*//*Label 6777*/ GIMT_Encode4(342798),
     /* 342510 */ // Label 6770: @342510
     /* 342510 */ GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(342547), // Rule ID 596 //
     /* 342515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342532 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342536 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 342536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 342541 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342545 */   GIR_RootConstrainSelectedInstOperands,
     /* 342546 */   // GIR_Coverage, 596,
     /* 342546 */   GIR_Done,
     /* 342547 */ // Label 6779: @342547
     /* 342547 */ GIM_Reject,
     /* 342548 */ // Label 6771: @342548
     /* 342548 */ GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(342585), // Rule ID 598 //
     /* 342553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342574 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 342574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 342579 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342583 */   GIR_RootConstrainSelectedInstOperands,
     /* 342584 */   // GIR_Coverage, 598,
     /* 342584 */   GIR_Done,
     /* 342585 */ // Label 6780: @342585
     /* 342585 */ GIM_Reject,
     /* 342586 */ // Label 6772: @342586
     /* 342586 */ GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(342645),
     /* 342591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 342597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342609 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(342628), // Rule ID 600 //
     /* 342614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342617 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 342617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 342622 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342626 */     GIR_RootConstrainSelectedInstOperands,
     /* 342627 */     // GIR_Coverage, 600,
     /* 342627 */     GIR_Done,
     /* 342628 */   // Label 6782: @342628
     /* 342628 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(342644), // Rule ID 4849 //
     /* 342633 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 342633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 342638 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342642 */     GIR_RootConstrainSelectedInstOperands,
     /* 342643 */     // GIR_Coverage, 4849,
     /* 342643 */     GIR_Done,
     /* 342644 */   // Label 6783: @342644
     /* 342644 */   GIM_Reject,
     /* 342645 */ // Label 6781: @342645
     /* 342645 */ GIM_Reject,
     /* 342646 */ // Label 6773: @342646
     /* 342646 */ GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(342683), // Rule ID 1243 //
     /* 342651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 342660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342672 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 342672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 342677 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342681 */   GIR_RootConstrainSelectedInstOperands,
     /* 342682 */   // GIR_Coverage, 1243,
     /* 342682 */   GIR_Done,
     /* 342683 */ // Label 6784: @342683
     /* 342683 */ GIM_Reject,
     /* 342684 */ // Label 6774: @342684
     /* 342684 */ GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(342721), // Rule ID 1247 //
     /* 342689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 342698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342706 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342710 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 342710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 342715 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342719 */   GIR_RootConstrainSelectedInstOperands,
     /* 342720 */   // GIR_Coverage, 1247,
     /* 342720 */   GIR_Done,
     /* 342721 */ // Label 6785: @342721
     /* 342721 */ GIM_Reject,
     /* 342722 */ // Label 6775: @342722
     /* 342722 */ GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(342759), // Rule ID 1239 //
     /* 342727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 342736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342748 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 342748 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 342753 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342757 */   GIR_RootConstrainSelectedInstOperands,
     /* 342758 */   // GIR_Coverage, 1239,
     /* 342758 */   GIR_Done,
     /* 342759 */ // Label 6786: @342759
     /* 342759 */ GIM_Reject,
     /* 342760 */ // Label 6776: @342760
     /* 342760 */ GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(342797), // Rule ID 1245 //
     /* 342765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 342774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342786 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 342786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 342791 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342795 */   GIR_RootConstrainSelectedInstOperands,
     /* 342796 */   // GIR_Coverage, 1245,
     /* 342796 */   GIR_Done,
     /* 342797 */ // Label 6787: @342797
     /* 342797 */ GIM_Reject,
     /* 342798 */ // Label 6777: @342798
     /* 342798 */ GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(342835), // Rule ID 1241 //
     /* 342803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 342812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342824 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 342824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 342829 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342833 */   GIR_RootConstrainSelectedInstOperands,
     /* 342834 */   // GIR_Coverage, 1241,
     /* 342834 */   GIR_Done,
     /* 342835 */ // Label 6788: @342835
     /* 342835 */ GIM_Reject,
     /* 342836 */ // Label 6778: @342836
     /* 342836 */ GIM_Reject,
     /* 342837 */ // Label 77: @342837
     /* 342837 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6797*/ GIMT_Encode4(343186),
     /* 342848 */ /*GILLT_s16*//*Label 6789*/ GIMT_Encode4(342888),
     /* 342852 */ /*GILLT_s32*//*Label 6790*/ GIMT_Encode4(342926),
     /* 342856 */ /*GILLT_s64*//*Label 6791*/ GIMT_Encode4(342961), GIMT_Encode4(0),
     /* 342864 */ /*GILLT_v2s32*//*Label 6792*/ GIMT_Encode4(342996),
     /* 342868 */ /*GILLT_v2s64*//*Label 6793*/ GIMT_Encode4(343034),
     /* 342872 */ /*GILLT_v4s16*//*Label 6794*/ GIMT_Encode4(343072),
     /* 342876 */ /*GILLT_v4s32*//*Label 6795*/ GIMT_Encode4(343110), GIMT_Encode4(0),
     /* 342884 */ /*GILLT_v8s16*//*Label 6796*/ GIMT_Encode4(343148),
     /* 342888 */ // Label 6789: @342888
     /* 342888 */ GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(342925), // Rule ID 4857 //
     /* 342893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342914 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 342914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 342919 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342923 */   GIR_RootConstrainSelectedInstOperands,
     /* 342924 */   // GIR_Coverage, 4857,
     /* 342924 */   GIR_Done,
     /* 342925 */ // Label 6798: @342925
     /* 342925 */ GIM_Reject,
     /* 342926 */ // Label 6790: @342926
     /* 342926 */ GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(342960), // Rule ID 4854 //
     /* 342931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342949 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 342949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 342954 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342958 */   GIR_RootConstrainSelectedInstOperands,
     /* 342959 */   // GIR_Coverage, 4854,
     /* 342959 */   GIR_Done,
     /* 342960 */ // Label 6799: @342960
     /* 342960 */ GIM_Reject,
     /* 342961 */ // Label 6791: @342961
     /* 342961 */ GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(342995), // Rule ID 4851 //
     /* 342966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 342972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342984 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 342984 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 342989 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342993 */   GIR_RootConstrainSelectedInstOperands,
     /* 342994 */   // GIR_Coverage, 4851,
     /* 342994 */   GIR_Done,
     /* 342995 */ // Label 6800: @342995
     /* 342995 */ GIM_Reject,
     /* 342996 */ // Label 6792: @342996
     /* 342996 */ GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(343033), // Rule ID 5048 //
     /* 343001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 343010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343022 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343022 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 343027 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343031 */   GIR_RootConstrainSelectedInstOperands,
     /* 343032 */   // GIR_Coverage, 5048,
     /* 343032 */   GIR_Done,
     /* 343033 */ // Label 6801: @343033
     /* 343033 */ GIM_Reject,
     /* 343034 */ // Label 6793: @343034
     /* 343034 */ GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(343071), // Rule ID 5042 //
     /* 343039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 343048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343056 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343060 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343060 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 343065 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343069 */   GIR_RootConstrainSelectedInstOperands,
     /* 343070 */   // GIR_Coverage, 5042,
     /* 343070 */   GIR_Done,
     /* 343071 */ // Label 6802: @343071
     /* 343071 */ GIM_Reject,
     /* 343072 */ // Label 6794: @343072
     /* 343072 */ GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(343109), // Rule ID 5054 //
     /* 343077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343098 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 343103 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343107 */   GIR_RootConstrainSelectedInstOperands,
     /* 343108 */   // GIR_Coverage, 5054,
     /* 343108 */   GIR_Done,
     /* 343109 */ // Label 6803: @343109
     /* 343109 */ GIM_Reject,
     /* 343110 */ // Label 6795: @343110
     /* 343110 */ GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(343147), // Rule ID 5045 //
     /* 343115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 343124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343136 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 343141 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343145 */   GIR_RootConstrainSelectedInstOperands,
     /* 343146 */   // GIR_Coverage, 5045,
     /* 343146 */   GIR_Done,
     /* 343147 */ // Label 6804: @343147
     /* 343147 */ GIM_Reject,
     /* 343148 */ // Label 6796: @343148
     /* 343148 */ GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(343185), // Rule ID 5051 //
     /* 343153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343174 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343174 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 343179 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343183 */   GIR_RootConstrainSelectedInstOperands,
     /* 343184 */   // GIR_Coverage, 5051,
     /* 343184 */   GIR_Done,
     /* 343185 */ // Label 6805: @343185
     /* 343185 */ GIM_Reject,
     /* 343186 */ // Label 6797: @343186
     /* 343186 */ GIM_Reject,
     /* 343187 */ // Label 78: @343187
     /* 343187 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6814*/ GIMT_Encode4(343536),
     /* 343198 */ /*GILLT_s16*//*Label 6806*/ GIMT_Encode4(343238),
     /* 343202 */ /*GILLT_s32*//*Label 6807*/ GIMT_Encode4(343276),
     /* 343206 */ /*GILLT_s64*//*Label 6808*/ GIMT_Encode4(343311), GIMT_Encode4(0),
     /* 343214 */ /*GILLT_v2s32*//*Label 6809*/ GIMT_Encode4(343346),
     /* 343218 */ /*GILLT_v2s64*//*Label 6810*/ GIMT_Encode4(343384),
     /* 343222 */ /*GILLT_v4s16*//*Label 6811*/ GIMT_Encode4(343422),
     /* 343226 */ /*GILLT_v4s32*//*Label 6812*/ GIMT_Encode4(343460), GIMT_Encode4(0),
     /* 343234 */ /*GILLT_v8s16*//*Label 6813*/ GIMT_Encode4(343498),
     /* 343238 */ // Label 6806: @343238
     /* 343238 */ GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(343275), // Rule ID 4858 //
     /* 343243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 343246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 343249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343264 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 343264 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 343269 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343273 */   GIR_RootConstrainSelectedInstOperands,
     /* 343274 */   // GIR_Coverage, 4858,
     /* 343274 */   GIR_Done,
     /* 343275 */ // Label 6815: @343275
     /* 343275 */ GIM_Reject,
     /* 343276 */ // Label 6807: @343276
     /* 343276 */ GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(343310), // Rule ID 4855 //
     /* 343281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 343284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343295 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343299 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 343299 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 343304 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343308 */   GIR_RootConstrainSelectedInstOperands,
     /* 343309 */   // GIR_Coverage, 4855,
     /* 343309 */   GIR_Done,
     /* 343310 */ // Label 6816: @343310
     /* 343310 */ GIM_Reject,
     /* 343311 */ // Label 6808: @343311
     /* 343311 */ GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(343345), // Rule ID 4852 //
     /* 343316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 343322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343330 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343334 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 343334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 343339 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343343 */   GIR_RootConstrainSelectedInstOperands,
     /* 343344 */   // GIR_Coverage, 4852,
     /* 343344 */   GIR_Done,
     /* 343345 */ // Label 6817: @343345
     /* 343345 */ GIM_Reject,
     /* 343346 */ // Label 6809: @343346
     /* 343346 */ GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(343383), // Rule ID 5049 //
     /* 343351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 343360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343372 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343372 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 343377 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343381 */   GIR_RootConstrainSelectedInstOperands,
     /* 343382 */   // GIR_Coverage, 5049,
     /* 343382 */   GIR_Done,
     /* 343383 */ // Label 6818: @343383
     /* 343383 */ GIM_Reject,
     /* 343384 */ // Label 6810: @343384
     /* 343384 */ GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(343421), // Rule ID 5043 //
     /* 343389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 343398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343406 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343410 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343410 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 343415 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343419 */   GIR_RootConstrainSelectedInstOperands,
     /* 343420 */   // GIR_Coverage, 5043,
     /* 343420 */   GIR_Done,
     /* 343421 */ // Label 6819: @343421
     /* 343421 */ GIM_Reject,
     /* 343422 */ // Label 6811: @343422
     /* 343422 */ GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(343459), // Rule ID 5055 //
     /* 343427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343448 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 343453 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343457 */   GIR_RootConstrainSelectedInstOperands,
     /* 343458 */   // GIR_Coverage, 5055,
     /* 343458 */   GIR_Done,
     /* 343459 */ // Label 6820: @343459
     /* 343459 */ GIM_Reject,
     /* 343460 */ // Label 6812: @343460
     /* 343460 */ GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(343497), // Rule ID 5046 //
     /* 343465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 343474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343482 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343486 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343486 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 343491 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343495 */   GIR_RootConstrainSelectedInstOperands,
     /* 343496 */   // GIR_Coverage, 5046,
     /* 343496 */   GIR_Done,
     /* 343497 */ // Label 6821: @343497
     /* 343497 */ GIM_Reject,
     /* 343498 */ // Label 6813: @343498
     /* 343498 */ GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(343535), // Rule ID 5052 //
     /* 343503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343524 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343524 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 343529 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343533 */   GIR_RootConstrainSelectedInstOperands,
     /* 343534 */   // GIR_Coverage, 5052,
     /* 343534 */   GIR_Done,
     /* 343535 */ // Label 6822: @343535
     /* 343535 */ GIM_Reject,
     /* 343536 */ // Label 6814: @343536
     /* 343536 */ GIM_Reject,
     /* 343537 */ // Label 79: @343537
     /* 343537 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6831*/ GIMT_Encode4(344239),
     /* 343548 */ /*GILLT_s16*//*Label 6823*/ GIMT_Encode4(343588),
     /* 343552 */ /*GILLT_s32*//*Label 6824*/ GIMT_Encode4(343626),
     /* 343556 */ /*GILLT_s64*//*Label 6825*/ GIMT_Encode4(343664), GIMT_Encode4(0),
     /* 343564 */ /*GILLT_v2s32*//*Label 6826*/ GIMT_Encode4(343724),
     /* 343568 */ /*GILLT_v2s64*//*Label 6827*/ GIMT_Encode4(343827),
     /* 343572 */ /*GILLT_v4s16*//*Label 6828*/ GIMT_Encode4(343930),
     /* 343576 */ /*GILLT_v4s32*//*Label 6829*/ GIMT_Encode4(344033), GIMT_Encode4(0),
     /* 343584 */ /*GILLT_v8s16*//*Label 6830*/ GIMT_Encode4(344136),
     /* 343588 */ // Label 6823: @343588
     /* 343588 */ GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(343625), // Rule ID 614 //
     /* 343593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 343596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 343599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343614 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 343614 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 343619 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343623 */   GIR_RootConstrainSelectedInstOperands,
     /* 343624 */   // GIR_Coverage, 614,
     /* 343624 */   GIR_Done,
     /* 343625 */ // Label 6832: @343625
     /* 343625 */ GIM_Reject,
     /* 343626 */ // Label 6824: @343626
     /* 343626 */ GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(343663), // Rule ID 616 //
     /* 343631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 343637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343648 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343652 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 343652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 343657 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343661 */   GIR_RootConstrainSelectedInstOperands,
     /* 343662 */   // GIR_Coverage, 616,
     /* 343662 */   GIR_Done,
     /* 343663 */ // Label 6833: @343663
     /* 343663 */ GIM_Reject,
     /* 343664 */ // Label 6825: @343664
     /* 343664 */ GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(343723),
     /* 343669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 343675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343687 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(343706), // Rule ID 618 //
     /* 343692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343695 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 343695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 343700 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343704 */     GIR_RootConstrainSelectedInstOperands,
     /* 343705 */     // GIR_Coverage, 618,
     /* 343705 */     GIR_Done,
     /* 343706 */   // Label 6835: @343706
     /* 343706 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(343722), // Rule ID 4848 //
     /* 343711 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 343711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 343716 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343720 */     GIR_RootConstrainSelectedInstOperands,
     /* 343721 */     // GIR_Coverage, 4848,
     /* 343721 */     GIR_Done,
     /* 343722 */   // Label 6836: @343722
     /* 343722 */   GIM_Reject,
     /* 343723 */ // Label 6834: @343723
     /* 343723 */ GIM_Reject,
     /* 343724 */ // Label 6826: @343724
     /* 343724 */ GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(343826),
     /* 343729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 343735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343739 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(343798), // Rule ID 2366 //
     /* 343744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343783 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 343786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343796 */     GIR_RootConstrainSelectedInstOperands,
     /* 343797 */     // GIR_Coverage, 2366,
     /* 343797 */     GIR_EraseRootFromParent_Done,
     /* 343798 */   // Label 6838: @343798
     /* 343798 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(343825), // Rule ID 1288 //
     /* 343803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343814 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 343819 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343823 */     GIR_RootConstrainSelectedInstOperands,
     /* 343824 */     // GIR_Coverage, 1288,
     /* 343824 */     GIR_Done,
     /* 343825 */   // Label 6839: @343825
     /* 343825 */   GIM_Reject,
     /* 343826 */ // Label 6837: @343826
     /* 343826 */ GIM_Reject,
     /* 343827 */ // Label 6827: @343827
     /* 343827 */ GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(343929),
     /* 343832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 343838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343842 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(343901), // Rule ID 2372 //
     /* 343847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343879 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343886 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 343889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 343899 */     GIR_RootConstrainSelectedInstOperands,
     /* 343900 */     // GIR_Coverage, 2372,
     /* 343900 */     GIR_EraseRootFromParent_Done,
     /* 343901 */   // Label 6841: @343901
     /* 343901 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(343928), // Rule ID 1292 //
     /* 343906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343917 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 343922 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343926 */     GIR_RootConstrainSelectedInstOperands,
     /* 343927 */     // GIR_Coverage, 1292,
     /* 343927 */     GIR_Done,
     /* 343928 */   // Label 6842: @343928
     /* 343928 */   GIM_Reject,
     /* 343929 */ // Label 6840: @343929
     /* 343929 */ GIM_Reject,
     /* 343930 */ // Label 6828: @343930
     /* 343930 */ GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(344032),
     /* 343935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343945 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(344004), // Rule ID 2360 //
     /* 343950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 343953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 343978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343989 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 343992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 343994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344002 */     GIR_RootConstrainSelectedInstOperands,
     /* 344003 */     // GIR_Coverage, 2360,
     /* 344003 */     GIR_EraseRootFromParent_Done,
     /* 344004 */   // Label 6844: @344004
     /* 344004 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(344031), // Rule ID 1284 //
     /* 344009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344020 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 344025 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344029 */     GIR_RootConstrainSelectedInstOperands,
     /* 344030 */     // GIR_Coverage, 1284,
     /* 344030 */     GIR_Done,
     /* 344031 */   // Label 6845: @344031
     /* 344031 */   GIM_Reject,
     /* 344032 */ // Label 6843: @344032
     /* 344032 */ GIM_Reject,
     /* 344033 */ // Label 6829: @344033
     /* 344033 */ GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(344135),
     /* 344038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344048 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(344107), // Rule ID 2369 //
     /* 344053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344092 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 344095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344105 */     GIR_RootConstrainSelectedInstOperands,
     /* 344106 */     // GIR_Coverage, 2369,
     /* 344106 */     GIR_EraseRootFromParent_Done,
     /* 344107 */   // Label 6847: @344107
     /* 344107 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(344134), // Rule ID 1290 //
     /* 344112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344123 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 344128 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344132 */     GIR_RootConstrainSelectedInstOperands,
     /* 344133 */     // GIR_Coverage, 1290,
     /* 344133 */     GIR_Done,
     /* 344134 */   // Label 6848: @344134
     /* 344134 */   GIM_Reject,
     /* 344135 */ // Label 6846: @344135
     /* 344135 */ GIM_Reject,
     /* 344136 */ // Label 6830: @344136
     /* 344136 */ GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(344238),
     /* 344141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344151 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(344210), // Rule ID 2363 //
     /* 344156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344195 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 344198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344208 */     GIR_RootConstrainSelectedInstOperands,
     /* 344209 */     // GIR_Coverage, 2363,
     /* 344209 */     GIR_EraseRootFromParent_Done,
     /* 344210 */   // Label 6850: @344210
     /* 344210 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(344237), // Rule ID 1286 //
     /* 344215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344226 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 344231 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344235 */     GIR_RootConstrainSelectedInstOperands,
     /* 344236 */     // GIR_Coverage, 1286,
     /* 344236 */     GIR_Done,
     /* 344237 */   // Label 6851: @344237
     /* 344237 */   GIM_Reject,
     /* 344238 */ // Label 6849: @344238
     /* 344238 */ GIM_Reject,
     /* 344239 */ // Label 6831: @344239
     /* 344239 */ GIM_Reject,
     /* 344240 */ // Label 80: @344240
     /* 344240 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6860*/ GIMT_Encode4(344942),
     /* 344251 */ /*GILLT_s16*//*Label 6852*/ GIMT_Encode4(344291),
     /* 344255 */ /*GILLT_s32*//*Label 6853*/ GIMT_Encode4(344329),
     /* 344259 */ /*GILLT_s64*//*Label 6854*/ GIMT_Encode4(344367), GIMT_Encode4(0),
     /* 344267 */ /*GILLT_v2s32*//*Label 6855*/ GIMT_Encode4(344427),
     /* 344271 */ /*GILLT_v2s64*//*Label 6856*/ GIMT_Encode4(344530),
     /* 344275 */ /*GILLT_v4s16*//*Label 6857*/ GIMT_Encode4(344633),
     /* 344279 */ /*GILLT_v4s32*//*Label 6858*/ GIMT_Encode4(344736), GIMT_Encode4(0),
     /* 344287 */ /*GILLT_v8s16*//*Label 6859*/ GIMT_Encode4(344839),
     /* 344291 */ // Label 6852: @344291
     /* 344291 */ GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(344328), // Rule ID 602 //
     /* 344296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 344299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 344302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344313 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344317 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 344317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 344322 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344326 */   GIR_RootConstrainSelectedInstOperands,
     /* 344327 */   // GIR_Coverage, 602,
     /* 344327 */   GIR_Done,
     /* 344328 */ // Label 6861: @344328
     /* 344328 */ GIM_Reject,
     /* 344329 */ // Label 6853: @344329
     /* 344329 */ GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(344366), // Rule ID 604 //
     /* 344334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 344337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344355 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 344355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 344360 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344364 */   GIR_RootConstrainSelectedInstOperands,
     /* 344365 */   // GIR_Coverage, 604,
     /* 344365 */   GIR_Done,
     /* 344366 */ // Label 6862: @344366
     /* 344366 */ GIM_Reject,
     /* 344367 */ // Label 6854: @344367
     /* 344367 */ GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(344426),
     /* 344372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344386 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344390 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(344409), // Rule ID 606 //
     /* 344395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 344398 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 344398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 344403 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344407 */     GIR_RootConstrainSelectedInstOperands,
     /* 344408 */     // GIR_Coverage, 606,
     /* 344408 */     GIR_Done,
     /* 344409 */   // Label 6864: @344409
     /* 344409 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(344425), // Rule ID 4847 //
     /* 344414 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 344414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 344419 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344423 */     GIR_RootConstrainSelectedInstOperands,
     /* 344424 */     // GIR_Coverage, 4847,
     /* 344424 */     GIR_Done,
     /* 344425 */   // Label 6865: @344425
     /* 344425 */   GIM_Reject,
     /* 344426 */ // Label 6863: @344426
     /* 344426 */ GIM_Reject,
     /* 344427 */ // Label 6855: @344427
     /* 344427 */ GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(344529),
     /* 344432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 344438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344442 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(344501), // Rule ID 2351 //
     /* 344447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344486 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 344486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 344489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344499 */     GIR_RootConstrainSelectedInstOperands,
     /* 344500 */     // GIR_Coverage, 2351,
     /* 344500 */     GIR_EraseRootFromParent_Done,
     /* 344501 */   // Label 6867: @344501
     /* 344501 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(344528), // Rule ID 1258 //
     /* 344506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344517 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 344517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 344522 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344526 */     GIR_RootConstrainSelectedInstOperands,
     /* 344527 */     // GIR_Coverage, 1258,
     /* 344527 */     GIR_Done,
     /* 344528 */   // Label 6868: @344528
     /* 344528 */   GIM_Reject,
     /* 344529 */ // Label 6866: @344529
     /* 344529 */ GIM_Reject,
     /* 344530 */ // Label 6856: @344530
     /* 344530 */ GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(344632),
     /* 344535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 344541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344545 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(344604), // Rule ID 2357 //
     /* 344550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344589 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 344589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 344592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344602 */     GIR_RootConstrainSelectedInstOperands,
     /* 344603 */     // GIR_Coverage, 2357,
     /* 344603 */     GIR_EraseRootFromParent_Done,
     /* 344604 */   // Label 6870: @344604
     /* 344604 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(344631), // Rule ID 1262 //
     /* 344609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344620 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 344620 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 344625 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344629 */     GIR_RootConstrainSelectedInstOperands,
     /* 344630 */     // GIR_Coverage, 1262,
     /* 344630 */     GIR_Done,
     /* 344631 */   // Label 6871: @344631
     /* 344631 */   GIM_Reject,
     /* 344632 */ // Label 6869: @344632
     /* 344632 */ GIM_Reject,
     /* 344633 */ // Label 6857: @344633
     /* 344633 */ GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(344735),
     /* 344638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344648 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(344707), // Rule ID 2345 //
     /* 344653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344692 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 344695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344705 */     GIR_RootConstrainSelectedInstOperands,
     /* 344706 */     // GIR_Coverage, 2345,
     /* 344706 */     GIR_EraseRootFromParent_Done,
     /* 344707 */   // Label 6873: @344707
     /* 344707 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(344734), // Rule ID 1254 //
     /* 344712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344723 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 344728 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344732 */     GIR_RootConstrainSelectedInstOperands,
     /* 344733 */     // GIR_Coverage, 1254,
     /* 344733 */     GIR_Done,
     /* 344734 */   // Label 6874: @344734
     /* 344734 */   GIM_Reject,
     /* 344735 */ // Label 6872: @344735
     /* 344735 */ GIM_Reject,
     /* 344736 */ // Label 6858: @344736
     /* 344736 */ GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(344838),
     /* 344741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344751 */   GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(344810), // Rule ID 2354 //
     /* 344756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344795 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 344798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344808 */     GIR_RootConstrainSelectedInstOperands,
     /* 344809 */     // GIR_Coverage, 2354,
     /* 344809 */     GIR_EraseRootFromParent_Done,
     /* 344810 */   // Label 6876: @344810
     /* 344810 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(344837), // Rule ID 1260 //
     /* 344815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344826 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 344831 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344835 */     GIR_RootConstrainSelectedInstOperands,
     /* 344836 */     // GIR_Coverage, 1260,
     /* 344836 */     GIR_Done,
     /* 344837 */   // Label 6877: @344837
     /* 344837 */   GIM_Reject,
     /* 344838 */ // Label 6875: @344838
     /* 344838 */ GIM_Reject,
     /* 344839 */ // Label 6859: @344839
     /* 344839 */ GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(344941),
     /* 344844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344854 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(344913), // Rule ID 2348 //
     /* 344859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344898 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 344901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344911 */     GIR_RootConstrainSelectedInstOperands,
     /* 344912 */     // GIR_Coverage, 2348,
     /* 344912 */     GIR_EraseRootFromParent_Done,
     /* 344913 */   // Label 6879: @344913
     /* 344913 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(344940), // Rule ID 1256 //
     /* 344918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344929 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 344934 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344938 */     GIR_RootConstrainSelectedInstOperands,
     /* 344939 */     // GIR_Coverage, 1256,
     /* 344939 */     GIR_Done,
     /* 344940 */   // Label 6880: @344940
     /* 344940 */   GIM_Reject,
     /* 344941 */ // Label 6878: @344941
     /* 344941 */ GIM_Reject,
     /* 344942 */ // Label 6860: @344942
     /* 344942 */ GIM_Reject,
     /* 344943 */ // Label 81: @344943
     /* 344943 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6889*/ GIMT_Encode4(345346),
     /* 344954 */ /*GILLT_s32*//*Label 6881*/ GIMT_Encode4(344994),
     /* 344958 */ /*GILLT_s64*//*Label 6882*/ GIMT_Encode4(345068), GIMT_Encode4(0),
     /* 344966 */ /*GILLT_v2s32*//*Label 6883*/ GIMT_Encode4(345142), GIMT_Encode4(0),
     /* 344974 */ /*GILLT_v4s16*//*Label 6884*/ GIMT_Encode4(345176),
     /* 344978 */ /*GILLT_v4s32*//*Label 6885*/ GIMT_Encode4(345210),
     /* 344982 */ /*GILLT_v8s8*//*Label 6886*/ GIMT_Encode4(345244),
     /* 344986 */ /*GILLT_v8s16*//*Label 6887*/ GIMT_Encode4(345278),
     /* 344990 */ /*GILLT_v16s8*//*Label 6888*/ GIMT_Encode4(345312),
     /* 344994 */ // Label 6881: @344994
     /* 344994 */ GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(345067),
     /* 344999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 345002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345013 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(345047), // Rule ID 2328 //
     /* 345018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 345033 */     // MIs[1] Operand 1
     /* 345033 */     // No operand predicates
     /* 345033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345035 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 345035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 345038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345040 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345045 */     GIR_RootConstrainSelectedInstOperands,
     /* 345046 */     // GIR_Coverage, 2328,
     /* 345046 */     GIR_EraseRootFromParent_Done,
     /* 345047 */   // Label 6891: @345047
     /* 345047 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(345066), // Rule ID 2327 //
     /* 345052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345059 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 345059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 345064 */     GIR_RootConstrainSelectedInstOperands,
     /* 345065 */     // GIR_Coverage, 2327,
     /* 345065 */     GIR_Done,
     /* 345066 */   // Label 6892: @345066
     /* 345066 */   GIM_Reject,
     /* 345067 */ // Label 6890: @345067
     /* 345067 */ GIM_Reject,
     /* 345068 */ // Label 6882: @345068
     /* 345068 */ GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(345141),
     /* 345073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 345076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 345079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345087 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(345121), // Rule ID 2330 //
     /* 345092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 345107 */     // MIs[1] Operand 1
     /* 345107 */     // No operand predicates
     /* 345107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345109 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 345109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 345112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345119 */     GIR_RootConstrainSelectedInstOperands,
     /* 345120 */     // GIR_Coverage, 2330,
     /* 345120 */     GIR_EraseRootFromParent_Done,
     /* 345121 */   // Label 6894: @345121
     /* 345121 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(345140), // Rule ID 2329 //
     /* 345126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345133 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 345133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 345138 */     GIR_RootConstrainSelectedInstOperands,
     /* 345139 */     // GIR_Coverage, 2329,
     /* 345139 */     GIR_Done,
     /* 345140 */   // Label 6895: @345140
     /* 345140 */   GIM_Reject,
     /* 345141 */ // Label 6893: @345141
     /* 345141 */ GIM_Reject,
     /* 345142 */ // Label 6883: @345142
     /* 345142 */ GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(345175), // Rule ID 1414 //
     /* 345147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345164 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345168 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 345168 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 345173 */   GIR_RootConstrainSelectedInstOperands,
     /* 345174 */   // GIR_Coverage, 1414,
     /* 345174 */   GIR_Done,
     /* 345175 */ // Label 6896: @345175
     /* 345175 */ GIM_Reject,
     /* 345176 */ // Label 6884: @345176
     /* 345176 */ GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(345209), // Rule ID 1412 //
     /* 345181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345202 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 345202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 345207 */   GIR_RootConstrainSelectedInstOperands,
     /* 345208 */   // GIR_Coverage, 1412,
     /* 345208 */   GIR_Done,
     /* 345209 */ // Label 6897: @345209
     /* 345209 */ GIM_Reject,
     /* 345210 */ // Label 6885: @345210
     /* 345210 */ GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(345243), // Rule ID 1415 //
     /* 345215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 345224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345232 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345236 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 345236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 345241 */   GIR_RootConstrainSelectedInstOperands,
     /* 345242 */   // GIR_Coverage, 1415,
     /* 345242 */   GIR_Done,
     /* 345243 */ // Label 6898: @345243
     /* 345243 */ GIM_Reject,
     /* 345244 */ // Label 6886: @345244
     /* 345244 */ GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(345277), // Rule ID 1410 //
     /* 345249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 345255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 345258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345270 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 345270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 345275 */   GIR_RootConstrainSelectedInstOperands,
     /* 345276 */   // GIR_Coverage, 1410,
     /* 345276 */   GIR_Done,
     /* 345277 */ // Label 6899: @345277
     /* 345277 */ GIM_Reject,
     /* 345278 */ // Label 6887: @345278
     /* 345278 */ GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(345311), // Rule ID 1413 //
     /* 345283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 345292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345300 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345304 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 345304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 345309 */   GIR_RootConstrainSelectedInstOperands,
     /* 345310 */   // GIR_Coverage, 1413,
     /* 345310 */   GIR_Done,
     /* 345311 */ // Label 6900: @345311
     /* 345311 */ GIM_Reject,
     /* 345312 */ // Label 6888: @345312
     /* 345312 */ GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(345345), // Rule ID 1411 //
     /* 345317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 345323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 345326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345338 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 345338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 345343 */   GIR_RootConstrainSelectedInstOperands,
     /* 345344 */   // GIR_Coverage, 1411,
     /* 345344 */   GIR_Done,
     /* 345345 */ // Label 6901: @345345
     /* 345345 */ GIM_Reject,
     /* 345346 */ // Label 6889: @345346
     /* 345346 */ GIM_Reject,
     /* 345347 */ // Label 82: @345347
     /* 345347 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6910*/ GIMT_Encode4(345750),
     /* 345358 */ /*GILLT_s32*//*Label 6902*/ GIMT_Encode4(345398),
     /* 345362 */ /*GILLT_s64*//*Label 6903*/ GIMT_Encode4(345472), GIMT_Encode4(0),
     /* 345370 */ /*GILLT_v2s32*//*Label 6904*/ GIMT_Encode4(345546), GIMT_Encode4(0),
     /* 345378 */ /*GILLT_v4s16*//*Label 6905*/ GIMT_Encode4(345580),
     /* 345382 */ /*GILLT_v4s32*//*Label 6906*/ GIMT_Encode4(345614),
     /* 345386 */ /*GILLT_v8s8*//*Label 6907*/ GIMT_Encode4(345648),
     /* 345390 */ /*GILLT_v8s16*//*Label 6908*/ GIMT_Encode4(345682),
     /* 345394 */ /*GILLT_v16s8*//*Label 6909*/ GIMT_Encode4(345716),
     /* 345398 */ // Label 6902: @345398
     /* 345398 */ GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(345471),
     /* 345403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 345406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345417 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(345451), // Rule ID 2324 //
     /* 345422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 345437 */     // MIs[1] Operand 1
     /* 345437 */     // No operand predicates
     /* 345437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345439 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 345439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 345442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345449 */     GIR_RootConstrainSelectedInstOperands,
     /* 345450 */     // GIR_Coverage, 2324,
     /* 345450 */     GIR_EraseRootFromParent_Done,
     /* 345451 */   // Label 6912: @345451
     /* 345451 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(345470), // Rule ID 2323 //
     /* 345456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345463 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 345463 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 345468 */     GIR_RootConstrainSelectedInstOperands,
     /* 345469 */     // GIR_Coverage, 2323,
     /* 345469 */     GIR_Done,
     /* 345470 */   // Label 6913: @345470
     /* 345470 */   GIM_Reject,
     /* 345471 */ // Label 6911: @345471
     /* 345471 */ GIM_Reject,
     /* 345472 */ // Label 6903: @345472
     /* 345472 */ GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(345545),
     /* 345477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 345480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 345483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345491 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(345525), // Rule ID 2326 //
     /* 345496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 345511 */     // MIs[1] Operand 1
     /* 345511 */     // No operand predicates
     /* 345511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345513 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 345513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 345516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345523 */     GIR_RootConstrainSelectedInstOperands,
     /* 345524 */     // GIR_Coverage, 2326,
     /* 345524 */     GIR_EraseRootFromParent_Done,
     /* 345525 */   // Label 6915: @345525
     /* 345525 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(345544), // Rule ID 2325 //
     /* 345530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345537 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 345537 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 345542 */     GIR_RootConstrainSelectedInstOperands,
     /* 345543 */     // GIR_Coverage, 2325,
     /* 345543 */     GIR_Done,
     /* 345544 */   // Label 6916: @345544
     /* 345544 */   GIM_Reject,
     /* 345545 */ // Label 6914: @345545
     /* 345545 */ GIM_Reject,
     /* 345546 */ // Label 6904: @345546
     /* 345546 */ GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(345579), // Rule ID 1402 //
     /* 345551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345572 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 345572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 345577 */   GIR_RootConstrainSelectedInstOperands,
     /* 345578 */   // GIR_Coverage, 1402,
     /* 345578 */   GIR_Done,
     /* 345579 */ // Label 6917: @345579
     /* 345579 */ GIM_Reject,
     /* 345580 */ // Label 6905: @345580
     /* 345580 */ GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(345613), // Rule ID 1400 //
     /* 345585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345602 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345606 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 345606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 345611 */   GIR_RootConstrainSelectedInstOperands,
     /* 345612 */   // GIR_Coverage, 1400,
     /* 345612 */   GIR_Done,
     /* 345613 */ // Label 6918: @345613
     /* 345613 */ GIM_Reject,
     /* 345614 */ // Label 6906: @345614
     /* 345614 */ GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(345647), // Rule ID 1403 //
     /* 345619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 345628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345640 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 345640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 345645 */   GIR_RootConstrainSelectedInstOperands,
     /* 345646 */   // GIR_Coverage, 1403,
     /* 345646 */   GIR_Done,
     /* 345647 */ // Label 6919: @345647
     /* 345647 */ GIM_Reject,
     /* 345648 */ // Label 6907: @345648
     /* 345648 */ GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(345681), // Rule ID 1398 //
     /* 345653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 345659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 345662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345674 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 345674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 345679 */   GIR_RootConstrainSelectedInstOperands,
     /* 345680 */   // GIR_Coverage, 1398,
     /* 345680 */   GIR_Done,
     /* 345681 */ // Label 6920: @345681
     /* 345681 */ GIM_Reject,
     /* 345682 */ // Label 6908: @345682
     /* 345682 */ GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(345715), // Rule ID 1401 //
     /* 345687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 345696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345708 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 345708 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 345713 */   GIR_RootConstrainSelectedInstOperands,
     /* 345714 */   // GIR_Coverage, 1401,
     /* 345714 */   GIR_Done,
     /* 345715 */ // Label 6921: @345715
     /* 345715 */ GIM_Reject,
     /* 345716 */ // Label 6909: @345716
     /* 345716 */ GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(345749), // Rule ID 1399 //
     /* 345721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 345727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 345730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345738 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345742 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 345742 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 345747 */   GIR_RootConstrainSelectedInstOperands,
     /* 345748 */   // GIR_Coverage, 1399,
     /* 345748 */   GIR_Done,
     /* 345749 */ // Label 6922: @345749
     /* 345749 */ GIM_Reject,
     /* 345750 */ // Label 6910: @345750
     /* 345750 */ GIM_Reject,
     /* 345751 */ // Label 83: @345751
     /* 345751 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6931*/ GIMT_Encode4(346154),
     /* 345762 */ /*GILLT_s32*//*Label 6923*/ GIMT_Encode4(345802),
     /* 345766 */ /*GILLT_s64*//*Label 6924*/ GIMT_Encode4(345876), GIMT_Encode4(0),
     /* 345774 */ /*GILLT_v2s32*//*Label 6925*/ GIMT_Encode4(345950), GIMT_Encode4(0),
     /* 345782 */ /*GILLT_v4s16*//*Label 6926*/ GIMT_Encode4(345984),
     /* 345786 */ /*GILLT_v4s32*//*Label 6927*/ GIMT_Encode4(346018),
     /* 345790 */ /*GILLT_v8s8*//*Label 6928*/ GIMT_Encode4(346052),
     /* 345794 */ /*GILLT_v8s16*//*Label 6929*/ GIMT_Encode4(346086),
     /* 345798 */ /*GILLT_v16s8*//*Label 6930*/ GIMT_Encode4(346120),
     /* 345802 */ // Label 6923: @345802
     /* 345802 */ GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(345875),
     /* 345807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 345810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345821 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(345855), // Rule ID 2336 //
     /* 345826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 345841 */     // MIs[1] Operand 1
     /* 345841 */     // No operand predicates
     /* 345841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345843 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 345843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 345846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345853 */     GIR_RootConstrainSelectedInstOperands,
     /* 345854 */     // GIR_Coverage, 2336,
     /* 345854 */     GIR_EraseRootFromParent_Done,
     /* 345855 */   // Label 6933: @345855
     /* 345855 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(345874), // Rule ID 2335 //
     /* 345860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345867 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 345867 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 345872 */     GIR_RootConstrainSelectedInstOperands,
     /* 345873 */     // GIR_Coverage, 2335,
     /* 345873 */     GIR_Done,
     /* 345874 */   // Label 6934: @345874
     /* 345874 */   GIM_Reject,
     /* 345875 */ // Label 6932: @345875
     /* 345875 */ GIM_Reject,
     /* 345876 */ // Label 6924: @345876
     /* 345876 */ GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(345949),
     /* 345881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 345884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 345887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345895 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(345929), // Rule ID 2338 //
     /* 345900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 345915 */     // MIs[1] Operand 1
     /* 345915 */     // No operand predicates
     /* 345915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345917 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 345917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 345920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345927 */     GIR_RootConstrainSelectedInstOperands,
     /* 345928 */     // GIR_Coverage, 2338,
     /* 345928 */     GIR_EraseRootFromParent_Done,
     /* 345929 */   // Label 6936: @345929
     /* 345929 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(345948), // Rule ID 2337 //
     /* 345934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345941 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 345941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 345946 */     GIR_RootConstrainSelectedInstOperands,
     /* 345947 */     // GIR_Coverage, 2337,
     /* 345947 */     GIR_Done,
     /* 345948 */   // Label 6937: @345948
     /* 345948 */   GIM_Reject,
     /* 345949 */ // Label 6935: @345949
     /* 345949 */ GIM_Reject,
     /* 345950 */ // Label 6925: @345950
     /* 345950 */ GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(345983), // Rule ID 1537 //
     /* 345955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345976 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 345976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 345981 */   GIR_RootConstrainSelectedInstOperands,
     /* 345982 */   // GIR_Coverage, 1537,
     /* 345982 */   GIR_Done,
     /* 345983 */ // Label 6938: @345983
     /* 345983 */ GIM_Reject,
     /* 345984 */ // Label 6926: @345984
     /* 345984 */ GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(346017), // Rule ID 1535 //
     /* 345989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346010 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 346010 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 346015 */   GIR_RootConstrainSelectedInstOperands,
     /* 346016 */   // GIR_Coverage, 1535,
     /* 346016 */   GIR_Done,
     /* 346017 */ // Label 6939: @346017
     /* 346017 */ GIM_Reject,
     /* 346018 */ // Label 6927: @346018
     /* 346018 */ GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(346051), // Rule ID 1538 //
     /* 346023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346044 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 346044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 346049 */   GIR_RootConstrainSelectedInstOperands,
     /* 346050 */   // GIR_Coverage, 1538,
     /* 346050 */   GIR_Done,
     /* 346051 */ // Label 6940: @346051
     /* 346051 */ GIM_Reject,
     /* 346052 */ // Label 6928: @346052
     /* 346052 */ GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(346085), // Rule ID 1533 //
     /* 346057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 346066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346078 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 346078 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 346083 */   GIR_RootConstrainSelectedInstOperands,
     /* 346084 */   // GIR_Coverage, 1533,
     /* 346084 */   GIR_Done,
     /* 346085 */ // Label 6941: @346085
     /* 346085 */ GIM_Reject,
     /* 346086 */ // Label 6929: @346086
     /* 346086 */ GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(346119), // Rule ID 1536 //
     /* 346091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 346100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346112 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 346112 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 346117 */   GIR_RootConstrainSelectedInstOperands,
     /* 346118 */   // GIR_Coverage, 1536,
     /* 346118 */   GIR_Done,
     /* 346119 */ // Label 6942: @346119
     /* 346119 */ GIM_Reject,
     /* 346120 */ // Label 6930: @346120
     /* 346120 */ GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(346153), // Rule ID 1534 //
     /* 346125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 346131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 346134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346146 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 346146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 346151 */   GIR_RootConstrainSelectedInstOperands,
     /* 346152 */   // GIR_Coverage, 1534,
     /* 346152 */   GIR_Done,
     /* 346153 */ // Label 6943: @346153
     /* 346153 */ GIM_Reject,
     /* 346154 */ // Label 6931: @346154
     /* 346154 */ GIM_Reject,
     /* 346155 */ // Label 84: @346155
     /* 346155 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6952*/ GIMT_Encode4(346558),
     /* 346166 */ /*GILLT_s32*//*Label 6944*/ GIMT_Encode4(346206),
     /* 346170 */ /*GILLT_s64*//*Label 6945*/ GIMT_Encode4(346280), GIMT_Encode4(0),
     /* 346178 */ /*GILLT_v2s32*//*Label 6946*/ GIMT_Encode4(346354), GIMT_Encode4(0),
     /* 346186 */ /*GILLT_v4s16*//*Label 6947*/ GIMT_Encode4(346388),
     /* 346190 */ /*GILLT_v4s32*//*Label 6948*/ GIMT_Encode4(346422),
     /* 346194 */ /*GILLT_v8s8*//*Label 6949*/ GIMT_Encode4(346456),
     /* 346198 */ /*GILLT_v8s16*//*Label 6950*/ GIMT_Encode4(346490),
     /* 346202 */ /*GILLT_v16s8*//*Label 6951*/ GIMT_Encode4(346524),
     /* 346206 */ // Label 6944: @346206
     /* 346206 */ GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(346279),
     /* 346211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 346214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346225 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(346259), // Rule ID 2332 //
     /* 346230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 346245 */     // MIs[1] Operand 1
     /* 346245 */     // No operand predicates
     /* 346245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346247 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 346247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 346250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346252 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346257 */     GIR_RootConstrainSelectedInstOperands,
     /* 346258 */     // GIR_Coverage, 2332,
     /* 346258 */     GIR_EraseRootFromParent_Done,
     /* 346259 */   // Label 6954: @346259
     /* 346259 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(346278), // Rule ID 2331 //
     /* 346264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346271 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 346271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 346276 */     GIR_RootConstrainSelectedInstOperands,
     /* 346277 */     // GIR_Coverage, 2331,
     /* 346277 */     GIR_Done,
     /* 346278 */   // Label 6955: @346278
     /* 346278 */   GIM_Reject,
     /* 346279 */ // Label 6953: @346279
     /* 346279 */ GIM_Reject,
     /* 346280 */ // Label 6945: @346280
     /* 346280 */ GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(346353),
     /* 346285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 346288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 346291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346299 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(346333), // Rule ID 2334 //
     /* 346304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 346319 */     // MIs[1] Operand 1
     /* 346319 */     // No operand predicates
     /* 346319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346321 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 346321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 346324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346326 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346331 */     GIR_RootConstrainSelectedInstOperands,
     /* 346332 */     // GIR_Coverage, 2334,
     /* 346332 */     GIR_EraseRootFromParent_Done,
     /* 346333 */   // Label 6957: @346333
     /* 346333 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(346352), // Rule ID 2333 //
     /* 346338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346345 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 346345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 346350 */     GIR_RootConstrainSelectedInstOperands,
     /* 346351 */     // GIR_Coverage, 2333,
     /* 346351 */     GIR_Done,
     /* 346352 */   // Label 6958: @346352
     /* 346352 */   GIM_Reject,
     /* 346353 */ // Label 6956: @346353
     /* 346353 */ GIM_Reject,
     /* 346354 */ // Label 6946: @346354
     /* 346354 */ GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(346387), // Rule ID 1525 //
     /* 346359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 346368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346376 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346380 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 346380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 346385 */   GIR_RootConstrainSelectedInstOperands,
     /* 346386 */   // GIR_Coverage, 1525,
     /* 346386 */   GIR_Done,
     /* 346387 */ // Label 6959: @346387
     /* 346387 */ GIM_Reject,
     /* 346388 */ // Label 6947: @346388
     /* 346388 */ GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(346421), // Rule ID 1523 //
     /* 346393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 346402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346410 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346414 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 346414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 346419 */   GIR_RootConstrainSelectedInstOperands,
     /* 346420 */   // GIR_Coverage, 1523,
     /* 346420 */   GIR_Done,
     /* 346421 */ // Label 6960: @346421
     /* 346421 */ GIM_Reject,
     /* 346422 */ // Label 6948: @346422
     /* 346422 */ GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(346455), // Rule ID 1526 //
     /* 346427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346448 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 346448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 346453 */   GIR_RootConstrainSelectedInstOperands,
     /* 346454 */   // GIR_Coverage, 1526,
     /* 346454 */   GIR_Done,
     /* 346455 */ // Label 6961: @346455
     /* 346455 */ GIM_Reject,
     /* 346456 */ // Label 6949: @346456
     /* 346456 */ GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(346489), // Rule ID 1521 //
     /* 346461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 346470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346482 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 346482 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 346487 */   GIR_RootConstrainSelectedInstOperands,
     /* 346488 */   // GIR_Coverage, 1521,
     /* 346488 */   GIR_Done,
     /* 346489 */ // Label 6962: @346489
     /* 346489 */ GIM_Reject,
     /* 346490 */ // Label 6950: @346490
     /* 346490 */ GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(346523), // Rule ID 1524 //
     /* 346495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 346504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346512 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346516 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 346516 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 346521 */   GIR_RootConstrainSelectedInstOperands,
     /* 346522 */   // GIR_Coverage, 1524,
     /* 346522 */   GIR_Done,
     /* 346523 */ // Label 6963: @346523
     /* 346523 */ GIM_Reject,
     /* 346524 */ // Label 6951: @346524
     /* 346524 */ GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(346557), // Rule ID 1522 //
     /* 346529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 346535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 346538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346546 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346550 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 346550 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 346555 */   GIR_RootConstrainSelectedInstOperands,
     /* 346556 */   // GIR_Coverage, 1522,
     /* 346556 */   GIR_Done,
     /* 346557 */ // Label 6964: @346557
     /* 346557 */ GIM_Reject,
     /* 346558 */ // Label 6952: @346558
     /* 346558 */ GIM_Reject,
     /* 346559 */ // Label 85: @346559
     /* 346559 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6974*/ GIMT_Encode4(347373),
     /* 346570 */ /*GILLT_s32*//*Label 6965*/ GIMT_Encode4(346610),
     /* 346574 */ /*GILLT_s64*//*Label 6966*/ GIMT_Encode4(346637), GIMT_Encode4(0),
     /* 346582 */ /*GILLT_v2s32*//*Label 6967*/ GIMT_Encode4(346716),
     /* 346586 */ /*GILLT_v2s64*//*Label 6968*/ GIMT_Encode4(346743),
     /* 346590 */ /*GILLT_v4s16*//*Label 6969*/ GIMT_Encode4(346926),
     /* 346594 */ /*GILLT_v4s32*//*Label 6970*/ GIMT_Encode4(346953),
     /* 346598 */ /*GILLT_v8s8*//*Label 6971*/ GIMT_Encode4(347136),
     /* 346602 */ /*GILLT_v8s16*//*Label 6972*/ GIMT_Encode4(347163),
     /* 346606 */ /*GILLT_v16s8*//*Label 6973*/ GIMT_Encode4(347346),
     /* 346610 */ // Label 6965: @346610
     /* 346610 */ GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(346636), // Rule ID 2317 //
     /* 346615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 346621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346629 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 346629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 346634 */   GIR_RootConstrainSelectedInstOperands,
     /* 346635 */   // GIR_Coverage, 2317,
     /* 346635 */   GIR_Done,
     /* 346636 */ // Label 6975: @346636
     /* 346636 */ GIM_Reject,
     /* 346637 */ // Label 6966: @346637
     /* 346637 */ GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(346715),
     /* 346642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 346645 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(346668), // Rule ID 1652 //
     /* 346650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346661 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 346661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 346666 */     GIR_RootConstrainSelectedInstOperands,
     /* 346667 */     // GIR_Coverage, 1652,
     /* 346667 */     GIR_Done,
     /* 346668 */   // Label 6977: @346668
     /* 346668 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(346691), // Rule ID 2318 //
     /* 346673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346684 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 346684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 346689 */     GIR_RootConstrainSelectedInstOperands,
     /* 346690 */     // GIR_Coverage, 2318,
     /* 346690 */     GIR_Done,
     /* 346691 */   // Label 6978: @346691
     /* 346691 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(346714), // Rule ID 2514 //
     /* 346696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 346699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346707 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 346707 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 346712 */     GIR_RootConstrainSelectedInstOperands,
     /* 346713 */     // GIR_Coverage, 2514,
     /* 346713 */     GIR_Done,
     /* 346714 */   // Label 6979: @346714
     /* 346714 */   GIM_Reject,
     /* 346715 */ // Label 6976: @346715
     /* 346715 */ GIM_Reject,
     /* 346716 */ // Label 6967: @346716
     /* 346716 */ GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(346742), // Rule ID 707 //
     /* 346721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346735 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 346735 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 346740 */   GIR_RootConstrainSelectedInstOperands,
     /* 346741 */   // GIR_Coverage, 707,
     /* 346741 */   GIR_Done,
     /* 346742 */ // Label 6980: @346742
     /* 346742 */ GIM_Reject,
     /* 346743 */ // Label 6968: @346743
     /* 346743 */ GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(346925),
     /* 346748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 346751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346755 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(346833), // Rule ID 4925 //
     /* 346760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 346772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 346776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 346792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346796 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346800 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 346809 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 346816 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 346816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 346819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 346826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 346831 */     GIR_RootConstrainSelectedInstOperands,
     /* 346832 */     // GIR_Coverage, 4925,
     /* 346832 */     GIR_EraseRootFromParent_Done,
     /* 346833 */   // Label 6982: @346833
     /* 346833 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(346905), // Rule ID 4924 //
     /* 346838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 346850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 346854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 346875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346879 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346883 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346890 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 346890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 346893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 346899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 346903 */     GIR_RootConstrainSelectedInstOperands,
     /* 346904 */     // GIR_Coverage, 4924,
     /* 346904 */     GIR_EraseRootFromParent_Done,
     /* 346905 */   // Label 6983: @346905
     /* 346905 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(346924), // Rule ID 709 //
     /* 346910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346917 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 346917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 346922 */     GIR_RootConstrainSelectedInstOperands,
     /* 346923 */     // GIR_Coverage, 709,
     /* 346923 */     GIR_Done,
     /* 346924 */   // Label 6984: @346924
     /* 346924 */   GIM_Reject,
     /* 346925 */ // Label 6981: @346925
     /* 346925 */ GIM_Reject,
     /* 346926 */ // Label 6969: @346926
     /* 346926 */ GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(346952), // Rule ID 705 //
     /* 346931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346945 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 346945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 346950 */   GIR_RootConstrainSelectedInstOperands,
     /* 346951 */   // GIR_Coverage, 705,
     /* 346951 */   GIR_Done,
     /* 346952 */ // Label 6985: @346952
     /* 346952 */ GIM_Reject,
     /* 346953 */ // Label 6970: @346953
     /* 346953 */ GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(347135),
     /* 346958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346965 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(347043), // Rule ID 4923 //
     /* 346970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 346978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 346990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 346994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 347002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347006 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347012 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 347019 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 347026 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 347026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 347029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 347036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 347041 */     GIR_RootConstrainSelectedInstOperands,
     /* 347042 */     // GIR_Coverage, 4923,
     /* 347042 */     GIR_EraseRootFromParent_Done,
     /* 347043 */   // Label 6987: @347043
     /* 347043 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(347115), // Rule ID 4922 //
     /* 347048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 347056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 347064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 347068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 347085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347089 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347093 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347100 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 347100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 347103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 347109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 347113 */     GIR_RootConstrainSelectedInstOperands,
     /* 347114 */     // GIR_Coverage, 4922,
     /* 347114 */     GIR_EraseRootFromParent_Done,
     /* 347115 */   // Label 6988: @347115
     /* 347115 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(347134), // Rule ID 708 //
     /* 347120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347127 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 347127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 347132 */     GIR_RootConstrainSelectedInstOperands,
     /* 347133 */     // GIR_Coverage, 708,
     /* 347133 */     GIR_Done,
     /* 347134 */   // Label 6989: @347134
     /* 347134 */   GIM_Reject,
     /* 347135 */ // Label 6986: @347135
     /* 347135 */ GIM_Reject,
     /* 347136 */ // Label 6971: @347136
     /* 347136 */ GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(347162), // Rule ID 703 //
     /* 347141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347155 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 347155 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 347160 */   GIR_RootConstrainSelectedInstOperands,
     /* 347161 */   // GIR_Coverage, 703,
     /* 347161 */   GIR_Done,
     /* 347162 */ // Label 6990: @347162
     /* 347162 */ GIM_Reject,
     /* 347163 */ // Label 6972: @347163
     /* 347163 */ GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(347345),
     /* 347168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347175 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(347253), // Rule ID 4921 //
     /* 347180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 347188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 347196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 347200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 347212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347216 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347220 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347222 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 347229 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 347236 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 347236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 347239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 347246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 347251 */     GIR_RootConstrainSelectedInstOperands,
     /* 347252 */     // GIR_Coverage, 4921,
     /* 347252 */     GIR_EraseRootFromParent_Done,
     /* 347253 */   // Label 6992: @347253
     /* 347253 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(347325), // Rule ID 4920 //
     /* 347258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 347266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 347274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 347278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 347295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347299 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347303 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347308 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347310 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 347310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 347313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 347319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 347323 */     GIR_RootConstrainSelectedInstOperands,
     /* 347324 */     // GIR_Coverage, 4920,
     /* 347324 */     GIR_EraseRootFromParent_Done,
     /* 347325 */   // Label 6993: @347325
     /* 347325 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(347344), // Rule ID 706 //
     /* 347330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347337 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 347337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 347342 */     GIR_RootConstrainSelectedInstOperands,
     /* 347343 */     // GIR_Coverage, 706,
     /* 347343 */     GIR_Done,
     /* 347344 */   // Label 6994: @347344
     /* 347344 */   GIM_Reject,
     /* 347345 */ // Label 6991: @347345
     /* 347345 */ GIM_Reject,
     /* 347346 */ // Label 6973: @347346
     /* 347346 */ GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(347372), // Rule ID 704 //
     /* 347351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 347357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347365 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 347365 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 347370 */   GIR_RootConstrainSelectedInstOperands,
     /* 347371 */   // GIR_Coverage, 704,
     /* 347371 */   GIR_Done,
     /* 347372 */ // Label 6995: @347372
     /* 347372 */ GIM_Reject,
     /* 347373 */ // Label 6974: @347373
     /* 347373 */ GIM_Reject,
     /* 347374 */ // Label 86: @347374
     /* 347374 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6998*/ GIMT_Encode4(347539),
     /* 347385 */ /*GILLT_s32*//*Label 6996*/ GIMT_Encode4(347393),
     /* 347389 */ /*GILLT_s64*//*Label 6997*/ GIMT_Encode4(347466),
     /* 347393 */ // Label 6996: @347393
     /* 347393 */ GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(347419), // Rule ID 4766 //
     /* 347398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 347401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 347404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347408 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 347408 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 347413 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347417 */   GIR_RootConstrainSelectedInstOperands,
     /* 347418 */   // GIR_Coverage, 4766,
     /* 347418 */   GIR_Done,
     /* 347419 */ // Label 6999: @347419
     /* 347419 */ GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(347442), // Rule ID 4772 //
     /* 347424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 347427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347431 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 347431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 347436 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347440 */   GIR_RootConstrainSelectedInstOperands,
     /* 347441 */   // GIR_Coverage, 4772,
     /* 347441 */   GIR_Done,
     /* 347442 */ // Label 7000: @347442
     /* 347442 */ GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(347465), // Rule ID 4774 //
     /* 347447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 347450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347454 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 347454 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 347459 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347463 */   GIR_RootConstrainSelectedInstOperands,
     /* 347464 */   // GIR_Coverage, 4774,
     /* 347464 */   GIR_Done,
     /* 347465 */ // Label 7001: @347465
     /* 347465 */ GIM_Reject,
     /* 347466 */ // Label 6997: @347466
     /* 347466 */ GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(347492), // Rule ID 4768 //
     /* 347471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 347474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 347477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347481 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 347481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 347486 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347490 */   GIR_RootConstrainSelectedInstOperands,
     /* 347491 */   // GIR_Coverage, 4768,
     /* 347491 */   GIR_Done,
     /* 347492 */ // Label 7002: @347492
     /* 347492 */ GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(347515), // Rule ID 4776 //
     /* 347497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 347500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347504 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 347504 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 347509 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347513 */   GIR_RootConstrainSelectedInstOperands,
     /* 347514 */   // GIR_Coverage, 4776,
     /* 347514 */   GIR_Done,
     /* 347515 */ // Label 7003: @347515
     /* 347515 */ GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(347538), // Rule ID 4778 //
     /* 347520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 347523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347527 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 347527 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 347532 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347536 */   GIR_RootConstrainSelectedInstOperands,
     /* 347537 */   // GIR_Coverage, 4778,
     /* 347537 */   GIR_Done,
     /* 347538 */ // Label 7004: @347538
     /* 347538 */ GIM_Reject,
     /* 347539 */ // Label 6998: @347539
     /* 347539 */ GIM_Reject,
     /* 347540 */ // Label 87: @347540
     /* 347540 */ GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(347638),
     /* 347545 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 347548 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7009*/ GIMT_Encode4(347637),
     /* 347559 */   /*GILLT_s16*//*Label 7006*/ GIMT_Encode4(347571),
     /* 347563 */   /*GILLT_s32*//*Label 7007*/ GIMT_Encode4(347595),
     /* 347567 */   /*GILLT_s64*//*Label 7008*/ GIMT_Encode4(347616),
     /* 347571 */   // Label 7006: @347571
     /* 347571 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(347594), // Rule ID 4770 //
     /* 347576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 347579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347583 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 347583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 347588 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347592 */     GIR_RootConstrainSelectedInstOperands,
     /* 347593 */     // GIR_Coverage, 4770,
     /* 347593 */     GIR_Done,
     /* 347594 */   // Label 7010: @347594
     /* 347594 */   GIM_Reject,
     /* 347595 */   // Label 7007: @347595
     /* 347595 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(347615), // Rule ID 4780 //
     /* 347600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347604 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 347604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 347609 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347613 */     GIR_RootConstrainSelectedInstOperands,
     /* 347614 */     // GIR_Coverage, 4780,
     /* 347614 */     GIR_Done,
     /* 347615 */   // Label 7011: @347615
     /* 347615 */   GIM_Reject,
     /* 347616 */   // Label 7008: @347616
     /* 347616 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(347636), // Rule ID 4782 //
     /* 347621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347625 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 347625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 347630 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 347634 */     GIR_RootConstrainSelectedInstOperands,
     /* 347635 */     // GIR_Coverage, 4782,
     /* 347635 */     GIR_Done,
     /* 347636 */   // Label 7012: @347636
     /* 347636 */   GIM_Reject,
     /* 347637 */   // Label 7009: @347637
     /* 347637 */   GIM_Reject,
     /* 347638 */ // Label 7005: @347638
     /* 347638 */ GIM_Reject,
     /* 347639 */ // Label 88: @347639
     /* 347639 */ GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(347654), // Rule ID 225 //
     /* 347644 */   // MIs[0] addr
     /* 347644 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 347647 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 347647 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 347652 */   GIR_RootConstrainSelectedInstOperands,
     /* 347653 */   // GIR_Coverage, 225,
     /* 347653 */   GIR_Done,
     /* 347654 */ // Label 7013: @347654
     /* 347654 */ GIM_Reject,
     /* 347655 */ // Label 89: @347655
     /* 347655 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 7025*/ GIMT_Encode4(353026),
     /* 347666 */ /*GILLT_s64*//*Label 7014*/ GIMT_Encode4(347738), GIMT_Encode4(0),
     /* 347674 */ /*GILLT_v2s32*//*Label 7015*/ GIMT_Encode4(348140), GIMT_Encode4(0),
     /* 347682 */ /*GILLT_v4s16*//*Label 7016*/ GIMT_Encode4(348542), GIMT_Encode4(0),
     /* 347690 */ /*GILLT_v8s8*//*Label 7017*/ GIMT_Encode4(348944), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 347702 */ /*GILLT_nxv1s1*//*Label 7018*/ GIMT_Encode4(349124),
     /* 347706 */ /*GILLT_nxv2s1*//*Label 7019*/ GIMT_Encode4(351387),
     /* 347710 */ /*GILLT_nxv2s16*//*Label 7020*/ GIMT_Encode4(352242),
     /* 347714 */ /*GILLT_nxv2s32*//*Label 7021*/ GIMT_Encode4(352529), GIMT_Encode4(0),
     /* 347722 */ /*GILLT_nxv4s1*//*Label 7022*/ GIMT_Encode4(352599),
     /* 347726 */ /*GILLT_nxv4s16*//*Label 7023*/ GIMT_Encode4(352886), GIMT_Encode4(0),
     /* 347734 */ /*GILLT_nxv8s1*//*Label 7024*/ GIMT_Encode4(352956),
     /* 347738 */ // Label 7014: @347738
     /* 347738 */ GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(348139),
     /* 347743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 347746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347750 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(347802), // Rule ID 5616 //
     /* 347755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 347763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347767 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 347769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347774 */     // MIs[0] Operand 2
     /* 347774 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 347785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347787 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 347787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 347790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347800 */     GIR_RootConstrainSelectedInstOperands,
     /* 347801 */     // GIR_Coverage, 5616,
     /* 347801 */     GIR_EraseRootFromParent_Done,
     /* 347802 */   // Label 7027: @347802
     /* 347802 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(347854), // Rule ID 5619 //
     /* 347807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 347815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347819 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 347821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347826 */     // MIs[0] Operand 2
     /* 347826 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 347837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347839 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 1:{ *:[i64] })  =>  (ZIP2v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 347839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 347842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 347852 */     GIR_RootConstrainSelectedInstOperands,
     /* 347853 */     // GIR_Coverage, 5619,
     /* 347853 */     GIR_EraseRootFromParent_Done,
     /* 347854 */   // Label 7028: @347854
     /* 347854 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(347922), // Rule ID 5495 //
     /* 347859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347863 */     // MIs[0] Operand 2
     /* 347863 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 347874 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 347874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 347881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347894 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 347897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347904 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347921 */     // GIR_Coverage, 5495,
     /* 347921 */     GIR_EraseRootFromParent_Done,
     /* 347922 */   // Label 7029: @347922
     /* 347922 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(347990), // Rule ID 5500 //
     /* 347927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347931 */     // MIs[0] Operand 2
     /* 347931 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 347942 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 347942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 347949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347954 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347958 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 347962 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 347965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 347970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347972 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 347979 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347984 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347989 */     // GIR_Coverage, 5500,
     /* 347989 */     GIR_EraseRootFromParent_Done,
     /* 347990 */   // Label 7030: @347990
     /* 347990 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(348032), // Rule ID 6943 //
     /* 347995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347999 */     // MIs[0] Operand 2
     /* 347999 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348010 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 348010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348015 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348031 */     // GIR_Coverage, 6943,
     /* 348031 */     GIR_EraseRootFromParent_Done,
     /* 348032 */   // Label 7031: @348032
     /* 348032 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(348074), // Rule ID 6944 //
     /* 348037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348041 */     // MIs[0] Operand 2
     /* 348041 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348052 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 348052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348057 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348073 */     // GIR_Coverage, 6944,
     /* 348073 */     GIR_EraseRootFromParent_Done,
     /* 348074 */   // Label 7032: @348074
     /* 348074 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(348138), // Rule ID 6948 //
     /* 348079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348083 */     // MIs[0] Operand 2
     /* 348083 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348094 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 348094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 348101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348110 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 348113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348120 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348137 */     // GIR_Coverage, 6948,
     /* 348137 */     GIR_EraseRootFromParent_Done,
     /* 348138 */   // Label 7033: @348138
     /* 348138 */   GIM_Reject,
     /* 348139 */ // Label 7026: @348139
     /* 348139 */ GIM_Reject,
     /* 348140 */ // Label 7015: @348140
     /* 348140 */ GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(348541),
     /* 348145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 348148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348152 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(348204), // Rule ID 5615 //
     /* 348157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 348165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 348169 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 348171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348176 */     // MIs[0] Operand 2
     /* 348176 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348189 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 348189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 348192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348202 */     GIR_RootConstrainSelectedInstOperands,
     /* 348203 */     // GIR_Coverage, 5615,
     /* 348203 */     GIR_EraseRootFromParent_Done,
     /* 348204 */   // Label 7035: @348204
     /* 348204 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(348256), // Rule ID 5618 //
     /* 348209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 348217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 348221 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 348223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348228 */     // MIs[0] Operand 2
     /* 348228 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 348239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348241 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 2:{ *:[i64] })  =>  (ZIP2v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 348241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 348244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348254 */     GIR_RootConstrainSelectedInstOperands,
     /* 348255 */     // GIR_Coverage, 5618,
     /* 348255 */     GIR_EraseRootFromParent_Done,
     /* 348256 */   // Label 7036: @348256
     /* 348256 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(348324), // Rule ID 5485 //
     /* 348261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348265 */     // MIs[0] Operand 2
     /* 348265 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 348276 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348288 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348292 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348296 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348306 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348313 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348318 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348323 */     // GIR_Coverage, 5485,
     /* 348323 */     GIR_EraseRootFromParent_Done,
     /* 348324 */   // Label 7037: @348324
     /* 348324 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(348392), // Rule ID 5490 //
     /* 348329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348333 */     // MIs[0] Operand 2
     /* 348333 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 348344 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348360 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348364 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348374 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348391 */     // GIR_Coverage, 5490,
     /* 348391 */     GIR_EraseRootFromParent_Done,
     /* 348392 */   // Label 7038: @348392
     /* 348392 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(348434), // Rule ID 6940 //
     /* 348397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348401 */     // MIs[0] Operand 2
     /* 348401 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348412 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 348412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348417 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348433 */     // GIR_Coverage, 6940,
     /* 348433 */     GIR_EraseRootFromParent_Done,
     /* 348434 */   // Label 7039: @348434
     /* 348434 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(348476), // Rule ID 6942 //
     /* 348439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348443 */     // MIs[0] Operand 2
     /* 348443 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348454 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 348454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348459 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348475 */     // GIR_Coverage, 6942,
     /* 348475 */     GIR_EraseRootFromParent_Done,
     /* 348476 */   // Label 7040: @348476
     /* 348476 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(348540), // Rule ID 6947 //
     /* 348481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348485 */     // MIs[0] Operand 2
     /* 348485 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348496 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 348496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 348503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348512 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 348515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348522 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348529 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348534 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348539 */     // GIR_Coverage, 6947,
     /* 348539 */     GIR_EraseRootFromParent_Done,
     /* 348540 */   // Label 7041: @348540
     /* 348540 */   GIM_Reject,
     /* 348541 */ // Label 7034: @348541
     /* 348541 */ GIM_Reject,
     /* 348542 */ // Label 7016: @348542
     /* 348542 */ GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(348943),
     /* 348547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 348550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348554 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(348606), // Rule ID 5614 //
     /* 348559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 348567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 348571 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 348573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348578 */     // MIs[0] Operand 2
     /* 348578 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348591 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 348591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 348594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348604 */     GIR_RootConstrainSelectedInstOperands,
     /* 348605 */     // GIR_Coverage, 5614,
     /* 348605 */     GIR_EraseRootFromParent_Done,
     /* 348606 */   // Label 7043: @348606
     /* 348606 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(348658), // Rule ID 5617 //
     /* 348611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 348619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 348623 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 348625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348630 */     // MIs[0] Operand 2
     /* 348630 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 348641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348643 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 4:{ *:[i64] })  =>  (ZIP2v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 348643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 348646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348656 */     GIR_RootConstrainSelectedInstOperands,
     /* 348657 */     // GIR_Coverage, 5617,
     /* 348657 */     GIR_EraseRootFromParent_Done,
     /* 348658 */   // Label 7044: @348658
     /* 348658 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(348726), // Rule ID 5475 //
     /* 348663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348667 */     // MIs[0] Operand 2
     /* 348667 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 348678 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348698 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348708 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348725 */     // GIR_Coverage, 5475,
     /* 348725 */     GIR_EraseRootFromParent_Done,
     /* 348726 */   // Label 7045: @348726
     /* 348726 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(348794), // Rule ID 5480 //
     /* 348731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348735 */     // MIs[0] Operand 2
     /* 348735 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 348746 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348766 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348776 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348793 */     // GIR_Coverage, 5480,
     /* 348793 */     GIR_EraseRootFromParent_Done,
     /* 348794 */   // Label 7046: @348794
     /* 348794 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(348836), // Rule ID 6938 //
     /* 348799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348803 */     // MIs[0] Operand 2
     /* 348803 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348814 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 348814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348819 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348825 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348830 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348835 */     // GIR_Coverage, 6938,
     /* 348835 */     GIR_EraseRootFromParent_Done,
     /* 348836 */   // Label 7047: @348836
     /* 348836 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(348878), // Rule ID 6941 //
     /* 348841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348845 */     // MIs[0] Operand 2
     /* 348845 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348856 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 348856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348861 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348877 */     // GIR_Coverage, 6941,
     /* 348877 */     GIR_EraseRootFromParent_Done,
     /* 348878 */   // Label 7048: @348878
     /* 348878 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(348942), // Rule ID 6946 //
     /* 348883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348887 */     // MIs[0] Operand 2
     /* 348887 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348898 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 348898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 348905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348914 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 348917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348924 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348941 */     // GIR_Coverage, 6946,
     /* 348941 */     GIR_EraseRootFromParent_Done,
     /* 348942 */   // Label 7049: @348942
     /* 348942 */   GIM_Reject,
     /* 348943 */ // Label 7042: @348943
     /* 348943 */ GIM_Reject,
     /* 348944 */ // Label 7017: @348944
     /* 348944 */ GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(349123),
     /* 348949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 348952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348960 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(349024), // Rule ID 5470 //
     /* 348965 */     // MIs[0] Operand 2
     /* 348965 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 348976 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348996 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349006 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349013 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349018 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349023 */     // GIR_Coverage, 5470,
     /* 349023 */     GIR_EraseRootFromParent_Done,
     /* 349024 */   // Label 7051: @349024
     /* 349024 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(349062), // Rule ID 6939 //
     /* 349029 */     // MIs[0] Operand 2
     /* 349029 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349040 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 349040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349045 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 349051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349061 */     // GIR_Coverage, 6939,
     /* 349061 */     GIR_EraseRootFromParent_Done,
     /* 349062 */   // Label 7052: @349062
     /* 349062 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(349122), // Rule ID 6945 //
     /* 349067 */     // MIs[0] Operand 2
     /* 349067 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349078 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 349078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 349085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349094 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 349097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349104 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349121 */     // GIR_Coverage, 6945,
     /* 349121 */     GIR_EraseRootFromParent_Done,
     /* 349122 */   // Label 7053: @349122
     /* 349122 */   GIM_Reject,
     /* 349123 */ // Label 7050: @349123
     /* 349123 */ GIM_Reject,
     /* 349124 */ // Label 7018: @349124
     /* 349124 */ GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(349159), // Rule ID 9037 //
     /* 349129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 349135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349139 */   // MIs[0] Operand 2
     /* 349139 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349150 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 349150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349155 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 349157 */   GIR_RootConstrainSelectedInstOperands,
     /* 349158 */   // GIR_Coverage, 9037,
     /* 349158 */   GIR_EraseRootFromParent_Done,
     /* 349159 */ // Label 7054: @349159
     /* 349159 */ GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(349194), // Rule ID 9038 //
     /* 349164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 349170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349174 */   // MIs[0] Operand 2
     /* 349174 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349185 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 349185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349190 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 349192 */   GIR_RootConstrainSelectedInstOperands,
     /* 349193 */   // GIR_Coverage, 9038,
     /* 349193 */   GIR_EraseRootFromParent_Done,
     /* 349194 */ // Label 7055: @349194
     /* 349194 */ GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(349248), // Rule ID 9045 //
     /* 349199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 349205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349209 */   // MIs[0] Operand 2
     /* 349209 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349220 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 349220 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349223 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349227 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349232 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349243 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349246 */   GIR_RootConstrainSelectedInstOperands,
     /* 349247 */   // GIR_Coverage, 9045,
     /* 349247 */   GIR_EraseRootFromParent_Done,
     /* 349248 */ // Label 7056: @349248
     /* 349248 */ GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(349302), // Rule ID 9046 //
     /* 349253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 349259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349263 */   // MIs[0] Operand 2
     /* 349263 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349274 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 349274 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349277 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349281 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349286 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349297 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349300 */   GIR_RootConstrainSelectedInstOperands,
     /* 349301 */   // GIR_Coverage, 9046,
     /* 349301 */   GIR_EraseRootFromParent_Done,
     /* 349302 */ // Label 7057: @349302
     /* 349302 */ GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(349356), // Rule ID 9047 //
     /* 349307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 349313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349317 */   // MIs[0] Operand 2
     /* 349317 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 349328 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 349328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349340 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349351 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349354 */   GIR_RootConstrainSelectedInstOperands,
     /* 349355 */   // GIR_Coverage, 9047,
     /* 349355 */   GIR_EraseRootFromParent_Done,
     /* 349356 */ // Label 7058: @349356
     /* 349356 */ GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(349410), // Rule ID 9048 //
     /* 349361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 349367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349371 */   // MIs[0] Operand 2
     /* 349371 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 349382 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 349382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349394 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349405 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349408 */   GIR_RootConstrainSelectedInstOperands,
     /* 349409 */   // GIR_Coverage, 9048,
     /* 349409 */   GIR_EraseRootFromParent_Done,
     /* 349410 */ // Label 7059: @349410
     /* 349410 */ GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(349481), // Rule ID 9057 //
     /* 349415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349425 */   // MIs[0] Operand 2
     /* 349425 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349436 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349436 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349439 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349443 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349448 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349466 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349479 */   GIR_RootConstrainSelectedInstOperands,
     /* 349480 */   // GIR_Coverage, 9057,
     /* 349480 */   GIR_EraseRootFromParent_Done,
     /* 349481 */ // Label 7060: @349481
     /* 349481 */ GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(349552), // Rule ID 9058 //
     /* 349486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349496 */   // MIs[0] Operand 2
     /* 349496 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349507 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349507 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349510 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349514 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349519 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349537 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349547 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349550 */   GIR_RootConstrainSelectedInstOperands,
     /* 349551 */   // GIR_Coverage, 9058,
     /* 349551 */   GIR_EraseRootFromParent_Done,
     /* 349552 */ // Label 7061: @349552
     /* 349552 */ GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(349623), // Rule ID 9059 //
     /* 349557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349567 */   // MIs[0] Operand 2
     /* 349567 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 349578 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349578 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349581 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349585 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349590 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349608 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349621 */   GIR_RootConstrainSelectedInstOperands,
     /* 349622 */   // GIR_Coverage, 9059,
     /* 349622 */   GIR_EraseRootFromParent_Done,
     /* 349623 */ // Label 7062: @349623
     /* 349623 */ GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(349694), // Rule ID 9060 //
     /* 349628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349638 */   // MIs[0] Operand 2
     /* 349638 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 349649 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349649 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349652 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349656 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349661 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349667 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349670 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349674 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349679 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349689 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349692 */   GIR_RootConstrainSelectedInstOperands,
     /* 349693 */   // GIR_Coverage, 9060,
     /* 349693 */   GIR_EraseRootFromParent_Done,
     /* 349694 */ // Label 7063: @349694
     /* 349694 */ GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(349765), // Rule ID 9061 //
     /* 349699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349709 */   // MIs[0] Operand 2
     /* 349709 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 349720 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349720 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349723 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349727 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349732 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349738 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349741 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349745 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349750 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349763 */   GIR_RootConstrainSelectedInstOperands,
     /* 349764 */   // GIR_Coverage, 9061,
     /* 349764 */   GIR_EraseRootFromParent_Done,
     /* 349765 */ // Label 7064: @349765
     /* 349765 */ GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(349836), // Rule ID 9062 //
     /* 349770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349780 */   // MIs[0] Operand 2
     /* 349780 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 349791 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349791 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349794 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349798 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349803 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349821 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349831 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349834 */   GIR_RootConstrainSelectedInstOperands,
     /* 349835 */   // GIR_Coverage, 9062,
     /* 349835 */   GIR_EraseRootFromParent_Done,
     /* 349836 */ // Label 7065: @349836
     /* 349836 */ GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(349907), // Rule ID 9063 //
     /* 349841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349851 */   // MIs[0] Operand 2
     /* 349851 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 349862 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349862 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349865 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349869 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349874 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349880 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349883 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349887 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349892 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349895 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349905 */   GIR_RootConstrainSelectedInstOperands,
     /* 349906 */   // GIR_Coverage, 9063,
     /* 349906 */   GIR_EraseRootFromParent_Done,
     /* 349907 */ // Label 7066: @349907
     /* 349907 */ GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(349978), // Rule ID 9064 //
     /* 349912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 349918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349922 */   // MIs[0] Operand 2
     /* 349922 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 349933 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 349933 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 349936 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349940 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349945 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 349951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349963 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349973 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349976 */   GIR_RootConstrainSelectedInstOperands,
     /* 349977 */   // GIR_Coverage, 9064,
     /* 349977 */   GIR_EraseRootFromParent_Done,
     /* 349978 */ // Label 7067: @349978
     /* 349978 */ GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(350066), // Rule ID 9073 //
     /* 349983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 349989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349993 */   // MIs[0] Operand 2
     /* 349993 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350004 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350004 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350007 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350011 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350016 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350020 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350022 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350025 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350029 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350034 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350051 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350061 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350064 */   GIR_RootConstrainSelectedInstOperands,
     /* 350065 */   // GIR_Coverage, 9073,
     /* 350065 */   GIR_EraseRootFromParent_Done,
     /* 350066 */ // Label 7068: @350066
     /* 350066 */ GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(350154), // Rule ID 9074 //
     /* 350071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350081 */   // MIs[0] Operand 2
     /* 350081 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 350092 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350092 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350095 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350099 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350104 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350110 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350113 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350117 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350122 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350127 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350134 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350139 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350149 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350152 */   GIR_RootConstrainSelectedInstOperands,
     /* 350153 */   // GIR_Coverage, 9074,
     /* 350153 */   GIR_EraseRootFromParent_Done,
     /* 350154 */ // Label 7069: @350154
     /* 350154 */ GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(350242), // Rule ID 9075 //
     /* 350159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350169 */   // MIs[0] Operand 2
     /* 350169 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350180 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350180 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350183 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350187 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350192 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350198 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350201 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350205 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350210 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350215 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350218 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350222 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350227 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350240 */   GIR_RootConstrainSelectedInstOperands,
     /* 350241 */   // GIR_Coverage, 9075,
     /* 350241 */   GIR_EraseRootFromParent_Done,
     /* 350242 */ // Label 7070: @350242
     /* 350242 */ GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(350330), // Rule ID 9076 //
     /* 350247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350257 */   // MIs[0] Operand 2
     /* 350257 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 350268 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350268 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350271 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350275 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350280 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350284 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350286 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350289 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350293 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350298 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350303 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350306 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350310 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350315 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350328 */   GIR_RootConstrainSelectedInstOperands,
     /* 350329 */   // GIR_Coverage, 9076,
     /* 350329 */   GIR_EraseRootFromParent_Done,
     /* 350330 */ // Label 7071: @350330
     /* 350330 */ GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(350418), // Rule ID 9077 //
     /* 350335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350345 */   // MIs[0] Operand 2
     /* 350345 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 350356 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350356 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350359 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350363 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350368 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350374 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350377 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350381 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350386 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350403 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350413 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350416 */   GIR_RootConstrainSelectedInstOperands,
     /* 350417 */   // GIR_Coverage, 9077,
     /* 350417 */   GIR_EraseRootFromParent_Done,
     /* 350418 */ // Label 7072: @350418
     /* 350418 */ GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(350506), // Rule ID 9078 //
     /* 350423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350433 */   // MIs[0] Operand 2
     /* 350433 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 350444 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350444 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350447 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350451 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350456 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350462 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350465 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350469 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350474 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350491 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350494 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350501 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350504 */   GIR_RootConstrainSelectedInstOperands,
     /* 350505 */   // GIR_Coverage, 9078,
     /* 350505 */   GIR_EraseRootFromParent_Done,
     /* 350506 */ // Label 7073: @350506
     /* 350506 */ GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(350594), // Rule ID 9079 //
     /* 350511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350521 */   // MIs[0] Operand 2
     /* 350521 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 350532 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350532 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350535 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350539 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350544 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350548 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350550 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350553 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350557 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350562 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350579 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350592 */   GIR_RootConstrainSelectedInstOperands,
     /* 350593 */   // GIR_Coverage, 9079,
     /* 350593 */   GIR_EraseRootFromParent_Done,
     /* 350594 */ // Label 7074: @350594
     /* 350594 */ GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(350682), // Rule ID 9080 //
     /* 350599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350609 */   // MIs[0] Operand 2
     /* 350609 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 350620 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350620 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350623 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350627 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350632 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350636 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350638 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350641 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350645 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350650 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350653 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350655 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350658 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350662 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350667 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350677 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350680 */   GIR_RootConstrainSelectedInstOperands,
     /* 350681 */   // GIR_Coverage, 9080,
     /* 350681 */   GIR_EraseRootFromParent_Done,
     /* 350682 */ // Label 7075: @350682
     /* 350682 */ GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(350770), // Rule ID 9081 //
     /* 350687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350697 */   // MIs[0] Operand 2
     /* 350697 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 350708 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350708 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350711 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350715 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350720 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350726 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350729 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350733 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350738 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350741 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350743 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350746 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350750 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350755 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350765 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350768 */   GIR_RootConstrainSelectedInstOperands,
     /* 350769 */   // GIR_Coverage, 9081,
     /* 350769 */   GIR_EraseRootFromParent_Done,
     /* 350770 */ // Label 7076: @350770
     /* 350770 */ GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(350858), // Rule ID 9082 //
     /* 350775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350785 */   // MIs[0] Operand 2
     /* 350785 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 350796 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350796 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350799 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350803 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350808 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350814 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350817 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350821 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350826 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350843 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350846 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350853 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350856 */   GIR_RootConstrainSelectedInstOperands,
     /* 350857 */   // GIR_Coverage, 9082,
     /* 350857 */   GIR_EraseRootFromParent_Done,
     /* 350858 */ // Label 7077: @350858
     /* 350858 */ GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(350946), // Rule ID 9083 //
     /* 350863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350873 */   // MIs[0] Operand 2
     /* 350873 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 350884 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350884 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350887 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350891 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350896 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350900 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350902 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350905 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350909 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350914 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350931 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350944 */   GIR_RootConstrainSelectedInstOperands,
     /* 350945 */   // GIR_Coverage, 9083,
     /* 350945 */   GIR_EraseRootFromParent_Done,
     /* 350946 */ // Label 7078: @350946
     /* 350946 */ GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(351034), // Rule ID 9084 //
     /* 350951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350961 */   // MIs[0] Operand 2
     /* 350961 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 350972 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350972 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350975 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350979 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350984 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350990 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350993 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350997 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351002 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351007 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351010 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351014 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351019 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351022 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351029 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351032 */   GIR_RootConstrainSelectedInstOperands,
     /* 351033 */   // GIR_Coverage, 9084,
     /* 351033 */   GIR_EraseRootFromParent_Done,
     /* 351034 */ // Label 7079: @351034
     /* 351034 */ GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(351122), // Rule ID 9085 //
     /* 351039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351049 */   // MIs[0] Operand 2
     /* 351049 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 351060 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351060 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351063 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351067 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351072 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351078 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351081 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351085 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351090 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351095 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351098 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351102 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351107 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351110 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351115 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351117 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351120 */   GIR_RootConstrainSelectedInstOperands,
     /* 351121 */   // GIR_Coverage, 9085,
     /* 351121 */   GIR_EraseRootFromParent_Done,
     /* 351122 */ // Label 7080: @351122
     /* 351122 */ GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(351210), // Rule ID 9086 //
     /* 351127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351137 */   // MIs[0] Operand 2
     /* 351137 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 351148 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351148 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351151 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351155 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351160 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351166 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351169 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351173 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351178 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351195 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351198 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351205 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351208 */   GIR_RootConstrainSelectedInstOperands,
     /* 351209 */   // GIR_Coverage, 9086,
     /* 351209 */   GIR_EraseRootFromParent_Done,
     /* 351210 */ // Label 7081: @351210
     /* 351210 */ GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(351298), // Rule ID 9087 //
     /* 351215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351225 */   // MIs[0] Operand 2
     /* 351225 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 351236 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351236 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351239 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351243 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351248 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351254 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351257 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351261 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351266 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351271 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351274 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351278 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351283 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351293 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351296 */   GIR_RootConstrainSelectedInstOperands,
     /* 351297 */   // GIR_Coverage, 9087,
     /* 351297 */   GIR_EraseRootFromParent_Done,
     /* 351298 */ // Label 7082: @351298
     /* 351298 */ GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(351386), // Rule ID 9088 //
     /* 351303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351313 */   // MIs[0] Operand 2
     /* 351313 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 351324 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351324 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351327 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351331 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351336 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351342 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351345 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351349 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351354 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351359 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351362 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351366 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351371 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351384 */   GIR_RootConstrainSelectedInstOperands,
     /* 351385 */   // GIR_Coverage, 9088,
     /* 351385 */   GIR_EraseRootFromParent_Done,
     /* 351386 */ // Label 7083: @351386
     /* 351386 */ GIM_Reject,
     /* 351387 */ // Label 7019: @351387
     /* 351387 */ GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(351422), // Rule ID 9039 //
     /* 351392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 351398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351402 */   // MIs[0] Operand 2
     /* 351402 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351413 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 351413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351418 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 351420 */   GIR_RootConstrainSelectedInstOperands,
     /* 351421 */   // GIR_Coverage, 9039,
     /* 351421 */   GIR_EraseRootFromParent_Done,
     /* 351422 */ // Label 7084: @351422
     /* 351422 */ GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(351457), // Rule ID 9040 //
     /* 351427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 351433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351437 */   // MIs[0] Operand 2
     /* 351437 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 351448 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 351448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351453 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 351455 */   GIR_RootConstrainSelectedInstOperands,
     /* 351456 */   // GIR_Coverage, 9040,
     /* 351456 */   GIR_EraseRootFromParent_Done,
     /* 351457 */ // Label 7085: @351457
     /* 351457 */ GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(351511), // Rule ID 9049 //
     /* 351462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351472 */   // MIs[0] Operand 2
     /* 351472 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351483 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 351483 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351486 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351490 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351495 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351506 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351509 */   GIR_RootConstrainSelectedInstOperands,
     /* 351510 */   // GIR_Coverage, 9049,
     /* 351510 */   GIR_EraseRootFromParent_Done,
     /* 351511 */ // Label 7086: @351511
     /* 351511 */ GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(351565), // Rule ID 9050 //
     /* 351516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351526 */   // MIs[0] Operand 2
     /* 351526 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 351537 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 351537 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351540 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351544 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351549 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351563 */   GIR_RootConstrainSelectedInstOperands,
     /* 351564 */   // GIR_Coverage, 9050,
     /* 351564 */   GIR_EraseRootFromParent_Done,
     /* 351565 */ // Label 7087: @351565
     /* 351565 */ GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(351619), // Rule ID 9051 //
     /* 351570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351580 */   // MIs[0] Operand 2
     /* 351580 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 351591 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 351591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351603 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351614 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351617 */   GIR_RootConstrainSelectedInstOperands,
     /* 351618 */   // GIR_Coverage, 9051,
     /* 351618 */   GIR_EraseRootFromParent_Done,
     /* 351619 */ // Label 7088: @351619
     /* 351619 */ GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(351673), // Rule ID 9052 //
     /* 351624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 351630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351634 */   // MIs[0] Operand 2
     /* 351634 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 351645 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 351645 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351648 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351652 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351657 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351668 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351671 */   GIR_RootConstrainSelectedInstOperands,
     /* 351672 */   // GIR_Coverage, 9052,
     /* 351672 */   GIR_EraseRootFromParent_Done,
     /* 351673 */ // Label 7089: @351673
     /* 351673 */ GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(351744), // Rule ID 9065 //
     /* 351678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351688 */   // MIs[0] Operand 2
     /* 351688 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 351699 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351699 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351702 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351706 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351711 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351717 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351720 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351724 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351729 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351739 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351742 */   GIR_RootConstrainSelectedInstOperands,
     /* 351743 */   // GIR_Coverage, 9065,
     /* 351743 */   GIR_EraseRootFromParent_Done,
     /* 351744 */ // Label 7090: @351744
     /* 351744 */ GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(351815), // Rule ID 9066 //
     /* 351749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351759 */   // MIs[0] Operand 2
     /* 351759 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 351770 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351770 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351773 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351777 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351782 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351788 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351791 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351795 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351800 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351813 */   GIR_RootConstrainSelectedInstOperands,
     /* 351814 */   // GIR_Coverage, 9066,
     /* 351814 */   GIR_EraseRootFromParent_Done,
     /* 351815 */ // Label 7091: @351815
     /* 351815 */ GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(351886), // Rule ID 9067 //
     /* 351820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351830 */   // MIs[0] Operand 2
     /* 351830 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 351841 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351841 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351844 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351848 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351853 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351859 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351862 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351866 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351871 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351881 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351884 */   GIR_RootConstrainSelectedInstOperands,
     /* 351885 */   // GIR_Coverage, 9067,
     /* 351885 */   GIR_EraseRootFromParent_Done,
     /* 351886 */ // Label 7092: @351886
     /* 351886 */ GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(351957), // Rule ID 9068 //
     /* 351891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351901 */   // MIs[0] Operand 2
     /* 351901 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 351912 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351912 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351915 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351919 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351924 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351930 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351933 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351937 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351942 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351955 */   GIR_RootConstrainSelectedInstOperands,
     /* 351956 */   // GIR_Coverage, 9068,
     /* 351956 */   GIR_EraseRootFromParent_Done,
     /* 351957 */ // Label 7093: @351957
     /* 351957 */ GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(352028), // Rule ID 9069 //
     /* 351962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351972 */   // MIs[0] Operand 2
     /* 351972 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 351983 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 351983 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351986 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351990 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351995 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352001 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352004 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352008 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352013 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352023 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352026 */   GIR_RootConstrainSelectedInstOperands,
     /* 352027 */   // GIR_Coverage, 9069,
     /* 352027 */   GIR_EraseRootFromParent_Done,
     /* 352028 */ // Label 7094: @352028
     /* 352028 */ GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(352099), // Rule ID 9070 //
     /* 352033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352043 */   // MIs[0] Operand 2
     /* 352043 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 352054 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352054 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352057 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352061 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352066 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352072 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352075 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352079 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352084 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352094 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352097 */   GIR_RootConstrainSelectedInstOperands,
     /* 352098 */   // GIR_Coverage, 9070,
     /* 352098 */   GIR_EraseRootFromParent_Done,
     /* 352099 */ // Label 7095: @352099
     /* 352099 */ GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(352170), // Rule ID 9071 //
     /* 352104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352114 */   // MIs[0] Operand 2
     /* 352114 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 352125 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352125 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352128 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352132 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352137 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352143 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352146 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352150 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352155 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352165 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352168 */   GIR_RootConstrainSelectedInstOperands,
     /* 352169 */   // GIR_Coverage, 9071,
     /* 352169 */   GIR_EraseRootFromParent_Done,
     /* 352170 */ // Label 7096: @352170
     /* 352170 */ GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(352241), // Rule ID 9072 //
     /* 352175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352185 */   // MIs[0] Operand 2
     /* 352185 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 352196 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352196 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352199 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352203 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352208 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352226 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352236 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352239 */   GIR_RootConstrainSelectedInstOperands,
     /* 352240 */   // GIR_Coverage, 9072,
     /* 352240 */   GIR_EraseRootFromParent_Done,
     /* 352241 */ // Label 7097: @352241
     /* 352241 */ GIM_Reject,
     /* 352242 */ // Label 7020: @352242
     /* 352242 */ GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(352277), // Rule ID 9089 //
     /* 352247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 352253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352257 */   // MIs[0] Operand 2
     /* 352257 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352268 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 352268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 352271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352273 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352275 */   GIR_RootConstrainSelectedInstOperands,
     /* 352276 */   // GIR_Coverage, 9089,
     /* 352276 */   GIR_EraseRootFromParent_Done,
     /* 352277 */ // Label 7098: @352277
     /* 352277 */ GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(352312), // Rule ID 9090 //
     /* 352282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 352288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352292 */   // MIs[0] Operand 2
     /* 352292 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 352303 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 352303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 352306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352308 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352310 */   GIR_RootConstrainSelectedInstOperands,
     /* 352311 */   // GIR_Coverage, 9090,
     /* 352311 */   GIR_EraseRootFromParent_Done,
     /* 352312 */ // Label 7099: @352312
     /* 352312 */ GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(352366), // Rule ID 9095 //
     /* 352317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 352323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352327 */   // MIs[0] Operand 2
     /* 352327 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352338 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 352338 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 352341 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 352345 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352350 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 352354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 352359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352364 */   GIR_RootConstrainSelectedInstOperands,
     /* 352365 */   // GIR_Coverage, 9095,
     /* 352365 */   GIR_EraseRootFromParent_Done,
     /* 352366 */ // Label 7100: @352366
     /* 352366 */ GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(352420), // Rule ID 9096 //
     /* 352371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 352377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352381 */   // MIs[0] Operand 2
     /* 352381 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 352392 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 352392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 352395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 352399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352404 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 352408 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 352413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352415 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352418 */   GIR_RootConstrainSelectedInstOperands,
     /* 352419 */   // GIR_Coverage, 9096,
     /* 352419 */   GIR_EraseRootFromParent_Done,
     /* 352420 */ // Label 7101: @352420
     /* 352420 */ GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(352474), // Rule ID 9097 //
     /* 352425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 352431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352435 */   // MIs[0] Operand 2
     /* 352435 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 352446 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 352446 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 352449 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 352453 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352458 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 352462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 352467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352469 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352472 */   GIR_RootConstrainSelectedInstOperands,
     /* 352473 */   // GIR_Coverage, 9097,
     /* 352473 */   GIR_EraseRootFromParent_Done,
     /* 352474 */ // Label 7102: @352474
     /* 352474 */ GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(352528), // Rule ID 9098 //
     /* 352479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 352485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352489 */   // MIs[0] Operand 2
     /* 352489 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 352500 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 352500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 352503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 352507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352512 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 352516 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 352521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352523 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352526 */   GIR_RootConstrainSelectedInstOperands,
     /* 352527 */   // GIR_Coverage, 9098,
     /* 352527 */   GIR_EraseRootFromParent_Done,
     /* 352528 */ // Label 7103: @352528
     /* 352528 */ GIM_Reject,
     /* 352529 */ // Label 7021: @352529
     /* 352529 */ GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(352598),
     /* 352534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 352537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352541 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(352569), // Rule ID 9093 //
     /* 352546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352549 */     // MIs[0] Operand 2
     /* 352549 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352560 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 352560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 352563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352567 */     GIR_RootConstrainSelectedInstOperands,
     /* 352568 */     // GIR_Coverage, 9093,
     /* 352568 */     GIR_EraseRootFromParent_Done,
     /* 352569 */   // Label 7105: @352569
     /* 352569 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(352597), // Rule ID 9094 //
     /* 352574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352577 */     // MIs[0] Operand 2
     /* 352577 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 352588 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 352588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 352591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352595 */     GIR_RootConstrainSelectedInstOperands,
     /* 352596 */     // GIR_Coverage, 9094,
     /* 352596 */     GIR_EraseRootFromParent_Done,
     /* 352597 */   // Label 7106: @352597
     /* 352597 */   GIM_Reject,
     /* 352598 */ // Label 7104: @352598
     /* 352598 */ GIM_Reject,
     /* 352599 */ // Label 7022: @352599
     /* 352599 */ GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(352634), // Rule ID 9041 //
     /* 352604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 352610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352614 */   // MIs[0] Operand 2
     /* 352614 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352625 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 352625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352630 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 352632 */   GIR_RootConstrainSelectedInstOperands,
     /* 352633 */   // GIR_Coverage, 9041,
     /* 352633 */   GIR_EraseRootFromParent_Done,
     /* 352634 */ // Label 7107: @352634
     /* 352634 */ GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(352669), // Rule ID 9042 //
     /* 352639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 352645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352649 */   // MIs[0] Operand 2
     /* 352649 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 352660 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 352660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352665 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 352667 */   GIR_RootConstrainSelectedInstOperands,
     /* 352668 */   // GIR_Coverage, 9042,
     /* 352668 */   GIR_EraseRootFromParent_Done,
     /* 352669 */ // Label 7108: @352669
     /* 352669 */ GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(352723), // Rule ID 9053 //
     /* 352674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352684 */   // MIs[0] Operand 2
     /* 352684 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352695 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 352695 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352698 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352702 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352707 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352711 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352718 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352721 */   GIR_RootConstrainSelectedInstOperands,
     /* 352722 */   // GIR_Coverage, 9053,
     /* 352722 */   GIR_EraseRootFromParent_Done,
     /* 352723 */ // Label 7109: @352723
     /* 352723 */ GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(352777), // Rule ID 9054 //
     /* 352728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352738 */   // MIs[0] Operand 2
     /* 352738 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 352749 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 352749 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352756 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352761 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352772 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352775 */   GIR_RootConstrainSelectedInstOperands,
     /* 352776 */   // GIR_Coverage, 9054,
     /* 352776 */   GIR_EraseRootFromParent_Done,
     /* 352777 */ // Label 7110: @352777
     /* 352777 */ GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(352831), // Rule ID 9055 //
     /* 352782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352792 */   // MIs[0] Operand 2
     /* 352792 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 352803 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 352803 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352806 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352810 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352815 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352826 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352829 */   GIR_RootConstrainSelectedInstOperands,
     /* 352830 */   // GIR_Coverage, 9055,
     /* 352830 */   GIR_EraseRootFromParent_Done,
     /* 352831 */ // Label 7111: @352831
     /* 352831 */ GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(352885), // Rule ID 9056 //
     /* 352836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352846 */   // MIs[0] Operand 2
     /* 352846 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 352857 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 352857 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352860 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352864 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352869 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352880 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352883 */   GIR_RootConstrainSelectedInstOperands,
     /* 352884 */   // GIR_Coverage, 9056,
     /* 352884 */   GIR_EraseRootFromParent_Done,
     /* 352885 */ // Label 7112: @352885
     /* 352885 */ GIM_Reject,
     /* 352886 */ // Label 7023: @352886
     /* 352886 */ GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(352955),
     /* 352891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 352894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352898 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(352926), // Rule ID 9091 //
     /* 352903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352906 */     // MIs[0] Operand 2
     /* 352906 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352917 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 352917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 352920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352924 */     GIR_RootConstrainSelectedInstOperands,
     /* 352925 */     // GIR_Coverage, 9091,
     /* 352925 */     GIR_EraseRootFromParent_Done,
     /* 352926 */   // Label 7114: @352926
     /* 352926 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(352954), // Rule ID 9092 //
     /* 352931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352934 */     // MIs[0] Operand 2
     /* 352934 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 352945 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 352945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 352948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352952 */     GIR_RootConstrainSelectedInstOperands,
     /* 352953 */     // GIR_Coverage, 9092,
     /* 352953 */     GIR_EraseRootFromParent_Done,
     /* 352954 */   // Label 7115: @352954
     /* 352954 */   GIM_Reject,
     /* 352955 */ // Label 7113: @352955
     /* 352955 */ GIM_Reject,
     /* 352956 */ // Label 7024: @352956
     /* 352956 */ GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(353025),
     /* 352961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352968 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(352996), // Rule ID 9043 //
     /* 352973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352976 */     // MIs[0] Operand 2
     /* 352976 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352987 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 352987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 352994 */     GIR_RootConstrainSelectedInstOperands,
     /* 352995 */     // GIR_Coverage, 9043,
     /* 352995 */     GIR_EraseRootFromParent_Done,
     /* 352996 */   // Label 7117: @352996
     /* 352996 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(353024), // Rule ID 9044 //
     /* 353001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353004 */     // MIs[0] Operand 2
     /* 353004 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 353015 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 353015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 353022 */     GIR_RootConstrainSelectedInstOperands,
     /* 353023 */     // GIR_Coverage, 9044,
     /* 353023 */     GIR_EraseRootFromParent_Done,
     /* 353024 */   // Label 7118: @353024
     /* 353024 */   GIM_Reject,
     /* 353025 */ // Label 7116: @353025
     /* 353025 */ GIM_Reject,
     /* 353026 */ // Label 7025: @353026
     /* 353026 */ GIM_Reject,
     /* 353027 */ // Label 90: @353027
     /* 353027 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7134*/ GIMT_Encode4(385948),
     /* 353038 */ /*GILLT_s64*//*Label 7119*/ GIMT_Encode4(353122), GIMT_Encode4(0),
     /* 353046 */ /*GILLT_v2s32*//*Label 7120*/ GIMT_Encode4(353832),
     /* 353050 */ /*GILLT_v2s64*//*Label 7121*/ GIMT_Encode4(357363),
     /* 353054 */ /*GILLT_v4s16*//*Label 7122*/ GIMT_Encode4(360604),
     /* 353058 */ /*GILLT_v4s32*//*Label 7123*/ GIMT_Encode4(364244),
     /* 353062 */ /*GILLT_v8s8*//*Label 7124*/ GIMT_Encode4(367312),
     /* 353066 */ /*GILLT_v8s16*//*Label 7125*/ GIMT_Encode4(370525),
     /* 353070 */ /*GILLT_v16s8*//*Label 7126*/ GIMT_Encode4(373944), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 353082 */ /*GILLT_nxv2s16*//*Label 7127*/ GIMT_Encode4(377148),
     /* 353086 */ /*GILLT_nxv2s32*//*Label 7128*/ GIMT_Encode4(377273),
     /* 353090 */ /*GILLT_nxv2s64*//*Label 7129*/ GIMT_Encode4(377398), GIMT_Encode4(0),
     /* 353098 */ /*GILLT_nxv4s16*//*Label 7130*/ GIMT_Encode4(379376),
     /* 353102 */ /*GILLT_nxv4s32*//*Label 7131*/ GIMT_Encode4(379528), GIMT_Encode4(0),
     /* 353110 */ /*GILLT_nxv8s16*//*Label 7132*/ GIMT_Encode4(381560), GIMT_Encode4(0),
     /* 353118 */ /*GILLT_nxv16s8*//*Label 7133*/ GIMT_Encode4(383828),
     /* 353122 */ // Label 7119: @353122
     /* 353122 */ GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(353831),
     /* 353127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 353130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353133 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353140 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(353270), // Rule ID 5770 //
     /* 353145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 353161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353178 */     // MIs[2] Operand 1
     /* 353178 */     // No operand predicates
     /* 353178 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353182 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353186 */     // MIs[3] Operand 1
     /* 353186 */     // No operand predicates
     /* 353186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353188 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 353188 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 353191 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353195 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353200 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 353203 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353207 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 353210 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353215 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 353223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 353227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353232 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 353238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 353245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353252 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 353259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353269 */     // GIR_Coverage, 5770,
     /* 353269 */     GIR_EraseRootFromParent_Done,
     /* 353270 */   // Label 7136: @353270
     /* 353270 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(353431), // Rule ID 5771 //
     /* 353275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 353291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353308 */     // MIs[2] Operand 1
     /* 353308 */     // No operand predicates
     /* 353308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353316 */     // MIs[3] Operand 1
     /* 353316 */     // No operand predicates
     /* 353316 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353318 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 353318 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 353321 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353325 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353330 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 353333 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353337 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 353340 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353345 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353350 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 353353 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353357 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353362 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 353365 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353369 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 353372 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353377 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 353385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 353389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353394 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 353400 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 353403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 353406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353413 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 353420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353430 */     // GIR_Coverage, 5771,
     /* 353430 */     GIR_EraseRootFromParent_Done,
     /* 353431 */   // Label 7137: @353431
     /* 353431 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(353561), // Rule ID 5810 //
     /* 353436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 353452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353469 */     // MIs[2] Operand 1
     /* 353469 */     // No operand predicates
     /* 353469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353477 */     // MIs[3] Operand 1
     /* 353477 */     // No operand predicates
     /* 353477 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353479 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 353479 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 353482 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353486 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353491 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 353494 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353498 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 353501 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353506 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 353514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 353518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353523 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 353529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 353536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353543 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 353550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353560 */     // GIR_Coverage, 5810,
     /* 353560 */     GIR_EraseRootFromParent_Done,
     /* 353561 */   // Label 7138: @353561
     /* 353561 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(353722), // Rule ID 5811 //
     /* 353566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 353582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353599 */     // MIs[2] Operand 1
     /* 353599 */     // No operand predicates
     /* 353599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353607 */     // MIs[3] Operand 1
     /* 353607 */     // No operand predicates
     /* 353607 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353609 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 353609 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 353612 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353616 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353621 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 353624 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353628 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 353631 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353636 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353641 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 353644 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353648 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353653 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 353656 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353660 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 353663 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 353676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 353680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353685 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 353691 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 353694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 353697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353704 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 353711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353721 */     // GIR_Coverage, 5811,
     /* 353721 */     GIR_EraseRootFromParent_Done,
     /* 353722 */   // Label 7139: @353722
     /* 353722 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(353758), // Rule ID 6719 //
     /* 353727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353745 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 353745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 353752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353757 */     // GIR_Coverage, 6719,
     /* 353757 */     GIR_EraseRootFromParent_Done,
     /* 353758 */   // Label 7140: @353758
     /* 353758 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(353794), // Rule ID 6721 //
     /* 353763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353781 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 353781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 353788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353793 */     // GIR_Coverage, 6721,
     /* 353793 */     GIR_EraseRootFromParent_Done,
     /* 353794 */   // Label 7141: @353794
     /* 353794 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(353830), // Rule ID 6723 //
     /* 353799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353817 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 353817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353820 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 353822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 353824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353829 */     // GIR_Coverage, 6723,
     /* 353829 */     GIR_EraseRootFromParent_Done,
     /* 353830 */   // Label 7142: @353830
     /* 353830 */   GIM_Reject,
     /* 353831 */ // Label 7135: @353831
     /* 353831 */ GIM_Reject,
     /* 353832 */ // Label 7120: @353832
     /* 353832 */ GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(357362),
     /* 353837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 353840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353843 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353850 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(353959), // Rule ID 4308 //
     /* 353855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353859 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353865 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353875 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353878 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353882 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353892 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 353899 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 353899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 353906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 353921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 353926 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353958 */     // GIR_Coverage, 4308,
     /* 353958 */     GIR_EraseRootFromParent_Done,
     /* 353959 */   // Label 7144: @353959
     /* 353959 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(354068), // Rule ID 4309 //
     /* 353964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353968 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 353974 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 353976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353984 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353987 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353991 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353995 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354001 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 354008 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 354015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354035 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354067 */     // GIR_Coverage, 4309,
     /* 354067 */     GIR_EraseRootFromParent_Done,
     /* 354068 */   // Label 7145: @354068
     /* 354068 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(354177), // Rule ID 4416 //
     /* 354073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354077 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354083 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354093 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354096 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354100 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354110 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 354117 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 354124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354144 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354176 */     // GIR_Coverage, 4416,
     /* 354176 */     GIR_EraseRootFromParent_Done,
     /* 354177 */   // Label 7146: @354177
     /* 354177 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(354286), // Rule ID 4417 //
     /* 354182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354186 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354192 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354202 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354205 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354209 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354219 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 354226 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 354233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354253 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354275 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354285 */     // GIR_Coverage, 4417,
     /* 354285 */     GIR_EraseRootFromParent_Done,
     /* 354286 */   // Label 7147: @354286
     /* 354286 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(354391), // Rule ID 4314 //
     /* 354291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354307 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354310 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354314 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354324 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 354331 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 354338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354358 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354390 */     // GIR_Coverage, 4314,
     /* 354390 */     GIR_EraseRootFromParent_Done,
     /* 354391 */   // Label 7148: @354391
     /* 354391 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(354496), // Rule ID 4316 //
     /* 354396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354412 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354415 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354419 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354423 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354429 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 354436 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 354443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354463 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354495 */     // GIR_Coverage, 4316,
     /* 354495 */     GIR_EraseRootFromParent_Done,
     /* 354496 */   // Label 7149: @354496
     /* 354496 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(354601), // Rule ID 4422 //
     /* 354501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354517 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354520 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354524 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354534 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 354541 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 354548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354568 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354600 */     // GIR_Coverage, 4422,
     /* 354600 */     GIR_EraseRootFromParent_Done,
     /* 354601 */   // Label 7150: @354601
     /* 354601 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(354706), // Rule ID 4424 //
     /* 354606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354622 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354625 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354629 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354639 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 354646 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 354653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354673 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354705 */     // GIR_Coverage, 4424,
     /* 354705 */     GIR_EraseRootFromParent_Done,
     /* 354706 */   // Label 7151: @354706
     /* 354706 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(354810), // Rule ID 4306 //
     /* 354711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354715 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354721 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354731 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354734 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354738 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354748 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 354755 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 354755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 354762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354777 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354809 */     // GIR_Coverage, 4306,
     /* 354809 */     GIR_EraseRootFromParent_Done,
     /* 354810 */   // Label 7152: @354810
     /* 354810 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(354914), // Rule ID 4307 //
     /* 354815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354819 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354825 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354835 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354838 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354842 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 354859 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 354859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 354866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354881 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354913 */     // GIR_Coverage, 4307,
     /* 354913 */     GIR_EraseRootFromParent_Done,
     /* 354914 */   // Label 7153: @354914
     /* 354914 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(355018), // Rule ID 4414 //
     /* 354919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354923 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354929 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354939 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354946 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 354963 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 354963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 354970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 354985 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355017 */     // GIR_Coverage, 4414,
     /* 355017 */     GIR_EraseRootFromParent_Done,
     /* 355018 */   // Label 7154: @355018
     /* 355018 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(355122), // Rule ID 4415 //
     /* 355023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355027 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355033 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355043 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355046 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355050 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355060 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 355067 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 355067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 355074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355089 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355111 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355121 */     // GIR_Coverage, 4415,
     /* 355121 */     GIR_EraseRootFromParent_Done,
     /* 355122 */   // Label 7155: @355122
     /* 355122 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(355222), // Rule ID 4310 //
     /* 355127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355143 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355146 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355150 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355160 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 355167 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 355167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 355174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355189 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355221 */     // GIR_Coverage, 4310,
     /* 355221 */     GIR_EraseRootFromParent_Done,
     /* 355222 */   // Label 7156: @355222
     /* 355222 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(355322), // Rule ID 4312 //
     /* 355227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355243 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355246 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355250 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355260 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 355267 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 355267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 355274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355289 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355321 */     // GIR_Coverage, 4312,
     /* 355321 */     GIR_EraseRootFromParent_Done,
     /* 355322 */   // Label 7157: @355322
     /* 355322 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(355422), // Rule ID 4418 //
     /* 355327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355343 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355346 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355350 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355360 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 355367 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 355367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 355374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355389 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355421 */     // GIR_Coverage, 4418,
     /* 355421 */     GIR_EraseRootFromParent_Done,
     /* 355422 */   // Label 7158: @355422
     /* 355422 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(355522), // Rule ID 4420 //
     /* 355427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355443 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355446 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355450 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355460 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 355467 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 355467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 355474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355489 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355521 */     // GIR_Coverage, 4420,
     /* 355521 */     GIR_EraseRootFromParent_Done,
     /* 355522 */   // Label 7159: @355522
     /* 355522 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(355642), // Rule ID 6497 //
     /* 355527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355546 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355549 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355553 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 355560 */     // MIs[2] Rn
     /* 355560 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 355564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 355569 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355573 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355575 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 355575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 355578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 355589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 355596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355601 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355604 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 355607 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 355611 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355624 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355641 */     // GIR_Coverage, 6497,
     /* 355641 */     GIR_EraseRootFromParent_Done,
     /* 355642 */   // Label 7160: @355642
     /* 355642 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(355762), // Rule ID 6499 //
     /* 355647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 355650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355666 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355669 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355673 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 355680 */     // MIs[2] Rn
     /* 355680 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 355684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 355689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355695 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 355695 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 355698 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 355702 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 355709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 355716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355721 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355724 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 355727 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 355731 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355744 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355761 */     // GIR_Coverage, 6499,
     /* 355761 */     GIR_EraseRootFromParent_Done,
     /* 355762 */   // Label 7161: @355762
     /* 355762 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(355892), // Rule ID 5762 //
     /* 355767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 355783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355800 */     // MIs[2] Operand 1
     /* 355800 */     // No operand predicates
     /* 355800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355808 */     // MIs[3] Operand 1
     /* 355808 */     // No operand predicates
     /* 355808 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355810 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355810 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 355813 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355817 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355822 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355825 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355829 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355832 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355837 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 355845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 355849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355854 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 355860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 355867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 355872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355874 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 355881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355886 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355891 */     // GIR_Coverage, 5762,
     /* 355891 */     GIR_EraseRootFromParent_Done,
     /* 355892 */   // Label 7162: @355892
     /* 355892 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(356053), // Rule ID 5763 //
     /* 355897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 355905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 355909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 355913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 355917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 355926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355930 */     // MIs[2] Operand 1
     /* 355930 */     // No operand predicates
     /* 355930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 355934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 355938 */     // MIs[3] Operand 1
     /* 355938 */     // No operand predicates
     /* 355938 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 355940 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 355940 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 355943 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355947 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355952 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355955 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 355959 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 355962 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355967 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355972 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 355975 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355979 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355984 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 355987 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 355991 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 355994 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 355999 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356016 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 356022 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 356025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 356028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356035 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356052 */     // GIR_Coverage, 5763,
     /* 356052 */     GIR_EraseRootFromParent_Done,
     /* 356053 */   // Label 7163: @356053
     /* 356053 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(356183), // Rule ID 5802 //
     /* 356058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 356074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356091 */     // MIs[2] Operand 1
     /* 356091 */     // No operand predicates
     /* 356091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 356095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356099 */     // MIs[3] Operand 1
     /* 356099 */     // No operand predicates
     /* 356099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356101 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 356101 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 356104 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356108 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356113 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 356116 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356120 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356123 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356128 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356145 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 356151 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 356158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356165 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356182 */     // GIR_Coverage, 5802,
     /* 356182 */     GIR_EraseRootFromParent_Done,
     /* 356183 */   // Label 7164: @356183
     /* 356183 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(356344), // Rule ID 5803 //
     /* 356188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 356204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356221 */     // MIs[2] Operand 1
     /* 356221 */     // No operand predicates
     /* 356221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 356225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356229 */     // MIs[3] Operand 1
     /* 356229 */     // No operand predicates
     /* 356229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356231 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 356231 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 356234 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356238 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356243 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 356246 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356250 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 356253 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356258 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356263 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 356266 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356270 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356275 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 356278 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356282 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356285 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356290 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356307 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 356313 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 356316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 356319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356326 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356343 */     // GIR_Coverage, 5803,
     /* 356343 */     GIR_EraseRootFromParent_Done,
     /* 356344 */   // Label 7165: @356344
     /* 356344 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(356410), // Rule ID 5713 //
     /* 356349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356367 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 356367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 356370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 356391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356409 */     // GIR_Coverage, 5713,
     /* 356409 */     GIR_EraseRootFromParent_Done,
     /* 356410 */   // Label 7166: @356410
     /* 356410 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(356476), // Rule ID 5725 //
     /* 356415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356427 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 356433 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 356433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 356436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 356457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356475 */     // GIR_Coverage, 5725,
     /* 356475 */     GIR_EraseRootFromParent_Done,
     /* 356476 */   // Label 7167: @356476
     /* 356476 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(356611), // Rule ID 5733 //
     /* 356481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 356493 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 356497 */     // MIs[1] Operand 1
     /* 356497 */     // No operand predicates
     /* 356497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 356501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356505 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 356509 */     // MIs[2] Operand 1
     /* 356509 */     // No operand predicates
     /* 356509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356511 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 356511 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 356514 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356518 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356525 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 356528 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356532 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356537 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 356540 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 356544 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356547 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356552 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356557 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 356569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356574 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 356580 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 356586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356593 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356610 */     // GIR_Coverage, 5733,
     /* 356610 */     GIR_EraseRootFromParent_Done,
     /* 356611 */   // Label 7168: @356611
     /* 356611 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(356743), // Rule ID 6506 //
     /* 356616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 356635 */     // MIs[1] Rn
     /* 356635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 356639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 356644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 356648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356652 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 356656 */     // MIs[2] Operand 1
     /* 356656 */     // No operand predicates
     /* 356656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356658 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 356658 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 356661 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356665 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356670 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 356673 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 356677 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356680 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 356697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356702 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 356708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356712 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356725 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356742 */     // GIR_Coverage, 6506,
     /* 356742 */     GIR_EraseRootFromParent_Done,
     /* 356743 */   // Label 7169: @356743
     /* 356743 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(356875), // Rule ID 6507 //
     /* 356748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356760 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356763 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 356767 */     // MIs[1] Rn
     /* 356767 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 356771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 356776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 356780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356784 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 356788 */     // MIs[2] Operand 1
     /* 356788 */     // No operand predicates
     /* 356788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356790 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 356790 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 356793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356797 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356802 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 356805 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 356809 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356812 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356817 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 356829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356834 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 356840 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356844 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356857 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356864 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356869 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356874 */     // GIR_Coverage, 6507,
     /* 356874 */     GIR_EraseRootFromParent_Done,
     /* 356875 */   // Label 7170: @356875
     /* 356875 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(357058), // Rule ID 5813 //
     /* 356880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 356888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 356892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 356901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356905 */     // MIs[2] Operand 1
     /* 356905 */     // No operand predicates
     /* 356905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356907 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 356907 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 356910 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356914 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 356921 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 356924 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356928 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356933 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 356936 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 356940 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 356943 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356948 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356953 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356958 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 356961 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356965 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356972 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 356975 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 356979 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356984 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 356987 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356991 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356994 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356999 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 357016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357021 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 357027 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 357030 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 357033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357040 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357057 */     // GIR_Coverage, 5813,
     /* 357057 */     GIR_EraseRootFromParent_Done,
     /* 357058 */   // Label 7171: @357058
     /* 357058 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(357236), // Rule ID 5736 //
     /* 357063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 357075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 357083 */     // MIs[1] Operand 1
     /* 357083 */     // No operand predicates
     /* 357083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357085 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 357085 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 357088 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357092 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 357099 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 357102 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357106 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357111 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 357114 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 357118 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 357121 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357126 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357131 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357136 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 357139 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357143 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357150 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 357153 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357157 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357162 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 357165 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 357169 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357172 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357177 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357182 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 357194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357199 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 357205 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 357208 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 357211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357218 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357235 */     // GIR_Coverage, 5736,
     /* 357235 */     GIR_EraseRootFromParent_Done,
     /* 357236 */   // Label 7172: @357236
     /* 357236 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(357361), // Rule ID 5739 //
     /* 357241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 357253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 357261 */     // MIs[1] Operand 1
     /* 357261 */     // No operand predicates
     /* 357261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357263 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 357263 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 357266 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357270 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357277 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 357280 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357284 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357289 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 357292 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 357296 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357299 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357304 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357309 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 357321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357326 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 357332 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 357336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357343 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357360 */     // GIR_Coverage, 5739,
     /* 357360 */     GIR_EraseRootFromParent_Done,
     /* 357361 */   // Label 7173: @357361
     /* 357361 */   GIM_Reject,
     /* 357362 */ // Label 7143: @357362
     /* 357362 */ GIM_Reject,
     /* 357363 */ // Label 7121: @357363
     /* 357363 */ GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(360603),
     /* 357368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 357371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 357374 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 357377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357381 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(357490), // Rule ID 4332 //
     /* 357386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357390 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357396 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357406 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357409 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357413 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357423 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 357430 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 357437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357457 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357489 */     // GIR_Coverage, 4332,
     /* 357489 */     GIR_EraseRootFromParent_Done,
     /* 357490 */   // Label 7175: @357490
     /* 357490 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(357599), // Rule ID 4333 //
     /* 357495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357499 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357505 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357515 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357518 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357522 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 357539 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 357546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357566 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357598 */     // GIR_Coverage, 4333,
     /* 357598 */     GIR_EraseRootFromParent_Done,
     /* 357599 */   // Label 7176: @357599
     /* 357599 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(357708), // Rule ID 4440 //
     /* 357604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357608 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357614 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357624 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357627 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357631 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357635 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357641 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 357648 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 357655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357675 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357702 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357707 */     // GIR_Coverage, 4440,
     /* 357707 */     GIR_EraseRootFromParent_Done,
     /* 357708 */   // Label 7177: @357708
     /* 357708 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(357817), // Rule ID 4441 //
     /* 357713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357717 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357723 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357733 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357736 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357740 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357750 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 357757 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 357764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357784 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357806 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357816 */     // GIR_Coverage, 4441,
     /* 357816 */     GIR_EraseRootFromParent_Done,
     /* 357817 */   // Label 7178: @357817
     /* 357817 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(357922), // Rule ID 4338 //
     /* 357822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357838 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357841 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357845 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357855 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 357862 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 357869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357889 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 357911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357921 */     // GIR_Coverage, 4338,
     /* 357921 */     GIR_EraseRootFromParent_Done,
     /* 357922 */   // Label 7179: @357922
     /* 357922 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(358027), // Rule ID 4340 //
     /* 357927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357943 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357946 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357950 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357960 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 357967 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 357967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 357970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 357974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357994 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358026 */     // GIR_Coverage, 4340,
     /* 358026 */     GIR_EraseRootFromParent_Done,
     /* 358027 */   // Label 7180: @358027
     /* 358027 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(358132), // Rule ID 4446 //
     /* 358032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358048 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358055 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358065 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358072 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358099 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358126 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358131 */     // GIR_Coverage, 4446,
     /* 358131 */     GIR_EraseRootFromParent_Done,
     /* 358132 */   // Label 7181: @358132
     /* 358132 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(358237), // Rule ID 4448 //
     /* 358137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358153 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358156 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358160 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358170 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 358177 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 358184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358204 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358226 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358236 */     // GIR_Coverage, 4448,
     /* 358236 */     GIR_EraseRootFromParent_Done,
     /* 358237 */   // Label 7182: @358237
     /* 358237 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(358341), // Rule ID 4330 //
     /* 358242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358246 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358252 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358262 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358265 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358269 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 358286 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 358286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 358293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358308 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358330 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358340 */     // GIR_Coverage, 4330,
     /* 358340 */     GIR_EraseRootFromParent_Done,
     /* 358341 */   // Label 7183: @358341
     /* 358341 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(358445), // Rule ID 4331 //
     /* 358346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358350 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358356 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358366 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358373 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358377 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358383 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 358390 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 358390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 358397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358412 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358444 */     // GIR_Coverage, 4331,
     /* 358444 */     GIR_EraseRootFromParent_Done,
     /* 358445 */   // Label 7184: @358445
     /* 358445 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(358549), // Rule ID 4438 //
     /* 358450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358454 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358460 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358470 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358473 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358477 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358481 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358487 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 358494 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 358494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 358501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358516 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358538 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358548 */     // GIR_Coverage, 4438,
     /* 358548 */     GIR_EraseRootFromParent_Done,
     /* 358549 */   // Label 7185: @358549
     /* 358549 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(358653), // Rule ID 4439 //
     /* 358554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358558 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358564 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358574 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358577 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358581 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358591 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 358598 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 358598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 358605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358620 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358652 */     // GIR_Coverage, 4439,
     /* 358652 */     GIR_EraseRootFromParent_Done,
     /* 358653 */   // Label 7186: @358653
     /* 358653 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(358753), // Rule ID 4334 //
     /* 358658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358674 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358677 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358681 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358691 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 358698 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 358698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 358705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358720 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358742 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358752 */     // GIR_Coverage, 4334,
     /* 358752 */     GIR_EraseRootFromParent_Done,
     /* 358753 */   // Label 7187: @358753
     /* 358753 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(358853), // Rule ID 4336 //
     /* 358758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358774 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358777 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358781 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 358798 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 358798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 358805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358820 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358852 */     // GIR_Coverage, 4336,
     /* 358852 */     GIR_EraseRootFromParent_Done,
     /* 358853 */   // Label 7188: @358853
     /* 358853 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(358953), // Rule ID 4442 //
     /* 358858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358874 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358877 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358881 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358885 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358891 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 358898 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 358898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 358905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 358920 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358952 */     // GIR_Coverage, 4442,
     /* 358952 */     GIR_EraseRootFromParent_Done,
     /* 358953 */   // Label 7189: @358953
     /* 358953 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(359053), // Rule ID 4444 //
     /* 358958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358974 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358981 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 358998 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 358998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359020 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359052 */     // GIR_Coverage, 4444,
     /* 359052 */     GIR_EraseRootFromParent_Done,
     /* 359053 */   // Label 7190: @359053
     /* 359053 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(359166), // Rule ID 5768 //
     /* 359058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 359082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 359091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359095 */     // MIs[3] Operand 1
     /* 359095 */     // No operand predicates
     /* 359095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359101 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 359101 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 359104 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 359108 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359113 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 359117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 359120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 359147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359165 */     // GIR_Coverage, 5768,
     /* 359165 */     GIR_EraseRootFromParent_Done,
     /* 359166 */   // Label 7191: @359166
     /* 359166 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(359279), // Rule ID 5808 //
     /* 359171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359191 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 359195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 359204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359208 */     // MIs[3] Operand 1
     /* 359208 */     // No operand predicates
     /* 359208 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359212 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359214 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 359214 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 359217 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 359221 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359226 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 359230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 359233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 359260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359278 */     // GIR_Coverage, 5808,
     /* 359278 */     GIR_EraseRootFromParent_Done,
     /* 359279 */   // Label 7192: @359279
     /* 359279 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(359357), // Rule ID 1941 //
     /* 359284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 359316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359320 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359324 */     // MIs[2] Operand 1
     /* 359324 */     // No operand predicates
     /* 359324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359332 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359336 */     // MIs[3] Operand 1
     /* 359336 */     // No operand predicates
     /* 359336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359338 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 359338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359343 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 359345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 359348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 359355 */     GIR_RootConstrainSelectedInstOperands,
     /* 359356 */     // GIR_Coverage, 1941,
     /* 359356 */     GIR_EraseRootFromParent_Done,
     /* 359357 */   // Label 7193: @359357
     /* 359357 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(359452), // Rule ID 7486 //
     /* 359362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 359365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 359377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 359381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 359385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359389 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 359392 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359396 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 359403 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 359406 */     // MIs[2] Rn
     /* 359406 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 359410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 359415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359419 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359423 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359427 */     // MIs[3] Operand 1
     /* 359427 */     // No operand predicates
     /* 359427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359429 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15907>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 359429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 359432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 359436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 359439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 359443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 359450 */     GIR_RootConstrainSelectedInstOperands,
     /* 359451 */     // GIR_Coverage, 7486,
     /* 359451 */     GIR_EraseRootFromParent_Done,
     /* 359452 */   // Label 7194: @359452
     /* 359452 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(359541), // Rule ID 5765 //
     /* 359457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 359469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 359477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359481 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359485 */     // MIs[2] Operand 1
     /* 359485 */     // No operand predicates
     /* 359485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359493 */     // MIs[3] Operand 1
     /* 359493 */     // No operand predicates
     /* 359493 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359495 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2f64] } ZPR:{ *:[nxv2f64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 359495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359507 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 359513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 359530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 359533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 359539 */     GIR_RootConstrainSelectedInstOperands,
     /* 359540 */     // GIR_Coverage, 5765,
     /* 359540 */     GIR_EraseRootFromParent_Done,
     /* 359541 */   // Label 7195: @359541
     /* 359541 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(359630), // Rule ID 5805 //
     /* 359546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 359558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 359566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359570 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 359574 */     // MIs[2] Operand 1
     /* 359574 */     // No operand predicates
     /* 359574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359582 */     // MIs[3] Operand 1
     /* 359582 */     // No operand predicates
     /* 359582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359584 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 359584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 359591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359596 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 359602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 359619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 359622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 359628 */     GIR_RootConstrainSelectedInstOperands,
     /* 359629 */     // GIR_Coverage, 5805,
     /* 359629 */     GIR_EraseRootFromParent_Done,
     /* 359630 */   // Label 7196: @359630
     /* 359630 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(359697), // Rule ID 5767 //
     /* 359635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 359664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359668 */     // MIs[2] Operand 1
     /* 359668 */     // No operand predicates
     /* 359668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359676 */     // MIs[3] Operand 1
     /* 359676 */     // No operand predicates
     /* 359676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359678 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 359678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359683 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 359685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 359688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 359695 */     GIR_RootConstrainSelectedInstOperands,
     /* 359696 */     // GIR_Coverage, 5767,
     /* 359696 */     GIR_EraseRootFromParent_Done,
     /* 359697 */   // Label 7197: @359697
     /* 359697 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(359795), // Rule ID 5769 //
     /* 359702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 359718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 359731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359735 */     // MIs[2] Operand 1
     /* 359735 */     // No operand predicates
     /* 359735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359743 */     // MIs[3] Operand 1
     /* 359743 */     // No operand predicates
     /* 359743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359745 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 359745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359757 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 359760 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359764 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 359767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359782 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 359784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 359787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 359793 */     GIR_RootConstrainSelectedInstOperands,
     /* 359794 */     // GIR_Coverage, 5769,
     /* 359794 */     GIR_EraseRootFromParent_Done,
     /* 359795 */   // Label 7198: @359795
     /* 359795 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(359862), // Rule ID 5807 //
     /* 359800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 359829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359833 */     // MIs[2] Operand 1
     /* 359833 */     // No operand predicates
     /* 359833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359841 */     // MIs[3] Operand 1
     /* 359841 */     // No operand predicates
     /* 359841 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359843 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 359843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359848 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 359850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 359853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 359860 */     GIR_RootConstrainSelectedInstOperands,
     /* 359861 */     // GIR_Coverage, 5807,
     /* 359861 */     GIR_EraseRootFromParent_Done,
     /* 359862 */   // Label 7199: @359862
     /* 359862 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(359960), // Rule ID 5809 //
     /* 359867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 359883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 359887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 359896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359900 */     // MIs[2] Operand 1
     /* 359900 */     // No operand predicates
     /* 359900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 359904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359908 */     // MIs[3] Operand 1
     /* 359908 */     // No operand predicates
     /* 359908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359910 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 359910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359922 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 359925 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 359929 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 359932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 359945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359947 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 359949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 359952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 359958 */     GIR_RootConstrainSelectedInstOperands,
     /* 359959 */     // GIR_Coverage, 5809,
     /* 359959 */     GIR_EraseRootFromParent_Done,
     /* 359960 */   // Label 7200: @359960
     /* 359960 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(360026), // Rule ID 5717 //
     /* 359965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 359983 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 359983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360025 */     // GIR_Coverage, 5717,
     /* 360025 */     GIR_EraseRootFromParent_Done,
     /* 360026 */   // Label 7201: @360026
     /* 360026 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(360092), // Rule ID 5727 //
     /* 360031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360049 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 360049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360091 */     // GIR_Coverage, 5727,
     /* 360091 */     GIR_EraseRootFromParent_Done,
     /* 360092 */   // Label 7202: @360092
     /* 360092 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(360161), // Rule ID 6488 //
     /* 360097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360109 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360112 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 360116 */     // MIs[1] Rn
     /* 360116 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 360120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 360125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 360129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360133 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360137 */     // MIs[2] Operand 1
     /* 360137 */     // No operand predicates
     /* 360137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360139 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 360139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 360142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 360146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360159 */     GIR_RootConstrainSelectedInstOperands,
     /* 360160 */     // GIR_Coverage, 6488,
     /* 360160 */     GIR_EraseRootFromParent_Done,
     /* 360161 */   // Label 7203: @360161
     /* 360161 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(360230), // Rule ID 6489 //
     /* 360166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360178 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360181 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 360185 */     // MIs[1] Rn
     /* 360185 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 360189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 360194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 360198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360202 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360206 */     // MIs[2] Operand 1
     /* 360206 */     // No operand predicates
     /* 360206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360208 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 360208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 360211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 360215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360228 */     GIR_RootConstrainSelectedInstOperands,
     /* 360229 */     // GIR_Coverage, 6489,
     /* 360229 */     GIR_EraseRootFromParent_Done,
     /* 360230 */   // Label 7204: @360230
     /* 360230 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(360312), // Rule ID 7485 //
     /* 360235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 360238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360250 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 360253 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 360257 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 360264 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 360267 */     // MIs[1] Rn
     /* 360267 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 360271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 360276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 360280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360284 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360288 */     // MIs[2] Operand 1
     /* 360288 */     // No operand predicates
     /* 360288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360290 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15907>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 360290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 360293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360295 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 360297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360310 */     GIR_RootConstrainSelectedInstOperands,
     /* 360311 */     // GIR_Coverage, 7485,
     /* 360311 */     GIR_EraseRootFromParent_Done,
     /* 360312 */   // Label 7205: @360312
     /* 360312 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(360361), // Rule ID 5734 //
     /* 360317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 360325 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 360329 */     // MIs[1] Operand 1
     /* 360329 */     // No operand predicates
     /* 360329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 360333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360337 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360341 */     // MIs[2] Operand 1
     /* 360341 */     // No operand predicates
     /* 360341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360343 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 360343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 360346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 360353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 360359 */     GIR_RootConstrainSelectedInstOperands,
     /* 360360 */     // GIR_Coverage, 5734,
     /* 360360 */     GIR_EraseRootFromParent_Done,
     /* 360361 */   // Label 7206: @360361
     /* 360361 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(360462), // Rule ID 5814 //
     /* 360366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 360374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 360378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 360387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360391 */     // MIs[2] Operand 1
     /* 360391 */     // No operand predicates
     /* 360391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360393 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 360393 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 360396 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360400 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 360410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360419 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360422 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 360426 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 360429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360449 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 360451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 360454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360460 */     GIR_RootConstrainSelectedInstOperands,
     /* 360461 */     // GIR_Coverage, 5814,
     /* 360461 */     GIR_EraseRootFromParent_Done,
     /* 360462 */   // Label 7207: @360462
     /* 360462 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(360506), // Rule ID 1937 //
     /* 360467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 360470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 360482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360490 */     // MIs[1] Operand 1
     /* 360490 */     // No operand predicates
     /* 360490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360492 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 360492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 360495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 360499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 360502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360504 */     GIR_RootConstrainSelectedInstOperands,
     /* 360505 */     // GIR_Coverage, 1937,
     /* 360505 */     GIR_EraseRootFromParent_Done,
     /* 360506 */   // Label 7208: @360506
     /* 360506 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(360602), // Rule ID 5738 //
     /* 360511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 360523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360531 */     // MIs[1] Operand 1
     /* 360531 */     // No operand predicates
     /* 360531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360533 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 360533 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 360536 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360540 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 360566 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 360569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 360594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360600 */     GIR_RootConstrainSelectedInstOperands,
     /* 360601 */     // GIR_Coverage, 5738,
     /* 360601 */     GIR_EraseRootFromParent_Done,
     /* 360602 */   // Label 7209: @360602
     /* 360602 */   GIM_Reject,
     /* 360603 */ // Label 7174: @360603
     /* 360603 */ GIM_Reject,
     /* 360604 */ // Label 7122: @360604
     /* 360604 */ GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(364243),
     /* 360609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 360612 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(360738), // Rule ID 4272 //
     /* 360617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360631 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360637 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360647 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360650 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360654 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 360661 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360671 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 360678 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 360685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360705 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360737 */     // GIR_Coverage, 4272,
     /* 360737 */     GIR_EraseRootFromParent_Done,
     /* 360738 */   // Label 7211: @360738
     /* 360738 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(360864), // Rule ID 4273 //
     /* 360743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360757 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360763 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360773 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360776 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360780 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 360787 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360791 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360795 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 360804 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 360811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360831 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360858 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360863 */     // GIR_Coverage, 4273,
     /* 360863 */     GIR_EraseRootFromParent_Done,
     /* 360864 */   // Label 7212: @360864
     /* 360864 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(360983), // Rule ID 4380 //
     /* 360869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360883 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360889 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360899 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360902 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360906 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360916 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 360923 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 360923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 360930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360950 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360982 */     // GIR_Coverage, 4380,
     /* 360982 */     GIR_EraseRootFromParent_Done,
     /* 360983 */   // Label 7213: @360983
     /* 360983 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(361102), // Rule ID 4381 //
     /* 360988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361002 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361008 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361018 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361021 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361025 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361035 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 361042 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 361049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361069 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361101 */     // GIR_Coverage, 4381,
     /* 361101 */     GIR_EraseRootFromParent_Done,
     /* 361102 */   // Label 7214: @361102
     /* 361102 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(361224), // Rule ID 4278 //
     /* 361107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361133 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361136 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361140 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361147 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361151 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361157 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 361164 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 361171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361191 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361213 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361218 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361223 */     // GIR_Coverage, 4278,
     /* 361223 */     GIR_EraseRootFromParent_Done,
     /* 361224 */   // Label 7215: @361224
     /* 361224 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(361346), // Rule ID 4280 //
     /* 361229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361255 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361258 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361262 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361269 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361279 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 361286 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 361293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361313 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361345 */     // GIR_Coverage, 4280,
     /* 361345 */     GIR_EraseRootFromParent_Done,
     /* 361346 */   // Label 7216: @361346
     /* 361346 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(361461), // Rule ID 4386 //
     /* 361351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361377 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361380 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361384 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361394 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 361401 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 361408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361428 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361450 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361455 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361460 */     // GIR_Coverage, 4386,
     /* 361460 */     GIR_EraseRootFromParent_Done,
     /* 361461 */   // Label 7217: @361461
     /* 361461 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(361576), // Rule ID 4388 //
     /* 361466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361492 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361499 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361509 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 361516 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 361523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361543 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361575 */     // GIR_Coverage, 4388,
     /* 361575 */     GIR_EraseRootFromParent_Done,
     /* 361576 */   // Label 7218: @361576
     /* 361576 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(361697), // Rule ID 4270 //
     /* 361581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361595 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361601 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361611 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361614 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361618 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361625 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361635 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 361642 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 361642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 361649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361664 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361691 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361696 */     // GIR_Coverage, 4270,
     /* 361696 */     GIR_EraseRootFromParent_Done,
     /* 361697 */   // Label 7219: @361697
     /* 361697 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(361818), // Rule ID 4271 //
     /* 361702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361716 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361722 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361732 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361735 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361739 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361746 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361756 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 361763 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 361763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 361770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361785 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361817 */     // GIR_Coverage, 4271,
     /* 361817 */     GIR_EraseRootFromParent_Done,
     /* 361818 */   // Label 7220: @361818
     /* 361818 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(361932), // Rule ID 4378 //
     /* 361823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361837 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361843 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361853 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361856 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361860 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361870 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 361877 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 361877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 361884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361899 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361926 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361931 */     // GIR_Coverage, 4378,
     /* 361931 */     GIR_EraseRootFromParent_Done,
     /* 361932 */   // Label 7221: @361932
     /* 361932 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(362046), // Rule ID 4379 //
     /* 361937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361951 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361957 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361967 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361970 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361974 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361978 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361984 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 361991 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 361991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 361998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362013 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362045 */     // GIR_Coverage, 4379,
     /* 362045 */     GIR_EraseRootFromParent_Done,
     /* 362046 */   // Label 7222: @362046
     /* 362046 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(362163), // Rule ID 4274 //
     /* 362051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362077 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362080 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362084 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362091 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362101 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 362108 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 362108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 362115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362130 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362157 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362162 */     // GIR_Coverage, 4274,
     /* 362162 */     GIR_EraseRootFromParent_Done,
     /* 362163 */   // Label 7223: @362163
     /* 362163 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(362280), // Rule ID 4276 //
     /* 362168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362194 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362197 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362201 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362208 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362218 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 362225 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 362225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 362232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362247 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362274 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362279 */     // GIR_Coverage, 4276,
     /* 362279 */     GIR_EraseRootFromParent_Done,
     /* 362280 */   // Label 7224: @362280
     /* 362280 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(362390), // Rule ID 4382 //
     /* 362285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362311 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362314 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362318 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362322 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362326 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362328 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 362335 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 362335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 362342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362357 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362379 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362389 */     // GIR_Coverage, 4382,
     /* 362389 */     GIR_EraseRootFromParent_Done,
     /* 362390 */   // Label 7225: @362390
     /* 362390 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(362500), // Rule ID 4384 //
     /* 362395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362421 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362424 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362428 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362438 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 362445 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 362445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 362452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362467 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362494 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362499 */     // GIR_Coverage, 4384,
     /* 362499 */     GIR_EraseRootFromParent_Done,
     /* 362500 */   // Label 7226: @362500
     /* 362500 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(362630), // Rule ID 6501 //
     /* 362505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362534 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362537 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362541 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 362548 */     // MIs[2] Rn
     /* 362548 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 362552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 362557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362563 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 362563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 362566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 362570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 362577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 362584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362589 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362592 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 362595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 362599 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362612 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362629 */     // GIR_Coverage, 6501,
     /* 362629 */     GIR_EraseRootFromParent_Done,
     /* 362630 */   // Label 7227: @362630
     /* 362630 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(362770), // Rule ID 5754 //
     /* 362635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362678 */     // MIs[2] Operand 1
     /* 362678 */     // No operand predicates
     /* 362678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 362682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362686 */     // MIs[3] Operand 1
     /* 362686 */     // No operand predicates
     /* 362686 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362688 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 362688 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 362691 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362695 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362700 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 362703 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 362707 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 362710 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362715 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 362727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362732 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 362738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 362745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362752 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362764 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362769 */     // GIR_Coverage, 5754,
     /* 362769 */     GIR_EraseRootFromParent_Done,
     /* 362770 */   // Label 7228: @362770
     /* 362770 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(362941), // Rule ID 5755 //
     /* 362775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 362801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362818 */     // MIs[2] Operand 1
     /* 362818 */     // No operand predicates
     /* 362818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 362822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362826 */     // MIs[3] Operand 1
     /* 362826 */     // No operand predicates
     /* 362826 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362828 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 362828 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 362831 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362835 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362840 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 362843 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 362847 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 362850 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362855 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362860 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 362863 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362867 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362872 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 362875 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 362879 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 362882 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362887 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 362895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 362899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362904 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 362907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 362910 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 362913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 362916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362923 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 362930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362940 */     // GIR_Coverage, 5755,
     /* 362940 */     GIR_EraseRootFromParent_Done,
     /* 362941 */   // Label 7229: @362941
     /* 362941 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(363081), // Rule ID 5794 //
     /* 362946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 362968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 362976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 362985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362989 */     // MIs[2] Operand 1
     /* 362989 */     // No operand predicates
     /* 362989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 362993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362997 */     // MIs[3] Operand 1
     /* 362997 */     // No operand predicates
     /* 362997 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 362999 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 362999 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 363002 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363006 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363011 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 363014 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 363018 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363021 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363026 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 363038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363043 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 363049 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 363053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 363056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363063 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363080 */     // GIR_Coverage, 5794,
     /* 363080 */     GIR_EraseRootFromParent_Done,
     /* 363081 */   // Label 7230: @363081
     /* 363081 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(363252), // Rule ID 5795 //
     /* 363086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 363112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363129 */     // MIs[2] Operand 1
     /* 363129 */     // No operand predicates
     /* 363129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 363133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363137 */     // MIs[3] Operand 1
     /* 363137 */     // No operand predicates
     /* 363137 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363139 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 363139 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 363142 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363146 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363151 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 363154 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 363158 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 363161 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363166 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363171 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 363174 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363178 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363183 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 363186 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 363190 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363193 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 363210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363215 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 363221 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 363224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 363227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363234 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363251 */     // GIR_Coverage, 5795,
     /* 363251 */     GIR_EraseRootFromParent_Done,
     /* 363252 */   // Label 7231: @363252
     /* 363252 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(363331), // Rule ID 5707 //
     /* 363257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363279 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363285 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 363285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363297 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 363301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 363320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363330 */     // GIR_Coverage, 5707,
     /* 363330 */     GIR_EraseRootFromParent_Done,
     /* 363331 */   // Label 7232: @363331
     /* 363331 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(363407), // Rule ID 5709 //
     /* 363336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363358 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363364 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 363364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 363367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363406 */     // GIR_Coverage, 5709,
     /* 363406 */     GIR_EraseRootFromParent_Done,
     /* 363407 */   // Label 7233: @363407
     /* 363407 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(363483), // Rule ID 5719 //
     /* 363412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363440 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 363440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 363443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 363464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363482 */     // GIR_Coverage, 5719,
     /* 363482 */     GIR_EraseRootFromParent_Done,
     /* 363483 */   // Label 7234: @363483
     /* 363483 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(363628), // Rule ID 5731 //
     /* 363488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 363510 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 363514 */     // MIs[1] Operand 1
     /* 363514 */     // No operand predicates
     /* 363514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 363518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363526 */     // MIs[2] Operand 1
     /* 363526 */     // No operand predicates
     /* 363526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363528 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 363528 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 363531 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363535 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 363542 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 363545 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363549 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363554 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 363557 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 363561 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363564 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363569 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363574 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 363586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363591 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 363597 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363610 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363627 */     // GIR_Coverage, 5731,
     /* 363627 */     GIR_EraseRootFromParent_Done,
     /* 363628 */   // Label 7235: @363628
     /* 363628 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(363777), // Rule ID 6505 //
     /* 363633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363655 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363658 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 363662 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 363669 */     // MIs[1] Rn
     /* 363669 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 363673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 363678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 363682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363686 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363690 */     // MIs[2] Operand 1
     /* 363690 */     // No operand predicates
     /* 363690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363692 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 363692 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 363695 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363699 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363704 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 363707 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 363711 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363714 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363719 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 363731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363736 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 363742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 363746 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363759 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363776 */     // GIR_Coverage, 6505,
     /* 363776 */     GIR_EraseRootFromParent_Done,
     /* 363777 */   // Label 7236: @363777
     /* 363777 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(363919), // Rule ID 6508 //
     /* 363782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363804 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363807 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 363811 */     // MIs[1] Rn
     /* 363811 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 363815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 363820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 363824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363828 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 363832 */     // MIs[2] Operand 1
     /* 363832 */     // No operand predicates
     /* 363832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363834 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 363834 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 363837 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363841 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363846 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 363849 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 363853 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363856 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363861 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 363873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363878 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 363884 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 363888 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363901 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363918 */     // GIR_Coverage, 6508,
     /* 363918 */     GIR_EraseRootFromParent_Done,
     /* 363919 */   // Label 7237: @363919
     /* 363919 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(364107), // Rule ID 5729 //
     /* 363924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 363946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 363954 */     // MIs[1] Operand 1
     /* 363954 */     // No operand predicates
     /* 363954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363956 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 363956 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 363959 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363963 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 363970 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 363973 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 363977 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363982 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 363985 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 363989 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 363992 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363997 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364002 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364007 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 364010 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364014 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364021 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 364024 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364028 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364033 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 364036 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 364040 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 364043 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364048 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364053 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 364065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364070 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 364076 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 364079 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 364082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364089 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364096 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364106 */     // GIR_Coverage, 5729,
     /* 364106 */     GIR_EraseRootFromParent_Done,
     /* 364107 */   // Label 7238: @364107
     /* 364107 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(364242), // Rule ID 5740 //
     /* 364112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 364130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 364134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 364142 */     // MIs[1] Operand 1
     /* 364142 */     // No operand predicates
     /* 364142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364144 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 364144 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 364147 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364151 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364158 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 364161 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364165 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364170 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 364173 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 364177 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 364180 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364185 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364190 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 364202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364207 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 364213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 364217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364224 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364241 */     // GIR_Coverage, 5740,
     /* 364241 */     GIR_EraseRootFromParent_Done,
     /* 364242 */   // Label 7239: @364242
     /* 364242 */   GIM_Reject,
     /* 364243 */ // Label 7210: @364243
     /* 364243 */ GIM_Reject,
     /* 364244 */ // Label 7123: @364244
     /* 364244 */ GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(367311),
     /* 364249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 364252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364255 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364262 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(364371), // Rule ID 4296 //
     /* 364267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364271 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364277 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364287 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364290 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364294 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364304 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 364311 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 364318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364338 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364370 */     // GIR_Coverage, 4296,
     /* 364370 */     GIR_EraseRootFromParent_Done,
     /* 364371 */   // Label 7241: @364371
     /* 364371 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(364480), // Rule ID 4297 //
     /* 364376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364380 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364386 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364396 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364399 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364403 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364413 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 364420 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 364427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364447 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364479 */     // GIR_Coverage, 4297,
     /* 364479 */     GIR_EraseRootFromParent_Done,
     /* 364480 */   // Label 7242: @364480
     /* 364480 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(364589), // Rule ID 4404 //
     /* 364485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364489 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364495 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364505 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364508 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364512 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364522 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 364529 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 364536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364556 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364578 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364588 */     // GIR_Coverage, 4404,
     /* 364588 */     GIR_EraseRootFromParent_Done,
     /* 364589 */   // Label 7243: @364589
     /* 364589 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(364698), // Rule ID 4405 //
     /* 364594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364598 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364604 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364614 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364617 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364621 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 364638 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 364645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364665 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364697 */     // GIR_Coverage, 4405,
     /* 364697 */     GIR_EraseRootFromParent_Done,
     /* 364698 */   // Label 7244: @364698
     /* 364698 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(364803), // Rule ID 4302 //
     /* 364703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364719 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364722 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364726 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364736 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 364743 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 364750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364770 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364802 */     // GIR_Coverage, 4302,
     /* 364802 */     GIR_EraseRootFromParent_Done,
     /* 364803 */   // Label 7245: @364803
     /* 364803 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(364908), // Rule ID 4304 //
     /* 364808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364824 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364827 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364831 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364835 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364841 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 364848 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 364855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364875 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364907 */     // GIR_Coverage, 4304,
     /* 364907 */     GIR_EraseRootFromParent_Done,
     /* 364908 */   // Label 7246: @364908
     /* 364908 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(365013), // Rule ID 4410 //
     /* 364913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364929 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364932 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364936 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364946 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 364953 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 364953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 364956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 364960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 364970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 364975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 364980 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365012 */     // GIR_Coverage, 4410,
     /* 365012 */     GIR_EraseRootFromParent_Done,
     /* 365013 */   // Label 7247: @365013
     /* 365013 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(365118), // Rule ID 4412 //
     /* 365018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365034 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365037 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365041 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365045 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365051 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 365058 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 365065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365085 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365107 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365117 */     // GIR_Coverage, 4412,
     /* 365117 */     GIR_EraseRootFromParent_Done,
     /* 365118 */   // Label 7248: @365118
     /* 365118 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(365222), // Rule ID 4294 //
     /* 365123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365127 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365133 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365143 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365146 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365150 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365160 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 365167 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 365167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 365174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365189 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365221 */     // GIR_Coverage, 4294,
     /* 365221 */     GIR_EraseRootFromParent_Done,
     /* 365222 */   // Label 7249: @365222
     /* 365222 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(365326), // Rule ID 4295 //
     /* 365227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365231 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365237 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365247 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365250 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365254 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365264 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 365271 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 365271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 365278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365293 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365325 */     // GIR_Coverage, 4295,
     /* 365325 */     GIR_EraseRootFromParent_Done,
     /* 365326 */   // Label 7250: @365326
     /* 365326 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(365430), // Rule ID 4402 //
     /* 365331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365335 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365341 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365351 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365354 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365358 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365362 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365368 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 365375 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 365375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 365382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365397 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365429 */     // GIR_Coverage, 4402,
     /* 365429 */     GIR_EraseRootFromParent_Done,
     /* 365430 */   // Label 7251: @365430
     /* 365430 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(365534), // Rule ID 4403 //
     /* 365435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365439 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365445 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365455 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365458 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365462 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365466 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365472 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 365479 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 365479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 365486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365501 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365533 */     // GIR_Coverage, 4403,
     /* 365533 */     GIR_EraseRootFromParent_Done,
     /* 365534 */   // Label 7252: @365534
     /* 365534 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(365634), // Rule ID 4298 //
     /* 365539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365547 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365551 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365555 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365558 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365562 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365566 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365572 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 365579 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 365579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 365586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365601 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365633 */     // GIR_Coverage, 4298,
     /* 365633 */     GIR_EraseRootFromParent_Done,
     /* 365634 */   // Label 7253: @365634
     /* 365634 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(365734), // Rule ID 4300 //
     /* 365639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365655 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365658 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365662 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365666 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365672 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 365679 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 365679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 365686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365701 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365733 */     // GIR_Coverage, 4300,
     /* 365733 */     GIR_EraseRootFromParent_Done,
     /* 365734 */   // Label 7254: @365734
     /* 365734 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(365834), // Rule ID 4406 //
     /* 365739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365755 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365758 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365762 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365772 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 365779 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 365779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 365786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365801 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365833 */     // GIR_Coverage, 4406,
     /* 365833 */     GIR_EraseRootFromParent_Done,
     /* 365834 */   // Label 7255: @365834
     /* 365834 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(365934), // Rule ID 4408 //
     /* 365839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365855 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365858 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365862 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365872 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 365879 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 365879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 365886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365901 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365923 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365933 */     // GIR_Coverage, 4408,
     /* 365933 */     GIR_EraseRootFromParent_Done,
     /* 365934 */   // Label 7256: @365934
     /* 365934 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(366047), // Rule ID 5760 //
     /* 365939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365955 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 365959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 365963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365968 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 365972 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365976 */     // MIs[3] Operand 1
     /* 365976 */     // No operand predicates
     /* 365976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365980 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 365982 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 365982 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 365985 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 365989 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365994 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 365998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 366001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 366028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366046 */     // GIR_Coverage, 5760,
     /* 366046 */     GIR_EraseRootFromParent_Done,
     /* 366047 */   // Label 7257: @366047
     /* 366047 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(366160), // Rule ID 5800 //
     /* 366052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 366085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366089 */     // MIs[3] Operand 1
     /* 366089 */     // No operand predicates
     /* 366089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366093 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366095 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 366095 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 366098 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 366102 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366107 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 366111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 366114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 366141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366154 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366159 */     // GIR_Coverage, 5800,
     /* 366159 */     GIR_EraseRootFromParent_Done,
     /* 366160 */   // Label 7258: @366160
     /* 366160 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(366238), // Rule ID 1940 //
     /* 366165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366201 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366205 */     // MIs[2] Operand 1
     /* 366205 */     // No operand predicates
     /* 366205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 366209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366213 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366217 */     // MIs[3] Operand 1
     /* 366217 */     // No operand predicates
     /* 366217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366219 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 366219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 366226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 366229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 366236 */     GIR_RootConstrainSelectedInstOperands,
     /* 366237 */     // GIR_Coverage, 1940,
     /* 366237 */     GIR_EraseRootFromParent_Done,
     /* 366238 */   // Label 7259: @366238
     /* 366238 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(366327), // Rule ID 5757 //
     /* 366243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 366255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366267 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366271 */     // MIs[2] Operand 1
     /* 366271 */     // No operand predicates
     /* 366271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 366275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366279 */     // MIs[3] Operand 1
     /* 366279 */     // No operand predicates
     /* 366279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366281 */     // (vector_insert:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4f32] } ZPR:{ *:[nxv4f32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 366281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366293 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 366299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 366319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 366325 */     GIR_RootConstrainSelectedInstOperands,
     /* 366326 */     // GIR_Coverage, 5757,
     /* 366326 */     GIR_EraseRootFromParent_Done,
     /* 366327 */   // Label 7260: @366327
     /* 366327 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(366416), // Rule ID 5797 //
     /* 366332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 366344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366356 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366360 */     // MIs[2] Operand 1
     /* 366360 */     // No operand predicates
     /* 366360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 366364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366368 */     // MIs[3] Operand 1
     /* 366368 */     // No operand predicates
     /* 366368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366370 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 366370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366382 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 366388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 366408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 366414 */     GIR_RootConstrainSelectedInstOperands,
     /* 366415 */     // GIR_Coverage, 5797,
     /* 366415 */     GIR_EraseRootFromParent_Done,
     /* 366416 */   // Label 7261: @366416
     /* 366416 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(366483), // Rule ID 5759 //
     /* 366421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366454 */     // MIs[2] Operand 1
     /* 366454 */     // No operand predicates
     /* 366454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 366458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366462 */     // MIs[3] Operand 1
     /* 366462 */     // No operand predicates
     /* 366462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366464 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 366464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366469 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 366471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 366474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 366481 */     GIR_RootConstrainSelectedInstOperands,
     /* 366482 */     // GIR_Coverage, 5759,
     /* 366482 */     GIR_EraseRootFromParent_Done,
     /* 366483 */   // Label 7262: @366483
     /* 366483 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(366581), // Rule ID 5761 //
     /* 366488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 366504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366521 */     // MIs[2] Operand 1
     /* 366521 */     // No operand predicates
     /* 366521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 366525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366529 */     // MIs[3] Operand 1
     /* 366529 */     // No operand predicates
     /* 366529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366531 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 366531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366543 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 366546 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366550 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 366553 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366558 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366568 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 366570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 366573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 366579 */     GIR_RootConstrainSelectedInstOperands,
     /* 366580 */     // GIR_Coverage, 5761,
     /* 366580 */     GIR_EraseRootFromParent_Done,
     /* 366581 */   // Label 7263: @366581
     /* 366581 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(366648), // Rule ID 5799 //
     /* 366586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366619 */     // MIs[2] Operand 1
     /* 366619 */     // No operand predicates
     /* 366619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 366623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366627 */     // MIs[3] Operand 1
     /* 366627 */     // No operand predicates
     /* 366627 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366629 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 366629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366634 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 366636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 366639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 366646 */     GIR_RootConstrainSelectedInstOperands,
     /* 366647 */     // GIR_Coverage, 5799,
     /* 366647 */     GIR_EraseRootFromParent_Done,
     /* 366648 */   // Label 7264: @366648
     /* 366648 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(366746), // Rule ID 5801 //
     /* 366653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 366669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366686 */     // MIs[2] Operand 1
     /* 366686 */     // No operand predicates
     /* 366686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 366690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366694 */     // MIs[3] Operand 1
     /* 366694 */     // No operand predicates
     /* 366694 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366696 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 366696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366708 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 366711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366715 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 366718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 366728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366733 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 366735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 366738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 366744 */     GIR_RootConstrainSelectedInstOperands,
     /* 366745 */     // GIR_Coverage, 5801,
     /* 366745 */     GIR_EraseRootFromParent_Done,
     /* 366746 */   // Label 7265: @366746
     /* 366746 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(366812), // Rule ID 5715 //
     /* 366751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366769 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 366769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 366793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366806 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366811 */     // GIR_Coverage, 5715,
     /* 366811 */     GIR_EraseRootFromParent_Done,
     /* 366812 */   // Label 7266: @366812
     /* 366812 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(366878), // Rule ID 5723 //
     /* 366817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366835 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 366835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 366859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366877 */     // GIR_Coverage, 5723,
     /* 366877 */     GIR_EraseRootFromParent_Done,
     /* 366878 */   // Label 7267: @366878
     /* 366878 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(366931), // Rule ID 5732 //
     /* 366883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 366895 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 366899 */     // MIs[1] Operand 1
     /* 366899 */     // No operand predicates
     /* 366899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366907 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366911 */     // MIs[2] Operand 1
     /* 366911 */     // No operand predicates
     /* 366911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366913 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 366913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 366916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 366920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 366923 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 366929 */     GIR_RootConstrainSelectedInstOperands,
     /* 366930 */     // GIR_Coverage, 5732,
     /* 366930 */     GIR_EraseRootFromParent_Done,
     /* 366931 */   // Label 7268: @366931
     /* 366931 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(367000), // Rule ID 6486 //
     /* 366936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366948 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 366955 */     // MIs[1] Rn
     /* 366955 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 366959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 366964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 366968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366972 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366976 */     // MIs[2] Operand 1
     /* 366976 */     // No operand predicates
     /* 366976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366978 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 366978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 366981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366983 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 366985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 366988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366998 */     GIR_RootConstrainSelectedInstOperands,
     /* 366999 */     // GIR_Coverage, 6486,
     /* 366999 */     GIR_EraseRootFromParent_Done,
     /* 367000 */   // Label 7269: @367000
     /* 367000 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(367069), // Rule ID 6487 //
     /* 367005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367017 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367020 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 367024 */     // MIs[1] Rn
     /* 367024 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 367028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 367033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 367037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367041 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367045 */     // MIs[2] Operand 1
     /* 367045 */     // No operand predicates
     /* 367045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367047 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 367047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 367050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 367054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 367057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367067 */     GIR_RootConstrainSelectedInstOperands,
     /* 367068 */     // GIR_Coverage, 6487,
     /* 367068 */     GIR_EraseRootFromParent_Done,
     /* 367069 */   // Label 7270: @367069
     /* 367069 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(367170), // Rule ID 5812 //
     /* 367074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 367082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 367095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367099 */     // MIs[2] Operand 1
     /* 367099 */     // No operand predicates
     /* 367099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367101 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 367101 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 367104 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367108 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 367115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 367118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367127 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 367130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 367134 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 367137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367157 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 367159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 367162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367168 */     GIR_RootConstrainSelectedInstOperands,
     /* 367169 */     // GIR_Coverage, 5812,
     /* 367169 */     GIR_EraseRootFromParent_Done,
     /* 367170 */   // Label 7271: @367170
     /* 367170 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(367214), // Rule ID 1936 //
     /* 367175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 367190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367198 */     // MIs[1] Operand 1
     /* 367198 */     // No operand predicates
     /* 367198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367200 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 367200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 367203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 367207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 367210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 367212 */     GIR_RootConstrainSelectedInstOperands,
     /* 367213 */     // GIR_Coverage, 1936,
     /* 367213 */     GIR_EraseRootFromParent_Done,
     /* 367214 */   // Label 7272: @367214
     /* 367214 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(367310), // Rule ID 5737 //
     /* 367219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 367231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367239 */     // MIs[1] Operand 1
     /* 367239 */     // No operand predicates
     /* 367239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367241 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 367241 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 367244 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367248 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 367255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 367258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367267 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 367270 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 367274 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 367277 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367282 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 367302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367308 */     GIR_RootConstrainSelectedInstOperands,
     /* 367309 */     // GIR_Coverage, 5737,
     /* 367309 */     GIR_EraseRootFromParent_Done,
     /* 367310 */   // Label 7273: @367310
     /* 367310 */   GIM_Reject,
     /* 367311 */ // Label 7240: @367311
     /* 367311 */ GIM_Reject,
     /* 367312 */ // Label 7124: @367312
     /* 367312 */ GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(370524),
     /* 367317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 367320 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(367439), // Rule ID 4200 //
     /* 367325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367339 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367345 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367355 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367358 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367362 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367366 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367372 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 367379 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 367386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367406 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367428 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367433 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367438 */     // GIR_Coverage, 4200,
     /* 367438 */     GIR_EraseRootFromParent_Done,
     /* 367439 */   // Label 7275: @367439
     /* 367439 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(367558), // Rule ID 4201 //
     /* 367444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367458 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367464 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367474 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367477 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367481 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367491 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 367498 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 367505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367525 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367557 */     // GIR_Coverage, 4201,
     /* 367557 */     GIR_EraseRootFromParent_Done,
     /* 367558 */   // Label 7276: @367558
     /* 367558 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(367684), // Rule ID 4236 //
     /* 367563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367577 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367583 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367593 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367596 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367600 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 367607 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367617 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 367624 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 367631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367651 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367673 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367683 */     // GIR_Coverage, 4236,
     /* 367683 */     GIR_EraseRootFromParent_Done,
     /* 367684 */   // Label 7277: @367684
     /* 367684 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(367810), // Rule ID 4237 //
     /* 367689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 367692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367703 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 367709 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 367711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367719 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367722 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367726 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 367733 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367743 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 367750 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 367757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367777 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367799 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367809 */     // GIR_Coverage, 4237,
     /* 367809 */     GIR_EraseRootFromParent_Done,
     /* 367810 */   // Label 7278: @367810
     /* 367810 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(367925), // Rule ID 4206 //
     /* 367815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367841 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367848 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 367865 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 367872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 367887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 367892 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 367914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 367924 */     // GIR_Coverage, 4206,
     /* 367924 */     GIR_EraseRootFromParent_Done,
     /* 367925 */   // Label 7279: @367925
     /* 367925 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(368040), // Rule ID 4208 //
     /* 367930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 367933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 367936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 367952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367956 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367959 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 367963 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 367967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 367980 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 367980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 367983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 367987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 367997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368007 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368029 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368039 */     // GIR_Coverage, 4208,
     /* 368039 */     GIR_EraseRootFromParent_Done,
     /* 368040 */   // Label 7280: @368040
     /* 368040 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(368162), // Rule ID 4242 //
     /* 368045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368071 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368074 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368078 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368085 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368095 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 368102 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 368109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368129 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368161 */     // GIR_Coverage, 4242,
     /* 368161 */     GIR_EraseRootFromParent_Done,
     /* 368162 */   // Label 7281: @368162
     /* 368162 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(368284), // Rule ID 4244 //
     /* 368167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368193 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368196 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368200 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368207 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368217 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 368224 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 368231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368251 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368283 */     // GIR_Coverage, 4244,
     /* 368283 */     GIR_EraseRootFromParent_Done,
     /* 368284 */   // Label 7282: @368284
     /* 368284 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(368398), // Rule ID 4198 //
     /* 368289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368303 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 368309 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 368311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368319 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368322 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368326 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368330 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 368343 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 368343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 368350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368365 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368397 */     // GIR_Coverage, 4198,
     /* 368397 */     GIR_EraseRootFromParent_Done,
     /* 368398 */   // Label 7283: @368398
     /* 368398 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(368512), // Rule ID 4199 //
     /* 368403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368417 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 368423 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 368425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368433 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368436 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368440 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 368457 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 368457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 368464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368479 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368501 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368511 */     // GIR_Coverage, 4199,
     /* 368511 */     GIR_EraseRootFromParent_Done,
     /* 368512 */   // Label 7284: @368512
     /* 368512 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(368633), // Rule ID 4234 //
     /* 368517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368531 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 368537 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 368539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368547 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368550 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368554 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368561 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368565 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368571 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 368578 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 368578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 368585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368600 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368632 */     // GIR_Coverage, 4234,
     /* 368632 */     GIR_EraseRootFromParent_Done,
     /* 368633 */   // Label 7285: @368633
     /* 368633 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(368754), // Rule ID 4235 //
     /* 368638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368652 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 368658 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 368660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368668 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368671 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368675 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368682 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368692 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 368699 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 368699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 368706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368721 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368743 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368748 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368753 */     // GIR_Coverage, 4235,
     /* 368753 */     GIR_EraseRootFromParent_Done,
     /* 368754 */   // Label 7286: @368754
     /* 368754 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(368864), // Rule ID 4202 //
     /* 368759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368785 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368788 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368792 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368802 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 368809 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 368809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 368816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368831 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368858 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368863 */     // GIR_Coverage, 4202,
     /* 368863 */     GIR_EraseRootFromParent_Done,
     /* 368864 */   // Label 7287: @368864
     /* 368864 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(368974), // Rule ID 4204 //
     /* 368869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368895 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368898 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368902 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368912 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 368919 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 368919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 368926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 368941 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368973 */     // GIR_Coverage, 4204,
     /* 368973 */     GIR_EraseRootFromParent_Done,
     /* 368974 */   // Label 7288: @368974
     /* 368974 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(369091), // Rule ID 4238 //
     /* 368979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369005 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369008 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369012 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369019 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369023 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369029 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 369036 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 369036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 369043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369058 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369090 */     // GIR_Coverage, 4238,
     /* 369090 */     GIR_EraseRootFromParent_Done,
     /* 369091 */   // Label 7289: @369091
     /* 369091 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(369208), // Rule ID 4240 //
     /* 369096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 369114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369122 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369125 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369129 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369136 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369146 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 369153 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 369153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 369160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369175 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369197 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369202 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369207 */     // GIR_Coverage, 4240,
     /* 369207 */     GIR_EraseRootFromParent_Done,
     /* 369208 */   // Label 7290: @369208
     /* 369208 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(369348), // Rule ID 5778 //
     /* 369213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 369239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369256 */     // MIs[2] Operand 1
     /* 369256 */     // No operand predicates
     /* 369256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 369260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369264 */     // MIs[3] Operand 1
     /* 369264 */     // No operand predicates
     /* 369264 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369266 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 369266 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 369269 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369273 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369278 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 369281 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369285 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369288 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369293 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 369305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369310 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 369316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 369323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369330 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369347 */     // GIR_Coverage, 5778,
     /* 369347 */     GIR_EraseRootFromParent_Done,
     /* 369348 */   // Label 7291: @369348
     /* 369348 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(369519), // Rule ID 5779 //
     /* 369353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 369379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369396 */     // MIs[2] Operand 1
     /* 369396 */     // No operand predicates
     /* 369396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 369400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369404 */     // MIs[3] Operand 1
     /* 369404 */     // No operand predicates
     /* 369404 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369406 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 369406 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 369409 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369413 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369418 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 369421 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369425 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 369428 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369433 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369438 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369441 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369445 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369450 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 369453 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369457 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369460 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369465 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 369477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369482 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 369488 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 369491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 369494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369501 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369518 */     // GIR_Coverage, 5779,
     /* 369518 */     GIR_EraseRootFromParent_Done,
     /* 369519 */   // Label 7292: @369519
     /* 369519 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(369659), // Rule ID 5786 //
     /* 369524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 369550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369567 */     // MIs[2] Operand 1
     /* 369567 */     // No operand predicates
     /* 369567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 369571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369575 */     // MIs[3] Operand 1
     /* 369575 */     // No operand predicates
     /* 369575 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369577 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 369577 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 369580 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369584 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369589 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 369592 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369596 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369599 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369604 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 369616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369621 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 369627 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 369634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369641 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369653 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369658 */     // GIR_Coverage, 5786,
     /* 369658 */     GIR_EraseRootFromParent_Done,
     /* 369659 */   // Label 7293: @369659
     /* 369659 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(369830), // Rule ID 5787 //
     /* 369664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 369690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369707 */     // MIs[2] Operand 1
     /* 369707 */     // No operand predicates
     /* 369707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 369711 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369715 */     // MIs[3] Operand 1
     /* 369715 */     // No operand predicates
     /* 369715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369717 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 369717 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 369720 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369724 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369729 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 369732 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 369736 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 369739 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369744 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369749 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369752 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369756 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369761 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 369764 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369768 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369771 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369776 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 369788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369793 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 369799 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 369802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 369805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369812 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 369819 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369829 */     // GIR_Coverage, 5787,
     /* 369829 */     GIR_EraseRootFromParent_Done,
     /* 369830 */   // Label 7294: @369830
     /* 369830 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(369909), // Rule ID 5702 //
     /* 369835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 369853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 369857 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 369863 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 369863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 369866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369875 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 369879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 369898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369908 */     // GIR_Coverage, 5702,
     /* 369908 */     GIR_EraseRootFromParent_Done,
     /* 369909 */   // Label 7295: @369909
     /* 369909 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(370051), // Rule ID 6503 //
     /* 369914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369936 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369939 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 369943 */     // MIs[1] Rn
     /* 369943 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 369947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 369952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 369956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 369964 */     // MIs[2] Operand 1
     /* 369964 */     // No operand predicates
     /* 369964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369966 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 369966 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369969 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369973 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369978 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 369981 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 369985 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369988 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369993 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 370005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370010 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 370016 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370020 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370033 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370050 */     // GIR_Coverage, 6503,
     /* 370050 */     GIR_EraseRootFromParent_Done,
     /* 370051 */   // Label 7296: @370051
     /* 370051 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(370200), // Rule ID 6504 //
     /* 370056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370078 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370081 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 370085 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 370092 */     // MIs[1] Rn
     /* 370092 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 370096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 370101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 370105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370109 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 370113 */     // MIs[2] Operand 1
     /* 370113 */     // No operand predicates
     /* 370113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370115 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 370115 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 370118 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370122 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370127 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 370130 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 370134 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370137 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370142 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 370154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370159 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 370165 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370169 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370182 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370194 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370199 */     // GIR_Coverage, 6504,
     /* 370199 */     GIR_EraseRootFromParent_Done,
     /* 370200 */   // Label 7297: @370200
     /* 370200 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(370335), // Rule ID 5741 //
     /* 370205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 370223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 370227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 370235 */     // MIs[1] Operand 1
     /* 370235 */     // No operand predicates
     /* 370235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370237 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 370237 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 370240 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370244 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 370251 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 370254 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370258 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370263 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 370266 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 370270 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370273 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370278 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 370295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370300 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 370306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 370310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370317 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370334 */     // GIR_Coverage, 5741,
     /* 370334 */     GIR_EraseRootFromParent_Done,
     /* 370335 */   // Label 7298: @370335
     /* 370335 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(370523), // Rule ID 5742 //
     /* 370340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 370343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 370362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 370370 */     // MIs[1] Operand 1
     /* 370370 */     // No operand predicates
     /* 370370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370372 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 370372 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 370375 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370379 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 370386 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 370389 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370393 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370398 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 370401 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 370405 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 370408 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370413 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370418 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 370423 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 370426 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370430 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 370437 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 370440 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370444 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370449 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 370452 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 370456 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370459 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370464 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370469 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 370481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370486 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 370492 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 370495 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 370498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370505 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370512 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370522 */     // GIR_Coverage, 5742,
     /* 370522 */     GIR_EraseRootFromParent_Done,
     /* 370523 */   // Label 7299: @370523
     /* 370523 */   GIM_Reject,
     /* 370524 */ // Label 7274: @370524
     /* 370524 */ GIM_Reject,
     /* 370525 */ // Label 7125: @370525
     /* 370525 */ GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(373943),
     /* 370530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370533 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(370659), // Rule ID 4260 //
     /* 370538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370552 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370558 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370568 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370571 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370575 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 370582 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370592 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 370599 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 370606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370626 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370653 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370658 */     // GIR_Coverage, 4260,
     /* 370658 */     GIR_EraseRootFromParent_Done,
     /* 370659 */   // Label 7301: @370659
     /* 370659 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(370785), // Rule ID 4261 //
     /* 370664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370678 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370684 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370694 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370697 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370701 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 370708 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370718 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 370725 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 370732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370752 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370784 */     // GIR_Coverage, 4261,
     /* 370784 */     GIR_EraseRootFromParent_Done,
     /* 370785 */   // Label 7302: @370785
     /* 370785 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(370904), // Rule ID 4368 //
     /* 370790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370804 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370810 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370820 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370827 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370837 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 370844 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 370851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370871 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 370893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370903 */     // GIR_Coverage, 4368,
     /* 370903 */     GIR_EraseRootFromParent_Done,
     /* 370904 */   // Label 7303: @370904
     /* 370904 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(371023), // Rule ID 4369 //
     /* 370909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370923 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 370929 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 370931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370939 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 370946 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 370950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 370963 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 370963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 370966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 370970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 370980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 370985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 370990 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371022 */     // GIR_Coverage, 4369,
     /* 371022 */     GIR_EraseRootFromParent_Done,
     /* 371023 */   // Label 7304: @371023
     /* 371023 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(371145), // Rule ID 4266 //
     /* 371028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371054 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371057 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371061 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371068 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371078 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 371085 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 371092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371112 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371134 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371139 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371144 */     // GIR_Coverage, 4266,
     /* 371144 */     GIR_EraseRootFromParent_Done,
     /* 371145 */   // Label 7305: @371145
     /* 371145 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(371267), // Rule ID 4268 //
     /* 371150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371176 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371179 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371183 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371190 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371200 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 371207 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 371214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371234 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371266 */     // GIR_Coverage, 4268,
     /* 371266 */     GIR_EraseRootFromParent_Done,
     /* 371267 */   // Label 7306: @371267
     /* 371267 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(371382), // Rule ID 4374 //
     /* 371272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371298 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371305 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371315 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 371322 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 371329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371349 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371381 */     // GIR_Coverage, 4374,
     /* 371381 */     GIR_EraseRootFromParent_Done,
     /* 371382 */   // Label 7307: @371382
     /* 371382 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(371497), // Rule ID 4376 //
     /* 371387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371413 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371416 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371420 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371430 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 371437 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 371444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371464 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371496 */     // GIR_Coverage, 4376,
     /* 371496 */     GIR_EraseRootFromParent_Done,
     /* 371497 */   // Label 7308: @371497
     /* 371497 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(371618), // Rule ID 4258 //
     /* 371502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371516 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 371522 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 371524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371532 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371535 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371539 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371546 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 371563 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 371563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 371570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371585 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371617 */     // GIR_Coverage, 4258,
     /* 371617 */     GIR_EraseRootFromParent_Done,
     /* 371618 */   // Label 7309: @371618
     /* 371618 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(371739), // Rule ID 4259 //
     /* 371623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371637 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 371643 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 371645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371653 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371656 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371660 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371667 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371677 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 371684 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 371684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 371691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371706 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371738 */     // GIR_Coverage, 4259,
     /* 371738 */     GIR_EraseRootFromParent_Done,
     /* 371739 */   // Label 7310: @371739
     /* 371739 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(371853), // Rule ID 4366 //
     /* 371744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371758 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 371764 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 371766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371774 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371777 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371781 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371791 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 371798 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 371798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 371805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371820 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371852 */     // GIR_Coverage, 4366,
     /* 371852 */     GIR_EraseRootFromParent_Done,
     /* 371853 */   // Label 7311: @371853
     /* 371853 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(371967), // Rule ID 4367 //
     /* 371858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371872 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 371878 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 371880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371888 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371895 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371905 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 371912 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 371912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 371919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 371934 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371966 */     // GIR_Coverage, 4367,
     /* 371966 */     GIR_EraseRootFromParent_Done,
     /* 371967 */   // Label 7312: @371967
     /* 371967 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(372084), // Rule ID 4262 //
     /* 371972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371998 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372001 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372005 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372012 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 372029 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 372029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 372036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372051 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372083 */     // GIR_Coverage, 4262,
     /* 372083 */     GIR_EraseRootFromParent_Done,
     /* 372084 */   // Label 7313: @372084
     /* 372084 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(372201), // Rule ID 4264 //
     /* 372089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372115 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372118 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372122 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372129 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372139 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 372146 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 372146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 372153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372168 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372190 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372200 */     // GIR_Coverage, 4264,
     /* 372200 */     GIR_EraseRootFromParent_Done,
     /* 372201 */   // Label 7314: @372201
     /* 372201 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(372311), // Rule ID 4370 //
     /* 372206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372232 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372239 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 372256 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 372256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 372263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372278 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372310 */     // GIR_Coverage, 4370,
     /* 372310 */     GIR_EraseRootFromParent_Done,
     /* 372311 */   // Label 7315: @372311
     /* 372311 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(372421), // Rule ID 4372 //
     /* 372316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372342 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372345 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372349 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372353 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372359 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 372366 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 372366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 372373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372388 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372410 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372415 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372420 */     // GIR_Coverage, 4372,
     /* 372420 */     GIR_EraseRootFromParent_Done,
     /* 372421 */   // Label 7316: @372421
     /* 372421 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(372544), // Rule ID 5752 //
     /* 372426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372473 */     // MIs[3] Operand 1
     /* 372473 */     // No operand predicates
     /* 372473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372477 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372479 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 372479 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 372482 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 372486 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372491 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 372495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 372498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 372500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 372525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372533 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372538 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372543 */     // GIR_Coverage, 5752,
     /* 372543 */     GIR_EraseRootFromParent_Done,
     /* 372544 */   // Label 7317: @372544
     /* 372544 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(372667), // Rule ID 5792 //
     /* 372549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372579 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372596 */     // MIs[3] Operand 1
     /* 372596 */     // No operand predicates
     /* 372596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372602 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 372602 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 372605 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 372609 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372614 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 372618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 372621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 372623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 372648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372666 */     // GIR_Coverage, 5792,
     /* 372666 */     GIR_EraseRootFromParent_Done,
     /* 372667 */   // Label 7318: @372667
     /* 372667 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(372755), // Rule ID 1939 //
     /* 372672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372718 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372722 */     // MIs[2] Operand 1
     /* 372722 */     // No operand predicates
     /* 372722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372730 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372734 */     // MIs[3] Operand 1
     /* 372734 */     // No operand predicates
     /* 372734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372736 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 372736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372741 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 372743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 372750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 372753 */     GIR_RootConstrainSelectedInstOperands,
     /* 372754 */     // GIR_Coverage, 1939,
     /* 372754 */     GIR_EraseRootFromParent_Done,
     /* 372755 */   // Label 7319: @372755
     /* 372755 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(372854), // Rule ID 5749 //
     /* 372760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 372782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372794 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372798 */     // MIs[2] Operand 1
     /* 372798 */     // No operand predicates
     /* 372798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372806 */     // MIs[3] Operand 1
     /* 372806 */     // No operand predicates
     /* 372806 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372808 */     // (vector_insert:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8f16] } ZPR:{ *:[nxv8f16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 372808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372820 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 372826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 372836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372852 */     GIR_RootConstrainSelectedInstOperands,
     /* 372853 */     // GIR_Coverage, 5749,
     /* 372853 */     GIR_EraseRootFromParent_Done,
     /* 372854 */   // Label 7320: @372854
     /* 372854 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(372953), // Rule ID 5789 //
     /* 372859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 372881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372893 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372897 */     // MIs[2] Operand 1
     /* 372897 */     // No operand predicates
     /* 372897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 372901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372905 */     // MIs[3] Operand 1
     /* 372905 */     // No operand predicates
     /* 372905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372907 */     // (vector_insert:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 372907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 372910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372919 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 372925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 372935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 372938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 372945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 372951 */     GIR_RootConstrainSelectedInstOperands,
     /* 372952 */     // GIR_Coverage, 5789,
     /* 372952 */     GIR_EraseRootFromParent_Done,
     /* 372953 */   // Label 7321: @372953
     /* 372953 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(373030), // Rule ID 5751 //
     /* 372958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373001 */     // MIs[2] Operand 1
     /* 373001 */     // No operand predicates
     /* 373001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373009 */     // MIs[3] Operand 1
     /* 373009 */     // No operand predicates
     /* 373009 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373011 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 373011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373016 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 373018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 373021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 373028 */     GIR_RootConstrainSelectedInstOperands,
     /* 373029 */     // GIR_Coverage, 5751,
     /* 373029 */     GIR_EraseRootFromParent_Done,
     /* 373030 */   // Label 7322: @373030
     /* 373030 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(373138), // Rule ID 5753 //
     /* 373035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 373061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373078 */     // MIs[2] Operand 1
     /* 373078 */     // No operand predicates
     /* 373078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373086 */     // MIs[3] Operand 1
     /* 373086 */     // No operand predicates
     /* 373086 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373088 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 373088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373100 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 373103 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373107 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 373110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373115 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373125 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 373127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 373130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 373136 */     GIR_RootConstrainSelectedInstOperands,
     /* 373137 */     // GIR_Coverage, 5753,
     /* 373137 */     GIR_EraseRootFromParent_Done,
     /* 373138 */   // Label 7323: @373138
     /* 373138 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(373215), // Rule ID 5791 //
     /* 373143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373186 */     // MIs[2] Operand 1
     /* 373186 */     // No operand predicates
     /* 373186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373194 */     // MIs[3] Operand 1
     /* 373194 */     // No operand predicates
     /* 373194 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373196 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 373196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373201 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 373203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 373206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 373213 */     GIR_RootConstrainSelectedInstOperands,
     /* 373214 */     // GIR_Coverage, 5791,
     /* 373214 */     GIR_EraseRootFromParent_Done,
     /* 373215 */   // Label 7324: @373215
     /* 373215 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(373323), // Rule ID 5793 //
     /* 373220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 373246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373263 */     // MIs[2] Operand 1
     /* 373263 */     // No operand predicates
     /* 373263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373271 */     // MIs[3] Operand 1
     /* 373271 */     // No operand predicates
     /* 373271 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373273 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 373273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373285 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 373288 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373292 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 373295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373310 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 373312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 373315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 373321 */     GIR_RootConstrainSelectedInstOperands,
     /* 373322 */     // GIR_Coverage, 5793,
     /* 373322 */     GIR_EraseRootFromParent_Done,
     /* 373323 */   // Label 7325: @373323
     /* 373323 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(373402), // Rule ID 5705 //
     /* 373328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 373350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373356 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 373356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 373359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 373372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 373391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373401 */     // GIR_Coverage, 5705,
     /* 373401 */     GIR_EraseRootFromParent_Done,
     /* 373402 */   // Label 7326: @373402
     /* 373402 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(373478), // Rule ID 5711 //
     /* 373407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373435 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 373435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373477 */     // GIR_Coverage, 5711,
     /* 373477 */     GIR_EraseRootFromParent_Done,
     /* 373478 */   // Label 7327: @373478
     /* 373478 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(373554), // Rule ID 5721 //
     /* 373483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373505 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373511 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 373511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373538 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373553 */     // GIR_Coverage, 5721,
     /* 373553 */     GIR_EraseRootFromParent_Done,
     /* 373554 */   // Label 7328: @373554
     /* 373554 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(373617), // Rule ID 5730 //
     /* 373559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 373581 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 373585 */     // MIs[1] Operand 1
     /* 373585 */     // No operand predicates
     /* 373585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 373589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373593 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373597 */     // MIs[2] Operand 1
     /* 373597 */     // No operand predicates
     /* 373597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373599 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 373599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 373602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 373609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 373615 */     GIR_RootConstrainSelectedInstOperands,
     /* 373616 */     // GIR_Coverage, 5730,
     /* 373616 */     GIR_EraseRootFromParent_Done,
     /* 373617 */   // Label 7329: @373617
     /* 373617 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(373703), // Rule ID 6485 //
     /* 373622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373647 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 373651 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 373658 */     // MIs[1] Rn
     /* 373658 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 373662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 373667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 373671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373675 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373679 */     // MIs[2] Operand 1
     /* 373679 */     // No operand predicates
     /* 373679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373681 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 373681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 373684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 373688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373701 */     GIR_RootConstrainSelectedInstOperands,
     /* 373702 */     // GIR_Coverage, 6485,
     /* 373702 */     GIR_EraseRootFromParent_Done,
     /* 373703 */   // Label 7330: @373703
     /* 373703 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(373782), // Rule ID 6490 //
     /* 373708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373730 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373733 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 373737 */     // MIs[1] Rn
     /* 373737 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 373741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 373746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 373750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373754 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373758 */     // MIs[2] Operand 1
     /* 373758 */     // No operand predicates
     /* 373758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373760 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 373760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 373763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 373767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373780 */     GIR_RootConstrainSelectedInstOperands,
     /* 373781 */     // GIR_Coverage, 6490,
     /* 373781 */     GIR_EraseRootFromParent_Done,
     /* 373782 */   // Label 7331: @373782
     /* 373782 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(373836), // Rule ID 1935 //
     /* 373787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 373808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 373812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373820 */     // MIs[1] Operand 1
     /* 373820 */     // No operand predicates
     /* 373820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373822 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 373822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 373825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 373829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 373832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373834 */     GIR_RootConstrainSelectedInstOperands,
     /* 373835 */     // GIR_Coverage, 1935,
     /* 373835 */     GIR_EraseRootFromParent_Done,
     /* 373836 */   // Label 7332: @373836
     /* 373836 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(373942), // Rule ID 5735 //
     /* 373841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 373863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373871 */     // MIs[1] Operand 1
     /* 373871 */     // No operand predicates
     /* 373871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373873 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 373873 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 373876 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373880 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 373887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373899 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 373902 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 373906 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 373909 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 373934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373940 */     GIR_RootConstrainSelectedInstOperands,
     /* 373941 */     // GIR_Coverage, 5735,
     /* 373941 */     GIR_EraseRootFromParent_Done,
     /* 373942 */   // Label 7333: @373942
     /* 373942 */   GIM_Reject,
     /* 373943 */ // Label 7300: @373943
     /* 373943 */ GIM_Reject,
     /* 373944 */ // Label 7126: @373944
     /* 373944 */ GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(377147),
     /* 373949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 373952 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(374071), // Rule ID 4188 //
     /* 373957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 373960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373971 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 373977 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 373979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373987 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373990 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373994 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374004 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 374011 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 374018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374038 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374070 */     // GIR_Coverage, 4188,
     /* 374070 */     GIR_EraseRootFromParent_Done,
     /* 374071 */   // Label 7335: @374071
     /* 374071 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(374190), // Rule ID 4189 //
     /* 374076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374090 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374096 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374106 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374109 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374113 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374123 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 374130 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 374137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374157 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374189 */     // GIR_Coverage, 4189,
     /* 374189 */     GIR_EraseRootFromParent_Done,
     /* 374190 */   // Label 7336: @374190
     /* 374190 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(374316), // Rule ID 4224 //
     /* 374195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374209 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374215 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374225 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374228 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374232 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374239 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374249 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 374256 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 374263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374283 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374315 */     // GIR_Coverage, 4224,
     /* 374315 */     GIR_EraseRootFromParent_Done,
     /* 374316 */   // Label 7337: @374316
     /* 374316 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(374442), // Rule ID 4225 //
     /* 374321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374335 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374341 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374351 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374354 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374358 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374365 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374375 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 374382 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 374389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374409 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374441 */     // GIR_Coverage, 4225,
     /* 374441 */     GIR_EraseRootFromParent_Done,
     /* 374442 */   // Label 7338: @374442
     /* 374442 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(374557), // Rule ID 4194 //
     /* 374447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374473 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374480 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374484 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374490 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 374497 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 374504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374524 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374556 */     // GIR_Coverage, 4194,
     /* 374556 */     GIR_EraseRootFromParent_Done,
     /* 374557 */   // Label 7339: @374557
     /* 374557 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(374672), // Rule ID 4196 //
     /* 374562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374588 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374595 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374605 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 374612 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 374619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374639 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374661 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374671 */     // GIR_Coverage, 4196,
     /* 374671 */     GIR_EraseRootFromParent_Done,
     /* 374672 */   // Label 7340: @374672
     /* 374672 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(374794), // Rule ID 4230 //
     /* 374677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374703 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374706 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374710 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374717 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374727 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 374734 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 374741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374761 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374793 */     // GIR_Coverage, 4230,
     /* 374793 */     GIR_EraseRootFromParent_Done,
     /* 374794 */   // Label 7341: @374794
     /* 374794 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(374916), // Rule ID 4232 //
     /* 374799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374825 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374828 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374832 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374839 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374843 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374849 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 374856 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 374863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374883 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374915 */     // GIR_Coverage, 4232,
     /* 374915 */     GIR_EraseRootFromParent_Done,
     /* 374916 */   // Label 7342: @374916
     /* 374916 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(375030), // Rule ID 4186 //
     /* 374921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374935 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374941 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374951 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374954 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374958 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 374975 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 374975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 374982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 374997 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375029 */     // GIR_Coverage, 4186,
     /* 375029 */     GIR_EraseRootFromParent_Done,
     /* 375030 */   // Label 7343: @375030
     /* 375030 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(375144), // Rule ID 4187 //
     /* 375035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375049 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 375055 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 375057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375065 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375068 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375072 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375080 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 375089 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 375089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 375096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375111 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375143 */     // GIR_Coverage, 4187,
     /* 375143 */     GIR_EraseRootFromParent_Done,
     /* 375144 */   // Label 7344: @375144
     /* 375144 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(375265), // Rule ID 4222 //
     /* 375149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375163 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 375169 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 375171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375179 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375182 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375186 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 375193 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375197 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375203 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 375210 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 375210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 375217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375232 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375254 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375264 */     // GIR_Coverage, 4222,
     /* 375264 */     GIR_EraseRootFromParent_Done,
     /* 375265 */   // Label 7345: @375265
     /* 375265 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(375386), // Rule ID 4223 //
     /* 375270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375284 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 375290 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 375292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375300 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375303 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375307 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 375314 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375324 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 375331 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 375331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 375338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375353 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375385 */     // GIR_Coverage, 4223,
     /* 375385 */     GIR_EraseRootFromParent_Done,
     /* 375386 */   // Label 7346: @375386
     /* 375386 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(375496), // Rule ID 4190 //
     /* 375391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375417 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375420 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375424 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 375441 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 375441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 375448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375463 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375495 */     // GIR_Coverage, 4190,
     /* 375495 */     GIR_EraseRootFromParent_Done,
     /* 375496 */   // Label 7347: @375496
     /* 375496 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(375606), // Rule ID 4192 //
     /* 375501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375527 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375530 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375534 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 375551 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 375551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 375558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375573 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375605 */     // GIR_Coverage, 4192,
     /* 375605 */     GIR_EraseRootFromParent_Done,
     /* 375606 */   // Label 7348: @375606
     /* 375606 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(375723), // Rule ID 4226 //
     /* 375611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375637 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375640 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375644 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 375651 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375661 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 375668 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 375668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 375675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375690 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375722 */     // GIR_Coverage, 4226,
     /* 375722 */     GIR_EraseRootFromParent_Done,
     /* 375723 */   // Label 7349: @375723
     /* 375723 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(375840), // Rule ID 4228 //
     /* 375728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375754 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375757 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375761 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 375768 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375778 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 375785 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 375785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 375792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375807 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375829 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375839 */     // GIR_Coverage, 4228,
     /* 375839 */     GIR_EraseRootFromParent_Done,
     /* 375840 */   // Label 7350: @375840
     /* 375840 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(375963), // Rule ID 5776 //
     /* 375845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 375875 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 375879 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 375888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375892 */     // MIs[3] Operand 1
     /* 375892 */     // No operand predicates
     /* 375892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375896 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 375898 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 375898 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 375901 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 375905 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375910 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 375914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 375917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 375922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 375944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375962 */     // GIR_Coverage, 5776,
     /* 375962 */     GIR_EraseRootFromParent_Done,
     /* 375963 */   // Label 7351: @375963
     /* 375963 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(376086), // Rule ID 5784 //
     /* 375968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 375994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 375998 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376015 */     // MIs[3] Operand 1
     /* 376015 */     // No operand predicates
     /* 376015 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376019 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376021 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 376021 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 376024 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 376028 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376033 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 376037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 376040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 376049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 376059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 376067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376085 */     // GIR_Coverage, 5784,
     /* 376085 */     GIR_EraseRootFromParent_Done,
     /* 376086 */   // Label 7352: @376086
     /* 376086 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(376174), // Rule ID 1938 //
     /* 376091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 376120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376137 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376141 */     // MIs[2] Operand 1
     /* 376141 */     // No operand predicates
     /* 376141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376149 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376153 */     // MIs[3] Operand 1
     /* 376153 */     // No operand predicates
     /* 376153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376155 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 376155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 376162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 376172 */     GIR_RootConstrainSelectedInstOperands,
     /* 376173 */     // GIR_Coverage, 1938,
     /* 376173 */     GIR_EraseRootFromParent_Done,
     /* 376174 */   // Label 7353: @376174
     /* 376174 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(376273), // Rule ID 5773 //
     /* 376179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 376201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376213 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376217 */     // MIs[2] Operand 1
     /* 376217 */     // No operand predicates
     /* 376217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376225 */     // MIs[3] Operand 1
     /* 376225 */     // No operand predicates
     /* 376225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376227 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i8] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 376227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376239 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 376245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376260 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 376265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 376271 */     GIR_RootConstrainSelectedInstOperands,
     /* 376272 */     // GIR_Coverage, 5773,
     /* 376272 */     GIR_EraseRootFromParent_Done,
     /* 376273 */   // Label 7354: @376273
     /* 376273 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(376372), // Rule ID 5781 //
     /* 376278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 376300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376312 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376316 */     // MIs[2] Operand 1
     /* 376316 */     // No operand predicates
     /* 376316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376324 */     // MIs[3] Operand 1
     /* 376324 */     // No operand predicates
     /* 376324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376326 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 376326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376338 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 376344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376359 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 376364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 376370 */     GIR_RootConstrainSelectedInstOperands,
     /* 376371 */     // GIR_Coverage, 5781,
     /* 376371 */     GIR_EraseRootFromParent_Done,
     /* 376372 */   // Label 7355: @376372
     /* 376372 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(376449), // Rule ID 5775 //
     /* 376377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 376403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376420 */     // MIs[2] Operand 1
     /* 376420 */     // No operand predicates
     /* 376420 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376424 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376428 */     // MIs[3] Operand 1
     /* 376428 */     // No operand predicates
     /* 376428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376430 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 376430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376435 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 376437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 376440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 376447 */     GIR_RootConstrainSelectedInstOperands,
     /* 376448 */     // GIR_Coverage, 5775,
     /* 376448 */     GIR_EraseRootFromParent_Done,
     /* 376449 */   // Label 7356: @376449
     /* 376449 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(376557), // Rule ID 5777 //
     /* 376454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 376480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376497 */     // MIs[2] Operand 1
     /* 376497 */     // No operand predicates
     /* 376497 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376501 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376505 */     // MIs[3] Operand 1
     /* 376505 */     // No operand predicates
     /* 376505 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376507 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 376507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376519 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376526 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 376529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376544 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 376546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 376549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 376555 */     GIR_RootConstrainSelectedInstOperands,
     /* 376556 */     // GIR_Coverage, 5777,
     /* 376556 */     GIR_EraseRootFromParent_Done,
     /* 376557 */   // Label 7357: @376557
     /* 376557 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(376634), // Rule ID 5783 //
     /* 376562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 376588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376605 */     // MIs[2] Operand 1
     /* 376605 */     // No operand predicates
     /* 376605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376613 */     // MIs[3] Operand 1
     /* 376613 */     // No operand predicates
     /* 376613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376615 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 376615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376620 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 376622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 376625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 376632 */     GIR_RootConstrainSelectedInstOperands,
     /* 376633 */     // GIR_Coverage, 5783,
     /* 376633 */     GIR_EraseRootFromParent_Done,
     /* 376634 */   // Label 7358: @376634
     /* 376634 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(376742), // Rule ID 5785 //
     /* 376639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 376665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376682 */     // MIs[2] Operand 1
     /* 376682 */     // No operand predicates
     /* 376682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376690 */     // MIs[3] Operand 1
     /* 376690 */     // No operand predicates
     /* 376690 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376692 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 376692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376704 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 376707 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376711 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 376714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376729 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 376731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 376734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 376740 */     GIR_RootConstrainSelectedInstOperands,
     /* 376741 */     // GIR_Coverage, 5785,
     /* 376741 */     GIR_EraseRootFromParent_Done,
     /* 376742 */   // Label 7359: @376742
     /* 376742 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(376821), // Rule ID 5700 //
     /* 376747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 376769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 376775 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 376775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 376778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 376791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 376810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 376820 */     // GIR_Coverage, 5700,
     /* 376820 */     GIR_EraseRootFromParent_Done,
     /* 376821 */   // Label 7360: @376821
     /* 376821 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(376900), // Rule ID 6483 //
     /* 376826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376848 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376851 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 376855 */     // MIs[1] Rn
     /* 376855 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 376859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 376864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 376868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376872 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376876 */     // MIs[2] Operand 1
     /* 376876 */     // No operand predicates
     /* 376876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376878 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 376878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 376881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 376885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376898 */     GIR_RootConstrainSelectedInstOperands,
     /* 376899 */     // GIR_Coverage, 6483,
     /* 376899 */     GIR_EraseRootFromParent_Done,
     /* 376900 */   // Label 7361: @376900
     /* 376900 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(376986), // Rule ID 6484 //
     /* 376905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376927 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376930 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 376934 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376941 */     // MIs[1] Rn
     /* 376941 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 376945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 376950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 376954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376958 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376962 */     // MIs[2] Operand 1
     /* 376962 */     // No operand predicates
     /* 376962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376964 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 376964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 376967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376969 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 376971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 376974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376984 */     GIR_RootConstrainSelectedInstOperands,
     /* 376985 */     // GIR_Coverage, 6484,
     /* 376985 */     GIR_EraseRootFromParent_Done,
     /* 376986 */   // Label 7362: @376986
     /* 376986 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(377040), // Rule ID 1934 //
     /* 376991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 377012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 377016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 377024 */     // MIs[1] Operand 1
     /* 377024 */     // No operand predicates
     /* 377024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377026 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 377026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 377029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 377033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 377036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377038 */     GIR_RootConstrainSelectedInstOperands,
     /* 377039 */     // GIR_Coverage, 1934,
     /* 377039 */     GIR_EraseRootFromParent_Done,
     /* 377040 */   // Label 7363: @377040
     /* 377040 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(377146), // Rule ID 5743 //
     /* 377045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 377048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 377067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 377075 */     // MIs[1] Operand 1
     /* 377075 */     // No operand predicates
     /* 377075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377077 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 377080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 377084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 377091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 377098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377103 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 377106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 377110 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 377113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 377131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 377138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377144 */     GIR_RootConstrainSelectedInstOperands,
     /* 377145 */     // GIR_Coverage, 5743,
     /* 377145 */     GIR_EraseRootFromParent_Done,
     /* 377146 */   // Label 7364: @377146
     /* 377146 */   GIM_Reject,
     /* 377147 */ // Label 7334: @377147
     /* 377147 */ GIM_Reject,
     /* 377148 */ // Label 7127: @377148
     /* 377148 */ GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(377272), // Rule ID 11258 //
     /* 377153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 377156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 377159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 377162 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377169 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377173 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 377177 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 377177 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 377180 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 377184 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377189 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 377193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 377195 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 377198 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 377202 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377207 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 377210 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 377213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 377215 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 377218 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 377222 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377227 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 377230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 377232 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 377235 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 377239 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377244 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 377247 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 377250 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 377253 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 377256 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 377261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 377263 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 377265 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377268 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 377270 */   GIR_RootConstrainSelectedInstOperands,
     /* 377271 */   // GIR_Coverage, 11258,
     /* 377271 */   GIR_EraseRootFromParent_Done,
     /* 377272 */ // Label 7365: @377272
     /* 377272 */ GIM_Reject,
     /* 377273 */ // Label 7128: @377273
     /* 377273 */ GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(377397), // Rule ID 11261 //
     /* 377278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 377281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 377284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377287 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377298 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 377302 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 377302 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 377305 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 377309 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377314 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 377318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 377320 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 377323 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 377327 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377332 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 377335 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 377338 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 377340 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 377343 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 377347 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377352 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 377355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 377357 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 377360 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 377364 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377369 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 377372 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 377375 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 377378 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 377381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 377386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 377388 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 377390 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377393 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 377395 */   GIR_RootConstrainSelectedInstOperands,
     /* 377396 */   // GIR_Coverage, 11261,
     /* 377396 */   GIR_EraseRootFromParent_Done,
     /* 377397 */ // Label 7366: @377397
     /* 377397 */ GIM_Reject,
     /* 377398 */ // Label 7129: @377398
     /* 377398 */ GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(379375),
     /* 377403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 377406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 377409 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377416 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(377525), // Rule ID 4356 //
     /* 377421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377425 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377431 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377441 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377444 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377448 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377458 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 377465 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 377472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377492 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377514 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377524 */     // GIR_Coverage, 4356,
     /* 377524 */     GIR_EraseRootFromParent_Done,
     /* 377525 */   // Label 7368: @377525
     /* 377525 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(377634), // Rule ID 4357 //
     /* 377530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377534 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377540 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377550 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377553 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377557 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377567 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 377574 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 377581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377601 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377633 */     // GIR_Coverage, 4357,
     /* 377633 */     GIR_EraseRootFromParent_Done,
     /* 377634 */   // Label 7369: @377634
     /* 377634 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(377743), // Rule ID 4464 //
     /* 377639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377643 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377649 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377659 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377662 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377666 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377676 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 377683 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 377690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377710 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377742 */     // GIR_Coverage, 4464,
     /* 377742 */     GIR_EraseRootFromParent_Done,
     /* 377743 */   // Label 7370: @377743
     /* 377743 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(377852), // Rule ID 4465 //
     /* 377748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377752 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 377758 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 377760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377768 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377771 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377775 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377785 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 377792 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 377799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377819 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377851 */     // GIR_Coverage, 4465,
     /* 377851 */     GIR_EraseRootFromParent_Done,
     /* 377852 */   // Label 7371: @377852
     /* 377852 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(377957), // Rule ID 4362 //
     /* 377857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377873 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377876 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377880 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377890 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 377897 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 377897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 377900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 377904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 377914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 377919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 377924 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 377946 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377951 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377956 */     // GIR_Coverage, 4362,
     /* 377956 */     GIR_EraseRootFromParent_Done,
     /* 377957 */   // Label 7372: @377957
     /* 377957 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(378062), // Rule ID 4364 //
     /* 377962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377978 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377981 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 377985 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 377989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377993 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377995 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 378002 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 378009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378029 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378061 */     // GIR_Coverage, 4364,
     /* 378061 */     GIR_EraseRootFromParent_Done,
     /* 378062 */   // Label 7373: @378062
     /* 378062 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(378167), // Rule ID 4470 //
     /* 378067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378083 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378086 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378090 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378100 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 378107 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 378114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378134 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378166 */     // GIR_Coverage, 4470,
     /* 378166 */     GIR_EraseRootFromParent_Done,
     /* 378167 */   // Label 7374: @378167
     /* 378167 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(378272), // Rule ID 4472 //
     /* 378172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378188 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378195 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378205 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 378212 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 378219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378239 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378266 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378271 */     // GIR_Coverage, 4472,
     /* 378271 */     GIR_EraseRootFromParent_Done,
     /* 378272 */   // Label 7375: @378272
     /* 378272 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(378376), // Rule ID 4354 //
     /* 378277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378281 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378287 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378297 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378300 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378304 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378308 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378314 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 378321 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 378321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 378328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378343 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378375 */     // GIR_Coverage, 4354,
     /* 378375 */     GIR_EraseRootFromParent_Done,
     /* 378376 */   // Label 7376: @378376
     /* 378376 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(378480), // Rule ID 4355 //
     /* 378381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378385 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378391 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378401 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378404 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378408 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378418 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 378425 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 378425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 378432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378447 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378469 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378479 */     // GIR_Coverage, 4355,
     /* 378479 */     GIR_EraseRootFromParent_Done,
     /* 378480 */   // Label 7377: @378480
     /* 378480 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(378584), // Rule ID 4462 //
     /* 378485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378489 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378495 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378505 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378508 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378512 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378522 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 378529 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 378529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 378536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378551 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378578 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378583 */     // GIR_Coverage, 4462,
     /* 378583 */     GIR_EraseRootFromParent_Done,
     /* 378584 */   // Label 7378: @378584
     /* 378584 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(378688), // Rule ID 4463 //
     /* 378589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378593 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378599 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378609 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378612 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378616 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378620 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378626 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 378633 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 378633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 378640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378655 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378687 */     // GIR_Coverage, 4463,
     /* 378687 */     GIR_EraseRootFromParent_Done,
     /* 378688 */   // Label 7379: @378688
     /* 378688 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(378788), // Rule ID 4358 //
     /* 378693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378709 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378712 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378716 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378726 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 378733 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 378733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 378740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378755 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378787 */     // GIR_Coverage, 4358,
     /* 378787 */     GIR_EraseRootFromParent_Done,
     /* 378788 */   // Label 7380: @378788
     /* 378788 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(378888), // Rule ID 4360 //
     /* 378793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378809 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378812 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378816 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 378833 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 378833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 378840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378855 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378877 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378887 */     // GIR_Coverage, 4360,
     /* 378887 */     GIR_EraseRootFromParent_Done,
     /* 378888 */   // Label 7381: @378888
     /* 378888 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(378988), // Rule ID 4466 //
     /* 378893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378909 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378912 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378916 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378926 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 378933 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 378933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 378940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 378955 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378987 */     // GIR_Coverage, 4466,
     /* 378987 */     GIR_EraseRootFromParent_Done,
     /* 378988 */   // Label 7382: @378988
     /* 378988 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(379088), // Rule ID 4468 //
     /* 378993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379009 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379012 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379016 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379020 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379026 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 379033 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 379033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 379040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379055 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379082 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379087 */     // GIR_Coverage, 4468,
     /* 379087 */     GIR_EraseRootFromParent_Done,
     /* 379088 */   // Label 7383: @379088
     /* 379088 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(379152), // Rule ID 11316 //
     /* 379093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 379096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 379116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379128 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 379132 */     // MIs[3] Operand 1
     /* 379132 */     // No operand predicates
     /* 379132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379138 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx)
     /* 379138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 379141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 379143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 379147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 379150 */     GIR_RootConstrainSelectedInstOperands,
     /* 379151 */     // GIR_Coverage, 11316,
     /* 379151 */     GIR_EraseRootFromParent_Done,
     /* 379152 */   // Label 7384: @379152
     /* 379152 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(379263), // Rule ID 11257 //
     /* 379157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 379160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379168 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 379168 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 379171 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 379175 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379180 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 379184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 379186 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 379189 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 379193 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379198 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 379201 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 379204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 379206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 379209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 379213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379218 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 379221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 379226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 379230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379235 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379238 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 379241 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 379244 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 379247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 379252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 379254 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 379256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379259 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 379261 */     GIR_RootConstrainSelectedInstOperands,
     /* 379262 */     // GIR_Coverage, 11257,
     /* 379262 */     GIR_EraseRootFromParent_Done,
     /* 379263 */   // Label 7385: @379263
     /* 379263 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(379374), // Rule ID 11263 //
     /* 379268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 379271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379279 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 379279 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 379282 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 379286 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379291 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 379295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 379297 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 379300 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 379304 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379309 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 379312 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 379315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 379317 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 379320 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 379324 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379329 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 379332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 379337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 379341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379346 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379349 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 379352 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 379355 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 379358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 379363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 379365 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 379367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379370 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 379372 */     GIR_RootConstrainSelectedInstOperands,
     /* 379373 */     // GIR_Coverage, 11263,
     /* 379373 */     GIR_EraseRootFromParent_Done,
     /* 379374 */   // Label 7386: @379374
     /* 379374 */   GIM_Reject,
     /* 379375 */ // Label 7367: @379375
     /* 379375 */ GIM_Reject,
     /* 379376 */ // Label 7130: @379376
     /* 379376 */ GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(379527), // Rule ID 11259 //
     /* 379381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 379384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 379387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 379390 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 379393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379401 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379405 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 379405 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 379408 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379412 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379417 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 379423 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 379428 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379433 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 379436 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 379440 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379445 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 379448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 379450 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 379453 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 379457 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379462 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 379465 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 379468 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 379470 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 379473 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 379477 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379482 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 379485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379487 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 379490 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 379494 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379499 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379502 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 379505 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 379508 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 379511 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 379516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 379518 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 379520 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379523 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 379525 */   GIR_RootConstrainSelectedInstOperands,
     /* 379526 */   // GIR_Coverage, 11259,
     /* 379526 */   GIR_EraseRootFromParent_Done,
     /* 379527 */ // Label 7387: @379527
     /* 379527 */ GIM_Reject,
     /* 379528 */ // Label 7131: @379528
     /* 379528 */ GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(381559),
     /* 379533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 379536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 379539 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 379542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379546 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(379655), // Rule ID 4320 //
     /* 379551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379555 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379561 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379571 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379574 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379578 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 379595 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 379602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379622 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379654 */     // GIR_Coverage, 4320,
     /* 379654 */     GIR_EraseRootFromParent_Done,
     /* 379655 */   // Label 7389: @379655
     /* 379655 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(379764), // Rule ID 4321 //
     /* 379660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379664 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379670 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379680 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379683 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379687 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 379704 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 379711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379731 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379763 */     // GIR_Coverage, 4321,
     /* 379763 */     GIR_EraseRootFromParent_Done,
     /* 379764 */   // Label 7390: @379764
     /* 379764 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(379873), // Rule ID 4428 //
     /* 379769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379773 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379779 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379789 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379792 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379796 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 379813 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 379820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379840 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379872 */     // GIR_Coverage, 4428,
     /* 379872 */     GIR_EraseRootFromParent_Done,
     /* 379873 */   // Label 7391: @379873
     /* 379873 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(379982), // Rule ID 4429 //
     /* 379878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379882 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379888 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379898 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379901 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379905 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379915 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 379922 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 379922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 379929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 379944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 379949 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 379971 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379976 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379981 */     // GIR_Coverage, 4429,
     /* 379981 */     GIR_EraseRootFromParent_Done,
     /* 379982 */   // Label 7392: @379982
     /* 379982 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(380087), // Rule ID 4326 //
     /* 379987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380003 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380006 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380010 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 380027 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 380034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380054 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380086 */     // GIR_Coverage, 4326,
     /* 380086 */     GIR_EraseRootFromParent_Done,
     /* 380087 */   // Label 7393: @380087
     /* 380087 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(380192), // Rule ID 4328 //
     /* 380092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380108 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380111 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380115 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380119 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380125 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 380132 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 380139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380159 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380181 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380186 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380191 */     // GIR_Coverage, 4328,
     /* 380191 */     GIR_EraseRootFromParent_Done,
     /* 380192 */   // Label 7394: @380192
     /* 380192 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(380297), // Rule ID 4434 //
     /* 380197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380213 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380216 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380220 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380230 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 380237 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 380244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380264 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380286 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380296 */     // GIR_Coverage, 4434,
     /* 380296 */     GIR_EraseRootFromParent_Done,
     /* 380297 */   // Label 7395: @380297
     /* 380297 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(380402), // Rule ID 4436 //
     /* 380302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380318 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380321 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380325 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380335 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 380342 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 380349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380369 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380401 */     // GIR_Coverage, 4436,
     /* 380401 */     GIR_EraseRootFromParent_Done,
     /* 380402 */   // Label 7396: @380402
     /* 380402 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(380506), // Rule ID 4318 //
     /* 380407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380411 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380417 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380427 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380430 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380434 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 380451 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 380451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 380458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380473 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380505 */     // GIR_Coverage, 4318,
     /* 380505 */     GIR_EraseRootFromParent_Done,
     /* 380506 */   // Label 7397: @380506
     /* 380506 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(380610), // Rule ID 4319 //
     /* 380511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380515 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380521 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380531 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380534 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380538 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380542 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380548 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 380555 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 380555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 380562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380577 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380609 */     // GIR_Coverage, 4319,
     /* 380609 */     GIR_EraseRootFromParent_Done,
     /* 380610 */   // Label 7398: @380610
     /* 380610 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(380714), // Rule ID 4426 //
     /* 380615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380619 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380625 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380635 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380638 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380642 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380646 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380652 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 380659 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 380659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 380666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380681 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380697 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380708 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380713 */     // GIR_Coverage, 4426,
     /* 380713 */     GIR_EraseRootFromParent_Done,
     /* 380714 */   // Label 7399: @380714
     /* 380714 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(380818), // Rule ID 4427 //
     /* 380719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380723 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380729 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380739 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380742 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380746 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380756 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 380763 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 380763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 380770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380785 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380817 */     // GIR_Coverage, 4427,
     /* 380817 */     GIR_EraseRootFromParent_Done,
     /* 380818 */   // Label 7400: @380818
     /* 380818 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(380918), // Rule ID 4322 //
     /* 380823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380839 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380842 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380846 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380856 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 380863 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 380863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 380870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380885 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380917 */     // GIR_Coverage, 4322,
     /* 380917 */     GIR_EraseRootFromParent_Done,
     /* 380918 */   // Label 7401: @380918
     /* 380918 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(381018), // Rule ID 4324 //
     /* 380923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380939 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380942 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380946 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380956 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 380963 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 380963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 380970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 380985 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381017 */     // GIR_Coverage, 4324,
     /* 381017 */     GIR_EraseRootFromParent_Done,
     /* 381018 */   // Label 7402: @381018
     /* 381018 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(381118), // Rule ID 4430 //
     /* 381023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381039 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381042 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381046 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381056 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 381063 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 381063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 381070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381085 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381107 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381117 */     // GIR_Coverage, 4430,
     /* 381117 */     GIR_EraseRootFromParent_Done,
     /* 381118 */   // Label 7403: @381118
     /* 381118 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(381218), // Rule ID 4432 //
     /* 381123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381139 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381142 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381146 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381156 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 381163 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 381163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 381170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381185 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381207 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381217 */     // GIR_Coverage, 4432,
     /* 381217 */     GIR_EraseRootFromParent_Done,
     /* 381218 */   // Label 7404: @381218
     /* 381218 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(381282), // Rule ID 11314 //
     /* 381223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 381226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 381246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381258 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 381262 */     // MIs[3] Operand 1
     /* 381262 */     // No operand predicates
     /* 381262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381268 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx)
     /* 381268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 381271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 381273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 381277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 381280 */     GIR_RootConstrainSelectedInstOperands,
     /* 381281 */     // GIR_Coverage, 11314,
     /* 381281 */     GIR_EraseRootFromParent_Done,
     /* 381282 */   // Label 7405: @381282
     /* 381282 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(381420), // Rule ID 11256 //
     /* 381287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 381290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 381294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381298 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 381298 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 381301 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381305 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381310 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 381316 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 381321 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381326 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 381329 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 381333 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381338 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 381341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 381343 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 381346 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 381350 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381355 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 381358 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 381361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 381363 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 381366 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 381370 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381375 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 381378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 381380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 381383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 381387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381392 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 381395 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 381398 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 381401 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 381404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 381409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 381411 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 381413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381416 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 381418 */     GIR_RootConstrainSelectedInstOperands,
     /* 381419 */     // GIR_Coverage, 11256,
     /* 381419 */     GIR_EraseRootFromParent_Done,
     /* 381420 */   // Label 7406: @381420
     /* 381420 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(381558), // Rule ID 11262 //
     /* 381425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 381428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381436 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 381436 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 381439 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381443 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381448 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 381454 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 381459 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381464 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 381467 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 381471 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381476 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 381479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 381481 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 381484 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 381488 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381493 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 381496 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 381499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 381501 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 381504 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 381508 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381513 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 381516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 381518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 381521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 381525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381530 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 381533 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 381536 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 381539 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 381542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 381547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 381549 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 381551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381554 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 381556 */     GIR_RootConstrainSelectedInstOperands,
     /* 381557 */     // GIR_Coverage, 11262,
     /* 381557 */     GIR_EraseRootFromParent_Done,
     /* 381558 */   // Label 7407: @381558
     /* 381558 */   GIM_Reject,
     /* 381559 */ // Label 7388: @381559
     /* 381559 */ GIM_Reject,
     /* 381560 */ // Label 7132: @381560
     /* 381560 */ GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(383827),
     /* 381565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 381568 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(381694), // Rule ID 4284 //
     /* 381573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 381576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381587 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381593 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381603 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381606 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381610 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 381617 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 381634 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 381641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381661 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381688 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381693 */     // GIR_Coverage, 4284,
     /* 381693 */     GIR_EraseRootFromParent_Done,
     /* 381694 */   // Label 7409: @381694
     /* 381694 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(381820), // Rule ID 4285 //
     /* 381699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 381702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381713 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381719 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381729 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381732 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381736 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 381743 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381753 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 381760 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 381767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381787 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381814 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381819 */     // GIR_Coverage, 4285,
     /* 381819 */     GIR_EraseRootFromParent_Done,
     /* 381820 */   // Label 7410: @381820
     /* 381820 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(381939), // Rule ID 4392 //
     /* 381825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 381828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381839 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381845 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381855 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381858 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381862 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381872 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 381879 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 381882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 381886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381906 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 381928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381933 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 381938 */     // GIR_Coverage, 4392,
     /* 381938 */     GIR_EraseRootFromParent_Done,
     /* 381939 */   // Label 7411: @381939
     /* 381939 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(382058), // Rule ID 4393 //
     /* 381944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 381947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 381950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381958 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381964 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381974 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381981 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381991 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 381998 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 381998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 382005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382025 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382057 */     // GIR_Coverage, 4393,
     /* 382057 */     GIR_EraseRootFromParent_Done,
     /* 382058 */   // Label 7412: @382058
     /* 382058 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(382180), // Rule ID 4290 //
     /* 382063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382089 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382092 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382096 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382103 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 382120 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 382127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382147 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382169 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382179 */     // GIR_Coverage, 4290,
     /* 382179 */     GIR_EraseRootFromParent_Done,
     /* 382180 */   // Label 7413: @382180
     /* 382180 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(382302), // Rule ID 4292 //
     /* 382185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382211 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382214 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382218 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382225 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382235 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 382242 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 382249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382269 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382301 */     // GIR_Coverage, 4292,
     /* 382301 */     GIR_EraseRootFromParent_Done,
     /* 382302 */   // Label 7414: @382302
     /* 382302 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(382417), // Rule ID 4398 //
     /* 382307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382333 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382336 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382340 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382350 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 382357 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 382364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382384 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382416 */     // GIR_Coverage, 4398,
     /* 382416 */     GIR_EraseRootFromParent_Done,
     /* 382417 */   // Label 7415: @382417
     /* 382417 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(382532), // Rule ID 4400 //
     /* 382422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382448 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382451 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382455 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382459 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382465 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 382472 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 382479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382499 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382526 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382531 */     // GIR_Coverage, 4400,
     /* 382531 */     GIR_EraseRootFromParent_Done,
     /* 382532 */   // Label 7416: @382532
     /* 382532 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(382653), // Rule ID 4282 //
     /* 382537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382551 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382557 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382567 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382570 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382574 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382581 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382591 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 382598 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 382598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 382605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382620 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382652 */     // GIR_Coverage, 4282,
     /* 382652 */     GIR_EraseRootFromParent_Done,
     /* 382653 */   // Label 7417: @382653
     /* 382653 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(382774), // Rule ID 4283 //
     /* 382658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382672 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382678 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382688 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382691 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382695 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382702 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382712 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 382719 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 382719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 382726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382741 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382773 */     // GIR_Coverage, 4283,
     /* 382773 */     GIR_EraseRootFromParent_Done,
     /* 382774 */   // Label 7418: @382774
     /* 382774 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(382888), // Rule ID 4390 //
     /* 382779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382793 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382799 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382809 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382812 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382816 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382826 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 382833 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 382833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 382840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382855 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382877 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382887 */     // GIR_Coverage, 4390,
     /* 382887 */     GIR_EraseRootFromParent_Done,
     /* 382888 */   // Label 7419: @382888
     /* 382888 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(383002), // Rule ID 4391 //
     /* 382893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382907 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382913 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382923 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382926 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382930 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382934 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382940 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 382947 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 382947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 382954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 382969 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383001 */     // GIR_Coverage, 4391,
     /* 383001 */     GIR_EraseRootFromParent_Done,
     /* 383002 */   // Label 7420: @383002
     /* 383002 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(383119), // Rule ID 4286 //
     /* 383007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383033 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383036 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383040 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 383047 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383057 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 383064 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 383064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 383071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383086 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383108 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383118 */     // GIR_Coverage, 4286,
     /* 383118 */     GIR_EraseRootFromParent_Done,
     /* 383119 */   // Label 7421: @383119
     /* 383119 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(383236), // Rule ID 4288 //
     /* 383124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383150 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383153 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383157 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 383164 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383174 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 383181 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 383181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 383188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383203 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383235 */     // GIR_Coverage, 4288,
     /* 383235 */     GIR_EraseRootFromParent_Done,
     /* 383236 */   // Label 7422: @383236
     /* 383236 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(383346), // Rule ID 4394 //
     /* 383241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383267 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383270 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383274 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383284 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 383291 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 383291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 383298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383313 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383345 */     // GIR_Coverage, 4394,
     /* 383345 */     GIR_EraseRootFromParent_Done,
     /* 383346 */   // Label 7423: @383346
     /* 383346 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(383456), // Rule ID 4396 //
     /* 383351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383377 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383380 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383384 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383394 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 383401 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 383401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 383408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383423 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383445 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383450 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383455 */     // GIR_Coverage, 4396,
     /* 383455 */     GIR_EraseRootFromParent_Done,
     /* 383456 */   // Label 7424: @383456
     /* 383456 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(383530), // Rule ID 11312 //
     /* 383461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 383464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 383494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383506 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 383510 */     // MIs[3] Operand 1
     /* 383510 */     // No operand predicates
     /* 383510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383514 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383516 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx)
     /* 383516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 383519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 383521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 383525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 383528 */     GIR_RootConstrainSelectedInstOperands,
     /* 383529 */     // GIR_Coverage, 11312,
     /* 383529 */     GIR_EraseRootFromParent_Done,
     /* 383530 */   // Label 7425: @383530
     /* 383530 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(383678), // Rule ID 11255 //
     /* 383535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 383538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 383552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 383556 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 383556 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 383559 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383563 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383568 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 383574 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 383579 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 383584 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 383587 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 383591 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383596 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 383599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 383601 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 383604 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 383608 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383613 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 383616 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 383619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 383621 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 383624 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 383628 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383633 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 383636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 383638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 383641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 383645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383650 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 383653 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 383656 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 383659 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 383662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 383667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 383669 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 383671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383674 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 383676 */     GIR_RootConstrainSelectedInstOperands,
     /* 383677 */     // GIR_Coverage, 11255,
     /* 383677 */     GIR_EraseRootFromParent_Done,
     /* 383678 */   // Label 7426: @383678
     /* 383678 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(383826), // Rule ID 11260 //
     /* 383683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 383686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 383704 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 383704 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 383707 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383711 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383716 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 383722 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 383727 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 383732 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 383735 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 383739 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383744 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 383747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 383749 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 383752 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 383756 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383761 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 383764 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 383767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 383769 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 383772 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 383776 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383781 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 383784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 383786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 383789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 383793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383798 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 383801 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 383804 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 383807 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 383810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 383815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 383817 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 383819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383822 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 383824 */     GIR_RootConstrainSelectedInstOperands,
     /* 383825 */     // GIR_Coverage, 11260,
     /* 383825 */     GIR_EraseRootFromParent_Done,
     /* 383826 */   // Label 7427: @383826
     /* 383826 */   GIM_Reject,
     /* 383827 */ // Label 7408: @383827
     /* 383827 */ GIM_Reject,
     /* 383828 */ // Label 7133: @383828
     /* 383828 */ GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(385947),
     /* 383833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 383836 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(383955), // Rule ID 4212 //
     /* 383841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 383844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383855 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383861 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383871 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383874 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383878 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383888 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 383895 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 383895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 383898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 383902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383922 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 383944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383949 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 383954 */     // GIR_Coverage, 4212,
     /* 383954 */     GIR_EraseRootFromParent_Done,
     /* 383955 */   // Label 7429: @383955
     /* 383955 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(384074), // Rule ID 4213 //
     /* 383960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 383963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383974 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383980 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383990 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383993 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383997 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384001 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384007 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 384014 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 384021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384041 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384073 */     // GIR_Coverage, 4213,
     /* 384073 */     GIR_EraseRootFromParent_Done,
     /* 384074 */   // Label 7430: @384074
     /* 384074 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(384200), // Rule ID 4248 //
     /* 384079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384093 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384099 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384109 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384112 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384116 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384123 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384133 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 384140 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 384147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384167 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384194 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384199 */     // GIR_Coverage, 4248,
     /* 384199 */     GIR_EraseRootFromParent_Done,
     /* 384200 */   // Label 7431: @384200
     /* 384200 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(384326), // Rule ID 4249 //
     /* 384205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384219 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384225 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384235 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384238 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384242 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384249 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384253 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384259 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 384266 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 384273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384293 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384320 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384325 */     // GIR_Coverage, 4249,
     /* 384325 */     GIR_EraseRootFromParent_Done,
     /* 384326 */   // Label 7432: @384326
     /* 384326 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(384441), // Rule ID 4218 //
     /* 384331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384357 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384360 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384364 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384374 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 384381 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 384388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384408 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384430 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384435 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384440 */     // GIR_Coverage, 4218,
     /* 384440 */     GIR_EraseRootFromParent_Done,
     /* 384441 */   // Label 7433: @384441
     /* 384441 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(384556), // Rule ID 4220 //
     /* 384446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384472 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384479 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384489 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 384496 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 384503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384523 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384555 */     // GIR_Coverage, 4220,
     /* 384555 */     GIR_EraseRootFromParent_Done,
     /* 384556 */   // Label 7434: @384556
     /* 384556 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(384678), // Rule ID 4254 //
     /* 384561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384587 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384590 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384594 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384601 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384605 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 384618 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 384625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384645 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384667 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384677 */     // GIR_Coverage, 4254,
     /* 384677 */     GIR_EraseRootFromParent_Done,
     /* 384678 */   // Label 7435: @384678
     /* 384678 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(384800), // Rule ID 4256 //
     /* 384683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384709 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384712 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384716 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384723 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384733 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 384740 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 384747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384767 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384789 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384794 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384799 */     // GIR_Coverage, 4256,
     /* 384799 */     GIR_EraseRootFromParent_Done,
     /* 384800 */   // Label 7436: @384800
     /* 384800 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(384914), // Rule ID 4210 //
     /* 384805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384819 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384825 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384835 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384838 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384842 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384846 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 384859 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 384859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 384866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384881 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384903 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384913 */     // GIR_Coverage, 4210,
     /* 384913 */     GIR_EraseRootFromParent_Done,
     /* 384914 */   // Label 7437: @384914
     /* 384914 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(385028), // Rule ID 4211 //
     /* 384919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384933 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384939 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384949 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384952 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384956 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384966 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 384973 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 384973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 384980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384995 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385027 */     // GIR_Coverage, 4211,
     /* 385027 */     GIR_EraseRootFromParent_Done,
     /* 385028 */   // Label 7438: @385028
     /* 385028 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(385149), // Rule ID 4246 //
     /* 385033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385047 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 385053 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 385055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385063 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385066 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385070 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385077 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385087 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 385094 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 385094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 385101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385116 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385148 */     // GIR_Coverage, 4246,
     /* 385148 */     GIR_EraseRootFromParent_Done,
     /* 385149 */   // Label 7439: @385149
     /* 385149 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(385270), // Rule ID 4247 //
     /* 385154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385168 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 385174 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 385176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385184 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385187 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385191 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385198 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385208 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 385215 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 385215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 385222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385237 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385269 */     // GIR_Coverage, 4247,
     /* 385269 */     GIR_EraseRootFromParent_Done,
     /* 385270 */   // Label 7440: @385270
     /* 385270 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(385380), // Rule ID 4214 //
     /* 385275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 385278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385301 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385304 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385308 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 385325 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 385325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 385332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385347 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385374 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385379 */     // GIR_Coverage, 4214,
     /* 385379 */     GIR_EraseRootFromParent_Done,
     /* 385380 */   // Label 7441: @385380
     /* 385380 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(385490), // Rule ID 4216 //
     /* 385385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 385388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385411 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385414 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385418 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385428 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 385435 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 385435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 385442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385457 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385489 */     // GIR_Coverage, 4216,
     /* 385489 */     GIR_EraseRootFromParent_Done,
     /* 385490 */   // Label 7442: @385490
     /* 385490 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(385607), // Rule ID 4250 //
     /* 385495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385521 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385524 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385528 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385535 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385539 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 385552 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 385552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 385559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385574 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385606 */     // GIR_Coverage, 4250,
     /* 385606 */     GIR_EraseRootFromParent_Done,
     /* 385607 */   // Label 7443: @385607
     /* 385607 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(385724), // Rule ID 4252 //
     /* 385612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385638 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385641 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385645 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385652 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 385669 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 385669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 385676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385691 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385723 */     // GIR_Coverage, 4252,
     /* 385723 */     GIR_EraseRootFromParent_Done,
     /* 385724 */   // Label 7444: @385724
     /* 385724 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(385798), // Rule ID 11310 //
     /* 385729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 385758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 385762 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385774 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 385778 */     // MIs[3] Operand 1
     /* 385778 */     // No operand predicates
     /* 385778 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385782 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385784 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx)
     /* 385784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 385787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 385789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 385793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 385796 */     GIR_RootConstrainSelectedInstOperands,
     /* 385797 */     // GIR_Coverage, 11310,
     /* 385797 */     GIR_EraseRootFromParent_Done,
     /* 385798 */   // Label 7445: @385798
     /* 385798 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(385946), // Rule ID 11254 //
     /* 385803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385824 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 385824 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 385827 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385831 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385836 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 385842 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 385847 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 385852 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 385855 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 385859 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385864 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 385867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 385869 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 385872 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 385876 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385881 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 385884 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 385887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 385889 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 385892 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 385896 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385901 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 385904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 385906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 385909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 385913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385918 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 385921 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 385924 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 385927 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 385930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 385935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 385937 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 385939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385942 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 385944 */     GIR_RootConstrainSelectedInstOperands,
     /* 385945 */     // GIR_Coverage, 11254,
     /* 385945 */     GIR_EraseRootFromParent_Done,
     /* 385946 */   // Label 7446: @385946
     /* 385946 */   GIM_Reject,
     /* 385947 */ // Label 7428: @385947
     /* 385947 */ GIM_Reject,
     /* 385948 */ // Label 7134: @385948
     /* 385948 */ GIM_Reject,
     /* 385949 */ // Label 91: @385949
     /* 385949 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7450*/ GIMT_Encode4(388866),
     /* 385960 */ /*GILLT_s16*//*Label 7447*/ GIMT_Encode4(385972),
     /* 385964 */ /*GILLT_s32*//*Label 7448*/ GIMT_Encode4(386606),
     /* 385968 */ /*GILLT_s64*//*Label 7449*/ GIMT_Encode4(388199),
     /* 385972 */ // Label 7447: @385972
     /* 385972 */ GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(386016), // Rule ID 11303 //
     /* 385977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 385980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 385983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 385986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 385990 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 385994 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 385994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 385997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385999 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 386005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386010 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386015 */   // GIR_Coverage, 11303,
     /* 386015 */   GIR_EraseRootFromParent_Done,
     /* 386016 */ // Label 7451: @386016
     /* 386016 */ GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(386060), // Rule ID 11304 //
     /* 386021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 386027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386034 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386038 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 386038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386043 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 386049 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386054 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386059 */   // GIR_Coverage, 11304,
     /* 386059 */   GIR_EraseRootFromParent_Done,
     /* 386060 */ // Label 7452: @386060
     /* 386060 */ GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(386104), // Rule ID 11305 //
     /* 386065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 386071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386078 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386082 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 386082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386087 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 386093 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386098 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386103 */   // GIR_Coverage, 11305,
     /* 386103 */   GIR_EraseRootFromParent_Done,
     /* 386104 */ // Label 7453: @386104
     /* 386104 */ GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(386149), // Rule ID 5833 //
     /* 386109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386123 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386127 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 386127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386132 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 386138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386143 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386148 */   // GIR_Coverage, 5833,
     /* 386148 */   GIR_EraseRootFromParent_Done,
     /* 386149 */ // Label 7454: @386149
     /* 386149 */ GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(386194), // Rule ID 5836 //
     /* 386154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386168 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386172 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386176 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 386180 */   // MIs[1] Operand 1
     /* 386180 */   // No operand predicates
     /* 386180 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386182 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 386182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 386185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386187 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386189 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386192 */   GIR_RootConstrainSelectedInstOperands,
     /* 386193 */   // GIR_Coverage, 5836,
     /* 386193 */   GIR_EraseRootFromParent_Done,
     /* 386194 */ // Label 7455: @386194
     /* 386194 */ GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(386270), // Rule ID 11278 //
     /* 386199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 386205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386212 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386216 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386220 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 386224 */   // MIs[1] Operand 1
     /* 386224 */   // No operand predicates
     /* 386224 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386226 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 386226 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386229 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 386233 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386238 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386242 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386245 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386252 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 386259 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386264 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386269 */   // GIR_Coverage, 11278,
     /* 386269 */   GIR_EraseRootFromParent_Done,
     /* 386270 */ // Label 7456: @386270
     /* 386270 */ GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(386346), // Rule ID 11279 //
     /* 386275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 386281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386288 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386292 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386296 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 386300 */   // MIs[1] Operand 1
     /* 386300 */   // No operand predicates
     /* 386300 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386302 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 386302 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386305 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 386309 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386314 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386318 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386328 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 386335 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386340 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386345 */   // GIR_Coverage, 11279,
     /* 386345 */   GIR_EraseRootFromParent_Done,
     /* 386346 */ // Label 7457: @386346
     /* 386346 */ GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(386422), // Rule ID 11280 //
     /* 386351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 386357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386364 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386368 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386372 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 386376 */   // MIs[1] Operand 1
     /* 386376 */   // No operand predicates
     /* 386376 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386378 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 386378 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386381 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 386385 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386390 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386394 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386404 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 386411 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386416 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386421 */   // GIR_Coverage, 11280,
     /* 386421 */   GIR_EraseRootFromParent_Done,
     /* 386422 */ // Label 7458: @386422
     /* 386422 */ GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(386483), // Rule ID 11268 //
     /* 386427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 386433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 386444 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 386444 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 386447 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 386451 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386456 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 386462 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 386466 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 386469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 386474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 386476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386479 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 386481 */   GIR_RootConstrainSelectedInstOperands,
     /* 386482 */   // GIR_Coverage, 11268,
     /* 386482 */   GIR_EraseRootFromParent_Done,
     /* 386483 */ // Label 7459: @386483
     /* 386483 */ GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(386544), // Rule ID 11269 //
     /* 386488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 386494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386501 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 386505 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 386505 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 386508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 386512 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386517 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 386523 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 386527 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 386530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 386535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 386537 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386540 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 386542 */   GIR_RootConstrainSelectedInstOperands,
     /* 386543 */   // GIR_Coverage, 11269,
     /* 386543 */   GIR_EraseRootFromParent_Done,
     /* 386544 */ // Label 7460: @386544
     /* 386544 */ GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(386605), // Rule ID 11270 //
     /* 386549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 386555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 386566 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 386566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 386569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 386573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386578 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 386584 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 386588 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 386591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 386596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 386598 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386601 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 386603 */   GIR_RootConstrainSelectedInstOperands,
     /* 386604 */   // GIR_Coverage, 11270,
     /* 386604 */   GIR_EraseRootFromParent_Done,
     /* 386605 */ // Label 7461: @386605
     /* 386605 */ GIM_Reject,
     /* 386606 */ // Label 7448: @386606
     /* 386606 */ GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(386651), // Rule ID 7012 //
     /* 386611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386625 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386629 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 386629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386634 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 386640 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386645 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386650 */   // GIR_Coverage, 7012,
     /* 386650 */   GIR_EraseRootFromParent_Done,
     /* 386651 */ // Label 7462: @386651
     /* 386651 */ GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(386696), // Rule ID 7013 //
     /* 386656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386670 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386674 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 386674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386677 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386679 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 386685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386690 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386695 */   // GIR_Coverage, 7013,
     /* 386695 */   GIR_EraseRootFromParent_Done,
     /* 386696 */ // Label 7463: @386696
     /* 386696 */ GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(386740), // Rule ID 11299 //
     /* 386701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 386707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386714 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386718 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 386718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386723 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 386729 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386734 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386739 */   // GIR_Coverage, 11299,
     /* 386739 */   GIR_EraseRootFromParent_Done,
     /* 386740 */ // Label 7464: @386740
     /* 386740 */ GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(386784), // Rule ID 11300 //
     /* 386745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 386751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386758 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386762 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 386762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386767 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 386773 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386783 */   // GIR_Coverage, 11300,
     /* 386783 */   GIR_EraseRootFromParent_Done,
     /* 386784 */ // Label 7465: @386784
     /* 386784 */ GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(386828), // Rule ID 11301 //
     /* 386789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 386795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386802 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386806 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 386806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386811 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 386817 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386822 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386827 */   // GIR_Coverage, 11301,
     /* 386827 */   GIR_EraseRootFromParent_Done,
     /* 386828 */ // Label 7466: @386828
     /* 386828 */ GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(386872), // Rule ID 11306 //
     /* 386833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 386839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386846 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386850 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 386850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386855 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 386861 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386866 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386871 */   // GIR_Coverage, 11306,
     /* 386871 */   GIR_EraseRootFromParent_Done,
     /* 386872 */ // Label 7467: @386872
     /* 386872 */ GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(386916), // Rule ID 11307 //
     /* 386877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 386883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386890 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386894 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 386894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386899 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 386905 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386910 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386915 */   // GIR_Coverage, 11307,
     /* 386915 */   GIR_EraseRootFromParent_Done,
     /* 386916 */ // Label 7468: @386916
     /* 386916 */ GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(386961), // Rule ID 5832 //
     /* 386921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 386924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386935 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386939 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 386939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386944 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 386950 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386960 */   // GIR_Coverage, 5832,
     /* 386960 */   GIR_EraseRootFromParent_Done,
     /* 386961 */ // Label 7469: @386961
     /* 386961 */ GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(387034), // Rule ID 11284 //
     /* 386966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 386972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386979 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386987 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 386991 */   // MIs[1] Operand 1
     /* 386991 */   // No operand predicates
     /* 386991 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386993 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 386993 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 386996 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387000 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387005 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 387011 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387016 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 387024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387026 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387029 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 387032 */   GIR_RootConstrainSelectedInstOperands,
     /* 387033 */   // GIR_Coverage, 11284,
     /* 387033 */   GIR_EraseRootFromParent_Done,
     /* 387034 */ // Label 7470: @387034
     /* 387034 */ GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(387107), // Rule ID 11285 //
     /* 387039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 387045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387052 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387056 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387060 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 387064 */   // MIs[1] Operand 1
     /* 387064 */   // No operand predicates
     /* 387064 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387066 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 387066 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 387069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387073 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387078 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 387084 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387089 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 387097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387099 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387102 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 387105 */   GIR_RootConstrainSelectedInstOperands,
     /* 387106 */   // GIR_Coverage, 11285,
     /* 387106 */   GIR_EraseRootFromParent_Done,
     /* 387107 */ // Label 7471: @387107
     /* 387107 */ GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(387180), // Rule ID 11286 //
     /* 387112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387125 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387129 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387133 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 387137 */   // MIs[1] Operand 1
     /* 387137 */   // No operand predicates
     /* 387137 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387139 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 387139 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 387142 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387146 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387151 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 387157 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387162 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 387170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387172 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387175 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 387178 */   GIR_RootConstrainSelectedInstOperands,
     /* 387179 */   // GIR_Coverage, 11286,
     /* 387179 */   GIR_EraseRootFromParent_Done,
     /* 387180 */ // Label 7472: @387180
     /* 387180 */ GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(387228), // Rule ID 1926 //
     /* 387185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 387188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 387191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387202 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387206 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387210 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 387214 */   // MIs[1] Operand 1
     /* 387214 */   // No operand predicates
     /* 387214 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387216 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 387219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387221 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387223 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387226 */   GIR_RootConstrainSelectedInstOperands,
     /* 387227 */   // GIR_Coverage, 1926,
     /* 387227 */   GIR_EraseRootFromParent_Done,
     /* 387228 */ // Label 7473: @387228
     /* 387228 */ GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(387276), // Rule ID 1927 //
     /* 387233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 387236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387250 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387254 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387258 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 387262 */   // MIs[1] Operand 1
     /* 387262 */   // No operand predicates
     /* 387262 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387264 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 387267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387269 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387271 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387274 */   GIR_RootConstrainSelectedInstOperands,
     /* 387275 */   // GIR_Coverage, 1927,
     /* 387275 */   GIR_EraseRootFromParent_Done,
     /* 387276 */ // Label 7474: @387276
     /* 387276 */ GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(387324), // Rule ID 1928 //
     /* 387281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 387284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387298 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387302 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387306 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 387310 */   // MIs[1] Operand 1
     /* 387310 */   // No operand predicates
     /* 387310 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387312 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 387315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387317 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387319 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387322 */   GIR_RootConstrainSelectedInstOperands,
     /* 387323 */   // GIR_Coverage, 1928,
     /* 387323 */   GIR_EraseRootFromParent_Done,
     /* 387324 */ // Label 7475: @387324
     /* 387324 */ GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(387372), // Rule ID 1930 //
     /* 387329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 387335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387346 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387354 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 387358 */   // MIs[1] Operand 1
     /* 387358 */   // No operand predicates
     /* 387358 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387360 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 387363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387365 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387367 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387370 */   GIR_RootConstrainSelectedInstOperands,
     /* 387371 */   // GIR_Coverage, 1930,
     /* 387371 */   GIR_EraseRootFromParent_Done,
     /* 387372 */ // Label 7476: @387372
     /* 387372 */ GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(387420), // Rule ID 1931 //
     /* 387377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387394 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387398 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387402 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 387406 */   // MIs[1] Operand 1
     /* 387406 */   // No operand predicates
     /* 387406 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387408 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 387411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387413 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387415 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387418 */   GIR_RootConstrainSelectedInstOperands,
     /* 387419 */   // GIR_Coverage, 1931,
     /* 387419 */   GIR_EraseRootFromParent_Done,
     /* 387420 */ // Label 7477: @387420
     /* 387420 */ GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(387468), // Rule ID 1932 //
     /* 387425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387442 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387446 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387450 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 387454 */   // MIs[1] Operand 1
     /* 387454 */   // No operand predicates
     /* 387454 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387456 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 387459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387461 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387463 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387466 */   GIR_RootConstrainSelectedInstOperands,
     /* 387467 */   // GIR_Coverage, 1932,
     /* 387467 */   GIR_EraseRootFromParent_Done,
     /* 387468 */ // Label 7478: @387468
     /* 387468 */ GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(387513), // Rule ID 5835 //
     /* 387473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387487 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387491 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387495 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 387499 */   // MIs[1] Operand 1
     /* 387499 */   // No operand predicates
     /* 387499 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387501 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 387504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387506 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387508 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387511 */   GIR_RootConstrainSelectedInstOperands,
     /* 387512 */   // GIR_Coverage, 5835,
     /* 387512 */   GIR_EraseRootFromParent_Done,
     /* 387513 */ // Label 7479: @387513
     /* 387513 */ GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(387589), // Rule ID 11274 //
     /* 387518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 387524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387531 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387535 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387539 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 387543 */   // MIs[1] Operand 1
     /* 387543 */   // No operand predicates
     /* 387543 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387545 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 387545 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387548 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 387552 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387557 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387561 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387571 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 387578 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387588 */   // GIR_Coverage, 11274,
     /* 387588 */   GIR_EraseRootFromParent_Done,
     /* 387589 */ // Label 7480: @387589
     /* 387589 */ GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(387665), // Rule ID 11275 //
     /* 387594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 387600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387607 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387611 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387615 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 387619 */   // MIs[1] Operand 1
     /* 387619 */   // No operand predicates
     /* 387619 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387621 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 387621 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387624 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 387628 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387633 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387637 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387647 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 387654 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387659 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387664 */   // GIR_Coverage, 11275,
     /* 387664 */   GIR_EraseRootFromParent_Done,
     /* 387665 */ // Label 7481: @387665
     /* 387665 */ GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(387741), // Rule ID 11276 //
     /* 387670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387683 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387687 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387691 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 387695 */   // MIs[1] Operand 1
     /* 387695 */   // No operand predicates
     /* 387695 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387697 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 387697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 387704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387709 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387713 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387723 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 387730 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387735 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387740 */   // GIR_Coverage, 11276,
     /* 387740 */   GIR_EraseRootFromParent_Done,
     /* 387741 */ // Label 7482: @387741
     /* 387741 */ GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(387817), // Rule ID 11281 //
     /* 387746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387759 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387763 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387767 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 387771 */   // MIs[1] Operand 1
     /* 387771 */   // No operand predicates
     /* 387771 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387773 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 387773 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387776 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 387780 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387785 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387789 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387792 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387799 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 387806 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387811 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387816 */   // GIR_Coverage, 11281,
     /* 387816 */   GIR_EraseRootFromParent_Done,
     /* 387817 */ // Label 7483: @387817
     /* 387817 */ GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(387893), // Rule ID 11282 //
     /* 387822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 387828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387835 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387839 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387843 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 387847 */   // MIs[1] Operand 1
     /* 387847 */   // No operand predicates
     /* 387847 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387849 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 387849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 387856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387861 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387865 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387875 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 387882 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387887 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387892 */   // GIR_Coverage, 11282,
     /* 387892 */   GIR_EraseRootFromParent_Done,
     /* 387893 */ // Label 7484: @387893
     /* 387893 */ GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(387954), // Rule ID 11264 //
     /* 387898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 387904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387915 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 387915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 387922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387927 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387933 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387937 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 387945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387950 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387952 */   GIR_RootConstrainSelectedInstOperands,
     /* 387953 */   // GIR_Coverage, 11264,
     /* 387953 */   GIR_EraseRootFromParent_Done,
     /* 387954 */ // Label 7485: @387954
     /* 387954 */ GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(388015), // Rule ID 11265 //
     /* 387959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 387965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387976 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 387976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 387983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387988 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387994 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387998 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 388006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388011 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388013 */   GIR_RootConstrainSelectedInstOperands,
     /* 388014 */   // GIR_Coverage, 11265,
     /* 388014 */   GIR_EraseRootFromParent_Done,
     /* 388015 */ // Label 7486: @388015
     /* 388015 */ GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(388076), // Rule ID 11266 //
     /* 388020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 388026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388033 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388037 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 388037 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388040 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 388044 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388049 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388055 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388059 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 388067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388069 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388072 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388074 */   GIR_RootConstrainSelectedInstOperands,
     /* 388075 */   // GIR_Coverage, 11266,
     /* 388075 */   GIR_EraseRootFromParent_Done,
     /* 388076 */ // Label 7487: @388076
     /* 388076 */ GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(388137), // Rule ID 11271 //
     /* 388081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 388087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388098 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 388098 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388101 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 388105 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388110 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388116 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388120 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 388128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 388130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388133 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388135 */   GIR_RootConstrainSelectedInstOperands,
     /* 388136 */   // GIR_Coverage, 11271,
     /* 388136 */   GIR_EraseRootFromParent_Done,
     /* 388137 */ // Label 7488: @388137
     /* 388137 */ GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(388198), // Rule ID 11272 //
     /* 388142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 388148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388159 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 388159 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388162 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 388166 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388171 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388177 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388181 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 388189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 388191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388194 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388196 */   GIR_RootConstrainSelectedInstOperands,
     /* 388197 */   // GIR_Coverage, 11272,
     /* 388197 */   GIR_EraseRootFromParent_Done,
     /* 388198 */ // Label 7489: @388198
     /* 388198 */ GIM_Reject,
     /* 388199 */ // Label 7449: @388199
     /* 388199 */ GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(388244), // Rule ID 7011 //
     /* 388204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388218 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388222 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 388222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388227 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 388233 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388238 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388243 */   // GIR_Coverage, 7011,
     /* 388243 */   GIR_EraseRootFromParent_Done,
     /* 388244 */ // Label 7490: @388244
     /* 388244 */ GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(388288), // Rule ID 11302 //
     /* 388249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388262 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388266 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 388266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388271 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 388277 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388282 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388287 */   // GIR_Coverage, 11302,
     /* 388287 */   GIR_EraseRootFromParent_Done,
     /* 388288 */ // Label 7491: @388288
     /* 388288 */ GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(388332), // Rule ID 11308 //
     /* 388293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388306 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388310 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 388310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388315 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 388321 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388326 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388331 */   // GIR_Coverage, 11308,
     /* 388331 */   GIR_EraseRootFromParent_Done,
     /* 388332 */ // Label 7492: @388332
     /* 388332 */ GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(388377), // Rule ID 5831 //
     /* 388337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388351 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388355 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 388355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388360 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 388366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388371 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388376 */   // GIR_Coverage, 5831,
     /* 388376 */   GIR_EraseRootFromParent_Done,
     /* 388377 */ // Label 7493: @388377
     /* 388377 */ GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(388450), // Rule ID 11287 //
     /* 388382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388395 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388399 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388403 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 388407 */   // MIs[1] Operand 1
     /* 388407 */   // No operand predicates
     /* 388407 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388409 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 388409 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 388412 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388416 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388421 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 388427 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388432 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 388440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388442 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388445 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 388448 */   GIR_RootConstrainSelectedInstOperands,
     /* 388449 */   // GIR_Coverage, 11287,
     /* 388449 */   GIR_EraseRootFromParent_Done,
     /* 388450 */ // Label 7494: @388450
     /* 388450 */ GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(388498), // Rule ID 1929 //
     /* 388455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 388458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388472 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388476 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388480 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 388484 */   // MIs[1] Operand 1
     /* 388484 */   // No operand predicates
     /* 388484 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388486 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 388489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388491 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388493 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388496 */   GIR_RootConstrainSelectedInstOperands,
     /* 388497 */   // GIR_Coverage, 1929,
     /* 388497 */   GIR_EraseRootFromParent_Done,
     /* 388498 */ // Label 7495: @388498
     /* 388498 */ GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(388546), // Rule ID 1933 //
     /* 388503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388520 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388524 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388528 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 388532 */   // MIs[1] Operand 1
     /* 388532 */   // No operand predicates
     /* 388532 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388534 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 388537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388539 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388541 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388544 */   GIR_RootConstrainSelectedInstOperands,
     /* 388545 */   // GIR_Coverage, 1933,
     /* 388545 */   GIR_EraseRootFromParent_Done,
     /* 388546 */ // Label 7496: @388546
     /* 388546 */ GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(388591), // Rule ID 5834 //
     /* 388551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388573 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 388577 */   // MIs[1] Operand 1
     /* 388577 */   // No operand predicates
     /* 388577 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388579 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 388579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 388582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388584 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388586 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388589 */   GIR_RootConstrainSelectedInstOperands,
     /* 388590 */   // GIR_Coverage, 5834,
     /* 388590 */   GIR_EraseRootFromParent_Done,
     /* 388591 */ // Label 7497: @388591
     /* 388591 */ GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(388667), // Rule ID 11277 //
     /* 388596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388609 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388613 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388617 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388621 */   // MIs[1] Operand 1
     /* 388621 */   // No operand predicates
     /* 388621 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388623 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 388623 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388626 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388630 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388635 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388639 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388649 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 388656 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388661 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388666 */   // GIR_Coverage, 11277,
     /* 388666 */   GIR_EraseRootFromParent_Done,
     /* 388667 */ // Label 7498: @388667
     /* 388667 */ GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(388743), // Rule ID 11283 //
     /* 388672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388685 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388689 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388693 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388697 */   // MIs[1] Operand 1
     /* 388697 */   // No operand predicates
     /* 388697 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388699 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 388699 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388702 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388706 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388711 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388715 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388725 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 388732 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388737 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388742 */   // GIR_Coverage, 11283,
     /* 388742 */   GIR_EraseRootFromParent_Done,
     /* 388743 */ // Label 7499: @388743
     /* 388743 */ GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(388804), // Rule ID 11267 //
     /* 388748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388765 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 388765 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388768 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 388772 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388777 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388783 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388787 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388790 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 388795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388797 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388800 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388802 */   GIR_RootConstrainSelectedInstOperands,
     /* 388803 */   // GIR_Coverage, 11267,
     /* 388803 */   GIR_EraseRootFromParent_Done,
     /* 388804 */ // Label 7500: @388804
     /* 388804 */ GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(388865), // Rule ID 11273 //
     /* 388809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388826 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 388826 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388829 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 388833 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388838 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388844 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388848 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 388856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 388858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388861 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388863 */   GIR_RootConstrainSelectedInstOperands,
     /* 388864 */   // GIR_Coverage, 11273,
     /* 388864 */   GIR_EraseRootFromParent_Done,
     /* 388865 */ // Label 7501: @388865
     /* 388865 */ GIM_Reject,
     /* 388866 */ // Label 7450: @388866
     /* 388866 */ GIM_Reject,
     /* 388867 */ // Label 92: @388867
     /* 388867 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7509*/ GIMT_Encode4(391186),
     /* 388878 */ /*GILLT_nxv2s16*//*Label 7502*/ GIMT_Encode4(388918),
     /* 388882 */ /*GILLT_nxv2s32*//*Label 7503*/ GIMT_Encode4(389277),
     /* 388886 */ /*GILLT_nxv2s64*//*Label 7504*/ GIMT_Encode4(389579), GIMT_Encode4(0),
     /* 388894 */ /*GILLT_nxv4s16*//*Label 7505*/ GIMT_Encode4(389954),
     /* 388898 */ /*GILLT_nxv4s32*//*Label 7506*/ GIMT_Encode4(390256), GIMT_Encode4(0),
     /* 388906 */ /*GILLT_nxv8s16*//*Label 7507*/ GIMT_Encode4(390631), GIMT_Encode4(0),
     /* 388914 */ /*GILLT_nxv16s8*//*Label 7508*/ GIMT_Encode4(391042),
     /* 388918 */ // Label 7502: @388918
     /* 388918 */ GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(389276),
     /* 388923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 388926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388930 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(388994), // Rule ID 6065 //
     /* 388935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 388946 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 388950 */     // MIs[1] Operand 1
     /* 388950 */     // No operand predicates
     /* 388950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388952 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 388952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 388959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388964 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 388983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388988 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388993 */     // GIR_Coverage, 6065,
     /* 388993 */     GIR_EraseRootFromParent_Done,
     /* 388994 */   // Label 7511: @388994
     /* 388994 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(389051), // Rule ID 2675 //
     /* 388999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 389014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389031 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 389035 */     // MIs[2] Operand 1
     /* 389035 */     // No operand predicates
     /* 389035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389037 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 389037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389049 */     GIR_RootConstrainSelectedInstOperands,
     /* 389050 */     // GIR_Coverage, 2675,
     /* 389050 */     GIR_EraseRootFromParent_Done,
     /* 389051 */   // Label 7512: @389051
     /* 389051 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(389108), // Rule ID 2677 //
     /* 389056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 389071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389088 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 389092 */     // MIs[2] Operand 1
     /* 389092 */     // No operand predicates
     /* 389092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389094 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 389094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389106 */     GIR_RootConstrainSelectedInstOperands,
     /* 389107 */     // GIR_Coverage, 2677,
     /* 389107 */     GIR_EraseRootFromParent_Done,
     /* 389108 */   // Label 7513: @389108
     /* 389108 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(389165), // Rule ID 8407 //
     /* 389113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 389128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389145 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 389149 */     // MIs[2] Operand 1
     /* 389149 */     // No operand predicates
     /* 389149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389151 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 389151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389163 */     GIR_RootConstrainSelectedInstOperands,
     /* 389164 */     // GIR_Coverage, 8407,
     /* 389164 */     GIR_EraseRootFromParent_Done,
     /* 389165 */   // Label 7514: @389165
     /* 389165 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(389199), // Rule ID 8450 //
     /* 389170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389181 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 389185 */     // MIs[1] Operand 1
     /* 389185 */     // No operand predicates
     /* 389185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389187 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 389187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 389190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389192 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 389197 */     GIR_RootConstrainSelectedInstOperands,
     /* 389198 */     // GIR_Coverage, 8450,
     /* 389198 */     GIR_EraseRootFromParent_Done,
     /* 389199 */   // Label 7515: @389199
     /* 389199 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(389275), // Rule ID 8428 //
     /* 389204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 389211 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389211 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 389214 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 389218 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 389225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 389232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389237 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 389240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 389244 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 389247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 389262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389273 */     GIR_RootConstrainSelectedInstOperands,
     /* 389274 */     // GIR_Coverage, 8428,
     /* 389274 */     GIR_EraseRootFromParent_Done,
     /* 389275 */   // Label 7516: @389275
     /* 389275 */   GIM_Reject,
     /* 389276 */ // Label 7510: @389276
     /* 389276 */ GIM_Reject,
     /* 389277 */ // Label 7503: @389277
     /* 389277 */ GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(389578),
     /* 389282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 389285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389289 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(389353), // Rule ID 6063 //
     /* 389294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389305 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 389309 */     // MIs[1] Operand 1
     /* 389309 */     // No operand predicates
     /* 389309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389311 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389323 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389352 */     // GIR_Coverage, 6063,
     /* 389352 */     GIR_EraseRootFromParent_Done,
     /* 389353 */   // Label 7518: @389353
     /* 389353 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(389410), // Rule ID 8416 //
     /* 389358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 389373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389390 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 389394 */     // MIs[2] Operand 1
     /* 389394 */     // No operand predicates
     /* 389394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389396 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 389396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389408 */     GIR_RootConstrainSelectedInstOperands,
     /* 389409 */     // GIR_Coverage, 8416,
     /* 389409 */     GIR_EraseRootFromParent_Done,
     /* 389410 */   // Label 7519: @389410
     /* 389410 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(389467), // Rule ID 8425 //
     /* 389415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 389430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389447 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 389451 */     // MIs[2] Operand 1
     /* 389451 */     // No operand predicates
     /* 389451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389453 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 389453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389465 */     GIR_RootConstrainSelectedInstOperands,
     /* 389466 */     // GIR_Coverage, 8425,
     /* 389466 */     GIR_EraseRootFromParent_Done,
     /* 389467 */   // Label 7520: @389467
     /* 389467 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(389501), // Rule ID 8452 //
     /* 389472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389483 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 389487 */     // MIs[1] Operand 1
     /* 389487 */     // No operand predicates
     /* 389487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389489 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 389489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 389492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389494 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 389499 */     GIR_RootConstrainSelectedInstOperands,
     /* 389500 */     // GIR_Coverage, 8452,
     /* 389500 */     GIR_EraseRootFromParent_Done,
     /* 389501 */   // Label 7521: @389501
     /* 389501 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(389577), // Rule ID 8430 //
     /* 389506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389513 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389513 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 389516 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 389520 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 389527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 389534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389539 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 389542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 389546 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 389549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 389564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389575 */     GIR_RootConstrainSelectedInstOperands,
     /* 389576 */     // GIR_Coverage, 8430,
     /* 389576 */     GIR_EraseRootFromParent_Done,
     /* 389577 */   // Label 7522: @389577
     /* 389577 */   GIM_Reject,
     /* 389578 */ // Label 7517: @389578
     /* 389578 */ GIM_Reject,
     /* 389579 */ // Label 7504: @389579
     /* 389579 */ GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(389953),
     /* 389584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 389587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389591 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(389645), // Rule ID 6058 //
     /* 389596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 389603 */     // (splat_vector:{ *:[nxv2i64] } 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389615 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389634 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389644 */     // GIR_Coverage, 6058,
     /* 389644 */     GIR_EraseRootFromParent_Done,
     /* 389645 */   // Label 7524: @389645
     /* 389645 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(389709), // Rule ID 6062 //
     /* 389650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389661 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 389665 */     // MIs[1] Operand 1
     /* 389665 */     // No operand predicates
     /* 389665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389667 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389679 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389698 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389708 */     // GIR_Coverage, 6062,
     /* 389708 */     GIR_EraseRootFromParent_Done,
     /* 389709 */   // Label 7525: @389709
     /* 389709 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(389766), // Rule ID 2672 //
     /* 389714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 389729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389746 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 389750 */     // MIs[2] Operand 1
     /* 389750 */     // No operand predicates
     /* 389750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389752 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 389752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389764 */     GIR_RootConstrainSelectedInstOperands,
     /* 389765 */     // GIR_Coverage, 2672,
     /* 389765 */     GIR_EraseRootFromParent_Done,
     /* 389766 */   // Label 7526: @389766
     /* 389766 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(389823), // Rule ID 8422 //
     /* 389771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 389786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389803 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 389807 */     // MIs[2] Operand 1
     /* 389807 */     // No operand predicates
     /* 389807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389809 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 389809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389821 */     GIR_RootConstrainSelectedInstOperands,
     /* 389822 */     // GIR_Coverage, 8422,
     /* 389822 */     GIR_EraseRootFromParent_Done,
     /* 389823 */   // Label 7527: @389823
     /* 389823 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(389857), // Rule ID 8453 //
     /* 389828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389839 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 389843 */     // MIs[1] Operand 1
     /* 389843 */     // No operand predicates
     /* 389843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389845 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 389845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 389848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389850 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 389855 */     GIR_RootConstrainSelectedInstOperands,
     /* 389856 */     // GIR_Coverage, 8453,
     /* 389856 */     GIR_EraseRootFromParent_Done,
     /* 389857 */   // Label 7528: @389857
     /* 389857 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(389876), // Rule ID 2391 //
     /* 389862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 389869 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 389869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 389874 */     GIR_RootConstrainSelectedInstOperands,
     /* 389875 */     // GIR_Coverage, 2391,
     /* 389875 */     GIR_Done,
     /* 389876 */   // Label 7529: @389876
     /* 389876 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(389952), // Rule ID 8431 //
     /* 389881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389888 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389888 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 389891 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 389895 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 389902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 389909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389914 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 389917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 389921 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 389924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389950 */     GIR_RootConstrainSelectedInstOperands,
     /* 389951 */     // GIR_Coverage, 8431,
     /* 389951 */     GIR_EraseRootFromParent_Done,
     /* 389952 */   // Label 7530: @389952
     /* 389952 */   GIM_Reject,
     /* 389953 */ // Label 7523: @389953
     /* 389953 */ GIM_Reject,
     /* 389954 */ // Label 7505: @389954
     /* 389954 */ GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(390255),
     /* 389959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 389962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389966 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(390030), // Rule ID 6066 //
     /* 389971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389982 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 389986 */     // MIs[1] Operand 1
     /* 389986 */     // No operand predicates
     /* 389986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389988 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390000 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390029 */     // GIR_Coverage, 6066,
     /* 390029 */     GIR_EraseRootFromParent_Done,
     /* 390030 */   // Label 7532: @390030
     /* 390030 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(390087), // Rule ID 2676 //
     /* 390035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 390050 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390067 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 390071 */     // MIs[2] Operand 1
     /* 390071 */     // No operand predicates
     /* 390071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390073 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 390073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 390076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390085 */     GIR_RootConstrainSelectedInstOperands,
     /* 390086 */     // GIR_Coverage, 2676,
     /* 390086 */     GIR_EraseRootFromParent_Done,
     /* 390087 */   // Label 7533: @390087
     /* 390087 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(390144), // Rule ID 8410 //
     /* 390092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 390107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390124 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 390128 */     // MIs[2] Operand 1
     /* 390128 */     // No operand predicates
     /* 390128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390130 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 390130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 390133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390142 */     GIR_RootConstrainSelectedInstOperands,
     /* 390143 */     // GIR_Coverage, 8410,
     /* 390143 */     GIR_EraseRootFromParent_Done,
     /* 390144 */   // Label 7534: @390144
     /* 390144 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(390178), // Rule ID 8449 //
     /* 390149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390160 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 390164 */     // MIs[1] Operand 1
     /* 390164 */     // No operand predicates
     /* 390164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390166 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 390166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 390169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390171 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 390176 */     GIR_RootConstrainSelectedInstOperands,
     /* 390177 */     // GIR_Coverage, 8449,
     /* 390177 */     GIR_EraseRootFromParent_Done,
     /* 390178 */   // Label 7535: @390178
     /* 390178 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(390254), // Rule ID 8427 //
     /* 390183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390190 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390190 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 390193 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 390197 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 390204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 390211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390216 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 390219 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 390223 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 390226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 390244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390252 */     GIR_RootConstrainSelectedInstOperands,
     /* 390253 */     // GIR_Coverage, 8427,
     /* 390253 */     GIR_EraseRootFromParent_Done,
     /* 390254 */   // Label 7536: @390254
     /* 390254 */   GIM_Reject,
     /* 390255 */ // Label 7531: @390255
     /* 390255 */ GIM_Reject,
     /* 390256 */ // Label 7506: @390256
     /* 390256 */ GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(390630),
     /* 390261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390268 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(390322), // Rule ID 6059 //
     /* 390273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 390280 */     // (splat_vector:{ *:[nxv4i32] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390292 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390321 */     // GIR_Coverage, 6059,
     /* 390321 */     GIR_EraseRootFromParent_Done,
     /* 390322 */   // Label 7538: @390322
     /* 390322 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(390386), // Rule ID 6064 //
     /* 390327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390338 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 390342 */     // MIs[1] Operand 1
     /* 390342 */     // No operand predicates
     /* 390342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390344 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390356 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390385 */     // GIR_Coverage, 6064,
     /* 390385 */     GIR_EraseRootFromParent_Done,
     /* 390386 */   // Label 7539: @390386
     /* 390386 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(390443), // Rule ID 2669 //
     /* 390391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 390406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390423 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 390427 */     // MIs[2] Operand 1
     /* 390427 */     // No operand predicates
     /* 390427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390429 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 390429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 390432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390441 */     GIR_RootConstrainSelectedInstOperands,
     /* 390442 */     // GIR_Coverage, 2669,
     /* 390442 */     GIR_EraseRootFromParent_Done,
     /* 390443 */   // Label 7540: @390443
     /* 390443 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(390500), // Rule ID 8419 //
     /* 390448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 390463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390480 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 390484 */     // MIs[2] Operand 1
     /* 390484 */     // No operand predicates
     /* 390484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390486 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 390486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 390489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390498 */     GIR_RootConstrainSelectedInstOperands,
     /* 390499 */     // GIR_Coverage, 8419,
     /* 390499 */     GIR_EraseRootFromParent_Done,
     /* 390500 */   // Label 7541: @390500
     /* 390500 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(390534), // Rule ID 8451 //
     /* 390505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390516 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 390520 */     // MIs[1] Operand 1
     /* 390520 */     // No operand predicates
     /* 390520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390522 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 390522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 390525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390527 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 390532 */     GIR_RootConstrainSelectedInstOperands,
     /* 390533 */     // GIR_Coverage, 8451,
     /* 390533 */     GIR_EraseRootFromParent_Done,
     /* 390534 */   // Label 7542: @390534
     /* 390534 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(390553), // Rule ID 2390 //
     /* 390539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 390546 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 390546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 390551 */     GIR_RootConstrainSelectedInstOperands,
     /* 390552 */     // GIR_Coverage, 2390,
     /* 390552 */     GIR_Done,
     /* 390553 */   // Label 7543: @390553
     /* 390553 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(390629), // Rule ID 8429 //
     /* 390558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390565 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390565 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 390568 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 390572 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 390579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 390586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390591 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 390594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 390598 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 390619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390627 */     GIR_RootConstrainSelectedInstOperands,
     /* 390628 */     // GIR_Coverage, 8429,
     /* 390628 */     GIR_EraseRootFromParent_Done,
     /* 390629 */   // Label 7544: @390629
     /* 390629 */   GIM_Reject,
     /* 390630 */ // Label 7537: @390630
     /* 390630 */ GIM_Reject,
     /* 390631 */ // Label 7507: @390631
     /* 390631 */ GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(390692), // Rule ID 6060 //
     /* 390636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390646 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 390650 */   // (splat_vector:{ *:[nxv8i16] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390650 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390653 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390657 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390662 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390675 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390686 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390691 */   // GIR_Coverage, 6060,
     /* 390691 */   GIR_EraseRootFromParent_Done,
     /* 390692 */ // Label 7545: @390692
     /* 390692 */ GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(390763), // Rule ID 6067 //
     /* 390697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 390703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390707 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390711 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390715 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 390719 */   // MIs[1] Operand 1
     /* 390719 */   // No operand predicates
     /* 390719 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390721 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390721 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390724 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390728 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390733 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390746 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390752 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390757 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390762 */   // GIR_Coverage, 6067,
     /* 390762 */   GIR_EraseRootFromParent_Done,
     /* 390763 */ // Label 7546: @390763
     /* 390763 */ GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(390827), // Rule ID 2666 //
     /* 390768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390778 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390782 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390786 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 390790 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390794 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390799 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390803 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390807 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 390811 */   // MIs[2] Operand 1
     /* 390811 */   // No operand predicates
     /* 390811 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390813 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 390813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 390816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390818 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390822 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390825 */   GIR_RootConstrainSelectedInstOperands,
     /* 390826 */   // GIR_Coverage, 2666,
     /* 390826 */   GIR_EraseRootFromParent_Done,
     /* 390827 */ // Label 7547: @390827
     /* 390827 */ GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(390891), // Rule ID 8413 //
     /* 390832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 390838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390850 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 390854 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390858 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390863 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390867 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390871 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 390875 */   // MIs[2] Operand 1
     /* 390875 */   // No operand predicates
     /* 390875 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390877 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 390877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 390880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390882 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390886 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390889 */   GIR_RootConstrainSelectedInstOperands,
     /* 390890 */   // GIR_Coverage, 8413,
     /* 390890 */   GIR_EraseRootFromParent_Done,
     /* 390891 */ // Label 7548: @390891
     /* 390891 */ GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(390932), // Rule ID 8448 //
     /* 390896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 390902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390906 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390910 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390914 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 390918 */   // MIs[1] Operand 1
     /* 390918 */   // No operand predicates
     /* 390918 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390920 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 390920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 390923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390925 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 390930 */   GIR_RootConstrainSelectedInstOperands,
     /* 390931 */   // GIR_Coverage, 8448,
     /* 390931 */   GIR_EraseRootFromParent_Done,
     /* 390932 */ // Label 7549: @390932
     /* 390932 */ GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(390958), // Rule ID 2389 //
     /* 390937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 390951 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 390951 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 390956 */   GIR_RootConstrainSelectedInstOperands,
     /* 390957 */   // GIR_Coverage, 2389,
     /* 390957 */   GIR_Done,
     /* 390958 */ // Label 7550: @390958
     /* 390958 */ GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(391041), // Rule ID 8426 //
     /* 390963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 390969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390977 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390977 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 390980 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 390984 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 390991 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390994 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 390998 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391003 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 391006 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 391010 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391013 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391018 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391023 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 391031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391033 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391039 */   GIR_RootConstrainSelectedInstOperands,
     /* 391040 */   // GIR_Coverage, 8426,
     /* 391040 */   GIR_EraseRootFromParent_Done,
     /* 391041 */ // Label 7551: @391041
     /* 391041 */ GIM_Reject,
     /* 391042 */ // Label 7508: @391042
     /* 391042 */ GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(391185),
     /* 391047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391054 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(391108), // Rule ID 6061 //
     /* 391059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 391066 */     // (splat_vector:{ *:[nxv16i8] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391078 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391102 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391107 */     // GIR_Coverage, 6061,
     /* 391107 */     GIR_EraseRootFromParent_Done,
     /* 391108 */   // Label 7553: @391108
     /* 391108 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(391165), // Rule ID 2663 //
     /* 391113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 391128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391145 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 391149 */     // MIs[2] Operand 1
     /* 391149 */     // No operand predicates
     /* 391149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391151 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 391151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 391154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391163 */     GIR_RootConstrainSelectedInstOperands,
     /* 391164 */     // GIR_Coverage, 2663,
     /* 391164 */     GIR_EraseRootFromParent_Done,
     /* 391165 */   // Label 7554: @391165
     /* 391165 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(391184), // Rule ID 2388 //
     /* 391170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 391177 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 391177 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 391182 */     GIR_RootConstrainSelectedInstOperands,
     /* 391183 */     // GIR_Coverage, 2388,
     /* 391183 */     GIR_Done,
     /* 391184 */   // Label 7555: @391184
     /* 391184 */   GIM_Reject,
     /* 391185 */ // Label 7552: @391185
     /* 391185 */ GIM_Reject,
     /* 391186 */ // Label 7509: @391186
     /* 391186 */ GIM_Reject,
     /* 391187 */ // Label 93: @391187
     /* 391187 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7558*/ GIMT_Encode4(391338),
     /* 391198 */ /*GILLT_s32*//*Label 7556*/ GIMT_Encode4(391206),
     /* 391202 */ /*GILLT_s64*//*Label 7557*/ GIMT_Encode4(391272),
     /* 391206 */ // Label 7556: @391206
     /* 391206 */ GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(391271),
     /* 391211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391222 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(391237), // Rule ID 2321 //
     /* 391227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 391230 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 391235 */     GIR_RootConstrainSelectedInstOperands,
     /* 391236 */     // GIR_Coverage, 2321,
     /* 391236 */     GIR_Done,
     /* 391237 */   // Label 7560: @391237
     /* 391237 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(391270), // Rule ID 4005 //
     /* 391242 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 391242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 391245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 391249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 391263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391268 */     GIR_RootConstrainSelectedInstOperands,
     /* 391269 */     // GIR_Coverage, 4005,
     /* 391269 */     GIR_EraseRootFromParent_Done,
     /* 391270 */   // Label 7561: @391270
     /* 391270 */   GIM_Reject,
     /* 391271 */ // Label 7559: @391271
     /* 391271 */ GIM_Reject,
     /* 391272 */ // Label 7557: @391272
     /* 391272 */ GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(391337),
     /* 391277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391288 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(391303), // Rule ID 2322 //
     /* 391293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 391296 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 391301 */     GIR_RootConstrainSelectedInstOperands,
     /* 391302 */     // GIR_Coverage, 2322,
     /* 391302 */     GIR_Done,
     /* 391303 */   // Label 7563: @391303
     /* 391303 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(391336), // Rule ID 4006 //
     /* 391308 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 391308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 391311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 391315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391320 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 391329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391334 */     GIR_RootConstrainSelectedInstOperands,
     /* 391335 */     // GIR_Coverage, 4006,
     /* 391335 */     GIR_EraseRootFromParent_Done,
     /* 391336 */   // Label 7564: @391336
     /* 391336 */   GIM_Reject,
     /* 391337 */ // Label 7562: @391337
     /* 391337 */ GIM_Reject,
     /* 391338 */ // Label 7558: @391338
     /* 391338 */ GIM_Reject,
     /* 391339 */ // Label 94: @391339
     /* 391339 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7573*/ GIMT_Encode4(392012),
     /* 391350 */ /*GILLT_s32*//*Label 7565*/ GIMT_Encode4(391390),
     /* 391354 */ /*GILLT_s64*//*Label 7566*/ GIMT_Encode4(391620), GIMT_Encode4(0),
     /* 391362 */ /*GILLT_v2s32*//*Label 7567*/ GIMT_Encode4(391850), GIMT_Encode4(0),
     /* 391370 */ /*GILLT_v4s16*//*Label 7568*/ GIMT_Encode4(391877),
     /* 391374 */ /*GILLT_v4s32*//*Label 7569*/ GIMT_Encode4(391904),
     /* 391378 */ /*GILLT_v8s8*//*Label 7570*/ GIMT_Encode4(391931),
     /* 391382 */ /*GILLT_v8s16*//*Label 7571*/ GIMT_Encode4(391958),
     /* 391386 */ /*GILLT_v16s8*//*Label 7572*/ GIMT_Encode4(391985),
     /* 391390 */ // Label 7565: @391390
     /* 391390 */ GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(391619),
     /* 391395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391402 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(391502), // Rule ID 4007 //
     /* 391407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 391415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 391419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 391423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 391431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 391435 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391439 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391443 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 391447 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 391451 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 391455 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 391459 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 391463 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 391467 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391472 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 391476 */     // MIs[3] Rn
     /* 391476 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 391481 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 391485 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 391489 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 391491 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 391494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 391500 */     GIR_RootConstrainSelectedInstOperands,
     /* 391501 */     // GIR_Coverage, 4007,
     /* 391501 */     GIR_EraseRootFromParent_Done,
     /* 391502 */   // Label 7575: @391502
     /* 391502 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(391602), // Rule ID 13877 //
     /* 391507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 391515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 391519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 391523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 391531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 391535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391539 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391543 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 391547 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 391551 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 391555 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391560 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 391564 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 391568 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 391572 */     // MIs[4] Rn
     /* 391572 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 391577 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 391581 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 391585 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 391589 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 391591 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 391594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 391600 */     GIR_RootConstrainSelectedInstOperands,
     /* 391601 */     // GIR_Coverage, 13877,
     /* 391601 */     GIR_EraseRootFromParent_Done,
     /* 391602 */   // Label 7576: @391602
     /* 391602 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(391618), // Rule ID 180 //
     /* 391607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391611 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 391616 */     GIR_RootConstrainSelectedInstOperands,
     /* 391617 */     // GIR_Coverage, 180,
     /* 391617 */     GIR_Done,
     /* 391618 */   // Label 7577: @391618
     /* 391618 */   GIM_Reject,
     /* 391619 */ // Label 7574: @391619
     /* 391619 */ GIM_Reject,
     /* 391620 */ // Label 7566: @391620
     /* 391620 */ GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(391849),
     /* 391625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391632 */   GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(391732), // Rule ID 4008 //
     /* 391637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 391645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 391649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 391661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 391665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 391677 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 391681 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 391685 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 391689 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 391693 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 391697 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391702 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 391706 */     // MIs[3] Rn
     /* 391706 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 391711 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 391715 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 391719 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 391721 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 391724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 391730 */     GIR_RootConstrainSelectedInstOperands,
     /* 391731 */     // GIR_Coverage, 4008,
     /* 391731 */     GIR_EraseRootFromParent_Done,
     /* 391732 */   // Label 7579: @391732
     /* 391732 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(391832), // Rule ID 13878 //
     /* 391737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 391745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 391749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 391761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 391765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 391773 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 391777 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 391781 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 391785 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391790 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 391794 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 391798 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 391802 */     // MIs[4] Rn
     /* 391802 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 391807 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 391811 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 391815 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 391819 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 391821 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 391824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 391830 */     GIR_RootConstrainSelectedInstOperands,
     /* 391831 */     // GIR_Coverage, 13878,
     /* 391831 */     GIR_EraseRootFromParent_Done,
     /* 391832 */   // Label 7580: @391832
     /* 391832 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(391848), // Rule ID 181 //
     /* 391837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391841 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391841 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 391846 */     GIR_RootConstrainSelectedInstOperands,
     /* 391847 */     // GIR_Coverage, 181,
     /* 391847 */     GIR_Done,
     /* 391848 */   // Label 7581: @391848
     /* 391848 */   GIM_Reject,
     /* 391849 */ // Label 7578: @391849
     /* 391849 */ GIM_Reject,
     /* 391850 */ // Label 7567: @391850
     /* 391850 */ GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(391876), // Rule ID 720 //
     /* 391855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 391861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391869 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 391869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 391874 */   GIR_RootConstrainSelectedInstOperands,
     /* 391875 */   // GIR_Coverage, 720,
     /* 391875 */   GIR_Done,
     /* 391876 */ // Label 7582: @391876
     /* 391876 */ GIM_Reject,
     /* 391877 */ // Label 7568: @391877
     /* 391877 */ GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(391903), // Rule ID 718 //
     /* 391882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 391888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391896 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 391896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 391901 */   GIR_RootConstrainSelectedInstOperands,
     /* 391902 */   // GIR_Coverage, 718,
     /* 391902 */   GIR_Done,
     /* 391903 */ // Label 7583: @391903
     /* 391903 */ GIM_Reject,
     /* 391904 */ // Label 7569: @391904
     /* 391904 */ GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(391930), // Rule ID 721 //
     /* 391909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 391915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391923 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 391923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 391928 */   GIR_RootConstrainSelectedInstOperands,
     /* 391929 */   // GIR_Coverage, 721,
     /* 391929 */   GIR_Done,
     /* 391930 */ // Label 7584: @391930
     /* 391930 */ GIM_Reject,
     /* 391931 */ // Label 7570: @391931
     /* 391931 */ GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(391957), // Rule ID 716 //
     /* 391936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 391942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 391950 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 391950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 391955 */   GIR_RootConstrainSelectedInstOperands,
     /* 391956 */   // GIR_Coverage, 716,
     /* 391956 */   GIR_Done,
     /* 391957 */ // Label 7585: @391957
     /* 391957 */ GIM_Reject,
     /* 391958 */ // Label 7571: @391958
     /* 391958 */ GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(391984), // Rule ID 719 //
     /* 391963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391977 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 391977 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 391982 */   GIR_RootConstrainSelectedInstOperands,
     /* 391983 */   // GIR_Coverage, 719,
     /* 391983 */   GIR_Done,
     /* 391984 */ // Label 7586: @391984
     /* 391984 */ GIM_Reject,
     /* 391985 */ // Label 7572: @391985
     /* 391985 */ GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(392011), // Rule ID 717 //
     /* 391990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 391996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392004 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 392004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 392009 */   GIR_RootConstrainSelectedInstOperands,
     /* 392010 */   // GIR_Coverage, 717,
     /* 392010 */   GIR_Done,
     /* 392011 */ // Label 7587: @392011
     /* 392011 */ GIM_Reject,
     /* 392012 */ // Label 7573: @392012
     /* 392012 */ GIM_Reject,
     /* 392013 */ // Label 95: @392013
     /* 392013 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7592*/ GIMT_Encode4(392172),
     /* 392024 */ /*GILLT_s32*//*Label 7588*/ GIMT_Encode4(392064),
     /* 392028 */ /*GILLT_s64*//*Label 7589*/ GIMT_Encode4(392091), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 392052 */ /*GILLT_v8s8*//*Label 7590*/ GIMT_Encode4(392118), GIMT_Encode4(0),
     /* 392060 */ /*GILLT_v16s8*//*Label 7591*/ GIMT_Encode4(392145),
     /* 392064 */ // Label 7588: @392064
     /* 392064 */ GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(392090), // Rule ID 2319 //
     /* 392069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 392072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392083 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392083 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 392088 */   GIR_RootConstrainSelectedInstOperands,
     /* 392089 */   // GIR_Coverage, 2319,
     /* 392089 */   GIR_Done,
     /* 392090 */ // Label 7593: @392090
     /* 392090 */ GIM_Reject,
     /* 392091 */ // Label 7589: @392091
     /* 392091 */ GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(392117), // Rule ID 2320 //
     /* 392096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 392099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392110 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 392110 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 392115 */   GIR_RootConstrainSelectedInstOperands,
     /* 392116 */   // GIR_Coverage, 2320,
     /* 392116 */   GIR_Done,
     /* 392117 */ // Label 7594: @392117
     /* 392117 */ GIM_Reject,
     /* 392118 */ // Label 7590: @392118
     /* 392118 */ GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(392144), // Rule ID 764 //
     /* 392123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 392129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392137 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 392137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 392142 */   GIR_RootConstrainSelectedInstOperands,
     /* 392143 */   // GIR_Coverage, 764,
     /* 392143 */   GIR_Done,
     /* 392144 */ // Label 7595: @392144
     /* 392144 */ GIM_Reject,
     /* 392145 */ // Label 7591: @392145
     /* 392145 */ GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(392171), // Rule ID 765 //
     /* 392150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 392156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392164 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 392164 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 392169 */   GIR_RootConstrainSelectedInstOperands,
     /* 392170 */   // GIR_Coverage, 765,
     /* 392170 */   GIR_Done,
     /* 392171 */ // Label 7596: @392171
     /* 392171 */ GIM_Reject,
     /* 392172 */ // Label 7592: @392172
     /* 392172 */ GIM_Reject,
     /* 392173 */ // Label 96: @392173
     /* 392173 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7604*/ GIMT_Encode4(392486),
     /* 392184 */ /*GILLT_s32*//*Label 7597*/ GIMT_Encode4(392220),
     /* 392188 */ /*GILLT_s64*//*Label 7598*/ GIMT_Encode4(392293), GIMT_Encode4(0),
     /* 392196 */ /*GILLT_v2s32*//*Label 7599*/ GIMT_Encode4(392366),
     /* 392200 */ /*GILLT_v2s64*//*Label 7600*/ GIMT_Encode4(392390),
     /* 392204 */ /*GILLT_v4s16*//*Label 7601*/ GIMT_Encode4(392414),
     /* 392208 */ /*GILLT_v4s32*//*Label 7602*/ GIMT_Encode4(392438), GIMT_Encode4(0),
     /* 392216 */ /*GILLT_v8s16*//*Label 7603*/ GIMT_Encode4(392462),
     /* 392220 */ // Label 7597: @392220
     /* 392220 */ GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(392292),
     /* 392225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392232 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(392275), // Rule ID 4011 //
     /* 392237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 392245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 392249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392258 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 392262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392264 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 392267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392273 */     GIR_RootConstrainSelectedInstOperands,
     /* 392274 */     // GIR_Coverage, 4011,
     /* 392274 */     GIR_EraseRootFromParent_Done,
     /* 392275 */   // Label 7606: @392275
     /* 392275 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(392291), // Rule ID 185 //
     /* 392280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392284 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 392289 */     GIR_RootConstrainSelectedInstOperands,
     /* 392290 */     // GIR_Coverage, 185,
     /* 392290 */     GIR_Done,
     /* 392291 */   // Label 7607: @392291
     /* 392291 */   GIM_Reject,
     /* 392292 */ // Label 7605: @392292
     /* 392292 */ GIM_Reject,
     /* 392293 */ // Label 7598: @392293
     /* 392293 */ GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(392365),
     /* 392298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392305 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(392348), // Rule ID 4012 //
     /* 392310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 392318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 392322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392331 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 392335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392337 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 392337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 392340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392346 */     GIR_RootConstrainSelectedInstOperands,
     /* 392347 */     // GIR_Coverage, 4012,
     /* 392347 */     GIR_EraseRootFromParent_Done,
     /* 392348 */   // Label 7609: @392348
     /* 392348 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(392364), // Rule ID 186 //
     /* 392353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392357 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 392357 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 392362 */     GIR_RootConstrainSelectedInstOperands,
     /* 392363 */     // GIR_Coverage, 186,
     /* 392363 */     GIR_Done,
     /* 392364 */   // Label 7610: @392364
     /* 392364 */   GIM_Reject,
     /* 392365 */ // Label 7608: @392365
     /* 392365 */ GIM_Reject,
     /* 392366 */ // Label 7599: @392366
     /* 392366 */ GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(392389), // Rule ID 5024 //
     /* 392371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392382 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 392382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 392387 */   GIR_RootConstrainSelectedInstOperands,
     /* 392388 */   // GIR_Coverage, 5024,
     /* 392388 */   GIR_Done,
     /* 392389 */ // Label 7611: @392389
     /* 392389 */ GIM_Reject,
     /* 392390 */ // Label 7600: @392390
     /* 392390 */ GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(392413), // Rule ID 5026 //
     /* 392395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392406 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 392406 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 392411 */   GIR_RootConstrainSelectedInstOperands,
     /* 392412 */   // GIR_Coverage, 5026,
     /* 392412 */   GIR_Done,
     /* 392413 */ // Label 7612: @392413
     /* 392413 */ GIM_Reject,
     /* 392414 */ // Label 7601: @392414
     /* 392414 */ GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(392437), // Rule ID 5022 //
     /* 392419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392430 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 392430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 392435 */   GIR_RootConstrainSelectedInstOperands,
     /* 392436 */   // GIR_Coverage, 5022,
     /* 392436 */   GIR_Done,
     /* 392437 */ // Label 7613: @392437
     /* 392437 */ GIM_Reject,
     /* 392438 */ // Label 7602: @392438
     /* 392438 */ GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(392461), // Rule ID 5025 //
     /* 392443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392454 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 392454 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 392459 */   GIR_RootConstrainSelectedInstOperands,
     /* 392460 */   // GIR_Coverage, 5025,
     /* 392460 */   GIR_Done,
     /* 392461 */ // Label 7614: @392461
     /* 392461 */ GIM_Reject,
     /* 392462 */ // Label 7603: @392462
     /* 392462 */ GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(392485), // Rule ID 5023 //
     /* 392467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392478 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 392478 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 392483 */   GIR_RootConstrainSelectedInstOperands,
     /* 392484 */   // GIR_Coverage, 5023,
     /* 392484 */   GIR_Done,
     /* 392485 */ // Label 7615: @392485
     /* 392485 */ GIM_Reject,
     /* 392486 */ // Label 7604: @392486
     /* 392486 */ GIM_Reject,
     /* 392487 */ // Label 97: @392487
     /* 392487 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7620*/ GIMT_Encode4(392640),
     /* 392498 */ /*GILLT_s32*//*Label 7616*/ GIMT_Encode4(392538),
     /* 392502 */ /*GILLT_s64*//*Label 7617*/ GIMT_Encode4(392562), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 392526 */ /*GILLT_v8s8*//*Label 7618*/ GIMT_Encode4(392586), GIMT_Encode4(0),
     /* 392534 */ /*GILLT_v16s8*//*Label 7619*/ GIMT_Encode4(392613),
     /* 392538 */ // Label 7616: @392538
     /* 392538 */ GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(392561), // Rule ID 182 //
     /* 392543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392554 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 392559 */   GIR_RootConstrainSelectedInstOperands,
     /* 392560 */   // GIR_Coverage, 182,
     /* 392560 */   GIR_Done,
     /* 392561 */ // Label 7621: @392561
     /* 392561 */ GIM_Reject,
     /* 392562 */ // Label 7617: @392562
     /* 392562 */ GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(392585), // Rule ID 183 //
     /* 392567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392578 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 392578 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 392583 */   GIR_RootConstrainSelectedInstOperands,
     /* 392584 */   // GIR_Coverage, 183,
     /* 392584 */   GIR_Done,
     /* 392585 */ // Label 7622: @392585
     /* 392585 */ GIM_Reject,
     /* 392586 */ // Label 7618: @392586
     /* 392586 */ GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(392612), // Rule ID 974 //
     /* 392591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 392597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392605 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 392605 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 392610 */   GIR_RootConstrainSelectedInstOperands,
     /* 392611 */   // GIR_Coverage, 974,
     /* 392611 */   GIR_Done,
     /* 392612 */ // Label 7623: @392612
     /* 392612 */ GIM_Reject,
     /* 392613 */ // Label 7619: @392613
     /* 392613 */ GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(392639), // Rule ID 975 //
     /* 392618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 392624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392632 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 392632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 392637 */   GIR_RootConstrainSelectedInstOperands,
     /* 392638 */   // GIR_Coverage, 975,
     /* 392638 */   GIR_Done,
     /* 392639 */ // Label 7624: @392639
     /* 392639 */ GIM_Reject,
     /* 392640 */ // Label 7620: @392640
     /* 392640 */ GIM_Reject,
     /* 392641 */ // Label 98: @392641
     /* 392641 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7633*/ GIMT_Encode4(393131),
     /* 392652 */ /*GILLT_s16*//*Label 7625*/ GIMT_Encode4(392692),
     /* 392656 */ /*GILLT_s32*//*Label 7626*/ GIMT_Encode4(392723),
     /* 392660 */ /*GILLT_s64*//*Label 7627*/ GIMT_Encode4(392754), GIMT_Encode4(0),
     /* 392668 */ /*GILLT_v2s32*//*Label 7628*/ GIMT_Encode4(392785),
     /* 392672 */ /*GILLT_v2s64*//*Label 7629*/ GIMT_Encode4(392816),
     /* 392676 */ /*GILLT_v4s16*//*Label 7630*/ GIMT_Encode4(392847),
     /* 392680 */ /*GILLT_v4s32*//*Label 7631*/ GIMT_Encode4(392878), GIMT_Encode4(0),
     /* 392688 */ /*GILLT_v8s16*//*Label 7632*/ GIMT_Encode4(392909),
     /* 392692 */ // Label 7625: @392692
     /* 392692 */ GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(392722), // Rule ID 552 //
     /* 392697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 392700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392711 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 392711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 392716 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392720 */   GIR_RootConstrainSelectedInstOperands,
     /* 392721 */   // GIR_Coverage, 552,
     /* 392721 */   GIR_Done,
     /* 392722 */ // Label 7634: @392722
     /* 392722 */ GIM_Reject,
     /* 392723 */ // Label 7626: @392723
     /* 392723 */ GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(392753), // Rule ID 554 //
     /* 392728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 392731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392742 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 392742 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 392747 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392751 */   GIR_RootConstrainSelectedInstOperands,
     /* 392752 */   // GIR_Coverage, 554,
     /* 392752 */   GIR_Done,
     /* 392753 */ // Label 7635: @392753
     /* 392753 */ GIM_Reject,
     /* 392754 */ // Label 7627: @392754
     /* 392754 */ GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(392784), // Rule ID 556 //
     /* 392759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 392762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392773 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 392773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 392778 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392782 */   GIR_RootConstrainSelectedInstOperands,
     /* 392783 */   // GIR_Coverage, 556,
     /* 392783 */   GIR_Done,
     /* 392784 */ // Label 7636: @392784
     /* 392784 */ GIM_Reject,
     /* 392785 */ // Label 7628: @392785
     /* 392785 */ GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(392815), // Rule ID 913 //
     /* 392790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392804 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 392809 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392813 */   GIR_RootConstrainSelectedInstOperands,
     /* 392814 */   // GIR_Coverage, 913,
     /* 392814 */   GIR_Done,
     /* 392815 */ // Label 7637: @392815
     /* 392815 */ GIM_Reject,
     /* 392816 */ // Label 7629: @392816
     /* 392816 */ GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(392846), // Rule ID 917 //
     /* 392821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392835 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 392840 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392844 */   GIR_RootConstrainSelectedInstOperands,
     /* 392845 */   // GIR_Coverage, 917,
     /* 392845 */   GIR_Done,
     /* 392846 */ // Label 7638: @392846
     /* 392846 */ GIM_Reject,
     /* 392847 */ // Label 7630: @392847
     /* 392847 */ GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(392877), // Rule ID 909 //
     /* 392852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392866 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392866 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 392871 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392875 */   GIR_RootConstrainSelectedInstOperands,
     /* 392876 */   // GIR_Coverage, 909,
     /* 392876 */   GIR_Done,
     /* 392877 */ // Label 7639: @392877
     /* 392877 */ GIM_Reject,
     /* 392878 */ // Label 7631: @392878
     /* 392878 */ GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(392908), // Rule ID 915 //
     /* 392883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392897 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392897 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 392902 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392906 */   GIR_RootConstrainSelectedInstOperands,
     /* 392907 */   // GIR_Coverage, 915,
     /* 392907 */   GIR_Done,
     /* 392908 */ // Label 7640: @392908
     /* 392908 */ GIM_Reject,
     /* 392909 */ // Label 7632: @392909
     /* 392909 */ GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(393130),
     /* 392914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392925 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(392944), // Rule ID 911 //
     /* 392930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392933 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 392938 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392942 */     GIR_RootConstrainSelectedInstOperands,
     /* 392943 */     // GIR_Coverage, 911,
     /* 392943 */     GIR_Done,
     /* 392944 */   // Label 7642: @392944
     /* 392944 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(393129), // Rule ID 7044 //
     /* 392949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 392952 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 392952 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 392955 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 392959 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392964 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 392970 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 392973 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 392977 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392982 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 392985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 392987 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 392990 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 392994 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392999 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 393005 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393010 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393015 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 393018 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 393022 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393027 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 393030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 393032 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 393035 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 393039 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393044 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 393047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 393049 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 393052 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 393056 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393061 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 393064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 393066 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 393069 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 393073 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 393080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 393087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393092 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 393095 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 393098 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 393101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393106 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393111 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 393119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 393127 */     GIR_RootConstrainSelectedInstOperands,
     /* 393128 */     // GIR_Coverage, 7044,
     /* 393128 */     GIR_EraseRootFromParent_Done,
     /* 393129 */   // Label 7643: @393129
     /* 393129 */   GIM_Reject,
     /* 393130 */ // Label 7641: @393130
     /* 393130 */ GIM_Reject,
     /* 393131 */ // Label 7633: @393131
     /* 393131 */ GIM_Reject,
     /* 393132 */ // Label 99: @393132
     /* 393132 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7652*/ GIMT_Encode4(393431),
     /* 393143 */ /*GILLT_s16*//*Label 7644*/ GIMT_Encode4(393183),
     /* 393147 */ /*GILLT_s32*//*Label 7645*/ GIMT_Encode4(393214),
     /* 393151 */ /*GILLT_s64*//*Label 7646*/ GIMT_Encode4(393245), GIMT_Encode4(0),
     /* 393159 */ /*GILLT_v2s32*//*Label 7647*/ GIMT_Encode4(393276),
     /* 393163 */ /*GILLT_v2s64*//*Label 7648*/ GIMT_Encode4(393307),
     /* 393167 */ /*GILLT_v4s16*//*Label 7649*/ GIMT_Encode4(393338),
     /* 393171 */ /*GILLT_v4s32*//*Label 7650*/ GIMT_Encode4(393369), GIMT_Encode4(0),
     /* 393179 */ /*GILLT_v8s16*//*Label 7651*/ GIMT_Encode4(393400),
     /* 393183 */ // Label 7644: @393183
     /* 393183 */ GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(393213), // Rule ID 570 //
     /* 393188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 393191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393202 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 393202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 393207 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393211 */   GIR_RootConstrainSelectedInstOperands,
     /* 393212 */   // GIR_Coverage, 570,
     /* 393212 */   GIR_Done,
     /* 393213 */ // Label 7653: @393213
     /* 393213 */ GIM_Reject,
     /* 393214 */ // Label 7645: @393214
     /* 393214 */ GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(393244), // Rule ID 572 //
     /* 393219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393233 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 393233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 393238 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393242 */   GIR_RootConstrainSelectedInstOperands,
     /* 393243 */   // GIR_Coverage, 572,
     /* 393243 */   GIR_Done,
     /* 393244 */ // Label 7654: @393244
     /* 393244 */ GIM_Reject,
     /* 393245 */ // Label 7646: @393245
     /* 393245 */ GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(393275), // Rule ID 574 //
     /* 393250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393264 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 393264 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 393269 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393273 */   GIR_RootConstrainSelectedInstOperands,
     /* 393274 */   // GIR_Coverage, 574,
     /* 393274 */   GIR_Done,
     /* 393275 */ // Label 7655: @393275
     /* 393275 */ GIM_Reject,
     /* 393276 */ // Label 7647: @393276
     /* 393276 */ GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(393306), // Rule ID 960 //
     /* 393281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393295 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 393300 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393304 */   GIR_RootConstrainSelectedInstOperands,
     /* 393305 */   // GIR_Coverage, 960,
     /* 393305 */   GIR_Done,
     /* 393306 */ // Label 7656: @393306
     /* 393306 */ GIM_Reject,
     /* 393307 */ // Label 7648: @393307
     /* 393307 */ GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(393337), // Rule ID 964 //
     /* 393312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393326 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393326 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 393331 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393335 */   GIR_RootConstrainSelectedInstOperands,
     /* 393336 */   // GIR_Coverage, 964,
     /* 393336 */   GIR_Done,
     /* 393337 */ // Label 7657: @393337
     /* 393337 */ GIM_Reject,
     /* 393338 */ // Label 7649: @393338
     /* 393338 */ GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(393368), // Rule ID 956 //
     /* 393343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393357 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 393362 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393366 */   GIR_RootConstrainSelectedInstOperands,
     /* 393367 */   // GIR_Coverage, 956,
     /* 393367 */   GIR_Done,
     /* 393368 */ // Label 7658: @393368
     /* 393368 */ GIM_Reject,
     /* 393369 */ // Label 7650: @393369
     /* 393369 */ GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(393399), // Rule ID 962 //
     /* 393374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393388 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393388 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 393393 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393397 */   GIR_RootConstrainSelectedInstOperands,
     /* 393398 */   // GIR_Coverage, 962,
     /* 393398 */   GIR_Done,
     /* 393399 */ // Label 7659: @393399
     /* 393399 */ GIM_Reject,
     /* 393400 */ // Label 7651: @393400
     /* 393400 */ GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(393430), // Rule ID 958 //
     /* 393405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393419 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 393424 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393428 */   GIR_RootConstrainSelectedInstOperands,
     /* 393429 */   // GIR_Coverage, 958,
     /* 393429 */   GIR_Done,
     /* 393430 */ // Label 7660: @393430
     /* 393430 */ GIM_Reject,
     /* 393431 */ // Label 7652: @393431
     /* 393431 */ GIM_Reject,
     /* 393432 */ // Label 100: @393432
     /* 393432 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7669*/ GIMT_Encode4(393922),
     /* 393443 */ /*GILLT_s16*//*Label 7661*/ GIMT_Encode4(393483),
     /* 393447 */ /*GILLT_s32*//*Label 7662*/ GIMT_Encode4(393514),
     /* 393451 */ /*GILLT_s64*//*Label 7663*/ GIMT_Encode4(393545), GIMT_Encode4(0),
     /* 393459 */ /*GILLT_v2s32*//*Label 7664*/ GIMT_Encode4(393576),
     /* 393463 */ /*GILLT_v2s64*//*Label 7665*/ GIMT_Encode4(393607),
     /* 393467 */ /*GILLT_v4s16*//*Label 7666*/ GIMT_Encode4(393638),
     /* 393471 */ /*GILLT_v4s32*//*Label 7667*/ GIMT_Encode4(393669), GIMT_Encode4(0),
     /* 393479 */ /*GILLT_v8s16*//*Label 7668*/ GIMT_Encode4(393700),
     /* 393483 */ // Label 7661: @393483
     /* 393483 */ GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(393513), // Rule ID 540 //
     /* 393488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 393491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393502 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 393502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 393507 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393511 */   GIR_RootConstrainSelectedInstOperands,
     /* 393512 */   // GIR_Coverage, 540,
     /* 393512 */   GIR_Done,
     /* 393513 */ // Label 7670: @393513
     /* 393513 */ GIM_Reject,
     /* 393514 */ // Label 7662: @393514
     /* 393514 */ GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(393544), // Rule ID 542 //
     /* 393519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393533 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 393533 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 393538 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393542 */   GIR_RootConstrainSelectedInstOperands,
     /* 393543 */   // GIR_Coverage, 542,
     /* 393543 */   GIR_Done,
     /* 393544 */ // Label 7671: @393544
     /* 393544 */ GIM_Reject,
     /* 393545 */ // Label 7663: @393545
     /* 393545 */ GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(393575), // Rule ID 544 //
     /* 393550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393564 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 393564 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 393569 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393573 */   GIR_RootConstrainSelectedInstOperands,
     /* 393574 */   // GIR_Coverage, 544,
     /* 393574 */   GIR_Done,
     /* 393575 */ // Label 7672: @393575
     /* 393575 */ GIM_Reject,
     /* 393576 */ // Label 7664: @393576
     /* 393576 */ GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(393606), // Rule ID 893 //
     /* 393581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393595 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393595 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 393600 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393604 */   GIR_RootConstrainSelectedInstOperands,
     /* 393605 */   // GIR_Coverage, 893,
     /* 393605 */   GIR_Done,
     /* 393606 */ // Label 7673: @393606
     /* 393606 */ GIM_Reject,
     /* 393607 */ // Label 7665: @393607
     /* 393607 */ GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(393637), // Rule ID 897 //
     /* 393612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393626 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 393631 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393635 */   GIR_RootConstrainSelectedInstOperands,
     /* 393636 */   // GIR_Coverage, 897,
     /* 393636 */   GIR_Done,
     /* 393637 */ // Label 7674: @393637
     /* 393637 */ GIM_Reject,
     /* 393638 */ // Label 7666: @393638
     /* 393638 */ GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(393668), // Rule ID 889 //
     /* 393643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393657 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 393662 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393666 */   GIR_RootConstrainSelectedInstOperands,
     /* 393667 */   // GIR_Coverage, 889,
     /* 393667 */   GIR_Done,
     /* 393668 */ // Label 7675: @393668
     /* 393668 */ GIM_Reject,
     /* 393669 */ // Label 7667: @393669
     /* 393669 */ GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(393699), // Rule ID 895 //
     /* 393674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393688 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 393693 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393697 */   GIR_RootConstrainSelectedInstOperands,
     /* 393698 */   // GIR_Coverage, 895,
     /* 393698 */   GIR_Done,
     /* 393699 */ // Label 7676: @393699
     /* 393699 */ GIM_Reject,
     /* 393700 */ // Label 7668: @393700
     /* 393700 */ GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(393921),
     /* 393705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393716 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(393735), // Rule ID 891 //
     /* 393721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393724 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 393729 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393733 */     GIR_RootConstrainSelectedInstOperands,
     /* 393734 */     // GIR_Coverage, 891,
     /* 393734 */     GIR_Done,
     /* 393735 */   // Label 7678: @393735
     /* 393735 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(393920), // Rule ID 7046 //
     /* 393740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 393743 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 393743 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 393746 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 393750 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393755 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 393761 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 393764 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 393768 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393773 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 393776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 393778 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 393781 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 393785 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393790 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 393796 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393801 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393806 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 393809 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 393813 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393818 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 393821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 393823 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 393826 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 393830 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393835 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 393838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 393840 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 393843 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 393847 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393852 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 393855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 393857 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 393860 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 393864 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 393871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 393878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393883 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 393886 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 393889 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 393892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 393910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 393918 */     GIR_RootConstrainSelectedInstOperands,
     /* 393919 */     // GIR_Coverage, 7046,
     /* 393919 */     GIR_EraseRootFromParent_Done,
     /* 393920 */   // Label 7679: @393920
     /* 393920 */   GIM_Reject,
     /* 393921 */ // Label 7677: @393921
     /* 393921 */ GIM_Reject,
     /* 393922 */ // Label 7669: @393922
     /* 393922 */ GIM_Reject,
     /* 393923 */ // Label 101: @393923
     /* 393923 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7688*/ GIMT_Encode4(394413),
     /* 393934 */ /*GILLT_s16*//*Label 7680*/ GIMT_Encode4(393974),
     /* 393938 */ /*GILLT_s32*//*Label 7681*/ GIMT_Encode4(394005),
     /* 393942 */ /*GILLT_s64*//*Label 7682*/ GIMT_Encode4(394036), GIMT_Encode4(0),
     /* 393950 */ /*GILLT_v2s32*//*Label 7683*/ GIMT_Encode4(394067),
     /* 393954 */ /*GILLT_v2s64*//*Label 7684*/ GIMT_Encode4(394098),
     /* 393958 */ /*GILLT_v4s16*//*Label 7685*/ GIMT_Encode4(394129),
     /* 393962 */ /*GILLT_v4s32*//*Label 7686*/ GIMT_Encode4(394160), GIMT_Encode4(0),
     /* 393970 */ /*GILLT_v8s16*//*Label 7687*/ GIMT_Encode4(394191),
     /* 393974 */ // Label 7680: @393974
     /* 393974 */ GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(394004), // Rule ID 558 //
     /* 393979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 393982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393993 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 393993 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 393998 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394002 */   GIR_RootConstrainSelectedInstOperands,
     /* 394003 */   // GIR_Coverage, 558,
     /* 394003 */   GIR_Done,
     /* 394004 */ // Label 7689: @394004
     /* 394004 */ GIM_Reject,
     /* 394005 */ // Label 7681: @394005
     /* 394005 */ GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(394035), // Rule ID 560 //
     /* 394010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394024 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 394024 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 394029 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394033 */   GIR_RootConstrainSelectedInstOperands,
     /* 394034 */   // GIR_Coverage, 560,
     /* 394034 */   GIR_Done,
     /* 394035 */ // Label 7690: @394035
     /* 394035 */ GIM_Reject,
     /* 394036 */ // Label 7682: @394036
     /* 394036 */ GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(394066), // Rule ID 562 //
     /* 394041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394055 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 394055 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 394060 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394064 */   GIR_RootConstrainSelectedInstOperands,
     /* 394065 */   // GIR_Coverage, 562,
     /* 394065 */   GIR_Done,
     /* 394066 */ // Label 7691: @394066
     /* 394066 */ GIM_Reject,
     /* 394067 */ // Label 7683: @394067
     /* 394067 */ GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(394097), // Rule ID 923 //
     /* 394072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394086 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 394086 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 394091 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394095 */   GIR_RootConstrainSelectedInstOperands,
     /* 394096 */   // GIR_Coverage, 923,
     /* 394096 */   GIR_Done,
     /* 394097 */ // Label 7692: @394097
     /* 394097 */ GIM_Reject,
     /* 394098 */ // Label 7684: @394098
     /* 394098 */ GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(394128), // Rule ID 927 //
     /* 394103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394117 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 394117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 394122 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394126 */   GIR_RootConstrainSelectedInstOperands,
     /* 394127 */   // GIR_Coverage, 927,
     /* 394127 */   GIR_Done,
     /* 394128 */ // Label 7693: @394128
     /* 394128 */ GIM_Reject,
     /* 394129 */ // Label 7685: @394129
     /* 394129 */ GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(394159), // Rule ID 919 //
     /* 394134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394148 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 394148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 394153 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394157 */   GIR_RootConstrainSelectedInstOperands,
     /* 394158 */   // GIR_Coverage, 919,
     /* 394158 */   GIR_Done,
     /* 394159 */ // Label 7694: @394159
     /* 394159 */ GIM_Reject,
     /* 394160 */ // Label 7686: @394160
     /* 394160 */ GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(394190), // Rule ID 925 //
     /* 394165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394179 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 394179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 394184 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394188 */   GIR_RootConstrainSelectedInstOperands,
     /* 394189 */   // GIR_Coverage, 925,
     /* 394189 */   GIR_Done,
     /* 394190 */ // Label 7695: @394190
     /* 394190 */ GIM_Reject,
     /* 394191 */ // Label 7687: @394191
     /* 394191 */ GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(394412),
     /* 394196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394207 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(394226), // Rule ID 921 //
     /* 394212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394215 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 394215 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 394220 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394224 */     GIR_RootConstrainSelectedInstOperands,
     /* 394225 */     // GIR_Coverage, 921,
     /* 394225 */     GIR_Done,
     /* 394226 */   // Label 7697: @394226
     /* 394226 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(394411), // Rule ID 7054 //
     /* 394231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 394234 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 394234 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 394237 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 394241 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394246 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 394252 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 394255 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 394259 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394264 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 394267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 394269 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 394272 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394276 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394281 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394287 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394292 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394297 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 394300 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 394304 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394309 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 394312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 394314 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 394317 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 394321 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394326 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 394329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 394331 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 394334 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 394338 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394343 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 394346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 394348 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 394351 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 394355 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 394362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 394369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394374 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 394377 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 394380 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 394383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 394401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 394409 */     GIR_RootConstrainSelectedInstOperands,
     /* 394410 */     // GIR_Coverage, 7054,
     /* 394410 */     GIR_EraseRootFromParent_Done,
     /* 394411 */   // Label 7698: @394411
     /* 394411 */   GIM_Reject,
     /* 394412 */ // Label 7696: @394412
     /* 394412 */ GIM_Reject,
     /* 394413 */ // Label 7688: @394413
     /* 394413 */ GIM_Reject,
     /* 394414 */ // Label 102: @394414
     /* 394414 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7707*/ GIMT_Encode4(394904),
     /* 394425 */ /*GILLT_s16*//*Label 7699*/ GIMT_Encode4(394465),
     /* 394429 */ /*GILLT_s32*//*Label 7700*/ GIMT_Encode4(394496),
     /* 394433 */ /*GILLT_s64*//*Label 7701*/ GIMT_Encode4(394527), GIMT_Encode4(0),
     /* 394441 */ /*GILLT_v2s32*//*Label 7702*/ GIMT_Encode4(394558),
     /* 394445 */ /*GILLT_v2s64*//*Label 7703*/ GIMT_Encode4(394589),
     /* 394449 */ /*GILLT_v4s16*//*Label 7704*/ GIMT_Encode4(394620),
     /* 394453 */ /*GILLT_v4s32*//*Label 7705*/ GIMT_Encode4(394651), GIMT_Encode4(0),
     /* 394461 */ /*GILLT_v8s16*//*Label 7706*/ GIMT_Encode4(394682),
     /* 394465 */ // Label 7699: @394465
     /* 394465 */ GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(394495), // Rule ID 534 //
     /* 394470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 394473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 394476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394484 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 394484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 394489 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394493 */   GIR_RootConstrainSelectedInstOperands,
     /* 394494 */   // GIR_Coverage, 534,
     /* 394494 */   GIR_Done,
     /* 394495 */ // Label 7708: @394495
     /* 394495 */ GIM_Reject,
     /* 394496 */ // Label 7700: @394496
     /* 394496 */ GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(394526), // Rule ID 536 //
     /* 394501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394515 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 394515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 394520 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394524 */   GIR_RootConstrainSelectedInstOperands,
     /* 394525 */   // GIR_Coverage, 536,
     /* 394525 */   GIR_Done,
     /* 394526 */ // Label 7709: @394526
     /* 394526 */ GIM_Reject,
     /* 394527 */ // Label 7701: @394527
     /* 394527 */ GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(394557), // Rule ID 538 //
     /* 394532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394546 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 394546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 394551 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394555 */   GIR_RootConstrainSelectedInstOperands,
     /* 394556 */   // GIR_Coverage, 538,
     /* 394556 */   GIR_Done,
     /* 394557 */ // Label 7710: @394557
     /* 394557 */ GIM_Reject,
     /* 394558 */ // Label 7702: @394558
     /* 394558 */ GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(394588), // Rule ID 883 //
     /* 394563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394577 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 394577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 394582 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394586 */   GIR_RootConstrainSelectedInstOperands,
     /* 394587 */   // GIR_Coverage, 883,
     /* 394587 */   GIR_Done,
     /* 394588 */ // Label 7711: @394588
     /* 394588 */ GIM_Reject,
     /* 394589 */ // Label 7703: @394589
     /* 394589 */ GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(394619), // Rule ID 887 //
     /* 394594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394608 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 394608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 394613 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394617 */   GIR_RootConstrainSelectedInstOperands,
     /* 394618 */   // GIR_Coverage, 887,
     /* 394618 */   GIR_Done,
     /* 394619 */ // Label 7712: @394619
     /* 394619 */ GIM_Reject,
     /* 394620 */ // Label 7704: @394620
     /* 394620 */ GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(394650), // Rule ID 879 //
     /* 394625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394639 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 394639 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 394644 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394648 */   GIR_RootConstrainSelectedInstOperands,
     /* 394649 */   // GIR_Coverage, 879,
     /* 394649 */   GIR_Done,
     /* 394650 */ // Label 7713: @394650
     /* 394650 */ GIM_Reject,
     /* 394651 */ // Label 7705: @394651
     /* 394651 */ GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(394681), // Rule ID 885 //
     /* 394656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394670 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 394670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 394675 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394679 */   GIR_RootConstrainSelectedInstOperands,
     /* 394680 */   // GIR_Coverage, 885,
     /* 394680 */   GIR_Done,
     /* 394681 */ // Label 7714: @394681
     /* 394681 */ GIM_Reject,
     /* 394682 */ // Label 7706: @394682
     /* 394682 */ GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(394903),
     /* 394687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394698 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(394717), // Rule ID 881 //
     /* 394703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394706 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 394706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 394711 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394715 */     GIR_RootConstrainSelectedInstOperands,
     /* 394716 */     // GIR_Coverage, 881,
     /* 394716 */     GIR_Done,
     /* 394717 */   // Label 7716: @394717
     /* 394717 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(394902), // Rule ID 7048 //
     /* 394722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 394725 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 394725 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 394728 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 394732 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394737 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 394743 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 394746 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 394750 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394755 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 394758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 394760 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 394763 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394767 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394772 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394778 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394783 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394788 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 394791 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 394795 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394800 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 394803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 394805 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 394808 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 394812 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394817 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 394820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 394822 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 394825 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 394829 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394834 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 394837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 394839 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 394842 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 394846 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 394853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 394860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394865 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 394868 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 394871 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 394874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 394892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 394900 */     GIR_RootConstrainSelectedInstOperands,
     /* 394901 */     // GIR_Coverage, 7048,
     /* 394901 */     GIR_EraseRootFromParent_Done,
     /* 394902 */   // Label 7717: @394902
     /* 394902 */   GIM_Reject,
     /* 394903 */ // Label 7715: @394903
     /* 394903 */ GIM_Reject,
     /* 394904 */ // Label 7707: @394904
     /* 394904 */ GIM_Reject,
     /* 394905 */ // Label 103: @394905
     /* 394905 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7726*/ GIMT_Encode4(396030),
     /* 394916 */ /*GILLT_s16*//*Label 7718*/ GIMT_Encode4(394956),
     /* 394920 */ /*GILLT_s32*//*Label 7719*/ GIMT_Encode4(395182),
     /* 394924 */ /*GILLT_s64*//*Label 7720*/ GIMT_Encode4(395408), GIMT_Encode4(0),
     /* 394932 */ /*GILLT_v2s32*//*Label 7721*/ GIMT_Encode4(395580),
     /* 394936 */ /*GILLT_v2s64*//*Label 7722*/ GIMT_Encode4(395618),
     /* 394940 */ /*GILLT_v4s16*//*Label 7723*/ GIMT_Encode4(395656),
     /* 394944 */ /*GILLT_v4s32*//*Label 7724*/ GIMT_Encode4(395694), GIMT_Encode4(0),
     /* 394952 */ /*GILLT_v8s16*//*Label 7725*/ GIMT_Encode4(395732),
     /* 394956 */ // Label 7718: @394956
     /* 394956 */ GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(395181),
     /* 394961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 394964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 394967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394971 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(395062), // Rule ID 6968 //
     /* 394976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 394984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 394992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394997 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 395001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395013 */     // MIs[2] Rn
     /* 395013 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395018 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 395022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395024 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 395024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395036 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 395055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395060 */     GIR_RootConstrainSelectedInstOperands,
     /* 395061 */     // GIR_Coverage, 6968,
     /* 395061 */     GIR_EraseRootFromParent_Done,
     /* 395062 */   // Label 7728: @395062
     /* 395062 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(395153), // Rule ID 14015 //
     /* 395067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395088 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 395092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395104 */     // MIs[2] Rn
     /* 395104 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395109 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 395113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395115 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 395115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395127 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395138 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 395146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395151 */     GIR_RootConstrainSelectedInstOperands,
     /* 395152 */     // GIR_Coverage, 14015,
     /* 395152 */     GIR_EraseRootFromParent_Done,
     /* 395153 */   // Label 7729: @395153
     /* 395153 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(395180), // Rule ID 583 //
     /* 395158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 395161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395169 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 395169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 395174 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395178 */     GIR_RootConstrainSelectedInstOperands,
     /* 395179 */     // GIR_Coverage, 583,
     /* 395179 */     GIR_Done,
     /* 395180 */   // Label 7730: @395180
     /* 395180 */   GIM_Reject,
     /* 395181 */ // Label 7727: @395181
     /* 395181 */ GIM_Reject,
     /* 395182 */ // Label 7719: @395182
     /* 395182 */ GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(395407),
     /* 395187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 395193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395197 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(395288), // Rule ID 6966 //
     /* 395202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395223 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 395227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395235 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395239 */     // MIs[2] Rn
     /* 395239 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395244 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 395248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395250 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 395250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395262 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 395281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395286 */     GIR_RootConstrainSelectedInstOperands,
     /* 395287 */     // GIR_Coverage, 6966,
     /* 395287 */     GIR_EraseRootFromParent_Done,
     /* 395288 */   // Label 7732: @395288
     /* 395288 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(395379), // Rule ID 14013 //
     /* 395293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395314 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 395318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395330 */     // MIs[2] Rn
     /* 395330 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395335 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 395339 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395341 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 395341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395353 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 395372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395377 */     GIR_RootConstrainSelectedInstOperands,
     /* 395378 */     // GIR_Coverage, 14013,
     /* 395378 */     GIR_EraseRootFromParent_Done,
     /* 395379 */   // Label 7733: @395379
     /* 395379 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(395406), // Rule ID 585 //
     /* 395384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395395 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 395395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 395400 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395404 */     GIR_RootConstrainSelectedInstOperands,
     /* 395405 */     // GIR_Coverage, 585,
     /* 395405 */     GIR_Done,
     /* 395406 */   // Label 7734: @395406
     /* 395406 */   GIM_Reject,
     /* 395407 */ // Label 7731: @395407
     /* 395407 */ GIM_Reject,
     /* 395408 */ // Label 7720: @395408
     /* 395408 */ GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(395579),
     /* 395413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 395419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395423 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(395487), // Rule ID 6964 //
     /* 395428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395449 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 395453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395461 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395465 */     // MIs[2] Rn
     /* 395465 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395470 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 395474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395476 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 395476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 395479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395485 */     GIR_RootConstrainSelectedInstOperands,
     /* 395486 */     // GIR_Coverage, 6964,
     /* 395486 */     GIR_EraseRootFromParent_Done,
     /* 395487 */   // Label 7736: @395487
     /* 395487 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(395551), // Rule ID 14011 //
     /* 395492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395513 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 395517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395529 */     // MIs[2] Rn
     /* 395529 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395534 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 395538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395540 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 395540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 395543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 395549 */     GIR_RootConstrainSelectedInstOperands,
     /* 395550 */     // GIR_Coverage, 14011,
     /* 395550 */     GIR_EraseRootFromParent_Done,
     /* 395551 */   // Label 7737: @395551
     /* 395551 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(395578), // Rule ID 587 //
     /* 395556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395567 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 395567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 395572 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395576 */     GIR_RootConstrainSelectedInstOperands,
     /* 395577 */     // GIR_Coverage, 587,
     /* 395577 */     GIR_Done,
     /* 395578 */   // Label 7738: @395578
     /* 395578 */   GIM_Reject,
     /* 395579 */ // Label 7735: @395579
     /* 395579 */ GIM_Reject,
     /* 395580 */ // Label 7721: @395580
     /* 395580 */ GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(395617), // Rule ID 1202 //
     /* 395585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 395594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395602 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395606 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 395606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 395611 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395615 */   GIR_RootConstrainSelectedInstOperands,
     /* 395616 */   // GIR_Coverage, 1202,
     /* 395616 */   GIR_Done,
     /* 395617 */ // Label 7739: @395617
     /* 395617 */ GIM_Reject,
     /* 395618 */ // Label 7722: @395618
     /* 395618 */ GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(395655), // Rule ID 1206 //
     /* 395623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 395632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395644 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 395644 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 395649 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395653 */   GIR_RootConstrainSelectedInstOperands,
     /* 395654 */   // GIR_Coverage, 1206,
     /* 395654 */   GIR_Done,
     /* 395655 */ // Label 7740: @395655
     /* 395655 */ GIM_Reject,
     /* 395656 */ // Label 7723: @395656
     /* 395656 */ GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(395693), // Rule ID 1198 //
     /* 395661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 395670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395682 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 395682 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 395687 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395691 */   GIR_RootConstrainSelectedInstOperands,
     /* 395692 */   // GIR_Coverage, 1198,
     /* 395692 */   GIR_Done,
     /* 395693 */ // Label 7741: @395693
     /* 395693 */ GIM_Reject,
     /* 395694 */ // Label 7724: @395694
     /* 395694 */ GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(395731), // Rule ID 1204 //
     /* 395699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 395708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395720 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 395720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 395725 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395729 */   GIR_RootConstrainSelectedInstOperands,
     /* 395730 */   // GIR_Coverage, 1204,
     /* 395730 */   GIR_Done,
     /* 395731 */ // Label 7742: @395731
     /* 395731 */ GIM_Reject,
     /* 395732 */ // Label 7725: @395732
     /* 395732 */ GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(396029),
     /* 395737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 395743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395755 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(395774), // Rule ID 1200 //
     /* 395760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395763 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 395763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 395768 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395772 */     GIR_RootConstrainSelectedInstOperands,
     /* 395773 */     // GIR_Coverage, 1200,
     /* 395773 */     GIR_Done,
     /* 395774 */   // Label 7744: @395774
     /* 395774 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(396028), // Rule ID 7057 //
     /* 395779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 395782 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 395782 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 395785 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 395789 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395794 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 395798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 395800 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 395803 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 395807 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395812 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 395818 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 395821 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 395825 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395830 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 395833 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 395836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 395838 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 395841 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395845 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395850 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 395856 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395861 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395866 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 395869 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 395873 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395878 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 395881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 395883 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 395886 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395890 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395895 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395901 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395906 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395911 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 395914 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 395918 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395923 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 395926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 395928 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 395931 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 395935 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395940 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 395943 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 395946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 395948 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 395951 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 395955 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395960 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 395963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 395965 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 395968 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395972 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 395982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395991 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 395994 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 395997 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 396000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396005 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396010 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 396018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 396026 */     GIR_RootConstrainSelectedInstOperands,
     /* 396027 */     // GIR_Coverage, 7057,
     /* 396027 */     GIR_EraseRootFromParent_Done,
     /* 396028 */   // Label 7745: @396028
     /* 396028 */   GIM_Reject,
     /* 396029 */ // Label 7743: @396029
     /* 396029 */ GIM_Reject,
     /* 396030 */ // Label 7726: @396030
     /* 396030 */ GIM_Reject,
     /* 396031 */ // Label 104: @396031
     /* 396031 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7754*/ GIMT_Encode4(396646),
     /* 396042 */ /*GILLT_s16*//*Label 7746*/ GIMT_Encode4(396082),
     /* 396046 */ /*GILLT_s32*//*Label 7747*/ GIMT_Encode4(396120),
     /* 396050 */ /*GILLT_s64*//*Label 7748*/ GIMT_Encode4(396158), GIMT_Encode4(0),
     /* 396058 */ /*GILLT_v2s32*//*Label 7749*/ GIMT_Encode4(396196),
     /* 396062 */ /*GILLT_v2s64*//*Label 7750*/ GIMT_Encode4(396234),
     /* 396066 */ /*GILLT_v4s16*//*Label 7751*/ GIMT_Encode4(396272),
     /* 396070 */ /*GILLT_v4s32*//*Label 7752*/ GIMT_Encode4(396310), GIMT_Encode4(0),
     /* 396078 */ /*GILLT_v8s16*//*Label 7753*/ GIMT_Encode4(396348),
     /* 396082 */ // Label 7746: @396082
     /* 396082 */ GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(396119), // Rule ID 631 //
     /* 396087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 396096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396108 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 396108 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 396113 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396117 */   GIR_RootConstrainSelectedInstOperands,
     /* 396118 */   // GIR_Coverage, 631,
     /* 396118 */   GIR_Done,
     /* 396119 */ // Label 7755: @396119
     /* 396119 */ GIM_Reject,
     /* 396120 */ // Label 7747: @396120
     /* 396120 */ GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(396157), // Rule ID 633 //
     /* 396125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 396134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396146 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 396146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 396151 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396155 */   GIR_RootConstrainSelectedInstOperands,
     /* 396156 */   // GIR_Coverage, 633,
     /* 396156 */   GIR_Done,
     /* 396157 */ // Label 7756: @396157
     /* 396157 */ GIM_Reject,
     /* 396158 */ // Label 7748: @396158
     /* 396158 */ GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(396195), // Rule ID 635 //
     /* 396163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 396172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396184 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 396184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 396189 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396193 */   GIR_RootConstrainSelectedInstOperands,
     /* 396194 */   // GIR_Coverage, 635,
     /* 396194 */   GIR_Done,
     /* 396195 */ // Label 7757: @396195
     /* 396195 */ GIM_Reject,
     /* 396196 */ // Label 7749: @396196
     /* 396196 */ GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(396233), // Rule ID 1342 //
     /* 396201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 396210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396222 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 396222 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 396227 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396231 */   GIR_RootConstrainSelectedInstOperands,
     /* 396232 */   // GIR_Coverage, 1342,
     /* 396232 */   GIR_Done,
     /* 396233 */ // Label 7758: @396233
     /* 396233 */ GIM_Reject,
     /* 396234 */ // Label 7750: @396234
     /* 396234 */ GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(396271), // Rule ID 1346 //
     /* 396239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 396248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396260 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 396260 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 396265 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396269 */   GIR_RootConstrainSelectedInstOperands,
     /* 396270 */   // GIR_Coverage, 1346,
     /* 396270 */   GIR_Done,
     /* 396271 */ // Label 7759: @396271
     /* 396271 */ GIM_Reject,
     /* 396272 */ // Label 7751: @396272
     /* 396272 */ GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(396309), // Rule ID 1338 //
     /* 396277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 396286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396298 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 396298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 396303 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396307 */   GIR_RootConstrainSelectedInstOperands,
     /* 396308 */   // GIR_Coverage, 1338,
     /* 396308 */   GIR_Done,
     /* 396309 */ // Label 7760: @396309
     /* 396309 */ GIM_Reject,
     /* 396310 */ // Label 7752: @396310
     /* 396310 */ GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(396347), // Rule ID 1344 //
     /* 396315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 396324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396336 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 396336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 396341 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396345 */   GIR_RootConstrainSelectedInstOperands,
     /* 396346 */   // GIR_Coverage, 1344,
     /* 396346 */   GIR_Done,
     /* 396347 */ // Label 7761: @396347
     /* 396347 */ GIM_Reject,
     /* 396348 */ // Label 7753: @396348
     /* 396348 */ GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(396645),
     /* 396353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 396359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396367 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396371 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(396390), // Rule ID 1340 //
     /* 396376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396379 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 396379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 396384 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396388 */     GIR_RootConstrainSelectedInstOperands,
     /* 396389 */     // GIR_Coverage, 1340,
     /* 396389 */     GIR_Done,
     /* 396390 */   // Label 7763: @396390
     /* 396390 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(396644), // Rule ID 7063 //
     /* 396395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 396398 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 396398 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 396401 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 396405 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396410 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 396414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 396416 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 396419 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 396423 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396428 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 396434 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 396437 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 396441 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396446 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 396449 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 396452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 396454 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 396457 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396461 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396466 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 396472 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396477 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396482 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 396485 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 396489 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396494 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 396497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 396499 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 396502 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396506 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396511 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 396517 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396522 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396527 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 396530 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 396534 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396539 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 396542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 396544 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 396547 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 396551 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396556 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 396559 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 396562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 396564 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 396567 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 396571 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396576 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 396579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 396581 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 396584 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396588 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 396598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396607 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396610 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 396613 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 396616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396621 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 396634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 396642 */     GIR_RootConstrainSelectedInstOperands,
     /* 396643 */     // GIR_Coverage, 7063,
     /* 396643 */     GIR_EraseRootFromParent_Done,
     /* 396644 */   // Label 7764: @396644
     /* 396644 */   GIM_Reject,
     /* 396645 */ // Label 7762: @396645
     /* 396645 */ GIM_Reject,
     /* 396646 */ // Label 7754: @396646
     /* 396646 */ GIM_Reject,
     /* 396647 */ // Label 105: @396647
     /* 396647 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7773*/ GIMT_Encode4(400368),
     /* 396658 */ /*GILLT_s16*//*Label 7765*/ GIMT_Encode4(396698),
     /* 396662 */ /*GILLT_s32*//*Label 7766*/ GIMT_Encode4(397252),
     /* 396666 */ /*GILLT_s64*//*Label 7767*/ GIMT_Encode4(397800), GIMT_Encode4(0),
     /* 396674 */ /*GILLT_v2s32*//*Label 7768*/ GIMT_Encode4(398348),
     /* 396678 */ /*GILLT_v2s64*//*Label 7769*/ GIMT_Encode4(398878),
     /* 396682 */ /*GILLT_v4s16*//*Label 7770*/ GIMT_Encode4(399236),
     /* 396686 */ /*GILLT_v4s32*//*Label 7771*/ GIMT_Encode4(399578), GIMT_Encode4(0),
     /* 396694 */ /*GILLT_v8s16*//*Label 7772*/ GIMT_Encode4(399936),
     /* 396698 */ // Label 7765: @396698
     /* 396698 */ GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(397251),
     /* 396703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 396709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396713 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(396826), // Rule ID 6296 //
     /* 396718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396742 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396758 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396762 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 396771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396775 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 396779 */     // MIs[3] Operand 1
     /* 396779 */     // No operand predicates
     /* 396779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396781 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 396781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396793 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 396799 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396804 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 396812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 396821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 396824 */     GIR_RootConstrainSelectedInstOperands,
     /* 396825 */     // GIR_Coverage, 6296,
     /* 396825 */     GIR_EraseRootFromParent_Done,
     /* 396826 */   // Label 7775: @396826
     /* 396826 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(396939), // Rule ID 13992 //
     /* 396831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 396859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 396863 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 396867 */     // MIs[2] Operand 1
     /* 396867 */     // No operand predicates
     /* 396867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 396871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396875 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396879 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 396883 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396888 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 396892 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 396894 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 396894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396906 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 396912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 396925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 396934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 396937 */     GIR_RootConstrainSelectedInstOperands,
     /* 396938 */     // GIR_Coverage, 13992,
     /* 396938 */     GIR_EraseRootFromParent_Done,
     /* 396939 */   // Label 7776: @396939
     /* 396939 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(397018), // Rule ID 13926 //
     /* 396944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396968 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396978 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 396978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 396981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396990 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 396996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 397009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397016 */     GIR_RootConstrainSelectedInstOperands,
     /* 397017 */     // GIR_Coverage, 13926,
     /* 397017 */     GIR_EraseRootFromParent_Done,
     /* 397018 */   // Label 7777: @397018
     /* 397018 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(397097), // Rule ID 4838 //
     /* 397023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 397026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397051 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397057 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 397057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 397060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397069 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 397075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397080 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 397088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397095 */     GIR_RootConstrainSelectedInstOperands,
     /* 397096 */     // GIR_Coverage, 4838,
     /* 397096 */     GIR_EraseRootFromParent_Done,
     /* 397097 */   // Label 7778: @397097
     /* 397097 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(397160), // Rule ID 13541 //
     /* 397102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 397126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397134 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397138 */     // MIs[2] Operand 1
     /* 397138 */     // No operand predicates
     /* 397138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397144 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 397147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397158 */     GIR_RootConstrainSelectedInstOperands,
     /* 397159 */     // GIR_Coverage, 13541,
     /* 397159 */     GIR_EraseRootFromParent_Done,
     /* 397160 */   // Label 7779: @397160
     /* 397160 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(397223), // Rule ID 2011 //
     /* 397165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 397193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397201 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397205 */     // MIs[2] Operand 1
     /* 397205 */     // No operand predicates
     /* 397205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397207 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 397210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397212 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397221 */     GIR_RootConstrainSelectedInstOperands,
     /* 397222 */     // GIR_Coverage, 2011,
     /* 397222 */     GIR_EraseRootFromParent_Done,
     /* 397223 */   // Label 7780: @397223
     /* 397223 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(397250), // Rule ID 619 //
     /* 397228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 397231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397239 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 397239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 397244 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397248 */     GIR_RootConstrainSelectedInstOperands,
     /* 397249 */     // GIR_Coverage, 619,
     /* 397249 */     GIR_Done,
     /* 397250 */   // Label 7781: @397250
     /* 397250 */   GIM_Reject,
     /* 397251 */ // Label 7774: @397251
     /* 397251 */ GIM_Reject,
     /* 397252 */ // Label 7766: @397252
     /* 397252 */ GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(397799),
     /* 397257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 397263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397267 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(397380), // Rule ID 6298 //
     /* 397272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397296 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397325 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397329 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397333 */     // MIs[3] Operand 1
     /* 397333 */     // No operand predicates
     /* 397333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397335 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 397335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 397338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397347 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 397353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 397366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397378 */     GIR_RootConstrainSelectedInstOperands,
     /* 397379 */     // GIR_Coverage, 6298,
     /* 397379 */     GIR_EraseRootFromParent_Done,
     /* 397380 */   // Label 7783: @397380
     /* 397380 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(397493), // Rule ID 13994 //
     /* 397385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397417 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397421 */     // MIs[2] Operand 1
     /* 397421 */     // No operand predicates
     /* 397421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397429 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397433 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 397437 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397442 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 397446 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397448 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 397448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 397451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397460 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 397466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 397479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397491 */     GIR_RootConstrainSelectedInstOperands,
     /* 397492 */     // GIR_Coverage, 13994,
     /* 397492 */     GIR_EraseRootFromParent_Done,
     /* 397493 */   // Label 7784: @397493
     /* 397493 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(397569), // Rule ID 13928 //
     /* 397498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397519 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397529 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 397529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 397532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397541 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 397547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 397560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397567 */     GIR_RootConstrainSelectedInstOperands,
     /* 397568 */     // GIR_Coverage, 13928,
     /* 397568 */     GIR_EraseRootFromParent_Done,
     /* 397569 */   // Label 7785: @397569
     /* 397569 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(397645), // Rule ID 4840 //
     /* 397574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397599 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397605 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 397605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 397608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397617 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 397623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 397636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397643 */     GIR_RootConstrainSelectedInstOperands,
     /* 397644 */     // GIR_Coverage, 4840,
     /* 397644 */     GIR_EraseRootFromParent_Done,
     /* 397645 */   // Label 7786: @397645
     /* 397645 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(397708), // Rule ID 13543 //
     /* 397650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397682 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397686 */     // MIs[2] Operand 1
     /* 397686 */     // No operand predicates
     /* 397686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397692 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 397695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397706 */     GIR_RootConstrainSelectedInstOperands,
     /* 397707 */     // GIR_Coverage, 13543,
     /* 397707 */     GIR_EraseRootFromParent_Done,
     /* 397708 */   // Label 7787: @397708
     /* 397708 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(397771), // Rule ID 2013 //
     /* 397713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397749 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 397753 */     // MIs[2] Operand 1
     /* 397753 */     // No operand predicates
     /* 397753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397755 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 397758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397769 */     GIR_RootConstrainSelectedInstOperands,
     /* 397770 */     // GIR_Coverage, 2013,
     /* 397770 */     GIR_EraseRootFromParent_Done,
     /* 397771 */   // Label 7788: @397771
     /* 397771 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(397798), // Rule ID 621 //
     /* 397776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 397779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397787 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 397787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 397792 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397796 */     GIR_RootConstrainSelectedInstOperands,
     /* 397797 */     // GIR_Coverage, 621,
     /* 397797 */     GIR_Done,
     /* 397798 */   // Label 7789: @397798
     /* 397798 */   GIM_Reject,
     /* 397799 */ // Label 7782: @397799
     /* 397799 */ GIM_Reject,
     /* 397800 */ // Label 7767: @397800
     /* 397800 */ GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(398347),
     /* 397805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 397808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397815 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(397928), // Rule ID 6300 //
     /* 397820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397844 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397877 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 397881 */     // MIs[3] Operand 1
     /* 397881 */     // No operand predicates
     /* 397881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397883 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 397883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397895 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 397901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 397914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397926 */     GIR_RootConstrainSelectedInstOperands,
     /* 397927 */     // GIR_Coverage, 6300,
     /* 397927 */     GIR_EraseRootFromParent_Done,
     /* 397928 */   // Label 7791: @397928
     /* 397928 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(398041), // Rule ID 13996 //
     /* 397933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397965 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 397969 */     // MIs[2] Operand 1
     /* 397969 */     // No operand predicates
     /* 397969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397973 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397977 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 397981 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 397985 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397990 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 397994 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397996 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 397996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 397999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398008 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 398014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 398027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398039 */     GIR_RootConstrainSelectedInstOperands,
     /* 398040 */     // GIR_Coverage, 13996,
     /* 398040 */     GIR_EraseRootFromParent_Done,
     /* 398041 */   // Label 7792: @398041
     /* 398041 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(398117), // Rule ID 13930 //
     /* 398046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398067 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398077 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 398077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 398080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398089 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 398095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 398108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398115 */     GIR_RootConstrainSelectedInstOperands,
     /* 398116 */     // GIR_Coverage, 13930,
     /* 398116 */     GIR_EraseRootFromParent_Done,
     /* 398117 */   // Label 7793: @398117
     /* 398117 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(398193), // Rule ID 4842 //
     /* 398122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398147 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398153 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 398153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 398156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398165 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 398171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 398184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398191 */     GIR_RootConstrainSelectedInstOperands,
     /* 398192 */     // GIR_Coverage, 4842,
     /* 398192 */     GIR_EraseRootFromParent_Done,
     /* 398193 */   // Label 7794: @398193
     /* 398193 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(398256), // Rule ID 13545 //
     /* 398198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398230 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398234 */     // MIs[2] Operand 1
     /* 398234 */     // No operand predicates
     /* 398234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398240 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 398243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398254 */     GIR_RootConstrainSelectedInstOperands,
     /* 398255 */     // GIR_Coverage, 13545,
     /* 398255 */     GIR_EraseRootFromParent_Done,
     /* 398256 */   // Label 7795: @398256
     /* 398256 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(398319), // Rule ID 2015 //
     /* 398261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398297 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398301 */     // MIs[2] Operand 1
     /* 398301 */     // No operand predicates
     /* 398301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398303 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 398306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398317 */     GIR_RootConstrainSelectedInstOperands,
     /* 398318 */     // GIR_Coverage, 2015,
     /* 398318 */     GIR_EraseRootFromParent_Done,
     /* 398319 */   // Label 7796: @398319
     /* 398319 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(398346), // Rule ID 623 //
     /* 398324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 398327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398335 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 398335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 398340 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398344 */     GIR_RootConstrainSelectedInstOperands,
     /* 398345 */     // GIR_Coverage, 623,
     /* 398345 */     GIR_Done,
     /* 398346 */   // Label 7797: @398346
     /* 398346 */   GIM_Reject,
     /* 398347 */ // Label 7790: @398347
     /* 398347 */ GIM_Reject,
     /* 398348 */ // Label 7768: @398348
     /* 398348 */ GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(398877),
     /* 398353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 398356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 398359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398363 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(398449), // Rule ID 13533 //
     /* 398368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 398387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 398391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398412 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398416 */     // MIs[3] Operand 1
     /* 398416 */     // No operand predicates
     /* 398416 */     // MIs[1] Operand 2
     /* 398416 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398433 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 398436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398447 */     GIR_RootConstrainSelectedInstOperands,
     /* 398448 */     // GIR_Coverage, 13533,
     /* 398448 */     GIR_EraseRootFromParent_Done,
     /* 398449 */   // Label 7799: @398449
     /* 398449 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(398535), // Rule ID 2003 //
     /* 398454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 398477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 398481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398485 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398502 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398506 */     // MIs[3] Operand 1
     /* 398506 */     // No operand predicates
     /* 398506 */     // MIs[1] Operand 2
     /* 398506 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398519 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 398522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398533 */     GIR_RootConstrainSelectedInstOperands,
     /* 398534 */     // GIR_Coverage, 2003,
     /* 398534 */     GIR_EraseRootFromParent_Done,
     /* 398535 */   // Label 7800: @398535
     /* 398535 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(398598), // Rule ID 13534 //
     /* 398540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 398551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398572 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398576 */     // MIs[2] Operand 1
     /* 398576 */     // No operand predicates
     /* 398576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398582 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 398585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398596 */     GIR_RootConstrainSelectedInstOperands,
     /* 398597 */     // GIR_Coverage, 13534,
     /* 398597 */     GIR_EraseRootFromParent_Done,
     /* 398598 */   // Label 7801: @398598
     /* 398598 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(398661), // Rule ID 2004 //
     /* 398603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 398618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398639 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398643 */     // MIs[2] Operand 1
     /* 398643 */     // No operand predicates
     /* 398643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398645 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 398648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398659 */     GIR_RootConstrainSelectedInstOperands,
     /* 398660 */     // GIR_Coverage, 2004,
     /* 398660 */     GIR_EraseRootFromParent_Done,
     /* 398661 */   // Label 7802: @398661
     /* 398661 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(398755), // Rule ID 13998 //
     /* 398666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 398674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 398678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398689 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 398689 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 398692 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398696 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 398706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398715 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398718 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398722 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 398725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 398743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398753 */     GIR_RootConstrainSelectedInstOperands,
     /* 398754 */     // GIR_Coverage, 13998,
     /* 398754 */     GIR_EraseRootFromParent_Done,
     /* 398755 */   // Label 7803: @398755
     /* 398755 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(398849), // Rule ID 6302 //
     /* 398760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 398772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 398776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398783 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 398783 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 398786 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 398790 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 398797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 398800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 398804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398809 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 398812 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398816 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 398819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 398837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398839 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 398847 */     GIR_RootConstrainSelectedInstOperands,
     /* 398848 */     // GIR_Coverage, 6302,
     /* 398848 */     GIR_EraseRootFromParent_Done,
     /* 398849 */   // Label 7804: @398849
     /* 398849 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(398876), // Rule ID 1322 //
     /* 398854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398865 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 398865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 398870 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398874 */     GIR_RootConstrainSelectedInstOperands,
     /* 398875 */     // GIR_Coverage, 1322,
     /* 398875 */     GIR_Done,
     /* 398876 */   // Label 7805: @398876
     /* 398876 */   GIM_Reject,
     /* 398877 */ // Label 7798: @398877
     /* 398877 */ GIM_Reject,
     /* 398878 */ // Label 7769: @398878
     /* 398878 */ GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(399235),
     /* 398883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 398889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398893 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(398956), // Rule ID 13539 //
     /* 398898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 398909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398930 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398934 */     // MIs[2] Operand 1
     /* 398934 */     // No operand predicates
     /* 398934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398940 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 398943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398954 */     GIR_RootConstrainSelectedInstOperands,
     /* 398955 */     // GIR_Coverage, 13539,
     /* 398955 */     GIR_EraseRootFromParent_Done,
     /* 398956 */   // Label 7807: @398956
     /* 398956 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(399019), // Rule ID 2009 //
     /* 398961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 398976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398997 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 399001 */     // MIs[2] Operand 1
     /* 399001 */     // No operand predicates
     /* 399001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399003 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 399006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399017 */     GIR_RootConstrainSelectedInstOperands,
     /* 399018 */     // GIR_Coverage, 2009,
     /* 399018 */     GIR_EraseRootFromParent_Done,
     /* 399019 */   // Label 7808: @399019
     /* 399019 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(399113), // Rule ID 14002 //
     /* 399024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 399032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 399036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399047 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399047 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 399050 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399054 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 399064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399073 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399080 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 399083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399088 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 399101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399111 */     GIR_RootConstrainSelectedInstOperands,
     /* 399112 */     // GIR_Coverage, 14002,
     /* 399112 */     GIR_EraseRootFromParent_Done,
     /* 399113 */   // Label 7809: @399113
     /* 399113 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(399207), // Rule ID 6306 //
     /* 399118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 399130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 399134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399141 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399141 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 399144 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399148 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 399158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399167 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399174 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 399177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 399195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399205 */     GIR_RootConstrainSelectedInstOperands,
     /* 399206 */     // GIR_Coverage, 6306,
     /* 399206 */     GIR_EraseRootFromParent_Done,
     /* 399207 */   // Label 7810: @399207
     /* 399207 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(399234), // Rule ID 1326 //
     /* 399212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399223 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 399223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 399228 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399232 */     GIR_RootConstrainSelectedInstOperands,
     /* 399233 */     // GIR_Coverage, 1326,
     /* 399233 */     GIR_Done,
     /* 399234 */   // Label 7811: @399234
     /* 399234 */   GIM_Reject,
     /* 399235 */ // Label 7806: @399235
     /* 399235 */ GIM_Reject,
     /* 399236 */ // Label 7770: @399236
     /* 399236 */ GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(399577),
     /* 399241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 399247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399251 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(399337), // Rule ID 13527 //
     /* 399256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 399279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399300 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399304 */     // MIs[3] Operand 1
     /* 399304 */     // No operand predicates
     /* 399304 */     // MIs[1] Operand 2
     /* 399304 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399319 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399321 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 399324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399335 */     GIR_RootConstrainSelectedInstOperands,
     /* 399336 */     // GIR_Coverage, 13527,
     /* 399336 */     GIR_EraseRootFromParent_Done,
     /* 399337 */   // Label 7813: @399337
     /* 399337 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(399423), // Rule ID 1997 //
     /* 399342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 399369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399377 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399382 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399386 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399390 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399394 */     // MIs[3] Operand 1
     /* 399394 */     // No operand predicates
     /* 399394 */     // MIs[1] Operand 2
     /* 399394 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399405 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399407 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 399410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399421 */     GIR_RootConstrainSelectedInstOperands,
     /* 399422 */     // GIR_Coverage, 1997,
     /* 399422 */     GIR_EraseRootFromParent_Done,
     /* 399423 */   // Label 7814: @399423
     /* 399423 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(399486), // Rule ID 13528 //
     /* 399428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 399439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399460 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399464 */     // MIs[2] Operand 1
     /* 399464 */     // No operand predicates
     /* 399464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399470 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 399473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399484 */     GIR_RootConstrainSelectedInstOperands,
     /* 399485 */     // GIR_Coverage, 13528,
     /* 399485 */     GIR_EraseRootFromParent_Done,
     /* 399486 */   // Label 7815: @399486
     /* 399486 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(399549), // Rule ID 1998 //
     /* 399491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 399506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399527 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399531 */     // MIs[2] Operand 1
     /* 399531 */     // No operand predicates
     /* 399531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399533 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 399536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399538 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399547 */     GIR_RootConstrainSelectedInstOperands,
     /* 399548 */     // GIR_Coverage, 1998,
     /* 399548 */     GIR_EraseRootFromParent_Done,
     /* 399549 */   // Label 7816: @399549
     /* 399549 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(399576), // Rule ID 1318 //
     /* 399554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399565 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 399565 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 399570 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399574 */     GIR_RootConstrainSelectedInstOperands,
     /* 399575 */     // GIR_Coverage, 1318,
     /* 399575 */     GIR_Done,
     /* 399576 */   // Label 7817: @399576
     /* 399576 */   GIM_Reject,
     /* 399577 */ // Label 7812: @399577
     /* 399577 */ GIM_Reject,
     /* 399578 */ // Label 7771: @399578
     /* 399578 */ GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(399935),
     /* 399583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 399589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399593 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(399656), // Rule ID 13537 //
     /* 399598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399630 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399634 */     // MIs[2] Operand 1
     /* 399634 */     // No operand predicates
     /* 399634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399640 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 399643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399654 */     GIR_RootConstrainSelectedInstOperands,
     /* 399655 */     // GIR_Coverage, 13537,
     /* 399655 */     GIR_EraseRootFromParent_Done,
     /* 399656 */   // Label 7819: @399656
     /* 399656 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(399719), // Rule ID 2007 //
     /* 399661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399697 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399701 */     // MIs[2] Operand 1
     /* 399701 */     // No operand predicates
     /* 399701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399703 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 399706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399717 */     GIR_RootConstrainSelectedInstOperands,
     /* 399718 */     // GIR_Coverage, 2007,
     /* 399718 */     GIR_EraseRootFromParent_Done,
     /* 399719 */   // Label 7820: @399719
     /* 399719 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(399813), // Rule ID 14000 //
     /* 399724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 399732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 399736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399747 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399747 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 399750 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399754 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 399764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399773 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399776 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399780 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 399783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 399801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399811 */     GIR_RootConstrainSelectedInstOperands,
     /* 399812 */     // GIR_Coverage, 14000,
     /* 399812 */     GIR_EraseRootFromParent_Done,
     /* 399813 */   // Label 7821: @399813
     /* 399813 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(399907), // Rule ID 6304 //
     /* 399818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 399830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 399834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399841 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399841 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 399844 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399848 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 399858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399867 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399870 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399874 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 399877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 399895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399905 */     GIR_RootConstrainSelectedInstOperands,
     /* 399906 */     // GIR_Coverage, 6304,
     /* 399906 */     GIR_EraseRootFromParent_Done,
     /* 399907 */   // Label 7822: @399907
     /* 399907 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(399934), // Rule ID 1324 //
     /* 399912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399923 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 399923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 399928 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399932 */     GIR_RootConstrainSelectedInstOperands,
     /* 399933 */     // GIR_Coverage, 1324,
     /* 399933 */     GIR_Done,
     /* 399934 */   // Label 7823: @399934
     /* 399934 */   GIM_Reject,
     /* 399935 */ // Label 7818: @399935
     /* 399935 */ GIM_Reject,
     /* 399936 */ // Label 7772: @399936
     /* 399936 */ GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(400367),
     /* 399941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 399947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399951 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(400014), // Rule ID 13531 //
     /* 399956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 399967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399988 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399992 */     // MIs[2] Operand 1
     /* 399992 */     // No operand predicates
     /* 399992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399998 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 400001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400012 */     GIR_RootConstrainSelectedInstOperands,
     /* 400013 */     // GIR_Coverage, 13531,
     /* 400013 */     GIR_EraseRootFromParent_Done,
     /* 400014 */   // Label 7825: @400014
     /* 400014 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(400077), // Rule ID 2001 //
     /* 400019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400055 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400059 */     // MIs[2] Operand 1
     /* 400059 */     // No operand predicates
     /* 400059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400061 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 400064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400066 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400075 */     GIR_RootConstrainSelectedInstOperands,
     /* 400076 */     // GIR_Coverage, 2001,
     /* 400076 */     GIR_EraseRootFromParent_Done,
     /* 400077 */   // Label 7826: @400077
     /* 400077 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(400104), // Rule ID 1320 //
     /* 400082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400093 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 400093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 400098 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400102 */     GIR_RootConstrainSelectedInstOperands,
     /* 400103 */     // GIR_Coverage, 1320,
     /* 400103 */     GIR_Done,
     /* 400104 */   // Label 7827: @400104
     /* 400104 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(400366), // Rule ID 7061 //
     /* 400109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 400112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400120 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 400120 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 400123 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 400127 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400132 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 400136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 400138 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 400141 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 400145 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400150 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 400154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 400156 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 400159 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 400163 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400168 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 400171 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 400174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 400176 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 400179 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400183 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400188 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 400194 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400199 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400204 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 400207 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 400211 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400216 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 400219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 400221 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 400224 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400228 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400233 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 400239 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400244 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400249 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 400252 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 400256 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400261 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 400264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 400266 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 400269 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 400273 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400278 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 400281 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 400284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 400286 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 400289 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 400293 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400298 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 400301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 400303 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 400306 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400310 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 400320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400329 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400332 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 400335 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 400338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 400356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 400358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 400364 */     GIR_RootConstrainSelectedInstOperands,
     /* 400365 */     // GIR_Coverage, 7061,
     /* 400365 */     GIR_EraseRootFromParent_Done,
     /* 400366 */   // Label 7828: @400366
     /* 400366 */   GIM_Reject,
     /* 400367 */ // Label 7824: @400367
     /* 400367 */ GIM_Reject,
     /* 400368 */ // Label 7773: @400368
     /* 400368 */ GIM_Reject,
     /* 400369 */ // Label 106: @400369
     /* 400369 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7837*/ GIMT_Encode4(400984),
     /* 400380 */ /*GILLT_s16*//*Label 7829*/ GIMT_Encode4(400420),
     /* 400384 */ /*GILLT_s32*//*Label 7830*/ GIMT_Encode4(400458),
     /* 400388 */ /*GILLT_s64*//*Label 7831*/ GIMT_Encode4(400496), GIMT_Encode4(0),
     /* 400396 */ /*GILLT_v2s32*//*Label 7832*/ GIMT_Encode4(400534),
     /* 400400 */ /*GILLT_v2s64*//*Label 7833*/ GIMT_Encode4(400572),
     /* 400404 */ /*GILLT_v4s16*//*Label 7834*/ GIMT_Encode4(400610),
     /* 400408 */ /*GILLT_v4s32*//*Label 7835*/ GIMT_Encode4(400648), GIMT_Encode4(0),
     /* 400416 */ /*GILLT_v8s16*//*Label 7836*/ GIMT_Encode4(400686),
     /* 400420 */ // Label 7829: @400420
     /* 400420 */ GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(400457), // Rule ID 589 //
     /* 400425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 400428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 400431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 400434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400442 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 400446 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 400446 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 400451 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400455 */   GIR_RootConstrainSelectedInstOperands,
     /* 400456 */   // GIR_Coverage, 589,
     /* 400456 */   GIR_Done,
     /* 400457 */ // Label 7838: @400457
     /* 400457 */ GIM_Reject,
     /* 400458 */ // Label 7830: @400458
     /* 400458 */ GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(400495), // Rule ID 591 //
     /* 400463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 400466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 400469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 400472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400480 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400484 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 400484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 400489 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400493 */   GIR_RootConstrainSelectedInstOperands,
     /* 400494 */   // GIR_Coverage, 591,
     /* 400494 */   GIR_Done,
     /* 400495 */ // Label 7839: @400495
     /* 400495 */ GIM_Reject,
     /* 400496 */ // Label 7831: @400496
     /* 400496 */ GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(400533), // Rule ID 593 //
     /* 400501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 400504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 400510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400522 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 400522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 400527 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400531 */   GIR_RootConstrainSelectedInstOperands,
     /* 400532 */   // GIR_Coverage, 593,
     /* 400532 */   GIR_Done,
     /* 400533 */ // Label 7840: @400533
     /* 400533 */ GIM_Reject,
     /* 400534 */ // Label 7832: @400534
     /* 400534 */ GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(400571), // Rule ID 1227 //
     /* 400539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 400548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400560 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 400560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 400565 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400569 */   GIR_RootConstrainSelectedInstOperands,
     /* 400570 */   // GIR_Coverage, 1227,
     /* 400570 */   GIR_Done,
     /* 400571 */ // Label 7841: @400571
     /* 400571 */ GIM_Reject,
     /* 400572 */ // Label 7833: @400572
     /* 400572 */ GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(400609), // Rule ID 1231 //
     /* 400577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 400586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400594 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400598 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 400598 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 400603 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400607 */   GIR_RootConstrainSelectedInstOperands,
     /* 400608 */   // GIR_Coverage, 1231,
     /* 400608 */   GIR_Done,
     /* 400609 */ // Label 7842: @400609
     /* 400609 */ GIM_Reject,
     /* 400610 */ // Label 7834: @400610
     /* 400610 */ GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(400647), // Rule ID 1223 //
     /* 400615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 400624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400636 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 400636 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 400641 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400645 */   GIR_RootConstrainSelectedInstOperands,
     /* 400646 */   // GIR_Coverage, 1223,
     /* 400646 */   GIR_Done,
     /* 400647 */ // Label 7843: @400647
     /* 400647 */ GIM_Reject,
     /* 400648 */ // Label 7835: @400648
     /* 400648 */ GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(400685), // Rule ID 1229 //
     /* 400653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 400662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400674 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 400674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 400679 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400683 */   GIR_RootConstrainSelectedInstOperands,
     /* 400684 */   // GIR_Coverage, 1229,
     /* 400684 */   GIR_Done,
     /* 400685 */ // Label 7844: @400685
     /* 400685 */ GIM_Reject,
     /* 400686 */ // Label 7836: @400686
     /* 400686 */ GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(400983),
     /* 400691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 400697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400705 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400709 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(400728), // Rule ID 1225 //
     /* 400714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400717 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 400717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 400722 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400726 */     GIR_RootConstrainSelectedInstOperands,
     /* 400727 */     // GIR_Coverage, 1225,
     /* 400727 */     GIR_Done,
     /* 400728 */   // Label 7846: @400728
     /* 400728 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(400982), // Rule ID 7059 //
     /* 400733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 400736 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 400736 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 400739 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 400743 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400748 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 400752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 400754 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 400757 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 400761 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400766 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 400770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 400772 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 400775 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 400779 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400784 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 400787 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 400790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 400792 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 400795 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400799 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400804 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 400810 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400815 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400820 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 400823 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 400827 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400832 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 400835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 400837 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 400840 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400844 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400849 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 400855 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400860 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400865 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 400868 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 400872 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400877 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 400880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 400882 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 400885 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 400889 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400894 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 400897 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 400900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 400902 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 400905 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 400909 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400914 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 400917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 400919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 400922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 400936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400945 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400948 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 400951 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 400954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 400972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 400974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 400980 */     GIR_RootConstrainSelectedInstOperands,
     /* 400981 */     // GIR_Coverage, 7059,
     /* 400981 */     GIR_EraseRootFromParent_Done,
     /* 400982 */   // Label 7847: @400982
     /* 400982 */   GIM_Reject,
     /* 400983 */ // Label 7845: @400983
     /* 400983 */ GIM_Reject,
     /* 400984 */ // Label 7837: @400984
     /* 400984 */ GIM_Reject,
     /* 400985 */ // Label 107: @400985
     /* 400985 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7856*/ GIMT_Encode4(416591),
     /* 400996 */ /*GILLT_s16*//*Label 7848*/ GIMT_Encode4(401036),
     /* 401000 */ /*GILLT_s32*//*Label 7849*/ GIMT_Encode4(403810),
     /* 401004 */ /*GILLT_s64*//*Label 7850*/ GIMT_Encode4(406740), GIMT_Encode4(0),
     /* 401012 */ /*GILLT_v2s32*//*Label 7851*/ GIMT_Encode4(409670),
     /* 401016 */ /*GILLT_v2s64*//*Label 7852*/ GIMT_Encode4(411191),
     /* 401020 */ /*GILLT_v4s16*//*Label 7853*/ GIMT_Encode4(412712),
     /* 401024 */ /*GILLT_v4s32*//*Label 7854*/ GIMT_Encode4(413891), GIMT_Encode4(0),
     /* 401032 */ /*GILLT_v8s16*//*Label 7855*/ GIMT_Encode4(415412),
     /* 401036 */ // Label 7848: @401036
     /* 401036 */ GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(403809),
     /* 401041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 401047 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 401050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401054 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(401204), // Rule ID 4900 //
     /* 401059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401083 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401108 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 401112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 401116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401120 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 401124 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401131 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 401131 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 401134 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401138 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401143 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 401149 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401154 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401171 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 401190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 401198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 401202 */     GIR_RootConstrainSelectedInstOperands,
     /* 401203 */     // GIR_Coverage, 4900,
     /* 401203 */     GIR_EraseRootFromParent_Done,
     /* 401204 */   // Label 7858: @401204
     /* 401204 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(401351), // Rule ID 4864 //
     /* 401209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401233 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 401253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401257 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401261 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 401265 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401270 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 401274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401278 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401280 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 401280 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 401283 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401287 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401292 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 401298 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401303 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401320 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 401339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 401347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 401349 */     GIR_RootConstrainSelectedInstOperands,
     /* 401350 */     // GIR_Coverage, 4864,
     /* 401350 */     GIR_EraseRootFromParent_Done,
     /* 401351 */   // Label 7859: @401351
     /* 401351 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(401498), // Rule ID 13939 //
     /* 401356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401392 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 401396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401404 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401408 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 401412 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401417 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 401421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401427 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 401427 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 401430 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401434 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401439 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 401445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401467 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 401486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 401494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 401496 */     GIR_RootConstrainSelectedInstOperands,
     /* 401497 */     // GIR_Coverage, 13939,
     /* 401497 */     GIR_EraseRootFromParent_Done,
     /* 401498 */   // Label 7860: @401498
     /* 401498 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(401629), // Rule ID 6134 //
     /* 401503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401527 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 401547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401551 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401555 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 401559 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401564 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 401568 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401572 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401576 */     // MIs[4] Operand 1
     /* 401576 */     // No operand predicates
     /* 401576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401580 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 401582 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 401582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401594 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 401613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 401617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 401624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 401627 */     GIR_RootConstrainSelectedInstOperands,
     /* 401628 */     // GIR_Coverage, 6134,
     /* 401628 */     GIR_EraseRootFromParent_Done,
     /* 401629 */   // Label 7861: @401629
     /* 401629 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(401760), // Rule ID 6166 //
     /* 401634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 401662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401666 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401670 */     // MIs[2] Operand 1
     /* 401670 */     // No operand predicates
     /* 401670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 401682 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 401686 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401690 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401694 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 401698 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401703 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 401707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401711 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 401713 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 401713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401725 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 401744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 401748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 401755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 401758 */     GIR_RootConstrainSelectedInstOperands,
     /* 401759 */     // GIR_Coverage, 6166,
     /* 401759 */     GIR_EraseRootFromParent_Done,
     /* 401760 */   // Label 7862: @401760
     /* 401760 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(401891), // Rule ID 6230 //
     /* 401765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401801 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 401805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 401809 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401813 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401817 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 401821 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401826 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 401830 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401834 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401838 */     // MIs[4] Operand 1
     /* 401838 */     // No operand predicates
     /* 401838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401842 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 401844 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 401844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401856 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 401875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 401879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 401886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 401889 */     GIR_RootConstrainSelectedInstOperands,
     /* 401890 */     // GIR_Coverage, 6230,
     /* 401890 */     GIR_EraseRootFromParent_Done,
     /* 401891 */   // Label 7863: @401891
     /* 401891 */   GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(402022), // Rule ID 6198 //
     /* 401896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 401911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 401915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 401932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 401936 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 401940 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 401944 */     // MIs[3] Operand 1
     /* 401944 */     // No operand predicates
     /* 401944 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 401948 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401952 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401956 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 401960 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401965 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 401969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401973 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 401975 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 401975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401987 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 402020 */     GIR_RootConstrainSelectedInstOperands,
     /* 402021 */     // GIR_Coverage, 6198,
     /* 402021 */     GIR_EraseRootFromParent_Done,
     /* 402022 */   // Label 7864: @402022
     /* 402022 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(402157), // Rule ID 2455 //
     /* 402027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402051 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402076 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402086 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402086 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 402089 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402093 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402098 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402126 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 402145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 402153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402155 */     GIR_RootConstrainSelectedInstOperands,
     /* 402156 */     // GIR_Coverage, 2455,
     /* 402156 */     GIR_EraseRootFromParent_Done,
     /* 402157 */   // Label 7865: @402157
     /* 402157 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(402276), // Rule ID 6102 //
     /* 402162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402186 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402202 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402211 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 402215 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402219 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402223 */     // MIs[3] Operand 1
     /* 402223 */     // No operand predicates
     /* 402223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402227 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402229 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402241 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 402260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 402274 */     GIR_RootConstrainSelectedInstOperands,
     /* 402275 */     // GIR_Coverage, 6102,
     /* 402275 */     GIR_EraseRootFromParent_Done,
     /* 402276 */   // Label 7866: @402276
     /* 402276 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(402395), // Rule ID 2537 //
     /* 402281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402313 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402317 */     // MIs[2] Operand 1
     /* 402317 */     // No operand predicates
     /* 402317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402325 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402329 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 402333 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402338 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 402342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402346 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402348 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402360 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 402379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 402393 */     GIR_RootConstrainSelectedInstOperands,
     /* 402394 */     // GIR_Coverage, 2537,
     /* 402394 */     GIR_EraseRootFromParent_Done,
     /* 402395 */   // Label 7867: @402395
     /* 402395 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(402495), // Rule ID 4862 //
     /* 402400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402424 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402451 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 402451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402463 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402493 */     GIR_RootConstrainSelectedInstOperands,
     /* 402494 */     // GIR_Coverage, 4862,
     /* 402494 */     GIR_EraseRootFromParent_Done,
     /* 402495 */   // Label 7868: @402495
     /* 402495 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(402595), // Rule ID 4898 //
     /* 402500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402524 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 402536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402551 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 402551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402563 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 402582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 402589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 402593 */     GIR_RootConstrainSelectedInstOperands,
     /* 402594 */     // GIR_Coverage, 4898,
     /* 402594 */     GIR_EraseRootFromParent_Done,
     /* 402595 */   // Label 7869: @402595
     /* 402595 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(402692), // Rule ID 13935 //
     /* 402600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402636 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402650 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402662 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 402685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402690 */     GIR_RootConstrainSelectedInstOperands,
     /* 402691 */     // GIR_Coverage, 13935,
     /* 402691 */     GIR_EraseRootFromParent_Done,
     /* 402692 */   // Label 7870: @402692
     /* 402692 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(402792), // Rule ID 13937 //
     /* 402697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402725 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402729 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402738 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402748 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 402748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402760 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402790 */     GIR_RootConstrainSelectedInstOperands,
     /* 402791 */     // GIR_Coverage, 13937,
     /* 402791 */     GIR_EraseRootFromParent_Done,
     /* 402792 */   // Label 7871: @402792
     /* 402792 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(402892), // Rule ID 4896 //
     /* 402797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402825 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 402833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402841 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402848 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402860 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 402879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 402890 */     GIR_RootConstrainSelectedInstOperands,
     /* 402891 */     // GIR_Coverage, 4896,
     /* 402891 */     GIR_EraseRootFromParent_Done,
     /* 402892 */   // Label 7872: @402892
     /* 402892 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(402989), // Rule ID 4860 //
     /* 402897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 402908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402937 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402947 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402959 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 402982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402987 */     GIR_RootConstrainSelectedInstOperands,
     /* 402988 */     // GIR_Coverage, 4860,
     /* 402988 */     GIR_EraseRootFromParent_Done,
     /* 402989 */   // Label 7873: @402989
     /* 402989 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(403073), // Rule ID 6164 //
     /* 402994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403026 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403030 */     // MIs[2] Operand 1
     /* 403030 */     // No operand predicates
     /* 403030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 403042 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403051 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403053 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 403064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 403071 */     GIR_RootConstrainSelectedInstOperands,
     /* 403072 */     // GIR_Coverage, 6164,
     /* 403072 */     GIR_EraseRootFromParent_Done,
     /* 403073 */   // Label 7874: @403073
     /* 403073 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(403154), // Rule ID 6196 //
     /* 403078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 403118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403122 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403126 */     // MIs[3] Operand 1
     /* 403126 */     // No operand predicates
     /* 403126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403134 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403136 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 403152 */     GIR_RootConstrainSelectedInstOperands,
     /* 403153 */     // GIR_Coverage, 6196,
     /* 403153 */     GIR_EraseRootFromParent_Done,
     /* 403154 */   // Label 7875: @403154
     /* 403154 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(403238), // Rule ID 6228 //
     /* 403159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403191 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 403204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403208 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403212 */     // MIs[3] Operand 1
     /* 403212 */     // No operand predicates
     /* 403212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403218 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 403236 */     GIR_RootConstrainSelectedInstOperands,
     /* 403237 */     // GIR_Coverage, 6228,
     /* 403237 */     GIR_EraseRootFromParent_Done,
     /* 403238 */   // Label 7876: @403238
     /* 403238 */   GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(403319), // Rule ID 6132 //
     /* 403243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 403287 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403291 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403295 */     // MIs[3] Operand 1
     /* 403295 */     // No operand predicates
     /* 403295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403299 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403301 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 403317 */     GIR_RootConstrainSelectedInstOperands,
     /* 403318 */     // GIR_Coverage, 6132,
     /* 403318 */     GIR_EraseRootFromParent_Done,
     /* 403319 */   // Label 7877: @403319
     /* 403319 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(403404), // Rule ID 2453 //
     /* 403324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403348 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403362 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 403362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403374 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 403393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403402 */     GIR_RootConstrainSelectedInstOperands,
     /* 403403 */     // GIR_Coverage, 2453,
     /* 403403 */     GIR_EraseRootFromParent_Done,
     /* 403404 */   // Label 7878: @403404
     /* 403404 */   GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(403489), // Rule ID 2451 //
     /* 403409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403437 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403447 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 403447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403459 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 403465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 403478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403487 */     GIR_RootConstrainSelectedInstOperands,
     /* 403488 */     // GIR_Coverage, 2451,
     /* 403488 */     GIR_EraseRootFromParent_Done,
     /* 403489 */   // Label 7879: @403489
     /* 403489 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(403558), // Rule ID 2535 //
     /* 403494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403526 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403530 */     // MIs[2] Operand 1
     /* 403530 */     // No operand predicates
     /* 403530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403540 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 403543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 403556 */     GIR_RootConstrainSelectedInstOperands,
     /* 403557 */     // GIR_Coverage, 2535,
     /* 403557 */     GIR_EraseRootFromParent_Done,
     /* 403558 */   // Label 7880: @403558
     /* 403558 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(403627), // Rule ID 6100 //
     /* 403563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403599 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403603 */     // MIs[2] Operand 1
     /* 403603 */     // No operand predicates
     /* 403603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403609 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 403612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 403625 */     GIR_RootConstrainSelectedInstOperands,
     /* 403626 */     // GIR_Coverage, 6100,
     /* 403626 */     GIR_EraseRootFromParent_Done,
     /* 403627 */   // Label 7881: @403627
     /* 403627 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(403677), // Rule ID 13381 //
     /* 403632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403662 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 403662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 403665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403675 */     GIR_RootConstrainSelectedInstOperands,
     /* 403676 */     // GIR_Coverage, 13381,
     /* 403676 */     GIR_EraseRootFromParent_Done,
     /* 403677 */   // Label 7882: @403677
     /* 403677 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(403727), // Rule ID 643 //
     /* 403682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403712 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 403712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 403715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403725 */     GIR_RootConstrainSelectedInstOperands,
     /* 403726 */     // GIR_Coverage, 643,
     /* 403726 */     GIR_EraseRootFromParent_Done,
     /* 403727 */   // Label 7883: @403727
     /* 403727 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(403777), // Rule ID 655 //
     /* 403732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 403747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 403762 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 403762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 403765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 403775 */     GIR_RootConstrainSelectedInstOperands,
     /* 403776 */     // GIR_Coverage, 655,
     /* 403776 */     GIR_EraseRootFromParent_Done,
     /* 403777 */   // Label 7884: @403777
     /* 403777 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(403808), // Rule ID 637 //
     /* 403782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403797 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 403797 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 403802 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403806 */     GIR_RootConstrainSelectedInstOperands,
     /* 403807 */     // GIR_Coverage, 637,
     /* 403807 */     GIR_Done,
     /* 403808 */   // Label 7885: @403808
     /* 403808 */   GIM_Reject,
     /* 403809 */ // Label 7857: @403809
     /* 403809 */ GIM_Reject,
     /* 403810 */ // Label 7849: @403810
     /* 403810 */ GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(406739),
     /* 403815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 403818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 403821 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 403824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403828 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(403978), // Rule ID 4906 //
     /* 403833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 403836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403857 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403882 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 403890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403894 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 403898 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403905 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 403905 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 403908 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403912 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403917 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 403923 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403928 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 403936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403945 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 403951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 403956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 403964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 403972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 403976 */     GIR_RootConstrainSelectedInstOperands,
     /* 403977 */     // GIR_Coverage, 4906,
     /* 403977 */     GIR_EraseRootFromParent_Done,
     /* 403978 */   // Label 7887: @403978
     /* 403978 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(404125), // Rule ID 4870 //
     /* 403983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 403986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404007 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 404023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 404027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404031 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404035 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 404039 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404044 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 404048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404052 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404054 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 404054 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 404057 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404061 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404066 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 404072 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404077 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404094 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 404113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 404121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404123 */     GIR_RootConstrainSelectedInstOperands,
     /* 404124 */     // GIR_Coverage, 4870,
     /* 404124 */     GIR_EraseRootFromParent_Done,
     /* 404125 */   // Label 7888: @404125
     /* 404125 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(404272), // Rule ID 13945 //
     /* 404130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 404145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404166 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404170 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404174 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404178 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404182 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 404186 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404191 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 404195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404201 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 404201 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 404204 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404208 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404213 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 404219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404241 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 404260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 404268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404270 */     GIR_RootConstrainSelectedInstOperands,
     /* 404271 */     // GIR_Coverage, 13945,
     /* 404271 */     GIR_EraseRootFromParent_Done,
     /* 404272 */   // Label 7889: @404272
     /* 404272 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(404403), // Rule ID 6150 //
     /* 404277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404301 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 404317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 404321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404325 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404329 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 404333 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404338 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 404342 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404346 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404350 */     // MIs[4] Operand 1
     /* 404350 */     // No operand predicates
     /* 404350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404354 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 404356 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404368 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404374 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404379 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 404387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 404398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 404401 */     GIR_RootConstrainSelectedInstOperands,
     /* 404402 */     // GIR_Coverage, 6150,
     /* 404402 */     GIR_EraseRootFromParent_Done,
     /* 404403 */   // Label 7890: @404403
     /* 404403 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(404534), // Rule ID 6182 //
     /* 404408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404440 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404444 */     // MIs[2] Operand 1
     /* 404444 */     // No operand predicates
     /* 404444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404448 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404452 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 404456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 404460 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404464 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404468 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 404472 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404477 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 404481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404485 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 404487 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404499 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 404518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404532 */     GIR_RootConstrainSelectedInstOperands,
     /* 404533 */     // GIR_Coverage, 6182,
     /* 404533 */     GIR_EraseRootFromParent_Done,
     /* 404534 */   // Label 7891: @404534
     /* 404534 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(404665), // Rule ID 6246 //
     /* 404539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 404554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404575 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404587 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404591 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 404595 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404600 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 404604 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404608 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404612 */     // MIs[4] Operand 1
     /* 404612 */     // No operand predicates
     /* 404612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404616 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 404618 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404630 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 404649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 404660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 404663 */     GIR_RootConstrainSelectedInstOperands,
     /* 404664 */     // GIR_Coverage, 6246,
     /* 404664 */     GIR_EraseRootFromParent_Done,
     /* 404665 */   // Label 7892: @404665
     /* 404665 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(404796), // Rule ID 6214 //
     /* 404670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 404685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404697 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404714 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404718 */     // MIs[3] Operand 1
     /* 404718 */     // No operand predicates
     /* 404718 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 404722 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404726 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404730 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 404734 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404739 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 404743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404747 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 404749 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 404749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404761 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404767 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 404780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404794 */     GIR_RootConstrainSelectedInstOperands,
     /* 404795 */     // GIR_Coverage, 6214,
     /* 404795 */     GIR_EraseRootFromParent_Done,
     /* 404796 */   // Label 7893: @404796
     /* 404796 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(404931), // Rule ID 2461 //
     /* 404801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404825 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404850 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404860 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 404860 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 404863 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404867 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404872 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 404878 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404883 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404900 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404906 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404911 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 404919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 404927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404929 */     GIR_RootConstrainSelectedInstOperands,
     /* 404930 */     // GIR_Coverage, 2461,
     /* 404930 */     GIR_EraseRootFromParent_Done,
     /* 404931 */   // Label 7894: @404931
     /* 404931 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(405050), // Rule ID 6118 //
     /* 404936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404960 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404993 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404997 */     // MIs[3] Operand 1
     /* 404997 */     // No operand predicates
     /* 404997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405003 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405015 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 405034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405048 */     GIR_RootConstrainSelectedInstOperands,
     /* 405049 */     // GIR_Coverage, 6118,
     /* 405049 */     GIR_EraseRootFromParent_Done,
     /* 405050 */   // Label 7895: @405050
     /* 405050 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(405169), // Rule ID 2553 //
     /* 405055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405087 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405091 */     // MIs[2] Operand 1
     /* 405091 */     // No operand predicates
     /* 405091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405099 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405103 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 405107 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405112 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 405116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405122 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405134 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 405153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405167 */     GIR_RootConstrainSelectedInstOperands,
     /* 405168 */     // GIR_Coverage, 2553,
     /* 405168 */     GIR_EraseRootFromParent_Done,
     /* 405169 */   // Label 7896: @405169
     /* 405169 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(405269), // Rule ID 4868 //
     /* 405174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405198 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 405214 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405225 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405237 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 405256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405267 */     GIR_RootConstrainSelectedInstOperands,
     /* 405268 */     // GIR_Coverage, 4868,
     /* 405268 */     GIR_EraseRootFromParent_Done,
     /* 405269 */   // Label 7897: @405269
     /* 405269 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(405369), // Rule ID 4904 //
     /* 405274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405298 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 405310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 405318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405325 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405337 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 405356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 405363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 405367 */     GIR_RootConstrainSelectedInstOperands,
     /* 405368 */     // GIR_Coverage, 4904,
     /* 405368 */     GIR_EraseRootFromParent_Done,
     /* 405369 */   // Label 7898: @405369
     /* 405369 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(405466), // Rule ID 13941 //
     /* 405374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405410 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 405414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405424 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 405424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405436 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 405442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 405455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405464 */     GIR_RootConstrainSelectedInstOperands,
     /* 405465 */     // GIR_Coverage, 13941,
     /* 405465 */     GIR_EraseRootFromParent_Done,
     /* 405466 */   // Label 7899: @405466
     /* 405466 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(405566), // Rule ID 13943 //
     /* 405471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405503 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405512 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 405516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405522 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405534 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 405553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405564 */     GIR_RootConstrainSelectedInstOperands,
     /* 405565 */     // GIR_Coverage, 13943,
     /* 405565 */     GIR_EraseRootFromParent_Done,
     /* 405566 */   // Label 7900: @405566
     /* 405566 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(405666), // Rule ID 4902 //
     /* 405571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405599 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 405607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 405615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405622 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 405622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405634 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 405640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 405653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405655 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 405664 */     GIR_RootConstrainSelectedInstOperands,
     /* 405665 */     // GIR_Coverage, 4902,
     /* 405665 */     GIR_EraseRootFromParent_Done,
     /* 405666 */   // Label 7901: @405666
     /* 405666 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(405763), // Rule ID 4866 //
     /* 405671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405711 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 405715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405721 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 405721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405733 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 405739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 405752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405761 */     GIR_RootConstrainSelectedInstOperands,
     /* 405762 */     // GIR_Coverage, 4866,
     /* 405762 */     GIR_EraseRootFromParent_Done,
     /* 405763 */   // Label 7902: @405763
     /* 405763 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(405841), // Rule ID 6268 //
     /* 405768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 405805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405809 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405813 */     // MIs[3] Operand 1
     /* 405813 */     // No operand predicates
     /* 405813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405823 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405839 */     GIR_RootConstrainSelectedInstOperands,
     /* 405840 */     // GIR_Coverage, 6268,
     /* 405840 */     GIR_EraseRootFromParent_Done,
     /* 405841 */   // Label 7903: @405841
     /* 405841 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(405925), // Rule ID 6180 //
     /* 405846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405878 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405882 */     // MIs[2] Operand 1
     /* 405882 */     // No operand predicates
     /* 405882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405890 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 405894 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405905 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 405916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405923 */     GIR_RootConstrainSelectedInstOperands,
     /* 405924 */     // GIR_Coverage, 6180,
     /* 405924 */     GIR_EraseRootFromParent_Done,
     /* 405925 */   // Label 7904: @405925
     /* 405925 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(406006), // Rule ID 6212 //
     /* 405930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405961 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405974 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405978 */     // MIs[3] Operand 1
     /* 405978 */     // No operand predicates
     /* 405978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405988 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406004 */     GIR_RootConstrainSelectedInstOperands,
     /* 406005 */     // GIR_Coverage, 6212,
     /* 406005 */     GIR_EraseRootFromParent_Done,
     /* 406006 */   // Label 7905: @406006
     /* 406006 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(406090), // Rule ID 6244 //
     /* 406011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406043 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406060 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406064 */     // MIs[3] Operand 1
     /* 406064 */     // No operand predicates
     /* 406064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406070 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 406081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406088 */     GIR_RootConstrainSelectedInstOperands,
     /* 406089 */     // GIR_Coverage, 6244,
     /* 406089 */     GIR_EraseRootFromParent_Done,
     /* 406090 */   // Label 7906: @406090
     /* 406090 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(406168), // Rule ID 6290 //
     /* 406095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 406136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406140 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406144 */     // MIs[3] Operand 1
     /* 406144 */     // No operand predicates
     /* 406144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406148 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406150 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406166 */     GIR_RootConstrainSelectedInstOperands,
     /* 406167 */     // GIR_Coverage, 6290,
     /* 406167 */     GIR_EraseRootFromParent_Done,
     /* 406168 */   // Label 7907: @406168
     /* 406168 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(406249), // Rule ID 6148 //
     /* 406173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406204 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406213 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406217 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406221 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406225 */     // MIs[3] Operand 1
     /* 406225 */     // No operand predicates
     /* 406225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406231 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406247 */     GIR_RootConstrainSelectedInstOperands,
     /* 406248 */     // GIR_Coverage, 6148,
     /* 406248 */     GIR_EraseRootFromParent_Done,
     /* 406249 */   // Label 7908: @406249
     /* 406249 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(406334), // Rule ID 2459 //
     /* 406254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406278 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406292 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 406292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406304 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 406323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 406330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406332 */     GIR_RootConstrainSelectedInstOperands,
     /* 406333 */     // GIR_Coverage, 2459,
     /* 406333 */     GIR_EraseRootFromParent_Done,
     /* 406334 */   // Label 7909: @406334
     /* 406334 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(406419), // Rule ID 2457 //
     /* 406339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406367 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406377 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 406377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406389 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 406395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 406408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406417 */     GIR_RootConstrainSelectedInstOperands,
     /* 406418 */     // GIR_Coverage, 2457,
     /* 406418 */     GIR_EraseRootFromParent_Done,
     /* 406419 */   // Label 7910: @406419
     /* 406419 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(406488), // Rule ID 2551 //
     /* 406424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 406452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406456 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406460 */     // MIs[2] Operand 1
     /* 406460 */     // No operand predicates
     /* 406460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406470 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 406473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 406486 */     GIR_RootConstrainSelectedInstOperands,
     /* 406487 */     // GIR_Coverage, 2551,
     /* 406487 */     GIR_EraseRootFromParent_Done,
     /* 406488 */   // Label 7911: @406488
     /* 406488 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(406557), // Rule ID 6116 //
     /* 406493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 406525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406529 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406533 */     // MIs[2] Operand 1
     /* 406533 */     // No operand predicates
     /* 406533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406539 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 406542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 406555 */     GIR_RootConstrainSelectedInstOperands,
     /* 406556 */     // GIR_Coverage, 6116,
     /* 406556 */     GIR_EraseRootFromParent_Done,
     /* 406557 */   // Label 7912: @406557
     /* 406557 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(406607), // Rule ID 13383 //
     /* 406562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406592 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 406592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 406595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406605 */     GIR_RootConstrainSelectedInstOperands,
     /* 406606 */     // GIR_Coverage, 13383,
     /* 406606 */     GIR_EraseRootFromParent_Done,
     /* 406607 */   // Label 7913: @406607
     /* 406607 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(406657), // Rule ID 645 //
     /* 406612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406642 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 406642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 406645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406655 */     GIR_RootConstrainSelectedInstOperands,
     /* 406656 */     // GIR_Coverage, 645,
     /* 406656 */     GIR_EraseRootFromParent_Done,
     /* 406657 */   // Label 7914: @406657
     /* 406657 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(406707), // Rule ID 657 //
     /* 406662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 406677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406692 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 406692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 406695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 406701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 406705 */     GIR_RootConstrainSelectedInstOperands,
     /* 406706 */     // GIR_Coverage, 657,
     /* 406706 */     GIR_EraseRootFromParent_Done,
     /* 406707 */   // Label 7915: @406707
     /* 406707 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(406738), // Rule ID 639 //
     /* 406712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406727 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 406727 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 406732 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 406736 */     GIR_RootConstrainSelectedInstOperands,
     /* 406737 */     // GIR_Coverage, 639,
     /* 406737 */     GIR_Done,
     /* 406738 */   // Label 7916: @406738
     /* 406738 */   GIM_Reject,
     /* 406739 */ // Label 7886: @406739
     /* 406739 */ GIM_Reject,
     /* 406740 */ // Label 7850: @406740
     /* 406740 */ GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(409669),
     /* 406745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 406748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 406751 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 406754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406758 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(406908), // Rule ID 4912 //
     /* 406763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406787 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406803 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406812 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 406820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406824 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 406828 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406835 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 406835 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 406838 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406842 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406847 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 406853 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406858 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 406866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406875 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 406881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 406894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 406902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 406906 */     GIR_RootConstrainSelectedInstOperands,
     /* 406907 */     // GIR_Coverage, 4912,
     /* 406907 */     GIR_EraseRootFromParent_Done,
     /* 406908 */   // Label 7918: @406908
     /* 406908 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(407055), // Rule ID 4876 //
     /* 406913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406937 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 406953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 406957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406961 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406965 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 406969 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406974 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 406978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406982 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406984 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 406984 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 406987 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406991 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406996 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 407002 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407007 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407024 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407030 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 407043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 407051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407053 */     GIR_RootConstrainSelectedInstOperands,
     /* 407054 */     // GIR_Coverage, 4876,
     /* 407054 */     GIR_EraseRootFromParent_Done,
     /* 407055 */   // Label 7919: @407055
     /* 407055 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(407202), // Rule ID 13951 //
     /* 407060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 407075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407087 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407091 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407096 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407108 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407112 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 407116 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407121 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 407125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407131 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 407131 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 407134 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407138 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407143 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 407149 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407154 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407171 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 407190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 407198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407200 */     GIR_RootConstrainSelectedInstOperands,
     /* 407201 */     // GIR_Coverage, 13951,
     /* 407201 */     GIR_EraseRootFromParent_Done,
     /* 407202 */   // Label 7920: @407202
     /* 407202 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(407333), // Rule ID 6154 //
     /* 407207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407231 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 407247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 407251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407255 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407259 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 407263 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407268 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 407272 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407276 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407280 */     // MIs[4] Operand 1
     /* 407280 */     // No operand predicates
     /* 407280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407284 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 407286 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407298 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407309 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 407317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 407328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 407331 */     GIR_RootConstrainSelectedInstOperands,
     /* 407332 */     // GIR_Coverage, 6154,
     /* 407332 */     GIR_EraseRootFromParent_Done,
     /* 407333 */   // Label 7921: @407333
     /* 407333 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(407464), // Rule ID 6186 //
     /* 407338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 407366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407370 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407374 */     // MIs[2] Operand 1
     /* 407374 */     // No operand predicates
     /* 407374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407382 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 407386 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 407390 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407394 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407398 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 407402 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407407 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 407411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407415 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 407417 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407429 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 407448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 407462 */     GIR_RootConstrainSelectedInstOperands,
     /* 407463 */     // GIR_Coverage, 6186,
     /* 407463 */     GIR_EraseRootFromParent_Done,
     /* 407464 */   // Label 7922: @407464
     /* 407464 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(407595), // Rule ID 6250 //
     /* 407469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 407484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407505 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407513 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407517 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407521 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 407525 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407530 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 407534 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407538 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407542 */     // MIs[4] Operand 1
     /* 407542 */     // No operand predicates
     /* 407542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407546 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 407548 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407560 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 407579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 407590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 407593 */     GIR_RootConstrainSelectedInstOperands,
     /* 407594 */     // GIR_Coverage, 6250,
     /* 407594 */     GIR_EraseRootFromParent_Done,
     /* 407595 */   // Label 7923: @407595
     /* 407595 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(407726), // Rule ID 6218 //
     /* 407600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 407615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407644 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407648 */     // MIs[3] Operand 1
     /* 407648 */     // No operand predicates
     /* 407648 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 407652 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407656 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407660 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 407664 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407669 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 407673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407677 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 407679 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407691 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 407710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407724 */     GIR_RootConstrainSelectedInstOperands,
     /* 407725 */     // GIR_Coverage, 6218,
     /* 407725 */     GIR_EraseRootFromParent_Done,
     /* 407726 */   // Label 7924: @407726
     /* 407726 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(407861), // Rule ID 2467 //
     /* 407731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407755 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407771 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407780 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407790 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 407790 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 407793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407797 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407802 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 407808 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407813 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407830 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 407849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 407857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407859 */     GIR_RootConstrainSelectedInstOperands,
     /* 407860 */     // GIR_Coverage, 2467,
     /* 407860 */     GIR_EraseRootFromParent_Done,
     /* 407861 */   // Label 7925: @407861
     /* 407861 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(407980), // Rule ID 6122 //
     /* 407866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407890 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407906 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407910 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 407919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407923 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407927 */     // MIs[3] Operand 1
     /* 407927 */     // No operand predicates
     /* 407927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407931 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407933 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407945 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 407964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 407975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 407978 */     GIR_RootConstrainSelectedInstOperands,
     /* 407979 */     // GIR_Coverage, 6122,
     /* 407979 */     GIR_EraseRootFromParent_Done,
     /* 407980 */   // Label 7926: @407980
     /* 407980 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(408099), // Rule ID 2557 //
     /* 407985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408017 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408021 */     // MIs[2] Operand 1
     /* 408021 */     // No operand predicates
     /* 408021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408029 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408033 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 408037 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408042 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 408046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408050 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408052 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408064 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 408083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408097 */     GIR_RootConstrainSelectedInstOperands,
     /* 408098 */     // GIR_Coverage, 2557,
     /* 408098 */     GIR_EraseRootFromParent_Done,
     /* 408099 */   // Label 7927: @408099
     /* 408099 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(408199), // Rule ID 4874 //
     /* 408104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408128 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 408144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408155 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408167 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 408186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408197 */     GIR_RootConstrainSelectedInstOperands,
     /* 408198 */     // GIR_Coverage, 4874,
     /* 408198 */     GIR_EraseRootFromParent_Done,
     /* 408199 */   // Label 7928: @408199
     /* 408199 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(408299), // Rule ID 4910 //
     /* 408204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408228 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 408240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 408248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408255 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408267 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 408286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 408293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 408297 */     GIR_RootConstrainSelectedInstOperands,
     /* 408298 */     // GIR_Coverage, 4910,
     /* 408298 */     GIR_EraseRootFromParent_Done,
     /* 408299 */   // Label 7929: @408299
     /* 408299 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(408396), // Rule ID 13947 //
     /* 408304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408340 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 408344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408354 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 408354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408366 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 408372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 408385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408394 */     GIR_RootConstrainSelectedInstOperands,
     /* 408395 */     // GIR_Coverage, 13947,
     /* 408395 */     GIR_EraseRootFromParent_Done,
     /* 408396 */   // Label 7930: @408396
     /* 408396 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(408496), // Rule ID 13949 //
     /* 408401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408433 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408442 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 408446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408452 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408464 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 408483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408494 */     GIR_RootConstrainSelectedInstOperands,
     /* 408495 */     // GIR_Coverage, 13949,
     /* 408495 */     GIR_EraseRootFromParent_Done,
     /* 408496 */   // Label 7931: @408496
     /* 408496 */   GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(408596), // Rule ID 4908 //
     /* 408501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408529 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 408537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 408545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408552 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 408552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408564 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 408570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 408583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 408594 */     GIR_RootConstrainSelectedInstOperands,
     /* 408595 */     // GIR_Coverage, 4908,
     /* 408595 */     GIR_EraseRootFromParent_Done,
     /* 408596 */   // Label 7932: @408596
     /* 408596 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(408693), // Rule ID 4872 //
     /* 408601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 408612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408641 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 408645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408651 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 408651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408663 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 408669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 408682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 408686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408691 */     GIR_RootConstrainSelectedInstOperands,
     /* 408692 */     // GIR_Coverage, 4872,
     /* 408692 */     GIR_EraseRootFromParent_Done,
     /* 408693 */   // Label 7933: @408693
     /* 408693 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(408771), // Rule ID 6272 //
     /* 408698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408726 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 408735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408739 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408743 */     // MIs[3] Operand 1
     /* 408743 */     // No operand predicates
     /* 408743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408751 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408753 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 408753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408769 */     GIR_RootConstrainSelectedInstOperands,
     /* 408770 */     // GIR_Coverage, 6272,
     /* 408770 */     GIR_EraseRootFromParent_Done,
     /* 408771 */   // Label 7934: @408771
     /* 408771 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(408855), // Rule ID 6184 //
     /* 408776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408808 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408812 */     // MIs[2] Operand 1
     /* 408812 */     // No operand predicates
     /* 408812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408820 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 408824 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408833 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408835 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 408846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408853 */     GIR_RootConstrainSelectedInstOperands,
     /* 408854 */     // GIR_Coverage, 6184,
     /* 408854 */     GIR_EraseRootFromParent_Done,
     /* 408855 */   // Label 7935: @408855
     /* 408855 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(408936), // Rule ID 6216 //
     /* 408860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408887 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408904 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408908 */     // MIs[3] Operand 1
     /* 408908 */     // No operand predicates
     /* 408908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408916 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408918 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408934 */     GIR_RootConstrainSelectedInstOperands,
     /* 408935 */     // GIR_Coverage, 6216,
     /* 408935 */     GIR_EraseRootFromParent_Done,
     /* 408936 */   // Label 7936: @408936
     /* 408936 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(409020), // Rule ID 6248 //
     /* 408941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408973 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408990 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408994 */     // MIs[3] Operand 1
     /* 408994 */     // No operand predicates
     /* 408994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409000 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 409011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409018 */     GIR_RootConstrainSelectedInstOperands,
     /* 409019 */     // GIR_Coverage, 6248,
     /* 409019 */     GIR_EraseRootFromParent_Done,
     /* 409020 */   // Label 7937: @409020
     /* 409020 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(409098), // Rule ID 6294 //
     /* 409025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 409066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409070 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409074 */     // MIs[3] Operand 1
     /* 409074 */     // No operand predicates
     /* 409074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409080 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409096 */     GIR_RootConstrainSelectedInstOperands,
     /* 409097 */     // GIR_Coverage, 6294,
     /* 409097 */     GIR_EraseRootFromParent_Done,
     /* 409098 */   // Label 7938: @409098
     /* 409098 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(409179), // Rule ID 6152 //
     /* 409103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409134 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409151 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409155 */     // MIs[3] Operand 1
     /* 409155 */     // No operand predicates
     /* 409155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409159 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409161 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409177 */     GIR_RootConstrainSelectedInstOperands,
     /* 409178 */     // GIR_Coverage, 6152,
     /* 409178 */     GIR_EraseRootFromParent_Done,
     /* 409179 */   // Label 7939: @409179
     /* 409179 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(409264), // Rule ID 2465 //
     /* 409184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409208 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 409212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 409222 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 409222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409234 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 409253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 409260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409262 */     GIR_RootConstrainSelectedInstOperands,
     /* 409263 */     // GIR_Coverage, 2465,
     /* 409263 */     GIR_EraseRootFromParent_Done,
     /* 409264 */   // Label 7940: @409264
     /* 409264 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(409349), // Rule ID 2463 //
     /* 409269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409297 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 409301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 409307 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 409307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409319 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 409325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 409338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409347 */     GIR_RootConstrainSelectedInstOperands,
     /* 409348 */     // GIR_Coverage, 2463,
     /* 409348 */     GIR_EraseRootFromParent_Done,
     /* 409349 */   // Label 7941: @409349
     /* 409349 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(409418), // Rule ID 2555 //
     /* 409354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409386 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409390 */     // MIs[2] Operand 1
     /* 409390 */     // No operand predicates
     /* 409390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409400 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 409403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409416 */     GIR_RootConstrainSelectedInstOperands,
     /* 409417 */     // GIR_Coverage, 2555,
     /* 409417 */     GIR_EraseRootFromParent_Done,
     /* 409418 */   // Label 7942: @409418
     /* 409418 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(409487), // Rule ID 6120 //
     /* 409423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409459 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409463 */     // MIs[2] Operand 1
     /* 409463 */     // No operand predicates
     /* 409463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409467 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409469 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 409472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409485 */     GIR_RootConstrainSelectedInstOperands,
     /* 409486 */     // GIR_Coverage, 6120,
     /* 409486 */     GIR_EraseRootFromParent_Done,
     /* 409487 */   // Label 7943: @409487
     /* 409487 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(409537), // Rule ID 13385 //
     /* 409492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 409522 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 409522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 409525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409535 */     GIR_RootConstrainSelectedInstOperands,
     /* 409536 */     // GIR_Coverage, 13385,
     /* 409536 */     GIR_EraseRootFromParent_Done,
     /* 409537 */   // Label 7944: @409537
     /* 409537 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(409587), // Rule ID 647 //
     /* 409542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 409572 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 409572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 409575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409585 */     GIR_RootConstrainSelectedInstOperands,
     /* 409586 */     // GIR_Coverage, 647,
     /* 409586 */     GIR_EraseRootFromParent_Done,
     /* 409587 */   // Label 7945: @409587
     /* 409587 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(409637), // Rule ID 659 //
     /* 409592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 409607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 409622 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 409622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 409625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 409631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 409635 */     GIR_RootConstrainSelectedInstOperands,
     /* 409636 */     // GIR_Coverage, 659,
     /* 409636 */     GIR_EraseRootFromParent_Done,
     /* 409637 */   // Label 7946: @409637
     /* 409637 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(409668), // Rule ID 641 //
     /* 409642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409657 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 409657 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 409662 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 409666 */     GIR_RootConstrainSelectedInstOperands,
     /* 409667 */     // GIR_Coverage, 641,
     /* 409667 */     GIR_Done,
     /* 409668 */   // Label 7947: @409668
     /* 409668 */   GIM_Reject,
     /* 409669 */ // Label 7917: @409669
     /* 409669 */ GIM_Reject,
     /* 409670 */ // Label 7851: @409670
     /* 409670 */ GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(411190),
     /* 409675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 409681 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 409684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409688 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(409766), // Rule ID 6252 //
     /* 409693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409721 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 409730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409734 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409738 */     // MIs[3] Operand 1
     /* 409738 */     // No operand predicates
     /* 409738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409748 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409764 */     GIR_RootConstrainSelectedInstOperands,
     /* 409765 */     // GIR_Coverage, 6252,
     /* 409765 */     GIR_EraseRootFromParent_Done,
     /* 409766 */   // Label 7949: @409766
     /* 409766 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(409850), // Rule ID 6168 //
     /* 409771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409803 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409807 */     // MIs[2] Operand 1
     /* 409807 */     // No operand predicates
     /* 409807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409815 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409819 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409830 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 409841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409848 */     GIR_RootConstrainSelectedInstOperands,
     /* 409849 */     // GIR_Coverage, 6168,
     /* 409849 */     GIR_EraseRootFromParent_Done,
     /* 409850 */   // Label 7950: @409850
     /* 409850 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(409931), // Rule ID 6200 //
     /* 409855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409899 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409903 */     // MIs[3] Operand 1
     /* 409903 */     // No operand predicates
     /* 409903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409911 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409913 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409929 */     GIR_RootConstrainSelectedInstOperands,
     /* 409930 */     // GIR_Coverage, 6200,
     /* 409930 */     GIR_EraseRootFromParent_Done,
     /* 409931 */   // Label 7951: @409931
     /* 409931 */   GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(410015), // Rule ID 6232 //
     /* 409936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409985 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409989 */     // MIs[3] Operand 1
     /* 409989 */     // No operand predicates
     /* 409989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409995 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 409998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 410006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410013 */     GIR_RootConstrainSelectedInstOperands,
     /* 410014 */     // GIR_Coverage, 6232,
     /* 410014 */     GIR_EraseRootFromParent_Done,
     /* 410015 */   // Label 7952: @410015
     /* 410015 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(410093), // Rule ID 6274 //
     /* 410020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410052 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410057 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 410061 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410065 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410069 */     // MIs[3] Operand 1
     /* 410069 */     // No operand predicates
     /* 410069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410075 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410091 */     GIR_RootConstrainSelectedInstOperands,
     /* 410092 */     // GIR_Coverage, 6274,
     /* 410092 */     GIR_EraseRootFromParent_Done,
     /* 410093 */   // Label 7953: @410093
     /* 410093 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(410174), // Rule ID 6136 //
     /* 410098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410146 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410150 */     // MIs[3] Operand 1
     /* 410150 */     // No operand predicates
     /* 410150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410154 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410156 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410172 */     GIR_RootConstrainSelectedInstOperands,
     /* 410173 */     // GIR_Coverage, 6136,
     /* 410173 */     GIR_EraseRootFromParent_Done,
     /* 410174 */   // Label 7954: @410174
     /* 410174 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(410243), // Rule ID 2539 //
     /* 410179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410211 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410215 */     // MIs[2] Operand 1
     /* 410215 */     // No operand predicates
     /* 410215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410225 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 410228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410241 */     GIR_RootConstrainSelectedInstOperands,
     /* 410242 */     // GIR_Coverage, 2539,
     /* 410242 */     GIR_EraseRootFromParent_Done,
     /* 410243 */   // Label 7955: @410243
     /* 410243 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(410312), // Rule ID 6104 //
     /* 410248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410267 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410284 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410288 */     // MIs[2] Operand 1
     /* 410288 */     // No operand predicates
     /* 410288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410294 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 410297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410310 */     GIR_RootConstrainSelectedInstOperands,
     /* 410311 */     // GIR_Coverage, 6104,
     /* 410311 */     GIR_EraseRootFromParent_Done,
     /* 410312 */   // Label 7956: @410312
     /* 410312 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(410405), // Rule ID 6256 //
     /* 410317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 410325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 410329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 410341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410356 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410368 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410371 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410375 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410403 */     GIR_RootConstrainSelectedInstOperands,
     /* 410404 */     // GIR_Coverage, 6256,
     /* 410404 */     GIR_EraseRootFromParent_Done,
     /* 410405 */   // Label 7957: @410405
     /* 410405 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(410504), // Rule ID 6170 //
     /* 410410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 410421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 410425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410453 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410465 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410468 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410472 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410475 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410480 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 410496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410502 */     GIR_RootConstrainSelectedInstOperands,
     /* 410503 */     // GIR_Coverage, 6170,
     /* 410503 */     GIR_EraseRootFromParent_Done,
     /* 410504 */   // Label 7958: @410504
     /* 410504 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(410600), // Rule ID 6202 //
     /* 410509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 410532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 410536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410551 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410563 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410570 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410598 */     GIR_RootConstrainSelectedInstOperands,
     /* 410599 */     // GIR_Coverage, 6202,
     /* 410599 */     GIR_EraseRootFromParent_Done,
     /* 410600 */   // Label 7959: @410600
     /* 410600 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(410699), // Rule ID 6234 //
     /* 410605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 410633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 410637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410648 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410660 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410663 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410667 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410675 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 410691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410697 */     GIR_RootConstrainSelectedInstOperands,
     /* 410698 */     // GIR_Coverage, 6234,
     /* 410698 */     GIR_EraseRootFromParent_Done,
     /* 410699 */   // Label 7960: @410699
     /* 410699 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(410792), // Rule ID 6278 //
     /* 410704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 410716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 410720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 410732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410743 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410755 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410762 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410790 */     GIR_RootConstrainSelectedInstOperands,
     /* 410791 */     // GIR_Coverage, 6278,
     /* 410791 */     GIR_EraseRootFromParent_Done,
     /* 410792 */   // Label 7961: @410792
     /* 410792 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(410888), // Rule ID 6138 //
     /* 410797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 410824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 410828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410839 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410851 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410858 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410886 */     GIR_RootConstrainSelectedInstOperands,
     /* 410887 */     // GIR_Coverage, 6138,
     /* 410887 */     GIR_EraseRootFromParent_Done,
     /* 410888 */   // Label 7962: @410888
     /* 410888 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(410972), // Rule ID 2541 //
     /* 410893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 410904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 410908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410923 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 410923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 410926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 410930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410935 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 410938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410942 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 410945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 410955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 410958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 410970 */     GIR_RootConstrainSelectedInstOperands,
     /* 410971 */     // GIR_Coverage, 2541,
     /* 410971 */     GIR_EraseRootFromParent_Done,
     /* 410972 */   // Label 7963: @410972
     /* 410972 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(411022), // Rule ID 13415 //
     /* 410977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411007 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 411007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 411010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411020 */     GIR_RootConstrainSelectedInstOperands,
     /* 411021 */     // GIR_Coverage, 13415,
     /* 411021 */     GIR_EraseRootFromParent_Done,
     /* 411022 */   // Label 7964: @411022
     /* 411022 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(411106), // Rule ID 6106 //
     /* 411027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 411046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411057 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411069 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411076 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 411092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411104 */     GIR_RootConstrainSelectedInstOperands,
     /* 411105 */     // GIR_Coverage, 6106,
     /* 411105 */     GIR_EraseRootFromParent_Done,
     /* 411106 */   // Label 7965: @411106
     /* 411106 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(411156), // Rule ID 1307 //
     /* 411111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411141 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 411141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 411144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411154 */     GIR_RootConstrainSelectedInstOperands,
     /* 411155 */     // GIR_Coverage, 1307,
     /* 411155 */     GIR_EraseRootFromParent_Done,
     /* 411156 */   // Label 7966: @411156
     /* 411156 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(411189), // Rule ID 1297 //
     /* 411161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411176 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 411176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 411179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 411187 */     GIR_RootConstrainSelectedInstOperands,
     /* 411188 */     // GIR_Coverage, 1297,
     /* 411188 */     GIR_EraseRootFromParent_Done,
     /* 411189 */   // Label 7967: @411189
     /* 411189 */   GIM_Reject,
     /* 411190 */ // Label 7948: @411190
     /* 411190 */ GIM_Reject,
     /* 411191 */ // Label 7852: @411191
     /* 411191 */ GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(412711),
     /* 411196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 411202 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 411205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411209 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(411287), // Rule ID 6264 //
     /* 411214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 411251 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411255 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411259 */     // MIs[3] Operand 1
     /* 411259 */     // No operand predicates
     /* 411259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411269 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411285 */     GIR_RootConstrainSelectedInstOperands,
     /* 411286 */     // GIR_Coverage, 6264,
     /* 411286 */     GIR_EraseRootFromParent_Done,
     /* 411287 */   // Label 7969: @411287
     /* 411287 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(411371), // Rule ID 6176 //
     /* 411292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 411320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411324 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411328 */     // MIs[2] Operand 1
     /* 411328 */     // No operand predicates
     /* 411328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 411332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411336 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411340 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411349 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411351 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 411362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411369 */     GIR_RootConstrainSelectedInstOperands,
     /* 411370 */     // GIR_Coverage, 6176,
     /* 411370 */     GIR_EraseRootFromParent_Done,
     /* 411371 */   // Label 7970: @411371
     /* 411371 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(411452), // Rule ID 6208 //
     /* 411376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 411407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411412 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411416 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411420 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411424 */     // MIs[3] Operand 1
     /* 411424 */     // No operand predicates
     /* 411424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411434 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411450 */     GIR_RootConstrainSelectedInstOperands,
     /* 411451 */     // GIR_Coverage, 6208,
     /* 411451 */     GIR_EraseRootFromParent_Done,
     /* 411452 */   // Label 7971: @411452
     /* 411452 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(411536), // Rule ID 6240 //
     /* 411457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 411493 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411506 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411510 */     // MIs[3] Operand 1
     /* 411510 */     // No operand predicates
     /* 411510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411514 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411516 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 411527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411534 */     GIR_RootConstrainSelectedInstOperands,
     /* 411535 */     // GIR_Coverage, 6240,
     /* 411535 */     GIR_EraseRootFromParent_Done,
     /* 411536 */   // Label 7972: @411536
     /* 411536 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(411614), // Rule ID 6286 //
     /* 411541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 411582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411586 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411590 */     // MIs[3] Operand 1
     /* 411590 */     // No operand predicates
     /* 411590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411594 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411596 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411612 */     GIR_RootConstrainSelectedInstOperands,
     /* 411613 */     // GIR_Coverage, 6286,
     /* 411613 */     GIR_EraseRootFromParent_Done,
     /* 411614 */   // Label 7973: @411614
     /* 411614 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(411695), // Rule ID 6144 //
     /* 411619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 411654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 411663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411667 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411671 */     // MIs[3] Operand 1
     /* 411671 */     // No operand predicates
     /* 411671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411677 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411693 */     GIR_RootConstrainSelectedInstOperands,
     /* 411694 */     // GIR_Coverage, 6144,
     /* 411694 */     GIR_EraseRootFromParent_Done,
     /* 411695 */   // Label 7974: @411695
     /* 411695 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(411764), // Rule ID 2547 //
     /* 411700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 411728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411732 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411736 */     // MIs[2] Operand 1
     /* 411736 */     // No operand predicates
     /* 411736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411744 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411746 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 411749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411762 */     GIR_RootConstrainSelectedInstOperands,
     /* 411763 */     // GIR_Coverage, 2547,
     /* 411763 */     GIR_EraseRootFromParent_Done,
     /* 411764 */   // Label 7975: @411764
     /* 411764 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(411833), // Rule ID 6112 //
     /* 411769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 411801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411805 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411809 */     // MIs[2] Operand 1
     /* 411809 */     // No operand predicates
     /* 411809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411815 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 411818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411831 */     GIR_RootConstrainSelectedInstOperands,
     /* 411832 */     // GIR_Coverage, 6112,
     /* 411832 */     GIR_EraseRootFromParent_Done,
     /* 411833 */   // Label 7976: @411833
     /* 411833 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(411926), // Rule ID 6266 //
     /* 411838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 411862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411877 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411889 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411896 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411899 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411904 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411924 */     GIR_RootConstrainSelectedInstOperands,
     /* 411925 */     // GIR_Coverage, 6266,
     /* 411925 */     GIR_EraseRootFromParent_Done,
     /* 411926 */   // Label 7977: @411926
     /* 411926 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(412025), // Rule ID 6178 //
     /* 411931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 411946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411974 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411986 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411993 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 411996 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 412017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412023 */     GIR_RootConstrainSelectedInstOperands,
     /* 412024 */     // GIR_Coverage, 6178,
     /* 412024 */     GIR_EraseRootFromParent_Done,
     /* 412025 */   // Label 7978: @412025
     /* 412025 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(412121), // Rule ID 6210 //
     /* 412030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 412057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412072 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412084 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412087 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412091 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412119 */     GIR_RootConstrainSelectedInstOperands,
     /* 412120 */     // GIR_Coverage, 6210,
     /* 412120 */     GIR_EraseRootFromParent_Done,
     /* 412121 */   // Label 7979: @412121
     /* 412121 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(412220), // Rule ID 6242 //
     /* 412126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 412158 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412169 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412181 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412184 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412188 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412191 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 412212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412218 */     GIR_RootConstrainSelectedInstOperands,
     /* 412219 */     // GIR_Coverage, 6242,
     /* 412219 */     GIR_EraseRootFromParent_Done,
     /* 412220 */   // Label 7980: @412220
     /* 412220 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(412313), // Rule ID 6288 //
     /* 412225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 412241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 412253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412264 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412276 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412279 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412283 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412286 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412311 */     GIR_RootConstrainSelectedInstOperands,
     /* 412312 */     // GIR_Coverage, 6288,
     /* 412312 */     GIR_EraseRootFromParent_Done,
     /* 412313 */   // Label 7981: @412313
     /* 412313 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(412409), // Rule ID 6146 //
     /* 412318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 412349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412360 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412372 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412375 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412379 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412407 */     GIR_RootConstrainSelectedInstOperands,
     /* 412408 */     // GIR_Coverage, 6146,
     /* 412408 */     GIR_EraseRootFromParent_Done,
     /* 412409 */   // Label 7982: @412409
     /* 412409 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(412493), // Rule ID 2549 //
     /* 412414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 412429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412444 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412456 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412459 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412463 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 412479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412491 */     GIR_RootConstrainSelectedInstOperands,
     /* 412492 */     // GIR_Coverage, 2549,
     /* 412492 */     GIR_EraseRootFromParent_Done,
     /* 412493 */   // Label 7983: @412493
     /* 412493 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(412543), // Rule ID 13419 //
     /* 412498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412528 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 412528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 412531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412541 */     GIR_RootConstrainSelectedInstOperands,
     /* 412542 */     // GIR_Coverage, 13419,
     /* 412542 */     GIR_EraseRootFromParent_Done,
     /* 412543 */   // Label 7984: @412543
     /* 412543 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(412627), // Rule ID 6114 //
     /* 412548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 412567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412578 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412590 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412597 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 412613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412625 */     GIR_RootConstrainSelectedInstOperands,
     /* 412626 */     // GIR_Coverage, 6114,
     /* 412626 */     GIR_EraseRootFromParent_Done,
     /* 412627 */   // Label 7985: @412627
     /* 412627 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(412677), // Rule ID 1311 //
     /* 412632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412662 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 412662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 412665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412675 */     GIR_RootConstrainSelectedInstOperands,
     /* 412676 */     // GIR_Coverage, 1311,
     /* 412676 */     GIR_EraseRootFromParent_Done,
     /* 412677 */   // Label 7986: @412677
     /* 412677 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(412710), // Rule ID 1301 //
     /* 412682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412697 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 412697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 412700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 412708 */     GIR_RootConstrainSelectedInstOperands,
     /* 412709 */     // GIR_Coverage, 1301,
     /* 412709 */     GIR_EraseRootFromParent_Done,
     /* 412710 */   // Label 7987: @412710
     /* 412710 */   GIM_Reject,
     /* 412711 */ // Label 7968: @412711
     /* 412711 */ GIM_Reject,
     /* 412712 */ // Label 7853: @412712
     /* 412712 */ GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(413890),
     /* 412717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 412723 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 412726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412730 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(412814), // Rule ID 6160 //
     /* 412735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412767 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412771 */     // MIs[2] Operand 1
     /* 412771 */     // No operand predicates
     /* 412771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 412775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412779 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412783 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412794 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 412805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412812 */     GIR_RootConstrainSelectedInstOperands,
     /* 412813 */     // GIR_Coverage, 6160,
     /* 412813 */     GIR_EraseRootFromParent_Done,
     /* 412814 */   // Label 7989: @412814
     /* 412814 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(412895), // Rule ID 6192 //
     /* 412819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412863 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412867 */     // MIs[3] Operand 1
     /* 412867 */     // No operand predicates
     /* 412867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412875 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412877 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412893 */     GIR_RootConstrainSelectedInstOperands,
     /* 412894 */     // GIR_Coverage, 6192,
     /* 412894 */     GIR_EraseRootFromParent_Done,
     /* 412895 */   // Label 7990: @412895
     /* 412895 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(412979), // Rule ID 6224 //
     /* 412900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 412928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 412941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412949 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 412953 */     // MIs[3] Operand 1
     /* 412953 */     // No operand predicates
     /* 412953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412957 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412959 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 412959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 412962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 412970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412977 */     GIR_RootConstrainSelectedInstOperands,
     /* 412978 */     // GIR_Coverage, 6224,
     /* 412978 */     GIR_EraseRootFromParent_Done,
     /* 412979 */   // Label 7991: @412979
     /* 412979 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(413060), // Rule ID 6128 //
     /* 412984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 412987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 413011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 413024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413032 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 413036 */     // MIs[3] Operand 1
     /* 413036 */     // No operand predicates
     /* 413036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413040 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413042 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 413042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413049 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413058 */     GIR_RootConstrainSelectedInstOperands,
     /* 413059 */     // GIR_Coverage, 6128,
     /* 413059 */     GIR_EraseRootFromParent_Done,
     /* 413060 */   // Label 7992: @413060
     /* 413060 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(413129), // Rule ID 2531 //
     /* 413065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 413076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 413089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413097 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 413101 */     // MIs[2] Operand 1
     /* 413101 */     // No operand predicates
     /* 413101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413111 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 413111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 413114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413127 */     GIR_RootConstrainSelectedInstOperands,
     /* 413128 */     // GIR_Coverage, 2531,
     /* 413128 */     GIR_EraseRootFromParent_Done,
     /* 413129 */   // Label 7993: @413129
     /* 413129 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(413198), // Rule ID 6096 //
     /* 413134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 413149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 413162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413170 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 413174 */     // MIs[2] Operand 1
     /* 413174 */     // No operand predicates
     /* 413174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413180 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 413180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 413183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413196 */     GIR_RootConstrainSelectedInstOperands,
     /* 413197 */     // GIR_Coverage, 6096,
     /* 413197 */     GIR_EraseRootFromParent_Done,
     /* 413198 */   // Label 7994: @413198
     /* 413198 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(413297), // Rule ID 6162 //
     /* 413203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413246 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 413249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413258 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413265 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 413268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 413289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413295 */     GIR_RootConstrainSelectedInstOperands,
     /* 413296 */     // GIR_Coverage, 6162,
     /* 413296 */     GIR_EraseRootFromParent_Done,
     /* 413297 */   // Label 7995: @413297
     /* 413297 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(413393), // Rule ID 6194 //
     /* 413302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 413325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413344 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 413347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413356 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413359 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413363 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 413366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413391 */     GIR_RootConstrainSelectedInstOperands,
     /* 413392 */     // GIR_Coverage, 6194,
     /* 413392 */     GIR_EraseRootFromParent_Done,
     /* 413393 */   // Label 7996: @413393
     /* 413393 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(413492), // Rule ID 6226 //
     /* 413398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 413426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413441 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 413444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413453 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413460 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 413463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413468 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 413484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413490 */     GIR_RootConstrainSelectedInstOperands,
     /* 413491 */     // GIR_Coverage, 6226,
     /* 413491 */     GIR_EraseRootFromParent_Done,
     /* 413492 */   // Label 7997: @413492
     /* 413492 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(413588), // Rule ID 6130 //
     /* 413497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 413524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 413528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413539 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 413542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413551 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413554 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413558 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 413561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413586 */     GIR_RootConstrainSelectedInstOperands,
     /* 413587 */     // GIR_Coverage, 6130,
     /* 413587 */     GIR_EraseRootFromParent_Done,
     /* 413588 */   // Label 7998: @413588
     /* 413588 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(413672), // Rule ID 2533 //
     /* 413593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413623 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 413626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413635 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413638 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413642 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 413645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 413658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413670 */     GIR_RootConstrainSelectedInstOperands,
     /* 413671 */     // GIR_Coverage, 2533,
     /* 413671 */     GIR_EraseRootFromParent_Done,
     /* 413672 */   // Label 7999: @413672
     /* 413672 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(413722), // Rule ID 13411 //
     /* 413677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413707 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 413707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 413710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413720 */     GIR_RootConstrainSelectedInstOperands,
     /* 413721 */     // GIR_Coverage, 13411,
     /* 413721 */     GIR_EraseRootFromParent_Done,
     /* 413722 */   // Label 8000: @413722
     /* 413722 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(413806), // Rule ID 6098 //
     /* 413727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413757 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 413760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413769 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413776 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 413779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413784 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 413792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413804 */     GIR_RootConstrainSelectedInstOperands,
     /* 413805 */     // GIR_Coverage, 6098,
     /* 413805 */     GIR_EraseRootFromParent_Done,
     /* 413806 */   // Label 8001: @413806
     /* 413806 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(413856), // Rule ID 1303 //
     /* 413811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413841 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 413841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 413844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413854 */     GIR_RootConstrainSelectedInstOperands,
     /* 413855 */     // GIR_Coverage, 1303,
     /* 413855 */     GIR_EraseRootFromParent_Done,
     /* 413856 */   // Label 8002: @413856
     /* 413856 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(413889), // Rule ID 1293 //
     /* 413861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413876 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 413876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 413879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413885 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 413887 */     GIR_RootConstrainSelectedInstOperands,
     /* 413888 */     // GIR_Coverage, 1293,
     /* 413888 */     GIR_EraseRootFromParent_Done,
     /* 413889 */   // Label 8003: @413889
     /* 413889 */   GIM_Reject,
     /* 413890 */ // Label 7988: @413890
     /* 413890 */ GIM_Reject,
     /* 413891 */ // Label 7854: @413891
     /* 413891 */ GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(415411),
     /* 413896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 413902 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 413905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413909 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(413987), // Rule ID 6258 //
     /* 413914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 413922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 413951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413955 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 413959 */     // MIs[3] Operand 1
     /* 413959 */     // No operand predicates
     /* 413959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413967 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413969 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 413969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 413972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413985 */     GIR_RootConstrainSelectedInstOperands,
     /* 413986 */     // GIR_Coverage, 6258,
     /* 413986 */     GIR_EraseRootFromParent_Done,
     /* 413987 */   // Label 8005: @413987
     /* 413987 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(414071), // Rule ID 6172 //
     /* 413992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414024 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414028 */     // MIs[2] Operand 1
     /* 414028 */     // No operand predicates
     /* 414028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 414032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414036 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414040 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414049 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414051 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 414062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414069 */     GIR_RootConstrainSelectedInstOperands,
     /* 414070 */     // GIR_Coverage, 6172,
     /* 414070 */     GIR_EraseRootFromParent_Done,
     /* 414071 */   // Label 8006: @414071
     /* 414071 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(414152), // Rule ID 6204 //
     /* 414076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414120 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414124 */     // MIs[3] Operand 1
     /* 414124 */     // No operand predicates
     /* 414124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414134 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414150 */     GIR_RootConstrainSelectedInstOperands,
     /* 414151 */     // GIR_Coverage, 6204,
     /* 414151 */     GIR_EraseRootFromParent_Done,
     /* 414152 */   // Label 8007: @414152
     /* 414152 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(414236), // Rule ID 6236 //
     /* 414157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414193 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414206 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414210 */     // MIs[3] Operand 1
     /* 414210 */     // No operand predicates
     /* 414210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414216 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 414227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414234 */     GIR_RootConstrainSelectedInstOperands,
     /* 414235 */     // GIR_Coverage, 6236,
     /* 414235 */     GIR_EraseRootFromParent_Done,
     /* 414236 */   // Label 8008: @414236
     /* 414236 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(414314), // Rule ID 6280 //
     /* 414241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 414282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414286 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414290 */     // MIs[3] Operand 1
     /* 414290 */     // No operand predicates
     /* 414290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414294 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414296 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414312 */     GIR_RootConstrainSelectedInstOperands,
     /* 414313 */     // GIR_Coverage, 6280,
     /* 414313 */     GIR_EraseRootFromParent_Done,
     /* 414314 */   // Label 8009: @414314
     /* 414314 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(414395), // Rule ID 6140 //
     /* 414319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414346 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414350 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414359 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414363 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414367 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414371 */     // MIs[3] Operand 1
     /* 414371 */     // No operand predicates
     /* 414371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414375 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414377 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414393 */     GIR_RootConstrainSelectedInstOperands,
     /* 414394 */     // GIR_Coverage, 6140,
     /* 414394 */     GIR_EraseRootFromParent_Done,
     /* 414395 */   // Label 8010: @414395
     /* 414395 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(414464), // Rule ID 2543 //
     /* 414400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414432 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414436 */     // MIs[2] Operand 1
     /* 414436 */     // No operand predicates
     /* 414436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414446 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 414449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414462 */     GIR_RootConstrainSelectedInstOperands,
     /* 414463 */     // GIR_Coverage, 2543,
     /* 414463 */     GIR_EraseRootFromParent_Done,
     /* 414464 */   // Label 8011: @414464
     /* 414464 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(414533), // Rule ID 6108 //
     /* 414469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414505 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414509 */     // MIs[2] Operand 1
     /* 414509 */     // No operand predicates
     /* 414509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414513 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414515 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 414518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414531 */     GIR_RootConstrainSelectedInstOperands,
     /* 414532 */     // GIR_Coverage, 6108,
     /* 414532 */     GIR_EraseRootFromParent_Done,
     /* 414533 */   // Label 8012: @414533
     /* 414533 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(414626), // Rule ID 6262 //
     /* 414538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 414550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 414562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414577 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414589 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414596 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414624 */     GIR_RootConstrainSelectedInstOperands,
     /* 414625 */     // GIR_Coverage, 6262,
     /* 414625 */     GIR_EraseRootFromParent_Done,
     /* 414626 */   // Label 8013: @414626
     /* 414626 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(414725), // Rule ID 6174 //
     /* 414631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 414646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414674 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414686 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414689 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414693 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414696 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 414717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414723 */     GIR_RootConstrainSelectedInstOperands,
     /* 414724 */     // GIR_Coverage, 6174,
     /* 414724 */     GIR_EraseRootFromParent_Done,
     /* 414725 */   // Label 8014: @414725
     /* 414725 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(414821), // Rule ID 6206 //
     /* 414730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 414757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414772 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414784 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414791 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414799 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414819 */     GIR_RootConstrainSelectedInstOperands,
     /* 414820 */     // GIR_Coverage, 6206,
     /* 414820 */     GIR_EraseRootFromParent_Done,
     /* 414821 */   // Label 8015: @414821
     /* 414821 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(414920), // Rule ID 6238 //
     /* 414826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 414858 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414869 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414881 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414884 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414888 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 414912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414918 */     GIR_RootConstrainSelectedInstOperands,
     /* 414919 */     // GIR_Coverage, 6238,
     /* 414919 */     GIR_EraseRootFromParent_Done,
     /* 414920 */   // Label 8016: @414920
     /* 414920 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(415013), // Rule ID 6284 //
     /* 414925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 414941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 414953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414964 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 414967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414976 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414979 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414983 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 414986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 414996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415011 */     GIR_RootConstrainSelectedInstOperands,
     /* 415012 */     // GIR_Coverage, 6284,
     /* 415012 */     GIR_EraseRootFromParent_Done,
     /* 415013 */   // Label 8017: @415013
     /* 415013 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(415109), // Rule ID 6142 //
     /* 415018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 415049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415060 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415072 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415075 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415079 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415107 */     GIR_RootConstrainSelectedInstOperands,
     /* 415108 */     // GIR_Coverage, 6142,
     /* 415108 */     GIR_EraseRootFromParent_Done,
     /* 415109 */   // Label 8018: @415109
     /* 415109 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(415193), // Rule ID 2545 //
     /* 415114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 415129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415144 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415156 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415159 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415163 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 415179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415191 */     GIR_RootConstrainSelectedInstOperands,
     /* 415192 */     // GIR_Coverage, 2545,
     /* 415192 */     GIR_EraseRootFromParent_Done,
     /* 415193 */   // Label 8019: @415193
     /* 415193 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(415243), // Rule ID 13417 //
     /* 415198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415228 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 415228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 415231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415241 */     GIR_RootConstrainSelectedInstOperands,
     /* 415242 */     // GIR_Coverage, 13417,
     /* 415242 */     GIR_EraseRootFromParent_Done,
     /* 415243 */   // Label 8020: @415243
     /* 415243 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(415327), // Rule ID 6110 //
     /* 415248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 415267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415278 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415290 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415293 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415297 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 415313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415325 */     GIR_RootConstrainSelectedInstOperands,
     /* 415326 */     // GIR_Coverage, 6110,
     /* 415326 */     GIR_EraseRootFromParent_Done,
     /* 415327 */   // Label 8021: @415327
     /* 415327 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(415377), // Rule ID 1309 //
     /* 415332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415362 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 415362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 415365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415375 */     GIR_RootConstrainSelectedInstOperands,
     /* 415376 */     // GIR_Coverage, 1309,
     /* 415376 */     GIR_EraseRootFromParent_Done,
     /* 415377 */   // Label 8022: @415377
     /* 415377 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(415410), // Rule ID 1299 //
     /* 415382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415397 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 415397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 415400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 415408 */     GIR_RootConstrainSelectedInstOperands,
     /* 415409 */     // GIR_Coverage, 1299,
     /* 415409 */     GIR_EraseRootFromParent_Done,
     /* 415410 */   // Label 8023: @415410
     /* 415410 */   GIM_Reject,
     /* 415411 */ // Label 8004: @415411
     /* 415411 */ GIM_Reject,
     /* 415412 */ // Label 7855: @415412
     /* 415412 */ GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(416590),
     /* 415417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 415423 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 415426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415430 */   GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(415514), // Rule ID 6156 //
     /* 415435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 415454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 415463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415467 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415471 */     // MIs[2] Operand 1
     /* 415471 */     // No operand predicates
     /* 415471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 415475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415479 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415483 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415494 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 415505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 415512 */     GIR_RootConstrainSelectedInstOperands,
     /* 415513 */     // GIR_Coverage, 6156,
     /* 415513 */     GIR_EraseRootFromParent_Done,
     /* 415514 */   // Label 8025: @415514
     /* 415514 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(415595), // Rule ID 6188 //
     /* 415519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415534 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415538 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415542 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415546 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 415550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415559 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415563 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415567 */     // MIs[3] Operand 1
     /* 415567 */     // No operand predicates
     /* 415567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415575 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415577 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 415593 */     GIR_RootConstrainSelectedInstOperands,
     /* 415594 */     // GIR_Coverage, 6188,
     /* 415594 */     GIR_EraseRootFromParent_Done,
     /* 415595 */   // Label 8026: @415595
     /* 415595 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(415679), // Rule ID 6220 //
     /* 415600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 415636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415649 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415653 */     // MIs[3] Operand 1
     /* 415653 */     // No operand predicates
     /* 415653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415657 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415659 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 415670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 415677 */     GIR_RootConstrainSelectedInstOperands,
     /* 415678 */     // GIR_Coverage, 6220,
     /* 415678 */     GIR_EraseRootFromParent_Done,
     /* 415679 */   // Label 8027: @415679
     /* 415679 */   GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(415760), // Rule ID 6124 //
     /* 415684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 415719 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415732 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415736 */     // MIs[3] Operand 1
     /* 415736 */     // No operand predicates
     /* 415736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415742 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 415758 */     GIR_RootConstrainSelectedInstOperands,
     /* 415759 */     // GIR_Coverage, 6124,
     /* 415759 */     GIR_EraseRootFromParent_Done,
     /* 415760 */   // Label 8028: @415760
     /* 415760 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(415829), // Rule ID 2527 //
     /* 415765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 415784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 415793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415797 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415801 */     // MIs[2] Operand 1
     /* 415801 */     // No operand predicates
     /* 415801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415811 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 415814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 415827 */     GIR_RootConstrainSelectedInstOperands,
     /* 415828 */     // GIR_Coverage, 2527,
     /* 415828 */     GIR_EraseRootFromParent_Done,
     /* 415829 */   // Label 8029: @415829
     /* 415829 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(415898), // Rule ID 6092 //
     /* 415834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 415849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 415857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 415862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 415866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415870 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 415874 */     // MIs[2] Operand 1
     /* 415874 */     // No operand predicates
     /* 415874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415880 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 415880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 415883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 415896 */     GIR_RootConstrainSelectedInstOperands,
     /* 415897 */     // GIR_Coverage, 6092,
     /* 415897 */     GIR_EraseRootFromParent_Done,
     /* 415898 */   // Label 8030: @415898
     /* 415898 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(415997), // Rule ID 6158 //
     /* 415903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 415906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 415918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 415935 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415946 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 415949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415958 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415965 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 415968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 415978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 415981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 415989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415995 */     GIR_RootConstrainSelectedInstOperands,
     /* 415996 */     // GIR_Coverage, 6158,
     /* 415996 */     GIR_EraseRootFromParent_Done,
     /* 415997 */   // Label 8031: @415997
     /* 415997 */   GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(416093), // Rule ID 6190 //
     /* 416002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 416025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416029 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416044 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 416047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416056 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416059 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416063 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 416066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416091 */     GIR_RootConstrainSelectedInstOperands,
     /* 416092 */     // GIR_Coverage, 6190,
     /* 416092 */     GIR_EraseRootFromParent_Done,
     /* 416093 */   // Label 8032: @416093
     /* 416093 */   GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(416192), // Rule ID 6222 //
     /* 416098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 416126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416141 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 416144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416153 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416160 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 416163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 416184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416190 */     GIR_RootConstrainSelectedInstOperands,
     /* 416191 */     // GIR_Coverage, 6222,
     /* 416191 */     GIR_EraseRootFromParent_Done,
     /* 416192 */   // Label 8033: @416192
     /* 416192 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(416288), // Rule ID 6126 //
     /* 416197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 416224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416239 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 416242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416251 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416258 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 416261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416286 */     GIR_RootConstrainSelectedInstOperands,
     /* 416287 */     // GIR_Coverage, 6126,
     /* 416287 */     GIR_EraseRootFromParent_Done,
     /* 416288 */   // Label 8034: @416288
     /* 416288 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(416372), // Rule ID 2529 //
     /* 416293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 416304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416323 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 416326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416335 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416342 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 416345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416350 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 416358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416370 */     GIR_RootConstrainSelectedInstOperands,
     /* 416371 */     // GIR_Coverage, 2529,
     /* 416371 */     GIR_EraseRootFromParent_Done,
     /* 416372 */   // Label 8035: @416372
     /* 416372 */   GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(416422), // Rule ID 13413 //
     /* 416377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416407 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 416407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 416410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416420 */     GIR_RootConstrainSelectedInstOperands,
     /* 416421 */     // GIR_Coverage, 13413,
     /* 416421 */     GIR_EraseRootFromParent_Done,
     /* 416422 */   // Label 8036: @416422
     /* 416422 */   GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(416506), // Rule ID 6094 //
     /* 416427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 416442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416457 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 416460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416469 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416472 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416476 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 416479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 416492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416504 */     GIR_RootConstrainSelectedInstOperands,
     /* 416505 */     // GIR_Coverage, 6094,
     /* 416505 */     GIR_EraseRootFromParent_Done,
     /* 416506 */   // Label 8037: @416506
     /* 416506 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(416556), // Rule ID 1305 //
     /* 416511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416541 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 416541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 416544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416554 */     GIR_RootConstrainSelectedInstOperands,
     /* 416555 */     // GIR_Coverage, 1305,
     /* 416555 */     GIR_EraseRootFromParent_Done,
     /* 416556 */   // Label 8038: @416556
     /* 416556 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(416589), // Rule ID 1295 //
     /* 416561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416576 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 416576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 416579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 416587 */     GIR_RootConstrainSelectedInstOperands,
     /* 416588 */     // GIR_Coverage, 1295,
     /* 416588 */     GIR_EraseRootFromParent_Done,
     /* 416589 */   // Label 8039: @416589
     /* 416589 */   GIM_Reject,
     /* 416590 */ // Label 8024: @416590
     /* 416590 */ GIM_Reject,
     /* 416591 */ // Label 7856: @416591
     /* 416591 */ GIM_Reject,
     /* 416592 */ // Label 108: @416592
     /* 416592 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 8048*/ GIMT_Encode4(416891),
     /* 416603 */ /*GILLT_s16*//*Label 8040*/ GIMT_Encode4(416643),
     /* 416607 */ /*GILLT_s32*//*Label 8041*/ GIMT_Encode4(416674),
     /* 416611 */ /*GILLT_s64*//*Label 8042*/ GIMT_Encode4(416705), GIMT_Encode4(0),
     /* 416619 */ /*GILLT_v2s32*//*Label 8043*/ GIMT_Encode4(416736),
     /* 416623 */ /*GILLT_v2s64*//*Label 8044*/ GIMT_Encode4(416767),
     /* 416627 */ /*GILLT_v4s16*//*Label 8045*/ GIMT_Encode4(416798),
     /* 416631 */ /*GILLT_v4s32*//*Label 8046*/ GIMT_Encode4(416829), GIMT_Encode4(0),
     /* 416639 */ /*GILLT_v8s16*//*Label 8047*/ GIMT_Encode4(416860),
     /* 416643 */ // Label 8040: @416643
     /* 416643 */ GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(416673), // Rule ID 569 //
     /* 416648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 416651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 416654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416662 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 416662 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 416667 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416671 */   GIR_RootConstrainSelectedInstOperands,
     /* 416672 */   // GIR_Coverage, 569,
     /* 416672 */   GIR_Done,
     /* 416673 */ // Label 8049: @416673
     /* 416673 */ GIM_Reject,
     /* 416674 */ // Label 8041: @416674
     /* 416674 */ GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(416704), // Rule ID 571 //
     /* 416679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 416682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 416685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416693 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 416693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 416698 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416702 */   GIR_RootConstrainSelectedInstOperands,
     /* 416703 */   // GIR_Coverage, 571,
     /* 416703 */   GIR_Done,
     /* 416704 */ // Label 8050: @416704
     /* 416704 */ GIM_Reject,
     /* 416705 */ // Label 8042: @416705
     /* 416705 */ GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(416735), // Rule ID 573 //
     /* 416710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 416713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 416716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416724 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 416724 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 416729 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416733 */   GIR_RootConstrainSelectedInstOperands,
     /* 416734 */   // GIR_Coverage, 573,
     /* 416734 */   GIR_Done,
     /* 416735 */ // Label 8051: @416735
     /* 416735 */ GIM_Reject,
     /* 416736 */ // Label 8043: @416736
     /* 416736 */ GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(416766), // Rule ID 959 //
     /* 416741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 416747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416755 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 416755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 416760 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416764 */   GIR_RootConstrainSelectedInstOperands,
     /* 416765 */   // GIR_Coverage, 959,
     /* 416765 */   GIR_Done,
     /* 416766 */ // Label 8052: @416766
     /* 416766 */ GIM_Reject,
     /* 416767 */ // Label 8044: @416767
     /* 416767 */ GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(416797), // Rule ID 963 //
     /* 416772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 416778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416786 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 416786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 416791 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416795 */   GIR_RootConstrainSelectedInstOperands,
     /* 416796 */   // GIR_Coverage, 963,
     /* 416796 */   GIR_Done,
     /* 416797 */ // Label 8053: @416797
     /* 416797 */ GIM_Reject,
     /* 416798 */ // Label 8045: @416798
     /* 416798 */ GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(416828), // Rule ID 955 //
     /* 416803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 416809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 416817 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 416817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 416822 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416826 */   GIR_RootConstrainSelectedInstOperands,
     /* 416827 */   // GIR_Coverage, 955,
     /* 416827 */   GIR_Done,
     /* 416828 */ // Label 8054: @416828
     /* 416828 */ GIM_Reject,
     /* 416829 */ // Label 8046: @416829
     /* 416829 */ GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(416859), // Rule ID 961 //
     /* 416834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416848 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 416848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 416853 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416857 */   GIR_RootConstrainSelectedInstOperands,
     /* 416858 */   // GIR_Coverage, 961,
     /* 416858 */   GIR_Done,
     /* 416859 */ // Label 8055: @416859
     /* 416859 */ GIM_Reject,
     /* 416860 */ // Label 8047: @416860
     /* 416860 */ GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(416890), // Rule ID 957 //
     /* 416865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416879 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 416879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 416884 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 416888 */   GIR_RootConstrainSelectedInstOperands,
     /* 416889 */   // GIR_Coverage, 957,
     /* 416889 */   GIR_Done,
     /* 416890 */ // Label 8056: @416890
     /* 416890 */ GIM_Reject,
     /* 416891 */ // Label 8048: @416891
     /* 416891 */ GIM_Reject,
     /* 416892 */ // Label 109: @416892
     /* 416892 */ GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(416905), // Rule ID 6573 //
     /* 416897 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 416897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 416900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 416903 */   GIR_RootConstrainSelectedInstOperands,
     /* 416904 */   // GIR_Coverage, 6573,
     /* 416904 */   GIR_EraseRootFromParent_Done,
     /* 416905 */ // Label 8057: @416905
     /* 416905 */ GIM_Reject,
     /* 416906 */ // Label 110: @416906
     /* 416906 */ GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(416926), // Rule ID 6574 //
     /* 416911 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 416911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 416914 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 416924 */   GIR_RootConstrainSelectedInstOperands,
     /* 416925 */   // GIR_Coverage, 6574,
     /* 416925 */   GIR_EraseRootFromParent_Done,
     /* 416926 */ // Label 8058: @416926
     /* 416926 */ GIM_Reject,
     /* 416927 */ // Label 111: @416927
     /* 416927 */ GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(416951), // Rule ID 6575 //
     /* 416932 */   // MIs[0] kind
     /* 416932 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 416935 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 416940 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 416940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 416943 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 416949 */   GIR_RootConstrainSelectedInstOperands,
     /* 416950 */   // GIR_Coverage, 6575,
     /* 416950 */   GIR_EraseRootFromParent_Done,
     /* 416951 */ // Label 8059: @416951
     /* 416951 */ GIM_Reject,
     /* 416952 */ // Label 112: @416952
     /* 416952 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8063*/ GIMT_Encode4(417261),
     /* 416963 */ /*GILLT_s16*//*Label 8060*/ GIMT_Encode4(416975),
     /* 416967 */ /*GILLT_s32*//*Label 8061*/ GIMT_Encode4(417128),
     /* 416971 */ /*GILLT_s64*//*Label 8062*/ GIMT_Encode4(417233),
     /* 416975 */ // Label 8060: @416975
     /* 416975 */ GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(417076), // Rule ID 5642 //
     /* 416980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 416983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 416990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416994 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 416994 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 416997 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 417001 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417006 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417010 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417014 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 417016 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 417019 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 417023 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417028 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 417031 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 417037 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 417040 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 417044 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417049 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 417056 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417061 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 417069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417071 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417074 */   GIR_RootConstrainSelectedInstOperands,
     /* 417075 */   // GIR_Coverage, 5642,
     /* 417075 */   GIR_EraseRootFromParent_Done,
     /* 417076 */ // Label 8064: @417076
     /* 417076 */ GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(417127), // Rule ID 5643 //
     /* 417081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 417084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417095 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 417095 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 417098 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 417102 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417107 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417111 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 417117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 417120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417125 */   GIR_RootConstrainSelectedInstOperands,
     /* 417126 */   // GIR_Coverage, 5643,
     /* 417126 */   GIR_EraseRootFromParent_Done,
     /* 417127 */ // Label 8065: @417127
     /* 417127 */ GIM_Reject,
     /* 417128 */ // Label 8061: @417128
     /* 417128 */ GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(417205), // Rule ID 5644 //
     /* 417133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417144 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 417144 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 417147 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 417151 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417156 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417160 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 417166 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 417169 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 417173 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417178 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 417185 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417190 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 417198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417203 */   GIR_RootConstrainSelectedInstOperands,
     /* 417204 */   // GIR_Coverage, 5644,
     /* 417204 */   GIR_EraseRootFromParent_Done,
     /* 417205 */ // Label 8066: @417205
     /* 417205 */ GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(417232), // Rule ID 5645 //
     /* 417210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417221 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 417221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 417226 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417230 */   GIR_RootConstrainSelectedInstOperands,
     /* 417231 */   // GIR_Coverage, 5645,
     /* 417231 */   GIR_Done,
     /* 417232 */ // Label 8067: @417232
     /* 417232 */ GIM_Reject,
     /* 417233 */ // Label 8062: @417233
     /* 417233 */ GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(417260), // Rule ID 5646 //
     /* 417238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417249 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 417249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 417254 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417258 */   GIR_RootConstrainSelectedInstOperands,
     /* 417259 */   // GIR_Coverage, 5646,
     /* 417259 */   GIR_Done,
     /* 417260 */ // Label 8068: @417260
     /* 417260 */ GIM_Reject,
     /* 417261 */ // Label 8063: @417261
     /* 417261 */ GIM_Reject,
     /* 417262 */ // Label 113: @417262
     /* 417262 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8072*/ GIMT_Encode4(417432),
     /* 417273 */ /*GILLT_s16*//*Label 8069*/ GIMT_Encode4(417285),
     /* 417277 */ /*GILLT_s32*//*Label 8070*/ GIMT_Encode4(417346),
     /* 417281 */ /*GILLT_s64*//*Label 8071*/ GIMT_Encode4(417404),
     /* 417285 */ // Label 8069: @417285
     /* 417285 */ GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(417315), // Rule ID 1942 //
     /* 417290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417304 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 417304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 417309 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417313 */   GIR_RootConstrainSelectedInstOperands,
     /* 417314 */   // GIR_Coverage, 1942,
     /* 417314 */   GIR_Done,
     /* 417315 */ // Label 8073: @417315
     /* 417315 */ GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(417345), // Rule ID 1944 //
     /* 417320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417334 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 417334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 417339 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417343 */   GIR_RootConstrainSelectedInstOperands,
     /* 417344 */   // GIR_Coverage, 1944,
     /* 417344 */   GIR_Done,
     /* 417345 */ // Label 8074: @417345
     /* 417345 */ GIM_Reject,
     /* 417346 */ // Label 8070: @417346
     /* 417346 */ GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(417376), // Rule ID 1946 //
     /* 417351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417365 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 417365 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 417370 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417374 */   GIR_RootConstrainSelectedInstOperands,
     /* 417375 */   // GIR_Coverage, 1946,
     /* 417375 */   GIR_Done,
     /* 417376 */ // Label 8075: @417376
     /* 417376 */ GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(417403), // Rule ID 5652 //
     /* 417381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417392 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 417392 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 417397 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417401 */   GIR_RootConstrainSelectedInstOperands,
     /* 417402 */   // GIR_Coverage, 5652,
     /* 417402 */   GIR_Done,
     /* 417403 */ // Label 8076: @417403
     /* 417403 */ GIM_Reject,
     /* 417404 */ // Label 8071: @417404
     /* 417404 */ GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(417431), // Rule ID 5654 //
     /* 417409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417420 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 417420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 417425 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417429 */   GIR_RootConstrainSelectedInstOperands,
     /* 417430 */   // GIR_Coverage, 5654,
     /* 417430 */   GIR_Done,
     /* 417431 */ // Label 8077: @417431
     /* 417431 */ GIM_Reject,
     /* 417432 */ // Label 8072: @417432
     /* 417432 */ GIM_Reject,
     /* 417433 */ // Label 114: @417433
     /* 417433 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8081*/ GIMT_Encode4(417603),
     /* 417444 */ /*GILLT_s16*//*Label 8078*/ GIMT_Encode4(417456),
     /* 417448 */ /*GILLT_s32*//*Label 8079*/ GIMT_Encode4(417517),
     /* 417452 */ /*GILLT_s64*//*Label 8080*/ GIMT_Encode4(417575),
     /* 417456 */ // Label 8078: @417456
     /* 417456 */ GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(417486), // Rule ID 1954 //
     /* 417461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417475 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 417475 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 417480 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417484 */   GIR_RootConstrainSelectedInstOperands,
     /* 417485 */   // GIR_Coverage, 1954,
     /* 417485 */   GIR_Done,
     /* 417486 */ // Label 8082: @417486
     /* 417486 */ GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(417516), // Rule ID 1956 //
     /* 417491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417505 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 417505 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 417510 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417514 */   GIR_RootConstrainSelectedInstOperands,
     /* 417515 */   // GIR_Coverage, 1956,
     /* 417515 */   GIR_Done,
     /* 417516 */ // Label 8083: @417516
     /* 417516 */ GIM_Reject,
     /* 417517 */ // Label 8079: @417517
     /* 417517 */ GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(417547), // Rule ID 1958 //
     /* 417522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417536 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 417536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 417541 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417545 */   GIR_RootConstrainSelectedInstOperands,
     /* 417546 */   // GIR_Coverage, 1958,
     /* 417546 */   GIR_Done,
     /* 417547 */ // Label 8084: @417547
     /* 417547 */ GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(417574), // Rule ID 5660 //
     /* 417552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417563 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 417563 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 417568 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417572 */   GIR_RootConstrainSelectedInstOperands,
     /* 417573 */   // GIR_Coverage, 5660,
     /* 417573 */   GIR_Done,
     /* 417574 */ // Label 8085: @417574
     /* 417574 */ GIM_Reject,
     /* 417575 */ // Label 8080: @417575
     /* 417575 */ GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(417602), // Rule ID 5662 //
     /* 417580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417591 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 417591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 417596 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417600 */   GIR_RootConstrainSelectedInstOperands,
     /* 417601 */   // GIR_Coverage, 5662,
     /* 417601 */   GIR_Done,
     /* 417602 */ // Label 8086: @417602
     /* 417602 */ GIM_Reject,
     /* 417603 */ // Label 8081: @417603
     /* 417603 */ GIM_Reject,
     /* 417604 */ // Label 115: @417604
     /* 417604 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8090*/ GIMT_Encode4(417774),
     /* 417615 */ /*GILLT_s16*//*Label 8087*/ GIMT_Encode4(417627),
     /* 417619 */ /*GILLT_s32*//*Label 8088*/ GIMT_Encode4(417688),
     /* 417623 */ /*GILLT_s64*//*Label 8089*/ GIMT_Encode4(417746),
     /* 417627 */ // Label 8087: @417627
     /* 417627 */ GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(417657), // Rule ID 1948 //
     /* 417632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417646 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 417646 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 417651 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417655 */   GIR_RootConstrainSelectedInstOperands,
     /* 417656 */   // GIR_Coverage, 1948,
     /* 417656 */   GIR_Done,
     /* 417657 */ // Label 8091: @417657
     /* 417657 */ GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(417687), // Rule ID 1950 //
     /* 417662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417676 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 417676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 417681 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417685 */   GIR_RootConstrainSelectedInstOperands,
     /* 417686 */   // GIR_Coverage, 1950,
     /* 417686 */   GIR_Done,
     /* 417687 */ // Label 8092: @417687
     /* 417687 */ GIM_Reject,
     /* 417688 */ // Label 8088: @417688
     /* 417688 */ GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(417718), // Rule ID 1952 //
     /* 417693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417707 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 417707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 417712 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417716 */   GIR_RootConstrainSelectedInstOperands,
     /* 417717 */   // GIR_Coverage, 1952,
     /* 417717 */   GIR_Done,
     /* 417718 */ // Label 8093: @417718
     /* 417718 */ GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(417745), // Rule ID 5656 //
     /* 417723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417734 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 417734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 417739 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417743 */   GIR_RootConstrainSelectedInstOperands,
     /* 417744 */   // GIR_Coverage, 5656,
     /* 417744 */   GIR_Done,
     /* 417745 */ // Label 8094: @417745
     /* 417745 */ GIM_Reject,
     /* 417746 */ // Label 8089: @417746
     /* 417746 */ GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(417773), // Rule ID 5658 //
     /* 417751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417762 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 417762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 417767 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417771 */   GIR_RootConstrainSelectedInstOperands,
     /* 417772 */   // GIR_Coverage, 5658,
     /* 417772 */   GIR_Done,
     /* 417773 */ // Label 8095: @417773
     /* 417773 */ GIM_Reject,
     /* 417774 */ // Label 8090: @417774
     /* 417774 */ GIM_Reject,
     /* 417775 */ // Label 116: @417775
     /* 417775 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8099*/ GIMT_Encode4(417945),
     /* 417786 */ /*GILLT_s16*//*Label 8096*/ GIMT_Encode4(417798),
     /* 417790 */ /*GILLT_s32*//*Label 8097*/ GIMT_Encode4(417859),
     /* 417794 */ /*GILLT_s64*//*Label 8098*/ GIMT_Encode4(417917),
     /* 417798 */ // Label 8096: @417798
     /* 417798 */ GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(417828), // Rule ID 1960 //
     /* 417803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417817 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 417817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 417822 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417826 */   GIR_RootConstrainSelectedInstOperands,
     /* 417827 */   // GIR_Coverage, 1960,
     /* 417827 */   GIR_Done,
     /* 417828 */ // Label 8100: @417828
     /* 417828 */ GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(417858), // Rule ID 1962 //
     /* 417833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417847 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 417847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 417852 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417856 */   GIR_RootConstrainSelectedInstOperands,
     /* 417857 */   // GIR_Coverage, 1962,
     /* 417857 */   GIR_Done,
     /* 417858 */ // Label 8101: @417858
     /* 417858 */ GIM_Reject,
     /* 417859 */ // Label 8097: @417859
     /* 417859 */ GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(417889), // Rule ID 1964 //
     /* 417864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417878 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 417878 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 417883 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417887 */   GIR_RootConstrainSelectedInstOperands,
     /* 417888 */   // GIR_Coverage, 1964,
     /* 417888 */   GIR_Done,
     /* 417889 */ // Label 8102: @417889
     /* 417889 */ GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(417916), // Rule ID 5664 //
     /* 417894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417905 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 417905 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 417910 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417914 */   GIR_RootConstrainSelectedInstOperands,
     /* 417915 */   // GIR_Coverage, 5664,
     /* 417915 */   GIR_Done,
     /* 417916 */ // Label 8103: @417916
     /* 417916 */ GIM_Reject,
     /* 417917 */ // Label 8098: @417917
     /* 417917 */ GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(417944), // Rule ID 5666 //
     /* 417922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417933 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 417933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 417938 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417942 */   GIR_RootConstrainSelectedInstOperands,
     /* 417943 */   // GIR_Coverage, 5666,
     /* 417943 */   GIR_Done,
     /* 417944 */ // Label 8104: @417944
     /* 417944 */ GIM_Reject,
     /* 417945 */ // Label 8099: @417945
     /* 417945 */ GIM_Reject,
     /* 417946 */ // Label 117: @417946
     /* 417946 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 8109*/ GIMT_Encode4(419074),
     /* 417957 */ /*GILLT_s8*//*Label 8105*/ GIMT_Encode4(417973),
     /* 417961 */ /*GILLT_s16*//*Label 8106*/ GIMT_Encode4(418020),
     /* 417965 */ /*GILLT_s32*//*Label 8107*/ GIMT_Encode4(418435),
     /* 417969 */ /*GILLT_s64*//*Label 8108*/ GIMT_Encode4(418888),
     /* 417973 */ // Label 8105: @417973
     /* 417973 */ GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(417996), // Rule ID 5945 //
     /* 417978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 417981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 417985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417989 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 417989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 417994 */   GIR_RootConstrainSelectedInstOperands,
     /* 417995 */   // GIR_Coverage, 5945,
     /* 417995 */   GIR_Done,
     /* 417996 */ // Label 8110: @417996
     /* 417996 */ GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(418019), // Rule ID 5946 //
     /* 418001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418012 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 418012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 418017 */   GIR_RootConstrainSelectedInstOperands,
     /* 418018 */   // GIR_Coverage, 5946,
     /* 418018 */   GIR_Done,
     /* 418019 */ // Label 8111: @418019
     /* 418019 */ GIM_Reject,
     /* 418020 */ // Label 8106: @418020
     /* 418020 */ GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(418070), // Rule ID 5892 //
     /* 418025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418032 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418040 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418043 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 418048 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 418052 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418057 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418059 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 418059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 418062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418064 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418068 */   GIR_RootConstrainSelectedInstOperands,
     /* 418069 */   // GIR_Coverage, 5892,
     /* 418069 */   GIR_EraseRootFromParent_Done,
     /* 418070 */ // Label 8112: @418070
     /* 418070 */ GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(418120), // Rule ID 5894 //
     /* 418075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418082 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418086 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418090 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418093 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 418098 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 418102 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418107 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418109 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 418109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 418112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418114 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418118 */   GIR_RootConstrainSelectedInstOperands,
     /* 418119 */   // GIR_Coverage, 5894,
     /* 418119 */   GIR_EraseRootFromParent_Done,
     /* 418120 */ // Label 8113: @418120
     /* 418120 */ GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(418170), // Rule ID 5902 //
     /* 418125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418132 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418136 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418140 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418143 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 418148 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 418152 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418157 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418159 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 418159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 418162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418164 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418168 */   GIR_RootConstrainSelectedInstOperands,
     /* 418169 */   // GIR_Coverage, 5902,
     /* 418169 */   GIR_EraseRootFromParent_Done,
     /* 418170 */ // Label 8114: @418170
     /* 418170 */ GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(418220), // Rule ID 5904 //
     /* 418175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418182 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418186 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418190 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418193 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 418198 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 418202 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418207 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418209 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 418209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 418212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418214 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418218 */   GIR_RootConstrainSelectedInstOperands,
     /* 418219 */   // GIR_Coverage, 5904,
     /* 418219 */   GIR_EraseRootFromParent_Done,
     /* 418220 */ // Label 8115: @418220
     /* 418220 */ GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(418262), // Rule ID 5901 //
     /* 418225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418232 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 418240 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418244 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418249 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418251 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 418251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 418254 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418256 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418260 */   GIR_RootConstrainSelectedInstOperands,
     /* 418261 */   // GIR_Coverage, 5901,
     /* 418261 */   GIR_EraseRootFromParent_Done,
     /* 418262 */ // Label 8116: @418262
     /* 418262 */ GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(418304), // Rule ID 5903 //
     /* 418267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418274 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418278 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 418282 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418286 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418291 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418293 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 418293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 418296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418298 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418302 */   GIR_RootConstrainSelectedInstOperands,
     /* 418303 */   // GIR_Coverage, 5903,
     /* 418303 */   GIR_EraseRootFromParent_Done,
     /* 418304 */ // Label 8117: @418304
     /* 418304 */ GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(418346), // Rule ID 5891 //
     /* 418309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418316 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418320 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 418324 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418328 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418333 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418335 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 418335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 418338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418340 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418344 */   GIR_RootConstrainSelectedInstOperands,
     /* 418345 */   // GIR_Coverage, 5891,
     /* 418345 */   GIR_EraseRootFromParent_Done,
     /* 418346 */ // Label 8118: @418346
     /* 418346 */ GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(418388), // Rule ID 5893 //
     /* 418351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418358 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 418366 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418370 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418375 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418377 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 418377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 418380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418382 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418386 */   GIR_RootConstrainSelectedInstOperands,
     /* 418387 */   // GIR_Coverage, 5893,
     /* 418387 */   GIR_EraseRootFromParent_Done,
     /* 418388 */ // Label 8119: @418388
     /* 418388 */ GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(418411), // Rule ID 5947 //
     /* 418393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418404 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 418404 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 418409 */   GIR_RootConstrainSelectedInstOperands,
     /* 418410 */   // GIR_Coverage, 5947,
     /* 418410 */   GIR_Done,
     /* 418411 */ // Label 8120: @418411
     /* 418411 */ GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(418434), // Rule ID 5948 //
     /* 418416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418427 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 418427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 418432 */   GIR_RootConstrainSelectedInstOperands,
     /* 418433 */   // GIR_Coverage, 5948,
     /* 418433 */   GIR_Done,
     /* 418434 */ // Label 8121: @418434
     /* 418434 */ GIM_Reject,
     /* 418435 */ // Label 8107: @418435
     /* 418435 */ GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(418485), // Rule ID 5896 //
     /* 418440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418447 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418451 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418455 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418458 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 418463 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 418467 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418472 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418474 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 418474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 418477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418479 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418483 */   GIR_RootConstrainSelectedInstOperands,
     /* 418484 */   // GIR_Coverage, 5896,
     /* 418484 */   GIR_EraseRootFromParent_Done,
     /* 418485 */ // Label 8122: @418485
     /* 418485 */ GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(418535), // Rule ID 5898 //
     /* 418490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418497 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418501 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418505 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418508 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 418513 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 418517 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418522 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418524 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 418524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 418527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418529 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418533 */   GIR_RootConstrainSelectedInstOperands,
     /* 418534 */   // GIR_Coverage, 5898,
     /* 418534 */   GIR_EraseRootFromParent_Done,
     /* 418535 */ // Label 8123: @418535
     /* 418535 */ GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(418585), // Rule ID 5906 //
     /* 418540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418547 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418551 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418555 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418558 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 418563 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 418567 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418572 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418574 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 418574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 418577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418579 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418583 */   GIR_RootConstrainSelectedInstOperands,
     /* 418584 */   // GIR_Coverage, 5906,
     /* 418584 */   GIR_EraseRootFromParent_Done,
     /* 418585 */ // Label 8124: @418585
     /* 418585 */ GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(418635), // Rule ID 5908 //
     /* 418590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418597 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418601 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418605 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418608 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 418613 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 418617 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418622 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418624 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 418624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 418627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418629 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418633 */   GIR_RootConstrainSelectedInstOperands,
     /* 418634 */   // GIR_Coverage, 5908,
     /* 418634 */   GIR_EraseRootFromParent_Done,
     /* 418635 */ // Label 8125: @418635
     /* 418635 */ GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(418677), // Rule ID 5905 //
     /* 418640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418647 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418651 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 418655 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418659 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418664 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418666 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 418666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 418669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418671 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418675 */   GIR_RootConstrainSelectedInstOperands,
     /* 418676 */   // GIR_Coverage, 5905,
     /* 418676 */   GIR_EraseRootFromParent_Done,
     /* 418677 */ // Label 8126: @418677
     /* 418677 */ GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(418719), // Rule ID 5907 //
     /* 418682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418689 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 418697 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418701 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418706 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418708 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 418708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 418711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418713 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418717 */   GIR_RootConstrainSelectedInstOperands,
     /* 418718 */   // GIR_Coverage, 5907,
     /* 418718 */   GIR_EraseRootFromParent_Done,
     /* 418719 */ // Label 8127: @418719
     /* 418719 */ GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(418761), // Rule ID 5895 //
     /* 418724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418731 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418735 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 418739 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418743 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418748 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418750 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 418750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 418753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418755 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418759 */   GIR_RootConstrainSelectedInstOperands,
     /* 418760 */   // GIR_Coverage, 5895,
     /* 418760 */   GIR_EraseRootFromParent_Done,
     /* 418761 */ // Label 8128: @418761
     /* 418761 */ GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(418803), // Rule ID 5897 //
     /* 418766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418773 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418777 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 418781 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418785 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418790 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418792 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 418792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 418795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418797 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418801 */   GIR_RootConstrainSelectedInstOperands,
     /* 418802 */   // GIR_Coverage, 5897,
     /* 418802 */   GIR_EraseRootFromParent_Done,
     /* 418803 */ // Label 8129: @418803
     /* 418803 */ GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(418864), // Rule ID 5949 //
     /* 418808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418819 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 418819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 418822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 418826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 418831 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418835 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 418839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 418841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 418844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 418846 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 418853 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418858 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418863 */   // GIR_Coverage, 5949,
     /* 418863 */   GIR_EraseRootFromParent_Done,
     /* 418864 */ // Label 8130: @418864
     /* 418864 */ GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(418887), // Rule ID 5950 //
     /* 418869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418880 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 418880 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 418885 */   GIR_RootConstrainSelectedInstOperands,
     /* 418886 */   // GIR_Coverage, 5950,
     /* 418886 */   GIR_Done,
     /* 418887 */ // Label 8131: @418887
     /* 418887 */ GIM_Reject,
     /* 418888 */ // Label 8108: @418888
     /* 418888 */ GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(419073),
     /* 418893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 418896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418900 */   GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(418943), // Rule ID 5900 //
     /* 418905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418913 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418916 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 418921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 418925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418932 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 418932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 418935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418941 */     GIR_RootConstrainSelectedInstOperands,
     /* 418942 */     // GIR_Coverage, 5900,
     /* 418942 */     GIR_EraseRootFromParent_Done,
     /* 418943 */   // Label 8133: @418943
     /* 418943 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(418986), // Rule ID 5910 //
     /* 418948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418956 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418959 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 418964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 418968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418975 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 418975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 418978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418984 */     GIR_RootConstrainSelectedInstOperands,
     /* 418985 */     // GIR_Coverage, 5910,
     /* 418985 */     GIR_EraseRootFromParent_Done,
     /* 418986 */   // Label 8134: @418986
     /* 418986 */   GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(419021), // Rule ID 5909 //
     /* 418991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 418999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419010 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 419010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 419013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419019 */     GIR_RootConstrainSelectedInstOperands,
     /* 419020 */     // GIR_Coverage, 5909,
     /* 419020 */     GIR_EraseRootFromParent_Done,
     /* 419021 */   // Label 8135: @419021
     /* 419021 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(419056), // Rule ID 5899 //
     /* 419026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 419034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419045 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 419045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 419048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419054 */     GIR_RootConstrainSelectedInstOperands,
     /* 419055 */     // GIR_Coverage, 5899,
     /* 419055 */     GIR_EraseRootFromParent_Done,
     /* 419056 */   // Label 8136: @419056
     /* 419056 */   GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(419072), // Rule ID 5951 //
     /* 419061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419065 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 419065 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 419070 */     GIR_RootConstrainSelectedInstOperands,
     /* 419071 */     // GIR_Coverage, 5951,
     /* 419071 */     GIR_Done,
     /* 419072 */   // Label 8137: @419072
     /* 419072 */   GIM_Reject,
     /* 419073 */ // Label 8132: @419073
     /* 419073 */ GIM_Reject,
     /* 419074 */ // Label 8109: @419074
     /* 419074 */ GIM_Reject,
     /* 419075 */ // Label 118: @419075
     /* 419075 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8141*/ GIMT_Encode4(419277),
     /* 419086 */ /*GILLT_s8*//*Label 8138*/ GIMT_Encode4(419098),
     /* 419090 */ /*GILLT_s16*//*Label 8139*/ GIMT_Encode4(419145),
     /* 419094 */ /*GILLT_s32*//*Label 8140*/ GIMT_Encode4(419192),
     /* 419098 */ // Label 8138: @419098
     /* 419098 */ GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(419121), // Rule ID 6042 //
     /* 419103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 419106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419114 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 419114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 419119 */   GIR_RootConstrainSelectedInstOperands,
     /* 419120 */   // GIR_Coverage, 6042,
     /* 419120 */   GIR_Done,
     /* 419121 */ // Label 8142: @419121
     /* 419121 */ GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(419144), // Rule ID 6043 //
     /* 419126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 419129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419137 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 419137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 419142 */   GIR_RootConstrainSelectedInstOperands,
     /* 419143 */   // GIR_Coverage, 6043,
     /* 419143 */   GIR_Done,
     /* 419144 */ // Label 8143: @419144
     /* 419144 */ GIM_Reject,
     /* 419145 */ // Label 8139: @419145
     /* 419145 */ GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(419168), // Rule ID 6044 //
     /* 419150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419161 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 419161 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 419166 */   GIR_RootConstrainSelectedInstOperands,
     /* 419167 */   // GIR_Coverage, 6044,
     /* 419167 */   GIR_Done,
     /* 419168 */ // Label 8144: @419168
     /* 419168 */ GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(419191), // Rule ID 6045 //
     /* 419173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419184 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 419184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 419189 */   GIR_RootConstrainSelectedInstOperands,
     /* 419190 */   // GIR_Coverage, 6045,
     /* 419190 */   GIR_Done,
     /* 419191 */ // Label 8145: @419191
     /* 419191 */ GIM_Reject,
     /* 419192 */ // Label 8140: @419192
     /* 419192 */ GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(419215), // Rule ID 6046 //
     /* 419197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419208 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 419208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 419213 */   GIR_RootConstrainSelectedInstOperands,
     /* 419214 */   // GIR_Coverage, 6046,
     /* 419214 */   GIR_Done,
     /* 419215 */ // Label 8146: @419215
     /* 419215 */ GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(419276), // Rule ID 6047 //
     /* 419220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419231 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 419231 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 419234 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 419238 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419243 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419247 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 419253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 419256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 419258 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 419265 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419270 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419275 */   // GIR_Coverage, 6047,
     /* 419275 */   GIR_EraseRootFromParent_Done,
     /* 419276 */ // Label 8147: @419276
     /* 419276 */ GIM_Reject,
     /* 419277 */ // Label 8141: @419277
     /* 419277 */ GIM_Reject,
     /* 419278 */ // Label 119: @419278
     /* 419278 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8151*/ GIMT_Encode4(419480),
     /* 419289 */ /*GILLT_s8*//*Label 8148*/ GIMT_Encode4(419301),
     /* 419293 */ /*GILLT_s16*//*Label 8149*/ GIMT_Encode4(419348),
     /* 419297 */ /*GILLT_s32*//*Label 8150*/ GIMT_Encode4(419395),
     /* 419301 */ // Label 8148: @419301
     /* 419301 */ GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(419324), // Rule ID 6036 //
     /* 419306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 419309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419317 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 419317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 419322 */   GIR_RootConstrainSelectedInstOperands,
     /* 419323 */   // GIR_Coverage, 6036,
     /* 419323 */   GIR_Done,
     /* 419324 */ // Label 8152: @419324
     /* 419324 */ GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(419347), // Rule ID 6037 //
     /* 419329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 419332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419340 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 419340 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 419345 */   GIR_RootConstrainSelectedInstOperands,
     /* 419346 */   // GIR_Coverage, 6037,
     /* 419346 */   GIR_Done,
     /* 419347 */ // Label 8153: @419347
     /* 419347 */ GIM_Reject,
     /* 419348 */ // Label 8149: @419348
     /* 419348 */ GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(419371), // Rule ID 6038 //
     /* 419353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419364 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 419364 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 419369 */   GIR_RootConstrainSelectedInstOperands,
     /* 419370 */   // GIR_Coverage, 6038,
     /* 419370 */   GIR_Done,
     /* 419371 */ // Label 8154: @419371
     /* 419371 */ GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(419394), // Rule ID 6039 //
     /* 419376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419387 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 419387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 419392 */   GIR_RootConstrainSelectedInstOperands,
     /* 419393 */   // GIR_Coverage, 6039,
     /* 419393 */   GIR_Done,
     /* 419394 */ // Label 8155: @419394
     /* 419394 */ GIM_Reject,
     /* 419395 */ // Label 8150: @419395
     /* 419395 */ GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(419418), // Rule ID 6040 //
     /* 419400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419411 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 419411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 419416 */   GIR_RootConstrainSelectedInstOperands,
     /* 419417 */   // GIR_Coverage, 6040,
     /* 419417 */   GIR_Done,
     /* 419418 */ // Label 8156: @419418
     /* 419418 */ GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(419479), // Rule ID 6041 //
     /* 419423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419434 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 419434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 419437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 419441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419446 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419450 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419454 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 419456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 419459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 419461 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 419468 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419473 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419478 */   // GIR_Coverage, 6041,
     /* 419478 */   GIR_EraseRootFromParent_Done,
     /* 419479 */ // Label 8157: @419479
     /* 419479 */ GIM_Reject,
     /* 419480 */ // Label 8151: @419480
     /* 419480 */ GIM_Reject,
     /* 419481 */ // Label 120: @419481
     /* 419481 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8161*/ GIMT_Encode4(419683),
     /* 419492 */ /*GILLT_s8*//*Label 8158*/ GIMT_Encode4(419504),
     /* 419496 */ /*GILLT_s16*//*Label 8159*/ GIMT_Encode4(419551),
     /* 419500 */ /*GILLT_s32*//*Label 8160*/ GIMT_Encode4(419598),
     /* 419504 */ // Label 8158: @419504
     /* 419504 */ GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(419527), // Rule ID 6030 //
     /* 419509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 419512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419520 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 419520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 419525 */   GIR_RootConstrainSelectedInstOperands,
     /* 419526 */   // GIR_Coverage, 6030,
     /* 419526 */   GIR_Done,
     /* 419527 */ // Label 8162: @419527
     /* 419527 */ GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(419550), // Rule ID 6031 //
     /* 419532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 419535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419543 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 419543 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 419548 */   GIR_RootConstrainSelectedInstOperands,
     /* 419549 */   // GIR_Coverage, 6031,
     /* 419549 */   GIR_Done,
     /* 419550 */ // Label 8163: @419550
     /* 419550 */ GIM_Reject,
     /* 419551 */ // Label 8159: @419551
     /* 419551 */ GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(419574), // Rule ID 6032 //
     /* 419556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419567 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 419567 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 419572 */   GIR_RootConstrainSelectedInstOperands,
     /* 419573 */   // GIR_Coverage, 6032,
     /* 419573 */   GIR_Done,
     /* 419574 */ // Label 8164: @419574
     /* 419574 */ GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(419597), // Rule ID 6033 //
     /* 419579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419590 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 419590 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 419595 */   GIR_RootConstrainSelectedInstOperands,
     /* 419596 */   // GIR_Coverage, 6033,
     /* 419596 */   GIR_Done,
     /* 419597 */ // Label 8165: @419597
     /* 419597 */ GIM_Reject,
     /* 419598 */ // Label 8160: @419598
     /* 419598 */ GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(419621), // Rule ID 6034 //
     /* 419603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419614 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 419614 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 419619 */   GIR_RootConstrainSelectedInstOperands,
     /* 419620 */   // GIR_Coverage, 6034,
     /* 419620 */   GIR_Done,
     /* 419621 */ // Label 8166: @419621
     /* 419621 */ GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(419682), // Rule ID 6035 //
     /* 419626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419637 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 419637 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 419640 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 419644 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419649 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419653 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 419659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 419662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 419664 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 419671 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419676 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419681 */   // GIR_Coverage, 6035,
     /* 419681 */   GIR_EraseRootFromParent_Done,
     /* 419682 */ // Label 8167: @419682
     /* 419682 */ GIM_Reject,
     /* 419683 */ // Label 8161: @419683
     /* 419683 */ GIM_Reject,
     /* 419684 */ // Label 121: @419684
     /* 419684 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8171*/ GIMT_Encode4(419886),
     /* 419695 */ /*GILLT_s8*//*Label 8168*/ GIMT_Encode4(419707),
     /* 419699 */ /*GILLT_s16*//*Label 8169*/ GIMT_Encode4(419754),
     /* 419703 */ /*GILLT_s32*//*Label 8170*/ GIMT_Encode4(419801),
     /* 419707 */ // Label 8168: @419707
     /* 419707 */ GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(419730), // Rule ID 6024 //
     /* 419712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 419715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419723 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 419723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 419728 */   GIR_RootConstrainSelectedInstOperands,
     /* 419729 */   // GIR_Coverage, 6024,
     /* 419729 */   GIR_Done,
     /* 419730 */ // Label 8172: @419730
     /* 419730 */ GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(419753), // Rule ID 6025 //
     /* 419735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 419738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419746 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 419746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 419751 */   GIR_RootConstrainSelectedInstOperands,
     /* 419752 */   // GIR_Coverage, 6025,
     /* 419752 */   GIR_Done,
     /* 419753 */ // Label 8173: @419753
     /* 419753 */ GIM_Reject,
     /* 419754 */ // Label 8169: @419754
     /* 419754 */ GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(419777), // Rule ID 6026 //
     /* 419759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419770 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 419770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 419775 */   GIR_RootConstrainSelectedInstOperands,
     /* 419776 */   // GIR_Coverage, 6026,
     /* 419776 */   GIR_Done,
     /* 419777 */ // Label 8174: @419777
     /* 419777 */ GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(419800), // Rule ID 6027 //
     /* 419782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419793 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 419793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 419798 */   GIR_RootConstrainSelectedInstOperands,
     /* 419799 */   // GIR_Coverage, 6027,
     /* 419799 */   GIR_Done,
     /* 419800 */ // Label 8175: @419800
     /* 419800 */ GIM_Reject,
     /* 419801 */ // Label 8170: @419801
     /* 419801 */ GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(419824), // Rule ID 6028 //
     /* 419806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419817 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 419817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 419822 */   GIR_RootConstrainSelectedInstOperands,
     /* 419823 */   // GIR_Coverage, 6028,
     /* 419823 */   GIR_Done,
     /* 419824 */ // Label 8176: @419824
     /* 419824 */ GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(419885), // Rule ID 6029 //
     /* 419829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419840 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 419840 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 419843 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 419847 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419852 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419856 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 419862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 419865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 419867 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 419874 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419879 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419884 */   // GIR_Coverage, 6029,
     /* 419884 */   GIR_EraseRootFromParent_Done,
     /* 419885 */ // Label 8177: @419885
     /* 419885 */ GIM_Reject,
     /* 419886 */ // Label 8171: @419886
     /* 419886 */ GIM_Reject,
     /* 419887 */ // Label 122: @419887
     /* 419887 */ GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(420026),
     /* 419892 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 419895 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 419899 */   GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(419933), // Rule ID 257 //
     /* 419904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 419911 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 419911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 419914 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 419916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 419921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 419926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 419931 */     GIR_RootConstrainSelectedInstOperands,
     /* 419932 */     // GIR_Coverage, 257,
     /* 419932 */     GIR_EraseRootFromParent_Done,
     /* 419933 */   // Label 8179: @419933
     /* 419933 */   GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(419967), // Rule ID 258 //
     /* 419938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 419945 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 419945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 419948 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 419950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 419955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 419960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 419965 */     GIR_RootConstrainSelectedInstOperands,
     /* 419966 */     // GIR_Coverage, 258,
     /* 419966 */     GIR_EraseRootFromParent_Done,
     /* 419967 */   // Label 8180: @419967
     /* 419967 */   GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(419996), // Rule ID 273 //
     /* 419972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 419979 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 419979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 419982 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 419984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 419989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 419994 */     GIR_RootConstrainSelectedInstOperands,
     /* 419995 */     // GIR_Coverage, 273,
     /* 419995 */     GIR_EraseRootFromParent_Done,
     /* 419996 */   // Label 8181: @419996
     /* 419996 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(420025), // Rule ID 294 //
     /* 420001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 420008 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 420008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 420011 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 420013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 420018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 420023 */     GIR_RootConstrainSelectedInstOperands,
     /* 420024 */     // GIR_Coverage, 294,
     /* 420024 */     GIR_EraseRootFromParent_Done,
     /* 420025 */   // Label 8182: @420025
     /* 420025 */   GIM_Reject,
     /* 420026 */ // Label 8178: @420026
     /* 420026 */ GIM_Reject,
     /* 420027 */ // Label 123: @420027
     /* 420027 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8195*/ GIMT_Encode4(421014),
     /* 420038 */ /*GILLT_s64*//*Label 8183*/ GIMT_Encode4(420122), GIMT_Encode4(0),
     /* 420046 */ /*GILLT_v2s32*//*Label 8184*/ GIMT_Encode4(420160),
     /* 420050 */ /*GILLT_v2s64*//*Label 8185*/ GIMT_Encode4(420198),
     /* 420054 */ /*GILLT_v4s16*//*Label 8186*/ GIMT_Encode4(420236),
     /* 420058 */ /*GILLT_v4s32*//*Label 8187*/ GIMT_Encode4(420274),
     /* 420062 */ /*GILLT_v8s8*//*Label 8188*/ GIMT_Encode4(420312),
     /* 420066 */ /*GILLT_v8s16*//*Label 8189*/ GIMT_Encode4(420350),
     /* 420070 */ /*GILLT_v16s8*//*Label 8190*/ GIMT_Encode4(420388), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 420090 */ /*GILLT_nxv2s64*//*Label 8191*/ GIMT_Encode4(420426), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 420102 */ /*GILLT_nxv4s32*//*Label 8192*/ GIMT_Encode4(420573), GIMT_Encode4(0),
     /* 420110 */ /*GILLT_nxv8s16*//*Label 8193*/ GIMT_Encode4(420720), GIMT_Encode4(0),
     /* 420118 */ /*GILLT_nxv16s8*//*Label 8194*/ GIMT_Encode4(420867),
     /* 420122 */ // Label 8183: @420122
     /* 420122 */ GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(420159), // Rule ID 5105 //
     /* 420127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 420130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 420133 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 420136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420144 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420148 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420152 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 420152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 420157 */   GIR_RootConstrainSelectedInstOperands,
     /* 420158 */   // GIR_Coverage, 5105,
     /* 420158 */   GIR_Done,
     /* 420159 */ // Label 8196: @420159
     /* 420159 */ GIM_Reject,
     /* 420160 */ // Label 8184: @420160
     /* 420160 */ GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(420197), // Rule ID 5104 //
     /* 420165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 420171 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 420174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420182 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420186 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420190 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 420190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 420195 */   GIR_RootConstrainSelectedInstOperands,
     /* 420196 */   // GIR_Coverage, 5104,
     /* 420196 */   GIR_Done,
     /* 420197 */ // Label 8197: @420197
     /* 420197 */ GIM_Reject,
     /* 420198 */ // Label 8185: @420198
     /* 420198 */ GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(420235), // Rule ID 5109 //
     /* 420203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 420206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 420209 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 420212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420224 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420228 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 420228 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 420233 */   GIR_RootConstrainSelectedInstOperands,
     /* 420234 */   // GIR_Coverage, 5109,
     /* 420234 */   GIR_Done,
     /* 420235 */ // Label 8198: @420235
     /* 420235 */ GIM_Reject,
     /* 420236 */ // Label 8186: @420236
     /* 420236 */ GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(420273), // Rule ID 5103 //
     /* 420241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 420247 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 420250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420258 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420262 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420266 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 420266 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 420271 */   GIR_RootConstrainSelectedInstOperands,
     /* 420272 */   // GIR_Coverage, 5103,
     /* 420272 */   GIR_Done,
     /* 420273 */ // Label 8199: @420273
     /* 420273 */ GIM_Reject,
     /* 420274 */ // Label 8187: @420274
     /* 420274 */ GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(420311), // Rule ID 5108 //
     /* 420279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 420285 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 420288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420300 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420304 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 420304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 420309 */   GIR_RootConstrainSelectedInstOperands,
     /* 420310 */   // GIR_Coverage, 5108,
     /* 420310 */   GIR_Done,
     /* 420311 */ // Label 8200: @420311
     /* 420311 */ GIM_Reject,
     /* 420312 */ // Label 8188: @420312
     /* 420312 */ GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(420349), // Rule ID 5102 //
     /* 420317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 420320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 420323 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 420326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420338 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420342 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 420342 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 420347 */   GIR_RootConstrainSelectedInstOperands,
     /* 420348 */   // GIR_Coverage, 5102,
     /* 420348 */   GIR_Done,
     /* 420349 */ // Label 8201: @420349
     /* 420349 */ GIM_Reject,
     /* 420350 */ // Label 8189: @420350
     /* 420350 */ GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(420387), // Rule ID 5107 //
     /* 420355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 420361 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 420364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420376 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420380 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 420380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 420385 */   GIR_RootConstrainSelectedInstOperands,
     /* 420386 */   // GIR_Coverage, 5107,
     /* 420386 */   GIR_Done,
     /* 420387 */ // Label 8202: @420387
     /* 420387 */ GIM_Reject,
     /* 420388 */ // Label 8190: @420388
     /* 420388 */ GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(420425), // Rule ID 5106 //
     /* 420393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 420396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 420399 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 420402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420410 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420414 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420418 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 420418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 420423 */   GIR_RootConstrainSelectedInstOperands,
     /* 420424 */   // GIR_Coverage, 5106,
     /* 420424 */   GIR_Done,
     /* 420425 */ // Label 8203: @420425
     /* 420425 */ GIM_Reject,
     /* 420426 */ // Label 8191: @420426
     /* 420426 */ GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(420572),
     /* 420431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 420434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 420437 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 420440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 420444 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(420497), // Rule ID 11955 //
     /* 420449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 420456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 420464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 420468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420472 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420478 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420482 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 420482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 420485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 420491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420493 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420495 */     GIR_RootConstrainSelectedInstOperands,
     /* 420496 */     // GIR_Coverage, 11955,
     /* 420496 */     GIR_EraseRootFromParent_Done,
     /* 420497 */   // Label 8205: @420497
     /* 420497 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(420550), // Rule ID 11966 //
     /* 420502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 420509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 420517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 420521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420525 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420531 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420535 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 420535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 420538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 420546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420548 */     GIR_RootConstrainSelectedInstOperands,
     /* 420549 */     // GIR_Coverage, 11966,
     /* 420549 */     GIR_EraseRootFromParent_Done,
     /* 420550 */   // Label 8206: @420550
     /* 420550 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(420571), // Rule ID 11947 //
     /* 420555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420558 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 420558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 420561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420569 */     GIR_RootConstrainSelectedInstOperands,
     /* 420570 */     // GIR_Coverage, 11947,
     /* 420570 */     GIR_EraseRootFromParent_Done,
     /* 420571 */   // Label 8207: @420571
     /* 420571 */   GIM_Reject,
     /* 420572 */ // Label 8204: @420572
     /* 420572 */ GIM_Reject,
     /* 420573 */ // Label 8192: @420573
     /* 420573 */ GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(420719),
     /* 420578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 420581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 420584 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 420587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 420591 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(420644), // Rule ID 11953 //
     /* 420596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 420603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 420611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 420615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420619 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420625 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420629 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 420629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 420632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 420638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420642 */     GIR_RootConstrainSelectedInstOperands,
     /* 420643 */     // GIR_Coverage, 11953,
     /* 420643 */     GIR_EraseRootFromParent_Done,
     /* 420644 */   // Label 8209: @420644
     /* 420644 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(420697), // Rule ID 11963 //
     /* 420649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 420656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 420664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 420668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420672 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420678 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420682 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 420682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 420685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 420693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420695 */     GIR_RootConstrainSelectedInstOperands,
     /* 420696 */     // GIR_Coverage, 11963,
     /* 420696 */     GIR_EraseRootFromParent_Done,
     /* 420697 */   // Label 8210: @420697
     /* 420697 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(420718), // Rule ID 11945 //
     /* 420702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420705 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 420705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 420708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420716 */     GIR_RootConstrainSelectedInstOperands,
     /* 420717 */     // GIR_Coverage, 11945,
     /* 420717 */     GIR_EraseRootFromParent_Done,
     /* 420718 */   // Label 8211: @420718
     /* 420718 */   GIM_Reject,
     /* 420719 */ // Label 8208: @420719
     /* 420719 */ GIM_Reject,
     /* 420720 */ // Label 8193: @420720
     /* 420720 */ GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(420866),
     /* 420725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 420728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 420731 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 420734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 420738 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(420791), // Rule ID 11951 //
     /* 420743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 420750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 420758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 420762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420766 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420772 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420776 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 420776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 420779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 420785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420789 */     GIR_RootConstrainSelectedInstOperands,
     /* 420790 */     // GIR_Coverage, 11951,
     /* 420790 */     GIR_EraseRootFromParent_Done,
     /* 420791 */   // Label 8213: @420791
     /* 420791 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(420844), // Rule ID 11960 //
     /* 420796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 420803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 420811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 420815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420819 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420825 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420829 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 420829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 420832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 420840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420842 */     GIR_RootConstrainSelectedInstOperands,
     /* 420843 */     // GIR_Coverage, 11960,
     /* 420843 */     GIR_EraseRootFromParent_Done,
     /* 420844 */   // Label 8214: @420844
     /* 420844 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(420865), // Rule ID 11943 //
     /* 420849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420852 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 420852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 420855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420863 */     GIR_RootConstrainSelectedInstOperands,
     /* 420864 */     // GIR_Coverage, 11943,
     /* 420864 */     GIR_EraseRootFromParent_Done,
     /* 420865 */   // Label 8215: @420865
     /* 420865 */   GIM_Reject,
     /* 420866 */ // Label 8212: @420866
     /* 420866 */ GIM_Reject,
     /* 420867 */ // Label 8194: @420867
     /* 420867 */ GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(421013),
     /* 420872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 420875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 420878 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 420881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 420885 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(420938), // Rule ID 11949 //
     /* 420890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 420897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 420905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 420909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420913 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420919 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420923 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 420923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 420926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 420932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 420934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420936 */     GIR_RootConstrainSelectedInstOperands,
     /* 420937 */     // GIR_Coverage, 11949,
     /* 420937 */     GIR_EraseRootFromParent_Done,
     /* 420938 */   // Label 8217: @420938
     /* 420938 */   GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(420991), // Rule ID 11957 //
     /* 420943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 420950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 420954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 420958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 420962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 420966 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 420972 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 420974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 420976 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 420976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 420979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 420981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 420983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 420987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 420989 */     GIR_RootConstrainSelectedInstOperands,
     /* 420990 */     // GIR_Coverage, 11957,
     /* 420990 */     GIR_EraseRootFromParent_Done,
     /* 420991 */   // Label 8218: @420991
     /* 420991 */   GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(421012), // Rule ID 11941 //
     /* 420996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 420999 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 420999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 421002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421010 */     GIR_RootConstrainSelectedInstOperands,
     /* 421011 */     // GIR_Coverage, 11941,
     /* 421011 */     GIR_EraseRootFromParent_Done,
     /* 421012 */   // Label 8219: @421012
     /* 421012 */   GIM_Reject,
     /* 421013 */ // Label 8216: @421013
     /* 421013 */ GIM_Reject,
     /* 421014 */ // Label 8195: @421014
     /* 421014 */ GIM_Reject,
     /* 421015 */ // Label 124: @421015
     /* 421015 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8228*/ GIMT_Encode4(422837),
     /* 421026 */ /*GILLT_s64*//*Label 8220*/ GIMT_Encode4(421062), GIMT_Encode4(0),
     /* 421034 */ /*GILLT_v2s32*//*Label 8221*/ GIMT_Encode4(421257),
     /* 421038 */ /*GILLT_v2s64*//*Label 8222*/ GIMT_Encode4(421504),
     /* 421042 */ /*GILLT_v4s16*//*Label 8223*/ GIMT_Encode4(421751),
     /* 421046 */ /*GILLT_v4s32*//*Label 8224*/ GIMT_Encode4(422027),
     /* 421050 */ /*GILLT_v8s8*//*Label 8225*/ GIMT_Encode4(422274),
     /* 421054 */ /*GILLT_v8s16*//*Label 8226*/ GIMT_Encode4(422419),
     /* 421058 */ /*GILLT_v16s8*//*Label 8227*/ GIMT_Encode4(422695),
     /* 421062 */ // Label 8220: @421062
     /* 421062 */ GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(421256),
     /* 421067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 421070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421074 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(421121), // Rule ID 6469 //
     /* 421079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421087 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421094 */     // MIs[1] Rn
     /* 421094 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421105 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 421108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421119 */     GIR_RootConstrainSelectedInstOperands,
     /* 421120 */     // GIR_Coverage, 6469,
     /* 421120 */     GIR_EraseRootFromParent_Done,
     /* 421121 */   // Label 8230: @421121
     /* 421121 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(421168), // Rule ID 6480 //
     /* 421126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421134 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421141 */     // MIs[1] Rn
     /* 421141 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421152 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 421155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421166 */     GIR_RootConstrainSelectedInstOperands,
     /* 421167 */     // GIR_Coverage, 6480,
     /* 421167 */     GIR_EraseRootFromParent_Done,
     /* 421168 */   // Label 8231: @421168
     /* 421168 */   GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(421215), // Rule ID 13284 //
     /* 421173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421181 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421184 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421188 */     // MIs[1] Rn
     /* 421188 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421199 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 421202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421213 */     GIR_RootConstrainSelectedInstOperands,
     /* 421214 */     // GIR_Coverage, 13284,
     /* 421214 */     GIR_EraseRootFromParent_Done,
     /* 421215 */   // Label 8232: @421215
     /* 421215 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(421235), // Rule ID 5668 //
     /* 421220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 421224 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 421224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 421229 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421234 */     // GIR_Coverage, 5668,
     /* 421234 */     GIR_Done,
     /* 421235 */   // Label 8233: @421235
     /* 421235 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(421255), // Rule ID 5669 //
     /* 421240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421244 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 421244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 421249 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421254 */     // GIR_Coverage, 5669,
     /* 421254 */     GIR_Done,
     /* 421255 */   // Label 8234: @421255
     /* 421255 */   GIM_Reject,
     /* 421256 */ // Label 8229: @421256
     /* 421256 */ GIM_Reject,
     /* 421257 */ // Label 8221: @421257
     /* 421257 */ GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(421503),
     /* 421262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421269 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(421316), // Rule ID 6466 //
     /* 421274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421282 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421285 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421289 */     // MIs[1] Rn
     /* 421289 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421300 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 421303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421314 */     GIR_RootConstrainSelectedInstOperands,
     /* 421315 */     // GIR_Coverage, 6466,
     /* 421315 */     GIR_EraseRootFromParent_Done,
     /* 421316 */   // Label 8236: @421316
     /* 421316 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(421363), // Rule ID 6477 //
     /* 421321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421329 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421332 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421336 */     // MIs[1] Rn
     /* 421336 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421347 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 421350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421361 */     GIR_RootConstrainSelectedInstOperands,
     /* 421362 */     // GIR_Coverage, 6477,
     /* 421362 */     GIR_EraseRootFromParent_Done,
     /* 421363 */   // Label 8237: @421363
     /* 421363 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(421410), // Rule ID 13281 //
     /* 421368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421376 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421379 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421383 */     // MIs[1] Rn
     /* 421383 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421394 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 421397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421408 */     GIR_RootConstrainSelectedInstOperands,
     /* 421409 */     // GIR_Coverage, 13281,
     /* 421409 */     GIR_EraseRootFromParent_Done,
     /* 421410 */   // Label 8238: @421410
     /* 421410 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(421429), // Rule ID 1916 //
     /* 421415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 421422 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 421422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 421427 */     GIR_RootConstrainSelectedInstOperands,
     /* 421428 */     // GIR_Coverage, 1916,
     /* 421428 */     GIR_Done,
     /* 421429 */   // Label 8239: @421429
     /* 421429 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(421502), // Rule ID 5670 //
     /* 421434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421438 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 421438 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 421441 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 421445 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 421452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 421455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 421459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421464 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 421467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421471 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 421474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 421489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 421492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 421497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421500 */     GIR_RootConstrainSelectedInstOperands,
     /* 421501 */     // GIR_Coverage, 5670,
     /* 421501 */     GIR_EraseRootFromParent_Done,
     /* 421502 */   // Label 8240: @421502
     /* 421502 */   GIM_Reject,
     /* 421503 */ // Label 8235: @421503
     /* 421503 */ GIM_Reject,
     /* 421504 */ // Label 8222: @421504
     /* 421504 */ GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(421750),
     /* 421509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 421512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421516 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(421563), // Rule ID 6468 //
     /* 421521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421529 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421532 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421536 */     // MIs[1] Rn
     /* 421536 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421547 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 421550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421561 */     GIR_RootConstrainSelectedInstOperands,
     /* 421562 */     // GIR_Coverage, 6468,
     /* 421562 */     GIR_EraseRootFromParent_Done,
     /* 421563 */   // Label 8242: @421563
     /* 421563 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(421610), // Rule ID 6479 //
     /* 421568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421576 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421583 */     // MIs[1] Rn
     /* 421583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421594 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 421597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421608 */     GIR_RootConstrainSelectedInstOperands,
     /* 421609 */     // GIR_Coverage, 6479,
     /* 421609 */     GIR_EraseRootFromParent_Done,
     /* 421610 */   // Label 8243: @421610
     /* 421610 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(421657), // Rule ID 13283 //
     /* 421615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421623 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421626 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421630 */     // MIs[1] Rn
     /* 421630 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421641 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 421644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421655 */     GIR_RootConstrainSelectedInstOperands,
     /* 421656 */     // GIR_Coverage, 13283,
     /* 421656 */     GIR_EraseRootFromParent_Done,
     /* 421657 */   // Label 8244: @421657
     /* 421657 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(421676), // Rule ID 1918 //
     /* 421662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 421669 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 421669 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 421674 */     GIR_RootConstrainSelectedInstOperands,
     /* 421675 */     // GIR_Coverage, 1918,
     /* 421675 */     GIR_Done,
     /* 421676 */   // Label 8245: @421676
     /* 421676 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(421749), // Rule ID 5672 //
     /* 421681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421685 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 421685 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 421688 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 421692 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 421699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 421702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 421706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421711 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 421714 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421718 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 421721 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 421739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 421741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 421744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 421747 */     GIR_RootConstrainSelectedInstOperands,
     /* 421748 */     // GIR_Coverage, 5672,
     /* 421748 */     GIR_EraseRootFromParent_Done,
     /* 421749 */   // Label 8246: @421749
     /* 421749 */   GIM_Reject,
     /* 421750 */ // Label 8241: @421750
     /* 421750 */ GIM_Reject,
     /* 421751 */ // Label 8223: @421751
     /* 421751 */ GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(421812), // Rule ID 6464 //
     /* 421756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421763 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421767 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421771 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421774 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421778 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 421785 */   // MIs[1] Rn
     /* 421785 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421789 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421794 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421796 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 421799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421801 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421805 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421810 */   GIR_RootConstrainSelectedInstOperands,
     /* 421811 */   // GIR_Coverage, 6464,
     /* 421811 */   GIR_EraseRootFromParent_Done,
     /* 421812 */ // Label 8247: @421812
     /* 421812 */ GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(421866), // Rule ID 6481 //
     /* 421817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 421820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421824 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421828 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421832 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421835 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421839 */   // MIs[1] Rn
     /* 421839 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421843 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421848 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421850 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 421853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421855 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421864 */   GIR_RootConstrainSelectedInstOperands,
     /* 421865 */   // GIR_Coverage, 6481,
     /* 421865 */   GIR_EraseRootFromParent_Done,
     /* 421866 */ // Label 8248: @421866
     /* 421866 */ GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(421920), // Rule ID 13279 //
     /* 421871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 421874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421878 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421882 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421886 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421889 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421893 */   // MIs[1] Rn
     /* 421893 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421897 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421902 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421904 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 421907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421909 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421913 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421918 */   GIR_RootConstrainSelectedInstOperands,
     /* 421919 */   // GIR_Coverage, 13279,
     /* 421919 */   GIR_EraseRootFromParent_Done,
     /* 421920 */ // Label 8249: @421920
     /* 421920 */ GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(421946), // Rule ID 1914 //
     /* 421925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 421928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 421939 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 421939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 421944 */   GIR_RootConstrainSelectedInstOperands,
     /* 421945 */   // GIR_Coverage, 1914,
     /* 421945 */   GIR_Done,
     /* 421946 */ // Label 8250: @421946
     /* 421946 */ GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(422026), // Rule ID 5673 //
     /* 421951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 421954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 421962 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 421962 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 421965 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 421969 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 421976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 421979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 421983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 421988 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 421991 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 421995 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 421998 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422003 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422008 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 422013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 422016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422018 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 422021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422024 */   GIR_RootConstrainSelectedInstOperands,
     /* 422025 */   // GIR_Coverage, 5673,
     /* 422025 */   GIR_EraseRootFromParent_Done,
     /* 422026 */ // Label 8251: @422026
     /* 422026 */ GIM_Reject,
     /* 422027 */ // Label 8224: @422027
     /* 422027 */ GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(422273),
     /* 422032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422039 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(422086), // Rule ID 6467 //
     /* 422044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422052 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422055 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422059 */     // MIs[1] Rn
     /* 422059 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422070 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 422073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422084 */     GIR_RootConstrainSelectedInstOperands,
     /* 422085 */     // GIR_Coverage, 6467,
     /* 422085 */     GIR_EraseRootFromParent_Done,
     /* 422086 */   // Label 8253: @422086
     /* 422086 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(422133), // Rule ID 6478 //
     /* 422091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422099 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422102 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422106 */     // MIs[1] Rn
     /* 422106 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422117 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 422120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422131 */     GIR_RootConstrainSelectedInstOperands,
     /* 422132 */     // GIR_Coverage, 6478,
     /* 422132 */     GIR_EraseRootFromParent_Done,
     /* 422133 */   // Label 8254: @422133
     /* 422133 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(422180), // Rule ID 13282 //
     /* 422138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422146 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422149 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422153 */     // MIs[1] Rn
     /* 422153 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422164 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 422167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422178 */     GIR_RootConstrainSelectedInstOperands,
     /* 422179 */     // GIR_Coverage, 13282,
     /* 422179 */     GIR_EraseRootFromParent_Done,
     /* 422180 */   // Label 8255: @422180
     /* 422180 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(422199), // Rule ID 1917 //
     /* 422185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 422192 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 422192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 422197 */     GIR_RootConstrainSelectedInstOperands,
     /* 422198 */     // GIR_Coverage, 1917,
     /* 422198 */     GIR_Done,
     /* 422199 */   // Label 8256: @422199
     /* 422199 */   GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(422272), // Rule ID 5671 //
     /* 422204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 422208 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 422208 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 422211 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 422215 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 422222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 422225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 422229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422234 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 422237 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 422241 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 422244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 422259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 422262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 422267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422270 */     GIR_RootConstrainSelectedInstOperands,
     /* 422271 */     // GIR_Coverage, 5671,
     /* 422271 */     GIR_EraseRootFromParent_Done,
     /* 422272 */   // Label 8257: @422272
     /* 422272 */   GIM_Reject,
     /* 422273 */ // Label 8252: @422273
     /* 422273 */ GIM_Reject,
     /* 422274 */ // Label 8225: @422274
     /* 422274 */ GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(422331), // Rule ID 13277 //
     /* 422279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 422282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422286 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422290 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422294 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422297 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422301 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 422305 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422307 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 422314 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 422317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422319 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 422324 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422329 */   GIR_RootConstrainSelectedInstOperands,
     /* 422330 */   // GIR_Coverage, 13277,
     /* 422330 */   GIR_EraseRootFromParent_Done,
     /* 422331 */ // Label 8258: @422331
     /* 422331 */ GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(422392), // Rule ID 6462 //
     /* 422336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422343 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422347 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422351 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422354 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422358 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 422365 */   // MIs[1] Rn
     /* 422365 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422369 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422374 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422376 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 422379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422381 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422385 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422390 */   GIR_RootConstrainSelectedInstOperands,
     /* 422391 */   // GIR_Coverage, 6462,
     /* 422391 */   GIR_EraseRootFromParent_Done,
     /* 422392 */ // Label 8259: @422392
     /* 422392 */ GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(422418), // Rule ID 1912 //
     /* 422397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 422411 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 422411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 422416 */   GIR_RootConstrainSelectedInstOperands,
     /* 422417 */   // GIR_Coverage, 1912,
     /* 422417 */   GIR_Done,
     /* 422418 */ // Label 8260: @422418
     /* 422418 */ GIM_Reject,
     /* 422419 */ // Label 8226: @422419
     /* 422419 */ GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(422480), // Rule ID 6465 //
     /* 422424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422431 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422435 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422439 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422442 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422446 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 422453 */   // MIs[1] Rn
     /* 422453 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422457 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422462 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422464 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 422467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422469 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422473 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422478 */   GIR_RootConstrainSelectedInstOperands,
     /* 422479 */   // GIR_Coverage, 6465,
     /* 422479 */   GIR_EraseRootFromParent_Done,
     /* 422480 */ // Label 8261: @422480
     /* 422480 */ GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(422534), // Rule ID 6482 //
     /* 422485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 422488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422492 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422496 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422500 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422503 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422507 */   // MIs[1] Rn
     /* 422507 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422511 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422516 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422518 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 422521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422523 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422527 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422532 */   GIR_RootConstrainSelectedInstOperands,
     /* 422533 */   // GIR_Coverage, 6482,
     /* 422533 */   GIR_EraseRootFromParent_Done,
     /* 422534 */ // Label 8262: @422534
     /* 422534 */ GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(422588), // Rule ID 13280 //
     /* 422539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 422542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422546 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422550 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422554 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422557 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422561 */   // MIs[1] Rn
     /* 422561 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422565 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422570 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422572 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 422575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422577 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422581 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422586 */   GIR_RootConstrainSelectedInstOperands,
     /* 422587 */   // GIR_Coverage, 13280,
     /* 422587 */   GIR_EraseRootFromParent_Done,
     /* 422588 */ // Label 8263: @422588
     /* 422588 */ GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(422614), // Rule ID 1915 //
     /* 422593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 422607 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 422607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 422612 */   GIR_RootConstrainSelectedInstOperands,
     /* 422613 */   // GIR_Coverage, 1915,
     /* 422613 */   GIR_Done,
     /* 422614 */ // Label 8264: @422614
     /* 422614 */ GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(422694), // Rule ID 5674 //
     /* 422619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 422622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 422630 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 422630 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 422633 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 422637 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 422644 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 422647 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 422651 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422656 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 422659 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 422663 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 422666 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422671 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422676 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 422681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 422684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422686 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 422689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422692 */   GIR_RootConstrainSelectedInstOperands,
     /* 422693 */   // GIR_Coverage, 5674,
     /* 422693 */   GIR_EraseRootFromParent_Done,
     /* 422694 */ // Label 8265: @422694
     /* 422694 */ GIM_Reject,
     /* 422695 */ // Label 8227: @422695
     /* 422695 */ GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(422756), // Rule ID 6463 //
     /* 422700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422707 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422711 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422715 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422718 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422722 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 422729 */   // MIs[1] Rn
     /* 422729 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422733 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422738 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422740 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 422743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422745 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422749 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422754 */   GIR_RootConstrainSelectedInstOperands,
     /* 422755 */   // GIR_Coverage, 6463,
     /* 422755 */   GIR_EraseRootFromParent_Done,
     /* 422756 */ // Label 8266: @422756
     /* 422756 */ GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(422810), // Rule ID 13278 //
     /* 422761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 422764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422768 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422772 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422776 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422779 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422783 */   // MIs[1] Rn
     /* 422783 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422787 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422792 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422794 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 422797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422799 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422803 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422808 */   GIR_RootConstrainSelectedInstOperands,
     /* 422809 */   // GIR_Coverage, 13278,
     /* 422809 */   GIR_EraseRootFromParent_Done,
     /* 422810 */ // Label 8267: @422810
     /* 422810 */ GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(422836), // Rule ID 1913 //
     /* 422815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 422829 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 422829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 422834 */   GIR_RootConstrainSelectedInstOperands,
     /* 422835 */   // GIR_Coverage, 1913,
     /* 422835 */   GIR_Done,
     /* 422836 */ // Label 8268: @422836
     /* 422836 */ GIM_Reject,
     /* 422837 */ // Label 8228: @422837
     /* 422837 */ GIM_Reject,
     /* 422838 */ // Label 125: @422838
     /* 422838 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 8271*/ GIMT_Encode4(423092),
     /* 422849 */ /*GILLT_v4s16*//*Label 8269*/ GIMT_Encode4(422865), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 422861 */ /*GILLT_v8s16*//*Label 8270*/ GIMT_Encode4(422951),
     /* 422865 */ // Label 8269: @422865
     /* 422865 */ GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(422950),
     /* 422870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 422873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422884 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(422918), // Rule ID 1922 //
     /* 422889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 422904 */     // MIs[1] Operand 1
     /* 422904 */     // No operand predicates
     /* 422904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422906 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 422906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 422909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 422916 */     GIR_RootConstrainSelectedInstOperands,
     /* 422917 */     // GIR_Coverage, 1922,
     /* 422917 */     GIR_EraseRootFromParent_Done,
     /* 422918 */   // Label 8273: @422918
     /* 422918 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(422949), // Rule ID 5675 //
     /* 422923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 422927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 422931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 422935 */     // MIs[1] Operand 1
     /* 422935 */     // No operand predicates
     /* 422935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422937 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 422937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 422940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 422944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 422947 */     GIR_RootConstrainSelectedInstOperands,
     /* 422948 */     // GIR_Coverage, 5675,
     /* 422948 */     GIR_EraseRootFromParent_Done,
     /* 422949 */   // Label 8274: @422949
     /* 422949 */   GIM_Reject,
     /* 422950 */ // Label 8272: @422950
     /* 422950 */ GIM_Reject,
     /* 422951 */ // Label 8270: @422951
     /* 422951 */ GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(423091),
     /* 422956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 422959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 422962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422966 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(423017), // Rule ID 6473 //
     /* 422971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422979 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422986 */     // MIs[1] Rn
     /* 422986 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422995 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 422999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423001 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 423004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423015 */     GIR_RootConstrainSelectedInstOperands,
     /* 423016 */     // GIR_Coverage, 6473,
     /* 423016 */     GIR_EraseRootFromParent_Done,
     /* 423017 */   // Label 8276: @423017
     /* 423017 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(423055), // Rule ID 1923 //
     /* 423022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 423041 */     // MIs[1] Operand 1
     /* 423041 */     // No operand predicates
     /* 423041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423043 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 423043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 423046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 423053 */     GIR_RootConstrainSelectedInstOperands,
     /* 423054 */     // GIR_Coverage, 1923,
     /* 423054 */     GIR_EraseRootFromParent_Done,
     /* 423055 */   // Label 8277: @423055
     /* 423055 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(423090), // Rule ID 5676 //
     /* 423060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 423076 */     // MIs[1] Operand 1
     /* 423076 */     // No operand predicates
     /* 423076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423078 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 423078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 423081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423088 */     GIR_RootConstrainSelectedInstOperands,
     /* 423089 */     // GIR_Coverage, 5676,
     /* 423089 */     GIR_EraseRootFromParent_Done,
     /* 423090 */   // Label 8278: @423090
     /* 423090 */   GIM_Reject,
     /* 423091 */ // Label 8275: @423091
     /* 423091 */ GIM_Reject,
     /* 423092 */ // Label 8271: @423092
     /* 423092 */ GIM_Reject,
     /* 423093 */ // Label 126: @423093
     /* 423093 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 8281*/ GIMT_Encode4(423347),
     /* 423104 */ /*GILLT_v2s32*//*Label 8279*/ GIMT_Encode4(423120), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 423116 */ /*GILLT_v4s32*//*Label 8280*/ GIMT_Encode4(423206),
     /* 423120 */ // Label 8279: @423120
     /* 423120 */ GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(423205),
     /* 423125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 423128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423139 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(423173), // Rule ID 1920 //
     /* 423144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 423159 */     // MIs[1] Operand 1
     /* 423159 */     // No operand predicates
     /* 423159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423161 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 423161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 423164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 423171 */     GIR_RootConstrainSelectedInstOperands,
     /* 423172 */     // GIR_Coverage, 1920,
     /* 423172 */     GIR_EraseRootFromParent_Done,
     /* 423173 */   // Label 8283: @423173
     /* 423173 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(423204), // Rule ID 5677 //
     /* 423178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 423190 */     // MIs[1] Operand 1
     /* 423190 */     // No operand predicates
     /* 423190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423192 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 423192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 423195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423202 */     GIR_RootConstrainSelectedInstOperands,
     /* 423203 */     // GIR_Coverage, 5677,
     /* 423203 */     GIR_EraseRootFromParent_Done,
     /* 423204 */   // Label 8284: @423204
     /* 423204 */   GIM_Reject,
     /* 423205 */ // Label 8282: @423205
     /* 423205 */ GIM_Reject,
     /* 423206 */ // Label 8280: @423206
     /* 423206 */ GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(423346),
     /* 423211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 423214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423221 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(423272), // Rule ID 6475 //
     /* 423226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423234 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423237 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423241 */     // MIs[1] Rn
     /* 423241 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 423254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423256 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 423259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423270 */     GIR_RootConstrainSelectedInstOperands,
     /* 423271 */     // GIR_Coverage, 6475,
     /* 423271 */     GIR_EraseRootFromParent_Done,
     /* 423272 */   // Label 8286: @423272
     /* 423272 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(423310), // Rule ID 1921 //
     /* 423277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 423296 */     // MIs[1] Operand 1
     /* 423296 */     // No operand predicates
     /* 423296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423298 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 423298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 423301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 423308 */     GIR_RootConstrainSelectedInstOperands,
     /* 423309 */     // GIR_Coverage, 1921,
     /* 423309 */     GIR_EraseRootFromParent_Done,
     /* 423310 */   // Label 8287: @423310
     /* 423310 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(423345), // Rule ID 5678 //
     /* 423315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 423331 */     // MIs[1] Operand 1
     /* 423331 */     // No operand predicates
     /* 423331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423333 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 423333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 423336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423343 */     GIR_RootConstrainSelectedInstOperands,
     /* 423344 */     // GIR_Coverage, 5678,
     /* 423344 */     GIR_EraseRootFromParent_Done,
     /* 423345 */   // Label 8288: @423345
     /* 423345 */   GIM_Reject,
     /* 423346 */ // Label 8285: @423346
     /* 423346 */ GIM_Reject,
     /* 423347 */ // Label 8281: @423347
     /* 423347 */ GIM_Reject,
     /* 423348 */ // Label 127: @423348
     /* 423348 */ GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(423493),
     /* 423353 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 423356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 423359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423366 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(423417), // Rule ID 6476 //
     /* 423371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423379 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423382 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423386 */     // MIs[1] Rn
     /* 423386 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 423399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423401 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 423404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423415 */     GIR_RootConstrainSelectedInstOperands,
     /* 423416 */     // GIR_Coverage, 6476,
     /* 423416 */     GIR_EraseRootFromParent_Done,
     /* 423417 */   // Label 8290: @423417
     /* 423417 */   GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(423492),
     /* 423422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423426 */     GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(423460), // Rule ID 1919 //
     /* 423431 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423434 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423438 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423442 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 423446 */       // MIs[1] Operand 1
     /* 423446 */       // No operand predicates
     /* 423446 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423448 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 423448 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 423451 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423453 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423455 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 423458 */       GIR_RootConstrainSelectedInstOperands,
     /* 423459 */       // GIR_Coverage, 1919,
     /* 423459 */       GIR_EraseRootFromParent_Done,
     /* 423460 */     // Label 8292: @423460
     /* 423460 */     GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(423491), // Rule ID 5679 //
     /* 423465 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423469 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423473 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 423477 */       // MIs[1] Operand 1
     /* 423477 */       // No operand predicates
     /* 423477 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423479 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 423479 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 423482 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423484 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423486 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423489 */       GIR_RootConstrainSelectedInstOperands,
     /* 423490 */       // GIR_Coverage, 5679,
     /* 423490 */       GIR_EraseRootFromParent_Done,
     /* 423491 */     // Label 8293: @423491
     /* 423491 */     GIM_Reject,
     /* 423492 */   // Label 8291: @423492
     /* 423492 */   GIM_Reject,
     /* 423493 */ // Label 8289: @423493
     /* 423493 */ GIM_Reject,
     /* 423494 */ // Label 128: @423494
     /* 423494 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8296*/ GIMT_Encode4(423672),
     /* 423505 */ /*GILLT_v8s8*//*Label 8294*/ GIMT_Encode4(423517), GIMT_Encode4(0),
     /* 423513 */ /*GILLT_v16s8*//*Label 8295*/ GIMT_Encode4(423566),
     /* 423517 */ // Label 8294: @423517
     /* 423517 */ GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(423565), // Rule ID 1924 //
     /* 423522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 423528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423539 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423543 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423547 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 423551 */   // MIs[1] Operand 1
     /* 423551 */   // No operand predicates
     /* 423551 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423553 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 423553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 423556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423558 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423560 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 423563 */   GIR_RootConstrainSelectedInstOperands,
     /* 423564 */   // GIR_Coverage, 1924,
     /* 423564 */   GIR_EraseRootFromParent_Done,
     /* 423565 */ // Label 8297: @423565
     /* 423565 */ GIM_Reject,
     /* 423566 */ // Label 8295: @423566
     /* 423566 */ GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(423671),
     /* 423571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 423574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423581 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(423632), // Rule ID 6471 //
     /* 423586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423594 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423597 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423601 */     // MIs[1] Rn
     /* 423601 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 423614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423616 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 423619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423630 */     GIR_RootConstrainSelectedInstOperands,
     /* 423631 */     // GIR_Coverage, 6471,
     /* 423631 */     GIR_EraseRootFromParent_Done,
     /* 423632 */   // Label 8299: @423632
     /* 423632 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(423670), // Rule ID 1925 //
     /* 423637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 423656 */     // MIs[1] Operand 1
     /* 423656 */     // No operand predicates
     /* 423656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423658 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 423658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 423661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 423668 */     GIR_RootConstrainSelectedInstOperands,
     /* 423669 */     // GIR_Coverage, 1925,
     /* 423669 */     GIR_EraseRootFromParent_Done,
     /* 423670 */   // Label 8300: @423670
     /* 423670 */   GIM_Reject,
     /* 423671 */ // Label 8298: @423671
     /* 423671 */ GIM_Reject,
     /* 423672 */ // Label 8296: @423672
     /* 423672 */ GIM_Reject,
     /* 423673 */ // Label 129: @423673
     /* 423673 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8310*/ GIMT_Encode4(425322),
     /* 423684 */ /*GILLT_s64*//*Label 8301*/ GIMT_Encode4(423768), GIMT_Encode4(0),
     /* 423692 */ /*GILLT_v2s32*//*Label 8302*/ GIMT_Encode4(424089),
     /* 423696 */ /*GILLT_v2s64*//*Label 8303*/ GIMT_Encode4(424410),
     /* 423700 */ /*GILLT_v4s16*//*Label 8304*/ GIMT_Encode4(424493),
     /* 423704 */ /*GILLT_v4s32*//*Label 8305*/ GIMT_Encode4(424814),
     /* 423708 */ /*GILLT_v8s8*//*Label 8306*/ GIMT_Encode4(424897),
     /* 423712 */ /*GILLT_v8s16*//*Label 8307*/ GIMT_Encode4(425106),
     /* 423716 */ /*GILLT_v16s8*//*Label 8308*/ GIMT_Encode4(425189), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 423764 */ /*GILLT_nxv16s8*//*Label 8309*/ GIMT_Encode4(425275),
     /* 423768 */ // Label 8301: @423768
     /* 423768 */ GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(424088),
     /* 423773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 423776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423783 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(423898), // Rule ID 5496 //
     /* 423788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 423800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423805 */     // MIs[1] Operand 2
     /* 423805 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 423816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423824 */     // MIs[2] Rn
     /* 423824 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423829 */     // MIs[2] Operand 2
     /* 423829 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 423840 */     // MIs[0] imm
     /* 423840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 423844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423848 */     // MIs[3] Operand 1
     /* 423848 */     // No operand predicates
     /* 423848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423850 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 423850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 423853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 423873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 423875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 423880 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 423887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423897 */     // GIR_Coverage, 5496,
     /* 423897 */     GIR_EraseRootFromParent_Done,
     /* 423898 */   // Label 8312: @423898
     /* 423898 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(424013), // Rule ID 5501 //
     /* 423903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 423915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423920 */     // MIs[1] Operand 2
     /* 423920 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 423931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 423935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 423939 */     // MIs[2] Rn
     /* 423939 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 423944 */     // MIs[2] Operand 2
     /* 423944 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 423955 */     // MIs[0] imm
     /* 423955 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 423959 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423963 */     // MIs[3] Operand 1
     /* 423963 */     // No operand predicates
     /* 423963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 423965 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 423965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 423968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 423972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423981 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 423988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 423990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 423993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 423995 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 424002 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424012 */     // GIR_Coverage, 5501,
     /* 424012 */     GIR_EraseRootFromParent_Done,
     /* 424013 */   // Label 8313: @424013
     /* 424013 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(424050), // Rule ID 5493 //
     /* 424018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424026 */     // MIs[0] imm
     /* 424026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424034 */     // MIs[1] Operand 1
     /* 424034 */     // No operand predicates
     /* 424034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424036 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424048 */     GIR_RootConstrainSelectedInstOperands,
     /* 424049 */     // GIR_Coverage, 5493,
     /* 424049 */     GIR_EraseRootFromParent_Done,
     /* 424050 */   // Label 8314: @424050
     /* 424050 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(424087), // Rule ID 5498 //
     /* 424055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424063 */     // MIs[0] imm
     /* 424063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424071 */     // MIs[1] Operand 1
     /* 424071 */     // No operand predicates
     /* 424071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424073 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424085 */     GIR_RootConstrainSelectedInstOperands,
     /* 424086 */     // GIR_Coverage, 5498,
     /* 424086 */     GIR_EraseRootFromParent_Done,
     /* 424087 */   // Label 8315: @424087
     /* 424087 */   GIM_Reject,
     /* 424088 */ // Label 8311: @424088
     /* 424088 */ GIM_Reject,
     /* 424089 */ // Label 8302: @424089
     /* 424089 */ GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(424409),
     /* 424094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 424097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 424100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424104 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(424219), // Rule ID 5486 //
     /* 424109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 424121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424126 */     // MIs[1] Operand 2
     /* 424126 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 424137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 424141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424145 */     // MIs[2] Rn
     /* 424145 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 424150 */     // MIs[2] Operand 2
     /* 424150 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 424161 */     // MIs[0] imm
     /* 424161 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 424165 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424169 */     // MIs[3] Operand 1
     /* 424169 */     // No operand predicates
     /* 424169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424171 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 424171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 424174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424183 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424187 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 424194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 424196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 424199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 424201 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 424208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424213 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424218 */     // GIR_Coverage, 5486,
     /* 424218 */     GIR_EraseRootFromParent_Done,
     /* 424219 */   // Label 8317: @424219
     /* 424219 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(424334), // Rule ID 5491 //
     /* 424224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 424236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424241 */     // MIs[1] Operand 2
     /* 424241 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 424252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 424256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424260 */     // MIs[2] Rn
     /* 424260 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 424265 */     // MIs[2] Operand 2
     /* 424265 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 424276 */     // MIs[0] imm
     /* 424276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 424280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424284 */     // MIs[3] Operand 1
     /* 424284 */     // No operand predicates
     /* 424284 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424286 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 424286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 424289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424302 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 424309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 424311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 424314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 424316 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 424323 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424333 */     // GIR_Coverage, 5491,
     /* 424333 */     GIR_EraseRootFromParent_Done,
     /* 424334 */   // Label 8318: @424334
     /* 424334 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(424371), // Rule ID 5483 //
     /* 424339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424347 */     // MIs[0] imm
     /* 424347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424355 */     // MIs[1] Operand 1
     /* 424355 */     // No operand predicates
     /* 424355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424357 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424362 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424369 */     GIR_RootConstrainSelectedInstOperands,
     /* 424370 */     // GIR_Coverage, 5483,
     /* 424370 */     GIR_EraseRootFromParent_Done,
     /* 424371 */   // Label 8319: @424371
     /* 424371 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(424408), // Rule ID 5488 //
     /* 424376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424384 */     // MIs[0] imm
     /* 424384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424392 */     // MIs[1] Operand 1
     /* 424392 */     // No operand predicates
     /* 424392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424394 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424406 */     GIR_RootConstrainSelectedInstOperands,
     /* 424407 */     // GIR_Coverage, 5488,
     /* 424407 */     GIR_EraseRootFromParent_Done,
     /* 424408 */   // Label 8320: @424408
     /* 424408 */   GIM_Reject,
     /* 424409 */ // Label 8316: @424409
     /* 424409 */ GIM_Reject,
     /* 424410 */ // Label 8303: @424410
     /* 424410 */ GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(424492),
     /* 424415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 424418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 424421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424433 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(424462), // Rule ID 5494 //
     /* 424438 */     // MIs[0] imm
     /* 424438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424446 */     // MIs[1] Operand 1
     /* 424446 */     // No operand predicates
     /* 424446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424448 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424460 */     GIR_RootConstrainSelectedInstOperands,
     /* 424461 */     // GIR_Coverage, 5494,
     /* 424461 */     GIR_EraseRootFromParent_Done,
     /* 424462 */   // Label 8322: @424462
     /* 424462 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(424491), // Rule ID 5499 //
     /* 424467 */     // MIs[0] imm
     /* 424467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424475 */     // MIs[1] Operand 1
     /* 424475 */     // No operand predicates
     /* 424475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424477 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424489 */     GIR_RootConstrainSelectedInstOperands,
     /* 424490 */     // GIR_Coverage, 5499,
     /* 424490 */     GIR_EraseRootFromParent_Done,
     /* 424491 */   // Label 8323: @424491
     /* 424491 */   GIM_Reject,
     /* 424492 */ // Label 8321: @424492
     /* 424492 */ GIM_Reject,
     /* 424493 */ // Label 8304: @424493
     /* 424493 */ GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(424813),
     /* 424498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 424501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 424504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424508 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(424623), // Rule ID 5476 //
     /* 424513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 424525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424530 */     // MIs[1] Operand 2
     /* 424530 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 424541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 424545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424549 */     // MIs[2] Rn
     /* 424549 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 424554 */     // MIs[2] Operand 2
     /* 424554 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 424565 */     // MIs[0] imm
     /* 424565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 424569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424573 */     // MIs[3] Operand 1
     /* 424573 */     // No operand predicates
     /* 424573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424575 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 424575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 424578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424587 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424591 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 424598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 424600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 424603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 424605 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 424612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424622 */     // GIR_Coverage, 5476,
     /* 424622 */     GIR_EraseRootFromParent_Done,
     /* 424623 */   // Label 8325: @424623
     /* 424623 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(424738), // Rule ID 5481 //
     /* 424628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 424640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424645 */     // MIs[1] Operand 2
     /* 424645 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 424656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 424660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424664 */     // MIs[2] Rn
     /* 424664 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 424669 */     // MIs[2] Operand 2
     /* 424669 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 424680 */     // MIs[0] imm
     /* 424680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 424684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424688 */     // MIs[3] Operand 1
     /* 424688 */     // No operand predicates
     /* 424688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424690 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 424690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 424693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424702 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424706 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 424713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 424715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 424718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 424720 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 424727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424737 */     // GIR_Coverage, 5481,
     /* 424737 */     GIR_EraseRootFromParent_Done,
     /* 424738 */   // Label 8326: @424738
     /* 424738 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(424775), // Rule ID 5473 //
     /* 424743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424751 */     // MIs[0] imm
     /* 424751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424759 */     // MIs[1] Operand 1
     /* 424759 */     // No operand predicates
     /* 424759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424761 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424773 */     GIR_RootConstrainSelectedInstOperands,
     /* 424774 */     // GIR_Coverage, 5473,
     /* 424774 */     GIR_EraseRootFromParent_Done,
     /* 424775 */   // Label 8327: @424775
     /* 424775 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(424812), // Rule ID 5478 //
     /* 424780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424788 */     // MIs[0] imm
     /* 424788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424796 */     // MIs[1] Operand 1
     /* 424796 */     // No operand predicates
     /* 424796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424798 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424810 */     GIR_RootConstrainSelectedInstOperands,
     /* 424811 */     // GIR_Coverage, 5478,
     /* 424811 */     GIR_EraseRootFromParent_Done,
     /* 424812 */   // Label 8328: @424812
     /* 424812 */   GIM_Reject,
     /* 424813 */ // Label 8324: @424813
     /* 424813 */ GIM_Reject,
     /* 424814 */ // Label 8305: @424814
     /* 424814 */ GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(424896),
     /* 424819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 424822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 424825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424837 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(424866), // Rule ID 5484 //
     /* 424842 */     // MIs[0] imm
     /* 424842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424850 */     // MIs[1] Operand 1
     /* 424850 */     // No operand predicates
     /* 424850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424852 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424864 */     GIR_RootConstrainSelectedInstOperands,
     /* 424865 */     // GIR_Coverage, 5484,
     /* 424865 */     GIR_EraseRootFromParent_Done,
     /* 424866 */   // Label 8330: @424866
     /* 424866 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(424895), // Rule ID 5489 //
     /* 424871 */     // MIs[0] imm
     /* 424871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424879 */     // MIs[1] Operand 1
     /* 424879 */     // No operand predicates
     /* 424879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424881 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424893 */     GIR_RootConstrainSelectedInstOperands,
     /* 424894 */     // GIR_Coverage, 5489,
     /* 424894 */     GIR_EraseRootFromParent_Done,
     /* 424895 */   // Label 8331: @424895
     /* 424895 */   GIM_Reject,
     /* 424896 */ // Label 8329: @424896
     /* 424896 */ GIM_Reject,
     /* 424897 */ // Label 8306: @424897
     /* 424897 */ GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(425105),
     /* 424902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 424905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 424908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424912 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(425027), // Rule ID 5471 //
     /* 424917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 424929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424934 */     // MIs[1] Operand 2
     /* 424934 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 424945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 424949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424953 */     // MIs[2] Rn
     /* 424953 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 424958 */     // MIs[2] Operand 2
     /* 424958 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 424969 */     // MIs[0] imm
     /* 424969 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 424973 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424977 */     // MIs[3] Operand 1
     /* 424977 */     // No operand predicates
     /* 424977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424979 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 424979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 424982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424991 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424995 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 425002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 425004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 425007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 425009 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 425016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425026 */     // GIR_Coverage, 5471,
     /* 425026 */     GIR_EraseRootFromParent_Done,
     /* 425027 */   // Label 8333: @425027
     /* 425027 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(425067), // Rule ID 1868 //
     /* 425032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425043 */     // MIs[0] imm
     /* 425043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425051 */     // MIs[1] Operand 1
     /* 425051 */     // No operand predicates
     /* 425051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425053 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 425056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425065 */     GIR_RootConstrainSelectedInstOperands,
     /* 425066 */     // GIR_Coverage, 1868,
     /* 425066 */     GIR_EraseRootFromParent_Done,
     /* 425067 */   // Label 8334: @425067
     /* 425067 */   GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(425104), // Rule ID 5468 //
     /* 425072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425080 */     // MIs[0] imm
     /* 425080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425088 */     // MIs[1] Operand 1
     /* 425088 */     // No operand predicates
     /* 425088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425090 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 425093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425102 */     GIR_RootConstrainSelectedInstOperands,
     /* 425103 */     // GIR_Coverage, 5468,
     /* 425103 */     GIR_EraseRootFromParent_Done,
     /* 425104 */   // Label 8335: @425104
     /* 425104 */   GIM_Reject,
     /* 425105 */ // Label 8332: @425105
     /* 425105 */ GIM_Reject,
     /* 425106 */ // Label 8307: @425106
     /* 425106 */ GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(425188),
     /* 425111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 425114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 425117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425129 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(425158), // Rule ID 5474 //
     /* 425134 */     // MIs[0] imm
     /* 425134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425142 */     // MIs[1] Operand 1
     /* 425142 */     // No operand predicates
     /* 425142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425144 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425156 */     GIR_RootConstrainSelectedInstOperands,
     /* 425157 */     // GIR_Coverage, 5474,
     /* 425157 */     GIR_EraseRootFromParent_Done,
     /* 425158 */   // Label 8337: @425158
     /* 425158 */   GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(425187), // Rule ID 5479 //
     /* 425163 */     // MIs[0] imm
     /* 425163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425171 */     // MIs[1] Operand 1
     /* 425171 */     // No operand predicates
     /* 425171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425173 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425185 */     GIR_RootConstrainSelectedInstOperands,
     /* 425186 */     // GIR_Coverage, 5479,
     /* 425186 */     GIR_EraseRootFromParent_Done,
     /* 425187 */   // Label 8338: @425187
     /* 425187 */   GIM_Reject,
     /* 425188 */ // Label 8336: @425188
     /* 425188 */ GIM_Reject,
     /* 425189 */ // Label 8308: @425189
     /* 425189 */ GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(425274),
     /* 425194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 425197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 425200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425212 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(425244), // Rule ID 1869 //
     /* 425217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425220 */     // MIs[0] imm
     /* 425220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425228 */     // MIs[1] Operand 1
     /* 425228 */     // No operand predicates
     /* 425228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425230 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425235 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425242 */     GIR_RootConstrainSelectedInstOperands,
     /* 425243 */     // GIR_Coverage, 1869,
     /* 425243 */     GIR_EraseRootFromParent_Done,
     /* 425244 */   // Label 8340: @425244
     /* 425244 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(425273), // Rule ID 5469 //
     /* 425249 */     // MIs[0] imm
     /* 425249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425257 */     // MIs[1] Operand 1
     /* 425257 */     // No operand predicates
     /* 425257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425259 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425271 */     GIR_RootConstrainSelectedInstOperands,
     /* 425272 */     // GIR_Coverage, 5469,
     /* 425272 */     GIR_EraseRootFromParent_Done,
     /* 425273 */   // Label 8341: @425273
     /* 425273 */   GIM_Reject,
     /* 425274 */ // Label 8339: @425274
     /* 425274 */ GIM_Reject,
     /* 425275 */ // Label 8309: @425275
     /* 425275 */ GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(425321), // Rule ID 2733 //
     /* 425280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 425283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 425286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 425289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 425293 */   // MIs[0] Op3
     /* 425293 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425297 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425301 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 425305 */   // MIs[1] Operand 1
     /* 425305 */   // No operand predicates
     /* 425305 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425307 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 425307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 425310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 425312 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 425314 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 425316 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 425319 */   GIR_RootConstrainSelectedInstOperands,
     /* 425320 */   // GIR_Coverage, 2733,
     /* 425320 */   GIR_EraseRootFromParent_Done,
     /* 425321 */ // Label 8342: @425321
     /* 425321 */ GIM_Reject,
     /* 425322 */ // Label 8310: @425322
     /* 425322 */ GIM_Reject,
     /* 425323 */ // Label 130: @425323
     /* 425323 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8350*/ GIMT_Encode4(425881),
     /* 425334 */ /*GILLT_s32*//*Label 8343*/ GIMT_Encode4(425370),
     /* 425338 */ /*GILLT_s64*//*Label 8344*/ GIMT_Encode4(425408), GIMT_Encode4(0),
     /* 425346 */ /*GILLT_v2s32*//*Label 8345*/ GIMT_Encode4(425506),
     /* 425350 */ /*GILLT_v2s64*//*Label 8346*/ GIMT_Encode4(425581),
     /* 425354 */ /*GILLT_v4s16*//*Label 8347*/ GIMT_Encode4(425656),
     /* 425358 */ /*GILLT_v4s32*//*Label 8348*/ GIMT_Encode4(425731), GIMT_Encode4(0),
     /* 425366 */ /*GILLT_v8s16*//*Label 8349*/ GIMT_Encode4(425806),
     /* 425370 */ // Label 8343: @425370
     /* 425370 */ GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(425407), // Rule ID 1622 //
     /* 425375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 425381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 425384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425392 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425396 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 425396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 425401 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425405 */   GIR_RootConstrainSelectedInstOperands,
     /* 425406 */   // GIR_Coverage, 1622,
     /* 425406 */   GIR_Done,
     /* 425407 */ // Label 8351: @425407
     /* 425407 */ GIM_Reject,
     /* 425408 */ // Label 8344: @425408
     /* 425408 */ GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(425505),
     /* 425413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 425416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425427 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(425458), // Rule ID 2513 //
     /* 425432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425439 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425445 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425449 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 425449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 425452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425456 */     GIR_RootConstrainSelectedInstOperands,
     /* 425457 */     // GIR_Coverage, 2513,
     /* 425457 */     GIR_EraseRootFromParent_Done,
     /* 425458 */   // Label 8353: @425458
     /* 425458 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(425481), // Rule ID 1621 //
     /* 425463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425470 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 425470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 425475 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425479 */     GIR_RootConstrainSelectedInstOperands,
     /* 425480 */     // GIR_Coverage, 1621,
     /* 425480 */     GIR_Done,
     /* 425481 */   // Label 8354: @425481
     /* 425481 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(425504), // Rule ID 5248 //
     /* 425486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425493 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 425493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 425498 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425502 */     GIR_RootConstrainSelectedInstOperands,
     /* 425503 */     // GIR_Coverage, 5248,
     /* 425503 */     GIR_Done,
     /* 425504 */   // Label 8355: @425504
     /* 425504 */   GIM_Reject,
     /* 425505 */ // Label 8352: @425505
     /* 425505 */ GIM_Reject,
     /* 425506 */ // Label 8345: @425506
     /* 425506 */ GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(425580),
     /* 425511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 425514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 425517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425525 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(425556), // Rule ID 773 //
     /* 425530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425537 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425543 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425547 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 425547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 425550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425554 */     GIR_RootConstrainSelectedInstOperands,
     /* 425555 */     // GIR_Coverage, 773,
     /* 425555 */     GIR_EraseRootFromParent_Done,
     /* 425556 */   // Label 8357: @425556
     /* 425556 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(425579), // Rule ID 1210 //
     /* 425561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425568 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 425568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 425573 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425577 */     GIR_RootConstrainSelectedInstOperands,
     /* 425578 */     // GIR_Coverage, 1210,
     /* 425578 */     GIR_Done,
     /* 425579 */   // Label 8358: @425579
     /* 425579 */   GIM_Reject,
     /* 425580 */ // Label 8356: @425580
     /* 425580 */ GIM_Reject,
     /* 425581 */ // Label 8346: @425581
     /* 425581 */ GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(425655),
     /* 425586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 425589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 425592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425600 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(425631), // Rule ID 775 //
     /* 425605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425612 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425618 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425622 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 425622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 425625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425629 */     GIR_RootConstrainSelectedInstOperands,
     /* 425630 */     // GIR_Coverage, 775,
     /* 425630 */     GIR_EraseRootFromParent_Done,
     /* 425631 */   // Label 8360: @425631
     /* 425631 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(425654), // Rule ID 1212 //
     /* 425636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425643 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 425643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 425648 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425652 */     GIR_RootConstrainSelectedInstOperands,
     /* 425653 */     // GIR_Coverage, 1212,
     /* 425653 */     GIR_Done,
     /* 425654 */   // Label 8361: @425654
     /* 425654 */   GIM_Reject,
     /* 425655 */ // Label 8359: @425655
     /* 425655 */ GIM_Reject,
     /* 425656 */ // Label 8347: @425656
     /* 425656 */ GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(425730),
     /* 425661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 425664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 425667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425675 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(425706), // Rule ID 771 //
     /* 425680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425687 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425693 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425697 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 425697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 425700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425704 */     GIR_RootConstrainSelectedInstOperands,
     /* 425705 */     // GIR_Coverage, 771,
     /* 425705 */     GIR_EraseRootFromParent_Done,
     /* 425706 */   // Label 8363: @425706
     /* 425706 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(425729), // Rule ID 1208 //
     /* 425711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425718 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 425718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 425723 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425727 */     GIR_RootConstrainSelectedInstOperands,
     /* 425728 */     // GIR_Coverage, 1208,
     /* 425728 */     GIR_Done,
     /* 425729 */   // Label 8364: @425729
     /* 425729 */   GIM_Reject,
     /* 425730 */ // Label 8362: @425730
     /* 425730 */ GIM_Reject,
     /* 425731 */ // Label 8348: @425731
     /* 425731 */ GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(425805),
     /* 425736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 425742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425750 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(425781), // Rule ID 774 //
     /* 425755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425762 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425768 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425772 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 425772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 425775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425779 */     GIR_RootConstrainSelectedInstOperands,
     /* 425780 */     // GIR_Coverage, 774,
     /* 425780 */     GIR_EraseRootFromParent_Done,
     /* 425781 */   // Label 8366: @425781
     /* 425781 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(425804), // Rule ID 1211 //
     /* 425786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425793 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 425793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 425798 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425802 */     GIR_RootConstrainSelectedInstOperands,
     /* 425803 */     // GIR_Coverage, 1211,
     /* 425803 */     GIR_Done,
     /* 425804 */   // Label 8367: @425804
     /* 425804 */   GIM_Reject,
     /* 425805 */ // Label 8365: @425805
     /* 425805 */ GIM_Reject,
     /* 425806 */ // Label 8349: @425806
     /* 425806 */ GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(425880),
     /* 425811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 425814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 425817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425825 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(425856), // Rule ID 772 //
     /* 425830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 425837 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 425843 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 425845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425847 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 425847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 425850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425854 */     GIR_RootConstrainSelectedInstOperands,
     /* 425855 */     // GIR_Coverage, 772,
     /* 425855 */     GIR_EraseRootFromParent_Done,
     /* 425856 */   // Label 8369: @425856
     /* 425856 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(425879), // Rule ID 1209 //
     /* 425861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 425864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425868 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 425868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 425873 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425877 */     GIR_RootConstrainSelectedInstOperands,
     /* 425878 */     // GIR_Coverage, 1209,
     /* 425878 */     GIR_Done,
     /* 425879 */   // Label 8370: @425879
     /* 425879 */   GIM_Reject,
     /* 425880 */ // Label 8368: @425880
     /* 425880 */ GIM_Reject,
     /* 425881 */ // Label 8350: @425881
     /* 425881 */ GIM_Reject,
     /* 425882 */ // Label 131: @425882
     /* 425882 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8378*/ GIMT_Encode4(426973),
     /* 425893 */ /*GILLT_s32*//*Label 8371*/ GIMT_Encode4(425929),
     /* 425897 */ /*GILLT_s64*//*Label 8372*/ GIMT_Encode4(425967), GIMT_Encode4(0),
     /* 425905 */ /*GILLT_v2s32*//*Label 8373*/ GIMT_Encode4(426108),
     /* 425909 */ /*GILLT_v2s64*//*Label 8374*/ GIMT_Encode4(426281),
     /* 425913 */ /*GILLT_v4s16*//*Label 8375*/ GIMT_Encode4(426454),
     /* 425917 */ /*GILLT_v4s32*//*Label 8376*/ GIMT_Encode4(426627), GIMT_Encode4(0),
     /* 425925 */ /*GILLT_v8s16*//*Label 8377*/ GIMT_Encode4(426800),
     /* 425929 */ // Label 8371: @425929
     /* 425929 */ GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(425966), // Rule ID 1624 //
     /* 425934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 425940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 425943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425951 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 425955 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 425955 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 425960 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 425964 */   GIR_RootConstrainSelectedInstOperands,
     /* 425965 */   // GIR_Coverage, 1624,
     /* 425965 */   GIR_Done,
     /* 425966 */ // Label 8379: @425966
     /* 425966 */ GIM_Reject,
     /* 425967 */ // Label 8372: @425967
     /* 425967 */ GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(426107),
     /* 425972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 425975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 425978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425982 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(426017), // Rule ID 5282 //
     /* 425987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425994 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426000 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426008 */     // (AArch64fcmge:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 426008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 426011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426015 */     GIR_RootConstrainSelectedInstOperands,
     /* 426016 */     // GIR_Coverage, 5282,
     /* 426016 */     GIR_EraseRootFromParent_Done,
     /* 426017 */   // Label 8381: @426017
     /* 426017 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(426052), // Rule ID 5280 //
     /* 426022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426033 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426039 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426043 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 426043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 426046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426050 */     GIR_RootConstrainSelectedInstOperands,
     /* 426051 */     // GIR_Coverage, 5280,
     /* 426051 */     GIR_EraseRootFromParent_Done,
     /* 426052 */   // Label 8382: @426052
     /* 426052 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(426079), // Rule ID 1623 //
     /* 426057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426068 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 426068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 426073 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426077 */     GIR_RootConstrainSelectedInstOperands,
     /* 426078 */     // GIR_Coverage, 1623,
     /* 426078 */     GIR_Done,
     /* 426079 */   // Label 8383: @426079
     /* 426079 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(426106), // Rule ID 5249 //
     /* 426084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426095 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 426095 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 426100 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426104 */     GIR_RootConstrainSelectedInstOperands,
     /* 426105 */     // GIR_Coverage, 5249,
     /* 426105 */     GIR_Done,
     /* 426106 */   // Label 8384: @426106
     /* 426106 */   GIM_Reject,
     /* 426107 */ // Label 8380: @426107
     /* 426107 */ GIM_Reject,
     /* 426108 */ // Label 8373: @426108
     /* 426108 */ GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(426280),
     /* 426113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 426116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 426119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426123 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(426182), // Rule ID 1172 //
     /* 426128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 426143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 426160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426167 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 426167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 426170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426180 */     GIR_RootConstrainSelectedInstOperands,
     /* 426181 */     // GIR_Coverage, 1172,
     /* 426181 */     GIR_EraseRootFromParent_Done,
     /* 426182 */   // Label 8386: @426182
     /* 426182 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(426217), // Rule ID 788 //
     /* 426187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426194 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426200 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426208 */     // (AArch64fcmge:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 426208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 426211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426215 */     GIR_RootConstrainSelectedInstOperands,
     /* 426216 */     // GIR_Coverage, 788,
     /* 426216 */     GIR_EraseRootFromParent_Done,
     /* 426217 */   // Label 8387: @426217
     /* 426217 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(426252), // Rule ID 778 //
     /* 426222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426233 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426239 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426243 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 426243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 426246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426248 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426250 */     GIR_RootConstrainSelectedInstOperands,
     /* 426251 */     // GIR_Coverage, 778,
     /* 426251 */     GIR_EraseRootFromParent_Done,
     /* 426252 */   // Label 8388: @426252
     /* 426252 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(426279), // Rule ID 1215 //
     /* 426257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426268 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 426268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 426273 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426277 */     GIR_RootConstrainSelectedInstOperands,
     /* 426278 */     // GIR_Coverage, 1215,
     /* 426278 */     GIR_Done,
     /* 426279 */   // Label 8389: @426279
     /* 426279 */   GIM_Reject,
     /* 426280 */ // Label 8385: @426280
     /* 426280 */ GIM_Reject,
     /* 426281 */ // Label 8374: @426281
     /* 426281 */ GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(426453),
     /* 426286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 426292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426296 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(426355), // Rule ID 1176 //
     /* 426301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426340 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 426340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 426343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426353 */     GIR_RootConstrainSelectedInstOperands,
     /* 426354 */     // GIR_Coverage, 1176,
     /* 426354 */     GIR_EraseRootFromParent_Done,
     /* 426355 */   // Label 8391: @426355
     /* 426355 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(426390), // Rule ID 790 //
     /* 426360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426367 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426373 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426381 */     // (AArch64fcmge:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 426381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 426384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426388 */     GIR_RootConstrainSelectedInstOperands,
     /* 426389 */     // GIR_Coverage, 790,
     /* 426389 */     GIR_EraseRootFromParent_Done,
     /* 426390 */   // Label 8392: @426390
     /* 426390 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(426425), // Rule ID 780 //
     /* 426395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426406 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426412 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426416 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 426416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 426419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426423 */     GIR_RootConstrainSelectedInstOperands,
     /* 426424 */     // GIR_Coverage, 780,
     /* 426424 */     GIR_EraseRootFromParent_Done,
     /* 426425 */   // Label 8393: @426425
     /* 426425 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(426452), // Rule ID 1217 //
     /* 426430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426441 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 426441 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 426446 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426450 */     GIR_RootConstrainSelectedInstOperands,
     /* 426451 */     // GIR_Coverage, 1217,
     /* 426451 */     GIR_Done,
     /* 426452 */   // Label 8394: @426452
     /* 426452 */   GIM_Reject,
     /* 426453 */ // Label 8390: @426453
     /* 426453 */ GIM_Reject,
     /* 426454 */ // Label 8375: @426454
     /* 426454 */ GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(426626),
     /* 426459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 426462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 426465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426469 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(426528), // Rule ID 1168 //
     /* 426474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 426489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 426506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426513 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 426513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 426516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426526 */     GIR_RootConstrainSelectedInstOperands,
     /* 426527 */     // GIR_Coverage, 1168,
     /* 426527 */     GIR_EraseRootFromParent_Done,
     /* 426528 */   // Label 8396: @426528
     /* 426528 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(426563), // Rule ID 786 //
     /* 426533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426540 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426546 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426554 */     // (AArch64fcmge:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 426554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 426557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426561 */     GIR_RootConstrainSelectedInstOperands,
     /* 426562 */     // GIR_Coverage, 786,
     /* 426562 */     GIR_EraseRootFromParent_Done,
     /* 426563 */   // Label 8397: @426563
     /* 426563 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(426598), // Rule ID 776 //
     /* 426568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426579 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426585 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426589 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 426589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 426592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426594 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426596 */     GIR_RootConstrainSelectedInstOperands,
     /* 426597 */     // GIR_Coverage, 776,
     /* 426597 */     GIR_EraseRootFromParent_Done,
     /* 426598 */   // Label 8398: @426598
     /* 426598 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(426625), // Rule ID 1213 //
     /* 426603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426614 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 426614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 426619 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426623 */     GIR_RootConstrainSelectedInstOperands,
     /* 426624 */     // GIR_Coverage, 1213,
     /* 426624 */     GIR_Done,
     /* 426625 */   // Label 8399: @426625
     /* 426625 */   GIM_Reject,
     /* 426626 */ // Label 8395: @426626
     /* 426626 */ GIM_Reject,
     /* 426627 */ // Label 8376: @426627
     /* 426627 */ GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(426799),
     /* 426632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 426638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426642 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(426701), // Rule ID 1174 //
     /* 426647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426686 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 426686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 426689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426699 */     GIR_RootConstrainSelectedInstOperands,
     /* 426700 */     // GIR_Coverage, 1174,
     /* 426700 */     GIR_EraseRootFromParent_Done,
     /* 426701 */   // Label 8401: @426701
     /* 426701 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(426736), // Rule ID 789 //
     /* 426706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426713 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426719 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426727 */     // (AArch64fcmge:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 426727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 426730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426734 */     GIR_RootConstrainSelectedInstOperands,
     /* 426735 */     // GIR_Coverage, 789,
     /* 426735 */     GIR_EraseRootFromParent_Done,
     /* 426736 */   // Label 8402: @426736
     /* 426736 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(426771), // Rule ID 779 //
     /* 426741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426752 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426758 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426762 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 426762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 426765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426769 */     GIR_RootConstrainSelectedInstOperands,
     /* 426770 */     // GIR_Coverage, 779,
     /* 426770 */     GIR_EraseRootFromParent_Done,
     /* 426771 */   // Label 8403: @426771
     /* 426771 */   GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(426798), // Rule ID 1216 //
     /* 426776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426787 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 426787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 426792 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426796 */     GIR_RootConstrainSelectedInstOperands,
     /* 426797 */     // GIR_Coverage, 1216,
     /* 426797 */     GIR_Done,
     /* 426798 */   // Label 8404: @426798
     /* 426798 */   GIM_Reject,
     /* 426799 */ // Label 8400: @426799
     /* 426799 */ GIM_Reject,
     /* 426800 */ // Label 8377: @426800
     /* 426800 */ GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(426972),
     /* 426805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 426808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 426811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426815 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(426874), // Rule ID 1170 //
     /* 426820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 426835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 426844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 426852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 426859 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 426859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 426862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 426868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 426872 */     GIR_RootConstrainSelectedInstOperands,
     /* 426873 */     // GIR_Coverage, 1170,
     /* 426873 */     GIR_EraseRootFromParent_Done,
     /* 426874 */   // Label 8406: @426874
     /* 426874 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(426909), // Rule ID 787 //
     /* 426879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426886 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426892 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426900 */     // (AArch64fcmge:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 426900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 426903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426907 */     GIR_RootConstrainSelectedInstOperands,
     /* 426908 */     // GIR_Coverage, 787,
     /* 426908 */     GIR_EraseRootFromParent_Done,
     /* 426909 */   // Label 8407: @426909
     /* 426909 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(426944), // Rule ID 777 //
     /* 426914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426925 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426931 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426935 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 426935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 426938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426942 */     GIR_RootConstrainSelectedInstOperands,
     /* 426943 */     // GIR_Coverage, 777,
     /* 426943 */     GIR_EraseRootFromParent_Done,
     /* 426944 */   // Label 8408: @426944
     /* 426944 */   GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(426971), // Rule ID 1214 //
     /* 426949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426960 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 426960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 426965 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426969 */     GIR_RootConstrainSelectedInstOperands,
     /* 426970 */     // GIR_Coverage, 1214,
     /* 426970 */     GIR_Done,
     /* 426971 */   // Label 8409: @426971
     /* 426971 */   GIM_Reject,
     /* 426972 */ // Label 8405: @426972
     /* 426972 */ GIM_Reject,
     /* 426973 */ // Label 8378: @426973
     /* 426973 */ GIM_Reject,
     /* 426974 */ // Label 132: @426974
     /* 426974 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8417*/ GIMT_Encode4(428065),
     /* 426985 */ /*GILLT_s32*//*Label 8410*/ GIMT_Encode4(427021),
     /* 426989 */ /*GILLT_s64*//*Label 8411*/ GIMT_Encode4(427059), GIMT_Encode4(0),
     /* 426997 */ /*GILLT_v2s32*//*Label 8412*/ GIMT_Encode4(427200),
     /* 427001 */ /*GILLT_v2s64*//*Label 8413*/ GIMT_Encode4(427373),
     /* 427005 */ /*GILLT_v4s16*//*Label 8414*/ GIMT_Encode4(427546),
     /* 427009 */ /*GILLT_v4s32*//*Label 8415*/ GIMT_Encode4(427719), GIMT_Encode4(0),
     /* 427017 */ /*GILLT_v8s16*//*Label 8416*/ GIMT_Encode4(427892),
     /* 427021 */ // Label 8410: @427021
     /* 427021 */ GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(427058), // Rule ID 1626 //
     /* 427026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 427032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 427035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 427039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 427043 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 427047 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 427047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 427052 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427056 */   GIR_RootConstrainSelectedInstOperands,
     /* 427057 */   // GIR_Coverage, 1626,
     /* 427057 */   GIR_Done,
     /* 427058 */ // Label 8418: @427058
     /* 427058 */ GIM_Reject,
     /* 427059 */ // Label 8411: @427059
     /* 427059 */ GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(427199),
     /* 427064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 427067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 427070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427074 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(427109), // Rule ID 5283 //
     /* 427079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427086 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427092 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427100 */     // (AArch64fcmgt:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 427100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 427103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427107 */     GIR_RootConstrainSelectedInstOperands,
     /* 427108 */     // GIR_Coverage, 5283,
     /* 427108 */     GIR_EraseRootFromParent_Done,
     /* 427109 */   // Label 8420: @427109
     /* 427109 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(427144), // Rule ID 5281 //
     /* 427114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427125 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427131 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427135 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 427135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 427138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427142 */     GIR_RootConstrainSelectedInstOperands,
     /* 427143 */     // GIR_Coverage, 5281,
     /* 427143 */     GIR_EraseRootFromParent_Done,
     /* 427144 */   // Label 8421: @427144
     /* 427144 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(427171), // Rule ID 1625 //
     /* 427149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427160 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 427160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 427165 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427169 */     GIR_RootConstrainSelectedInstOperands,
     /* 427170 */     // GIR_Coverage, 1625,
     /* 427170 */     GIR_Done,
     /* 427171 */   // Label 8422: @427171
     /* 427171 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(427198), // Rule ID 5250 //
     /* 427176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427187 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 427187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 427192 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427196 */     GIR_RootConstrainSelectedInstOperands,
     /* 427197 */     // GIR_Coverage, 5250,
     /* 427197 */     GIR_Done,
     /* 427198 */   // Label 8423: @427198
     /* 427198 */   GIM_Reject,
     /* 427199 */ // Label 8419: @427199
     /* 427199 */ GIM_Reject,
     /* 427200 */ // Label 8412: @427200
     /* 427200 */ GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(427372),
     /* 427205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 427208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 427211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427215 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(427274), // Rule ID 1182 //
     /* 427220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 427235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 427252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427259 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 427259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 427262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427272 */     GIR_RootConstrainSelectedInstOperands,
     /* 427273 */     // GIR_Coverage, 1182,
     /* 427273 */     GIR_EraseRootFromParent_Done,
     /* 427274 */   // Label 8425: @427274
     /* 427274 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(427309), // Rule ID 793 //
     /* 427279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427286 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427292 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427300 */     // (AArch64fcmgt:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 427300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 427303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427307 */     GIR_RootConstrainSelectedInstOperands,
     /* 427308 */     // GIR_Coverage, 793,
     /* 427308 */     GIR_EraseRootFromParent_Done,
     /* 427309 */   // Label 8426: @427309
     /* 427309 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(427344), // Rule ID 783 //
     /* 427314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427325 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427331 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427335 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 427335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 427338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427342 */     GIR_RootConstrainSelectedInstOperands,
     /* 427343 */     // GIR_Coverage, 783,
     /* 427343 */     GIR_EraseRootFromParent_Done,
     /* 427344 */   // Label 8427: @427344
     /* 427344 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(427371), // Rule ID 1220 //
     /* 427349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427360 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 427360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 427365 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427369 */     GIR_RootConstrainSelectedInstOperands,
     /* 427370 */     // GIR_Coverage, 1220,
     /* 427370 */     GIR_Done,
     /* 427371 */   // Label 8428: @427371
     /* 427371 */   GIM_Reject,
     /* 427372 */ // Label 8424: @427372
     /* 427372 */ GIM_Reject,
     /* 427373 */ // Label 8413: @427373
     /* 427373 */ GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(427545),
     /* 427378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 427381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 427384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427388 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(427447), // Rule ID 1186 //
     /* 427393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 427408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 427425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427432 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 427432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 427435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427445 */     GIR_RootConstrainSelectedInstOperands,
     /* 427446 */     // GIR_Coverage, 1186,
     /* 427446 */     GIR_EraseRootFromParent_Done,
     /* 427447 */   // Label 8430: @427447
     /* 427447 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(427482), // Rule ID 795 //
     /* 427452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427459 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427465 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427473 */     // (AArch64fcmgt:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 427473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 427476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427480 */     GIR_RootConstrainSelectedInstOperands,
     /* 427481 */     // GIR_Coverage, 795,
     /* 427481 */     GIR_EraseRootFromParent_Done,
     /* 427482 */   // Label 8431: @427482
     /* 427482 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(427517), // Rule ID 785 //
     /* 427487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427498 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427504 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427508 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 427508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 427511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427515 */     GIR_RootConstrainSelectedInstOperands,
     /* 427516 */     // GIR_Coverage, 785,
     /* 427516 */     GIR_EraseRootFromParent_Done,
     /* 427517 */   // Label 8432: @427517
     /* 427517 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(427544), // Rule ID 1222 //
     /* 427522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427533 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 427533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 427538 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427542 */     GIR_RootConstrainSelectedInstOperands,
     /* 427543 */     // GIR_Coverage, 1222,
     /* 427543 */     GIR_Done,
     /* 427544 */   // Label 8433: @427544
     /* 427544 */   GIM_Reject,
     /* 427545 */ // Label 8429: @427545
     /* 427545 */ GIM_Reject,
     /* 427546 */ // Label 8414: @427546
     /* 427546 */ GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(427718),
     /* 427551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 427557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427561 */   GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(427620), // Rule ID 1178 //
     /* 427566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427605 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 427605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 427608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427618 */     GIR_RootConstrainSelectedInstOperands,
     /* 427619 */     // GIR_Coverage, 1178,
     /* 427619 */     GIR_EraseRootFromParent_Done,
     /* 427620 */   // Label 8435: @427620
     /* 427620 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(427655), // Rule ID 791 //
     /* 427625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427632 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427638 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427646 */     // (AArch64fcmgt:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 427646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 427649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427653 */     GIR_RootConstrainSelectedInstOperands,
     /* 427654 */     // GIR_Coverage, 791,
     /* 427654 */     GIR_EraseRootFromParent_Done,
     /* 427655 */   // Label 8436: @427655
     /* 427655 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(427690), // Rule ID 781 //
     /* 427660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427671 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427677 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427681 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 427681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 427684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427688 */     GIR_RootConstrainSelectedInstOperands,
     /* 427689 */     // GIR_Coverage, 781,
     /* 427689 */     GIR_EraseRootFromParent_Done,
     /* 427690 */   // Label 8437: @427690
     /* 427690 */   GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(427717), // Rule ID 1218 //
     /* 427695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427706 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 427706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 427711 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427715 */     GIR_RootConstrainSelectedInstOperands,
     /* 427716 */     // GIR_Coverage, 1218,
     /* 427716 */     GIR_Done,
     /* 427717 */   // Label 8438: @427717
     /* 427717 */   GIM_Reject,
     /* 427718 */ // Label 8434: @427718
     /* 427718 */ GIM_Reject,
     /* 427719 */ // Label 8415: @427719
     /* 427719 */ GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(427891),
     /* 427724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 427730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427734 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(427793), // Rule ID 1184 //
     /* 427739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427778 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 427778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 427781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427791 */     GIR_RootConstrainSelectedInstOperands,
     /* 427792 */     // GIR_Coverage, 1184,
     /* 427792 */     GIR_EraseRootFromParent_Done,
     /* 427793 */   // Label 8440: @427793
     /* 427793 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(427828), // Rule ID 794 //
     /* 427798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427805 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427811 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427819 */     // (AArch64fcmgt:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 427819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 427822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427826 */     GIR_RootConstrainSelectedInstOperands,
     /* 427827 */     // GIR_Coverage, 794,
     /* 427827 */     GIR_EraseRootFromParent_Done,
     /* 427828 */   // Label 8441: @427828
     /* 427828 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(427863), // Rule ID 784 //
     /* 427833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427844 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427850 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427854 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 427854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 427857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427861 */     GIR_RootConstrainSelectedInstOperands,
     /* 427862 */     // GIR_Coverage, 784,
     /* 427862 */     GIR_EraseRootFromParent_Done,
     /* 427863 */   // Label 8442: @427863
     /* 427863 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(427890), // Rule ID 1221 //
     /* 427868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427879 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 427879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 427884 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427888 */     GIR_RootConstrainSelectedInstOperands,
     /* 427889 */     // GIR_Coverage, 1221,
     /* 427889 */     GIR_Done,
     /* 427890 */   // Label 8443: @427890
     /* 427890 */   GIM_Reject,
     /* 427891 */ // Label 8439: @427891
     /* 427891 */ GIM_Reject,
     /* 427892 */ // Label 8416: @427892
     /* 427892 */ GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(428064),
     /* 427897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 427903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427907 */   GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(427966), // Rule ID 1180 //
     /* 427912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427951 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 427951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 427954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427964 */     GIR_RootConstrainSelectedInstOperands,
     /* 427965 */     // GIR_Coverage, 1180,
     /* 427965 */     GIR_EraseRootFromParent_Done,
     /* 427966 */   // Label 8445: @427966
     /* 427966 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(428001), // Rule ID 792 //
     /* 427971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427978 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427984 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427992 */     // (AArch64fcmgt:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 427992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 427995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427999 */     GIR_RootConstrainSelectedInstOperands,
     /* 428000 */     // GIR_Coverage, 792,
     /* 428000 */     GIR_EraseRootFromParent_Done,
     /* 428001 */   // Label 8446: @428001
     /* 428001 */   GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(428036), // Rule ID 782 //
     /* 428006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428017 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428023 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428027 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 428027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 428030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428034 */     GIR_RootConstrainSelectedInstOperands,
     /* 428035 */     // GIR_Coverage, 782,
     /* 428035 */     GIR_EraseRootFromParent_Done,
     /* 428036 */   // Label 8447: @428036
     /* 428036 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(428063), // Rule ID 1219 //
     /* 428041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428052 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 428052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 428057 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428061 */     GIR_RootConstrainSelectedInstOperands,
     /* 428062 */     // GIR_Coverage, 1219,
     /* 428062 */     GIR_Done,
     /* 428063 */   // Label 8448: @428063
     /* 428063 */   GIM_Reject,
     /* 428064 */ // Label 8444: @428064
     /* 428064 */ GIM_Reject,
     /* 428065 */ // Label 8417: @428065
     /* 428065 */ GIM_Reject,
     /* 428066 */ // Label 133: @428066
     /* 428066 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8453*/ GIMT_Encode4(428219),
     /* 428077 */ /*GILLT_s32*//*Label 8449*/ GIMT_Encode4(428117),
     /* 428081 */ /*GILLT_s64*//*Label 8450*/ GIMT_Encode4(428141), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 428105 */ /*GILLT_v8s8*//*Label 8451*/ GIMT_Encode4(428165), GIMT_Encode4(0),
     /* 428113 */ /*GILLT_v16s8*//*Label 8452*/ GIMT_Encode4(428192),
     /* 428117 */ // Label 8449: @428117
     /* 428117 */ GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(428140), // Rule ID 4015 //
     /* 428122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 428125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 428129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 428133 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 428133 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 428138 */   GIR_RootConstrainSelectedInstOperands,
     /* 428139 */   // GIR_Coverage, 4015,
     /* 428139 */   GIR_Done,
     /* 428140 */ // Label 8454: @428140
     /* 428140 */ GIM_Reject,
     /* 428141 */ // Label 8450: @428141
     /* 428141 */ GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(428164), // Rule ID 4016 //
     /* 428146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 428149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 428153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 428157 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 428157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 428162 */   GIR_RootConstrainSelectedInstOperands,
     /* 428163 */   // GIR_Coverage, 4016,
     /* 428163 */   GIR_Done,
     /* 428164 */ // Label 8455: @428164
     /* 428164 */ GIM_Reject,
     /* 428165 */ // Label 8451: @428165
     /* 428165 */ GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(428191), // Rule ID 976 //
     /* 428170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 428176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428184 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 428184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 428189 */   GIR_RootConstrainSelectedInstOperands,
     /* 428190 */   // GIR_Coverage, 976,
     /* 428190 */   GIR_Done,
     /* 428191 */ // Label 8456: @428191
     /* 428191 */ GIM_Reject,
     /* 428192 */ // Label 8452: @428192
     /* 428192 */ GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(428218), // Rule ID 977 //
     /* 428197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 428203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428211 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 428211 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 428216 */   GIR_RootConstrainSelectedInstOperands,
     /* 428217 */   // GIR_Coverage, 977,
     /* 428217 */   GIR_Done,
     /* 428218 */ // Label 8457: @428218
     /* 428218 */ GIM_Reject,
     /* 428219 */ // Label 8453: @428219
     /* 428219 */ GIM_Reject,
     /* 428220 */ // Label 134: @428220
     /* 428220 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8462*/ GIMT_Encode4(428395),
     /* 428231 */ /*GILLT_v4s16*//*Label 8458*/ GIMT_Encode4(428251), GIMT_Encode4(0),
     /* 428239 */ /*GILLT_v8s8*//*Label 8459*/ GIMT_Encode4(428296),
     /* 428243 */ /*GILLT_v8s16*//*Label 8460*/ GIMT_Encode4(428323),
     /* 428247 */ /*GILLT_v16s8*//*Label 8461*/ GIMT_Encode4(428368),
     /* 428251 */ // Label 8458: @428251
     /* 428251 */ GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(428295),
     /* 428256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428267 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(428282), // Rule ID 980 //
     /* 428272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428275 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 428275 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 428280 */     GIR_RootConstrainSelectedInstOperands,
     /* 428281 */     // GIR_Coverage, 980,
     /* 428281 */     GIR_Done,
     /* 428282 */   // Label 8464: @428282
     /* 428282 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(428294), // Rule ID 4998 //
     /* 428287 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 428287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 428292 */     GIR_RootConstrainSelectedInstOperands,
     /* 428293 */     // GIR_Coverage, 4998,
     /* 428293 */     GIR_Done,
     /* 428294 */   // Label 8465: @428294
     /* 428294 */   GIM_Reject,
     /* 428295 */ // Label 8463: @428295
     /* 428295 */ GIM_Reject,
     /* 428296 */ // Label 8459: @428296
     /* 428296 */ GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(428322), // Rule ID 978 //
     /* 428301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 428307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428315 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 428315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 428320 */   GIR_RootConstrainSelectedInstOperands,
     /* 428321 */   // GIR_Coverage, 978,
     /* 428321 */   GIR_Done,
     /* 428322 */ // Label 8466: @428322
     /* 428322 */ GIM_Reject,
     /* 428323 */ // Label 8460: @428323
     /* 428323 */ GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(428367),
     /* 428328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428339 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(428354), // Rule ID 981 //
     /* 428344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428347 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 428347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 428352 */     GIR_RootConstrainSelectedInstOperands,
     /* 428353 */     // GIR_Coverage, 981,
     /* 428353 */     GIR_Done,
     /* 428354 */   // Label 8468: @428354
     /* 428354 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(428366), // Rule ID 5000 //
     /* 428359 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 428359 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 428364 */     GIR_RootConstrainSelectedInstOperands,
     /* 428365 */     // GIR_Coverage, 5000,
     /* 428365 */     GIR_Done,
     /* 428366 */   // Label 8469: @428366
     /* 428366 */   GIM_Reject,
     /* 428367 */ // Label 8467: @428367
     /* 428367 */ GIM_Reject,
     /* 428368 */ // Label 8461: @428368
     /* 428368 */ GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(428394), // Rule ID 979 //
     /* 428373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 428379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428387 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 428387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 428392 */   GIR_RootConstrainSelectedInstOperands,
     /* 428393 */   // GIR_Coverage, 979,
     /* 428393 */   GIR_Done,
     /* 428394 */ // Label 8470: @428394
     /* 428394 */ GIM_Reject,
     /* 428395 */ // Label 8462: @428395
     /* 428395 */ GIM_Reject,
     /* 428396 */ // Label 135: @428396
     /* 428396 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8477*/ GIMT_Encode4(428669),
     /* 428407 */ /*GILLT_v2s32*//*Label 8471*/ GIMT_Encode4(428435), GIMT_Encode4(0),
     /* 428415 */ /*GILLT_v4s16*//*Label 8472*/ GIMT_Encode4(428480),
     /* 428419 */ /*GILLT_v4s32*//*Label 8473*/ GIMT_Encode4(428525),
     /* 428423 */ /*GILLT_v8s8*//*Label 8474*/ GIMT_Encode4(428570),
     /* 428427 */ /*GILLT_v8s16*//*Label 8475*/ GIMT_Encode4(428597),
     /* 428431 */ /*GILLT_v16s8*//*Label 8476*/ GIMT_Encode4(428642),
     /* 428435 */ // Label 8471: @428435
     /* 428435 */ GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(428479),
     /* 428440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428451 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(428466), // Rule ID 986 //
     /* 428456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428459 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 428459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 428464 */     GIR_RootConstrainSelectedInstOperands,
     /* 428465 */     // GIR_Coverage, 986,
     /* 428465 */     GIR_Done,
     /* 428466 */   // Label 8479: @428466
     /* 428466 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(428478), // Rule ID 5002 //
     /* 428471 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 428471 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 428476 */     GIR_RootConstrainSelectedInstOperands,
     /* 428477 */     // GIR_Coverage, 5002,
     /* 428477 */     GIR_Done,
     /* 428478 */   // Label 8480: @428478
     /* 428478 */   GIM_Reject,
     /* 428479 */ // Label 8478: @428479
     /* 428479 */ GIM_Reject,
     /* 428480 */ // Label 8472: @428480
     /* 428480 */ GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(428524),
     /* 428485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428496 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(428511), // Rule ID 984 //
     /* 428501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428504 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 428504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 428509 */     GIR_RootConstrainSelectedInstOperands,
     /* 428510 */     // GIR_Coverage, 984,
     /* 428510 */     GIR_Done,
     /* 428511 */   // Label 8482: @428511
     /* 428511 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(428523), // Rule ID 4999 //
     /* 428516 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 428516 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 428521 */     GIR_RootConstrainSelectedInstOperands,
     /* 428522 */     // GIR_Coverage, 4999,
     /* 428522 */     GIR_Done,
     /* 428523 */   // Label 8483: @428523
     /* 428523 */   GIM_Reject,
     /* 428524 */ // Label 8481: @428524
     /* 428524 */ GIM_Reject,
     /* 428525 */ // Label 8473: @428525
     /* 428525 */ GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(428569),
     /* 428530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428541 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(428556), // Rule ID 987 //
     /* 428546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428549 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 428549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 428554 */     GIR_RootConstrainSelectedInstOperands,
     /* 428555 */     // GIR_Coverage, 987,
     /* 428555 */     GIR_Done,
     /* 428556 */   // Label 8485: @428556
     /* 428556 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(428568), // Rule ID 5003 //
     /* 428561 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 428561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 428566 */     GIR_RootConstrainSelectedInstOperands,
     /* 428567 */     // GIR_Coverage, 5003,
     /* 428567 */     GIR_Done,
     /* 428568 */   // Label 8486: @428568
     /* 428568 */   GIM_Reject,
     /* 428569 */ // Label 8484: @428569
     /* 428569 */ GIM_Reject,
     /* 428570 */ // Label 8474: @428570
     /* 428570 */ GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(428596), // Rule ID 982 //
     /* 428575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 428581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428589 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 428589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 428594 */   GIR_RootConstrainSelectedInstOperands,
     /* 428595 */   // GIR_Coverage, 982,
     /* 428595 */   GIR_Done,
     /* 428596 */ // Label 8487: @428596
     /* 428596 */ GIM_Reject,
     /* 428597 */ // Label 8475: @428597
     /* 428597 */ GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(428641),
     /* 428602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428613 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(428628), // Rule ID 985 //
     /* 428618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428621 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 428621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 428626 */     GIR_RootConstrainSelectedInstOperands,
     /* 428627 */     // GIR_Coverage, 985,
     /* 428627 */     GIR_Done,
     /* 428628 */   // Label 8489: @428628
     /* 428628 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(428640), // Rule ID 5001 //
     /* 428633 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 428633 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 428638 */     GIR_RootConstrainSelectedInstOperands,
     /* 428639 */     // GIR_Coverage, 5001,
     /* 428639 */     GIR_Done,
     /* 428640 */   // Label 8490: @428640
     /* 428640 */   GIM_Reject,
     /* 428641 */ // Label 8488: @428641
     /* 428641 */ GIM_Reject,
     /* 428642 */ // Label 8476: @428642
     /* 428642 */ GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(428668), // Rule ID 983 //
     /* 428647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 428653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428661 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 428661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 428666 */   GIR_RootConstrainSelectedInstOperands,
     /* 428667 */   // GIR_Coverage, 983,
     /* 428667 */   GIR_Done,
     /* 428668 */ // Label 8491: @428668
     /* 428668 */ GIM_Reject,
     /* 428669 */ // Label 8477: @428669
     /* 428669 */ GIM_Reject,
     /* 428670 */ // Label 136: @428670
     /* 428670 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8498*/ GIMT_Encode4(428875),
     /* 428681 */ /*GILLT_s64*//*Label 8492*/ GIMT_Encode4(428713), GIMT_Encode4(0),
     /* 428689 */ /*GILLT_v2s32*//*Label 8493*/ GIMT_Encode4(428740),
     /* 428693 */ /*GILLT_v2s64*//*Label 8494*/ GIMT_Encode4(428767),
     /* 428697 */ /*GILLT_v4s16*//*Label 8495*/ GIMT_Encode4(428794),
     /* 428701 */ /*GILLT_v4s32*//*Label 8496*/ GIMT_Encode4(428821), GIMT_Encode4(0),
     /* 428709 */ /*GILLT_v8s16*//*Label 8497*/ GIMT_Encode4(428848),
     /* 428713 */ // Label 8492: @428713
     /* 428713 */ GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(428739), // Rule ID 1008 //
     /* 428718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428732 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 428732 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 428737 */   GIR_RootConstrainSelectedInstOperands,
     /* 428738 */   // GIR_Coverage, 1008,
     /* 428738 */   GIR_Done,
     /* 428739 */ // Label 8499: @428739
     /* 428739 */ GIM_Reject,
     /* 428740 */ // Label 8493: @428740
     /* 428740 */ GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(428766), // Rule ID 1004 //
     /* 428745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428759 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 428759 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 428764 */   GIR_RootConstrainSelectedInstOperands,
     /* 428765 */   // GIR_Coverage, 1004,
     /* 428765 */   GIR_Done,
     /* 428766 */ // Label 8500: @428766
     /* 428766 */ GIM_Reject,
     /* 428767 */ // Label 8494: @428767
     /* 428767 */ GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(428793), // Rule ID 1010 //
     /* 428772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428786 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 428786 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 428791 */   GIR_RootConstrainSelectedInstOperands,
     /* 428792 */   // GIR_Coverage, 1010,
     /* 428792 */   GIR_Done,
     /* 428793 */ // Label 8501: @428793
     /* 428793 */ GIM_Reject,
     /* 428794 */ // Label 8495: @428794
     /* 428794 */ GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(428820), // Rule ID 1000 //
     /* 428799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 428805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428813 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 428813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 428818 */   GIR_RootConstrainSelectedInstOperands,
     /* 428819 */   // GIR_Coverage, 1000,
     /* 428819 */   GIR_Done,
     /* 428820 */ // Label 8502: @428820
     /* 428820 */ GIM_Reject,
     /* 428821 */ // Label 8496: @428821
     /* 428821 */ GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(428847), // Rule ID 1006 //
     /* 428826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428840 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 428840 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 428845 */   GIR_RootConstrainSelectedInstOperands,
     /* 428846 */   // GIR_Coverage, 1006,
     /* 428846 */   GIR_Done,
     /* 428847 */ // Label 8503: @428847
     /* 428847 */ GIM_Reject,
     /* 428848 */ // Label 8497: @428848
     /* 428848 */ GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(428874), // Rule ID 1002 //
     /* 428853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 428859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428867 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 428867 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 428872 */   GIR_RootConstrainSelectedInstOperands,
     /* 428873 */   // GIR_Coverage, 1002,
     /* 428873 */   GIR_Done,
     /* 428874 */ // Label 8504: @428874
     /* 428874 */ GIM_Reject,
     /* 428875 */ // Label 8498: @428875
     /* 428875 */ GIM_Reject,
     /* 428876 */ // Label 137: @428876
     /* 428876 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8507*/ GIMT_Encode4(429274),
     /* 428887 */ /*GILLT_v2s64*//*Label 8505*/ GIMT_Encode4(428899), GIMT_Encode4(0),
     /* 428895 */ /*GILLT_v4s32*//*Label 8506*/ GIMT_Encode4(429037),
     /* 428899 */ // Label 8505: @428899
     /* 428899 */ GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(428958), // Rule ID 5926 //
     /* 428904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428915 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 428915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 428918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 428922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428927 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 428933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 428936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 428938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 428941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 428944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 428947 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428952 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428957 */   // GIR_Coverage, 5926,
     /* 428957 */   GIR_EraseRootFromParent_Done,
     /* 428958 */ // Label 8508: @428958
     /* 428958 */ GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(429036), // Rule ID 6048 //
     /* 428963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428974 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 428974 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 428977 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 428981 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 428986 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 428990 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 428992 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 428995 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 428999 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 429004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 429006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 429009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 429011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 429014 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 429017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 429020 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429025 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429030 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429035 */   // GIR_Coverage, 6048,
     /* 429035 */   GIR_EraseRootFromParent_Done,
     /* 429036 */ // Label 8509: @429036
     /* 429036 */ GIM_Reject,
     /* 429037 */ // Label 8506: @429037
     /* 429037 */ GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(429096), // Rule ID 5922 //
     /* 429042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 429045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429053 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 429053 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 429056 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 429060 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 429065 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 429069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 429071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 429074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 429076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 429082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 429085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429090 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 429095 */   // GIR_Coverage, 5922,
     /* 429095 */   GIR_EraseRootFromParent_Done,
     /* 429096 */ // Label 8510: @429096
     /* 429096 */ GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(429155), // Rule ID 5923 //
     /* 429101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 429104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429112 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 429112 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 429115 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 429119 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 429124 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 429128 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 429130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 429133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 429135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429138 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 429141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 429144 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 429154 */   // GIR_Coverage, 5923,
     /* 429154 */   GIR_EraseRootFromParent_Done,
     /* 429155 */ // Label 8511: @429155
     /* 429155 */ GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(429214), // Rule ID 5924 //
     /* 429160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 429163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429171 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 429171 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 429174 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 429178 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 429183 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 429187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 429189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 429192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 429194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 429200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 429203 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429208 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 429213 */   // GIR_Coverage, 5924,
     /* 429213 */   GIR_EraseRootFromParent_Done,
     /* 429214 */ // Label 8512: @429214
     /* 429214 */ GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(429273), // Rule ID 5925 //
     /* 429219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429230 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 429230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 429233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 429237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 429242 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 429246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 429248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 429251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 429253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429256 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 429259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 429262 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429267 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 429272 */   // GIR_Coverage, 5925,
     /* 429272 */   GIR_EraseRootFromParent_Done,
     /* 429273 */ // Label 8513: @429273
     /* 429273 */ GIM_Reject,
     /* 429274 */ // Label 8507: @429274
     /* 429274 */ GIM_Reject,
     /* 429275 */ // Label 138: @429275
     /* 429275 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8518*/ GIMT_Encode4(429644),
     /* 429286 */ /*GILLT_v2s32*//*Label 8514*/ GIMT_Encode4(429346), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 429298 */ /*GILLT_v4s32*//*Label 8515*/ GIMT_Encode4(429466), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 429330 */ /*GILLT_nxv2s64*//*Label 8516*/ GIMT_Encode4(429586), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 429342 */ /*GILLT_nxv4s32*//*Label 8517*/ GIMT_Encode4(429615),
     /* 429346 */ // Label 8514: @429346
     /* 429346 */ GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(429465),
     /* 429351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 429357 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 429360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429372 */   GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(429445), // Rule ID 26 //
     /* 429377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 429380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 429384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 429388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429408 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429421 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429425 */     // MIs[3] Operand 1
     /* 429425 */     // No operand predicates
     /* 429425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429427 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 429430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 429432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 429434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429443 */     GIR_RootConstrainSelectedInstOperands,
     /* 429444 */     // GIR_Coverage, 26,
     /* 429444 */     GIR_EraseRootFromParent_Done,
     /* 429445 */   // Label 8520: @429445
     /* 429445 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(429464), // Rule ID 22 //
     /* 429450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 429453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429457 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 429457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 429462 */     GIR_RootConstrainSelectedInstOperands,
     /* 429463 */     // GIR_Coverage, 22,
     /* 429463 */     GIR_Done,
     /* 429464 */   // Label 8521: @429464
     /* 429464 */   GIM_Reject,
     /* 429465 */ // Label 8519: @429465
     /* 429465 */ GIM_Reject,
     /* 429466 */ // Label 8515: @429466
     /* 429466 */ GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(429585),
     /* 429471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 429477 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 429480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429492 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(429565), // Rule ID 27 //
     /* 429497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 429500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 429504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 429508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429541 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429545 */     // MIs[3] Operand 1
     /* 429545 */     // No operand predicates
     /* 429545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429547 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 429550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 429552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 429554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 429556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429563 */     GIR_RootConstrainSelectedInstOperands,
     /* 429564 */     // GIR_Coverage, 27,
     /* 429564 */     GIR_EraseRootFromParent_Done,
     /* 429565 */   // Label 8523: @429565
     /* 429565 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(429584), // Rule ID 23 //
     /* 429570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 429573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429577 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 429577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 429582 */     GIR_RootConstrainSelectedInstOperands,
     /* 429583 */     // GIR_Coverage, 23,
     /* 429583 */     GIR_Done,
     /* 429584 */   // Label 8524: @429584
     /* 429584 */   GIM_Reject,
     /* 429585 */ // Label 8522: @429585
     /* 429585 */ GIM_Reject,
     /* 429586 */ // Label 8516: @429586
     /* 429586 */ GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(429614), // Rule ID 2986 //
     /* 429591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 429594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 429597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 429600 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 429603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 429607 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 429607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 429612 */   GIR_RootConstrainSelectedInstOperands,
     /* 429613 */   // GIR_Coverage, 2986,
     /* 429613 */   GIR_Done,
     /* 429614 */ // Label 8525: @429614
     /* 429614 */ GIM_Reject,
     /* 429615 */ // Label 8517: @429615
     /* 429615 */ GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(429643), // Rule ID 2985 //
     /* 429620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 429623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 429626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 429629 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 429632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 429636 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 429636 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 429641 */   GIR_RootConstrainSelectedInstOperands,
     /* 429642 */   // GIR_Coverage, 2985,
     /* 429642 */   GIR_Done,
     /* 429643 */ // Label 8526: @429643
     /* 429643 */ GIM_Reject,
     /* 429644 */ // Label 8518: @429644
     /* 429644 */ GIM_Reject,
     /* 429645 */ // Label 139: @429645
     /* 429645 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8530*/ GIMT_Encode4(429761),
     /* 429656 */ /*GILLT_s16*//*Label 8527*/ GIMT_Encode4(429668),
     /* 429660 */ /*GILLT_s32*//*Label 8528*/ GIMT_Encode4(429699),
     /* 429664 */ /*GILLT_s64*//*Label 8529*/ GIMT_Encode4(429730),
     /* 429668 */ // Label 8527: @429668
     /* 429668 */ GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(429698), // Rule ID 1658 //
     /* 429673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 429676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 429679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 429683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 429687 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 429687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 429692 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429696 */   GIR_RootConstrainSelectedInstOperands,
     /* 429697 */   // GIR_Coverage, 1658,
     /* 429697 */   GIR_Done,
     /* 429698 */ // Label 8531: @429698
     /* 429698 */ GIM_Reject,
     /* 429699 */ // Label 8528: @429699
     /* 429699 */ GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(429729), // Rule ID 1657 //
     /* 429704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 429707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 429710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 429714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 429718 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 429718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 429723 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429727 */   GIR_RootConstrainSelectedInstOperands,
     /* 429728 */   // GIR_Coverage, 1657,
     /* 429728 */   GIR_Done,
     /* 429729 */ // Label 8532: @429729
     /* 429729 */ GIM_Reject,
     /* 429730 */ // Label 8529: @429730
     /* 429730 */ GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(429760), // Rule ID 1656 //
     /* 429735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 429738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 429741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429749 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 429749 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 429754 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 429758 */   GIR_RootConstrainSelectedInstOperands,
     /* 429759 */   // GIR_Coverage, 1656,
     /* 429759 */   GIR_Done,
     /* 429760 */ // Label 8533: @429760
     /* 429760 */ GIM_Reject,
     /* 429761 */ // Label 8530: @429761
     /* 429761 */ GIM_Reject,
     /* 429762 */ // Label 140: @429762
     /* 429762 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8537*/ GIMT_Encode4(430994),
     /* 429773 */ /*GILLT_v2s64*//*Label 8534*/ GIMT_Encode4(429793), GIMT_Encode4(0),
     /* 429781 */ /*GILLT_v4s32*//*Label 8535*/ GIMT_Encode4(430354), GIMT_Encode4(0),
     /* 429789 */ /*GILLT_v8s16*//*Label 8536*/ GIMT_Encode4(430915),
     /* 429793 */ // Label 8534: @429793
     /* 429793 */ GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(430353),
     /* 429798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 429804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429808 */   GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(429900), // Rule ID 2054 //
     /* 429813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 429820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429857 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429861 */     // MIs[3] Operand 1
     /* 429861 */     // No operand predicates
     /* 429861 */     // MIs[1] Operand 2
     /* 429861 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 429872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 429881 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 429884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 429891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429898 */     GIR_RootConstrainSelectedInstOperands,
     /* 429899 */     // GIR_Coverage, 2054,
     /* 429899 */     GIR_EraseRootFromParent_Done,
     /* 429900 */   // Label 8539: @429900
     /* 429900 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(429992), // Rule ID 13582 //
     /* 429905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 429912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 429916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 429924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 429928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 429936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 429945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 429949 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 429953 */     // MIs[3] Operand 1
     /* 429953 */     // No operand predicates
     /* 429953 */     // MIs[1] Operand 2
     /* 429953 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 429964 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 429966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 429973 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 429973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 429976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 429978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 429983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 429987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 429990 */     GIR_RootConstrainSelectedInstOperands,
     /* 429991 */     // GIR_Coverage, 13582,
     /* 429991 */     GIR_EraseRootFromParent_Done,
     /* 429992 */   // Label 8540: @429992
     /* 429992 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(430078), // Rule ID 13580 //
     /* 429997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430037 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430041 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 430045 */     // MIs[3] Operand 1
     /* 430045 */     // No operand predicates
     /* 430045 */     // MIs[1] Operand 2
     /* 430045 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 430056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430060 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430062 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 430065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 430069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430076 */     GIR_RootConstrainSelectedInstOperands,
     /* 430077 */     // GIR_Coverage, 13580,
     /* 430077 */     GIR_EraseRootFromParent_Done,
     /* 430078 */   // Label 8541: @430078
     /* 430078 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(430164), // Rule ID 2052 //
     /* 430083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430118 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430131 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 430135 */     // MIs[3] Operand 1
     /* 430135 */     // No operand predicates
     /* 430135 */     // MIs[1] Operand 2
     /* 430135 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 430146 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430148 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 430151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 430155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430162 */     GIR_RootConstrainSelectedInstOperands,
     /* 430163 */     // GIR_Coverage, 2052,
     /* 430163 */     GIR_EraseRootFromParent_Done,
     /* 430164 */   // Label 8542: @430164
     /* 430164 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(430203), // Rule ID 1741 //
     /* 430169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 430179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 430186 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 430186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 430189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 430196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 430201 */     GIR_RootConstrainSelectedInstOperands,
     /* 430202 */     // GIR_Coverage, 1741,
     /* 430202 */     GIR_EraseRootFromParent_Done,
     /* 430203 */   // Label 8543: @430203
     /* 430203 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(430266), // Rule ID 13581 //
     /* 430208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 430227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 430236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430240 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 430244 */     // MIs[2] Operand 1
     /* 430244 */     // No operand predicates
     /* 430244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 430250 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 430253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 430257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 430261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 430264 */     GIR_RootConstrainSelectedInstOperands,
     /* 430265 */     // GIR_Coverage, 13581,
     /* 430265 */     GIR_EraseRootFromParent_Done,
     /* 430266 */   // Label 8544: @430266
     /* 430266 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(430329), // Rule ID 2053 //
     /* 430271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 430294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 430303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430307 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 430311 */     // MIs[2] Operand 1
     /* 430311 */     // No operand predicates
     /* 430311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 430313 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 430316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430318 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 430320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 430324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 430327 */     GIR_RootConstrainSelectedInstOperands,
     /* 430328 */     // GIR_Coverage, 2053,
     /* 430328 */     GIR_EraseRootFromParent_Done,
     /* 430329 */   // Label 8545: @430329
     /* 430329 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(430352), // Rule ID 1740 //
     /* 430334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430345 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 430345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 430350 */     GIR_RootConstrainSelectedInstOperands,
     /* 430351 */     // GIR_Coverage, 1740,
     /* 430351 */     GIR_Done,
     /* 430352 */   // Label 8546: @430352
     /* 430352 */   GIM_Reject,
     /* 430353 */ // Label 8538: @430353
     /* 430353 */ GIM_Reject,
     /* 430354 */ // Label 8535: @430354
     /* 430354 */ GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(430914),
     /* 430359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 430362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 430365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430369 */   GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(430461), // Rule ID 2051 //
     /* 430374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 430397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 430410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430418 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 430422 */     // MIs[3] Operand 1
     /* 430422 */     // No operand predicates
     /* 430422 */     // MIs[1] Operand 2
     /* 430422 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 430433 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 430442 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 430445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 430452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430459 */     GIR_RootConstrainSelectedInstOperands,
     /* 430460 */     // GIR_Coverage, 2051,
     /* 430460 */     GIR_EraseRootFromParent_Done,
     /* 430461 */   // Label 8548: @430461
     /* 430461 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(430553), // Rule ID 13579 //
     /* 430466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 430489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 430502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430510 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 430514 */     // MIs[3] Operand 1
     /* 430514 */     // No operand predicates
     /* 430514 */     // MIs[1] Operand 2
     /* 430514 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 430525 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 430534 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 430537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 430544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430551 */     GIR_RootConstrainSelectedInstOperands,
     /* 430552 */     // GIR_Coverage, 13579,
     /* 430552 */     GIR_EraseRootFromParent_Done,
     /* 430553 */   // Label 8549: @430553
     /* 430553 */   GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(430639), // Rule ID 13577 //
     /* 430558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 430581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 430594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430602 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 430606 */     // MIs[3] Operand 1
     /* 430606 */     // No operand predicates
     /* 430606 */     // MIs[1] Operand 2
     /* 430606 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 430617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430623 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 430626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 430630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430637 */     GIR_RootConstrainSelectedInstOperands,
     /* 430638 */     // GIR_Coverage, 13577,
     /* 430638 */     GIR_EraseRootFromParent_Done,
     /* 430639 */   // Label 8550: @430639
     /* 430639 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(430725), // Rule ID 2049 //
     /* 430644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 430671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430675 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 430684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430688 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430692 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 430696 */     // MIs[3] Operand 1
     /* 430696 */     // No operand predicates
     /* 430696 */     // MIs[1] Operand 2
     /* 430696 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 430707 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430709 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 430712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 430716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430723 */     GIR_RootConstrainSelectedInstOperands,
     /* 430724 */     // GIR_Coverage, 2049,
     /* 430724 */     GIR_EraseRootFromParent_Done,
     /* 430725 */   // Label 8551: @430725
     /* 430725 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(430764), // Rule ID 1739 //
     /* 430730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 430740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 430747 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 430747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 430750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 430757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 430762 */     GIR_RootConstrainSelectedInstOperands,
     /* 430763 */     // GIR_Coverage, 1739,
     /* 430763 */     GIR_EraseRootFromParent_Done,
     /* 430764 */   // Label 8552: @430764
     /* 430764 */   GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(430827), // Rule ID 13578 //
     /* 430769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 430780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 430788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 430793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 430797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430801 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 430805 */     // MIs[2] Operand 1
     /* 430805 */     // No operand predicates
     /* 430805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 430811 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 430814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 430818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 430822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 430825 */     GIR_RootConstrainSelectedInstOperands,
     /* 430826 */     // GIR_Coverage, 13578,
     /* 430826 */     GIR_EraseRootFromParent_Done,
     /* 430827 */   // Label 8553: @430827
     /* 430827 */   GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(430890), // Rule ID 2050 //
     /* 430832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 430847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 430855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 430860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 430864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430868 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 430872 */     // MIs[2] Operand 1
     /* 430872 */     // No operand predicates
     /* 430872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 430874 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 430877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 430881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 430885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 430888 */     GIR_RootConstrainSelectedInstOperands,
     /* 430889 */     // GIR_Coverage, 2050,
     /* 430889 */     GIR_EraseRootFromParent_Done,
     /* 430890 */   // Label 8554: @430890
     /* 430890 */   GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(430913), // Rule ID 1738 //
     /* 430895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430906 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 430906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 430911 */     GIR_RootConstrainSelectedInstOperands,
     /* 430912 */     // GIR_Coverage, 1738,
     /* 430912 */     GIR_Done,
     /* 430913 */   // Label 8555: @430913
     /* 430913 */   GIM_Reject,
     /* 430914 */ // Label 8547: @430914
     /* 430914 */ GIM_Reject,
     /* 430915 */ // Label 8536: @430915
     /* 430915 */ GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(430993),
     /* 430920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 430923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 430926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430930 */   GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(430969), // Rule ID 1737 //
     /* 430935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 430945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 430952 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 430952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 430955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 430962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 430967 */     GIR_RootConstrainSelectedInstOperands,
     /* 430968 */     // GIR_Coverage, 1737,
     /* 430968 */     GIR_EraseRootFromParent_Done,
     /* 430969 */   // Label 8557: @430969
     /* 430969 */   GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(430992), // Rule ID 1736 //
     /* 430974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430985 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 430985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 430990 */     GIR_RootConstrainSelectedInstOperands,
     /* 430991 */     // GIR_Coverage, 1736,
     /* 430991 */     GIR_Done,
     /* 430992 */   // Label 8558: @430992
     /* 430992 */   GIM_Reject,
     /* 430993 */ // Label 8556: @430993
     /* 430993 */ GIM_Reject,
     /* 430994 */ // Label 8537: @430994
     /* 430994 */ GIM_Reject,
     /* 430995 */ // Label 141: @430995
     /* 430995 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8577*/ GIMT_Encode4(431774),
     /* 431006 */ /*GILLT_v2s32*//*Label 8559*/ GIMT_Encode4(431082),
     /* 431010 */ /*GILLT_v2s64*//*Label 8560*/ GIMT_Encode4(431137),
     /* 431014 */ /*GILLT_v4s16*//*Label 8561*/ GIMT_Encode4(431192),
     /* 431018 */ /*GILLT_v4s32*//*Label 8562*/ GIMT_Encode4(431247),
     /* 431022 */ /*GILLT_v8s8*//*Label 8563*/ GIMT_Encode4(431302),
     /* 431026 */ /*GILLT_v8s16*//*Label 8564*/ GIMT_Encode4(431336),
     /* 431030 */ /*GILLT_v16s8*//*Label 8565*/ GIMT_Encode4(431391), GIMT_Encode4(0),
     /* 431038 */ /*GILLT_nxv2s1*//*Label 8566*/ GIMT_Encode4(431425),
     /* 431042 */ /*GILLT_nxv2s16*//*Label 8567*/ GIMT_Encode4(431451),
     /* 431046 */ /*GILLT_nxv2s32*//*Label 8568*/ GIMT_Encode4(431477),
     /* 431050 */ /*GILLT_nxv2s64*//*Label 8569*/ GIMT_Encode4(431503),
     /* 431054 */ /*GILLT_nxv4s1*//*Label 8570*/ GIMT_Encode4(431550),
     /* 431058 */ /*GILLT_nxv4s16*//*Label 8571*/ GIMT_Encode4(431576),
     /* 431062 */ /*GILLT_nxv4s32*//*Label 8572*/ GIMT_Encode4(431602),
     /* 431066 */ /*GILLT_nxv8s1*//*Label 8573*/ GIMT_Encode4(431649),
     /* 431070 */ /*GILLT_nxv8s16*//*Label 8574*/ GIMT_Encode4(431675),
     /* 431074 */ /*GILLT_nxv16s1*//*Label 8575*/ GIMT_Encode4(431722),
     /* 431078 */ /*GILLT_nxv16s8*//*Label 8576*/ GIMT_Encode4(431748),
     /* 431082 */ // Label 8559: @431082
     /* 431082 */ GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(431136),
     /* 431087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 431090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 431093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431105 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(431120), // Rule ID 1874 //
     /* 431110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431113 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 431113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 431118 */     GIR_RootConstrainSelectedInstOperands,
     /* 431119 */     // GIR_Coverage, 1874,
     /* 431119 */     GIR_Done,
     /* 431120 */   // Label 8579: @431120
     /* 431120 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(431135), // Rule ID 2505 //
     /* 431125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431128 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 431128 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 431133 */     GIR_RootConstrainSelectedInstOperands,
     /* 431134 */     // GIR_Coverage, 2505,
     /* 431134 */     GIR_Done,
     /* 431135 */   // Label 8580: @431135
     /* 431135 */   GIM_Reject,
     /* 431136 */ // Label 8578: @431136
     /* 431136 */ GIM_Reject,
     /* 431137 */ // Label 8560: @431137
     /* 431137 */ GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(431191),
     /* 431142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 431145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 431148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431160 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(431175), // Rule ID 1876 //
     /* 431165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431168 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 431168 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 431173 */     GIR_RootConstrainSelectedInstOperands,
     /* 431174 */     // GIR_Coverage, 1876,
     /* 431174 */     GIR_Done,
     /* 431175 */   // Label 8582: @431175
     /* 431175 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(431190), // Rule ID 2507 //
     /* 431180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431183 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 431183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 431188 */     GIR_RootConstrainSelectedInstOperands,
     /* 431189 */     // GIR_Coverage, 2507,
     /* 431189 */     GIR_Done,
     /* 431190 */   // Label 8583: @431190
     /* 431190 */   GIM_Reject,
     /* 431191 */ // Label 8581: @431191
     /* 431191 */ GIM_Reject,
     /* 431192 */ // Label 8561: @431192
     /* 431192 */ GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(431246),
     /* 431197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 431200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 431203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431211 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431215 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(431230), // Rule ID 1872 //
     /* 431220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431223 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 431223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 431228 */     GIR_RootConstrainSelectedInstOperands,
     /* 431229 */     // GIR_Coverage, 1872,
     /* 431229 */     GIR_Done,
     /* 431230 */   // Label 8585: @431230
     /* 431230 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(431245), // Rule ID 2503 //
     /* 431235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431238 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 431238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 431243 */     GIR_RootConstrainSelectedInstOperands,
     /* 431244 */     // GIR_Coverage, 2503,
     /* 431244 */     GIR_Done,
     /* 431245 */   // Label 8586: @431245
     /* 431245 */   GIM_Reject,
     /* 431246 */ // Label 8584: @431246
     /* 431246 */ GIM_Reject,
     /* 431247 */ // Label 8562: @431247
     /* 431247 */ GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(431301),
     /* 431252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 431258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431270 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(431285), // Rule ID 1875 //
     /* 431275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431278 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 431278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 431283 */     GIR_RootConstrainSelectedInstOperands,
     /* 431284 */     // GIR_Coverage, 1875,
     /* 431284 */     GIR_Done,
     /* 431285 */   // Label 8588: @431285
     /* 431285 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(431300), // Rule ID 2506 //
     /* 431290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431293 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 431293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 431298 */     GIR_RootConstrainSelectedInstOperands,
     /* 431299 */     // GIR_Coverage, 2506,
     /* 431299 */     GIR_Done,
     /* 431300 */   // Label 8589: @431300
     /* 431300 */   GIM_Reject,
     /* 431301 */ // Label 8587: @431301
     /* 431301 */ GIM_Reject,
     /* 431302 */ // Label 8563: @431302
     /* 431302 */ GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(431335), // Rule ID 1870 //
     /* 431307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 431313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 431316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431328 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 431328 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 431333 */   GIR_RootConstrainSelectedInstOperands,
     /* 431334 */   // GIR_Coverage, 1870,
     /* 431334 */   GIR_Done,
     /* 431335 */ // Label 8590: @431335
     /* 431335 */ GIM_Reject,
     /* 431336 */ // Label 8564: @431336
     /* 431336 */ GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(431390),
     /* 431341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 431347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431359 */   GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(431374), // Rule ID 1873 //
     /* 431364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431367 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 431367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 431372 */     GIR_RootConstrainSelectedInstOperands,
     /* 431373 */     // GIR_Coverage, 1873,
     /* 431373 */     GIR_Done,
     /* 431374 */   // Label 8592: @431374
     /* 431374 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(431389), // Rule ID 2504 //
     /* 431379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431382 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 431382 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 431387 */     GIR_RootConstrainSelectedInstOperands,
     /* 431388 */     // GIR_Coverage, 2504,
     /* 431388 */     GIR_Done,
     /* 431389 */   // Label 8593: @431389
     /* 431389 */   GIM_Reject,
     /* 431390 */ // Label 8591: @431390
     /* 431390 */ GIM_Reject,
     /* 431391 */ // Label 8565: @431391
     /* 431391 */ GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(431424), // Rule ID 1871 //
     /* 431396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 431402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 431405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431417 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 431417 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 431422 */   GIR_RootConstrainSelectedInstOperands,
     /* 431423 */   // GIR_Coverage, 1871,
     /* 431423 */   GIR_Done,
     /* 431424 */ // Label 8594: @431424
     /* 431424 */ GIM_Reject,
     /* 431425 */ // Label 8566: @431425
     /* 431425 */ GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(431450), // Rule ID 9033 //
     /* 431430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 431436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 431439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 431443 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 431443 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 431448 */   GIR_RootConstrainSelectedInstOperands,
     /* 431449 */   // GIR_Coverage, 9033,
     /* 431449 */   GIR_Done,
     /* 431450 */ // Label 8595: @431450
     /* 431450 */ GIM_Reject,
     /* 431451 */ // Label 8567: @431451
     /* 431451 */ GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(431476), // Rule ID 9009 //
     /* 431456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 431462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 431465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431469 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 431469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 431474 */   GIR_RootConstrainSelectedInstOperands,
     /* 431475 */   // GIR_Coverage, 9009,
     /* 431475 */   GIR_Done,
     /* 431476 */ // Label 8596: @431476
     /* 431476 */ GIM_Reject,
     /* 431477 */ // Label 8568: @431477
     /* 431477 */ GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(431502), // Rule ID 9010 //
     /* 431482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 431488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 431491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431495 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 431495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 431500 */   GIR_RootConstrainSelectedInstOperands,
     /* 431501 */   // GIR_Coverage, 9010,
     /* 431501 */   GIR_Done,
     /* 431502 */ // Label 8597: @431502
     /* 431502 */ GIM_Reject,
     /* 431503 */ // Label 8569: @431503
     /* 431503 */ GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(431549),
     /* 431508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 431511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 431514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431518 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(431533), // Rule ID 9005 //
     /* 431523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431526 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 431526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 431531 */     GIR_RootConstrainSelectedInstOperands,
     /* 431532 */     // GIR_Coverage, 9005,
     /* 431532 */     GIR_Done,
     /* 431533 */   // Label 8599: @431533
     /* 431533 */   GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(431548), // Rule ID 9011 //
     /* 431538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431541 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 431541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 431546 */     GIR_RootConstrainSelectedInstOperands,
     /* 431547 */     // GIR_Coverage, 9011,
     /* 431547 */     GIR_Done,
     /* 431548 */   // Label 8600: @431548
     /* 431548 */   GIM_Reject,
     /* 431549 */ // Label 8598: @431549
     /* 431549 */ GIM_Reject,
     /* 431550 */ // Label 8570: @431550
     /* 431550 */ GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(431575), // Rule ID 9032 //
     /* 431555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 431561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 431564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 431568 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 431568 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 431573 */   GIR_RootConstrainSelectedInstOperands,
     /* 431574 */   // GIR_Coverage, 9032,
     /* 431574 */   GIR_Done,
     /* 431575 */ // Label 8601: @431575
     /* 431575 */ GIM_Reject,
     /* 431576 */ // Label 8571: @431576
     /* 431576 */ GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(431601), // Rule ID 9007 //
     /* 431581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 431587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 431590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431594 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 431594 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 431599 */   GIR_RootConstrainSelectedInstOperands,
     /* 431600 */   // GIR_Coverage, 9007,
     /* 431600 */   GIR_Done,
     /* 431601 */ // Label 8602: @431601
     /* 431601 */ GIM_Reject,
     /* 431602 */ // Label 8572: @431602
     /* 431602 */ GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(431648),
     /* 431607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 431610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 431613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431617 */   GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(431632), // Rule ID 9004 //
     /* 431622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431625 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 431625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 431630 */     GIR_RootConstrainSelectedInstOperands,
     /* 431631 */     // GIR_Coverage, 9004,
     /* 431631 */     GIR_Done,
     /* 431632 */   // Label 8604: @431632
     /* 431632 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(431647), // Rule ID 9008 //
     /* 431637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431640 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 431640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 431645 */     GIR_RootConstrainSelectedInstOperands,
     /* 431646 */     // GIR_Coverage, 9008,
     /* 431646 */     GIR_Done,
     /* 431647 */   // Label 8605: @431647
     /* 431647 */   GIM_Reject,
     /* 431648 */ // Label 8603: @431648
     /* 431648 */ GIM_Reject,
     /* 431649 */ // Label 8573: @431649
     /* 431649 */ GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(431674), // Rule ID 9031 //
     /* 431654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 431660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 431663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 431667 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 431667 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 431672 */   GIR_RootConstrainSelectedInstOperands,
     /* 431673 */   // GIR_Coverage, 9031,
     /* 431673 */   GIR_Done,
     /* 431674 */ // Label 8606: @431674
     /* 431674 */ GIM_Reject,
     /* 431675 */ // Label 8574: @431675
     /* 431675 */ GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(431721),
     /* 431680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 431683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 431686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431690 */   GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(431705), // Rule ID 9003 //
     /* 431695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431698 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 431698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 431703 */     GIR_RootConstrainSelectedInstOperands,
     /* 431704 */     // GIR_Coverage, 9003,
     /* 431704 */     GIR_Done,
     /* 431705 */   // Label 8608: @431705
     /* 431705 */   GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(431720), // Rule ID 9006 //
     /* 431710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431713 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 431713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 431718 */     GIR_RootConstrainSelectedInstOperands,
     /* 431719 */     // GIR_Coverage, 9006,
     /* 431719 */     GIR_Done,
     /* 431720 */   // Label 8609: @431720
     /* 431720 */   GIM_Reject,
     /* 431721 */ // Label 8607: @431721
     /* 431721 */ GIM_Reject,
     /* 431722 */ // Label 8575: @431722
     /* 431722 */ GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(431747), // Rule ID 2414 //
     /* 431727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 431733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 431736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 431740 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 431740 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 431745 */   GIR_RootConstrainSelectedInstOperands,
     /* 431746 */   // GIR_Coverage, 2414,
     /* 431746 */   GIR_Done,
     /* 431747 */ // Label 8610: @431747
     /* 431747 */ GIM_Reject,
     /* 431748 */ // Label 8576: @431748
     /* 431748 */ GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(431773), // Rule ID 9002 //
     /* 431753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 431756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 431759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 431762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 431766 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 431766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 431771 */   GIR_RootConstrainSelectedInstOperands,
     /* 431772 */   // GIR_Coverage, 9002,
     /* 431772 */   GIR_Done,
     /* 431773 */ // Label 8611: @431773
     /* 431773 */ GIM_Reject,
     /* 431774 */ // Label 8577: @431774
     /* 431774 */ GIM_Reject,
     /* 431775 */ // Label 142: @431775
     /* 431775 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8630*/ GIMT_Encode4(432554),
     /* 431786 */ /*GILLT_v2s32*//*Label 8612*/ GIMT_Encode4(431862),
     /* 431790 */ /*GILLT_v2s64*//*Label 8613*/ GIMT_Encode4(431917),
     /* 431794 */ /*GILLT_v4s16*//*Label 8614*/ GIMT_Encode4(431972),
     /* 431798 */ /*GILLT_v4s32*//*Label 8615*/ GIMT_Encode4(432027),
     /* 431802 */ /*GILLT_v8s8*//*Label 8616*/ GIMT_Encode4(432082),
     /* 431806 */ /*GILLT_v8s16*//*Label 8617*/ GIMT_Encode4(432116),
     /* 431810 */ /*GILLT_v16s8*//*Label 8618*/ GIMT_Encode4(432171), GIMT_Encode4(0),
     /* 431818 */ /*GILLT_nxv2s1*//*Label 8619*/ GIMT_Encode4(432205),
     /* 431822 */ /*GILLT_nxv2s16*//*Label 8620*/ GIMT_Encode4(432231),
     /* 431826 */ /*GILLT_nxv2s32*//*Label 8621*/ GIMT_Encode4(432257),
     /* 431830 */ /*GILLT_nxv2s64*//*Label 8622*/ GIMT_Encode4(432283),
     /* 431834 */ /*GILLT_nxv4s1*//*Label 8623*/ GIMT_Encode4(432330),
     /* 431838 */ /*GILLT_nxv4s16*//*Label 8624*/ GIMT_Encode4(432356),
     /* 431842 */ /*GILLT_nxv4s32*//*Label 8625*/ GIMT_Encode4(432382),
     /* 431846 */ /*GILLT_nxv8s1*//*Label 8626*/ GIMT_Encode4(432429),
     /* 431850 */ /*GILLT_nxv8s16*//*Label 8627*/ GIMT_Encode4(432455),
     /* 431854 */ /*GILLT_nxv16s1*//*Label 8628*/ GIMT_Encode4(432502),
     /* 431858 */ /*GILLT_nxv16s8*//*Label 8629*/ GIMT_Encode4(432528),
     /* 431862 */ // Label 8612: @431862
     /* 431862 */ GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(431916),
     /* 431867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 431870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 431873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431885 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(431900), // Rule ID 1881 //
     /* 431890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431893 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 431893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 431898 */     GIR_RootConstrainSelectedInstOperands,
     /* 431899 */     // GIR_Coverage, 1881,
     /* 431899 */     GIR_Done,
     /* 431900 */   // Label 8632: @431900
     /* 431900 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(431915), // Rule ID 5505 //
     /* 431905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431908 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 431908 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 431913 */     GIR_RootConstrainSelectedInstOperands,
     /* 431914 */     // GIR_Coverage, 5505,
     /* 431914 */     GIR_Done,
     /* 431915 */   // Label 8633: @431915
     /* 431915 */   GIM_Reject,
     /* 431916 */ // Label 8631: @431916
     /* 431916 */ GIM_Reject,
     /* 431917 */ // Label 8613: @431917
     /* 431917 */ GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(431971),
     /* 431922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 431925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 431928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431940 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(431955), // Rule ID 1883 //
     /* 431945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431948 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 431948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 431953 */     GIR_RootConstrainSelectedInstOperands,
     /* 431954 */     // GIR_Coverage, 1883,
     /* 431954 */     GIR_Done,
     /* 431955 */   // Label 8635: @431955
     /* 431955 */   GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(431970), // Rule ID 5507 //
     /* 431960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431963 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 431963 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 431968 */     GIR_RootConstrainSelectedInstOperands,
     /* 431969 */     // GIR_Coverage, 5507,
     /* 431969 */     GIR_Done,
     /* 431970 */   // Label 8636: @431970
     /* 431970 */   GIM_Reject,
     /* 431971 */ // Label 8634: @431971
     /* 431971 */ GIM_Reject,
     /* 431972 */ // Label 8614: @431972
     /* 431972 */ GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(432026),
     /* 431977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 431980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 431983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431995 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(432010), // Rule ID 1879 //
     /* 432000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432003 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 432003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 432008 */     GIR_RootConstrainSelectedInstOperands,
     /* 432009 */     // GIR_Coverage, 1879,
     /* 432009 */     GIR_Done,
     /* 432010 */   // Label 8638: @432010
     /* 432010 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(432025), // Rule ID 5503 //
     /* 432015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432018 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 432018 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 432023 */     GIR_RootConstrainSelectedInstOperands,
     /* 432024 */     // GIR_Coverage, 5503,
     /* 432024 */     GIR_Done,
     /* 432025 */   // Label 8639: @432025
     /* 432025 */   GIM_Reject,
     /* 432026 */ // Label 8637: @432026
     /* 432026 */ GIM_Reject,
     /* 432027 */ // Label 8615: @432027
     /* 432027 */ GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(432081),
     /* 432032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 432038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432050 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(432065), // Rule ID 1882 //
     /* 432055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432058 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 432058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 432063 */     GIR_RootConstrainSelectedInstOperands,
     /* 432064 */     // GIR_Coverage, 1882,
     /* 432064 */     GIR_Done,
     /* 432065 */   // Label 8641: @432065
     /* 432065 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(432080), // Rule ID 5506 //
     /* 432070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432073 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 432073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 432078 */     GIR_RootConstrainSelectedInstOperands,
     /* 432079 */     // GIR_Coverage, 5506,
     /* 432079 */     GIR_Done,
     /* 432080 */   // Label 8642: @432080
     /* 432080 */   GIM_Reject,
     /* 432081 */ // Label 8640: @432081
     /* 432081 */ GIM_Reject,
     /* 432082 */ // Label 8616: @432082
     /* 432082 */ GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(432115), // Rule ID 1877 //
     /* 432087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 432093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 432096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432108 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 432108 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 432113 */   GIR_RootConstrainSelectedInstOperands,
     /* 432114 */   // GIR_Coverage, 1877,
     /* 432114 */   GIR_Done,
     /* 432115 */ // Label 8643: @432115
     /* 432115 */ GIM_Reject,
     /* 432116 */ // Label 8617: @432116
     /* 432116 */ GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(432170),
     /* 432121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 432127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432139 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(432154), // Rule ID 1880 //
     /* 432144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432147 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 432147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 432152 */     GIR_RootConstrainSelectedInstOperands,
     /* 432153 */     // GIR_Coverage, 1880,
     /* 432153 */     GIR_Done,
     /* 432154 */   // Label 8645: @432154
     /* 432154 */   GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(432169), // Rule ID 5504 //
     /* 432159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432162 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 432162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 432167 */     GIR_RootConstrainSelectedInstOperands,
     /* 432168 */     // GIR_Coverage, 5504,
     /* 432168 */     GIR_Done,
     /* 432169 */   // Label 8646: @432169
     /* 432169 */   GIM_Reject,
     /* 432170 */ // Label 8644: @432170
     /* 432170 */ GIM_Reject,
     /* 432171 */ // Label 8618: @432171
     /* 432171 */ GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(432204), // Rule ID 1878 //
     /* 432176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 432182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 432185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432197 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 432197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 432202 */   GIR_RootConstrainSelectedInstOperands,
     /* 432203 */   // GIR_Coverage, 1878,
     /* 432203 */   GIR_Done,
     /* 432204 */ // Label 8647: @432204
     /* 432204 */ GIM_Reject,
     /* 432205 */ // Label 8619: @432205
     /* 432205 */ GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(432230), // Rule ID 9036 //
     /* 432210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 432216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 432219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 432223 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 432223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 432228 */   GIR_RootConstrainSelectedInstOperands,
     /* 432229 */   // GIR_Coverage, 9036,
     /* 432229 */   GIR_Done,
     /* 432230 */ // Label 8648: @432230
     /* 432230 */ GIM_Reject,
     /* 432231 */ // Label 8620: @432231
     /* 432231 */ GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(432256), // Rule ID 9019 //
     /* 432236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 432242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 432245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432249 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 432249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 432254 */   GIR_RootConstrainSelectedInstOperands,
     /* 432255 */   // GIR_Coverage, 9019,
     /* 432255 */   GIR_Done,
     /* 432256 */ // Label 8649: @432256
     /* 432256 */ GIM_Reject,
     /* 432257 */ // Label 8621: @432257
     /* 432257 */ GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(432282), // Rule ID 9020 //
     /* 432262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 432268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 432271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432275 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 432275 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 432280 */   GIR_RootConstrainSelectedInstOperands,
     /* 432281 */   // GIR_Coverage, 9020,
     /* 432281 */   GIR_Done,
     /* 432282 */ // Label 8650: @432282
     /* 432282 */ GIM_Reject,
     /* 432283 */ // Label 8622: @432283
     /* 432283 */ GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(432329),
     /* 432288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 432291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 432294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432298 */   GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(432313), // Rule ID 9015 //
     /* 432303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432306 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 432306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 432311 */     GIR_RootConstrainSelectedInstOperands,
     /* 432312 */     // GIR_Coverage, 9015,
     /* 432312 */     GIR_Done,
     /* 432313 */   // Label 8652: @432313
     /* 432313 */   GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(432328), // Rule ID 9021 //
     /* 432318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432321 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 432321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 432326 */     GIR_RootConstrainSelectedInstOperands,
     /* 432327 */     // GIR_Coverage, 9021,
     /* 432327 */     GIR_Done,
     /* 432328 */   // Label 8653: @432328
     /* 432328 */   GIM_Reject,
     /* 432329 */ // Label 8651: @432329
     /* 432329 */ GIM_Reject,
     /* 432330 */ // Label 8623: @432330
     /* 432330 */ GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(432355), // Rule ID 9035 //
     /* 432335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 432341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 432344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 432348 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 432348 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 432353 */   GIR_RootConstrainSelectedInstOperands,
     /* 432354 */   // GIR_Coverage, 9035,
     /* 432354 */   GIR_Done,
     /* 432355 */ // Label 8654: @432355
     /* 432355 */ GIM_Reject,
     /* 432356 */ // Label 8624: @432356
     /* 432356 */ GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(432381), // Rule ID 9017 //
     /* 432361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 432367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 432370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432374 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 432374 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 432379 */   GIR_RootConstrainSelectedInstOperands,
     /* 432380 */   // GIR_Coverage, 9017,
     /* 432380 */   GIR_Done,
     /* 432381 */ // Label 8655: @432381
     /* 432381 */ GIM_Reject,
     /* 432382 */ // Label 8625: @432382
     /* 432382 */ GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(432428),
     /* 432387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 432390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 432393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432397 */   GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(432412), // Rule ID 9014 //
     /* 432402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432405 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 432405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 432410 */     GIR_RootConstrainSelectedInstOperands,
     /* 432411 */     // GIR_Coverage, 9014,
     /* 432411 */     GIR_Done,
     /* 432412 */   // Label 8657: @432412
     /* 432412 */   GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(432427), // Rule ID 9018 //
     /* 432417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432420 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 432420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 432425 */     GIR_RootConstrainSelectedInstOperands,
     /* 432426 */     // GIR_Coverage, 9018,
     /* 432426 */     GIR_Done,
     /* 432427 */   // Label 8658: @432427
     /* 432427 */   GIM_Reject,
     /* 432428 */ // Label 8656: @432428
     /* 432428 */ GIM_Reject,
     /* 432429 */ // Label 8626: @432429
     /* 432429 */ GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(432454), // Rule ID 9034 //
     /* 432434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 432440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 432443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 432447 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 432447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 432452 */   GIR_RootConstrainSelectedInstOperands,
     /* 432453 */   // GIR_Coverage, 9034,
     /* 432453 */   GIR_Done,
     /* 432454 */ // Label 8659: @432454
     /* 432454 */ GIM_Reject,
     /* 432455 */ // Label 8627: @432455
     /* 432455 */ GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(432501),
     /* 432460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 432463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 432466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432470 */   GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(432485), // Rule ID 9013 //
     /* 432475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432478 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 432478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 432483 */     GIR_RootConstrainSelectedInstOperands,
     /* 432484 */     // GIR_Coverage, 9013,
     /* 432484 */     GIR_Done,
     /* 432485 */   // Label 8661: @432485
     /* 432485 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(432500), // Rule ID 9016 //
     /* 432490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432493 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 432493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 432498 */     GIR_RootConstrainSelectedInstOperands,
     /* 432499 */     // GIR_Coverage, 9016,
     /* 432499 */     GIR_Done,
     /* 432500 */   // Label 8662: @432500
     /* 432500 */   GIM_Reject,
     /* 432501 */ // Label 8660: @432501
     /* 432501 */ GIM_Reject,
     /* 432502 */ // Label 8628: @432502
     /* 432502 */ GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(432527), // Rule ID 2418 //
     /* 432507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 432513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 432516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 432520 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 432520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 432525 */   GIR_RootConstrainSelectedInstOperands,
     /* 432526 */   // GIR_Coverage, 2418,
     /* 432526 */   GIR_Done,
     /* 432527 */ // Label 8663: @432527
     /* 432527 */ GIM_Reject,
     /* 432528 */ // Label 8629: @432528
     /* 432528 */ GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(432553), // Rule ID 9012 //
     /* 432533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 432539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 432542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432546 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 432546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 432551 */   GIR_RootConstrainSelectedInstOperands,
     /* 432552 */   // GIR_Coverage, 9012,
     /* 432552 */   GIR_Done,
     /* 432553 */ // Label 8664: @432553
     /* 432553 */ GIM_Reject,
     /* 432554 */ // Label 8630: @432554
     /* 432554 */ GIM_Reject,
     /* 432555 */ // Label 143: @432555
     /* 432555 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8671*/ GIMT_Encode4(432760),
     /* 432566 */ /*GILLT_s64*//*Label 8665*/ GIMT_Encode4(432598), GIMT_Encode4(0),
     /* 432574 */ /*GILLT_v2s32*//*Label 8666*/ GIMT_Encode4(432625),
     /* 432578 */ /*GILLT_v2s64*//*Label 8667*/ GIMT_Encode4(432652),
     /* 432582 */ /*GILLT_v4s16*//*Label 8668*/ GIMT_Encode4(432679),
     /* 432586 */ /*GILLT_v4s32*//*Label 8669*/ GIMT_Encode4(432706), GIMT_Encode4(0),
     /* 432594 */ /*GILLT_v8s16*//*Label 8670*/ GIMT_Encode4(432733),
     /* 432598 */ // Label 8665: @432598
     /* 432598 */ GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(432624), // Rule ID 1069 //
     /* 432603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 432609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432617 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 432617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 432622 */   GIR_RootConstrainSelectedInstOperands,
     /* 432623 */   // GIR_Coverage, 1069,
     /* 432623 */   GIR_Done,
     /* 432624 */ // Label 8672: @432624
     /* 432624 */ GIM_Reject,
     /* 432625 */ // Label 8666: @432625
     /* 432625 */ GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(432651), // Rule ID 1065 //
     /* 432630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 432636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432644 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 432644 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 432649 */   GIR_RootConstrainSelectedInstOperands,
     /* 432650 */   // GIR_Coverage, 1065,
     /* 432650 */   GIR_Done,
     /* 432651 */ // Label 8673: @432651
     /* 432651 */ GIM_Reject,
     /* 432652 */ // Label 8667: @432652
     /* 432652 */ GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(432678), // Rule ID 1071 //
     /* 432657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432671 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 432671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 432676 */   GIR_RootConstrainSelectedInstOperands,
     /* 432677 */   // GIR_Coverage, 1071,
     /* 432677 */   GIR_Done,
     /* 432678 */ // Label 8674: @432678
     /* 432678 */ GIM_Reject,
     /* 432679 */ // Label 8668: @432679
     /* 432679 */ GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(432705), // Rule ID 1061 //
     /* 432684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 432690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432698 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 432698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 432703 */   GIR_RootConstrainSelectedInstOperands,
     /* 432704 */   // GIR_Coverage, 1061,
     /* 432704 */   GIR_Done,
     /* 432705 */ // Label 8675: @432705
     /* 432705 */ GIM_Reject,
     /* 432706 */ // Label 8669: @432706
     /* 432706 */ GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(432732), // Rule ID 1067 //
     /* 432711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432725 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 432725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 432730 */   GIR_RootConstrainSelectedInstOperands,
     /* 432731 */   // GIR_Coverage, 1067,
     /* 432731 */   GIR_Done,
     /* 432732 */ // Label 8676: @432732
     /* 432732 */ GIM_Reject,
     /* 432733 */ // Label 8670: @432733
     /* 432733 */ GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(432759), // Rule ID 1063 //
     /* 432738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 432744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432752 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 432752 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 432757 */   GIR_RootConstrainSelectedInstOperands,
     /* 432758 */   // GIR_Coverage, 1063,
     /* 432758 */   GIR_Done,
     /* 432759 */ // Label 8677: @432759
     /* 432759 */ GIM_Reject,
     /* 432760 */ // Label 8671: @432760
     /* 432760 */ GIM_Reject,
     /* 432761 */ // Label 144: @432761
     /* 432761 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8680*/ GIMT_Encode4(433627),
     /* 432772 */ /*GILLT_v2s64*//*Label 8678*/ GIMT_Encode4(432784), GIMT_Encode4(0),
     /* 432780 */ /*GILLT_v4s32*//*Label 8679*/ GIMT_Encode4(433078),
     /* 432784 */ // Label 8678: @432784
     /* 432784 */ GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(432866), // Rule ID 5912 //
     /* 432789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432796 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432800 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 432804 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 432807 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 432812 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 432816 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432821 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 432823 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 432823 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 432826 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 432830 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432835 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 432839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432849 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 432855 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432860 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 432865 */   // GIR_Coverage, 5912,
     /* 432865 */   GIR_EraseRootFromParent_Done,
     /* 432866 */ // Label 8681: @432866
     /* 432866 */ GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(432940), // Rule ID 5911 //
     /* 432871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432878 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 432882 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 432886 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432890 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432895 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 432897 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 432897 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 432900 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 432904 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432909 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 432913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432923 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 432929 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432934 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 432939 */   // GIR_Coverage, 5911,
     /* 432939 */   GIR_EraseRootFromParent_Done,
     /* 432940 */ // Label 8682: @432940
     /* 432940 */ GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(432999), // Rule ID 5921 //
     /* 432945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432956 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 432956 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 432959 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 432963 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 432968 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 432972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 432974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 432977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 432979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 432982 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 432985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 432988 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432993 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432998 */   // GIR_Coverage, 5921,
     /* 432998 */   GIR_EraseRootFromParent_Done,
     /* 432999 */ // Label 8683: @432999
     /* 432999 */ GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(433077), // Rule ID 6049 //
     /* 433004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 433007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433015 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 433015 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 433018 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 433022 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433027 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 433031 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 433033 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 433036 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 433040 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 433050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433052 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433055 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 433058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 433061 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433066 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433076 */   // GIR_Coverage, 6049,
     /* 433076 */   GIR_EraseRootFromParent_Done,
     /* 433077 */ // Label 8684: @433077
     /* 433077 */ GIM_Reject,
     /* 433078 */ // Label 8679: @433078
     /* 433078 */ GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(433160), // Rule ID 5914 //
     /* 433083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433090 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433094 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 433098 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 433101 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 433106 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 433110 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433115 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433117 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 433117 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 433120 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 433124 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433129 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 433133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433143 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 433149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433154 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433159 */   // GIR_Coverage, 5914,
     /* 433159 */   GIR_EraseRootFromParent_Done,
     /* 433160 */ // Label 8685: @433160
     /* 433160 */ GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(433242), // Rule ID 5916 //
     /* 433165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 433168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433172 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433176 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 433180 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 433183 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 433188 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 433192 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433197 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433199 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 433199 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 433202 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 433206 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433211 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 433215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 433231 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433236 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433241 */   // GIR_Coverage, 5916,
     /* 433241 */   GIR_EraseRootFromParent_Done,
     /* 433242 */ // Label 8686: @433242
     /* 433242 */ GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(433316), // Rule ID 5913 //
     /* 433247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433254 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433258 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 433262 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 433266 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433271 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433273 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 433273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 433276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 433280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433285 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 433289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433299 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 433305 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433310 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433315 */   // GIR_Coverage, 5913,
     /* 433315 */   GIR_EraseRootFromParent_Done,
     /* 433316 */ // Label 8687: @433316
     /* 433316 */ GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(433390), // Rule ID 5915 //
     /* 433321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 433324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433328 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433332 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 433336 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 433340 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433345 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433347 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 433347 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 433350 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 433354 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433359 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 433363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433373 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 433379 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433384 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433389 */   // GIR_Coverage, 5915,
     /* 433389 */   GIR_EraseRootFromParent_Done,
     /* 433390 */ // Label 8688: @433390
     /* 433390 */ GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(433449), // Rule ID 5917 //
     /* 433395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 433398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433406 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 433406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 433409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 433413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433418 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 433422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433432 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 433438 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433443 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433448 */   // GIR_Coverage, 5917,
     /* 433448 */   GIR_EraseRootFromParent_Done,
     /* 433449 */ // Label 8689: @433449
     /* 433449 */ GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(433508), // Rule ID 5918 //
     /* 433454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 433457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433465 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 433465 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 433468 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 433472 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433477 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 433481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433491 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 433497 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433502 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 433507 */   // GIR_Coverage, 5918,
     /* 433507 */   GIR_EraseRootFromParent_Done,
     /* 433508 */ // Label 8690: @433508
     /* 433508 */ GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(433567), // Rule ID 5919 //
     /* 433513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 433516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433524 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 433524 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 433527 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 433531 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433536 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 433540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433550 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 433556 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433561 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 433566 */   // GIR_Coverage, 5919,
     /* 433566 */   GIR_EraseRootFromParent_Done,
     /* 433567 */ // Label 8691: @433567
     /* 433567 */ GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(433626), // Rule ID 5920 //
     /* 433572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433583 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 433583 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 433586 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 433590 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433595 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 433599 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433609 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 433615 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433620 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 433625 */   // GIR_Coverage, 5920,
     /* 433625 */   GIR_EraseRootFromParent_Done,
     /* 433626 */ // Label 8692: @433626
     /* 433626 */ GIM_Reject,
     /* 433627 */ // Label 8680: @433627
     /* 433627 */ GIM_Reject,
     /* 433628 */ // Label 145: @433628
     /* 433628 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8697*/ GIMT_Encode4(433997),
     /* 433639 */ /*GILLT_v2s32*//*Label 8693*/ GIMT_Encode4(433699), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 433651 */ /*GILLT_v4s32*//*Label 8694*/ GIMT_Encode4(433819), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 433683 */ /*GILLT_nxv2s64*//*Label 8695*/ GIMT_Encode4(433939), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 433695 */ /*GILLT_nxv4s32*//*Label 8696*/ GIMT_Encode4(433968),
     /* 433699 */ // Label 8693: @433699
     /* 433699 */ GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(433818),
     /* 433704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 433707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 433710 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 433713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433725 */   GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(433798), // Rule ID 28 //
     /* 433730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 433733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 433737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 433741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 433745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433774 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433778 */     // MIs[3] Operand 1
     /* 433778 */     // No operand predicates
     /* 433778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433780 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 433783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 433787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 433789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433796 */     GIR_RootConstrainSelectedInstOperands,
     /* 433797 */     // GIR_Coverage, 28,
     /* 433797 */     GIR_EraseRootFromParent_Done,
     /* 433798 */   // Label 8699: @433798
     /* 433798 */   GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(433817), // Rule ID 24 //
     /* 433803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 433806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433810 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 433810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 433815 */     GIR_RootConstrainSelectedInstOperands,
     /* 433816 */     // GIR_Coverage, 24,
     /* 433816 */     GIR_Done,
     /* 433817 */   // Label 8700: @433817
     /* 433817 */   GIM_Reject,
     /* 433818 */ // Label 8698: @433818
     /* 433818 */ GIM_Reject,
     /* 433819 */ // Label 8694: @433819
     /* 433819 */ GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(433938),
     /* 433824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 433830 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 433833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433845 */   GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(433918), // Rule ID 29 //
     /* 433850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 433853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 433857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 433861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 433869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 433873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 433881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 433890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 433894 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 433898 */     // MIs[3] Operand 1
     /* 433898 */     // No operand predicates
     /* 433898 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 433900 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 433900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 433903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 433907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 433909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 433913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 433916 */     GIR_RootConstrainSelectedInstOperands,
     /* 433917 */     // GIR_Coverage, 29,
     /* 433917 */     GIR_EraseRootFromParent_Done,
     /* 433918 */   // Label 8702: @433918
     /* 433918 */   GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(433937), // Rule ID 25 //
     /* 433923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 433926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433930 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 433930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 433935 */     GIR_RootConstrainSelectedInstOperands,
     /* 433936 */     // GIR_Coverage, 25,
     /* 433936 */     GIR_Done,
     /* 433937 */   // Label 8703: @433937
     /* 433937 */   GIM_Reject,
     /* 433938 */ // Label 8701: @433938
     /* 433938 */ GIM_Reject,
     /* 433939 */ // Label 8695: @433939
     /* 433939 */ GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(433967), // Rule ID 7719 //
     /* 433944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 433950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 433953 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 433956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433960 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 433960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 433965 */   GIR_RootConstrainSelectedInstOperands,
     /* 433966 */   // GIR_Coverage, 7719,
     /* 433966 */   GIR_Done,
     /* 433967 */ // Label 8704: @433967
     /* 433967 */ GIM_Reject,
     /* 433968 */ // Label 8696: @433968
     /* 433968 */ GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(433996), // Rule ID 7718 //
     /* 433973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 433979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 433982 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 433985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433989 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 433989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 433994 */   GIR_RootConstrainSelectedInstOperands,
     /* 433995 */   // GIR_Coverage, 7718,
     /* 433995 */   GIR_Done,
     /* 433996 */ // Label 8705: @433996
     /* 433996 */ GIM_Reject,
     /* 433997 */ // Label 8697: @433997
     /* 433997 */ GIM_Reject,
     /* 433998 */ // Label 146: @433998
     /* 433998 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8709*/ GIMT_Encode4(434114),
     /* 434009 */ /*GILLT_s16*//*Label 8706*/ GIMT_Encode4(434021),
     /* 434013 */ /*GILLT_s32*//*Label 8707*/ GIMT_Encode4(434052),
     /* 434017 */ /*GILLT_s64*//*Label 8708*/ GIMT_Encode4(434083),
     /* 434021 */ // Label 8706: @434021
     /* 434021 */ GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(434051), // Rule ID 1669 //
     /* 434026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 434029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 434032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 434036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 434040 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 434040 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 434045 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 434049 */   GIR_RootConstrainSelectedInstOperands,
     /* 434050 */   // GIR_Coverage, 1669,
     /* 434050 */   GIR_Done,
     /* 434051 */ // Label 8710: @434051
     /* 434051 */ GIM_Reject,
     /* 434052 */ // Label 8707: @434052
     /* 434052 */ GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(434082), // Rule ID 1668 //
     /* 434057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 434060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 434063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 434067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 434071 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 434071 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 434076 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 434080 */   GIR_RootConstrainSelectedInstOperands,
     /* 434081 */   // GIR_Coverage, 1668,
     /* 434081 */   GIR_Done,
     /* 434082 */ // Label 8711: @434082
     /* 434082 */ GIM_Reject,
     /* 434083 */ // Label 8708: @434083
     /* 434083 */ GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(434113), // Rule ID 1667 //
     /* 434088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 434091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 434094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434102 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 434102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 434107 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 434111 */   GIR_RootConstrainSelectedInstOperands,
     /* 434112 */   // GIR_Coverage, 1667,
     /* 434112 */   GIR_Done,
     /* 434113 */ // Label 8712: @434113
     /* 434113 */ GIM_Reject,
     /* 434114 */ // Label 8709: @434114
     /* 434114 */ GIM_Reject,
     /* 434115 */ // Label 147: @434115
     /* 434115 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8716*/ GIMT_Encode4(435347),
     /* 434126 */ /*GILLT_v2s64*//*Label 8713*/ GIMT_Encode4(434146), GIMT_Encode4(0),
     /* 434134 */ /*GILLT_v4s32*//*Label 8714*/ GIMT_Encode4(434707), GIMT_Encode4(0),
     /* 434142 */ /*GILLT_v8s16*//*Label 8715*/ GIMT_Encode4(435268),
     /* 434146 */ // Label 8713: @434146
     /* 434146 */ GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(434706),
     /* 434151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 434154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 434157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434161 */   GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(434253), // Rule ID 2106 //
     /* 434166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 434173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 434189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434210 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 434214 */     // MIs[3] Operand 1
     /* 434214 */     // No operand predicates
     /* 434214 */     // MIs[1] Operand 2
     /* 434214 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 434225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 434234 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 434237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434251 */     GIR_RootConstrainSelectedInstOperands,
     /* 434252 */     // GIR_Coverage, 2106,
     /* 434252 */     GIR_EraseRootFromParent_Done,
     /* 434253 */   // Label 8718: @434253
     /* 434253 */   GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(434345), // Rule ID 13612 //
     /* 434258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 434281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434302 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 434306 */     // MIs[3] Operand 1
     /* 434306 */     // No operand predicates
     /* 434306 */     // MIs[1] Operand 2
     /* 434306 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 434317 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 434326 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 434329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434343 */     GIR_RootConstrainSelectedInstOperands,
     /* 434344 */     // GIR_Coverage, 13612,
     /* 434344 */     GIR_EraseRootFromParent_Done,
     /* 434345 */   // Label 8719: @434345
     /* 434345 */   GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(434431), // Rule ID 13610 //
     /* 434350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 434373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434394 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 434398 */     // MIs[3] Operand 1
     /* 434398 */     // No operand predicates
     /* 434398 */     // MIs[1] Operand 2
     /* 434398 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 434409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434413 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434415 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 434418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 434422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434429 */     GIR_RootConstrainSelectedInstOperands,
     /* 434430 */     // GIR_Coverage, 13610,
     /* 434430 */     GIR_EraseRootFromParent_Done,
     /* 434431 */   // Label 8720: @434431
     /* 434431 */   GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(434517), // Rule ID 2104 //
     /* 434436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 434447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 434463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434484 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 434488 */     // MIs[3] Operand 1
     /* 434488 */     // No operand predicates
     /* 434488 */     // MIs[1] Operand 2
     /* 434488 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 434499 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434501 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 434504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434506 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 434508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434515 */     GIR_RootConstrainSelectedInstOperands,
     /* 434516 */     // GIR_Coverage, 2104,
     /* 434516 */     GIR_EraseRootFromParent_Done,
     /* 434517 */   // Label 8721: @434517
     /* 434517 */   GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(434556), // Rule ID 1831 //
     /* 434522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 434532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 434539 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 434539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 434542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 434554 */     GIR_RootConstrainSelectedInstOperands,
     /* 434555 */     // GIR_Coverage, 1831,
     /* 434555 */     GIR_EraseRootFromParent_Done,
     /* 434556 */   // Label 8722: @434556
     /* 434556 */   GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(434619), // Rule ID 13611 //
     /* 434561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 434572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 434580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 434589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434593 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 434597 */     // MIs[2] Operand 1
     /* 434597 */     // No operand predicates
     /* 434597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 434603 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 434606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 434610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 434614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 434617 */     GIR_RootConstrainSelectedInstOperands,
     /* 434618 */     // GIR_Coverage, 13611,
     /* 434618 */     GIR_EraseRootFromParent_Done,
     /* 434619 */   // Label 8723: @434619
     /* 434619 */   GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(434682), // Rule ID 2105 //
     /* 434624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 434635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 434639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 434647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 434656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434660 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 434664 */     // MIs[2] Operand 1
     /* 434664 */     // No operand predicates
     /* 434664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 434666 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 434669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 434673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 434677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 434680 */     GIR_RootConstrainSelectedInstOperands,
     /* 434681 */     // GIR_Coverage, 2105,
     /* 434681 */     GIR_EraseRootFromParent_Done,
     /* 434682 */   // Label 8724: @434682
     /* 434682 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(434705), // Rule ID 1830 //
     /* 434687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434698 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 434698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 434703 */     GIR_RootConstrainSelectedInstOperands,
     /* 434704 */     // GIR_Coverage, 1830,
     /* 434704 */     GIR_Done,
     /* 434705 */   // Label 8725: @434705
     /* 434705 */   GIM_Reject,
     /* 434706 */ // Label 8717: @434706
     /* 434706 */ GIM_Reject,
     /* 434707 */ // Label 8714: @434707
     /* 434707 */ GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(435267),
     /* 434712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 434715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 434718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434722 */   GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(434814), // Rule ID 2103 //
     /* 434727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 434734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434754 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434758 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434771 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434775 */     // MIs[3] Operand 1
     /* 434775 */     // No operand predicates
     /* 434775 */     // MIs[1] Operand 2
     /* 434775 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 434786 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 434795 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 434798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434812 */     GIR_RootConstrainSelectedInstOperands,
     /* 434813 */     // GIR_Coverage, 2103,
     /* 434813 */     GIR_EraseRootFromParent_Done,
     /* 434814 */   // Label 8727: @434814
     /* 434814 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(434906), // Rule ID 13609 //
     /* 434819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434863 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434867 */     // MIs[3] Operand 1
     /* 434867 */     // No operand predicates
     /* 434867 */     // MIs[1] Operand 2
     /* 434867 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 434878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 434887 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 434890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 434897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434904 */     GIR_RootConstrainSelectedInstOperands,
     /* 434905 */     // GIR_Coverage, 13609,
     /* 434905 */     GIR_EraseRootFromParent_Done,
     /* 434906 */   // Label 8728: @434906
     /* 434906 */   GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(434992), // Rule ID 13607 //
     /* 434911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 434914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 434922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 434934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434938 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 434947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434955 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 434959 */     // MIs[3] Operand 1
     /* 434959 */     // No operand predicates
     /* 434959 */     // MIs[1] Operand 2
     /* 434959 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 434970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434976 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 434979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 434981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 434983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434990 */     GIR_RootConstrainSelectedInstOperands,
     /* 434991 */     // GIR_Coverage, 13607,
     /* 434991 */     GIR_EraseRootFromParent_Done,
     /* 434992 */   // Label 8729: @434992
     /* 434992 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(435078), // Rule ID 2101 //
     /* 434997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 435008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 435024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435028 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 435037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435045 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 435049 */     // MIs[3] Operand 1
     /* 435049 */     // No operand predicates
     /* 435049 */     // MIs[1] Operand 2
     /* 435049 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 435060 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435062 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 435065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 435069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435076 */     GIR_RootConstrainSelectedInstOperands,
     /* 435077 */     // GIR_Coverage, 2101,
     /* 435077 */     GIR_EraseRootFromParent_Done,
     /* 435078 */   // Label 8730: @435078
     /* 435078 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(435117), // Rule ID 1829 //
     /* 435083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 435093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 435100 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 435100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 435103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 435110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 435115 */     GIR_RootConstrainSelectedInstOperands,
     /* 435116 */     // GIR_Coverage, 1829,
     /* 435116 */     GIR_EraseRootFromParent_Done,
     /* 435117 */   // Label 8731: @435117
     /* 435117 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(435180), // Rule ID 13608 //
     /* 435122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 435133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 435141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 435146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 435150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435154 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 435158 */     // MIs[2] Operand 1
     /* 435158 */     // No operand predicates
     /* 435158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 435164 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 435167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 435171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 435175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 435178 */     GIR_RootConstrainSelectedInstOperands,
     /* 435179 */     // GIR_Coverage, 13608,
     /* 435179 */     GIR_EraseRootFromParent_Done,
     /* 435180 */   // Label 8732: @435180
     /* 435180 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(435243), // Rule ID 2102 //
     /* 435185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 435196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 435200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 435208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 435213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 435217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435221 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 435225 */     // MIs[2] Operand 1
     /* 435225 */     // No operand predicates
     /* 435225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 435227 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 435230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 435234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 435238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 435241 */     GIR_RootConstrainSelectedInstOperands,
     /* 435242 */     // GIR_Coverage, 2102,
     /* 435242 */     GIR_EraseRootFromParent_Done,
     /* 435243 */   // Label 8733: @435243
     /* 435243 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(435266), // Rule ID 1828 //
     /* 435248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435259 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 435259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 435264 */     GIR_RootConstrainSelectedInstOperands,
     /* 435265 */     // GIR_Coverage, 1828,
     /* 435265 */     GIR_Done,
     /* 435266 */   // Label 8734: @435266
     /* 435266 */   GIM_Reject,
     /* 435267 */ // Label 8726: @435267
     /* 435267 */ GIM_Reject,
     /* 435268 */ // Label 8715: @435268
     /* 435268 */ GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(435346),
     /* 435273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 435276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 435279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435283 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(435322), // Rule ID 1827 //
     /* 435288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 435298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 435305 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 435305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 435308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 435315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 435320 */     GIR_RootConstrainSelectedInstOperands,
     /* 435321 */     // GIR_Coverage, 1827,
     /* 435321 */     GIR_EraseRootFromParent_Done,
     /* 435322 */   // Label 8736: @435322
     /* 435322 */   GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(435345), // Rule ID 1826 //
     /* 435327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435338 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 435338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 435343 */     GIR_RootConstrainSelectedInstOperands,
     /* 435344 */     // GIR_Coverage, 1826,
     /* 435344 */     GIR_Done,
     /* 435345 */   // Label 8737: @435345
     /* 435345 */   GIM_Reject,
     /* 435346 */ // Label 8735: @435346
     /* 435346 */ GIM_Reject,
     /* 435347 */ // Label 8716: @435347
     /* 435347 */ GIM_Reject,
     /* 435348 */ // Label 148: @435348
     /* 435348 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8756*/ GIMT_Encode4(436127),
     /* 435359 */ /*GILLT_v2s32*//*Label 8738*/ GIMT_Encode4(435435),
     /* 435363 */ /*GILLT_v2s64*//*Label 8739*/ GIMT_Encode4(435490),
     /* 435367 */ /*GILLT_v4s16*//*Label 8740*/ GIMT_Encode4(435545),
     /* 435371 */ /*GILLT_v4s32*//*Label 8741*/ GIMT_Encode4(435600),
     /* 435375 */ /*GILLT_v8s8*//*Label 8742*/ GIMT_Encode4(435655),
     /* 435379 */ /*GILLT_v8s16*//*Label 8743*/ GIMT_Encode4(435689),
     /* 435383 */ /*GILLT_v16s8*//*Label 8744*/ GIMT_Encode4(435744), GIMT_Encode4(0),
     /* 435391 */ /*GILLT_nxv2s1*//*Label 8745*/ GIMT_Encode4(435778),
     /* 435395 */ /*GILLT_nxv2s16*//*Label 8746*/ GIMT_Encode4(435804),
     /* 435399 */ /*GILLT_nxv2s32*//*Label 8747*/ GIMT_Encode4(435830),
     /* 435403 */ /*GILLT_nxv2s64*//*Label 8748*/ GIMT_Encode4(435856),
     /* 435407 */ /*GILLT_nxv4s1*//*Label 8749*/ GIMT_Encode4(435903),
     /* 435411 */ /*GILLT_nxv4s16*//*Label 8750*/ GIMT_Encode4(435929),
     /* 435415 */ /*GILLT_nxv4s32*//*Label 8751*/ GIMT_Encode4(435955),
     /* 435419 */ /*GILLT_nxv8s1*//*Label 8752*/ GIMT_Encode4(436002),
     /* 435423 */ /*GILLT_nxv8s16*//*Label 8753*/ GIMT_Encode4(436028),
     /* 435427 */ /*GILLT_nxv16s1*//*Label 8754*/ GIMT_Encode4(436075),
     /* 435431 */ /*GILLT_nxv16s8*//*Label 8755*/ GIMT_Encode4(436101),
     /* 435435 */ // Label 8738: @435435
     /* 435435 */ GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(435489),
     /* 435440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 435443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 435446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435454 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435458 */   GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(435473), // Rule ID 1888 //
     /* 435463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435466 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 435466 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 435471 */     GIR_RootConstrainSelectedInstOperands,
     /* 435472 */     // GIR_Coverage, 1888,
     /* 435472 */     GIR_Done,
     /* 435473 */   // Label 8758: @435473
     /* 435473 */   GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(435488), // Rule ID 5510 //
     /* 435478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435481 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 435481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 435486 */     GIR_RootConstrainSelectedInstOperands,
     /* 435487 */     // GIR_Coverage, 5510,
     /* 435487 */     GIR_Done,
     /* 435488 */   // Label 8759: @435488
     /* 435488 */   GIM_Reject,
     /* 435489 */ // Label 8757: @435489
     /* 435489 */ GIM_Reject,
     /* 435490 */ // Label 8739: @435490
     /* 435490 */ GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(435544),
     /* 435495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 435498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 435501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435513 */   GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(435528), // Rule ID 1890 //
     /* 435518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435521 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 435521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 435526 */     GIR_RootConstrainSelectedInstOperands,
     /* 435527 */     // GIR_Coverage, 1890,
     /* 435527 */     GIR_Done,
     /* 435528 */   // Label 8761: @435528
     /* 435528 */   GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(435543), // Rule ID 5512 //
     /* 435533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435536 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 435536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 435541 */     GIR_RootConstrainSelectedInstOperands,
     /* 435542 */     // GIR_Coverage, 5512,
     /* 435542 */     GIR_Done,
     /* 435543 */   // Label 8762: @435543
     /* 435543 */   GIM_Reject,
     /* 435544 */ // Label 8760: @435544
     /* 435544 */ GIM_Reject,
     /* 435545 */ // Label 8740: @435545
     /* 435545 */ GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(435599),
     /* 435550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 435553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 435556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435568 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(435583), // Rule ID 1886 //
     /* 435573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435576 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 435576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 435581 */     GIR_RootConstrainSelectedInstOperands,
     /* 435582 */     // GIR_Coverage, 1886,
     /* 435582 */     GIR_Done,
     /* 435583 */   // Label 8764: @435583
     /* 435583 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(435598), // Rule ID 5508 //
     /* 435588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435591 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 435591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 435596 */     GIR_RootConstrainSelectedInstOperands,
     /* 435597 */     // GIR_Coverage, 5508,
     /* 435597 */     GIR_Done,
     /* 435598 */   // Label 8765: @435598
     /* 435598 */   GIM_Reject,
     /* 435599 */ // Label 8763: @435599
     /* 435599 */ GIM_Reject,
     /* 435600 */ // Label 8741: @435600
     /* 435600 */ GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(435654),
     /* 435605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 435611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435623 */   GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(435638), // Rule ID 1889 //
     /* 435628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435631 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 435631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 435636 */     GIR_RootConstrainSelectedInstOperands,
     /* 435637 */     // GIR_Coverage, 1889,
     /* 435637 */     GIR_Done,
     /* 435638 */   // Label 8767: @435638
     /* 435638 */   GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(435653), // Rule ID 5511 //
     /* 435643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435646 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 435646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 435651 */     GIR_RootConstrainSelectedInstOperands,
     /* 435652 */     // GIR_Coverage, 5511,
     /* 435652 */     GIR_Done,
     /* 435653 */   // Label 8768: @435653
     /* 435653 */   GIM_Reject,
     /* 435654 */ // Label 8766: @435654
     /* 435654 */ GIM_Reject,
     /* 435655 */ // Label 8742: @435655
     /* 435655 */ GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(435688), // Rule ID 1884 //
     /* 435660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 435666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 435669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435681 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 435681 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 435686 */   GIR_RootConstrainSelectedInstOperands,
     /* 435687 */   // GIR_Coverage, 1884,
     /* 435687 */   GIR_Done,
     /* 435688 */ // Label 8769: @435688
     /* 435688 */ GIM_Reject,
     /* 435689 */ // Label 8743: @435689
     /* 435689 */ GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(435743),
     /* 435694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 435700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435712 */   GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(435727), // Rule ID 1887 //
     /* 435717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435720 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 435720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 435725 */     GIR_RootConstrainSelectedInstOperands,
     /* 435726 */     // GIR_Coverage, 1887,
     /* 435726 */     GIR_Done,
     /* 435727 */   // Label 8771: @435727
     /* 435727 */   GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(435742), // Rule ID 5509 //
     /* 435732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435735 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 435735 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 435740 */     GIR_RootConstrainSelectedInstOperands,
     /* 435741 */     // GIR_Coverage, 5509,
     /* 435741 */     GIR_Done,
     /* 435742 */   // Label 8772: @435742
     /* 435742 */   GIM_Reject,
     /* 435743 */ // Label 8770: @435743
     /* 435743 */ GIM_Reject,
     /* 435744 */ // Label 8744: @435744
     /* 435744 */ GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(435777), // Rule ID 1885 //
     /* 435749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 435755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 435758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435770 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 435770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 435775 */   GIR_RootConstrainSelectedInstOperands,
     /* 435776 */   // GIR_Coverage, 1885,
     /* 435776 */   GIR_Done,
     /* 435777 */ // Label 8773: @435777
     /* 435777 */ GIM_Reject,
     /* 435778 */ // Label 8745: @435778
     /* 435778 */ GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(435803), // Rule ID 9027 //
     /* 435783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 435789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 435792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435796 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 435796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 435801 */   GIR_RootConstrainSelectedInstOperands,
     /* 435802 */   // GIR_Coverage, 9027,
     /* 435802 */   GIR_Done,
     /* 435803 */ // Label 8774: @435803
     /* 435803 */ GIM_Reject,
     /* 435804 */ // Label 8746: @435804
     /* 435804 */ GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(435829), // Rule ID 8989 //
     /* 435809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 435815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 435818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435822 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 435822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 435827 */   GIR_RootConstrainSelectedInstOperands,
     /* 435828 */   // GIR_Coverage, 8989,
     /* 435828 */   GIR_Done,
     /* 435829 */ // Label 8775: @435829
     /* 435829 */ GIM_Reject,
     /* 435830 */ // Label 8747: @435830
     /* 435830 */ GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(435855), // Rule ID 8990 //
     /* 435835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 435841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 435844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435848 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 435848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 435853 */   GIR_RootConstrainSelectedInstOperands,
     /* 435854 */   // GIR_Coverage, 8990,
     /* 435854 */   GIR_Done,
     /* 435855 */ // Label 8776: @435855
     /* 435855 */ GIM_Reject,
     /* 435856 */ // Label 8748: @435856
     /* 435856 */ GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(435902),
     /* 435861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 435864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 435867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435871 */   GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(435886), // Rule ID 8985 //
     /* 435876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435879 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 435879 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 435884 */     GIR_RootConstrainSelectedInstOperands,
     /* 435885 */     // GIR_Coverage, 8985,
     /* 435885 */     GIR_Done,
     /* 435886 */   // Label 8778: @435886
     /* 435886 */   GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(435901), // Rule ID 8991 //
     /* 435891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435894 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 435894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 435899 */     GIR_RootConstrainSelectedInstOperands,
     /* 435900 */     // GIR_Coverage, 8991,
     /* 435900 */     GIR_Done,
     /* 435901 */   // Label 8779: @435901
     /* 435901 */   GIM_Reject,
     /* 435902 */ // Label 8777: @435902
     /* 435902 */ GIM_Reject,
     /* 435903 */ // Label 8749: @435903
     /* 435903 */ GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(435928), // Rule ID 9026 //
     /* 435908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 435914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 435917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 435921 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 435921 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 435926 */   GIR_RootConstrainSelectedInstOperands,
     /* 435927 */   // GIR_Coverage, 9026,
     /* 435927 */   GIR_Done,
     /* 435928 */ // Label 8780: @435928
     /* 435928 */ GIM_Reject,
     /* 435929 */ // Label 8750: @435929
     /* 435929 */ GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(435954), // Rule ID 8987 //
     /* 435934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 435940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 435943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435947 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 435947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 435952 */   GIR_RootConstrainSelectedInstOperands,
     /* 435953 */   // GIR_Coverage, 8987,
     /* 435953 */   GIR_Done,
     /* 435954 */ // Label 8781: @435954
     /* 435954 */ GIM_Reject,
     /* 435955 */ // Label 8751: @435955
     /* 435955 */ GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(436001),
     /* 435960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 435963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 435966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 435970 */   GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(435985), // Rule ID 8984 //
     /* 435975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435978 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 435978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 435983 */     GIR_RootConstrainSelectedInstOperands,
     /* 435984 */     // GIR_Coverage, 8984,
     /* 435984 */     GIR_Done,
     /* 435985 */   // Label 8783: @435985
     /* 435985 */   GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(436000), // Rule ID 8988 //
     /* 435990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 435993 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 435993 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 435998 */     GIR_RootConstrainSelectedInstOperands,
     /* 435999 */     // GIR_Coverage, 8988,
     /* 435999 */     GIR_Done,
     /* 436000 */   // Label 8784: @436000
     /* 436000 */   GIM_Reject,
     /* 436001 */ // Label 8782: @436001
     /* 436001 */ GIM_Reject,
     /* 436002 */ // Label 8752: @436002
     /* 436002 */ GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(436027), // Rule ID 9025 //
     /* 436007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 436013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 436016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436020 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 436020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 436025 */   GIR_RootConstrainSelectedInstOperands,
     /* 436026 */   // GIR_Coverage, 9025,
     /* 436026 */   GIR_Done,
     /* 436027 */ // Label 8785: @436027
     /* 436027 */ GIM_Reject,
     /* 436028 */ // Label 8753: @436028
     /* 436028 */ GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(436074),
     /* 436033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 436036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 436039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436043 */   GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(436058), // Rule ID 8983 //
     /* 436048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436051 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 436051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 436056 */     GIR_RootConstrainSelectedInstOperands,
     /* 436057 */     // GIR_Coverage, 8983,
     /* 436057 */     GIR_Done,
     /* 436058 */   // Label 8787: @436058
     /* 436058 */   GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(436073), // Rule ID 8986 //
     /* 436063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436066 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 436066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 436071 */     GIR_RootConstrainSelectedInstOperands,
     /* 436072 */     // GIR_Coverage, 8986,
     /* 436072 */     GIR_Done,
     /* 436073 */   // Label 8788: @436073
     /* 436073 */   GIM_Reject,
     /* 436074 */ // Label 8786: @436074
     /* 436074 */ GIM_Reject,
     /* 436075 */ // Label 8754: @436075
     /* 436075 */ GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(436100), // Rule ID 2406 //
     /* 436080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 436086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 436089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436093 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 436093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 436098 */   GIR_RootConstrainSelectedInstOperands,
     /* 436099 */   // GIR_Coverage, 2406,
     /* 436099 */   GIR_Done,
     /* 436100 */ // Label 8789: @436100
     /* 436100 */ GIM_Reject,
     /* 436101 */ // Label 8755: @436101
     /* 436101 */ GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(436126), // Rule ID 8982 //
     /* 436106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 436112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 436115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436119 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 436119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 436124 */   GIR_RootConstrainSelectedInstOperands,
     /* 436125 */   // GIR_Coverage, 8982,
     /* 436125 */   GIR_Done,
     /* 436126 */ // Label 8790: @436126
     /* 436126 */ GIM_Reject,
     /* 436127 */ // Label 8756: @436127
     /* 436127 */ GIM_Reject,
     /* 436128 */ // Label 149: @436128
     /* 436128 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8809*/ GIMT_Encode4(436907),
     /* 436139 */ /*GILLT_v2s32*//*Label 8791*/ GIMT_Encode4(436215),
     /* 436143 */ /*GILLT_v2s64*//*Label 8792*/ GIMT_Encode4(436270),
     /* 436147 */ /*GILLT_v4s16*//*Label 8793*/ GIMT_Encode4(436325),
     /* 436151 */ /*GILLT_v4s32*//*Label 8794*/ GIMT_Encode4(436380),
     /* 436155 */ /*GILLT_v8s8*//*Label 8795*/ GIMT_Encode4(436435),
     /* 436159 */ /*GILLT_v8s16*//*Label 8796*/ GIMT_Encode4(436469),
     /* 436163 */ /*GILLT_v16s8*//*Label 8797*/ GIMT_Encode4(436524), GIMT_Encode4(0),
     /* 436171 */ /*GILLT_nxv2s1*//*Label 8798*/ GIMT_Encode4(436558),
     /* 436175 */ /*GILLT_nxv2s16*//*Label 8799*/ GIMT_Encode4(436584),
     /* 436179 */ /*GILLT_nxv2s32*//*Label 8800*/ GIMT_Encode4(436610),
     /* 436183 */ /*GILLT_nxv2s64*//*Label 8801*/ GIMT_Encode4(436636),
     /* 436187 */ /*GILLT_nxv4s1*//*Label 8802*/ GIMT_Encode4(436683),
     /* 436191 */ /*GILLT_nxv4s16*//*Label 8803*/ GIMT_Encode4(436709),
     /* 436195 */ /*GILLT_nxv4s32*//*Label 8804*/ GIMT_Encode4(436735),
     /* 436199 */ /*GILLT_nxv8s1*//*Label 8805*/ GIMT_Encode4(436782),
     /* 436203 */ /*GILLT_nxv8s16*//*Label 8806*/ GIMT_Encode4(436808),
     /* 436207 */ /*GILLT_nxv16s1*//*Label 8807*/ GIMT_Encode4(436855),
     /* 436211 */ /*GILLT_nxv16s8*//*Label 8808*/ GIMT_Encode4(436881),
     /* 436215 */ // Label 8791: @436215
     /* 436215 */ GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(436269),
     /* 436220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 436223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 436226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436238 */   GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(436253), // Rule ID 1895 //
     /* 436243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436246 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 436246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 436251 */     GIR_RootConstrainSelectedInstOperands,
     /* 436252 */     // GIR_Coverage, 1895,
     /* 436252 */     GIR_Done,
     /* 436253 */   // Label 8811: @436253
     /* 436253 */   GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(436268), // Rule ID 5515 //
     /* 436258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436261 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 436261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 436266 */     GIR_RootConstrainSelectedInstOperands,
     /* 436267 */     // GIR_Coverage, 5515,
     /* 436267 */     GIR_Done,
     /* 436268 */   // Label 8812: @436268
     /* 436268 */   GIM_Reject,
     /* 436269 */ // Label 8810: @436269
     /* 436269 */ GIM_Reject,
     /* 436270 */ // Label 8792: @436270
     /* 436270 */ GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(436324),
     /* 436275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 436278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 436281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436289 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436293 */   GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(436308), // Rule ID 1897 //
     /* 436298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436301 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 436301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 436306 */     GIR_RootConstrainSelectedInstOperands,
     /* 436307 */     // GIR_Coverage, 1897,
     /* 436307 */     GIR_Done,
     /* 436308 */   // Label 8814: @436308
     /* 436308 */   GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(436323), // Rule ID 5517 //
     /* 436313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436316 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 436316 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 436321 */     GIR_RootConstrainSelectedInstOperands,
     /* 436322 */     // GIR_Coverage, 5517,
     /* 436322 */     GIR_Done,
     /* 436323 */   // Label 8815: @436323
     /* 436323 */   GIM_Reject,
     /* 436324 */ // Label 8813: @436324
     /* 436324 */ GIM_Reject,
     /* 436325 */ // Label 8793: @436325
     /* 436325 */ GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(436379),
     /* 436330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 436333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 436336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436344 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436348 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(436363), // Rule ID 1893 //
     /* 436353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436356 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 436356 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 436361 */     GIR_RootConstrainSelectedInstOperands,
     /* 436362 */     // GIR_Coverage, 1893,
     /* 436362 */     GIR_Done,
     /* 436363 */   // Label 8817: @436363
     /* 436363 */   GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(436378), // Rule ID 5513 //
     /* 436368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436371 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 436371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 436376 */     GIR_RootConstrainSelectedInstOperands,
     /* 436377 */     // GIR_Coverage, 5513,
     /* 436377 */     GIR_Done,
     /* 436378 */   // Label 8818: @436378
     /* 436378 */   GIM_Reject,
     /* 436379 */ // Label 8816: @436379
     /* 436379 */ GIM_Reject,
     /* 436380 */ // Label 8794: @436380
     /* 436380 */ GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(436434),
     /* 436385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 436391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436403 */   GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(436418), // Rule ID 1896 //
     /* 436408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436411 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 436411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 436416 */     GIR_RootConstrainSelectedInstOperands,
     /* 436417 */     // GIR_Coverage, 1896,
     /* 436417 */     GIR_Done,
     /* 436418 */   // Label 8820: @436418
     /* 436418 */   GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(436433), // Rule ID 5516 //
     /* 436423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436426 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 436426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 436431 */     GIR_RootConstrainSelectedInstOperands,
     /* 436432 */     // GIR_Coverage, 5516,
     /* 436432 */     GIR_Done,
     /* 436433 */   // Label 8821: @436433
     /* 436433 */   GIM_Reject,
     /* 436434 */ // Label 8819: @436434
     /* 436434 */ GIM_Reject,
     /* 436435 */ // Label 8795: @436435
     /* 436435 */ GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(436468), // Rule ID 1891 //
     /* 436440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 436446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 436449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436457 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436461 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 436461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 436466 */   GIR_RootConstrainSelectedInstOperands,
     /* 436467 */   // GIR_Coverage, 1891,
     /* 436467 */   GIR_Done,
     /* 436468 */ // Label 8822: @436468
     /* 436468 */ GIM_Reject,
     /* 436469 */ // Label 8796: @436469
     /* 436469 */ GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(436523),
     /* 436474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 436477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 436480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436492 */   GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(436507), // Rule ID 1894 //
     /* 436497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436500 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 436500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 436505 */     GIR_RootConstrainSelectedInstOperands,
     /* 436506 */     // GIR_Coverage, 1894,
     /* 436506 */     GIR_Done,
     /* 436507 */   // Label 8824: @436507
     /* 436507 */   GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(436522), // Rule ID 5514 //
     /* 436512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436515 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 436515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 436520 */     GIR_RootConstrainSelectedInstOperands,
     /* 436521 */     // GIR_Coverage, 5514,
     /* 436521 */     GIR_Done,
     /* 436522 */   // Label 8825: @436522
     /* 436522 */   GIM_Reject,
     /* 436523 */ // Label 8823: @436523
     /* 436523 */ GIM_Reject,
     /* 436524 */ // Label 8797: @436524
     /* 436524 */ GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(436557), // Rule ID 1892 //
     /* 436529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 436535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 436538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436546 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436550 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 436550 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 436555 */   GIR_RootConstrainSelectedInstOperands,
     /* 436556 */   // GIR_Coverage, 1892,
     /* 436556 */   GIR_Done,
     /* 436557 */ // Label 8826: @436557
     /* 436557 */ GIM_Reject,
     /* 436558 */ // Label 8798: @436558
     /* 436558 */ GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(436583), // Rule ID 9030 //
     /* 436563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 436569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 436572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436576 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 436576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 436581 */   GIR_RootConstrainSelectedInstOperands,
     /* 436582 */   // GIR_Coverage, 9030,
     /* 436582 */   GIR_Done,
     /* 436583 */ // Label 8827: @436583
     /* 436583 */ GIM_Reject,
     /* 436584 */ // Label 8799: @436584
     /* 436584 */ GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(436609), // Rule ID 8999 //
     /* 436589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 436595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 436598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436602 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 436602 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 436607 */   GIR_RootConstrainSelectedInstOperands,
     /* 436608 */   // GIR_Coverage, 8999,
     /* 436608 */   GIR_Done,
     /* 436609 */ // Label 8828: @436609
     /* 436609 */ GIM_Reject,
     /* 436610 */ // Label 8800: @436610
     /* 436610 */ GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(436635), // Rule ID 9000 //
     /* 436615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 436621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 436624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436628 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 436628 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 436633 */   GIR_RootConstrainSelectedInstOperands,
     /* 436634 */   // GIR_Coverage, 9000,
     /* 436634 */   GIR_Done,
     /* 436635 */ // Label 8829: @436635
     /* 436635 */ GIM_Reject,
     /* 436636 */ // Label 8801: @436636
     /* 436636 */ GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(436682),
     /* 436641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 436644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 436647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436651 */   GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(436666), // Rule ID 8995 //
     /* 436656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436659 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 436659 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 436664 */     GIR_RootConstrainSelectedInstOperands,
     /* 436665 */     // GIR_Coverage, 8995,
     /* 436665 */     GIR_Done,
     /* 436666 */   // Label 8831: @436666
     /* 436666 */   GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(436681), // Rule ID 9001 //
     /* 436671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436674 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 436674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 436679 */     GIR_RootConstrainSelectedInstOperands,
     /* 436680 */     // GIR_Coverage, 9001,
     /* 436680 */     GIR_Done,
     /* 436681 */   // Label 8832: @436681
     /* 436681 */   GIM_Reject,
     /* 436682 */ // Label 8830: @436682
     /* 436682 */ GIM_Reject,
     /* 436683 */ // Label 8802: @436683
     /* 436683 */ GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(436708), // Rule ID 9029 //
     /* 436688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 436694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 436697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436701 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 436701 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 436706 */   GIR_RootConstrainSelectedInstOperands,
     /* 436707 */   // GIR_Coverage, 9029,
     /* 436707 */   GIR_Done,
     /* 436708 */ // Label 8833: @436708
     /* 436708 */ GIM_Reject,
     /* 436709 */ // Label 8803: @436709
     /* 436709 */ GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(436734), // Rule ID 8997 //
     /* 436714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 436720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 436723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436727 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 436727 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 436732 */   GIR_RootConstrainSelectedInstOperands,
     /* 436733 */   // GIR_Coverage, 8997,
     /* 436733 */   GIR_Done,
     /* 436734 */ // Label 8834: @436734
     /* 436734 */ GIM_Reject,
     /* 436735 */ // Label 8804: @436735
     /* 436735 */ GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(436781),
     /* 436740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 436743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 436746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436750 */   GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(436765), // Rule ID 8994 //
     /* 436755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436758 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 436758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 436763 */     GIR_RootConstrainSelectedInstOperands,
     /* 436764 */     // GIR_Coverage, 8994,
     /* 436764 */     GIR_Done,
     /* 436765 */   // Label 8836: @436765
     /* 436765 */   GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(436780), // Rule ID 8998 //
     /* 436770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436773 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 436773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 436778 */     GIR_RootConstrainSelectedInstOperands,
     /* 436779 */     // GIR_Coverage, 8998,
     /* 436779 */     GIR_Done,
     /* 436780 */   // Label 8837: @436780
     /* 436780 */   GIM_Reject,
     /* 436781 */ // Label 8835: @436781
     /* 436781 */ GIM_Reject,
     /* 436782 */ // Label 8805: @436782
     /* 436782 */ GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(436807), // Rule ID 9028 //
     /* 436787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 436793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 436796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436800 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 436800 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 436805 */   GIR_RootConstrainSelectedInstOperands,
     /* 436806 */   // GIR_Coverage, 9028,
     /* 436806 */   GIR_Done,
     /* 436807 */ // Label 8838: @436807
     /* 436807 */ GIM_Reject,
     /* 436808 */ // Label 8806: @436808
     /* 436808 */ GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(436854),
     /* 436813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 436816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 436819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436823 */   GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(436838), // Rule ID 8993 //
     /* 436828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436831 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 436831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 436836 */     GIR_RootConstrainSelectedInstOperands,
     /* 436837 */     // GIR_Coverage, 8993,
     /* 436837 */     GIR_Done,
     /* 436838 */   // Label 8840: @436838
     /* 436838 */   GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(436853), // Rule ID 8996 //
     /* 436843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436846 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 436846 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 436851 */     GIR_RootConstrainSelectedInstOperands,
     /* 436852 */     // GIR_Coverage, 8996,
     /* 436852 */     GIR_Done,
     /* 436853 */   // Label 8841: @436853
     /* 436853 */   GIM_Reject,
     /* 436854 */ // Label 8839: @436854
     /* 436854 */ GIM_Reject,
     /* 436855 */ // Label 8807: @436855
     /* 436855 */ GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(436880), // Rule ID 2410 //
     /* 436860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 436866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 436869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436873 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 436873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 436878 */   GIR_RootConstrainSelectedInstOperands,
     /* 436879 */   // GIR_Coverage, 2410,
     /* 436879 */   GIR_Done,
     /* 436880 */ // Label 8842: @436880
     /* 436880 */ GIM_Reject,
     /* 436881 */ // Label 8808: @436881
     /* 436881 */ GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(436906), // Rule ID 8992 //
     /* 436886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 436892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 436895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436899 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 436899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 436904 */   GIR_RootConstrainSelectedInstOperands,
     /* 436905 */   // GIR_Coverage, 8992,
     /* 436905 */   GIR_Done,
     /* 436906 */ // Label 8843: @436906
     /* 436906 */ GIM_Reject,
     /* 436907 */ // Label 8809: @436907
     /* 436907 */ GIM_Reject,
     /* 436908 */ // Label 150: @436908
     /* 436908 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8852*/ GIMT_Encode4(437605),
     /* 436919 */ /*GILLT_s64*//*Label 8844*/ GIMT_Encode4(436955), GIMT_Encode4(0),
     /* 436927 */ /*GILLT_v2s32*//*Label 8845*/ GIMT_Encode4(437066),
     /* 436931 */ /*GILLT_v2s64*//*Label 8846*/ GIMT_Encode4(437143),
     /* 436935 */ /*GILLT_v4s16*//*Label 8847*/ GIMT_Encode4(437220),
     /* 436939 */ /*GILLT_v4s32*//*Label 8848*/ GIMT_Encode4(437297),
     /* 436943 */ /*GILLT_v8s8*//*Label 8849*/ GIMT_Encode4(437374),
     /* 436947 */ /*GILLT_v8s16*//*Label 8850*/ GIMT_Encode4(437451),
     /* 436951 */ /*GILLT_v16s8*//*Label 8851*/ GIMT_Encode4(437528),
     /* 436955 */ // Label 8844: @436955
     /* 436955 */ GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(437065),
     /* 436960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 436963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436971 */   GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(436996), // Rule ID 5287 //
     /* 436976 */     // MIs[0] Operand 2
     /* 436976 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 436987 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 436987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 436990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436994 */     GIR_RootConstrainSelectedInstOperands,
     /* 436995 */     // GIR_Coverage, 5287,
     /* 436995 */     GIR_EraseRootFromParent_Done,
     /* 436996 */   // Label 8854: @436996
     /* 436996 */   GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(437030), // Rule ID 2120 //
     /* 437001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437004 */     // MIs[0] imm
     /* 437004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 437016 */     // MIs[1] Operand 1
     /* 437016 */     // No operand predicates
     /* 437016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437018 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 437021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437023 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437028 */     GIR_RootConstrainSelectedInstOperands,
     /* 437029 */     // GIR_Coverage, 2120,
     /* 437029 */     GIR_EraseRootFromParent_Done,
     /* 437030 */   // Label 8855: @437030
     /* 437030 */   GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(437064), // Rule ID 6345 //
     /* 437035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437038 */     // MIs[0] imm
     /* 437038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 437050 */     // MIs[1] Operand 1
     /* 437050 */     // No operand predicates
     /* 437050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437052 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 437052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 437055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437062 */     GIR_RootConstrainSelectedInstOperands,
     /* 437063 */     // GIR_Coverage, 6345,
     /* 437063 */     GIR_EraseRootFromParent_Done,
     /* 437064 */   // Label 8856: @437064
     /* 437064 */   GIM_Reject,
     /* 437065 */ // Label 8853: @437065
     /* 437065 */ GIM_Reject,
     /* 437066 */ // Label 8845: @437066
     /* 437066 */ GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(437142),
     /* 437071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 437074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437082 */   GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(437107), // Rule ID 4928 //
     /* 437087 */     // MIs[0] Operand 2
     /* 437087 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 437098 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 437098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 437101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437105 */     GIR_RootConstrainSelectedInstOperands,
     /* 437106 */     // GIR_Coverage, 4928,
     /* 437106 */     GIR_EraseRootFromParent_Done,
     /* 437107 */   // Label 8858: @437107
     /* 437107 */   GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(437141), // Rule ID 2227 //
     /* 437112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437115 */     // MIs[0] imm
     /* 437115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 437127 */     // MIs[1] Operand 1
     /* 437127 */     // No operand predicates
     /* 437127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437129 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 437132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437139 */     GIR_RootConstrainSelectedInstOperands,
     /* 437140 */     // GIR_Coverage, 2227,
     /* 437140 */     GIR_EraseRootFromParent_Done,
     /* 437141 */   // Label 8859: @437141
     /* 437141 */   GIM_Reject,
     /* 437142 */ // Label 8857: @437142
     /* 437142 */ GIM_Reject,
     /* 437143 */ // Label 8846: @437143
     /* 437143 */ GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(437219),
     /* 437148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 437151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437159 */   GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(437184), // Rule ID 4932 //
     /* 437164 */     // MIs[0] Operand 2
     /* 437164 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 437175 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 437175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 437178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437182 */     GIR_RootConstrainSelectedInstOperands,
     /* 437183 */     // GIR_Coverage, 4932,
     /* 437183 */     GIR_EraseRootFromParent_Done,
     /* 437184 */   // Label 8861: @437184
     /* 437184 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(437218), // Rule ID 2229 //
     /* 437189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437192 */     // MIs[0] imm
     /* 437192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 437204 */     // MIs[1] Operand 1
     /* 437204 */     // No operand predicates
     /* 437204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437206 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 437209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437216 */     GIR_RootConstrainSelectedInstOperands,
     /* 437217 */     // GIR_Coverage, 2229,
     /* 437217 */     GIR_EraseRootFromParent_Done,
     /* 437218 */   // Label 8862: @437218
     /* 437218 */   GIM_Reject,
     /* 437219 */ // Label 8860: @437219
     /* 437219 */ GIM_Reject,
     /* 437220 */ // Label 8847: @437220
     /* 437220 */ GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(437296),
     /* 437225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 437228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437236 */   GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(437261), // Rule ID 4927 //
     /* 437241 */     // MIs[0] Operand 2
     /* 437241 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 437252 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 437252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 437255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437259 */     GIR_RootConstrainSelectedInstOperands,
     /* 437260 */     // GIR_Coverage, 4927,
     /* 437260 */     GIR_EraseRootFromParent_Done,
     /* 437261 */   // Label 8864: @437261
     /* 437261 */   GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(437295), // Rule ID 2225 //
     /* 437266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437269 */     // MIs[0] imm
     /* 437269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 437281 */     // MIs[1] Operand 1
     /* 437281 */     // No operand predicates
     /* 437281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437283 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 437286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437293 */     GIR_RootConstrainSelectedInstOperands,
     /* 437294 */     // GIR_Coverage, 2225,
     /* 437294 */     GIR_EraseRootFromParent_Done,
     /* 437295 */   // Label 8865: @437295
     /* 437295 */   GIM_Reject,
     /* 437296 */ // Label 8863: @437296
     /* 437296 */ GIM_Reject,
     /* 437297 */ // Label 8848: @437297
     /* 437297 */ GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(437373),
     /* 437302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 437305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437313 */   GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(437338), // Rule ID 4931 //
     /* 437318 */     // MIs[0] Operand 2
     /* 437318 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 437329 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 437329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 437332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437336 */     GIR_RootConstrainSelectedInstOperands,
     /* 437337 */     // GIR_Coverage, 4931,
     /* 437337 */     GIR_EraseRootFromParent_Done,
     /* 437338 */   // Label 8867: @437338
     /* 437338 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(437372), // Rule ID 2228 //
     /* 437343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437346 */     // MIs[0] imm
     /* 437346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437354 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 437358 */     // MIs[1] Operand 1
     /* 437358 */     // No operand predicates
     /* 437358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437360 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 437363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437370 */     GIR_RootConstrainSelectedInstOperands,
     /* 437371 */     // GIR_Coverage, 2228,
     /* 437371 */     GIR_EraseRootFromParent_Done,
     /* 437372 */   // Label 8868: @437372
     /* 437372 */   GIM_Reject,
     /* 437373 */ // Label 8866: @437373
     /* 437373 */ GIM_Reject,
     /* 437374 */ // Label 8849: @437374
     /* 437374 */ GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(437450),
     /* 437379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 437382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437390 */   GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(437415), // Rule ID 4926 //
     /* 437395 */     // MIs[0] Operand 2
     /* 437395 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 437406 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 437406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 437409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437413 */     GIR_RootConstrainSelectedInstOperands,
     /* 437414 */     // GIR_Coverage, 4926,
     /* 437414 */     GIR_EraseRootFromParent_Done,
     /* 437415 */   // Label 8870: @437415
     /* 437415 */   GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(437449), // Rule ID 2223 //
     /* 437420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437423 */     // MIs[0] imm
     /* 437423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 437435 */     // MIs[1] Operand 1
     /* 437435 */     // No operand predicates
     /* 437435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437437 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 437440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437447 */     GIR_RootConstrainSelectedInstOperands,
     /* 437448 */     // GIR_Coverage, 2223,
     /* 437448 */     GIR_EraseRootFromParent_Done,
     /* 437449 */   // Label 8871: @437449
     /* 437449 */   GIM_Reject,
     /* 437450 */ // Label 8869: @437450
     /* 437450 */ GIM_Reject,
     /* 437451 */ // Label 8850: @437451
     /* 437451 */ GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(437527),
     /* 437456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437467 */   GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(437492), // Rule ID 4930 //
     /* 437472 */     // MIs[0] Operand 2
     /* 437472 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 437483 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 437483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 437486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437490 */     GIR_RootConstrainSelectedInstOperands,
     /* 437491 */     // GIR_Coverage, 4930,
     /* 437491 */     GIR_EraseRootFromParent_Done,
     /* 437492 */   // Label 8873: @437492
     /* 437492 */   GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(437526), // Rule ID 2226 //
     /* 437497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437500 */     // MIs[0] imm
     /* 437500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 437512 */     // MIs[1] Operand 1
     /* 437512 */     // No operand predicates
     /* 437512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437514 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 437517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437524 */     GIR_RootConstrainSelectedInstOperands,
     /* 437525 */     // GIR_Coverage, 2226,
     /* 437525 */     GIR_EraseRootFromParent_Done,
     /* 437526 */   // Label 8874: @437526
     /* 437526 */   GIM_Reject,
     /* 437527 */ // Label 8872: @437527
     /* 437527 */ GIM_Reject,
     /* 437528 */ // Label 8851: @437528
     /* 437528 */ GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(437604),
     /* 437533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 437536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437544 */   GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(437569), // Rule ID 4929 //
     /* 437549 */     // MIs[0] Operand 2
     /* 437549 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 437560 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 437560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 437563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437567 */     GIR_RootConstrainSelectedInstOperands,
     /* 437568 */     // GIR_Coverage, 4929,
     /* 437568 */     GIR_EraseRootFromParent_Done,
     /* 437569 */   // Label 8876: @437569
     /* 437569 */   GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(437603), // Rule ID 2224 //
     /* 437574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437577 */     // MIs[0] imm
     /* 437577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 437589 */     // MIs[1] Operand 1
     /* 437589 */     // No operand predicates
     /* 437589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437591 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 437594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437601 */     GIR_RootConstrainSelectedInstOperands,
     /* 437602 */     // GIR_Coverage, 2224,
     /* 437602 */     GIR_EraseRootFromParent_Done,
     /* 437603 */   // Label 8877: @437603
     /* 437603 */   GIM_Reject,
     /* 437604 */ // Label 8875: @437604
     /* 437604 */ GIM_Reject,
     /* 437605 */ // Label 8852: @437605
     /* 437605 */ GIM_Reject,
     /* 437606 */ // Label 151: @437606
     /* 437606 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8886*/ GIMT_Encode4(438061),
     /* 437617 */ /*GILLT_s64*//*Label 8878*/ GIMT_Encode4(437653), GIMT_Encode4(0),
     /* 437625 */ /*GILLT_v2s32*//*Label 8879*/ GIMT_Encode4(437739),
     /* 437629 */ /*GILLT_v2s64*//*Label 8880*/ GIMT_Encode4(437785),
     /* 437633 */ /*GILLT_v4s16*//*Label 8881*/ GIMT_Encode4(437831),
     /* 437637 */ /*GILLT_v4s32*//*Label 8882*/ GIMT_Encode4(437877),
     /* 437641 */ /*GILLT_v8s8*//*Label 8883*/ GIMT_Encode4(437923),
     /* 437645 */ /*GILLT_v8s16*//*Label 8884*/ GIMT_Encode4(437969),
     /* 437649 */ /*GILLT_v16s8*//*Label 8885*/ GIMT_Encode4(438015),
     /* 437653 */ // Label 8878: @437653
     /* 437653 */ GIM_Try, /*On fail goto*//*Label 8887*/ GIMT_Encode4(437738),
     /* 437658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 437661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437669 */   GIM_Try, /*On fail goto*//*Label 8888*/ GIMT_Encode4(437703), // Rule ID 2129 //
     /* 437674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437677 */     // MIs[0] imm
     /* 437677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 437689 */     // MIs[1] Operand 1
     /* 437689 */     // No operand predicates
     /* 437689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437691 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 437694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437701 */     GIR_RootConstrainSelectedInstOperands,
     /* 437702 */     // GIR_Coverage, 2129,
     /* 437702 */     GIR_EraseRootFromParent_Done,
     /* 437703 */   // Label 8888: @437703
     /* 437703 */   GIM_Try, /*On fail goto*//*Label 8889*/ GIMT_Encode4(437737), // Rule ID 6348 //
     /* 437708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437711 */     // MIs[0] imm
     /* 437711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 437723 */     // MIs[1] Operand 1
     /* 437723 */     // No operand predicates
     /* 437723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437725 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 437725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 437728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437735 */     GIR_RootConstrainSelectedInstOperands,
     /* 437736 */     // GIR_Coverage, 6348,
     /* 437736 */     GIR_EraseRootFromParent_Done,
     /* 437737 */   // Label 8889: @437737
     /* 437737 */   GIM_Reject,
     /* 437738 */ // Label 8887: @437738
     /* 437738 */ GIM_Reject,
     /* 437739 */ // Label 8879: @437739
     /* 437739 */ GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(437784), // Rule ID 2286 //
     /* 437744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 437750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437758 */   // MIs[0] imm
     /* 437758 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437762 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437766 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 437770 */   // MIs[1] Operand 1
     /* 437770 */   // No operand predicates
     /* 437770 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437772 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 437775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437777 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437779 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437782 */   GIR_RootConstrainSelectedInstOperands,
     /* 437783 */   // GIR_Coverage, 2286,
     /* 437783 */   GIR_EraseRootFromParent_Done,
     /* 437784 */ // Label 8890: @437784
     /* 437784 */ GIM_Reject,
     /* 437785 */ // Label 8880: @437785
     /* 437785 */ GIM_Try, /*On fail goto*//*Label 8891*/ GIMT_Encode4(437830), // Rule ID 2288 //
     /* 437790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 437796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437804 */   // MIs[0] imm
     /* 437804 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437812 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 437816 */   // MIs[1] Operand 1
     /* 437816 */   // No operand predicates
     /* 437816 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437818 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 437821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437823 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437825 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437828 */   GIR_RootConstrainSelectedInstOperands,
     /* 437829 */   // GIR_Coverage, 2288,
     /* 437829 */   GIR_EraseRootFromParent_Done,
     /* 437830 */ // Label 8891: @437830
     /* 437830 */ GIM_Reject,
     /* 437831 */ // Label 8881: @437831
     /* 437831 */ GIM_Try, /*On fail goto*//*Label 8892*/ GIMT_Encode4(437876), // Rule ID 2284 //
     /* 437836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 437842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437850 */   // MIs[0] imm
     /* 437850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437858 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 437862 */   // MIs[1] Operand 1
     /* 437862 */   // No operand predicates
     /* 437862 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437864 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 437867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437869 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437871 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437874 */   GIR_RootConstrainSelectedInstOperands,
     /* 437875 */   // GIR_Coverage, 2284,
     /* 437875 */   GIR_EraseRootFromParent_Done,
     /* 437876 */ // Label 8892: @437876
     /* 437876 */ GIM_Reject,
     /* 437877 */ // Label 8882: @437877
     /* 437877 */ GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(437922), // Rule ID 2287 //
     /* 437882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 437888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437896 */   // MIs[0] imm
     /* 437896 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437900 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437904 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 437908 */   // MIs[1] Operand 1
     /* 437908 */   // No operand predicates
     /* 437908 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437910 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 437913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437915 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437917 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437920 */   GIR_RootConstrainSelectedInstOperands,
     /* 437921 */   // GIR_Coverage, 2287,
     /* 437921 */   GIR_EraseRootFromParent_Done,
     /* 437922 */ // Label 8893: @437922
     /* 437922 */ GIM_Reject,
     /* 437923 */ // Label 8883: @437923
     /* 437923 */ GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(437968), // Rule ID 2282 //
     /* 437928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 437934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437942 */   // MIs[0] imm
     /* 437942 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437946 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437950 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 437954 */   // MIs[1] Operand 1
     /* 437954 */   // No operand predicates
     /* 437954 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437956 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 437959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437961 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437963 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437966 */   GIR_RootConstrainSelectedInstOperands,
     /* 437967 */   // GIR_Coverage, 2282,
     /* 437967 */   GIR_EraseRootFromParent_Done,
     /* 437968 */ // Label 8894: @437968
     /* 437968 */ GIM_Reject,
     /* 437969 */ // Label 8884: @437969
     /* 437969 */ GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(438014), // Rule ID 2285 //
     /* 437974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437988 */   // MIs[0] imm
     /* 437988 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437992 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437996 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 438000 */   // MIs[1] Operand 1
     /* 438000 */   // No operand predicates
     /* 438000 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438002 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 438005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438007 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438009 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438012 */   GIR_RootConstrainSelectedInstOperands,
     /* 438013 */   // GIR_Coverage, 2285,
     /* 438013 */   GIR_EraseRootFromParent_Done,
     /* 438014 */ // Label 8895: @438014
     /* 438014 */ GIM_Reject,
     /* 438015 */ // Label 8885: @438015
     /* 438015 */ GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(438060), // Rule ID 2283 //
     /* 438020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 438026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438034 */   // MIs[0] imm
     /* 438034 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438038 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438042 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 438046 */   // MIs[1] Operand 1
     /* 438046 */   // No operand predicates
     /* 438046 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438048 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 438051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438053 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438055 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438058 */   GIR_RootConstrainSelectedInstOperands,
     /* 438059 */   // GIR_Coverage, 2283,
     /* 438059 */   GIR_EraseRootFromParent_Done,
     /* 438060 */ // Label 8896: @438060
     /* 438060 */ GIM_Reject,
     /* 438061 */ // Label 8886: @438061
     /* 438061 */ GIM_Reject,
     /* 438062 */ // Label 152: @438062
     /* 438062 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8915*/ GIMT_Encode4(438841),
     /* 438073 */ /*GILLT_v2s32*//*Label 8897*/ GIMT_Encode4(438149),
     /* 438077 */ /*GILLT_v2s64*//*Label 8898*/ GIMT_Encode4(438204),
     /* 438081 */ /*GILLT_v4s16*//*Label 8899*/ GIMT_Encode4(438259),
     /* 438085 */ /*GILLT_v4s32*//*Label 8900*/ GIMT_Encode4(438314),
     /* 438089 */ /*GILLT_v8s8*//*Label 8901*/ GIMT_Encode4(438369),
     /* 438093 */ /*GILLT_v8s16*//*Label 8902*/ GIMT_Encode4(438403),
     /* 438097 */ /*GILLT_v16s8*//*Label 8903*/ GIMT_Encode4(438458), GIMT_Encode4(0),
     /* 438105 */ /*GILLT_nxv2s1*//*Label 8904*/ GIMT_Encode4(438492),
     /* 438109 */ /*GILLT_nxv2s16*//*Label 8905*/ GIMT_Encode4(438518),
     /* 438113 */ /*GILLT_nxv2s32*//*Label 8906*/ GIMT_Encode4(438544),
     /* 438117 */ /*GILLT_nxv2s64*//*Label 8907*/ GIMT_Encode4(438570),
     /* 438121 */ /*GILLT_nxv4s1*//*Label 8908*/ GIMT_Encode4(438617),
     /* 438125 */ /*GILLT_nxv4s16*//*Label 8909*/ GIMT_Encode4(438643),
     /* 438129 */ /*GILLT_nxv4s32*//*Label 8910*/ GIMT_Encode4(438669),
     /* 438133 */ /*GILLT_nxv8s1*//*Label 8911*/ GIMT_Encode4(438716),
     /* 438137 */ /*GILLT_nxv8s16*//*Label 8912*/ GIMT_Encode4(438742),
     /* 438141 */ /*GILLT_nxv16s1*//*Label 8913*/ GIMT_Encode4(438789),
     /* 438145 */ /*GILLT_nxv16s8*//*Label 8914*/ GIMT_Encode4(438815),
     /* 438149 */ // Label 8897: @438149
     /* 438149 */ GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(438203),
     /* 438154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 438157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 438160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438172 */   GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(438187), // Rule ID 1902 //
     /* 438177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438180 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 438180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 438185 */     GIR_RootConstrainSelectedInstOperands,
     /* 438186 */     // GIR_Coverage, 1902,
     /* 438186 */     GIR_Done,
     /* 438187 */   // Label 8917: @438187
     /* 438187 */   GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(438202), // Rule ID 5520 //
     /* 438192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438195 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 438195 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 438200 */     GIR_RootConstrainSelectedInstOperands,
     /* 438201 */     // GIR_Coverage, 5520,
     /* 438201 */     GIR_Done,
     /* 438202 */   // Label 8918: @438202
     /* 438202 */   GIM_Reject,
     /* 438203 */ // Label 8916: @438203
     /* 438203 */ GIM_Reject,
     /* 438204 */ // Label 8898: @438204
     /* 438204 */ GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(438258),
     /* 438209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 438212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 438215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438227 */   GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(438242), // Rule ID 1904 //
     /* 438232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438235 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 438235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 438240 */     GIR_RootConstrainSelectedInstOperands,
     /* 438241 */     // GIR_Coverage, 1904,
     /* 438241 */     GIR_Done,
     /* 438242 */   // Label 8920: @438242
     /* 438242 */   GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(438257), // Rule ID 5522 //
     /* 438247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438250 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 438250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 438255 */     GIR_RootConstrainSelectedInstOperands,
     /* 438256 */     // GIR_Coverage, 5522,
     /* 438256 */     GIR_Done,
     /* 438257 */   // Label 8921: @438257
     /* 438257 */   GIM_Reject,
     /* 438258 */ // Label 8919: @438258
     /* 438258 */ GIM_Reject,
     /* 438259 */ // Label 8899: @438259
     /* 438259 */ GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(438313),
     /* 438264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 438267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 438270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438282 */   GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(438297), // Rule ID 1900 //
     /* 438287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438290 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 438290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 438295 */     GIR_RootConstrainSelectedInstOperands,
     /* 438296 */     // GIR_Coverage, 1900,
     /* 438296 */     GIR_Done,
     /* 438297 */   // Label 8923: @438297
     /* 438297 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(438312), // Rule ID 5518 //
     /* 438302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438305 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 438305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 438310 */     GIR_RootConstrainSelectedInstOperands,
     /* 438311 */     // GIR_Coverage, 5518,
     /* 438311 */     GIR_Done,
     /* 438312 */   // Label 8924: @438312
     /* 438312 */   GIM_Reject,
     /* 438313 */ // Label 8922: @438313
     /* 438313 */ GIM_Reject,
     /* 438314 */ // Label 8900: @438314
     /* 438314 */ GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(438368),
     /* 438319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 438322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 438325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438337 */   GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(438352), // Rule ID 1903 //
     /* 438342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438345 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 438345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 438350 */     GIR_RootConstrainSelectedInstOperands,
     /* 438351 */     // GIR_Coverage, 1903,
     /* 438351 */     GIR_Done,
     /* 438352 */   // Label 8926: @438352
     /* 438352 */   GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(438367), // Rule ID 5521 //
     /* 438357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438360 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 438360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 438365 */     GIR_RootConstrainSelectedInstOperands,
     /* 438366 */     // GIR_Coverage, 5521,
     /* 438366 */     GIR_Done,
     /* 438367 */   // Label 8927: @438367
     /* 438367 */   GIM_Reject,
     /* 438368 */ // Label 8925: @438368
     /* 438368 */ GIM_Reject,
     /* 438369 */ // Label 8901: @438369
     /* 438369 */ GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(438402), // Rule ID 1898 //
     /* 438374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 438380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 438383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438395 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 438395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 438400 */   GIR_RootConstrainSelectedInstOperands,
     /* 438401 */   // GIR_Coverage, 1898,
     /* 438401 */   GIR_Done,
     /* 438402 */ // Label 8928: @438402
     /* 438402 */ GIM_Reject,
     /* 438403 */ // Label 8902: @438403
     /* 438403 */ GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(438457),
     /* 438408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 438411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 438414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438426 */   GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(438441), // Rule ID 1901 //
     /* 438431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438434 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 438434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 438439 */     GIR_RootConstrainSelectedInstOperands,
     /* 438440 */     // GIR_Coverage, 1901,
     /* 438440 */     GIR_Done,
     /* 438441 */   // Label 8930: @438441
     /* 438441 */   GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(438456), // Rule ID 5519 //
     /* 438446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438449 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 438449 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 438454 */     GIR_RootConstrainSelectedInstOperands,
     /* 438455 */     // GIR_Coverage, 5519,
     /* 438455 */     GIR_Done,
     /* 438456 */   // Label 8931: @438456
     /* 438456 */   GIM_Reject,
     /* 438457 */ // Label 8929: @438457
     /* 438457 */ GIM_Reject,
     /* 438458 */ // Label 8903: @438458
     /* 438458 */ GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(438491), // Rule ID 1899 //
     /* 438463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 438469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 438472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438480 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438484 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 438484 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 438489 */   GIR_RootConstrainSelectedInstOperands,
     /* 438490 */   // GIR_Coverage, 1899,
     /* 438490 */   GIR_Done,
     /* 438491 */ // Label 8932: @438491
     /* 438491 */ GIM_Reject,
     /* 438492 */ // Label 8904: @438492
     /* 438492 */ GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(438517), // Rule ID 3348 //
     /* 438497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 438503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 438506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438510 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 438510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 438515 */   GIR_RootConstrainSelectedInstOperands,
     /* 438516 */   // GIR_Coverage, 3348,
     /* 438516 */   GIR_Done,
     /* 438517 */ // Label 8933: @438517
     /* 438517 */ GIM_Reject,
     /* 438518 */ // Label 8905: @438518
     /* 438518 */ GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(438543), // Rule ID 2879 //
     /* 438523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 438529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 438532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438536 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 438536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 438541 */   GIR_RootConstrainSelectedInstOperands,
     /* 438542 */   // GIR_Coverage, 2879,
     /* 438542 */   GIR_Done,
     /* 438543 */ // Label 8934: @438543
     /* 438543 */ GIM_Reject,
     /* 438544 */ // Label 8906: @438544
     /* 438544 */ GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(438569), // Rule ID 2880 //
     /* 438549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 438555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 438558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438562 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 438562 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 438567 */   GIR_RootConstrainSelectedInstOperands,
     /* 438568 */   // GIR_Coverage, 2880,
     /* 438568 */   GIR_Done,
     /* 438569 */ // Label 8935: @438569
     /* 438569 */ GIM_Reject,
     /* 438570 */ // Label 8907: @438570
     /* 438570 */ GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(438616),
     /* 438575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 438578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 438581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438585 */   GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(438600), // Rule ID 2875 //
     /* 438590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438593 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 438593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 438598 */     GIR_RootConstrainSelectedInstOperands,
     /* 438599 */     // GIR_Coverage, 2875,
     /* 438599 */     GIR_Done,
     /* 438600 */   // Label 8937: @438600
     /* 438600 */   GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(438615), // Rule ID 2881 //
     /* 438605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438608 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 438608 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 438613 */     GIR_RootConstrainSelectedInstOperands,
     /* 438614 */     // GIR_Coverage, 2881,
     /* 438614 */     GIR_Done,
     /* 438615 */   // Label 8938: @438615
     /* 438615 */   GIM_Reject,
     /* 438616 */ // Label 8936: @438616
     /* 438616 */ GIM_Reject,
     /* 438617 */ // Label 8908: @438617
     /* 438617 */ GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(438642), // Rule ID 3347 //
     /* 438622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 438628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 438631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438635 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 438635 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 438640 */   GIR_RootConstrainSelectedInstOperands,
     /* 438641 */   // GIR_Coverage, 3347,
     /* 438641 */   GIR_Done,
     /* 438642 */ // Label 8939: @438642
     /* 438642 */ GIM_Reject,
     /* 438643 */ // Label 8909: @438643
     /* 438643 */ GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(438668), // Rule ID 2877 //
     /* 438648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 438654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 438657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438661 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 438661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 438666 */   GIR_RootConstrainSelectedInstOperands,
     /* 438667 */   // GIR_Coverage, 2877,
     /* 438667 */   GIR_Done,
     /* 438668 */ // Label 8940: @438668
     /* 438668 */ GIM_Reject,
     /* 438669 */ // Label 8910: @438669
     /* 438669 */ GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(438715),
     /* 438674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 438677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 438680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438684 */   GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(438699), // Rule ID 2874 //
     /* 438689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438692 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 438692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 438697 */     GIR_RootConstrainSelectedInstOperands,
     /* 438698 */     // GIR_Coverage, 2874,
     /* 438698 */     GIR_Done,
     /* 438699 */   // Label 8942: @438699
     /* 438699 */   GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(438714), // Rule ID 2878 //
     /* 438704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438707 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 438707 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 438712 */     GIR_RootConstrainSelectedInstOperands,
     /* 438713 */     // GIR_Coverage, 2878,
     /* 438713 */     GIR_Done,
     /* 438714 */   // Label 8943: @438714
     /* 438714 */   GIM_Reject,
     /* 438715 */ // Label 8941: @438715
     /* 438715 */ GIM_Reject,
     /* 438716 */ // Label 8911: @438716
     /* 438716 */ GIM_Try, /*On fail goto*//*Label 8944*/ GIMT_Encode4(438741), // Rule ID 3346 //
     /* 438721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 438727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 438730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438734 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 438734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 438739 */   GIR_RootConstrainSelectedInstOperands,
     /* 438740 */   // GIR_Coverage, 3346,
     /* 438740 */   GIR_Done,
     /* 438741 */ // Label 8944: @438741
     /* 438741 */ GIM_Reject,
     /* 438742 */ // Label 8912: @438742
     /* 438742 */ GIM_Try, /*On fail goto*//*Label 8945*/ GIMT_Encode4(438788),
     /* 438747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 438750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 438753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438757 */   GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(438772), // Rule ID 2873 //
     /* 438762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438765 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 438765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 438770 */     GIR_RootConstrainSelectedInstOperands,
     /* 438771 */     // GIR_Coverage, 2873,
     /* 438771 */     GIR_Done,
     /* 438772 */   // Label 8946: @438772
     /* 438772 */   GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(438787), // Rule ID 2876 //
     /* 438777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438780 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 438780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 438785 */     GIR_RootConstrainSelectedInstOperands,
     /* 438786 */     // GIR_Coverage, 2876,
     /* 438786 */     GIR_Done,
     /* 438787 */   // Label 8947: @438787
     /* 438787 */   GIM_Reject,
     /* 438788 */ // Label 8945: @438788
     /* 438788 */ GIM_Reject,
     /* 438789 */ // Label 8913: @438789
     /* 438789 */ GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(438814), // Rule ID 2398 //
     /* 438794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 438800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 438803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 438807 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 438807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 438812 */   GIR_RootConstrainSelectedInstOperands,
     /* 438813 */   // GIR_Coverage, 2398,
     /* 438813 */   GIR_Done,
     /* 438814 */ // Label 8948: @438814
     /* 438814 */ GIM_Reject,
     /* 438815 */ // Label 8914: @438815
     /* 438815 */ GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(438840), // Rule ID 2872 //
     /* 438820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 438823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 438826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 438829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 438833 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 438833 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 438838 */   GIR_RootConstrainSelectedInstOperands,
     /* 438839 */   // GIR_Coverage, 2872,
     /* 438839 */   GIR_Done,
     /* 438840 */ // Label 8949: @438840
     /* 438840 */ GIM_Reject,
     /* 438841 */ // Label 8915: @438841
     /* 438841 */ GIM_Reject,
     /* 438842 */ // Label 153: @438842
     /* 438842 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8968*/ GIMT_Encode4(439621),
     /* 438853 */ /*GILLT_v2s32*//*Label 8950*/ GIMT_Encode4(438929),
     /* 438857 */ /*GILLT_v2s64*//*Label 8951*/ GIMT_Encode4(438984),
     /* 438861 */ /*GILLT_v4s16*//*Label 8952*/ GIMT_Encode4(439039),
     /* 438865 */ /*GILLT_v4s32*//*Label 8953*/ GIMT_Encode4(439094),
     /* 438869 */ /*GILLT_v8s8*//*Label 8954*/ GIMT_Encode4(439149),
     /* 438873 */ /*GILLT_v8s16*//*Label 8955*/ GIMT_Encode4(439183),
     /* 438877 */ /*GILLT_v16s8*//*Label 8956*/ GIMT_Encode4(439238), GIMT_Encode4(0),
     /* 438885 */ /*GILLT_nxv2s1*//*Label 8957*/ GIMT_Encode4(439272),
     /* 438889 */ /*GILLT_nxv2s16*//*Label 8958*/ GIMT_Encode4(439298),
     /* 438893 */ /*GILLT_nxv2s32*//*Label 8959*/ GIMT_Encode4(439324),
     /* 438897 */ /*GILLT_nxv2s64*//*Label 8960*/ GIMT_Encode4(439350),
     /* 438901 */ /*GILLT_nxv4s1*//*Label 8961*/ GIMT_Encode4(439397),
     /* 438905 */ /*GILLT_nxv4s16*//*Label 8962*/ GIMT_Encode4(439423),
     /* 438909 */ /*GILLT_nxv4s32*//*Label 8963*/ GIMT_Encode4(439449),
     /* 438913 */ /*GILLT_nxv8s1*//*Label 8964*/ GIMT_Encode4(439496),
     /* 438917 */ /*GILLT_nxv8s16*//*Label 8965*/ GIMT_Encode4(439522),
     /* 438921 */ /*GILLT_nxv16s1*//*Label 8966*/ GIMT_Encode4(439569),
     /* 438925 */ /*GILLT_nxv16s8*//*Label 8967*/ GIMT_Encode4(439595),
     /* 438929 */ // Label 8950: @438929
     /* 438929 */ GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(438983),
     /* 438934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 438937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 438940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438952 */   GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(438967), // Rule ID 1909 //
     /* 438957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438960 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 438960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 438965 */     GIR_RootConstrainSelectedInstOperands,
     /* 438966 */     // GIR_Coverage, 1909,
     /* 438966 */     GIR_Done,
     /* 438967 */   // Label 8970: @438967
     /* 438967 */   GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(438982), // Rule ID 5525 //
     /* 438972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438975 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 438975 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 438980 */     GIR_RootConstrainSelectedInstOperands,
     /* 438981 */     // GIR_Coverage, 5525,
     /* 438981 */     GIR_Done,
     /* 438982 */   // Label 8971: @438982
     /* 438982 */   GIM_Reject,
     /* 438983 */ // Label 8969: @438983
     /* 438983 */ GIM_Reject,
     /* 438984 */ // Label 8951: @438984
     /* 438984 */ GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(439038),
     /* 438989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 438992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 438995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439003 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439007 */   GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(439022), // Rule ID 1911 //
     /* 439012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439015 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 439015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 439020 */     GIR_RootConstrainSelectedInstOperands,
     /* 439021 */     // GIR_Coverage, 1911,
     /* 439021 */     GIR_Done,
     /* 439022 */   // Label 8973: @439022
     /* 439022 */   GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(439037), // Rule ID 5527 //
     /* 439027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439030 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 439030 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 439035 */     GIR_RootConstrainSelectedInstOperands,
     /* 439036 */     // GIR_Coverage, 5527,
     /* 439036 */     GIR_Done,
     /* 439037 */   // Label 8974: @439037
     /* 439037 */   GIM_Reject,
     /* 439038 */ // Label 8972: @439038
     /* 439038 */ GIM_Reject,
     /* 439039 */ // Label 8952: @439039
     /* 439039 */ GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(439093),
     /* 439044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 439047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 439050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439058 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439062 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(439077), // Rule ID 1907 //
     /* 439067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439070 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 439070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 439075 */     GIR_RootConstrainSelectedInstOperands,
     /* 439076 */     // GIR_Coverage, 1907,
     /* 439076 */     GIR_Done,
     /* 439077 */   // Label 8976: @439077
     /* 439077 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(439092), // Rule ID 5523 //
     /* 439082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439085 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 439085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 439090 */     GIR_RootConstrainSelectedInstOperands,
     /* 439091 */     // GIR_Coverage, 5523,
     /* 439091 */     GIR_Done,
     /* 439092 */   // Label 8977: @439092
     /* 439092 */   GIM_Reject,
     /* 439093 */ // Label 8975: @439093
     /* 439093 */ GIM_Reject,
     /* 439094 */ // Label 8953: @439094
     /* 439094 */ GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(439148),
     /* 439099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 439102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 439105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439113 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439117 */   GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(439132), // Rule ID 1910 //
     /* 439122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439125 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 439125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 439130 */     GIR_RootConstrainSelectedInstOperands,
     /* 439131 */     // GIR_Coverage, 1910,
     /* 439131 */     GIR_Done,
     /* 439132 */   // Label 8979: @439132
     /* 439132 */   GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(439147), // Rule ID 5526 //
     /* 439137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439140 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 439140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 439145 */     GIR_RootConstrainSelectedInstOperands,
     /* 439146 */     // GIR_Coverage, 5526,
     /* 439146 */     GIR_Done,
     /* 439147 */   // Label 8980: @439147
     /* 439147 */   GIM_Reject,
     /* 439148 */ // Label 8978: @439148
     /* 439148 */ GIM_Reject,
     /* 439149 */ // Label 8954: @439149
     /* 439149 */ GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(439182), // Rule ID 1905 //
     /* 439154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 439160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 439163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439171 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439175 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 439175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 439180 */   GIR_RootConstrainSelectedInstOperands,
     /* 439181 */   // GIR_Coverage, 1905,
     /* 439181 */   GIR_Done,
     /* 439182 */ // Label 8981: @439182
     /* 439182 */ GIM_Reject,
     /* 439183 */ // Label 8955: @439183
     /* 439183 */ GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(439237),
     /* 439188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 439191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 439194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439206 */   GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(439221), // Rule ID 1908 //
     /* 439211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439214 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 439214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 439219 */     GIR_RootConstrainSelectedInstOperands,
     /* 439220 */     // GIR_Coverage, 1908,
     /* 439220 */     GIR_Done,
     /* 439221 */   // Label 8983: @439221
     /* 439221 */   GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(439236), // Rule ID 5524 //
     /* 439226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439229 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 439229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 439234 */     GIR_RootConstrainSelectedInstOperands,
     /* 439235 */     // GIR_Coverage, 5524,
     /* 439235 */     GIR_Done,
     /* 439236 */   // Label 8984: @439236
     /* 439236 */   GIM_Reject,
     /* 439237 */ // Label 8982: @439237
     /* 439237 */ GIM_Reject,
     /* 439238 */ // Label 8956: @439238
     /* 439238 */ GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(439271), // Rule ID 1906 //
     /* 439243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 439249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 439252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439264 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 439264 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 439269 */   GIR_RootConstrainSelectedInstOperands,
     /* 439270 */   // GIR_Coverage, 1906,
     /* 439270 */   GIR_Done,
     /* 439271 */ // Label 8985: @439271
     /* 439271 */ GIM_Reject,
     /* 439272 */ // Label 8957: @439272
     /* 439272 */ GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(439297), // Rule ID 9024 //
     /* 439277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 439283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 439286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439290 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 439290 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 439295 */   GIR_RootConstrainSelectedInstOperands,
     /* 439296 */   // GIR_Coverage, 9024,
     /* 439296 */   GIR_Done,
     /* 439297 */ // Label 8986: @439297
     /* 439297 */ GIM_Reject,
     /* 439298 */ // Label 8958: @439298
     /* 439298 */ GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(439323), // Rule ID 8979 //
     /* 439303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 439309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 439312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439316 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 439316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 439321 */   GIR_RootConstrainSelectedInstOperands,
     /* 439322 */   // GIR_Coverage, 8979,
     /* 439322 */   GIR_Done,
     /* 439323 */ // Label 8987: @439323
     /* 439323 */ GIM_Reject,
     /* 439324 */ // Label 8959: @439324
     /* 439324 */ GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(439349), // Rule ID 8980 //
     /* 439329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 439335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 439338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439342 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 439342 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 439347 */   GIR_RootConstrainSelectedInstOperands,
     /* 439348 */   // GIR_Coverage, 8980,
     /* 439348 */   GIR_Done,
     /* 439349 */ // Label 8988: @439349
     /* 439349 */ GIM_Reject,
     /* 439350 */ // Label 8960: @439350
     /* 439350 */ GIM_Try, /*On fail goto*//*Label 8989*/ GIMT_Encode4(439396),
     /* 439355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 439358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 439361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439365 */   GIM_Try, /*On fail goto*//*Label 8990*/ GIMT_Encode4(439380), // Rule ID 8975 //
     /* 439370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439373 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 439373 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 439378 */     GIR_RootConstrainSelectedInstOperands,
     /* 439379 */     // GIR_Coverage, 8975,
     /* 439379 */     GIR_Done,
     /* 439380 */   // Label 8990: @439380
     /* 439380 */   GIM_Try, /*On fail goto*//*Label 8991*/ GIMT_Encode4(439395), // Rule ID 8981 //
     /* 439385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439388 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 439388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 439393 */     GIR_RootConstrainSelectedInstOperands,
     /* 439394 */     // GIR_Coverage, 8981,
     /* 439394 */     GIR_Done,
     /* 439395 */   // Label 8991: @439395
     /* 439395 */   GIM_Reject,
     /* 439396 */ // Label 8989: @439396
     /* 439396 */ GIM_Reject,
     /* 439397 */ // Label 8961: @439397
     /* 439397 */ GIM_Try, /*On fail goto*//*Label 8992*/ GIMT_Encode4(439422), // Rule ID 9023 //
     /* 439402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 439408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 439411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439415 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 439415 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 439420 */   GIR_RootConstrainSelectedInstOperands,
     /* 439421 */   // GIR_Coverage, 9023,
     /* 439421 */   GIR_Done,
     /* 439422 */ // Label 8992: @439422
     /* 439422 */ GIM_Reject,
     /* 439423 */ // Label 8962: @439423
     /* 439423 */ GIM_Try, /*On fail goto*//*Label 8993*/ GIMT_Encode4(439448), // Rule ID 8977 //
     /* 439428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 439434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 439437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439441 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 439441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 439446 */   GIR_RootConstrainSelectedInstOperands,
     /* 439447 */   // GIR_Coverage, 8977,
     /* 439447 */   GIR_Done,
     /* 439448 */ // Label 8993: @439448
     /* 439448 */ GIM_Reject,
     /* 439449 */ // Label 8963: @439449
     /* 439449 */ GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(439495),
     /* 439454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 439457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 439460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439464 */   GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(439479), // Rule ID 8974 //
     /* 439469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439472 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 439472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 439477 */     GIR_RootConstrainSelectedInstOperands,
     /* 439478 */     // GIR_Coverage, 8974,
     /* 439478 */     GIR_Done,
     /* 439479 */   // Label 8995: @439479
     /* 439479 */   GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(439494), // Rule ID 8978 //
     /* 439484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439487 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 439487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 439492 */     GIR_RootConstrainSelectedInstOperands,
     /* 439493 */     // GIR_Coverage, 8978,
     /* 439493 */     GIR_Done,
     /* 439494 */   // Label 8996: @439494
     /* 439494 */   GIM_Reject,
     /* 439495 */ // Label 8994: @439495
     /* 439495 */ GIM_Reject,
     /* 439496 */ // Label 8964: @439496
     /* 439496 */ GIM_Try, /*On fail goto*//*Label 8997*/ GIMT_Encode4(439521), // Rule ID 9022 //
     /* 439501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 439507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 439510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439514 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 439514 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 439519 */   GIR_RootConstrainSelectedInstOperands,
     /* 439520 */   // GIR_Coverage, 9022,
     /* 439520 */   GIR_Done,
     /* 439521 */ // Label 8997: @439521
     /* 439521 */ GIM_Reject,
     /* 439522 */ // Label 8965: @439522
     /* 439522 */ GIM_Try, /*On fail goto*//*Label 8998*/ GIMT_Encode4(439568),
     /* 439527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 439530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 439533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439537 */   GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(439552), // Rule ID 8973 //
     /* 439542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439545 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 439545 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 439550 */     GIR_RootConstrainSelectedInstOperands,
     /* 439551 */     // GIR_Coverage, 8973,
     /* 439551 */     GIR_Done,
     /* 439552 */   // Label 8999: @439552
     /* 439552 */   GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(439567), // Rule ID 8976 //
     /* 439557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439560 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 439560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 439565 */     GIR_RootConstrainSelectedInstOperands,
     /* 439566 */     // GIR_Coverage, 8976,
     /* 439566 */     GIR_Done,
     /* 439567 */   // Label 9000: @439567
     /* 439567 */   GIM_Reject,
     /* 439568 */ // Label 8998: @439568
     /* 439568 */ GIM_Reject,
     /* 439569 */ // Label 8966: @439569
     /* 439569 */ GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(439594), // Rule ID 2402 //
     /* 439574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 439580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 439583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439587 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 439587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 439592 */   GIR_RootConstrainSelectedInstOperands,
     /* 439593 */   // GIR_Coverage, 2402,
     /* 439593 */   GIR_Done,
     /* 439594 */ // Label 9001: @439594
     /* 439594 */ GIM_Reject,
     /* 439595 */ // Label 8967: @439595
     /* 439595 */ GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(439620), // Rule ID 8972 //
     /* 439600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 439606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 439609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439613 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 439613 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 439618 */   GIR_RootConstrainSelectedInstOperands,
     /* 439619 */   // GIR_Coverage, 8972,
     /* 439619 */   GIR_Done,
     /* 439620 */ // Label 9002: @439620
     /* 439620 */ GIM_Reject,
     /* 439621 */ // Label 8968: @439621
     /* 439621 */ GIM_Reject,
     /* 439622 */ // Label 154: @439622
     /* 439622 */ GIM_Reject,
     /* 439623 */ }; // Size: 439623 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
